Feff8L
======

[![DOI](https://zenodo.org/badge/doi/10.5281/zenodo.20629.svg)](https://doi.org/10.5281/zenodo.20629)

Feff8L: Open Source theoretical EXAFS calculations

Based on or developed using Distribution: FEFF8.5L Copyright (c) [2013] University of Washington

 * The [goals](https://github.com/xraypy/feff85exafs/wiki/Goals-of-the-feff85exafs-project) of this
   project are discussed on the [wiki](https://github.com/xraypy/feff85exafs/wiki).

 * This project is sometimes called Feff8L or Feff85exafs.  The "L" implies "Lite" (as in diluted
   beer, not illumination), "85" comes from the version of Feff (8.5) that this version is derived
   from, and "exafs" is because this version is used to calculate EXAFS only -- not XANES or other
   core-level spectroscopies.  Using either Feff8L or feff85exafs or some combination of these is
   fine with us.

* Build and Installation instructions are given in [`INSTALL.md`](INSTALL.md), with more details in
 [`src/README.md`](src/README.md) .

* There are extensive tests for Feff8L in the [`tests`](tests) directory.  To run these, you will
  need [Larch](https://github.com/xraypy/xraylarch)

* Example programs using the fortran entry point to the stand-alone F_eff calculations or programs
  using the C wrapper can be found in the `wrappers/` directory.  There you will also find language
  bindings to the C wrapper, including python and perl.

# Simple static analysis of Feff

---

**NOTE:** The files discussed below were removed at
https://github.com/xraypy/feff85exafs/tree/1bc6fdeff71cf5a29e68aa70170a7329f5e19c61 
Most of the issues uncovered by that static analysis have been
addressed.  I am leaving this file in the repo in case anyone wants to
redo a static analysis

---

For each subdir with code, I ran
[ftnchek](http://www.dsm.fordham.edu/~ftnchek/) a couple times.  (Note
that ftnchek has a debian/ubuntu package.)

The file `static.analysis/syntax` was generated by 

        ftnchek --nocommon *.f  > static.analysis/syntax

The files `static.analysis/calltree`, `static.analysis/common_blocks`,
and `static.analysis/subprograms` all came from 

        ftnchek --calltree *.f  > static.analysis/calltree

The `common_blocks` and `subprograms` are simply chunks extracted from
the call using the `--calltree` argument.

I also ran ftncheck on the moonolithic code in the `attic`
subdirectory.  That might help resolve some missing references found
when invoking it on the "modules" and libraries.

There is not much organization here.  This is a simple start to
dealing with issue #5.

As Matt said in the email I quoted from to create #5

       It would be nice to come up with a tree of called functions and 
	   dependencies -- I think  there are quite a few completely unused 
	   functions, and lots of commented out code blocks.   These should
	   all be removed - they exist in the initial git commit, so are not
	   lost to history, but there's no reason to have to look at that.
	   

# Executable scripts for feff8l

## f85e

This is a bash script which emulates the behavior of a monolithic Feff
by running the "modules" one after another given a `feff.inp` file.

This script is used by the unit testing framework.

In its current form, it deduces the locations of the various
stand-alone executables for the modules based on the structure of the
repository.  That is, this script assumes that is lives in the `bin/`
folder of the repository and that the executables will be found in
subfolders of the `src` folder, where `bin/` and `src/` are at the
same level of the repository folder structure.

	~/feff8l/> ls -R
	./bin:
	f85e*

	./src:
	ATOM/    EXCH/  FOVRG/    JSON/  PAR/   RDINP/  FortranCompilation.py
	COMMON/  FF2X/  GENFMT/   LIB/   PATH/  XSPH/   SConstruct
	DEBYE/   FMS/   HEADERS/  MATH/  POT/   attic/  README.md

	and so on...

Eventually, an installation scripts might be written, in which case a
successor to this script will need to know (or determine) the
installation locations of the various executables.

For now, I am assuming that primary purpose of the `f85e` script is to
aid unit testing during the development of Feff8L.

# feff85_light

This is a script written by Josh.  It makes calls to executables
called `opconsat`, `atomic`, and `aps2exc`, none of which I know how
to build from the source code provided.  The text of the script
suggests that Josh intended this to be an example of using
Feff8L, but its use is unclear.

# Dictionaries of Feff interchange files

Feff uses a slew of files to exchange data between the different parts of the program.

An early modification of feff8l changed the legacy structured
text files into JSON files.

old        | new         | purpose
---------- | ----------- | ------------------------------------------------------
mod1.inp   | pot.json    | input data for POT module taken from feff.inp
mod2.inp   | xsph.json   | input data for XSPH module taken from feff.inp
mod4.inp   | path.json   | input data for PATH module taken from feff.inp
mod5.inp   | genfmt.json | input data for GENFMT module taken from feff.inp
mod6.inp   | ff2x.json   | input data for FF2X module taken from feff.inp
global.dat | global.json | input data common to all modules, taken from feff.inp
atoms.dat  | atoms.dat   | geometric information about ATOMS list
geom.dat   | geom.dat    | geometric information about ATOMS list
xsect.bin  | xsect.json  | energy grid and cross-section data


The files in this folder are JSON files containing dictionaries of the
content of each of the interchange files.  Hopefully this will help
application developers who need to read from or write to these
interchange files.


## Other ascii interchange files that do not yet have json files

Some of these are throw-away diagnostic files

1. nstar.dat, see `GENFMT/genfmt.f`, but nstar.dat seems to be written but not read in feff8l
2. wscrn.dat, see `XSPH/xsph.f`
3. exc.dat + sigma.dat + ratio.dat + ratiop.dat + mpse.dat, see `XSPH/xsect.f` + `XSPH/phase.f`
4. various in `XSPH/rholat.f`
5. emesh.dat in `XSPH/phmesh.f`
6. axafs.dat in `XSPH/axafs.f`
7. various things written with PRINT cards, see comments lines 319 to 342 in `RDINP/rdinp_l.f`
8. rotmat.dat in `GENFMT/rot3i.f`
9. various in `FMS/xprep.f`, `FMS/inc.f`
10. various in `FF2X/ff2gen.f`
11. exc.dat in `EXCH/mpse.f`
12. various in `DEBYE/sigrem.f`
13. `spring.inp` in  `DEBYE/sigrem.f`

# Building feff85exafs

In an attempt to move beyond the inadequate collection of Makefiles
that this project inherited from the Feff Project, Bruce decided to
use the [scons software construction tool](http://www.scons.org/) as a
replacement.  scons seemed easier to understand than GNU Autotools
(which Matt used ages ago for feff6l and Ifeffit).  Because scons is
written in python and uses configuration files that contain python
code, it seemed like a good fit for something that would eventually be
integrated into [Larch](https://github.com/xraypy/xraylarch).

Compilation is as simple as typing `scons` from the top of the repo.

You can also cd into one of the `src\` subfolders and do `scons` to
build just that piece.

The file `FeffBuild.py` has a bit of logic for specifying compilation
flags, which may be attractive for optimization or other reasons, and
installation locations.  This is then imported by each of the
lower-level SConstruct files.  Except for gfortran, the initial
guesses for compilation flags were taken from the top level Makefile
that came from the Feff Project.  The gfortran flags were selected by
Bruce after playing around on his Ubuntu system.

---

# Installed files

Many of the libraires and stand-alone programs have been renamed from
the names chosen by the original build system for feff85exafs.

## Feff Libraries

The following libraries contain the various parts of Feff.

* `ATOM/libfeffatom.a`
* `COMMON/libfeffcom.a`
* `DEBYE/libfeffdw.a`
* `EXCH/libfeffexch.a`
* `FMS/libfefffms.a`
* `FOVRG/libfeffpha.a`
* `GENFMT/libfeffgenfmt.a`
* `JSON/libfeffjson.a`
* `MATH/libfeffmath.a`
* `OPCONSAT/libfeffopconsat.a`
* `PAR/libfeffpar.a`
* `POT/libfeffint.a`

These will be used to compile against the stand-alone executables, but
will normally not be installed on the system.

## Stand-alone programs

* `RDINP/rdinp`: input file reader
* `POT/pot`: module 1, potentials calculation
* `OPCONSAT/opconsat` and `OPCONSAT/eps2exc`: multipole loss approximation
* `XSPH/xsph`: module 2, phase shifts calculation
* `PATH/pathfinder`: module 4, path finder
* `GENFMT/genfmt`: module 5, F-matrix calculation
* `FF2X/ff2x`: module 6, output files

Note that module 3, `fms`, the full multiple scattering XANES
calculator, is not a part of feff85exafs, although the matrix algebra
components can be used to compute self-consistent potentials.

Default installation locations:

* Linux: `/usr/local/bin`
* Windows: `C:\Program Files\???`     :FIXME:
* Mac: `/some/where/bin`              :FIXME:

See below for hints of setting the installation location prefix from
the command line.

Note that the ultimate goal of the feff85exafs project is to do away
with the stand-alone programs.
 * `rdinp` is a chore better handled by a GUI or other user interface.
 * `pot` and `xsph` (as well as `opconsat` and `eps2exc`) are replaced
   by the `feffphases` library
 * `genfmt` and `ff2x` are replaced by the `feffpath` library, which
   can be called directly by a program written in fortran, C, or some
   other language
 * finally the pathfinder is missing critical features (most
   prominently: caching geometry of degenerate paths and fuzzy
   degeneracy).  The pathfinder has already been rewritten in Perl for
   Demeter, for example.


## The feffpath library and its wrappers

These files are the entry points for various programming languages to
the "feffpath" calculation, that is, the calculation of a single
`feffNNNN.dat` file given an input scattering geometry.

This presumes that `pot` and `xsph` have already been run and that the
`phase.pad` file is accessible.

* `GENFMT/libonepath.so`: This is the Fortran entry point.
* `GENFMT/libfeffpath.so`: This is the C wrapper around the Fortran onepath
* `GENFMT/feffpath.h`: This is the header file, almost certainly required by any language wrapper

`libonepath.so` and `libfeffpath.so` will be installed to:

* Linux: `/usr/local/lib`
* Windows: `C:\Program Files\???`   :FIXME:
* Mac: `/some/where/lib`            :FIXME:

This can be set from the command line:

	~> make PREFIX="/other/location"

where the default value for "PREFIX" is `/usr/local` on Linux, etc.

Alternately, you could edit the top-level make file with the PREFIX
location and any other compilation changes for your machine.

This location **must** be in the linker/loader path.  With bash, for
example, you may need to do

	~> export LD_LIBRARY_PATH=/usr/local/lib

or, if LD\_LIBRARY\_PATH already has a value:

	~> export LD_LIBRARY_PATH=$LD_LIBRARY_PATH ":/usr/local/lib"

You may want to put that in your `.bashrc` file.

The other files are transferred into the proper place in the
`wrappers` folder of the feff85exafs distribution so that the
language-specific wrapper can be built using language-specific build
tools.


---

# Compiling against json-fortran

At the moment, feff85exafs has been modified to replace all
intermediate i/o files (`modN.inp`, `global.dat`, `geom.dat`, and so
on) with JSON file.  Reading and writing the JSON files is currently
done using
[json-fortran](https://github.com/jacobwilliams/json-fortran).

According to the json-fortran web page, it can be compiled with Visual
Studio 2010, Intel Fortran, and gfortran 4.9.  My only experience is
with gfortran 4.9 and greater.  I know that gfortran 4.8 will not
work.

With gfortran 4.9 or higher
([this helped on an older Ubuntu machine](http://askubuntu.com/questions/428198/getting-installing-gcc-g-4-9-on-ubuntu)),
I was able to use the `build.sh` script that comes with json-fortran
to build the static library and the test program.  The static library
and corresponding module end up in the `lib/` folder.

The files in `lib/` need to end up someplace where the compiler and
linker can find them.  The simple build script doesn't do an install.
I put the `libjsonfortran.a` and `json_module.mod` files in
`/usr/local/lib`.  This way, the linker was able to find the library
and the Makefiles set the `-I` and `-J` flags appropriately.

## Matt's comment on json-fortran

Matt has these reasonable things to say about compiling against json-fortran:

    Do you know what versions of Fortran the json-fortran library
    requires?  I know it may not be easy, but I'd like to leave the
    numerical code to be F77 (long arg lists and no common blocks!) to
    be more easily called from C (and so easier to wrap).  I don't
    know how portable doing this really is for Fortran versions beyond
    F77.  My understanding is that many F90 "objects" are not that
    easy to pass between C and Fortran, and even some F90 structures
    are apparently challenging, though I don't know the details and
    have never delved into this.

	That's not to say I don't completely agree that json is better
    than FEFF.inp, and it might be that the json-fortran library is no
    problem.  And we might be able to simply not need to wrap this
    code. But I'd like to be a little careful about adding
    dependencies on F90 and later.

Clearly, if we stay with json-fortran, these concerns need to be
addressed and well tested.

**NOTE (2015-02-11):** This seems not to be a problem.  Everything is
working for me (Bruce) on both linux and Windows with gfortran 4.9.


---

# Simple static analysis

The following is a very useful command:

	../src> ftnchek -mkhtml */*.f

When run in the `src/` folder, this will generate a small html file
for every fortran source file below `src/` in the repository.  These
html files explain function and subroutine arguments, common block
parameters, local variables, and several other useful tidbits for each
file.

This combined with the call graphs in the `tree/` folder under each
source code folder provide a fairly thorough mapping of information
through the many parts of Feff.


## Hints for building on Mac OS X

Some notes on building Feff8L on Mac OS X:

1. You will need XCode installed and the Xcode command-line tools (run
   `xcode-select --install` from a Terminal).

2. You will need the gfortran compiler. Download the official Gfortran installer from
    https://gcc.gnu.org/wiki/GFortranBinaries#MacOS

and install this package.

3. `make -jN` seems to not work for building the `json-fortran` module, at
   least on Mac OS X.

4. If `make` fails almost immediately with messages like:
    gfortran -c -O3 -ffree-line-length-none -g -Wall -fPIC .. -o head.o head.f
    /var/folders/c8/ycgqywlj3wbdjp3mlknv8n980000gn/T//cchhLRiB.s:545:suffix or operands invalid for `movq'
    /var/folders/c8/ycgqywlj3wbdjp3mlknv8n980000gn/T//cchhLRiB.s:560:suffix or operands invalid for `movq'
    .....

then you *probably* have MacPorts installed (perhaps because you've
installed Demeter) and are seeing conflicts from the MacPorts assembler and
Apple's LLVM.  Remove the MacPorts paths (typically, '/opt/...') from your
PATH environmental variable and redo `make`.  This appears to be only a
build-time problem, not a run-time problem (so you're safe to then put the
MacPorts back in your path.

# Content of the OPCONSAT folder

This directory contains routines for the many-pole self-energy model
using the optical constants: atomic approximation model.  See
[the 2007 Kas, et al. paper](https://doi.org/10.1103/PhysRevB.76.195116).

The original Fortran 77 and Fortran 90 routines in this directory are
covered by the [LICENSE](../HEADERS/license.h).

This directory also contains the `libfeffloss` library, which combines
the functionality of the `opconsat` and `eps2exc` programs into a
single, callable library.  This library is, in turn, called by the
[`libfeffphases` library](../POT/README.md) whenever the MPSE
calculation is turned on.

# NOTE: Currently disabled!

To turn opconsat back on:

 * Edit `../json-fortran/json_read_libpotpht.f` and uncomment the
   reading of the `iplsmn` parameter at lines 266-267
 * Edit `../POT/libpotph.f` and uncomment the call to `feffloss` at
   lines 292-294
 * uncomment all the lines related to OPCONSAT in the main Makefile
 * uncomment all the lines related to OPCONSAT in `src/POT/Makefile`

After that, the output of `feffloss` needs to actually be used.
Several arrays need to be put into the argument list for `xsph`, then
used as needed (`phase`, `xsect`, elsewhere?).


# Build and install

To build, type `make`.  This will build:

 * `opconsat`: the first stand-alone program
 * `eps2exc`: the second stand-alone program
 * `libfeffloss.so`: the Fortran entry point for computing the MPSE

Type `make loss` to compile the sample program.  Try doing 

```
	ln -s ../../wrappers/fortran/libpotph.json
```

to get it to run to completion for copper metal.  (Or run Feff on
something else to get a `libpotph.json` file.

Once built, type `make install` to install everything:

 * `libfeffloss.so`: installed to `/usr/local/lib`
 * `opconsat`, `eps2exc`: installed to `/usr/local/bin`

This will need to be installed before building the Python, Perl, or
other wrappers.

# Sample program

Assuming that a
[`libpotph.json`](../../wrappers/fortran/libpotph.json) file is
present in the current directory, this program will read the
`libpotph.json` information and compute the `loss.dat` file.  This is
a bit of a dodge, in that the `rnrm` values for copper metal are
hardwired in.

```fortran
      program loss

      include '../HEADERS/const.h'
      include '../HEADERS/dim.h'
      include '../HEADERS/parallel.h'

      integer epsmax
      parameter(epsmax = 700)
      
      integer npoles
      double precision rnrm(0:nphx), eps0, gamma
      logical write_loss, write_opcons, write_exc, verbose

      double precision wpcorr(MxPole), delta(MxPole), ampfac(MxPole)

      character*80 title(nheadx)
      integer ntitle, nat, nph, iphat(natx), ipol, ispin, ihole
      integer lfms1, nmix, icoul, ixc, ixc0, iafolp, iunf, inters
      integer jumprm, nohole, iplsmn
      integer iz(0:nphx), lmaxsc(0:nphx), lmaxph(0:nphx)
      double precision evec(3), xivec(3), spvec(3), spinph(0:nphx)
      complex*16 ptz(-1:1, -1:1)
      double precision rat(3,natx)
      double precision xnatph(0:nphx), folp(0:nphx), xion(0:nphx)
      character*6 potlbl(0:nphx)
      real rfms1
      double precision elpty, angks, gamach, ca1, ecv
      double precision vr0, vi0, rgrd, totvol

      write_loss   = .true.
      write_opcons = .false.
      write_exc    = .false.
      verbose      = .true.
      npoles       = 100
      eps0         = -1.d0

      call inipotph(
c     TITLE
     1       ntitle, title,
c     ATOMS
     2       nat, rat, iphat,
c     POTENTIALS
     3       nph, iz, potlbl, lmaxsc, lmaxph, xnatph, spinph,
c     HOLE/EDGE
     4       ihole,
c     SCF
     5       rfms1, lfms1, nscmt, ca1, nmix, ecv, icoul,
c     POLARIZATION, ELLIPTICITY
     6       ipol, evec, elpty, xivec,
c     SPIN
     7       ispin, spvec, angks,
c     computed
     8       ptz, gamach,
c     EXCHANGE
     9       ixc, vr0, vi0, ixc0,
c     AFOLP, FOLP, ION, RGRID, UNFREEZEF
     _       iafolp, folp, xion, rgrd, iunf,
c     INTERSTITIAL, JUMPRM, NOHOLE
     1       inters, totvol, jumprm, nohole, iplsmn)


c*****************************************************************************
c     read the contents of a json file that includes all of global.json,
c     atoms.json, pot.json & xpsh.json (i.e. global.dat, atoms.dat, mod1.inp,
c     and mod2.inp)
c*****************************************************************************
      call json_read_libpotph(
c     TITLE
     1       ntitle, title,
c     ATOMS
     2       nat, rat, iphat,
c     POTENTIALS
     3       nph, iz, potlbl, lmaxsc, lmaxph, xnatph, spinph,
c     HOLE/EDGE
     4       ihole,
c     SCF
     5       rfms1, lfms1, nscmt, ca1, nmix, ecv, icoul,
c     POLARIZATION, ELLIPTICITY
     6       ipol, evec, elpty, xivec,
c     SPIN
     7       ispin, spvec, angks,
c     computed
     8       ptz, gamach,
c     EXCHANGE
     9       ixc, vr0, vi0, ixc0,
c     AFOLP, FOLP, ION, RGRID, UNFREEZEF
     _       iafolp, folp, xion, rgrd, iunf,
c     INTERSTITIAL, JUMPRM, NOHOLE
     1       inters, totvol, jumprm, nohole, iplsmn)

c  this is a cheat .. rather than calling rdpot and all that, just
c  hard wire the values for a Copper calculation
      rnrm(0) = 2.8384890981392523
      rnrm(1) = 2.6294479894989911

      call feffloss(nph, iz, xnatph, rnrm, npoles, eps0,
     1       write_opcons, write_loss, write_exc, verbose,
     2       wpcorr, gamma, ampfac, delta)
      

      end
```


## Arguments to the feffloss subroutine


| element        | type                 | I/O | description                                                  | Feff card    |
| -------------- | -------------------- | --- |------------------------------------------------------------- | ------------ |
|  nph           | integer              | I   | number of potential indeces                                  | POTENTIALS   |
|  iz            | integer              | I   | array(0:nphx) of unique potential Z numbers                  | POTENTIALS   |
|  xnatph        | double precision     | I   | array(0:nphx) of unique potential stoichiometries            | POTENTIALS   |
|  rnrm          | double precision     | I   | array(0:nphx) of norman radii                                | from rdpot   |
|  npoles        | integer              | I   | number of poles to use in the calculation                    |              |
|  eps0          | double precision     | I   | dielectric constant                                          |              |
|  write\_opcons | logical              | I   | write opconsEE.dat file                                      |              |
|  write\_loss   | logical              | I   | write loss.dat file                                          |              |
|  write\_exc    | logical              | I   | write exc.dat file                                           |              |
|  verbose       | logical              | I   | write screen messages                                        |              |
|  wpcorr        | double precision     | O   | array(MxPole) energy grid for MPSE calculation               |              |
|  gamma         | double precision     | O   | array(MxPole) .... for MPSE calculation                      |              |
|  ampfac        | double precision     | O   | array(MxPole) .... for MPSE calculation                      |              |
|  delta         | double precision     | O   | array(MxPole) .... for MPSE calculation                      |              |

# json-fortran

The file `json_module.f90` is copied from https://github.com/jacobwilliams/json-fortran

See the file `LICENSE` for its licensing terms and authorship.

To update to the latest version of that file

	git clone https://github.com/jacobwilliams/json-fortran.git

and copy `src/json_module.f90` to this directory.

# Using the onepath Fortran entry point

The `onepath` library will be installed when feff85exafs is built.
This folder contains an example of its use in a Fortran program.  The
program `makepath` will read from `phase.pad` (this example is
calculated from copper metal) and write the files `feff0001.dat` and
`feff0004.dat`.

The `makepath.f` program likely will not compile before you build and
install feff85exafs.  The build script will look for the `onepath`
library.

To compile the `makepath` sample program:

	~> make

That's it!

## Sample program

Here is the simplest program using the Fortran entry point:

```fortran
  	  program makepath
	  implicit double precision (a-h, o-z)

c     taken from the feff HEADERS/dim.h
      integer nex, legtot, ixc
      parameter (nex = 150, legtot = 9)
      double precision evec(3), xivec(3)

	  integer iorder, innnn, ixdi, ivrbse
	  integer ipot(0:legtot), iz(0:nphx)
      double precision elpty, rat(3,0:legtot+1)

      double precision ri(legtot), beta(legtot+1), eta(0:legtot+1)
      dimension col1(nex), col2(nex), col3(nex), col4(nex), col5(nex)
      dimension col6(nex), col7(nex)

      character*256 phpad
      character*8 cxc

c     initialize everything
      phpad   = 'phase.pad'
      index   = 9999
      nleg    = 0
      deg     = 1.0
      iorder  = 2
      innnn   = 1 
      ixdi    = 1
      ivrbse  = 1
      ipol    = 0 
      elpty   = 0.0
      ne      = 0

      cxc    = ''
      versn  = ''
      rs     = 0.
      vint   = 0.
      xmu    = 0.
      edge   = 0.
      xkf    = 0.
      rnrmav = 0.
      gamach = 0.
      
      do 5  i=1,3
         evec(i)  = 0
         xivec(i) = 0
 5    continue
      do 10 i=0, legtot
         rat(1,i) = 0
         rat(2,i) = 0
         rat(3,i) = 0
         ipot(i)  = 0
         eta(i)   = 0
         if (i>0) then
            ri(i)   = 0
            beta(i) = 0
            eta(i)  = 0
         endif
 10   continue
      beta(legtot+1) = 0
      eta(legtot+1)  = 0

      do 15 i=0,nphx
         iz(i) = 0
 15   continue

	  do 20 i=1, nex
         col1(i) = 0
         col2(i) = 0
         col3(i) = 0
         col4(i) = 0
         col5(i) = 0
         col6(i) = 0
         col7(i) = 0
 20   continue
c     done initializing

c     compute first shell of Copper (SS, deg=12)
      index  = 1
      nleg   = 2
      deg    = 12

c                  leg   x	  y      z   ip  ipot and rat arrays
      call addatom(1, -1.805, 0., -1.805, 1, ipot, rat)
      call onepath(phpad, index, nleg, deg, iorder,
     &     cxc, rs, vint, xmu, edge, xkf, rnrmav, gamach,
     &     versn, ipot, rat, iz, ipol, evec, elpty, xivec,
     &     innnn, ixdi, ivrbse, ri, beta, eta,
     &     ne,col1,col2,col3,col4,col5,col6,col7)

c
c     now you can do things with the colN arrays
c
      end

```

1. All the necessary variables are typed, dimensioned, and initialized.

2. `phpad` is a character*256 parameter containing the path to the
   `phase.pad` file.  If not specified (or if the file does not
   exist), `onepath` will try to read `phase.pad` in the current
   working directory.

3. Setting `nnnn` and `verbose` to a true value tells the program to
   write `feffNNNN.dat` files and to write a short message to the
   screen when it is written.  (Set `xdi` to true to get this file in
   XDI format.

4. The path index is set to 1.  This means the output file will be
   called `feff0001.dat`.

5. The degeneracy of the path is specified.

6. The `addatom` subroutine (scroll down for an explanation) is used
   to build the scattering geometry.  It's arguments are the leg
   index, the Cartesian coordinates (referenced to the absorber *at
   the origin*) and the unique potential index of the atom.  In this
   case, a single scattering path is calculated, so `addatom` is
   called only once.  For a multiple scattering path, `addatom` would
   be called repeatedly, once for each atom (or leg) in the path.
   `addatom` fills the `rat` and `ipot` arrays.

7. The call to `onepath` computes the parts of F-effective and
   stores them in the `colN` arrays.


## Arguments of the onepath subroutine

Here are all the elements of the struct, their data types,
descriptions, and default values.  Input parameters are marked with
"I" and output parameters, set by the `make_path` method, are marked
with "O".  Many of the names are chosen to be consistent with the
naming conventions in Feff.

| element    | type          | I/O | description                             | default              |
| ---------- | ------------  | --- |---------------------------------------- | -------------------- |
|  phpad     | character*256 | I   | path to `phase.pad` file                |  `phase.pad`         |
|  index     | integer       | I   | path index                              |  9999                |
|  deg       | double        | I   | path degeneracy                         |  required input      |
|  nleg      | integer       | I   | number of legs in path                  |  required input      |
|  rat       | double(3,0:legtot+1) | I   | cartesian positions of atoms in path |  use addatom     |
|  ipot      | integer(legtot)      | I   | unique potentials of atoms in path   |  use addatom     |
|  iorder    | integer       | I   | order of approximation in genfmt        |  2                   |
|  innnn     | integer       | I   | flag to write `feffNNNN.dat` file       |  0                   |
|  ixdi      | integer       | I   | flag to write `feffNNNN.xdi` file       |  0                   |
|  iverbose  | integer       | I   | flag to write screen messages           |  0                   |
|  ipol      | integer       | I   | flag to do polarization calculation     |  0                   |
|  evec      | double(3)     | I   | polarization vector                     |  (0,0,0)             |
|  elpty     | double        | I   | ellipticity                             |  0                   |
|  xivec     | double(3)     | I   | direction of X-ray propagation          |  (0,0,0)             |
|  ri        | double(legtot)     | O | leg lengths                          |                      |
|  beta      | double(legtot+1)   | O | beta angles                          |                      |
|  eta       | double(0:legtot+1) | O | eta angles                           |                      |
|  ne        | integer       | O   | number of energy points actually used by Feff                | |
|  col1      | double(nex)   | O   | k grid for calculation, column 1 in `feffNNNN.dat`           | |
|  col2      | double(nex)   | O   | central atom phase shifts. column 2 in `feffNNNN.dat`        | |
|  col3      | double(nex)   | O   | magnitude of F\_eff, column 3 in `feffNNNN.dat`              | |
|  col4      | double(nex)   | O   | phase of F\_eff, column 4 in `feffNNNN.dat`                  | |
|  col5      | double(nex)   | O   | reduction factor, column 5 in `feffNNNN.dat`                 | |
|  col6      | double(nex)   | O   | mean free path, column 6 in `feffNNNN.dat`                   | |
|  col7      | double(nex)   | O   | real part of complex momentum, column 7 in `feffNNNN.dat`    | |

Additionally, the entry point returns several bits of information
about the potential model that Feff traditionally writes to the header
of the `feffNNNN.dat` file:

| attribute  | type    | I/O | description                             |
| ---------- | ------- | --- |---------------------------------------- |
|  versn     | string  |  O  | the version of feff and the feffpath revision |
|  cxc       | string  |  O  | brief description of the electronic exchange model |
|  edge      | float   |  O  | energy threshold relative to atomic value (a poor estimate) |
|  gamach    | float   |  O  | core level energy width |
|  xkf       | float   |  O  | k value at Fermi level |
|  xmu       | float   |  O  | Fermi level, eV |
|  rnrmav    | float   |  O  | average Norman radius |
|  rs        | float   |  O  | interstitial radius |
|  vint      | float   |  O  | interstitial potential |

A polarization calculation is enabled by setting the `ipol` element to
a true value.  `evec` has 3 elements and represents the polarization
vector of the incident beam.  `elpty` and `xivec` are the ellipticity
and Poynting vector of the incident beam for a calculation with
ellipticity.

When `onepath` is called, the `ri`, `beta`, and `eta` arrays are
filled to be `nleg` elements long and contain the geometry of the
scattering path.

Also when `onepath` is called, the arrays containing the columns of
a traditional `feffNNNN.dat` file are filled to be `ne` elements long.
These arrays are the same (besides precision) as the corresponding
columns.  While a `feffNNNN.dat` file can be exported (using the
`nnnn` flag), the need to write/read that file is obviated.

While you can certainly fill `rat` and `ipot` directly, `addatom` is
more convenient.  In any case, be aware that the units in `rat` are
bohr, not Angstrom.

## A comment on the addatom subroutine

This is a helper subroutine to help organize the contents of `ipot`
and `rat` and to convert the Cartesian coordinates to code units.

```fortran
      subroutine addatom(leg, x, y, z, ip, ipot, rat)
      implicit double precision (a-h, o-z)
      integer legtot
      parameter (legtot=9)

      integer leg, ip
      real x, y, z
      double precision rat(3,0:legtot+1)
      integer ipot(0:legtot)
      double precision bohr
      parameter (bohr = 0.529 177 249d0)

      ipot(leg)  = ip
      rat(1,leg) = dble(x) / bohr
      rat(2,leg) = dble(y) / bohr
      rat(3,leg) = dble(z) / bohr
      return
      end
```

The way of building the geometry of the scattering path was
purposefully kept completely general.  While a program might use the
output of Feff's pathfinder, we also want to suport any other way of
generating path geometries.

To use the output of Feff's pathfinder, one would parse the
`paths.dat` file, making a path for each "paragraph" in the file and
calling `addatom` for each atom in the path.

As a more complicated example, a reverse Monte Carlo approach to a fit
will move atoms to minimize difference between a model and the data.
As the atoms move about, the RMC program will generate new SS and MS
paths based on the current atom positions.  In that case, the current
coordinates can be used as the input to `addatom` (with the
caveat that the `onepath` library expects the absorber to be at the
origin, so the arguments to `addatom` should have the absorber
position subtracted off).

# Content of the FF2X folder

This directory contains various routines to calculate 
various x-ray spectra.

For feff8l, this functionality is rolled into `libfeffpath`, see
[../GENFMT](../GENFMT).

All routines in this directory are covered by the [LICENSE](../HEADERS/license.h)

# Simple static analysis

To make HTML files explaining data I/O for each fortran source file, do

	../src> ftnchek -mkhtml *.f

# Call graph

![call graph for the FF2X folder](tree/ff2x.png)

# Content of the FOVRG folder

This directory contains various routines to solve Dirac equations.

All routines in this directory are covered by the [LICENSE](../HEADERS/license.h)

# Simple static analysis

To make HTML files explaining data I/O for each fortran source file, do

	../src> ftnchek -mkhtml *.f

# Call graph

![call graph for the FOVRG folder](tree/FOVRG.png)

# Content of the PATH folder

This directory contains various routines to filter important paths
in path expansion.

All routines in this directory are covered by the [LICENSE](../HEADERS/license.h)

[Zabinsky, Rehr, Ankudinov, Albers, and Eller, Multiple-scattering calculations of x-ray-absorption spectra](https://doi.org/10.1103/PhysRevB.52.2995)

# Simple static analysis

To make HTML files explaining data I/O for each fortran source file, do

	../src> ftnchek -mkhtml *.f

# Call graph

![call graph for the PATH folder](tree/path.png)

This directory contains routines for MPI parallel processing.
 parallel.f - routines for MPI parallel processing
 sequential.f - dummy routines for sequential calculations

All routines in this directory are covered by the LICENSE inside
license.h file.

# Content of the MATH folder

This directory contains various mathematical routines for linear algebra,
interpolation, integration, 3j symbols, Wigner rotation matrices, 
Bessel functions, etc..

All routines in this directory are covered by the [LICENSE](../HEADERS/license.h)

The file [lu.f](lu.f) contains public domain
[LAPACK linear algebra routines](http://www.netlib.org/lapack/) used
by FEFF.

# Simple static analysis

To make HTML files explaining data I/O for each fortran source file, do

	../src> ftnchek -mkhtml *.f

# Call graph

![call graph for the MATH folder](tree/MATH.png)

# Fortran entry points


The libraries `libpotph` and `libonepath` are the Fortran entry points
for Feff's phase calculator and path calculator.

 * [Documentation for libpotph, the phases calculator](README_potph.md)

 * [Documentation for libonepath, the path calculator](README_onepath.md)

# Using the C wrappers

The wrappers will be installed when feff85exafs is built.  This folder
contains examples of their use in C programs.

 * [Using the libfeffpath wrapper](README_paths.md)
 * [Using the libfeffphases wrapper](README_phases.md)


## Memory testing

If the C libraries have memory leaks or other memory use problems, the
bindings to other languages will suffer from problems that are very
hard to understand and track down.  It is, therefore, a *very* good
idea to use a tool like [Valgrind](http://valgrind.org/) to test
`makepath`, `errors`, `makephases`, and `pherr` whenever changes are
made to the libraries.

Using [Valgrind](http://valgrind.org/) like so works wonders:

	~> valgrind --track-origins=yes --leak-check=full --show-leak-kinds=all ./makepath
	~> valgrind --track-origins=yes --leak-check=full --show-leak-kinds=all ./errors
	~> valgrind --track-origins=yes --leak-check=full --show-leak-kinds=all ./makephases
	~> valgrind --track-origins=yes --leak-check=full --show-leak-kinds=all ./pherr

If you can get the programs to run without any error reports from
Valgrind, the bindings to other languages will have a fighting chance
of working correctly.

# Content of the POT folder

This directory contains various routines to calculate 
self-consistent potentials.

Also here is the code for a stand-alone library combining the features
of POT and XSPH, that is to take input data and write out the phase
information needed for EXAFS to a `phase.pad` file.  The Fortran entry
point to this is contained in `libpotpht.f` and gets compiled along
with *all* of it dependencies to `libpotph.so`.  The C wrapper around
`libpotph.so` is `feffbphases.c`, with header file `libphases.h`.  This
gets compiled to `libfeffphases.so`.

Most routines in this directory are covered by the [LICENSE](../HEADERS/license.h)

The [JSON parser](https://github.com/jacobwilliams/json-fortran) is
the work of Jacob Williams and is available under
[a BSD-like license](https://raw.githubusercontent.com/jacobwilliams/json-fortran/master/LICENSE)

The C wrapper around POT and XSPH is released to the public domain.

# Build and install

To build, type `make`.  This will build:

 * `libfeffint.a`: most of the functionality of POT, a static library
   used to build the stand-alone executables
 * `pot`: the stand-alone potentials calculation program
 * `libpotph.so`: the Fortran entry point for generating the phases file
 * `libfeffphases.so`: the C wrapper around libpotph

Once built, type `sudo make install` to install everything:

 * `libpotph.so`, `libphases.so`: installed to `/usr/local/lib`
 * `pot`: installed to `/usr/local/bin`
 * `feffphases.h`: installed to `/usr/local/include`

You **must** install before building the Perl or Python wrappers.
Other wrappers almost certainly require at least that `libphases.so`
be installed.


# Simple static analysis

To make HTML files explaining data I/O for each fortran source file, do

	../src> ftnchek -mkhtml *.f

# Call graph

![call graph for the POT folder](tree/pot.png)


# The libpotph.json file

This file conatins the relevant content of a `feff.inp` file and is
generated by the stand-alone `rdinp` program.  The point of
abstracting the input to the potentials and phases calculator in this
way is to make it easier to decouple this functionality from the input
structure of conventional Feff.

The eventual intent is that an interface -- not reliant on `feff.inp`
-- will either generate the json file or (much better!) simply make
use of the FEFFPHASES struct directly.  In short, it's time for
`feff.inp` to sail off into the sunset.

# Using the onepath Fortran entry point

The `libpotph` library will be installed when feff85exafs is built.
This folder contains an example of its use in a Fortran program.  The
program `makepotph` will read from `libpotph.json` (this example is
generated for copper metal) and write the file `phase.pad`.

The `makepotph.f` program likely will not compile before you build and
install feff85exafs.  The build script will look for the `libpotph`
library.

To compile the `makepotph` sample program:

	~> make

That's it!

## Sample program

Here is the simplest program using the Fortran entry point in
`libpotph`:

```fortran
  	  program makepotph
	  implicit double precision (a-h, o-z)

      integer nphx, natx, nphx
      parameter (nphx = 11, natx = 1000, nheadx = 30)

      character*80 title(nheadx)
      integer ntitle, nat, nph, iphat(natx), ipol, ispin, ihole
      integer lfms1, nmix, icoul, ixc, ixc0, iafolp, iunf, inters
      integer jumprm, nohole, iplsmn
      integer iz(0:nphx), lmaxsc(0:nphx), lmaxph(0:nphx)
      double precision evec(3), xivec(3), spvec(3), spinph(0:nphx)
      complex*16 ptz(-1:1, -1:1)
      double precision rat(3,natx)
      double precision xnatph(0:nphx), folp(0:nphx), xion(0:nphx)
      character*6 potlbl(0:nphx)
      real rfms1
      double precision elpty, angks, gamach, ca1, ecv
      double precision vr0, vi0, rgrd, totvol

	  character*256 phpad
	  logical verbse

	  call inipotph(ntitle, title, nat, rat, iphat,
     1       nph, iz, potlbl, lmaxsc, lmaxph, xnatph, spinph,
     2       ihole, rfms1, lfms1, nscmt, ca1, nmix, ecv, icoul,
     3       ipol, evec, elpty, xivec, ispin, spvec, angks,
     4       ptz, gamach, ixc, vr0, vi0, ixc0,
     5       iafolp, folp, xion, rgrd, iunf,
     6       inters, totvol, jumprm, nohole, iplsmn)

	  call json_read_libpotph(ntitle, title, nat, rat, iphat,
     1       nph, iz, potlbl, lmaxsc, lmaxph, xnatph, spinph,
     2       ihole, rfms1, lfms1, nscmt, ca1, nmix, ecv, icoul,
     3       ipol, evec, elpty, xivec, ispin, spvec, angks,
     4       ptz, gamach, ixc, vr0, vi0, ixc0,
     5       iafolp, folp, xion, rgrd, iunf,
     6       inters, totvol, jumprm, nohole, iplsmn)

	  phpad = 'phase.pad'
	  verbse = .true.
	  call libpotph(phpad, verbse,
	 1       ntitle, title, nat, rat, iphat,
     2       nph, iz, potlbl, lmaxsc, lmaxph, xnatph, spinph,
     3       ihole, rfms1, lfms1, nscmt, ca1, nmix, ecv, icoul,
     4       ipol, evec, elpty, xivec, ispin, spvec, angks,
     5       ptz, gamach, ixc, vr0, vi0, ixc0,
     6       iafolp, folp, xion, rgrd, iunf,
     7       inters, totvol, jumprm, nohole, iplsmn)

	  stop
	  end
```

 1. All the necessary variables are typed, dimensioned, and initialized.

 2. Everything gets initialized.  Note that `rfms1` is single precision,
    not double.

 3. Read the values of parameters from `feff.inp`, which were written
    to a file called `libpotph.json` by RDINP.  (See note below.)

 4. `json_read_libpotph` converts to code units (bohr and hartree).
    `libpotph` expects code units, **not** natural units.  If you use
    some other mechanism to get data into `libpotph`, you **must**
    remember to convert `rfms1`, `gamach`, `ecv`, `totvol`, and all of
    `rat` to code units.  See, for example, lines 342 - 350 in
    `src/JSON/json_read_libpotph`.

 5. Specify the path and name of the output `phase.pad` file.

 6. Call the libpotph library, which sorts the input cluster, computes
    the muffin tin potentials, and writes phase shifts to a file
    as specified by the phpad argument.

## Arguments of the libpotph subroutine

Here are all the arguments to `libpotph`, their data types,
descriptions, and which `feff.inp` card they are associated with.
Input parameters are marked with "I" and output parameters, set by the
`make_path` method, are marked with "O".  Most of the names are chosen
to be consistent with the naming conventions in Feff.

| element    | type                 | I/O | description                                                  | Feff card    |
| ---------- | -------------------- | --- |------------------------------------------------------------- | ------------ |
|  phpad     | character\*256       | O   | path and name of output phase.pad file                       |              |
|  verbse    | logical              | I   | flag to write screen messages, .false.=suppress              |              |
|  ntitle    | integer              | I   | number of title lines                                        | TITLE        |
|  title     | character\*80        | I   | array(nheadx) of title lines                                 | TITLE        |
|  nat       | integer              | I   | number of atoms in cluster                                   | ATOMS        |
|  rat       | double precision     | I   | array(3,natx) of Cartesian coordinates                       | ATOMS        |
|  iphat     | integer              | I   | array(natx) of potential indeces                             | ATOMS        |
|  nph       | integer              | I   | number of potential indeces                                  | POTENTIALS   |
|  iz        | integer              | I   | array(0:nphx) of unique potential Z numbers                  | POTENTIALS   |
|  potlbl    | character\*6         | I   | array(0:nphx) of unique potential labels                     | POTENTIALS   |
|  lmaxsc    | integer              | I   | array(0:nphx) of unique potential l max for self consistency | POTENTIALS   |
|  lmaxph    | integer              | I   | array(0:nphx) of unique potential l max for FMS              | POTENTIALS   |
|  xnatph    | double precision     | I   | array(0:nphx) of unique potential stoichiometries            | POTENTIALS   |
|  spinph    | double precision     | I   | array(0:nphx) of unique potential spin values                | POTENTIALS   |
|  ihole     | integer              | I   | edge index (K=1, L:3=4, etc)                                 | HOLE/EDGE    |
|  rfms1     | double precision     | I   | radial size of cluster for self consistency                  | SCF          |
|  lfms1     | integer              | I   | for self consistency, 0=solid, 1=molecule                    | SCF          |
|  nscmt     | integer              | I   | max number of self-consistency iterations                    | SCF          |
|  ca1       | double precision     | I   | self-consistency convergence accelerator                     | SCF          |
|  nmix      | integer              | I   | number of mixing iterations before Broyden                   | SCF          |
|  ecv       | double precision     | I   | core valence separation energy                               | SCF          |
|  icoul     | integer              | I   | obsolete param. for handling Coulomb pot.                    | SCF          |
|  ipol      | integer              | I   | 1=do polarization calculation                                | POLARIZATION |
|  evec      | double precision     | I   | array(3) polarization vector                                 | POLARIZATION |
|  elpty     | double precision     | I   | eccentricity of elleptical light                             | ELLIPTICITY  |
|  xivec     | double precision     | I   | array(3) ellipticity vector                                  | ELLIPTICITY  |
|  ispin     | integer              | I   | 1=do spin calculation                                        | SPIN         |
|  spvec     | double precision     | I   | array(3) spin vector                                         | SPIN         |
|  angks     | double precision     | I   | angle between spin vector and incident beam                  | SPIN         |
|  ptz       | double precision     | O   | array(-1:1, -1:1) polarization tensor                        |              |
|  gamach    | double precision     | O   | tabulated core-hole lifetime                                 |              |
|  ixc       | integer              | I   | echange index                                                | EXCHANGE     |
|  vr0       | double precision     | I   | Fermi level shift                                            | EXCHANGE     |
|  vi0       | double precision     | I   | "optical" loss term                                          | EXCHANGE     |
|  ixc0      | integer              | I   | exchange index used for background function                  | EXCHANGE     |
|  iafolp    | integer              | I   | 1=do automated potential overlap                             | AFOLP        |
|  folp      | double precision     | I   | array(0:nphx) overlap fractions                              | FOLP/AFOLP   |
|  xion      | double precision     | I   | array(0:nphx) potential ionizations                          | ION          |
|  rgrd      | double precision     | I   | radial grid used for the potentials/phases                   | RGRID        |
|  iunf      | integer              | I   | 1=unfreeze f electrons                                       | UNFREEZEF    |
|  inters    | integer              | I   | interstitial potential and density param                     | INTERSTITIAL |
|  totvol    | double precision     | I   | interstitial potential and density param                     | INTERSTITIAL |
|  jumprm    | integer              | I   | 1=remove potential jumps at muffin tin radii                 | JUMPRM       |
|  nohole    | integer              | I   | 1=compute without core-hole                                  | NOHOLE       |
|  iplsmn    | integer              | I   | 1=compute with the MPSE approximation                        | PLASMON      |


### A note about Feff's screen messages

Feff traditionally spits a lot of text to the screen, particularly
when computing self-consistent potentials.  This screen output can be
suppressed by setting `verbse` to `.false.`, making the potentials and
phases calculation run completely silently (except for terminal
errors).  Setting `verbse` to `.true.` makes the library behave much
like the stand-alone `pot` and `xsph` programs.


## A note about the libpotph.json file

At this time (the date at the time of writing this note is 8 July
2015) the revamping of feff85exafs is a work in progress.  The
purpose is to facilitate the tight integration of feff into EXAFS data
analysis software.  Step one was to combine the roles of GENFMT and
FF2X into a stand-alone library, allowing user software to easily
generate the data table contained in a `feffNNNN.dat` file.  Step two
is to combine the roles of POT and XSPH into this stand-alone library,
alowing user software to easily generate the phase shifts needed for
path generation.

The full flowchart for an interaction with feff starts with gathering
data about the cluster and the details of the calculation.
Historically, this was done by reading a file called `feff.inp` using
the RDINP part of feff.  Armed with this information, the phases would
be calculated then the pathfinder would be used to enumerate the full
list of paths represented in the input cluster.  Finally,
`feffNNNN.dat` files would be generated.

The stand-alone libraries for phases and path are part of a plan to
disrupt this work flow.  Rather than relying on the quirky `feff.inp`
file, better user experiences could be created using modern UI and GUI
tools.  Until those new, better user experiences exist, we need a way
to get information into the phases library.

As a stop-gap measure, `rdinp` has been modified to write out a file
called `libpotph.json` which contains the content from a `feff.inp`
file required by the phases library in JSON format.  The
`read_libpotph_json` method used in the example above reads this JSON
file.

The eventual goal is that the UI somehow organizes the data needed by
the phases library, eliminating the need for either `feff.inp` or
`libpotph.json`.

# Content of the DEBYE folder

This directory contains various routines to calculate Debye-Waller
factors.

All routines in this directory are covered by the [LICENSE](../HEADERS/license.h)

[Sevillano, Meuth, and Rehr reference for correlated Debye model](https://doi.org/10.1103/PhysRevB.20.4908)


# Simple static analysis

To make HTML files explaining data I/O for each fortran source file, do

	../src> ftnchek -mkhtml *.f

# Call graph

![call graph for the BEBYE folder](tree/DEBYE.png)

# Content of the COMMON folder

This directory contains routines that are used by several modules.

Input/output routines:

* `chopen.f` - checks whether file was successfully opened
* `wlog.f` - writes string on screen and into the log file
* `head.f`  - routines to write header information
* `rdhead.f` - routines to read header information
* `itoken.f` - produces integer for each keyword in feff.inp
* `padlib.f` - PAD library written by M. Newville
* `str2dp.f` - additional routines to work with PAD format
* `str.f` - routines to deal with strings
* `rdpot.f` - read information from pot.pad
* `rdxsph.f` - read information from phase.pad
* `isnum.f` - tests whether a string can be a number
* `nxtunt.f` - returns the value of the next unopened unit number

Miscellaneous routines:

* `fixdsp.f` - fixes up the dirac spinor components for fine grid
* `fixdsx.f` - fixes up the dirac spinor components for fine grid
* `fixvar.f` - fixes up potential and density for fine grid
* `getorb.f` - gets atomic orbital data for chosen element
* `getxk.f` - gets k vector value for given energy
* `pertab.f` - periodic table: symbols and weights for each element
* `pijump.f` - removes jumps of 2*pi in phases
* `setkap.f` - set initial state ang mom and quantum number kappa
* `xx.f`  - returns x grid point on logarithmic radial grid 


The LICENSE for PAD library routines is included in the
[`padlib.f`](padlib.f) file.

All other routines in this directory are covered by the [LICENSE](../HEADERS/license.h)

# Simple static analysis

To make HTML files explaining data I/O for each fortran source file, do

	../src> ftnchek -mkhtml *.f

# Call graph

![call graph for the COMMON folder](tree/COMMON.png)

# Content of the ATOM folder

This directory contains various routines for single configuration
atomic calculations described in
[Ankudinov, Zabinsky, Rehr, Comp. Phys. Comm. 98, pp.359-364 (1996)](https://doi.org/10.1016/0010-4655%2896%2900097-5).

All routines in this directory are covered by the [LICENSE](../HEADERS/license.h)

# Simple static analysis

To make HTML files explaining data I/O for each fortran source file, do

	../src> ftnchek -mkhtml *.f

# Call graph

![call graph for the ATOM folder](tree/ATOM.png)

Python interface using ctypes: A work in progress 

Basically, this makes a direct connection to the
Fortran routine "onepath()" to calculate the XAFS
contributions for a scattering path, given path
geometry and a PAD-format file of the Potentials
and Phase-Shifts calculated by Feff.

Status:
==========

   Basic Functionality: Connecting to and running
   "onepath" from the libfeffgenfmt or libonepath
   shared library works.

   A simple calculation for 1 path appears to be
   approximately correct, but needs testing.

    
To Do:
=========

  1. Add a Larch Group interface.  This should
     better match Bruce's scatteringpath module,

  2. Get the unit tests to run!
  
  3. More testing, including Multiple Scattering

  4. Add "calculate_chi()" method to convert results of
     "calculate_xafs()" to chi(k).

  5. Mix with Larch's FeffPath, so that a Path
     can be specified as either FeffDatFile or as
     PotentialsFile + Geometry, and have
     calculation of chi(k) being automatic (or
     whenever geometry changes).

  6. Change the Fortran onepath() to be broken into
     genfmt_prep() and genfmt_calc(), so that the
     Potentials File can be loaded to memory only once.

# Content of the EXCH folder

This directory contains various routines to calculate self-energy
and exchange-correlation potentials.

All routines in this directory are covered by the [LICENSE](../HEADERS/license.h)

[Ankudinov and Rehr, Non-Local Self-Energy Models for XAS](https://doi.org/10.1051/jp4/1997099)
[Rehr, Kas, Prange, Sorini, Takimoto, Vila, Ab initio theory and calculations of X-ray spectra](https://doi.org/10.1016/j.crhy.2008.08.004)

# Simple static analysis

To make HTML files explaining data I/O for each fortran source file, do

	../src> ftnchek -mkhtml *.f

# Call graph

![call graph for the EXCH folder](tree/EXCH.png)

# NAME

Xray::FeffPath - Moose wrapper around an Inline::C interface to libfeffpath

# VERSION

1.00

# SYNOPSIS

This provides a simple object oriented interface to the `feffpath`
wrapper around Feff's `onepath` subroutine.  `onepath` combines the
F-matrix calculation in `GENFMT/genfmt.f` with the construction of the
common presentation of F-effective from `FF2X/feffdt.f`.

Given the geometry of a scattering path in the form of Cartesian
coordinates of atoms making up the path, along with some additional
information such as the degeneracy, compute F-effective for that
scattering path.

This replaces the need to read a `feffNNNN.dat` file.  Given a
scattering geometry, the equivalent data can be computed directly.

The following computes the columns of the `feff0004.dat` file for
copper metal:

    #!/usr/bin/perl
    use strict;
    use warnings;
    use Xray::FeffPath;

    my $path = Xray::FeffPath->new();
    $path->degen(48);
    $path->Index(4);
    $path->phpad('../fortran/phase.pad');
    $path->atom(0, 0, -3.61, 1);
    $path->atom(-1.805, 0, -1.805, 1);
    $path->path;
    my @kgrid  = @{ $path->k };
    my @caps   = @{ $path->real_phc };
    my @amff   = @{ $path->mag_feff };
    my @phff   = @{ $path->pha_feff };
    my @redfac = @{ $path->red_fact };
    my @lambda = @{ $path->lam };
    my @rep    = @{ $path->rep };
    undef $path

# INSTALLATION

After you have built and installed _feff85exafs_, do the following:

    perl Makefile.PL
    make
    make test
    sudo make install

That's it!  Note, though, that building this wrapper **requires** that
the fortran and C code _feff85exafs_ be completely compiled and that
the resulting libraries (and other files) be successfully installed.

# METHODS

- `new`

    Create the FeffPath object

        my $path = Xray::FeffPath->new();

- `atom`

    Add an atom to the scattering path, supplying the Cartesian
    coordiantes of the atom and its unique potential index.

        $nleg = $path->atom($x, $y, $z, $ipot);

    This returns the current number of legs in the path.  To make a SS
    paths do:

        $path->atom($x,  $y,  $z, $ipot1);
        print $path->nleg, $/;
        #   ==prints===> 2

    To make a MS path do:

        $path->atom($x1, $y1, $z1, $ipot1);
        $path->atom($x2, $y2, $z2, $ipot2);
        $path->atom($x3, $y3, $z3, $ipot3);
        print $path->nleg, $/;
        #   ==prints===> 4

    Note that there is no setter method for the nleg attribute.  Rather,
    `nleg` is incremented by each call to the `atom` method.

- `path`

    Compute the scattering path

        $path->path;

- `clear`

    Reinitialize the scattering path

        $path->clear;

To destroy a FeffPath object, simply

    undef $path;

# ATTRIBUTES

Each of the members of the FEFFPATH struct is wrapped in a getter
method of the same name.  Each of the following exists:

## Scalar valued attributes

- `phpad` (character, default = phase.pad)

    The path to the `phase.pad` file.  This gets right-padded with spaces
    to 256 characters, which is the length of the parameter in the
    underlying Fortran library.  Therefore, the value returned by the
    getter will be right-padded.

- `Index` (integer, default = 9999)

    The path index, used for form the name of the output `feffNNNN.dat`
    file.

    Accessing this and other scalar-values attributes works in the typical
    Moose-y way:

        $path->Index(4);
        print $path->Index, $/;
        ## ==prints==> 4

    Note that this attribute (but only this one) is capitalized to avoid
    confusion with the built-in `index` function.

- `degen` (float, default = 0)

    The path degeneracy.  This is required input for a calculation.

- `nleg` (integer, default = 0)

    The number of legs in the path.  This should never be set by hand.  It
    gets incremented by calls to the `atom` method.

- `iorder` (integer, default = 2)

    Order of approximation for multiple scattering paths.

- `nnnn` (boolean, default = 0)

    Flag for writing `feffNNNN.dat` file.

- `json` (boolean, default = 0)

    Flag for writing `feffNNNN.json` file.

- `verbose` (integer, default = 0)

    Flag for writing screen messages as files are written.

- `ipol` (boolean, default = 0)

    Perform polarization calculation.  This gets toggled to true whenever
    any of `elpty`, `evec`, or `xivec` are set.

- `elpty` (integer, default = 0)

    Ellipticity for use in polarization calculation.

- `reff` (float, default = 0)

    Half path length.  This should never be set by hand.  It
    gets set correctly when the `path` method is called.

- `ne` (integer, default = 0)

    Number of outpit k grid point.  This should never be set by hand.  It
    gets set correctly when the `path` method is called.

## Error reporting

- `errorcode` (integer)

    An integer error code from either `atom` or `path`.  Check for
    non-zero value.  For a non-zero return from `atom`, calling `path`
    is likely to cause a problem in the genfmt calculation.  For a
    non-zero return from `path`, the genfmt calculation was skipped.  See
    `errormessage` for an explanation of the problem.

- `errormessage` (string)

    A explanation of words of the problem found during `atom` or `path`.

        $path->degen(-48);
        $path->atom(0, 0, 3.61, 1);
        $path->path;
        if ($path->errorcode) {
           print $path->errormessage;
        };
        ## ==prints==>
         Error in make_path
             path degeneracy (-48.00) is negative

## Attributes related to the potential model

Several parameters are captured by the C struct (and therefore
available via the perl wrapper) which are related to how Feff's
potential model was calculated.  This information is written to the
`feffNNNN.dat` header.

- `version`

    A string identifying the version number and the \`feffpath\` wrapper
    revision.

- `exch`

    A string identifying the type of potential model used.  The
    possibilities are

        H-L exch (the default)
        D-H exch
        Gd state
        DH - HL
        DH + HL
        val=s+d
        sigmd(r)
        sigmd=c

    See the description of the EXCHANGE keyword in the Feff document
    [http://feffproject.org/feff/Docs/feff9/feff90/feff90\_users\_guide.pdf](http://feffproject.org/feff/Docs/feff9/feff90/feff90_users_guide.pdf)
    at page 92.

- `edge`

    A poor estimate of the energy threshold relative to the atomic value, in eV.

- `gam_ch`

    The core-hole lifetime, in eV.

- `kf`

    The k value at the Fermi energy, in inverse Angstroms.

- `mu`

    The Fermi energy, in eV.

- `rnorman`

    The average Norman radius.

- `rs_int`

    An estimate of the interstitial radius.

- `vint`

    The interstitial potential, in eV.

## Constants from feffpath.h

The following constants are captured from the feffpath header file:

- `nex` (150)

    The maximum number of points in the energy grid.

- `nphx` (11)

    The maximum number of unique potentials.

- `npatx` (8)

    The maximum number of path atoms

- `legtot` (9)

    The maximum number of legs in a path (npatx + 1)

- `bohr` (0.529177249)

    A unit of length, in Angstrom.

- `ryd` (13.605698)

    A Rydberg, a unit of energy, in eV.

- `hart` (27.211396)

    A Hartree, a unit of energy, in eV.

## Attributes with values of array-reference

- `absorber`

    The Cartesian coordinates of the absober atom.  By default the
    absorber is placed at (0,0,0).

- `ipot`

    A list of the unique potentials of the scatterers in a path.  This is
    populated by the calls to the `atom` method.

- `rat`

    A list of lists of the Cartesian coordinates of the scatterers in a
    path.  This is populated by the calls to the `atom` method.

- `evec`

    The electric vector of the incident beam for the polarization
    calculation.  Note that the setter's argument is an array reference as
    is the getter's return value.

        $path->evec([0,0,1]);
        $evec_ref = $path->evec;
        print join(", ", @$evec_ref);
        ## ==prints==> 0, 0, 1

    Setting `evec` will also set `ipol` to true.

- `xivec`

    The Poynting vector of the incident beam for the ellipticity
    calculation.  Note that the setter's argument is an array reference as
    is the getter's return value.

        $path->xivec([1,1,0]);
        $xivec_ref = $path->xivec;
        print join(", ", @$xivec_ref);
        ## ==prints==> 1, 1, 0

    Setting `xivec` will also set `ipol` to true.

- `ri`

    The leg lengths (in Angstroms) of the specified path.  This gets set
    when `path` is called.  It returns an reference to an array with
    `nleg` elements.

- `beta`

    The Eulerian beta angles (in degrees) of the specified path.  This
    gets set when `path` is called.  It returns a reference to an array
    with `nleg` elements.

- `eta`

    The Eulerian eta angles (in degrees) of the specified path.  This gets
    set when `path` is called.  It returns a reference to an array with
    `nleg` elements.

- `k`

    A reference to an array containing the k grid of the calculation.
    This is column 1 from `feffNNNN.dat`.

- `real_phc`

    A reference to an array containing the central atom phase shifts.
    This is column 2 from `feffNNNN.dat`.

- `mag_feff`

    A reference to an array containing the magnitude of F-effective.  This
    is column 3 from `feffNNNN.dat`.

- `pha_feff`

    A reference to an array containing the phase of F-effective.  This is
    column 4 from `feffNNNN.dat`.

- `red_fact`

    A reference to an array containing the reduction factor.  This is
    column 5 from `feffNNNN.dat`.

- `lam`

    A reference to an array containing lambda, the mean free path.  This is
    column 6 from `feffNNNN.dat`.

- `rep`

    A reference to an array containing the real part of the complex
    momentum.  This is column 7 from `feffNNNN.dat`.

# Error codes

The error codes returned by the `atom` and `path` methods are the
sums of the codes actually found by the method call, thus the returned
error codes are meant to be interpreted bitwise.

## `atom` method

If any of these are triggered, it is very likely that a call to
`path` will return unreliable results or may crash the program.

- _1_

    ipot argument to add\_scatterer is less than 0

- _2_

    ipot argument to add\_scatterer is greater than 7

- _4_

    coordinates are for an atom too close to the previous atom in the path

- _8_

    nlegs greater than legtot

## `path` method

If any of these are triggered, genfmt will not be called and all
output arrays will be zero-filled.

- _1_

    the first atom specified is the absorber

- _2_

    the last atom specified is the absorber

- _4_

    path degeneracy is negative

- _8_

    path index not between 0 and 9999

- _16_

    ellipticity not between 0 and 1

- _32_

    iorder not between 0 and 10

- _64_

    `phase.pad` cannot be found or cannot be read

# EXTERNAL DEPENDENCIES

- [Inline](https://metacpan.org/pod/Inline), and [Inline::C](https://metacpan.org/pod/Inline::C)
- [Moose](https://metacpan.org/pod/Moose)
- [MooseX::NonMoose](https://metacpan.org/pod/MooseX::NonMoose) and [MooseX::Aliases](https://metacpan.org/pod/MooseX::Aliases)

# BUGS AND LIMITATIONS

- Setting a boolean unsets phpad at Inline::C level.  Weird!
- Polarization test is quite trivial.  Should test against an actual
calculation.
- `ipol` and `rat` not accessed via wrapper.  That said,
Xray::FeffPath keeps those attributes current.

Please report problems to Bruce Ravel (bravel AT bnl DOT gov)

Patches are welcome.

# AUTHOR

Bruce Ravel (bravel AT bnl DOT gov)

[https://github.com/bruceravel](https://github.com/bruceravel)

# LICENSE AND COPYRIGHT

To the extent possible, the authors have waived all rights granted by
copyright law and related laws for the code and documentation that
make up the Perl Interface to the feffpath library.  While information
about Authorship may be retained in some files for historical reasons,
this work is hereby placed in the Public Domain.  This work is
published from: United States.

Note that the feffpath and onepath libraries themselves are NOT public
domain, nor is the Fortran source code for Feff that it relies upon.

Author: Bruce Ravel (bravel AT bnl DOT gov).
Last update: 13 February, 2015

# Content of the RDINP folder

This directory contains various routines to read the `feff.inp` file
and sort the data.

All routines in this directory are covered by the [LICENSE](../HEADERS/license.h)

# Simple static analysis

To make HTML files explaining data I/O for each fortran source file, do

	../src> ftnchek -mkhtml *.f

# Call graph

![call graph for the RDINP folder](tree/rdinp.png)

# Using the feffpath C wrapper

The program `makepath.c` will read from `phase.pad` (this example is
calculated from copper metal) and write the files `feff0001.dat` and
`feff0004.dat`.

The `makepath.c` program likely will not compile before you build and
install feff85exafs.  The build script will look for the `feffpath`
library and the `feffpath.h` header file in their installation
locations

The `errors.c` program exercises most of the error conditions
resulting from improper input to `add\_scatterer` or `make_path`.

To compile the `makepath` and `errors` sample programs:

	~> make

That's it!

## Sample program

Here is the simplest program using the C wrapper:

```C
#include <stdio.h>
#include <stdlib.h>
#include "feffpath.h"

long main()
{
  long i, ret;
  FEFFPATH *path;

  path = malloc(sizeof(FEFFPATH));
  ret = create_path(path);

  strcpy(path->phpad, "../fortran/phase.pad");
  path->nnnn    = 1;
  path->xdi     = 0;
  path->verbose = 1;

  /* first path in copper */
  path->index   = 1;
  path->deg     = 12.0;
  ret = add_scatterer(path, 1.805, 0, 1.805, 1);
  if (ret > 0) {
    printf("%s", path->errormessage);
    exit(ret);
  };
  ret = make_path(path);
  if (ret > 0) {
    printf("%s", path->errormessage);
    exit(ret);
  };

  clear_path(path);

  free(path);
  return 0;
}

```

1. The `feffpath.h` header file is included.

2. A FEFFPATH struct is created and called `path`.  Memory is
   allocated for it.

3. The call to `create_path` allocates memory for all elements of the
   struct and initializes everything.  The `phpad` attribute, which
   specifies the location of the `phase.pad` file, is set to
   `phase.pad` in the current working directory.

4. `strcpy` is used to set the `phpad` attribute to the actual location
   of the `phase.pad` file.  Note that the fortran parameter in the
   `onepath` library has this string dimensioned to be 256 characters.
   And it's fortran, so it probably won't deal gracefully with unicode
   characters.

5. Setting `nnnn` and `verbose` to a true value tells the program to
   write `feffNNNN.dat` files and to write a short message to the
   screen when it is written.  Setting `xdi` to a true value will
   cause `feffNNNN.xdi` to be written.  This is equivalent to
   `feffNNNN.dat`, but in XDI format.

6. The path index is set to 1.  This means the output file will be
   called `feff0001.dat`.

7. The degeneracy of the path is specified.

8. The `add_scatterer` method is used to build the scattering
   geometry.  It's arguments are the Cartesian coordinates (referenced
   to the absorber *at the origin*), the unique potential index of the
   atom.  The return value is an error code (see `feffpath.h`).  0
   means no error.

   In this case, a single scattering path is calculated, so
   `add_scatterer` is called only once.  For a multiple scattering
   path, `add_scatterer` would be called repeatedly, once for each
   atom (or leg) in the path.  `add_scatterer` fills the `rat` and
   `ipot` members of the struct and also sets `nleg`.

9. The call to `make_path` computes the parts of F-effective and
   stores them in the `path` struct.  The return value is an error
   code (see `feffpath.h`).  0 means no error.

10. The call to `clear_path` reinitializes the struct.  This is not
	strictly necessary in this case, but would be were the program to
	go on to compute another path.  Note that clear_path does not
	reset `phpad`, `nnnn`, or `xdi`, which are assumed to be
	constant from time to time calling `make_path`.

11. Finally, the memory for `path` is deallocated and the program
    terminates.


## Contents of the FEFFPATH struct

Here are all the elements of the struct, their data types,
descriptions, and default values.  Input parameters are marked with
"I" and output parameters, set by the `make_path` method, are marked
with "O".  Most of the names are chosen to be consistent with the
naming conventions in Feff.  The output arrays for the columns of
`feffNNNN.dat` are those
[used by Larch](http://xraypy.github.io/xraylarch/xafs/feffpaths.html#the-feffdat-group-full-details-of-the-feff-dat-file).

| attribute  | type       | I/O | description                             | default              |
| ---------- | --------   | --- |---------------------------------------- | -------------------- |
|  phpad     | \*char     | I   | path to `phase.pad`                     |  `phase.pad`         |
|  index     | long       | I   | path index                              |  9999                |
|  deg       | double     | I   | path degeneracy                         |  required input      |
|  nleg      | long       | I   | number of legs in path                  |  use add\_scatterer  |
|  rat       | \*\*double | I   | cartesian positions of atoms in path    |  use add\_scatterer  |
|  ipot      | \*long     | I   | unique potentials of atoms in path      |  use add\_scatterer  |
|  iorder    | long       | I   | order of approximation in genfmt        |  2                   |
|  nnnn      | bool       | I   | flag to write `feffNNNN.dat` file       |  false               |
|  xdi       | bool       | I   | flag to write `feffNNNN.xdi` file       |  false               |
|  verbose   | bool       | I   | flag to write screen messages           |  false               |
|  ipol      | bool       | I   | flag to do polarization calculation     |  false               |
|  evec      | \*double   | I   | polarization vector                     |  (0,0,0)             |
|  elpty     | double     | I   | ellipticity                             |  0                   |
|  xivec     | \*double   | I   | direction of X-ray propagation          |  (0,0,0)             |
|  ri        | \*double   | O   | leg lengths                             |                      |
|  beta      | \*double   | O   | beta angles                             |                      |
|  eta       | \*double   | O   | eta angles                              |                      |
|  reff      | double     | O   | half path length                        |  computed from ri    |
|  ne        | long       | O   | number of energy points actually used by Feff                | |
|  k         | \*double   | O   | k grid for feff path calculation, column 1 in `feffNNNN.dat` | |
|  real\_phc | \*double   | O   | central atom phase shifts. column 2 in `feffNNNN.dat`        | |
|  mag\_feff | \*double   | O   | magnitude of F\_eff, column 3 in `feffNNNN.dat`              | |
|  pha\_feff | \*double   | O   | phase of F\_eff, column 4 in `feffNNNN.dat`                  | |
|  red\_fact | \*double   | O   | reduction factor, column 5 in `feffNNNN.dat`                 | |
|  lam       | \*double   | O   | mean free path, column 6 in `feffNNNN.dat`                   | |
|  rep       | \*double   | O   | real part of complex momentum, column 7 in `feffNNNN.dat`    | |
|  errorcode | long       | O   | error code from `add_scatterer` or `make_path`               | |
|  errormessage | \*char  | O   | error message from `add_scatterer` or `make_path`            | |

Additionally, this struct captures several bits of information about
the potential model that Feff writes to the header of the `feffNNNN.dat` file:

| attribute  | type    | I/O | description                             |
| ---------- | ------- | --- |---------------------------------------- |
|  edge      | float   |  O  | energy threshold relative to atomic value (a poor estimate) |
|  gam\_ch   | float   |  O  | core level energy width |
|  kf        | float   |  O  | k value at Fermi level |
|  mu        | float   |  O  | Fermi level, eV |
|  rnorman   | float   |  O  | average Norman radius |
|  version   | string  |  O  | Feff version |
|  exch      | string  |  O  | brief description of the electronic exchange model |
|  rs\_int   | float   |  O  | interstitial radius |
|  vint      | float   |  O  | interstitial potential |
|  version   | string  |  O  | the version of feff and the feffpath revision |

A polarization calculation is enabled by setting the `ipol` element to
a true value.  `evec` has 3 elements and represents the polarization
vector of the incident beam.  `elpty` and `xivec` are the ellipticity
and Poynting vector of the incident beam for a calculation with
ellipticity.

When `make_path` is called, the `ri`, `beta`, and `eta` arrays are
filled to be `nleg` elements long and contain the geometry of the
scattering path.

Also when `make_path` is called, the arrays containing the columns of
a traditional `feffNNNN.dat` file are filled to be `ne` elements long.
These arrays are the same (besides precision) as the corresponding
columns.  While a `feffNNNN.dat` file can be exported (using the
`nnnn` flag), the need to write/read that file is obviated.

Direct access to `rat` and `ipot` is inconvenient and discouraged.
Use `add_scatterer`.

## A comment on the add_scatterer method

The way of building the geometry of the scattering path was
purposefully kept completely general.  While a program might use the
output of Feff's pathfinder, we also want to suport any other way of
generating path geometries.

To use the output of Feff's pathfinder, one would parse the
`paths.dat` file, making a path for each "paragraph" in the file and
calling `add_scatterer` for each atom in the path.

As a more complicated example, a reverse Monte Carlo approach to a fit
will move atoms to minimize difference between a model and the data.
As the atoms move about, the RMC program will generate new SS and MS
paths based on the current atom positions.  In that case, the current
coordinates can be used as the input to `add_scatterer` (with the
caveat that the `feffpath` library expects the absorber to be at the
origin, so the arguments to `add_scatterer` should have the absorber
position subtracted off).

# Content of the GENFMT folder

This directory contains routines for generalized F matrix
calculations, as described in
[the 1990 Rehr-Albers paper](https://doi.org/10.1103/PhysRevB.41.8139).

All routines in this directory are covered by the [LICENSE](../HEADERS/license.h)

This directory also contains the Fortran subroutine `onepath.f` which
combines the F-matrix caluclation of `GENFMT/genfmt.f` with the
presentation of F-effective from `FF2X/feffdt.f`.  The `onepath`
subroutine can be called with a specified path geometry and it will
return the columns of the `feffNNNN.dat` file as arrays.  Optionally,
it can also write out a `feffNNNN.dat` file or a JSON file containing
all information from the `feffNNNN.dat` file.

Also here is a C wrapper around `onepath.f` called `feffpath.c`.  This
is compiled into `libfeffpath.so`.  `feffpath.h` defines a struct
containing all the information found in a `feffNNNN.dat` file.  See
[wrappers/C/makepath.c](../../wrappers/C/makepath.c) for an example of
the use of the C wrapper in a C program.

The C library can be wrapped for use in other languages.
[Here's a use of the perl wrapper as an example.](../../wrappers/perl/examples/pathsdat.pl)
[And here's a very simple larch script.](../../wrappers/python/makepath.lar)

# Build and install

To build, type `make`.  This will build:

 * `libfeffgenfmt.a`: most of the functionality of genfmt
 * `genfmt`: the stand-alone program
 * `libonepath.so`: the Fortran entry point for generating a single path
 * `libfeffpath.so`: the C wrapper around onepath

Once built, type `sudo make install` to install everything:

 * `libonepath.so` and `libfeffpath.so`: installed to `/usr/local/lib`
 * `genfmt`: installed to `/usr/local/bin`
 * `feffpath.h`: installed to `/usr/local/include`

You **must** install this before building the Perl or Python wrappers.
All other wrappers will require that `libonepath.so` and
`libfeffpath.so` are installed.

# Simple static analysis

To make HTML files explaining data I/O for each fortran source file, do

	../src> ftnchek -mkhtml *.f

# Call graph

![call graph for the GENFMT folder](tree/genfmt.png)

## The phase.pad file ##

Along with the primary goal of wrapping up the calculation of the
columns of the `feffNNNN.dat` file, one of the goals of the C wrapper
is to provide a way of encapsulating *all* the information in that
file in a C struct.  We also aimed to do this without requiring any of
Feff's intermediate files.  That is, we want the only input for the
use of the `onepath`/`feffpath` libraries to be a `phase.pad` file.

A few of the bits of information in the header of the `feffNNNN.dat`
file are not used in the calculations -- computation of F\_eff and of
the columns of `feffNNNN.dat` -- performed by the `onepath` library
and so were not readily available.  To overcome this problem, the
content `phase.pad` file was modified slightly, but in a way that
should be both forward and backward compatible.

The first line in `phase.pad` is not packed ASCII.  Rather, it is a
straight print of several integers.  See
https://github.com/xraypy/feff85exafs/blob/master/src/XSPH/wrxsph.f#L46

An integer and two floats were added to the end of this list.  Those
three new parameters are initialized to zero before `phase.pad` is
read.  An old version of Feff reading this newly modified `phase.pad`
will simply ignore the three new numbers.  The newly modified Feff
reading an old version of `phase.pad` will simply report 0 for each of
these parameters. 


# The feffNNNN.dat file

When told to do so,, the `onepath`/`feffpath` libraries write out a
file called `f3ffNNNN.dat` which is a close approximation of the
traditional `feffNNNN.dat` file.

There is a little bit of information that is simply not available to
`onepath` without lifting the requirement that `phase.pad` be the only
required input file.  Here are the missing pieces of information, all
from the header:

* The user supplied title lines

* The title line which explains how the potentials are overlapped
  (see `POT/reapot.f` lines 233-280)

* The values for muffin tin and norman radii of the unique potentials
  (also the ionizations, if those are used).  This is actually a
  troublesome shortcoming that will have to be corrected via
  interaction with the forthcoming wrapper around the calcuation of
  the `phase.pad` file.

* The `vi0` and `vr0` parameters of the EXCHANGE card are not
  captured.  These are reported after `exch` in the header if either
  is non-zero.  Non-default values of RGRID are also not captured.

* The header line giving the keep and heap limits and the plane wave
  criterion.  These may not even be relevant, depending on how
  `onepath`/`feffpath` is used.

* Feff has an odd habit of specifying a 0 coordinate as `-0.0000`.
  `onepath`/`feffpath` will never write "negative zero".

Finally, there likely will be small differences in the data table at
the level of the fifth decimal place in floating point value.

# Using the scatteringpath python wrapper

When feff85exafs is built and installed, the basic SWIG wrapper files
(`feffpathwrapper.py` and `feffpath_wrap.c`) will be installed into
this folder.  This folder contains the file `scatteringpath.py`, which
is a Larch plugin encasulating much prettier syntax for the wrapper
generated by SWIG.

This folder contains an example of its use in a Larch script.  The larch
script `makepath.lar` will read from `phase.pad` (this example is
calculated from copper metal) and write the files `feff0001.dat` and
`feff0004.dat`.

You **must** build and install feff85exafs before attempting to build
this wrapper.

To compile the python wrapper:

	~> python setup.py build_ext --inplace

To install:

    >~ sudo python setup.py install_data

I know that's not the standard python installation incantation, but
those commands will see the files installed into Larch's space (which
is required for `scatteringpath` to be recognized as a plugin) rather
than into Python's space.


## Sample program

Once installed, here is the simplest larch program using the python wrapper:

```python
a=scatteringpath()

a.phpad = '../fortran/phase.pad
a.deg   = 12
a.index = 1

a.atom(0,0,-3.61,1)

a.make()

show a
```

1. The scatteringpath plugin is imported into the Larch session

2. A FeffPath Group is made

3. The FeffPath Group is pointed at a `phase.pad` file on disk.  The
   degeneracy and path index are set.  The flag for friting out the
   `feffNNNN.dat` file is set to True.

4. A scattering atom (in this case a Cu atom in the first coordination
   shell of Cu metal) is added to the path.  This increments the nleg
   attribute of the Group.

5. F_eff is calcuated using the make method.  This writes the
   `feff0001.dat` file and stores the columns of that file in the `k`,
   `real_phc`, `mag_feff`, `pha_feff`, `red_fact`, `lam`, and `rep`
   attributes of the Group.


## Attributes of the FeffPath Group

### Input:

| element   | type     | description                           | default              |
| ----------| -------- | ------------------------------------- | -------------------- |
| phpad     | string   | path to `phase.pad`                   |  `phase.pad`         |
| index     | integer  | path index                            |  9999                |
| deg       | float    | path degeneracy                       |  required input      |
| nleg      | integer  | number of legs in path                |  set using atom method (read-only)         |
| rat       | array    | cartesian positions of atoms in path  |  set using atom method (not yet available) |
| ipot      | integer  | unique potentials of atoms in path    |  set using atom method (not yet available) |
| iorder    | integer  | order of approximation in genfmt      |  2                   |
| nnnn      | boolean  | flag to write `feffNNNN.dat` file     |  False               |
| json      | boolean  | flag to write `feffNNNN.json` file    |  False               |
| verbose   | boolean  | flag to write screen messages         |  False               |
| ipol      | boolean  | flag to do polarization calculation   |  False (set True when evec|xivec|elpty set) |
| evec      | array    | polarization vector                   |  (0,0,0)             |
| elpty     | float    | ellipticity                           |  0                   |
| xivec     | array    | direction of X-ray propagation        |  (0,0,0)             |

### Output:

| element      | type     | description                                                 |
| ------------ | -------- | ----------------------------------------------------------- |
| ri           | array    | leg lengths                                                 |
| beta         | array    | beta angles                                                 |
| eta          | array    | eta angles                                                  |
| reff         | float    | half path length (computed from ri)                         |
| ne           | integer  | number of energy points actually used by Feff (read-only)   |
| k            | array    | k grid for feff path calculation, column 1 in `feffNNNN.dat`|
| real_phc     | array    | central atom phase shifts. column 2 in `feffNNNN.dat`       |
| mag_feff     | array    | magnitude of F_eff, column 3 in `feffNNNN.dat`              |
| pha_feff     | array    | phase of F_eff, column 4 in `feffNNNN.dat`                  |
| red_fact     | array    | reduction factor, column 5 in `feffNNNN.dat`                |
| lam          | array    | mean free path, column 6 in `feffNNNN.dat`                  |
| rep          | array    | real part of complex momentum, column 7 in `feffNNNN.dat`   |
| errorcode    | integer  | error code from `atom` or `make`                            |
| errormessage | string   | error message from `atom` or `make`                         |

Additionally, several bits of information about the potential model
are capture.  These are things that Feff writes to the header of the
`feffNNNN.dat` file:

| attribute  | type    |  description                             |
| ---------- | ------- | ---------------------------------------- |
|  edge      | float   |  energy threshold relative to atomic value (a poor estimate) |
|  gam\_ch   | float   |  core level energy width |
|  kf        | float   |  k value at Fermi level |
|  mu        | float   |  Fermi level, eV |
|  rnorman   | float   |  average Norman radius |
|  version   | string  |  Feff version |
|  exch      | string  |  brief description of the electronic exchange model |
|  rs\_int   | float   |  interstitial radius |
|  vint      | float   |  interstitial potential |
|  version   | string  |  the version of feff and the feffpath revision |


A polarization calculation is enabled by setting the `ipol` element to
a true value.  `evec` has 3 elements and represents the polarization
vector of the incident beam.  `elpty` and `xivec` are the ellipticity
and Poynting vector of the incident beam for a calculation with
ellipticity.

When `make` is called, the `ri`, `beta`, and `eta` arrays are
filled to be `nleg` elements long and contain the geometry of the
scattering path.

Also when `make` is called, the arrays containing the columns of a
traditional `feffNNNN.dat` file are filled to be `ne` elements long.
These arrays are the same (besides precision) as the corresponding
columns.  While a `feffNNNN.dat` file can be exported (using the
`nnnn` flag), the need to write/read that file is obviated.

Direct access to `rat` and `ipot` is not provided.  Use `atom`.

## A comment on the atom method

The way of building the geometry of the scattering path was
purposefully kept completely general.  While a program might use the
output of Feff's pathfinder, we also want to suport any other way of
generating path geometries.

To use the output of Feff's pathfinder, one would parse the
`paths.dat` file, making a path for each "paragraph" in the file and
calling `atom` for each atom in the path.

As a more complicated example, a reverse Monte Carlo approach to a fit
will move atoms to minimize difference between a model and the data.
As the atoms move about, the RMC program will generate new SS and MS
paths based on the current atom positions.  In that case, the current
coordinates can be used as the input to `atom` (with the caveat that
the `feffpath` library expects the absorber to be at the origin, so
the arguments to `atom` should have the absorber position subtracted
off).

# Content of the FMS folder

This directory contains various routines for Full Multiple Scattering
calculations.

All routines in this directory are covered by the [LICENSE](../HEADERS/license.h)

[Ankudinov, Ravel, Rehr, Conradson, Real-space multiple-scattering calculation and interpretation of x-ray-absorption near-edge structure](https://doi.org/10.1103/PhysRevB.58.7565)

# Simple static analysis

To make HTML files explaining data I/O for each fortran source file, do

	../src> ftnchek -mkhtml *.f

# Call graph

![call graph for the FMS folder](tree/FMS.png)

# Using the feffphases C wrapper

The program `makephases.c` will read from `libpotph.json` (this
example is made from a `feff.inp` file for copper metal) and write the
`phase.pad` file.

The `makephases.c` program likely will not compile before you build and
install feff85exafs.  The build script will look for the `feffphases`
library and the `feffphases.h` header file in their installation
locations

To compile the `makephases` sample programs:

	~> make

That's it!

## Sample program

Here is the simplest program using the C wrapper in `libfeffphases`:

```C
#include <stdio.h>
#include <stdlib.h>
#include "feffphases.h"

int main()
{
  int i, ret;
  FEFFPHASES *phases;

  phases = malloc(sizeof(FEFFPHASES));
  ret = create_phases(phases);

  strcpy(phases->jsonfile, "../fortran/libpotph.json");
  strcpy(phases->phpad, "/path/to/phase.pad");
  ret = read_libpotph_json(phases);
  if (ret > 0) {
    printf("%s (error code %d)\n", phases->errormessage, phases->errorcode);
  } else {
	ret = make_phases(phases);
    if (ret > 0) {
      printf("%s (error code %d)\n", phases->errormessage, phases->errorcode);
    };
  }

  cleanup(phases);
  free(phases);
  return 0;
}

```

1. The `feffphases.h` header file is included.

2. A FEFFPHASES struct is created and is named `phases`.  Memory is
   allocated for it.

3. The call to `create_phases` allocates memory for all elements of the
   struct and initializes everything.

4. The `jsonfile` attribute of the struct is set to the location of
   the `libpotph.json` file, then it is read and imported into the
   struct.  (See note below.)

5. If no problems are found among the input data, the `phase.pad` file
   is calcuated and written to disk.

6. Finally, the memory for `phases` is deallocated and the program
   terminates.

## Contents of the FEFFPATH struct

| attribute    | type               | I/O | description                                         | feff.inp card |
| ------------ | ------------------ | --- |---------------------------------------------------- | ------------- |
| phpad        | \*char             | I   | path to output `phase.pad` file                     |               |
| jsonfile     | \*char             | I   | path to `libpotph.json`                             |               |
| verbose      | bool               | I   | flag to wrrite Feff screen messages, F=suppress     |               |
| errorcode    | int                | O   | integer error code                                  |               |
| errormessage | \*char             | O   | message associated with error code                  |               |
| ntitle       | int                | I   | number of header lines                              | TITLE         |
| titles       | \*\*char           | I   | (nheadx) array of header string                     | TITLE         |
| nat          | int                | I   | number of atoms in cluster                          | ATOMS         |
| rat          | \*\*double         | I   | (3,natx) cartesian coordinates of atoms in cluster  | ATOMS         |
| iphat        | \*int              | I   | (natx) unique potential indeces of atoms in cluster | ATOMS         |
| nph          | int                | I   | number of unique potentials                         | POTENTIALS    |
| iz           | \*int              | I   | (0:nphx) Z numbers of unique potentials             | POTENTIALS    |
| potlbl       | \*\*char           | I   | (0:nphx) labels of unique potentials                | POTENTIALS    |
| lmaxsc       | \*int              | I   | (0:nphx) l max for SCF for each potential           | POTENTIALS    |
| lmaxph       | \*int              | I   | (0:nphx) l max for FMS for each potential           | POTENTIALS    |
| xnatph       | \*double           | I   | (0:nphx) stoichiometry of each potential            | POTENTIALS    |
| spinph       | \*double           | I   | (0:nphx) spin on each unique potential              | POTENTIALS    |
| ihole        | int                | I   | edge index, 1=K, 4=L3, etc                          | HOLE/EDGE     |
| rscf         | float              | I   | cluster radius for self-consistent calculation      | SCF           |
| lscf         | int                | I   | 0=solid, 1=molecule                                 | SCF           |
| nscmt        | int                | I   | max number of self-consistency iterations           | SCF           |
| ca           | double             | I   | self-consistency convergence accelerator            | SCF           |
| nmix         | int                | I   | number of mixing iterations before Broyden          | SCF           |
| ecv          | double             | I   | core/valence separation energy                      | SCF           |
| icoul        | int                | I   | obsolete param. for handling Coulomb potential      | SCF           |
| ipol         | int                | I   | 1=do polarization calculation                       | POLARIZATION  |
| evec         | \*double           | I   | (3) polarization array                              | POLARIZATION  |
| elpty        | double             | I   | eccentricity of elliptical light                    | ELLIPTICITY   |
| xivec        | \*double           | I   | (3) ellipticity array                               | ELLIPTICITY   |
| ispin        | int                | I   | +/-2 = do spin calculation                          | SPIN          |
| spvec        | \*double           | I   | (3) spin array                                      | SPIN          |
| angks        | double             | I   | angle between spin and incidient beam               | SPIN          |
| ptz          | \*\*double complex | O   | (-1:1,-1:1) polarization tensor                     | return        |
| gamach       | double             | O   | tabulated core-hole lifetime                        | return        |
| ixc          | int                | I   | exchange index                                      | EXCHANGE      |
| vr0          | double             | I   | Fermi level offset                                  | EXCHANGE      |
| vi0          | double             | I   | constant broadening                                 | EXCHANGE      |
| ixc0         | int                | I   | exchange index for background function              | EXCHANGE      |
| iafolp       | int                | I   | 1=do automated overlapping                          | FOLP & AFOLP  |
| folp         | \*double           | I   | (0:nphx) overlapping fractions                      | FOLP & AFOLP  |
| xion         | \*double           | I   | (0:nphx) potential ionizations                      | ION           |
| rgrd         | double             | I   | radial grid used for the potentials/phases          | RGRID         |
| iunf         | int                | I   | 1=unfreeze f electrons                              | UNFREEZEF     |
| inters       | int                | I   |                                                     | INTERSTITIAL  |
| totvol       | double             | I   |                                                     | INTERSTITIAL  |
| jumprm       | int                | I   | 1=remove potential jumps at muffin tin radii        | JUMPRM        |
| nohole       | int                | I   | 1=compute without core-hole                         | NOHOLE        |
| iplsmn       | int                | I   | 1=compute with the MPSE approximation               | PLASMON       |


Note that `rscf` is a _single precision float_!

Note, where appropriate (`rscf`, `gamach`, `ecv`, `totvol`, `rat`),
these parameters are in *natural units* (Angstrom and eV).  They will
be converted to *code units* (Bohr and Hartree) by the library.

The error code and message will be 0 and an empty string when no
errors are found.

### A note about Feff screen messages

The default is to suppress Feff's many screen messages, ie. `verbose`
is false by default.  No effort is made to capture the path to
convergence when computing self-consistent potentials.  In order to
preserve that information, you must set `verbose` to true then somehow
capture and parse the screen output.  This is left as a chore for the
user interface.

### Attributes to consider trimming

1. `iafolp`: this may not be needed in the struct, the folp array gets filled
2. does the polarization and ellipticity info have any impact on the phases?
3. is spin to be supported in feff85exafs?
4. what does INTERSTITIAL do?  I've never quite understood that one....


## A note about the libpotph.json file

At this time (the date at the time of writing this note is 8 July
2015) the revamping of feff85exafs is a work in progress.  The
purpose is to facilitate the tight integration of feff into EXAFS data
analysis software.  Step one was to combine the roles of GENFMT and
FF2X into a stand-alone library, allowing user software to easily
generate the data table contained in a `feffNNNN.dat` file.  Step two
is to combine the roles of POT and XSPH into this stand-alone library,
alowing user software to easily generate the phase shifts needed for
path generation.

The full flowchart for an interaction with feff starts with gathering
data about the cluster and the details of the calculation.
Historically, this was done by reading a file called `feff.inp` using
the RDINP part of feff.  Armed with this information, the phases would
be calculated then the pathfinder would be used to enumerate the full
list of paths represented in the input cluster.  Finally,
`feffNNNN.dat` files would be generated.

The stand-alone libraries for phases and path are part of a plan to
disrupt this work flow.  Rather than relying on the quirky `feff.inp`
file, better user experiences could be created using modern UI and GUI
tools.  Until those new, better user experiences exist, we need a way
to get information into the phases library.

As a stop-gap measure, `rdinp` has been modified to write out a file
called `libpotph.json` which contains the content from a `feff.inp`
file required by the phases library in JSON format.  The
`read_libpotph_json` method used in the example above reads this JSON
file.

The eventual goal is that the UI somehow organizes the data needed by
the phases library, eliminating the need for either `feff.inp` or
`libpotph.json`.

# Deprecated files in GENFMT

These deprecated files are the various `.h` header files used to
define the common blocks that were used to pass information between
the parts of genfmt.

For feff8l, the use of common blocks was removed in favor of
explicit argument passing.

The folder will likely be removed at some future time.

Materials for unit testing
==========================

For each example material, several files are provided:

 1. Structural data, either in the form of an
    [Atoms input file](http://bruceravel.github.io/demeter/artug/feff/index.html#crystaldata),
    a [CIF file](http://www.iucr.org/resources/cif), or a
    [Feff input file](http://monalisa.phys.washington.edu/feff/wiki/static/f/e/f/FEFFinp_4993.html).

 2. Where crystal data is given in the form of an Atoms input or CIF
	file, the crystal data has been converted into a file very much
	like a Feff input file and with the extension `.mustache`.

 3. The Feff input files are not yet in a form ready for running Feff.
    Each one is in a form used by the
    [Mustache](http://mustache.github.io/) templating system.  A few
    bits of input data have been replaced by tokens that look like
    this: `{{scf}}`.  These tokens will be replaced by values
    appropriate to the test being performed.  Those values are usually
    taken from a `.json` file with the same name as the folder itself.
    The mustache files here were edited by hand or made using
    [the `feff85exafs` template in Demeter](https://github.com/bruceravel/demeter/blob/master/lib/Demeter/templates/atoms/feff85test.tmpl).

 4. For tests which have data associated with them and will include
    results of fits to EXAFS data as part of their test, the data is
    provided in the form of an
    [Athena project file](http://bruceravel.github.io/demeter/aug/output/project.html)
    and as a column ASCII data containing chi(k).  The column data
    file is in the
    [XDI format](https://github.com/XraySpectroscopy/XAS-Data-Interchange).

 5. For tests which have data associated with them and will include
    results of fits to EXAFS data as part of their test, a file of
    python code defining the fit must be provided.  This **must**
    define a function called `do_fit` which implements the fit in
    larch and provides a plot and fit report for interactive use.

 6. Most of the material folders also contain some kind of image
    showing the nature of the coordination environment about the
    absorbing atom.

 7. Each materials folder has a subfolder containing the baseline Feff
    calculation.  This is a run of Feff 8.5 as delivered by the Feff
    Project.  The sense in which this is a baseline is that, as
    changes are made to the Feff85EXAFS code base, those changes can
    be tested against this original state of the software.  Changes to
    the code base should not result in changes to the output of Feff.
    This baseline can also serve as a platform for testing changes
    across versions of Feff, allowing us to probe in a systematic way
    the differences in EXAFS analysis between versions 6 through 9 or
    Feff.  Baseline calculations have been made with and without
    self-consistency.


The testing infrastructure is implemented with
[Nose](https://nose.readthedocs.org/en/latest/index.html) and a
[Larch](https://github.com/xraypy/xraylarch) plugin.

The testing infrastructure is designed so that it is easy to add new
tests, so long as an appropriate set of files is provided for each new
test.

Note that the file naming conventions for the test files are quite
strict.  If you introduce a new material, say Ceria (CeO2), and you
name the folder containing its files `Ceria/`, then the you must
follow these rules:

1. The structure file **must** be `Ceria.<extension>` or
   `Ceria_atoms.inp`.  Here `<extension>` is something like `cif` or
   `sdf`.
2. The Mustache template file **must** be called `Ceria.mustache`.
3. The chi(k) **must** be called `Ceria.chik`, the first data column
   **must** be wavenumber and the second column **must** be
   un-k-weighted chi(k).  You **should** save the chi(k) file as an
   XDI file. 
4. The JSON file with the configuration for the Feff run **must** be
   called `Ceria.json`.
5. There **must** be a folder called `baseline/` which has folders
   called `withSCF/` and `noSCF/`. These contain the baseline
   calculations with and without self-consistency.  The baseline
   calculation should be made using a point in the feff85exafs history
   ([this point, for example](https://github.com/xraypy/feff85exafs/commit/cac0f8c90749ce52581a658c5a6c8ae144cc2211))
   from before changes were made to the code as it was delivered to us
   from the Feff Project.
6. If you provide an Athena project file, it should be called
   `Ceria.prj`.
7. If fits to data are part of the test, there must be a file called
   `Ceria.py` containing python code defining the fit to the data.
8. You must add `Ceria` to the `folders` tuple at the top of
   `tests/test_materials.py`.
9. You should provide a `README.md` file with basic information in
   markdown format.  Any other files, for instance images displayed in
   the `README.md` file can have any name (since they will not be used
   in testing)

---

## Materials:

1. **copper metal**: because copper

2. **nickel oxide, NiO**: this is a simple, cubic, metal oxide.  It
   represents a problem slightly more complicated than copper metal.
   It also is easy to get a decent fit out to the sixth coordination
   shell.

3. **uraninite, UO2**: this is an f-electron system

4. **zircon, ZrSiO4**: this has Si, a tender energy absorber, with a
   4d backscatterer

5. **bromoadamantane**: this is a small molecule which can be fit with a
   fairly simple model of four paths, but for which the 6 nearby hydrogen
   scatterers play a big role in the fit.

6. **ferrocene macrocycle**: this is a iron organometallic with Fe in
   between two 5 member carbon rings, so it has 10 C neighbors at a range
   of distances from 2.026 A to 2.099 A

7. **lanthanum cuprate**: this is an orthorhombic crystal with the
   copper atom in an octahedral configuration.  The oxygen atoms along
   the z axis are much farther away than the ones in the plane.  This,
   then, is a test that involves Feff's polarization and ellipticity
   calculations.  There is one folder for calculating with the
   incident light parallel to the z axis (polarization only) and one
   for light perpendicular to the z axis (polarization and
   ellipticity).

---

## Installing and using the unit testing tool

Make sure that all parts of Feff have been compiled successfully.  The
unit test framework currently uses larch's `feffrunner` class to make
the test runs of Feff.  You must have the termcolor, pystache and nose
python libraries installed.  (In debian/ubuntu, these are called
`python-termcolor`, `python-pystache`, and `python-nose`.  Or you can
use [pip](https://pip.pypa.io/en/stable/)).

(Eventually, this testing framework will need to test the data tables
from the wrapper against the `feffNNNN.dat` files from the baseline
calculation.)

Copy the file `f85ut.py` to the larch plugins folder
(`$HOME/.larch/plugins/` on Unix; `C:\Users\<ME>\larch\plugins` or
`C:\Program Files\larch\plugins` on Windows).  Alternately, make a
symbolic link from the plugin folder to the file:

      ln -s  `pwd`/f85ut.py ~/.larch/plugins/f85ut.py

Here, I have assumed that you will run this command in the folder
containing both this README file and the `f85ut.py` file.  That is why
the call to `pwd` works.



---

### Run tests through nose

In the `materials` folder, run `nosetests` at the command line.  Nose
writes a report on the results of the test sequence.

Any tests that fail can be further examined interactively within
Larch.

When run through Nose, the beginning of the test sequence is *very*
time consuming as all the Feff calculations are made before any of the
actual tests are made.  I find it helpful to run `nosetests
--verbosity=3`, which gives some feedback about what is actually
happening.


#### Run Feff with self-consistency

set the `FEFF_TEST_SCF` environment variable to `True`.  With bash,
zsh, etc:

    ~> export FEFF_TEST_SCF=True

With csh, tcsh, etc:

    ~> setenv FEFF_TEST_SCF "True"

#### Skip canned data tests

Normally, a data test will be run if the `<name>.py` file is present
in the material's folder.  The data test for that material will be
skipped if a file called `<name>.skip` exists in its folder.  For
example, to skip the test for UO2, do

	~> touch UO2/UO2.skip

To re-enable the data test for UO2, do

	~> rm UO2/UO2.skip



---

### Interactive testing in Larch

Fire up Larch from the folder containing this README file and do the
following:

    larch> add_plugin('f85ut')
    larch> my_ut = ut('Copper')

That will create a unit testing object called `my_ut` and point it at
the folder containing the materials related to unit tests on a
calculation for copper metal.

Next do

     larch> my_ut.run()

This will run a calculation on copper metal using Feff85exafs in its
current state.  Once this is done, you can check the results of the
calculation against the baseline calculation, i.e. a calculation made
using Feff85exafs as it was delivered to us by the Feff Project.

To run Feff with self-consistency, do

	 larch> my_ut.doscf=True

The Feff run is, of course, much more time consuming with
self-consistency.

To see whether the calculation of a path differs from the baseline
calculation, do

     larch> my_ut.compare(path_index)

where `path_index` is the `NNNN` in `feffNNNN.dat`.

This will compute a simple R factor between the magnitude of F\_eff in
the baseline and the test run.  It will also compute and R factor for
the phase of F\_eff.  If `my_ut.doplot` is True (which is the default),
plots of magnitude and phase of F\_eff will be made including both the
baseline and the test run.

You can compare other parts of the calculation:

     larch> my_ut.compare(path_index, part)

where `part` is one of

part    | purpose
--------|------------------------------------------------
feff    | test the magnitude AND phase of F_eff (default)
amp     | test the total amplitude of the path
phase   | test the total phase of the path
lambda  | test the mean free path
caps    | test the central atom phase shift
redfact | test the reduction factor
rep     | test the real part of the complex wavenumber

To test if a path index was saved from the Feff calculation

     larch> if my_ut.available(nnnn):
     larch>     my_ut.compare(nnnn)
     larch> end if

To examine various other quantities from the Feff calculation:

     larch> my_ut.feffterms()
	 larch> print my_ut.radii('testrun', 'muffintin') my_ut.radii('baseline', 'muffintin') 
	 larch> print my_ut.radii('testrun', 'norman')    my_ut.radii('baseline', 'norman') 
	 larch> print my_ut.s02('testrun')                my_ut.s02('baseline') 

Some of the materials have data tests.  This

     larch> my_ut.fit()

runs a canned fit, once using the baseline Feff calculation and once
using the test run.  You can then compare fitting parameters and
statistics from the two.  The fit groups are `my_ut.blfit` and
`my_ut.trfit`.  You could, for example, examine the `amp` parameter:

     larch> print my_ut.blfit.params.amp.value my_ut.blfit.params.amp.stderr
     larch> print my_ut.trfit.params.amp.value my_ut.trfit.params.amp.stderr

Finally, clean up the test run by doing:

     larch> my_ut.clean()

Some convenience functions exported by the plugin:

* use `my_ut = ir('Copper')` to define the unit testing object and run feff
* use `my_ut = irc('Copper')` to define the unit testing object, run
  feff, and make a comparison for first path
* use `my_ut = irf('Copper')` to define the unit testing object, run
  feff, and run the fit


# Still to do

* use wrapper to do tests of baseline feffNNNN.dat file to in-memory
  data table

* capture and interpret Feff's screen messages to use number of SCF
  iterations as a unit test

* More materials:
	+ A polymer, i.e. something pseudo-one-dimensional
	+ Something from the first row of the periodic table
	+ Something with lead as the absorber
	+ Something from column 1 or column 2 of the periodic table
	+ Something with a ring structure and strong, high-order MS paths
      (paradibromobenzene, perhaps)
	+ americium, a transuranic that was above Feff6's Z cutoff

# Feff85EXAFS example: zircon, ZrSiO4

This is not a data-bearing example, thus the tests will only cover the
computation.

Zircon is an example of a tender energy absorber -- Si.  The
calculation will be made at the Si K edge

![Ball and stick figure of ZrSiO4, zircon ](ZrSiO4.png) -- [image from the ChemTube3D website](http://www.chemtube3d.com/solidstate/SS-ZrSiO4.htm)


* [Atoms input file for zircon](Zircon_atoms.cif)
* [template for feff input file (generated from CIF file)](Zircon.mustache) -- uses the [mustache](http://mustache.github.io/) templating system

# Feff85EXAFS example: Lanthanum cuprate, polarization perpendicular to the z-axis

This is not a data-bearing example, thus the tests will only cover the
computation.

This is La2CuO4, an orthorhombic crystal with the oxygen octahedron
around the copper atom elongated in the z direction.  In the plane,
there are 4 Cu-O scatterers at 1.90 angstrom.  In the z direction,
there are two Cu-O scatterers at 2.43 angstrom.

This tests making a polarizion dependent Feff calculation.  See also
the LCO-para test which uses the same material to test polarization
without ellipticipty.

Structure from
[Radaelli at al.](https://doi.org/10.1103/PhysRevB.49.4163).
EXAFS analysis from
[Haskel, et al.](https://doi.org/10.1103/PhysRevB.56.R521)

![Ball and stick figure of La2CuO4 from Haskel, et al. ](LCO.png)


* [Atoms input file for LCO](LCO-perp.inp)
* [template for feff input file (generated from the atoms input file)](LCO-perp.mustache) -- uses the [mustache](http://mustache.github.io/) templating system

# Feff85EXAFS example: ferrocene

This is not a data-bearing example, thus the tests will only cover the
computation.

This is a ferrocene-based macrocycle, see Dinnebier et al,
Organometallics 2001, 20, 5642-5647
[doi:10.1021/om0105066](https://doi.org/10.1021/om0105066).
Ferrocene is an example of a transition metal carbide with an odd,
low-symmetry, disordered local coordination environment.  The Fe atom
is surrounded by 10 carbon atoms at distances ranging from 2.02642
Angstrom to 2.09948 Angstrom.  These carbon atoms are arranged in a
bipyramidal configuration where each pyramid is five-sdied.

This example represents the sort of problem of interest to biologist
and biochemists.


![Schematic representation of the macrocycle, including the Fe atoms surrounded by two ferrocenylene units, image from Dinnebier et al.](macrocycle.png)


* [Atoms input file for ferrocene macrocycle, positions from Table 2 in Dinnebier et al.](ferrocene_atoms.inp)
* [template for feff input file (generated from atoms input file file)](ferrocene.mustache) -- uses the [mustache](http://mustache.github.io/) templating system

# Feff85EXAFS example: 1-bromoadamantane

This is a data-bearing example, thus the tests will cover both the
computation and the results of the analysis.

Bromoadamantane is a single-bonded, 10-carbon frame with hydrogen
atoms accommodating the remaining charge on the carbon atoms.  One
hydrogen atom is replaced with a bromine atom.  The XAS data are
measured at the Br K edge.

This is an interesting analysis problem because the Br-H scattering
plays a significant and easily measurable role in the EXAFS analysis.

The bromoadamantane sample was kindly provided by Alessandra Leri,
Marymount Manhattan College and measured by Bruce at NSLS X23A2.

![Ball and stick figure of the 1-bromoadamantane molecule](bromoadamantane.png)


* [Chemical table file (cartesian coordinates)](bromoadamantane.sdf) -- [CID 79106](http://pubchem.ncbi.nlm.nih.gov/summary/summary.cgi?cid=79106)
* [template for feff input file (converted from SDF file)](bromoadamantane.mustache) -- uses the [mustache](http://mustache.github.io/) templating system
* [XDI data file: chi(k)](bromoadamantane.chik)
* [Athena project file](bromoadamantane.prj) -- Data processed with a pre-release of Demeter 0.9.21 using the larch (0.9.23) backend and XDI 1.0

# Feff85EXAFS example: Copper metal

This is a data-bearing example, thus the tests will cover both the
computation and the results of the analysis.

This is a copper foil measured in a displex near 10K.  Since 1995,
this has been a canonical example for testing EXAFS theory and analysis.

This copper data is the foil in reference 57 of the Zabinski et al
paper from 1995 which introduced Feff's approach to multiple
scattering to the world.  According to Google Scholar, this spectrum
has been cited at least 17 times!

For an amusing walk down memory lane, here's Matt and Bruce recalling
this measurement 22 years later:
https://github.com/XraySpectroscopy/XAS-Data-Interchange/issues/29


* [Atoms input file for copper](Copper_atoms.inp)
* [template for feff input file (generated from the atoms input file)](Copper.mustache) -- uses the [mustache](http://mustache.github.io/) templating system
* [XDI data file: chi(k)](Copper.chik)
* [The raw data file](cu.012)
* [Athena project file](Copper.prj) -- Data processed with a pre-release of Demeter 0.9.21 using the larch (0.9.23) backend and XDI 1.0

# Feff85EXAFS example: uraninite, UO2

This is a data-bearing example, thus the tests will cover both the
computation and the results of the analysis.

Uraninite is a simple, cubic structure with uranium octahedrally
coordinated by oxygen.  It is included as an example of an f-electron
system.

The nonparticle uraninite data was measured at APS 10ID and kindly
provided by Shelly Kelly.  The data test follows her fitting model
from [DOI: 10.1021/es0208409](https://doi.org/10.1021/es0208409).


![Ball and stick figure of uraninite](uraninite.gif)


Canada apparently &hearts;s uraninite.
![Canada &#9829; uraninite!](stamp.jpg)


* [CIF file for uraninite](UO2.cif)
* [template for feff input file (generated from CIF file)](UO2.mustache) -- uses the [mustache](http://mustache.github.io/) templating system
* [XDI data file: chi(k)](UO2.chik)
* [Athena project file](UO2.prj) -- Data processed with a pre-release of Demeter 0.9.21 using the larch (0.9.23) backend and XDI 1.0

# Feff85EXAFS example: NiO

This is a data-bearing example, thus the tests will cover both the
computation and the results of the analysis.

NiO is a simple transition metal oxide in the rock-salt structure.
This is intended as a slightly more complex example than copper metal.
The XAS data are measured at the Ni K edge.

The NiO sample was kindly provided by Neil Hyatt and Martin Stennett,
Sheffield University and measured by Bruce at NSLS X23A2.
See [DOI: 10.1107/S1600577515013521](https://doi.org/10.1107/S1600577515013521).

![Ball and stick figure of rock-salt NiO](NiO.png)

* [Atoms input file file for NiO](NiO_atoms.inp)
* [template for feff input file (generated from the atoms input file)](NiO.mustache) -- uses the [mustache](http://mustache.github.io/) templating system
* [XDI data file: chi(k)](NiO.chik)
* [Athena project file](NiO.prj) -- Data processed with a pre-release of Demeter 0.9.21 using the larch (0.9.24) backend and XDI 1.0

! Subroutine getomi finds poles and weights for representing epsInv.
! Written by J. Kas, 2006
      SUBROUTINE getomi(wgrid, epsInv, NPts, NPoles, omi, gi, Deltai,
     &     eps0)
      IMPLICIT NONE
!     Input variables
!     wGrid(NPts)  - grid of omega
!     epsInv(NPts) - loss function
!     NPoles       - Number of poles to represent epsInv
      
!     Output
!     omi          - omega position of poles
!     gi           - pole strengths
!     Deltai       - energry region about omi where
      INTEGER NPoles, NPts
      DOUBLE PRECISION wGrid(NPts), epsInv(NPts), omi(NPoles),
     &     gi(NPoles), Deltai(NPoles), eps0

!     Local variables
      INTEGER maxPts, MaxPoles, iMax, i1, i2
      PARAMETER (maxPts = 50000)
      DOUBLE PRECISION M0, M0i, M1i, MM1i, M1Old, M1New, omNew, omOld,
     $     pi, Tmp1(maxPts), Tmp2(maxPts), IntGrl, a, b, c, frac, egap
      PARAMETER (pi = 3.14159 26535 89793 23846 26433d0)
      EXTERNAL IntGrl
!     Find zeroth moment
!      frac = (1.d0-0.01d0)
      frac = 0.999d0
      M0 = 0.5d0*epsInv(1)*wGrid(1)
      DO i1 = 2, NPts
         M0 = M0 + 0.5d0*(epsInv(i1)+epsInv(i1-1))*
     &        (wGrid(i1)-wGrid(i1-1))
         Tmp1(i1) = epsInv(i1)/wGrid(i1)
         Tmp2(i1) = epsInv(i1)*wGrid(i1)
      END DO
!     Find gap energy
!      DO i1 = 1, NPts
      
!     Now find energy regions such that the integral of epsinv in each region is
!     equal.
      omOld = 0.d0
      omNew = 0.d0
      M1Old = 0.d0
      M1New = 0.d0
      ! Save the first 10 poles for low energies.
      DO i1 = 1, NPoles
         M0i = 0.5d0*epsInv(1)*wGrid(1)
         M1New = 0.5d0*epsInv(1)*wGrid(1)**2
         DO i2 = 2, NPts
            IF(M0i.ge.(DBLE(i1)*frac*M0/DBLE(NPoles))) THEN
               omOld = omNew
               omNew = wGrid(i2-1)
               IF(i2.eq.1) THEN
                  M0i = 0.d0
               ELSEIF(i2.eq.2) THEN
                  M0i = 0.5d0*epsInv(1)*wGrid(1)
               ELSE
                  M0i = M0i - 0.5d0*(epsInv(i2-1)+ epsInv(i2-2))*
     $              (wGrid(i2-1)-wGrid(i2-2))
               END IF
               GOTO 5
            ELSE
               M0i = M0i + 0.5d0*(epsInv(i2)+epsInv(i2-1))*
     $              (wGrid(i2)-wGrid(i2-1))
               M1New = M1New + 0.5d0*(epsInv(i2)*wGrid(i2)+ epsInv(i2-1)
     $              *wGrid(i2-1))*(wGrid(i2)-wGrid(i2-1))
            END IF
         END DO
 5       CONTINUE
 
!        The region has been found up to the wGrid accuracy. Now interpolate
!        to find omi
         IF(i2.eq.2) THEN
            a = epsInv(i2-1)/omNew
         ELSE
            a = (epsInv(i2-1) - epsInv(i2-2))/(omNew - wGrid(i2-2))
            b = epsInv(i2-2)
         END IF
         a = MAX(a, 1.d-6)
         c = 2.d0/a*(M0i - frac*M0*(DBLE(i1)/DBLE(NPoles)))

         omNew = wGrid(i2-2) - b/a + SQRT((b/a)**2 - c)
         IF((omNew.lt.wGrid(i2-2)).or.(omNew.gt.wGrid(i2-1))) THEN
            omNew = wGrid(i2-2) - b/a - SQRT((b/a)**2 - c)
         END IF

         IF(.FALSE.) THEN
            omOld = DBLE(i1-1)*500.d0/DBLE(NPoles)
            omNew = DBLE(i1)*500.d0/DBLE(NPoles) 
         END IF
!        Now set omi and g s.t. the inverse and first moments are preserved for
!        this region.
         MM1i = 0.d0
         M1i  = 0.d0
         IF(omOld.eq.0.d0) THEN
            MM1i = 0.5d0*epsInv(1)
            M1i  = 0.5d0*epsInv(1)*wGrid(1)**2
            omOld = wGrid(1)
         END IF
         MM1i = MM1i + IntGrl(omOld, omNew, wGrid, Tmp1, NPts)
         M1i  = M1i + IntGrl(omOld, omNew, wGrid, Tmp2, NPts)
         gi(i1)  = 2.d0/pi*MM1i
         omi(i1) = SQRT(M1i/MM1i)
         Deltai(i1) = omNew-omOld
         M1Old  = M1New
         !PRINT '(a27,i6,20f20.10)', 'i1, omi, omOld, omNew, a, b', i1,
         !&    omi(i1), omOld, omNew, a, b
      END DO

!     Shift and scale the poles to set inverse moment to 1-1/eps0, without changing
!     first moment. (eps0 is input by user)
      CALL getdom(gi,omi,NPoles,eps0)
      
      RETURN
      END
      subroutine terp (x, y, n, m, x0, y0)
      implicit double precision (a-h, o-z)

      dimension x(n), y(n)

c     Find out between which x points x0 lies
      i = locat (x0, n, x)
      k = min( max(i-m/2,1) , n-m )
      call polint( x(k), y(k), m+1, x0, y0, dy)

      return
      end


      subroutine polint( xa, ya, n, x, y, dy)
c     draws a polynimial P(x) of order (n-1) through n points.
c     returns y = P(x) and dy - estimate of the error
c     adapted  from numerical recipies in fortran by Press et al.
                                                                                                                                                             
      implicit double precision (a-h,o-z)
      integer n, nmax
      parameter (nmax=4)
      dimension xa(nmax), ya(nmax), c(nmax), d (nmax)
                                                                                                                                                             
      ns = 1
      dif = abs (x-xa(1))
      do 10 i=1,n
         dift = abs(x-xa(i))
         if (dift.lt.dif) then
            ns = i
            dif = dift
         endif
         c(i) = ya(i)
         d(i) = ya(i)
  10  continue
      y = ya(ns)
      ns = ns-1
      do 30 m=1,n-1
         do 20 i=1,n-m
            ho = xa(i)-x
            hp = xa(i+m)-x
            w = c(i+1) - d(i)
            den = ho-hp
            if (den.eq.0) pause 'failure in polint'
            den = w/den
            d(i) = hp*den
            c(i) = ho*den
  20     continue
         if (2*ns .lt. n-m) then
            dy = c(ns+1)
         else
            dy = d(ns)
            ns = ns-1
         endif
         y = y + dy
  30  continue
                                                                                                                                                             
      return
      end


      function locat (x, n, xx)
      integer  u, m, n
      double precision x, xx(n)
                                                                                                                                                             
c     Binary search for index of grid point immediately below x.
c     Array xx required to be monotonic increasing.
c     Returns
c     0            x <  xx(1)
c     1            x =  xx(1)
c     i            x =  xx(i)
c     n            x >= xx(n)
                                                                                                                                                             
      locat = 0
      u = n+1
                                                                                                                                                             
   10 if (u-locat .gt. 1)  then
         m = (u + locat) / 2
         if (x .lt. xx(m))  then
            u = m
         else
            locat = m
         endif
         goto 10
      endif
                                                                                                                                                             
      return
      end

      DOUBLE PRECISION FUNCTION IntGrl(a, b, x, y, n)
      INTEGER n, i, iStart, iLast
      DOUBLE PRECISION x(n), y(n), dx, a, b, aEnd, bEnd,
     &     ya, yb

      iStart = -1
      iLast = -1
      IntGrl = 0.d0
      dx = x(2) - x(1)
      
      DO i = 1, n
         IF(x(i).ge.a.and.x(i).lt.b) THEN
            iStart = i
            goto 5
         ELSE
            iStart = -1
         END IF
      END DO
 5    CONTINUE
      
      DO i = n, 1, -1
         IF(x(i).le.b.and.x(i).gt.a) THEN
            iLast = i
            goto 10
         ELSE
            iLast = -1
         END IF
      END DO
 10   CONTINUE

      IF (iStart.lt.0.and.iLast.lt.0) THEN
         CALL terp(x, y, n, 1, a, ya)
         CALL terp(x, y, n, 1, b, yb)
         IntGrl = IntGrl + 0.5d0*(yb+ya)*(b-a)
      ELSE
         DO i = iStart, iLast-1
            dx=x(i+1)-x(i)
            IntGrl = IntGrl + 0.5d0*(y(i)+y(i+1))*dx
         END DO
         
         CALL terp(x, y, n, 1, a, ya)
         CALL terp(x, y, n, 1, b, yb)
         
         IntGrl = IntGrl + 0.5d0*(ya+y(iStart))*(x(iStart) - a)
         IntGrl = IntGrl + 0.5d0*(yb+y(iLast))*(b-x(iLast))
      END IF
      RETURN
      END
      SUBROUTINE rdloss(Uloss,Dat,NPts)
      IMPLICIT NONE
c     Variables passed
      INTEGER Uloss, NPts
      DOUBLE PRECISION Dat(50000,2)

      
c     local variables
      INTEGER nterp,n,i
      DOUBLE PRECISION dum
      CHARACTER(1) comment, ch
      CHARACTER(200) Line
      comment='#*!c'
      nterp=1
      n=0

c     Read data into Dat
 200  DO i=1,50000
c     Read past comments
         CALL rdcmt(Uloss,comment)
         READ(Uloss,*,end=250) Dat(i,1), Dat(i,2)
         n=i
      END DO      
 250  CONTINUE
      NPts=n
      
300   CLOSE(Uloss)
      RETURN 
      END
      SUBROUTINE rdcmt(iUnt,Cmt)
      INTEGER iUnt, i1
      CHARACTER(300) line
      CHARACTER(4) Cmt
      CHARACTER TmpCmt(4), ch
      LOGICAL CmtLin

      CmtLin = .true.
      DO i1 = 1, 4
         TmpCmt(i1) = Cmt(i1:i1)
      END DO
 5    CONTINUE
      READ(iUnt,*,END=10) ch
      DO i1 = 1, 4
         IF(ch.eq.TmpCmt(i1)) goto 5
      END DO
      
      BACKSPACE(iUnt)
      
 10   CONTINUE
      
      RETURN
      END
! Written by J. Kas, 2006
! eps2exc takes loss function from loss.dat and gives poles and weights
! corresponding to the many pole model detailed in
! Phys. Rev. B 76, 195116 (2007). 
! First, regions are chosen 
      PROGRAM eps2exc
      DOUBLE PRECISION Dat(50000,2), g(10000), gamma, omi(10000),
     &     Delta(10000),eps0, sumrl, xNElec, csumrl
      INTEGER i,i1,ios1,ios2,imax, NPoles,NPts,NFile
      CHARACTER*80 infl, outfl, comment
      CHARACTER ch
      EXTERNAL IntGrl
      NPts = 1000
      infl='loss.dat'
      outfl='exc.dat'
      PRINT*, '# Enter number of poles:'
      READ*, NPoles
      ! This input can be used to correct the sumrules
      !PRINT*, '# Enter eps^-1 sumrule and N_el:'
      !READ*, sumrl, xNElec
      sumrl = 1.d0
      xNElec = 1.d0
      PRINT*, 'Is this a metal? (y/n)'
      READ*, ch
      IF(ch.EQ.'y'.OR.ch.EQ.'Y') THEN
         eps0 = -1.d0
      ELSE
         PRINT*, 'Would you like to set the dielectric constant? (y/n)'
         READ*, ch
         IF(ch.EQ.'n'.OR.ch.EQ.'N') THEN
            eps0 = -2.d0
         ELSE
       
            ! This input can be used to correct the dielectric constant,
            ! which is related to the inverse moment.
            ! Use eps0 = -2 to ignore this correction.
            PRINT*, '# Enter dielectric constant: '
            READ*, eps0
         END IF
      END IF 
      PRINT*, eps0
      gamma = 0.01
      csumrl= xNElec/sumrl
      
      OPEN(unit=12,file=infl,status='old')
      OPEN(unit=13,file=outfl,status='replace')
      CALL rdloss(12,Dat,NPts)

      DO i1 = 1, NPts
         Dat(i1,2) = Dat(i1,2)*csumrl
      END DO
      ! getomi finds poles and weights
      CALL getomi(Dat(1,1), Dat(1,2), NPts, NPoles, omi, g, Delta, eps0)
      WRITE(13,'(A33,I4,A6)') '# Loss function represented with ',
     $     NPoles, ' poles'
      WRITE(13,'(A23,f8.4)') '# Dielectric constant: ', eps0
      DO i = 1, NPoles
         WRITE(13,'(4f20.10)'), omi(i), omi(i)*gamma, g(i), Delta(i)
      END DO
      
      END
! This will change the pole representation of the loss function without
! changing the f-sum rules. Written by J. Kas 2006
      SUBROUTINE getdom(gi,omi,NPoles,eps0)
      IMPLICIT NONE

!     Input/output
      INTEGER NPoles
      DOUBLE PRECISION gi(NPoles), omi(NPoles), eps0

!     Local
      INTEGER i1, i2, MxIter
      DOUBLE PRECISION MM1, tol, dom, dom1, dom2, sumg1, sumg2
      PARAMETER(MxIter = 10000, tol = 1.d-6)
      IF(eps0.lt.-1.5d0) RETURN
      IF(eps0.lt.0.d0) THEN
         MM1 = 1.d0
      ELSE
         MM1   = 1.d0 - 1.d0/eps0
      END IF
      dom1  = -omi(1)*0.999d0
      dom2  = omi(1)*0.999d0
!     Bracket dom between dom1 and dom2
      DO i1 = 1, MxIter
         sumg1 = 0.d0
         sumg2 = 0.d0
         DO i2 = 1, NPoles
            sumg1 = sumg1 + gi(i2)*(omi(i2)/(omi(i2)-dom1))**2
            sumg2 = sumg2 + gi(i2)*(omi(i2)/(omi(i2)-dom2))**2
         END DO
         IF((sumg1.lt.MM1).and.(sumg2.gt.MM1)) GOTO 5
         !IF(sumg1.gt.MM1) dom1 = dom1*2.d0
         !IF(sumg2.lt.MM1) dom2 = dom2/2.d0
         PRINT*, 'Error in getdom.f.'
         PRINT*, 'sumg1, sumg2', sumg1, sumg2, MM1, dom1, dom2
         STOP
      END DO
 5    CONTINUE                  ! dom bracketed

      dom = 0.5d0*(dom1+dom2)
      DO i1 = 1, MxIter
         sumg1 = 0.d0
         DO i2 = 1, NPoles
            sumg1 = sumg1 + gi(i2)*(omi(i2)/(omi(i2)-dom))**2
         END DO
         IF(abs((sumg1-MM1)/MM1).lt.tol) GOTO 10
         IF((sumg1-MM1).gt.0.d0) THEN
            dom2 = dom
         ELSE
            dom1 = dom
         END IF
         dom = 0.5d0*(dom1+dom2)
      END DO
 10   CONTINUE

      DO i1 = 1, NPoles
         gi(i1)  = gi(i1)*(omi(i1)/(omi(i1)-dom))**2
         omi(i1) = omi(i1)-dom
      END DO
      RETURN
      END
      

      subroutine fovrg (il, ihard, rmt, xmt, jri, e, nr, dx, ri, v, dny,
     1                  pu, qu, p, q, ps, qs, vm)
      implicit double precision (a-h, o-z)

c     Input:
c        il      ang mom number + 1
c        ihard   number of times convergence test fails
c        rmt     muffin tin radius
c        xmt     x such that rmt = exp ((x-1)*dx - 8.8)
c        jri     first interstitial grid point (imt + 1)
c        e       current complex energy
c        nr      number of points in r grid
c        dx      dx in Loucks' grid (usually .05)
c        ri(nr)  Loucks' position grid, r = exp ((i-1)*dx - 8.8)
c        v(nr)   total complex potential including energy dep xc
c                v is in the form  pot*r**2
c
c     Work space:
c        complex*16 p(nr), q(nr), ps(nr), qs(nr), vm(nr)
c        Must be dimensioned in calling program.  Coded like this
c        to make using different r-grids with different nrmax easy.
c
c     Output:
c        ihard   incremented each time convergence test fails
c        dny     r*g'/g, see loucks (4-85), q/p = cf/g (eq 4-86)
c        pu, qu  upper and lower components at muffin tin
c        q and q arrays  upper and lower components (see comments)

      complex*16 v(nr), e
      dimension ri(nr)
      complex*16 dny, pu, qu
      complex*16 p(nr), q(nr), ps(nr), qs(nr), vm(nr)

      include 'const.h'
      parameter (c = clight)
      parameter (csq = c**2)

      double precision lp1, ldcsq
      complex*16 c1,c2,c3,pc,qc,dp1,dq1,dp2,dq2,dp3,dq3,dp4,dq4
      complex*16 vh,vmh,vmnp1,psn,qsn,psnm1,qsnm1,psnm2,qsnm2
      complex*16 psnm3,qsnm3,psnm4,qsnm4,pp,qp,psnp1,qsnp1,prel,qrel
      complex*16 psu,vu,dummy
      complex*16 vn,vmn

c     test=1.e+04 value in loucks
      test=1.e+05
      nrk=6

      expdxh=exp(dx/2.0)
      dxd4=dx/4.0
      dxd8=dx/8.0
      a1=dx*3.30
      a2=-dx*4.20
      a3=dx*7.80
      a4=dx*14.0/45.0
      a5=dx*64.0/45.0
      a6=dx*24.0/45.0
      call diff (v,dx,jri,vm)
      twoz=-dble (v(1))/ri(1)
      l=il-1
      lp1=l+1.0
      ldcsq=l/csq
      ie=1
      r=ri(1)
      vn=v(1)
      vmn=vm(1)
cv    p(1)=1.0
      p(1)=1.e-20
      q(1)=-e/(2.0*l+3.0)*r*p(1)
      beta=lp1
      if (twoz.eq.0.0) go to 10
      beta=sqrt(lp1*l+1.0-(twoz/c)**2)
      sb0=(beta-lp1)*csq/twoz
      sa1=(3.0*beta-(twoz/c)**2)/(2.0*beta+1.0)
      sb1=csq/twoz*((beta-l)*sa1-1.0)-sb0
      sa2=((beta+3.0*lp1)*sa1-3.0*l+twoz/csq*(beta+lp1+3.0)*sb1)/
     1 (beta+1.0)/4.0
      sb2=(csq/twoz*(2.0*l*(beta+2.0-lp1)-l-(twoz/c)**2)*sa1-3.0*l
     1 *csq/twoz*(beta+2.0-lp1)+(beta+3.0-2.0*lp1-(twoz/c)**2)*sb1)/
     2 (beta+1.0)/4.0
      delta=r*csq/twoz
      q(1)=(sb0+delta*(sb1+delta*sb2))/(1.0+delta*(sa1+delta*sa2))*p(1)
   10 continue
c     runge kutta method  (see loucks)
      c1=vn/r**2-e
      c2=1.0-c1/csq
      c3=(vmn-2.0*vn)/c2/c2*ldcsq
      ps(1)=r*c2*q(1)+lp1*p(1)
      qs(1)=-lp1*q(1)+(r*c1-c3/r**3)*p(1)
      n=1
   20 continue
      pc=p(n)
      qc=q(n)
      dp1=dx*(r*c2*qc+lp1*pc)
      dq1=dx*(-lp1*qc+(r*c1-c3/r**3)*pc)
      pc=pc+0.50*dp1
      qc=qc+0.50*dq1
      r=r*expdxh
      vnp1=v(n+1)
      vmnp1=vm(n+1)
      vh=(vn+vnp1)*.50+(vmn-vmnp1)*dxd8
      vmh=(1.50*(vnp1-vn)-(vmn+vmnp1)*dxd4)/dx
      c1=vh/r/r-e
      c2=1.0-c1/csq
      c3=(vmh-2.0*vh)/c2/c2*ldcsq
      dp2=dx*(r*c2*qc+lp1*pc)
      dq2=dx*(-lp1*qc+(r*c1-c3/r**3)*pc)
      pc=pc+0.50*(dp2-dp1)
      qc=qc+0.50*(dq2-dq1)
      dp3=dx*(r*c2*qc+lp1*pc)
      dq3=dx*(-lp1*qc+(r*c1-c3/r**3)*pc)
      pc=pc+dp3-0.50*dp2
      qc=qc+dq3-0.50*dq2
      n=n+1
      r=ri(n)
      c1=vnp1/r/r-e
      c2=1.0-c1/csq
      c3=(vmnp1-2.0*vnp1)/c2/c2*ldcsq
      dp4=dx*(r*c2*qc+lp1*pc)
      dq4=dx*(-lp1*qc+(r*c1-c3/r**3)*pc)
      p(n)=p(n-1)+(dp1+2.0*(dp2+dp3)+dp4)/6.0
      q(n)=q(n-1)+(dq1+2.0*(dq2+dq3)+dq4)/6.0
      ps(n)=r*c2*q(n)+lp1*p(n)
      qs(n)=-lp1*q(n)+(r*c1-c3/r**3)*p(n)
      vn=vnp1
      vmn=vmnp1
      if (n-nrk) 20,30,30
   30 if (n.ge.jri) go to 120
      psn=ps(nrk)
      qsn=qs(nrk)
      psnm1=ps(nrk-1)
      qsnm1=qs(nrk-1)
      psnm2=ps(nrk-2)
      qsnm2=qs(nrk-2)
      psnm3=ps(nrk-3)
      qsnm3=qs(nrk-3)
      psnm4=ps(nrk-4)
      qsnm4=qs(nrk-4)
c     milne method
   40 r=ri(n+1)
      c1=v(n+1)/r/r-e
      c2=1.0-c1/csq
      c3=(vm(n+1)-2.0*v(n+1))/c2/c2*ldcsq
      pp=p(n-5)+a1*(psn+psnm4)+a2*(psnm1+psnm3)+a3*psnm2
      qp=q(n-5)+a1*(qsn+qsnm4)+a2*(qsnm1+qsnm3)+a3*qsnm2
      nit=0
   50 psnp1=r*c2*qp+lp1*pp
      qsnp1=-lp1*qp+(r*c1-c3/r**3)*pp
      pc=p(n-3)+a4*(psnp1+psnm3)+a5*(psn+psnm2)+a6*psnm1
      qc=q(n-3)+a4*(qsnp1+qsnm3)+a5*(qsn+qsnm2)+a6*qsnm1
      if (abs(test*(pc-pp))-abs(pc)) 60,60,70
   60 if (abs(test*(qc-qp))-abs(qc)) 110,110,70
   70 if (nit-40) 100,80,100
c  70 if (nit-5) 100,80,100 value in loucks
   80 prel=(pc-pp)/pc
      qrel=(qc-qp)/qc
c     count times hard test fails
      ihard = ihard + 1
c     print90, il,ie,n,prel,qrel
   90 format (' hard test in fovrg il=',i2,' ie=',i1,' n=',i3,' prel='
     1 ,e16.8,' qrel=',e16.8,' **********')
      go to 110
  100 nit=nit+1
      pp=pc
      qp=qc
      go to 50
  110 n=n+1
      p(n)=pc
      q(n)=qc
      ps(n)=psnp1
      qs(n)=qsnp1
      psnm4=psnm3
      psnm3=psnm2
      psnm2=psnm1
      psnm1=psn
      psn=psnp1
      qsnm4=qsnm3
      qsnm3=qsnm2
      qsnm2=qsnm1
      qsnm1=qsn
      qsn=qsnp1
c     introduce scale factor to prevent overflow on vax jjr
      if(abs(pc).lt.1.e+20) go to 119
      scale=1.e-20
      do 112 mm=1,6
      nm=n-mm+1
      p(nm)=scale*p(nm)
      q(nm)=scale*q(nm)
      ps(nm)=scale*ps(nm)
      qs(nm)=scale*qs(nm)
  112 continue
      psnm4=scale*psnm4
      psnm3=scale*psnm3
      psnm2=scale*psnm2
      psnm1=scale*psnm1
      psn=scale*psn
      qsnm4=scale*qsnm4
      qsnm3=scale*qsnm3
      qsnm2=scale*qsnm2
      qsnm1=scale*qsnm1
      qsn=scale*qsn
  119 if (n-jri) 40,120,120
  120 jm=jri-1
      x=dx*(xmt-jm)
      call intpol (zero,dx,p(jm),p(jri),ps(jm),ps(jri),x,pu,psu)
      call intpol (zero,dx,q(jm),q(jri),qs(jm),qs(jri),x,qu,dummy)
      call intpol (zero,dx,v(jm),v(jri),vm(jm),vm(jri),x,vu,dummy)
      dny=rmt*(1.0-(vu/rmt**2-e)/csq)*qu/pu+l
c dny is r*g'/g, see loucks (4-85), q/p = cf/g (eq 4-86)
c (watch for factors of rmt)
      return
      end

      subroutine mmtrxi ( rkk, lam1x, bmati, ie, ileg, ilegp, lind,
     &       clmi, mlam, nlam, xnlm, eta, fmati)
c     calculates matrix M in Rehr,Albers paper.
c     in polarization case
      implicit double precision (a-h, o-z)

c     inputs:
c       lam1x:  limits on lambda and lambda'
c       ie:  energy grid points
c       ileg, ilegp: leg and leg'
c       phases, use ph(ie,...,ilegp), and lmax(ie,ilegp)
c       lambda arrays
c       rotation matrix for ilegp
c       clmz for ileg and ilegp
c       path data, eta(ilegp) and ipot(ilegp)
c       xnlm array
c
c     Output:  fmati(...,ilegp) is set for current energy point.

c     calculate scattering amplitude matrices
c     f(lam,lam') = sum_l tl gam(l,m,n)dri(l,m,m',ileg)gamt(l,m',n')
c                 *cexp(-i*m*eta),  eta = gamma+alpha'
c     lam lt lam1x, lam' lt lam2x such that m(lam) lt l0, n(lam) lt l0
c     gam = (-)**m c_l,n+m*xnlm, gamt = (2l+1)*c_ln/xnlm,
c     gamtl = gamt*tl

      include '../HEADERS/const.h'
      include '../HEADERS/dim.h'
      
c+----------------------------------------------------------------------
c     removing local common blocks, replacing them with explicit passing
c     of the defined data srtuctures
c+----------------------------------------------------------------------
c     include 'nlm.h'
      dimension xnlm(ltot+1,mtot+1)
c     include 'lambda.h'
      integer mlam(lamtot), nlam(lamtot)
c     include 'clmz.h'
      complex*16 clmi(ltot+1,mtot+ntot+1,legtot)
c     include 'fmatrx.h'
      complex*16 fmati(lamtot,lamtot,legtot)
c     include 'pdata.h'
      double precision eta(0:legtot+1)


      complex*16 cam, camt, tltl, bmati
      dimension bmati(-mtot:mtot, 1:8, -mtot:mtot, 1:8), lind(8)
      complex*16  rkk(nex,8)
      complex*16 gam(ltot+1,mtot+1,ntot+1),
     1           gamtl(ltot+1,mtot+1,ntot+1)

c     calculate factors gam and gamtl
 
c     set limits for orbital momentum
      lmn = ltot
      lmx = 0
      do 10 k1 = 1,8
        if (lind(k1).gt.lmx) lmx = lind(k1)
        if (lind(k1).lt.lmn .and. lind(k1).ge.0) lmn = lind(k1)
  10  continue
      iln = lmn + 1
      ilx = lmx + 1
 
      do 30  il = iln, ilx
         tltl = 2*il - 1
         do 20  lam = 1, lam1x
            m = mlam(lam)
            if (m .lt. 0)  goto 20
            im = m+1
            if (im .gt. il)  goto 20
            in = nlam(lam) + 1
            imn = in + m
            if (lam .gt. lam1x)  goto 20
            cam = xnlm(il,im) * (-1)**m
            if (imn .le. il)  gam(il,im,in) = cam * clmi(il,imn,ileg)
            if (imn .gt. il)  gam(il,im,in) = 0
            camt = tltl / xnlm(il,im)
            gamtl(il,im,in) = camt * clmi(il,in,ilegp)
   20    continue
   30 continue

      do 60 lam1 = 1,lam1x
         m1 = mlam(lam1)
         in1 = nlam(lam1) + 1
         iam1 = abs(m1) + 1
         do 50  lam2 = 1, lam1x
            m2 = mlam(lam2)
            in2 = nlam(lam2) + 1
            iam2 = abs(m2) + 1
            fmati(lam1,lam2,ilegp) = 0.0d0

            do 40 k1 = 1, 8
            do 40 k2 = 1, 8
               l1 = lind(k1) + 1
               l2 = lind(k2) + 1
               if (l1.gt.0.and.l2.gt.0 .and. iam1.le.l1.and.iam2.le.l2) 
     1           fmati(lam1,lam2,ilegp) = fmati(lam1,lam2,ilegp) +
     2           bmati(m1,k1, m2,k2) * rkk(ie,k1) * rkk(ie,k2) *
     3           gam( l1, iam1, in1) * gamtl( l2, iam2, in2)
   40       continue
            fmati(lam1,lam2,ilegp) = fmati(lam1,lam2,ilegp) *
     1      exp(-coni*eta(ileg)*m1)
   50    continue
   60 continue

      return
      end

      subroutine xcpot (iph, ie, index, lreal, ifirst, jri,
     1                  em, xmu,
     2                 vtot, vvalgs, densty, dmag, denval,
     3                  eref, v, vval, iPl, WpCorr, AmpFac,
     4                  vxcrmu, vxcimu, gsrel, vvxcrm, vvxcim,rnrm)
c      subroutine xcpot (iph, ie, index, lreal, ifirst, jri,
c     1                  em, xmu,
c     2                 vtot, vvalgs, densty, dmag, denval,
c     3                  eref, v, vval, iPl, WpCorr, Gamma, AmpFac,
c     4                  vxcrmu, vxcimu, gsrel, vvxcrm, vvxcim,rnrm)

      implicit double precision (a-h, o-z)
c     calculate self-energy correction
c     first coded j. mustre de leon
c     last modified a.ankudinov 1996 for non-local self-energies
c     Ankudinov, Rehr, J. Physique IV, vol. 7, C2-121, (1997).

c     INPUT
c     iph, ie used only for debug and labels.
c     index       0  Hedin-Lunqvist + const real & imag part
c                 1  Dirac-Hara + const real & imag part
c                 2  ground state + const real & imag part
c                 3  Dirac-Hara + HL imag part + const real & imag part
c                 4  See rdinp for comment
c     lreal       not equal zero for real self energy
c     ifirst      first entry flag, set to zero before first call for
c                 each unique potential, see vxcrmu and vxcimu below
c     jri         index of first interstitial point in current
c                 Loucks r grid
c     em          current energy grid point
c     xmu         fermi level
c     vi0         const imag part to subtract from potential
c     gamach      core hole lifetime
c     vtot(nr)    total potential (coulomb and gs exchange corr)
c     vvalgs(nr)  total coulomb + gs xc potential from valence electrons
c     densty(nr)  electron density
c     dmag(nr)    density magnetization
c     denval(nr)  valence electron density
c     iPl         Control for many pole self energy (Josh)
c
c     OUTPUT
c     eref        complex energy reference for current energy
c     v(nr)       complex potential including energy dep xc
c     vval(nr)    as above,but xc from valence electrons only
c     em          current energy
c
c     WORKSPACE
c     vxcrmu and vxcimu are calculated only on first entry for a
c     particular unique potential, re-used on subsequent entries.
c     vxcrmu(nr)  real part of xc at fermi level
c     vxcimu(nr)  imag part of xc at fermi level
c     gsrel(nr) ratio of gs xc potentials with and without magnetization
c     vvxcrm(nr)  real part of xc at fermi level from valence electrons
c     vvxcim(nr)  imag part of xc at fermi level from valence electrons


      include '../HEADERS/const.h'
      include '../HEADERS/dim.h'

      dimension   vtot(nrptx), vvalgs(nrptx), densty(nrptx)
      dimension   dmag(nrptx), denval(nrptx)
      complex*16  em, eref, v(nrptx), vval(nrptx)
      dimension   vxcrmu(nrptx), vxcimu(nrptx)
      dimension   vvxcrm(nrptx), vvxcim(nrptx), gsrel(nrptx)

c     Josh added variables:
c     ZRnrm      - renormalization constant
c     ZTmp       - Temp var for ZRnrm
c     csig       - control for using many pole self energy
c     NRPts      - Number of points to use inside atom.
c                  Other points are linearly interpolated.
c     WpCorr     - Array of frequencies for many pole self energy.
c     rsTmp      - Temp var for rs
c     WpTmp      - Temp var for Wp
c     AmpFac     - g_i (pole strengths)
c     Gamma      - pole broadening
c     RsInt      - Rs in the intersitial
c     DRs        - RsCore - RsInt
c     delrHL     - Re[delta sigma] for many pole self energy
c     deliHL     - Im[delta sigma] for many pole self energy
c     Rs1(NRPts) - Array of Rs points for interpolation
      complex*16  delta, deltav, ZRnrm, ZTemp
      character*512 slog
      logical csig, rdmpse
      integer NRPts, lastPl
      parameter (tol=0.0004d0)
      parameter (NRPts=10)
      double precision WpCorr(MxPole), AmpFac(MxPole)
c      double precision  Gamma(MxPole), rsTmp, WpTmp
      double precision RsInt, DRs, delrHL(NRPts), deliHL(NRPts),
     &     Rs1(NRPts), dx, x0, volume, totvol, rnrm, ri, riInt, omp,
     &     ompmax
      complex*16 delavg
c    Josh END

c     First calculate vxc to correct the local momentum dispersion
c     relation, delta = vxc(e,k) - vxc(mu,k), and
c               p^2 = k^2 -mu + kf^2 - delta.
c     In jr theory, v(e,r) = vcoul(r) + vxc(e,r) =
c                          = vcoul(r) + vxcgs(r) + delta(e,r).

c    at jri potential is smooth continuation of potential to r(jri)
c    at this point potential jumps to interstitial value at jri+1
c     Atom r grid
      dx = 0.05d0
      x0 = 8.8d0
      totvol = 4.d0/3.d0*pi*rnrm**3
      delavg = 0.d0
c      totvol = 0.d0
      ZRnrm = 0.d0
      csig=.false.
      ompm1 = 0.d0
      jri1 = jri + 1
c      rsTmp = RsCorr
      xfval=0
      delvr = 0
      delvi = 0
      lastPl = 0
      nmax=1
      nul=0
      ibp = index / 10
      ixc = mod(index,10)
      ixcTmp=ixc
      DO i = 1, MxPole
         IF(WpCorr(i).le.0.d0) then
            lastPl = i-1
            GOTO 5
         END IF
      END DO
   5  CONTINUE
      if((ixc.eq.0).and.(iPl.gt.0)) then
         csig=.true.
      end if
      if (ixc .eq. 2 .or. dble(em).le.xmu)  then
         do 10  i = 1, jri1
            v(i) = vtot(i)
            vval(i) = vvalgs(i)
   10    continue
c        Ground state exchange, no self energy calculation
         goto 888
      endif

c     Josh - Added CSigma to calculate HL Sigma with broadening and such.
c     Calculate Rs at the core and interstitial densities.
      if (densty(jri1).le.0) then
         RsInt =10
      else
         RsInt = (3 / (4*pi*densty(jri1))) ** third
      endif
      if (densty(1).le.0) then
         rscore =101.d0
      else
         rscore = (3 / (4*pi*densty(1))) ** third
      endif
      DRs = (RsInt-rscore)/(NRPts-1)
      omp = SQRT(3.d0/RsInt**3)*hart
      ompmax=omp*WpCorr(lastPl)
c     Now calculate delta sigma as a function of Rs and energy
      if (csig) then
         do i= NRPts, 1, -1
            rdmpse = .false.
            delrHL(i) = 0.d0
            deliHL(i) = 0.d0
            Rs1(i)=rscore+DBLE(i-1)*DRs

c           If iPl > 1, use renormalization, else not
c           If iPl = 2, use Sigma(r) = Sigma[Wp(r)*Wp/Wp(RsInt)]
c           If iPl = 3, use Sigma(r) = 0 outside of intersitial region
c                       actually linearly interpolates to zero at the
c                       first RPt.
c           If iPl > 3, use Sigma(r) = Sigma(RsInt) (Sigma as a bulk property)
            if(iPl.gt.1) then
               if((iPl.eq.2).or.(i.eq.NRPts)) then
c                  call CSigZ(em,xmu,Rs1(i),delrHL(i),deliHL(i),ZTemp,
c     &                 WpCorr,Gamma,AmpFac)
                  call CSigZ(em,xmu,Rs1(i),delrHL(i),deliHL(i),ZTemp,
     &                 WpCorr,AmpFac)
               elseif(iPl.eq.3) then
                  delrHL(i) = 0.d0
                  deliHL(i) = 0.d0
               else
                  delrHL(i) = delrHL(NRPts)
               end if
               if(i.eq.NRPts) ZRnrm = ZTemp
            else
c               call CSigma(em,xmu,Rs1(i),delrHL(i),deliHL(i),WpCorr,
c     &              Gamma,AmpFac)
               call CSigma(em,xmu,Rs1(i),delrHL(i),deliHL(i),WpCorr,
     &              AmpFac)
            end if
c            Josh Kas - Write self energy to mpse.bin for fast processing later
c            write(23,'(6f30.10)') DBLE(em), Rs1(i), delrHL(i),
c     &           deliHL(i), Ztemp
c 17         continue
c           debugging output of deltaSigma(em, rs)
c           write(44,'(6f30.10)') DBLE(em), Rs1(i), delrHL(i), deliHL(i),
c     &           dble(ZRnrm), dimag(ZRnrm)
         end do
c        write(44,*)
      end if
c     END Josh

c     Add the self energy correction
      do 20  i =  jri1,1,-1
         ri = exp((i-1)*dx - x0)
         if(i.eq.jri1) then
            riInt = ri
         end if
         niter = 0
         if (densty(i).le.0) then
            rs =10
         else
            rs = (3 / (4*pi*densty(i))) ** third
         endif
c         write(22,*) 1.d0*exp(dble(i)*0.01), densty(i)
c        Josh - If csigma is turned on, interpolate onto rs.
c        Then skip to 15 (skip other calculations and self
c        consistency)
         if(csig) then
            omp = SQRT(3.d0/rs**3)*hart
            if(iPl.ge.4) then
               delr = delrHL(NRPts)
               deli = deliHL(NRPts)
            else
               call terp (Rs1, delrHL, NRPts, 1, rs, delr)
               call terp (Rs1, deliHL, NRPts, 1, rs, deli)
            end if
            if((iPl.ne.5).or.(omp.lt.ompmax)) then
               goto 15
            end if
         end if
c        END Josh

c        xf = 1.9191.../rs
         xf = fa / rs
         rsm = rs / (1+dmag(i))**third
         xfm = fa / rsm

         if (ixc.eq.5) then
            if ( denval(i) .gt. 0.00001) then
               rsval = (3 / (4*pi*denval(i))) ** third
               if (rsval.gt.10.0) rsval=10.0
            else
               rsval = 10.0
            endif
            xfval = fa / rsval
         elseif (ixc.ge.6) then
            if (densty(i) .le. denval(i) ) then
               rscore = 101.0
            else
               rscore = (3 / (4*pi*(densty(i)-denval(i)))) ** third
            endif
         endif

         if (ifirst .eq. 0)  then
c           vxc_mu indep of energy, calc only once
c           Calculate vxc at fermi level e = mu, j.m. 1/12/89
            xk = xf * 1.00001
            gsrel(i) = 1.0d0
            if (ixc .lt. 5) then
              call sigma(ixc, ibp,rs,rscore,xk,vxcrmu(i),vxcimu(i))
              if (index .eq. 0) then
c  do not need 4 following lines for gs difference in potential
c                xmag = 1.0d0+ dmag(i)
c                call vbh(rs,xmag,v1)
c                call vbh(rs, 1.0d0,v0)
c                if (v0 .ne. 0) gsrel(i) = v1/v0
              endif
            else
              call sigma(nul,ibp, rs, rscore,xk,vxcrmu(i),vxcimu(i))
            endif
            if (ixc.eq.5 ) then
               xkpp = xfval * 1.00001
               call sigma
     1         (ixc, ibp, rsval, rscore, xkpp, vvxcrm(i),vvxcim(i))
               if (ixc.eq.5 .and. i.eq.jri1) then
                  vvxcrm(jri1) =  vxcrmu(jri1)
                  vvxcim(jri1) =  vxcimu(jri1)
               endif
            elseif (ixc .ge. 6) then
               call sigma
     1         (ixc, ibp, rs, rscore, xk, vvxcrm(i), vvxcim(i))
               if (ixc.eq.6 .and. i.eq.jri1) then
                  vvxcrm(jri1) =  vxcrmu(jri1)
                  vvxcim(jri1) =  vxcimu(jri1)
               endif
            else
               vvxcrm(i) = 0.0d0
               vvxcim(i) = 0.0d0
            endif
         endif

c        xk2 is the local momentum squared, p^2 = k^2 - 2*mu + kf^2,
c        k^2 represents energy measured from vacuum.
c        See formula 2.15 in Lee and Beni's paper with the last 2
c        terms neglected.  (complete reference?)
         xk2 = 2 * (dble(em) - xmu) + xf**2
         xk = sqrt(xk2)
         xkm2 = 2 * (dble(em) - xmu) + xfm**2
c        quick fix
         if (xkm2.lt.0) xkm2=xk2
         xkm = sqrt(xkm2)

c        find \delta_1
         if (ixc .lt. 5) then
            call sigma (ixc, ibp, rs, rscore, xk, vxcr, vxci)
         else
            call sigma (nul, ibp, rs, rscore, xk, vxcr, vxci)
         endif
         del1r = gsrel(i) * (vxcr - vxcrmu(i))

c        Correct local momentum according to the formula
c        p^2 = k^2 - 2*mu + kf^2 - 2*delta.  Note that imag part
c        of delta is ignored, since xk2 is a real quantity.

c        find xk(em) by iterative solution of dyson equation
  50     continue
         xk2 = 2*(dble(em) - xmu - del1r) + xf**2
         if (xk2 .lt. 0)  then
            write(slog,'(1pe13.5, 3i8, a)')
     1         xk2, i, ie, iph, ' xk2, i, ie, iph'
            call wlog(slog)
            call wlog(' em, xf**2, xmu, delta')
            write(slog,'(1p, 5e13.5)') dble(em), xf**2, xmu, del1r
            call wlog(slog)
            call par_stop('XCPOT-2')
         endif
         xk = sqrt (xk2)

c        calculate \delta_2 and \delta_v,2 with the corrected
c        local momentum
         call sigma (ixc, ibp, rs, rscore, xk, vxcr, vxci)
c        delta corrected calculated with new local momentum
         delr = gsrel(i) * (vxcr - vxcrmu(i))
         deli = vxci-vxcimu(i)

         if (ixc.ge.5 .and. i.eq.jri1 .and. xk.gt.xf) then
            if (ixc.eq.5 .or. ixc.eq.6) then
               delvr = delr
               delvi = deli
            endif
         endif

         if (niter.lt.nmax) then
            del1r=delr
            niter=niter+1
            go to 50
         endif

         if (ixc .ge. 5 .and. i.lt.jri1 .and. xk.gt.xf) then
            if (ixc.eq.5) then
               xkpp=sqrt(xk**2-xf**2+xfval**2)
               call sigma (ixc, ibp, rsval,rscore,xkpp,vxcvr,vxcvi)
            else
               call sigma (ixc, ibp, rs, rscore, xk, vxcvr, vxcvi)
            endif
            delvr = vxcvr-vvxcrm(i)
            delvi = vxcvi-vvxcim(i)
         endif

c        Josh - Skip SC loop if CSigma is called. CSigma calculates self consistently.
 15      continue

         delta = dcmplx(delr,deli)

c	 Josh - write out delta sigma at interstitial level to sigma.dat.
c         if(i.eq.jri1) then
c            write(45,'(X,20e14.6)') (DBLE(em) - xmu)*hart, delr*hart,
c     &                        deli*hart, DBLE(ZRnrm), DIMAG(ZRnrm),
c     &                        SQRT(DBLE(ZRnrm)**2+DIMAG(ZRnrm)**2),
c     &                        ATAN2(DIMAG(ZRnrm),DBLE(ZRnrm)),
c     &                        SQRT(DBLE(em-xmu)/2.d0)/ABS(deli)*bohr
c         end if
c	 Josh END

         if (ixc .eq. 5) delta = dcmplx(delr,delvi)
         v(i) = vtot(i) + delta
         if (ixc .ge. 5) then
            deltav = dcmplx(delvr,delvi)
            vval(i) = vvalgs(i) + deltav
         endif
         if(i.eq.jri1) then
            volume = 0.d0
         elseif(i.eq.jri) then
            volume = 4.d0*pi/3.d0*(rnrm**3 - exp(3.d0*((i-1)*dx - x0)))
         else
            volume = 4.d0*pi/3.d0*exp(3.d0*((i-1)*dx-x0))*(exp(3.d0*dx)
     &           - 1.d0)
         end if
         if(volume.lt.0.d0) volume = 0.d0
         omp = SQRT(3.d0/rs**3)
c         write(39,'(I5,20f30.10)') i, dble(em-xmu), volume/totvol,
c     &        exp((i-1)*dx - x0)*bohr,
c     &        rnrm*bohr, densty(i), denval(i), dble(volume*delta),
c     &        dimag(volume*delta), omp*hart, omp-ompm1
c         ompm1 = omp
c         delavg = delavg + volume*delta
 20   continue
c      write(39,*)

      ifirst = 1
      delavg = delavg/totvol
c      write(38,'(X,20e14.6)') (DBLE(em) - xmu)*hart, dble(delavg)*hart,
c     &     dimag(delavg)*hart,
c     &     SQRT(DBLE(em-xmu)/2.d0)/ABS(dimag(delavg))*bohr,
c     &     totvol
c     Reference the potential with respect to mt potential, ie,
c     first interstitial point.  v(jri1) = 0

c     Note that the reference does not contain the core hole lifetime
c     since the total atomic potential should have it. However in the
c     perturbation  deltav = v - vmt it cancels out.
c     ( deltav = vat - igamma - (vatmt-igamma) ).

 888  eref = v(jri1)
      do 910 i = 1, jri1
  910 v(i) = v(i) - eref
      if (ixc.ge.5) then
         do 920 i = 1, jri1
  920    vval(i) = vval(i) - eref
      else
         do 930 i = 1, jri1
  930    vval(i) = v(i)
      endif

c     Real self energy, zero imag part
      if (lreal.gt.0)  then
         do 950  i = 1, jri1
            v(i) = dble(v(i))
            if (ixc.gt.4)  vval(i) = dble(vval(i))
  950    continue
         eref = dble(eref)
      endif

      return
      end

      subroutine sigma (ixc, ibp, rs, rscore, xk, vr, vi)
      implicit double precision (a-h, o-z)

      if ((ixc.eq.0 .or. ixc.ge.5) .and. ibp .eq. 0) then
         call rhl (rs, xk, vr, vi)
      elseif ((ixc.eq.0.or. ixc.ge.5) .and. ibp .eq. 1) then
         call rhlbp (rs, xk, vr, vi)
      elseif (ixc .eq. 1) then
         vi = 0
         call edp(rs,xk,vr)
      elseif (ixc .eq. 3) then
         call edp(rs,xk,vr)
         call imhl (rs,xk,vi,icusp)
      endif

      if (ixc .ge. 6) then
         call edp(rscore,xk,vrp)
         vr = vr - vrp
      endif

      return
      end

      subroutine cdsld

      implicit double precision (a-h,o-z)
      save
      common /print/ iprint
      common /atomco/ den(30), dq1(30), dfl(30), ws, nqn(30), nql(30),
     1                nk(30), nmax(30), nel(30), norb, norbco

      common /dira/ dv(251), dr(251), dp(251), dq(251), dpas, tets,
     1              z, nstop, nes, np, nuc
      common /deux/ dvn(251), dvf(251), d(251), dc(251), dgc(251,30),
     1 dpc(251,30)

c titre = identification of the wave functions  s,p*,p,........
      character*40 ttl
      character*2  titre
      common /char/ titre(30), ttl

c  -- This read commented out to make input easier, not used for
c     PHASE calculations
      irm  = 0
      ins  = 0
      npun = 0
      nmfg = 0
      nmrk = 0
c     read (5,10) irm,ins,npun,nmfg,nmrk
   10 format (8i3)

c valeurs moyennes de r**j  if irm non-zero
c tabulation of the wave functions if ins non-zero
c the potential multiplied by r is perfore if npun non-zero
      if (irm.eq.0) go to 200
      if (iprint .ge. 5)  write(16,20) ttl
   20 format (1h1,40x,a40,/)
   30 read (5,10) j,l,n1,l1,j1,n2,l2,j2
      if (l.eq.0) go to 200

c valeur moyenne of (p1*p2+q1*q2)*r**j  if l positive
c valeur moyenne of (p1*q2+p2*q1)*r**j  if l negative
      if (n1.gt.0) go to 40
      if (((n1+1)*(n1+2)).ne.0) go to 60
      i1=1
      i2=1
      go to 80
   40 i1=0
      i2=0
      do 50 i=1,norb
      if (nqn(i).eq.n1.and.nql(i).eq.l1.and.(j1-1).eq.(-nk(i)/iabs(nk(i)
     1 ))) i1=i
      if (nqn(i).eq.n2.and.nql(i).eq.l2.and.(j2-1).eq.(-nk(i)/iabs(nk(i)
     1 ))) i2=i
   50 continue
      if (i1.ne.0.and.i2.ne.0) go to 80
   60 if (iprint .ge. 5)  write(16,70) j,l,n1,l1,j1,n2,l2,j2
   70 format (1h0,'    error for the card     ',8i3)
      go to 30
   80 dval=dfl(i1)+dfl(i2)
      if ((dval+j).gt.-1.0) go to 90
      if (n1) 170,170,60
   90 im=nmax(i1)
      if (nmax(i2).lt.im) im=nmax(i2)
      if (l.lt.0) go to 110
      do 100 i=1,im
      dv(i)=dgc(i,i1)*dgc(i,i2)
  100 dq(i)=dpc(i,i1)*dpc(i,i2)
      go to 130
  110 do 120 i=1,im
      dv(i)=dgc(i,i1)*dpc(i,i2)
  120 dq(i)=dgc(i,i2)*dpc(i,i1)
  130 call somm (dr,dv,dq,dpas,dval,j,im)
      if (l.lt.0) go to 150
      if (iprint .ge. 5)  write(16,140) j,nqn(i1),titre(i1),nqn(i2),
     1                                   titre(i2),dval
  140 format (24x,'(p1p2+q1q2)r**',i2,' for  ',i1,a2,i3,a2,5x,'=',1pe14.
     1 7,/)
      go to 170
  150 if (iprint .ge. 5)  write(16,160) j,nqn(i1),titre(i1),nqn(i2),
     1                                   titre(i2),dval
  160 format (24x,'(p1q2+q1p2)r**',i2,' for  ',i1,a2,i3,a2,5x,'=',1pe14.
     1 7,/)
  170 if (n1+1) 190,180,30
  180 i1=i1+1
      i2=i1
      if (i1-norb) 80,80,30
  190 i2=i2+1
      if (i2-norb) 80,80,180
  200 if (ins.eq.0) go to 260
      do 250 i=1,norb,3
      j=i+2
      if (j.gt.norb) j=norb
      im=0
      do 210 l=i,j
      if (nmax(l).gt.im) im=nmax(l)
  210 continue
      do 230 k=1,im
      if (((k-1)*(k-48*(k/48))).ne.0) go to 230
      if (iprint .ge. 5)  write(16,20) ttl
      if (iprint .ge. 5)  write(16,220) (nqn(l),titre(l),nqn(l),
     1                                     titre(l),l=i,j)
  220 format (9x,'r',14x,3(i1,a2,'g.c.',i11,a2,'p.c.',10x))
  230 if (iprint .ge. 5)  write(16,240) dr(k),
     1                                   (dgc(k,l),dpc(k,l),l=i,j)
  240 format (7(1pe17.7))
  250 continue
  260 if (npun.eq.0) go to 300
      do 270 i=1,np
  270 dp(i)=dvf(i)*dr(i)
c     write(8,280) ttl
  280 format (a40)
c     write(8,290) (dp(i),i=1,np)
  290 format (8f9.4)
  300 do 310 i=1,np
  310 d(i)=0.0
      nag=1
      if (nmfg.eq.0) go to 470
      if (iprint .ge. 5)  write(16,20)
      if (iprint .ge. 5)  write(16,320)
  320 format (/,30x,'integrales magnetiques directes et d echange'//)
  330 read (5,10) i1,i2,n1
      if (i1.le.0) go to 470
      if (i2.gt.0) go to 350
      if (((i2+1)*(i2+2)).ne.0) go to 340
      if (n1.le.0) n1=1
      i1=n1
      n1=i2
      i2=i1
      go to 360
  340 if (iprint .ge. 5)  write(16,70) i1,i2,n1
      go to 330
  350 if (i1.gt.norb.or.i2.gt.norb) go to 340
      n1=1
  360 j1=2*iabs(nk(i1))-1
      j2=2*iabs(nk(i2))-1
      kma=min0(j1,j2)
      nm=nmax(i2)
      do 380 j=1,kma,2
      call ykdir (i1,i1,j,nag)
      do 370 i=1,nm
  370 dp(i)=dq(i)*dgc(i,i2)*dpc(i,i2)
      dval=j+1
      call somm (dr,d,dp,dpas,dval,-1,nm)
  380 if (iprint .ge. 5)  write(16,390) j,nqn(i1),titre(i1),nqn(i2),
     1                                   titre(i2),dval
  390 format (20x,'fm',i2,' (',i1,a2,',',i1,a2,') =',1pe14.7)
      if (i1.eq.i2) go to 440
      j1=(iabs(1-2*nk(i1))-1)/2
      j2=(iabs(1-2*nk(i2))-1)/2
      kma=max0(nql(i1)+j2,nql(i2)+j1)
      j1=iabs(nql(i2)-j1)
      j2=iabs(nql(i1)-j2)
      kmi=min0(j1,j2)
      j1=kmi+nql(i1)+nql(i2)
      j1=j1-2*(j1/2)
      if (j1.eq.0) kmi=kmi+1
      nm=min0(nmax(i1),nmax(i2))
      do 420 j=kmi,kma,2
      call ykdir (i1,i2,j,nag)
      do 400 i=1,nm
      dp(i)=dq(i)*dgc(i,i1)*dpc(i,i2)
  400 dc(i)=dq(i)*dgc(i,i2)*dpc(i,i1)
      dval=j+1
      dvalp=dval
      dvalm=dval
      call somm (dr,d,dp,dpas,dvalp,-1,nm)
      call somm (dr,d,dc,dpas,dval,-1,nm)
      call ykdir (i2,i1,j,nag)
      do 410 i=1,nm
  410 dp(i)=dq(i)*dgc(i,i2)*dpc(i,i1)
      call somm (dr,d,dp,dpas,dvalm,-1,nm)
  420 if (iprint .ge. 5)  write(16,430) j,nqn(i1),titre(i1),nqn(i2),
     1                                   titre(i2),dvalm,dval,dvalp
  430 format (' gm',i2,' (',i1,a2,',',i1,a2,')',5x,'(-1)=',1pe14.7,5x,'(
     10)=',1pe14.7,5x,'(+1)=',1pe14.7)
  440 if (n1+1) 460,450,330
  450 i1=i1+1
      i2=i1
      if (i1-norb) 360,360,330
  460 i2=i2+1
      if (i2-norb) 360,360,450
  470 if (nmrk.eq.0) go to 530
      if (iprint .ge. 5)  write(16,20)
      if (iprint .ge. 5)  write(16,480)
  480 format (/,20x,'integrales magnetiques rk=integrale de p1(1)*q2(1)*
     1uk(1,2)*p3(2)*q4(2)'//)
  490 read (5,10) i1,i2,i3,i4,k
      if (i1.le.0) go to 530
      if (i1.le.norb.and.i2.gt.0.and.i2.le.norb.and.i3.gt.0.and.i3.le
     1 .norb.and.i4.gt.0.and.i4.le.norb.and.k.ge.0) go to 500
      if (iprint .ge. 5)  write(16,70) i1,i2,i3,i4,k
      go to 490
  500 call ykdir (i1,i2,k,nag)
      do 510 i=1,np
  510 dp(i)=dq(i)*dgc(i,i3)*dpc(i,i4)
      dval=k+1
      call somm (dr,d,dp,dpas,dval,-1,np)
      if (iprint .ge. 5)  write(16,520) k,nqn(i1),titre(i1),nqn(i2),
     1              titre(i2),nqn(i3),titre(i3),nqn(i4),titre(i4),dval
  520 format (20x,'rm',i2,' (',i1,a2,',',i1,a2,',',i1,a2,',',i1,a2,') ='
     1 ,1pe14.7)
      go to 490
  530 return
      end

c      subroutine solout(en, fl, agi, api, kap, rmt,
c     1                  jri, max0, ic3, vm, iwkb)
      subroutine solout(en, fl, agi, api, kap,
     1                  jri, max0, ic3, vm, iwkb)
c                  resolution of the dirac equation
c                   p' - kap*p/r = - ( en/cl-v )*g - eg/r
c                   g' + kap*g/r = ( 2*cl+en/cl-v )*p + ep/r
c at the origin v approximately is -z/(r*cl) due to the point nucleus
c en one-electron energy in atomic units and negative
c fl power of the first term in development at the origin
c agi (api) initial values of the first development coefficient
c at the origin of the large(small)component
c kap quantum number kappa
c max0 the last point of tabulation of the wave function
 
      implicit double precision (a-h,o-z)
      include '../HEADERS/dim.h'
      include '../HEADERS/const.h'
      parameter (npi=6, test=1.0d+5)
      parameter (ccl=2*alpinv, csq=ccl**2 )
      complex*16 en,agi,api
      complex*16 gg,ag,gp,ap,dv,av,eg,ceg,ep,cep, vm(nrptx)
      common/comdic/cl,dz,gg(nrptx),ag(10),gp(nrptx),ap(10),dv(nrptx),
     1   av(10),eg(nrptx),ceg(10),ep(nrptx),cep(10)

      complex*16 ec,eph,f,g

c gg,gp -output, dv,eg,ep - input
c
c cl speed of light (approximately 137.037 in atomic units)
c dz nuclear charge
c gg (gp) large (small) component
c dv direct potential (v)     eg and ep exchange potentials
c ag,ap,av,ceg and cep are respectively the
c development coefficients for gg,gp,dv,eg and ep
c
      common/tabtec/hx,dr(nrptx),test1,test2,ndor,np,nes,method,idim
c hx exponential step
c dr radial mesh
c test1,test2,nes,method are dummy.
c  ndor number of terms for the developments at the origin
c np maximum number of the tabulation points
c idim dimension of the block dr


c{#mn: g77 chokes on taking real of a double-precision complex
c      if (real(av(1)).lt.0.0d 00.and.kap.gt.0) api=-agi*(kap+fl)/av(1)
c      if (real(av(1)).lt.0.0d 00.and.kap.lt.0) api=-agi*av(1)/(kap-fl)
      if (dble(av(1)).lt.0.0d 00.and.kap.gt.0) api=-agi*(kap+fl)/av(1)
      if (dble(av(1)).lt.0.0d 00.and.kap.lt.0) api=-agi*av(1)/(kap-fl)
c#mn}
      ec=en/cl
      ag(1)=agi
      ap(1)=api
      do 115 i=2,ndor
         ag(i)=ceg(i-1)
 115     ap(i)=cep(i-1)
c     integration of the inhomogenious system
c     no need in normalization, since we can use 
c     normalization agi=ag(1)=const
 
c            solution of the inhomogenios dirac equation
c gg gp initially exch. terms, at the time of return are wave functions
c ag and ap development coefficients of  gg and gp
c en one-electron energy
c fl power of the first development term at the origin
c agi (api) initial values of the first development coefficients
c at the origin of a large (small) component
 
c     initial values for the outward integration
      if (ic3.eq.0) then
c       Desclaux power expansion
         do 35 j=2,ndor
            k=j-1
            a=fl+kap+k
            b=fl-kap+k
            eph=a*b+av(1)*av(1)
            f=(ec+ccl)*ap(k)+ap(j)
            g=ec*ag(k)+ag(j)
            do 31 i=1,k
               f=f-av(i+1)*ap(j-i)
 31            g=g-av(i+1)*ag(j-i)
 
            ag(j)=(b*f+av(1)*g)/eph
 35         ap(j)=(av(1)*f-a*g)/eph

         do  41 i = 1,1
            gg(i)=0.0d 00
            gp(i)=0.0d 00
         do 41 j=1,ndor
            a=fl+j-1
            b=dr(i)**a
            gg(i)=gg(i)+b*ag(j)
 41         gp(i)=gp(i)+b*ap(j)
      else
c        see fovrg.f in feff6, be aware of different units
         twoz = -dble(av(1)) * 2.0*cl
         rat1 = twoz/ccl
         rat2 = rat1**2
         rat3 = csq/twoz
         il = -kap
         if (kap.gt.0) il = kap+1
         l0 = il-1
         ag(1) = agi
         if (twoz.le.0.0) then
            ap(1) = -ec/(2.0*il+1.0)*dr(1)*ag(1)
            ag(2) = 0.0
            ap(2) = 0.0
            ag(3) = 0.0
            ap(3) = 0.0
         else
            ap(1) = (fl-il)*rat3*ag(1)
            ag(2) = (3.0*fl-rat2)/(2.0*fl+1.0) * ag(1)
            ap(2)= rat3*( (fl -l0)*ag(2) - ag(1) ) -ap(1)
            ag(3)=( (fl+3.0*il)*ag(2) - 3.0*l0*ag(1) + 
     1      (fl+il+3.0)/rat3*ap(2) ) /(fl+1.0)/4.0
            ap(3)=( rat3*(2.0*l0*(fl+2.0-il)-l0-rat2)*ag(2)
     1      - 3.0*l0*rat3*(fl+2.0-il)*ag(1) + (fl+3.0-2.0*il-rat2)
     2      *ap(2) ) /(fl+1.0)/4.0
            ap(1) = ap(1)/ccl
            ag(2)= ag(2)*rat3
            ap(2)= ap(2)*rat3/ccl
            ag(3)= ag(3)*rat3**2
            ap(3)= ap(3)*rat3**2/ccl
         endif
         gg(1)=dr(1)**fl * (ag(1)+dr(1)*(ag(2)+dr(1)*ag(3)))
         gp(1)=dr(1)**fl * (ap(1)+dr(1)*(ap(2)+dr(1)*ap(3)))
      endif

      i0=1
      iflat = min ( jri, iwkb)
      call intout (en, i0, kap, iflat, ic3, vm)

      do 100 i = iflat, max0-1
         if (i.eq.iwkb) then
            eph = cl* ( 3*dv(iwkb+1) - dv(iwkb+2)) /2
            if (iwkb.eq.jri-1) eph=  cl* (dv(i) + dv(i+1)) /2
         else
            eph = cl* (dv(i) + dv(i+1)) /2
         endif
         if (ic3.gt.0 .and. i.lt.jri) then
           rav = (dr(i)+dr(i+1)) / 2
           ec = rav**3 * ( ccl+ (en - eph) / cl )**2
           eph = eph + ic3 * cl / ec * (vm(i) + vm(i+1)) / 2
         endif
         call flatv( dr(i), dr(i+1), gg(i), gp(i), en, eph, kap,
     1               gg(i+1), gp(i+1))
  100 continue

      return
      end

      subroutine fmssz(verbse, iph0, ie, em, eref, ph, nph,
     1           rfms, lfms, nat, iphat, rath, amat, lipotx, gctr, gtr)
c     uses Bruce Ravel subroutine to do FMS in self-consistency loop
c     written by alexei ankudinov 06.1997

      implicit double precision (a-h, o-z)
      include '../HEADERS/dim.h'

c     input
      dimension iphat(natx), rath(3,natx)
      real rat(3,natx), rfms
      real rpart,aipart
      integer nph
c      dimension iz(0:nphx)

c     work space
      complex*16 ph(lx+1, 0:nphx)
c      integer iph
      complex*16 em, eref
      character*512 slog
c     fms staff
      integer lipotx(0:nphx)
      complex gg(nspx*(lx+1)**2, nspx*(lx+1)**2, 0:nphx)
      complex gtr(2,2, 3,0:lx, 0:nphx)
      real amat(-lx:lx,2,2, 3,0:lx), gctr(2,2, 3,0:lx, 0:nphx)
      complex xphase(nspx, -lx:lx, 0:nphx), ck(nspx)
      complex*16 dck
      real  rdirec, toler1, toler2
      logical lcalc, verbse
      dimension lcalc(0:lx)
      save

      if (rfms .gt. 0) then
        do 25 iat=1,nat
        do 25 j=1,3
   25   rat(j,iat) = real (rath(j,iat))

c       transform to single precision
        minv = 0
        rdirec = 2*rfms
        toler1 = 0.e0
        toler2 = 0.e0


c       it will be nice to call yprep once for all energy points,
c       fix later, and now call it every time
        if (ie.eq.1 .or. lfms.eq.0) 
     1    call yprep(iph0, nat, inclus, iphat, rfms, rat)

        if (inclus.gt.1) then
cc        call fms for a cluster around central atom
          if (ie.eq.1 .and. verbse) then
             write (slog,35) inclus, iph0
  35         format ('        Doing FMS for a cluster of ',i3,
     1       ' atoms around iph = ',i2)
             call wlog (slog)
          endif

          dck=sqrt(2*(em-eref))
          rpart  = real(dble(dck))
          aipart = real(dimag(dck))
          ck(1) = cmplx(rpart, aipart)
          do 50 ipp = 0,nph
            do 40 ill = -lipotx(ipp), lipotx(ipp)
              rpart  = real(dble( ph(abs(ill)+1,ipp)))
              aipart = real(dimag(ph(abs(ill)+1,ipp)))
              xphase(1, ill, ipp) = cmplx(rpart, aipart)
  40        continue
  50      continue
          iverb=0
          if (ie.eq.1) iverb = 1
c         neglect spin-flip processes (fix later for ispin=1)
          nsp = 1
          ispin = 0
          do 55 ill = 0, lx
  55      lcalc(ill) = .true.
          call fms(lfms, nsp, ispin, inclus, nph, ck, lipotx, xphase,ie,
     1     iverb, minv, rdirec, toler1, toler2, lcalc,gg)
        endif
      endif

      do 200 ip=0,nph

        if (lfms.ne.0 .or. ip.eq.iph0) then
          do 190 lpp =0,lipotx(ip)
             ix1 = lpp**2 
             do 170 im=1,2*lpp+1
c              now cycle over gtr dimensions
               do 100 iop = 1,3
               do 100 i2 = 1,2
               do 100 i1 = 1,2
                 if (rfms.gt.0 .and. inclus.gt.0) gtr(i1,i2,iop,lpp,ip)= 
     1             gtr(i1,i2,iop,lpp,ip) + amat(im-lpp-1,i1,i2,iop,lpp)
     2             * gg(ix1+im,ix1+im,ip)
                 gctr(i1, i2, iop,lpp,ip)= gctr(i1, i2, iop,lpp,ip)
     1             + amat(im-lpp-1,i1,i2,iop,lpp)
 100           continue
 170         continue
 190      continue
        endif
 200  continue

      return
      end

      subroutine rholsz ( dx, x0, ri, em,
     2                  ixc, rmt, rnrm,
     3                  vtot, vvalgs, xnval, dgcn, dpcn, eref,
     4                  adgc, adpc, xrhole, xrhoce, ph,
     i                  iz, xion, iunf, ihole, lmaxsc)

      implicit double precision (a-h, o-z)

c     INPUT
c     dx, x0, ri(nr)
c                  Loucks r-grid, ri=exp((i-1)*dx-x0)
c     ne, em(ne)   number of energy points,  complex energy grid
c     ixc          0  Hedin-Lunqist + const real & imag part
c                  1  Dirac-Hara + const real & imag part
c                  2  ground state + const real & imag part
c                  3  Dirac-Hara + HL imag part + const real & imag part
c                  5  Dirac-Fock exchange with core electrons +
c                     ixc=0 for valence electron density
c     rmt          r muffin tin
c     rnrm         r norman
c     vtot(nr)     total potential, including gsxc, final state
c     dgcn(dpcn)   large (small) dirac components for central atom
c     adgc(adpc)   their development coefficients
c
c     OUTPUT
c     xrhole(0:lx)  integral over r of density function
c     xrhoce(0:lx)  the same integral for embedded atom only


      include '../HEADERS/const.h'
      include '../HEADERS/dim.h'

c     max number allowed in xsect r-grid
      parameter (nrx = nrptx)

c     output
      complex*16  xrhole(-4:3,-4:3)
      complex*16  xrhoce(-4:3, -4:3)
      complex*16  ph(lx+1)

      dimension ri(nrptx)
c      dimension ri05(251)
      dimension  vtot(nrptx), vvalgs(nrptx)
      complex*16 vtotc(nrptx), vvalc(nrptx)
      dimension xnval(30), dgcn(nrptx,30), dpcn(nrptx,30)
      dimension adgc(10,30), adpc(10,30)

c     energy grid in complex e-plane
      complex*16 em, eref

c     work space for dfovrg: regular and irregular solutions
      complex*16 pr(nrx,2,2), qr(nrx,2,2), pn(nrx,2,2), qn(nrx,2,2)

      complex*16  p2, xkmt, ck
c      complex*16 xck
      complex*16  pu, qu
      complex*16  xfnorm, xirf, xmp, xpm
      complex*16  temp,  phx, phm(2,2), factor

      complex*16 jl,jlp1,nl,nlp1
      complex*16  xpc(nrx)

c     initialize
      lmax=lmaxsc
      if (lmax.gt.lx) lmax = lx
      if (iz.le.4) lmax=2
      if (iz.le.2) lmax=1
      do 20 i = 1, nrptx
         vtotc(i)=vtot(i)
         vvalc(i)= vvalgs(i)
  20  continue
c     set imt and jri (use general Loucks grid)
c     rmt is between imt and jri (see function ii(r) in file xx.f)
      imt  = int((log(rmt) + x0) / dx)  +  1
      jri  = imt+1
      if (jri .gt. nrptx)  call par_stop('jri .gt. nrptx in phase')
      inrm = int((log(rnrm) + x0) / dx)  +  1
      jnrm = inrm+1

c     set limits for tabulations
      nr05= int((log(rnrm) + x0) / 0.05d0) + 5
      if (nr05.gt.251) nr05 = 251
c     ilast is the last integration point
c     it is larger than jnrm for better interpolations
      ilast = nint( (nr05-1) *0.05d0 / dx ) + 1
      if (ilast.gt.nrptx) ilast=nrptx

      do 10 i = -4,3
      do 10 j = -4,3
         xrhole(i,j) = 0
         xrhoce(i,j) = 0
  10  continue
      do 15 i=1,lx+1
  15  ph(i) = 0

c     p2 is 0.5*(complex momentum)**2 referenced to energy dep xc
c     need hartree units for dfovrg
      p2 = em - eref
      if (mod(ixc,10) .lt. 5) then
        ncycle = 0
      else
        ncycle = 3
      endif
      ck = sqrt(2*p2 + (p2*alphfs)**2)
      xkmt = rmt * ck

      do 200 lll=0,lmax
        do 199 jd = 0,1
          ikap = (lll+jd)* (-1)**jd
          if (ikap.eq.0) goto 199

          ilp = lll + 1
          if (ikap.gt.0) ilp = lll - 1
          im = 1+ jd

          do 150 j = 1, 2
            ic3 = j-1
            if (lll.eq.0 .and. ic3.eq.1) goto 150

            irr = -1
            call dfovrg ( ncycle, ikap, rmt, ilast, jri, p2, dx,
     $                ri, vtotc, vvalc, dgcn, dpcn, adgc, adpc,
     $                xnval, pu, qu, pn(1,im,j), qn(1,im,j),
     $                iz, ihole, xion, iunf, irr, ic3)
            
            call exjlnl (xkmt, lll, jl, nl)
            call exjlnl (xkmt, ilp, jlp1, nlp1)
            call phamp (rmt, pu, qu, ck,  jl, nl, jlp1, nlp1, ikap,
     1                  phx, temp)
            if (lll.eq.0)  ph(1)=phx
            phm(im,j) = phx

c           Normalize final state  at rmt to
c           rmt*(jl*cos(delta) - nl*sin(delta))
            xfnorm = 1 / temp
c           normalize regular solution
            do 133  i = 1,ilast
              pr(i,im,j)=pn(i,im,j)*xfnorm
              qr(i,im,j)=qn(i,im,j)*xfnorm
  133       continue

c          find irregular solution
            irr = 1
            pu = ck*alphfs
            factor = pu/(1+sqrt(1+pu**2))
            if (ikap.lt.0) factor = -factor
c           set pu, qu - initial condition for irregular solution at ilast
c           qu=(nlp1*cos(phx)+jlp1*sin(phx))*pu *rmt
c           pu = (nl*cos(phx)+jl*sin(phx)) *rmt
            qu=(nlp1*cos(phx)+jlp1*sin(phx))* factor *rmt 
            pu = (nl*cos(phx)+jl*sin(phx)) *rmt 

            call dfovrg (ncycle, ikap, rmt, ilast, jri, p2, dx,
     1              ri, vtotc,vvalc, dgcn, dpcn, adgc, adpc,
     1              xnval, pu, qu, pn(1,im,j), qn(1,im,j),
     1              iz, ihole, xion, iunf, irr, ic3)
cc            set N- irregular solution , which is outside
cc            N=(nlp1*cos(ph0)+jlp1*sin(ph0))*factor *rmt * dum1
cc            N = i*R - H*exp(i*ph0)
              temp = exp(coni*phx)
              do i = 1, ilast
                pn(i,im,j) = coni * pr(i,im,j) - temp * pn(i,im,j)
                qn(i,im,j) = coni * qr(i,im,j) - temp * qn(i,im,j)
              enddo

 150      continue

c         combine all constant factors to temp
c         add relativistic correction to normaliz. and factor 2*lll+1
          temp = 2*ck / (1+factor**2) / pi
  
c         ic3 = 0, j= ic3+1
          j = 1
c         calculate diagonal radial integrals R(k1,k1) - xrhoce and xrhole
            do 190  i = 1, ilast
              xpc(i) = pr(i,im,j) **2 + qr(i,im,j) **2
 190        continue
            xirf = lll*2 + 2
c           i0 should be less or equal to  ilast
            i0=jnrm+1
            call csomm2 (ri, xpc, dx, xirf, rnrm, i0)
            xrhole(ikap,ikap) =xirf*temp*exp(coni*(phm(im,j)+phm(im,j)))

c         only central atom contribution needs irregular solution
            do 195  i = 1, ilast
              xpc(i) = pn(i,im,j)*pr(i,im,j)+ qn(i,im,j) *qr(i,im,j)
              xpc(i) = xpc(i) - coni*(pr(i,im,j)**2 + qr(i,im,j)**2)
 195        continue
            xirf =  1
            call csomm2 (ri, xpc, dx, xirf, rnrm, i0)
            xrhoce(ikap,ikap) = - xirf * temp

c         calculate cross terms
          if (ikap.lt.-1) then
            k1 = ikap + 2*lll + 1
            do 290  i = 1, ilast
              xpc(i) = pr(i,1,j) * pr(i,2,j) + qr(i,1,j) * qr(i,2,j) 
 290        continue
            xirf = lll*2 + 2
c           i0 should be less or equal to  ilast
            i0=jnrm+1
            call csomm2 (ri, xpc, dx, xirf, rnrm, i0)
            xrhole (ikap, k1) = xirf*temp* exp(coni*(phm(1,j)+phm(2,j)))
            xrhole (k1, ikap) = xrhole (ikap, k1)

c           ic3 = 1, j= ic3+1
            j = 2
            xpm =  exp(coni*(phm(1,j)-phm(2,j))) / 2
            xmp =  exp(coni*(phm(2,j)-phm(1,j))) / 2
            do 295  i = 1, ilast
              xpc(i) = (pn(i,1,j)*pr(i,2,j)+ qn(i,1,j) *qr(i,2,j)) * xmp
     1               + (pn(i,2,j)*pr(i,1,j)+ qn(i,2,j) *qr(i,1,j)) * xpm
              xpc(i) = xpc(i) - coni*(xpm+xmp) *
     1                 (pr(i,1,j)*pr(i,2,j) + qr(i,1,j)*qr(i,2,j))
 295        continue
            xirf =  1
            call csomm2 (ri, xpc, dx, xirf, rnrm, i0)
            xrhoce(ikap,k1) = - xirf * temp
            xrhoce(k1,ikap) =  xrhoce(ikap,k1)
          endif
 199    continue 
 200  continue 

c     calculate phase shift in old way (ic3=1) test new one
c     which is commented out above later
      do 300 lll = 1,lmax
          im = 1
          ikap = -lll-1
          irr = -1
          ic3 = 1
          call dfovrg ( ncycle, ikap, rmt, ilast, jri, p2, dx,
     $                ri, vtotc, vvalc, dgcn, dpcn, adgc, adpc,
     $                xnval, pu, qu, pr(1,im,1), qr(1,im,1),
     $                iz, ihole, xion, iunf, irr, ic3)
            
          call exjlnl (xkmt, lll, jl, nl)
          call exjlnl (xkmt, lll+1, jlp1, nlp1)
          call phamp (rmt, pu, qu, ck,  jl, nl, jlp1, nlp1, ikap,
     1                  phx, temp)
          ph(1+lll)=phx
 300  continue

      return
      end

!=======================================================================
!     LDOS
!=======================================================================

module ldos_inp
  use atoms_inp,only: nph
  use potential_inp,only: ixc, rgrd
  use global_inp,only: ispin
  use dimsmod,only : nphx
  implicit none
  character(*),parameter,private :: filename='ldos.inp'
  integer mldos, lfms2, minv, lmaxph(0:nphx)
  double precision emin, emax, eimag
  integer neldos
  real rdirec, toler1, toler2, rfms2
  logical save_g0, save_compton_info ! BAM 2/2012

contains

  subroutine ldos_write
    integer iph
    open (file=filename, unit=3, status='unknown')
    write(3,10) 'mldos, lfms2, ixc, ispin, minv, neldos'
    write(3,20)  mldos, lfms2, ixc, ispin, minv, neldos
    write(3,10) 'rfms2, emin, emax, eimag, rgrd'
    write(3,30)  rfms2, emin, emax, eimag, rgrd
    write(3,10) 'rdirec, toler1, toler2'
    write(3,30)  rdirec, toler1, toler2
    write(3,10) ' lmaxph(0:nph)'
    write(3,20)  (lmaxph(iph),iph=0,nph)
    write(3,10) 'save_g0? save_compton_info?'
    write(3,*)  save_g0, save_compton_info
    close(3)
    ! standard formats for string, integers and real numbers
10  format(a)
20  format (20i4)
30  format (9f13.5)
  end subroutine ldos_write

  subroutine ldos_read
    integer iph
    open (file=filename, unit=3, status='old')
    read(3,*) ; read(3,*)  mldos, lfms2, ixc, ispin, minv, neldos
    read(3,*) ; read(3,*)  rfms2, emin, emax, eimag, rgrd
    read(3,*) ; read(3,*)  rdirec, toler1, toler2
    read(3,*) ; read(3,*)  (lmaxph(iph),iph=0,nph)
    read(3,*) ; read(3,*)  save_g0, save_compton_info
    close(3)
  end subroutine ldos_read

  subroutine ldos_init
    mldos = 0
    lfms2 = 0
    minv = 0
    emax = 0.d0
    emin = 1000*1.d0
    eimag = -1*1.d0
    neldos = 101
    rfms2 = -1 * 1.e0
    rdirec = -1 * 1.e0
    toler1 = 1.e-3
    toler2 = 1.e-3
    lmaxph(:) = 0
    save_g0 = .false.
    save_compton_info = .false.
  end subroutine ldos_init

end module ldos_inp

      subroutine trig (x, y, z, ct, st, cp, sp)
      implicit double precision (a-h, o-z)
c     returns cos(theta), sin(theta), cos(phi), sin(ph) for (x,y,z)
c     convention - if x=y=0 and z>0, phi=0, cp=1, sp=0
c                  if x=y=0 and z<0, phi=180, cp=-1,sp=0
c                - if x=y=z=0, theta=0, ct=1, st=0
      parameter (eps = 1.0d-6)
      r = sqrt (x**2 + y**2 + z**2)
      rxy = sqrt (x**2 + y**2)
      if (r .lt. eps)  then
         ct = 1
         st = 0
      else
         ct = z/r
         st = rxy/r
      endif
      if (rxy .lt. eps)  then
         cp = 1
         if (ct .lt. 0) cp = -1
         sp = 0
      else
         cp = x / rxy
         sp = y / rxy
      endif
      return
      end


      subroutine arg(c,fi,th)
      implicit double precision (a-h, o-z)
      complex*16  c
      parameter (eps = 1.0d-6)
      x = dble(c)
      y = dimag(c)
      if (abs(x) .lt. eps) x = 0
      if (abs(y) .lt. eps) y = 0
      if (abs(x) .lt. eps  .and.  abs(y) .lt. eps) then
        th = fi
      else
        th = atan2(y,x)
      endif
      return
      end

      subroutine fdtarr(ne, reff, lzero, achi, phchi, caps, xk, ck,
     &       col1, col2, col3, col4, col5, col6, col7)

c+---------------------------------------------------------------------
c     "Based on or developed using Distribution: FEFF8.5L
c      Copyright (c) [2013] University of Washington"
c
C  See ../HEADERS/license.h for full llicense information
c+---------------------------------------------------------------------
      implicit double precision (a-h, o-z)
      include '../HEADERS/const.h'
      include '../HEADERS/dim.h'

      parameter (eps = 1.0d-16)
      real xk(nex), reff
      complex caps(nex), ck(nex)
      real achi(nex), phchi(nex)
      dimension col1(nex), col2(nex), col3(nex), col4(nex), col5(nex)
      dimension col6(nex), col7(nex)
      complex*16 cchi, cfms
      integer ne, lzero, ie

c     Make the feff.dat stuff and write it to feff.dat
c     Also write out for inspection to fort.66
c     note that dimag takes complex*16 argument, aimag takes
c     single precision complex argument.  Stuff from feff.pad
c     is single precision, cchi is complex*16

      do 450  ie = 1, ne
c        Consider chi in the standard XAFS form.  Use R = rtot/2.
         cchi = achi(ie) * exp (coni*phchi(ie))
         xlam = 1.0e10
         if (abs(aimag(ck(ie))) .gt. eps) xlam = 1/aimag(ck(ie))
         redfac = exp (-2 * aimag (caps(ie)))
         cdelt = 2*dble(caps(ie))
         cfms = cchi * xk(ie) * reff**2 *
     1          exp(2*reff/xlam) / redfac
         if (abs(cchi) .lt. eps)  then
            phff = 0
         else
            phff = atan2 (dimag(cchi), dble(cchi))
         endif
c        remove 2 pi jumps in phases
         if (ie .gt. 1)  then
            call pijump (phff, phffo)
            call pijump (cdelt, cdelto)
         endif
         phffo = phff
         cdelto = cdelt


c        columns
c        . 1 k, momentum wrt fermi level k=sqrt(p**2-kf**2)
c        . 2 central atom phase shift (real part),
c        . 3 magnitude of feff,
c        . 4 phase of feff,
c        . 5 absorbing atom reduction factor,
c        . 6 mean free path = 1/(Im (p))
c        . 7 real part of local momentum p

         col1(ie) = xk(ie)/bohr
         col2(ie) = cdelt + lzero*pi
         col3(ie) = abs(cfms) * bohr
         col4(ie) = phff - cdelt - lzero*pi
         col5(ie) = redfac
         col6(ie) = xlam * bohr
         col7(ie) = dble(ck(ie))/bohr
 450  continue
      return
      end

      subroutine wfirdf (en,ch,nq,kap,nmax,ido)
c     calculate initial orbiatls from integration of dirac equation
c cg (cp) large (small) radial components
c bg (bp) development coefficients at the origin of cg (cp)
c en one-electron energies 
c fl power of the first term of development at the origin
c ch ionicity (nuclear charge - number of electrons)
c nq principal quantum number
c kap quantum number "kappa"
c nmax number of tabulation points for the orbitals
c ibgp first dimension of the arrays bg and bp
c        this programmes utilises nucdev,dentfa,soldir et messer
 
      implicit double precision (a-h,o-z)
      common cg(251,30), cp(251,30), bg(10,30), bp(10,30),
     1         fl(30), fix(30), ibgp
      dimension en(30),nq(30),kap(30),nmax(30)
      common/comdir/cl,dz,dg(251),ag(10),dp(251),ap(10),
     1dv(251),av(10),eg(251),ceg(10),ep(251),cep(10)
      common/itescf/testy,rap(2),teste,nz,norb,norbsc
      common/inelma/nem
      common/messag/dlabpr,numerr
      character*8 dlabpr
      character*512 slog
      common/snoyau/dvn(251),anoy(10),nuc
      common/tabtes/hx,dr(251),test1,test2,ndor,np,nes,method,idim
c#mn
       external dentfa

      cl=1.370373d+02
c    speed of light in atomic units
      dz = nz
c make r-mesh and calculate nuclear potential
c hx exponential step
c dr1 first tabulation point multiplied by nz
      hx=5.0d-02
      dr1= nz*exp(-8.8)
      call nucdev (anoy,dr,dvn,dz,hx,nuc,idim,ndor,dr1)
c notice that here nuc=1, 
c unless you specify nuclear mass and thickness in nucdev.f

      a=(dz/cl)**2
      if (nuc.gt.1) a=0.0d 00
      do 11 j=1,norb
         b=kap(j)*kap(j)-a
         fl(j)= sqrt(b)
c        quick fix of development coefficients. ala
 11      fix(j) = dr(1)**(fl(j)-abs(kap(j)))
c calculate potential from thomas-fermi model
      do 21 i=1,idim
 21   dv(i)=(dentfa(dr(i),dz,ch)+dvn(i))/cl
      if (numerr.ne.0) return
      do 51 i=1,idim
         eg(i)=0.0d 00
 51      ep(i)=0.0d 00
      do 61 i=1,ibgp
         ceg(i)=0.0d 00
         cep(i)=0.0d 00
 61      av(i)=anoy(i)/cl
      av(2)=av(2)+dentfa(dr(nuc),dz,ch)/cl
      test1=testy/rap(1)
      b=test1

c resolution of the dirac equation to get initial orbitals
      if (ido.ne.1) then
         call wlog('only option ido=1 left')
         ido = 1
      endif
c  here was a piece to read orbitals from cards
      do 281 j=1,norb
         bg(1,j)=1.0d 00
         i=nq(j)- abs(kap(j))
         if (kap(j).lt.0) i=i-1
         if (mod(i,2).eq.0) bg(1,j)=-bg(1,j)
         if (kap(j).lt.0) go to 201
         bp(1,j)=bg(1,j)*cl*(kap(j)+fl(j))/dz
         if (nuc.gt.1) bg(1,j)=0.0d 00
         go to 211

 201     bp(1,j)=bg(1,j)*dz/(cl*(kap(j)-fl(j)))
         if (nuc.gt.1) bp(1,j)=0.0d 00
 211     np=idim
         en(j)=-dz*dz/nq(j)*nq(j)
         method=0
         ifail = 0
         call soldir
     1     (en(j),fl(j),bg(1,j),bp(1,j),b,nq(j),kap(j),nmax(j),ifail)

         if (numerr.eq.0) go to 251
         call messer
         write(slog,'(a,2i3)') 
     1   'soldir failed in wfirdf for orbital nq,kappa ',nq(j),kap(j)
         call wlog(slog)
         go to 281

 251     do 261 i=1,ibgp
            bg(i,j)=ag(i)
 261        bp(i,j)=ap(i)
         do 271 i=1,np
            cg(i,j)=dg(i)
 271        cp(i,j)=dp(i)
 281  continue
      nem=0
      return
      end

c     Josh - added argument iPl to control many pole self energy.
      subroutine xsph (wrxsec, verbse, phpad,
     -       ipr2, ispec, vixan, xkstep, xkmax, gamach, rgrd,
     1       nph, lmaxph, potlbl, spinph, iatph, nat, rat, iphat,
     2       ixc, vr0, vi0, ixc0, lreal, rfms2, lfms2, l2lp,
     3       ipol, ispin, le2, angks, ptz, iPl,
     4       izstd, ifxc, ipmbse, itdlda, nonlocal,
c        pass parameters from rdpot
     1       ntitle, title, rnrmav, xmu, vint, rhoint,
     2       emu, s02, erelax, wp, ecv, rs, xf, qtotel,
     3       imt, rmt, inrm, rnrm, folp, folpx, xnatph,
     4       dgc0, dpc0, dgc, dpc, adgc, adpc,
     5       edens, vclap, vtot, edenvl, vvalgs, dmag, xnval,
     6       iorb, nohole, ihole,
     7       inters, totvol, iafolp, xion, iunf, iz, jumprm)
c squelch compiler warning about unused dummy variables, apparently
c removed from f85e
c    iGrid, (after iPl)
c  , ibasis)

c     Cluster code -- multiple shell single scattering version of FEFF
c     This program (or subroutine) calculates potentials and phase
c     shifts for unique potentials specifed by atoms and overlap cards.
c
c     Input files:  potph.inp    input data, atoms, overlaps, etc.
c     Output:       phases.bin   phase shifts for use by the rest of the
c                                program
c                   xxx.dat      various diagnostics

      implicit double precision (a-h, o-z)

      include '../HEADERS/const.h'
      include '../HEADERS/dim.h'

c     control whether xsect.json gets written, .true. for conventional
c     feff, .false. for libpotph
      logical wrxsec, verbse

      double precision col1(nex), col2(nex), col3(nex)
      double precision col4(nex), col5(nex)

c     Notes:
c        nat    number of atoms in problem
c        nph    number of unique potentials
c        ihole  hole code of absorbing atom
c        iph=0 for central atom

c     Specific atom input data
c     iphat(natx)  -  given specific atom, which unique pot?
      dimension iphat(natx)
c     rat(3,natx)  -  cartesian coords of specific atom
      dimension rat(3,natx)

c     Unique potential input data
c     iatph(0:nphx)  - given unique pot, which atom is model?
c                      (0 if none specified for this unique pot)
      dimension iatph(0:nphx)
c     xnatph(0:nphx) - given unique pot, how many atoms are there
c                      of this type? (used for interstitial calc)
      dimension xnatph(0:nphx), spinph(0:nphx)
c     potlbl(0:nphx)    -   label for user convienence
      character*6 potlbl(0:nphx)

c     folp(0:nphx) -  overlap factor for rmt calculation
      dimension folp(0:nphx)
c     novr(0:nphx) -  number of overlap shells for unique pot
      dimension novr(0:nphx)
c     iphovr(novrx,0:nphx) -  unique pot for this overlap shell
      dimension iphovr(novrx,0:nphx)
c     nnovr(novrx,0:nphx) -   number of atoms in overlap shell
      dimension nnovr(novrx,0:nphx)
c     rovr(novrx,0:nphx)  -   r for overlap shell
      dimension rovr(novrx,0:nphx)

c     Free atom data
c     xion(0:nphx)  - ionicity, input
      dimension xion(0:nphx)
c     iz(0:nphx)    - atomic number, input
      dimension iz(0:nphx)

c     Overlap calculation results
c     edens(251,0:nphx)   -   overlapped density*4*pi
      dimension edens(251,0:nphx)
c     vtot (251,0:nphx)   -   overlapped total potential
      dimension vtot (251,0:nphx), vclap (251,0:nphx)

c     Muffin tin calculation results
c     imt(0:nphx)  -  r mesh index just inside rmt
      dimension imt(0:nphx), inrm(0:nphx), folpx(0:nphx)
c     rmt(0:nphx)  -  muffin tin radius
      dimension rmt(0:nphx)
c     rnrm(0:nphx)  -  Norman radius
      dimension rnrm(0:nphx)
c     , qnrm(0:nphx)
c      dimension xnmues(0:lx,0:nphx)
      real rfms2
      integer ipol, ispin, lfms2
      complex*16 ptz
      dimension ptz(-1:1, -1:1)
      dimension lmaxph(0:nphx)

c     PHASE output
c     eref(nex, nspx)         -     interstitial energy ref
      complex*16 eref(nex, nspx)
c     ph(nex,-ltot:ltot,nspx,0:nphx) - phase shifts
      complex*16 ph( nex, -ltot:ltot, nspx, 0:nphx)
c     lmax(0:nphx)      -     number of ang mom levels
      dimension lmax(0:nphx)

      character*80 title(nheadx)

      complex*16  em(nex)
      complex*16  rkk(nex,8,nspx), xsec(nex,nspx)
      dimension xsnorm(nex, nspx)
      dimension dgc0(251), dpc0(251)

c     additioal data needed for relativistic version
      dimension dgc(251,30,0:nphx), dpc(251,30,0:nphx)
      dimension adgc(10,30,0:nphx), adpc(10,30,0:nphx)
      dimension dgcn(nrptx,30), dpcn(nrptx,30)
      dimension edenvl(251,0:nphx)
c     , eorb(30), kappa(30)
      dimension vvalgs (251,0:nphx), xnval(30,0:nphx), iorb(-4:3,0:nphx)

c     nrx = max number of r points for phase and xsect r grid
      parameter (nrx = nrptx)
      dimension ri(nrptx), vtotph(nrx), rhoph(nrx)
      dimension  dmagx(nrptx), dmag(251,0:nphx)
      dimension dgcx(nrptx), dpcx(nrptx), vvalph(nrx), rhphvl(nrx)
      dimension vch (251), vchp(nrx)

      logical lopt
      character*512 slog

c     Josh - Added iPl for PLASMON card, and iexist for mpse.dat
      integer iPl
c      integer iexist
      
      character*256 phpad


   10 format (4x, a, i5)

c     Phase shift calculation
c     Atom r grid
      dx = 0.05d0
      x0 = 8.8d0
c     Phase r grid
      dxnew = rgrd

c*************************************************************************
c     move the call to rdpot out to ffmod1.f so that this file can be
c     reused between the conventional feff programs and libpotph
c*************************************************************************
c$$$      call rdpot ( ntitle, title, rnrmav, xmu, vint, rhoint,
c$$$     1                  emu, s02, erelax, wp, ecv,rs,xf, qtotel,
c$$$     2                  imt, rmt, inrm, rnrm, folp, folpx, xnatph,
c$$$     3                  dgc0, dpc0, dgc, dpc, adgc, adpc,
c$$$     3                  edens, vclap, vtot, edenvl, vvalgs, dmag, xnval,
c$$$     4                  eorb, kappa, iorb, qnrm, xnmues, nohole, ihole,
c$$$     5                  inters, totvol, iafolp, xion, iunf, iz, jumprm)
c      lopt=true for the Rivas code of optical constants
       lopt = .false.
       if (lopt) call getedg(ihole,iz(0), emu)
       if (lopt) ik0 = 1
       if (lopt .and. verbse) then
         call wlog('   Fixing edge energy from Elam table...')
         write(slog,fmt="('   emu = ',f10.3,' eV')") emu*hart
         call wlog(slog)
       endif

       do 15 iph = 0, nph
 15    novr(iph) = 0

c  update header, since e.g. one may use diff ixc for the same potential
        call sthead (ntitle, title, nph, iz, rmt, rnrm,
     1          xion, ihole, ixc,
     2          vr0, vi0, gamach, xmu, xf, vint, rs,
     2          lreal, rgrd)
c     Make energy mesh
      edge = xmu - vr0
      if (.not.lopt) emu = emu - vr0

cc    manual input. Later make TDLDA and PMBSE cards
cc    TDLDA ifxc  (izstd=1 if TDLDA card is present)
c     izstd = 0
c     ifxc = 0
cc    PMBSE  ipmbse  nonlocal ifxc itdlda
c     ipmbse = 2
c     ibasis = 2
cc    ipmbse=0 (do not run); 1-LF only; 2-PM only; 3-combined; 
cc           4-combined with s-function kernel splitting
c     nonlocal = 0
cc    nonlocal = 0 (local fxc); 1-read W from pot.ch; 2-from yoshi.dat
c     itdlda = 2
cc    itdlda = 0, 1, 2 should be run in sequence
cc    end of manual input

c     check that logic is set up correctly
      if (ipmbse.le.0) itdlda = 0
      if (nohole.lt.0) then
c       core-hole potential is used already
        if (ifxc.ne.0) then
           if (verbse)
     1            call wlog(' Reset ifxc=0 since NOHOLE card is absent')
          ifxc = 0
          if (ipmbse.gt.0) nonlocal = 0
        endif
        if (ipmbse.eq.3 .and. izstd.eq.0) then
           if (verbse)
     1          call wlog(' Reset ipmbse=1 since NOHOLE card is absent')
          ipmbse = 1
        endif
      endif
      if (izstd.gt.0 .and. itdlda.gt.0) then
c       no need run PMBSE in this case
         if (verbse)
     1          call wlog(' Ignored PMBSE cards since TDLDA is present')
        itdlda = 0
      endif
      if (ipmbse.eq.2 .and. nonlocal.gt.0 .and. ifxc.gt.0) then
c       accounting for core-hole twice. reset ifxc=0
         if (verbse)
     1     call wlog(' Reset ifxc=0 since core-hole potential is used.')
        ifxc = 0
      endif
      if (ipmbse.eq.1 .and. nonlocal.gt.0) then
c       V_ch should be zero
        nonlocal = 0
      endif

c     Josh - if nohole = 2, read wscrn.dat and add ch pot to vtot.
c     Need to add file check and emesh check.
      if (nohole.eq.2)  then
         open (unit=13, file='wscrn.dat', status='old', iostat=ios)
         call chopen (ios, 'wscrn.dat', 'ffmod2(xsph)')
         open (unit=14, file='vtot.dat', status='replace',iostat=ios)
         call chopen (ios, 'vtot.dat', 'ffmod2(xsph)')
         do i = 1, 251
            read(13,'(2e20.10)',end=20) dum1, dum2
            dum3 = vtot(i,0)
            vtot(i,0) = vtot(i,0) - dum2
            write(14,'(3e20.10)') dum1, dum3, dum2
         end do
 20      continue
         nohole = 0
         close(13)
         close(14)
      end if
c     Josh END

      if (itdlda.eq.0)  then 
!     Josh - Replaced call to phmesh with phmesh2, which allows user
!     defined grids read from grid.inp. Details can be found in phmesh2.f
!         call phmesh2 (ipr2, ispec, edge, emu, vi0, gamach, xkmax,
!     &        xkstep, vixan, ne, ne1, em, ik0, ne3,iGrid)
c        print *, ipr2, ispec, edge, emu, vi0, gamach
c        print *, xkmax, xkstep, vixan, ne, ne1, ik0, ne3
        call phmesh (ipr2, ispec, edge, emu, vi0, gamach,
     1                 xkmax, xkstep, vixan, ne, ne1, em, ik0, ne3)
      else
c       nesvi TDLDA
c        call meshlda (xkstep, ne, ne1, em, ik0)
        corr = 1.0
      endif

      if (itdlda.eq.1) then
c       to get the mesh only
        do 93  i = 1, ne1
          write(3,94) dble(em(i))*hart
 94       format (7f10.5)
 93     continue
        stop 'TDLDA energy mesh is written out'
c       end of itdlda=1 calculations
      endif

c     Make old grid to report distances in xsect.bin
      do 95 i = 1, 251
 95   ri(i) = exp(-x0+dx*(i-1))

c     open xsect.bin and write the header
c--json--      open (unit=1, file='xsect.bin', status='unknown', iostat=ios)
c--json--      call chopen (ios, 'xsect.bin', 'potph')
c--json--      call wthead (1, ntitle, title)
c skip old output in title ( title lines are above ------ )
c     write(1,*) 'vtot in eV, rho in code units, includes 4pi'
c     write(1,*) 'ipot, vtot(imt), rho(imt) '
c     write(1,122) 'interstitial', vint*hart, rhoint
c     do 386  iph = 0, nph
c        write(1,123)iph,vtot(imt(iph),iph)*hart,edens(imt(iph),iph)
c 386 continue
c 122 format (1x, a, 1p, 2e20.6)
c 123 format (i10, 1p, 2e20.6)
c     write(1,42)  emu*hart
c  42 format ('       edge ', 2f20.5)
c     write(1,*)  imt(0), ' imt(0)'
c     write(1,200)  vint*hart, rhoint, ri(imt(0)+1)
c 200 format ('  v, rho, r', /, 1p, 3e20.4, ' intersitial')
c     do 220  iii = imt(0), imt(0)-4, -1
c        write(1,210)  vtot(iii,0)* hart, edens(iii,0), ri(iii), iii
c 210 format (1p, 3e20.4, i6)
c 220 continue

c--json--      write(1,45)
c--json--   45 format (1x, 71('-'))
c--json--      write(1,55) s02, erelax, wp, edge, emu
c--json--   55 format ( 3e13.5, 2e15.7, ' method to calculate xsect')
c--json--      write(1,56) gamach*hart, ne1, ik0
c--json--   56 format (1p, e15.7, 2i4,
c--json--     1       ' gamach in eV, # of points on horizintal axis')
c--json--      write(1,57)
c--json--   57 format ('        em              xsnorm            xsec  ')
c--json--c     end of the xsect.bin header


c     nsp = 1 - spin average caclulations; 2 - spin up and down
      nsp = 1
      if (abs(ispin).eq.1) nsp = nspx
c     scale spin density on each atom appropriately
      do iph = 0, nph
       do i = 1, 251
         dmag(i,iph) = dmag(i, iph) * spinph(iph)
       enddo
      enddo

      do 300 isp = 1, nsp
        if (ispin.ne.0) then
c         make spin dependent potential if needed
c         isp = 1-spin-down; 2-spin-up potentials
          idmag = (-1)**isp
          if (nsp.eq.1) then
             idmag = 1
             if(ispin.lt.0) idmag=-1
          endif
          call  istprm (nph, nat, iphat, rat, iatph, xnatph,
     1               novr, iphovr, nnovr, rovr, folp, folpx, iafolp,
     1               edens, edenvl, idmag,
     2               dmag, vclap, vtot, vvalgs, imt, inrm, rmt, rnrm,
     3               ixc, rhoint,vint, rs, xf, xmu, xmunew,
     5               rnrmav, qtotel, inters, totvol)
          xmunew = xmu
          if (abs(ispin).eq.1 .and. nsp.eq.2) then
c           |ispinp| = |ispin|, but sign is determined by isp
             ispinp = abs(ispin)
             if (isp.eq.1) ispinp = -ispinp
          else
c            sign is determined by spin (always for ispin=-2,2)
             ispinp = ispin
          endif
        else
c         spin-independent case
          ispinp = 0
        endif

c       calculate operators of interest (s_z, l_z, t_z)
        xmuvr = xmu - vr0
        if (ipr2.ge.3) call szlz(verbse,
     1      ispinp,ecv,nph,nat,rgrd,nohole,rfms2,
     2      lfms2, lmaxph, edens, edenvl, dmag, vtot, vvalgs, rmt, rnrm,
     3      ixc, rhoint, vint, xmuvr, jumprm,
     4      xnval, iorb, x0, dx, xion, iunf, iz,
     5      adgc, adpc, dgc, dpc, ihole, rat, iphat, corr)
c    1                   em, ne1, ne, ik0 )

c       Cross section calculation, use phase mesh for now
c       Absorbing atom is iph=0
        if (verbse) then
           write(slog,10) 'absorption cross section'
           call wlog(slog)
        endif
        iph = 0
        call fixvar (rmt(0), edens(1,0), vtot(1,0), dmag(1,0),
     1             vint, rhoint, dx, dxnew, jumprm,
     2             vjump, ri, vtotph, rhoph, dmagx)
        call fixdsx (iph, dx, dxnew, dgc, dpc, dgcn, dpcn)
        if (mod(ixc,10) .ge. 5) then
           if (jumprm .gt. 0) jumprm = 2
           call fixvar (rmt(0), edenvl(1,0), vvalgs(1,0), dmag(1,0),
     1             vint, rhoint, dx, dxnew, jumprm,
     2             vjump, ri, vvalph, rhphvl, dmagx)
           if (jumprm .gt. 0) jumprm = 1
        endif
        call fixdsp (dx, dxnew, dgc0, dpc0, dgcx, dpcx, jnew)
  
        if (itdlda.eq.0) then
c         Josh - added argument iPl to control many pole self energy
c         BR - removed eorb, gamach, ifxc, vi0
          call xsect (ipr2, dxnew, x0, ri, ne, ne1, ik0, em, edge,
     1       ihole, emu, corr, dgcx, dpcx, jnew,
     2       ixc0, lreal, rmt(0), rnrm(0), xmuvr, iPl,
     3       vtotph, vvalph, rhoph, dmagx, rhphvl, 
     4       dgcn, dpcn, adgc(1,1,iph), adpc(1,1,iph), xsec(1,isp),
     5       xsnorm(1,isp), rkk(1,1,isp), iz(0), xion(0), iunf,
     6       xnval(1,iph), izstd, iorb(-4,iph), l2lp,
     7       ipol, ispinp, le2, angks,ptz)
        else
          if (nonlocal.gt.0) then
c           read potential with core-hole from a file
            if (nonlocal.eq.1) then
c              call rdpotp(vch)
            elseif (nonlocal.eq.2) then
c             open (unit=3, file='MgO_Mgk.dat', status='old')
              open (unit=3, file='wscrn.dat', status='old')
c             open (unit=3, file='w_m5p.dat', status='old')
c             open (unit=3, file='ni_l2.dat', status='old')
c             open (unit=3, file='ni_l2_sp.dat', status='old')
              n=0
 338          n = n+1
                read(3,337, end=339) dum1, dum2
c               use frac.ne.1  to mix bare and screened ch pot
c                frac = 0.80
c                frac = 1.00
                vch(n) = -1.d0*dum2
 337            format(6e20.10)
                goto 338
 339          continue
              close (unit=3)
            endif
            call fixvar (rmt(0), edens(1,0), vch, dmag(1,0),
     1             vint, rhoint, dx, dxnew, jumprm,
     2             vjump, ri, vchp, rhoph, dmagx)
            do 333 i = 1, nrptx
               if (ri(i).lt.rmt(0)) then
                 if (nonlocal.eq.1) then
                   vchp(i) = vchp(i) - vtotph(i)
                 endif
               elseif (ri(i).lt.40.d0) then
c                 assume const/r behaviour
                  vchp(i) = vchp(i-1) * ri(i-1) / ri(i) 
               else
                  vchp(i) = 0
               endif
c           testing: write core-hole potential in fort.17
               if (ri(i).lt.40.d0) write(17,332) ri(i), vchp(i)
 332            format(2f30.5)
 333        continue
           
            close (unit=17)
c           itest = 2
c           if (itest.eq.2) stop
          else
            do 334 i =1, nrptx
 334        vchp(i) = 0
          endif
          
c         Josh - added argument iPl to control many pole self energy
c          call xsectd (ipr2,dxnew, x0, ri, ne, ne1, ik0, em, edge,
c     1       ihole, emu, corr, dgcx, dpcx, jnew,
c     2       ixc0, lreal, rmt(0), rnrm(0), xmuvr, vi0, iPl,
c     3       gamach, vtotph, vvalph,vchp, rhoph, dmagx, rhphvl,
c     4       dgcn, dpcn, adgc(1,1,iph), adpc(1,1,iph), xsec(1,isp),
c     5       xsnorm(1,isp), rkk(1,1,isp),iz(0), xion(0), iunf,
c     6       xnval(1,iph), ipmbse, ifxc, ibasis, eorb, kappa,
c     7       iorb(-4,iph), l2lp, ipol, ispinp, le2, angks,ptz, itdlda)
        endif


        do 60 iph = 0, nph
           if (verbse) then
              write(slog,10) 'phase shifts for unique potential', iph
              call wlog(slog)
           endif
c          fix up variable for phase
           call fixvar (rmt(iph), edens(1,iph), vtot(1,iph),
     1            dmag(1,iph), vint, rhoint, dx, dxnew, jumprm,
     2            vjump, ri, vtotph, rhoph, dmagx)
           if (mod(ixc,10) .ge.5) then
              if (jumprm .gt. 0) jumprm = 2
              call fixvar (rmt(iph), edenvl(1,iph), vvalgs(1,iph),
     1               dmag(1,iph), vint, rhoint, dx, dxnew, jumprm,
     2               vjump, ri, vvalph, rhphvl, dmagx)
              if (jumprm .gt. 0) jumprm = 1
              call fixdsx (iph, dx, dxnew, dgc, dpc, dgcn, dpcn)
           endif
           if (iph .eq. 0)  then
              itmp = ihole
           else
              itmp = 0
           endif

          call phase (iph, dxnew, x0, ri, ne, ne1, ne3, em, ixc, nsp,
     1            lreal, rmt(iph),rnrm(iph), xmuvr, iPl,
     2            vtotph, vvalph, rhoph, dmagx, rhphvl,
     3            dgcn, dpcn, adgc(1,1,iph), adpc(1,1,iph), eref(1,isp),
     4            ph(1,-ltot,isp,iph), lmax(iph), iz(iph), itmp,
     5            xion(iph), iunf, xnval(1,iph), ispinp)
c          call phase (iph, dxnew, x0, ri, ne, ne1, ne3, em, ixc, nsp,
c     1            lreal, rmt(iph),rnrm(iph), xmuvr, vi0, iPl,
c     2            gamach, vtotph, vvalph, rhoph, dmagx, rhphvl,
c     3            dgcn, dpcn, adgc(1,1,iph), adpc(1,1,iph), eref(1,isp),
c     4            ph(1,-ltot,isp,iph), lmax(iph), iz(iph), itmp,
c     5            xion(iph), iunf, xnval(1,iph), ispinp)
 60     continue

 300  continue

c     write main output to xsect.bin
c--json--  340 format (e17.9, 4e13.5)
      if (abs(ispin).ne.1 .or. nspx.eq.1) then
        do 350  ie = 1, ne
c--json--           write(1,340) dble(em(ie))*hart, dimag(em(ie))*hart,
c--json--     1                 xsnorm(ie,1), dble(xsec(ie,1)), dimag(xsec(ie,1))
           col1(ie) = dble(em(ie))*hart
           col2(ie) = dimag(em(ie))*hart
           col3(ie) = xsnorm(ie,1)
           col4(ie) = dble(xsec(ie,1))
           col5(ie) = dimag(xsec(ie,1))
  350   continue
      else
c       nspx = 2
        do 380  ie = 1, ne
c--json--           write(1,340) dble(em(ie))*hart, dimag(em(ie))*hart,
c--json--     1             (xsnorm(ie,1) + xsnorm(ie,nspx)) / 2.d0 ,
c--json--     2           dble( (xsec(ie,1) + xsec(ie,nspx)) ),
c--json--     3          dimag( (xsec(ie,1) + xsec(ie,nspx)) )
           col1(ie) = dble(em(ie))*hart
           col2(ie) = dimag(em(ie))*hart
           col3(ie) = (xsnorm(ie,1) + xsnorm(ie,nspx)) / 2.d0
           col4(ie) = dble( (xsec(ie,1) + xsec(ie,nspx)) )
           col5(ie) = dimag( (xsec(ie,1) + xsec(ie,nspx)) )
c          Normalize rkk to the average over up/down spin
c          nsp=2
           xnorm1 = sqrt( 2*xsnorm(ie,1) /
     1                         (xsnorm(ie,1) + xsnorm(ie,nspx)) )
           xnorm2 = sqrt( 2*xsnorm(ie,nspx) /
     1                         (xsnorm(ie,1) + xsnorm(ie,nspx)) )
           do 360 kdif = 1,8
             rkk (ie, kdif, 1) = rkk (ie, kdif, 1) * xnorm1
             rkk (ie, kdif, nspx) = rkk (ie, kdif, nspx) * xnorm2
  360      continue
  380   continue
      endif
c--json--      close (unit=1)

c     using opconsat resulted in NaNs in these array in one case
c     a.ne.a is an idiom for testing NaN-ness     
      do 390  ie = 1, ne
         if (col3(ie) .ne. col3(ie)) col3(ie) = 0.d0
         if (col4(ie) .ne. col4(ie)) col4(ie) = 0.d0
         if (col5(ie) .ne. col5(ie)) col5(ie) = 0.d0
 390  continue
      
      if (wrxsec) call json_xsect(ntitle, title, s02, erelax,
     -       wp, edge, emu,
     1       gamach*hart, ne, ne1, ik0,
     2       col1, col2, col3, col4, col5)

c     disable for now since dimensions are different
      if (ipr2 .ge. 2)  then
         call wphase (nph, em, eref, lmax, ne, ph, ntitle, title)
      endif

c     Write out phases for paths and genfmt
      call wrxsph (phpad,
     &       nsp, ne, ne1, ne3, nph, ihole, rnrmav, xmuvr,
     &       edge, ik0, ixc, rs, vint,
     &       em, eref, lmax, iz, potlbl, ph, rkk)

      if (ipr2 .ge. 1) then
c       calculate axafs
c       axafs does not make sense for |ispin| = 1
        call axafs (em, emu, xsec(1,1), ne1, ik0)
      endif

      return
      end

       subroutine get_inpfile(defval,fname,istat)
c 
c  return first command line argument, as if for a filename,
c  using defval if no argument is given:
c
c  arguments 
c      defval   default file name  (character) input only
c      fname    output file name   (character) output only
c      istat    output status      (integer)   output only
c        = 0 for success,  = 1 for failure

       character*(*) defval, fname
       integer  n_args, istat, jstat
       character*512 cl_args(3), f
c
c g77 version
       istat = 1 
       n_args = iargc()
       f = defval
       if (n_args .ge. 1) then
          call getarg(1,f)
          istat = 0
       endif
       call triml(f)
       fname = f
       return 
       end

cc dvf version
c       use dflib
c       istat  = 1
c       n_args = nargs()
c       f      = defval
c       jstat  = 0
c
c       if (n_args .ge.2) then 
c          CALL GETARG(1,f, jstat)
c          istat = 0
c       endif	
c       call triml(f)
c       fname = f
c       return
c       end
c

c     sub-program exchange point
      program rdinp 
c     subroutine rdinp (nabs,ceels)

c    reads 'feff.inp' file and writes several files in special format
c    ready for the use by other modules: geom.dat, global.dat,
c    mod1.inp, mod2.inp, mod3.inp mod4.inp mod5.inp mod6.inp ldos.inp .
c    The subroutine output 'nabs' is needed for configurational average
c    The rest of output, passed to wrtall via common blocks (allinp.h)

c     coded s. zabinski 1994
c     last modified by a.l.ankudinov march 2001  for new i/o structure

      implicit double precision (a-h, o-z)
      include '../HEADERS/const.h'
      include '../HEADERS/dim.h'
      include '../RDINP/allinp.h'
      include '../HEADERS/vers.h'
      include '../HEADERS/parallel.h'

c     Single scattering path to go with Overlap information
      parameter (nssx = 16)
      dimension indss(nssx), iphss(nssx)
      dimension degss(nssx), rss(nssx)

c     Local stuff
      character*150  line
      dimension ltit(nheadx)
      parameter (nwordx = 20)
      character*20 words(nwordx)
      integer iatph(0:nphx)
      integer icnt  !KJ 1-06 this is just a local index that does not need to be saved

      parameter (nbr=30)
      logical nogeom
      parameter (big = 1.0e5)
      character*512 slog
      character*38 tmpstr
      logical ceels  !KJ for monolithic version 5-6

      external dist

      icnt = 0

c   10 format (a)
   20 format (bn, i15)
   30 format (bn, f15.0)

      call par_begin
      if (worker) go to 400

c     open the log file, unit 11.  See subroutine wlog.
      open (unit=11, file='log.dat', status='unknown', iostat=ios)
      call chopen (ios, 'log.dat', 'feff')

      tmpstr = vfeff // 'release '//vf85e
      call triml (tmpstr)
      call wlog(' ' // tmpstr)

c     initialize all things to be passed
      nabs = 1
      call iniall

c     initialize local staff 
      iatom = 0
      ifolp = 0
      iovrlp = 0
      iphabs = 0
      lxnat = 0
      folpx = 1.15d0
      nogeom = .false.
      rclabs = big
      rmult = 1.0d0
      s02h = 1.0d0
      natt = 0
      nss = 0
      do 90  iss = 1, nssx
         indss(iss) = 0
         iphss(iss) = 0
         degss(iss) = 0
         rss(iss) = 0
  90  continue
      do 95 iph = 0, nphx
  95  iatph(iph) = 0

c     tokens  0 if not a token
c             1 if ATOM (ATOMS)
c             2 if HOLE
c             3 if OVER (OVERLAP)
c             4 if CONT (CONTROL)
c             5 if EXCH (EXCHANGE)
c             6 if ION
c             7 if TITL (TITLE)
c             8 if FOLP
c             9 if RPATH or RMAX
c            10 if DEBY (DEBYE)
c            11 if RMUL (RMULTIPLIER)
c            12 if SS
c            13 if PRIN (PRINT)
c            14 if POTE (POTENTIALS)
c            15 if NLEG
c            16 if CRIT (CRITERIA)
c            17 if NOGEOM
c            18 if IORDER
c            19 if PCRI (PCRITERIA)
c            20 if SIG2
c            21 if XANE (XANES)
c            22 if CORR (CORRECTIONS)
c            23 if AFOL (AFOLP)
c            24 if EXAF (EXAFS)
c            25 if POLA (POLARIZATION)
c            26 if ELLI (ELLIPTICITY) 
c            27 if RGRI (RGRID)
c            28 if RPHA (RPHASES), real phase shifts
c            29 if NSTA (NSTAR), n* for co-linear polarization
c            30 if NOHO (NOHOLE), use no hole for potentials
c            31 if SIG3 third and first cumulants for ss paths
c            32 if JUMP (JUMPRM), remove jumps of potential   
c            33 if MBCO (MBCONV), do convolution with exitation spectrum
c            34 if SPIN do calculation for spin-up(down) photoelectron  
c            35 if EDGE to specify edge by name
c            36 if SCF  do self-consistency loop
c            37 if FMS  use FMS for cluster of the size rfms
c            38 if LDOS print out l-dos for specified energy range
c            39 if INTE how to find interstitial parameters
c            40 if CFAV to do configuration average
c            41 if S02  to specify S_0^2
c            45 if RSIG (RSIGMA), real self-energy 
c            46 if XNCD natural dichroism
c            47 if MULT for quadrupolar etc. transitions
c            48 if UNFR unfreeze f-electrons
c            49 if TDLDA use TDLDA background
c            50 if PMBSE use BSE for background
c            51 if PLASMON       - Added by Josh Kas
c                                - PLASMON
c                                - With this card set, ffmod2 will read exc.dat and
c                                - use a multiple pole self energy
c            52 if S02C (S02CONV) compute S_0^2 from response function
c            53 if SELF print on shell self energy as a function of E.
c            54 if SFSE print off shell self energy and spectral function.
c            55 if RCONV print running convolution with spectral function.
c            56 if ELNE calculate ELNES  !KJ 1-06
c            57 if EXEL calculate EXELFS !KJ 1-06
c            58 if MAGI plot magic angle !KJ 1-06
c            59 if ABSO don't normalize spectrum !KJ 3-06
c            60 if EGRID (Gives user control of grid through grid.inp)
c            -1 if END  (end)
c     mode flag  0 ready to read a keyword card
c                1 reading atom positions
c                2 reading overlap instructions for unique pot
c                3 reading unique potential definitions
c                4 reading EELS input  !KJ

c#mn{
c  replaced read of feff.inp with  call to rdline, which will:
c    1. read from feff.inp if found, otherwise will stop and complain
c       (support for reading from standard input would be easy to add)
c    2. handles line processing tasks like 
c         = ignoring comment lines and blank lines
c         = tab removal
c    3. allows 'include' files in input file
c    4. for initial call, set jinit = -1, line = input_file_name
c
      mode  = 0
      jinit = -1
      line  = 'feff.inp'
  200 continue 
         call rdline(jinit,line)
         if (line .eq. 'read_line_end')    line='END'
         if (line .eq. 'read_line_error')  line='END'
c#mn}

         nwords = nwordx
         call bwords (line, nwords, words)
         itok = itoken (words(1),'feff.inp')

c        process the card using current mode
  210    continue

         if (mode .eq. 0)  then
            if (itok .eq. 1)  then
c              ATOM
c              Following lines are atom postions, one per line
               mode = 1
               iatom  = iatom  +1
            elseif (itok .eq. 2)  then
c              HOLE     1  1.0
c                   holecode s02
               read(words(2),20,err=900)  ihole
               if (nwords.gt.2) read(words(3),30,err=900)  s02h
               mode = 0
            elseif (itok .eq. 3)  then
c              OVERLAP iph
c                  iph  n  r
               read(words(2),20,err=900)  iph
               call phstop(iph,line)
               call warnex(' OVERLAP:')
               mode = 2
               iovrlp = iovrlp +1
            elseif (itok .eq. 4)  then
c              CONTROL  mphase, mpath, mfeff, mchi
c               0 - do not run modules, 1 - run module
               if (nwords.eq.5) then
c                 feff7 input file
                  read(words(2),20,err=900)  mpot
                  mphase = mpot
                  mfms = mpot
                  read(words(3),20,err=900)  mpath
                  read(words(4),20,err=900)  mfeff
                  read(words(5),20,err=900)  mchi
               else
c                 feff8 input file
                  read(words(2),20,err=900)  mpot
                  read(words(3),20,err=900)  mphase
                  read(words(4),20,err=900)  mfms
                  read(words(5),20,err=900)  mpath
                  read(words(6),20,err=900)  mfeff
                  read(words(7),20,err=900)  mchi
               endif
               mode = 0
            elseif (itok .eq. 5)  then
c              EXCHANGE  ixc  vr0  vi0 (ixc0)
c              ixc=0  Hedin-Lunqvist + const real & imag part
c              ixc=1  Dirac-Hara + const real & imag part
c              ixc=2  ground state + const real & imag part
c              ixc=3  Dirac-Hara + HL imag part + const real & imag part
c              ixc=5  partially nonlocal: Dirac-Fock for core + HL for
c                     valence electrons, + const real & imag part
c              ixc=10 same as ixc=0 with broadened plasmon HL selfenergy
c              ixc=13 same as ixc=3 with broadened plasmon HL selfenergy
c              ixc=15 same as ixc=5 with broadened plasmon HL selfenergy
c              vr0 is const imag part of potential
c              vi0 is const imag part of potential
c              Default is HL. (ixc=0, vr0=0, vi0=0, ixc0 = 2)
               vr0=0.0
               vi0=0.0
               read(words(2),20,err=900)  ixc
!              if (nwords.ge.3) (read(words(3),30,err=900)  vr0
                read(words(3),30,err=900)  vr0
!              if (nwords.ge.4) read(words(4),30,err=900)  vi0
                read(words(4),30,err=900)  vi0
               if (nwords .gt. 4) read(words(5),20,err=900)  ixc0
               if (ixc .ge. 3)  call warnex(' EXCHANGE >= 3:')
               mode = 0
            elseif (itok .eq. 6)  then
c              ION  iph xion(iph)
               read(words(2),20,err=900)  iph
               call phstop(iph,line)
               read(words(3),30,err=900)  xion(iph)
               call warnex(' ION:')
               mode = 0
            elseif (itok .eq. 7)  then
c              TITLE title...
               ntitle = ntitle + 1
               if (ntitle .le. nheadx)  then
                  title(ntitle) = line(6:)
                  call triml (title(ntitle))
               else
                  call wlog(' Too many title lines, title ignored')
                  call wlog(' ' // line(1:71))
               endif
               mode = 0
            elseif (itok .eq. 8)  then
c              FOLP iph folp (overlap factor, default 1)
               ifolp = 1
               read(words(2),20,err=900)  iph
               call phstop(iph,line)
               read(words(3),30,err=900)  folp(iph)
               call warnex(' FOLP:')
               mode = 0
            elseif (itok .eq. 9)  then
c              RPATH rmax (max r for ss and pathfinder)
               read(words(2),30,err=900)  rmax
            elseif (itok .eq. 10)  then
c              DEBYE  temp debye-temp ( idwopt )
c                   temps in kelvin
c                   idwopt = 0 use CD model
c                   idwopt = 1 use EM method
c                   idwopt = 2 use RM method
c                   idwopt = -1,-2,... don't calculate DW factors
c                   These add to any sig2 from SIG2 card or files.dat
               read(words(2),30,err=900)  tk
               read(words(3),30,err=900)  thetad
               idwopt=0 
               if (nwords.gt.3) then
                 read(words(4),20,err=900)  idwopt
                 if (idwopt.gt.2) then
                    write(slog,'(a,i5,2x,a)')
     1                 ' Option idwopt=',idwopt,'is not available.'
                    call wlog(slog)
                    write(slog,'(a)')
     1                   '...setting idwopt=2 to use RM.' 
                    call wlog(slog)
                 endif
               endif
               mode = 0
            elseif (itok .eq. 11)  then
c              RMULTIPLIER  rmult
c              Multiples atom coord, rss, overlap and rmax distances by
c              rmult (default 1).  DOES NOT modify sig2g
               read(words(2),30,err=900)  rmult
               mode = 0
            elseif (itok .eq. 12)  then
c              SS index ipot deg rss
               nss = nss + 1
               if (nss .gt. nssx)  then
                  write(slog,'(a,i8)')
     1               ' Too many ss paths requested, max is ', nssx
                  call wlog(slog)
                  call par_stop('RDINP')
               endif
               read(words(2),20,err=900)  indss(nss)
               read(words(3),20,err=900)  iphss(nss)
               read(words(4),30,err=900)  degss(nss)
               read(words(5),30,err=900)  rss(nss)
               mode = 0
            elseif (itok .eq. 13)  then
c              PRINT  ipr1  ipr2  ipr3  ipr4 ipr5 ipr6
c              print flags for various modules
c              ipr1 potph  0 pot.pad only
c                          1 add misc.dat
c                          2 add pot.dat
c                          5 add atom.dat
c                          6 add central atom dirac stuff
c                          7 stop after doing central atom dirac stuff
c              ipr2 xsph   0 phase.pad only
c                          2 add  phase.dat
c                          3 add  emesh.dat
c              ipr3 fmstot  currently is dummy
c              ipr4 pathfinder  0 paths.dat only
c                               1 add crit.dat
c                               2 keep geom.dat
c                               3 add fbeta files
c                               5 special magic code, crit&geom only
c                                 not paths.dat.  Use for path studies
c              ipr5 genfmt 0 files.dat, feff.dats that pass 2/3 of
c                            curved wave importance ratio
c                          1 keep all feff.dats
c              ipr6 ff2chi 0 chi.dat
c                          1 add sig2.dat with debye waller factors
c                          2 add chipnnnn.dat for each path
c                          3 add feffnnnn.dat for each path, and
c                            do not add chipnnnn.dat for each path
c                          4 add both feffnnnn.dat and chipnnnn.dat
c                            for each path
               if (nwords.eq.5) then
c                 feff7 input file
                  read(words(2),20,err=900)  ipr1
                  ipr2 = ipr1
                  ipr3 = ipr1
                  read(words(3),20,err=900)  ipr4
                  read(words(4),20,err=900)  ipr5
                  read(words(5),20,err=900)  ipr6
               else
c                 feff8 input file
                  read(words(2),20,err=900)  ipr1
                  read(words(3),20,err=900)  ipr2
                  read(words(4),20,err=900)  ipr3
                  read(words(5),20,err=900)  ipr4
                  read(words(6),20,err=900)  ipr5
                  read(words(7),20,err=900)  ipr6
               endif
               mode = 0
            elseif (itok .eq. 14)  then
c              POTENTIALS
c              Following lines are unique potential defs, 1 per line
               mode = 3
            elseif (itok .eq. 15)  then
c              NLEG nlegmax (for pathfinder)
               read(words(2),20,err=900)  nlegxx
               mode = 0
            elseif (itok .eq. 16)  then
c              CRIT critcw critpw
               read(words(2),30,err=900)  critcw
               read(words(3),30,err=900)  critpw
               mode = 0
            elseif (itok .eq. 17)  then
c              NOGEOM (do not write geom.dat) (disabled)
               nogeom = .true.
               mode = 0
            elseif (itok .eq. 18)  then
c              IORDER  iorder (used in genfmt, see setlam for meaning)
               read(words(2),20,err=900)  iorder
               call warnex(' IORDER:')
               mode = 0
            elseif (itok .eq. 19)  then
c              PCRIT  pcritk pcrith
c                     (keep and heap criteria for pathfinder)
               read(words(2),30,err=900)  pcritk
               read(words(3),30,err=900)  pcrith
               mode = 0
            elseif (itok .eq. 20)  then
c              SIG2  sig2g   global sig2 used by ff2chi, summed with
c              correlated debye model if DEBYE card used, and with
c              sig2 from files.dat if non-zero.
c              Units are Ang**2
               read(words(2),30,err=900)  sig2g
               mode = 0
            elseif (itok .eq. 21)  then
c              XANES ( xkmax  xkstep vixan)
               slog='XANES is not available in this version of feff8.5'
               call wlog(slog)
               call wlog("Ignoring XANES")
            elseif (itok .eq. 22)  then
c              CORRECTIONS  e0-shift, lambda correction
c              e0 shift is in eV, edge will be edge-e0
c              lambda corr is a const imag energy in eV
c              e0 and lambda corr same as vr0 and vi0 in EXCH card
               read(words(2),30,err=900)  vrcorr
               read(words(3),30,err=900)  vicorr
               mode = 0
            elseif (itok .eq. 23)  then
c              AFOLP use generalized automatic folp
               folpx = 1.15
               if (nwords.ge.2) read(words(2),30,err=900)  folpx
               mode =0
            elseif (itok .eq. 24)  then
c              EXAFS  xkmax for energy grid
               read(words(2),30,err=900)  xkmax
               mode = 0
            elseif (itok .eq. 25)  then
c              POLARIZATION  X Y Z
               ipol = 1
c              run linear polarization code 
               read(words(2),30,err=900)  evec(1)
               read(words(3),30,err=900)  evec(2)
               read(words(4),30,err=900)  evec(3)
               mode = 0
            elseif (itok .eq. 26)  then
c              ELLIPTICITY  E incident direction
               read(words(2),30,err=900)  elpty
               read(words(3),30,err=900)  xivec(1)
               read(words(4),30,err=900)  xivec(2)
               read(words(5),30,err=900)  xivec(3)
               mode = 0
            elseif (itok .eq. 27)  then
c              RGRID  rgrd
c              rgrd will be dpas, default is 0.03 in feff7
               read(words(2),30,err=900)  rgrd
               call warnex(' RGRID:')
               write(slog,'(a,1pe13.5)') ' RGRID, rgrd; ', rgrd
               call wlog(slog)
               i = 1 + int (12.5d0 / rgrd)
               if (mod(i,2) .eq. 0) i = i + 1
               if (i.gt.nrptx) then
                 write(slog,'(a,i6)') 
     1           ' FATAL error in RGRID: increase in dim.h nrptx to', i
                 call wlog(slog)
                 call par_stop(' ')
               endif
               mode = 0
            elseif (itok .eq. 28)  then
c              RPHASES (real phase shifts only)
               call warnex(' RPHASES:')
               call wlog(' Real phase shifts only will be used.  ' //
     1                   'FEFF results will be unreliable.')
               lreal = 2
               mode = 0
            elseif (itok .eq. 29)  then
c              NSTAR, write out n* for colinear polarization
               wnstar = .true.
               mode = 0
            elseif (itok .eq. 30)  then
c              NOHOLE
               if (nohole.lt.0) then
                  nohole = 0
                  if (nwords.ge.2) read(words(2),20,err=900)  nohole
                  call warnex(' NOHOLE:')
               end if
            elseif (itok .eq. 31)  then
c              SIG3 alphat  thetae   first and third cumulants for ss paths
               read(words(2),30,err=900)  alphat
               if (nwords.ge.3) read(words(3),20,err=900)  thetae
               call warnex(' SIG3:')
               write(slog,'(a,1pe13.5)') ' SIG3, alphat ; ', alphat
               call wlog(slog)
               mode = 0
            elseif (itok .eq. 32)  then
c              JUMPRM remove potential jumps at muffin tin radii
               jumprm = 1
            elseif (itok .eq. 33)  then
c              MBCONV do many body convolution with excitation spectrum
               mbconv = 1
            elseif (itok .eq. 34)  then
c              SPIN  specifies spin direction on central atom 
               read(words(2),20,err=900)  ispin 
c              set default spin along z axis
               if (ispin.ne.0) spvec(3) = 1.d0
               if (nwords.gt.2) read(words(3),30,err=900)  spvec(1)
               if (nwords.gt.3) read(words(4),30,err=900)  spvec(2)
               if (nwords.gt.4) read(words(5),30,err=900)  spvec(3)
            elseif (itok .eq. 35)  then
c              EDGE     L3 
c                   holecode
               call setedg (words(2), ihole)
               mode = 0
            elseif (itok .eq. 36)  then
c              SCF    rfms [ lfms nscmt  ca1 nmix  ecv icoul]
c              number of cycles, mode of calculating coulomb potential,
c              convergence accelerator
               nscmt = nbr
               ca1 = 0.2d0
               read(words(2),30,err=900)  rfms1
               if (nwords.gt.2) read(words(3),20,err=900)  lfms1
               if (nwords.gt.3) read(words(4),20,err=900)  nscmt
               if (nwords.gt.4) read(words(5),30,err=900)  ca1
               if (nwords.gt.5) read(words(6),20,err=900)  nmix
               if (nwords.gt.6) read(words(7),30,err=900)  ecv
               if (nwords.gt.7) read(words(8),20,err=900)  icoul
               if (nscmt.le.0 .or. nscmt.gt.nbr) nscmt = nbr
               if (lfms1.gt.0) lfms1 = 1
c              sanity checks for ca1
               if (ca1.lt.0) ca1 =0
               if (ca1.gt.0.5) then
                 call wlog(' Reduce convergence factors in SCF ')
                 call par_stop
     .            (' Cannot run with specified ca1 in SCF card.')
               endif
               if (ecv.ge.0) ecv = -40.0
               if (nmix.le.0) nmix=1
               if (nmix.gt.30) nmix=30
            elseif (itok .eq. 37)  then
c              FMS   rfms2  (lfms2 minv toler1 toler2 rdirec)
c              radius of the cluster to do FMS
               slog="FMS is not available in this version of FEFF8.5"
               call wlog(slog)
               call wlog("Ignoring FMS")
            elseif (itok .eq. 38)  then
               slog="LDOS is not available in this version of FEFF8.5"
               call wlog(slog)
               call wlog("Ignoring LDOS")
            elseif (itok .eq. 39)  then
c              INTERSTITIAL  inters  totvol
c              inters = 1 local V_int (around central atom)
c              inters = 0 extended V_int (average over all atoms)
c              more obscure options described in manual
               read(words(2),20,err=900)  inters
               if (nwords.ge.3) read(words(3),30,err=900)  totvol
            elseif (itok .eq. 40) then
c              CFAV  iphabs nabs rclabs
               read(words(2),20,err=900)  iphabs
               read(words(3),20,err=900)  nabs
               read(words(4),30,err=900)  rclabs
               if (rclabs.lt.0.5) rclabs=big
               mode = 0
            elseif (itok .eq. 41) then
c              S02  s02
               read(words(2),30,err=900)  s02
               mode = 0
            elseif (itok .eq. 42)  then
               slog="XES is not available in this version of FEFF8.5"
               call wlog(slog)
               call wlog("Ignoring XES")
            elseif (itok .eq. 43)  then
               slog="DANES is not available in this version of FEFF8.5"
               call wlog(slog)
               call wlog("Ignoring DANES")
c              DANES ( xkmax  xkstep vixan)
            elseif (itok .eq. 44)  then
c              FPRIME  emin emax estep
               slog="FPRIME is not available in this version of FEFF8.5"
               call wlog(slog)
               call wlog("Ignoring FPRIME")
            elseif (itok .eq. 45)  then
c              RSIGMA  (real self energy only)
               call warnex(' RSIGMA :')
               call wlog(' Real self energy only will be used.  ' //
     1                   'FEFF results will be unreliable.')
               if (lreal.lt.1) lreal = 1
               mode = 0
            elseif (itok .eq. 46)  then
c              XNCD or XMCD
               slog="XMCD is not available in this version of FEFF8.5"
               call wlog(slog)
               call wlog("Ignoring XMCD")
            elseif (itok .eq. 47)  then
c              MULTIPOLES le2 (l2lp)
               read(words(2),20,err=900)  le2
               if (nwords.gt.2) read(words(3),20,err=900)  l2lp
               mode = 0
            elseif (itok .eq. 48)  then
c              UNFREEZEF   
               iunf = 1
               mode = 0
            elseif (itok .eq. 49)  then
c              TDLDA 
               slog="TDLDA is not available in this version of FEFF8.5"
               call wlog(slog)
               call wlog("Ignoring TDLDA")
            elseif (itok .eq. 50)  then
c              PMBSE 
               slog="PMBSE is not available in this version of FEFF8.5"
               call wlog(slog)
               call wlog("Ignoring PMBSE")
            elseif (itok .eq. 51)  then ! Added by Josh Kas
c              PLASMON
               if(nwords.gt.1) then
                  read(words(2),20,err=900) iPlsmn
               else
                  iPlsmn = 1
               end if
            elseif (itok .eq. 52)  then ! Added by Josh Kas
c              S02CONV
               mso2conv = 1
            elseif (itok .eq. 53)  then ! Added by Josh Kas
c              SELF (print out on shell self energy Sig(k(E),E) )
               ipse = 1
            elseif (itok .eq. 54)  then ! Added by Josh Kas
c              SFSE k0 (print out self energy Sig(k0,E) ) 
               ipsk = 1
               read(words(2),30,err=900)  wsigk
            elseif (itok .eq. 55) then ! Added by Josh Kas
c              RCONV (print running convolution with file cfname at energy cen)
c              RCONV cen cname
               read(words(2),30,err=900) cen
               cfname = words(3)(1:12)
            elseif (itok.eq.56) then  !KJ added this card 1-06
c               ELNES
               slog="ELNES is not available in this version of FEFF8.5"
               call wlog(slog)
               call wlog("Ignoring ELNES")
            elseif (itok.eq.57) then  !KJ added this card 1-06
c               EXELFS
               slog="EXELFS is not available in this version of FEFF8.5"
               call wlog(slog)
               call wlog("Ignoring EXELFS")
            elseif (itok .eq. 58) then !KJ added this card 1-06
c               MAGIC card
               slog="MAGIC is not available in this version of FEFF8.5"
               call wlog(slog)
               call wlog("Ignoring MAGIC")
            elseif (itok .eq. 59) then !KJ added this card 3-06
c               ABSOLUTE card
               slog="ABSOLUTE is not available in this" // 
     &                  "version of FEFF8.5"
               call wlog(slog)
               call wlog("Ignoring ABSOLUTE")
            elseif ( itok .eq. 60) then
c               EGRID card
               slog="EGRID is not available in this version of FEFF8.5"
               call wlog(slog)
               call wlog("Ignoring EGRID")
            elseif (itok .eq. -1)  then
c              END
               goto 220
            else
               write(slog,'(1x,a)') line(1:70)
               call wlog(slog)
               write(slog,'(1x,a)') words(1)
               call wlog(slog)
               write(slog,'(a,i8)') ' Token ', itok
               call wlog(slog)
               call wlog(' Keyword unrecognized.')
               call wlog(' See FEFF document -- some old features')
               call wlog(' are no longer available.')
               call par_stop('RDINP-2')
            endif
         elseif (mode .eq. 1)  then
            if (itok .ne. 0)  then
c              We're done reading atoms.
c              Change mode and process current card.
               mode = 0
               goto 210
            endif
            natt = natt+1
            if (natt.gt. nattx)  then
               write(slog,'(a,i8)') 'Too many atoms, max is ', nattx
               call wlog(slog)
               call par_stop('RDINP-3')
            endif
            read(words(1),30,err=900)  ratx(1,natt)
            read(words(2),30,err=900)  ratx(2,natt)
            read(words(3),30,err=900)  ratx(3,natt)
            read(words(4),20,err=900)  iphatx(natt)
            if (iatph(iphatx(natt)) .le. 0) iatph(iphatx(natt)) = natt
         elseif (mode .eq. 2)  then
            if (itok .ne. 0)  then
c              We're done reading these overlap instructions.
c              Change mode and process current card.
               mode = 0
               goto 210
            endif
            novr(iph) = novr(iph)+1
            iovr = novr(iph)
            if (iovr .gt. novrx)  then
               write(slog,'(a,i8)') 'Too many overlap shells, max is ',
     1                               novrx
               call wlog(slog)
               call par_stop('RDINP-5')
            endif
            read(words(1),20,err=900) iphovr(iovr,iph)
            read(words(2),20,err=900) nnovr(iovr,iph)
            read(words(3),30,err=900) rovr(iovr,iph)
         elseif (mode .eq. 3)  then
            if (itok .ne. 0)  then
c              We're done reading unique potential definitions
c              Change mode and process current card.
               mode = 0
               goto 210
            endif
            read(words(1),20,err=900)  iph
            if (iph .lt. 0  .or.  iph .gt. nphx)  then
               write(slog,'(a,i8)') 
     1             'Unique potentials must be between 0 and ',
     1             nphx
               call wlog(slog)
               write(slog,'(i8,a)') iph, ' not allowed'
               call wlog(slog)
               write(slog,'(1x,a)') line(1:71)
               call wlog(slog)
               call par_stop('RDINP')
            endif
            read(words(2),20,err=900)  iz(iph)
            if (iz(iph).lt. 6) then
               lmaxsc(iph) = 1
            elseif (iz(iph).lt.55) then
               lmaxsc(iph) = 2
            else
               lmaxsc(iph) = 3
            endif
c           No potential label if user didn't give us one
c           Default set above is potlbl=' '
            if (nwords .ge. 3)  potlbl(iph) = words(3)(1:6)
            if (nwords .ge. 4)  then
              read(words(4),20,err=900) ltmp
              if (ltmp.ge.1 .and. ltmp.le.lx) lmaxsc(iph) = ltmp
            endif
            lmaxph(iph) = 3
            if (iz(iph).lt.6) lmaxph(iph) = 2
            if (nwords .ge. 5)  then
              read(words(5),20,err=900) ltmp
              if (ltmp.ge.1 .and. ltmp.le.lx) lmaxph(iph) = ltmp
            endif
            if (nwords .ge. 6) then
              read(words(6),30,err=900) xnatph(iph)
              lxnat = 1
            endif
            if (nwords .ge. 7) then
              read(words(7),30,err=900) spinph(iph)
            endif
           elseif (mode.eq.4) then  !KJ 1-06 this mode added to read ELNES card
             if(icnt.eq.5) then
                 read(words(1),30,err=900) ebeam   ! read beam energy in keV
                 ebeam=ebeam * dble(1000)  ! convert to eV
                 read(words(2),20,err=1011) aver ! average over sample to beam orientation?
                 read(words(3),20,err=1011) cross ! calculate cross terms?
                 read(words(4),20,err=1011) relat ! use relativistic q-vector?
                 read(words(5),20,err=1012) iinput ! read xmu.dat or opconsKK.dat or ... ?   !KJ 5/6
                 read(words(6),20,err=1013) spcol !column that has spectrum
                 if (aver.eq.1) icnt=icnt-1 !skip the line for beam orientation
                 goto 1011
 1012            iinput=1                
 1013            spcol=4
                 if(iinput.eq.2) spcol=3
 1011          continue ! Josh - Should these 1011 be 900? !KJ No.  Optional input.
              elseif(icnt.eq.4) then
                 read(words(1),30,err=900) xivec(1)  ! read direction of incoming beam
                 read(words(2),30,err=900) xivec(2)  ! in arbitrary units
                 read(words(3),30,err=900) xivec(3)
                 xinorm=dsqrt(xivec(1)**2+xivec(2)**2+xivec(3)**2)
                 if (xinorm.gt.0.0) then
                    do i=1,3
                       xivec(i)=xivec(i)/xinorm    ! normalize this vector.
                    enddo
                 elseif(.not.(aver.eq.1)) then
                    call wlog('WARNING : beam direction unspecified
     1                  in orientation sensitive EELS calculation.
     2                  Please correct before running EELS module.')
                 endif
             elseif(icnt.eq.3) then
                 read(words(1),30,err=900) acoll  ! collection semiangle in mrad
                 read(words(2),30,err=900) aconv  ! convergence semiangle in mrad
                 acoll=acoll/dble(1000);aconv=aconv/dble(1000) ! convert from mrad to rad
             elseif(icnt.eq.2) then
                 read(words(1),20,err=900) nqr    ! specify q-mesh, radial parameter
                 read(words(2),20,err=900) nqf    ! specify q-mesh, angular parameter
                 if(nqr*nqf.eq.0) then
                    call wlog('WARNING : zero q-mesh points specified
     1               for EELS calculation.  Please correct before
     2               running EELS module.')
                 endif
           elseif(icnt.eq.1) then
                 read(words(1),30,err=900) thetax ! detector position in plane perpendicular to beam ; angle in mrad
                 read(words(2),30,err=900) thetay ! detector position in plane perpendicular to beam ; angle in mrad
                 mode=0  ! finished reading ELNES card
!! initialize evec to be nonzero and perpendicular to xivec
!               if(dabs(xivec(1)-xivec(2)).gt.0.0001.or.
!     1            dabs(xivec(2)-xivec(3)).gt.0.0001) then
!                     evec(1)=xivec(2)*xivec(1)-xivec(3)**2
!                     evec(2)=xivec(3)*xivec(2)-xivec(1)**2
!                     evec(3)=xivec(1)*xivec(3)-xivec(2)**2
!                 else
!                     evec(1)=xivec(2)
!                     evec(2)=dble(0)
!                     evec(3)=-xivec(2)
!                 endif
             endif
             icnt=icnt-1    ! now read the next line
         !KJ end my changes                            
         else
            write(slog,'(a,i8)') 'Mode unrecognized, mode ', mode
            call wlog(slog)
            call par_stop('RDINP-6')
         endif
      goto 200
  220 continue
c done reading input file, 
c#{mn
c call rdline with jinit=0 to clean up all input files
       jinit = 0
       call rdline(jinit,line)
c#mn}

c     Fix up defaults, error check limits, figure out free atoms, etc.



c !KJ added this check 1-06
      if(magic.eq.1.and.(eels.ne.1)) then
          call wlog('To use MAGIC card you must have ELNES card.')
          call wlog('Ignoring MAGIC card.')
          magic=0
        endif
c !KJ

c  !KJ another check for eels 1-06
      if((eels.eq.1).and.(aver.eq.1).and.(cross.eq.1)) then
          call wlog('WARNING : you have asked to calculate an
     1   orientation averaged spectrum, but you have also asked
     2   to calculate cross-terms.  Averaging kills the cross terms.
     3   Hence the program ignores your request and does not
     4   calculate cross terms.')
      endif
c  !KJ

c  !KJ  set up a variable needed for elnes 1-06
        if(eels.eq.1) then
          if(aver.eq.1) then
             ipstep=1
             ipmin=10
             ipmax=10
          else
            ipmin=1
            ipmax=9
            if(cross.eq.1) then
               ipstep=1
            else
               ipstep=4
            endif
          endif
        endif
c  !KJ


c     need smaller rgrid for nonlocal exchange
      if (ixc0.lt.0) ixc0 = 0
      if (mod(ixc,10).ge.5 .and. rgrd.gt.0.03) rgrd=0.03d0 
      if (mod(ixc0,10).ge.5 .and. rgrd.gt.0.03) rgrd=0.03d0 
c     must use linear polarization to use nstar
      if (wnstar)  then
         if (ipol.ne.1)  then
            call wlog(' Must have linear polarization to use NSTAR.')
            call wlog(' NSTAR will be turned off.')
            wnstar = .false.
         endif
      endif

c     Do not use ihole .le. 0
      if (ihole .le. 0)  then
         call wlog(' Use NOHOLE to calculate without core hole.')
         call wlog(' Only ihole greater than zero are allowed.')
         call par_stop('RDINP')
      endif

c     Find out how many unique potentials we have
c     in POTENTIAL card
      nph = 0
      do 300  iph = nphx, 0, -1
         if (iz(iph) .gt. 0)  then
            nph = iph
            goto 301
         endif
  300 continue
  301 continue

c     cannot use OVERLAP and ATOMS cards together
      if (iatom .gt. 0 .and. iovrlp .gt. 0)  then
        call wlog(' Cannot use ATOMS and OVERLAP in the same feff.inp.')
        call par_stop('RDINP')
      endif

c     cannot use OVERLAP and CFAVERAGE   cards together
      if (novr(0) .gt. 0) then
c        OVERLAP is used, cannot do configuration average
         iphabs = 0
         nabs = 1
         rclabs = big
      endif

c     Must have central atom
      if (iz(0) .le. 0)  then
         if (iphabs .gt. 0) then
c           central atom is of the iphabs type
            iz(0) = iz(iphabs)
            potlbl(0) = potlbl(iphabs)
            lmaxsc(0) = lmaxsc(iphabs)
            lmaxph(0) = lmaxph(iphabs)
            xion(0) = xion(iphabs)
         else
            call wlog(' No absorbing atom (unique pot 0) was defined.')
            call par_stop('RDINP')
         endif
      endif

c     No gaps allowed in unique pots.  Make sure we have enough
c     to overlap all unique pots 0 to nph.
      if (iphabs.gt.0 .and. iatph(0).le.0)   iatph(0) = iatph(iphabs)
      do 340  iph = 0, nph
         if (iatph(iph) .le. 0  .and.  novr(iph) .le. 0)  then
c           No model atom, no overlap cards, can't do this unique pot
            write(slog,'(a,i8)') 
     1       ' No atoms or overlap cards for unique pot ', iph
            call wlog(slog)
            call wlog(' Cannot calculate potentials, etc.')
            call par_stop('RDINP-')
         endif
c        by default freeze f-electrons and reset lmaxsc=2
         if (iunf.eq.0 .and. lmaxsc(iph).gt.2) lmaxsc(iph)=2
  340 continue

c     Need number of atoms of each unique pot, count them.  If none,
c     set to one. Do statistics for all atoms in feff.inp.
      do 350  iph = 0, nph
        if (lxnat.eq.0) then 
          xnatph(iph) = 0
          do 346  iat = 1, natt
              if (iphatx(iat) .eq. iph)  xnatph(iph) = xnatph(iph)+1
  346     continue
          if (iph.gt.0 .and. iph.eq.iphabs) xnatph(iph) = xnatph(iph)-1
        else
          if (xnatph(iph).le. 0.01) then
            if (iph.eq.0) then
              xnatph(iph) = 0.01d0
            else
              write (slog,'(a,i4)') ' Inconsistency in POTENTIAL card'//
     1                              ' is detected for unique pot ', iph
              call wlog (slog)
              call wlog (' Results might be meaningless.')
            endif
          endif
        endif
        if (xnatph(iph) .le. 0)  xnatph(iph) = 1
  350 continue
      if (lxnat.ne.0) then
c        normalize statistics to hav one absorber
         do 351 iph = 1, nph
  351    xnatph(iph) = xnatph(iph) /xnatph(0)
         xnatph(0) = 1
      endif
      xnat = 0
      do 352 iph = 0,nph
  352 xnat = xnat + xnatph(iph)

c     Find distance to nearest and most distant atom (use overlap card
c     if no atoms specified.)
      if (natt .lt. 2)  then
         ratmin = rovr(1,0)
         ratmax = rovr(novr(0),0)
      else
         ratmax = 0
         ratmin = 1.0e10
         iatabs = iatph(0)
         icount = 0
         if (iatabs.le.0) iatabs = iatph( iphabs)
         if (iatabs.le.0) call par_stop('RDINP fatal error: iatabs=NaN')

         do 412  iat = 1, natt
           if (iphatx(iat) .eq. iphabs .or. iphatx(iat).eq.0)
     1        icount = icount +1
           if (iat.ne.iatabs) then
c           skip absorbing atom
            tmp = dist (ratx(1,iat), ratx(1,iatabs))
            if (tmp .gt. ratmax)  ratmax = tmp
            if (tmp .lt. ratmin)  ratmin = tmp
           endif
  412    continue
         if (nabs.le.0) nabs = icount
      endif

c     Set total volume
      if (totvol.gt.0) totvol = totvol * ratmin**3 * xnat

c     Set rfms if they are too small
      if (rfms1 .lt. ratmin) rfms1 = -1.e0
      if (rfms2 .lt. ratmin) rfms2 = -1.e0
      if (rfms2 .lt. ratmin .and. ispec.lt.2) ispec = - ispec 
      if (rfms2 .lt. ratmin .and. ispec.eq.3) ispec = - ispec 
c     if ispec.le.0 MS expansion will be used, else - FMS method.
      

c     Set rmax if necessary
      if (rmax.le.0 .and. nss.le.0 .and. ispec.le.0)  then
c        set to min (2+ times ratmin, ratmax) (magic numbers to
c        avoid roundoff, note that rmax is single precision).
         rmax = min (2.2 * real(ratmin), 1.01 * real(ratmax))
      endif

c     Set core hole lifetime (central atom quantity) and s02
      iph = 0
      call setgam (iz(iph), ihole, gamach)
      if (s02.eq.1.d0) s02=s02h

c     Convert everything to code units, and use rmult factor
c     rmax is for pathfinder, so leave it in Ang.
      rmax = rmax * real(rmult)
      rfms1 = rfms1 * real(rmult)
      rfms2 = rfms2 * rmult 
      totvol = totvol * rmult**3
c     Use rmult factor.  Leave distances in Ang.
      do 430  iat = 1, natt
         do 420  i = 1, 3
            ratx(i,iat) = ratx(i,iat) * rmult
  420    continue
  430 continue
      do 460  iph = 0, nph
         do 450  iovr = 1, novr(iph)
            rovr(iovr,iph) = rovr(iovr,iph) * rmult
  450    continue
  460 continue
      do 462  iss = 1, nss
c        rss used only to make paths.dat, so leave it in Angstroms.
         rss(iss) = rss(iss) * rmult
  462 continue

c     Clean up control flags
      if (mpot .ne. 0)  mpot = 1
      if (mphase .ne. 0)  mphase = 1
      if (mfms .ne. 0)  mfms = 1
      if (mpath  .ne. 0)  mpath = 1
      if (mfeff  .ne. 0)  mfeff = 1
      if (mchi   .ne. 0)  mchi = 1
      if (nss    .le. 0)  ms = 1
      if (ifolp  .ne. 0)  iafolp = -1
      if (natt.le.0) then
c       Overalp geometry
        mfms = 0
        mpath = 0
        ms = 0
c       no SCF loop
        nscmt = 0
        do 464 iph = 0, nph
          if (novr(iph).le.0) call par_stop('Bad OVERLAP cards.')
  464   continue
      endif

      if (iafolp .ge. 0) then
         do 485 i = 0, nphx
  485    folp(i) = folpx
      endif

      if (ntitle .le. 0)  then
         ntitle = 1
         title(1) = 'Null title'
      endif
      do 490  i = 1, ntitle
         ltit(i) = istrln (title(i))
  490 continue
      nttl = ntitle

c     write atoms.dat, global.inp, modN.inp and ldos.inp
c      call wrtall (nabs)
      call wrtjsn (nabs)

c     In case of OVERLAP and SS calculateions write 'paths.dat'
c     without invoking the pathfinder. Single scattering paths only.
      if (nss .gt. 0  .and.  mpath .eq. 1)  then
         open (unit=1, file='paths.dat', status='unknown', iostat=ios)
         call chopen (ios, 'paths.dat', 'rdinp')
         do 750  i = 1, ntitle
            write(1,748)  title(i)(1:ltit(i))
  748       format (1x, a)
  750    continue
         write(1,751)
  751    format (' Single scattering paths from ss lines cards',
     1           ' in feff input')
         write(1,706)
  706    format (1x, 71('-'))
         do 760  iss = 1, nss
            if (rmax.le.0  .or.  rss(iss).le.rmax)  then
c              NB, rmax and rss are in angstroms
               write(1,752) indss(iss), 2, degss(iss),
     2              rss(iss)
  752          format ( 2i4, f8.3,
     1             '  index,nleg,degeneracy,r=', f8.4)
               write(1,766)
  766          format (' single scattering')
               write(1,754) rss(iss), zero, zero, iphss(iss),
     1                      potlbl(iphss(iss))
               write(1,753) zero, zero, zero, 0, potlbl(0)
  753          format (3f12.6, i4,  1x, '''', a6, '''', '  x,y,z,ipot')
  754          format (3f12.6, i4,  1x, '''', a6, '''')
            endif
  760    continue
         close (unit=1)
      endif

      do 120  i = 1, ntitle
         call wlog(' ' // title(i)(1:ltit(i)))
  120 continue

c     if user does not want geom.dat, don't do it
      if (nogeom)  then
c        don't delete geom.dat when done with it either...
         if (ipr4 .lt. 2)  ipr4 = 2
         if (nabs.gt.1) call 
     1     par_stop('NOGEOM and CFAVERAGE are incompatible')
      else
c       temporarily call ffsort. here
        iabs = 1
c !KJ 1-06 : If the user does EELS and does not calculate cross terms for an
c       orientation sensitive calculation, FEFF mustn't change the
c       coordinate system, as this would lead to the appearance of
c       cross terms after all.  Therefore, I added an argument to the
c       calling sequence of ffsort.
c       To be precise, giving '.false.' disables the call of ffsort to mkptz.
c       Giving '.true.' makes ffsort work exactly as it always has.
        if((eels.eq.1)) then
           call ffsort(iabs,.false.)
        else
           call ffsort(iabs,.true.)
        endif   !KJ end my changes
       endif
       ceels=(eels.eq.1) !KJ 5-6 for monolithic version

      close(unit=11)
  400 call par_barrier
      call par_end

c     sub-program exchange
      stop
c     return

c     normal end of rdinp

  900 continue
      call wlog(' Error reading input, bad line follows:')
      write(slog,'(1x,a)') line(1:71)
      call wlog(slog)
      call par_stop('RDINP fatal error.')

      end

      subroutine phstop (iph,line)
      implicit double precision (a-h, o-z)
      character*(*) line
      include '../HEADERS/dim.h'
      character*512 slog
      if (iph .lt. 0  .or.  iph .gt. nphx)  then
         write(slog,10) iph, nphx, line
         call wlog(slog)
   10    format (' Unique potential index', i5, ' out of range.', 
     1           ' Must be between 0 and', i5, '.  Input line:', 
     2           1x, a)
         call par_stop('RDINP - PHSTOP')
      endif
      return
      end

      subroutine warnex (string)
      implicit double precision (a-h, o-z)
c     This prints a warning message if the user is using an
c     expert option.
      character*(*) string

      call wlog(string)
      call wlog(' Expert option, please read documentation ' //
     1          'carefully and check your results.')
      return
      end

      complex*16  function aprdec(ala,bla,lla)
c     the result of this function is the coefficient for the term of
c     power (l-1) for the product of two polynomes, whose coefficients
c     are in rows a and b
 
      implicit double precision (a-h, o-z)
      complex*16 ala (10)
      integer lla
      dimension bla(10)
 
      aprdec = (0.0d0, 0.0d0)
      do 11 m = 1, lla
 11      aprdec = aprdec + ala(m) * bla(lla+1-m)
      return
      end

      subroutine ffsort(iabs, natt, ratx, iphatx,
     1       nabs, iphabs, rclabs, ipol, ispin, le2,
     2       elpty, angks, evec, xivec, spvec, ptz,
     3       iatph)


c***********************************************************************
c input/output:
c      ratx:   atomic positions from feff.inp on input
c              shifted and sorted by distance on output
c      iphatx: unique potentials from feff.inp on input
c              sorted by distance on output
c
c input:
c      nabs:  absorber index
c      natt:  number of atoms in cluster
c      nabs:   \
c      iphabs:  } stuff related to CFAVERAGE, ignored
c      rclabs  /
c      ipol:   flag for polarization calculation
c      ispin:  flag for spin-dep calculation
c      le2:    something related to MULTIPOLE, ignored
c      elpty:  eccentricity of elliptical light
c      angks:  angle between beam and spin 
c      evec:   polarization vector
c      xivec:  ellipticipty vecotr
c      spvec:  spin vector
c
c output
c      ptz:    polarization tensor
c      iatph:  list of example atoms for each unique potential
c***********************************************************************

c removed doptz boolean, which seems to be used only for eels, which is
c outside the scope of feff85exafs

      implicit double precision (a-h, o-z)

c     finds iabs-th atom of 'iphabs' type in file atoms.dat and writes
c     a smaller list of all atoms within 'rclabs' of that particular
c     absorber into 'geom.dat' file.
c      first coded by a.l.ankudinov, 1998 for CFAVERAGE card
c      modified by a.l.ankudinov, march 2001 for new i/o structure

      include '../HEADERS/const.h'
      include '../HEADERS/dim.h'
      include '../HEADERS/vers.h'
      include '../HEADERS/parallel.h'

      integer nat, natt, ipol, ispin, le2, iabs, nabs, iphabs
      integer iatph(0:nphx), iphat(natx), iphatx(natx), index(natx)
      double precision rclabs, elpty, angks
      double precision rat(3,natx), ratx(3,natx)
      double precision evec(3), xivec(3), spvec(3)
      complex*16 ptz(-1:1, -1:1)

c     Local stuff
      parameter (big = 1.0d5)
      character*512 slog

      external dist

c      call json_read_atoms(natt, ratx, iphatx)

c      call json_read_global(nabs, iphabs, rclabs, ipol, ispin, le2,
c     1                      elpty, angks, evec, xivec, spvec, ptz)


c     Find the first absorber (iphabs type) in a long list (iabs.le.0),
c     or find iabs-th atom in the list of type iphabs (iabs.gt.0)
      iatabs = 0
      icount = 0
      ifound = 0
      do 305 iat = 1, natt
         if (iphatx(iat) .eq. 0) iphatx(iat) = iphabs
         if (iphatx(iat) .eq. iphabs) icount = icount +1
         if (ifound.eq.0 .and. icount.gt.0 .and. (icount.eq.iabs .or.
     1                          (iabs.le.0 .and. icount.eq.1))) then
            iatabs = iat
            ifound =1
         endif
  305 continue

c     Make several sanity checks
      if (iatabs.eq.0 .and. natt.gt.1) then
         call wlog(' No absorbing atom (unique pot 0 or iphabs in'//
     1             ' CFAVERAGE  card) was defined.')
         call par_stop('libpotph')
      endif
      if (iphabs.eq.0 .and. icount.gt.1) then
         call wlog(' More than one absorbing atom (potential 0)')
         call wlog(' Only one absorbing atom allowed')
         call par_stop('libpotph')
      endif
      if ((icount.gt.0 .and. icount.lt.nabs) .or. nabs.le.0) then
         nabs = icount
         call wlog(' Averaging over ALL atoms of iphabs type')
      endif

c     Make absorbing atom first in the short list
      if (iatabs .ne. 0) then
         rat(1,1) = 0
         rat(2,1) = 0
         rat(3,1) = 0
         iphat(1) = 0
         index(1) = iatabs
      endif
          
c     make a smaller list of atoms from a big one
      nat = 1
      do 309 iat = 1,natt
         if (iat.ne.iatabs) then
            tmp = dist (ratx(1,iat), ratx(1,iatabs))
            if (tmp.gt.0.1d0 .and. tmp.le.rclabs) then
               nat = nat + 1
               if (nat.gt.natx) then
                 write (slog, 307) nat, natx
  307            format (' Number of atoms', i6, 'exceeds max allowed',
     1           ' for the pathfinder =', i6)
                 call wlog (' Use or reduce rclabs in CFAVERAGE card')
                 call wlog (' Or increase parameter natx and recompile')
                 call par_stop('libpotph')
               endif
               rat(1,nat) = ratx(1,iat)-ratx(1,iatabs)
               rat(2,nat) = ratx(2,iat)-ratx(2,iatabs)
               rat(3,nat) = ratx(3,iat)-ratx(3,iatabs)
               iphat(nat) = iphatx(iat)
               index(nat) = iat
            endif
         endif
 309  continue
c     squelch a compiler warning
      i=1
c     sort atoms by distance
      do 315 iat = 1,nat-1
        r2min = rat(1,iat)**2 + rat(2,iat)**2 + rat(3,iat)**2
        imin = iat
        do 310 i = iat+1,nat
          r2 = rat(1,i)**2 + rat(2,i)**2 + rat(3,i)**2
          if (r2.lt.r2min) then
            r2min = r2
            imin = i
          endif
 310    continue
        if (imin.ne.iat) then
c         permute coordinates for atoms iat and imin
          do 311 i = 1,3
            r2 = rat(i,iat)
            rat(i,iat) = rat(i,imin)
            rat(i,imin) = r2
 311      continue
          i = iphat(iat)
          iphat(iat) = iphat(imin)
          iphat(imin) = i
          i = index(iat)
          index(iat) = index(imin)
          index(imin) = i
        endif
 315  enddo

c     rotate xyz frame for the most convinience and make
c     polarization tensor
c     make polarization tensor when z-axis is along k-vector 
      call mkptz(ipol, elpty, evec, xivec, ispin, spvec, nat, rat,
     1       angks, le2, ptz)

c     rewrite global.json for initial iteration to update 'ptz'
c      call json_global(nabs)


c     Find model atoms for unique pots that have them
c     Use atom closest to absorber for model
      do 316  iph = 1, nphx
 316  iatph(iph) = 0
c     By construction absorbing atom is first in the list
      iatph(0) = 1
c      nph = 0
      do 330  iph = 1, nphx
         rabs = big
         do 320  iat = 2, nat
            if (iph .eq. iphat(iat))  then
               tmp = dist (rat(1,iat), rat(1,1))
               if (tmp .lt. rabs)  then
c                 this is the closest so far
                  rabs = tmp
                  iatph(iph) = iat
               endif
            endif
  320    continue
c         if (iatph(iph).gt.0) nph = iph
  330 continue
c     if iatph > 0, a model atom has been found.

c     Check if 2 atoms are closer together than 1.75 bohr (~.93 Ang)
      ratmin = 1.0d20
      do 480  iat = 1, nat
         do 470  jat = iat+1, nat
            rtmp = dist(rat(1,iat),rat(1,jat))
            if (rtmp .lt. ratmin)  ratmin = rtmp
            if (rtmp .lt. 1.75d0 * bohr)  then
               call wlog(' WARNING:  TWO ATOMS VERY CLOSE TOGETHER.' //
     1                   '  CHECK INPUT.')
               iatx = index(iat)
               jatx = index(jat)
               write(slog,'(a,2i8)') ' atoms ', iatx, jatx
               call wlog(slog)
               write(slog,'(i5,1p,3e13.5)') iatx, (ratx(i,iatx),i=1,3)
               call wlog(slog)
               write(slog,'(i5,1p,3e13.5)') jatx, (ratx(i,jatx),i=1,3)
               call wlog(slog)
               call wlog(' Run continues in case you really meant it.')
            endif
  470    continue
  480 continue

c      call json_geom(iatph,rat,iphat)


c     transfer rat back to ratx and iphat back to iphatx
      do 1000 j=1,nat
         ratx(1,j) = rat(1,j)
         ratx(2,j) = rat(2,j)
         ratx(3,j) = rat(3,j)
         iphatx(j) = iphat(j)
 1000 continue

c     Atoms for the pathfinder
      if (iatabs .le. 0)  then
         call wlog(' Absorbing atom coords not specified.')
         call wlog(' Cannot find multiple scattering paths.')
         call par_stop('libpotph')
      endif

c 400 call par_barrier

      return
      end

      subroutine fixdsp (dxorg, dxnew, dgc0, dpc0, dgcx, dpcx, jnew)

c     This fixes up the dirac spinor components (dgc and dpc) from ATOM
c     for the xsect code.

      implicit double precision (a-h, o-z)

      include '../HEADERS/dim.h'
      include '../HEADERS/const.h'

      dimension dgc0(251), dpc0(251)
      dimension dgcx(nrptx), dpcx(nrptx)

      dimension xorg(nrptx), xnew(nrptx)

      parameter (xx00 = 8.8d0)

c     statement functions to do indexing.  delta is 'dx' for current
c     grid.  jjj is index of grid point immediately before 'r'
      xxx(j) = -xx00 + (j-1)*delta
      rrr(j) = exp (-xx00 + (j-1)*delta)
      jjj(r) = int((log(r) + xx00) / delta) + 1

c     Use linear interpolation in x whether necessary or not.  If
c     new grid is same as old, it shouldn't make any difference.

c     relation between x, r, and j.  xx00 = 8.8 for all grids
c     in this version, change it if more flexibility is necessary.
c     xx = -xx00 + (j-1)*delta
c     rr = exp (xx)
c     jj = (log(r) + xx00) / delta + 1; this is j immediately BELOW r

c     The dgc and dpc arrays are zero beyond a certain point, usually
c     inside the muffin tin radius.  Find this distance.
      imax = 0
      do 100  i = 251, 1, -1
         if ( abs(dgc0(i)) .ge. 1.0d-11 .or. 
     1        abs(dpc0(i)) .ge. 1.0d-11 )  then
            imax = i
            goto 16
         endif
  100 continue
      call wlog(' Should never see this line from sub fixdsp')
   16 continue
c     jmax is the first point where both dpc and dgc are zero in
c     the original grid
      jmax = min(imax, 250) + 1

      delta = dxorg
      do 10  j = 1, jmax
         xorg(j) = xxx(j)
   10 continue
      rmax = rrr(jmax)

c     How far out do we go in the new grid?  To the last new grid
c     point before jmax.  Everything will be zero beyond jmax.
      delta = dxnew
      jnew = jjj(rmax)
      do 20  j = 1, jnew
         xnew(j) = xxx(j)
   20 continue

c     interpolate to new grid using x, only inside of rmax
      do 30  j = 1, jnew
         call terp (xorg, dgc0,  jmax, 3, xnew(j), dgcx(j))
         call terp (xorg, dpc0,  jmax, 3, xnew(j), dpcx(j))
   30 continue

c     and zero the arrays past rmax
      do 32  j = jnew+1, nrptx
         dgcx(j) = zero
         dpcx(j) = zero
   32 continue

      return
      end

      subroutine sigte3 (iz1,iz2, sig2, alphat, thetad, reff, sig1,sig3)
c     single scattering only.

c     input: sig2
c     iz1, iz2 are iz at central atom and neighbor
c     alphat coeef of thermal expansion at high T
c     reff

c     output: sig1 sig3
      implicit double precision (a-h, o-z)
      real reff

c     con=hbar**2/(kB*amu)*10**20   in ang**2 units
c     hbar, amu, kb updated 2017
      parameter (hbar = 1.054571800d-34)
      parameter (amu = 1.660539040d-27)
      parameter (xkb = 1.38064852d-23)
      parameter (con = 48.50875019927435d0)

      ami=atwtd(iz1)*amu
      amj=atwtd(iz2)*amu

c     reduced mass
      xmu = 1 / (1/ami + 1/amj)
c     Einstein frequency
      omega = (2 * xkb * thetad) / (3 * hbar)
      xks = xmu * omega**2
      xk3 = xks**2 * reff * alphat / (3 * xkb)
      sig02 = hbar * omega / xks
      sig1 = -3 * (xk3 / xks) * sig2
      sig3 = 2 - (4.0/3.0) * (sig02 / sig2)**2
      sig3 = sig3 * (sig1 * sig2)

      return
      end

      subroutine fmtrxi (lam1x, lam2x, ie, ileg, ilegp,
     &       clmi, mlam, nlam, xnlm, dri,
     &       ph, eta, lmax, ipot, fmati)
      implicit double precision (a-h, o-z)

c     inputs:
c       lam1x, lam2x:  limits on lambda and lambda'
c       ie:  energy grid points
c       ileg, ilegp: leg and leg'
c       phases, use ph(ie,...,ilegp), and lmax(ie,ilegp)
c       lambda arrays
c       rotation matrix for ilegp
c       clmz for ileg and ilegp
c       path data, eta(ilegp) and ipot(ilegp)
c       xnlm array
c
c     Output:  fmati(...,ilegp) is set for current energy point.

c     calculate scattering amplitude matrices
c     f(lam,lam') = sum_l tl gam(l,m,n)dri(l,m,m',ileg)gamt(l,m',n')
c                 *cexp(-i*m*eta),  eta = gamma+alpha'
c     lam lt lam1x, lam' lt lam2x such that m(lam) lt l0, n(lam) lt l0
c     gam = (-)**m c_l,n+m*xnlm, gamt = (2l+1)*c_ln/xnlm,
c     gamtl = gamt*tl

      include '../HEADERS/const.h'
      include '../HEADERS/dim.h'

c+----------------------------------------------------------------------
c     removing local common blocks, replacing them with explicit passing
c     of the defined data srtuctures
c+----------------------------------------------------------------------
c     include 'lambda.h'
      integer mlam(lamtot), nlam(lamtot)
c     include 'clmz.h'
      complex*16 clmi(ltot+1,mtot+ntot+1,legtot)
c     include 'fmatrx.h'
      complex*16 fmati(lamtot,lamtot,legtot)
c     include 'nlm.h'
      dimension xnlm(ltot+1,mtot+1)
c     include 'rotmat.h'
      dimension dri(ltot+1,2*mtot+1,2*mtot+1,legtot+1)
c     include 'pdata.h'
      complex*16 ph(nex,-ltot:ltot,0:nphx)
      double precision eta(0:legtot+1)
      integer lmax(nex,0:nphx), ipot(0:legtot)

      complex*16 cam, camt, cterm, tltl
      complex*16 gam(ltot+1,mtot+1,ntot+1),
     1           gamtl(ltot+1,mtot+1,ntot+1), tl

c     calculate factors gam and gamtl
      iln = 1
      ilx = lmax(ie,ipot(ilegp)) + 1
      do 30  il = iln, ilx
         ll = il - 1
c        do j-average t-matrix
         tl = (exp(2*coni*ph(ie,-ll,ipot(ilegp))) - 1) / (2*coni)
         tltl = (exp(2*coni*ph(ie,ll,ipot(ilegp))) - 1) / (2*coni)
         tltl = tl * (ll+1) + tltl * ll
         lam12x = max (lam1x, lam2x)
         do 20  lam = 1, lam12x
            m = mlam(lam)
            if (m .lt. 0)  goto 20
            im = m+1
            if (im .gt. il)  goto 20
            in = nlam(lam) + 1
            imn = in + m
            if (lam .gt. lam1x)  goto 10
            cam = xnlm(il,im) * (-1)**m
            if (imn .le. il)  gam(il,im,in) = cam * clmi(il,imn,ileg)
            if (imn .gt. il)  gam(il,im,in) = 0
   10       if (lam .gt. lam2x) goto 20
            camt = tltl / xnlm(il,im)
            gamtl(il,im,in) = camt * clmi(il,in,ilegp)
   20    continue
   30 continue

      do 60 lam1 = 1,lam1x
         m1 = mlam(lam1)
         in1 = nlam(lam1) + 1
         iam1 = abs(m1) + 1
         do 60  lam2 = 1, lam2x
            m2 = mlam(lam2)
            in2 = nlam(lam2) + 1
            iam2 = iabs(m2) + 1
            imn1 = iam1 + in1 - 1
            cterm = 0
            ilmin = max (iam1, iam2, imn1, in2, iln)
            do 40  il = ilmin, ilx
c              skip terms with mu > l (NB il=l+1, so mu=il is mu>l)
               if (abs(m1).ge.il .or. abs(m2).ge.il)  goto 40
               m1d = m1 + mtot+1
               m2d = m2 + mtot+1

               cterm = cterm + gam(il,iam1,in1)*gamtl(il,iam2,in2)
     1                         *dri(il,m1d,m2d,ilegp)

   40       continue
            if (eta(ileg) .ne. 0.0) then
               m1 = mlam(lam1)
               cterm = cterm * exp(-coni*eta(ileg)*m1)
            endif
c           Above was org coding, change to use eta(ilegp) as test
c           based on algebra check.  July 20, 1992, siz&jjr
c           Changed back with redifinition of eta(see rdpath.f)
c           which is more convinient in polarization case.
c           August 8,1993, ala.
c           if (eta(ilegp) .ne. 0.0) then
c              m1 = mlam(lam1)
c              cterm = cterm * exp(-coni*eta(ilegp)*m1)
c           endif
            fmati(lam1,lam2,ilegp) = cterm
   60 continue

c     test of fmati(lam,lam',ileg)
c     plot fmat(lam,lam') = csqrt((z/2)**(m1-m2))*fmat

      return
      end

      SUBROUTINE CSigma(Energy, Mu, Rs, ReSig, ImSig, WpScl,!
     &     AmpFac)
c      SUBROUTINE CSigma(Energy, Mu, Rs, ReSig, ImSig, WpScl, Gamma,
c     &     AmpFac)
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     Written by Josh Kas
c     This subroutine calculates the self energy Sigma(k(Energy),Energy)
c     based on an electron gas model of epsilon^-1.
c      
c     Solve: k0**2 = 2*Energy - 2*Mu -
c                    2*(Sigma(k0,Energy)-Sigma(kFermi,EFermi))
c            
c     Steps:
c
c            1. k0**2  = 2*(Energy-Mu) + SigmaF (SigmaF is self energy at fermi level).
c            2. Sigma0 = Sigma(k0,Energy)
c            3. k1**2  = 
c                  k0**2 - 2*(Sigma0-SigmaF)
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      include '../HEADERS/const.h'
c     Parameters:
c     MxPole - Maximum number of poles      
      INTEGER MxPole
      PARAMETER(MxPole=1000)
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     Input:
c     Energy - Energy at which to evaluate Sigma
c     Mu     - Fermi energy as calculated by FEFF
c     Rs     - R sub s (sphere of radius Rs holds charge e)
c     WpScl  - Scale Wp in interstitial by WpScl
c     Gamma  - Use broadening Gamma when calculating Sigma
c     AmpFac - Use amplitude AmpFac for plasmon pole.
c     Note: Atomic units are used.
      DOUBLE PRECISION Rs, WpScl(MxPole), AmpFac(MxPole), Mu
c      DOUBLE PRECISION Gamma(MxPole)
      COMPLEX*16 Energy
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     Output:
c     ReSig  - Re[Sigma(Energy,k(Energy))]
c     ImSig  - Im[Sigma(Energy,k(Energy))]
      DOUBLE PRECISION ReSig, ImSig
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     Local Variables:
c     kFermi - Fermi momentum calculated from Rs via electron gas
c              approximation.
c     EFermi - Fermi energy = kFermi^2/2
c     Wp     - Electron gas plasmon frequency.
c     Gam    - broadening for broadened pole.
c     ckF    - complex variable to store kFermi
c     ck0    - complex momentum
c     SigmaF - Self energy at the fermi energy and fermi momentum
c              Does not include the Hartree Fock part.
c     Sigma0 - Single pole self energy evaluated at
c              Wp = Wp(ipole)/Wp(R_Interstitial)*Wp(Rs)
c     dSgdE  - Derivative of sigma w.r.t. Energy
c     ZTot   - Renormalization factor Z = 1/(1-dSgdE)
c     RelEn  - Energy relative to the fermi energy from FEFF      
c              Relen = Energy - Mu + EFermi
c     SigTot - Total many pole deltaSigma = Sigma(E,k(E))-Sigma(EF,kF)
c     DelHF  - Sigma_HartreeFock(k) - Sigma_HartreeFock(kF)      
      DOUBLE PRECISION kFermi, EFermi, Wp, Gam
      COMPLEX*16 ckF, ck0, SigmaF, Sigma0,
     &     RelEn, SigTot, DelHF
      INTEGER i1, i2

c     Parameters:
      DOUBLE PRECISION DPZero, h
      PARAMETER(DPZero = 0.d0, h = 1.d-3)
      INTEGER MxIter

      PARAMETER(MxIter = 1)

c     Externals:
      COMPLEX*16 Sigma1, dSigma, HFExc
      EXTERNAL Sigma1, dSigma, HFExc
      
c     Initialization
      kFermi = fa/Rs
      EFermi = kFermi*kFermi/2.d0
      SigTot=0.d0
      SigmaF = 0.d0 
      Gam = 0.d0
      ckF = 0.d0

c     Loop1: Start self consistency loop.
      DO i2 = 1, MxIter
c        Loop2: Loop over poles to find SigmaF
         DO i1 = 1, MxPole
            IF(WpScl(i1).lt.-1000.d0) GOTO 5
            
c           Wp is in Hartrees
            Wp = SQRT(3.d0/rs**3)*WpScl(i1)
            
c           find Sigma_Fermi (SigmaF)
            ckF = kFermi*1.00001d0
            RelEn = EFermi
            SigmaF = SigmaF + Sigma1(ckF,RelEn,Wp,Gam,AmpFac(i1),
     &           kFermi,EFermi)
         END DO
 5       CONTINUE
         
c        Loop3: Loop over poles
         DO i1 = 1, MxPole
            IF(WpScl(i1).lt.-1000.d0) GOTO 10
c           Wp is in Hartrees
            Wp = SQRT(3.d0/rs**3)*WpScl(i1)

c           Start with ck0=Sqrt[Re(Energy)-Mu+EFermi]
            RelEn = DBLE(Energy) - Mu + EFermi
            ck0 = SQRT(2.d0*DBLE(RelEn))
            
c           Find Sigma0
            Sigma0 = Sigma1(ck0,RelEn,Wp,Gam,AmpFac(i1),kFermi,
     &           EFermi)
            
            SigTot = SigTot + Sigma0
            
c        End loop over poles.            
         END DO
 10      CONTINUE
         
c     End self-consistency loop
      END DO

c     Form delta sigma and retur.n
      SigTot = SigTot - SigmaF
      DelHF = HFExc(ck0,EFermi,kFermi) - HFExc(ckF,EFermi,kFermi)
      SigTot = SigTot + DelHF
      
      ReSig = DBLE(SigTot)
      ImSig = DIMAG(SigTot)
      
      RETURN
      END

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      FUNCTION Sigma1(ck,Energy,Wi,Gamma,Amp,kFermi,EFermi)
c     Written by Josh Kas
c     Function Sigma calculates the energy dependent part
c     of Sigma(ck,Energy) from H.L. electron gas model.
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      include '../HEADERS/const.h'
c     Input:
c     ck     - complex momentum
c     Energy - Energy
c     Wi     - Plasmon pole energy
c     Gamma  - Broadening of plasmon pole.
c     Amp    - Amplitude of plasmon pole.
c     kFermi - Fermi momentum
c     EFermi - Fermi energy
c              This is used when calculating dSigma/dE
      DOUBLE PRECISION Wi, Gamma, Amp, kFermi, EFermi
      COMPLEX*16 ck, Energy
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     Output:
c     Sigma(ck,Energy)
      COMPLEX*16 Sigma1
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     Local Variables:
c     NSing  - Number of singularities of integrand (used in cgratr)
c     NCalls - Number of fcn calls used in cgratr
c     MaxNR  - Max number of regions used in cgratr
c     DPPar  - Array of double precision parameters passed to cgratr
c              to be used in the functions r1, r2, and r3
c     CPar   - Array of complex parameters passed to cgratr
c              to be used in the functions r1, r2, and r3
c     Limit1 - Lower limit of integration
c     Limit2 - Upper limit of integration
c     HLInt1 - Integral of r2 (first integral in eq. 13 of H.L.)
c     HLInt2 - Integral of r1 (second integral in eq. 13 of H.L.)
c     HLInt3 - Integral of r1 or r3 (3rd or 4th integral)
c     XSing  - Array of singularities of integrand (used by cgratr)      
      INTEGER NSing, NCalls, MaxNR
      DOUBLE PRECISION DPPar(10), Beta
      COMPLEX*16 CPar(10), Limit1, Limit2, HLInt1, HLInt2, HLInt3,
     &     XSing(20)
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     Loop variables:
      INTEGER i1, i2
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     Parameters:
c     ZeroPl - lower bound Limit1
c     Inf    - Upper bound of Limit2
c     AbsErr - absolute error used by cgratr
c     RelErr - Relative error used by cgratr
c     Error  - used for error codes by cgratr      
      DOUBLE PRECISION ZeroPl, Inf, AbsErr, RelErr, Error
      PARAMETER(ZeroPl = 1.d-5, Inf = 1.d2)
      PARAMETER(AbsErr = 1.d-5, RelErr = 1.d-4)
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     Externals:
c     Externals:
c     cgratr      - integration routine
c     dr1,dr2,dr3 - functions to integrate
c     HFExc       - Calculates Hartree Fock exchange      
      COMPLEX*16 cgratr, r1, r2, r3, HFExc
      EXTERNAL cgratr, r1, r2, r3, HFExc
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc      
c     Initialization:
      NSing  = 0
      NCalls = 0
      MaxNR  = 0
c     DPPar is array of dp parameters to evaluate functions in cgratr.
c     Everything is in dimensionless units.
c     1. xwg
      DPPar(1) = (Wi/EFermi)
c     2. xgam
      DPPar(2) = gamma/EFermi
c     3. xe
      DPPar(3) = DBLE(Energy)/EFermi
c     4. xeg (gap energy)
      DPPar(4) = 0.d0
c     CPar is array of complex parameters to evaluate functions in cgratr.
c     ck in dimensionless units.
      CPar(1) = ck/kFermi
c     2. ce (complex energy)
      CPar(2) = Energy/EFermi
      
c     Josh - This is a possible fix for functions that overlap zero by a large
c     amount so that Wp does not equal Wi. 
*      Beta = 1.d0*Gamma*SQRT(2.d0/(Wi**2+Gamma**2))
c      Beta  = 0.9d0*Gamma*Gamma/(Wi**2+Gamma**2)
c      Wp =  2.d0*Gamma*LOG(Gamma/Beta) + 2.d0*ATAN2(Wi,Gamma) -
c     &     Gamma*LOG(Gamma**2 + Wi**2)
c      Wp = SQRT(Wi*Wp)
      
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      DO i1 = 1, 1
         IF(i1.eq.2) THEN
            DPPar(1) = 0.d0
            DPPar(2) = 0.9d0*Gamma/EFermi
         END IF         
c     Calculate integrals in eq. 13 of H.L.
c     1)
c     Integral { ln[((ck+q)**2-E+Wq)/((ck-q)**2-E+Wq)] }
c     from ck + kFermi to Inf.
         Limit1 = ck/kFermi+1.d0
         Limit2 = Inf
      
c     Find singularities in r2
         iFcn = 2
         CALL FndSng(Limit1, Limit2, NSing, XSing, DPPar, CPar, iFcn)
      
c     Calculate integral
         HLInt1 = cgratr(r2,DPPar,CPar,Limit1,Limit2,AbsErr,RelErr,
     &        NSing, XSing,Error,NCalls,MaxNR)
         DO i2 = 1, NSing
            XSing(i2) = (1.d0,0)*XSing(i2)
         END DO

c     2)
c     Integral { ln[(kFermi**2-E-Wq)/(kFermi**2-E+Wq)*
c                     ((ck+q)**2-E+Wq)/((ck-q)**2-E-Wq)] }
c     From ck - kFermi to ck + kFermi
         Limit1 = MAX(ABS(DBLE(ck)/kFermi-1.d0), ZeroPl)
         Limit2 = ck/kFermi+1.d0

c     Find singularities in r1
         IFcn = 1
         CALL FndSng(Limit1, Limit2, NSing, XSing, DPPar, CPar, iFcn)

c     Calculate integral
         HLInt2 = cgratr(r1,DPPar,CPar,Limit1,Limit2,AbsErr,RelErr,
     &        NSing, XSing,Error,NCalls,MaxNR)
         DO i2 = 1, NSing
            XSing(i2) = (1.d0,0)*XSing(i2)
         END DO      
            
c     3)
c     Theta(kFermi-Re(ck)) *
c     Integral { ln[((ck+q)**2-E-Wq)/((ck-q)**2-E-Wq)] } +
c     Theta(Re(ck)-kFermi) *
c     Integral { ln[((ck+q)**2-E+Wq)/((ck-q)**2-E+Wq)] }
c     (Integrals from 0 to kFermi - k and 0 to k - kFermi)
         Limit1 = ZeroPl
         Limit2 = ABS(DBLE(ck)/kfermi-1.d0)

c     If ck = kFermi, HLInt3 = 0
         IF((ABS(DBLE(ck)-kFermi).lt.ZeroPl).or.
     &        (DBLE(Limit2).le.DBLE(Limit1))) THEN
            HLInt3 = 0.d0
c     If ck < kFermi, HLint3 = Integral { ln[((ck+q)**2-E-Wq)/((ck-q)**2-E-Wq)] }
         ELSEIF(DBLE(ck).lt.kFermi) THEN
            Limit2 = 1.d0 - DBLE(ck)/kFermi
            
c     Find singularities in r3
            iFcn = 3         
            CALL FndSng(Limit1, Limit2, NSing, XSing, DPPar, CPar, iFcn)
c     Calculate integral
            HLInt3 = cgratr(r3,DPPar,CPar,Limit1,Limit2,AbsErr,RelErr,
     &           NSing,XSing,Error,NCalls,MaxNR)
            DO i2 = 1, NSing
               XSing(i2) = (1.d0,0)*XSing(i2)
            END DO
         
c     Else ck > kFermi, HLint3 = Integral { ln[((ck+q)**2-E+Wq)/((ck-q)**2-E+Wq)] }
         ELSE
            Limit2 = DBLE(ck)/kFermi - 1.d0
            
c     Find singularities in r2
            iFcn = 2
            CALL FndSng(Limit1, Limit2, NSing, XSing, DPPar, CPar, iFcn)
            
c     Calculate integral
            HLInt3 = cgratr(r2,DPPar,CPar,Limit1,Limit2,AbsErr,RelErr,
     &           NSing,XSing,Error,NCalls,MaxNR)
            DO i2 = 1, NSing
               XSing(i2) = (1.d0,0)*XSing(i2)
            END DO
         END IF
                           
         IF(i1.eq.1) THEN
            Sigma1 = - Amp*Wi*(Wi-coni*Gamma)/(2.d0*pi*EFermi*ck)*
     &           (HLInt1 + HLInt2 + HLInt3)
         ELSE
            Sigma1 = Sigma1 - Amp*Beta*
     &           Wi*(coni*Gamma)/(pi*EFermi*ck)*
     &           (HLInt1 + HLInt2 + HLInt3)
         END IF
      END DO
      
      RETURN
      END

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      FUNCTION dSigma(ck,Energy,Wi,Gamma,Amp,kFermi,EFermi)
c     Written by Josh Kas
c     Function dSigma calculates dSigma(ck,Energy)/dE from H.L.
c     electron gas model.
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      include '../HEADERS/const.h'
c     Input:
c     ck     - complex momentum
c     Energy - Energy
c     Wi     - Plasmon pole energy
c     Gamma  - Broadening of plasmon pole.
c     Amp    - Amplitude of plasmon pole.
c     kFermi - Fermi momentum
c     EFermi - Fermi energy
c              This is used when calculating dSigma/dE
      DOUBLE PRECISION Wi, Gamma, Amp, kFermi, EFermi
      COMPLEX*16 ck, Energy
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     Output:
c     Sigma(ck,Energy)
      COMPLEX*16 dSigma
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     Local Variables:
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     Local Variables:
c     Wp     - Plasmon frequency, for broadened poles, Wp is not the
c              same as Wi.
c     Beta   - g_i for the negative weight pole at zero. 
c              Adding the negative weight pole at zero corrects the
c              diverging sum rule for epsilon^-1. This is irrelevant
c              for unbroadened poles.
c     NSing  - Number of singularities of integrand (used in cgratr)
c     NCalls - Number of fcn calls used in cgratr
c     MaxNR  - Max number of regions used in cgratr
c     DPPar  - Array of double precision parameters passed to cgratr
c              to be used in the functions r1, r2, and r3
c     CPar   - Array of complex parameters passed to cgratr
c              to be used in the functions r1, r2, and r3
c     Limit1 - Lower limit of integration
c     Limit2 - Upper limit of integration
c     HLInt1 - Integral of dr2 (derivative of first integral in eq. 13 of H.L.)
c     HLInt2 - Integral of dr1 (derivative second integral in eq. 13 of H.L.)
c     HLInt3 - Integral of dr1 or dr3 (derivative of 3rd or 4th integral)
c     XSing  - Array of singularities of integrand (used by cgratr)      
      INTEGER NSing, NCalls, MaxNR
      DOUBLE PRECISION DPPar(10), Beta
c      DOUBLE PRECISION Wp
      COMPLEX*16 CPar(10), Limit1, Limit2, HLInt1, HLInt2, HLInt3,
     &     XSing(20)
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc      
c     Loop Variables:
      INTEGER i1, i2
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc      
c     Parameters:
c     ZeroPl - lower bound Limit1
c     Inf    - Upper bound of Limit2
c     AbsErr - absolute error used by cgratr
c     RelErr - Relative error used by cgratr
c     Error  - used for error codes by cgratr
      DOUBLE PRECISION ZeroPl, Inf, AbsErr, RelErr, Error
      PARAMETER(ZeroPl = 1.d-5, Inf = 1.d2)
      PARAMETER(AbsErr = 1.d-5, RelErr = 1.d-4)
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     Externals:
c     cgratr      - integration routine
c     dr1,dr2,dr3 - functions to integrate
c     HFExc       - Calculates Hartree Fock exchange
      COMPLEX*16 cgratr, dr1, dr2, dr3, HFExc
      EXTERNAL cgratr, dr1, dr2, dr3, HFExc
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc            
c     Initialization:
      NSing  = 0
      NCalls = 0
      MaxNR  = 0
c     DPPar is array of dp parameters to evaluate functions in cgratr.
c     Everything is in dimensionless units.
c     1. xwg
      DPPar(1) = Wi/EFermi
c     2. xgam
      DPPar(2) = Gamma/EFermi
c     3. xe
      DPPar(3) = dble(Energy/EFermi)
c     4. xeg
      DPPar(4) = 0.d0
c     CPar is array of complex parameters to evaluate functions in cgratr.
c     ck in dimensionless units.
      CPar(1) = ck/kFermi
c     2. ce (complex energy)
      CPar(2) = Energy/EFermi + coni*DPPar(2)
      
c     Josh - This is a possible fix for functions that overlap zero by a large
c     amount so that Wp does not equal Wi. 
c     Wp= pi*Wi/2 + Wi*ArcTan[Wi/Gamma] - Gamma*Log[Beta] + Gamma*Log[Gamma] - 
c               1/2*Gamma*Log[Wi**2 + Gamma**2]
c      Beta = 1.d0*Gamma*SQRT(2.d0/(Wi**2+Gamma**2))
c      Beta  = 0.9d0*Gamma*Gamma/(Wi**2+Gamma**2)
c      Wp =  2*Gamma*LOG(Gamma/Beta) + 2*ATAN2(Wi,Gamma) -
c     &     Gamma*LOG(Gamma**2 + Wi**2)
c      Wp = SQRT(Wi*Wp)
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      DO i1 = 1, 1
         IF(i1.eq.2) THEN
            DPPar(1) = 0.d0
            DPPar(2) = 0.9d0*Gamma/EFermi
         END IF         
         
c     Calculate derivatives of integrals in eq. 13 of H.L.      
c     1)
c     Integral d/dE{ ln[((ck+q)**2-E+Wq)/((ck-q)**2-E+Wq)] }
c     from ck + kFermi to Inf.      
         Limit1 = ck/kFermi+1.d0
         Limit2 = Inf
c     Find singularities in dr2
         iFcn = 2
         CALL FndSng(Limit1, Limit2, NSing, XSing, DPPar, CPar, iFcn)
         
c     Calculate integral
         HLInt1 = cgratr(dr2,DPPar,CPar,Limit1,Limit2,AbsErr,RelErr,
     &        NSing, XSing,Error,NCalls,MaxNR)
         DO i2 = 1, NSing
            XSing(i2) = (1.d0,0)*XSing(i2)
         END DO
         
c     2)
c     Integral d/dE{ ln[(kFermi**2-E-Wq)/(kFermi**2-E+Wq)*
c     ((ck+q)**2-E+Wq)/((ck-q)**2-E-Wq)] }
c     From ck - kFermi to ck + kFermi
         Limit1 = MAX(ABS(DBLE(ck)/kFermi-1.d0), ZeroPl)
         Limit2 = ck/kFermi+1.d0
         
c     Find singularities in dr1
         iFcn = 1
         CALL FndSng(Limit1, Limit2, NSing, XSing, DPPar, CPar, iFcn)
         HLInt2 = cgratr(dr1,DPPar,CPar,Limit1,Limit2,AbsErr,RelErr,
     &        NSing, XSing,Error,NCalls,MaxNR)
         DO i2 = 1, NSing
            XSing(i2) = (1.d0,0)*XSing(i2)
         END DO
         
c     3)
c     Theta(kFermi-Re(ck)) *
c     Integral { ln[((ck+q)**2-E-Wq)/((ck-q)**2-E-Wq)] +
c     Theta(Re(ck)-kFermi) *
c     Integral { ln[((ck+q)**2-E+Wq)/((ck-q)**2-E+Wq)]
c     (Integrals from 0 to kFermi - k and 0 to k - kFermi)
         Limit1 = ZeroPl
         Limit2 = ABS(DBLE(ck)/kfermi-1.d0)
         
c     If ck = kFermi, HLInt3 = 0      
         IF((ABS(DBLE(ck)-kFermi).lt.ZeroPl).or.
     &        (DBLE(Limit2).le.DBLE(Limit1))) THEN         
            HLInt3 = 0.d0
c     If ck < kFermi, HLint3 = Integral d/dE{ ln[((ck+q)**2-E-Wq)/((ck-q)**2-E-Wq)] }          
         ELSEIF(DBLE(ck).lt.kFermi) THEN
            Limit2 = 1.d0 - DBLE(ck)/kFermi
            
c     Find singularities in r3        
            iFcn = 3
            CALL FndSng(Limit1, Limit2, NSing, XSing, DPPar, CPar, iFcn)
            
c     Calculate integral         
            HLInt3 = cgratr(dr3,DPPar,CPar,Limit1,Limit2,AbsErr,RelErr,
     &           NSing,XSing,Error,NCalls,MaxNR)
            DO i2 = 1, NSing
               XSing(i2) = (1.d0,0)*XSing(i2)
            END DO
c     Else ck > kFermi, HLint3 = Integral d/dE{ ln[((ck+q)**2-E+Wq)/((ck-q)**2-E+Wq)] }         
         ELSE
            Limit2 = DBLE(ck)/kFermi - 1.d0
            
c     Find singularities in r2         
            iFcn = 2
            CALL FndSng(Limit1, Limit2, NSing, XSing, DPPar, CPar, iFcn)
            
c     Calculate integral         
            HLInt3 = cgratr(dr2,DPPar,CPar,Limit1,Limit2,AbsErr,RelErr,
     &           NSing,XSing,Error,NCalls,MaxNR)
            DO i2 = 1, NSing
               XSing(i2) = (1.d0,0)*XSing(i2)
            END DO
         END IF

         IF(i1.eq.1) THEN
            dSigma = - Amp*Wi*(Wi-coni*Gamma)/(2.d0*pi*EFermi*ck)*
     &           (HLInt1 + HLInt2 + HLInt3)
         ELSE
            dSigma = dSigma - Amp*Beta*
     &           Wi*(coni*Gamma)/(pi*EFermi*ck)*
     &           (HLInt1 + HLInt2 + HLInt3)
         END IF
      END DO
      
      RETURN
      END      

      FUNCTION HFExc(ckIn, EFermi, kFermi)
c     returns dirac-hara hartree-fock exchange
c     ck - complex momentum in units of kFermi
      include '../HEADERS/const.h'
      COMPLEX*16 ckIn, ck, HFExc, c
      DOUBLE PRECISION EFermi, kFermi
      ck = ckIn/kFermi
      c=-2.d0*EFermi/(pi*kFermi)
      IF(ABS(ck-1.d0).le.0.00001d0) THEN
         HFExc = c
      ELSE
         HFExc = c*(1.d0+(1.d0/ck-ck)* log( (1.d0+ck)/(ck-1.d0) )/2.d0)
      END IF
      RETURN
      END
      
c****************************************************************************
c     the following function routines are used for evaluating integals and
c     their derivatives.
c****************************************************************************
      complex*16 function r1(q,dppar,cpar)
      implicit double precision (a-h,o-z)
      include '../HEADERS/const.h'
      
c     Input:
      double precision dppar(4)
c     dppar contains:
c     xe, xeg, xwg, xgam
      complex*16 cpar(2)

c     Local Variables:
      complex*16 fq,fqq,fiq,a1,a2,a3,a4,t1,t2,q,ck,xe
      external fq

      ck=CPar(1)
c     3. xe
      xe = CPar(2)
c     4. xeg
      xeg = DPPar(4)
c     print*, 'call fq(q),ck', q, ck
      fqq=fq(q,dppar)
c     print*,'fqq=', fqq
      fiq=1./(q*fqq)
      a1=1.d0-xeg-xe-fqq - coni*1.d-10
      a2=(ck+q)**2-xe+fqq - coni*1.d-10
      a3=(ck-q)**2-xe-fqq - coni*1.d-10
      a4=1.d0+xeg-xe+fqq - coni*1.d-10
      t1=(a1*a2)
      t2=(a3*a4)
c     print*,'a1,a2,a3,a4,t1,t2',a1,a2,a3,a4,t1,t2
c      t1=t1/t2
      r1=fiq*(log(a1)+log(a2)-log(a3)-log(a4))
c     Test with r=E
c      r1=xe
c     print*,'r1 return to cgratr', r1
      return
      end
c****************************************************************************
      complex*16 function dr1(q,dppar,cpar)
      implicit double precision (a-h,o-z)
      include '../HEADERS/const.h'
      
c     Input:
      double precision dppar(4)
c     dppar contains:
c     xe, xeg, xwg, xgam
      complex*16 cpar(2)

c     Local Variables:
      complex*16 fq,fqq,fiq,a1,a2,a3,a4,q,ck,xe
      external fq

      ck=CPar(1)
c     3. xe
      xe = CPar(2)
c     4. xeg
      xeg = DPPar(4)
c     print*, 'call fq(q),ck', q, ck
      fqq=fq(q,dppar)
c     print*,'fqq=', fqq
      fiq=1./(q*fqq)
      a1=1.d0-xeg-xe-fqq - coni*1.d-10
      a2=(ck+q)**2-xe+fqq - coni*1.d-10
      a3=(ck-q)**2-xe-fqq - coni*1.d-10
      a4=1.d0+xeg-xe+fqq - coni*1.d-10

      dr1 = -fiq*(1.d0/a1+1.d0/a2-1.d0/a3-1.d0/a4)
c     Test with r=E
c      dr1=1.d0
c      write(51,*) dble(q), dble(dr1)
c     print*,'r1 return to cgratr', r1
      return
      end
c**********************************************************************
      complex*16 function r2(q,dppar,cpar)
      implicit double precision (a-h,o-z)
      include '../HEADERS/const.h'
      
c     Input:
      double precision dppar(4)
c     dppar contains:
c     xe, xeg, xwg, xgam
      complex*16 cpar(2)

c     Local Variables:
      complex*16 fqq,fq,fiq,a1,a2,q,ck,xe
      ck = CPar(1)
c     3. xe
      xe = CPar(2)
c     4. xeg
c      xeg = DPPar(4)
      
      fqq=fq(q,dppar)
      fiq=1.d0/(q*fqq)
      a1=((ck+q)**2-xe+fqq) - coni*1.d-10
      a2=((ck-q)**2-xe+fqq) - coni*1.d-10
      r2=fiq*(log(a1)-log(a2))
c     Test with r=E
c      r2=xe      
      return
      end
c**********************************************************************
      complex*16 function dr2(q,dppar,cpar)
      implicit double precision (a-h,o-z)
      include '../HEADERS/const.h'
      
c     Input:
      double precision dppar(4)
c     dppar contains:
c     xe, xeg, xwg, xgam
      complex*16 cpar(2)

c     Local Variables:
      complex*16 fqq,fq,fiq,a1,a2,q,ck,xe
      ck = CPar(1)
c     3. xe
      xe = CPar(2)
c     4. xeg
c      xeg = DPPar(4)
      
      fqq=fq(q,dppar)
      fiq=1.d0/(q*fqq)
      a1=((ck+q)**2-xe+fqq) - coni*1.d-10
      a2=((ck-q)**2-xe+fqq) - coni*1.d-10
      dr2=-fiq*(1.d0/a1-1.d0/a2)
c     Test with r=E
c      dr2=1.d0      
c      write(52,*) dble(q), dble(dr2)
      return
      end  
c**********************************************************************
      complex*16 function r3(q,dppar,cpar)
      implicit double precision (a-h,o-z)
      include '../HEADERS/const.h'

c     Input:
      double precision dppar(4)
c     dppar contains:
c     xe, xeg, xwg, xgam
      complex*16 cpar(2)

c     Local Variables:
      complex*16 fqq,fq,fiq,a1,a2,q,ck,xe
      ck = CPar(1)
c     3. xe
      xe = CPar(2)
c     4. xeg
c      xeg = DPPar(4)
c     valid only for k<kf, q<kf-k ?
      fqq=fq(q,dppar)
      fiq=1.d0/(q*fqq)
      a1=( (ck+q)**2-xe-fqq) - coni*1.d-10
      a2=( (ck-q)**2-xe-fqq) - coni*1.d-10
      r3=fiq*(log(a1) - log(a2))
c     Test with r=E
c      r3=xe      
      return
      end
c**********************************************************************
      complex*16 function dr3(q,dppar,cpar)
      implicit double precision (a-h,o-z)
      include '../HEADERS/const.h'

c     Input:
      double precision dppar(4)
c     dppar contains:
c     xe, xeg, xwg, xgam
      complex*16 cpar(2)

c     Local Variables:
      complex*16 fqq,fq,fiq,a1,a2,q,ck,xe
      ck = CPar(1)
c     3. xe
      xe = CPar(2)
c     4. xeg
c      xeg = DPPar(4)
c     valid only for k<kf, q<kf-k ?
      fqq=fq(q,dppar)
      fiq=1.d0/(q*fqq)
      a1=( (ck+q)**2-xe-fqq) - coni*1.d-10
      a2=( (ck-q)**2-xe-fqq) - coni*1.d-10
      dr3=-fiq*(1.d0/a1-1.d0/a2)
c     Test with r=E
c      dr3=1.d0
c      write(53,*) dble(q), dble(dr2)
      return
      end     
c**********************************************************************
      complex*16 function fq(q,dppar)
      implicit double precision (a-h,o-z)
      include '../HEADERS/const.h'
      complex*16 q
      double precision dppar(4)

c     1. xwg
      xwg = DPPar(1)
c     2. xgam
      xgam = DPPar(2)
      
c     Here I am going to change the dispersion relation to 
c     wq = wp + 1/2 * q**2 
c     This makes calculation of broadened poles easier. 
c      fq = xwg-coni*xgam + q**2
      
c     fq(q)=w1(q)=sqrt(w1**2+((omega(q)-omega_p)/omega_f)**2)
c     omega(q)**2=omega_p**2+omega_g**2(q)
c     fq(q)=xwg+a2*q**2+a4*q**4    xwg=(w1/ef)**2
c     electron gas parameters xwg=wp**2 a2=4/3, a4=1
c     uncomment the following 4 lines to use the old dispersion relation.
      a2=4.d0/3.d0
      a4=1.d0
      fq=(xwg-coni*xgam)**2 + a2*q*q + a4*q**4
      fq=sqrt(fq)
      return
      end

               
c*********************************************************************
c   This is Steve White's rewrite of Mike Teter's integration routine.  
c   Modified by J. Rehr for complex integration.
c   The following is a listing of the arguments in the initial function 
c   statement:
c     fn    -- routine requires external function statement in MAIN
c     xmin  -- lower limit
c     xmax  -- upper limit
c     abr   -- absolute tolerable error
c     rlr   -- relative tolerable error
c     nsing -- number of singularities or regions requiring 
c     special attention
c     xsing -- array of locations of singularities or endpoints
c     of special regions
c     error -- output for routine error messages
c     numcal-- the number of times fn was called
c     maxns -- the maximum number of regions being considered simultaneously
c     function cgratr(fn,xmin,xmax,abr,rlr,nsing,xsing,error,numcal,maxns)
c     fn declared double precision
c     double precision function cgratr(fn,xmin,xmax,abr,rlr,
c     fn declared complex*16
      
      complex*16 function cgratr(fn,dppar,cpar,xmin,xmax,abr,rlr,
     &     nsing,xsing,error,numcal,maxns)
      implicit double precision (a-h,o-z)
      parameter (mx=1500)
      integer nsing
      complex*16 fn,value,valu,fval(3,mx),xmax,xmin,del,del1
      complex*16 xleft(mx), xsing(20), cpar(10)
      double precision dppar(10)
      external fn
c     dimension xleft(mx),fval(3,mx),dx(3),wt(3)
      dimension wt9(9),dx(3),wt(3)
c     dimension xsing(20)
      logical atsing
      save dx,wt,wt9
      data dx/0.1127016653792583  ,0.5  ,0.8872983346207417  /
      data wt/0.277777777777777778  ,0.4444444444444444444  ,
     1     0.2777777777777777778  /
      data wt9/0.0616938806304841571  ,0.108384229110206161  ,
     1     0.0398463603260281088  ,0.175209035316976464  ,
     2     0.229732989232610220  ,0.175209035316976464  ,
     3     0.0398463603260281088  ,0.108384229110206161  ,
     4     0.0616938806304841571  /
c     nstack is the number of different intervals into which the 
c     integration region is currently divided. The number of regions can
c     grow if more accuracy is needed by dividing the right-most region
c     into three regions. The number of regions shrinks when the integral
c     over the right-most region is accurate enough, in which case that
c     integral is added to the total (stored in cgratr) and the region
c     is removed from consideration (and a new region is the right-most).
      nstack=nsing+1
      maxns = nstack
      error=0.  
      cgratr=0.  
c     The array xleft stores the boundary points of the regions.
c     The singular points just govern the initial placement of the regions.
      xleft(1)=xmin
      xleft(nsing+2)=xmax
      if(nsing.gt.0) then
         do 9 j=1,nsing
            xleft(j+1)=xsing(j)
 9       continue
      endif
c     For each region, calculate the function and store at three selected points.
      do 1 jj=1,nstack
         del=xleft(jj+1)-xleft(jj)
c     print*, 'fn call j= ,'
         do 1 j=1,3
c     print*, 'fn call in cgratr j= ',j
            fval(j,jj)=fn(xleft(jj)+del*dx(j),dppar,cpar)
 1    continue
c     print*, 'output of fn call, fval(j,jj)',fval(j,jj)
      numcal = nstack * 3
 6    continue
      if(nstack+3.ge.mx) then
         write(*,*) ' TOO MANY REGIONS'
         stop 0006
      endif
c     Divide the rightmost region into three subregions.  
      del=xleft(nstack+1)-xleft(nstack)
      xleft(nstack+3)=xleft(nstack+1)
      xleft(nstack+1)=xleft(nstack)+del*dx(1)*2.
      xleft(nstack+2)=xleft(nstack+3)-del*dx(1)*2.
c     The three data points already found for the region become the 
c     middle data points (number 2 in first index of fval) for each region.
      fval(2,nstack+2)=fval(3,nstack)
      fval(2,nstack+1)=fval(2,nstack)
      fval(2,nstack)=fval(1,nstack)
c     Now do the integral over the right-most region in two different ways-
c     a three point integral (valu) over each of the three subregions 
c     and a more accurate nine-point integral (value) over whole region.
c     valu is used only for the error estimate.
      icount=0
      value=0.  
      valu=0.  
      do 3 j=nstack,nstack+2
         del1=xleft(j+1)-xleft(j)
c     print*, 'fn call 2'
         fval(1,j)=fn(xleft(j)+dx(1)*del1,dppar,cpar)
         fval(3,j)=fn(xleft(j)+dx(3)*del1,dppar,cpar)
c     print*, 'fn call 2'
         numcal = numcal + 2
         do 5 k=1,3
            icount=icount+1
            value=value+wt9(icount)*fval(k,j)*del
            valu=valu+fval(k,j)*wt(k)*del1
 5       continue
 3    continue
      dif=abs(value-valu)
c     If the following condition is true, add in this integral to the total,
c     and reduce the number of regions under consideration.
      frac = dble(del / (xmax - xmin))
      atsing = .false.
      if(frac .le. 1.0e-8) atsing = .true.
      if(dif .le. abr*frac .or. dif.le.rlr*abs(value) .or. 
     1     (atsing .and. 
     2     (frac .le. 1.0e-15 .or. dif .le. abr*0.1  ))) then
c     The following commented out line is Teeter's old error criterion.
c     if(dif.le.abr.or.dif.le.rlr*abs(value))then
         cgratr=cgratr+value
         error=error+abs(dif)
         nstack=nstack-1
c     If no more regions, we are done.
         if(nstack.le.0) return
      else
c     If the integration is insufficiently accurate, make each of the 
c     three subregions of the right-most region into regions.
c     On next pass the right-most of these is the new current region.
         nstack=nstack+2
         maxns = max(maxns,nstack)
      endif
      go to 6
      end

      subroutine moveh (nat, iphat, iz, rath)
c    Increase length of bonds with hydrogen atoms
c    Move Hydrogens for potentials. Otherwise MT geometry is screwed up.
      implicit double precision (a-h, o-z)
      include '../HEADERS/dim.h'

c     input is everything; output is modified  atomic coordinates (rath) 
c     nat is number of atoms in cluster
      dimension iphat(natx),  iz(0:nphx)
      dimension rath(3,natx)

      do 970 iat = 1, nat
        if (iz(iphat(iat)) .eq. 1) then
c         find the nearest atom A, units for rat are bohr.
          rah = 100
          ia = 0
          do i = 1,nat
              rattmp = dist(rath(1,iat), rath(1,i) )
              if (rattmp.lt. rah .and. i.ne. iat) then
                 ia = i
                 rah = rattmp
              endif
          enddo
          if (iz(iphat(ia)).eq.1) goto 970

c         set max distance as function of rah ( set by calculations
c         for H2O and GeH4)
          ratmax = rah + 4.d0/rah**2 

c        find shortest AB bond (neither A or B are H)
          rab = 10
          ib = 0
          do i = 1,nat
              rattmp = dist(rath(1,ia), rath(1,i))
              if (i.ne.ia .and. iz(iphat(i)).ne.1 .and.
     1            rab.gt.rattmp) then
                 rab = rattmp
                 ib = i
              endif
          enddo
          if (rab.lt.ratmax) ratmax = 0.95d0*rab + 0.05d0*rah
          if (rah .gt. ratmax) goto 970

c         increase rah to ratmax and check that A is still closest to H
          ratmin = rah
  960     do i = 1,3
           rath(i,iat)=rath(i,ia)+ratmax/ratmin*(rath(i,iat)-rath(i,ia))
          enddo
          rbh = 10
          ib = 0
          do i = 1,nat
              rattmp = dist(rath(1,iat), rath(1,i))
              if (i.ne.iat .and. rbh.gt.rattmp) then
                 rbh = rattmp
                 ib = i
              endif
          enddo

          if (ia.ne.ib) then
             rab = dist(rath(1,ia),rath(1,ib))
             rattmp = ratmax*rab**2/(ratmax**2+rab**2-rbh**2)
             ratmin = ratmax
             ratmax = 0.95d0*rattmp +0.05d0*rah
             goto 960
          endif
        endif
  970 continue

      return
      end

      subroutine genfmt (ipr5, critcw, iorder, wnstar,
     1       ipol, ispin, le2, angks, elpty, evec, xivec, ptz)
      implicit double precision (a-h, o-z)

c     altered by matt newville (jan 1999):
c     format of feff.pad changed to packed-ascii, and all writes changed.
c     altered by alex ankudinov(feb 2000); disabled use of paths in LDOS.

      include '../HEADERS/const.h'
      include '../HEADERS/dim.h'
      include '../HEADERS/vers.h'

c+----------------------------------------------------------------------
c     removing local common blocks, replacing them with explicit passing
c     of the various data srtuctures
c+----------------------------------------------------------------------
c     include 'clmz.h'
      complex*16 clmi(ltot+1,mtot+ntot+1,legtot)
c     include 'fmatrx.h'
      complex*16 fmati(lamtot,lamtot,legtot)
c     include 'lambda.h'
c     .   mlam(lamtot),     !mu for each lambda
c     .   nlam(lamtot),     !nu for each lambda
c     .   lamx,             !max lambda in problem
c     .   laml0x,           !max lambda for vectors involving absorbing atom
c     .   mmaxp1, nmax      !max mu in problem + 1, max nu in problem
      integer mlam(lamtot), nlam(lamtot), lamx, laml0x, mmaxp1, nmax
c     include 'nlm.h'
      dimension xnlm(ltot+1,mtot+1)
c     include 'rotmat.h'
      dimension dri(ltot+1,2*mtot+1,2*mtot+1,legtot+1)
c     include 'pdata.h'
      character*80 text(5)
      character*6  potlbl(0:nphx)
      complex*16 ph(nex,-ltot:ltot,0:nphx), eref(nex), em(nex)
      double precision rat(3,0:legtot+1)
      double precision ri(legtot), beta(legtot+1), eta(0:legtot+1)
      double precision deg, rnrmav, xmu, edge
      integer lmax(nex,0:nphx), ipot(0:legtot), iz(0:nphx), ltext(5)
      integer nsc, nleg, npot, ne, ik0, ipath, ihole
      integer kinit, linit, ilinit, lmaxp1, ntext
c     common /pdata/ ph(nex,-ltot:ltot,0:nphx), !complex phase shifts ipot=0
c     .  eref(nex),                             !complex energy reference
c     .  rat(3,0:legtot+1),                     !position of each atom, code units(bohr)
c     .  em(nex),                               !energy mesh
c     .  ri(legtot), beta(legtot+1), eta(0:legtot+1), !r, beta, eta for each leg
c     .  deg, rnrmav, xmu, edge,                !(output only)
c     .  lmax(nex,0:nphx),                      !max l with non-zero phase for each energy
c     .  ipot(0:legtot),                        !potential for each atom in path
c     .  iz(0:nphx),                            !atomic number (output only)
c     .  ltext (5),                             !length of each string
c     .  nsc, nleg,                             !nscatters, nlegs (nleg = nsc+1)
c     .  npot, ne,                              !number of potentials, energy points
c     .  ik0,                                   !index of energy grid corresponding to k=0 (edge)
c     .  ipath, ihole,                          !index of current path  and hole (output only)
c     .  kinit, linit, ilinit,                  ! initial state kappa and ang. mom.
c     .  lmaxp1,                                !largest lmax in problem + 1
c     .  ntext                                  !number of text  lines




      dimension   evec(3), xivec(3)
      complex*16  ptz
      dimension   ptz(-1:1, -1:1), lind(8)

      complex*16  rho(legtot), pmati(lamtot,lamtot,2)
      complex*16  pllp, ptrac, srho, prho, cfac
      complex*16  cchi(nex)
      complex*16  rkk(nex,8)
      complex*16  rkk2(nex,8,nspx)
      complex*16  eref2(nex,nspx), ph4, bmati
      dimension   ph4(nex,-ltot:ltot, nspx, 0:nphx)
      dimension   bmati(-mtot:mtot, 8, -mtot:mtot, 8)
      dimension   xk(nex), ckmag(nex)
      complex*16  ck(nex)
      dimension   eps1(3), eps2(3), vec1(3), vec2(3)

      character*128 string
      character*256 phpad
      character*512 slog
      logical done, wnstar

c      padlib staff
      double precision phff(nex), amff(nex),  xkr(nex)
      integer  mpadx
      parameter (mpadx = 8)
      character*75 wfmt, atsym*2
      external atsym, cwig3j, istrln

c     Input flags:
c     iorder, order of approx in f-matrix expansion (see setlam)
c             (normal use, 2.  Do ss exactly regardless of iorder)

c     used for divide-by-zero and trig tests
      parameter (eps = 1.0d-16)
      external getxk, xstar

c+---------------------------------------------------------------------
c begin intialization

      phpad = 'phase.pad'
      call genfmt_prep(phpad, ispin,
c     arguments for rdxsph
     &       ne, ne1, ne3, npot, ihole, rnrmav,
     &       xmu, edge, ik0, ixc, rs, vint,
     &       em, eref2, iz, potlbl, ph4, rkk2, lmax, lmaxp1,
c     arguments for setkap
     &       kinit, linit, ilinit,
c     argument for snlm (also a return)
     &       xnlm,
c     things set in genfmt_prep
     &       eref, ph, xk, ck, ckmag, xkr,
     &       nsp, ll, npath, ntotal, nused, xportx)

c end of intialization
c+---------------------------------------------------------------------

c     Open path input file (unit in) and read text .  Use unit 1.
      ntext  = 5
      open (unit=1, file='paths.dat', status='old', iostat=ios)
      call chopen (ios, 'paths.dat', 'genfmt')
      call rdhead (1, ntext , text, ltext)
      if (ntext  .le. 0)  then
         text (1) = ' '
      endif
c
c     Save indices of paths for use by ff2chi
      open (unit=2, file='list.dat', status='unknown', iostat=ios)
      call chopen (ios, 'list.dat', 'genfmt')
c     Put phase header on top of list.dat
      call wthead (2, ntext , text )
      write(2, 125)
 125  format (1x, 71('-'))
      write(2, 135)
 135  format('  pathindex     sig2   amp ratio    ',
     1       'deg    nlegs  r effective')

c     Open nstar.dat if necessary
      if (wnstar)  then
         open(unit=4,file='nstar.dat', status='unknown', iostat=ios)
         call chopen (ios, 'nstar.dat', 'genfmt')
         write(4,'(1x,a,f8.4)' ) ' polarization', evec
         write(4,'(1x,a)' ) ' npath     n*'
      endif

c     Set crit0 for keeping feff.dat's
      if (ipr5 .le. 0)  crit0 = 2*critcw/3
c     Make a header for the running messages.
      write(slog, 155) critcw
 155  format ('    Curved wave chi amplitude ratio', f7.2, '%')
      call wlog(slog)
      if (ipr5 .le. 0)  then
         write(slog,165) crit0
         call wlog(slog)
      endif
 165  format('    Discard feff.dat for paths with cw ratio <',
     1       f7.2, '%')
      write(slog,195)
 195  format ('    path  cw ratio     deg    nleg  reff')
      call wlog(slog)

c     open feff.pad for storing path info
c     for now, use double precision.  After it's working, try
c     single precision.
c     Use single precision for all fp numbers in feff.pad
c     !KJ replaced by next lines      open (unit=3, file='feff.pad', status='unknown', iostat=ios)
c     !KJ idem      call chopen (ios, 'feff.pad', 'genfmt')
      open (unit=3, file='feff.pad', status='unknown', iostat=ios) !KJ f1  1-06
      call chopen (ios, 'feff.pad', 'genfmt') !KJ introduced f1
c     put label line in feff.pad so other programs know it really
c     is a feff.pad file
      string = '#_feff.pad v03: ' // vfeff // vf85e
      jstr   = istrln(string)
      write(3, '(a)')  string(1:jstr)

c     save stuff that is the same for all paths
c     header, ck, central atom phase shifts
      write(3, '(a2,6(1x,i4))') '#_', npot, ne, mpadx

c     Misc stuff from phase.pad and genfmt call
 345  format(a2,3(1x,i7), 3(1x,g14.7))
      write(3, 345) '#&', ihole, iorder, ilinit, rnrmav, xmu, edge
 395  format('(',i3,'(1x,a6),',i3,'(1x,i3))')
      write(wfmt, 395) npot+1, npot+1
      write(string,wfmt) (potlbl(i),i=0,npot) , (iz(i),i=0,npot)
      jstr = istrln(string)
      write(3, '(a2,a)') '#@',string(:jstr)

c     Central atom phase shifts
      call wrpadx(3,mpadx, ph(1,ll, 0),ne)
      call wrpadx(3,mpadx, ck,ne)
      call wrpadd(3,mpadx, xkr,ne)

c     While not done, read path, find feff.
 1000 continue

c     Read current path
      call rdpath (1, done, ipol, potlbl, rat, ri, beta, eta,
     &       deg, ipot, nsc, nleg, npot, ipath)

      icalc = iorder
      if (.not.done)  then
         npath = npath + 1
         ntotal = ntotal + 1
         if (wnstar)  then
c           should be ipol=1
            do 1150 ic =1,3
               vec1(ic) = rat(ic,1) - rat(ic,0)
               vec2(ic) = rat(ic,nleg-1) - rat(ic,0)
               eps1(ic) = evec(ic)
 1150       continue
            if (elpty.ne.0.0) then
               eps2(1) = xivec(2)*evec(3)-xivec(3)*evec(2)
               eps2(2) = xivec(3)*evec(1)-xivec(1)*evec(3)
               eps2(3) = xivec(1)*evec(2)-xivec(2)*evec(1)
            endif
            ndeg = nint (deg)
            xxstar = xstar(eps1, eps2, vec1, vec2, ndeg, elpty,
     &             ilinit)
            write(4,'(1x,i6,f10.3)')  npath, xxstar
         endif

c        Need reff
         reff = 0
         do 1200  i = 1, nleg
            reff = reff + ri(i)
 1200    continue
         reff = reff/2

c        Set lambda for low k
         call setlam(icalc, 1, beta, nsc, nleg, ilinit,
     &          mlam, nlam, lamx, laml0x, mmaxp1, nmax)

c        Calculate and store rotation matrix elements
         do 1300  isc = 1, nleg
            call rot3i (lmaxp1, mmaxp1, isc, beta, dri)
 1300    continue
         if (ipol.gt.0)  then
c           one more rotation in polarization case
c           NEED MORE rot3j FOR CENTRAL ATOM ( l \pm 1 )
            call rot3i (ilinit+1, ilinit+1, nleg+1, beta, dri)
         endif

c        Start cycle over spin
         do ie = 1, ne
            cchi(ie) = 0
         enddo

         do 6000 is = 1, nsp
            if (nsp.eq.1) then
               call mmtr(bmati, ipol, ispin, le2, angks, ptz, lind,
     &                dri, eta, nsc, nleg, kinit, ilinit)
            else
               call mmtr(bmati, ipol, is, le2, angks, ptz, lind,
     &                dri, eta, nsc, nleg, kinit, ilinit)
            endif
            do 110 ie = 1, ne
               eref(ie) = eref2(ie,is)
 110        continue
            do 120 iph = 0, npot
               do 122 ie = 1, ne
                  do 124 il = -lmax(ie, iph), lmax(ie, iph)
                     ph(ie,il, iph) = ph4(ie, il, is, iph)
 124              continue
 122           continue
 120        continue
            do 130 ie = 1, ne
               do 132 kdif = 1, 8
                  rkk(ie,kdif) = rkk2(ie,kdif,is)
 132           continue
 130        continue
            do 140 ie = 1, ne
               ck(ie) = sqrt (2* (em(ie) - eref(ie)))
 140        continue

c           Big energy loop
            do 5000  ie = 1, ne
c              complex rho
               do 2010  ileg = 1, nleg
                  rho(ileg) = ck(ie) * ri(ileg)
 2010          continue
c              if ck is zero, xafs is undefined.  Make it zero and jump
c              to end of calc part of loop.
               if (abs(ck(ie)) .le. eps)  then
                  cchi(ie) = cchi(ie) + 0
                  write(slog,2055)  ie, ck(ie)
 2055             format (' genfmt: ck=0.  ie, ck(ie)',i5,1p,2e14.5)
                  call wlog(slog)
                  goto 4990
               endif
c              Calculate and store spherical wave factors c_l^(m)z^m/m!
c              in a matrix clmi(il,im,ileg), ileg=1...nleg.
c              Result is that common /clmz/ is updated for use by fmtrxi.
c
c              zero clmi arrays
               do 2100  ileg = 1, legtot
                  do 2102 im = 1, mtot+ntot+1
                     do 2104  il = 1, ltot+1
                        clmi(il,im,ileg) = 0
 2104                continue
 2102             continue
 2100          continue
               mnmxp1 = mmaxp1 + nmax
               do 2150  ileg = 1, nleg
                  isc0 = ileg-1
                  if (isc0.eq.0) isc0=nleg
                  isc1 = ileg
                  lxp1 = max (lmax(ie,ipot(isc0))+1,
     &                   lmax(ie,ipot(isc1))+1)
                  mnp1 = min (lxp1, mnmxp1)
                  call sclmz (rho, lxp1, mnp1, ileg, clmi)
 2150          continue

c              Calculate and store scattering matrices fmati.
c              First matrix
               call fmtrxi(lamx, laml0x, ie, 2, 1,
     &                clmi, mlam, nlam, xnlm, dri,
     &                ph, eta, lmax, ipot, fmati)
c              Last matrix if needed
               if (nleg .gt. 2)  then
                  call fmtrxi(laml0x, lamx, ie, nleg, nleg-1,
     &                   clmi, mlam, nlam, xnlm, dri,
     &                   ph, eta, lmax, ipot, fmati)
               endif
c              Intermediate scattering matrices
               do 2200  ilegp = 2, nsc-1
                  ileg = ilegp + 1
                  call fmtrxi(lamx, lamx, ie, ileg, ilegp,
     &                   clmi, mlam, nlam, xnlm, dri,
     &                   ph, eta, lmax, ipot, fmati)
 2200          continue

c              Big matrix multiplication loops.
c              Calculates trace of matrix product
c              M(1,N) * f(N,N-1) * ... * f(3,2) * f(2,1), as in reference.
c              We will calculate the trace over lambda_N, working from
c              right to left.
c              Use only 2 pmati arrays, alternating indp (index p)
c              1 and 2.

c              to start f(2,1) -> pmat(1)
               indp = 1
               do 2250 lmp = 1, laml0x
                  do 2252 lm = 1, lamx
                     pmati(lm,lmp,indp)= fmati(lm,lmp,1)
 2252             continue
 2250          continue

c              f(N,N-1) * ... * f(3,2) * [f(2,1)]
c              Term in [] is pmat(1)
               do 2900 isc = 2, nleg-1
c                 indp is current p matrix, indp0 is previous p matrix
                  indp = 2 - mod(isc,2)
                  indp0 = 1 + mod(indp,2)
                  do 2850  lmp = 1, laml0x
                     do 2852  lm = 1, lamx
                        pllp=0
                        do 2800 lmi = 1, lamx
                           pllp = pllp +
     1                            fmati(lm,lmi,isc)*pmati(lmi,lmp,indp0)
 2800                   continue
                        pmati(lm,lmp,indp) = pllp
 2852                continue
 2850             continue
 2900          continue

c              srho=sum pr(i), prho = prod pr(i)
               srho=0
               prho=1
               do 3200  ileg = 1, nleg
                  srho = srho + rho(ileg)
                  prho = prho * rho(ileg)
 3200          continue

c              Termination matrix, fmati(...,nleg)
c              Polarization enters only this matrix
c              this will fill fmati(...,nleg) (NO LONGER in common /fmtrxi/)
               call mmtrxi(rkk, laml0x, bmati, ie, 1, nleg,lind,
     &                clmi, mlam, nlam, xnlm, eta, fmati)

c              Final trace over matrix
               ptrac=0
               do 4400  lm = 1, laml0x
                  do 4402  lmp = 1, laml0x
                     ptrac = ptrac + fmati(lm,lmp,nleg) *
     &                      pmati(lmp,lm,indp)
 4402             continue
 4400          continue

c              Calculate xafs
c              Complex chi (without 2kr term)
c              ipot(nleg) is central atom
c              cdel1 = exp(2*coni*ph(ie,ilinit+1,0))
c              central atom phase shift are included in normalized
c              reduced matrix elements rkk(....)
               cfac = exp(coni*(srho-2*xk(ie)*reff)) / prho

c              now factor 1/(2*l0+1) is inside termination matrix
c              cchi(ie) = ptrac * cfac/(2*l0+1)
               if (nsp.eq.2 .and. is.eq.1) cfac = -cfac
               cchi(ie) = cchi(ie) + ptrac * cfac
c              write(7,5) xk(ie), -12*dimag(cchi(ie)*exp(coni*2*xk(ie)*reff))
c              5              format (3f13.5)

c              When ck(ie)=0, xafs is set to zero.  Calc above undefined.
c              Jump to here from ck(ie)=0 test above.
 4990          continue

 5000       continue
c           end of energy loop
 6000    continue
c        end of loop over spins

c        compute the importance factor of this path
         call import(ne1, nsp, ik0, reff, deg, ckmag, em, eref2,
     &          cchi, xportx, crit)

c        Write path data to feff.pad if we need it.
         if (ipr5 .ge. 1  .or.  crit .ge. crit0)  then
c           write path info
 7225       format('(i6,1x,i3,1x,f7.3,1x,f11.7,1x,e15.4,',i3,
     &             '(1x,i2))')  !KJ  1-06
c           7225         format('(i6,1x,i3,1x,f7.3,1x,f11.7,1x,f9.4,',i3,'(1x,i2))') !KJ original code
            write(wfmt, 7225) nleg
            write(string,wfmt) ipath, nleg, deg, reff*bohr,
     $             crit, (ipot(i),i=1, nleg)
            jstr = istrln(string)
            write(3,'(a2,a)') '##',string(:jstr)
            call wrpadd(3,mpadx, rat(1,1),3*nleg)
            call wrpadd(3,mpadx, beta,nleg)
            call wrpadd(3,mpadx, eta,nleg)
            call wrpadd(3,mpadx, ri,nleg)
            phffo = 0
            do 7700  ie = 1, ne
               phff(ie) = 0
               if (abs(cchi(ie)) .ge. eps) then
                  phff(ie) = atan2 (dimag(cchi(ie)),
     $                   dble(cchi(ie)))
               end if

c              remove 2 pi jumps in phase
               if (ie.gt.1) call pijump (phff(ie), phffo)
               phffo    = phff(ie)
               amff(ie) = dble(abs(cchi(ie)))
 7700       continue
            call wrpadd(3,mpadx, amff,ne)
            call wrpadd(3,mpadx, phff,ne)

c           Put feff.dat and stuff into list.dat
c           zero is debye-waller factor column
            write(2,8215) ipath, zero, crit, deg, nleg, reff*bohr
 8215       format(1x, i8, f12.5, 2f10.3, i6, f9.4) !KJ original code
c           8215         format(1x, i8, f12.5, e15.4, f10.3, i6, f9.4) !KJ  1-06

c           Tell user about the path we just did
            write(slog, 8225) ipath, crit, deg, nleg, reff*bohr
 8225       format (3x, i4, 2f10.3, i6, f9.4) !KJ original code
c           8225         format (3x, i4, e15.4, f10.3, i6, f9.4) !KJ    1-06
            call wlog(slog)
            nused = nused+1
         else
c           path unimportant, tell user
            write(slog, 8235) ipath, crit, deg, nleg, reff*bohr
 8235       format (3x, i4, 2f10.3, i6, f9.4, ' neglected')
            call wlog(slog)
         endif
c        goto next path
         goto 1000
c        done with loop over paths
      end if
c     close paths.dat, list.dat, feff.pad, nstar.dat
      close (unit=1)
      close (unit=2)
      close (unit=3)
      if (wnstar) close (unit=4)
      write(slog,'(1x,i4,a,i4,a)') nused,' paths kept, ',
     $       ntotal,' examined.'
      call wlog(slog)

      return
      end

C FUNCTION ISTRLN (STRING)  Returns index of last non-blank
C                           character.  Returns zero if string is
C                           null or all blank.

      FUNCTION ISTRLN (STRING)
      CHARACTER*(*)  STRING
      CHARACTER BLANK, TAB
      PARAMETER (BLANK = ' ', TAB = '	')
C     there is a tab character here  ^

C  -- If null string or blank string, return length zero.
      ISTRLN = 0
      IF (STRING (1:1) .EQ. CHAR(0))  RETURN
      IF (STRING .EQ. ' ')  RETURN

C  -- Find rightmost non-blank character.
      ILEN = LEN (STRING)
      DO 20  I = ILEN, 1, -1
         IF (STRING(I:I).NE.BLANK .AND. STRING(I:I).NE.TAB
     &        .AND. STRING(I:I).NE.CHAR(0))  GOTO 30
   20 CONTINUE
   30 ISTRLN = I

      RETURN
      END
C SUBROUTINE TRIML (STRING)  Removes leading blanks.

      SUBROUTINE TRIML (STRING)
      CHARACTER*(*)  STRING
      CHARACTER*200  TMP
      CHARACTER BLANK, TAB
      PARAMETER (BLANK = ' ', TAB = '	')
C     there is a tab character here  ^

      JLEN = ISTRLN (STRING)

C  -- All blank and null strings are special cases.
      IF (JLEN .EQ. 0)  RETURN

C  -- FInd first non-blank char
      DO 10  I = 1, JLEN
         IF (STRING(I:I).NE.BLANK .AND. STRING(I:I).NE.TAB)  GOTO 20
   10 CONTINUE
   20 CONTINUE

C  -- If I is greater than JLEN, no non-blanks were found.
      IF (I .GT. JLEN)  RETURN

C  -- Remove the leading blanks.
      TMP = STRING (I:)
      STRING = TMP
      RETURN
      END
C SUBROUTINE UPPER (STRING)  Changes a-z to upper case.

      SUBROUTINE UPPER (STRING)
      CHARACTER*(*)  STRING

      JLEN = ISTRLN (STRING)

      DO 10  I = 1, JLEN
         IC = ICHAR (STRING (I:I))
         IF ((IC .LT. 97)  .OR.  (IC .GT. 122))  GOTO 10
         STRING (I:I) = CHAR (IC - 32)
   10 CONTINUE

      RETURN
      END
C SUBROUTINE LOWER (STRING)  Changes A-Z to lower case.

      SUBROUTINE LOWER (STRING)
      CHARACTER*(*)  STRING

      JLEN = ISTRLN (STRING)

      DO 10  I = 1, JLEN
         IC = ICHAR (STRING (I:I))
         IF ((IC .LT. 65) .OR.  (IC .GT. 90))  GOTO 10
         STRING (I:I) = CHAR (IC + 32)
   10 CONTINUE

      RETURN
      END
C***********************************************************************
C
      SUBROUTINE BWORDS (S, NWORDS, WORDS)
C
C     Breaks string into words.  Words are seperated by one or more
C     blanks or tabs, or a comma and zero or more blanks.
C
C     ARGS        I/O      DESCRIPTION
C     ----        ---      -----------
C     S            I       CHAR*(*)  String to be broken up
C     NWORDS      I/O      Input:  Maximum number of words to get
C                          Output: Number of words found
C     WORDS(NWORDS) O      CHAR*(*) WORDS(NWORDS)
C                          Contains words found.  WORDS(J), where J is
C                          greater then NWORDS found, are undefined on
C                          output.
C
C      Written by:  Steven Zabinsky, September 1984
C      Tab char added July 1994.
C
C**************************  Deo Soli Gloria  **************************

C  -- No floating point numbers in this routine.
      IMPLICIT INTEGER (A-Z)

      CHARACTER*(*) S, WORDS(NWORDS)

      CHARACTER BLANK, COMMA, TAB
      PARAMETER (BLANK = ' ', COMMA = ',', TAB = '	')
C     there is a tab character here               ^.

C  -- BETW    .TRUE. if between words
C     COMFND  .TRUE. if between words and a comma has already been found
      LOGICAL BETW, COMFND

C  -- Maximum number of words allowed
      WORDSX = NWORDS

C  -- SLEN is last non-blank character in string
      SLEN = ISTRLN (S)

C  -- All blank string is special case
      IF (SLEN .EQ. 0)  THEN
         NWORDS = 0
         RETURN
      ENDIF

C  -- BEGC is beginning character of a word
      BEGC = 1
      NWORDS = 0

      BETW   = .TRUE.
      COMFND = .TRUE.

      DO 10  I = 1, SLEN
         IF (S(I:I) .EQ. BLANK .OR. S(I:I) .EQ. TAB)  THEN
            IF (.NOT. BETW)  THEN
               NWORDS = NWORDS + 1
               WORDS (NWORDS) = S (BEGC : I-1)
               BETW = .TRUE.
               COMFND = .FALSE.
            ENDIF
         ELSEIF (S(I:I) .EQ. COMMA)  THEN
            IF (.NOT. BETW)  THEN
               NWORDS = NWORDS + 1
               WORDS (NWORDS) = S(BEGC : I-1)
               BETW = .TRUE.
            ELSEIF (COMFND)  THEN
               NWORDS = NWORDS + 1
               WORDS (NWORDS) = BLANK
            ENDIF
            COMFND = .TRUE.
         ELSE
            IF (BETW)  THEN
               BETW = .FALSE.
               BEGC = I
            ENDIF
         ENDIF

         IF (NWORDS .GE. WORDSX)  RETURN

   10 CONTINUE

      IF (.NOT. BETW  .AND.  NWORDS .LT. WORDSX)  THEN
         NWORDS = NWORDS + 1
         WORDS (NWORDS) = S (BEGC :SLEN)
      ENDIF

      RETURN
      END
      SUBROUTINE UNTAB (STRING)
C REPLACE TABS WITH BLANKS :    TAB IS ASCII DEPENDENT
      INTEGER        ITAB , I, ILEN, ISTRLN
      PARAMETER      (ITAB = 9)
      CHARACTER*(*)  STRING, TAB*1
      EXTERNAL ISTRLN
      TAB  = CHAR(ITAB)
      ILEN = MAX(1, ISTRLN(STRING))
 10   CONTINUE 
        I = INDEX(STRING(:ILEN), TAB ) 
        IF (I .NE. 0) THEN
            STRING(I:I) = ' '
            GO TO 10
        END IF
      RETURN
C END SUBROUTINE UNTAB
      END

      logical function iscomm (line)
c     returns true if line is a comment or blank line, false otherwise
c#mn{ rewritten to allow ";*%#" as comment characters
       character*(*) line
       iscomm = ((line.eq.' ').or.(index(';*%#',line(1:1)).ne.0))
c#mn}
      return
      end

      subroutine soldir (en,fl,agi,api,ainf,nq,kap,max0,ifail)
c                  resolution of the dirac equation
c                   p' - kap*p/r = - ( en/cl-v )*g - eg/r
c                   g' + kap*g/r = ( 2*cl+en/cl-v )*p + ep/r
c at the origin v approximately is -z/(r*cl) due to the point nucleus
c en one-electron energy in atomic units and negative
c fl power of the first term in development at the origin
c agi (api) initial values of the first development coefficient
c at the origin of the large(small)component
c ainf initial value for the large component at the point dr(max0)
c nq principal quantum number     kap quantum number kappa
c max0 the last point of tabulation of the wave function
c        this programm uses intdir
 
      implicit double precision (a-h,o-z)
      common/comdir/cl,dz,gg(251),ag(10),gp(251),ap(10),dv(251),av(10),
     2eg(251),ceg(10),ep(251),cep(10)
c gg,gp -output, dv,eg,ep - input
      dimension hg(251),agh(10),
     1hp(251),aph(10),bg(251),bgh(10),bp(251),bph(10)
c
c cl speed of light (approximately 137.037 in atomic units)
c dz nuclear charge
c gg (gp) large (small) component
c hg,hp,bg et bp working space
c dv direct potential (v)     eg and ep exchange potentials
c ag,ap,agh,aph,bgh,bph,av,ceg and cep are respectively the
c development coefficients for gg,gp,hg,hp,bg,bp,dv,eg et ep
c
      common/tabtes/hx,dr(251),test1,test2,ndor,np,nes,method,idim
c
c hx exponential step
c dr radial mesh
c test1 precision for the matching the small component if method=1
c test2 precision for the normalisation if method=2
c ndor number of terms for the developments at the origin
c np maximum number of the tabulation points
c nes maximum number of attempts to ajust the small component
c method at the initial time distinguish the homoginious (method=0)
c  from inhomoginious system. at the end is the index of method used.
c idim dimension of the block dr

      common/subdir/ell,fk,ccl,imm,nd,node,mat

c ell fk*(fk+1)/ccl     fk=kap     ccl=cl+cl
c imm a flag for the determination of matching point
c nd number of nodes found     node number of nodes to be found
c mat index of the matching point

      common/messag/dlabpr,numerr
      character*8 dprlab,dlabpr, drplab
c at the time of return numerr should be zero if integration is correct,
c otherwise numerr contains the number of instruction, which
c indicate the sourse and reason for abnornal return.
*     character*512 slog
      save

      data dprlab/'  soldir'/,drplab/'  intdir'/
      dlabpr=dprlab
      enav=1.0d 00
      ainf= abs(ainf)
      ccl=cl+cl
      iex=method
      if (method.le.0) method=1
c notice that iex=0,1 and method=1,2 only below.
c this was used to simplify block structure of program. ala 11/22/94
      fk=kap
      if (av(1).lt.0.0d 00.and.kap.gt.0) api=-agi*(fk+fl)/av(1)
      if (av(1).lt.0.0d 00.and.kap.lt.0) api=-agi*av(1)/(fk-fl)
      ell=fk*(fk+1.0d 00)/ccl
      node=nq- abs(kap)
      if (kap.lt.0) node=node+1
      emin=0.0
      do 91 i=1,np
         a=(ell/(dr(i)*dr(i))+dv(i))*cl
         if (a.lt.emin) emin=a
 91   continue
      if (emin .ge. 0.0) then
         numerr=75011
c       *potential is apparently positive
         return
      endif
      if (en.lt.emin) en=emin*0.9d 00
      edep=en

 101  numerr=0
      test=test1
      if (method.gt.1) test=test2
      einf=1.0d 00
      esup=emin
      en=edep
      ies=0
      nd=0
 105  jes=0
 106  modmat=0
      imm=0
      if ( abs((enav-en)/en).lt.1.0d-01) imm=1
      enav=en
 
c     integration of the inhomogenious system
 107  do 111 i=1,idim
         gg(i)=eg(i)
 111     gp(i)=ep(i)
      do 115 i=2,ndor
         ag(i)=ceg(i-1)
 115     ap(i)=cep(i-1)
      call intdir (gg,gp,ag,ap,ggmat,gpmat,en,fl,agi,api,ainf,max0)
      if (numerr.ne.0) then
         dlabpr=drplab
         return
      endif
      if (iex.ne.0) go to 141
 
c     match large component for the homogenios system(method=0)
      a=ggmat/gg(mat)
      do 135 i=mat,max0
         gg(i)=a*gg(i)
 135     gp(i)=a*gp(i)
      j=mat
      go to 215
 
c     integration of the homogenios system
 141  do 151 i=1,idim
            hg(i)=0.0d 00
 151     hp(i)=0.0d 00
      do 155 i=1,ndor
         agh(i)=0.0d 00
 155     aph(i)=0.0d 00
      imm=1
      if (method.eq.1) imm=-1
      call intdir (hg,hp,agh,aph,hgmat,hpmat,en,fl,agi,api,ainf,max0)
 
c     match the large component for inhomogenious system(method=1)
      a=gg(mat)-ggmat
      if (method.lt.2) then
         b=-a/hg(mat)
      else
         b=gp(mat)-gpmat
         ah=hpmat*hg(mat)-hgmat*hp(mat)
         if (ah.eq.0.0d 00) go to 263
         c=(b*hg(mat)-a*hp(mat))/ah
         b=(b*hgmat-a*hpmat)/ah
         do 165 i=1,ndor
            ag(i)=ag(i)+c*agh(i)
 165        ap(i)=ap(i)+c*aph(i)
         j=mat-1
         do 168 i=1,j
            gg(i)=gg(i)+c*hg(i)
 168        gp(i)=gp(i)+c*hp(i)
      endif
      do 173 i=mat,max0
         gg(i)=gg(i)+b*hg(i)
 173     gp(i)=gp(i)+b*hp(i)

      if (method.ge.2) then
c        integration of the system derived from disagreement in energy
         do 175 i=2,ndor
            bgh(i)=ag(i-1)/cl
 175        bph(i)=ap(i-1)/cl
         do 177 i=1,max0
            bg(i)=gg(i)*dr(i)/cl
 177        bp(i)=gp(i)*dr(i)/cl
         call intdir (bg,bp,bgh,bph,bgmat,bpmat,en,fl,agi,api,ainf,max0)
 
c        match both components for inhomogenious system (method=2)
         f=bg(mat)-bgmat
         g=bp(mat)-bpmat
         a=(g*hg(mat)-f*hp(mat))/ah
         g=(g*hgmat-f*hpmat)/ah
         do 181 i=1,j
            bg(i)=bg(i)+a*hg(i)
 181        bp(i)=bp(i)+a*hp(i)
         do 182 i=1,ndor
            bgh(i)=bgh(i)+a*agh(i)
 182        bph(i)=bph(i)+a*aph(i)
         do 183 i=mat,max0
            bg(i)=bg(i)+g*hg(i)
 183        bp(i)=bp(i)+g*hp(i)
c        calculate the norm 
         call norm(b,hp,dr,gg,gp,ag,ap,method,hx,ndor,
     1     gpmat,fl,max0,mat)
 
c        correction to the energy (method=2)
         do 186 i=1,max0
 186     hg(i)=(gg(i)*bg(i)+gp(i)*bp(i))*dr(i)
         ah=0.0d 00
         c=0.0d 00
         do 187 i=2,max0,2
 187     ah=ah+hg(i)+hg(i)+hg(i+1)
         ah=hx*(ah+ah+hg(1)-hg(max0))/3.0d 00+hg(1)/(fl+fl+1.0d 00)
         f=(1.0d 00-b)/(ah+ah)
         c=1.0d 00-b
         do 191 i=1,max0
            gg(i)=gg(i)+f*bg(i)
 191        gp(i)=gp(i)+f*bp(i)
         do 195 i=1,ndor
            ag(i)=ag(i)+f*bgh(i)
 195        ap(i)=ap(i)+f*bph(i)
      endif
 
c     search for the maximum of the modulus of large component
      a=0.0d 00
      bgh(1)=b
      bph(1)=ah
      do 211 i=1,max0
         g=gg(i)*gg(i)
         if (g.le.a) go to 211
         a=g
         j=i
 211  continue
      if (j.gt.mat .and. modmat.eq.0) then
         modmat=1
         mat=j
         if (mod(mat,2).eq.0) mat=mat+1
         imm=1
         if (mat.lt.(max0-10)) go to 107

         mat=max0-12
         j=mat
         if (mod(mat,2).eq.0) mat=mat+1
c        write(slog,'(a,i4,a,i4)') ' warning  mat=',mat,' max0=',max0
c        call wlog(slog)
      endif
c this case can happen due to bad starting point in scf procedure.
c ignore this warning unless you are getting it at final norb calls
c of soldir
c  redirected by ala 11/21/94.
c     numerr=220021
c * impossible matching point
c     go to 899
 
c compute number of nodes
 215  nd=1
      j= max(j,mat)
      do 231 i=2,j
         if (gg(i-1).eq.0.0d 00) go to 231
         if ((gg(i)/gg(i-1)).le.0.0d 00) nd=nd+1
 231  continue

      if (nd-node) 251,305,261
 251  esup=en
      if (einf.lt.0.0d 00) go to 271
      en=en*8.0d-01
      if ( abs(en).gt.test1) go to 285
      numerr=238031
c    *zero energy
      go to 899

 261  einf=en
      if (esup.gt.emin) go to 271
 263  en=en*1.2d 00
      if (en.gt.emin) go to 285
      numerr=245041
c    *energy is lower than the minimum of apparent potential
      go to 899

 271  if ( abs(einf-esup).gt.test1) go to 281
      numerr=249051
c    *the upper and lower limits of energy are identical
      go to 899

 281  en=(einf+esup)/2.0d 00

 285  jes=jes+1
      if (jes.le.nes) go to 106
 
c *number of attempts to find good number of nodes is over the limit
c this case can happen due to bad starting point in scf procedure.
c ignore this warning unless you  got it at final norb calls of soldir
c     call wlog('warning jes>nes')
      ifail=1
c    *redirected by ala 11/21/94.
c     numerr=255061
c     go to 899

c     calculation of the norm
 305  call norm(b,hp,dr,gg,gp,ag,ap,method,hx,ndor,
     1     gpmat,fl,max0,mat)
      if (method.eq.1) then
c        correction to the energy (method=1)
         c=gpmat-gp(mat)
         f=gg(mat)*c*cl/b
         if (gpmat.ne.0.0d 00) c=c/gpmat
      endif

      en=en+f
      g= abs(f/(en-f))
 371  if ((en.ge.0 .or. g.gt.2.0d-01) .or.
     1 (abs(c).gt.test .and. (en.lt.esup.or.en.gt.einf))) then
c        try smaller step in enrgy under above conditions
         f=f/2.0d 00
         g=g/2.0d 00
         en=en-f
         if (g.gt.test1) go to 371
         numerr=29071
c       *zero energy
         go to 899
      endif

      if ( abs(c).gt.test)  then
         ies=ies+1
         if (ies.le.nes) go to 105
         ifail=1
c        call wlog('warning: iteration stopped because ies=nes')
c     everything is fine unless you got this message on the latest stage
c     of selfconsistent process. just stopped trying to match lower
c     component, because number of trials exceeded limit.
c     lines below were commented out.  ala 11/18/94
      endif

c     numerr=298081
c    *number of attempts to match the lower component is over the limit
c     go to 899
 
c     divide by a square root of the norm, and test the sign of w.f.
      b= sqrt(b)
      c=b
      if ((ag(1)*agi).lt.0.0d 00.or.(ap(1)*api).lt.0.0d 00) c=-c
      do 711 i=1,ndor
         ag(i)=ag(i)/c
 711     ap(i)=ap(i)/c
      if ((gg(1)*agi).lt.0.0d 00.or.(gp(1)*api).lt.0.0d 00) b=-b
      do 721 i=1,max0
         gg(i)=gg(i)/b
 721     gp(i)=gp(i)/b
      if (max0.ge.np) return
      j=max0+1
      do 741 i=j,np
         gg(i)=0.0d 00
 741     gp(i)=0.0d 00
c     if everything o'k , exit is here.
      return

c     abnormal exit is here, if method.ne.1
 899  if (iex.eq.0 .or. method.eq.2) go to 999
      method=method+1
      go to 101

 999  return
      end

      subroutine norm(b,hp,dr,gg,gp,ag,ap,method,hx,ndor,
     1 gpmat,fl,max0,mat)
c    calculate norm b. this part of original code was used twice,
c    causing difficult block structure. so it was rearranged into
c    separate subroutine. ala 
      implicit double precision (a-h, o-z)
      dimension hp(251),dr(251),gg(251),gp(251),ag(10),ap(10)

      b=0.0d 00
      do 311 i=1,max0
 311  hp(i)=dr(i)*(gg(i)*gg(i)+gp(i)*gp(i))
      if (method.ne.1) go to 315
      hp(mat)=hp(mat)+dr(mat)*(gpmat**2-gp(mat)**2)/2.0d 00
 315  do 321 i=2,max0,2
 321  b=b+hp(i)+hp(i)+hp(i+1)
      b=hx*(b+b+hp(1)-hp(max0))/3.0d 00
      do 325 i=1,ndor
         g=fl+fl+i
         g=(dr(1)**g)/g
         do 325 j=1,i
 325     b=b+ag(j)*g*ag(i+1-j)+ap(j)*g*ap(i+1-j)
      return
      end

      subroutine sthead (ntitle, title, nph, iz, rmt, rnrm,
     1     xion, ihole, ixc,
     2     vr0, vi0, gamach, xmu, xf, vint, rs,
     2     lreal,  rgrd)

c     SeT HEAD
c     This routine makes the file header, returned in head array.
c     header lines do not include a leading blank.
c     Last header line is not --------- end-of-header line

c     title lines coming into sthead include carriage control, since
c     they were read from potph.bin

      implicit double precision (a-h, o-z)

      include '../HEADERS/const.h'
      include '../HEADERS/dim.h'
      include '../HEADERS/vers.h'

      dimension xion(0:nphx)
      dimension iz(0:nphx)
      dimension rmt(0:nphx)
      dimension rnrm(0:nphx)

      character*80 title(nheadx), store
      character*16 s1, s2

      character*10 shole(0:29)
      character*8  sout(0:7)
      data shole /'no hole',   'K  shell',  'L1 shell',  'L2 shell',
     2            'L3 shell',  'M1 shell',  'M2 shell',  'M3 shell',
     3            'M4 shell',  'M5 shell',  'N1 shell',  'N2 shell',
     4            'N3 shell',  'N4 shell',  'N5 shell',  'N6 shell',
     5            'N7 shell',  'O1 shell',  'O2 shell',  'O3 shell',
     6            'O4 shell',  'O5 shell',  'O6 shell',  'O7 shell',
     7            'P1 shell',  'P2 shell',  'P3 shell',  'P4 shell',
     8            'P5 shell',  'R1 shell'/
      data sout /'H-L exch', 'D-H exch', 'Gd state', 'DH - HL ',
     1           'DH + HL ', 'val=s+d ', 'sigmd(r)', 'sigmd=c '/


c     Fills head arrray, n = number of lines used.
c     Does not include line of dashes at the end.

      if (ntitle .ge. 1 ) then
         ii = istrln(title(1)) 
         if (ii.gt.1)  then
            write(store,100)  title(1)(1:59), vfeff//vf85e
         else
            write(store,102)  vfeff//vf85e
         endif
      else
         write(store,102)   vfeff//vf85e
      endif
  100 format( a45, t48, a30)
  102 format( t48, a30)
      title(1) = store
      nstor = 1

c     remove empty title lines
      do 120  ititle = 2, ntitle
         ii = istrln ( title (ititle) ) 
         if (ii.le.1)  goto 120
         nstor = nstor+1
         title(nstor) = title (ititle)
  120 continue
      ntitle = nstor

c     add more title lines
      if (xion(0) .ne. 0)  then
         ntitle = ntitle + 1
         write(title(ntitle),130)  iz(0), rmt(0)*bohr,
     1                    rnrm(0)*bohr, xion(0), shole(ihole)
      else
         ntitle = ntitle + 1
         write(title(ntitle),140)  iz(0), rmt(0)*bohr,
     1                    rnrm(0)*bohr, shole(ihole)
      endif
  130 format('Abs   Z=',i2, ' Rmt=',f6.3, ' Rnm=',f6.3,
     1       ' Ion=',f5.2,  1x,a10)
  140 format('Abs   Z=',i2,' Rmt=',f6.3,' Rnm=',f6.3, 1x,a10)
      if (lreal.ge.1 .or. (abs(rgrd - 0.05) .gt. 1.0e-5)) then
        ntitle = ntitle + 1
        s1 = ' '
        if (lreal.gt.1)  then
c        write(title(ntitle),144)
c 144    format ('Calculations done using only real phase shifts.')
         s1 = 'RPHASES'
        elseif (lreal.eq.1) then
c        ntitle = ntitle + 1
c        write(title(ntitle),145)
c 145    format ('Calculations done using only real self energy.')
         s1 = 'RSIGMA'
        endif
        s2 = '  '
        if (abs(rgrd - 0.05) .gt. 1.0e-5)  then
         write(s2,146)  rgrd
  146    format ('  RGRID', f7.4)
        endif
        ilen = istrln(s1)
        title(ntitle) = s1(1:ilen) // s2
      endif

      do 150  iph = 1, nph
         if (xion(iph) .ne. 0)  then
            ntitle = ntitle + 1
            write(title(ntitle),160)  iph, iz(iph),  rmt(iph)*bohr,
     1           rnrm(iph)*bohr, xion(iph)
         else
            ntitle = ntitle + 1
            write(title(ntitle),170)  iph, iz(iph),  rmt(iph)*bohr,
     1           rnrm(iph)*bohr
         endif
  150 continue
  160 format('Pot',i2,' Z=',i2,' Rmt=',f6.3,' Rnm=',f6.3,' Ion=',f5.2)
  170 format('Pot',i2,' Z=',i2,' Rmt=',f6.3,' Rnm=',f6.3)
      if (abs(vi0) .gt. 1.0e-8 .or. abs(vr0) .gt. 1.0e-8)  then
         ntitle = ntitle + 1
         write(title(ntitle),180)  gamach*hart, sout(ixc), vi0*hart,
     1                           vr0*hart
      else
         ntitle = ntitle + 1
         write(title(ntitle),190)  gamach*hart, sout(ixc)
      endif
      ntitle = ntitle + 1
  180 format('Gam_ch=',1pe9.3, 1x,a8, ' Vi=',1pe10.3, ' Vr=',1pe10.3)
  190 format('Gam_ch=',1pe9.3, 1x,a8)
  200 format('Mu=',1pe10.3, ' kf=',1pe9.3, ' Vint=',1pe10.3,
     x        ' Rs_int=',0pf6.3)
      write(title(ntitle),200)  xmu*hart, xf/bohr, vint*hart, rs

      return
      end

      subroutine wthead (io, ntitle, title)
c     Dump title lines to unit io, which must be open. 
      integer io, i, ll
      character*80 title(ntitle)

c     nice for UNIX to use with gnuplot etc.,
      do 310 i = 1, ntitle
         ll = istrln(title(i))
         write(io,300)  title(i)(1:ll)
  300    format (a)
  310 continue

      return
      end

      subroutine ff2chi (ipr4, critcw, s02, tk, thetad, icsig,
     1                   vrcorr, vicorr)
c     modified for feff6l by jjr
      implicit double precision (a-h, o-z)

      include 'vers.h'
      include 'const.h'

      parameter (delk = 0.05)
      parameter (eps = 1.0e-10)
      parameter (eps4 = 1.0e-4)
c     e (eV) = bohr**2 * ryd * k**2 (k in invA), b2r ~=3.81
      parameter (b2r = bohr**2 * ryd)

c     This is set in dim.h for other parts of the code
      parameter (nex = 100)

c     Max number of points on fine k grid for chi output
      parameter (nfinex = 601)

      dimension achi(nex), achix(nex)
      dimension xk(nex), cdelta(nex), afeff(nex), phfeff(nex),
     1          redfac(nex), xlam(nex), rep(nex)

      dimension emxs(nex), omega(nex), xkxs(nex), xsec(nex)

      complex*16 p2, pp2
      complex*16 ck(nex), dw
      complex*16 cchi(nfinex), ccc, ccpath(nfinex)

c     head is headers from files.dat, hdxs is headers from xsect.bin
      parameter (nheadx = 30)
      character*80 head(nheadx), hdxs(nheadx)
      dimension lhead(nheadx), lhdxs(nheadx)

      parameter (nlegx = 10)
      dimension rat(3,0:nlegx), iz(0:nlegx)

      character*80  line, out_message*256
      parameter (nwordx = 4)
      character*50  words(nwordx), fname

c     do (or don't) correlated debye model dw factor
      logical dwcorr
c     write xmu file only if xsect.bin exists
      logical wxmu

c     icsig 0, use real    momentum for debye waller factor
c           1, use complex momentum for debye waller factor

c     NB: code units for this module are Ang, Ang**-1, eV, etc.
      vrcorr = vrcorr * ryd
      vicorr = vicorr * ryd

      do 22  i = 1, nfinex
         cchi(i) = 0
   22 continue

c     Keep stats on total paths and paths used to make chi
      ntotal = 0
      nused = 0

c     open files.dat
      open (unit=2, file='files.dat', status='old', iostat=ios)
      call chopen (ios, 'files.dat', 'ff2chi')
      nhead = nheadx
      call rdhead (2, nhead, head, lhead)
c     header from rdhead includes carriage control
c     skip a label line
      read(2,*)

      dwcorr = .false.
      if (tk .gt. 1.0e-1)  dwcorr = .true.

c     Open chi.dat and xmu.dat (output) and start header
      open (unit=3, file='chi.dat', status='unknown', iostat=ios)
      call chopen (ios, 'chi.dat', 'ff2chi')
c      open (unit=8, file='xsect.bin', status='old', iostat=ios)
      wxmu = .false.
      if (ios .le. 0)  wxmu = .true.
      if(wxmu) then
c        read xsect.bin
         nhdxs = nheadx
c        skip label
cc         edge0 = (emxs(1)/ryd + xkxs(1)**2*bohr**2)*ryd

      endif

      do 14  ihead = 1, nhead
         if (lhead(ihead) .gt. 0)  then
            write(3,12) head(ihead)(1:lhead(ihead))
         endif
   12    format (a)
   14 continue
      if (dwcorr)  then
         write(3,800)  s02, tk, thetad, vfeff, vff2ch
  800    format (' S02', f7.3, '   Temp', f8.2, '  Debye temp', f8.2,
     1           t57, 2a12)
      else
         write(3,801)  s02, vfeff, vff2ch
  801    format (' S02', f7.3, t57, 2a12)
      endif

      if (abs(vrcorr).ge.eps4 .or. abs(vicorr).ge.eps4)  then
         write(out_message,802) vrcorr, vicorr
         write(3,'(a)') out_message
         call echo(out_message)
      endif
  802 format (' Energy zero shift, vr, vi ', 1p, 2e14.5)


      if (critcw .gt. 0)  write(3,15) critcw
   15 format (' Curved wave amplitude ratio filter ', f7.3, '%')
      write(3,16)
   16 format ('    file           sig2  cw amp ratio   deg',
     1        '  nlegs  r effective')

c     Open sig2.dat if necessary (output) and start header
      if (ipr4 .ge. 1)  then
         open (unit=4, file='sig2.dat', status='unknown', iostat=ios)
         call chopen (ios, 'sig2.dat', 'ff2chi')
         do 514  ihead = 1, nhead
            if (lhead(ihead) .gt. 0)
     1            write(4,12) head(ihead)(1:lhead(ihead))
  514    continue
         if (dwcorr)  then
            write(4,800)  s02, tk, thetad, vfeff, vff2ch
         else
            write(4,801)  s02, vfeff, vff2ch
         endif
         write(4,16)
      endif
       write(out_message, 515) critcw
       call echo(out_message)
  515 format ('    Use all paths with cw amplitude ratio', f7.2, '%')
      if (dwcorr)  then
         write(out_message, 516) s02, tk, thetad
      else
         write(out_message, 517) s02
      endif
       call echo(out_message)
  516 format('    Use correlated Debye model.  S02', f7.3,
     1        '  Temp', f8.2, '  Debye temp', f8.2)
  517 format('    Use Debye-Waller factors from files.dat.  S02', f7.3)

   10 continue
         read(2,11,end=399)  line
   11    format (a)
         call triml (line)
         nwords = nwordx
         call bwords (line, nwords, words)
c        if line was blank, skip it and go on to next line
         if (nwords .lt. 1)  goto 10

         ntotal = ntotal+1
c        word 1 - feff.dat file name
c             2 - sig2 for path
c             3 - amplitude ratio, full k range

         read(words(2),40,err=900)  sig2
         read(words(3),40,err=900)  crit
   40    format (bn, f15.0)
c        Skip un-important path

c        Write output if path is important enough (ie, path is
         if (crit .lt. critcw)  then
            write(out_message,17) words(1)(1:15), crit, '  (not used) '
 17         format (4x, a, f10.4, a)
            call echo(out_message)
            goto 10
         endif

c      Read feff.dat file
         nused = nused+1
         write(out_message,17) words(1)(1:15), crit
         call echo(out_message)
         fname = words(1)
         open (unit=1, file=words(1), status='old', iostat=ios)
         call chopen (ios, words(1), 'ff2chi')
         nhead = nheadx
         call rdhead (1, nhead, head, lhead)
         read(1,*)  nleg, deg, reff, rs, edge
         if (abs(vrcorr) .gt. eps4) edge = edge-vrcorr
         if (nleg .gt. nlegx)  then
            call fstop(' at FF2CHI: too many legs')
         endif
c        skip label
         read(1,*)
         do 30  ileg = 0, nleg-1
            read(1,*) (rat(j,ileg),j=1,3), ipot, iz(ileg)
   30    continue
c        skip label
         read(1,*)
         do 20  j = 1, 3
            rat(j,nleg) = rat(j,0)
   20    continue
         iz(nleg) = iz(0)

c        Get sig2 from correlated debye model if required
         if (dwcorr)  then
c           replace sig2 from files.dat
            call sigms (tk, thetad, rs, nlegx, nleg, rat, iz, sig2)
         endif

c        Put path into chi.dat header, sig2.dat as required
         write(3,110)  words(1)(1:15), sig2, crit,
     1                 deg, nleg, reff
         if (ipr4 .ge. 1)  then
            write(4,110)  words(1)(1:15), sig2, crit,
     1                    deg, nleg, reff
         endif
  110    format(1x, a, f8.5, 2f10.2, i6, f9.4)

c        read data
         i = 1
  120    read(1,*,end=130)  xk(i), cdelta(i), afeff(i),
     1             phfeff(i), redfac(i), xlam(i), rep(i)

c           make complex momentum
c           add correction to imag part of energy to xlam here

c           use atomic units for this
            viryd = vicorr / ryd
            preal = rep(i) * bohr
            xlamb = xlam(i) / bohr
            pimag = 1 / xlamb
c           p2 is p**2, pp2 is p' **2 (p prime squared, new p)
            p2 = (preal + coni*pimag)**2
            pp2 = p2 + coni*viryd
            ck(i) = sqrt (pp2)
            xlam(i) = 1 / dimag(ck(i))
            rep(i) = dble(ck(i))
c           put everything back into Ang and invAng
            ck(i) = ck(i) / bohr
            xlam(i) = xlam(i) * bohr
            rep(i) = rep(i) / bohr

            npts = i
            i = i+1
         goto 120
  130    continue
         close(unit=1)

c        Make chi, note that |feff| at k=0 is zero.  Must interpolate
c        or extrapolate to find it.  Can interpolate when we have 
c        data for k<0, but just extrapolate for all cases for now.
         iextr = 0
         do 300  i = 1, npts

c           extrapolate chi when k=0, otherwise calculate it
c           achi has no 2kr term
            dw = exp(-2*sig2*ck(i)**2)
            phdw = atan2 (dimag(dw), dble(dw))
            if (abs(xk(i)) .lt. 0.01)  then
               iextr = i
            else
               achi(i) = afeff(i) * deg * abs(dw) *
     1             exp(-2*reff/xlam(i)) * redfac(i) * s02 / 
     2             (abs(xk(i))*reff**2)
            endif
            achix(i) = cdelta(i) + phfeff(i) + phdw
  300    continue
c        fill in achi where extrapolation necessary
         if (iextr .gt. 0)  then
            achi(iextr) = 2*achi(iextr+1) - achi(iextr+2)
         endif

c        make sure no 2pi jumps in phase
         do 310  i = 2, npts
            call pijump (achix(i), achix(i-1))
  310    continue

c        Decide on fine grid -- need k' if vrcorr /= 0
         if (abs(vrcorr) .gt. eps4)  then
            xkpmin = xk2xkp (xk(1), vrcorr)
            n = xkpmin / delk
c           need 1st int ABOVE xkpmin/delk
            if (xkpmin .gt. 0)  n = n+1
c           First k grid point moved by vrcorr
            xkmin = n * delk
         else
c           Use unmodified grid
            xkmin = xk(1)
         endif

c        sum chi on fine k grid
         nkx = nfinex
         do 330  i = 1, nfinex
c           xkout is k value for output, xk0 is k value used for 
c           interpolation and reconstruction of chi with original grid.
c           If vrcorr=0, xk0 and xkout will be the same.
            xkout = delk * (i-1) + xkmin
            xk0 = xkp2xk (xkout, vrcorr)

c           find end of data, eps4 is to handle round-off (we've been 
c           reading files with limited precision)
            if (xk0 .gt. xk(npts)+eps4)  then
               nkx = i-1
               goto 331
            endif
            call terp (xk, achi,  npts, xk0, achi0)
            call terp (xk, achix, npts, xk0, achix0)
            cchi(i) = cchi(i) + achi0 *
     1                exp (coni * (2*xk0*reff + achix0))
            ccpath(i) = achi0 * exp (coni * (2*xk0*reff + achix0))
  330    continue
  331    continue

c        write out a chinnnn.dat for this path, if necessary.  Headers
c        later...
         if (ipr4 .ge. 2)  then
c           Assume file is form  feffnnnn.whatever, change it to
c                                chipnnnn.whatever.  Other filenames
c           will turn out wierdly
            fname(1:4) = 'chip'
            open (unit=9, file=fname, status='unknown')
            do 370  ihead = 1, nhead
               if (lhead(ihead) .gt. 0)  then
                  write(9,12) head(ihead)(1:lhead(ihead))
               endif
  370       continue
            if (dwcorr)  then
               write(9,800)  s02, tk, thetad, vfeff, vff2ch
            else
               write(9,801)  s02, vfeff, vff2ch
            endif

            if (abs(vrcorr).ge.eps4 .or. abs(vicorr).ge.eps4)  then
               write(9,802)  vrcorr, vicorr
            endif
            write(9,*) 'Debye-waller factor ', sig2

            write(9,407)
            write(9,338)
  338       format ('       k         chi           mag          ',
     1              'phase        phase-2kr  @#')
            do 340  i = 1, nkx
               xk0 = delk * (i-1) + xkmin
               ccc = ccpath(i)
               phase=0
               if (abs(ccc) .gt. 0)  phase=atan2(dimag(ccc), dble(ccc))
               if (i .gt. 1)  call pijump (phase, phase0)
               phase0 = phase
               write(9,410)  xk0, dimag(ccc), abs(ccc), phase,
     1                       phase-2*xk0*reff
  340       continue
         endif

      goto 10
  399 continue
      close (unit=2)

c     Write it out
      write(3,405)  nused, ntotal
  405 format (1x, i4, '/', i4, ' paths used')
      write(3,407)
  407 format (1x, 79('-'))
      write(3,406)
  406 format ( '      k          chi          mag           phase @#')
      do 420  i = 1, nkx
         xk0 = delk * (i-1) + xkmin
         ccc = cchi(i)
         phase=0
         if (abs(ccc) .gt. 0)  phase=atan2(dimag(ccc), dble(ccc))
         if (i .gt. 1)  call pijump (phase, phase0)
         phase0 = phase
         write(3,410)  xk0, dimag(ccc), abs(ccc), phase
  410    format (1x, f10.4, 3x, 4(1pe13.6,1x))
  420 continue
      close (unit=3)


       write(out_message, 500) nused, ntotal
       call echo(out_message)
  500 format (' ff2chi done, ', i4, '/', i4, ' paths used.')
      return

 900   call fstop(' at FF2CHI: reading '//
     $     'files.dat importance factors')
       end

c     following functions use invA and eV as input and output,
c     internal workings in atomic units

      double precision function xk2xkp (xk, vrcorr)
      implicit double precision (a-h, o-z)
      include 'const.h'
      xk0 = xk*bohr
      vr = vrcorr / ryd
      xksign = sign (one, xk0)
      e = xksign*xk0**2 + vr
      xk2xkp = getxk(e) / bohr
      return
      end

      double precision function xkp2xk (xkp, vrcorr)
      implicit double precision (a-h, o-z)
      include 'const.h'
       external getxk
      xkp0 = xkp*bohr
      vr = vrcorr / ryd
      xkpsgn = sign (one, xkp0)
      e = xkpsgn*xkp0**2 - vr
      xkp2xk = getxk(e) / bohr
      return
      end

      subroutine json_read_atoms(nat, rat, iphat)

      use json_module
      implicit double precision (a-h, o-z)

      include '../HEADERS/const.h'
      include '../HEADERS/dim.h'

      logical :: found
      type(json_file) :: json   !the JSON structure read from the file:
      integer,dimension(:),allocatable :: intgs
      double precision,dimension(:),allocatable :: dbpcs, dbpcy, dbpcz

      integer nat, iphat(natx)
      double precision rat(3,natx)

      call json%load_file('atoms.json')
      if (json_failed()) then   !if there was an error reading the file
         print *, "failed to read atoms.json"
         stop
      else
         call json%get('natt', nat, found)
                   if (.not. found) call bailout('natt', 'atoms.json')
         call json%get('x',    dbpcs, found)
                   if (.not. found) call bailout('x', 'atoms.json')
         call json%get('y',    dbpcy, found)
                   if (.not. found) call bailout('y', 'atoms.json')
         call json%get('z',    dbpcz, found)
                   if (.not. found) call bailout('z', 'atoms.json')
         call json%get('iphatx', intgs, found)
                   if (.not. found) call bailout('iphatx', 'atoms.json')
         do 20 i=1,nat
            iphat(i)  = intgs(i)
            rat(1,i)  = dbpcs(i)
            rat(2,i)  = dbpcy(i)
            rat(3,i)  = dbpcz(i)
 20      continue
         call json%destroy()
      end if

      return
      end

      subroutine yprep(iph0, nat, inclus, iphat, rmax, rat)
c
c  removed izx, nopt, rdirec from arg list, unused or use commented out
c
c    yprep is the same as xprep for negative idwopt
c    simlifies calls in SCF and LDOS where DW factors should not enter

      implicit real (a-h,o-z)
      implicit integer (i-n)

      include '../HEADERS/dim.h'
      include '../HEADERS/const.h'
      include 'xparam.h'
c====================================================================
c  This header file contains the structural information about the
c  cluster to be used for the full multiple scattering calculation

      common /xstruc/ xphi(nclusx,nclusx), xrat(3,nclusx),
     $            iphx(nclusx)
      save /xstruc/

c  xphi:  matrix of angles between the z axis and pairs of atoms
c  xrat:  xyz coordinates of the atoms in the cluster, the first
c         npot+1 entries are examples of each unique potential
c  iphx:  potential indeces of each atom in the cluster, ordered like
c         xrat
c********************************************************************
c**** rotation matrices for entire cluster
c
      complex drix
      common /rotx/ drix(-lx:lx, -lx:lx, 0:lx, 0:1, nclusx, nclusx)
      save /rotx/
c********************************************************************
c common blocks for saving rotation matrices between xanes and rotxan
       integer    jsavx, jsav, jbmagk
       parameter (jsavx = 150, roteps = 1.e-12,jbmagk=-9999)
       dimension drisav(-lx:lx,-lx:lx,0:lx,jsavx), betsav(jsavx)
       integer   ldsav(jsavx), mdsav(jsavx)
       common /rotsav/  drisav, betsav, ldsav, mdsav, jsav
       save  /rotsav/
c********************************************************************
c**** legendre polynomial normalization constants
c
      common /lnlm/ xnlm(0:lx,0:lx)
      save   /lnlm/

c********************************************************************
c**** legendre polynomial normalization constants
c
      common /xdwf/ sigsqr(nclusx,nclusx)
      save   /xdwf/

c  end of xstruc.h
c********************************************************************
      integer   iphat(natxx), iphat2(natxx)
c      integer izpair(0:2), izx(0:nphasx)
      dimension rat(3,natxx), rat2(3,natxx)
      double precision ra(natxx)
      character*78 line
c     sigms is written in double precision.  these are the variables
c     that it uses
c      double precision dtemp, dthet, drs, dsigsq, pair(3,0:2)
c      double precision sig2mx, sig2x(0:nphx,0:nphx)
c     iwarn - needed to wrtite waqrning just one time
      integer iwarn
      save iwarn
      data  iwarn /0/

c  initialize geometrical arrays
      do 30 i=1,nclusx
        do 10 j=1,nclusx
          xphi(j,i) = zero
 10     continue
        do 20 j=1,3
          xrat(j,i) = zero
 20     continue
        iphx(i) = 0
 30   continue
      inclus = 0

c --- find the central atom, ipot=iph0 (iph0=0 for the absorbing atom)
      icen = 0
      do 40 i=1,nat
        iphat2(i) = iphat(i)
        if (iphat(i).eq.iph0) then
            if (icen.eq.0) then
                icen = i
            elseif (iph0.eq.0) then
                call wlog('* * * ERROR!  More than one atom '//
     $                      'in the extended cluster have ipot=0')
                call wlog('      You may only have one central atom.')
                call wlog('      Stopping in xprep.')
                call par_stop('YPREP-1')
            endif
        endif
 40   continue
c --- make sure central atom is at (0,0,0)
      do 45 i=1,nat
        rat2(1,i) = rat(1,i)-rat(1,icen)
        rat2(2,i) = rat(2,i)-rat(2,icen)
        rat2(3,i) = rat(3,i)-rat(3,icen)
 45   continue

c --- sort the atoms from extended cluster by distance from central
c     atom.
      call atheap(nat, rat2, iphat2, ra)

c --- define cluster from extended cluster by as those closer than
c     rmax to central atom
      inclus=0
      rmax2 = rmax**2
      do 50 i=1,nat
        rr = (rat2(1,i)**2 + rat2(2,i)**2 + rat2(3,i)**2)
        if (rr.gt.rmax2) then
            inclus = i-1
            goto 60
        endif
 50   continue
 60   continue
      if (inclus.eq.0) inclus=nat

c --- sanity check size of cluster
      if (inclus.gt.nclusx) then
        if (iwarn.eq.0) then
          call wlog('* * * WARNING preparing cluster for '//
     $                'FMS calculation.')
          write(line,400) inclus
 400      format('      You specified a cluster of ', i3,
     $                ' atoms for the FMS calculation.')
          call wlog(line)
          write(line,410)nclusx
          call wlog(line)
 410      format('      This exceeds the hard wired limit of ', i3,
     $                ' atoms.')
          write(line,420)nclusx
          call wlog(line)
 420      format('      The cluster size was reset to ', i3,
     $                ' and the calculation will continue.')
          iwarn = 1
        endif
        inclus = nclusx
      endif

c --- make the first few entries in xrat represent each of the
c     unique potentials, sorting around the chosen center
c     (iph0=0 for the absorbing atom)
c     call sortat(iph0, inclus, npot, iphat2, iphx, rat2, xrat)
      do 430 iat = 1, inclus
          iphx(iat) = iphat2(iat)
          xrat(1,iat) = real (rat2(1,iat))
          xrat(2,iat) = real (rat2(2,iat))
          xrat(3,iat) = real (rat2(3,iat))
 430  continue


c --- Calculate and store rotation matrix elements and phi angles
c     the k loop calculates the forward then the backward rotation
c     for an atom pair (ij). k = 0-->forward, 1-->backward
      call rotint
      lplus1 = lx+1
      mplus1 = lx+1
      do 150  i=1,inclus
        do 140 j=1,inclus
          rr = (xrat(1,i)-xrat(1,j))**2 + (xrat(2,i)-xrat(2,j))**2
     1       + (xrat(3,i)-xrat(3,j))**2
c         if (rr.gt.rdirec**2) goto 140

          call getang(nclusx, xrat, i, j, xbeta, xphi(i,j))
          if (i.eq.j) goto 140
          do 130 k=0,1
            if (k.eq.1) xbeta = (-1) * xbeta
            call rotxan(lplus1, mplus1, xbeta, i, j, k)
 130      continue
 140    continue
 150  continue

c --- calculate spherical harmonic normalization factors
      call xanlm(lplus1,mplus1)

      do 200 iat2=1,nclusx
      do 200 iat1=1,nclusx
        sigsqr(iat1,iat2) = zero
 200  continue

      return
      end

      subroutine ff2g (gtr, iph, ie, ilast, xrhoce, xrhole, xrhocp,
     1             ee, ep, yrhole, yrhoce,  yrhocp, rhoval, xnmues,
     2             xnatph, xntot, iflr, iflrp, fl, fr, iunf)
      implicit double precision (a-h, o-z)
c     the main output is l-dos in xrhoce, and valence density 
c     of states at distance r
c     in yrhoce, which at the input are only embedded atom quantities

      include '../HEADERS/const.h'
      include '../HEADERS/dim.h'

      complex*16 xrhoce(0:lx,0:nphx), xrhocp(0:lx,0:nphx)
      complex*16 yrhoce(251), yrhocp(251)
      complex*16 xrhole(0:lx)
      complex*16 yrhole(251,0:lx)
      complex gtr(0:lx)
      complex*16 ee, ep, del, der, fl, fr
      complex*16 cchi(0:lx)
      dimension xnmues(0:lx), rhoval(251)

c     chi from fms is contained in gtr
      do 200  j = 0, lx
         cchi(j) =  dble( real( gtr(j) )) + coni* dble(aimag( gtr(j) ))
  200 continue

      do 730 il = 0,lx
        xrhoce(il, iph)=xrhoce(il, iph)+
     1                       cchi(il)*xrhole(il) 
        if (ie.eq.1) xrhocp(il,iph) = xrhoce(il,iph)
  730 continue

      del = ee-ep
      der = del
c     if iflr=1 add/subtract integral from point to real axis
c     factor 2 below comes from spin degeneracy
      if (iflr.eq.1) der = der - coni * 2 * dimag(ee)
      if (iflrp.eq.1) del = del + coni * 2 * dimag(ep)
      do 750 il = 0, lx
        if (il.le.2 .or. iunf.ne.0) then
         fl = fl + 2 * xrhocp(il,iph) * xnatph
         fr = fr + 2 * xrhoce(il,iph) * xnatph
         xnmues(il) = xnmues(il) + 
     1        dimag( xrhoce(il,iph) * der + xrhocp(il,iph) * del )
         xntot = xntot + xnmues(il) * xnatph
        endif
  750 continue

cc    calculate r-dependent l-dos for later use
      do 840 il = 0,lx
      do 840 ir = 1,ilast
       if (il.le.2 .or. iunf.ne.0) then
        yrhoce(ir) = yrhoce(ir) + cchi(il)*yrhole(ir,il)
        if (ie.eq.1) yrhocp(ir) = yrhoce(ir)
       endif
  840 continue

      do 850 ir = 1, ilast
         rhoval(ir) = rhoval(ir) + dimag(yrhoce(ir)*der+yrhocp(ir)*del)
  850 continue

      return
      end

      subroutine snlm (lmaxp1, mmaxp1, xnlm)
      implicit double precision(a-h,o-z)

c     Set nlm, legendre normalization factors, xnlm in common /nlm/
c     Calculates legendre norm factors
c     xnlm= sqrt ((2l+1)(l-m)!/(l+m)!)

      include '../HEADERS/dim.h'
c     include 'nlm.h'
      dimension xnlm(ltot+1,mtot+1)


c     flg(i) = i! * afac**i, set in factst
      dimension flg(0:210)

      call factst (afac, flg)

c     initialize xnlm explicitly
      do 5  il = 1, ltot+1
      do 5  im = 1, mtot+1
         xnlm(il,im) = 0
    5 continue

      do 10  il = 1, lmaxp1
         mmxp1 = min (mmaxp1, il)
         do 10  im = 1, mmxp1
            l = il-1
            m = im-1
            cnlm = (2*l+1) * flg(l-m) / flg(l+m)
            cnlm = sqrt(cnlm) * afac**m
            xnlm(il,im) = cnlm
   10 continue

      return
      end
      subroutine factst (afac, flg)
      implicit double precision (a-h,o-z)

c     FACTorial SeT, flg(i) = i! * afac**i
      dimension flg(0:210)

c     afac = 1/64 works with double precision on a VAX
      afac = 1./64.

      flg(0) = 1
      flg(1) = afac

      do 10  i = 2, 210
   10 flg(i) = flg(i-1) * i * afac

      return
      end

      subroutine sidx (rholap, npts, rmt, rnrm, imax, imt, inrm)

      implicit double precision (a-h, o-z)
      dimension rholap (npts)
      character*512 slog
c#mn
      external ii, rr

      imt = ii (rmt)
      inrm = ii (rnrm)

c     Set imax (last non-zero rholap data)
      do 220  i = imt, npts
         if (rholap(i) .le. 1.0d-5)  goto 230
         imax = i
  220 continue
  230 continue

c     We need data up to the norman radius, so move norman
c     radius if density is zero inside rnrm.
      if (inrm .gt. imax)  then
         inrm = imax
         rnrm = rr (inrm)
  232    format(a,1pe13.5)
         write(slog,232) ' Moved rnrm.  New rnrm (au) ', rnrm
         call wlog(slog)
      endif
      if (imt .gt. imax)  then
         imt = imax
         rmt = rr (imt)
         write(slog,232) ' Moved rmt.  New rmt (au) ', rmt
         call wlog(slog)
      endif
      return
      end

      PROGRAM test
      INCLUDE '../../HEADERS/dim.h'
      INTEGER iprint, ispec, ne, ne1, ik0, ne3, i1, igrid
      DOUBLE PRECISION edge, emu, vi0, gamach, xkmax, xkstep, vixan, ecv
      COMPLEX*16 em1(nex), em2(nex)
      iprint = 0
      ispec = 1
      ne = 0
      ne1 = 0
      ik0 = 0
      ne3 = 0
      edge = 0.d0
      emu = 10.d0
      vi0 = 0.d0
      gamach = 1.d0
      xkmax = 10.1d0
      xkstep = 1.05d0
      vixan = 1.d0
      ecv = 0.d0
      igrid = 1
      
c      CALL phmesh(iprint, ispec, edge, emu, vi0, gamach, ecv,
c     &                  xkmax, xkstep, vixan, ne, ne1, em1, ik0, ne3)

      CALL phmesh2(iprint, ispec, edge, emu, vi0, gamach,
     &     xkmax, xkstep, vixan, ne, ne1, em2, ik0, ne3, 1)
c      DO i1 = 1, ne
c         print*, i1, SQRT(2*ABS(DBLE(em1(i1)-edge)))/0.529,
c     &        SQRT(2*ABS(DBLE(em2(i1)-edge)))/0.529
c      END DO
      PRINT*, 'next'
      DO i1 = 1, ne
c     &        DIMAG(em1(i1)), DIMAG(em2(i1))
         print*, i1, DBLE(em2(i1))*27.2, DIMAG(em2(i1))*27.2
c     &        DIMAG(em1(i1)), DIMAG(em2(i1))
      END DO

      END

FUNCTION GetElement(iz)
  INTEGER iz
  CHARACTER(2) GetElement
  CHARACTER(2) Elements(100)


  DATA Elements(1) /'H '/
  DATA Elements(2) /'He'/
  DATA Elements(3) /'Li'/
  DATA Elements(4) /'Be'/
  DATA Elements(5) /'B '/
  DATA Elements(6) /'C '/
  DATA Elements(7) /'N '/
  DATA Elements(8) /'O '/
  DATA Elements(9) /'F '/
  DATA Elements(10) /'Ne'/
  DATA Elements(11) /'Na'/
  DATA Elements(12) /'Mg'/
  DATA Elements(13) /'Al'/
  DATA Elements(14) /'Si'/
  DATA Elements(15) /'P '/
  DATA Elements(16) /'S '/
  DATA Elements(17) /'Cl'/
  DATA Elements(18) /'Ar'/
  DATA Elements(19) /'K '/
  DATA Elements(20) /'Ca'/
  DATA Elements(21) /'Sc'/
  DATA Elements(22) /'Ti'/
  DATA Elements(23) /'V '/
  DATA Elements(24) /'Cr'/
  DATA Elements(25) /'Mn'/
  DATA Elements(26) /'Fe'/
  DATA Elements(27) /'Co'/
  DATA Elements(28) /'Ni'/
  DATA Elements(29) /'Cu'/
  DATA Elements(30) /'Zn'/
  DATA Elements(31) /'Ga'/
  DATA Elements(32) /'Ge'/
  DATA Elements(33) /'As'/
  DATA Elements(34) /'Se'/
  DATA Elements(35) /'Br'/
  DATA Elements(36) /'Kr'/
  DATA Elements(37) /'Rb'/
  DATA Elements(38) /'Sr'/
  DATA Elements(39) /'Y '/
  DATA Elements(40) /'Zr'/
  DATA Elements(41) /'Nb'/
  DATA Elements(42) /'Mo'/
  DATA Elements(43) /'Tc'/
  DATA Elements(44) /'Ru'/
  DATA Elements(45) /'Rh'/
  DATA Elements(46) /'Pd'/
  DATA Elements(47) /'Ag'/
  DATA Elements(48) /'Cd'/
  DATA Elements(49) /'In'/
  DATA Elements(50) /'Sn'/
  DATA Elements(51) /'Sb'/
  DATA Elements(52) /'Te'/
  DATA Elements(53) /'I '/
  DATA Elements(54) /'Xe'/
  DATA Elements(55) /'Cs'/
  DATA Elements(56) /'Ba'/
  DATA Elements(57) /'La'/
  DATA Elements(58) /'Ce'/
  DATA Elements(59) /'Pr'/
  DATA Elements(60) /'Nd'/
  DATA Elements(61) /'Pm'/
  DATA Elements(62) /'Sm'/
  DATA Elements(63) /'Eu'/
  DATA Elements(64) /'Gd'/
  DATA Elements(65) /'Tb'/
  DATA Elements(66) /'Dy'/
  DATA Elements(67) /'Ho'/
  DATA Elements(68) /'Er'/
  DATA Elements(69) /'Tm'/
  DATA Elements(70) /'Yb'/
  DATA Elements(71) /'Lu'/
  DATA Elements(72) /'Hf'/
  DATA Elements(73) /'Ta'/
  DATA Elements(74) /'W '/
  DATA Elements(75) /'Re'/
  DATA Elements(76) /'Os'/
  DATA Elements(77) /'Ir'/
  DATA Elements(78) /'Pt'/
  DATA Elements(79) /'Au'/
  DATA Elements(80) /'Hg'/
  DATA Elements(81) /'Tl'/
  DATA Elements(82) /'Pb'/
  DATA Elements(83) /'Bi'/
  DATA Elements(84) /'Po'/
  DATA Elements(85) /'At'/
  DATA Elements(86) /'Rn'/
  DATA Elements(87) /'Fr'/
  DATA Elements(88) /'Ra'/
  DATA Elements(89) /'Ac'/
  DATA Elements(90) /'Th'/
  DATA Elements(91) /'Pa'/
  DATA Elements(92) /'U '/
  DATA Elements(93) /'Np'/
  DATA Elements(94) /'Pu'/
  DATA Elements(95) /'Am'/
  DATA Elements(96) /'Cm'/
  DATA Elements(97) /'Bk'/
  DATA Elements(98) /'Cf'/
  DATA Elements(99) /'Es'/
  DATA Elements(100) /'Fm'/

  GetElement = Elements(iz)
  RETURN
END FUNCTION GetElement

      SUBROUTINE FndSng(Limit1, Limit2, NSing, XSing, DPPar, CPar, iFcn)
c     Josh Kas
c     This subroutine finds the singularities in the integrands of eq. 13
c     in
c     Single-particle Spectrum of the Degenerate Electron Gas
c     II. Numerical Results for Electrons Coupled to Plasmons
c     Phys. kondens. Materie, Bd. 6 (1967)
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc      
c     In practice this routine only solves for the singularities of one
c     of the three integrands, then checks to see that the singularity
c     is within the limits of integration, and throws out singularities
c     that are not.
c     In units of the Fermi energy the equations to solve are:
c     1) +/- k*q**3 + 2*(3*k**2 - E - 2/3)*q**2 +/- 4*k*(k**2 - E)*q +
c                     [(k**2 - E)**2 - Wp**2] = 0 
c     2) q**4 + 4/3*q**2 + Wp**2 - (1 - E)**2 = 0
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc      
c     Input:
c     Limit1 - Lower limit of integration
c     Limit2 - Upper limit of integration
c     CPar   - Array of complex parameters passed to function
c              CPar(1) = ck/kFermi
c              CPar(2) = Energy/EFermi + i*Gamma/EFermi
c     DPPar  - Array of double precision parameters passed to function
c              DPPar(1) = Wp/EFermi
c              DPPar(2) = Gamma/EFermi
c              DPPar(3) = Energy/EFermi
c              DPPar(4) = xeg (gap energy)
c     iFcn   - Integer denoting which function is the integrand
c              iFcn = 1: solve eqs 1 and 2 for q
c              iFcn = 2: solve eq 1 for q      
      COMPLEX*16 Limit1, Limit2, CPar(10)
      DOUBLE PRECISION DPPar(10)
      INTEGER iFcn
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     Output:
c     XSing  - Array of singularities
c     NSing  - Number of singularities
      COMPLEX*16 XSing(20)
      INTEGER NSing
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     Local Variables:
c     Coef   - Coefficients of q**n of eq. to solve.
c              eq = Coef(1)*q**n + Coef(2)*q**(n-1)...
c     Sol(4) - Array of solutions to the equation.
c     XSing2 - Temp XSing      
c     Test   - Used to test solution of equation.
c     Zero   - Tolerance for testing solution to eqs.
c     NSol   - Number of solutions to eq.
c     Order  - Used to order singulaties from smallest to largest
      COMPLEX*16 Coef(4), Sol(4), XSing2(4)
      DOUBLE PRECISION Test, Zero
      INTEGER NSol, Order(100)
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     Loop variables
      INTEGER i1
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     Initialization
      NSing = 0
      Zero=1.d-4

c     Solve eq 1 for q with + sign
      Coef(1) = 4.d0*CPar(1)
      Coef(2) = 2.d0*(3.d0*CPar(1)**2 - DPPar(3) - 2.d0/3.d0)
      Coef(3) = 4.d0*CPar(1)*(CPar(1)**2 - DPPar(3))
      Coef(4) = (CPar(1)**2 - DPPar(3))**2 - DPPar(1)**2
      
      CALL CCubic(Coef, Sol, NSol)
      
c     Test solutions. If Sol is a solution and it is real
c     and it lies between Limit1 and Limit2, add it to list
c     of singularities.         
      DO i1 = 1, NSol
         Test = ABS((CPar(1)+Sol(i1))**2 - DPPar(3) +
     &        SQRT(Sol(i1)**4 + 4.d0/3.d0*Sol(i1)**2 + DPPar(1)**2))
         IF(Test.lt.Zero) THEN               
            IF((DBLE(Sol(i1)).ge.DBLE(Limit1)).and.
     &           (DBLE(Sol(i1)).le.DBLE(Limit2)).and.
     &           (ABS(DIMAG(Sol(i1))).le.Zero)) THEN               
               NSing = NSing + 1
               XSing(NSing) = DBLE(Sol(i1))
            END IF
         END IF
      END DO
      
c     Now solve eq. 1 for q with - sign
      Coef(1) = -Coef(1)
      Coef(3) = -Coef(3)
      
      CALL CCubic(Coef, Sol, NSol)
      
c     Test solutions as before.
      DO i1 = 1, NSol
         Test = ABS((CPar(1)-Sol(i1))**2 - DPPar(3) -
     &        SQRT(Sol(i1)**4 + 4.d0/3.d0*Sol(i1)**2 + DPPar(1)**2))
         IF(Test.lt.Zero) THEN
            IF((DBLE(Sol(i1)).ge.DBLE(Limit1)).and.
     &           (DBLE(Sol(i1)).le.DBLE(Limit2)).and.
     &           (ABS(DIMAG(Sol(i1))).le.Zero)) THEN
               NSing = NSing + 1
               XSing(NSing) = DBLE(Sol(i1))
            END IF
         END IF
      END DO

c     If iFcn = 1 (Solving for singularities of r1(q))
      IF(iFcn.eq.1) THEN         
c        Solve eq. 2 for q
         Coef(1) = 1.d0
         Coef(2) = 4.d0/3.d0
         Coef(3) = DPPar(1)**2

         CALL CQdrtc(Coef,Sol,NSol)
         DO i1 = 1, NSol
            XSing2(2*i1-1) =  DBLE(SQRT(Sol(i1)))
            XSing2(2*i1)   = -DBLE(SQRT(Sol(i1)))
         END DO

c        Test Solutions
         DO i1 = 1, 2*NSol
            IF((DBLE(XSing2(i1)).ge.DBLE(Limit1)).and.
     &           (DBLE(XSing2(i1)).le.DBLE(Limit2)).and.
     &              (ABS(DIMAG(Sol(i1))).le.Zero)) THEN
               NSing = NSing + 1
               XSing(NSing) = XSing2(i1)
            END IF
         END DO
      END IF
      
c     Sort singularities
      CALL QSORTI(Order,NSing,Xsing)
      DO i1 = 1, NSing
         XSing2(i1) = XSing(i1)
      END DO
      DO i1 = 1, NSing
         XSing(i1) = XSing2(Order(i1))
      END DO

      RETURN
      END

! Written by J. Kas, 2006
! eps2exc takes loss function from loss.dat and gives poles and weights
! corresponding to the many pole model detailed in
! Phys. Rev. B 76, 195116 (2007). 
! First, regions are chosen 
      PROGRAM eps2exc
      DOUBLE PRECISION Dat(50000,2), g(10000), gamma, omi(10000),
     &     Delta(10000),eps0, sumrl, xNElec, csumrl
      INTEGER i,i1,NPoles,NPts
c     INTEGER ios1,ios2,imax,NFile
      CHARACTER*80 infl, outfl
c     CHARACTER*80 comment
      CHARACTER ch
      EXTERNAL IntGrl
      NPts = 1000
      infl='loss.dat'
      outfl='exc.dat'
      PRINT*, '# Enter number of poles:'
      READ*, NPoles
      ! This input can be used to correct the sumrules
      !PRINT*, '# Enter eps^-1 sumrule and N_el:'
      !READ*, sumrl, xNElec
      sumrl = 1.d0
      xNElec = 1.d0
      PRINT*, 'Is this a metal? (y/n)'
      READ*, ch
      IF(ch.EQ.'y'.OR.ch.EQ.'Y') THEN
         eps0 = -1.d0
      ELSE
         PRINT*, 'Would you like to set the dielectric constant? (y/n)'
         READ*, ch
         IF(ch.EQ.'n'.OR.ch.EQ.'N') THEN
            eps0 = -2.d0
         ELSE
       
            ! This input can be used to correct the dielectric constant,
            ! which is related to the inverse moment.
            ! Use eps0 = -2 to ignore this correction.
            PRINT*, '# Enter dielectric constant: '
            READ*, eps0
         END IF
      END IF 
      PRINT*, eps0
      gamma = 0.01
      csumrl= xNElec/sumrl
      
      OPEN(unit=12,file=infl,status='old')
      OPEN(unit=13,file=outfl,status='replace')
      CALL rdloss(12,Dat,NPts)

      DO i1 = 1, NPts
         Dat(i1,2) = Dat(i1,2)*csumrl
      END DO
      ! getomi finds poles and weights
      CALL getomi(Dat(1,1), Dat(1,2), NPts, NPoles, omi, g, Delta, eps0)
      WRITE(13,'(A33,I4,A6)') '# Loss function represented with ',
     $     NPoles, ' poles'
      WRITE(13,'(A23,f8.4)') '# Dielectric constant: ', eps0
      DO i = 1, NPoles
         WRITE(13,'(4f20.10)'), omi(i), omi(i)*gamma, g(i), Delta(i)
      END DO
      
      END

      SUBROUTINE CSigZ(Energy, Mu, Rs, ReSig, ImSig, ZTot, WpScl,
     &     AmpFac)
c      SUBROUTINE CSigZ(Energy, Mu, Rs, ReSig, ImSig, ZTot, WpScl, Gamma,
c     &     AmpFac)
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     Written by Josh Kas
c     This subroutine calculates the self energy Sigma(k(Energy),Energy)
c     based on an electron gas model of epsilon^-1.
c      
c     Solve: k0**2 = 2*Energy - 2*Mu -
c                    2*(Sigma(k0,Energy)-Sigma(kFermi,EFermi))
c            
c     Steps:
c
c            1. k0**2  = 2*(Energy-Mu) + SigmaF (SigmaF is self energy at fermi level).
c            2. Sigma0 = Sigma(k0,Energy)
c            3. Find derivative w.r.t. E dSgdE
c            4. k1**2  = 
c                  k0**2 - 2*(Sigma0-SigmaF)/(1-dSgdE)
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      include '../HEADERS/const.h'
c     Parameters:
c     MxPole - Maximum number of poles
      INTEGER MxPole
      PARAMETER(MxPole=1000)
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     Input:
c     Energy - Energy at which to evaluate Sigma
c     Mu     - Fermi energy as calculated by FEFF.
c     Rs     - R sub s (sphere of radius Rs holds charge e)
c     WpScl  - Scale Wp in interstitial by WpScl
c     Gamma  - Use broadening Gamma when calculating Sigma
c     AmpFac - Use amplitude AmpFac for plasmon pole.
      DOUBLE PRECISION Rs, WpScl(MxPole), AmpFac(MxPole), Mu
c      DOUBLE PRECISION Gamma(MxPole),
      COMPLEX*16 Energy
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     Output:
c     ReSig  - Re[Sigma(k,e)]
c     ImSig  - Im[Sigma(k,e)]
c     ZTot   - Renormalization factor Z = 1/(1-dSgdE)
c     Note: Atomic units are used.
      DOUBLE PRECISION ReSig, ImSig
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     Local Variables:
c     kFermi - Fermi momentum calculated from Rs via electron gas
c              approximation.
c     EFermi - Fermi energy = kFermi^2/2
c     Wp     - Electron gas plasmon frequency.
c     Gam    - broadening for broadened pole.
c     ckF    - complex variable to store kFermi
c     ck0    - complex momentum
c     SigmaF - Self energy at the fermi energy and fermi momentum
c              Does not include the Hartree Fock part.
c     Sigma0 - Single pole self energy evaluated at
c              Wp = Wp(ipole)/Wp(R_Interstitial)*Wp(Rs)
c     dSgdE  - Derivative of sigma w.r.t. Energy
c     ZTot   - Renormalization factor Z = 1/(1-dSgdE)
c     RelEn  - Energy relative to the fermi energy from FEFF      
c              Relen = Energy - Mu + EFermi
c     SigTot - Total many pole deltaSigma = Sigma(E,k(E))-Sigma(EF,kF)
c     DelHF  - Sigma_HartreeFock(k) - Sigma_HartreeFock(kF)
      DOUBLE PRECISION kFermi, EFermi, Wp, Gam
      COMPLEX*16 ckF, ck0, SigmaF, Sigma0, dSgdE, ZTot, RelEn, RelEnP,
     &     SigTot, DelHF, SigmaP
c     Loop variables
      INTEGER i1, i2

c     Parameters:
      DOUBLE PRECISION DPZero
      PARAMETER(DPZero = 0.d0)
      INTEGER MxIter
      PARAMETER(MxIter = 1)

c     Externals:
c     Sigma1 - calculates the energy dependent part of self energy
c              for a single pole.
c     dSigma - calculates derivative of self energy w.r.t energy.
c     HFExt  - calculates Hartree Fock exchange
      COMPLEX*16 Sigma1, dSigma, HFExc
      EXTERNAL Sigma1, dSigma, HFExc
      
c     Initialization
      ZTot = 0.d0
      kFermi = fa/Rs
      EFermi = kFermi*kFermi/2.d0
      SigTot=0.d0
      dSgdE = 0.d0
      SigmaF = 0.d0
      Gam = 0.d0

c     Loop1: Start self consistency loop.
c     This does not seem to work, so MxIter = 1
      DO i2 = 1, MxIter

c        Loop2: Loop over poles to get SigmaF
         DO i1 = 1, MxPole
            IF(WpScl(i1).lt.0) GOTO 5
            
c           Wp is in Hartrees            
            Wp = SQRT(3.d0/Rs**3)*WpScl(i1)
c            Gam = Gamma(i1)
            
c           find Sigma_Fermi (SigmaF)
            ckF = kFermi*1.00001d0
            RelEn = EFermi
            SigmaF = SigmaF + Sigma1(ckF,RelEn,Wp,Gam,AmpFac(i1),
     &           kFermi, EFermi)
         END DO
c        End Loop2
 5       CONTINUE
         
         dsgdE = 0.d0
c        Loop3: Loop over poles         
         DO i1 = 1, MxPole
            IF(WpScl(i1).lt.0) GOTO 10
c           Wp is in Hartrees
            Wp = SQRT(3.d0/Rs**3)*WpScl(i1)
c            Gam = Gamma(i1)
c           Start with ck0=Sqrt[Re(Energy)-Mu+EFermi]
            RelEn = DBLE(Energy) - Mu + EFermi
            ck0 = SQRT(2.d0*DBLE(RelEn))
            
c           Find Sigma0 = Sigma(ck0,E); ck0=SQRT(2*(Energy-Mu))
            Sigma0 = Sigma1(ck0,RelEn,Wp,Gam,AmpFac(i1),kFermi,
     &           EFermi)
                  
            RelEnP = RelEn*0.001d0
            SigmaP = Sigma1(ck0,RelEnP,Wp,Gam,AmpFac(i1),kFermi,
     &           EFermi)

c            write(71,*) DBLE(RelEn-EFermi), DBLE(dSgdE), DIMAG(dSgDE)
            dSgdE = dSgdE + (SigmaP - Sigma0)/(RelEnP-RelEn)
c            dSgdE = dSgdE + 
c     &          dSigma(ck0,RelEn,Wp,Gam,AmpFac(i1),kFermi,EFermi)
c           Uncomment the following line to print derivative            
c            write(72,*) DBLE(RelEn-EFermi), DBLE(dSgdE2), DIMAG(dSgDE2)         

c           SigTot is sum of poles
            SigTot = SigTot + Sigma0
            
c        End Loop3: loop over poles.            
         END DO         
 10      CONTINUE
         
c     End Loop1: self-consistency loop      
      END DO


c     Add Hartree Fock part of delta Sigma.
      DelHF = HFExc(ck0,EFermi,kFermi) - HFExc(ckF,EFermi,kFermi)
      SigTot = SigTot - SigmaF + DelHF

c     Form ZTot and return Re and Im parts of Sigma.
      ZTot = 1.d0/(1.d0-dSgdE)
c      ZTot = 1.d0
      SigTot = ZTot*(SigTot)
      
      ReSig = DBLE(SigTot)
      ImSig = DIMAG(SigTot)
      
      RETURN
      END

      double precision function getxk (e)
      implicit double precision (a-h, o-z)

c     Make xk from energy(in Hartrees) as
c          k =  sqrt(2*e)  for e > 0  (above the edge)
c          k = -sqrt(-2*e)  for e < 0  (below the edge)
      getxk = sqrt(abs(2*e))
      if (e .lt. 0)  getxk = - getxk
      return
      end

      subroutine wfirdc (eph,kap,nmax,vxc,ps,qs,aps,aqs,irr,ic3,vm,
     1                   jri, iwkb) 
c     1                   rmt,jri, iwkb) 
c     calculate photoelectron orbital using lda in dirac equation
c     cg (cp) large (small) radial components
c     bg (bp) development coefficients at the origin of cg (cp)
c     eph one-electron energy of photoelectron
c     fl power of the first term of development at the origin
c     kap quantum number "kappa"
c     nmax number of tabulation points for the orbitals
c     vxc  is initial lda potential for photoelectron
c     ibgp first dimension of the arrays bg and bp
c        this programmes utilises nucdec,dentfa,soldir et messer
 
      implicit double precision (a-h,o-z)
      include '../HEADERS/dim.h'
      common/dff/cg(nrptx,30),cp(nrptx,30),bg(10,30),bp(10,30),
     1             fl(30), fix(30), ibgp
      dimension kap(30),nmax(30)
c    for photoelectron potential and wavefunction will be complex
      complex*16 eph,dg,ag,dp,ap,dv,av,eg,ceg,ep,cep,vxc(nrptx)
      complex*16 ps(nrptx),qs(nrptx),aps(10),aqs(10),vm(nrptx)
      common/comdic/cl,dz,dg(nrptx),ag(10),dp(nrptx),ap(10),
     1dv(nrptx),av(10),eg(nrptx),ceg(10),ep(nrptx),cep(10)
      common/itescf/testy,rap(2),teste,nz,norb,norbsc
      common/messag/dlabpr,numerr
      character*8 dlabpr
      common/snoyac/dvn(nrptx),anoy(10),nuc
      common/tabtec/hx,dr(nrptx),test1,test2,ndor,np,nes,method,idim
 
      cl=1.370373d+02
c     speed of light in atomic units
      dz = nz
c     make r-mesh and calculate nuclear potential
c     hx exponential step
c     dr1 first tabulation point multiplied by nz
      dr1= nz*exp(-8.8)
      call nucdec (anoy,dr,dvn,dz,hx,nuc,idim,10,dr1)
c     notice that here nuc=1, 
c     unless you specify nuclear mass and thickness in nucdec.f


      a=(dz/cl)**2
      if (nuc.gt.1) a=0.0d 00
      do 11 j=1,norb
         b=kap(j)*kap(j)-a
         if (j.eq.norb) b=b+(kap(j)+1)*ic3
         fl(j)= sqrt(b)
 11      fix(j) = dr(1)**(fl(j)-abs(kap(j)))
c     if irregular solution
      if (irr.gt.0) then
         fl(norb) = -fl(norb)
         fix(norb) = 1.0/fix(norb)
      endif

c     use lda potential to calculate initial w.f.
      do 21 i=1,jri-1
 21   dv(i)= vxc(i)/cl
      do  i=jri,idim
        dv(i)= vxc(jri+1)/cl
      enddo
      if (numerr.ne.0) return
      do 51 i=1,idim
         eg(i)=0.0d 00
 51      ep(i)=0.0d 00
      do 61 i=1,ibgp
         ceg(i)=0.0d 00
 61      cep(i)=0.0d 00
      call potdvp
      av(2)=av(2)+(vxc(nuc)-dvn(nuc))/cl

c     resolution of the dirac equation to get initial orbital
      if (irr.lt.0) then
         if (a .gt. 0.0d0) then 
            aps(1) = 1.0
            if (kap(norb) .lt. 0) then
               aqs(1)=aps(1)*dz/(cl*(kap(norb)-fl(norb)))
            else
               aqs(1)=aps(1)*cl*(kap(norb)+fl(norb))/dz
            endif
         else
            if (kap(norb).lt.0)then
               aps(1)=1.0d 00
               aqs(1)=0.0d 00
            else
               aps(1)=0.0d 00
               aqs(1)=1.0d 00
            endif
         endif
      endif

      np=1+int((8.8 + log(10.0))/hx)
c     exp(-8.8+(np-1)*hx) = 10.0 bohrs - max distance
      if (idim .lt. np) np=idim
      if (nmax(norb) .gt. np) nmax(norb)=np
         
      if (irr.lt.0) then
c         call solout( eph, fl(norb), aps(1), aqs(1), kap(norb), rmt,
c     1              jri, nmax(norb), ic3, vm, iwkb)
         call solout( eph, fl(norb), aps(1), aqs(1), kap(norb),
     1              jri, nmax(norb), ic3, vm, iwkb)
      else
c         call solin( eph, fl(norb), aps(1), aqs(1), kap(norb), rmt,
c     1              jri, nmax(norb), ic3, vm, iwkb)
         call solin( eph, fl(norb), kap(norb),
     1              jri, nmax(norb), ic3, vm, iwkb)
      endif
         
      do 261 i=1,10
         aps(i)=ag(i)
 261     aqs(i)=ap(i)
      do 271 i=1,idim
         ps(i)=dg(i)
 271     qs(i)=dp(i)
      return
      end

      subroutine cofcon (a,b,p,q)
c     acceleration of the convergence in the iterative process
c     b is the part of final iteration n is a function of the error (p)
c     (p) at iteration n and the error (q) at the iteration n-1.
c     if the product p*q is positive  b is increased by 0.1
c                        zero b is unchanged
c                        negative b is decreased by 0.1
c     b is between 0.1 and 0.9
c                a = 1. - b
c     ** at the end makes q=p
c
      implicit double precision (a-h,o-z)

      if (p*q)  11,31,21
 11   if (b .ge. 0.2) b = b - 0.1
      go to 31

 21   if (b .le. 0.8) b = b + 0.1

 31   a = 1.0 - b
      q=p
      return
      end

      double precision function fdmocc (i,j)
c     product of the occupation numbers of the orbitals i and j

      implicit double precision (a-h,o-z)
      common/ratom1/xnel(30),en(30),scc(30),scw(30),sce(30),
     1nq(30),kap(30),nmax(30)
 
      if (j.eq.i) then
         fdmocc=xnel(i)*(xnel(j)-1)
         a=2* abs(kap(i))
         fdmocc=fdmocc*a/(a-1.0)
      else
         fdmocc=xnel(i)*xnel(j)
      endif
      return
      end

!=======================================================================
!     RECIPROCAL
!=======================================================================

module reciprocal_inp
  !     k-space variables :
  use controls  !KJ 8/06
  use struct, nphstr => nph
  use kklist,only: nkp,usesym,nkx,nky,nkz,ktype
  use strfacs,only: streta,strrmax,strgmax,init_strfacs
  implicit none
  integer icorehole
  real*8 streimag ! additional broadening for calculation KKR structure factors ; not recommended
  character(*),parameter,private :: filename='reciprocal.inp'

contains

  subroutine reciprocal_write
    !KJ next file added 8/06
    integer i
    open (file=filename, unit=3, status='unknown')
    !       in which space are we?
    write(3,10) 'spacy'
    write(3,20) spacy
    if(spacy.eq.0) then
       write(3,10) 'lattice vectors  (in A, in Carthesian coordinates)'
       write(3,30) a1
       write(3,30) a2
       write(3,30) a3
       write(3,10) 'Volume scaling factor (A^3); eimag; core hole'
       write(3,30) dble(-1),dble(0),dble(1)
       write(3,10) 'lattice type  (P,I,F,R,B,CXY,CYZ,CXZ)'
       write(3,10) latticename
       write(3,10) '#atoms in unit cell ; position absorber ; corehole?'
       write(3,20) nats,absorber,icorehole
       write(3,10) '# k-points total/x/y/z ; ktype; use symmetry?'
       write(3,*) nkp,nkx,nky,nkz,ktype,usesym  ! format line 20 limits integer to 4 positions - not enough for nkp!
       write(3,10) 'ppos'
       do i=1,nats
          write(3,30) ppos(:,i)
       enddo
       write(3,10) 'ppot'
       !KJ bugfix 5/2012: It's important not to use formatting when there are more atoms than fit on one line!!			   
       write(3,*) ppot
       write(3,10) 'streta,strgmax,strrmax'
       write(3,30) streta,strgmax,strrmax
    endif
    close(3)
    ! standard formats for string, integers and real numbers
10  format(a)
20  format (20i4)
30  format (9f13.5)
  end subroutine reciprocal_write

  subroutine reciprocal_read(celvin)
    use struct, nphstr => nph
    integer i
    real*8,intent(out) :: celvin
    open (3,file=filename,status='unknown',err=167)
    read(3,*,end=167,err=167)
    read(3,*,end=167,err=167) spacy
    if(spacy.eq.0) then
       read(3,*) ; read(3,*) a1(:)
       read(3,*) a2(:)
       read(3,*) a3(:)
       read(3,*) ; read(3,*) celvin,streimag,cholestrength
       read(3,*) ; read(3,*) latticename
       lattice=latticename(1:1)
       read(3,*) ; read(3,*) nats,absorber,icorehole
       read(3,*) ; read(3,*) nkp,nkx,nky,nkz,ktype,usesym
       read(3,*)
       !Careful: the next statement used to be "if size(ppot).eq.0".  However, on ifort size(ppot)=0 but on gfortran it =1!!
       !Hence the new instruction.
       !I wish if(allocated(ppot)) would work here; I don't understand why it doesn't.
       if(size(ppot).lt.nats) call init_struct(nats) !KJ 7-09 bugfix call this only once ; I can't seem to use "allocated(ppos)" here?
       do i=1,nats
          read(3,*) ppos(:,i)
       enddo
       read(3,*) ; read(3,*) ppot
       read(3,*) ; read(3,*) streta,strgmax,strrmax
       if(icorehole.eq.1) then
          corehole=.true.
       else
          corehole=.false.
       endif
    endif
    return
167 spacy=1
    return
  end subroutine reciprocal_read

  subroutine reciprocal_init
    call init_controls
    call init_strfacs
    icorehole = 1  ! use core hole
    streimag = dble(0) ! no extra broadening for KKR struc factors
    cholestrength = dble(1) ! don't mess with core hole
  end subroutine reciprocal_init

end module reciprocal_inp

      subroutine pijump (ph, old)
      implicit double precision (a-h, o-z)

c     removes jumps of 2*pi in phases

c     ph = current value of phase (may be modified on output, but
c          only by multiples of 2*pi)
c     old = previous value of phase

      include '../HEADERS/const.h'
      parameter (twopi = 2 * pi)
      dimension xph(3)

      xph(1) = ph - old
      jump =  int((abs(xph(1))+ pi) / twopi)
      xph(2) = xph(1) - jump*twopi
      xph(3) = xph(1) + jump*twopi


      xphmin = min (abs(xph(1)), abs(xph(2)), abs(xph(3)))
      isave = 0
      do 10  i = 1, 3
         if (abs (xphmin - abs(xph(i))) .le. 0.01)  isave = i
   10 continue
      if (isave .eq. 0)  then
         call par_stop('pijump')
      endif

      ph = old + xph(isave)

      return
      end

      subroutine xscorr(ispec, emxs ,ne1, ne, ik0, xsec, xsnorm, chia,
     1                  vrcorr, vicorr, cchi)
c     convolute xmu(E)=xsec+xsnorm*chia with lorentzian using 
c     calculations in the complex energy plane

c     Input: ispec - type of spectroscopy
c       emxs - complex energy grid
c       ne1 - number of points on horizonatal axis 
c       ne - total number of points (ne-ne1) points on vertical axis
c       ik0 - Fermi level index on horizontal axis
c       xsec, xsnorm, chia - give function f in complex energy plain
c           xmu(ie) = xsec + xsnorm*chia
c       vrcorr = correction for the shift of the Fermi level
c       vicorr = 0 (disabled)
c     Output: cchi(w) - result of convolution for w = dble(emxs)
c       cchi(w) = \int_C dE xmu(E)*xloss/pi/((E-w)**2+xloss**2) = 
c       xmu(w+i*xloss)* [1/2+atan(w-efermi/xloss)/pi] +
c       \int_C dE ff(E)*xloss/pi/((E-w)**2+xloss**2)
c       where ff(E)=xmu(E)-xmu(w+i*xloss) for w<efermi we use 
c       xmu(efermi+i*xloss) instead of xmu(w+i*xloss);
c       contour C starts at efermi, goes vertically to efermi+i*xloss 
c       and then goes horizontally to infinity + i*xloss

      implicit double precision (a-h, o-z)
      include '../HEADERS/const.h'
      include '../HEADERS/dim.h'

      dimension  xsnorm(nex), omega(nex)
      complex*16 emxs(nex), xsec(nex), chia(nex), cchi(nex) 
      complex*16 xmu(nex), aa, bb, f1, f2, ff(nex), xmu0
c      complex*16 c1
      parameter (eps4 = 1.0d-4)
      complex*16 ec(nex), fc(nex), e1,e2, z1,z2, corr
      complex*16 lorenz
      external lorenz, astep

      ne2 = ne-ne1
      efermi = dble(emxs(ne)) 
      xloss = dimag(emxs(1))
      vicorr = 0

c     xmu - analytic function in complex energy plain
      do  ie = 1,ne
        xmu (ie) = xsec(ie) + xsnorm(ie)*chia(ie)
      enddo
c     real frequencies
      do ie = 1, ne1
        omega(ie) = dble(emxs(ie))
      enddo

      if (abs(vrcorr).gt.eps4) then
c       account for the fermi level shift
        bb = xmu(ik0)
        efermi = efermi - vrcorr
        call terpc(omega, xmu ,ne1, 1, efermi, bb)

c       shift the vertical axis
        do ie = 1, ne2
          emxs(ne1+ie) = emxs(ne1+ie) - vrcorr
        enddo

c       rescale values on vertical axis
        bb = bb/xmu(ik0)
        do ie = ne1+1, ne
          xmu(ie) = xmu (ie) * bb 
        enddo
      else
        bb = 1
      endif

c     construct the integration countur C
      nc = 0
c     start with points on vertical axis below xloss
      do ie = 1,ne2
        if (dimag(emxs(ne1+ie)).lt.xloss) then
          nc = nc+1
          ec(nc) = emxs(ne1+ie)
          fc(nc) = xmu(ne1+ie)
        endif
      enddo
c     add corner at efermi + xloss*i
      nc = nc+1
      ic0 = nc
      if (abs(vrcorr).gt.eps4) then
        ec(nc) = efermi + coni*xloss
        fc(nc) = bb * xmu(ik0)
      else
        ec(nc) = emxs(ik0)
        fc(nc) = xmu(ik0)
      endif
c     add points on horizontal axis above efermi
      if (ispec.ne.2) then
        do ie = 1,ne1
          if (dble(emxs(ie))-efermi.gt.eps4) then
            nc = nc+1
            ec(nc) = emxs(ie)
            fc(nc) = xmu(ie)
          endif
        enddo
      else
c       ispec=2 - emission calculations- need points below E_fermi
        do ie = ne1,1,-1
          if (efermi-dble(emxs(ie)).gt.eps4) then
            nc = nc+1
            ec(nc) = emxs(ie)
            fc(nc) = xmu(ie)
          endif
        enddo
      endif
c     endo of countour construction
              
c     cycle over frequency points 
      do ie = 1, ne1
        if (omega(ie).ge.efermi) then
          xmu0 = xmu(ie)
          if (ispec.eq.2) xmu0 = xmu(ik0)*bb
        else
          xmu0 = xmu(ik0)*bb
          if (ispec.eq.2) xmu0 = xmu(ie)
        endif
        e1 = omega(ie) + coni*xloss
        e2 = omega(ie) - coni*xloss
        do ic = 1, nc 
          ff(ic) = fc(ic) - xmu0
        enddo
        dele = omega(ie) - efermi
        cchi(ie) = xmu0 * astep( xloss, dele)
        if (ispec.eq.2) cchi(ie) = xmu0 - cchi(ie)
        corr = 0

        if (abs(dele).lt.eps4) dele = 0.0d0
        w1 = dimag(ec(1))
        w2 = dimag(ec(2))
        w3 = dimag(ec(3))
        ip =0

c       add half matsubara pole contribution
c       equivalent to integral from efermi to efermi+i*w1
        corr = corr + lorenz(xloss,w1,dele)*ff(1) *coni*w1
        if (nc0.gt.3) then
c       add sommerfeld correction (correction for derivative)
c         corr = corr + coni * w1**2 / 6   / (w3-w2) *
c    2   (lorenz(xloss,w3,dele)*ff(3)-lorenz(xloss,w2,dele)*ff(2))
        endif


c       cycle over contour points 
        do ic = 1,nc-1
c         perform integration over contour from efermi+i*2*w1 to 
c         efermi+i*xloss; linear interpolation of ff between  z1 and z2
          z1 = ec(ic)
          z2 = ec(ic+1)
c         if (ic.eq.1) z1 = efermi+coni*2*w1
          f1 = ff(ic)
          f2 = ff(ic+1)
c         if (ic.eq.1) f1 = (f1*(z2-z1) + f2*(z1-ec(ic))) / (z2-ec(ic))
c         add correction from pole above real axis
          aa = 0
          if (abs(z1-e1).gt.eps4 .and. abs(z2-e1).gt.eps4) then
            aa = log((z2-e1)/(z1-e1)) *(f1*(z2-e1)+f2*(e1-z1))
c           z1 or z2 equal to e1; in this case corr is exactly zero
          endif
c         second pole 
          aa = aa - log((z2-e2)/(z1-e2)) *(f1*(z2-e2)+f2*(e2-z1))
          corr = corr + aa/ (z2-z1) /2/pi/coni
        enddo
c       end of cycle over contour points
        if (ispec.eq.2) corr = -corr
c       if (ispec.eq.2) corr = 0

        cchi(ie) = cchi(ie) +  corr
c       return the result of convolution minus bare value
        cchi(ie) = cchi(ie) - xmu(ie)
      enddo
c     end of cycle over frequency points

c     restore the input energy mesh
      if (abs(vrcorr).gt.eps4) then
        do  ie = ne1+1, ne
          emxs(ie) = emxs(ie) + vrcorr
        enddo
      endif

      return
      end

      complex*16 function lorenz (xloss, w, dele)
      implicit double precision (a-h, o-z)
      include '../HEADERS/const.h'
c     ifp is dummy now. correspond to ifp=0 in old code
c     can remove it and change calls to lorenz in other routines

      lorenz = xloss /pi / (xloss**2+(coni*w-dele)**2)

      return
      end

      double precision function astep ( xloss, dele)
      implicit double precision (a-h, o-z)
      include '../HEADERS/const.h'

      astep = 0.5d0 + atan(dele/xloss) /pi
      if (astep.lt.0.d0) astep = 0.d0
      if (astep.gt.1.d0) astep = 1.d0

      return
      end

      subroutine genfmt_prep(phpad, ispin,
c     arguments for rdxsph
     &       ne, ne1, ne3, npot, ihole, rnrmav,
     &       xmu, edge, ik0, ixc, rs, vint,
     &       em, eref2, iz, potlbl, ph4, rkk2, lmax, lmaxp1,
c     arguments for setkap
     &       kinit, linit, ilinit,
c     argument for snlm (also a return)
     &       xnlm,
c     things set here
     &       eref, ph, xk, ck, ckmag, xkr,
     &       nsp, ll, npath, ntotal, nused, xportx)

c+---------------------------------------------------------------------
c     "Based on or developed using Distribution: FEFF8.5L
c      Copyright (c) [2013] University of Washington"
c
C  See ../HEADERS/license.h for full llicense information
c+---------------------------------------------------------------------
c  abstract out the initialization parts of genfmt.  this can then be
c  dropped into genfmt for normal use or be used as part of a single-path
c  library
c+----------------------------------------------------------------------
c     phpad  - specify path to phase.pad     (character*256)
c  Energy grid information
c     em     - complex energy grid
c     eref   - V_int + i*gamach/2 + self-energy correction
c     ne     - total number of points in complex energy grid
c     ne1    - number of points on main horizontal axis
c     ne2    - number of points on vertical vertical axis ne2=ne-ne1-ne3
c     ne3    - number of points on auxilary horizontal axis (need for f')
c     xmu    - Fermi energy
c     edge   - x-ray frequency for final state at Fermi level
c     ik0    - grid point index at Fermi level
c  Potential type information
c     npot   - number of potential types
c     iz     - charge of nuclei (atomic number)
c     potlbl - label for each potential type
c     lmax   - max orb momentum for each potential type
c     ihole  - index of core-hole orbital for absorber (iph=0)
c     rnrmav - average Norman radius (used in headers only)
c  Main output of xsect and phases module (except that in xsect.bin)
c     ph     - complex scattering phase shifts
c     rkk    - complex multipole matrix elements
c+----------------------------------------------------------------------

      implicit double precision (a-h, o-z)

      include '../HEADERS/const.h'
      include '../HEADERS/dim.h'

      complex*16 ph(nex,-ltot:ltot,0:nphx), eref(nex), em(nex)
      complex*16 ph4(nex,-ltot:ltot, nspx, 0:nphx), eref2(nex,nspx)
      complex*16 ck(nex)
      complex*16 rkk2(nex,8,nspx)
      double precision xk(nex), ckmag(nex), xkr(nex)
      double precision rnrmav, xmu, edge
      dimension xnlm(ltot+1,mtot+1)
      integer lmax(nex,0:nphx), iz(0:nphx)
      integer ne, ne1, ne3, npot, ihole, ik0, kinit, linit, ll
      integer nsp, ispin
      character*6  potlbl(0:nphx)

      character*2 atsym
      external atsym

      character*256 phpad

c     Read phase calculation input
c      print *, 'calling rdxsph'
      call rdxsph (phpad,
     1     ne, ne1, ne3, npot, ihole, rnrmav, xmu, edge, ik0,
     2     ixc, rs, vint,
     3     em, eref2, iz, potlbl, ph4, rkk2, lmax, lmaxp1)
      call setkap (ihole, kinit, linit)
      ilinit = linit + 1

c
c     need to sum over spin-up and -down for |ispin|=1 (fix later)
      nsp = 1
      if (ispin.eq.1) nsp = nspx

      if (nsp.eq.1) then
c        for ispin=2 the variables already written into is=1 positions
         is = 1
         do 10 ie = 1, ne
            eref(ie) = eref2(ie,is)
 10      continue
         do 20 iph = 0, npot
            do 22 ie = 1, ne
               do 24 il = -lmax(ie, iph), lmax(ie, iph)
                  ph(ie,il, iph) = ph4(ie, il, is, iph)
 24            continue
 22         continue
 20      continue
      else
c        average over two spin direction
         do 12 ie = 1, ne
            eref(ie) = (eref2(ie,1) + eref2(ie,nsp)) /2
 12      continue
c        !KJ  12     eref(ie) = (eref2(ie,1) + eref2(ie,2)) /2
         do 30 iph = 0, npot
            do 32 ie = 1, ne
               do 34 il = -lmax(ie, iph), lmax(ie, iph)
                  ph(ie,il, iph) = (ph4(ie, il, 1,iph) + 
     &                   ph4(ie, il, nsp,iph)) /2
 34            continue
 32         continue
 30      continue
c        !KJ  22     ph(ie,il, iph) =(ph4(ie, il, 1,iph) + ph4(ie, il, 2,iph)) /2
      endif

c     Set nlm factors in common /nlm/ for use later
      call snlm (ltot+1, mtot+1, xnlm)

      do 380 i = 0, npot
         if (potlbl(i).eq.' ') potlbl(i)  = atsym(iz(i))
         if (potlbl(i).eq.' ') potlbl(i)  = 'null'
 380  continue 

c     Make xk and ck array for later use
      do 850  ie = 1, ne
c        real momentum (k)
         xk(ie) = getxk (dble(em(ie)) - edge)
c        complex momentum (p)
         ck(ie) = sqrt (2*(em(ie) - eref(ie)))
         ckmag(ie) = abs(ck(ie))
         xkr(ie) = real(xk(ie))
 850  continue

c     Central atom phase shifts
      ll = linit+1
      if (kinit.lt.0) ll = -ll

      npath  = 0
      ntotal = 0
      nused  = 0
      xportx = -1


      return
      end

      subroutine mkptz (ipol, elpty, evec, xivec, ispin, spvec,nat,rat,
     1                  angks, le2, ptz)
c     choose new right handed frame of reference with z along spvec,
c      y along (xivec cross spvec); simpler choice if one of them is 0.
c     get all vectors in new frame and
c     makes polarization tensor ptz when z is rotated along k-vector

c     input:
c     ipol = 0  random k-vector orientation in 3d; ptz(i,j)=\delta_{i,j}
c     ipol = 1 for polarizion vector eps and it's  complex conjugate epc
c        ptz(j,i) = 0.5 [(eps(-i))^* eps(-j) + (epc(-i))^* epc(-j)]
c        notice that complex conjugation and taking i-th component
c        are non commuting operations. (eps(-i))^* = (-)^i (epc(i))
c     ipol = 2 ptz(i,j)= i*\delta_{i,j}
c     elpty - ellipticity (optional for ipol=1)
c     xivec - direction of x-ray propagation
c     ispin - type of spin calculations
c        0 - spin independent
c        -1,1 - spin dependent potential
c        2 - calculations with spin-up potential
c       -2 - calculations with spin-down potential
c     spvec - direction of spin vector (along z at the output)
c     nat - number of atoms
c     rat - xyz cordinates of atoms (changed due to the rotations)

c     output:
c     angks - angle between k-vector and spin-vector (0-pi)
c     le2   - 0-only E1, 1-E1+M1, 2-E1+E2, 3-E1+E2+M1 transitions
c     ptz   - polarization tensor

      implicit double precision (a-h, o-z)

c     all input and output through common area /pol/
      include '../HEADERS/const.h'
      dimension evec(3), xivec(3), spvec(3), rat(3,nat)
      complex*16 ptz
      dimension ptz(-1:1, -1:1)

c     addittonal local stuff to create polarization tensor ptz(i,j)
      dimension e2(3)
      complex*16  e(3),eps,epc
      dimension eps(-1:1),epc(-1:1)
      character*512 slog

c     make z axis along propagation (XIVEC).
c     le2=0 - only E1 transitions; le2=1 - E1+M1; le2=2 - E1+E2 
      rr = xivec(1)**2 + xivec(2)**2 + xivec(3)**2
      if (rr.eq.0) then
        angks = 0
c       special case when xivec is not specified
        if (ipol.eq.1) then
c         need to know xivec for E2 and M1 transitions
c         leave only E1 contribution
          if (le2.ne.0) call wlog(
     1    '  Can do only E1 transitions. Specify k-vector for M1 or E2')
          le2 = 0
        else
c         for polarization average of circular dichroizm
          if (ispin.ne.0) then
c           spin-dependent case
            do 10 i = 1,3
  10        xivec(i) = spvec(i)
            rr = xivec(1)**2 + xivec(2)**2 + xivec(3)**2
          endif
        endif
      endif
            
              
      if (rr.gt.0) then
         rsp = sqrt(rr)
         rr = xivec(1)**2 + xivec(2)**2
         if ( rr.ne.0 .or. xivec(3).lt.0) then
           if (rr.eq. 0) then
             cst = - 1
             snt = 0
             csf = 1
             snf = 0
           else
c            rotation is defined by angles theta and fi
             rr = sqrt(rr)
             cst = xivec(3) / rsp
             snt = rr / rsp
             csf = xivec(1) / rr
             snf = xivec(2) / rr
           endif
c          rotate all vectors
           do 20 i = 1, nat
 20        call rotate (rat(1,i), cst, snt, csf, snf)
           call rotate (evec, cst, snt, csf, snf)
           call rotate (xivec, cst, snt, csf, snf)
           call rotate (spvec, cst, snt, csf, snf)
         endif
      endif


c     initialize ptz
      do 30 i=-1,1
      do 30 j=-1,1
 30   ptz(j,i) = 0

c     make ptz in the frame when z is along xivec, except ipol=0
      if (ipol .eq. 0) then
         do 40 i=-1,1
 40      ptz(i,i) = 1.d0 /3.d0
      elseif (ipol .eq. 2) then
         ptz( 1, 1) =  1.d0
         ptz(-1,-1) = -1.d0
      elseif (ipol .eq. 1) then
c       Normalize polarization vector
        x = sqrt (evec(1)**2 + evec(2)**2 + evec(3)**2)
        if (x .le. 0.000001) then
         call wlog(' STOP  Polarization vector of almost zero length')
         call wlog(' Correct POLARIZATION card')
         call par_stop('MKPTZ-1')
        endif
        do 50  i = 1, 3
         evec(i) = evec(i) / x
  50    continue
        x = sqrt (xivec(1)**2 + xivec(2)**2 + xivec(3)**2)
        if (x .gt. 0) then
c         run elliptical polarization code
          do 60  i = 1, 3
            xivec(i) = xivec(i) / x
  60      continue
          x = evec(1)*xivec(1)+evec(2)*xivec(2)+evec(3)*xivec(3)
          if (abs(x) .gt. 0.9) then
            call wlog(' polarization')
            write(slog,292)  (evec(i), i=1,3)
            call wlog(slog)
            call wlog(' incidence')
            write(slog,292) (xivec(i), i=1,3)
            call wlog(slog)
            call wlog(' dot product')
            write(slog,292)  x
            call wlog(slog)
  292       format (5x, 1p, 2e13.5)
            call wlog(' STOP polarization almost parallel' //
     1                ' to the incidence')
            call wlog(' Correct ELLIPTICITY and POLARIZATION cards')
            call par_stop('MKPTZ-2')
          endif
          if (x .ne. 0.0) then
c           if xivec not normal to evec then make in normal, keeping the
c           plane based on two vectors
            call wlog(' Changing polarization vector!')
            call wlog(' Incidence is not normal to polarization.')
            call wlog(' Check your input for errors. Run continues.')
            do 70  i = 1,3
              evec(i) = evec(i) - x*xivec(i)
  70        continue
            x = sqrt (evec(1)**2 + evec(2)**2 + evec(3)**2)
            do 80   i = 1, 3
               evec(i) = evec(i) / x
  80        continue
          endif
        else
c         elpty cannot be used with xivec=0
          elpty = 0.0
        endif 
     
        e2(1) = xivec(2)*evec(3)-xivec(3)*evec(2)
        e2(2) = xivec(3)*evec(1)-xivec(1)*evec(3)
        e2(3) = xivec(1)*evec(2)-xivec(2)*evec(1)
        do 90   i = 1,3
          e(i) = (evec(i)+elpty*e2(i)*coni)
  90    continue 
        eps(-1) =  (e(1)-coni*e(2))/sqrt(2.0)
        eps(0)  =   e(3)
        eps(1)  = -(e(1)+coni*e(2))/sqrt(2.0)
        do 100  i = 1,3
          e(i) = (evec(i)-elpty*e2(i)*coni)
  100   continue 
        epc(-1) =  (e(1)-coni*e(2))/sqrt(2.0)
        epc(0)  =   e(3)
        epc(1)  = -(e(1)+coni*e(2))/sqrt(2.0)
        do 110 i = -1,1
        do 110 j = -1,1
c         ptz(j,i) = (-1.0)**i * epc(i)*eps(-j) / (1+elpty**2)
c         above - true polarization tensor for given ellipticity, 
c         below - average over left and right in order to have
c         path reversal simmetry
          ptz(j,i) = ((-1.0)**i)*(epc(i)*eps(-j)+eps(i)*epc(-j))
     1               /(1+elpty**2)/2.0
  110   continue
      endif
c     end of making polarization tensor

      angks = 0


c     second rotate so that z parrallel to spin
c     note that new y-axis is normal to spin AND incidence vector
c     which simplifies further expression for rotation matrix
      rr = spvec(1)**2 + spvec(2)**2 + spvec(3)**2
      if (rr.gt.0) then
         rsp = sqrt(rr)
         rr = spvec(1)**2 + spvec(2)**2
         if ( rr.ne.0 .or. spvec(3).lt.0) then
           if (rr.eq. 0) then
             cst = - 1
             snt = 0
             csf = 1
             snf = 0
             angks = pi
           else
c            rotation is defined by angles theta and fi
             rr = sqrt(rr)
             cst = spvec(3) / rsp
             snt = rr / rsp
             csf = spvec(1) / rr
             snf = spvec(2) / rr
             angks = acos( cst)
           endif
c          rotate all vectors
           do 120 i = 1, nat
 120       call rotate (rat(1,i), cst, snt, csf, snf)
           call rotate (evec, cst, snt, csf, snf)
           call rotate (xivec, cst, snt, csf, snf)
         endif
      endif

      return
      end

      subroutine rotate (vec, cst, snt, csf, snf)
      implicit double precision (a-h, o-z)
c     rotates vector to a new coordinate system
c     Euler angles: alpha=phi, beta=theta, gamma=0
      dimension vec(3), temp (3)

      temp(1) = vec(1)*cst*csf + vec(2)*cst*snf - vec(3)*snt
      temp(2) = -vec(1)*snf + vec(2)*csf
      temp(3) = vec(1)*csf*snt + vec(2)*snt*snf + vec(3)*cst
      do 10 i = 1,3
  10  vec(i) = temp(i)

      return
      end

      subroutine afolp (verbse, nph, nat, iphat, rat, iatph, xnatph,
     1                novr, iphovr, nnovr, rovr, folp, folpx, iafolp,
     1                edens, edenvl,
     2                dmag, vclap, vtot, vvalgs, imt, inrm, rmt, rnrm, 
     2                ixc, rhoint, vint, rs, xf, xmu, xmunew,
     3                rnrmav, qtotel, inters, totvol)

c     find folp(iph) automatically and recalculates
c     interstitial parameters, rmt, vint, etc.
c     written by ala 11.97
      implicit double precision (a-h, o-z)

      include '../HEADERS/const.h'
      include '../HEADERS/dim.h'

      logical verbse

      dimension iphat(natx)
      dimension rat(3,natx)
      dimension iatph(0:nphx)
      dimension xnatph(0:nphx)
      dimension novr(0:nphx)
      dimension iphovr(novrx,0:nphx)
      dimension nnovr(novrx,0:nphx)
      dimension rovr(novrx,0:nphx)
      dimension folp(0:nphx), folpx(0:nphx)
      dimension edens(251,0:nphx), edenvl(251,0:nphx)
      dimension dmag(251,0:nphx+1)
      dimension vclap(251,0:nphx)
      dimension vtot (251,0:nphx), vvalgs (251,0:nphx)
      dimension imt(0:nphx)
      dimension inrm(0:nphx)
      dimension rmt(0:nphx), rmtx(0:nphx)
      dimension rnrm(0:nphx)
      character*512 slog

      do 5 iph=0,nph
         rmtx(iph) = rmt(iph) / folp(iph)
   5  continue

      if (verbse)
     1call wlog('    : ipot, Norman radius, Muffin tin radius, Overlap')
      if (iafolp.ge.0) then
         do 400  iph = 0, nph
c          old algorithm for automatic overlap
c          folp(iph) = 1 + 0.7*(rnrm(iph)/rmt(iph) - 1)
           folp(iph) = folpx(iph)
           rmt(iph) = folp(iph) * rmtx(iph)

           if (verbse) then
 398          format(i10, 1p, 3e13.5)
              write(slog,398) iph, rnrm(iph)*bohr, rmt(iph)*bohr,
     1               folp(iph)
              call wlog(slog)
           endif
  400    continue

         idmag = 0
         call istprm (nph, nat, iphat, rat, iatph, xnatph,
     1               novr, iphovr, nnovr, rovr, folp, folpx, iafolp,
     1               edens, edenvl, idmag,
     2               dmag, vclap, vtot, vvalgs, imt, inrm, rmt, rnrm,
     3               ixc, rhoint,vint, rs, xf, xmu, xmunew,
     4               rnrmav, qtotel, inters, totvol)

      endif

      return
      end

      subroutine potslw (dv,d,dr,dpas,np)
c
c coulomb potential uses a 4-point integration method
c dv=potential;  d=density;  dp=bloc de travail; dr=radial mesh
c dpas=exponential step;
c np=number of points
c **********************************************************************

      implicit double precision (a-h,o-z)
      dimension dv(251), d(251), dp(251), dr(251)

      das=dpas/24.0
      do 10 i=1,np
   10 dv(i)=d(i)*dr(i)
      dlo=exp(dpas)
      dlo2=dlo*dlo
      dp(2)=dr(1)*(d(2)-d(1)*dlo2)/(12.0*(dlo-1.0))
      dp(1)=dv(1)/3.0-dp(2)/dlo2
      dp(2)=dv(2)/3.0-dp(2)*dlo2
      j=np-1
      do 20 i=3,j
   20 dp(i)=dp(i-1)+das*(13.0*(dv(i)+dv(i-1))-(dv(i-2)+dv(i+1)))
      dp(np)=dp(j)
      dv(j)=dp(j)
      dv(np)=dp(j)
      do 30 i=3,j
      k=np+1-i
   30 dv(k)=dv(k+1)/dlo+das*(13.0*(dp(k+1)/dlo+dp(k))-(dp(k+2)/dlo2+dp
     1 (k-1)*dlo))
      dv(1)=dv(3)/dlo2+dpas*(dp(1)+4.0*dp(2)/dlo+dp(3)/dlo2)/3.0
      do 40 i=1,np
   40 dv(i)=dv(i)/dr(i)
      return
      end

      subroutine json_xsect(ntitle, title, s02, erelax,
     -       wp, edge, emu,
     1       gamach, ne, ne1, ik0,
     2       col1, col2, col3, col4, col5)

      include '../HEADERS/dim.h'
      integer ntitle, ne, ne1, ik0
      character*80 title(nheadx)
      double precision s02, erelax, wp, edge, emu, gamach
      double precision col1(nex), col2(nex), col3(nex)
      double precision col4(nex), col5(nex)

      return
      end

c     code: relativistic atom code (relativistic hartree fock slater)
c     modified desclaux code -- partially translated from the french
c
c     modified by: r. c. albers (from previously modified code from
c                  j. e. muller who in turn got it from the danes)
c                  j. j. rehr and s. i. zabinsky for inclusion in feff 
c
c     special features:  renormalizes charge density at wigner-seitz
c                        radius
c
c     version 2 (30 september 87): renormalized coulomb potential and
c     renormalized charge density are produced to be used in XAFS
c     calculations by cphase program. j.j. rehr, j. mustre  university
c     of washington., a.djaoui university of essex.
c     please acknowledge use. r. c. albers  (los alamos national lab)
c     j.j. rehr (university of washington),
c
c     Subroutine calling hierarchy siz 1/8/90
c     ATOM
c        INDATA
c           GETORB
c           FPOT
c        DIRAC
c           INOUH
c           INTH
c        POTSL
c        SOMM
c        TOTALE
c           SOMM
c        CDSLD
c           SOMM
c           YKDIR
c        RENORM
c           POTSLW
c
c     Version 1/11/90:  Input and output re-organized to work
c                       easily with overlapped potential code
c                       in FEFF.
c
c     Version Aug 1990: Minor modification to work more easily with
c                       FEFF4, cluster version.  SRHO no longer has
c                       factor of r**2.  INDATA uses rr function to
c                       set r grid.
c     Version Dec 1990: Writes to atom.dat restored
c     Version Feb 1991: Unit 16 opened in atom if necessary
c     June 1992  dirac upper and lower components and total energy
c                passed out for use with matrix element calculations
c
c     Input:   title    title, max 40 characters
c              ifr      index of free atom, used for output labels
c              iz       atomic number of atom
c              ihole    location of electron hole
c              rws      Wigner-Seitz radius
c              ionin    ionicity
c              iprint   print flag, passed through commom /print/
c              ispinr   0, do not save dirac spinors, else save for
c                       orbital ispinr
c
c     Output:  vcoul(251)  coulomb potential (no factor r**2)
c              srho(251)   electron density in form
c                          4*pi*density (formerly 4*pi*density*r**2)
c              dgc0(251)   large component (set if ispinr.ne.0)
c              dpc0(251)   small component (set if ispinr.ne.0)
c              eatom       total energy in rydbergs
c
c     All data is on a grid r(i) = exp (-8.8 + (i-1)*0.05)

      subroutine atom (title, ifr, iz, ihole, rws, ionin, vcoul, srho,
     1                 ispinr, dgc0, dpc0, eatom)

      implicit double precision (a-h,o-z)
      save

c     Save central atom dirac components, see comments below.
      dimension dgc0(251), dpc0(251)

      character*(*)  title
      dimension vcoul(251)
      dimension srho(251)
      common /print/ iprint

      common /atomco/ den(30), dq1(30), dfl(30), ws, nqn(30), nql(30),
     1                nk(30), nmax(30), nel(30), norb, norbco

      common /dira/ dv(251), dr(251), dp(251), dq(251), dpas, tets,
     1              z, nstop, nes, np, nuc

      common /ps2/ dexv, dexe, dcop, test, teste,
     1             testy, testv, niter, ion, icut, iprat, irnorm

      common /deux/ dvn(251), dvf(251), d(251), dc(251), dgc(251,30),
     1              dpc(251,30)

      character*40 ttl
      character*2  titre
      common /char/ titre(30), ttl

      dimension tden(30)
      character*30 fname
       external dalp
      data harryd /2./

      if (iprint .ge. 3)  then
c        prepare file for atom output
         write(fname,14)  ifr
   14    format('atom', i2.2, '.dat')
         open (unit=16, file=fname, status='unknown', iostat=ios)
         call chopen (ios, fname, 'atom')
c        call head (16)
         write(16,*)  ' Free atom ', ifr
      endif

      ttl = title

      nstop=1
      mark=0

      call indata (iz, ihole, rws, ionin)
      iter=1
      do 30 i=1,np
      do 30 j=1,norb
         dgc(i,j)=0.0
         dpc(i,j)=0.0
   30 continue

      if (iprint .ge. 3)  write(16,40) ttl
   40 format (1h1,40x,a40)
      n=-(ion+1)

   60 continue
      do 70 i=1,np
         d(i)=0.0
   70 continue
      tets=test
      ymax=0.0
      vmax=0.0
      emax=0.0

c resolution of the dirac equation for each orbital
      do 150 j=1,norb
         de=den(j)
   80    call dirac (nqn(j),nql(j),nk(j),imax,den(j),dfl(j),dq1(j),j)
            if (nstop.eq.0) go to 110
            if (nstop.ne.362.or.iter.ge.10.or.tets.gt.test) go to 90
            tets=testv
         go to 80
   90    if (iprint .ge. 3)  write(16,100) nstop,nqn(j),titre(j)
  100    format ('  nstop=',i4,'  for the orbital',i3,a2)
         call echo( ' Fatal error.  Wigner-Seitz or muffin tin')
         call echo( '               radius may be too small.')
         go to 999

  110    val=abs((den(j)-de)/de)
         if (val.gt.emax) emax=val
         nmax(j)=imax
         do 140 i=1,np
            val=dgc(i,j)-dp(i)
            if (abs(dp(i)).gt.1.0) val=val/dp(i)
            if (abs(val).lt.abs(ymax)) go to 120
               ymax=val
               y=dp(i)
               yn=dgc(i,j)
  120       val=dpc(i,j)-dq(i)
            if (abs(dq(i)).gt.1.0) val=val/dq(i)
            if (abs(val).lt.abs(ymax)) go to 130
               ymax=val
               y=dq(i)
               yn=dpc(i,j)
  130       dgc(i,j)=dp(i)
            dpc(i,j)=dq(i)
  140    d(i)=d(i)+nel(j)*(dp(i)*dp(i)+dq(i)*dq(i))
  150 continue

c     dgc and dpc are set in loop above, only referenced in remainder
c     of code, so save them into dgc0 and dpc0 here.  Note: np=251,
c     set in indata.  dgc0 is large component
c                     dpc0 is small
      if (ispinr .ne. 0)  then
         do 152  i = 1, np
            dgc0(i) = dgc(i,ispinr)
            dpc0(i) = dpc(i,ispinr)
  152    continue
      endif

      if (mark.eq.0) go to 280

c  This is case mark .ne. 0
c  d is the core electron density resulting from the renormalized pot.
      dval=0.0
      do 160 j=1,norb
  160    dval=dval+nel(j)*den(j)

      dval=dval*2.0
c jm-- core charge density commented away in unit 6 appears in unit 3--
      if (iprint .ge. 3)  write(16,170) dval
  170 format (1h ,' core energy = ',e15.8)

c jm- renormalized potential

c     note conversion to rydbergs using constant harryd
c     passvt is part of old system to pass data directly from
c     ATOM to PHASE
c      do 200 ixx=1,251
c  200    passvt(ixx)=harryd*dr(ixx)*dr(ixx)*dv(ixx)


c  d is the core electron density resulting from the renormalized pot.

c  next write renormalized electron density for each shell
      do 270 j=1,norb
         do 240 i=1,np
            d(i)=dgc(i,j)*sqrt(12.56637062)
  240    continue
  270 continue
      go to 750

c     mark .eq. 0 case
  280 continue

      call potsl (dc,d,dp,dr,dpas,dexv,z,np,ion,icut,dvn)
      if (nuc.le.0) go to 300
         do 290 i=1,nuc
            dc(i)=dc(i)+z/dr(i)+z*((dr(i)/dr(nuc))**2-3.0) /
     1            (dr(nuc)+dr(nuc))
  290    continue
  300 continue
      do 310 i=1,np
         dval=abs(dc(i)-dv(i))
         if ((dr(i)*dc(i)).le.n) dval=-dval/dc(i)
         if (dval.le.vmax) go to 310
            vmax=dval
            j=i
  310 continue

c     print 320, iter,vmax,dr(j),dv(j),dc(j),emax,ymax,yn,y
c 320 format (i5,1pe11.2,3(1pe16.6),2(1pe11.2),2(1pe16.6))

      if (tets.le.test.and.emax.le.teste.and.vmax.le.testv.and.ymax.le
     1 .testy) go to 430
      if (mark.eq.1) go to 430
      iter=iter+1
      if (iter.le.niter) go to 340
      if (iprint .ge. 3)  write(16,330) niter
  330 format (' number of iterations greater than',i4)
      nstop=2
       call echo(' ATOM-Fatal error, too many iterations.')
cc       print*, '   iter, niter ', iter, niter
      go to 999
c potential for the following iteration

  340 continue
      if (iter.eq.2) go to 350
      if (iprat) 350,390,350
  350 dval=1.0-dcop
      do 360 i=1,np
      dvn(i)=dv(i)
      dvf(i)=dc(i)
  360 dv(i)=dval*dv(i)+dcop*dc(i)
      go to 60

  390 continue
      do 400 i=1,np
      dval=dalp(dvn(i),dvf(i),dv(i),dc(i))
      dvn(i)=dv(i)
      dvf(i)=dc(i)
  400 dv(i)=dval*dv(i)+(1.0-dval)*dc(i)
      go to 60

  430 if (iprint .ge. 3)  write(16,40) ttl
      if (iprint .ge. 3)  write(16,460)
  460 format (12x,'energie',12x,'(r4)',14x,'(r2)',14x,'(r)',15x,'(r-1)',
     1 13x,'(r-3)'/)

c valeurs moyennes de r
      do 470 i=1,np
      dvf(i)=dc(i)
  470 dq(i)=0.0
      dval=0.0
      do 560 i=1,norb
      im=nmax(i)
      dval=dval+nel(i)*den(i)
      do 480 j=1,im
  480 dc(j)=dgc(j,i)*dgc(j,i)+dpc(j,i)*dpc(j,i)
      l=5
      if (iabs(nk(i)).eq.1) l=l-1
      do 550 j=1,l
      dp(j)=dfl(i)+dfl(i)
      if (j-2) 490,500,510
  490 n=4
      go to 550
  500 n=2
      go to 550
  510 if (j-4) 520,530,540
  520 n=1
      go to 550
  530 n=-1
      go to 550
  540 n=-3
  550 call somm (dr,dc,dq,dpas,dp(j),n,im)
  560 if (iprint .ge. 3)  write(16,570) nqn(i),titre(i),
     1                                   den(i),(dp(j),j=1,l)
  570 format (i3,a2,6(1pe18.7))

      if (dexv.eq.0.0) go to 650

c energie totale en moyenne spherique
      do 580 i=1,norb
  580 tden(i)=-2.0*den(i)

      dc(1)=1
      do 600 i=1,np
  600 dp(i)=d(i)/dr(i)
      if (nuc.le.0) go to 620
      do 610 i=1,nuc
  610 dp(i)=d(i)*(3.0-dr(i)*dr(i)/(dr(nuc)*dr(nuc)))/(dr(nuc)+dr(nuc))
      dc(1)=4
  620 call somm (dr,dp,dq,dpas,dc(1),0,np)
      do 630 i=1,np
      dp(i)=d(i)*dvf(i)
  630 d(i)=d(i)*((d(i)*dr(i))**(1.0/3.0))
      dc(2)=3
      dc(3)=1
      if (nuc.ne.0) dc(3)=4
      call somm (dr,dp,dq,dpas,dc(3),0,np)
      call somm (dr,d,dq,dpas,dc(2),-1,np)
      dc(2)=-3.0*dc(2)/(105.27578**(1.0/3.0))
      dc(1)=-z*dc(1)
      dc(4)=dval-dc(3)
      dval=dval+(dc(1)-dc(3)+(dexe-dexv)*dc(2))/2.0
      dc(3)=(dc(3)-dc(1)-dexv*dc(2))/2.0
      dc(2)=dc(2)*dexe/2.0
      if (iprint .ge. 3)  write(16,640) dval,dc(4),dc(3),dc(2),dc(1)
  640 format (1h0,5x,'et=',1pe14.7,5x,'ec=',1pe14.7,5x,'ee=',1pe14.7,5x,
     1 'ex=',1pe14.7,5x,'en=',1pe14.7)
      go to 660
  650 call totale (dval)
  660 continue

c     pass out eatom (total energy) (factor of 2 is to put energy in
c     rydberg units)
      eatom = 2 * dval

      if (norb.eq.1) go to 710
      if (iprint .ge. 3)  write(16,40) ttl
      if (iprint .ge. 3)  write(16,670)
  670 format (1h0,47x,'overlap integrals         '/)

c overlap integrals
      do 700 i=2,norb
      k=i-1
      do 700 j=1,k
      if (nql(i).ne.nql(j).or.nk(i).ne.nk(j)) go to 700
      im=nmax(j)
      if (nmax(i).lt.im) im=nmax(i)
      do 680 l=1,im
      dq(l)=dpc(l,i)*dpc(l,j)
  680 dc(l)=dgc(l,i)*dgc(l,j)
      dval=dfl(i)+dfl(j)
      call somm (dr,dc,dq,dpas,dval,0,im)
      if (iprint .ge. 3)  write(16,690) nqn(i),titre(i),
     1                                   nqn(j),titre(j),dval
  690 format (34x,i1,a2,i3,a2,f19.7)
  700 continue
  710 call cdsld


      if (irnorm.eq.1) then
         call renorm (dexv, vcoul, srho)
      endif
      do 720 i=1,np
  720 dc(i)=harryd*dv(i)*dr(i)**2
      if (irnorm.ne.1) call fstop(' at ATOM-0')
      norb=norbco
      if (norbco.eq.0) go to 750
      if (mark.eq.1) go to 750
      mark=1
      go to 60

  750 continue

c     return srho as 4*pi*density instead of 4*pi*density*r**2
      do 760  i = 1, 251
         srho(i) = srho(i) / (dr(i)**2)
  760 continue

      if (iprint .ge. 3)  close(unit=16)

      return


  999 continue
       call fstop(' at ATOM-1')
      end

      subroutine intout (en,i0, kap,max0,ic3,vm)
c                  resolution of the dirac equation
c                   p' - kap*p/r = - ( en/cl-v )*g - eg/r
c                   g' + kap*g/r = ( 2*cl+en/cl-v )*p + ep/r
c at the origin v approximately is -z/(r*cl) due to the point nucleus
c en one-electron energy in atomic units and negative
c at the origin of the large(small)component
c kap quantum number kappa
c max0 the last point of tabulation of the wave function
 
      implicit double precision (a-h,o-z)
      include '../HEADERS/dim.h'
      include '../HEADERS/const.h'
      parameter (npi=6, test=1.0d+5)
      complex*16 en,c3,vmh
      complex*16 gg,ag,gp,ap,dv,av,eg,ceg,ep,cep, vm(nrptx)
      common/comdic/cl,dz,gg(nrptx),ag(10),gp(nrptx),ap(10),dv(nrptx),
     1   av(10),eg(nrptx),ceg(10),ep(nrptx),cep(10)

      complex*16 ec,eph,egh,f,g,ac,bc,acp,bcp,dg,dp, dv1,dv2,vh
      complex*16 dg2, dp2, dg3, dp3, dg4, dp4
      dimension dg(npi), dp(npi)

c gg,gp -output, dv,eg,ep - input
c
c cl speed of light (approximately 137.037 in atomic units)
c dz nuclear charge
c gg (gp) large (small) component
c dv direct potential (v)     eg and ep exchange potentials
c ag,ap,av,ceg and cep are respectively the
c development coefficients for gg,gp,dv,eg and ep
c
      common/tabtec/hx,dr(nrptx),test1,test2,ndor,np,nes,method,idim
c hx exponential step
c dr radial mesh
c test1,test2,nes,method are dummy.
c  ndor number of terms for the developments at the origin
c np maximum number of the tabulation points
c idim dimension of the block dr


      ccl=cl+cl
      exphx = exp (hx/2)
      ihard = 0
      ec=en/cl
 
c            solution of the inhomogenios dirac equation
c gg gp initially exch. terms, at the time of return are wave functions
c ag and ap development coefficients of  gg and gp
c en one-electron energy
c fl power of the first development term at the origin

c     runge-kutta for first npi points
      i = i0
      j=1
      f = (ec - dv(i))*dr(i)
      g = f + ccl * dr(i)
      c3 = ic3*vm(i)/g**2
      dg(j) = hx * (g*gp(i) - kap*gg(i) + ep(i))
      dp(j) = hx * (kap*gp(i) - (f-c3)*gg(i) - eg(i))

 44   continue
      if (i.ge.max0) goto 999
      ac = gg(i) + 0.5d0 * dg(j)
      bc = gp(i) + 0.5d0 * dp(j)
      rh = dr(i) *exphx
c     find potential and exchange terms between 2 points
c     use linear interpolation with imp. nonlinearity correction
      xm1 = (dr(i+1)-rh) / (dr(i+1)-dr(i))
      xm2 = (rh - dr(i)) / (dr(i+1)-dr(i))
      if (dble(av(1)) .lt. 0.0 .and. i0.eq.1) then
c        point nucleus case
c        important nonlinearity from z/r term
         dv1 = dv(i) - av(1)/dr(i)
         dv2 = dv(i+1) - av(1)/dr(i+1)
         vh = dv1*xm1 + dv2*xm2
         vh = vh + av(1)/rh
         vmh = (xm1*vm(i)*dr(i) +xm2*vm(i+1)*dr(i+1))/rh
      elseif (i0.eq.1) then
c        finite nucleus
c        important nonlinearity from z*r**2 term
         dv1 = dv(i) - av(4)*dr(i)**2
         dv2 = dv(i+1) - av(4)*dr(i+1)**2
         vh = (dv1*(dr(i+1)-rh)+dv2*(rh-dr(i))) / (dr(i+1)-dr(i))
         vh = vh + av(4)*rh**2
         vmh = (xm1*vm(i)/dr(i)**2 +xm2*vm(i+1)/dr(i+1)**2)*rh**2
      else
c        outward integration of irregular solution near jri
         vh = dv(i)*xm1 + dv(i+1)*xm2
         vmh = xm1*vm(i) +xm2*vm(i+1)
      endif
      eph = ep(i) * xm1 + ep(i+1) * xm2
      egh = eg(i) * xm1 + eg(i+1) * xm2

      f = (ec - vh)*rh
      g = f + ccl * rh
      c3 = ic3*vmh/g**2
      dg2 = hx * (g*bc - kap*ac + eph)
      dp2 = hx * (kap*bc - (f-c3)*ac - egh)
      ac = ac + 0.50*(dg2-dg(j))
      bc = bc + 0.50*(dp2-dp(j))
      dg3 = hx * (g*bc - kap*ac + eph)
      dp3 = hx * (kap*bc - (f-c3)*ac - egh)
      ac = ac + dg3 - 0.50*dg2
      bc = bc + dp3 - 0.50*dp2

      i=i+1
      j=j+1
      f = (ec - dv(i))*dr(i)
      g = f + ccl * dr(i)
      c3 = ic3*vm(i)/g**2
      dg4 = hx * (g*bc - kap*ac + ep(i))
      dp4 = hx * (kap*bc - (f-c3)*ac - eg(i))
      gg(i) = gg(i-1)+(dg(j-1) + 2.0*(dg2+dg3)+dg4)/6.0
      gp(i) = gp(i-1)+(dp(j-1) + 2.0*(dp2+dp3)+dp4)/6.0
      dg(j) = hx * (g*gp(i) - kap*gg(i) + ep(i))
      dp(j) = hx * (kap*gp(i) - (f-c3)*gg(i) - eg(i))
      if (j.lt.npi) goto 44

c     scale derivatives for milne method
      do 51 i = 1,npi
        dg(i) = dg(i)/hx
 51     dp(i) = dp(i)/hx

c     integration of the inhomogenious system
      a1 = hx * 3.3
      a2 = -hx * 4.2
      a3 = hx * 7.8
      a4 = hx * 14.0/45.0
      a5 = hx * 64.0/45.0
      a6 = hx * 24.0/45.0
      do 55 i = npi+i0-1,max0-1
         nit = 0
c        predictor
         acp=gg(i-5)+a1*(dg(npi)+dg(npi-4))+a2*(dg(npi-1)+dg(npi-3))
     1       +a3*dg(npi-2)
         bcp=gp(i-5)+a1*(dp(npi)+dp(npi-4))+a2*(dp(npi-1)+dp(npi-3))
     1       +a3*dp(npi-2)
c        ac,bc -corrector w/o contribution from derivatives at i+1
         ac=gg(i-3)+a4*dg(npi-3)+a5*(dg(npi)+dg(npi-2))+a6*dg(npi-1)
         bc=gp(i-3)+a4*dp(npi-3)+a5*(dp(npi)+dp(npi-2))+a6*dp(npi-1)
         do 61 j=1,npi-1
            dg(j)=dg(j+1)
 61         dp(j)=dp(j+1)
         f=(ec-dv(i+1))*dr(i+1)
         g=f+ccl*dr(i+1)
         c3 = ic3*vm(i+1)/g**2
 64      dg(npi)=g*bcp-kap*acp+ep(i+1)
         dp(npi)=kap*bcp-(f-c3)*acp-eg(i+1)
c        corrected values
         gg(i+1)=ac+a4*dg(npi)
         gp(i+1)=bc+a4*dp(npi)
         if ( abs(test*(gg(i+1)-acp)) .gt. abs(gg(i+1)) .or.
     1        abs(test*(gp(i+1)-bcp)) .gt. abs(gp(i+1)) ) then
c           test failed
            if (nit.lt.40) then
               acp = gg(i+1)
               bcp = gp(i+1)
               nit = nit + 1
               goto 64
            else
               ihard = ihard+1
            endif
         endif
 55   continue

 999  do 741 i=max0+1,np
         gg(i)=0.0d 00
 741     gp(i)=0.0d 00

      return
      end

c     sub-program exchange
      program ffmod6
c     subroutine ffmod6 (iabs)

c     final calculations for various spectroscopies
c     (EXAFS, XANES, FPRIME, DANES, XES)
c     written by a.ankudinov 2000
c     modified by a.ankudinov 2001 for new I/O structure

c     INPUT: mod6.inp global.dat xsect.bin fms.bin list.dat and feff.pad
c     OUTPUT: xmu.dat (chi.dat for EXAFS)

      implicit double precision (a-h, o-z)

      include '../HEADERS/dim.h'
      include '../HEADERS/parallel.h'
      integer elnes,ipmin,ipmax,ipstep  !KJ my variables 1-06 
      integer absolu !KJ 3-06     


      call par_begin
      if (worker) go to 400

c     sub-program exchange
      iabs = 1
c     

c     open the log file, unit 11.  See subroutine wlog.
      open (unit=11, file='log6.dat', status='unknown', iostat=ios)
      call chopen (ios, 'log6.dat', 'feff')

c     read  input files
      call reff2x(mchi, ispec, ipr6, idwopt, critcw, s02, sig2g,
     1                   tk, thetad, mbconv, absolu,  !KJ added absolu 3-06
     1                   vrcorr, vicorr, alphat, thetae, nabs,
     4            elnes,ipmin,ipmax,ipstep)   !KJ added this line 1-06     

      if (mchi .eq. 1)  then
         call wlog(' Calculating chi...')
         if (ispec.gt.0 .and. ispec.lt.3) then 
c           using FMS+Paths method
            call ff2xmu (ispec, ipr6, idwopt, critcw, s02, sig2g, 
     1                   tk, thetad, mbconv, absolu,  !KJ added absolu 3-06
     1                   vrcorr, vicorr, alphat, thetae, iabs, nabs,
     4            ipmin,ipmax,ipstep)   !KJ added this line  1-06     
         elseif (ispec.eq.3 .or. ispec.eq.4) then 
c           using FMS+Paths method
            call ff2afs ( ipr6, idwopt, critcw, s02, sig2g, 
     1                   tk, thetad, mbconv, absolu,  !KJ added absolu 4-06
     1                   vrcorr, vicorr, alphat, thetae, iabs, nabs,
     4            ipmin,ipmax,ipstep)   !KJ added this line 4-06     
         else
c           using MS Paths expansion
            call ff2chi (ispec, ipr6, idwopt, critcw, s02, sig2g, 
     1           tk, thetad, mbconv, absolu, !KJ added absolu 3-06
     1           vrcorr, vicorr, alphat, thetae, iabs, nabs,
     4           ipmin,ipmax,ipstep) !KJ added this line 1-06     
         endif
         call wlog(' Done with module 6: DW + final sum over paths.')
      endif
      close (unit=11)

  400 call par_barrier
      call par_end
      
c     sub-program exchange
      stop  
c     return

      end

c***********************************************************************
c
c     this subroutine calculates the ' energy dependent
c     exchange-correlation potential' (or 'dirac- hara potential')
c     ref.: paper by s.h.chou, j.j.rehr, e.a.stern, e.r.davidson (1986)
c
c     inputs:    rs in a.u.
c                xk momentum in a.u.
c     outputs:   vr --- dirac potential (Hartrees)
c     written by j. mustre 8/31/87
c**********************************************************************

      subroutine edp (rs, xk, vr)
      implicit double precision (a-h, o-z)
      include '../HEADERS/const.h'

      vr = 0.0d0
      if (rs .le. 100.0) then
c       p = sqrt (k^2 + kf^2) is the local momentum, and x = p / kf
c       Reference formula 23 in Role of Inelastic effects in EXAFS
c       by Rehr and Chou. EXAFS1 conference editted by Bianconi.
c       x is local momentum in units of fermi momentum

        xf = fa / rs
        x = xk / xf
        x = x + 1.0e-5
c       set to fermi level if below fermi level
        if (x .lt. 1.00001) x = 1.00001
        c = abs( (1+x) / (1-x) )
        c = log(c)
        vr = - (xf/pi) * (1 + c * (1-x**2) / (2*x))
      endif

      return
      end

      subroutine trap (x, y, n, sum)
      implicit double precision (a-h, o-z)

c     Trapeziodal integration of y(x), result in sum

      dimension x(n), y(n)

      sum = y(1) * (x(2) - x(1))
      do 10  i = 2, n-1
         sum = sum + y(i) * (x(i+1) - x(i-1))
   10 continue
      sum = sum + y(n) * (x(n) - x(n-1))
      sum = sum/2

      return
      end

! Subroutine getomi finds poles and weights for representing epsInv.
! Written by J. Kas, 2006
      SUBROUTINE getomi(wgrid, epsInv, NPts, NPoles, omi, gi, Deltai,
     &     eps0)
      IMPLICIT NONE
!     Input variables
!     wGrid(NPts)  - grid of omega
!     epsInv(NPts) - loss function
!     NPoles       - Number of poles to represent epsInv
      
!     Output
!     omi          - omega position of poles
!     gi           - pole strengths
!     Deltai       - energry region about omi where
      INTEGER NPoles, NPts
      DOUBLE PRECISION wGrid(NPts), epsInv(NPts), omi(NPoles),
     &     gi(NPoles), Deltai(NPoles), eps0

!     Local variables
      INTEGER maxPts, MaxPoles, iMax, i1, i2
      PARAMETER (maxPts = 50000)
      DOUBLE PRECISION M0, M0i, M1i, MM1i, M1Old, M1New, omNew, omOld,
     $     pi, Tmp1(maxPts), Tmp2(maxPts), IntGrl, a, b, c, frac, egap
      PARAMETER (pi = 3.14159 26535 89793 23846 26433d0)
      EXTERNAL IntGrl
!     Find zeroth moment
!      frac = (1.d0-0.01d0)
      frac = 0.999d0
      M0 = 0.5d0*epsInv(1)*wGrid(1)
      DO i1 = 2, NPts
         M0 = M0 + 0.5d0*(epsInv(i1)+epsInv(i1-1))*
     &        (wGrid(i1)-wGrid(i1-1))
         Tmp1(i1) = epsInv(i1)/wGrid(i1)
         Tmp2(i1) = epsInv(i1)*wGrid(i1)
      END DO
!     Find gap energy
!      DO i1 = 1, NPts
      
!     Now find energy regions such that the integral of epsinv in each region is
!     equal.
      omOld = 0.d0
      omNew = 0.d0
      M1Old = 0.d0
      M1New = 0.d0
      ! Save the first 10 poles for low energies.
      DO i1 = 1, NPoles
         M0i = 0.5d0*epsInv(1)*wGrid(1)
         M1New = 0.5d0*epsInv(1)*wGrid(1)**2
         DO i2 = 2, NPts
            IF(M0i.ge.(DBLE(i1)*frac*M0/DBLE(NPoles))) THEN
               omOld = omNew
               omNew = wGrid(i2-1)
               IF(i2.eq.1) THEN
                  M0i = 0.d0
               ELSEIF(i2.eq.2) THEN
                  M0i = 0.5d0*epsInv(1)*wGrid(1)
               ELSE
                  M0i = M0i - 0.5d0*(epsInv(i2-1)+ epsInv(i2-2))*
     $              (wGrid(i2-1)-wGrid(i2-2))
               END IF
               GOTO 5
            ELSE
               M0i = M0i + 0.5d0*(epsInv(i2)+epsInv(i2-1))*
     $              (wGrid(i2)-wGrid(i2-1))
               M1New = M1New + 0.5d0*(epsInv(i2)*wGrid(i2)+ epsInv(i2-1)
     $              *wGrid(i2-1))*(wGrid(i2)-wGrid(i2-1))
            END IF
         END DO
 5       CONTINUE
 
!        The region has been found up to the wGrid accuracy. Now interpolate
!        to find omi
         IF(i2.eq.2) THEN
            a = epsInv(i2-1)/omNew
         ELSE
            a = (epsInv(i2-1) - epsInv(i2-2))/(omNew - wGrid(i2-2))
            b = epsInv(i2-2)
         END IF
         a = MAX(a, 1.d-6)
         c = 2.d0/a*(M0i - frac*M0*(DBLE(i1)/DBLE(NPoles)))

         omNew = wGrid(i2-2) - b/a + SQRT((b/a)**2 - c)
         IF((omNew.lt.wGrid(i2-2)).or.(omNew.gt.wGrid(i2-1))) THEN
            omNew = wGrid(i2-2) - b/a - SQRT((b/a)**2 - c)
         END IF

         IF(.FALSE.) THEN
            omOld = DBLE(i1-1)*500.d0/DBLE(NPoles)
            omNew = DBLE(i1)*500.d0/DBLE(NPoles) 
         END IF
!        Now set omi and g s.t. the inverse and first moments are preserved for
!        this region.
         MM1i = 0.d0
         M1i  = 0.d0
         IF(omOld.eq.0.d0) THEN
            MM1i = 0.5d0*epsInv(1)
            M1i  = 0.5d0*epsInv(1)*wGrid(1)**2
            omOld = wGrid(1)
         END IF
         MM1i = MM1i + IntGrl(omOld, omNew, wGrid, Tmp1, NPts)
         M1i  = M1i + IntGrl(omOld, omNew, wGrid, Tmp2, NPts)
         gi(i1)  = 2.d0/pi*MM1i
         omi(i1) = SQRT(M1i/MM1i)
         Deltai(i1) = omNew-omOld
         M1Old  = M1New
         !PRINT '(a27,i6,20f20.10)', 'i1, omi, omOld, omNew, a, b', i1,
         !&    omi(i1), omOld, omNew, a, b
      END DO

!     Shift and scale the poles to set inverse moment to 1-1/eps0, without changing
!     first moment. (eps0 is input by user)
      CALL getdom(gi,omi,NPoles,eps0)
      
      RETURN
      END
      subroutine terp (x, y, n, m, x0, y0)
      implicit double precision (a-h, o-z)

      dimension x(n), y(n)

c     Find out between which x points x0 lies
      i = locat (x0, n, x)
      k = min( max(i-m/2,1) , n-m )
      call polint( x(k), y(k), m+1, x0, y0, dy)

      return
      end


      subroutine polint( xa, ya, n, x, y, dy)
c     draws a polynimial P(x) of order (n-1) through n points.
c     returns y = P(x) and dy - estimate of the error
c     adapted  from numerical recipies in fortran by Press et al.
                                                                                                                                                             
      implicit double precision (a-h,o-z)
      integer n, nmax
      parameter (nmax=4)
      dimension xa(nmax), ya(nmax), c(nmax), d (nmax)
                                                                                                                                                             
      ns = 1
      dif = abs (x-xa(1))
      do 10 i=1,n
         dift = abs(x-xa(i))
         if (dift.lt.dif) then
            ns = i
            dif = dift
         endif
         c(i) = ya(i)
         d(i) = ya(i)
  10  continue
      y = ya(ns)
      ns = ns-1
      do 30 m=1,n-1
         do 20 i=1,n-m
            ho = xa(i)-x
            hp = xa(i+m)-x
            w = c(i+1) - d(i)
            den = ho-hp
            if (den.eq.0) pause 'failure in polint'
            den = w/den
            d(i) = hp*den
            c(i) = ho*den
  20     continue
         if (2*ns .lt. n-m) then
            dy = c(ns+1)
         else
            dy = d(ns)
            ns = ns-1
         endif
         y = y + dy
  30  continue
                                                                                                                                                             
      return
      end


      function locat (x, n, xx)
      integer  u, m, n
      double precision x, xx(n)
                                                                                                                                                             
c     Binary search for index of grid point immediately below x.
c     Array xx required to be monotonic increasing.
c     Returns
c     0            x <  xx(1)
c     1            x =  xx(1)
c     i            x =  xx(i)
c     n            x >= xx(n)
                                                                                                                                                             
      locat = 0
      u = n+1
                                                                                                                                                             
   10 if (u-locat .gt. 1)  then
         m = (u + locat) / 2
         if (x .lt. xx(m))  then
            u = m
         else
            locat = m
         endif
         goto 10
      endif
                                                                                                                                                             
      return
      end

      DOUBLE PRECISION FUNCTION IntGrl(a, b, x, y, n)
      INTEGER n, i, iStart, iLast
      DOUBLE PRECISION x(n), y(n), dx, a, b, aEnd, bEnd,
     &     ya, yb

      iStart = -1
      iLast = -1
      IntGrl = 0.d0
      dx = x(2) - x(1)
      
      DO i = 1, n
         IF(x(i).ge.a.and.x(i).lt.b) THEN
            iStart = i
            goto 5
         ELSE
            iStart = -1
         END IF
      END DO
 5    CONTINUE
      
      DO i = n, 1, -1
         IF(x(i).le.b.and.x(i).gt.a) THEN
            iLast = i
            goto 10
         ELSE
            iLast = -1
         END IF
      END DO
 10   CONTINUE

      IF (iStart.lt.0.and.iLast.lt.0) THEN
         CALL terp(x, y, n, 1, a, ya)
         CALL terp(x, y, n, 1, b, yb)
         IntGrl = IntGrl + 0.5d0*(yb+ya)*(b-a)
      ELSE
         DO i = iStart, iLast-1
            dx=x(i+1)-x(i)
            IntGrl = IntGrl + 0.5d0*(y(i)+y(i+1))*dx
         END DO
         
         CALL terp(x, y, n, 1, a, ya)
         CALL terp(x, y, n, 1, b, yb)
         
         IntGrl = IntGrl + 0.5d0*(ya+y(iStart))*(x(iStart) - a)
         IntGrl = IntGrl + 0.5d0*(yb+y(iLast))*(b-x(iLast))
      END IF
      RETURN
      END
      SUBROUTINE rdloss(Uloss,Dat,NPts)
      IMPLICIT NONE
c     Variables passed
      INTEGER Uloss, NPts
      DOUBLE PRECISION Dat(50000,2)

      
c     local variables
      INTEGER nterp,n,i
      DOUBLE PRECISION dum
      CHARACTER(LEN=4) comment
      CHARACTER ch
      CHARACTER(200) Line
      comment='#*!c'
      nterp=1
      n=0

c     Read data into Dat
 200  DO i=1,50000
c     Read past comments
         CALL rdcmt(Uloss,comment)
         READ(Uloss,*,end=250) Dat(i,1), Dat(i,2)
         n=i
      END DO      
 250  CONTINUE
      NPts=n
      
300   CLOSE(Uloss)
      RETURN 
      END
      SUBROUTINE rdcmt(iUnt,Cmt)
      INTEGER iUnt, i1
      CHARACTER(300) line
      CHARACTER(4) Cmt
      CHARACTER TmpCmt(4), ch
      LOGICAL CmtLin

      CmtLin = .true.
      DO i1 = 1, 4
         TmpCmt(i1) = Cmt(i1:i1)
      END DO
 5    CONTINUE
      READ(iUnt,*,END=10) ch
      DO i1 = 1, 4
         IF(ch.eq.TmpCmt(i1)) goto 5
      END DO
      
 10   CONTINUE
      BACKSPACE(iUnt)
      
      RETURN
      END
! Written by J. Kas, 2006
! eps2exc takes loss function from loss.dat and gives poles and weights
! corresponding to the many pole model detailed in
! Phys. Rev. B 76, 195116 (2007). 
! First, regions are chosen 
      PROGRAM eps2exc
      DOUBLE PRECISION Dat(50000,2), g(10000), gamma, omi(10000),
     &     Delta(10000),eps0, sumrl, xNElec, csumrl
      INTEGER i,i1,ios1,ios2,imax, NPoles,NPts,NFile
      CHARACTER*80 infl, outfl, comment
      CHARACTER ch
      EXTERNAL IntGrl
      NPts = 1000
      infl='loss.dat'
      outfl='exc.dat'
      PRINT*, '# Enter number of poles:'
      READ*, NPoles
      ! This input can be used to correct the sumrules
      !PRINT*, '# Enter eps^-1 sumrule and N_el:'
      !READ*, sumrl, xNElec
      sumrl = 1.d0
      xNElec = 1.d0
      PRINT*, 'Is this a metal? (y/n)'
      READ*, ch
      IF(ch.EQ.'y'.OR.ch.EQ.'Y') THEN
         eps0 = -1.d0
      ELSE
         PRINT*, 'Would you like to set the dielectric constant? (y/n)'
         READ*, ch
         IF(ch.EQ.'n'.OR.ch.EQ.'N') THEN
            eps0 = -2.d0
         ELSE
       
            ! This input can be used to correct the dielectric constant,
            ! which is related to the inverse moment.
            ! Use eps0 = -2 to ignore this correction.
            PRINT*, '# Enter dielectric constant: '
            READ*, eps0
         END IF
      END IF 
      PRINT*, eps0
      gamma = 0.01
      csumrl= xNElec/sumrl
      
      OPEN(unit=12,file=infl,status='old')
      OPEN(unit=13,file=outfl,status='replace')
      CALL rdloss(12,Dat,NPts)

      DO i1 = 1, NPts
         Dat(i1,2) = Dat(i1,2)*csumrl
      END DO
      ! getomi finds poles and weights
      CALL getomi(Dat(1,1), Dat(1,2), NPts, NPoles, omi, g, Delta, eps0)
      WRITE(13,'(A33,I4,A6)') '# Loss function represented with ',
     $     NPoles, ' poles'
      WRITE(13,'(A23,f8.4)') '# Dielectric constant: ', eps0
      DO i = 1, NPoles
         WRITE(13,'(4f20.10)'), omi(i), omi(i)*gamma, g(i), Delta(i)
      END DO
      
      END
! This will change the pole representation of the loss function without
! changing the f-sum rules. Written by J. Kas 2006
      SUBROUTINE getdom(gi,omi,NPoles,eps0)
      IMPLICIT NONE

!     Input/output
      INTEGER NPoles
      DOUBLE PRECISION gi(NPoles), omi(NPoles), eps0

!     Local
      INTEGER i1, i2, MxIter
      DOUBLE PRECISION MM1, tol, dom, dom1, dom2, sumg1, sumg2
      PARAMETER(MxIter = 10000, tol = 1.d-6)
      IF(eps0.lt.-1.5d0) RETURN
      IF(eps0.lt.0.d0) THEN
         MM1 = 1.d0
      ELSE
         MM1   = 1.d0 - 1.d0/eps0
      END IF
      dom1  = -omi(1)*0.999d0
      dom2  = omi(1)*0.999d0
!     Bracket dom between dom1 and dom2
      DO i1 = 1, MxIter
         sumg1 = 0.d0
         sumg2 = 0.d0
         DO i2 = 1, NPoles
            sumg1 = sumg1 + gi(i2)*(omi(i2)/(omi(i2)-dom1))**2
            sumg2 = sumg2 + gi(i2)*(omi(i2)/(omi(i2)-dom2))**2
         END DO
         IF((sumg1.lt.MM1).and.(sumg2.gt.MM1)) GOTO 5
         !IF(sumg1.gt.MM1) dom1 = dom1*2.d0
         !IF(sumg2.lt.MM1) dom2 = dom2/2.d0
         PRINT*, 'Error in getdom.f.'
         PRINT*, 'sumg1, sumg2', sumg1, sumg2, MM1, dom1, dom2
         STOP
      END DO
 5    CONTINUE                  ! dom bracketed

      dom = 0.5d0*(dom1+dom2)
      DO i1 = 1, MxIter
         sumg1 = 0.d0
         DO i2 = 1, NPoles
            sumg1 = sumg1 + gi(i2)*(omi(i2)/(omi(i2)-dom))**2
         END DO
         IF(abs((sumg1-MM1)/MM1).lt.tol) GOTO 10
         IF((sumg1-MM1).gt.0.d0) THEN
            dom2 = dom
         ELSE
            dom1 = dom
         END IF
         dom = 0.5d0*(dom1+dom2)
      END DO
 10   CONTINUE

      DO i1 = 1, NPoles
         gi(i1)  = gi(i1)*(omi(i1)/(omi(i1)-dom))**2
         omi(i1) = omi(i1)-dom
      END DO
      RETURN
      END
      

ccccccccccccccccccccccccccccccccccccccccccccccccccc
c      PROGRAM Quartic
      SUBROUTINE Quartic(q)
ccccccccccccccccccccccccccccccccccccccccccccccccccc
c     Finds the roots of the quartic polynomial   c
c             a*q**4 + b*q**2 + c*q + d             c
ccccccccccccccccccccccccccccccccccccccccccccccccccc
      IMPLICIT NONE

c     Variables
      COMPLEX*16 a, b, c, d, A1, B1, D1, D2, P, QPlus, QMin, q(4), F, G

c     PARAMETERS
      DOUBLE PRECISION One, Two, Four, Eight, Twelve, Twnt7, Sevnt2,
     $     Tto1O3, Tto2O3, Root6, amp
c     Integer-double Parameters
      PARAMETER(One = 1.d0, Two = 2.d0, Four = 4.d0, Eight = 8.d0)
      PARAMETER(Twelve = 12.d0, Twnt7 = 27.d0, Sevnt2 = 72.d0)
c     Irrational Parameters - Tto1O3 = 2**(1/3)
c                           - Tto1O3 = 2**(2/3)
c                           - Root6  = Sqrt(6)
      PARAMETER(Tto1O3 = 1.259921049894873, Tto2O3 = 1.587401051968199)
      PARAMETER(Root6 = 2.449489742783178)

      a = q(1)
      b = q(2)
      c = q(3)
      d = q(4)

c      a = 1.d0
c      b = 2.d0
c      c = 3.d0
c      d = 4.d0

      F  = b**2+ Twelve*a*d
      G  = Two*b**3 + Twnt7*a*c**2 - Sevnt2*a*b*d

      A1 = (G + SQRT(-Four*F**3 + G**2))**(1.d0/3.d0)
      B1 = Two*Tto1O3*F

      P  = SQRT( (-Four*b + B1/A1 + Tto2O3*A1)/a )

      D1 = Eight*b + B1/A1 + Tto2O3*A1
      D2 = Twelve*Root6*c/P

      QPlus = SQRT( -(D1 + D2)/a )
      QMin  = SQRT( -(D1 - D2)/a )

      amp = 1.d0/(Two*Root6)

      q(1) = amp*(P - QPlus)
      q(2) = amp*(P + QPlus)
      q(3) = -amp*(P + QMin)
      q(4) = amp*(-P + QMin)

c      PRINT*, q(1)
c      PRINT*, q(2)
c      PRINT*, q(3)
c      PRINT*, q(4)

      RETURN
      END

      subroutine inipot (dgc, dpc, edenvl, vvalgs, xnmues)
c     initialize values of arrays to zero
      implicit double precision (a-h, o-z)
      include '../HEADERS/dim.h'
      parameter (zero=0.0d0)

      dimension dgc(251,30,0:nphx+1), dpc(251,30,0:nphx+1)
      dimension edenvl(251,0:nphx), vvalgs (251,0:nphx)
      dimension xnmues(0:lx,0:nphx)

      do 10 iph  = 0,nphx+1
      do 10 iorb = 1,30
      do 10 i = 1,251
   10    dgc(i,iorb,iph) = zero

      do 20 iph  = 0,nphx+1
      do 20 iorb = 1,30
      do 20 i = 1,251
   20    dpc(i,iorb,iph) = zero

      do 30 iph = 0, nphx
      do 30 i = 1, 251
   30    edenvl(i, iph) = zero

      do 40 iph = 0, nphx
      do 40 i = 1, 251
   40    vvalgs(i, iph) = zero

      do 50 iph = 0, nphx
      do 50 ll = 0, lx
   50    xnmues (ll, iph) = zero

      return
      end

      subroutine eu2au
c     generic routine to
c     transform all code variables from exp. units (Angstrom, eV, etc.)
c     to the atomic units (bohrs, hartrees, etc.)

      implicit double precision (a-h, o-z)
      include '../HEADERS/const.h'
      include '../HEADERS/dim.h'

c     sig2g is not transformed
      rmax  = rmax  / bohr
      rfms1 = rfms1 / bohr
      rfms2 = rfms2 / bohr
      rdirec = rdirec / bohr
      vr0   = vr0 / hart
      vi0   = vi0 / hart
      vrcorr = vrcorr / hart 
      vicorr = vicorr / hart 
      gamach = gamach / hart
      ecv   = ecv   / hart
      emin  = emin  / hart
      emax  = emax  / hart
      eimag = eimag / hart
      vixan = vixan / hart
      xkstep = xkstep * bohr
      xkmax  = xkmax  * bohr
      totvol = totvol / bohr**3
      do 10 iat = 1, nat
      do 10 i = 1,3
        rat(i,iat) = rat (i, iat) / bohr
  10  continue
      do 20 iph = 0, nph
      do 20 iovr = 1, novr(iph)
         rovr(iovr,iph) = rovr(iovr,iph) / bohr
  20  continue

      return
      end

c     major revision, input now comes from main program feff
c     input data is passed here to indata for processing

      subroutine indata (iz, ihole, wsin, ionin)

      implicit double precision (a-h, o-z)
      save

c     logical unit from which to read input
      parameter (linp = 1)

      common /print/ iprint
      common /atomco/ den(30), dq1(30), dfl(30), ws, nqn(30), nql(30),
     1                nk(30), nmax(30), nel(30), norb, norbco

      common /dira/ dv(251), dr(251), dp(251), dq(251), dpas, tets,
     1              z, nstop, nes, np, nuc
      common /ps2/ dexv, dexe, dcop, test, teste,
     1             testy, testv, niter, ion, icut, iprat, irnorm

      character*40 ttl, messag*128
      character*2  titre
      common /char/ titre(30), ttl

       external fpot
      character*2  ttire(9)
      data ttire /'s ', 'p*', 'p ', 'd*', 'd ', 'f*', 'f ','g*', 'g '/

c following variables fixed as data by jm 4/20/87
      data i /0/
      data j /0/
      data k /0/
      data l /0/

      idep   = 0
      icut   = 0
c     Normal use, iprat = 1
      iprat  = 1
      irnorm = 1
      iex    = 1
      nuc    = 0

c idep=0 starting potential = thomas-fermi potential
c idep=1 starting potential read in from cards
c if icut is zero one corrects the potential by -(ion+1)/r
c if iprat is zero the pratt procedure is used
c if iex is zero one uses the unmodified slater exchange
c l=0 standard option for the bloc ofs points and their precision
c finite nuclear size option if nuc is positive
c if irnorm=1 renormalize potential to wigner-seitz radius

      dvc=137.0373
      dsal=dvc+dvc
      iz1=0
      ion1=0
      nuc1=-1
      dpas=0.05
      dr1=0.01
      nes=15

      niter=50

c     orig values:  teste 5.e-6, testy 1.e-5, testv 1.e-5, test 1.e-7
c     JM used teste 5.0e-5 to treat negative ion,
c     SZ changed teste to 1.0e-4 for selenium only to avoid convergence
c     problems with this particular atom.
c     teste set to 1.0e-4 to reduce run time (sz and jjr)
      teste = 1.0e-4
      testy=1.e-04
      testv=1.e-04
      test=1.e-07

      np=251
      nstop=30

c     Set dexv to zero for use with exafs model
      dexv = 0.0

      dexe=1.5
      dcop=0.3

c     i, j, k set to zero when old read statements removed
      i=0
      j=0
      k=0

c iz     = atomic number
c ion    = iz-number of electrons
c norb   = number of orbitals
c idep   = should be either 0 or 1
c i      = number of points for the integration = 251 by default
c j      = number of attempts to adjust the energy = 15 by default
c k      = number of iterations = 50 by default
c norbco = number of core orbitals

c put input data passed from feff into the necessary variables
      ws  = wsin
      ion = ionin
c     given iz, find norb, norbco, then den, nqn, nk and nel for
c     each orbital.
      call getorb (iz, ihole, ion, norb, norbco,
     1            den, nqn, nk, nel)

      if (norb .gt. nstop)  then
         if (iprint .ge. 5)  write(16,44) norb
         write(messag,44) norb
         call echo(messag)
   44    format (' norb=',i3,'too big')
         goto 999
      endif

c dexv = exchange coefficient for the potential: dexv=1. for slater
c dexe = exchange energy coefficient
c dexv should be equal to 2.*dexe/3. in order to satisfy the virial theo
c dexv=0.0 and iex=1, hedin-barth exchange and correlation is used

c dpas  = exponential step;  dr1 defines the first point = dr1/iz
c test  = energy precision criteria in dirac
c teste = self-consistency criteria for the energies of all the electron
c testy = self-consistency criteria for the wavefunctions
c testv = self-consistency criteria for the potential
      z=iz

      if (nuc .gt. 0)  then
         call echo(' enter atomic mass ')
         read (linp,*,end=900) dval
c        dval = atomic mass if nuc positive

         dval=z*(dval**(1.0/3.0))*2.267700e-05/exp(4.0*dpas)
         if (dval .le. dr1)  then
            dr1=dval
            nuc=5
         else
            dval=dval*exp(4.0*dpas)
            do 170 i=6,np
               d1=dr1*exp((i-1)*dpas)
               if (d1.ge.dval) goto 190
  170       continue
            write(messag,180)
            call echo(messag)
            if (iprint .ge. 5)  write(16,180)
  180       format (' error for the atomic mass')
            goto 999

  190       nuc=i
            dr1=dr1*dval/d1
         endif
      endif

      if (iprint .ge. 5)  write(16,210) ttl,niter,teste,testy,testv
  210 format (1h1,40x,A40,//,5x,'number of iterations',i4,//,
     1        5x,'precision of the energies',1pe9.2,//,
     2        23x,'wave functions  ',1pe9.2,//,
     3        23x,'potential',1pe9.2,/)

      xtmp = 8.8
      dr1=z*exp(-xtmp)

      if (iprint .ge. 5)  write(16,220) np,dr1,iz,dpas
  220 format (' the integration is made on ', i3,
     1        ' points-the first is equal to ' ,f7.4, '/', i2,/,
     2        ' and the step-size pas = ',f7.4,/)
      if (iprint .ge. 5)  write(16,230) test,nes,idep,icut,iprat
  230 format (' dans le sous programme resld la precision relative a',
     1        ' obtenir sur l energie est ', 1pe9.2,
     2        ' et le nombre d essais ',i3, //,
     3        'idep=', i3, 5x, 'icut=', i3, 5x, 'iprat=', i3, /)
      if (iprint .ge. 5)  write(16,240) dexv,dexe
  240 format ('  dexv=', 1pe14.7, '     dexe=' ,1pe14.7,
     1        ' if dexv=0.0 hedin-barth corr. and exchan. is used'/)
      k=0
      dval=z*z/(dvc*dvc)


      if (nuc.gt.0) then
         if (iprint .ge. 5)  write(16,250)
  250    format (1h0,30x,'finite nucleus case used'/)
      endif

      do 350 i=1,norb
c        den = orbital energy in atomic units and negative
c        nqn = principal quantum number; nk = kappa quantum number
c        nel = occupation of the orbital

         k=k+nel(i)
         if (den(i) .ge. 0.0)  den(i) = -z*z / (4.0*nqn(i)*nqn(i))

         nql(i)=iabs(nk(i))

         if (nk(i).lt.0) nql(i)=nql(i)-1
         if (nuc .le. 0)  then
            dfl(i)=nk(i)*nk(i)
            dfl(i)=sqrt(dfl(i)-dval)
         else
            dfl(i)=iabs(nk(i))
         endif
         l=2*iabs(nk(i))


         if (nql(i).lt.nqn(i)  .and.  nel(i).le.l  .and.
     1       nqn(i).gt.0       .and.  nql(i).le.4)   goto 340
         write(messag,330) den(i),nqn(i),nql(i),j,nel(i)
         call echo(messag)
            if (iprint .ge. 5)  write(16,330) den(i),nqn(i),nql(i),
     1                                         j,nel(i)
  330       format (' error in the card    ',e15.8,i2,3i2)
            goto 999
  340    continue
         j=nql(i)+iabs(nk(i))
         titre(i)=ttire(j)
         if (iprint .ge. 5)  write(16,345) nqn(i),titre(i),nel(i),
     1                                      den(i)
  345    format (7x,i1,a2,i16,1pe23.7)
  350 continue

      if (iprint .ge. 5)  write(16,370) norbco
  370 format (' no. of core orbitals=',i3)
      if (k.eq.(iz-ion)) goto 390
         write(messag,380)
         call echo(messag)
         if (iprint .ge. 5)  write(16,380)
  380    format (' error for the number of electrons')
         goto 999
  390 continue

      if (iprat .eq. 0)  then
         if (iprint .ge. 5)  write(16,410)
  410    format (1h0,'  the pratt procedure is used'/)
      else
         if (iprint .ge. 5)  write(16,430) ws
  430    format (1h0,'  wigner-seitz radius = ',0pf10.6,/)
      endif

      if (nuc .eq. nuc1)  then
         if (iz.eq.iz1.and.ion.eq.ion1) goto 600
         if (iz.eq.iz1) goto 470
      endif

c     dr(1)=dr1/z
c     do 460 i=2,np
c        dr(i)=dr(1)*exp((i-1)*dpas)
c 460 continue
c     Let's make this consistant with grid in other routines
c     dr array commeted out above
c     SIZ  December 1990
      do 461  i = 1, 251
         dr(i) = rr(i)
  461 continue

c starting potential

  470 val=-ion-1

c     Following code is a block, block ends at line 600
      if (idep .eq. 1)  then

c        read in starting potential (in a.u. and negative) if idep=1
         read (linp,480,end=900) (dv(i),i=1,np)
  480    format (8f9.4)

         if (iprint .ge. 5)  write(16,490) TTL,(dv(i),i=1,np)
  490    format (1h1, 40x, A40, //,
     1           5x, 'starting potential multiplied by r ' /,
     2           10(2x, f9.4))
         dval = -z/dv(1)
         if (nuc.gt.0)  dval = 1.0
         do 500 i=1,np
            dv(i)=dv(i)*dval/dr(i)
  500    continue

      else

         if (idep .ne. 0)  then
            write(messag,510)
            call echo(messag)
            if (iprint .ge. 5)  write(16,510)
  510       format (' error for idep')
            goto 999
         endif

         if (iz.ne.iz1  .or .  ion.le.ion1  .or.   nuc.ne.nuc1)  then
            do 520 i=1,np
               r=dr(i)
               dv(i)=fpot(r,z,val)
  520       continue
            if (nuc .gt. 0)  then
               do 530 i=1,nuc
                  dv(i) = dv(i) + z/dr(i) +
     1                    z*((dr(i)/dr(nuc))**2-3.0)/(dr(nuc)+dr(nuc))
  530          continue
            endif
            goto 600
         endif
      endif
      if (icut .eq. 0)  then
         do 540 i=1,np
            if ((dr(i)*dv(i)).gt.val)  dv(i)=val/dr(i)
  540    continue
      endif
      val=z+dv(1)*dr(1)
      if (nuc.gt.0)  val=z+dv(nuc)*dr(nuc)
      if (abs(val) .ge. 0.1)  then
         write(messag,550)
         call echo(messag)
         if (iprint .ge. 5)  write(16,550)
  550    format (' error for the potential ')
         goto 999
      endif

  600 continue
c     End of block above


      if (norb .ne. 1)  then
         do 620 i=2,norb
            k=i-1
            do 620 j=1,k
            if (nqn(i).eq.nqn(j)  .and. nk(i).eq.nk(j))   then
               write(messag,610)
               call echo(messag)
               if (iprint .ge. 5)  write(16,610)
  610          format (' standard configuration')
               goto 999
            endif
  620    continue
      endif

  630 iz1=iz
      ion1=ion
      nuc1=nuc
      do 660 i=1,norb
         nmax(i)=np
         l=1
         j=nqn(i)-nql(i)
         if ((j-2*(j/2)).eq.0) l=-l
         dq1(i)=l*nk(i)/iabs(nk(i))
         if (nuc .ne. 0  .and.  nk(i) .lt. 0)  then
            dq1(i)=dq1(i)*(nk(i)-dfl(i))*dvc/z
         endif
  660 continue


c  -- Normal return
      return


c  -- Error condition, stop program

c     Unexpected end of file during read -- stop program
  900 continue
      call echo(' Unexpected end of file')

c     Fatal error, stop gracefully (sic)
  999 continue
       call fstop(' at INDATA-1')
      end

      subroutine atheap(nat, rat, iphat, ra)

c--------------------------------------------------------------
c  copyright 1993 university of washington         bruce ravel
c  modified by alexei ankudinov in march 1999
c--------------------------------------------------------------
      implicit real (a-h,o-z)
      implicit integer (i-n)
c      implicit double precision (a-h,o-z)
c-------------------------------------------------------------------
c  heapsort adapted from numerical recipes.  sort atoms by distance.
c  all the pesky little do loops are for transferring rows
c  of temp into toss.
c-------------------------------------------------------------------
c  alexei ankudinov: needed to avoid unnecessary permutations when atoms
c  are at the same distance from the central atom, in order to comply 
c  feff document: the sample atom should be the nearest to absorber or
c  first in the list among equidistant
c  Add small contribution 10**-8 * number to the sorting variable ra
c  in order to achieve this.
c-------------------------------------------------------------------
c  natx:   dimension parameter from calling program
c-------------------------------------------------------------------
      dimension rat(3, nat), toss(3), iphat(nat)
      double precision ra(nat), dum 

      if (nat.lt.2) return

      l=0
      do 10 i=1,nat
         ra(i) = dble( rat(1,i)**2 + rat(2,i)**2 + rat(3,i)**2 ) +
     1           i*1.d-8
c        small addition at to prefer the old ordering
         if (l.eq.0 .and.i.gt.1) then
             if (ra(i).lt.ra(i-1)) l=1
         endif
  10  continue
c     check if array is already in order
      if (l.eq.0) return

      l  = nat/2+1
      ir = nat
 110  continue
         if (l.gt.1) then
            l = l-1
            do 120 index=1,3
               toss(index)=rat(index,l)
 120        continue
            itoss = iphat(l)
            dum = ra(l)
         else
            do 130 index=1,3
               toss(index) = rat(index,ir)
 130        continue
            itoss = iphat(ir)
            dum = ra(ir)
            do 140 index=1,3
               rat(index,ir) = rat(index,1)
 140        continue
            iphat(ir) = iphat(1)
            ra(ir) = ra(1)
            ir=ir-1
            if (ir.eq.1) then
               do 150 index=1,3
                  rat(index,1)=toss(index)
 150           continue
               iphat(1) = itoss
               ra(1) = dum
c              sort is finished
               goto 300
            endif
         endif
         i=l
         j=l+l

 160     if (j.le.ir) then
            if (j.lt.ir) then
               if ( ra(j) .lt. ra(j+1) ) then
                  j  = j + 1
               endif
            endif

            if ( dum .lt. ra(j) ) then
               do 170 index=1,3
                  rat(index,i) = rat(index,j)
 170           continue
               iphat(i) = iphat(j)
               ra(i) = ra(j)
               i=j
               j=j+j
            else
               j=ir+1
            endif
            goto 160
         endif

         do 180 index=1,3
            rat(index,i) = toss(index)
 180     continue
         iphat(i) = itoss
         ra(i) = dum

      goto 110
 300  continue

      return
c end subroutine atheap
      end
      subroutine getang(nclusx, rat, i, j, theta, phi)

c------------------------------------------------------------------
c  determine theta and phi polar angles of the vector between two
c  atom positions
c
c  inputs
c    rat:   (3,nclusx) x,y,z of all atoms in cluster
c    i, j:  indices of atoms at ends of vector Ri-Rj
c
c  outputs
c    theta: polar angle theta of vector Ri-Rj
c    phi:   polar angle phi of vector Ri-Rj
c------------------------------------------------------------------

      implicit real (a-h,o-z)
      implicit integer (i-n)

c       include 'dim.h'
c       include 'xparam.h'
      dimension rat(3,nclusx)
      parameter(tiny=1.e-7, zero=0.e0, pi=3.141592654)

      x = rat(1,i) - rat(1,j)
      y = rat(2,i) - rat(2,j)
      z = rat(3,i) - rat(3,j)
      r = sqrt(x**2 + y**2 + z**2)

c  this fails to calculate phi correctly for, as an example,
c  x=0.5e-7 and y=2e-7.  However, those numbers are below the
c  precision of the numbers stored in potph.bin.

      phi = zero
      theta  = zero
      if (i.ne.j) then
c           phi = atan2(y,x)
c        all of these conditionals will do the work for a machine that
c        cannot correctly handle a zero value for the second argument
c        of atan2
          if (abs(x).lt.tiny) then
              if (abs(y).lt.tiny) then
                  phi = zero
              elseif (y.gt.tiny) then
                  phi = pi/2
              else
                  phi = -pi/2
              endif
          else
              phi = atan2(y,x)
          endif
          if (r.gt.tiny) then
            if (z.le.-r) then
             theta = pi
            elseif ( z.lt.r) then
             theta = acos(z/r)
            endif
          endif
      endif

      return
c  end subroutine getang
      end


c====================================================================
      subroutine rotxan (lxp1, mxp1, betax, i, j, k)
      implicit real (a-h,o-z)

c     input:  lxp1, mxp1: lmax+1 & mmax+1, largest L states in matrix
c             betax is the rotation angle
c             i and j are the indeces of the atoms, thus denote
c                 which pair of atoms this is the rotation matrix for
c             k=0 for forward rotation, k=1 for backward rotation
c     output: drix(L,k,j,i) in common /rotx/
c+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+
c     adapted by BR from rot3i, version for genfmt by SIZ
c        new data structure for rotation matrices to accomodate
c        xanes calculation
c+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+
c     subroutine rot3 calculates rotation matrices for l = 0,lxp1-1

c     subroutine rot3 calculates the beta dependence of rotation
c     matrix elements using recursion of an iterated version of
c     formula (4.4.1) in edmonds.
c
c     first written:(september 17,1986) by j. mustre
c     version 2  (17 sep 86)
c     version 3  (22 feb 87) modified by j. rehr
c     version for genfmt, modified by s. zabinsky, Sept 1991
c     Initialized dri0.  Some elements may be used before being
c        initialized elsewhere -- rot3i needs to be carefully
c        checked.  S. Zabinsky, April 1993
c
c******************** warning****************************************
c     lxx must be at least lxp1 or overwriting will occur
c     nmax must be at least nm or overwriting will occur
c--------------------------------------------------------------------
c     notation dri0(l,m,n) =  drot_i(l'm'n')
c     l = l'+1, n' = n-l, m' = m-l, primes denoting subscripts
c     thus dri0(1,1,1) corresponds to the rotation matrix with
c     l' = 0, and n' and m' = 0; dri0(3,5,5) : l' = 2,n' = 2,m' = 2.
c--------------------------------------------------------------------

      include '../HEADERS/dim.h'
      include 'xparam.h'
c       include 'xstruc.h'
c====================================================================
c  This header file contains the structural information about the
c  cluster to be used for the full multiple scattering calculation

      common /xstruc/ xphi(nclusx,nclusx), xrat(3,nclusx),
     $            iphx(nclusx)
      save /xstruc/

c  xphi:  matrix of angles between the z axis and pairs of atoms
c  xrat:  xyz coordinates of the atoms in the cluster, the first
c         npot+1 entries are examples of each unique potential
c  iphx:  potential indeces of each atom in the cluster, ordered like
c         xrat
c********************************************************************
c**** rotation matrices for entire cluster
c
      complex drix
      common /rotx/ drix(-lx:lx, -lx:lx, 0:lx, 0:1, nclusx, nclusx)
      save /rotx/
c********************************************************************
c#mn{
c common blocks for saving rotation matrices between xanes and rotxan
       integer    jsavx, jsav, jbmagk
       parameter (jsavx = 150, roteps = 1.e-12,jbmagk=-9999)
       dimension drisav(-lx:lx,-lx:lx,0:lx,jsavx), betsav(jsavx)
       integer   ldsav(jsavx), mdsav(jsavx)
       common /rotsav/  drisav, betsav, ldsav, mdsav, jsav
       save  /rotsav/
c#mn}

c********************************************************************
c**** legendre polynomial normalization constants
c
      common /lnlm/ xnlm(0:lx,0:lx)
      save   /lnlm/

c********************************************************************
c**** legendre polynomial normalization constants
c
      common /xdwf/ sigsqr(nclusx,nclusx)
      save   /xdwf/

c  end of xstruc.h
c********************************************************************
      parameter (one = 1, zero = 0)
c      needed for commented out diagnostic file
c      logical open
      parameter(lxx=24)
      parameter (pi = 3.14159 26535 89793 23846 26433e0)
      complex coni, dum 
      parameter (coni = (0,1))

c     dri0 is larger than needed for genfmt, but necessary for
c     this calculation algorithm.  Copy result into smaller
c     dri arrays (in common) at end of this routine.
      dimension  dri0 (lxx+1, 2*lxx+1, 2*lxx+1)

c#mn{
c  check whether a rotation matrix for this {beta(ileg),lxp1,mxp1} has
c  been calculated and saved.  If so, just use the saved value
       do 90 isav = 1, jsav
          if (betsav(isav).eq.jbmagk) go to 95
          if ((lxp1.eq.ldsav(isav)).and.(mxp1.eq.mdsav(isav)).and.
     $         (abs(betax-betsav(isav)).le.roteps) ) then
cc             print*, 'using drisav for ', isav, betax, lxp1, mxp1
             do 85 il = 0, lx
             do 85 m1 = -il, il
             do 85 m2 = -il, il
               drix(m2,m1,il,k,j,i)=cmplx(drisav(m2,m1,il,isav),zero)
 85          continue
             go to 770
          end if
 90    continue
 95    continue
c#mn}


c     initialize dri0
      do 150 in = 1, 2*lxx+1
        do 150 im = 1, 2*lxx+1
          do 150 il = 1, lxx+1
            dri0(il,im,in) = zero
 150  continue

      nm  = mxp1
      ndm = lxp1+nm-1
      xc  = cos(betax/2)
      xs  = sin(betax/2)
      s   = sin(betax)
      dri0(1,1,1) =  1
      dri0(2,1,1) =  xc**2
      dri0(2,1,2) =  s/sqrt(2*one)
      dri0(2,1,3) =  xs**2
      dri0(2,2,1) = -dri0(2,1,2)
      dri0(2,2,2) =  cos(betax)
      dri0(2,2,3) =  dri0(2,1,2)
      dri0(2,3,1) =  dri0(2,1,3)
      dri0(2,3,2) = -dri0(2,2,3)
      dri0(2,3,3) =  dri0(2,1,1)
      do 230  l = 3, lxp1
        ln = 2*l - 1
        lm = 2*l - 3
        if (ln .gt. ndm)  ln = ndm
        if (lm .gt. ndm)  lm = ndm
        do 220  n = 1, ln
          do 210  m = 1, lm
            t1   = (2*l-1-n) * (2*l-2-n)
            t    = (2*l-1-m) * (2*l-2-m)
            f1   = sqrt(t1/t)
            f2   = sqrt( (2*l-1-n) * (n-1) / t )
            t3   = (n-2) * (n-1)
            f3   = sqrt(t3/t)
            dlnm = f1 * xc**2 * dri0(l-1,n,m)
            if (n-1 .gt. 0) dlnm = dlnm - f2*s*dri0(l-1,n-1,m)
            if (n-2 .gt. 0) dlnm = dlnm + f3*xs**2*dri0(l-1,n-2,m)
            dri0(l,n,m) = dlnm
            if (n .gt. (2*l-3))
     $                  dri0(l,m,n) = (-1)**(n-m) * dri0(l,n,m)
 210      continue
          if (n .gt. (2*l-3)) then
              dri0(l,2*l-2,2*l-2) =  dri0(l,2,2)
              dri0(l,2*l-1,2*l-2) = -dri0(l,1,2)
              dri0(l,2*l-2,2*l-1) = -dri0(l,2,1)
              dri0(l,2*l-1,2*l-1) =  dri0(l,1,1)
          endif
 220    continue
 230  continue


c     initialize drix
      do 310 il = 0, lx
      do 310 m1 = -lx, lx
      do 310 m2 = -lx, lx
        drix(m2,m1,il,k,j,i) = cmplx(zero,zero)
        drix(m2,m1,il,k,i,i) = cmplx(zero,zero)
 310  continue

c     Copy result into drix(...,k,j,i) in /rotx/
      do 390  il = 1, lxp1
        mmx = min (il-1, mxp1-1)
        do 380  m1 = -mmx, mmx
        do 380  m2 = -mmx, mmx
          drix(m2, m1, il-1, k, j, i)=cmplx(dri0(il,m1+il,m2+il),zero)
 380    continue
 390  continue
c#mn{
c      save dri if there's room
       if (jsav.lt.jsavx) then
          jsav = jsav + 1
cc          print*, 'saving dri to ',  jsav, betax, lxp1, mxp1
          betsav(jsav) = betax
          ldsav(jsav)  = lxp1
          mdsav(jsav)  = mxp1
          do 720 il = 0, lx
          do 720 m1 = -il, il
          do 720 m2 = -il, il
            drisav(m2,m1,il,jsav) = real(drix(m2,m1,il,k,j,i))
 720      continue
       else
cc          print*, 'not saving dri to ',  betax, lxp1, mxp1
       end if
 770   continue
c#mn}

c-----test sum rule on d
c       if (idbg(1).eq.1) then
c           inquire(file='rotmat.dat', opened=open)
c           if (.not.open) then
c               iun = nxtunt(25)
c               open (iun,file='rotmat.dat',status='unknown')
c           endif
c           write(iun,*)'  '
c           write(iun,*)'atom #s : ',i,j
c           write(iun,*)  ' il, im, sum, beta'
c           write(iun,*) ' (drix(il,im,in,k,j,i),in = -il,il)'
c           do 880 il = 0,lxp1-1
c             do 870 im = -il,il
c               sum = 0
c               do 850 in = -il,il
c                 term = drix(in,im,il,k,j,i)
c                 sum = sum+term**2
c  850           continue
c               write(iun,860) il,im,sum,betax
c               write(iun,862) (drix(in,im,il,k,j,i),in = -il,il)
c  860          format(2i3,1x,f16.12,1x,f8.4)
c  862          format(5f14.6)
c  870         continue
c  880       continue
c c          close(iun)
c       endif
c-----end test------------------------

        do 920 il = 0, lx
        do 920 m1 = -il, il
          dum = coni * m1 * (xphi(i,j)-pi)
          if (k.eq.1) dum = -dum
          dum = exp( dum )
          do 910 m2 = -il, il
            if (k.eq.1) then
              drix(m2,m1,il,k,j,i) = drix(m2,m1,il,k,j,i) * dum
            else
              drix(m1,m2,il,k,j,i) = drix(m1,m2,il,k,j,i) * dum
            endif
 910       continue
 920     continue

      return
c  end subroutine rotxan
      end
c====================================================================
c#mn{
       subroutine rotint
       implicit real (a-h,o-z)
       include '../HEADERS/dim.h'
       include 'xparam.h'
c        include 'xstruc.h'
c====================================================================
c  This header file contains the structural information about the
c  cluster to be used for the full multiple scattering calculation

      common /xstruc/ xphi(nclusx,nclusx), xrat(3,nclusx),
     $            iphx(nclusx)
      save /xstruc/

c  xphi:  matrix of angles between the z axis and pairs of atoms
c  xrat:  xyz coordinates of the atoms in the cluster, the first
c         npot+1 entries are examples of each unique potential
c  iphx:  potential indeces of each atom in the cluster, ordered like
c         xrat
c********************************************************************
c**** rotation matrices for entire cluster
c
      complex drix
      common /rotx/ drix(-lx:lx, -lx:lx, 0:lx, 0:1, nclusx, nclusx)
      save /rotx/
c********************************************************************
c#mn{
c common blocks for saving rotation matrices between xanes and rotxan
       integer    jsavx, jsav, jbmagk
       parameter (jsavx = 150, roteps = 1.e-12,jbmagk=-9999)
       dimension drisav(-lx:lx,-lx:lx,0:lx,jsavx), betsav(jsavx)
       integer   ldsav(jsavx), mdsav(jsavx)
       common /rotsav/  drisav, betsav, ldsav, mdsav, jsav
       save  /rotsav/
c#mn}

c********************************************************************
c**** legendre polynomial normalization constants
c
      common /lnlm/ xnlm(0:lx,0:lx)
      save   /lnlm/

c********************************************************************
c**** legendre polynomial normalization constants
c
      common /xdwf/ sigsqr(nclusx,nclusx)
      save   /xdwf/

c  end of xstruc.h
c********************************************************************
c initialize /rotsav/
       jsav = 0
       do 100 js = 1, jsavx
          betsav(js) = jbmagk
          ldsav(js)  = 0
          mdsav(js)  = 0
          do 90 il  = 0, lx
             do 80 m1 = -lx, lx
                do 70 m2 = -lx, lx
                   drisav(m2,m1,il,js) = 0
 70             continue
 80          continue
 90       continue
 100   continue
       return
c#mn}
       end
      subroutine sortat(iph0, nat, npot, iphat, iphx, rat, xrat)

      implicit real (a-h,o-z)
      implicit integer (i-n)
c--------------------------------------------------------------------
c  this subroutine sorts the atoms in xrat such that the first npot
c  entries are each a representative atom of a unique potential.  This
c  will mean that the upper left corner of the full MS matrix will
c  contain all of the information needed to compute the fine structure
c  and all of the electron densities.
c  NOTA BENE:  the atoms *must* have already been sorted by radial
c    distance!
c--------------------------------------------------------------------
c  input:
c    iph0:    potential index for central atom in LDOS (added by ala)
c                (iph0=0 for absorbing atom as the central atom)
c     nat:    number of atoms in cluster
c    npot:    number of unique potentials in cluster
c    iphat:   (nclusx) potential index of each atom in cluster as read
c             from geometry file
c    rat:     (3, nclusx) coordinates of each atom in cluster as read
c             from geometry file
c  output:
c    iphx:    (nclusx) potential index of each atom in cluster sorted
c             so that the first npot+1 entries are examples of each
c             ipot
c    xrat:    (3, nclusx) coordinates of each atom in cluster sorted
c             so that the first npot+1 entries are examples of each
c             ipot
c--------------------------------------------------------------------

      include '../HEADERS/dim.h'
      include 'xparam.h'
      dimension rat(3,natxx), xrat(3,nclusx)
      integer   iphat(natxx), iphx(nclusx), ipoint
      dimension ipoint(0:nphasx)
      integer iph0, ip, ilast

      do 10 i=0,nphasx
        ipoint(i) = 0
 10   continue
      do 30 ic=1,nat
        iphx(ic) = iphat(ic)
        do 20 ix=1,3
          xrat(ix,ic) = rat(ix,ic)
 20     continue
 30   continue

c     (iph0=0 for absorbing atom as the central atom)
      if (iphx(1).ne.iph0) then
          call wlog('* * * ERROR in sortat * * *')
          call wlog('            The first atom in xrat is not '//
     $                'the central atom.')
          call wlog('            Complain to Bruce immediately!')
          call par_stop('SORTAT-1')
      endif

c       if (idbg(4).eq.1) print*,'SORTAT: nat,npot: ',nat,npot
c       if (idbg(4).eq.1) print*,'SORTAT: xcen,ycen,zcen: ',
c      $            xcen,ycen,zcen

c --- find the example of each unique potential that is closest to the
c     central atom.  This will presumably be well within the cluster
c     that was used to compute the overlapped potentials
      ipoint(iph0) = 1
      do 150 ip=0,npot
        if (ip .ne. iph0) then
          do 130 iat=2,nat
            if (iphx(iat).eq.ip .and. ipoint(ip).eq.0) then
                ipoint(ip) = iat
c                print*,'>>>>> ip, ipoint(ip)', ip, ipoint(ip)
            endif
 130      continue
        endif
 150  continue

c --- now swap the first few atoms with the atoms found above
      do 200 ip=0,npot

c ----- some potentials might not be in the xanes cluster
        if (ipoint(ip).eq.0) goto 200
c ----- don't swap two potentials if examples live in the first npot
c       entries
        if (ipoint(ip).le.ip+1) goto 200

        xx  = xrat(1,1+ip)
        yy  = xrat(2,1+ip)
        zz  = xrat(3,1+ip)
        iph = iphx(1+ip)

        xrat(1,1+ip) = xrat(1,ipoint(ip))
        xrat(2,1+ip) = xrat(2,ipoint(ip))
        xrat(3,1+ip) = xrat(3,ipoint(ip))
        iphx(1+ip)  = iphx(ipoint(ip))

        xrat(1,ipoint(ip)) = xx
        xrat(2,ipoint(ip)) = yy
        xrat(3,ipoint(ip)) = zz
        iphx(ipoint(ip))  = iph

c       added by ala
c       check that substituted atom was not some ip example
c          ???BR Jan 16 1998???
        do 190 ipp = ip+1, npot
          if (ipoint(ipp).eq.ip+1) ipoint(ipp) = ipoint(ip)
  190   continue
c       set the correct pointer to ip example
        ipoint(ip) = ip+1

 200  continue

c     added by ala
c     Notice that fms will take the last atom of given type ip
c     from first npot atoms in the list as an example for ip.
c     Make more permutaions if necesary.
      ilast = -1
      nmin = min (npot+1, nat)
      do 210 ip = 0, npot
        if (ipoint(ip).ne.0) then
          do 205 iat = 1,nmin
  205     if (iphx(iat).eq.ip) ilast = iat

          if (ilast.ne.ipoint(ip)) then
            xx  = xrat(1,ilast)
            yy  = xrat(2,ilast)
            zz  = xrat(3,ilast)

            xrat(1,ilast)= xrat(1,ipoint(ip))
            xrat(2,ilast)= xrat(2,ipoint(ip))
            xrat(3,ilast)= xrat(3,ipoint(ip))

            xrat(1,ipoint(ip)) = xx
            xrat(2,ipoint(ip)) = yy
            xrat(3,ipoint(ip)) = zz
c           now ipoint(ip) = ilast, but don't need ipoint anymore
          endif
        endif
  210 continue

c       if (idbg(4).eq.1) then
c           do 220 i=1,npot+1
c             print *,i,xrat(1,i),xrat(2,i),xrat(3,i),iphx(i)
c  220      continue
c       endif
      return
c  end subroutine sortat
      end
      subroutine xanlm(lmaxp1,mmaxp1)

c------------------------------------------------------------------
c  calculate and store all of the legendre polynomial normalization
c  factors needed in the problem
c     xnlm= sqrt ((2l+1)(l-m)!/(l+m)!)
c  see, for instance, Arfken section 12.6.  Note that this lacks the
c  factor of sqrt(4*pi)
c
c  inputs:
c     lmaxp1, nmaxp1:  maximun l and m considered in the problem +1
c                      i.e. lmaxp1 = l_max+1
c
c  outputs:
c     all normalization factors passed in common /xnlm/
c------------------------------------------------------------------

      implicit real(a-h,o-z)
c       parameter(ltot=6,mtot=3)

      include '../HEADERS/dim.h'
      include 'xparam.h'
c       include 'xstruc.h'
c====================================================================
c  This header file contains the structural information about the
c  cluster to be used for the full multiple scattering calculation

      common /xstruc/ xphi(nclusx,nclusx), xrat(3,nclusx),
     $            iphx(nclusx)
      save /xstruc/

c  xphi:  matrix of angles between the z axis and pairs of atoms
c  xrat:  xyz coordinates of the atoms in the cluster, the first
c         npot+1 entries are examples of each unique potential
c  iphx:  potential indeces of each atom in the cluster, ordered like
c         xrat
c********************************************************************
c**** rotation matrices for entire cluster
c
      complex drix
      common /rotx/ drix(-lx:lx, -lx:lx, 0:lx, 0:1, nclusx, nclusx)
      save /rotx/
c********************************************************************
c common blocks for saving rotation matrices between xanes and rotxan
       integer    jsavx, jsav, jbmagk
       parameter (jsavx = 150, roteps = 1.e-12,jbmagk=-9999)
       dimension drisav(-lx:lx,-lx:lx,0:lx,jsavx), betsav(jsavx)
       integer   ldsav(jsavx), mdsav(jsavx)
       common /rotsav/  drisav, betsav, ldsav, mdsav, jsav
       save  /rotsav/

c********************************************************************
c**** legendre polynomial normalization constants
c
      common /lnlm/ xnlm(0:lx,0:lx)
      save   /lnlm/

c********************************************************************
c**** legendre polynomial normalization constants
c
      common /xdwf/ sigsqr(nclusx,nclusx)
      save   /xdwf/

c  end of xstruc.h
c********************************************************************

      common/afctr/afac,flzero,flg(0:50)
c      common/afctr/afac,flzero,flg(0:210)
c      common/afctr/afac,flzero,flg(0:110) vax change

      call xfctst
      do 50 il=1,lmaxp1
        mmxp1 = min(mmaxp1,il)
        do 40 im=1,mmxp1
          l    = il-1
          m    = im-1
          cnlm = (2*l+1) * flg(l-m) / flg(l+m)
          cnlm = sqrt(cnlm) * afac**m
          xnlm(m,l) = cnlm

 40     continue
 50   continue
      return
c  end subroutine xlm
      end


      subroutine xfctst
c  same as feff's factst, but with a different name
      implicit real (a-h,o-z)
c     program for s3j and s6j symbols obtained from
c     steve younger of n.b.s.   modified by j.b.mann
c--------------------------------------------------------------------
c     a set to 1/64 to prevent overflow on vax
c     range on  flg set to 0:210, rather than flg(210)
c--------------------------------------------------------------------
cBR   This allows calculation of a large factorial (~100) without
cBR   overflow problems -- factor in a power of a small number then
cBR   factor it out
c--------------------------------------------------------------------
      common /afctr/ a, flzero, flg(0:50)
c      common /afctr/ a, flzero, flg(0:210)
      a=0.03125
c     a=0.015625
      flzero = 1.0
      flg(0) = 1.0
      flg(1) = a
      do 10 i=2,50
        flg(i) = flg(i-1) * i * a
 10   continue
      return
      end



c====================================================================

       subroutine echo(str)
c
c//////////////////////////////////////////////////////////////////////
c Copyright (c) 1997--2000 Matthew Newville, The University of Chicago
c Copyright (c) 1992--1996 Matthew Newville, University of Washington
c
c Permission to use and redistribute the source code or binary forms of
c this software and its documentation, with or without modification is
c hereby granted provided that the above notice of copyright, these
c terms of use, and the disclaimer of warranty below appear in the
c source code and documentation, and that none of the names of The
c University of Chicago, The University of Washington, or the authors
c appear in advertising or endorsement of works derived from this
c software without specific prior written permission from all parties.
c
c THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
c EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
c MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
c IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
c CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
c TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
c SOFTWARE OR THE USE OR OTHER DEALINGS IN THIS SOFTWARE.
c//////////////////////////////////////////////////////////////////////
c
c dump string to standard output
       implicit none
       include 'echo.h'
       character*(*) str,form*8
       parameter (form = '(1x)' )
       call chrdmp(str)
       if (mod(i_echo,2).eq.1) write(*,form)
       return
c end  subroutine echo
       end
       subroutine chrdmp(str)
c dump string to screen with "$" format
c
c i_echo
c  0   echo to buffer
c  1   echo to screen
c  2   echo to open echo_file (if open)
c  3   echo to screen and open echo_file (if open)
c
       implicit none
       include 'echo.h'
       character*(*) str, out*512,frm*8,ffrm*8
       parameter (frm= '(1x,a,$)', ffrm= '(1x,a)' )
       integer  istrln, n
       external istrln
       out = str
       n   = max(1, istrln(out))
       if (i_echo.eq.0) then
          call echo_push(out)
       else
          if (mod(i_echo,2).eq.1) write(*,frm) out(1:n)
          if ((i_echo.ge.2).and.(lun_echo.ge.1))
     $         write(lun_echo, ffrm) out(1:n)
       endif
       return
c  end subroutine chrdmp
       end

       subroutine echo_init
c initialize echo lines
       implicit none
       include 'echo.h'
       integer i
       do 20 i  = 1, mxecho
          echo_str(i) = ' '
 20    continue
       call setsca('&echo_lines', 0.d0)
       n_echo = 0
       call setsca('&screen_echo', 1.d0)
       i_echo    = 1
       lun_echo  = 0
       echo_file = ''
       return
       end

       subroutine close_echofile()
       implicit none
       include 'echo.h'
       if (lun_echo .ge. 1) then
          close(lun_echo)
          lun_echo  = -1
          echo_file = ''
          if (i_echo.eq.3) i_echo  = 1
          if (i_echo.eq.2) i_echo  = 0
       endif
       return
       end

       subroutine open_echofile(s)
       implicit none
       include 'echo.h'
       character*(*) s
       integer  iex, ier, istrln
       external istrln
       call close_echofile()

       lun_echo = 19
       echo_file = s(1:istrln(s))
       call triml(echo_file)

       call openfl(lun_echo, echo_file, 'unknown', iex, ier)
       if (i_echo.eq.0) i_echo = 2
       if (i_echo.eq.1) i_echo = 3
cc       print*, ' done ' , i_echo
c
       return
       end



       subroutine echo_push(string)
c add echo string to internal list
c copyright (c) 1999 matt newville
       implicit none
       character*(*) string, str*512
       include 'echo.h'
       integer  istrln, ilen, i
       external istrln
       str  = string
       call sclean(str)
       call triml(str)
       ilen = istrln(str)
       if ((ilen.ge.1).and.(n_echo.lt.mxecho)) then
          do 30 i = mxecho, 2, -1
             echo_str(i) = echo_str(i-1)
 30       continue
          echo_str(1) = str(1:ilen)
cc          print*, ' ECHO_PUSH: ', str(1:ilen)
          n_echo      = min(mxecho, n_echo + 1)
       endif
       call setsca('&echo_lines', n_echo * 1.d0)
       return
c  end subroutine echo_push
       end
       subroutine echo_pop(string)
c add echo string to internal list
c copyright (c) 1999 matt newville
       implicit none
       character*(*) string
       include 'echo.h'
       string  = ' '
       if (n_echo .gt. 0) then
          string  = echo_str(n_echo)
cc          print*, ' ECHO_POP: ', string(1:60)
          echo_str(n_echo)  =  ' '
       end if
       n_echo  = min(mxecho, max(0, n_echo - 1))
       call setsca('&echo_lines', n_echo * 1.d0)
       return
c  end subroutine echo_pop
       end



c
c routines to initialize and use a 'stop file'
c that is, do
c         call fstop_init('stopfile.err')
c early on, and replace subsequent
c         stop 'problem at line xxx'
c with
c         call fstop('problem at line xxx')
c
c the error file will contain the error message
c and will exist only if fstop() has been called.
c that is, fstop_init() erases the stop file.
c
       subroutine fstop_init(s)
       character*(*) s
       character*32 stopfilename
       common /stop_file/ stopfilename
       integer istrln
       external istrln
       stopfilename = s
       call triml(stopfilename)

       return
       end

       subroutine fstop(s)
c
c replaces intrinsic 'stop', writing stop message to
c the stopfile initialized by fstop_init
c
       implicit none
       character*(*) s, str*128
       integer i, istrln
       external istrln
       character*32 stopfilename
       common /stop_file/ stopfilename

       str = s
       call triml(str)
       if (str .eq. '') str = 'unknown error'
       str   = 'Fatal Error: '//str(1:istrln(str))
       call echo(str(1:istrln(str)))

       call triml(stopfilename)
       if (istrln(stopfilename).ge.1) then
          i = 9
          call newfil(stopfilename,i)
          write(i,'(1x,a)') str(1:istrln(str))
          close (unit=i)
       endif
       stop
       return
       end

       subroutine warn(i,s)
c
c set &status value and write string to echo buffer
       integer i
       character*(*) s
       call echo(s)
       call set_status(i)
       return
       end

       subroutine set_status(i)
c
c set &status value
       integer i
       double precision getsca, xc, xi
       xi = i * 1.d0
       xc = getsca('&status',0)
       if (xi .gt. xc) call setsca('&status',xi)
       return
       end

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Information about last revision of $RCSfile: m_par.f90,v $:
! $Revision: 1.2 $
! $Author: hebhop $
! $Date: 2010/02/23 23:52:06 $
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
module par

  implicit none
  integer par_type, this_process, numprocs, my_rank
  logical master, worker, parallel_run
  real*8 wall_comm, time_comm

end module par

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Information about last revision of $RCSfile: m_iofiles.f90,v $:
! $Revision: 1.6 $
! $Author: hebhop $
! $Date: 2010/02/23 23:52:06 $
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
MODULE IOFiles
  USE ErrorMod
  IMPLICIT NONE
  ! MaxLength - Maximum length of filename strings
  ! MaxSections - Maximum number of sections in a file
  INTEGER,PRIVATE :: MaxLength, MaxSections, NError
  PARAMETER( MaxLength = 300, MaxSections = 1000, NError = 2 )

  ! Default format strings for Integer, Real, Double, Complex, 
  ! Double Complex, and String
  CHARACTER(100) DefaultIFormat, DefaultRFormat, DefaultDFormat, &
       & DefaultCFormat, DefaultDCFormat, DefaultSFormat
  PARAMETER ( DefaultIFormat  = '(I10)' )
  PARAMETER ( DefaultRFormat  = '(E20.10)' )
  PARAMETER ( DefaultDFormat  = '(E20.10)' )
  PARAMETER ( DefaultCFormat  = '(1E20.10,1X,1E20.10)' )
  PARAMETER ( DefaultDCFormat = '(1E20.10,1X,1E20.10)' )
  PARAMETER ( DefaultSFormat  = '(A)' )

  ! Default file format is text
  CHARACTER(3) DefaultFileFormat
  PARAMETER ( DefaultFileFormat = 'TXT' )


  TYPE IOFile
     ! Filename - name of file.
     ! DataTypeLine - type description of the columns of data that will 
     ! be in a section. Section changes when data types change or user 
     ! specifies a new section.
     CHARACTER(300) FileName, DataTypeLine(MaxSections)
     ! Format strings for each type of data (Integer, Real, Double, 
     ! Complex, Complex*16, and String
     CHARACTER(100) IFormat, RFormat, DFormat, CFormat, DCFormat, SFormat
     ! Specify whether you want output to be ASCII ('txt') or packed 
     ! ascii ('pad'). Can add new formats later, i.e. 'xml' ...
     CHARACTER(5) FileFormat
     ! IOFileAction: READ, WRITE, READWRITE
     CHARACTER(9) IOFileAction
     ! NLines     - number of lines in a section
     ! TotLines   - total number of lines in file.
     ! NSections  - Number of sections (Write) or current section (Read).
     ! UnitNumber - unit number of the file.
     INTEGER NLines(MaxSections), TotLines, NSections, UnitNumber
     ! IsInitialized - this IOFile was initialized if true.
     ! ExistedOnOpen - file existed when we opened it if true.
     ! IsOpen        - file is open if true.
     ! EOF           - End of file has been reached (Read) if true.
     LOGICAL IsInitialized, ExistedOnOpen, IsOpen, EOF
     ! ReadError and WriteError define possible errors that could occur, and what action to take
     ! if each error does occur.
     TYPE(ErrorType) IOErrors(NError)
  END TYPE IOFile

  TYPE(IOFile),PRIVATE,SAVE :: FileStack(100)
  INTEGER,PRIVATE,Save :: NFiles = 0

  INTERFACE ASSIGNMENT(=)
     MODULE PROCEDURE CopyIOFile
  END INTERFACE ASSIGNMENT(=)

CONTAINS

  ! Set IOFile1 = IOFile2
  SUBROUTINE CopyIOFile(IOFile1, IOFile2)
    TYPE(IOFile),INTENT(OUT) :: IOFile1
    TYPE(IOFile),INTENT(IN)  :: IOFile2

    IOFile1%FileName = IOFile2%FileName
    IOFile1%DataTypeLine(:) = IOFile2%DataTypeLine(:) 

    IOFile1%IFormat  = IOFile2%IFormat
    IOFile1%RFormat  = IOFile2%RFormat
    IOFile1%DFormat  = IOFile2%DFormat
    IOFile1%CFormat  = IOFile2%CFormat
    IOFile1%DCFormat = IOFile2%DCFormat
    IOFile1%SFormat  = IOFile2%SFormat

    IOFile1%FileFormat = IOFile2%FileFormat

    IOFile1%IOFileAction = IOFile2%IOFileAction

    IOFile1%NLines(:) = IOFile2%NLines(:)
    IOFile1%TotLines = IOFile2%TotLines
    IOFile1%NSections = IOFile2%NSections
    IOFile1%UnitNumber = IOFile2%UnitNumber

    IOFile1%IsInitialized = IOFile2%IsInitialized
    IOFile1%ExistedOnOpen = IOFile2%ExistedOnOpen
    IOFile1%IsOpen = IOFile2%IsOpen
    IOFile1%EOF = IOFile2%EOF


  END SUBROUTINE COPYIOFILE

  ! Initialize IOFile IOF. FileName must be specified.
  ! All other arguments are optional.
  SUBROUTINE InitIOFile(IOF, FileName)
    TYPE(IOFile),INTENT(INOUT) :: IOF
    CHARACTER*(*),INTENT(IN) :: FileName
    ! Loop variables
    !INTEGER i1
    ! Set FileName, NSections, NLines
    IOF%FileName  = FileName
    IOF%NSections = 0
    IOF%NLines(:) = 0
    IOF%TotLines  = 0
    IOF%NSections = 0
    IOF%DataTypeLine(:)='Unknown'
    IOF%IsInitialized = .TRUE.
    IOF%ExistedOnOpen = .FALSE.
    IOF%IFormat = DefaultIFormat
    IOF%RFormat = DefaultRFormat
    IOF%DFormat = DefaultDFormat
    IOF%CFormat = DefaultCFormat
    IOF%DCFormat = DefaultDCFormat
    IOF%SFormat = DefaultSFormat
    IOF%FileFormat = DefaultFileFormat
    IOF%EOF = .FALSE.

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    ! Error definitions: Not set up yet.
    ! ArrayTooSmall - Error evaluates true if arrays passed to read routines are not big enough
    !                 to hold the data in the file.
    IOF%IOErrors(1)%ErrorName = 'ArrayTooSmall'
    IOF%IOErrors(1)%Message(1)    = 'Array too small to hold data in file ' // FileName // '.'
    IOF%IOErrors(1)%Action        = 'WARN' 
    IOF%IOErrors(1)%ErrorOccured  = .FALSE.
    IOF%IOErrors(1)%NErrLines     = 1

    ! ArrayTooLarge - Error evaluates true if arrays passed to read routines are larger than
    !                 the data in the file.
    IOF%IOErrors(2)%ErrorName = 'ArrayTooLarge'
    IOF%IOErrors(2)%Message(1)    = 'Array too large when compared to data in file ' // FileName // '.'
    IOF%IOErrors(2)%Action        = 'WARN' 
    IOF%IOErrors(2)%ErrorOccured  = .FALSE.
    IOF%IOErrors(2)%NErrLines     = 1

  END SUBROUTINE InitIOFile

  ! Add a file to the stack
  SUBROUTINE AddIOFile(FileName)
    CHARACTER*(*),INTENT(IN) :: FileName
    TYPE(IOFile) IOF

    ! If file exists, do nothing
    IF(IndexIOFile(FileName).ne.0) RETURN 

    ! initialize IOFile
    CALL InitIOFile(IOF, FileName)

    ! Add IOFile to stack.
    NFiles = NFiles + 1
    FileStack(NFiles) = IOF
    FileStack(NFiles)%IsInitialized = .TRUE.
  END SUBROUTINE AddIOFile

  ! Find the index of a file
  INTEGER FUNCTION IndexIOFile(FileName)
    CHARACTER*(*) FileName
    INTEGER i1
    IndexIOFile = 0
    DO i1 = 1, NFiles
       IF(TRIM(FileStack(i1)%FileName).eq.TRIM(FileName)) THEN
          IndexIOFile = i1
          RETURN
       END IF
    END DO
  END FUNCTION IndexIOFile


  ! Remove a file from the stack
  SUBROUTINE DeleteIOFile(FileName)
    CHARACTER*(*),INTENT(IN) :: FileName
    CHARACTER(10) TmpStr

    ! Local variable index is index of file to delete
    INTEGER Index
    INTEGER i1

    TmpStr = TRIM(ADJUSTL(FileName))
    CALL Upper(TmpStr)

    IF(TmpStr(1:3).eq.'ALL') THEN       
       NFiles = 0
    ELSE
       Index = IndexIOFile(FileName)
       ! If file doesn't exist, do nothing
       IF(Index.eq.0) RETURN

       ! Shift remaining files left
       DO i1 = Index, NFiles - 1
          FileStack(i1) = FileStack(i1+1)
       END DO

       NFiles = NFiles - 1
    END IF
  END SUBROUTINE DeleteIOFile

  ! Set options for IOFile
  SUBROUTINE SetIOFileInfo(FileName,UnitNumber, DataTypeLine, IFormat, RFormat, &
       & DFormat, CFormat, DCFormat, SFormat, FileFormat, ExistedOnOpen, IsOpen, &
       & FileAction, NSections,EOF)
    CHARACTER*(*),INTENT(IN) :: FileName
    CHARACTER*(*),INTENT(IN),OPTIONAL :: DataTypeLine, IFormat, RFormat, DFormat, &
         & CFormat, DCFormat, SFormat, FileFormat, FileAction
    LOGICAL, INTENT(IN), OPTIONAL :: ExistedOnOpen, IsOpen, EOF
    INTEGER, INTENT(IN), OPTIONAL :: UnitNumber, NSections

    CHARACTER(1000) TmpStr
    INTEGER IOFIndex

    IOFIndex = IndexIOFile(FileName)
    IF(IOFIndex.eq.0) THEN
       CALL Error('Error in function: SetIOFileOptions', StopProgram = .FALSE.)
       CALL Error('File: ' // FileName // ' does not exist.')
    END IF

    ! If arguments are present, set them.
    IF(PRESENT(UnitNumber)) FileStack(IOFIndex)%UnitNumber = UnitNumber
    IF(PRESENT(NSections)) FileStack(IOFIndex)%NSections = NSections
    IF(PRESENT(DataTypeLine)) THEN
       IF(FileStack(IOFIndex)%NSections.gt.0) FileStack(IOFIndex)%DataTypeLine(FileStack(IOFIndex)%NSections) = DataTypeLine
    END IF
    IF(PRESENT(IFormat))  FileStack(IOFIndex)%IFormat  = IFormat
    IF(PRESENT(RFormat))  FileStack(IOFIndex)%RFormat  = RFormat
    IF(PRESENT(DFormat))  FileStack(IOFIndex)%DFormat  = DFormat
    IF(PRESENT(CFormat))  FileStack(IOFIndex)%CFormat  = CFormat
    IF(PRESENT(DCFormat)) FileStack(IOFIndex)%DCFormat = DCFormat
    IF(PRESENT(SFormat))  FileStack(IOFIndex)%SFormat  = SFormat
    IF(PRESENT(FileFormat)) THEN
       TmpStr = TRIM(ADJUSTL(FileFormat))
       CALL Upper(TmpStr)
       FileStack(IOFIndex)%FileFormat  = TRIM(TmpStr)
    END IF
    IF(PRESENT(ExistedOnOpen)) FileStack(IOFIndex)%ExistedOnOpen  = ExistedOnOpen
    IF(PRESENT(IsOpen)) FileStack(IOFIndex)%IsOpen  = IsOpen
    IF(PRESENT(FileAction)) THEN
       TmpStr = TRIM(ADJUSTL(FileAction))
       CALL Upper(TmpStr)
       FileStack(IOFIndex)%IOFileAction = TRIM(TmpStr)
    END IF
    IF(PRESENT(EOF)) FileStack(IOFIndex)%EOF = EOF
  END SUBROUTINE SetIOFileInfo

  SUBROUTINE GetIOFileInfo(FileName, UnitNumber, DataTypeLine, IFormat, RFormat, &
       & DFormat, CFormat, DCFormat, SFormat, FileFormat, ExistedOnOpen, IsOpen, &
       & FileAction, NSections, EOF)
    CHARACTER*(*),INTENT(IN) :: FileName
    CHARACTER*(*),INTENT(OUT),OPTIONAL :: DataTypeLine, IFormat, RFormat, DFormat, &
         & CFormat, DCFormat, SFormat, FileFormat, FileAction
    LOGICAL, INTENT(OUT), OPTIONAL :: ExistedOnOpen, IsOpen, EOF
    INTEGER, INTENT(OUT), OPTIONAL :: UnitNumber, NSections

    INTEGER IOFIndex

    IOFIndex = IndexIOFile(FileName)

    IF(IOFIndex.eq.0) THEN
       CALL Error('Error in function: GetIOFileInfo', StopProgram = .FALSE.)
       CALL Error('File: ' // FileName // ' does not exist.')
    END IF

    ! If arguments are present, set them.
    IF(PRESENT(UnitNumber)) UnitNumber = FileStack(IOFIndex)%UnitNumber
    IF(PRESENT(DataTypeLine)) THEN
       IF(FileStack(IOFIndex)%NSections.gt.0) THEN
          DataTypeLine = FileStack(IOFIndex)%DataTypeLine(FileStack(IOFIndex)%NSections)
       END IF
    END IF
    IF(PRESENT(IFormat))  IFormat  = FileStack(IOFIndex)%IFormat
    IF(PRESENT(RFormat))  RFormat  = FileStack(IOFIndex)%RFormat
    IF(PRESENT(DFormat))  DFormat  = FileStack(IOFIndex)%DFormat
    IF(PRESENT(CFormat))  CFormat  = FileStack(IOFIndex)%CFormat
    IF(PRESENT(DCFormat)) DCFormat = FileStack(IOFIndex)%DCFormat
    IF(PRESENT(SFormat))  SFormat  = FileStack(IOFIndex)%SFormat 

    IF(PRESENT(FileFormat)) FileFormat = FileStack(IOFIndex)%FileFormat
    IF(PRESENT(ExistedOnOpen)) ExistedOnOpen = FileStack(IOFIndex)%ExistedOnOpen
    IF(PRESENT(IsOpen)) IsOpen = FileStack(IOFIndex)%IsOpen
    IF(PRESENT(NSections)) NSections = FileStack(IOFIndex)%NSections
    IF(PRESENT(EOF)) EOF = FileStack(IOFIndex)%EOF
    IF(PRESENT(FileAction)) FileAction = FileStack(IOFIndex)%IOFileAction
  END SUBROUTINE GetIOFileInfo

  SUBROUTINE PrintIOFileInfo(IOF)
    TYPE(IOFile) IOF
    INTEGER i1

    PRINT '(A)', 'Information for file ' // TRIM(IOF%FileName)
    PRINT *, 'File is initialized ?: ', IOF%IsInitialized
    PRINT*, 'File is open?: ', IOF%IsOpen
    PRINT*, 'Files existed on open ?: ', IOF%ExistedOnOpen
    PRINT*, 'Unit Number: ', IOF%UnitNumber
    PRINT*, 'End of file?: ', IOF%EOF
    PRINT '(2A)', 'IFormat: ', IOF%IFormat
    PRINT '(2A)', 'RFormat: ', IOF%RFormat
    PRINT '(2A)', 'DFormat: ', IOF%DFormat
    PRINT '(2A)', 'CFormat: ', IOF%CFormat
    PRINT '(2A)', 'DCFormat: ',IOF%DCFormat
    PRINT '(2A)', 'SFormat: ', IOF%SFormat
    PRINT '(2A)', 'FileFormat: ', IOF%FileFormat
    PRINT '(2A)', 'FileAction: ', IOF%IOFileAction
    PRINT '(A,I10)', 'Total number of Lines: ', IOF%TotLines
    PRINT '(A,I10)', 'Number of sections: ', IOF%NSections

    PRINT '(A)', 'Section information:'
    PRINT '(A)', 'Section  NLines  DataTypeLine'
    DO i1 = 1, IOF%NSections
       PRINT '(2I5,1X,A)', i1, IOF%NLines(i1), IOF%DataTypeLine(i1)
    END DO
  END SUBROUTINE PrintIOFileInfo

  SUBROUTINE PrintFileStackInfo
    INTEGER i1
    PRINT*, 'Number of files: ', NFiles
    DO i1 = 1, NFiles
       CALL PrintIOFileInfo(FileStack(i1))
    END DO
  END SUBROUTINE PrintFileStackInfo

  LOGICAL FUNCTION ReadingNewSection(FileName,NSections)
    CHARACTER*(*), INTENT(IN) :: FileName
    INTEGER,INTENT(IN) :: NSections
    INTEGER IOFIndex

    IOFIndex = IndexIOFile(FileName)

    IF(IOFIndex.eq.0) THEN
       CALL Error('Error in function IsNewSection. File: ' &
            & // FileName // ' does not exist.')
    ELSE

       IF(FileStack(IOFIndex)%NSections.eq.NSections+1) THEN
          ReadingNewSection = .TRUE.
       ELSE
          ReadingNewSection = .FALSE.
       END IF
    END IF
  END FUNCTION ReadingNewSection

  LOGICAL FUNCTION WritingNewSection(FileName,DataTypeLine)
    CHARACTER*(*), INTENT(IN) :: FileName, DataTypeLine
    INTEGER IOFIndex, NSections

    !    write(*,*) 'filename,datatypeline',filename,datatypeline
    !	write(*,*) 'filestack',filestack
    IOFIndex = IndexIOFile(FileName)
    IF(IOFIndex.eq.0) THEN
       CALL Error('Error in function IsNewSection. File: ' &
            & // FileName // ' does not exist.')
    ELSE
       NSections = FileStack(IOFIndex)%NSections
       IF(NSections.le.0) THEN
          WritingNewSection = .FALSE.
          RETURN
       END IF
       IF(TRIM(DataTypeLine).eq. &
            & TRIM(FileStack(IOFIndex)%DataTypeLine(NSections)).or.&
            & LEN_TRIM(DataTypeLine).eq.0) THEN
          WritingNewSection = .FALSE.
       ELSE
          WritingNewSection = .TRUE.
       END IF
    END IF
  END FUNCTION WritingNewSection

  SUBROUTINE GetFileStackInfo(NumberOfFiles, FileNames, UnitNumbers)
    INTEGER,INTENT(OUT) :: NumberOfFiles
    CHARACTER*(*),INTENT(OUT),OPTIONAL :: FileNames(:)
    INTEGER,INTENT(OUT),OPTIONAL :: UnitNumbers(:)

    INTEGER i1

    IF(PRESENT(FileNames)) THEN
       ! Check the size of the array.
       IF(SIZE(FileNames).gt.NFiles) CALL Error('Array to hold file names passed to ' // &
            & 'GetFileStackInfo is not large enough.')

       DO i1 = 1, NFiles
          FileNames(i1) = FileStack(i1)%FileName
       END DO
    END IF

    IF(PRESENT(UnitNumbers)) THEN
       ! Check the size of the array.
       IF(SIZE(UnitNumbers).gt.NFiles) CALL Error('Array to hold file names passed to ' // &
            & 'GetFileStackInfo is not large enough.')

       DO i1 = 1, NFiles
          UnitNumbers(i1) = FileStack(i1)%UnitNumber
       END DO
    END IF
    NumberOfFiles = NFiles
  END SUBROUTINE GetFileStackInfo

  ! Find the index of an ioerror.
  INTEGER FUNCTION IndexIOError(Filename,ErrorName)
    CHARACTER*(*) FileName, ErrorName
    INTEGER IOFIndex, i1

    IOFIndex = IndexIOFile(FileName)
    ! If file doesn't exist, error
    IF(IOFIndex.eq.0) CALL Error('ERROR: IOFile does not exist for file ' // FileName // '.')

    DO i1 = 1, NError
       IF(TRIM(FileStack(IOFIndex)%IOErrors(i1)%ErrorName).eq.TRIM(ErrorName)) THEN
          IndexIOError = i1
          RETURN
       END IF
    END DO
  END FUNCTION IndexIOError

  SUBROUTINE SetIOErrorInfo(FileName, ErrorName, Message, Action, ErrorOccured)
    CHARACTER*(*),INTENT(IN) :: FileName, ErrorName
    CHARACTER*(*),INTENT(IN),OPTIONAL :: Message(:), Action
    LOGICAL,INTENT(IN),OPTIONAL :: ErrorOccured
    INTEGER IOErrorIndex, IOFIndex, i1, NMessage, NErrLines

    IOFIndex = IndexIOFile(FileName)
    IOErrorIndex = IndexIOError(FileName,ErrorName)
    NErrLines = FileStack(IOFIndex)%IOErrors(IOErrorIndex)%NErrLines

    IF(PRESENT(Message)) THEN
       NMessage = MAX(SIZE(Message)+NErrLines,MxErrLines)
       DO i1 = NErrLines, NMessage
          FileStack(IOFIndex)%IOErrors(IOErrorIndex)%Message(i1) = Message(i1-NErrLines+1)
       END DO
    END IF
    FileStack(IOFIndex)%IOErrors(IOErrorIndex)%NErrLines = NMessage
    IF(PRESENT(Action))  FileStack(IOFIndex)%IOErrors(IOErrorIndex)%Action = Action
    IF(PRESENT(ErrorOccured)) FileStack(IOFIndex)%IOErrors(IOErrorIndex)%ErrorOccured = ErrorOccured
  END SUBROUTINE SetIOErrorInfo

  SUBROUTINE GetIOErrorInfo(FileName, ErrorName, Message, Action, ErrorOccured, NErrLines)
    CHARACTER*(*),INTENT(IN) :: FileName, ErrorName
    CHARACTER*(*),INTENT(OUT),OPTIONAL :: Message(:), Action
    LOGICAL,INTENT(OUT),OPTIONAL :: ErrorOccured
    INTEGER,INTENT(OUT),OPTIONAL :: NErrLines
    INTEGER IOErrorIndex, IOFIndex, i1, NLines

    IOFIndex = IndexIOFile(FileName)
    IOErrorIndex = IndexIOError(FileName,ErrorName)
    NLines = FileStack(IOFIndex)%IOErrors(IOErrorIndex)%NErrLines

    IF(PRESENT(Message)) THEN
       DO i1 = 1, NLines
          Message(i1) = FileStack(IOFIndex)%IOErrors(IOErrorIndex)%Message(i1)
       END DO
    END IF

    IF(PRESENT(Action))  Action = FileStack(IOFIndex)%IOErrors(IOErrorIndex)%Action
    IF(PRESENT(ErrorOccured))  ErrorOccured = FileStack(IOFIndex)%IOErrors(IOErrorIndex)%ErrorOccured
    IF(PRESENT(NErrLines))  NErrLines = FileStack(IOFIndex)%IOErrors(IOErrorIndex)%NErrLines 
  END SUBROUTINE GetIOErrorInfo

END MODULE IOFiles

      subroutine potrdf (ia)
c        this programm uses akeato(bkeato),aprdev,multrk,yzkrdf
      implicit double precision (a-h,o-z)
      common cg(251,30), cp(251,30), bg(10,30), bp(10,30),
     1        fl(30), fix(30), ibgp
      common/comdir/cl,dz,dg(251),ag(10),dp(251),ap(10),dv(251),av(10),
     2              eg(251),ceg(10),ep(251),cep(10)
c     dg,dp to get data from yzkrdf, dv,eg,ep -output for soldir
      dimension at(251),bt(251)
      common/itescf/testy,rap(2),teste,nz,norb,norbsc
      common/ratom1/xnel(30),en(30),scc(30),scw(30),sce(30),
     1nq(30),kap(30),nmax(30)
      common/scrhf1/eps(435),nre(30),ipl
      common/snoyau/dvn(251),anoy(10),nuc
      common/tabtes/hx,dr(251),test1,test2,ndor,np,nes,method,idim
      dimension bgj(10),bpj(10)
c#mn
       external akeato, bkeato, aprdev
 
      do 9 i=1,ndor
         cep(i)=0.0d 00
         ceg(i)=0.0d 00
 9       av(i)=anoy(i)
      do 11 i=1,idim
         at(i)=0.0d 00
         bt(i)=0.0d 00
         ep(i)=0.0d 00
         eg(i)=0.0d 00
 11      dv(i)=0.0d 00
 
c     coulomb terms
      jia=2* abs(kap(ia))-1
      k=0
 21   do 25 i=1,idim
 25   dg(i)=0.0d 00
      do 31 i=1,ndor
 31   ag(i)=0.0d 00
      max0=0
      do 51 j=1,norb
         do 33 i = 1,10
            bgj(i) = bg(i,j)
 33         bpj(i) = bp(i,j)
         m=2* abs(kap(j))-1
         if (k.gt.m) go to 51
         a=akeato(ia,j,k)/xnel(ia)
         if (a.eq.0.0d 00) go to 51
         m=nmax(j)
         do 35 i=1,m
 35         dg(i)=dg(i)+a*(cg(i,j)*cg(i,j)+cp(i,j)*cp(i,j))
         n=2* abs(kap(j))-k
         l=ndor+2-n
         if (l.le.0) go to 51
c        quick fix of development coefficients
         a = a * fix(j)**2
         do 41 i=1,l
            m=n-2+i
 41         ag(m)=ag(m)+a*(aprdev(bgj,bgj,i)+
     1            aprdev(bpj,bpj,i))
 51      max0= max(max0,nmax(j))
      call yzkrdf (0,max0,k)
      do 61 i=1,ndor
         l=k+i+3
         if (l.gt.ndor) go to 61
         av(l)=av(l)-ag(i)
 61   continue
      do 81 i=1,idim
 81   dv(i)=dv(i)+dg(i)
      k=k+2
      if (k.le.ndor) av(k)=av(k)+ap(1)
      if (k.lt.jia) go to 21
 
c     exchange terms
      if (method.eq.0) go to 411
      do 201 j=1,norb
         if (j-ia) 105,201,105
 105     max0=nmax(j)
         jj=2* abs(kap(j))-1
         kma=(jj+jia)/2
         k= abs(jj-kma)
         if ((kap(j)*kap(ia)).lt.0) k=k+1

 111     a=bkeato(j,ia,k)/xnel(ia)
         if (a.eq.0.0d 00) go to 151
         call yzkrdf (j,ia,k)
         do 121 i=1,max0
            eg(i)=eg(i)+a*dg(i)*cg(i,j)
 121        ep(i)=ep(i)+a*dg(i)*cp(i,j)
         n=k+1+ abs(kap(j))- abs(kap(ia))
         if (n.gt.ndor) go to 141
         do 135 i=n,ndor
            ceg(i)=ceg(i)+bg(i+1-n,j)*a*ap(1) *fix(j)/fix(ia)
 135        cep(i)=cep(i)+bp(i+1-n,j)*a*ap(1) *fix(j)/fix(ia)
 141     i=2* abs(kap(j))+1
         if (i.gt.ndor) go to 151
         do 143 ix = 1,10
            bgj(ix) = bg(ix,j)
 143        bpj(ix) = bp(ix,j)
         do 145 n=i,ndor
            ceg(n)=ceg(n)-a*aprdev(ag,bgj,n+1-i) *fix(j)**2
 145        cep(n)=cep(n)-a*aprdev(ag,bpj,n+1-i) *fix(j)**2
 151     k=k+2
         if (k.le.kma) go to 111
 201  continue
 411  if (ipl.eq.0) go to 511
      do 481 j=1,norbsc
         if (kap(j).ne.kap(ia).or.j.eq.ia) go to 481
         if (nre(j).lt.0.and.nre(ia).lt.0) go to 481
         m= max(j,ia)
         i= min(j,ia)+((m-1)*(m-2))/2
         a=eps(i)*xnel(j)
         max0=nmax(j)
         do 461 i=1,max0
            at(i)=at(i)+a*cg(i,j)
 461        bt(i)=bt(i)+a*cp(i,j)
         do 471 i=1,ndor
            ceg(i)=ceg(i)+bg(i,j)*a
 471        cep(i)=cep(i)+bp(i,j)*a
 481  continue
 
c addition of nuclear potential and division of potentials and
c       their development limits by speed of light
 511  do 527 i=1,ndor
         av(i)=av(i)/cl
         cep(i)=cep(i)/cl
 527     ceg(i)=ceg(i)/cl
      do 531 i=1,idim
         dv(i)=(dv(i)/dr(i)+dvn(i))/cl
         ep(i)=(ep(i)+bt(i)*dr(i))/cl
 531     eg(i)=(eg(i)+at(i)*dr(i))/cl
      return
      end

      subroutine somm2 (dr,dp,dpas,da,rnrm,m,np)
c Modified to use complex p and q.  SIZ 4/91
c Modified to use double simpson integration ALA 3/97
c integration by the method of simpson of dp*dr from 
c 0 to r=rnrm  with proper end corrections
c dpas=exponential step;
c for r in the neighborhood of zero dp=cte*r**da
c **********************************************************************
      implicit double precision (a-h,o-z)
      dimension dr(*)
      dimension  dp(*)

      mm = m + 1
      d1=dble(da)+mm
      da=0.0
      db=0.0
c      np-2=inrm -point of grid just below rnrm
      a1=log(rnrm/dr(np-2)) / dpas
      a2=a1**2/8.0d0
      a3=a1**3/12.0d0
      do 70 i=1,np
         if (i.eq.1) then
            dc=dp(i) *dr(i)**mm*9.0d0/24.0d0
         elseif (i.eq.2) then
            dc=dp(i) *dr(i)**mm*28.0d0/24.0d0
         elseif (i.eq.3) then
            dc=dp(i)*dr(i)**mm*23.0d0/24.0d0
         elseif (i.eq.np-3) then
            dc=dp(i)*dr(i)**mm*(25.0d0/24.0d0-a2+a3)
         elseif (i.eq.np-2) then
            dc=dp(i)*dr(i)**mm*(0.5d0+a1-3*a2-a3)
         elseif (i.eq.np-1) then
            dc=dp(i)*dr(i)**mm*(-1.0d0/24.0d0+5*a2-a3)
         elseif (i.eq.np) then
            dc=dp(i)*dr(i)**mm*(-a2+a3)
         else
c           like trapesoidal rule
            dc=dp(i)*dr(i)**mm
         endif
         da=da+dc
   70 continue
      da=dpas*da

c     add initial point (r=0) correction
      dd=exp(dpas)-1.0
      db=d1*(d1+1.0)*dd*exp((d1-1.0)*dpas)
      db=dr(1)*(dr(2)**m)/db
      dd=(dr(1)**mm)*(1.0+1.0/(dd*(d1+1.0)))/d1
      da=da+dd*dp(1)-db*dp(2)
      return
      end

      subroutine frnrm (rho, iz, rnrm)
      implicit double precision (a-h, o-z)
      include 'dim.h'
      dimension rho(nrptx)

c     finds norman radius

c     Need overlapped densities.  We'll get them in the form
c     4*pi*density = rho.  Also need z of atom

c     Then integrate out to the point where the integral of
c     4*pi*density*r**2 is equal to iz
      sum = 0.0
      do 10  i = 1, nrptx-1
         fr = rho(i+1) * rr(i+1)**3
         fl = rho(i)   * rr(i)**3
         sumsav = sum
         sum = sum + 0.025*(fr+fl)
         if (sum .ge. iz)  then
            inrm = i+1
            goto 20
         endif
   10 continue
       call echo( ' FRNRM Could not integrate enough charge')
       call echo( '       to reach required z.')
       call fstop(' at FRNRM-1')
   20 continue
c     inrm is too big, subtract one from irnm and interpolate
c     to get correct value
      inrm = inrm - 1
      deltaq = iz - sumsav
      fr = rho(inrm+1) * rr(inrm+1)**3
      fl = rho(inrm)   * rr(inrm)**3
c     dipas is delta i * 0.05
      dipas = 2*deltaq / (fl + fr)
      rnrm = rr(inrm)*(1 + dipas)

      return
      end

      subroutine scfdat ( ipr1, iph, nph, iz, ihole, xion, iunf, vcoul,
     1     srho, dmag, srhovl, ispinr, dgc0, dpc0, dgc, dpc, adgc, adpc,
     2     s02, efrozn, eatom, xntot, xnval, indorb, norbp, eorb, kappa)
c     single configuration Dirac-Fock atom code
c     Ankudinov, Zabinsky, Rehr, Comp.Phys. Comm. 98, p.359 (1996).
c     which is modified Desclaux multi-configuration code.
c     written by a.ankudinov 1996

      implicit double precision (a-h,o-z)

      include '../HEADERS/dim.h'
      include '../HEADERS/parallel.h'
c     save central atom dirac components, see comments below.
      dimension dgc0(251), dpc0(251)
      dimension dgc(251, 30, 0:nphx), dpc(251, 30, 0:nphx)
      dimension adgc(10, 30, 0:nphx), adpc(10, 30, 0:nphx)
      dimension xntot(0:lx), xnval(30), eorb(30), kappa(30)
      dimension xmag(30)
 
      dimension vcoul(251)
      dimension srho(251), dmag(251), srhovl(251)
c     temporary do not use core-valence separation
      dimension xnvalp(30), indorb(-4:3)
      logical open_16
     
      dimension ovpint(30, 30)
      character*30 fname
c#mn:
       external dsordf

c muatco programm to calculate angular coefficients
c        this programm uses cofcon cofdat dsordf ictime iowrdf
c        lagdat messer nucdev ortdat potrdf soldir 
      common cg(251,30), cp(251,30), bg(10,30), bp(10,30),
     1         fl(30), fix(30), ibgp
c cg (cp) large (small) components
c bg (bp) development coefficients at the origin of large
c    (small) component
c fl power of the first term of development limits.
c ibgp first dimension of the arrays bg and bp

      common/comdir/ cl, dz, gg(251), ag(10), gp(251), ap(10), bid(783)
c  gg,gp are the output from soldir
      common/itescf/ testy, rap(2), teste, nz, norb, norbsc
cXX   common/mulabk/ afgk
      common/inelma/ nem
cXX      dimension afgk(30, 30, 0:3)
      common/messag/ dlabpr, numerr
      character*8 dprlab, dlabpr
      common/ratom1/ xnel(30), en(30), scc(30), scw(30), sce(30),
     1nq(30), kap(30), nmax(30)
      common/scrhf1/ eps(435), nre(30), ipl
      common/snoyau/ dvn(251), anoy(10), nuc
      common/tabtes/ hx, dr(251), test1, test2, ndor, np, nes, method,
     1 idim
      data dprlab /'  scfdat'/
 
      if (ipr1 .ge. 3 .and. iph.le.nph)  then
c        do not want to have extra file
c        prepare file for atom output
         write(fname,14)  iph
   14    format('atom', i2.2, '.dat')
         if (master) then
           open (unit=16, file=fname, status='unknown', iostat=ios)
           open_16 = .true.
         else
           open_16 = .false.
         endif
c        call chopen (ios, fname, 'atom')
c        call head (16)
         if (open_16) write (16,*)  ' free atom ', iph
      endif

c  initialize the data and test parameters
      open_16 = .false.
      jfail = 0
      ibgp = 10
      numerr = 0
      nz = iz
      call inmuat (ihole, xion, iunf, xnval, iholep, xmag, indorb)

      idfock = 1
c     idfock = 2
c     idfock=1  --  pure Dirac-Fock.
c     idfock=2  --  pure LDA
c     idfock=5  --  exchange 5 model.
c     idfock=6  --  exchange 6 model.
      if (idfock.eq.1) then 
         do 42 i=1,30
  42     xnvalp(i) = 0.0d0
      elseif (idfock.eq.2) then
         do 44 i=1,30
  44     xnvalp(i) = xnel(i)
      else
c        use core-valence separation. also change vlda.f
         do 43 i=1,30
  43     xnvalp(i) = xnval(i)
      endif

c     iholep is the index for core hole orbital in all arrays
c     ihole is just a code number for given core hole
c     for 90% of atoms iholep=ihole
      ilast = 0

c   calculate initial orbitals using thomas-fermi model ido=1
c   option to read from cards(ido=2) destroyed
      ido = 1
      if (numerr .eq. 0) then
         a = -xion - 1
         call wfirdf (en, a, nq, kap, nmax, ido)
      endif

      niter = 30
c if niter is negative then schmidt orthogonalization procedure is used
c           niter =1000*n1+100*n2+n3
c n3 is the number of iterations per orbital
      j = 1
      ind = 1
      nter = 0
      do 41 i = 1, norb
 41   scw(i) = 0.
      test1 = testy / rap(1)
      test2 = testy / rap(2)
      netir = abs(niter) * norb
      if (ipr1 .ge. 5 .and. iph.le.nph .and. open_16)  then
         write(16,210) niter, teste, testy
  210    format (5x,'number of iterations',i4,//,
     1        5x,'precision of the energies',1pe9.2,//,
     2        23x,'wave functions  ',1pe9.2,/)
         write(16,220) idim, dr(1), hx
  220    format (' the integration is made on ', i3,
     1        ' points-the first is equal to ' ,f7.4,/,
     2        ' and the step-size pas = ',f7.4,/)
         write(16,230) test1, nes
  230    format ('matching of w.f. with precision', 1pe9.2,
     2        ' in ',i3,' attempts ',/)
         if (nuc .gt. 1)  write(16,250)
  250    format (1h0, 30x,'finite nucleus case used'/)
      endif
 
c     angular coefficients 
c     corrected for valence model. ala
      call muatco(xnvalp)
      if (numerr .ne. 0) go to 711

c     iteration over the number of cycles
 101  iort = 0
         nter = nter + 1
         if (niter .ge. 0) go to 105
c        orthogonalization by schmidt procedure
 104     call ortdat (j)
 105     method = 1
c        calculate lagrange parameters
         if (nre(j).gt.0 .and. ipl.ne.0) call lagdat (j,1)
c        calculate electron potential
         call potrdf (j)
c        add potential due to xc with valence electrons
         call vlda (xnval, srho, srhovl, dmag, ilast, idfock)
c         call vlda (j, xnval, srho, srhovl, dmag, ilast, idfock)
         e = en(j)
         np = idim
c        resolution of the dirac equation
         ifail = 0
         ainf = cg(nmax(j),j)
         call soldir (en(j), fl(j), bg(1,j), bp(1,j), ainf,
     1                nq(j), kap(j), nmax(j), ifail)
         if (ifail.ne.0 .and. jfail.eq.0) jfail = j
         if (jfail.eq.j .and. ifail.eq.0) jfail = 0
         if (numerr. eq. 0) go to 111
         if (iort.ne.0 .or. niter.lt.0) go to 711
         iort = 1
         go to 104

 111     sce(j) = abs ((e - en(j)) / en(j))
c        variation of the wave function using two iterations
         k = nmax(j)
         pr = 0.
         do 121 i = 1, k
            w = cg(i,j) - gg(i)
            if (abs(w) .le. abs(pr)) go to 115
            pr = w
            a = cg(i,j)
            b = gg(i)
 115        w = cp(i,j) - gp(i)
            if (abs(w) .le. abs(pr)) go to 121
            pr = w
            a = cp(i,j)
            b = gp(i)
 121     continue
c        write original Desclaux output on screen and into the logfile
c        write (slog,'(i4, i3, 2(1pe11.2), 2(1pd16.6), 4x, a, i2)')
c    1   nter, j, sce(j), pr, a, b, 'method', method
c        call wlog(slog)

c        acceleration of the convergence
         b = scc(j)
         call cofcon (a, b, pr, scw(j))
         scc(j) = b
         do 151 i = 1, k
            gg(i) = b * gg(i) + a * cg(i,j)
 151        gp(i) = b * gp(i) + a * cp(i,j)
         do 155 i = 1, ndor
            ag(i) = b * ag(i) + a * bg(i,j)
 155        ap(i) = b * ap(i) + a * bp(i,j)
c        normalization of the wave function
         a = dsordf (j, k, 0, 4, fl(j))
         a = sqrt(a)
         do 171 i = 1, np
            cg(i,j) = gg(i) / a
 171        cp(i,j) = gp(i) / a
         do 175 i = 1, ndor
            bg(i,j) = ag(i) / a
 175        bp(i,j) = ap(i) / a
c        determination of the next orbital to calculate
         if (nter.lt.norbsc .or. (ind.lt.0 .and. j.lt.norbsc)) then
            j = j + 1
            go to 451
         endif
            j = j + 1
         pr = 0.
         do 301 i = 1, norbsc
            w = abs (scw(i))
            if (w .gt. pr) then
               pr = w
               j = i
            endif
 301     continue
         if (j .gt. norbsc) j = 1
         if (pr .gt. testy) go to 421
         pr = 0.
         do 321 i = 1, norbsc
            w = abs (sce(i))
            if (w .gt. pr) then
               pr = w
               j = i
            endif
 321     continue
         if (pr .ge. teste) go to 421
         if (ind .lt. 0) go to 999
         ind = -1
         j = 1
         go to 451

 421     ind = 1
 451  if (nter .le. netir) go to 101
      numerr= 192011
c **** number of iterations exceeded the limit
      dlabpr = dprlab
 711  call messer
      call par_stop('SCFDAT-1')
 999  if (numerr .eq. 0) then
         if (jfail .ne. 0) then
            call par_stop(
     1    '  Failed to match lower component, results are meaningless')
c           stop
         endif
c        tabulation of the results
         if (ipr1 .ge. 5 .and. iph.le.nph)  call tabrat
         call etotal (16, kap, xnel, xnvalp, en, eatom)
         do 504 ix = 1,251 
 504       dmag(ix)=0.0d0 
         ilast = 1
         iorb = 0
c        use to test SIC
c         do 505 iorb = 1,norb
         call vlda (xnval, srho, srhovl, dmag, ilast, idfock)
c         call vlda (iorb, xnval, srho, srhovl, dmag, ilast, idfock)
c 505       call vlda (iorb, xnval, srho, srhovl, dmag, ilast, idfock)
         ecorr =2.0
         call somm(dr,dmag,dmag,hx, ecorr,0,idim)
         eatom = (eatom-ecorr/4.0) 

c        jcore = 1

c        prepare information for SCMT and core-valence separation
         norbp = norb
         do 499 i = 0,lx
  499    xntot(i)=0.0d0
         do 500 j = 1, norb
           eorb(j) = en(j) 
           kappa(j) = kap(j)
           i = kap(j)
           if (kap(j) .lt.0) i=-kap(j)-1
           if (i.le.lx) xntot(i)=xntot(i)+xnval(j)
  500    continue
c 500     if (xnel(j).gt.xnval(j) .and. nmax(j).gt.jcore) jcore=nmax(j)

c  get difference in spin-up and -down densities per spin 
c  the spin - polarizable orbitals are specified in subroutine getorb
c  The spin amplitude and directions are taken care of in subroutine ovrlp
c  and specified in feff.inp file
         spin = 0
         do 530 i = 1, idim
  530    dmag(i) = 0.0
         do 536 iorb = 1, norb
           spin = spin + xmag(iorb)
           do 535 i = 1, np
  535      dmag(i)= dmag(i)+ xmag(iorb)* (cg(i,iorb)**2 + cp(i,iorb)**2)
  536    continue
         if (spin.gt.0.d0) then
c          normalize dmag per  spin
           do 537 i = 1, np
  537      dmag(i) = dmag(i) / spin
         endif

c  return coulomb potential
c  fix later: can be replaced by potrdf
         call potslw (vcoul, srho, dr, hx, idim)
         do 510 i = 1, 251
  510      vcoul(i) = (vcoul(i) - nz / dr(i)) 

c        return srho as 4*pi*density instead of 4*pi*density*r**2
         do 560  i = 1, 251
            srho(i) = srho(i) / (dr(i)**2)
            dmag(i) = dmag(i) / (dr(i)**2)
            srhovl(i) = srhovl(i) / (dr(i)**2)
  560    continue

         if (ipr1 .ge. 3 .and. iph.le.nph)  close(unit=16)

         if (ispinr .ne. 0)  then
c        need kap(i) for central atom without core hole, all output of
c        getorb is dummy, except iholep and kap(i) which is put in nq(i)
            call getorb (iz, ispinr, xion, iunf, i, j, indorb,
     1                   iholep, nre, nq, scw, sce, eps)
            do 552  i = 1, nmax(iholep)
               dgc0(i) = cg(i,iholep)
               dpc0(i) = cp(i,iholep)
  552       continue
            do 553  i = nmax(iholep) + 1, 251
               dgc0(i) = 0.0d0
               dpc0(i) = 0.0d0
  553       continue
         endif

         do 590 j = 1, 30
            do 570 i = 1, nmax(j)
               dgc(i,j,iph) = cg(i,j)
               dpc(i,j,iph) = cp(i,j)
  570       continue
            do 575 i = nmax(j) + 1, 251
               dgc(i,j,iph) = 0.0d 00
               dpc(i,j,iph) = 0.0d 00
  575       continue
            do 580 i = 1, 10
               adgc(i,j,iph) = bg(i,j)
               adpc(i,j,iph) = bp(i,j)
  580       continue
  590    continue
      endif

c     calc. overlap integrals for the final and initial state orbitals
c     of the central atom
      if (iholep .gt. 0 .and. iholep.lt.30 .and. ihole.le.0) then
c        this logic is fulfilled only in the last call of scfdat
c        in subroutine pot ( ihole=0 and iholep=ispinr.neq.0)
         efrozn = en(iholep) 
         do 790 i = 1, norb
c          to handle special case when electron added to new orbital
           if (nq(i) .eq. kap(i)) then
              itr = 0
           elseif (nq(i+1) .eq. kap(i)) then
              itr = 1
           else
              call wlog
     1        ('  If it is not la, gd or np, please, give us a call')
              call wlog('  s02 is overestimated')
              do 710 j = 1, i - 1
  710            ovpint(j,i) = 0.0
              ovpint(i,i) = 1.0
              goto 780
           endif
           i0 = i + itr
           iph1 = 0
           if (iph.eq.0) iph1 = nph + 1
           do 720 ir = 1, idim
             gg(ir) = dgc(ir, i0, iph1)
  720        gp(ir) = dpc(ir, i0, iph1)
           do 730 ir = 1, ndor
              ag(ir) = adgc(ir, i0, iph1)
  730         ap(ir) = adpc(ir, i0, iph1)
           do 770 j = 1, norb
             if (kap(i) .ne. kap(j)) go to 770
             ovpint(i,j) = dsordf ( j, j, 0, 3, fl(i))
  770      continue
  780      continue
  790    continue
         do 810 j=1,norb
             xnel(j) = xnel(j)-xnval(j)
 810     continue

c        need better control here. for now always print fpf0.dat
c        if (ipr1.ge.3) call  fpf0 ( iz, iholep, srho, dr, hx,
c         call  fpf0 ( iz, iholep, srho, dr, hx,
c     1     dgc0, dpc0, dgc, dpc,
c     2     eatom, xnel, norb, eorb, kappa)

         call s02at (iholep, norb, kap, xnel, ovpint, s02)
c        print*,'z=',iz, '   s02 calculated = ', s02
      endif

      return
      end

      subroutine ccrit (npat, ipat, ckspc,
     1    fbetac, xlamc, rmax, pcrith, pcritk, nncrit, ipot,
     2    rpath, lheap, lkeep, xcalcx, iclus)

c     lheap to add to heap, lkeep if keep path at output.
c     NB, if lheap is false, lkeep is not used (since path
c     won't be in the heap).

      include '../HEADERS/const.h'
      include '../HEADERS/dim.h'
      logical lheap, lkeep
      dimension ipat(npatx)
      dimension ipot(0:natx)
      parameter (necrit=9, nbeta=40)
      dimension fbetac(-nbeta:nbeta,0:nphx,necrit), ckspc(necrit)
      dimension xlamc(necrit), iclus(0:natx)

c     local variables
      dimension ri(npatx+1), beta(npatx+1), indbet(npatx+1)


c     mrb is efficient way to get only ri and beta
c     note that beta is cos(beta)
      call mrb (npat, ipat, ri, beta)

      rpath = 0
      do 300  i = 1, npat+1
         rpath = rpath + ri(i)
  300 continue

c     If we can decide only on rpath, do it here...
      if (rpath .gt. rmax)  then
         lheap = .false.
         lkeep = .false.
         return
      endif

c     If last atom central atom, do put in heap, don't use it
c     as an actual path at output
      if (ipat(npat).eq.0)  then
         lheap = .true.
         lkeep = .false.
         return
      endif

c     Make index into fbetac array (this is nearest cos(beta) grid 
c     point, code is a bit cute [sorry!], see prcrit for grid).
      do 290  i = 1, npat+1
         tmp = abs(beta(i))
         n = int(tmp / 0.025)
         del = tmp - n*0.025
         if (del .gt. 0.0125)  n = n+1
         if (beta(i) .lt. 0)  n = -n
         indbet(i) = n
  290 continue

c     Decide if we want the path added to the heap if necessary.
c     (Not necessary if no pcrith in use.)
      if (pcrith .gt. 0)  then

         call mcrith (npat, ipat, ri, indbet,
     1                ipot, nncrit, fbetac, ckspc, xheap)

c        xheap = -1 if not defined for this path (too few legs, etc.)
         if (xheap .ge. 0  .and.  xheap .lt. pcrith)  then
c           Do not want path in heap
            lheap = .false.
            lkeep = .false.
            return
         endif
      endif
c     Keep this path in the heap
      lheap = .true.

c     We may want path in heap so that other paths built from this
c     path will be considered, but do not want this path to be
c     written out for itself.  Decide that now and save the flag
c     in the heap, so we won't have to re-calculate the mpprm
c     path parameters later.

c     Skip calc if pcritk < 0
      if (pcritk .le. 0)  then
         lkeep = .true.
         goto 999
      endif

c     Make xout, output inportance factor.
      call mcritk (npat, ipat, ri, beta, indbet,
     1             ipot, nncrit, fbetac, xlamc, ckspc, xout, xcalcx)

c     See if path wanted for output
c     Do not want it if last atom is central atom (xout = -1) or
c     if xout is too small
      lkeep = .false.
      if (xout .ge. pcritk)  lkeep = .true.

c     If path is entirely inside a cluster do not keep it
  999 nclus=0
      do 700 i=1,npat
  700 nclus=nclus+iclus(ipat(i))
      if (nclus.eq.0) lkeep = .false.

      return
      end

!=======================================================================
!     GEOMETRY
!=======================================================================

module geometry_inp
  use dimsmod, only: nattx
  implicit none
  !c    atoms.dat
  integer  natt
  integer iphatx(nattx)
  double precision  ratx(3,nattx)

contains

  subroutine geometry_write_atoms
    integer iat
    double precision distance
    !c    atoms.dat to be read by ffsort, which will write smaller geom.dat file
    open (file='atoms.dat', unit=3, status='unknown')
    write (3, 35) natt
35  format ('natx =  ', i7)
    write (3, 10) '    x       y        z       iph  '
    do iat = 1, natt
       distance=dsqrt((ratx(1,iat)-ratx(1,1))**2+(ratx(2,iat)-ratx(2,1))**2+(ratx(3,iat)-ratx(3,1))**2) ! core hole should be in position 1 by now
       write(3,36) ratx(1,iat), ratx(2,iat), ratx(3,iat), iphatx(iat), distance
36     format( 3f13.5, i4, f13.5)
    enddo
    close(3)
10  format(a)
    ! 20  format (20i4)
    ! 30  format (9f13.5)
  end subroutine geometry_write_atoms

  subroutine geometry_init
    natt = 0
    iphatx(:) = -1
    ratx(:,:) = 0.d0 !KJ added 7-09
  end subroutine geometry_init

end module geometry_inp

! Kevin Jorissen 2012.  Purpose: to pass exit codes to an external
! program, e.g. the JFEFF Java GUI which launches FEFF9 modules and
! must be able to figure out if they succeed before launching the next
! module.  There is no really reliable way to set exit codes in
! Fortran (compiler/platform dependencies; exit codes are only
! included in very latest Fortran standards (2008? 2010?).  Therefore,
! we copy the WIEN2k approach.  Set error file in working directory at
! program launch.  Wipe it on successful termination.  The GUI can
! then check for the presence of a non-zero-size file: If such a file
! exists, the program did not exit cleanly, signifying a crash.  This
! approach is robust and does not depend on any Fortran programming to
! catch runtime exceptiosn, memory allocation problems, ...  The
! downside is that the file will not contain much useful information.
! However any runtime information will still be printed to the screen.

! There is already some error handling code present in FEFF,
! introduced by Josh; presumably only used in a few of the routines he
! contributed?  In any case, it is not set up to output to file rather
! than stdout/err, and I don't want to mess with it.  The simple code
! below is good enough for me.

module errorfile

  implicit none
  character*11,private :: ErrorFileName='.feff.error'
  integer,private :: lun = 77


contains

  subroutine OpenErrorfileAtLaunch(ModuleName)
    ! Open the errorfile and set a default message.  Call at the start of a module.
    character*(*),intent(in) :: ModuleName
    character*500 :: ErrorMessage
    ErrorMessage='Starting feff8l module ' // ModuleName // &
         '.  If this message is still here after the module finishes running,' // &
         ' it must have crashed.  The content of this file is wiped on successful termination.'
    call SetErrorfileMessage(ErrorMessage)
    return
  end subroutine OpenErrorfileAtLaunch


  subroutine WipeErrorfileAtFinish
    !Overwrite the error file with an empty, 0-byte file.  Call at the regular termination of a module.
    open(lun,file=ErrorFileName,status='replace',err=1000)
    close(lun)
    return
1000 stop 'Unable to wipe errorfile in SetErrorfileMessage.  How ironic.'
  end subroutine WipeErrorfileAtFinish



  subroutine SetErrorfileMessage(ErrorMessage)
    !Write a user(programmer)-specified error message to the errorfile.  Useful for diagnostic purposes.
    character*(*),intent(in) :: ErrorMessage
    open(lun,file=ErrorFileName,status='unknown',err=1000)
    write(lun,*) ErrorMessage
    close(lun)
    return
1000 stop 'Unable to open errorfile in SetErrorfileMessage'
  end subroutine SetErrorfileMessage



end module errorfile

C From HDK@psuvm.psu.edu Thu Dec  8 15:27:16 MST 1994
C 
C The following was converted from Algol recursive to Fortran iterative
C by a colleague at Penn State (a long time ago - Fortran 66, please
C excuse the GoTo's). The following code also corrects a bug in the
C Quicksort algorithm published in the ACM (see Algorithm 402, CACM,
C Sept. 1970, pp 563-567; also you younger folks who weren't born at
C that time might find interesting the history of the Quicksort
C algorithm beginning with the original published in CACM, July 1961,
C pp 321-322, Algorithm 64). Note that the following algorithm sorts
C integer data; actual data is not moved but sort is affected by sorting
C a companion index array (see leading comments). The data type being
C sorted can be changed by changing one line; see comments after
C declarations and subsequent one regarding comparisons(Fortran
C 77 takes care of character comparisons of course, so that comment
C is merely historical from the days when we had to write character
C compare subprograms, usually in assembler language for a specific
C mainframe platform at that time). But the following algorithm is
C good, still one of the best available.


      SUBROUTINE QSORTI (ORD,N,A)
C
C==============SORTS THE ARRAY A(I),I=1,2,...,N BY PUTTING THE
C   ASCENDING ORDER VECTOR IN ORD.  THAT IS ASCENDING ORDERED A
C   IS A(ORD(I)),I=1,2,...,N; DESCENDING ORDER A IS A(ORD(N-I+1)),
C   I=1,2,...,N .  THIS SORT RUNS IN TIME PROPORTIONAL TO N LOG N .
C
C
C     ACM QUICKSORT - ALGORITHM #402 - IMPLEMENTED IN FORTRAN 66 BY
C                                 WILLIAM H. VERITY, WHV@PSUVM.PSU.EDU
C                                 CENTER FOR ACADEMIC COMPUTING
C                                 THE PENNSYLVANIA STATE UNIVERSITY
C                                 UNIVERSITY PARK, PA.  16802
C
      IMPLICIT INTEGER (A-Z)
C
      DIMENSION ORD(N),POPLST(2,20)
      INTEGER X,XX,Z,ZZ,Y
C
C     TO SORT DIFFERENT INPUT TYPES, CHANGE THE FOLLOWING
C     SPECIFICATION STATEMENTS; FOR EXAMPLE, FOR FORTRAN CHARACTER
C     USE THE FOLLOWING:  CHARACTER *(*) A(N)
C
      DOUBLE PRECISION A(N)
C
      NDEEP=0
      U1=N
      L1=1
      DO 1  I=1,N
    1 ORD(I)=I
    2 IF (U1.LE.L1) RETURN
C
    3 L=L1
      U=U1
C
C PART
C
    4 P=L
      Q=U
C     FOR CHARACTER SORTS, THE FOLLOWING 3 STATEMENTS WOULD BECOME
C     X = ORD(P)
C     Z = ORD(Q)
C     IF (A(X) .LE. A(Z)) GO TO 2
C
C     WHERE "CLE" IS A LOGICAL FUNCTION WHICH RETURNS "TRUE" IF THE
C     FIRST ARGUMENT IS LESS THAN OR EQUAL TO THE SECOND, BASED ON "LEN"
C     CHARACTERS.
C
      X=A(ORD(P))
      Z=A(ORD(Q))
      IF (X.LE.Z) GO TO 5
      Y=X
      X=Z
      Z=Y
      YP=ORD(P)
      ORD(P)=ORD(Q)
      ORD(Q)=YP
    5 IF (U-L.LE.1) GO TO 15
      XX=X
      IX=P
      ZZ=Z
      IZ=Q
C
C LEFT
C
    6 P=P+1
      IF (P.GE.Q) GO TO 7
      X=A(ORD(P))
      IF (X.GE.XX) GO TO 8
      GO TO 6
    7 P=Q-1
      GO TO 13
C
C RIGHT
C
    8 Q=Q-1
      IF (Q.LE.P) GO TO 9
      Z=A(ORD(Q))
      IF (Z.LE.ZZ) GO TO 10
      GO TO 8
    9 Q=P
      P=P-1
      Z=X
      X=A(ORD(P))
C
C DIST
C
   10 IF (X.LE.Z) GO TO 11
      Y=X
      X=Z
      Z=Y
      IP=ORD(P)
      ORD(P)=ORD(Q)
      ORD(Q)=IP
   11 IF (X.LE.XX) GO TO 12
      XX=X
      IX=P
   12 IF (Z.GE.ZZ) GO TO 6
      ZZ=Z
      IZ=Q
      GO TO 6
C
C OUT
C
   13 CONTINUE
      IF (.NOT.(P.NE.IX.AND.X.NE.XX)) GO TO 14
      IP=ORD(P)
      ORD(P)=ORD(IX)
      ORD(IX)=IP
   14 CONTINUE
      IF (.NOT.(Q.NE.IZ.AND.Z.NE.ZZ)) GO TO 15
      IQ=ORD(Q)
      ORD(Q)=ORD(IZ)
      ORD(IZ)=IQ
   15 CONTINUE
      IF (U-Q.LE.P-L) GO TO 16
      L1=L
      U1=P-1
      L=Q+1
      GO TO 17
   16 U1=U
      L1=Q+1
      U=P-1
   17 CONTINUE
      IF (U1.LE.L1) GO TO 18
C
C START RECURSIVE CALL
C
      NDEEP=NDEEP+1
      POPLST(1,NDEEP)=U
      POPLST(2,NDEEP)=L
      GO TO 3
   18 IF (U.GT.L) GO TO 4
C
C POP BACK UP IN THE RECURSION LIST
C
      IF (NDEEP.EQ.0) GO TO 2
      U=POPLST(1,NDEEP)
      L=POPLST(2,NDEEP)
      NDEEP=NDEEP-1
      GO TO 18
C
C END SORT
C END QSORT
C
      END

c     interpolation and extrapolation by m-th order polynomial
c     maximum m = 3. Change nmax if needed.
c     Input x and y arrays, returns y value y0 at requested x value x0.
c     Dies on error.

      subroutine terp (x, y, n, m, x0, y0)
      implicit double precision (a-h, o-z)

      dimension x(n), y(n)

c     Find out between which x points x0 lies
      i = locat (x0, n, x)
      k = min( max(i-m/2,1) , n-m )
      call polint( x(k), y(k), m+1, x0, y0, dy)

      return
      end

      function locat (x, n, xx)
      integer  u, m, n
      double precision x, xx(n)

c     Binary search for index of grid point immediately below x.
c     Array xx required to be monotonic increasing.
c     Returns
c     0            x <  xx(1)
c     1            x =  xx(1)
c     i            x =  xx(i)
c     n            x >= xx(n)

      locat = 0
      u = n+1

   10 if (u-locat .gt. 1)  then
         m = (u + locat) / 2
         if (x .lt. xx(m))  then
            u = m
         else
            locat = m
         endif
         goto 10
      endif

      return
      end


c     These routines, terp1 and locat1, are special versions to
c     be used with ff2chi, which uses some single and some double
c     precision.  They are the same as the routines in terp.f.

      subroutine terp1 (x, y, n, x0, y0)
      implicit double precision (a-h, o-z)

      real x(n), y(n)

c     Find out between which x points x0 lies
      i = locat1 (x0, n, x)
c     if i < 1, set i=1, if i > n-1, set i=n-1
      i = max (i, 1)
      i = min (i, n-1)

      if (x(i+1) - x(i) .eq. 0)  stop 'TERP-1'

      y0 = y(i) +  (x0 - x(i)) * (y(i+1) - y(i)) / (x(i+1) - x(i))

      return
      end

      function locat1 (x, n, xx)
      integer  u, m, n
      double precision x
      real xx(n)

c     Binary search for index of grid point immediately below x.
c     Array xx required to be monotonic increasing.
c     Returns
c     0            x <  xx(1)
c     1            x =  xx(1)
c     i            x =  xx(i)
c     n            x >= xx(n)

      locat1 = 0
      u = n+1

   10 if (u-locat1 .gt. 1)  then
         m = (u + locat1) / 2
         if (x .lt. xx(m))  then
            u = m
         else
            locat1 = m
         endif
         goto 10
      endif

      return
      end

      subroutine setlam (icalc, ie)
      implicit double precision (a-h, o-z)

c     Set lambda array based on icalc and ie
c     icalc  what to do
c      0     i0, ss exact
c      1     i1, ss exact
c      2     i2, ss exact
c     10     cute algorithm
c     <0     do exactly as told, decode as:
c               icalc = -(nmax + 100*mmax + 10 000*(iord+1))
c               Note that iord=0 <=> nmax=mmax=0, so use
c                  icalc = -10 000 for this case.
c               iord = 2*nmax + mmax, so if you want iord to control,
c               set nmax and mmax large enough-- if you want nmax and
c               mmax to control, set iord = 2*nmax + mmax...

c     inputs: ie used for cute algorithm
c             nsc used from /pdata/ to recognize ss paths
c     output: variables in /lambda/ set

      include 'const.h'
      include 'dim.h'
      include 'lambda.h'
      include 'pdata.h'
      dimension mlam0(lamtot), nlam0(lamtot)
      character messag*128
c     one degree in radians
      parameter (onedeg = .01745329252)

c     Set iord, nmax and mmax based on icalc
      if (icalc .lt. 0)  then
c        decode it and do what user wants
         icode = -icalc
         nmax = mod(icode,100)
         mmax = mod(icode,10000)/100
         iord = icode/10000 -1
      elseif (nsc .eq. 1)  then
         mmax = il0-1
         nmax = il0-1
         iord = 2*nmax + mmax
      elseif (icalc .lt. 10)  then
         iord = icalc
         mmax = iord
         nmax = iord/2
      elseif (icalc .eq. 10)  then
c        do cute algorithm
c        set mmax = L0 if straight line path, otherwise set mmax = 3
         mmax = il0-1
         do 10  ileg = 1, nleg
            mag1 = abs(beta(ileg))
            mag2 = abs(mag1 - pi)
c           if beta is not 0 or pi, path is non-linear
            if (mag1.gt.onedeg .and. mag2.gt.onedeg) mmax = 3
   10    continue
c        Set nmax based on ie and l0.
c        k <= 12 invA (ie=41)  nmax = L0
c        k >= 13 invA (ie=42)  nmax =  9
         nmax = il0-1
         if (ie .ge. 42)  nmax = 9
         iord = 2*nmax + mmax
      else
         write(messag,'(1x,a,i7)') '  icalc out of range ', icalc
         call echo(messag)
         call fstop('at SETLAM')
      endif

c-----construct index lambda (lam), (mu, nu) = mlam(lam), nlam(lam)
c     lamtot, ntot, mtot are maximum lambda, mu and nu to consider
c     Use ...0 for making indices, then sort into arrays with no
c     trailing 0 so laml0x is minimimized. (note: this is a crude
c     n**2 sort -- can 'improve' to nlog_2(n) if necessary)
      lam = 0
      do 20 in = 1, nmax+1
         n = in - 1
         do 20  im = 1, mmax+1
            m = im-1
            jord = 2*n+m
            if (jord .gt. iord)  goto 20
            if (lam .ge. lamtot)  then
               call echo('Lambda array filled, some order lost')
               goto 21
            endif
            lam = lam+1
            mlam0(lam) = -m
            nlam0(lam) = n
            if (m .eq. 0)  goto 20
            if (lam .ge. lamtot)  then
               call echo('Lambda array filled, some order lost')
               goto 21
            endif
            lam = lam+1
            mlam0(lam) = m
            nlam0(lam) = n
   20 continue
   21 continue
      lamx=lam
c     lamx must be less than lamtot
       if (lamx .gt. lamtot)
     $     call fstop(' at SETLAM lamx > lamtot')

c     laml0x is biggest lam for non-zero fmatrix, also set mmax and nmax
c     Sort mlam0 and nlam0 to use min possible laml0x
      lam = 0
      do 30  lam0 = 1, lamx
         if ((nlam0(lam0).le.l0) .and. (iabs(mlam0(lam0)).le.l0)) then
            lam = lam+1
            nlam(lam) = nlam0(lam0)
            mlam(lam) = mlam0(lam0)
            nlam0(lam0) = -1
         endif
   30 continue
      laml0x = lam
      do 40  lam0 = 1, lamx
         if (nlam0(lam0) .ge. 0)  then
            lam = lam+1
            nlam(lam) = nlam0(lam0)
            mlam(lam) = mlam0(lam0)
         endif
   40 continue

      mmaxp1 = 0
      nmax = 0
      do 50  lam = 1, lamx
         if (mlam(lam)+1 .gt. mmaxp1)  mmaxp1 = mlam(lam)+1
         if (nlam(lam) .gt. nmax)  nmax = nlam(lam)
   50 continue

      if (nmax.gt.ntot .or. mmaxp1.gt.mtot+1)  then
         call echo(' mmaxp1, nmax, mtot, ntot icalc')

         write(messag,'(3x,5i8)') 
     1        mmaxp1, nmax, mtot, ntot, icalc
         call echo(messag)

         call fstop(' at SETLAM')
      endif

      return
      end

      subroutine acoef(ispin, amat)
c     performs the sum of the product of 4 3j symbols
c       ispin - type of spin calculation
c       amat  - matrix to calculate density via
c             \mu=\mu_at*(1- Im \sum_kp,kpp rkk(kp)*rkk(kpp)*
c                         \sum_m1,m2 bmat(kp,kpp,m1,m2)*G_lp,m2;lpp,m1 )

      implicit double precision (a-h,o-z)
      include '../HEADERS/dim.h'
      integer ispin

      real  amat(-lx:lx,2,2, 3,0:lx)
      real t3j(0:lx,0:lx,0:1), operls (0:1, 0:1, 3)
      real xms, xml, xmj

      external cwig3j

      do 10 i5 =  0,lx
      do 10 i4 =  1,3 
      do 10 i3 =  1,2
      do 10 i2 =  1,2
      do 10 i1 = -lx,lx
         amat(i1,i2,i3,i4,i5)=0
  10  continue
      ms = 1
      if (ispin.lt.0) ms=0
      print*, ' Spin = ', 2*ms-1

      do 100 ml = -lx, lx
        mj = 2*ml + (2*ms-1)
        xmj = 0.5e0*mj
        mj = -mj
c       mj is conserved for all operators of interst (s_z, l_z, t_z)
c       tabulate necessary Clebsh-Gordon coefficients
        do 20 lp = 0,lx
        do 20 jp = 0,lx
        do 20 mp = 0,1
           lp2 = 2*lp
           jp2 = 2*jp+1
           mp2 = 2*mp-1
           t3j(lp,jp,mp) = (-1)**lp *sqrt(jp2+1.e0) * 
     1                    real( cwig3j ( 1, jp2, lp2, mp2, mj, 2) )
 20     continue

        do 90 lpp = 0,lx
          do 30 m1=0,1
          do 30 m2=0,1
          do 30 iop=1,3
            operls(m1,m2,iop) = 0
            if (m1.eq.m2) then
              xms =  m1 - 0.5e0
              xml = xmj-xms
              if (abs(ml+ms-m1).le.lpp) then
                if (ispin.eq.0) then
c                 occupation numbers N_l, N_j- , N_j+
                  operls(m1,m2,iop) = 2
                elseif (iop.eq.1) then
c                 s_z operator in ls basis
                  operls(m1,m2,iop) = xms
                elseif (iop.eq.2 .and. abs(ispin).eq.1) then
c                 l_z operator
                  operls(m1,m2,iop) = xml
                elseif (iop.eq.2 .and. abs(ispin).eq.2) then
c                 unit operator for occupation numbers
                  operls(m1,m2,iop) = 1
                elseif (iop.eq.3 .and. abs(ispin).eq.1) then
c                 t_z operator
                  operls(m1,m2,iop) = xms*2*(3*xml**2-lpp*(lpp+1))
     1                                /(2*lpp+3) /(2*lpp-1)
                elseif (iop.eq.3 .and. abs(ispin).eq.2) then
c                 occupation number for j=l+1/2
                  operls(m1,m2,iop) = t3j(lpp,lpp,m1)**2
                endif
              endif
            else
c             t_z only has nonzero off diagonal matrix elements 
              if (iop.eq.3 .and. abs(ispin).le.1 .and.
     1        nint( 0.5e0+abs(xmj)).lt.lpp)  then
                 operls(m1,m2,iop)=3*xmj*
     1           sqrt(lpp*(lpp+1)-(xmj**2-0.25e0)) /(2*lpp+3) /(2*lpp-1)
              elseif (iop.eq.3 .and. abs(ispin).gt.1) then
                 operls(m1,m2,iop)= t3j(lpp,lpp,m1)* t3j(lpp,lpp,m2)
              endif
            endif
  30      continue

c         calculate energy and r independent matrix amat
c         which is equivalent to integration over angular coordinates
c         for assumed density matrix
          do 80 i1=1,2
             call kfromi(i1,lpp,jj,k1)
             if (k1.eq.0) goto 80
             do 70 i2=1,2
                call kfromi(i2,lpp,jp,k2)
                if (k2.eq.0) goto 70
                do 60 iop=1,3
                do 60 m2=0,1
                do 60 m1=0,1
                  amat(ml,i1,i2,iop,lpp) =  amat(ml,i1,i2,iop,lpp) +
     1            operls(m1,m2,iop) * t3j(lpp,jp,ms)* t3j(lpp,jp,m1)*
     2            t3j(lpp,jj,m2)*t3j(lpp,jj,ms)
  60            continue
  70         continue
  80      continue
  90    continue
 100  continue

      return
      end

      subroutine kfromi (i, lpp, jj, k)
c     input index i1 and orb. mom. lpp
c     output: final state kappa - k; jj=tot.mom(k)-1/2
      integer i, lpp, jj, k

      jj = lpp + i - 2
      k = - lpp - 1
      if (i.eq.1) k = lpp

      return
      end

c SUBROUTINE SUMAX (RN, ANN, AA2, AASUM)
c This is a version of the subroutine sumax found on page 110 of
c Louck's book.  It performs eq 3.22, using simpson's rule and
c taking advantage of the logarithmic grid so that sum f(r)*dr becomes
c sum over f(r)*r*(0.05).  Linear interpolation is used at the end
c caps.  This version does not sum over 14 shells of identical
c atoms, instead it averages the contribution of one or more atoms
c of type 2 at the location of atom 1.  Louck's description (except
c for his integration algorithm) is very clear.
c
c input:  
c         rn        distance from atom 1 to atom 2 in au
c         ann       number of type 2 atoms to add to atom 1, can
c                   be fractional
c         aa2(i)    potential or density at atom 2
c output: aasum(i)  spherically summed contribution added into this
c                   array so that sumax can be called repeatedly
c                   and the overlapped values summed into aasum
c
c Note that this routine requires that all position data be on a
c grid  rr(j) = exp (-8.8d0 + (j-1)*0.05d0), which is the grid
c used by Louck, and also used by ATOM if nuclear options not used.
c
c Coded by Steven Zabinsky, December 1989
c Modified for FEFF cluster code, August 1990, siz
c Bug fixed, May 1991, SIZ
c Another bug fixed, Mar 1992, SIZ
c
c T.L.Louck, "Augmented Plane Wave Method", W.A.Benjamin, Inc., 1967

      subroutine sumax (rn, ann, aa2, aasum)
      implicit double precision (a-h, o-z)
      parameter (nptx=250)
      dimension aa2(nptx), aasum(nptx)
      dimension stor(nptx)
c#mn
       external ii, xx

c     jjchi     index beyond which aa2 is zero
c     jtop      index just below distance to neighbor
c               aasum is calculated only up to index jtop

c     Wigner-Seitz radius is set to 15 in ATOM.
      rws = 15
      jjchi = ii(rws)
      jtop  = ii(rn)
      xbl = 0

      topx = xx(jjchi)

      do 120  i = 1, jtop
         x = xx(i)
         xint = 0.0d0
         et = exp(x)
         blx = log(rn-et)
         if (blx .ge. topx)  goto 119
         jbl = int(2.0d0+20.0d0*(blx+8.8d0))
         if (jbl .lt. 1)  jbl=1
         if (jbl .ge. 2)  then
c           use linear interp to make end cap near center of neighbor
            xjbl = jbl
            xbl = 0.05d0 * (xjbl-1.0d0) - 8.8d0
            g = xbl-blx
            xint= xint+0.5d0*g*(aa2(jbl)*(2.0d0-20.0d0*g)*exp(2.0d0*xbl)
     1             +20.0d0*g*aa2(jbl-1)*exp(2.0d0*(xbl-0.05d0)))
         endif
         tlx = log(rn+et)
         if (tlx .ge. topx)  then
            jtl = jjchi
            go to 90
         endif
         jtl = int(1.0d0 + 20.0d0*(tlx+8.8d0))
         if (jtl .lt. jbl)  then
c           handle peculiar special case at center of atom 1
            fzn = aa2(jtl)*exp(2.0d0*(xbl-0.05d0))
            fz3 = aa2(jbl)*exp(2.0d0*xbl)
            fz2 = fzn+20.0d0*(fz3-fzn)*(tlx-xbl+0.05d0)
            fz1 = fzn+20.0d0*(fz3-fzn)*(blx-xbl+0.05d0)
            xint = 0.5d0*(fz1+fz2)*(tlx-blx)
            go to 119
         endif
         xjtl = jtl
         xtl = 0.05d0*(xjtl-1.0d0)-8.8d0
         c = tlx-xtl
         xint = xint+0.5d0*c*(aa2(jtl)*(2.0d0-20.0d0*c)
     1         *exp(2.0d0*xtl)+aa2(jtl+1)*20.0d0*c
     2         *exp(2.0d0*(xtl+0.05d0)))

   90    if (jtl .gt. jbl)  then
  100       xint = xint+0.5d0*(aa2(jbl)*exp(2.0d0*xbl)+aa2(jbl+1)
     1             *exp(2.0d0*(xbl+0.05d0)))*0.05d0
            jbl = jbl+1
            if (jbl .lt. jtl) then
               xbl = xbl+0.05d0
               go to 100
            endif
         endif
  119    stor(i) = 0.5d0*xint*ann/(rn*et)
  120 continue

      do 190  i = 1, jtop
         aasum(i) = aasum(i) + stor(i)
  190 continue

      return
      end

      double precision function dist (r0, r1)
c     find distance between cartesian points r0 and r1
      implicit double precision (a-h, o-z)
      dimension r0(3), r1(3)
      dist = 0
      do 10  i = 1, 3
         dist = dist + (r0(i) - r1(i))**2
   10 continue
      dist = sqrt (dist)
      return
      end

      SUBROUTINE RdGrid(em,ne,nGrid,iGridType,GridMin,GridMax,GridStep,
     &     nGridMax,nex)
!     Read data from grid.inp.
!     file should have lines with the following format:
!     
!     Grid_Type    GridMin    GridMax    GridStep
!     
!     Grid_Type can be any of the following (case insensitive):
!     egrid    - (regular in energy)
!     kgrid    - (regular in k)
!     expgrid  - (exponential in energy)
!     usergrid - (read a grid from the file)
!
!     Energy, and k are given relative to the edge.
!     For egrid and expgrid, GridMin, GridMax, and GridStep are
!     given in (eV).
!     For kgrid, units are inverse angstroms.
!     usergrid is a special case and is followed by one energy
!     point per line, i.e.
!            usergrid
!            -1.01
!            -0.55
!            10.01
!              .!              .
!              .
!
!     More than one grid may be specified, and grids can
!     overlap, for example:
!
!     egrid -10 10 0.1
!     kgrid  0  15 0.5
!
!     will make overlapping grids going from E = -10 eV to
!     k = 15 Angstrom**(-1). Up to 10 different grids can be
!     defined.
!     If the 'last' keyword is used in the GridMin field, i.e.
!        expgrid  last  100
!     the specified grid will start where the last grid ended.
!     This is usefull when defining non-overlapping k/e grids.
!     Comments lines have #,!,c, or * at the beginning.
      include '../HEADERS/const.h'
!     Input:
!     nGridMax - max number of grids that can be defined.
!     nex      - max number of energy points
      INTEGER nGridMax, nex

!     Output:
!     nGrid     - number of grids defined in file
!     iGridType - Type of grid. (0 = user, 1 = energy, 2 = k, 3 = exponential)
!     GridMin   - Minimum value of grid.
!     GridMax   - Maximum value of grid.
!     GridStep  - Step size.
!     ne        - number of energy points
!     em(nex)        - energy grid
      INTEGER nGrid, iGridType(nGridMax), ne
      DOUBLE PRECISION GridMin(nGridMax), GridMax(nGridMax),
     &     GridStep(nGridMax)
      COMPLEX*16 em(nex)

!     Local Variables:
!     ios      - i/o error flag
!     iUGrid   - unit number for grid.inp
!     RealE    - real part of energy
!     ImagE    - imaginary part of energy
!     nWords   - number of words in the line
!     Words(4) - array of words
!     line     - string to hold line
!     ieMin    - index of minimum of user defined grid
!     ieMax    - index of max of user defined frid
      INTEGER ios, iUGrid, nWords
c      INTEGER ieMin, ieMax
      DOUBLE PRECISION RealE, ImagE
      CHARACTER(20) Words(10)
      CHARACTER(100) line

!     Loop Variables:
      INTEGER i1, i2

!     Externals
      LOGICAL isnum
      EXTERNAL isnum

      iUGrid = 22
      OPEN(unit=iUGrid,file='grid.inp',status='old',iostat=ios)
      CALL CHOPEN(ios, 'grid.inp', 'xsph')
      
      DO nGrid = 1, nGridMax
!        Read comment lines
         CALL rdcmt(iUGrid,'#!*C')
!        Read data line into string variable "line" and change to
!        lowercase.
         READ(iUGrid,'(A)',END=5) line
c         CALL lower(line)
!        bwords breaks line into words which are then passed
!        back in Words array
         nWords = 4
         CALL untab(line)
         CALL bwords(line,nWords,Words)

!        Set iGridType
         IF(Words(1).eq.'usergrid') THEN
            iGridType(nGrid) = 0
         ELSEIF(Words(1).eq.'egrid') THEN
            iGridType(nGrid) = 1
c            IF(nwords.ne.4) CALL GridError('Error in grid.inp', line)
         ELSEIF(Words(1).eq.'kgrid') THEN
            iGridType(nGrid) = 2
         ELSEIF(Words(1).eq.'expgrid') THEN
            iGridType(nGrid) = 3
         END IF
         
         IF(iGridType(nGrid).ne.0) THEN
            IF(Words(2).eq.'last') THEN
               ! Set the grid minimum to the max of the last grid.
               IF(nGrid.gt.1) THEN
                  CALL SetGridMin(GridMin,GridMax,GridStep,iGridType,
     &                 nGrid)
               ELSE
                  GridMin(1) = 0.d0
               END IF
            ELSE
               READ(Words(2),*) GridMin(nGrid)
            END IF
            READ(Words(3),*) GridMax(nGrid)
            READ(Words(4),*) GridStep(nGrid)
         END IF

         IF(iGridType(nGrid).eq.0) THEN
!        User defined points: read from file.
            DO i2 = 1, nex
               ! Read comments
               CALL rdcmt(iUGrid,'#!*C')
               ! Read line
               READ(iUGrid,'(A)',END=5) line
               nwords = 2
               ! break line into words
               CALL untab(line)
               CALL bwords(line,nWords,Words)
               ! if first word is number, Real(em) = num
               IF(isnum(Words(1))) THEN
                  READ(Words(1),*) RealE
                  ! if second word exists and is a num, Im(em) = num
                  IF((nWords.ge.2).and.isnum(Words(2)))
     &                 READ(Words(2),*) ImagE                  
                  em(i2) = (RealE + coni*ImagE)
                  ne = ne + 1
               ! If first word is not a number, exit loop and read line again.   
               ELSE
                  ! Set GridMax and GridMin for reference
                  GridMin(nGrid) = DBLE(em(ne - i2 + 1))
                  GridMax(nGrid) = DBLE(em(ne))

                  BACKSPACE(iUGrid)
                  EXIT
               END IF
            END DO
         END IF
      END DO
 5    CONTINUE
      nGrid = nGrid - 1

      DO i1 = 1, nGrid
         IF(iGridType(i1).eq.2) THEN
!     k-Grid. Set units to bohr**(-1)
            GridMin(i1) = GridMin(i1)*bohr
            GridMax(i1) = GridMax(i1)*bohr
            GridStep(i1) = GridStep(i1)*bohr
         ELSE
!     e-grid. Set units to hartrees
            GridMin(i1) = GridMin(i1)/hart
            GridMax(i1) = GridMax(i1)/hart
            GridStep(i1) = GridStep(i1)/hart
         END IF
      END DO
      DO i1 = 1, ne
         em(i1) = em(i1)/hart
      END DO

      CLOSE(iUGrid)
      RETURN
      END

      SUBROUTINE SetGridMin(GridMin, GridMax, GridStep, iGridType,
     &     nGrid)
!     This sets the minimum of the current grid to the maximum of the last grid + GridStep
      include '../HEADERS/const.h'
!     Input:
!     GridMin   - array that holds grid minima
!     GridMax   - array that holds grid maxima
!     GridStep  - array of steps
!     iGridType - array of grid types
!     nGrid     - current grid
      INTEGER nGrid
      INTEGER iGridType(nGrid)
      DOUBLE PRECISION GridMin(nGrid), GridMax(nGrid), GridStep(nGrid)

!     Output: GridMin(nGrid) (minimum of current grid.

      IF((iGridType(nGrid).ne.2).and.(iGridType(nGrid-1).ne.2).or.
     &    (iGridType(nGrid).eq.iGridType(nGrid-1))) THEN
!     If neither grid is a k grid, or if both are k-grid, just set the minimum to the previous
!     maximum.
         GridMin(nGrid) = GridMax(nGrid-1) + GridStep(nGrid)
      ELSEIF(iGridType(nGrid).eq.2) THEN
!     If current grid is k, kmin = sqrt(2*emax)
         GridMin(nGrid) =
     &        SQRT(2*GridMax(nGrid-1)/hart)/bohr + GridStep(nGrid)
      ELSE
!     If current grid is e, emin = k**2/2
         GridMin(nGrid) =
     &        (GridMax(nGrid-1)*bohr)**2/2*hart + GridStep(nGrid)
      END IF

      RETURN
      END

      SUBROUTINE GridError(message, line)
      CHARACTER(300) message, line
      
      CALL wlog(message)
      CALL wlog(line)
      STOP

      RETURN
      END

      subroutine rhlbp (rs, xk, erl, eim)
c     This is a new broadened plasmon hl subroutine, 
c     using interpolation for the real and imaginary part.
c     test of multi-pole pole model
c     input:  
c        rs - r_s 
c        xk - k in a.u.
c     output: 
c        erl, eim - Re and Im part of self energy normalized to k_f**2/2

      implicit double precision (a-h,o-z)    
      include '../HEADERS/const.h'
      parameter (nrs=21, nx=51 )
      dimension rsmesh(nrs), xmesh(nx), sigma(nrs,nx,2)
      save ifirst, rsmesh, xmesh, sigma
      data  ifirst /0/

      xf = fa / rs
      ef = xf *xf / 2.  
      wp = sqrt (3 / rs**3) / ef
      xk0 = xk / xf
      xx = (xk0 ** 2  - 1) / sqrt(rs)

      if (ifirst .eq. 0) then
c        read self energy for grid points from bphl.dat
         open (unit=2, file='bphl.dat', status='old', iostat=ios)
         call chopen (ios, 'bphl.dat', 'rhlbp')
         xmesh(1) = 0.0
         do 200 irs = 1, nrs
            sigma (irs, 1, 1) = 0.0
            sigma (irs, 1, 2) = 0.0
c           irs correspond to grid in r_s: rs = 10.0**(0.1 * irs)
            do  100 ik = 2, nx
c              xmesh define grid in k-space as follows:
c              xmesh = ((ik-1) / 20.0) * (1.0 + ((ik-1) / 20.0)**4.0)
c              xmesh = (xk**2 - 1) / sqrt (rs)
c              xk = sqrt (xmesh * sqrt(rs) + 1.0)
c              xk = k / k_f
               read(2, *) rsmesh(irs), xmesh(ik), 
     1              sigma(irs, ik, 1), sigma(irs, ik, 2)
 100        continue
 200     continue
         ifirst = 1
         close (unit=2)
      endif

c     delev = xdel * ef * hart * rs
      call terp2d (rsmesh, xmesh, sigma(1, 1, 1), nrs, nx, rs, xx, erl)
      call terp2d (rsmesh, xmesh, sigma(1, 1, 2), nrs, nx, rs, xx, eim)
c     transfer to atomic units
      erl = erl / rs / hart
      eim = eim / rs / hart

      call quinn (xk0, rs, wp, ef, ei)
      if (eim .ge. ei)  eim = ei

      return
      end

      subroutine terp2d (x, y, z, nx, ny, x0, y0, z0)
c     Linear interpolation and extrapolation.
c     2d analog of terp.f
      implicit double precision (a-h, o-z)

      dimension x(nx), y(ny), z(nx,ny)

c     Find out between which x points x0 lies
      ix = locat (x0, nx, x)
c     if i < 1, set i=1, if i > n-1, set i=n-1
      ix = max (ix, 1)
      ix = min (ix, nx-1)
      if (x(ix+1) - x(ix) .eq. 0)  call par_stop('TERP-1')
c     Find out between which y points y0 lies
      iy = locat (y0, ny, y)
c     if i < 1, set i=1, if i > n-1, set i=n-1
      iy = max (iy, 1)
      iy = min (iy, ny-1)
      if (y(iy+1) - y(iy) .eq. 0)  call par_stop('TERP-1')

      dx = (x0 - x(ix)) / (x(ix+1) - x(ix))
      dy = (y0 - y(iy)) / (y(iy+1) - y(iy))
      z1 = z(ix,iy) +  dx * (z(ix+1,iy) - z(ix,iy))
      z2 = z(ix,iy) +  dx * (z(ix+1,iy) - z(ix,iy))
      z0 = z1 + dy * (z2 - z1)

      return
      end

      subroutine chopen (ios, fname, mod)
c     Writes error msg and stops if error in ios flag from open
c     statement.  fname is filename, mod is module with failed open.
      character*(*) fname, mod, s*512
       integer il, istrln
c     open successful
      if (ios .le. 0)  return

c     error opening file, tell user and die.
       il = istrln(fname)
       write(s,100) fname(1:il), mod
 100   format ('cannot open file "',
     $      a, '" in module ', a)
       call fstop(s)
       end

      complex*16 function dsordc(j,a,dg,dp,ag,ap)
c              * calculation of overlap integrals*
c        integration by simpson method of the   hg*(r**0)
c        hg(l)=dg(l)*cg(l,j)+dp(l)*cp(l,j)
c                cg,cp(l,j)  orbital j
c        a is such that dg,dp or hg following the case
c        behave at the origin as cte*r**a
c        the development limits at the origin (used for calculation
c        of integral form 0 to dr(1) ) of functions dg,dp and hg are
c        supposed to be in blocks ag,ap and chg respectively
c        this program uses   aprdec
c
      implicit double precision (a-h,o-z)
      include '../HEADERS/dim.h'
      complex*16 aprdec
      common/dff/ cg(nrptx,30), cp(nrptx,30), bg(10,30), bp(10,30),
     1              fl(30), fix(30), ibgp
      complex*16 dg(nrptx),ag(10),dp(nrptx),ap(10)
      complex*16 hg(nrptx),chg(10)
c     common/ratom1/xnel(30),en(30),scc(30),scw(30),sce(30),
c    1   nq(30),kap(30),nmax(30)
      common/tabtec/hx,dr(nrptx),test1,test2,ndor,np,nes,method,idim
      dimension bgj(10),bpj(10)

c        construction of the array hg
      do  15 l= 1,ibgp
        bgj(l) = bg(l,j)
 15     bpj(l) = bp(l,j)

      do 221 l=1,idim
 221  hg(l)=dg(l)*cg(l,j)+dp(l)*cp(l,j)
      b=a+fl(j)
      do 241 l=1,ndor
 241     chg(l) = aprdec(ag,bgj,l) + aprdec(ap,bpj,l)
 
c        integration of the hg
      dsordc = (0.0d0, 0.0d0)
      do 305 l=1,idim
 305     hg(l)=hg(l)*dr(l)
      do 311 l=2,idim,2
 311     dsordc=dsordc+hg(l)+hg(l)+hg(l+1)
      dsordc=hx*(dsordc+dsordc+hg(1)-hg(idim))/3.0d0
c        integral from 0 to dr(1)
      do 331 l=1,ndor
         b=b+1.0d 00
 331     dsordc=dsordc+chg(l)*(dr(1)**b)/b
      return
      end

      double precision function dalp (d1,d2,d3,d4)
      implicit double precision (a-h,o-z)
      save
c
c procedure of pratt to accelerate the convergence
c d1=initial (n-1);   d2=final (n-1);   d3=initial (n);   d4=final (n);
c **********************************************************************
      if ((d1+d4).eq.(d2+d3)) go to 10
      d=(d4-d2)/((d1+d4)-(d2+d3))
      if (d.lt.0.0) go to 20
      if (d.lt.0.5) go to 30
   10 d=0.5
      go to 30
   20 d=0.0
   30 dalp=d
      return
      end

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Information about last revision of $RCSfile: m_mtdp.f90,v $:
! $Revision: 1.3 $
! $Author: hebhop $
! $Date: 2010/02/23 23:52:06 $
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
module Mtdp

  ! Muffin-Tin density and potential

  use m_Kinds

  type :: Mtdp_Data_Type
     integer(kind=i08)                            :: nR
     integer(kind=i08)                            :: nAt
     integer(kind=i08), dimension(:), allocatable :: At_AN
     real(kind=r08), dimension(:,:), allocatable  :: At_XYZ
     real(kind=r08), dimension(:), allocatable    :: At_R
     integer(kind=i08), dimension(:), allocatable :: At_iR
     real(kind=r08), dimension(:,:), allocatable  :: At_Den
     real(kind=r08), dimension(:,:), allocatable  :: At_Pot
     integer(kind=i08)                            :: nESph
     real(kind=r08), dimension(:,:), allocatable  :: ESph_XYZ
     real(kind=r08), dimension(:), allocatable    :: ESph_R
     integer(kind=i08), dimension(:), allocatable :: ESph_iR
     real(kind=r08), dimension(:,:), allocatable  :: ESph_Den
     real(kind=r08), dimension(:,:), allocatable  :: ESph_Pot
     real(kind=r08)                               :: V_Int
     real(kind=r08)                               :: V_HOMO
     real(kind=r08)                               :: V_LUMO
  end type Mtdp_Data_Type

  private
  public :: Mtdp_Data_Type
  public :: Write_Mtdp
  public :: Read_Mtdp

contains

  subroutine Write_Mtdp(Mtdp_Data)

    implicit none

    type(Mtdp_Data_Type), intent(in) :: Mtdp_Data

    ! Number of points in the radial grid
    write(6,fmt='(i12)') Mtdp_Data%nR

    ! Number of atoms
    write(6,fmt='(i12)') Mtdp_Data%nAt

    ! Atomic numbers
    write(6,fmt='(i12)') Mtdp_Data%At_AN

    ! Atomic coordinates
    write(6,fmt='(1p,e20.10)') Mtdp_Data%At_XYZ

    ! Muffin-Tin Radii
    write(6,fmt='(1p,e20.10)') Mtdp_Data%At_R

    ! Index of the radii on the radial grid
    write(6,fmt='(i12)') Mtdp_Data%At_iR

    ! Electron density inside each Muffin-Tin
    write(6,fmt='(1p,e20.10)') Mtdp_Data%At_Den

    ! Potential (H+XC) inside each Muffin-Tin
    write(6,fmt='(1p,e20.10)') Mtdp_Data%At_Pot

    ! Number of empty spheres
    write(6,fmt='(i12)') Mtdp_Data%nESph

    ! Coordinates of the empty sphere's centers
    write(6,fmt='(1p,e20.10)') Mtdp_Data%ESph_XYZ

    ! Empty sphere's radii
    write(6,fmt='(1p,e20.10)') Mtdp_Data%ESph_R

    ! Index of the empty sphere's radii on the radial grid
    write(6,fmt='(i12)') Mtdp_Data%ESph_iR

    ! Electron density inside each empty sphere
    write(6,fmt='(1p,e20.10)') Mtdp_Data%ESph_Den

    ! Potential (H+XC) inside each empty sphere
    write(6,fmt='(1p,e20.10)') Mtdp_Data%ESph_Pot

    ! Interstitial potential
    write(6,fmt='(1p,e20.10)') Mtdp_Data%V_Int

    ! HOMO energy
    write(6,fmt='(1p,e20.10)') Mtdp_Data%V_HOMO

    ! LUMO energy
    write(6,fmt='(1p,e20.10)') Mtdp_Data%V_LUMO

  end subroutine Write_Mtdp

  subroutine Read_Mtdp(iunit,Mtdp_Data)

    implicit none

    integer, intent(in) :: iunit
    type(Mtdp_Data_Type), intent(out) :: Mtdp_Data

    ! Number of points in the radial grid
    read(iunit,*) Mtdp_Data%nR

    ! Number of atoms
    read(iunit,*) Mtdp_Data%nAt

    ! Atomic numbers
    allocate(Mtdp_Data%At_AN(Mtdp_Data%nAt))
    read(iunit,*) Mtdp_Data%At_AN

    ! Atomic coordinates
    allocate(Mtdp_Data%At_XYZ(3,Mtdp_Data%nAt))
    read(iunit,*) Mtdp_Data%At_XYZ

    ! Muffin-Tin Radii
    allocate(Mtdp_Data%At_R(Mtdp_Data%nAt))
    read(iunit,*) Mtdp_Data%At_R

    ! Index of the radii on the radial grid
    allocate(Mtdp_Data%At_iR(Mtdp_Data%nAt))
    read(iunit,*) Mtdp_Data%At_iR

    ! Electron density inside each Muffin-Tin
    allocate(Mtdp_Data%At_Den(Mtdp_Data%nR,Mtdp_Data%nAt))
    read(iunit,*) Mtdp_Data%At_Den

    ! Potential (H+XC) inside each Muffin-Tin
    allocate(Mtdp_Data%At_Pot(Mtdp_Data%nR,Mtdp_Data%nAt))
    read(iunit,*) Mtdp_Data%At_Pot

    ! Number of empty spheres
    read(iunit,*) Mtdp_Data%nESph

    ! Coordinates of the empty sphere's centers
    allocate(Mtdp_Data%ESph_XYZ(3,Mtdp_Data%nESph))
    read(iunit,*) Mtdp_Data%ESph_XYZ

    ! Empty sphere's radii
    allocate(Mtdp_Data%ESph_R(Mtdp_Data%nESph))
    read(iunit,*) Mtdp_Data%ESph_R

    ! Index of the empty sphere's radii on the radial grid
    allocate(Mtdp_Data%ESph_iR(Mtdp_Data%nESph))
    read(iunit,*) Mtdp_Data%ESph_iR

    ! Electron density inside each empty sphere
    allocate(Mtdp_Data%ESph_Den(Mtdp_Data%nR,Mtdp_Data%nESph))
    read(iunit,*) Mtdp_Data%ESph_Den

    ! Potential (H+XC) inside each empty sphere
    allocate(Mtdp_Data%ESph_Pot(Mtdp_Data%nR,Mtdp_Data%nESph))
    read(iunit,*) Mtdp_Data%ESph_Pot

    ! Interstitial potential
    read(iunit,*) Mtdp_Data%V_Int

    ! HOMO energy
    read(iunit,*) Mtdp_Data%V_HOMO

    ! LUMO energy
    read(iunit,*) Mtdp_Data%V_LUMO

  end subroutine Read_Mtdp

end module Mtdp

      program loss

      include '../HEADERS/const.h'
      include '../HEADERS/dim.h'
      include '../HEADERS/parallel.h'

      integer epsmax
      parameter(epsmax = 700)
      
c      integer iz(0:nphx)
      integer npoles
      double precision rnrm(0:nphx), eps0, gamma
      logical write_loss, write_opcons, write_exc, verbose

      double precision wpcorr(MxPole), delta(MxPole), ampfac(MxPole)

      character*80 title(nheadx)
      integer ntitle, nat, nph, iphat(natx), ipol, ispin, ihole
      integer lfms1, nmix, icoul, ixc, ixc0, iafolp, iunf, inters
      integer jumprm, nohole, iplsmn
      integer iz(0:nphx), lmaxsc(0:nphx), lmaxph(0:nphx)
      double precision evec(3), xivec(3), spvec(3), spinph(0:nphx)
      complex*16 ptz(-1:1, -1:1)
      double precision rat(3,natx)
      double precision xnatph(0:nphx), folp(0:nphx), xion(0:nphx)
      character*6 potlbl(0:nphx)
      real rfms1
      double precision elpty, angks, gamach, ca1, ecv
      double precision vr0, vi0, rgrd, totvol


      
      write_loss   = .true.
      write_opcons = .false.
      write_exc    = .false.
      verbose      = .true.
      npoles       = 100
      eps0         = -1.d0



      call inipotph(
c     TITLE
     1       ntitle, title,
c     ATOMS
     2       nat, rat, iphat,
c     POTENTIALS
     3       nph, iz, potlbl, lmaxsc, lmaxph, xnatph, spinph,
c     HOLE/EDGE
     4       ihole,
c     SCF
     5       rfms1, lfms1, nscmt, ca1, nmix, ecv, icoul,
c     POLARIZATION, ELLIPTICITY
     6       ipol, evec, elpty, xivec,
c     SPIN
     7       ispin, spvec, angks,
c     computed
     8       ptz, gamach,
c     EXCHANGE
     9       ixc, vr0, vi0, ixc0,
c     AFOLP, FOLP, ION, RGRID, UNFREEZEF
     _       iafolp, folp, xion, rgrd, iunf,
c     INTERSTITIAL, JUMPRM, NOHOLE
     1       inters, totvol, jumprm, nohole, iplsmn)


c*****************************************************************************
c     read the contents of a json file that includes all of global.json,
c     atoms.json, pot.json & xpsh.json (i.e. global.dat, atoms.dat, mod1.inp,
c     and mod2.inp)
c*****************************************************************************
      call json_read_libpotph(
c     TITLE
     1       ntitle, title,
c     ATOMS
     2       nat, rat, iphat,
c     POTENTIALS
     3       nph, iz, potlbl, lmaxsc, lmaxph, xnatph, spinph,
c     HOLE/EDGE
     4       ihole,
c     SCF
     5       rfms1, lfms1, nscmt, ca1, nmix, ecv, icoul,
c     POLARIZATION, ELLIPTICITY
     6       ipol, evec, elpty, xivec,
c     SPIN
     7       ispin, spvec, angks,
c     computed
     8       ptz, gamach,
c     EXCHANGE
     9       ixc, vr0, vi0, ixc0,
c     AFOLP, FOLP, ION, RGRID, UNFREEZEF
     _       iafolp, folp, xion, rgrd, iunf,
c     INTERSTITIAL, JUMPRM, NOHOLE
     1       inters, totvol, jumprm, nohole, iplsmn)

      rnrm(0) = 2.8384890981392523
      rnrm(1) = 2.6294479894989911

      call feffloss(nph, iz, xnatph, rnrm, npoles, eps0,
     1       write_opcons, write_loss, write_exc, verbose,
     2       wpcorr, gamma, ampfac, delta)
      

      end

      subroutine mmtr( bmati, ipol, ispin, le2, angks, ptz, lind, dri,
     &       eta, nsc, nleg, kinit, ilinit)
c     calculates the part of matrix M which does not depend on energy
c     point.( see Rehr and Albers paper)
c     for path expansion always neglect spin-flip processes
c     to simplify calculations; (bmati does not have spin indices)

      implicit double precision (a-h, o-z)

c     Inputs:
c        kinit: quantum number kappa for initial orbital
c        rotation matrix for ilegp
c        path data, eta(ilegp) and ipot(ilegp)
c        mtot,l0
c        polarization data : ipol, ispin, ptz
c     Output:  bmati(...) 

      include '../HEADERS/const.h'
      include '../HEADERS/dim.h'
c     include 'rotmat.h'
      dimension dri(ltot+1,2*mtot+1,2*mtot+1,legtot+1)
c     include 'pdata.h'
      double precision eta(0:legtot+1)
      integer nsc, nleg
      integer kinit, ilinit

      complex*16 ptz
      dimension ptz(-1:1, -1:1)

      complex*16 bmati, bmat
      dimension bmati(-mtot:mtot, 1:8, -mtot:mtot, 1:8)
      dimension bmat(-lx:lx,0:1,8, -lx:lx,0:1,8)
      dimension kind(8), lind(8)
      logical ltrace

      do 10 i = 1,8
      do 10 k = -mtot,mtot
      do 10 j = 1,8
      do 10 l = -mtot,mtot
         bmati(l,j,k,i)=0.0d0
  10  continue

      ltrace = .false.
      call bcoef (kinit, ipol, ptz, le2, ltrace, ispin, angks,
     1            kind, lind, bmat)
      is = 0
      if (ispin.eq.1) is = nspx - 1

c     ilinit = initial orb. momentum + 1. 
      lxx = min(mtot,ilinit)

c     set indices for bmati (no indentation)
      do 60 mu1 = -lxx,lxx
      mu1d = mu1+mtot+1
      do 50 mu2 = -lxx,lxx
      mu2d = mu2+mtot+1
      if (ipol.ne.0) then
        do 40 k1 = 1,8
        do 40 k2=  1,8
          l1 = lind(k1) + 1
          l2 = lind(k2) + 1
          do 35 m1 = -lind(k1), lind(k1)
          do 35 m2 = -lind(k2), lind(k2)
            m1d = m1 + mtot+1
            m2d = m2 + mtot+1
            bmati(mu1,k1, mu2,k2) =bmati(mu1,k1, mu2,k2) +
     1      bmat(m1,is,k1,m2,is,k2)*exp(-coni*(eta(nsc+2)*m2+eta(0)*m1))
     1        * dri(l1,mu1d,m1d,nsc+2) * dri(l2,m2d,mu2d,nleg)
c           dri(nsc+2)  is angle between z and leg1
c           dri(nsc+1)  is angle between last leg and z
c           eta(0)      is gamma between eps and rho1,
c           eta(nsc+2)  is alpha between last leg and eps
   35     continue
   40   continue
      else
c       ipol=0 and bmat is diagonal in k1,k2 and LS L'S'
c       and 2 rotation matrices can be combined to 1
        do 140 k1 = 1,8
          l1 = lind(k1) + 1
          if (l1.gt.0) then
            m1 = 0
            m1d = m1 + mtot+1
            bmati(mu1,k1, mu2,k1) =bmati(mu1,k1, mu2,k1) +
     1        bmat(m1,is,k1,m1,is,k1) * dri( l1, mu1d, mu2d, nsc+1)
c           dri(nsc+1)  is angle between last leg and first leg
          endif
  140   continue
      endif
   50 continue
   60 continue

      return
      end

!=======================================================================
!     SFCONV
!=======================================================================

module sfconv_inp
  use global_inp, only : ispec
  use ff2x_inp, only : ipr6
  implicit none
  character(*),parameter,private :: filename='sfconv.inp'
  integer  msfconv, ipse, ipsk
  double precision wsigk, cen
  character(12) cfname

contains

  subroutine sfconv_write
    !c    sfconv.inp - Josh Kas
    open (file=filename, unit=3, status='unknown')
    write(3,10) 'msfconv, ipse, ipsk'
    write(3,20)  msfconv, ipse, ipsk
    write(3,10) 'wsigk, cen'
    write(3,30) wsigk, cen
    write(3,10) 'ispec, ipr6'
    write(3,20)  ispec, ipr6
    write(3,10) 'cfname'
    write(3,10) cfname
    close(3)
    ! standard formats for string, integers and real numbers
10  format(a)
20  format (20i4)
30  format (9f13.5)
  end subroutine sfconv_write

  subroutine sfconv_read
    open (file=filename, unit=3, status='old')
    read (3,*) ; read (3,*)  msfconv, ipse, ipsk
    read (3,*) ; read (3,*)  wsigk, cen
    read (3,*) ; read (3,*)  ispec, ipr6
    read (3,*) ; read (3,*)  cfname
    close(3)
  end subroutine sfconv_read

  subroutine sfconv_init
    msfconv = 0 ! Josh Kas
    ipse = 0
    ipsk = 0
    wsigk = 0.d0 ! Josh Kas
    cen = 0.d0 ! Josh Kas
    cfname = 'NULL'
  end subroutine sfconv_init

end module sfconv_inp

      subroutine json_read_fpf0(nosc, oscstr, enosc)

      use json_module
      implicit double precision (a-h, o-z)

      include '../HEADERS/const.h'
      include '../HEADERS/dim.h'

      logical :: found
      type(json_file) :: json   !the JSON structure read from the file:
      double precision,dimension(:),allocatable :: dbpcs, dbpce

      integer nosc
      double precision oscstr(14), enosc(14)

      call json%load_file('fpf0.json')
      if (json_failed()) then   !if there was an error reading the file
         print *, "failed to read fpf0.json"
         stop
      else
         call json%get('nosc', nat, found)
                   if (.not. found) call bailout('nosc', 'fpf0.json')
         call json%get('oscstr', dbpcs, found)
                   if (.not. found) call bailout('x', 'atoms.json')
         call json%get('enosc',  dbpce, found)
                   if (.not. found) call bailout('y', 'atoms.json')
         do 20 i=1,nosc
            oscstr(i) = dbpcs(i)
            enosc(i)  = dbpce(i)
 20      continue
         call json%destroy()
      end if

      return
      end

      subroutine mpprmp (npat, ipat, xp, yp, zp)

c     make path parameters,  xp, yp,zp for each atom for a given
c     path.

c     Input is list of atoms (npat, ipat(npat)), output are
c     x,y,z coord. of path in standard frame of reference
c     (see comments in timrep.f or here below)

      include 'dim.h'
      include 'pola.h'
      double precision  ro2, norm, zvec, xvec, yvec, ri, xp1, yp1, zp1
      dimension ipat(npatx+1), zvec(3), xvec(3), yvec(3)

      common /atoms/ rat(3,0:natx), ipot(0:natx), i1b(0:natx)

      dimension xp(npatx), yp(npatx), zp(npatx)
      dimension xp1(npatx), yp1(npatx), zp1(npatx)
      dimension ri(3,npatx)

      parameter (eps4 = 1.0E-4)

c        get the atoms in this path
c        we actually have them already via the ipat array

c     initialize staff
      do 10 j = 1, npatx
         xp(j) = 0
         yp(j) = 0
         zp(j) = 0
         xp1(j) = 0
         yp1(j) = 0
         zp1(j) = 0
   10 continue
      nleg = npat + 1
      do 20  j = 1, npat
      do 20  i = 1, 3
         ri(i,j) = rat(i,ipat(j)) - rat(i,0)
   20 continue
      do 30  j = nleg, npatx
      do 30  i = 1, 3
         ri(i,j) = 0
   30 continue
      do 40 i =1, 3
         xvec(i) = 0.0
         yvec(i) = 0.0
         zvec(i) = 0.0
   40 continue

      if (.not. pola) then
c        z-axis along first leg
         norm = ri(1,1)*ri(1,1)+ri(2,1)*ri(2,1)+ri(3,1)*ri(3,1)
         norm = sqrt(norm)
         do 140 i = 1, 3
           zvec(i) = ri(i,1)/norm
  140    continue
      else
c        z-axis in direction of polarization
         do 120 i = 1, 3
           zvec(i) = evec(i)
  120    continue
      endif

      do 160 j = 1,npat
      do 160 i = 1, 3
        zp1(j) = zp1(j) + zvec(i)*ri(i,j)
  160 continue

      num = 1
      if (.not. pola) then
c        first nonzero z-coord. is already positive
         goto 240
      endif
  200 continue
      if (abs(zp1(num)) .gt. eps4) then
         if (zp1(num) .lt. 0.0) then
c           inverse all z-coordinates and zvec, if 
c           first nonzero z-coordinate is negative 
            do 210 j = 1, 3
               zvec(j) = - zvec(j)
  210       continue
            do 220 j = 1, npat
               zp1(j) = - zp1(j)
  220       continue
         endif
         goto 240
      endif
      num = num +1
      if (num .lt. nleg) then
         goto 200
      endif
c     here first nonzero z-coordinate is positive
  240 continue

      num = 1
  300 continue
      ro2 = 0.0
      do 310 i =1, 3
         ro2 = ro2 + ri(i,num)*ri(i,num)
  310 continue
c     looking for first atom which is not on z-axis
      ro2 = ro2 - zp1(num)*zp1(num)
      ro2 = sqrt(abs(ro2))
      if (ro2 .ge. eps4) then
c     if atom not on the z-axis then
         if (elpty .eq. 0.0) then
c           if not elliptical polarization then
c           choose x-axis so that x-coord. positive and y=0.
            do 320 i = 1, 3
               xvec(i) = ri(i,num) - zvec(i)*zp1(num)
  320       continue
            do 330 i = 1, 3
               xvec(i) = xvec(i)/ro2
  330       continue
         else
c           if elliptical polarization then
c           choose x-axis along incident beam
            do 350 i =1, 3
               xvec(i) = ivec(i)
  350       continue
         endif
         yvec(1) = zvec(2)*xvec(3) - zvec(3)*xvec(2)
         yvec(2) = zvec(3)*xvec(1) - zvec(1)*xvec(3)
         yvec(3) = zvec(1)*xvec(2) - zvec(2)*xvec(1)
         goto 390
      endif
      num = num + 1
      if (num .lt. nleg) then
         goto 300
      endif
  390 continue

c     calculate x,y coord for each atom in chosen frame of reference
      do 400 j = 1, npat
      do 400 i =1,3
         xp1(j) = xp1(j) + xvec(i)*ri(i,j)
         yp1(j) = yp1(j) + yvec(i)*ri(i,j)
  400 continue

      if ( elpty .ne. 0.0) then
c        if no polarization or linear polarization then first nonzero
c        x-coordinate is already positive, no need to check it.
         num = 1
  500    continue
         if (abs(xp1(num)) .ge. eps4) then
            if (xp1(num) .lt. 0.0) then
               do 510 j = 1, npat
                  xp1(j) = - xp1(j)
  510          continue
            endif
            goto 520
         endif
         num = num + 1
         if (num .lt. nleg) then
            goto 500
         endif
  520    continue
      endif

      num = 1
  570 continue
c     inverse all y-coordinates if first nonzero y-coord is negative
      if (abs(yp1(num)) .ge. eps4) then
         if (yp1(num) .lt. 0.0) then
            do 580 j = 1, npat
               yp1(j) = - yp1(j)
  580       continue
         endif
         goto 590
      endif
      num = num + 1
      if (num .lt. nleg) then
         goto 570
      endif
  590 continue

      do 595 j = 1, npat
        xp(j) = xp1(j)
        yp(j) = yp1(j)
        zp(j) = zp1(j)
  595 continue
c     now xp,yp,zp represent the path in standard order
      return
      end

      subroutine  grids ( ecv, xmu, negx, neg, emg , step, nflrx)
c     makes a grid in complex e-plane for scmt calculation
c     add complications for complex cases later. ala
c     emg is comlex energy in hartrees
      implicit double precision (a-h, o-z)

      complex*16 emg(negx), eim, eimmin
      dimension step(nflrx)
      include '../HEADERS/const.h'

c     the choice of e_cv should be automated later
c     all l-dos should be zero at ecv
c     fix it by hand if needed below
c     for some complicated materials may need multiple e_cv
c     it may also depend on core-valence separation

c     eimmin = the lowest im energy to search for fermi level
c     may simulate Fermi distr for occ numbers, thus may want
c     to lower eimmin for low temperatures.
      eimmin = coni*0.05d0/hart
      neg1 = (nflrx+1)/2
      neg3 = nflrx - 1
      neg2mx = negx-neg1-neg3
c     never do calculations on real axis.
      eim = eimmin*neg1**2
      eim = eimmin 
      de = dimag(eim)/4

      do 10 i =1, neg1
c        step linearly increases as one get farther from real axis
         eim = eimmin *i**2
         emg(i) = ecv +eim
  10  continue
      step(nflrx) = dimag(eim)/4

c     set energy step for integration eim above real axis
      de = dimag(emg(neg1))/4
      neg2= nint((xmu-ecv)/de)
      if (neg2.gt.neg2mx) neg2=neg2mx
      if (neg2.lt.neg1) neg2 = neg1
      de = (xmu-ecv) / neg2
      do 20 i = neg1+1,neg1+neg2
  20  emg(i) = emg(i-1) + de

      neg = neg1 + neg2 + neg3
      do 30 i =1, neg3
c        step linearly increases as one get farther from real axis
         eim = eimmin *(i+1)**2 /4.d0
         if (i.le.nflrx) step(i) = dimag(eim)/4
         emg(neg-i+1) = xmu + eim
  30  continue

      return
      end

      subroutine wrxsph (phpad,
     1       nsp, ne, ne1, ne3, nph, ihole, rnrmav,xmu,edge,
     2       ik0, ixc, rs, vint,
     3       em, eref, lmax, iz, potlbl, ph, rkk)
      implicit double precision (a-h, o-z)
c     writes down file 'phase.pad' to be read by rphpad
c  Energy grid information
c     em   - complex energy grid
c     eref - V_int + i*gamach/2 + self-energy correction
c     ne   - total number of points in complex energy grid
c     ne1  - number of points on main horizontal axis
c     ne2  - number of points on vertical vertical axis ne2=ne-ne1-ne3
c     ne3  - number of points on auxilary horizontal axis (need for f')
c     xmu  - Fermi energy
c     edge - x-ray frequency for final state at Fermi level
c     ik0  - grid point index at Fermi level
c  Potential type information
c     ixc    - potential model (this, rs, vint added to phase.pad for sake of onepath.f)
c     rs     - r_s estimate from rhoint (4/3 r_s**3 * rhoint = 1)
c     vint   - muffin-tin zero energy (interstitial potential) 
c     nph    - number of potential types
c     iz     - charge of nuclei (atomic number)
c     potlbl - label for each potential type
c     lmax   - max orb momentum for each potential type
c     ihole  - index of core-hole orbital for absorber (iph=0)
c     rnrmav - average Norman radius (used in headers only)
c  Main output of xsect and phases module (except that in xsect.bin)
c     ph  - complex scattering phase shifts
c     rkk - complex multipole matrix elements

      include '../HEADERS/dim.h'

      character*256 phpad

      character*6  potlbl
      dimension  potlbl(0:nphx)

      complex*16 ph(nex,-ltot:ltot,nspx,0:nphx), eref(nex,nspx), em(nex)
      complex*16 rkk(nex, 8, nspx)
      dimension lmax(0:nphx)
      dimension iz(0:nphx)

c     Local staff
c     npadx control padlib precision (see padlib package)
      parameter (npadx=8)
c     use temp to write ph, rkk, since ne < nex
      complex*16 temp(nex*(2*ltot+1))
      dimension dum(3)

      
c     intialize temp to all 0+i0
      do 5 i = 1, nex*(2*ltot+1)
         temp(i) = dcmplx(0.0,0.0)
 5    continue

c      print *, '>', phpad(1:istrln(phpad)), '<'
      open (unit=1, file=phpad, status='unknown', iostat=ios)
      call chopen (ios, 'phase.pad', 'wrxsph')

      write(1,10) nsp, ne, ne1, ne3, nph, ihole, ik0, npadx, ixc,
     &     rs, vint
 10   format (9(1x,i4), 2(1x,f10.5))

      dum(1) = rnrmav
      dum(2) = xmu 
      dum(3) = edge
      call wrpadd(1, npadx, dum(1), 3)

      call wrpadx(1, npadx, em(1), ne)
      ii = 0
      do 60 isp = 1, nsp
      do 60 ie=1, ne
        ii = ii + 1
        temp(ii) = eref (ie, isp)
  60  continue
      call wrpadx (1, npadx, temp(1), ii)

      do 80  iph = 0, nph
         write(1, 20) lmax(iph), iz(iph), potlbl(iph)
  20     format(2(1x,i3), 1x, a6)
         do 75  isp = 1, nsp
            ii = 0
            do 70  ie = 1, ne
            do 70  ll = -lmax(iph), lmax(iph)
               ii = ii+ 1
               temp(ii) = ph(ie, ll, isp, iph)
   70       continue
            call wrpadx (1, npadx, temp(1), ii )
   75    continue
   80 continue

      ii = 0
      do 90 isp = 1, nsp
      do 90 kdif = 1, 8
      do 90 ie=1, ne
        ii = ii + 1
        temp(ii) = rkk (ie, kdif, isp)
  90  continue
      call wrpadx (1, npadx, temp(1), ii)

      close (unit=1)

      return
      end

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Information about last revision of $RCSfile: m_struct.f90,v $:
! $Revision: 1.12 $
! $Author: jorissen $
! $Date: 2012/01/31 22:47:21 $
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!*****************************************************************************
!       DEFINE THE UNIT CELL
!*****************************************************************************
module struct

  !    The space group
  integer sgroup  ! goes from 1 to 230
  !    The H-M name of the space group
  character*8 sgroup_hm
  !    The Bravais lattice
  character*3 latticename ! can be P,F,H,R,B,CXZ,CYZ
  !    Similar to the above; here we only want to know whether we're in the "primitive" lattice or a "conventional" lattice
  character*1 lattice  ! allowed values :  P,F,I,B,C
  !    The lattice constants
  real*8 alat(3),alfalat(3)
  !    The lattice vectors
  real*8 a1(3),a2(3),a3(3)
  !    The reciprocal lattice vectors
  real*8 b1(3),b2(3),b3(3)
  !    Number of atoms
  integer nats
  !    Number of potentials
  integer nph
  !    Number of atoms per potential type
  integer,allocatable :: natom(:)
  !    Index of representative atom for a potential type in the list of the atom positions of the unit cell
  integer,allocatable :: firstpos(:)
  !    Positions of all atoms
  real*8, allocatable :: ppos(:,:)
  !    Potential type of each position
  integer, allocatable :: ppot(:)
  !    Position containing the absorber
  integer absorber
  !    Angular expansion limit of potential
  integer,allocatable :: lpot(:)
  !    Atom type for each potential
  character*2,allocatable :: label(:)
  !    Atomic number z for each potential
  integer,allocatable :: izatom(:)
  !    Number of spin states
  integer nsp
  !    Volume of the unit cell :
  real*8 celvol
  !    Volume of the reciprocal unit cell
  real*8 volbz
  !    Symmetry operations of the crystal
  real*8 cryst_gr(3,4,48,2)
  !     cryst_gr(:,:,:,2) : in lattice coordinates
  !     cryst_gr(:,:,:,1) : in carthesian coordinates
  !    Number of symmetry operations of the crystal
  integer nsym
  !    The Bravais matrix, in units 2 pi / a_i
  real*8 bramat(3,3)
  !    Real space basis matrix
  real*8 rbas(3,3)
  !    Reciprocal space basis matrix
  real*8 gbas(3,3)
  !    Is the real space basis orthogonal or not
  logical ortho

contains

  subroutine init_struct(n)
    implicit none
    integer n


    if(allocated(ppos)) write(*,*) 'ppos is allocated'
    if(allocated(ppot)) write(*,*) 'ppot is allocated'
    if(allocated(lpot)) write(*,*) 'lpot is allocated'
    if(allocated(natom)) write(*,*) 'natom is allocated'

    allocate(ppos(3,n),ppot(n),lpot(0:n),natom(n),label(0:n),izatom(0:n),firstpos(n))
    ppos=dble(0)
    natom=0
    ppot=-1
    lpot=-1
    label(:)='  '
    if(absorber.lt.1.or.absorber.gt.n) absorber=1
    if( (latticename.ne.'P  '.and.latticename.ne.'F  '.and.latticename.ne.'I  '.and.latticename.ne.'CXZ' &
         .and.latticename.ne.'CYZ'.and.latticename.ne.'H  ' &
         .and.latticename.ne.'R'.and.latticename.ne.'B  '.and.latticename.ne.'CXY')  .or.  &
         (lattice.ne.'P'.and.lattice.ne.'F'.and.lattice.ne.'I'.and.lattice.ne.'C'.and.lattice.ne.'H' &
         .and.lattice.ne.'R'.and.lattice.ne.'B')  ) then
       call wlog('Setting unknown lattice type '//latticename//' '//lattice//'  to P.')
       lattice='P'
       latticename='P  '
    endif
    if(sgroup.lt.1.or.sgroup.gt.230) sgroup=1
    ortho=.false.
    gbas=dble(0)
    rbas=dble(0)
    bramat=dble(0)
    cryst_gr=dble(0)
    nsym=0

  end subroutine init_struct

end module struct

      subroutine fixlinenow(w,nw)
      implicit none 
      integer nwordx     
      parameter (nwordx = 20)
      character*20 w(nwordx),k
      integer nw,nwold,i
      logical iscomm
      external iscomm
      
      nwold=nw
      do i=1,nw
        k=w(i)
        call untab(k)
        call triml(k)
        w(i)=k
!       write(*,'(a1,a20,a1,i1)') '-',w(i),'-',iscomm(w(i))
        if (iscomm(w(i))) then
          nw=i-1
          exit
        endif
      enddo
      
      if (nw.ne.nwold) then
        do i=nw+1,nwold
        
          w(i)='                    '
        enddo
      endif
      
      
      return
      end
      

      subroutine scmt (verbse, iscmt, ecv, nph, nat, vclap,
     1                edens, edenvl, vtot, vvalgs, rmt, rnrm,qnrm,
     2                ixc, rhoint, vint, xmu, jumprm,
     3                xnferm, xnvmu, xnval,
     4                x0, ri, dx, xnatph, xion, iunf, iz,
     5                adgc, adpc, dgc,dpc, ihole,
     7                rat,iatph,iphat, lmaxsc, rhoval, xnmues, ok,
     8                rgrd, nohole, nscmt, icoul, ca1, rfms1, lfms1)

c     Finds new Fermi level (xmu), electron counts (qnrm)
c     and new valence densities (rhoval).

      implicit double precision (a-h, o-z)
      include '../HEADERS/dim.h'
      include '../HEADERS/const.h'

      logical verbse
c     input
      dimension dmagx(nrptx), dmag0(251)
      dimension vclap(251,0:nphx)
      dimension vtot (251,0:nphx), vvalgs (251,0:nphx)
      dimension xnvmu(0:lx,0:nphx+1), rmt(0:nphx),rnrm(0:nphx)
      dimension xnval (30,0:nphx)
      dimension qnrm(0:nphx), dq(0:nphx)
      dimension ri(nrptx), ri05(251), nr05(0:nphx)
      dimension xnatph(0:nphx), iz(0:nphx), xion(0:nphx)
      dimension rat(3,natx),iatph(0:nphx),iphat(natx), lmaxsc(0:nphx)
      real  rfms1
c     input and output
      dimension edens(251,0:nphx), edenvl(251,0:nphx)
      dimension rhoval(251,0:nphx+1)

c     work space
      dimension xnmues(0:lx, 0:nphx)
      complex gtr(0:lx, 0:nphx)
      dimension dum(nrptx), vtotph(nrptx),vvalph(nrptx)
      dimension dgc(251,30,0:nphx+1), dpc(251,30,0:nphx+1)
      dimension adgc(10,30,0:nphx+1), adpc(10,30,0:nphx+1)
      dimension dgcn(nrptx,30), dpcn(nrptx,30)
      complex*16 xrhoce(0:lx,0:nphx), xrhocp(0:lx,0:nphx)
      complex*16 xrhole(0:lx,0:nphx)
      complex*16 yrhoce(251,0:nphx), yrhocp(251,0:nphx)
      complex*16 yrhole(251,0:lx,0:nphx)
      complex*16 ph(lx+1, 0:nphx)
      integer iph
c     complex energy grid emg is decomposed into em and eref
      parameter (negx = 80)
      complex*16 emg(negx), em, eref, ee, ep, fl, fr, fxa
c     nflrx should be odd and defines the max of Im energy for
c     the countour
      parameter (nflrx = 17)
      dimension step(nflrx)
c     stuff from feff.f for rdinp, pathfinder and genfmt
      logical upok, ok
c      logical wnstar
c     Following passed to pathfinder, which is single precision.
      character*512 slog
      integer ient
      data ient /0/

c     save staff from rdinp, so no need to call it again
      save   ri05, ient

      upok = .false.
      idir = 1
      ient = ient + 1
      if (ient.eq.1) then
         do 15 i= 1,251
  15     ri05(i) = exp (-8.8d0+0.05d0*(i-1))
      endif

      if (verbse) then
         write (slog,10) iscmt, nscmt
 10      format('              SCF ITERATION NUMBER',i3,'  OUT OF',i3)
         call wlog(slog)

         call wlog (' Calculating energy and space dependent l-DOS.')
         call wlog (' It takes time ...')
      endif

c     initialize new valence density
      do 16 iph=0,nphx
      do 16 ir=1,251
  16  rhoval(ir,iph) = 0

c     polarization average in scmt and ldos

      call grids (ecv, xmu, negx, neg, emg, step, nflrx)

c     ie - is number of energy points calculated
      ie = 0
      xndifp = 0
      xndif  = 0
      ee = emg(1)
      ep = dble(ee)
      do 22 iph=0,nphx
      do 22 il=0,lx
        xrhoce(il,iph) = 0
        xnmues(il,iph) = 0
  22  continue
      do 23 iph=0,nphx
      do 23  ir = 1,251
  23  yrhoce(ir,iph) = 0
      iflr = nflrx
      iflrp = nflrx

c     Start the cycle over energy points (ie)
  25  continue
      ie = ie + 1

      do 29 iph = 0,nph
        do 860 il = 0,lx
  860     xrhocp(il,iph) = xrhoce(il,iph)
        do 870 i = 1,251
  870     yrhocp(i,iph) = yrhoce(i,iph)
  29  continue

      if (ie.eq.1 .or. mod(ie,20).eq.0) then
         if (verbse) then
            write(slog,30) ie, dble(ee)*hart
 30         format('     point # ', i3, '  energy = ', f7.3)
            call wlog(slog)
         endif
      endif

      do 100  iph = 0, nph

         do 35 i=1, 251
  35     dmag0(i) = 0.d0
cc       use spin-unpolarized case to get SCF. set dmagx to zero
cc       may want to replace dmag0 with dmag(1,iph) for spin-dependent
cc       extension of SCF procedure.
         call fixvar (rmt(iph),edens(1,iph),vtot(1,iph),dmag0,
     1                vint, rhoint, dx, rgrd, jumprm,
     2                vjump, ri, vtotph, dum, dmagx)
         if (mod(ixc,10) .ge.5) then
            if (jumprm .gt. 0) jumprm = 2
            call fixvar (rmt(iph), edenvl(1,iph), vvalgs(1,iph),
     1                dmag0, vint, rhoint, dx, rgrd , jumprm,
     2                vjump, ri, vvalph, dum, dmagx)
            if (jumprm .gt. 0) jumprm = 1
         endif

         call fixdsx (iph, dx, rgrd , dgc, dpc, dgcn, dpcn)
        jri = int((log(rmt(iph)) + x0) / rgrd) + 2
        jri1 = jri+1
        eref = vtotph(jri1)
        do 40 i = 1, jri1
  40    vtotph(i) = vtotph(i) - dble(eref)
        if (ixc.ge.5) then
           do 50 i = 1, jri1
  50       vvalph(i) = vvalph(i) - dble(eref)
        else
           do 60 i = 1, jri1
  60       vvalph(i) = vtotph(i)
        endif

         itmp = 0
         if (iph.eq.0 .and. nohole.lt.0) itmp = ihole
         call rholie( ri05, nr05(iph), rgrd, x0, ri, ee,
     2           ixc, rmt(iph), rnrm(iph),
     3           vtotph, vvalph, xnval(1,iph), dgcn, dpcn, eref,
     4           adgc(1,1,iph), adpc(1,1,iph), xrhole(0,iph),
     5          xrhoce(0,iph),yrhole(1,0,iph),yrhoce(1,iph),ph(1,iph),
     6           iz(iph), xion(iph), iunf, itmp,lmaxsc(iph))
  100 continue

c     Write out phases for fmsie
c     transform neg,emg to em,ne,eref first
       em= dble(ee)
       eref=dble(eref)-coni*dimag(ee)

cc    call fms for a cluster around central atom
       do 195 iph0 = 0,nph
       do 195 il = 0, lx
  195  gtr(il,iph0) = 0
      if (rfms1 .gt. 0) then
        if (lfms1 .ne. 0) then
          iph0 = 0
          call fmsie(verbse, iph0, nph, lmaxsc, ie,  em, eref, ph,
     1                rfms1, lfms1, nat, iphat, rat, gtr)
        else
          do 190 iph0 = 0, nph
  190     call fmsie(verbse, iph0, nph, lmaxsc, ie, em, eref, ph,
     1                rfms1, lfms1, nat, iphat, rat, gtr)
        endif
      endif

      xntot = 0
      fl = 0
      fr = 0
      do 300 iph = 0,nph
c       calculate density and integrated number of electrons in each
c       channel for each type of atoms density, etc., find xntot.
        call ff2g (gtr(0,iph), iph, ie, nr05(iph), xrhoce,
     1     xrhole(0,iph), xrhocp, ee, ep,
     2     yrhole(1,0,iph), yrhoce(1,iph), yrhocp(1,iph), rhoval(1,iph),
     3     xnmues(0,iph), xnatph(iph), xntot, iflr, iflrp, fl, fr, iunf)
  300 continue

      if (ie.ne.1) xndifp = xndif
      xndif = xntot - xnferm

c     decide on next energy point; there are nflrx floors, defined
c     by the magnitude of Im part. Each floor has it's height and
c     horizontal step to search for Fermi level associated with it.
c     The driver below will decide whether to go left or right on
c     the current floor, go one floor up or down.

      if ((ie.lt.neg .and. ient.gt.1) .or.
     1    (ient.eq.1.and.ie.lt.nflrx)) then
         ep = ee
         ee = emg(ie+1)
         if (ie.eq.neg-1) then
c          reset iflr variables
           iflrp = 2
           iflr  = 1
         endif
         goto 25
      elseif (ient.eq.1 .and. ie.eq.nflrx) then
         upok = .false.
         idir = 1
         if (xntot.gt. xnferm) idir = -1
         ep = ee
         ee = ee + idir * step(iflr)
         goto 25
      elseif (ient.gt.1 .and. ie.eq.neg) then
         upok = .true.
         iflrp = 1
         iflr  = 1
         idir = -1
         if (xntot.lt. xnferm) idir = 1
         ep = ee
         ee = ee + idir * step(iflr)
         goto 25
      else
c       check if the fermi level is found
        if (iflrp.eq.1 .and. iflr.eq.1 .and.
     1                xndifp*xndif .le. 0.d0) then
c          Fermi level is found ; do not goto 25
           if (xndif.eq.0) then
              xmunew = dble(ee)
              a=0
           else
              a = xndif/(xndif-xndifp)
              do 220 i = 1,4
                fxa = a*fl + (1-a)*fr
                bb = dimag(dcmplx((ep-ee)*(fr+fxa)/2 +
     $               coni*imag(ee)*(fr-fl)))
                xndif1 = xndif + a * bb
                a = a - xndif1 / bb
  220         continue
              xmunew = dble((1-a)*ee+a*ep)
           endif

c          add end cap corrections to the configuration and density
c          factor 2 for spin degeneracy
           do 250 iph = 0,nph
              do 230 il = 0,lx
               if (il.le.2 .or. iunf.ne.0) then
                fl = xrhocp(il,iph) * 2
                fr = xrhoce(il,iph) * 2
                fxa = a*fl + (1-a)*fr
                bb = dimag(dcmplx((ep-ee)*(fr+fxa)/2 +
     1               coni*dimag(dcmplx(ee))*(fr-fl)))
                xnmues(il,iph) = xnmues(il,iph) + a * bb
               endif
  230         continue
              do 240 ir = 1,nr05(iph)
                fl = yrhocp(ir,iph) * 2
                fr = yrhoce(ir,iph) * 2
                fxa = a*fl + (1-a)*fr
                bb = dimag(dcmplx((ep-ee)*(fr+fxa)/2 +
     1               coni*dimag(dcmplx(ee))*(fr-fl)))
                rhoval(ir,iph) = rhoval(ir,iph) + a * bb
  240         continue
  250      continue
        else
c          continue search ; goto 25 eventually
           if (iflr.eq.iflrp) then
c            previous step was gorizontal
             if (xndifp*xndif.le.0) then
c               need to step down
                upok =.false.
                iflrp = iflr
                iflr = iflr - 1
                ep = ee
                ee = dble(ee) + coni*4*step(iflr)
             elseif (abs(xndif).gt.10.d0*abs(xndif-xndifp)
     1          .and. upok) then
c               need to go up one floor since too far from fermi level
                iflrp = iflr
                if (iflr.lt.nflrx) then
                  iflr = iflr+1
                  ep = ee
                  ee = dble(ee) +  coni*4*step(iflr)
                else
                  ep = ee
                  ee = ee + idir* step(iflr)
                endif
             else
c               keep the same floor and direction
                ep = ee
                ee = ee + idir* step(iflr)
             endif
           else
c            previous step was up or down (vertical)
c            check the direction of search
             idir = -1
             if (xndif.lt.0) idir = 1
             iflrp = iflr
             ep = ee
             ee = ee + idir* step(iflr)
           endif
           goto 25
        endif
      endif
c     END of the loop over energy in comlex plane.
c     new fermi level and densities are calculated.

c     report configuration; repeat iteration if found bad counts.
      ok = .true.
      if (verbse) then
         call wlog('  Electronic configuration')
         call wlog('   iph    il      N_el')
      endif
 310  format (2i6, f9.3)
      do 320 ip= 0,nph
      do 320 il = 0,lx
         if (verbse) then
            write (slog,310) ip,il,xnmues(il,ip)
            call wlog(slog)
         endif
c        check that occupation numbers are consistent with those
c        set in getorb.f
         diff = abs(xnmues(il,ip) - xnvmu(il,ip))
         if (diff.gt.13.1d0 .or. (il.eq.2 .and. diff.gt. 9.1d0) .or.
     1   (il.eq.1 .and. diff.gt.5.1d0) .or.
     2   (il.eq.0 .and. diff.gt.1.95d0)) then
            call wlog (' Found bad counts.')
            write (slog,311) xnvmu(il,ip)
  311       format('  Occupation number in getorb is ', f9.3)
            call wlog(slog)
            call wlog ('  Will repeat this iteration ')
c            if (ient.gt.1) ok = .false.
         endif
 320  continue

c     if (.not. ok) then will restart SCF loop
      if (ok) then
         xmu = xmunew
c        find rhoval via Broyden algorithm
         call broydn( iscmt, ca1, nph, xnvmu,
     1         nr05 , xnatph, rnrm, qnrm, edenvl, rhoval, dq)

c        calculate new vclap - overlap coulomb potential
         call coulom (icoul, nph, nr05 , rhoval, edenvl, edens,
     2     nat, rat, iatph, iphat, rnrm, dq, iz, vclap)

c       update array edens
        do 350 ip=0,nph
           do 330 ir=1,nr05 (ip)
             edens(ir,ip)=edens(ir,ip)-edenvl(ir,ip)+rhoval(ir,ip)
  330      continue
           do 340 ir=nr05 (ip)+1,251
             edens(ir,ip)=0.0d0
             edenvl(ir,ip)=0.0d0
  340      continue
  350   continue
      endif

      return
      end

      subroutine potdvp
c     this programm uses aprdep,multrk,yzkrdf
c     to calculate potential development coefficients
      implicit double precision (a-h,o-z)
      include '../HEADERS/dim.h'
      common/dff/ cg(nrptx,30), cp(nrptx,30), bg(10,30), bp(10,30),
     1              fl(30), fix(30), ibgp
      complex*16 dg,ag,dp,ap,dv,av,eg,ceg,ep,cep
      common/comdic/cl,dz,dg(nrptx),ag(10),dp(nrptx),ap(10),dv(nrptx),
     2         av(10),eg(nrptx),ceg(10),ep(nrptx),cep(10)
c     dg,dp to get data from yzkrdf, dv,eg,ep -output for soldir
      common/itescf/testy,rap(2),teste,nz,norb,norbsc
      common/ratom1/xnel(30),en(30),scc(30),scw(30),sce(30),
     1nq(30),kap(30),nmax(30)
      common/snoyac/dvn(nrptx),anoy(10),nuc
      common/tabtec/hx,dr(nrptx),test1,test2,ndor,np,nes,method,idim
      dimension bgj(10),bpj(10)
c#mn
       external aprdep

      do 9 i=1,10
 9       av(i)=anoy(i)
 
c     calculate density development coefficients
      do 31 i=1,ndor
 31   ag(i)=0.0d 00
      do 51 j=1,norb-1
         do 33 i = 1,10
            bgj(i) = bg(i,j)
 33         bpj(i) = bp(i,j)
         n=2* abs(kap(j))
         l=ndor+2-n
         if (l.le.0) go to 51
         do 41 i=1,l
            m=n-2+i
 41         ag(m)=ag(m)+xnel(j)*(aprdep(bgj,bgj,i)+
     1            aprdep(bpj,bpj,i))*fix(j)**2
 51   continue

c     transform density coefficients into ones for potential
      ap(1)=0.0d 00 
      do 15 i=1,ndor
         ag(i)=ag(i)/(i+2)/(i+1)
         ap(1)=ap(1)+ag(i)*dr(1)**(i+1)
 15   continue

      do 61 i=1,ndor
         l=i+3
         if (l.gt.ndor) go to 61
         av(l)=av(l)-ag(i)
 61   continue
c     av(2)=avoy(2) + ap(1)+(vxcvzl(1)-dvn(1)) in order 
c     to have sum av(i)*dr(1)**(i-2)=vxcval(1)
      av(2)=av(2)+ap(1)
 
c addition of nuclear potential and division of potentials and
c       their development limits by speed of light
      do 527 i=1,10
 527     av(i)=av(i)/cl
      return
      end

      subroutine repath ( ms, mpath, ipr4, pcritk, pcrith, nncrit, rmax,
     1             nlegxx, rfms2, critpw,
     2             nat, rat, iphat, ibounc,
     3             ipol, ispin, evec, xivec)
c ,eels)  !KJ added eels 5/06

      use json_module
      implicit double precision (a-h, o-z)
      logical :: found
      type(json_file) :: json   !the JSON structure read from the file:
      double precision toss

      include '../HEADERS/const.h'
      include '../HEADERS/dim.h'

cc    geom.dat
        integer  nat, iatph(0:nphx), iphat(natx), ibounc(natx)
        double precision  rat(3,natx)
cc    global.dat 
c       configuration average
        integer nabs, iphabs
c       global polarization data
        integer  ipol, ispin, le2
        double precision evec(3), xivec(3), spvec(3), elpty,angks,rclabs
        complex*16 ptz(-1:1, -1:1)
cc    mod4.inp
        integer  mpath, ms, nncrit, nlegxx, ipr4
        real critpw, pcritk, pcrith,  rmax, rfms2

c        integer eels !KJ added 5/06


c     Local stuff
c      character*512 slog
c      character*80 head(nheadx)
c      dimension lhead(nheadx)

c     standard formats for string, integers and real numbers
c  10  format(a)
c  20  format (20i4)
c  30  format (6f13.5)


c--json--c     Read  geom.dat file
c--json--      open (file='geom.dat', unit=3, status='old',iostat=ios)
c--json--c       read header from geom.dat
c--json--        nhead = nheadx
c--json--        call rdhead (3, nhead, head, lhead)
c--json--        nat = 0
c--json--        nph = 0
c--json--        do 40 iph = 0, nphx
c--json--  40    iatph(iph) = 0
c--json--  50    continue
c--json--         nat = nat+1
c--json--         if (nat .gt. natx)  then
c--json--           write(slog,55) ' nat, natx ', nat, natx
c--json--           call wlog(slog)
c--json--  55       format(a, 2i10)
c--json--           stop 'Bad input'
c--json--         endif
c--json--         read(3,*,end=60) idum,(rat(j,nat),j=1,3),iphat(nat),ibounc(nat)
c--json--         if (iphat(nat).gt.nph) nph = iphat(nat)
c--json--         if ( iatph(iphat(nat)).eq.0) iatph(iphat(nat)) = nat
c--json--        goto 50
c--json--  60    continue
c--json--        nat = nat-1
c--json--      close(3)

c--json--cc    global.inp
c--json--      open (file='global.dat', unit=3, status='unknown',iostat=ios)
c--json--c       configuration average data
c--json--        read  (3, 10) slog
c--json--        read  (3, 65) nabs, iphabs, rclabs
c--json--  65    format ( 2i8, f13.5)
c--json--c       global polarization data
c--json--        read  (3,10)   slog
c--json--        read  (3, 70)  ipol, ispin, le2, elpty, angks
c--json--  70    format ( 3i5, 2f12.4)
c--json--        read  (3, 10) slog
c--json--        do 80 i = 1,3
c--json--          read  (3,30) evec(i), xivec(i), spvec(i)
c--json--  80    continue
c--json--        read  (3, 10) slog
c--json--        do 90 i = -1, 1
c--json--          read (3,30) a1, b1, a2, b2, a3, b3
c--json--          ptz(-1,i)= dcmplx(a1,b1)
c--json--          ptz(0,i) = dcmplx(a2,b2)
c--json--          ptz(1,i) = dcmplx(a3,b3)
c--json--  90    continue
c--json--      close(3)

c--json--c     read mod4.inp
c--json--      open (file='mod4.inp', unit=3, status='old',iostat=ios)
c--json--        read (3,10)  slog
c--json--        read (3,20)  mpath, ms, nncrit, nlegxx, ipr4
c--json--        read (3,10)  slog
c--json--        read (3,30)  critpw, pcritk, pcrith,  rmax, rfms2
c--json--      close(3)

      call json_read_geom(nat, nph, iatph, rat, iphat, ibounc)

      call json_read_global(nabs, iphabs, rclabs, ipol, ispin, le2,
     1                      elpty, angks, evec, xivec, spvec, ptz)


      call json%load_file('path.json')
      if (json_failed()) then   !if there was an error reading the file
         print *, "failed to read path.json"
         stop
      else
         call json%get('mpath',   mpath, found)
                   if (.not. found) call bailout('mpath', 'path.json')
         call json%get('ms',   ms, found)
                   if (.not. found) call bailout('ms', 'path.json')
         call json%get('nncrit',   nncrit, found)
                   if (.not. found) call bailout('nncrit', 'path.json')
         call json%get('nlegxx',   nlegxx, found)
                   if (.not. found) call bailout('nlegxx', 'path.json')
         call json%get('ipr4',   ipr4, found)
                   if (.not. found) call bailout('ipr4', 'path.json')
         call json%get('critpw',   toss, found)
                   if (.not. found) call bailout('critpw', 'path.json')
         critpw = real(toss)
         call json%get('pcritk', toss, found)
                   if (.not. found) call bailout('pcritk', 'path.json')
         pcritk = real(toss)
         call json%get('pcrith', toss, found)
                   if (.not. found) call bailout('pcrith', 'path.json')
         pcrith = real(toss)
         call json%get('rmax',   toss, found)
                   if (.not. found) call bailout('rmax', 'path.json')
         rmax = real(toss)
         call json%get('rfms2',  toss, found)
                   if (.not. found) call bailout('rfms2', 'path.json')
         rfms2 = real(toss)
         call json%destroy()
      end if      

      return
      end

      subroutine sigm3(sig1, sig2, sig3, tk, alphat, thetae)

c     using correlated Einstein-model with a morse potential
c     Nguyen Van Hung & J.J.Rehr Phys. Rev. B 56 , 43

      implicit double precision (a-h, o-z)
      include '../HEADERS/const.h'

      real sig02,  sig01, z
c     dimension alphat=[1/anstroems]
      parameter(three=3.d0)
      parameter(four=4.d0 )
      parameter(fourthird= four/three)
      parameter(threequarter= three/four)

      alphat= alphat * bohr
      z     = real(exp(- thetae/tk))
      sig02 = real((1-z)/ (1+z) * sig2)
      sig01 = real(alphat) * sig02 * real(threequarter)
      sig1  = sig01 * sig2 / sig02
      sig3  = (2- fourthird * (sig02/sig2) **2)* sig1 * sig2

      return
      end

      subroutine muatco(xnval) 
c               * angular coefficients *
c        sous programmes utilises  cwig3j
c
      implicit double precision (a-h,o-z)
      dimension xnval(30)
      common/itescf/testy,rap(2),teste,nz,norb,norbsc
      common/mulabk/afgk
      dimension afgk(30,30,0:3)
      common/ratom1/xnel(30),en(30),scc(30),scw(30),sce(30),
     1nq(30),kap(30),nmax(30)
c#mn
       external cwig3j

      do 511 i=1,30
         do 511 j=1,30
            do 511 k=0,3
               afgk(i,j,k)=0.0d00
 511  continue 
      do 701 i=1,norb
         li= abs(kap(i))*2-1
         do 701 j=1,i
            lj= abs(kap(j))*2-1
            kmax=(li+lj)/2
            kmin= abs(li-lj)/2
            if ((kap(i)*kap(j)).lt.0) kmin=kmin+1
c calculate a_k(i,j)
            m=0
            if (j.eq.i .and. xnval(i).le.0.0d0) m=1
c           use to test SIC
c           if (j.eq.i) m=1

            afgk(j,i,0)=afgk(j,i,0)+xnel(i)*(xnel(j)-m)
            if (xnval(i).gt.0.0d0 .and. xnval(j).gt.0.0d0) goto 700
c calculate b_k(i,j)
            b=afgk(j,i,0)
            if (j.eq.i .and. xnval(i).le.0.0d0) then
               a=li
               b=-b*(a+1.0d 00)/a
               kmin = kmin+2
            endif
            do 675 k = kmin, kmax,2
               afgk(i,j,k/2)=b*(cwig3j(li,k*2,lj,1,0,2)**2)
 675        continue

 700        continue
 701  continue
      return
      end

      subroutine prcrit (neout, nncrit, ik0out, cksp, fbeta, ckspc, 
     1                   fbetac, potlb0)
      implicit double precision (a-h, o-z)

c     Prepare fbeta arrays, etc., for pathfinder criteria
c
c     Note that path finder is single precision, so be sure that
c     things are correct precision in calls and declarations!
c     See declarations below for details.
c     
c     Inputs:  Reads phase.bin
c     Output:  neout   'ne', number of energy grid points
c              ik0out  index of energy grid with k=0
c              cksp    |p| at each energy grid point in single precision
c              fbeta   |f(beta)| for each angle, npot, energy point, sp
c              ckspc   |p| at each necrit point in single precision
c              fbetac  |f(beta)| for each angle, npot, nncrit point, sp
c              potlb0  unique potential labels

      include 'const.h'
      include 'dim.h'
      include 'pdata.h'

c     Output variables SINGLE PRECISION for use with path finder.
c     BE CAREFUL!!
      parameter (necrit=9, nbeta=40)
      real fbetac(-nbeta:nbeta,0:npotx,necrit), ckspc(necrit)
      real fbeta(-nbeta:nbeta,0:npotx,nex), cksp(nex)
      character*6  potlb0(0:npotx)
      character*128 messag

c     Local variables
      complex*16 cfbeta, tl
      dimension dcosb(-nbeta:nbeta)
      dimension pl(ltot+1)
      dimension iecrit(necrit)

cc      print*, 'prcrit 01 ne = ' , ne
c     Need stuff from phase.bin
c     Read phase calculation input, data returned via commons
      open (unit=1, file='phase.bin', status='old',
     1      access='sequential', form='unformatted', iostat=ios)
      call chopen (ios, 'phase.bin', 'prcrit')
      call rphbin (1)
      close (unit=1)
c     Pass out ne, ik0, potlbl (from rphbin via /pdata/)
      neout = ne
cc      print*, 'prcrit 02 ne = ' , ne
      ik0out = ik0
      do 40  i = 0, npotx
         potlb0(i) = potlbl(i)
   40 continue

c     |p| at each energy point (path finder uses invA, convert here)
      do 100  ie = 1, ne
         cksp(ie) = abs (sqrt (em(ie) - eref(ie))) / bohr
  100 continue

c     Make the cos(beta)'s
c     Grid is from -40 to 40, 81 points from -1 to 1, spaced .025
      do 200  ibeta = -nbeta, nbeta
         dcosb(ibeta) = 0.025 * ibeta
  200 continue
c     watch out for round-off error
      dcosb(-nbeta) = -1
      dcosb(nbeta)  =  1

c     make fbeta (f(beta) for all energy points
      do 280  ibeta = -nbeta, nbeta
         call cpl0 (dcosb(ibeta), pl, lmaxp1)
         do 260  iii = 0, npot
            do 250  ie = 1, ne
               cfbeta = 0
               do 245  il = 1, lmax(ie,iii)+1
                  tl = (exp (2*coni*ph(ie,il,iii)) - 1) / (2*coni)
                  cfbeta = cfbeta + tl*pl(il)*(2*il-1)
  245          continue
               fbeta(ibeta,iii,ie) = abs(cfbeta)
  250       continue
  260    continue
  280 continue

c     Make similar arrays for only the icrit points

c     Use 9 points at k=0,1,2,3,4,6,8,10,12 invA
c     See phmesh for energy gid definition.  These seem to work fine, 
c     and results aren't too sensitive to choices of k.  As few as 4
c     points work well (used 0,3,6,9), but time penalty for 9 points
c     is small and increased safety seems to be worth it.
      iecrit(1) = ik0
      iecrit(2) = ik0 + 5
      iecrit(3) = ik0 + 10
      iecrit(4) = ik0 + 15
      iecrit(5) = ik0 + 20
      iecrit(6) = ik0 + 30
      iecrit(7) = ik0 + 34
      iecrit(8) = ik0 + 38
      iecrit(9) = ik0 + 40

c     make sure that we have enough energy grid points to use all
c     9 iecrits
      nncrit = 0
      do 290  ie = 1, necrit
         if (iecrit(ie) .gt. ne)  goto 295
         nncrit = ie
  290 continue
  295 continue
       if (nncrit .eq. 0) call fstop(' at PRCRIT: bad nncrit')
       write(messag,'(1x,a,i7)') ' nncrit in prcrit ', nncrit
       call echo(messag)

      do 320  icrit = 1, nncrit
         ie = iecrit(icrit)
         ckspc(icrit) = cksp(ie)
         do 310  ibeta = -nbeta, nbeta
            do 300  iii = 0, npot
               fbetac(ibeta,iii,icrit) = fbeta(ibeta,iii,ie)
  300       continue
  310    continue
  320 continue

      return
      end

      subroutine mrb (npat, ipat, ri, beta)

c     Make ri, beta and rpath path parameters for crit calculations.

c     Input is list of atoms (npat, ipat(npat)), output is
c     ri(npat+1), beta, eta.

      include 'dim.h'
      dimension ipat(npatx)

      common /atoms/ rat(3,0:natx), ipot(0:natx), i1b(0:natx)

      dimension beta(npatx+1), ri(npatx+1), ipat0(npatx+1)

      nleg = npat+1
c     central atom is atom 0 in rat array
c     need local ipat0 array since we use ipat0(npat+1), final atom
c     in path (final atom is, of course, the central atom)
      do 10  i = 1, npat
         ipat0(i) = ipat(i)
   10 continue
      ipat0(nleg) = 0

      do 30  ileg = 1, nleg
c        make beta and ri for point i from 1 to N
c        NB: N is npat+1, since npat is number of bounces and N is
c            number of legs, or think of N=npat+1 as the central atom
c            that is the end of the path.
c
c        We'll need angles from n-1 to n to 1,
c        so use rat(n+1) = rat(1), so we don't have to write code
c        later to handle these cases.

c        Work with atom j
c        jp1 = (j+1)
c        jm1 = (j-1)
         j = ileg
         jm1 = j-1
         jp1 = j+1
c        Fix special cases (wrap around when j is near central atom,
c        also handle ss and triangular cases).
         if (jm1 .le.    0)  jm1 = nleg
         if (jp1 .gt. nleg)  jp1 = 1

         jat = ipat0(j)
         jm1at = ipat0(jm1)
         jp1at = ipat0(jp1)

         ri(ileg) = sdist (rat(1,jat), rat(1,jm1at))

c        Make cos(beta) from dot product
         call dotcos (rat(1,jm1at), rat(1,jat), rat(1,jp1at),
     1               beta(ileg))
   30 continue

      rpath = 0
      do 60  ileg = 1, nleg
         rpath = rpath + ri(ileg)
   60 continue

      return
      end
      subroutine dotcos (rm1, r, rp1, cosb)
      dimension rm1(3), r(3), rp1(3)

      parameter (eps = 1.0e-8)

      cosb = 0
      do 100  i = 1, 3
         cosb = cosb + (r(i)-rm1(i)) * (rp1(i)-r(i))
  100 continue

c     if denom is zero (and it may be if 2 atoms are in the same place,
c     which will happen when last path atom is central atom), set
c     cosb = 0, so it won't be undefined.

      denom = (sdist(r,rm1) * sdist(rp1,r))
      if (denom .gt. eps)  then
         cosb = cosb / denom
      else
         cosb = 0
      endif
      return
      end

      subroutine mcrith (npat, ipat, ri, indbet,
     1                   ipot, nncrit, fbetac, ckspc, xheap)

      include 'const.h'
      include 'dim.h'
      dimension ipat(npatx)
      dimension ri(npatx+1), indbet(npatx+1)
      dimension ipot(0:natx)
      parameter (necrit=9, nbeta=40)
      dimension fbetac(-nbeta:nbeta,0:npotx,necrit), ckspc(necrit)

c     Decide if we want the path added to the heap.

      if (ipat(npat) .eq. 0 .or. npat.le.2)  then
c        Partial path is used for xheap, not defined for ss and
c        triangles.  Special case: central atom added to end of path 
c        necessary for complete tree, but not a real path, again,
c        xheap not defined.  Return -1 as not-defined flag.
         xheap = -1
      else
c        Calculate xheap and see if we want to add path to heap.
c        Factor for comparison is sum over nncrit of
c        f(beta1)*f(beta2)*..*f(beta npat-2)/(rho1*rho2*..*rho npat-1).
c        Compare this to sum(1/p), multiply by 100 so we can think 
c        in percent.  Allow for degeneracy when setting crit.
         xheap = 0
         spinv = 0
         do 340  icrit = 1, nncrit
            x = ckspc(icrit) ** (-(npat-1)) * ri(npat-1)
            do 320  i = 1, npat-2
               ipot0 = ipot(ipat(i))
               x = x * fbetac(indbet(i),ipot0,icrit) / ri(i)
  320       continue
            spinv = spinv + 1/ckspc(icrit)
            xheap = xheap + x
  340    continue
         xheap = 100 * xheap / spinv

c        Factor for comparison is sum over nncrit of
c        New xheap:
c        Full chi is
c f(beta1)*f(beta2)*..*f(beta npat)cos(beta0)/(rho1*rho2*..*rho nleg).
c Some of this stuff may change when the path is modified --
c we can't use rho nleg or nleg-1, beta0, beta(npat) or beta(npat-1).
c We DO want to normalize wrt first ss path, f(pi)/(rho nn)**2.
c
c So save f(pi)/(rho nn)**2, 
c calculate 
c f(beta1)*f(beta2)*..*f(beta npat-2)/(rho1*rho2*..*rho npat-1).
c divide nn ss term by stuff we left out -- beta(npat), beta(npat-1),
c cos(beta0), rho nleg, rho nleg-1.
c
c Sum this over nncrit and try it out.
*
c        Sum over nncrit of
c        1/(rho1+rho2+..+rho npat-1).
*        reff = 0
*        do 350  i = 1, npat-1
*           reff = reff + ri(i)
* 350    continue
*        xss = 0
*        do 360  icrit = 1, nncrit
*           rho = ckspc(icrit) * reff
*           xss = xss + 1/rho
* 360    continue
*        xheap = 100 * xheap / xss
      endif

      return
      end

      subroutine inipotph(
     1       ntitle, title,                                             ! TITLE
     2       nat, rat, iphat,                                           ! ATOMS
     3       nph, iz, potlbl, lmaxsc, lmaxph, xnatph, spinph,           ! POTENTIALS
     4       ihole,                                                     ! HOLE/EDGE
     5       rfms1, lfms1, nscmt, ca1, nmix, ecv, icoul,                ! SCF
     6       ipol, evec, elpty, xivec,                                  ! POLARIZATION, ELLIPTICITY
     7       ispin, spvec, angks,                                       ! SPIN
     8       ptz, gamach,                                               ! computed
     9       ixc, vr0, vi0, ixc0,                                       ! EXCHANGE
     _       iafolp, folp, xion, rgrd, iunf,                            ! AFOLP, FOLP, ION, RGRID, UNFREEZEF
     1       inters, totvol, jumprm, nohole, iplsmn)                    ! INTERSTITIAL, JUMPRM, NOHOLE, PLASMON

c$$$(nat, rat, iphat,
c$$$     1       le2, elpty, angks, evec, xivec, spvec, ptz,
c$$$     2       nabs, iphabs, rclabs, ipol, ispin,
c$$$     3       mpot, rgrd, ntitle, title, ipr1, ispec,
c$$$     4       nohole, ihole, gamach, nph, iz, lmaxsc, xnatph,
c$$$     5       xion, iunf, ixc, jumprm, iafolp, folp, inters, totvol,
c$$$     6       rfms1, lfms1, nscmt, ca1, nmix, ecv, icoul,
c$$$     7       mphase, ipr2, vixan, xkstep, xkmax,
c$$$     8       lmaxph, potlbl, spinph, vr0, vi0, ixc0, lreal, 
c$$$     9       rfms2, lfms2, l2lp, iPl, iGrid,
c$$$     _       izstd, ifxc, ipmbse, itdlda, nonlocal, ibasis)


      implicit double precision (a-h, o-z)

      include '../HEADERS/const.h'
      include '../HEADERS/dim.h'


c     dimension/types of atoms & global.json things
      integer nat, iphat(natx), nabs, iphabs, ipol, ispin, le2
      double precision evec(3), xivec(3), spvec(3), elpty,angks,rclabs
      complex*16 ptz(-1:1, -1:1)
      double precision rat(3,natx)


c     dimension/type os mod1/pot things
c      integer  iatph(0:nphx), ibounc(natx)
      character*80 title(nheadx)
c     character*80 head(nheadx)
c     integer lhead(nheadx)
      integer mpot, nph, ntitle, ihole, ipr1, iafolp, ixc, iplsmn,
     1       iunf, nmix, nohole, jumprm, inters, nscmt, icoul, lfms1
      integer iz(0:nphx), lmaxsc(0:nphx)
      real rfms1
      double precision gamach, rgrd, ca1, ecv, totvol
      double precision  xnatph(0:nphx), folp(0:nphx), xion(0:nphx)
c     for OVERLAP option
c      integer novr(0:nphx), iphovr(novrx,0:nphx), nnovr(novrx,0:nphx)
c      double precision  rovr(novrx,0:nphx)


c     dimension/type os mod2/xpsh things
      integer mphase, ipr2, ixc0, ispec, lreal, lfms2, l2lp, 
     1       iGrid
      double precision xkstep, xkmax, vixan
      double precision vr0, vi0, spinph(0:nphx)
      real rfms2
      integer lmaxph(0:nphx)
      character*6  potlbl(0:nphx)
      integer izstd, ifxc, ipmbse, itdlda, nonlocal, ibasis

      parameter (big = 1.0d5)


c*****************************************************************************
c     initialize everything

      nat      = 0
      nabs     = 0
      iphabs   = 0
      ipol     = 0 
      ispin    = 0
      le2      = 0
      mpot     = 1
      nph      = 0
      ntitle   = 0
      ihole    = 0
      ipr1     = 0
      iafolp   = 0
      ixc      = 0
      iunf     = 0
      nmix     = 0
      nohole   = -1
      jumprm   = 0
      inters   = 0
      nscmt    = 0
      icoul    = 0
      lfms1    = 0
      mphase   = 0
      ipr2     = 0
      ixc0     = -1
      ispec    = 0
      lreal    = 0
      lfms2    = 0
      l2lp     = 0
      iplsmn   = 0
      iGrid    = 0
      izstd    = 0
      ifxc     = 0
      ipmbse   = 0
      itdlda   = 0
      nonlocal = 0
      ibasis   = 0

      elpty  = 0.0d0
      angks  = 0.0d0
      rclabs = big
      gamach = 0.0d0
      rgrd   = 0.05d0
      ca1    = 0.0d0
      ecv    = -40.0d0
      totvol = 0.0d0
      xkmax  = 20.0d0 * bohr
      xkstep = 0.07d0 * bohr
      vixan  = 0.0d0 / hart
      vr0    = 0.0d0 / hart
      vi0    = 0.0d0 / hart

      rfms1  = real(-1.) / real(bohr)
      rfms2  = real(-1.) / real(bohr)

      do 10 i=0,nphx
         lmaxph(i) = 0
         iz(i)     = 0
         lmaxsc(i) = 0
         potlbl(i) = ' '
         xnatph(i) = 0.0d0
         spinph(i) = 0.0d0
         folp(i)   = 1.0d0
         xion(i)   = 0.0d0
 10   continue
      do 20 i=1,natx
         iphat(i) = -1
 20   continue

      do 35 i=-1,1
         do 30 j=-1,1
            ptz(i,j) = dcmplx(0.0d0,0.0d0)
 30      continue
 35   continue

      do 40 i=1,3
         evec(i)  = 0.0d0
         xivec(i) = 0.0d0
         spvec(i) = 0.0d0
 40   continue

      do 55 i=1,3
         do 50 j=1,natx
            rat(i,j) = 0.0d0
 50      continue
 55   continue

      do 60 i=1,nheadx
         title(i)  = ' '
 60   continue

      return
      end

      subroutine s02at(ihole, norb, nk, xnel, ovpint, dval)
      implicit double precision (a-h,o-z)
      double precision  m1(7,7), m2(7,7)
      dimension nk(30), xnel(30), iorb(30), ovpint(30,30)

      dval = 1.0
c     loop over possible kappa for existing atoms
      do 100 kap = -4,3

c        initialize matrices and other stuff
         do 10 i = 1,7
         do 10 j = 1,7
            m1(i,j) = 0
  10        m2(i,j) = 0
         do 20 i= 1,7
            iorb(i) = 0
            m1(i,i) = 1.0
  20        m2(i,i) = 1.0
c        morb - number of orbitals with quantum number kappa
         morb = 0
         nhole = 0

c        construct the largest possible matrix for given value of kappa.
         do 40 i = 1, norb
            if (nk(i) .eq. kap) then
               morb = morb + 1
               iorb(morb) = i
               do 50 j = 1, morb
c                 print overlap integrals
c                 print*, kap,' ', iorb(j),' ', iorb(morb), '
c    1                            ovp= ',ovpint(iorb(j), iorb(morb))
   50             m1(j,morb) = ovpint(iorb(j), iorb(morb))
               do 60 j = 1, morb - 1
   60             m1(morb,j) = m1(j,morb)
               
               if (ihole .eq. i) nhole = morb
            endif
   40    continue
         if (morb .eq. 0) goto 100
         dum1 = determ(m1, morb, 7)
         dum1 = dum1**2

         dum3 = determ(m1, morb-1, 7)
         dum3 = dum3**2
         xn = xnel(iorb(morb))
         nmax = 2*abs(kap)
         xnh = nmax - xn
         if (nhole .eq. 0) then 
            dval = dval * dum1**xn * dum3**xnh
         elseif (nhole .eq. morb) then
            dval = dval * dum1**(xn-1) * dum3**(xnh+1)
         else
            call elimin(m1,nhole,m2)
            dum2 = determ(m2,morb,7)
            dum2 = dum2**2
            dum4 = determ(m2,morb-1,7)
            dum4 = dum4**2
            dum5 = (dum4*dum1*xnh + dum2*dum3*xn)/nmax
            dval = dval * dum5 * dum1**(xn-1) * dum3**(xnh-1)
         endif

100   continue

      return
      end

      subroutine elimin(d1,n,d2)
      implicit double precision (a-h,o-z)
      dimension d1(7,7), d2(7,7)

      do 10 i = 1,7
      do 10 j = 1,7
         if (i .ne. n) then
            if (j .ne. n) then
               d2(i,j)=d1(i,j)
            else
               d2(i,j) = 0
            endif
         else
            if (j .ne. n) then
               d2(i,j) = 0
            else
               d2(i,j) = 1.0
            endif
         endif
   10 continue
      return
      end

      subroutine corval (verbse,
     1       ecv, xnvmu, eorb, norb, xnval, kappa, rgrd,
     2       nohole, nph, edens, edenvl, vtot, vvalgs,
     3       rmt, rnrm, ixc, rhoint, vint, jumprm,
     4       x0, ri, dx, xion, iunf, iz,
     5       adgc, adpc, dgc, dpc, ihole, lmaxsc)

c     Finds the core-valence separation for the cluster of atoms.
c     written by ala 10 1998

c     Input: necessary atomic data and the muffin-tin potential data
c     Output:
c          xnvmu - number of valence atoms for each channel
c          ecv   - core-valence separation energy
c     Algorithm:
c       definite valence electron - above -20 eV;
c       definite core electrons   - below -70 ev;
c       first find suspicious points in LDOS (central atom only)
c       between -20 and -70, which are written in eldos array
c       After sorting, the lowest valence state is found and
c       all core states above this energy are reassigned to valence.
c       The "ecv" should be between the lowest valence energy and
c       the highest core level. Also it should be far enough 
c       (see variable tol) from both of the above levels and V_int.
c       If fails to find "ecv" for a given core-valence separation,
c       then the highest core level is reassigned to valence and
c       attempt to find "ecv' is repeated.

      implicit double precision (a-h, o-z)
      include '../HEADERS/dim.h'
      include '../HEADERS/const.h'

c     input
      dimension dmagx(nrptx), dmag0(251)
      dimension vtot (251,0:nphx), vvalgs (251,0:nphx)
      dimension xnvmu(0:lx,0:nphx+1), rmt(0:nphx),rnrm(0:nphx)
      dimension ri(nrptx), ri05(251)
      dimension iz(0:nphx), xion(0:nphx),xnval(30,0:nphx)
      dimension norb(0:nphx), kappa(30,0:nphx), iiorb(0:lx,0:nphx)
      dimension eorb(30,0:nphx), eldos(0:lx,0:nphx)
      dimension lmaxsc(0:nphx), ival(0:lx, 0:nphx), ifound(0:lx)
c     input and output
      dimension edens(251,0:nphx), edenvl(251,0:nphx)

c     work space
      dimension dum(nrptx), vtotph(nrptx),vvalph(nrptx)
      dimension dgc(251,30,0:nphx+1), dpc(251,30,0:nphx+1)
      dimension adgc(10,30,0:nphx+1), adpc(10,30,0:nphx+1)
      dimension dgcn(nrptx,30), dpcn(nrptx,30)
      complex*16 xrhoce(0:lx)
      complex*16 xrhole(0:lx)
      complex*16 yrhoce(251)
      complex*16 yrhole(251,0:lx)
      complex*16 ph(lx+1)
c     dimension 32 = (0:lx)*(0:nphx)
      dimension en(32)
      integer ll(32), ip(32), icv(32)
      complex*16 emg, eref, eimag
      dimension xp(0:lx), xpeak(0:lx)
c     stuff from feff.f for rdinp, pathfinder and genfmt
c     Following passed to pathfinder, which is single precision.
      character*512 slog
      logical ok, verbse

      do 5 i=1,32
         en(i)  = 0.0d0
         ll(i)  = 0
         ip(i)  = 0
         icv(i) = 0
 5    continue

      if (verbse) then
         write (slog,10) 
 10      format('              Core-valence separation ')
         call wlog(slog)
      endif

c     initialize staff
      do 15 i= 1,251
        dmag0(i) = 0.d0
  15  ri05(i) = exp (-8.8d0+0.05d0*(i-1))
      do 20 iph = 0, nphx
      do 20 il = 0, lx
         eldos(il, iph) = 0
         iiorb(il, iph) = 0
         ival(il, iph) = 0
  20  continue

      tol = 5.0d0/hart
      if (vint - ecv.lt.tol) ecv = vint - tol
      elow = -70.0d0/hart
      ehigh = -20.0d0/hart
      eimag = coni*1.5d0/hart
c     make energy step about 0.5 eV
      ne = 1 + nint((ehigh-elow)*2*hart)
      de = (ehigh-elow)/(ne-1)

c     find out problematic energies for core-valence separation
      do 100 iph = 0, nph
      do 100 iorb = 1, norb(iph)
        if (eorb(iorb,iph).lt.ehigh-tol.and.eorb(iorb,iph).gt.elow) then
          lll = -kappa(iorb,iph) - 1
          if (lll.lt.0) lll = kappa(iorb,iph)
c        skip in special case for Hf,Lu,Ta; treat f-electrons as valence
c        or as core according to UNFREEZEF
          if((iz(iph).ge.71.and.iz(iph).le.73) .and. lll.eq.3) goto 100
          if(iunf.eq.0 .and. lll.eq.3) goto 100

          eldos(lll,iph) = eorb(iorb,iph)
          ival(lll,iph) = 1
          if (xnval(iorb,iph).lt. 0.1d0) ival(lll,iph)=-1
          iiorb(lll,iph) = iorb
        endif
  100 continue

      do 500  iph = 0, nph
         call fixvar (rmt(iph),edens(1,iph),vtot(1,iph),dmag0,
     1                vint, rhoint, dx, rgrd, jumprm,
     2                vjump, ri, vtotph, dum, dmagx)
         if (mod(ixc,10) .ge.5) then
            if (jumprm .gt. 0) jumprm = 2
            call fixvar (rmt(iph), edenvl(1,iph), vvalgs(1,iph),
     1                dmag0, vint, rhoint, dx, rgrd , jumprm,
     2                vjump, ri, vvalph, dum, dmagx)
            if (jumprm .gt. 0) jumprm = 1
         endif
         call fixdsx (iph, dx, rgrd , dgc, dpc, dgcn, dpcn)

         jri = int((log(rmt(iph)) + x0) / rgrd) + 2
         jri1 = jri+1
         eref = vtotph(jri1)
         do 40 i = 1, jri1
  40     vtotph(i) = vtotph(i) - dble(eref)
         if (ixc.ge.5) then
           do 50 i = 1, jri1
  50       vvalph(i) = vvalph(i) - dble(eref)
         else
           do 60 i = 1, jri1
  60       vvalph(i) = vtotph(i)
         endif
         itmp = 0
         if (iph.eq.0 .and. nohole.lt.0) itmp = ihole

         xx = dimag(eimag)
         nfound = 0
         do 80 il = 0,lx
           xpeak(il) = (2*il+1.d0)/(6*xx*pi)
           xp(il) = 0
           ifound(il) = 1
           if (ival(il,iph).ne.0) ifound(il) = 0
           nfound = nfound + ifound(il)
  80     continue
         if (nfound .eq. lx+1) goto 500

c        start the search for suspicious maxima in LDOS for iph
         ie = 0
  200    ie=ie + 1
            emg = elow + de*(ie-1) + eimag
            call rholie( ri05, nr05, rgrd, x0, ri, emg,
     2           ixc, rmt(iph), rnrm(iph),
     3           vtotph, vvalph, xnval(1,iph), dgcn, dpcn, eref,
     4           adgc(1,1,iph), adpc(1,1,iph), xrhole,
     5           xrhoce, yrhole, yrhoce, ph,
     6           iz(iph), xion(iph), iunf, itmp,lmaxsc(iph))

c           find the suspicious peaks on ldos and correct the energy
            nfound = 0
            do 400 il = 0, lx
               if (ival(il,iph).ne.0 .and. ifound(il).eq.0) then
c                suspicious ldos; find the first peak in ldos that
c                contains more than 1 electron is not found yet
                 xx = dimag(xrhoce(il))
                 if ((ie.eq.ne .or. xx.lt.xp(il)) .and.
     1                xp(il).gt.xpeak(il)) then
                   ifound(il) = 1
                   eldos(il,iph) = elow + de*(ie-2)
c      print*,iph,' approx count is ',xp(il)*pi*dimag(eimag),' in l=',il
                 else
                   xp(il) = xx
                 endif
               endif
               nfound = nfound + ifound(il)
  400       continue
         if (nfound.lt.lx+1 .and. ie.lt.ne) goto 200

         if (nfound.lt.lx+1) then 
            call wlog ('WARNING: fatal error in subroutine corval. Try')
            call wlog ('  to reduce ca1 in SCF card. If does not help,')
            call wlog ('SEND bug report to AUTHORS')
            call par_stop('CORVAL-1')
         endif
  500 continue

c     arrange suspicious levels in order
      ne = 0
      do 600 iph = 0,nph
      do 600  il = 0, lx
         if (eldos(il,iph) .lt. 0) then
            ne = ne + 1
c           find in which position to put the new energy
            inew = ne
            do 580 ie = 1,ne-1
               if (en(ie).gt.eldos(il,iph) .and. inew.eq.ne) inew = ie
  580       continue
            do 590 ie = ne-1,inew, -1
               en(ie+1) = en(ie)
               icv(ie+1) = icv(ie)
               ll(ie+1) = ll(ie)
               ip(ie+1) = ip(ie)
  590       continue
            en(inew) = eldos(il,iph)
            icv(inew) = ival(il,iph)
            ll(inew) = il
            ip(inew) = iph
         endif
  600 continue

c     goto exit if there is no suspicious points
      if (ne.eq.0) goto 999
 
c     find the highest core and lowest valence energies
      ic = 0
      iv = ne + 1
      do 700 ie = 1,ne
         if (icv(ie).eq.-1) then
            ic = ie
         else
            if (ie.lt.iv) iv = ie
         endif
  700 continue

c     change assignment from core to valence, if core state above lowest
c     valence
      do 720 ie=iv+1,ic
        if (icv(ie).lt.0) then
           iph = ip(ie)
           icv(ie) = 1
           ival(ll(ie),iph) = 1
c          update occupation number
           xnvmu(ll(ie), iph) = xnvmu(ll(ie), iph) + 4*ll(ie)+2
c          update valence density
           iorb = iiorb(ll(ie),iph)

           do 710 ir = 1,251
             edenvl(ir,iph) =  edenvl(ir,iph) + 2*(ll(ie)+1)*
     1       (dgc(ir,iorb,iph)**2 + dpc(ir,iorb,iph)**2)/ri05(ir)**2
             if (ll(ie).ne.0) then
               edenvl(ir,iph) =  edenvl(ir,iph) + 2*ll(ie)*
     1         (dgc(ir,iorb-1,iph)**2+dpc(ir,iorb-1,iph)**2)/ri05(ir)**2
             endif
  710      continue
        endif
  720 continue
      ic = iv - 1

c     check if suggested ecv is between core and valence
      ok = .false.
      if (ic.gt. 0) then
        if (iv.le.ne) then
          if (ecv-en(ic).gt.tol .and. en(iv)-ecv.gt.tol) ok = .true.
        else
          if (ecv-en(ic).gt.tol) ok = .true.
        endif
      else
        if (iv.le.ne) then
          if (en(iv)-ecv.gt.tol) ok = .true.
        endif
      endif
      if (ok) goto 999

  800 ecv = vint - tol
      if (iv.le.ne) ecv = min(ecv,en(iv)-tol)
      if (ic.eq.0) goto 899
      if (ecv-en(ic).gt.tol) goto 899

c     need to reassign the last core state to valence
      ic = ic - 1
      iv = iv - 1
      icv(iv) = 1
      ival(ll(iv),ip(iv)) = 1
      xnvmu(ll(iv),ip(iv)) =  xnvmu(ll(iv),ip(iv)) + 4*ll(iv)+2
c     update valence density
      iph = ip(iv)
      iorb = iiorb(ll(iv),iph)
      do 810 ir = 1,251
        edenvl(ir,iph) =  edenvl(ir,iph)+ 2*(ll(iv)+1)*
     1  (dgc(ir,iorb,iph)**2 + dpc(ir,iorb,iph)**2)/ri05(ir)**2
        if (ll(iv).ne.0) then
          edenvl(ir,iph) =  edenvl(ir,iph)+ 2*ll(iv)*
     1    (dgc(ir,iorb-1,iph)**2+dpc(ir,iorb-1,iph)**2)/ri05(ir)**2
        endif
  810 continue
      go to 800

899   continue
c     update the core valence separation in array xnval
c     need to do that for second call of 'corval' and for ixc=5,6
      do 900  ie = iv, ne
         iph = ip(ie)
         lll = ll(ie)
         iorb = iiorb(lll,iph)
         if (xnval(iorb,iph).lt.0.1d0) then
            xnval(iorb,iph) = 2*lll+2
            if (lll.gt.0) xnval(iorb-1,iph) = 2*lll
         endif
  900 continue

999   continue
      return
      end

      subroutine json_read_libpotph(
c     TITLE
     1       ntitle, title,
c     ATOMS
     2       nat, rat, iphat,
c     POTENTIALS
     3       nph, iz, potlbl, lmaxsc, lmaxph, xnatph, spinph,
c     HOLE/EDGE
     4       ihole,
c     SCF
     5       rfms1, lfms1, nscmt, ca1, nmix, ecv, icoul,
c     POLARIZATION, ELLIPTICITY
     6       ipol, evec, elpty, xivec,
c     SPIN
     7       ispin, spvec, angks,
c     computed
     8       ptz, gamach,
c     EXCHANGE
     9       ixc, vr0, vi0, ixc0,
c     AFOLP, FOLP, ION, RGRID, UNFREEZEF
     _       iafolp, folp, xion, rgrd, iunf,
c     INTERSTITIAL, JUMPRM, NOHOLE
     1       inters, totvol, jumprm, nohole, iplsmn)




c$$$(nat, rat, iphat,
c$$$     2       le2, elpty, angks, evec, xivec, spvec, ptz,
c$$$     1       nabs, iphabs, rclabs, ipol, ispin,
c$$$     5       mpot, rgrd, ntitle, title, ipr1, ispec,
c$$$     6       nohole, ihole, gamach, nph, iz, lmaxsc, xnatph,
c$$$     7       xion, iunf, ixc, jumprm, iafolp, folp, inters, totvol,
c$$$     8       rfms1, lfms1, nscmt, ca1, nmix, ecv, icoul,
c$$$     3       mphase, ipr2, vixan, xkstep, xkmax,
c$$$     7       lmaxph, potlbl, spinph, vr0, vi0, ixc0, lreal, 
c$$$     1       rfms2, lfms2, l2lp, iPl, iGrid,
c$$$     2       izstd, ifxc, ipmbse, itdlda, nonlocal, ibasis)

      use json_module
      implicit double precision (a-h, o-z)

      include '../HEADERS/const.h'
      include '../HEADERS/dim.h'

      logical :: found
      type(json_file) :: json   !the JSON structure read from the file:
      integer,dimension(:),allocatable :: intgs
      character*80,dimension(:),allocatable :: strings
      double precision,dimension(:),allocatable :: dbpcx, dbpcy, dbpcz
      double precision,dimension(:),allocatable :: dbpc1, dbpc2, dbpc3
      double precision,dimension(:),allocatable :: dbpc4, dbpc5, dbpc6
      double precision,dimension(:),allocatable :: dbpc7, dbpc8, dbpc9
      double precision,dimension(:),allocatable :: dbpc10

c     dimension/types of atoms.json things
c     dimension/types of global.json things
      integer nat, iphat(natx), ipol, ispin
      double precision evec(3), xivec(3), spvec(3), 
     1       rat(3,natx), elpty, angks
      complex*16 ptz(-1:1, -1:1)


c     dimension/type os mod1/pot things
      character*80 title(nheadx)
      integer nph, ntitle, ihole, iafolp, ixc, iplsmn,
     1       iunf, nmix, nohole, jumprm, inters, nscmt, icoul, lfms1
      integer iz(0:nphx), lmaxsc(0:nphx)
      real rfms1
      double precision gamach, rgrd, ca1, ecv, totvol
      double precision  xnatph(0:nphx), folp(0:nphx), xion(0:nphx)
c     for OVERLAP option
c$$ovr$$      integer novr(0:nphx), iphovr(novrx,0:nphx), nnovr(novrx,0:nphx)
c$$ovr$$      double precision  rovr(novrx,0:nphx)


      double precision vr0, vi0, spinph(0:nphx)
      integer lmaxph(0:nphx)
      character*6  potlbl(0:nphx)

c      integer iphabs, ipr1, le2, nabs
c      integer mpot, mphase, ipr2, ixc0, ispec, lreal, lfms2, l2lp, iPl, 
c     1       iGrid
c     double precision xkstep, xkmax, vixan, rclabs
c     real rfms2
c     integer izstd, ifxc, ipmbse, itdlda, nonlocal, ibasis

      character*32 s1, s2, s3

      call json%load_file('libpotph.json')
      if (json_failed()) then   !if there was an error reading the file
         print *, "failed to read libpotph.json"
         stop
      else

c        TITLE
         call json%get('ntitle', ntitle, found)
                if (.not. found) call bailout('ntitle', 'libpotph.json')
         call json%get('titles', strings, found)
                if (.not. found) call bailout('titles', 'libpotph.json')
         do 10 itit = 1, nheadx
            title(itit) = strings(itit)            
 10      continue


c        ATOMS
         call json%get('natt', nat, found)
                if (.not. found) call bailout('natt',   'libpotph.json')
         call json%get('x',    dbpcx, found)
                if (.not. found) call bailout('x',      'libpotph.json')
         call json%get('y',    dbpcy, found)
                if (.not. found) call bailout('y',      'libpotph.json')
         call json%get('z',    dbpcz, found)
                if (.not. found) call bailout('z',      'libpotph.json')
         call json%get('iphatx', intgs, found)
                if (.not. found) call bailout('iphatx', 'libpotph.json')
         do 20 i=1,nat
            iphat(i)  = intgs(i)
            rat(1,i)  = dbpcx(i)
            rat(2,i)  = dbpcy(i)
            rat(3,i)  = dbpcz(i)
 20      continue

c        POTENTIALS
         call json%get('nph',    nph, found)
                if (.not. found) call bailout('nph',    'libpotph.json')
         call json%get('iz', intgs, found)
                if (.not. found) call bailout('iz',     'libpotph.json')
         do 30 iph = 0, nphx
            iz(iph) = intgs(iph+1)            
 30      continue
         call json%get('potlbl', strings, found)
                if (.not. found) call bailout('potlbl', 'libpotph.json')
         do 40 itit = 1, nphx
c            potlbl(itit-1) = strings(itit)
            potlbl(itit-1) = strings(itit)(1:6)
 40      continue
         call json%get('lmaxsc', intgs, found)
                if (.not. found) call bailout('lmaxsc', 'libpotph.json')
         do 50 iph = 0, nphx
            lmaxsc(iph) = intgs(iph+1)            
 50      continue
         call json%get('lmaxph', intgs, found)
                if (.not. found) call bailout('lmaxph', 'libpotph.json')
         do 60 iph = 0, nphx
            lmaxph(iph) = intgs(iph+1)            
 60      continue
         call json%get('xnatph', dbpc1, found)
                if (.not. found) call bailout('xnatph', 'libpotph.json')
         do 70 iph = 0, nphx
            xnatph(iph) = dbpc1(iph+1)            
 70      continue
         call json%get('spinph', dbpc2, found)
                if (.not. found) call bailout('spinph', 'libpotph.json')
         do 80 iph = 0, nphx
            spinph(iph) = dbpc2(iph+1)            
 80      continue

c        HOLE/EDGE
         call json%get('ihole',  ihole, found)
                if (.not. found) call bailout('ihole',  'libpotph.json')

c        SCF
         call json%get('rfms1',  toss, found)   
                if (.not. found) call bailout('rfms1',  'libpotph.json')
         rfms1 = real(toss)
         call json%get('lfms1',  lfms1, found)
                if (.not. found) call bailout('lfms1',  'libpotph.json')
         call json%get('nscmt',  nscmt, found)
                if (.not. found) call bailout('nscmt',  'libpotph.json')
         call json%get('ca1',    ca1, found)
                if (.not. found) call bailout('ca1',    'libpotph.json')
         call json%get('nmix',   nmix, found)
                if (.not. found) call bailout('nmix',   'libpotph.json')
         call json%get('ecv',    ecv, found)
                if (.not. found) call bailout('ecv',    'libpotph.json')
         call json%get('icoul',  icoul, found)
                if (.not. found) call bailout('icoul',  'libpotph.json')

c        POLARIZATION, ELLIPTICITY
         call json%get('ipol', ipol, found)
                if (.not. found) call bailout('ipol',   'libpotph.json')
         call json%get('evec',  dbpc3, found)
                if (.not. found) call bailout('evec',   'libpotph.json')
         do 90 i=1,3
            evec(i) = dbpc3(i)
 90      continue
         call json%get('elpty', elpty, found)
                if (.not. found) call bailout('elpty',  'libpotph.json')
         call json%get('xivec',  dbpc4, found)
                if (.not. found) call bailout('xivec',  'libpotph.json')
         do 100 i=1,3
            xivec(i) = dbpc4(i)
 100     continue

c        SPIN
         call json%get('ispin', ispin, found)
                if (.not. found) call bailout('ispin',  'libpotph.json')
         call json%get('spvec',  dbpc5, found)
                if (.not. found) call bailout('spvec',  'libpotph.json')
         do 110 i=1,3
            spvec(i) = dbpc5(i)
 110     continue
         call json%get('angks', angks, found)
                if (.not. found) call bailout('angks',  'libpotph.json')


c        computed: ptz and gamach
         call json%get('ptz0',  dbpc6, found)
                if (.not. found) call bailout('ptz0',  'libpotph.json')
         ptz(-1,-1) = dcmplx(dbpc6(1), dbpc6(2))
         ptz( 0,-1) = dcmplx(dbpc6(3), dbpc6(4))
         ptz( 1,-1) = dcmplx(dbpc6(5), dbpc6(6))
         call json%get('ptz1',  dbpc7, found)
                if (.not. found) call bailout('ptz1',  'libpotph.json')
         ptz(-1, 0) = dcmplx(dbpc7(1), dbpc7(2))
         ptz( 0, 0) = dcmplx(dbpc7(3), dbpc7(4))
         ptz( 1, 0) = dcmplx(dbpc7(5), dbpc7(6))
         call json%get('ptz2',  dbpc8, found)
                if (.not. found) call bailout('ptz2',  'libpotph.json')
         ptz(-1, 1) = dcmplx(dbpc8(1), dbpc8(2))
         ptz( 0, 1) = dcmplx(dbpc8(3), dbpc8(4))
         ptz( 1, 1) = dcmplx(dbpc8(5), dbpc8(6))
         call json%get('gamach', gamach, found)
                if (.not. found) call bailout('gamach', 'libpotph.json')


c        EXCHANGE
         call json%get('ixc',    ixc, found)
                if (.not. found) call bailout('ixc',    'libpotph.json')
         call json%get('vro',   vr0, found)
                if (.not. found) call bailout('vr0',    'libpotph.json')
         call json%get('vio',   vi0, found)
                if (.not. found) call bailout('vi0',    'libpotph.json')
         call json%get('ixc0',   ixc0, found)
                if (.not. found) call bailout('ixc0',   'libpotph.json')

c        AFOLP, FOLP, ION, RGRID, UNFREEZEF
         call json%get('iafolp', iafolp, found)
                if (.not. found) call bailout('iafolp', 'libpotph.json')
         call json%get('folp', dbpc9, found)
                if (.not. found) call bailout('folp',   'libpotph.json')
         do 120 iph = 0, nphx
            folp(iph) = dbpc9(iph+1)            
 120    continue
         call json%get('xion', dbpc10, found)
                if (.not. found) call bailout('xion',   'libpotph.json')
         do 130 iph = 0, nphx
            xion(iph) = dbpc10(iph+1)            
 130    continue
         call json%get('rgrd',   rgrd, found)
                if (.not. found) call bailout('rgrd',   'libpotph.json')
         call json%get('iunf',   iunf, found)
                if (.not. found) call bailout('iunf',   'libpotph.json')
         

c        INTERSTITIAL, JUMPRM, NOHOLE, PLASMON
         call json%get('inters', inters, found)
                if (.not. found) call bailout('inters', 'libpotph.json')
         call json%get('totvol', totvol, found)
                if (.not. found) call bailout('totvol', 'libpotph.json')
         call json%get('nohole', nohole, found)
                if (.not. found) call bailout('nohole', 'libpotph.json')
         call json%get('jumprm', jumprm, found)
                if (.not. found) call bailout('jumprm', 'libpotph.json')
c         call json%get('iplsmn', iplsmn, found)
c                if (.not. found) call bailout('iplsmn', 'libpotph.json')


c The rest are parameters associated with:
c    CFAVERAGE, MULTIPOLE, XANES, FMS, PMBSE, TDLDA, RPHASES
c    CONTROL, PRINT 

c        content of global.json
c         call json%get('nabs', nabs, found)
c                if (.not. found) call bailout('nabs',   'libpotph.json')
c         call json%get('iphabs', iphabs, found)
c                if (.not. found) call bailout('iphabs', 'libpotph.json')
c         call json%get('rclabs', rclabs, found)
c                if (.not. found) call bailout('rclabs', 'libpotph.json')
c         call json%get('le2', le2, found)
c                if (.not. found) call bailout('le2',    'libpotph.json')



c        content of pot/mod1.json (except overlap stuff)
c         call json%get('mpot',   mpot, found)
c                if (.not. found) call bailout('mpot',   'libpotph.json')
c         call json%get('ipr1',   ipr1, found)
c                if (.not. found) call bailout('ipr1',   'libpotph.json')
c         call json%get('ispec',  ispec, found)
c                if (.not. found) call bailout('ispec',  'libpotph.json')




c        content of xsph/mod2.json
c         call json%get('mphase',   mphase, found)
c                if (.not. found) call bailout('mphase', 'libpotph.json')
c         call json%get('ipr2',   ipr2, found)
c                if (.not. found) call bailout('ipr2',   'libpotph.json')
c         call json%get('lreal',   lreal, found)
c                if (.not. found) call bailout('lreal',  'libpotph.json')
c         call json%get('lfms2',   lfms2, found)
c                if (.not. found) call bailout('lfms2',  'libpotph.json')
c         call json%get('l2lp',   l2lp, found)
c                if (.not. found) call bailout('l2lp',   'libpotph.json')
c         call json%get('iGrid',   iGrid, found)
c                if (.not. found) call bailout('iGrid',  'libpotph.json')


c         call json%get('rfms2',  toss, found)
c                if (.not. found) call bailout('rfms2',  'libpotph.json')
c         rfms2 = real(toss)
c         call json%get('xkstep',   xkstep, found)
c                if (.not. found) call bailout('xkstep', 'libpotph.json')
c         call json%get('xkmax',   xkmax, found)
c                if (.not. found) call bailout('xkmax',  'libpotph.json')
c         call json%get('vixan',   vixan, found)
c                if (.not. found) call bailout('vixan',  'libpotph.json')

c         call json%get('izstd',   izstd, found)
c                if (.not. found) call bailout('izstd')
c         call json%get('ifxc',   ifxc, found)
c                if (.not. found) call bailout('ifxc')
c         call json%get('ipmbse',   ipmbse, found)
c                if (.not. found) call bailout('ipmbse')
c         call json%get('itdlda',   itdlda, found)
c                if (.not. found) call bailout('itdlda')
c         call json%get('nonlocal',   nonlocal, found)
c                if (.not. found) call bailout('nonlocal')
c         call json%get('ibasis',   ibasis, found)
c                if (.not. found) call bailout('ibasis')


         call json%destroy()
      end if

c********************************************************************************
c     the 3000s are taken straight from reapot.f
c     transform to code units (bohrs and hartrees - atomic unuts)
      rfms1 = rfms1 / real(bohr)
      gamach = gamach / hart
      ecv   = ecv   / hart
      totvol = totvol / bohr**3
      do 3010 iat = 1, nat
         do 3000 i = 1,3
            rat(i,iat) = rat (i, iat) / bohr
 3000    continue
 3010 continue

c$$ovr$$      do 3030 iph = 0, nph
c$$ovr$$         do 3020 iovr = 1, novr(iph)
c$$ovr$$            rovr(iovr,iph) = rovr(iovr,iph) / bohr
c$$ovr$$ 3020    continue
c$$ovr$$ 3030 continue

c     add lines to the title
c      if (mpot.eq.1) then
      ntitle = ntitle + 1
      if (nat.gt.1) then
         if (rfms1.lt.0) rfms1 = 0
         if (nscmt.gt.0) then
            write(s1, 3230) nscmt, rfms1*bohr, lfms1
 3230       format(' POT  SCF', i4, f8.4, i4)
         else
            write(s1, 3235) 
 3235       format(' POT  Non-SCF' )
         endif
      else
         write(s1, 3240) 
 3240    format(' POT  used OVERLAP geometry,')
      endif
      if (nohole.eq.0) then
         write(s2, 3310) 
 3310    format(', NO core-hole,')
      elseif (nohole.eq.2) then
         write(s2, 3315) 
 3315    format(', screened core-hole,')
      else
         write(s2, 3320) 
 3320    format(', core-hole,')
      endif
      if (iafolp.lt.0) then
         write(s3, 3330) folp(0)
 3330    format(' FOLP (folp(0)=', f6.3, ')' )
      else
         write(s3, 3340) folp(0)
 3340    format(' AFOLP (folp(0)=', f6.3, ')' )
      endif
c     concatenate 3 strings into 1
      title(ntitle) = ' '
      ilen   = istrln(s1)
      istart = 1
      iend   = ilen
      title(ntitle)(istart:iend) = s1(1:ilen)
      ilen   = istrln(s2)
      istart = iend + 1
      iend   = iend + ilen
      title(ntitle)(istart:iend) = s2(1:ilen)
      ilen   = istrln(s3)
      istart = iend + 1
      iend   = iend + ilen
      title(ntitle)(istart:iend) = s3(1:ilen)
c     endif


      return
      end

c---------------------------------------------------------------------
c     program sigem
c
c     calculate the Debye-Waller factors for each MS path
c     using the equation-of-motion methods
c
c     input files:  feff.inp and spring.inp
c
c     version 2  ( January 99)
c
c     coded by  A. Poiarkova
c
c---------------------------------------------------------------------
c  References:
c             for the EM method: Phys. Rev. B , 59, p.948, 1999
c     also see dissertation
c        "X-ray Absorption Fine Structure Debye-Waller Factors"
c         by Anna V. Poiarkova
c
c---------------------------------------------------------------------
c         tk temperature in degrees K
c         nleg  nlegs in path
c         rat   positions of each atom in path
c         NB Units of distance in this routine
c            are angstroms, including sig2.
c         sig2 is output DW factor
c
c---------------------------------------------------------------------
      subroutine sigem (sig2mx, sig2x, iem, tk, ipath, nleg, rat, sig2)
      implicit double precision (a-h, o-z)

      parameter (natxdw = 200, nlegx1 = 9, nphx1=7)
      include '../HEADERS/parallel.h'

c feff parameters (from dim.h):
c     parameter (legtot=9)
c     parameter (nphx = 7)

      parameter (nphx = nphx1)
      parameter (natx = natxdw)

c local parameters:
      parameter (amu0 = 1.660539040d0)
      parameter (pi = 3.14159 26535 89793 23846 26433d0)
      parameter (nwx = 700)

      double precision sig2mx, sig2x(0:nphx,0:nphx)
      dimension iphat(natx), izph(0:nphx)

c variables shared with rdspr.f:
      dimension rat1(3,natx), iz(natx)
      dimension dm(3,3,natx,natx)
      dimension rnn(3,natx,natx)
      dimension nnl(natx,natx)

c local variables:
      dimension rat(3,0:nlegx1)
      dimension nconv(0:nlegx1)
      dimension q0(3,natx)
      dimension gr(nwx), w(nwx)
      dimension nq0(0:nlegx1)
      dimension uu(3,natx), up(3,natx), ff(3,natx)

      character*30  fname
      parameter (ntitx1 = 10)
      character*71  title(ntitx1)
      dimension ltit(ntitx1)
c     character*80  titlep(ntitx1)

      character*512 slog
      logical iem_open

      save
      data nsigc /0/
c-------------------------------------------------------------

      inquire(unit=iem,opened=iem_open)
      if (nsigc.eq.0) then

c Read coordinates and potentials from feff.inp
      call dwrdin (rat1, iphat, izph, natom,
     1            ntitle, title, ltit)

      if (natom.gt.natx) natom=natx
      do 5 iat=1, natom
         iz(iat) = izph(iphat(iat))
         if (iphat(iat).eq.0) i0=iat
  5   continue

c Read spring.inp and build dynamical matrix
      call rdspr(rat1, iz, natom, i0,
     1           dm, rnn,
     1           acut, res, wmax, dosfit, zshell, w0,
     1           rintr, iprdos, nnl)

            write(slog,7)
   7        format(2x,'Calculating Debye-Waller factors via EMM...')
            call wlog(slog)
            write(slog,9)
   9        format(2x,'This might take a while.')
            call wlog(slog)

      if (ipath.ne.0.and.iem_open) then
c           Echo title cards to s2_em.dat
            do 10  i = 1, ntitle
               write(iem,12)  title(i)(1:ltit(i))
  10        continue
  12        format (1x, a)
            write(iem,17) tk, natom
  17        format(1x,'temperature =',f7.2,2x,'N_at =',i4)
            write(iem,19)
  19        format (1x, 71('-'))
            write(iem,25)
            write(slog,25)
            call wlog(slog)
  25        format(3x,'ipath',4x,'nleg',3x,'sig2',5x,
     1            'mu_ipath',2x,'check0(%)')
      endif

c Integration parameters:
      wmaxx=sqrt(zshell)
      dt=2.*pi/wmaxx/15.
c top limit in t integration:
      cutoff=2.*sqrt(2.*acut)/res/wmaxx
      nstep=int(cutoff/dt)
      xlam=acut/(cutoff)**2
      wl=0.0000001
c top limit in w integration:
      wm=wmax*wmaxx
      dw=0.01
      nw=int((wm-wl)/dw) + 1
      if (nw .gt. nwx) then
          nw = nwx
          dw = (wm-wl)/(nw -1)
      endif
      nfit = int(dosfit*nw/20.)

      endif
c------------------------------------

cc    Open path input file (unit in) and read title.  Use unit 2.
c     ntitle2 = 5
c     open(unit=2,file='paths.dat',status='old', iostat=ios)
c     call chopen (ios, 'paths.dat', 'sigem')
c     call rdhead (2, ntitle2, titlep, ltit)
cc    if (ntitle2 .le. 0)  then
cc       titlep(1) = ' '
cc    endif

c 84  continue
c     read(2,*,end=1010) ipath, nleg
c     skip label (x y z ipot rleg beta eta) and read the path
c     read(2,*)
      do 78 ileg=0,nleg
c        read(2,*,end=1010) (rat(j,ileg),j=1,3)
         nconv(ileg)=0
  78  continue

      do 88 n=1,3
         aa = rat(n,nleg)
         do 87 i=0,(nleg-2)
            j=nleg-i
            rat(n,j)=rat(n,j-1)
  87     continue
         rat(n,1)=aa
  88  continue
      do 89 i=1,nleg
         nq0(i)=0
  89  continue

c nconv converts # of an atom in the nleg list of coordinates (rat) to
c its # in the full list of all atomic coordinates (rat1)
      do 94 i=1,natom
         do 91 n=1,3
   91    q0(n,i)=0.
         do 95 jl=1,nleg
            m=0
            do 93 n=1,3
               l=nint(100.*rat(n,jl))
               l1=nint(100.*rat1(n,i))
               if (abs(l-l1).le.1) m=m+1
   93       continue
            if (m.eq.3) then
              nconv(jl)=i
            endif
   95    continue
   94 continue
c     check that all path atoms are found
      do 96 jl=1,nleg
        if (nconv(jl).eq.0) then
           print*,' did not find atom jl=', jl
           print*, rat(1,jl),rat(2,jl),rat(3,jl)
           call par_stop('SIGREM-1')
        endif
  96  continue

      atmu=0.
      iq0=0
      nconv(0)=nconv(nleg)
      do 100 il=1,nleg
         l=nconv(il)
         do 101 jq=1,iq0
  101    if(nq0(jq).eq.l) go to 102
         iq0=iq0+1
         nq0(iq0)=l
  102    continue
         nq0x=iq0
         i=nconv(il)
         im=nconv(il-1)
         ip=nconv(il+1)
c        if (il.eq.1) im=nconv(nleg)
         if (il.eq.nleg) ip=nconv(1)
         atmass=atwtd(iz(i))
      do 100 n=1,3
         atmu=atmu + 0.25*( rnn(n,i,im)+rnn(n,i,ip) )**2 /atmass
  100 continue
      atmu=1./atmu
      icount=1
  108 continue
      icount= icount+1
      if (icount.gt.10) call par_stop('SIGREM-2')

      do 115 i=1,natom
      do 115 n=1,3
  115 q0(n,i)=0.

c Build initial state vector |Q_j(0)> for the current path
      do 116 n=1,3
      do 116 il=1,nleg
         i=nconv(il)
         im=nconv(il-1)
         ip=nconv(il+1)
         if (il.eq.1) im=nconv(nleg)
         if (il.eq.nleg) ip=nconv(1)
         atmass=atwtd(iz(i))
         q0(n,i)=q0(n,i)+sqrt(atmu/atmass)*(rnn(n,im,i)-rnn(n,i,ip))/2.
  116 continue

c make sure it's normalized <Q_j(0)|Q_j(0)>=1
      q0q0=0.
      do 120 iq0=1,nq0x
      i=nq0(iq0)
      do 120 n=1,3
         q0q0=q0q0+q0(n,i)*q0(n,i)
 120  continue
      p00=nint(q0q0*1000.d0)/1000.d0
      if (abs(p00-1.d0).gt.5.d-4) then
         atmu=atmu/q0q0
         go to 108
      endif

c     to get THz units:
      wnorm=100.*w0/sqrt(amu0*10.)
c*** moments
      a0=0.
      do 132 il=1,nq0x
      do 132 im=1,nq0x
         l=nq0(il)
         m=nq0(im)
      do 132 n1=1,3
      do 132 n2=1,3
         a0 = a0 + q0(n1,l)*dm(n1,n2,l,m)*q0(n2,m)/w0/w0
  132 continue
      a0=wnorm*sqrt(a0)

      do 125 kw=1, nwx
         gr(kw) = 0.
  125 w(kw) = (wl+(kw-1)*dw)

c  make file prdennnnn.dat
      if (master.and.ipath.ne.0.and.ipath.le.iprdos) then
         write(fname,130)  ipath
  130    format('prden', i4.4, '.dat')
         open (unit=25, file=fname, status='unknown',iostat=ios)
         call chopen (ios, fname, 'sigem')
         do 134  i = 1, ntitle
            write(25,136)  title(i)(1:ltit(i))
  134    continue
         write(25,135) natom
  135    format('#',1x,'N_at =', i4)
  136    format ('#',1x, a)
         write(25,138)
  138    format ('#',1x, 71('-'))
      endif


c  set initial conditions
      do 150 i=1, natom
      do 150 n=1,3
         uu(n,i)=q0(n,i)
         up(n,i)=uu(n,i)
  150 continue

c Solve 3*natom equations of motion and find projected VDOS (gr)
      dt2=dt*dt
      t=dt/2.
      do 200 kstep = 1, nstep
c        damping factor:
         e1=exp(-xlam*t*t)
         xat=0.
         do 167 i=1, natom
         do 167 n=1,3
  167    xat = xat + uu(n,i)*q0(n,i)
         xat=xat*e1
         do 170 kw=1, nw
  170    gr(kw) = gr(kw) + xat*cos(w(kw)*t)*dt
         if(kstep.eq.nstep) go to 200

         do 175 i=1,natom
         do 175 n=1,3
  175    ff(n,i)=0.

         do 180 i=1,natom
            jn=1
  185       if (nnl(i,jn).ne.0) then
               j=nnl(i,jn)
               am=w0*w0
               do 187 n1=1,3
               do 187 n2=1,3
                  ff(n1,i)=ff(n1,i)-dm(n1,n2,i,j)*uu(n2,j)/am
                  if(i.ne.j) ff(n1,j)=ff(n1,j)-dm(n1,n2,j,i)*uu(n2,i)/am
  187          continue
               jn = jn + 1
               go to 185
            endif
  180    continue

         do 199 i=1,natom
         do 199 n=1,3
            put=2.*uu(n,i)-up(n,i)+dt2*ff(n,i)
            up(n,i)=uu(n,i)
            uu(n,i)=put
  199    continue

  200 t=t+dt

      afit = 0.
      if (nfit.ne.0) then
         if (w(nfit).ne.0.) afit=gr(nfit)/(w(nfit)**4)
      endif

c fit vibr.density to A*w^4, for low w
      do 225 kw=1, nfit
         gr(kw)=afit*w(kw)**4
  225 continue

c Normalization of the pr.density of modes
c (it's the 2/pi factor which was left out till now with,
c perhaps, a small diffrence due to the fit)
      gr(nw)=0.
      if (gr(1).lt.0.) gr(1)=0.
      xx=(gr(1)+gr(nw))*dw/2.
      do 247 kw=2, (nw-1)
         if (gr(kw).lt.0.) gr(kw)=0.
  247 xx = xx + gr(kw)*dw
      cn1=1./xx

      if (master.and.ipath.ne.0.and.ipath.le.iprdos) then
c to get THz units:
         wnorm=100.*w0/sqrt(amu0*10.)
         write(25,349) ipath, nleg
  349    format('#',2x,'ipath =',i3,2x,'nleg =',i2)
         write(25,350)
c 350    format(1h#,6x,5hw,THz,18x,6hrho(w))
  350    format(1h#,6x,'cm^-1',18x,6hrho(w))
         do 370 kw=1,nw
            write(25,360) w(kw)*wnorm*100./6./pi, gr(kw)*cn1/wnorm
c           write(25,360) w(kw)*wnorm, gr(kw)*cn1/wnorm
  360       format(2x,f10.3,15x,f10.7)
  370    continue
         close (unit=25)
      endif

      wt=tk/187.64/w0
      ccc=cn1
      check0 = abs((2./pi - cn1)/(2./pi))
      check0=check0*100.
      coef = ccc*0.5*0.2587926/atmu/w0
c integrate over w to get sig2
      cth=0.
      s2=0.
c     gr(1)=0.
      do 400 kw=2, (nw-1)
         cth = 1./tanh( w(kw)/(2.*wt) )
         s2 = s2 + coef*gr(kw)*cth*dw/w(kw)
  400 continue
      sig2 = s2

      if (ipath.ne.0.and.iem_open) then
         write(iem,473) ipath, nleg, sig2,atmu,check0
         write(slog,473) ipath, nleg, sig2,atmu,check0
         call wlog(slog)
  473    format(4x,i3,4x,i3,4x,f7.5,3x,f7.3,4x,f5.2)
      endif

      nsigc = nsigc + 1
c1000 go to 84
c1010 continue
c     close (unit=2)
      if (sig2.gt.1.0) then
        sig2 = 1.0d0
        call wlog (' WARNING: Found sig**2>1. Set sig2=1. ')
        write (slog,1011) nconv(1), nconv(2)
 1011   format('          Possible zero ferquency modes with atoms', i4,
     1   ' or', i4)
         call wlog(slog)
         call wlog('          Check springs.inp')
      endif
      if (check0.gt.5.0) then
        write (slog,*) ' WARNING: Failed check0 test:missing VDOS.',
     1  ' Reduce dosfit and/or increase wmax.'
        call wlog(slog)
      endif

c     update maximum DW factors
      if (sig2.gt.sig2mx) sig2mx=sig2
      if (sig2.gt.sig2x( iphat(nconv(1)),  iphat(nconv(2)) )) then
         sig2x( iphat(nconv(1)),  iphat(nconv(2)) ) = sig2
         sig2x( iphat(nconv(2)),  iphat(nconv(1)) ) = sig2
      endif

      return
      end
c----------------------------------------------------
      subroutine dwrdin (rat, iphat, izph, nat,
     1            ntitle, title, ltit)

c     Read feff.inp for sigem.f
c     (here we need only coordinates and potentials)

      implicit double precision (a-h, o-z)

      parameter (natxdw = 200, nlegx1 = 9, nphx1=7)

c feff parameters:
c     parameter (nphx = 7)

      parameter (nphx = nphx1)
      parameter (natx = natxdw)

      dimension iphat(natx)
      dimension rat(3,natx)
      dimension iatph(0:nphx)

      character*6  potlbl(0:nphx)

c     Local stuff
      character*150  line
      parameter (nwordx = 20)
      character*20 words(nwordx)

      parameter (ntitx = 10)
      character*71  title(ntitx)
      dimension ltit(ntitx)
      dimension izph(0:nphx)
      logical iscomm
      parameter (nssx = 16)

      parameter (big = 1.0d5)
      character*512 slog

      iat0 = 0
   10 format (a)
   20 format (bn, i15)
   30 format (bn, f15.0)

cc    initialize things

      ntitle = 0

      nat = 0
      do 100  iat = 1, natx
         iphat(iat) = -1
  100 continue

      nph = 0
      do 110  iph = 0, nphx
         iatph(iph) = 0
         izph(iph) = 0
         potlbl(iph) = ' '
  110 continue

c     Open feff.inp, the input file we're going to read
      open (unit=1, file='feff.inp', status='old', iostat=ios)
      call chopen (ios, 'feff.inp', 'rdinp')

c     tokens  0 if not a token
c             1 if ATOM (ATOMS)
c             7 if TITL (TITLE)
c            10 if DEBY (DEBYE)
c            13 if PRIN (PRINT)
c            14 if POTE (POTENTIALS)
c            -1 if END  (end)
c     mode flag  0 ready to read a keyword card
c                1 reading atom positions
c                2 reading overlap instructions for unique pot
c                3 reading unique potential definitions

      mode = 0
  200 read(1,10,iostat=ios)  line
         if (ios .lt. 0)  line='END'
         call triml (line)
         if (iscomm(line))  goto 200
         nwords = nwordx
         call bwords (line, nwords, words)
         itok = itoken (words(1),'feff.inp')

c        process the card using current mode
  210    continue

         if (mode .eq. 0)  then
            if (itok .eq. 1)  then
c              ATOM
c              Following lines are atom postions, one per line
               mode = 1

            elseif (itok .eq. 7)  then
c              TITLE title...
               ntitle = ntitle + 1
               if (ntitle .le. ntitx)  then
                  title(ntitle) = line(6:)
                  call triml (title(ntitle))
               else
                  call wlog(' Too many title lines, title ignored')
                  call wlog(' ' // line(1:71))
               endif
               mode = 0

c           elseif (itok .eq. 10)  then
cc             DEBYE  temp debye-temp
cc                  temps in kelvin
cc                  These add to any sig2 from SIG2 card or files.dat
c              read(words(2),30,err=900)  tk
c              read(words(3),30,err=900)  thetad
c              idwopt=0
c              read(words(4),20,err=900)  idwopt
c              mode = 0
            elseif (itok .eq. 14)  then
c              POTENTIALS
c              Following lines are unique potential defs, 1 per line
               mode = 3

            elseif (itok .eq. -1)  then
cc             END
               goto 220
            else
               mode = 0
c *            write(slog,'(1x,a)') line(1:70)
c *            call wlog(slog)
c *            write(slog,'(1x,a)') words(1)
c *            call wlog(slog)
c *            write(slog,'(a,i8)') ' Token ', itok
c *            call wlog(slog)
c *            call wlog(' Keyword unrecognized.')
c *            call wlog(' See FEFF document -- some old features')
c *            call wlog(' are no longer available.')
c *            call par_stop('DWRDIN-1')
            endif
         elseif (mode .eq. 1)  then
            if (itok .ne. 0)  then
cc             We're done reading atoms.
cc             Change mode and process current card.
               mode = 0
               goto 210
            endif
            nat = nat+1
            if (nat .gt. natx)  then
               write(slog,'(1x,a,i5)') 'Too many atoms, max is ', natx
               call wlog(slog)
               write(slog,'(1x,a,i5,a)') 'Only', natx,
     1       ' atoms will be considered in the DW factor calculations.'
               call wlog(slog)
               nat = nat-1
               mode = 0
               goto 210
c              call par_stop('DWRDIN-2')
            endif
            if (nat.le.natx) then
               read(words(1),30,err=900)  rat(1,nat)
               read(words(2),30,err=900)  rat(2,nat)
               read(words(3),30,err=900)  rat(3,nat)
               read(words(4),20,err=900)  iphat(nat)
               if (iphat(nat).eq.0) iat0 = nat
            else
               mode = 0
               goto 210
            endif
         elseif (mode .eq. 3)  then
            if (itok .ne. 0)  then
cc             We're done reading unique potential definitions
cc             Change mode and process current card.
               mode = 0
               goto 210
            endif
            read(words(1),20,err=900)  iph
            if (iph .lt. 0  .or.  iph .gt. nphx)  then
               write(slog,'(a,i8)')
     1             'Unique potentials must be between 0 and ',
     1             nphx
               call wlog(slog)
               write(slog,'(i8,a)') iph, ' not allowed'
               call wlog(slog)
               write(slog,'(1x,a)') line(1:71)
               call wlog(slog)
               call par_stop('DWRDIN-3')
            endif
            read(words(2), 20, err=900)  izph(iph)
cc          No potential label if user didn't give us one
cc          Default set above is potlbl=' '
            if (nwords .ge. 3)  potlbl(iph) = words(3)(:6)
         else
            write(slog,'(a,i8)')
     .        'DWRDIN-4: Mode unrecognized, mode ', mode
c           call wlog(slog)
            call par_stop(slog)
         endif
      goto 200
  220 continue

cc    We're done reading the input file, close it.
      close (unit=1)
            if (nat .gt. natx)  then
               write(slog,'(a,i8)') 'Too many atoms for DW calculations,
     1         max is ', natx
               call wlog(slog)
               write(slog,'(a,i8,a)') 'Only atoms up to #',natx,
     1         '  will be considered'
               call wlog(slog)
            endif

      do 250 iat = 1, nat
      do 250 i = 1,3
        if (iat.ne. iat0) rat(i,iat) = rat(i,iat) - rat(i,iat0)
 250  continue
      do 251 i = 1,3
 251  rat(i,iat0) = 0.d0

cc    Find out how many unique potentials we have
      nph = 0
      do 300  iph = nphx, 0, -1
         if (izph(iph) .gt. 0)  then
            nph = iph
            goto 301
         endif
  300 continue
  301 continue
cc    Must have central atom
      if (izph(0) .le. 0)  then
         call wlog(' No absorbing atom (unique pot 0) was defined.')
         call par_stop('DWRDIN-5')
      endif
cc    Find central atom (only 1 permitted)
      iatabs = -1
      do 400  iat = 1, nat
         if (iphat(iat) .eq. 0)  then
            if (iatabs .lt. 0)  then
               iatabs = iat
            else
               call wlog(' More than one absorbing atom (potential 0)')
               call wlog(' Only one absorbing atom allowed')
               call par_stop('DWRDIN-6')
            endif
         endif
  400 continue

cc    Then find model atoms for unique pots that have them
cc    Use atom closest to absorber for model
      do 330  iph = 0, nphx
         rabs = big
         do 320  iat = 1, nat
            if (iph .eq. iphat(iat))  then
               tmp = dist (rat(1,iat), rat(1,iatabs))
               if (tmp .lt. rabs)  then
cc                this is the closest so far
                  rabs = tmp
                  iatph(iph) = iat
               endif
            endif
  320    continue
  330 continue
cc    if iatph > 0, a model atom has been found.

      if (ntitle .le. 0)  then
         ntitle = 1
         title(1) = 'Null title'
      endif
      do 490  i = 1, ntitle
         ltit(i) = istrln (title(i))
  490 continue

      return

  900 continue
      call wlog(' Error reading input, bad line follows:')
      write(slog,'(1x,a)') line(1:71)
      call wlog(slog)
      call par_stop('DWRDIN-7 fatal error.')

c      return
      end

c----------------------------------------------------------
      subroutine rdspr(rat1, iz, natom, i0,
     1           dm, rnn,
     1           acut, res, wmax, dosfit, zshell, w0,
     1           rintr, iprdos, nnl)

c     Read spring.inp for multiple scattering feff and
c     build dynamical matrix.

      implicit double precision (a-h, o-z)

      parameter (natxdw = 200, nlegx1 = 9, nphx1=7)
      include '../HEADERS/parallel.h'

c feff parameters:

c     parameter (nphx = nphx1)
      parameter (natx = natxdw)

c new local parameters:
      parameter (nangx = 7*natx)
      parameter (nsprx = 40)
      parameter (nshx = 100)

c variables shared with sigem.f:
      dimension rat1(3,natx), iz(natx)
      dimension dm(3,3,natx,natx)
      dimension rnn(3,natx,natx)
      dimension nnl(natx,natx)

c local variables:
      dimension rshell(natx,0:nshx)
      dimension nspr(2,nsprx), drij(natx,natx)
      dimension str(natx,natx)
      dimension ang(nangx), dang(nangx)
      dimension nang(3,nangx)
      dimension dmstr(3,3,natx,natx),dma(3,3,natx,natx)
      dimension si(3), sj(3), sk(3)

      character*150  line
      parameter (nwordx = 20)
      character*20  words(nwordx)
      character*512 slog

      logical iscomm

      ix=0
      jx=0
   10 format (a)
   20 format (bn, i15)
   30 format (bn, f15.0)

c initialize things

      do 40 i=1, natom
      do 40 j=1, natom
         str(i,j)=0.
         drij(i,j)=0.02
   40 continue
      do 47 na=1,nangx
         ang(na)=0.
         dang(na)=0.
      do 47 m=1,3
         nang(m,na)=0
   47 continue

      do 50 ispr=1, nsprx
      do 50 n=1,2
   50 nspr(n,ispr)=0

      acut=3.
      res=0.05
      dosfit=0.
      wmax=1.
      na=1
      nintr=0
      strx=10000.
      ispr=1
      iprdos = 0
      ddrij=0.02
      ddang=0.02

      open(unit=1,file='spring.inp',status='old', iostat=ios)
      call chopen (ios, 'spring.inp', 'rdspr')

c     tokens  0 if not a token
c             1 if STRE (STRETCHES)
c             2 if ANGL (ANGLES)
c             3 if VDOS
c             4 if PRDOS
c            -1 if END  (end)
c     mode flag  0 ready to read a keyword card
c                1 reading stretches
c                2 reading angle-bends

      mode = 0
  200 read(1,10,iostat=ios)  line
         if (ios .lt. 0)  line='END'
         call triml (line)
         if (iscomm(line))  goto 200
         nwords = nwordx
         call bwords (line, nwords, words)
         itok = itoken (words(1),'spring.inp')

c        process the card using current mode
  210    continue

         if (mode .eq. 0)  then
            if (itok .eq. 1)  then
c              STRE
c              Following lines are stretches, one per line
c              read(words(2),20,err=900)  nintr
               mode = 1
            elseif (itok .eq. 2)  then
c              ANGL
c              Following are ...
               mode = 2
            elseif (itok .eq. 3)  then
c              VDOS
c              VDOS  resolution, a_cut, wmax, dosfit
c               0 - do not run modules, 1 - run module
               read(words(2),30,err=900)  res
               read(words(3),30,err=900)  wmax
               read(words(4),30,err=900)  dosfit
               if (nwords.gt.4) then
                   read(words(5),30,err=900)  acut
               endif
               mode = 0
            elseif (itok .eq. 4)  then
c              PRINT  iprdos
c              to print or not to print prdennnnn.dat files;
c              if the card is present, these files will be
c              printed for paths 1 through iprdos
               iprdos = 1
               read(words(2),20,err=900)  iprdos
               mode = 0
            elseif (itok .eq. -1)  then
c              END
               goto 220
            else
               write(slog,'(1x,a)') line(1:71)
               call wlog(slog)
               write(slog,'(1x,a)') words(1)
               call wlog(slog)
               write(slog,'(a,i8)') ' Token ', itok
             call wlog(slog)
               call wlog(' Keyword unrecognized.')
               call wlog(' See FEFF document -- some old features')
               call wlog(' are no longer available.')
             call par_stop('RDSPR-1')
            endif
         elseif (mode .eq. 1)  then
            if (itok .ne. 0)  then
c              We're done reading stretches
c              Change mode and process current card.
               mode = 0
               goto 210
            endif
            read(words(1),20,err=900) ii
            i=ii+1
            call chekin (ii, natom, line)
            read(words(2),20,err=900) jj
            j=jj+1
            call chekin (jj, natom, line)
            read(words(3),30,err=900) str(i,j)
            ix = 1
            jx = 1
            if (str(i,j).lt.strx) then
               strx=str(i,j)
               ix=i
               jx=j
            endif
            nspr(1,ispr)=i
            nspr(2,ispr)=j
            ispr=ispr+1
            read(words(4),30,err=900) ddrij
            drij(i,j) = abs(ddrij)/100.
            drij(j,i) = abs(ddrij)/100.
         elseif (mode .eq. 2)  then
            if (itok .ne. 0)  then
c              We're done reading angle-bends
c              Change mode and process current card.
               mode = 0
               goto 210
            endif
            read(words(1),20,err=900) ii
            i=ii+1
            call chekin (ii, natom, line)
            read(words(2),20,err=900) jj
            j=jj+1
            call chekin (jj, natom, line)
            read(words(3),20,err=900) kk
            k=kk+1
            call chekin (kk, natom, line)
            read(words(4),30,err=900) ang(na)
            nang(1,na)=i
            nang(2,na)=j
            nang(3,na)=k
            read(words(5),30,err=900) ddang
            dang(na) = abs(ddang)/100.
            na=na+1
         else
            write(slog,'(a,i8)') 'Mode unrecognized, mode ', mode
            call wlog(slog)
            call par_stop('RDSPR-2')
         endif
      goto 200
  220 continue

c     We're done reading the input file, close it.
      close (unit=1)
      nax=na-1

c     write statistics on found bonds and angles into spring.dat
      if (master) then
        open (unit=2, file='spring.dat', status='unknown',iostat=ios)
        call chopen (ios, 'spring.dat', 'spring')
        write(2,*) ' Statistics on spring constants in spring.inp.'
        write(2,*) '   STRETCHES  i  j  aa   found_number'
      endif

c find all stretching bonds
      do 321 jspr=1, (ispr-1)
         icnt=0
         i=nspr(1,jspr)
         j=nspr(2,jspr)
         aa = str(i,j)
         ddrij=drij(i,j)
         ip=iz(i)
         jp=iz(j)
         rij = dist (rat1(1,i), rat1(1,j))
         if (aa.eq.0.) go to 321
         do 320 k=1, natom
            do 320 l=k+1, natom
               kp=iz(k)
               lp=iz(l)
               rkl = dist (rat1(1,k), rat1(1,l))
               comp = abs(rij/rkl - 1.)
               if (comp.gt.ddrij) go to 320
               if (ip.ne.kp.or.jp.ne.lp) then
                  if (ip.ne.lp.or.jp.ne.kp) go to 320
               endif
               str(k,l) = aa
               str(l,k) = aa
calex       to check the bonds, that were found
calex        print*, k,l,aa
                icnt = icnt+1
  320    continue
         str(j,i) = aa
         if (master) write (2,*) i-1, j-1, aa, icnt
  321 continue
      if (master) write(2,*) '   BENDS   i  j  k   aa   found_number'

c find all bending angles
      naxx=nax
      do 323 na=1,nax
         icnt=1
         i=nang(1,na)
         j=nang(2,na)
         k=nang(3,na)
         ddrij=drij(i,j)
         ddrkj=drij(k,j)
         ip=iz(i)
         jp=iz(j)
         kp=iz(k)
         call coss(rat1(1,i),rat1(1,j),rat1(1,k),cosijk)
         rij = dist (rat1(1,i), rat1(1,j))
         rkj = dist (rat1(1,k), rat1(1,j))
         aa=ang(na)
c        print*, na, i,j,k, aa
         do 326 ii=1, natom
         do 326 jj=1, natom
            if (ii.eq.jj) go to 326
            rrij=dist (rat1(1,ii), rat1(1,jj))
            do 322 kk=ii+1, natom
               if (kk.eq.jj) go to 322
               rrkj=dist (rat1(1,kk), rat1(1,jj))
               comp1 = abs(rrij/rij - 1.)
               comp2 = abs(rrkj/rkj - 1.)
               if (comp1.gt.ddrij.or.comp2.gt.ddrkj) then
                  comp1 = abs(rrkj/rij - 1.)
                  comp2 = abs(rrij/rkj - 1.)
                  if (comp1.gt.ddrij.or.comp2.gt.ddrkj) go to 322
               endif
               iip=iz(ii)
               jjp=iz(jj)
               kkp=iz(kk)
            if (iip.ne.ip.or.jjp.ne.jp.or.kkp.ne.kp) then
               if (kkp.ne.ip.or.jjp.ne.jp.or.iip.ne.kp) go to 322
            endif
               call coss(rat1(1,ii),rat1(1,jj),rat1(1,kk),cssijk)
               if (dacos(cosijk).eq.0.) go to 322
                  comp = abs( dacos(cssijk)/dacos(cosijk) -1.)
               if (comp.ge.dang(na)) go to 322
               do 324 na1=1,naxx
                  ii1=nang(1,na1)
                  jj1=nang(2,na1)
                  kk1=nang(3,na1)
               if (ii.eq.ii1.and.jj.eq.jj1.and.kk.eq.kk1) go to 322
               if (kk.eq.ii1.and.jj.eq.jj1.and.ii.eq.kk1) go to 322
 324           continue
               naxx=naxx+1
               ang(naxx)=aa
               nang(1,naxx)=ii
               nang(2,naxx)=jj
               nang(3,naxx)=kk
calex          to check the bends, that were found
c              print*, naxx, ii,jj,kk,aa
               icnt = icnt + 1
               if (naxx.eq.nangx) goto 333
 322        continue
 326     continue
         if (master) write (2,*) i-1, j-1, k-1, aa, icnt
 323  continue
 333  continue

      if (master) close (unit=2)

      do 325 i=1, natom
      do 325 nshell=0, nshx
         rshell(i,nshell)=0.
 325  continue

c find shells
      rintr=0.
      nintr=1
      do 330 i=1, natom
      nshell=0
      do 335 j=1, natom
         if (j.eq.i) go to 332
         if (nshell.gt.nshx) go to 332
         rij = dist (rat1(1,i), rat1(1,j))
         ddrij=drij(i,j)
         ncount=0
         do 331 ish=0, nshell
            b = real(rshell(i,ish))
            dif=1.
            if (b.ne.0.) dif = abs(rij -b)/b
            if (dif.le.ddrij) ncount=ncount+1
 331     continue
         if (ncount.eq.0) then
            nshell = nshell + 1
            if (str(i,j).ne.0.and.rij.gt.rintr) rintr=rij
            rshell(i,nshell) = rij
         endif
 332     do 335 n=1,3
         rnn(n,i,j)=0.
         do 335 m=1,3
            dmstr(n,m,i,j)=0.
            dma(n,m,i,j)=0.
            dm(n,m,i,j)=0.
 335  continue
c sort rshell into ascending numerical order
c and find maximum order of interacting neighbor nintr
      do 342 jsh=2,nshell
         aa = rshell(i,jsh)
         do 341 ish=jsh-1,1,-1
            if(rshell(i,ish).le.aa) go to 340
            rshell(i,ish+1)=rshell(i,ish)
 341     continue
         ish=0
 340     rshell(i,ish+1) = aa
         if (aa.le.rintr.and.(ish+1).gt.nintr) nintr = ish+1
 342  continue
 330  continue

      zshell=0.
      i1=0
      do 350 i=1,natom
         do 352 in=1,natx
 352     nnl(i,in)=0
         do 350 j=i+1,natom
            dx=rat1(1,j)-rat1(1,i)
            dy=rat1(2,j)-rat1(2,i)
            dz=rat1(3,j)-rat1(3,i)
            dr=sqrt(dx*dx+dy*dy+dz*dz)
            rnn(1,i,j)=dx/dr
            rnn(2,i,j)=dy/dr
            rnn(3,i,j)=dz/dr
            rnn(1,j,i)=-rnn(1,i,j)
            rnn(2,j,i)=-rnn(2,i,j)
            rnn(3,j,i)=-rnn(3,i,j)
            rrij = abs( dr/rshell(1,1) -1.)
c           if (i.eq.1.and.rrij.le.drij(i,j)) zshell=zshell+1
            if (i.eq.i0.and.rrij.le.drij(i,j)) then
               zshell=zshell+1
               if (i1.eq.0.and.str(i,j).ne.0.) i1 = j
            endif
  350 continue

c Build dynm. matrix for angle bends
      nan=0
      do 355 na=1,naxx
c        print*,na, naxx, nangx
         i=nang(1,na)
         j=nang(2,na)
         k=nang(3,na)
         if (i.eq.j.or.j.eq.k) go to 355
         if(ang(na).eq.0.) go to 355
         nan=nan+1
         rij = dist(rat1(1,i),rat1(1,j))
         rkj = dist(rat1(1,k),rat1(1,j))
         if (rij.gt.rintr.or.rkj.gt.rintr) go to 355
         call sang (i, j, k, rat1, si, sj, sk)
         do 357 n1=1,3
         do 357 n2=1,3
            dma(n1,n2,i,j)=dma(n1,n2,i,j)+ang(na)*si(n1)*sj(n2)
            dma(n1,n2,j,k)=dma(n1,n2,j,k)+ang(na)*sj(n1)*sk(n2)
            dma(n1,n2,i,k)=dma(n1,n2,i,k)+ang(na)*si(n1)*sk(n2)

            dma(n1,n2,i,i)=dma(n1,n2,i,i)+ang(na)*si(n1)*si(n2)
            dma(n1,n2,j,j)=dma(n1,n2,j,j)+ang(na)*sj(n1)*sj(n2)
            dma(n1,n2,k,k)=dma(n1,n2,k,k)+ang(na)*sk(n1)*sk(n2)

            dma(n2,n1,j,i)=dma(n1,n2,i,j)
            dma(n2,n1,k,j)=dma(n1,n2,j,k)
            dma(n2,n1,k,i)=dma(n1,n2,i,k)
  357    continue
  355 continue

c Build dynm. matrix for stretches
      do 375 l=1,natom
      do 375 m=l,natom
         do 373 n1=1,3
            x2=str(l,m)*rnn(n1,l,m)
         do 373 n2=1,3
         dmi=0.
         if (l.eq.m) then
            do 377 i=1,natom
               if (real(str(i,m)).eq.0.) go to 377
               dmi = dmi + str(i,m)*rnn(n1,i,m)*rnn(n2,i,m)
 377        continue
         endif
         dmstr(n1,n2,l,m) = dmi - x2*rnn(n2,l,m)
         dmstr(n2,n1,m,l)=dmstr(n1,n2,l,m)
 373  continue
 375  continue

c Add two dynm. matrices D_str+D_ang
      lnx=0
      do 380 i=1,natom
      ami=sqrt(atwtd(iz(i)))
      in=0
      do 380 j=1,natom
      amj=sqrt(atwtd(iz(j)))
      sumdm=0.
      do 381 n1=1,3
      do 381 n2=1,3
         dmdm=dma(n1,n2,i,j)+dmstr(n1,n2,i,j)
         sumdm=sumdm+abs(dmdm)
         dm(n1,n2,i,j)=dmdm/ami/amj
 381  continue
      if (real(sumdm).ne.0.and.i.le.j) then
         in=in+1
         nnl(i,in)=j
      endif
      if (in.ge.lnx) lnx=in
 380  continue

      atmu = 1./(1./atwtd(iz(i0)) + 1./atwtd(iz(i1)))
      a0=0.
      do 450 i=1,2
      do 450 j=1,2
      if (i.eq.1) l=i0
      if (i.eq.2) l=i1
      if (j.eq.1) m=i0
      if (j.eq.2) m=i1
      do 450 n1=1,3
      do 450 n2=1,3
         fact = (-1)**(i+j)*atmu
         atmass = 1./atwtd(iz(l))/atwtd(iz(m))
         a0 = a0 + fact*sqrt(atmass)*rnn(n1,i0,i1)*
     1             dm(n1,n2,l,m)*rnn(n2,i0,i1)
  450 continue
c     effective freq. for the 1st shell:
      w0=sqrt(a0)
      if (w0.eq.0.) then
         atmux = 1./(1./atwtd(iz(ix)) + 1./atwtd(iz(jx)))
         w0=sqrt(strx/atmux)
      endif

      return

  900 continue
      call wlog(' Error reading input, bad line follows:')
      write(slog,'(1x,a)') line(1:71)
      call wlog(slog)
      call par_stop('RDSPR fatal error.')

cc      return
      end

c---------------------------------------------------

      subroutine sang (i, j, k, rat1, si, sj, sk)

c*calculates coeficients s  (Sint=sum {si*ui}) connecting internal
c*coordinate delta_phi(ijk)=(valence ijk angle bend) with ui (atomic
c*displacements)

      implicit double precision (a-h, o-z)

      parameter (natxdw = 200, nlegx1 = 9, nphx1=7)

      parameter (natx = natxdw)

      dimension rat1(3,natx), rji(3), rjk(3)
      dimension eji(3), ejk(3), ej(3)
      dimension si(3), sk(3), sj(3)

      dji=0.
      djk=0.
      dik=0.
      do 905 m = 1, 3
         rji(m) = rat1(m,i) - rat1(m,j)
         rjk(m) = rat1(m,k) - rat1(m,j)
         dji = dji + rji(m)**2
         djk = djk + rjk(m)**2
         dik = dik + ( rat1(m,k) - rat1(m,i) )**2
         si(m) = 0.
         sj(m) = 0.
         sk(m) = 0.
  905 continue
      dji = sqrt(dji)
      djk = sqrt(djk)
      dik = sqrt(dik)

      dotj=0.
      do 910 m = 1, 3
         eji(m) = rji(m)/dji
         ejk(m) = rjk(m)/djk
         dotj = dotj + eji(m) * ejk(m)
  910 continue
c     ri = dji
c     rk = djk
c     rj = sqrt(dji*djk)
c     rj = dik
      rj=1.
      call vect (eji, ejk, ej, sinj)
      do 920 m = 1, 3
         si(m) = rj*(dotj * eji(m) - ejk(m))/dji/sinj
         sk(m) = rj*(dotj * ejk(m) - eji(m))/djk/sinj
         sj(m) = rj*((dji - djk * dotj)*eji(m) +
     1              (djk - dji * dotj)*ejk(m))/dji/djk/sinj
  920 continue
      return
      end

c-----------------------------------------------------------
      subroutine vect (v1, v2, v3, sin12)

c*calculates vector product v3 = [v1 x v2] and sin of the angle

      implicit double precision (a-h, o-z)

      dimension v1(3), v2(3), v3(3)

      v3(1) = v1(2)*v2(3) - v1(3)*v2(2)
      v3(2) = v1(3)*v2(1) - v1(1)*v2(3)
      v3(3) = v1(1)*v2(2) - v1(2)*v2(1)
      d1 = 0.
      d2 = 0.
      d3 = 0.
      do 990 m = 1, 3
         d1 = d1 + v1(m)**2
         d2 = d2 + v2(m)**2
         d3 = d3 + v3(m)**2
  990 continue
      sin12 = sqrt(d3/d1/d2)
      return
      end

c-----------------------------------------------------------
      subroutine coss (v1,v2,v3,cos12)
c* calculates cos between two vectors v1-v2 and v3-v2
      implicit double precision (a-h, o-z)
      dimension v1(3), v2(3), v3(3)

      vv1=0.
      vv2=0.
      scal=0.
      do 995 m=1,3
         vv1=vv1+(v1(m)-v2(m))**2
         vv2=vv1+(v3(m)-v2(m))**2
         scal=scal+(v1(m)-v2(m))*(v3(m)-v2(m))
  995 continue
      cos12=scal/vv1/vv2
      return
      end

c-----------------------------------------------------------
      subroutine chekin (i, natom, line)
      character*150  line
      character*512  slog

            if (i .gt. (natom-1) .or. i .lt. 0) then
               write(slog,'(a,i8)')
     1             'the atomic indexes must be between 0 and ',
     1             (natom - 1)
               call wlog(slog)
               write(slog,'(i8,a)') i, ' not allowed'
               call wlog(slog)
               write(slog,'(1x,a)') line(1:71)
               call wlog(slog)
               call par_stop('RDSPR')
            endif
        return
        end

c---------------------------------------------------------------------
c     program sigrm
c
c     calculate the Debye-Waller factors for each MS path
c     using the recursion method
c
c     input files:  feff.inp and spring.inp
c
c     version 2  ( January 99)
c
c     coded by  A. Poiarkova
c
c---------------------------------------------------------------------
c  References:
c             for the RM: J. Synchrotron Rad., 1999 (to bu published)
c     also see dissertation
c        "X-ray Absorption Fine Structure Debye-Waller Factors"
c         by Anna V. Poiarkova
c
c---------------------------------------------------------------------
c         tk temperature in degrees K
c         nleg  nlegs in path
c         rat   positions of each atom in path
c         NB Units of distance in this routine
c            are angstroms, including sig2.
c         sig2 is output DW factor
c
c---------------------------------------------------------------------
      subroutine sigrm (sig2mx, sig2x,ir1, ir2, tk,ipath,nleg,rat,sig2)
      implicit double precision (a-h, o-z)

      parameter (natxdw = 200, nlegx1 = 9, nphx1=7)

c feff parameters (from dim.h):
c     parameter (legtot=9)
c     parameter (nphx = 7)

      parameter (nphx = nphx1)
      parameter (natx = natxdw)

c local parameters:
      parameter (amu0  = 1.660 54)
      double precision sig2mx, sig2x(0:nphx,0:nphx)
      dimension iphat(natx), izph(0:nphx)

c variables shared with rdspr.f:
      dimension rat1(3,natx), iz(natx)
      dimension dm(3,3,natx,natx)
      dimension rnn(3,natx,natx)
      dimension nnl(natx,natx)

c local variables:
      dimension rat(3,0:nlegx1)
      dimension nconv(0:nlegx1)
      dimension q0(3,natx)
c   list of atoms |0>=|Q>:
      dimension nq0(0:nlegx1)
c   state |1>=D|Q>:
      dimension q1(3,natx)
c   list of atoms in |1>:
      dimension nq1(natx)

c     character*30  fname
      parameter (ntitx1 = 10)
      character*71  title(ntitx1)
      dimension ltit(ntitx1)
c     character*80  titlep(ntitx1)

      character*512 slog

      logical ir1_open, ir2_open

      save
      data nsigc /0/
c-------------------------------------------------------------

      inquire(unit=ir1,opened=ir1_open)
      inquire(unit=ir2,opened=ir2_open)

      if (nsigc.eq.0) then
c        Read coordinates and potentials from feff.inp
         call dwrdin (rat1, iphat, izph, natom,
     1            ntitle, title, ltit)

         if (natom.gt.natx) natom=natx
         do 5 iat=1, natom
            iz(iat) = izph(iphat(iat))
            if (iphat(iat).eq.0) i0=iat
  5      continue

         write(slog,7)
   7     format(2x,'Calculating Debye-Waller factors via RM...')
         call wlog(slog)
         write(slog,9)
   9     format(2x,'This might take a while.')
         call wlog(slog)

c        Read spring.inp and build dynamical matrix
         call rdspr(rat1, iz, natom, i0,
     1           dm, rnn,
     1           acut, res, wmax, dosfit, zshell, w0,
     1           rintr, iprdos, nnl)

         if (ipath.ne.0) then
            if(ir1_open) then
c             Echo title cards to s2_rm2.dat
              do 10  i = 1, ntitle
                write(ir1,12)  title(i)(1:ltit(i))
  10          continue
  12          format (1x, a)
              write(ir1,17) tk, natom
  17          format(1x,'temperature =',f7.2,2x,'N_at =',i4)
              write(ir1,19)
  19          format (1x, 71('-'))
              write(ir1,25)
              write(slog,25)
  25          format(1x,'ipath',2x,'nleg',4x,'sig2',3x,'mu_ipath',4x,
     1          'w_1',6x,'w_2',7x,'A1',5x,'A2')
              call wlog(slog)
            endif
            if (iprdos.ne.0.and.ir2_open) then
c              Echo title cards to s2_rm1.dat
               do 30  i = 1, ntitle
                  write(ir2,12)  title(i)(1:ltit(i))
  30           continue
               write(ir2,17) tk, natom
               write(ir2,19)
               write(ir2,35)
  35           format(1x,'ipath',2x,'nleg',4x,'sig2',3x,'mu_ipath',
     1              4x,'w_e')
            endif
         endif
      endif
      nsigc = nsigc + 1
c---- end of first time reading -------

cc    Open path input file (unit in) and read title.  Use unit 2.
c     ntitle2 = 5
c     open(unit=2,file='paths.dat',status='old', iostat=ios)
c     call chopen (ios, 'paths.dat', 'sigrm')
c     call rdhead (2, ntitle2, titlep, ltit)
cc    if (ntitle2 .le. 0)  then
cc       titlep(1) = ' '
cc    endif

c 84  continue
c     read(2,*,end=1010) ipath, nleg
c     skip label (x y z ipot rleg beta eta) and read the path
c     read(2,*)
      do 78 ileg=0,nleg
c        read(2,*,end=1010) (rat(j,ileg),j=1,3)
         nconv(ileg)=0
  78  continue

      do 88 n=1,3
         aa = rat(n,nleg)
         do 87 i=0,(nleg-2)
            j=nleg-i
            rat(n,j)=rat(n,j-1)
  87     continue
         rat(n,1)=aa
  88  continue
      do 89 i=1,nleg
         nq0(i)=0
  89  continue

c nconv converts # of an atom in the nleg list of coordinates (rat) to
c its # in the full list of all atomic coordinates (rat1)
      do 94 i=1,natom
         do 91 n=1,3
            q1(n,i)=0.
   91    q0(n,i)=0.
            do 95 jl=1,nleg
            m=0
            do 93 n=1,3
               l=nint(100.*rat(n,jl))
               l1=nint(100.*rat1(n,i))
               if (abs(l-l1).le.1) m=m+1
   93       continue
            if (m.eq.3) then
              nconv(jl)=i
              go to 95
            endif
   95    continue
   94 continue

      atmu=0.
      inn=1
      nq1(inn)=1
      iq0=0
      nconv(0)=nconv(nleg)
      do 100 il=1,nleg
         l=nconv(il)
         do 101 jq=1,iq0
  101    if(nq0(jq).eq.l) go to 102
         iq0=iq0+1
         nq0(iq0)=l
  102    continue
         do 105 ii=1,natom
            a = dist(rat1(1,ii),rat1(1,l))
            if (a.le.rintr) then
               do 103 jn=1,inn
  103          if(nq1(jn).eq.ii) go to 105
               inn=inn+1
               nq1(inn)=ii
            endif
  105    continue
         nq1x=inn
         nq0x=iq0
         i=nconv(il)
         im=nconv(il-1)
         ip=nconv(il+1)
c        if (il.eq.1) im=nconv(nleg)
         if (il.eq.nleg) ip=nconv(1)
         atmass=atwtd(iz(i))
      do 100 n=1,3
         atmu=atmu + 0.25*( rnn(n,i,im)+rnn(n,i,ip) )**2 /atmass
  100 continue
      atmu=1./atmu
  108 continue

      do 115 i=1,natom
      do 115 n=1,3
  115 q0(n,i)=0.

c Build initial state vector |Q_j(0)> for the current path
      do 116 n=1,3
      do 116 il=1,nleg
         i=nconv(il)
         im=nconv(il-1)
         ip=nconv(il+1)
         if (il.eq.1) im=nconv(nleg)
         if (il.eq.nleg) ip=nconv(1)
         atmass=atwtd(iz(i))
         q0(n,i)=q0(n,i)+sqrt(atmu/atmass)*(rnn(n,im,i)-rnn(n,i,ip))/2.
  116 continue

c make sure it's normalized <Q_j(0)|Q_j(0)>=1
      q0q0=0.
      do 120 iq0=1,nq0x
      i=nq0(iq0)
      do 120 n=1,3
         q0q0=q0q0+q0(n,i)*q0(n,i)
 120  continue
      p00=nint(q0q0*1000.)/1000.
      if (abs(p00-1.d0).gt.5.d-4) then
         atmu=atmu/q0q0
         go to 108
      endif

c     to get THz units:
      wnorm=100.*w0/sqrt(amu0*10.)
c*** moments
      a0=0.
      do 132 il=1,nq0x
      do 132 im=1,nq0x
         l=nq0(il)
         m=nq0(im)
      do 132 n1=1,3
      do 132 n2=1,3
         a0 = a0 + q0(n1,l)*dm(n1,n2,l,m)*q0(n2,m)/w0/w0
  132 continue
      we=wnorm*sqrt(a0)
      if (we.lt.1) then
c        recursion method is inapplicable, use statistics to set sig2
         sig2 = sig2x ( iphat(nconv(1)),  iphat(nconv(1)) )
         if (sig2.lt.1.d-6) sig2 = sig2mx
         return
      endif

      do 137 iset=1,nq1x
         i=nq1(iset)
      do 137 n1=1,3
            q1i=0.
            do 138 im=1,nq0x
               m=nq0(im)
            do 138 n2=1,3
               q1i=q1i+dm(n1,n2,i,m)*q0(n2,m)/w0/w0
  138       continue
         q1(n1,i) = q1i - a0*q0(n1,i)
  137 continue

      b0=0.
      do 139 i=1,natom
      do 139 n1=1,3
         b0=b0+q1(n1,i)*q1(n1,i)
  139 continue

      a1=0.
      do 150 iset=1,nq1x
         i=nq1(iset)
         do 150 n1=1,3
         q2=0.
         do 151 jset=1,nq1x
         j=nq1(jset)
            do 151 n2=1,3
               q2 = q2 + dm(n1,n2,i,j)*q1(n2,j)/w0/w0
  151       continue
            a1 = a1 + q1(n1,i)*q2
  150 continue

      a0=a0*wnorm**2
      a1=a1/b0
      a1=a1*wnorm**2
      b0=b0*wnorm**4

c** recursion sigma^2
      dd = (a0+a1)**2 - 4.*(a0*a1-b0)
      x1 = (a0+a1+sqrt(dd))/2.
      x2 = (a0+a1-sqrt(dd))/2.
      aa2 = (a1-x2)/(x1-x2)
c     aa2 = (a1-x2)/(x1-x2)*9./8.
      aa1 = (x1-a1)/(x1-x2)
      w1 = sqrt(x1)
      w2 = sqrt(x2)
      s1 = 3.1746/(atmu*w1*tanh(w1*7.6383/2./tk))
      s2 = 3.1746/(atmu*w2*tanh(w2*7.6383/2./tk))
      sigma2 = aa1*s1+aa2*s2
      sig2e = 3.1746/(atmu*we*tanh(we*7.6383/2./tk))

      if (ipath.ne.0) then
         write(slog,250) ipath,nleg,sigma2,atmu,w1,w2,aa1,aa2
         call wlog(slog)
         if (ir1_open) then
           write(ir1,250) ipath,nleg,sigma2,atmu,w1,w2,aa1,aa2
  250      format(1x,i3,4x,i1,3x,f9.5,2x,f7.3,2x,f7.2,2x,f7.2,
     1       4x,f5.3,2x,f5.3)
         endif
         if (iprdos.ne.0.and.ir2_open) then
            write(ir2,260) ipath,nleg,sig2e,atmu,we
  260       format(1x,i3,4x,i3,3x,f7.5,2x,f7.3,2x,f7.2)
         endif
      endif
      sig2 = sigma2

c     update maximum DW factors
      if (sig2.gt.sig2mx) sig2mx=sig2
      if (sig2.gt.sig2x( iphat(nconv(1)),  iphat(nconv(2)) )) then
         sig2x( iphat(nconv(1)),  iphat(nconv(2)) ) = sig2
         sig2x( iphat(nconv(2)),  iphat(nconv(1)) ) = sig2
      endif

      return
      end
c----------------------------------------------------

      double precision function exchan (d,dr,dexv)
      implicit double precision (a-h,o-z)
      save
c  dexv=0.0, hedin-barth corr. and exch. potential
c  dexv.ne. 0.0, dexv*slater exchange potential
c  d=4pi*rho*r^2 , radial density for r=dr
c  this function calculates exch=-r*Vexch
c  105.27578=32*(pi^2)/3
c  comments added by j. mustre 8/27/87
      if (dexv.eq.0.0) go to 10
      exchan=3.0*dexv*((dr*d/105.27578)**(1.0/3.0))
      return
   10 continue
      rrs=(d/(3.0*dr**2))**.33333333333
      exchan=+0.5*(1.22177412*rrs+.0504*log(30.0*rrs+1.0))*dr
      return
      end

      SUBROUTINE mpse(edens,jIntrs,E,iPl,Mu)
      IMPLICIT NONE
      include '../HEADERS/dim.h'
      include '../HEADERS/const.h'
c     Josh Kas - This subroutine calculates the many pole self
c     energy at each energy pt and at a few r pts
!     and saves it in mpse.bin to be used later by xcpot
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     Input Variables:
c     densty - density for all unique potentials
c     Mu     - Fermi Energy
      DOUBLE PRECISION edens(251,0:nphx)
      DOUBLE PRECISION Mu, E, MaxDens, MinDens
c     jIntrs - index of the last point before intersitial level
      INTEGER jIntrs, iPl
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     Parameters:
      INTEGER NRPts
      PARAMETER (NRPts = 12)
      
c     Local Variables:
      INTEGER iR, iph, iPole
      INTEGER ios, RsMax, RsMin, Rs, RsInt
      DOUBLE PRECISION WpCorr(MxPole), Gamma(MxPole), AmpFac(MxPole),
     &     Densty, dR, delrHL(NRPts), deliHL(NRPts),
     &     Rs1(NRPts)
c      DOUBLE PRECISION MinDns
      COMPLEX*16 ZRnrm, ZTemp

c     Read exc.dat
      OPEN(file='exc.dat', unit=47, status='old',iostat=ios)
      CALL chopen (ios, 'exc.dat', 'ffmod2(xsect)')
      DO iPole = 1, MxPole
         CALL rdcmt(47,'#*cC')
         READ(47,*,END=5) WpCorr(iPole), Gamma(iPole), AmpFac(iPole)
         Gamma(iPole)  = Gamma(iPole)/hart
         WpCorr(iPole) = (WpCorr(iPole)/hart) /
     &        SQRT(3.d0/((3 / (4*pi*edens(jIntrs+1,1))) ** third)**3)
      END DO
 5    CONTINUE
      WpCorr(iPole) = -1.d30
      CLOSE(47)
      
c     find the minimum and maximum densities and calculate RsMin, RsMax
      MaxDens=-1.d30
      MinDens=1.d30
      DO iR = 1, 251
         DO iph = 0, nphx
            Densty=edens(iR,iph)
            IF(MaxDens.lt.Densty) MaxDens=Densty
            IF(MinDens.gt.Densty) MinDens=Densty
         END DO
      END DO

c     Calculate RsMax(MinDens), RsMin(MaxDens)
      RsMax = int(MIN( 10.d0, (3 / (4*pi*MinDens)) ** third ))
      RsMin = int(MAX( 0.001d0, (3 / (4*pi*MaxDens)) ** third ))
      RsInt = int((3 / (4*pi*edens(jIntrs+1,1))) ** third )
      
c     Calculate Sigma on a grid of NRPts points from RsMin to RsMax
c     and write to mpse.bin
      OPEN(file='mpse.bin', unit=47, status='replace',iostat=ios)
      CALL chopen (ios, 'mpse.bin', 'ffmod2(xsect)')
      dR = (RsMax - RsMin)/(NRPts - 1)
      DO iR = 1, NRPts
         delrHL(iR) = 0.d0
         deliHL(iR) = 0.d0
         Rs = int(RsMin + (iR-1)*dR)
         IF(iPl.gt.1) THEN
               IF((iPl.eq.2).or.(iR.eq.NRPts)) THEN                  
c                  CALL CSigZ(E,Mu,Rs,delrHL(iR),deliHL(iR),ZTemp,
c     &                 WpCorr,Gamma,AmpFac)
                  CALL CSigZ(E,Mu,Rs,delrHL(iR),deliHL(iR),ZTemp,
     &                 WpCorr,AmpFac)
               ELSE IF(iPl.eq.3) THEN
                  delrHL(iR) = 0.d0
                  deliHL(iR) = 0.d0
               ELSE
                  delrHL(iR) = delrHL(NRPts)
               END IF
               IF(iR.eq.NRPts) ZRnrm = ZTemp
            ELSE
c               CALL CSigma(E,Mu,Rs1(iR),delrHL(iR),deliHL(iR),WpCorr,
c     &              Gamma,AmpFac)
               CALL CSigma(E,Mu,Rs1(iR),delrHL(iR),deliHL(iR),WpCorr,
     &              AmpFac)
            END IF  
      
c           Write Sigma(Rs,E) to mpse.bin
            WRITE(47,'(6F20.10)') E, Rs, delrHL(iR), deliHL(iR),
     &           DBLE(ZTemp), DIMAG(ZTemp)
         END DO
         CLOSE(47)
         
         RETURN
         END

c     Josh - argument iPl has been added to arguments of xsect
      subroutine xsect (ipr2, dx, x0, ri, ne, ne1, ik0, em, edge,
     1                  ihole, emu, corr, dgc0, dpc0, jnew,
     2                  ixc, lreal, rmt, rnrm, xmu,
     2                  iPl,
     3                  vtot, vvalgs, edens, dmag, edenvl,
     4                  dgcn, dpcn, adgc, adpc, xsec, xsnorm, rkk,
     5                  iz, xion, iunf, xnval,
     5                  izstd, iorb, l2lp,
     6                  ipol, ispin, le2, angks, ptz)

c gamach, eorb, ifxc, kappa

c     right know the same self-energy is used for calculation
c     of the central atom part (xsec) and dipole m.e. for
c     scattering (rkk). You may want to run xsect separately
c     for xsec and for rkk, if you want to use different self-energy
c     for central and scattering parts.  ala. fix later

      implicit double precision (a-h, o-z)

c     INPUT
c     dx, x0, ri(nr)
c                  Loucks r-grid, ri=exp((i-1)*dx-x0)
c     ne, em(ne)   number of energy points, real energy grid
c     edge         chemical potential (energy for k=0)
c     ihole        hole code
c     emu          position of chemical potential in absorption specrum
c     dgc0(nr)     dirac upper component, ground state hole orbital
c     dpc0(nr)     dirac lower component, ground state hole orbital
c     ixc          0  Hedin-Lunqist + const real & imag part
c                  1  Dirac-Hara + const real & imag part
c                  2  ground state + const real & imag part
c                  3  Dirac-Hara + HL imag part + const real & imag part
c                  5  Dirac-Fock exchange with core electrons +
c                     ixc=0 for valence electron density
c     lreal        logical, true for real phase shifts only
c     rmt          r muffin tin
c     xmu          fermi level
c     vi0          const imag part to add to complex potential
c     gamach       core hole lifetime
c     vtot(nr)     total potential, including gsxc, final state
c     edens(nr)    density, hole orbital, final state
c     dmag(251)     density magnetization
c     edenvl      valence charge density
c     dgcn(dpcn)   large (small) dirac components for central atom
c     adgc(adpc)   their development coefficients
c
c     OUTPUT
c     xsec(ne)    atomic absorption cross section to multiply \chi
c                 (atomic background for XMCD)
c     xsnorm(ne)  atomic  absorption cross section (norm for XMCD)
c     rkk(ne, 8)  normalized reduced matrix elements for construction
c                 of termination matrix in genfmt.

      include '../HEADERS/const.h'
      include '../HEADERS/dim.h'
      complex*16 ptz
      dimension ptz(-1:1, -1:1)

      complex*16 em(nex)
      dimension ri(nrptx), vtot(nrptx), edens(nrptx),dmag(nrptx)
      dimension dgc0(nrptx), dpc0(nrptx), vvalgs(nrptx), edenvl(nrptx)
      dimension dgcn(nrptx,30), dpcn(nrptx,30)
c      dimension eorb(30), kappa(30)
      dimension adgc(10,30), adpc(10,30), xnval(30), iorb(-4:3)
      complex*16 rkk(nex, 8), xsec(nex)
      complex*16 bmat(-lx:lx,0:1,8, -lx:lx,0:1,8)
      dimension kind(8), lind(8)
      dimension xsnorm(nex)

      dimension xp(nrptx), xq(nrptx)

c     work space for xcpot
      dimension vxcrmu(nrptx), vxcimu(nrptx), gsrel(nrptx)
      dimension vvxcrm(nrptx), vvxcim(nrptx)

c     work space for fovrg
      complex*16 p(nrptx), q(nrptx), pn(nrptx), qn(nrptx), fscf(nrptx)
      complex*16 pp(nrptx), qp(nrptx), pnp(nrptx), qnp(nrptx)
c     storage for calculation of cross term (SPIN 1 only)
      complex*16 xrcold(nrptx) , xncold(nrptx)

      complex*16  p2, ck, xkmt
c      complex*16  xkmtp, xm1, xm2, xm3, xm4, yvec(nrptx,1)
      complex*16  pu, qu, dum1, factor
      complex*16  xfnorm, xirf, xirf1
      complex*16  temp, aa, bb, cc, rkk1, rkk0, phold
      complex*16  phx(8), ph0
      complex*16  eref

      complex*16 jl,jlp1,nl,nlp1
      complex*16  v(nrptx), vval(nrptx)
      complex*16  xrc(nrptx), xnc(nrptx)
      character*512 slog
      logical ltrace
c     nesvi:  
      complex*16 xrhoce(nex), xrhopr(nex), chia(nex), cchi(nex)
      dimension omega1(nex), bf(0:2, nrptx)

      dimension pat(nrptx),qat(nrptx)
      complex*16 intr(nrptx),var(nrptx) 
c     to pass energy levels and projected DOS
c      dimension neg(30), rhoj(nex,30)
      dimension eng(nex, 30)
c     Josh - Added iPl switch for PLASMON card
c          - and WpCorr = Wi/Wp, Gamma, AmpFac
c          - to describe Im[eps^-1]
      integer iPl, ipole
      double precision WpCorr(MxPole), Gamma(MxPole), AmpFac(MxPole)
c     Josh END

c     explicitly intialize some things
      rkk0  = (0.,0.)
      rkk1  = (0.,0.)
      phold = (0.,0.)
      
      do 5 i=1,MxPole
         WpCorr(1) = -1.d30
 5    continue

      call setkap(ihole, kinit, linit)
c      PRINT*, 'dx=',dx
c     set imt and jri (use general Loucks grid)
c     rmt is between imt and jri (see function ii(r) in file xx.f)
      imt = int((log(rmt) + x0) / dx)  +  1
      jri = imt+1
      jri1 = jri+1
      if (jri1 .gt. nrptx)  call par_stop('jri .gt. nrptx in phase')

c     nesvi: define jnrm
      inrm = int((log(rnrm) + x0) / dx) + 1
      jnrm = inrm + 1

c     We'll need <i|i> later to normalize dipole matrix elements
c     <i|r|f>.  NB, dgc and dpc are r*wave_fn, so use '0' in somm to
c     get integral  psi**2 r**2 dr.
c     Square the dgc0 and dpc0 arrays before integrating.
c     <i|i> == xinorm.
c     dgc and dpc should be normalized <i|i>=1, check this here
      do 10  i = 1, nrptx
         xp(i) = dpc0(i)**2
         xq(i) = dgc0(i)**2
  10  continue
c     nb, xinorm is used for exponent on input to somm
      xinorm = 2*linit + 2
      call somm (ri, xp, xq, dx, xinorm, 0, jnrm)
      del = abs (abs(xinorm) - 1)
      if (del .gt. 1.e-2) then
         write(slog,'(a,i8,1p2e13.5)') ' ihole, xinorm ', ihole , xinorm
         call wlog(slog)
c        if using real phase shifts, don't expect great results
         if (lreal.lt.2)  then
           call wlog(' There may be convergence problems.')
           call wlog(' Xinorm should be 1. If you set the RGRID, '//
     1               'minor interpolation errors ')
           call wlog(' that will not affect final results may occur')
         endif
      endif

c     use ixc for testing
      index = ixc
c       Always use ground state self energy for xsection, quick fix
c       JJR, Jan 93
c       change for testing broadened plasmon pole 6/93
c       index = 2
c   ALA found that it is better to use index=ixc and real part of 
c   self-energy for atomic xsection. 12/96
      ltrace = .true.
      call bcoef(kinit, ipol, ptz, le2, ltrace, ispin, angks, 
     1           kind, lind, bmat)
c     set spin index to use bmat
      isp = 0
      if (ispin.eq.1) isp = nspx - 1

c     zero rkk and phx
      do 20 ie = 1,nex
      do 20 k1 = 1,8
 20   rkk(ie,k1) = 0
      do 30 k1 = 1,8
 30   phx(k1) = 0

      ifirst = 0
c     Josh - if PLASMON card is set, and using HL exc,
c          - read pole information from epsinv.dat
      IF( (iPl.gt.0).and.(ixc.eq.0) ) THEN
         open(file='exc.dat', unit=47, status='old',iostat=ios)
         call chopen (ios, 'exc.dat', 'ffmod2(xsect)')
         DO ipole = 1, MxPole
            call rdcmt(47,'#*cC')
            read(47,*,END=35) WpCorr(ipole), Gamma(ipole), AmpFac(ipole)
            Gamma(ipole)  = Gamma(ipole)/hart
            WpCorr(ipole) = (WpCorr(ipole)/hart) /
     &           SQRT(3.d0/((3 / (4*pi*edens(jri+1))) ** third)**3)
         END DO
 35      CONTINUE
         WpCorr(ipole) = -1.d30
         CLOSE(47)
      END IF
c$$$      IF(ixc.eq.0) THEN
c$$$c        Write wp as calculated from density to sigma.dat
c$$$         open(file='mpse.dat', unit=45, status='replace',iostat=ios)
c$$$         call chopen (ios, 'sigma.dat', 'ffmod2(xsect)')
c$$$         write(45,*) '# ', 'rs      wp(Hartrees)'
c$$$         write(45,*) '# ', (3 / (4*pi*edens(jri+1))) ** third,
c$$$     &        SQRT(3.d0/((3 / (4*pi*edens(jri+1))) ** third)**3)*hart
c$$$         write(45,'(a)')
c$$$     &        '# E-EFermi (eV)   Re[Sigma(E)] (eV)   Im[Sigma(E)] (eV)'
c$$$     &        // '   Re[Z]   Im[Z]   Mag[Z]   Phase[Z]   Lambda(E) (/A)'
c$$$      END IF
c     Josh END
      
      do 400 ie = 1, ne
         iph = 0
c        Josh - xcpot now has new arguments:
c             - iPl, WpCorr, Gamma, AmpFac         
         call xcpot (iph, ie, index, lreal, ifirst, jri,
     1               em(ie), xmu,
     2               vtot, vvalgs, edens, dmag, edenvl,
     3               eref, v, vval, iPl, WpCorr, AmpFac,
     4               vxcrmu, vxcimu, gsrel, vvxcrm, vvxcim,rnrm)
c         call xcpot (iph, ie, index, lreal, ifirst, jri,
c     1               em(ie), xmu,
c     2               vtot, vvalgs, edens, dmag, edenvl,
c     3               eref, v, vval, iPl, WpCorr, Gamma, AmpFac,
c     4               vxcrmu, vxcimu, gsrel, vvxcrm, vvxcim,rnrm)

c       set the method to calculate atomic cross section
c       p2 is (complex momentum)**2 referenced to energy dep xc
        p2 = em(ie) - eref
        p2f = edge - dble(eref)
        ck = sqrt (2*p2 + (p2*alphfs)**2)
        xkmt = rmt * ck

        if (mod(index,10) .lt. 5) then
           ncycle = 0
        else
c          fix later . may be ncycle can be less
           ncycle = 3
        endif
        omega = (dble(em(ie)) - edge) + emu
        omega = max (omega, 0.001d0 / hart)
c       nesvi: add omega1(ie)- need it later
        omega1(ie) = omega

c       remember the bessel functions for multipole matrix elements
        xk0 = omega * alphfs
        ilast = jnrm+6
        if (ilast.lt.jnew) ilast = jnew
        if (ilast.gt.nrptx) ilast = nrptx
        do 50 i = 1, ilast
          temp = xk0 * ri(i)
          if (abs(temp).lt.1.d0) then
c           use series expansion
            do 40 ll = 0,2
              call bjnser(temp,ll, xirf, dum1,1)
              bf(ll,i) = dble(xirf)
 40         continue
          else
c           use formula
            x = dble(temp)
            sinx = sin(x)
            cosx = cos(x)
            bf(0,i) = sinx/x
            bf(1,i) = sinx/x**2 - cosx/x
            bf(2,i) = sinx*(3/x**3-1/x) - 3*cosx/x**2
          endif
 50     continue

c       notice for spin-dep case xsnorm and xsec are spin-dep
c       and kept separately (see call to xsect in subroutine xsph)
        xsnorm(ie) = 0 
        xsec(ie) = 0
        if (dble(em(ie)).lt.-10.d0) goto 400
        if (dimag(p2).le.0.d0 .and. dble(p2).le.0.d0) goto 400

c       matrix elements for multipole (E1,E2,M1) transitions
c       The terms up to (k/c)^2 for absorption are kept.
c       L3 edge: kdif=1 (3d5/2)      kdif=2 (3d3/2), kdif=3(4s)
c       L2 edge: kdif=1 (no transition), 2 (4s),      3 (3d3/2)
        do 350 mult = 0, 2
          if (mult.eq.0) then
c           E1 transitions
            kx = 1
            ks = 2
          else
c           M1 transitions
            kx = 1
            ks = 6
c           E2 transitions
            if (mult.eq.2) kx = 2
          endif 
c         skip unnecessary calculations
          if (mult.gt.0 .and. (mult.ne.le2)) goto 350
 
c         set ilast larger than jri for better interpolation for pu
c         also need 5 points after jri for irregular solution
          ilast = jnrm + 6
          if (ilast.lt.jnew) ilast = jnew

cc        calculate screened dipole field
          ww = dble(emu+p2-edge)
          if (mult.eq.0 .and. izstd.gt.0) then
c            if (ie.eq.1) call correorb(iz, ihole, rmt, jri, dx,ri,
c     1                   p2f,edge, v, dgcn, dpcn, adgc, adpc,
c     2                   eorb, neg, eng, rhoj, kappa, norbp)
            maxsize = 1
            matsize = 0
            sfun = 1.d0
c            call phiscf (ifxc, rmt, ilast, jri, p2, p2f, emu, dx,
c    1                  ri, v, edens, dgcn, dpcn, adgc, adpc,
c     2                  iz, ihole, neg, eng, rhoj,kappa, norbp, fscf,
c     3                  yvec, maxsize, matsize, sfun)
            wse = dble(p2-eng(1,ihole))
          else
            do 159 i = 1, nrptx 
  159       fscf(i) = 1.d0
            wse = ww
          endif
      
c         ww = 1
c         ww = wse / ww
          ww = sqrt(wse/ww)

          do 300 kdif = -kx, kx
            if (omega.le.0.0) goto 300
            ind = kdif + ks
            ikap = kind (ind)
            if (ikap .eq. 0) goto 300
c           use l2lp =0 to include both transitions l-->l+/-1
c           if (l2lp.ne.0) only dipole transitions are calculated.
c            l-->l+1 transitions
            if (l2lp.eq.1 .and. ((kinit.lt.0 .and. ind.ge.3) .or.
     1          (kinit.gt.0 .and. ind.ne.3)) ) goto 300
c            l-->l-1 transitions
            if (l2lp.eq.-1 .and. ((kinit.lt.0 .and. ind.ne.3) .or.
     1          (kinit.gt.0 .and. ind.ge.3)) ) goto 300

            iold = 0
            ic3=0
c           start cycle  do ic3=0,1
c           return for ic3=1 calculations only for |ispin|=1
c           where the central atom cross terms are needed
  100       continue

            irr = -1
c           ic3p=1 to test K2Cr2O7  L3 XES 
            ic3p = ic3
            call dfovrg ( ncycle, ikap, rmt, ilast, jri, p2, dx,
     1      ri, v, vval, dgcn, dpcn, adgc, adpc,
     2               xnval, pu, qu, p, q,
     3               iz, ihole, xion, iunf, irr, ic3p)
            lfin = lind (ind)
            ilp = lfin - 1
            if (ikap .lt. 0) ilp = lfin + 1
            call exjlnl (xkmt, lfin, jl, nl)
            call exjlnl (xkmt, ilp, jlp1, nlp1)
            call phamp(rmt,pu,qu, ck, jl,nl,jlp1,nlp1, ikap, ph0,temp)

            sign = -1.0
            if (ikap.gt.0) sign = 1.0
            factor = ck*alphfs 
            factor = sign * factor/(1+sqrt(1+factor**2))
            dum1 = 1/ sqrt(1+factor**2)
            xfnorm = 1 / temp *dum1
c           normalization factor
c           xfnorm = dum1*rmt*(jl*cos(delta) - nl*sin(delta))/ Rl(rmt)
c           dum1 is relativistic correction to normalization
c           normalize regular solution
            do 130  i = 1,ilast
              p(i)=p(i)*xfnorm
              q(i)=q(i)*xfnorm
  130       continue

cc          calculate xirf including fscf - TDLDA result
            do 140 id = 1, 2
              if (id.eq.1) then
                do 121 j = 1,ilast 
                  pp(j)  = p(j)*dble(fscf(j))
                  qp(j)  = q(j)*dble(fscf(j))
  121           continue
              else
                do 122 j = 1,ilast
                  pp(j)  = p(j)*dimag(fscf(j))
                  qp(j)  = q(j)*dimag(fscf(j))
  122           continue
              endif
              ifl = 1
              if (izstd.gt.0) ifl = -1
              xirf1 = 0
              call radint(ifl, mult, bf, kinit, dgc0,dpc0, ikap, pp,qp,
     1        pn,qn,ri,dx, ilast,iold, xrc,xnc, xrcold,xncold, xirf1)
c             if (ifl.lt.0) xirf1 = xirf1 * xk0 * ww
              if (ifl.lt.0) xirf1 = xirf1 * xk0 
              if (id.eq.1) then
                xirf = xirf1
              else
                if (abs(xirf) .eq. 0.d0) then
                  xirf = xirf1
                elseif (abs(xirf1) .eq. 0.d0) then
                  xirf = xirf
                elseif (abs(xirf1) .lt. abs(xirf)) then
                  dum = abs(xirf1) / abs(xirf)
                  xirf = xirf * sqrt(1.d0 + dum**2)
                else
                  dum = abs(xirf) / abs(xirf1)
                  xirf = xirf1 * sqrt(1.d0 + dum**2)
                endif
              endif
  140       continue

c           note that for real potential  xirf is real or reduced matrix
c           element for dipole transition is pure imaginary.
            if (ic3.eq.0) then
c              can remember only E2 or M1 matrix elements
               if (mult.eq.0 .or. le2.eq.mult) then
                 rkk(ie,ind)=xirf 
                 phx(ind) = ph0
               endif
c              for f' want to include both E2 and M1 for xsnorm and xsec
c              but now only one of them is included (fix later)
               xsnorm(ie)=xsnorm(ie) +
     1         ( dble(xirf)**2 + dimag(xirf)**2 )/ (2*kx+1)
               aa =  - coni*xirf**2
               xsec(ie) = xsec(ie) -  aa * bmat(0,isp,ind, 0,isp,ind)
            elseif (iold.eq.1) then
                rkk1=xirf
                phold = ph0
            elseif (iold.eq.2) then
                rkk0=xirf
            endif

c           get irregular solution and atomic cross-section xsec
c           find irregular solution

            if(dimag(em(ie)).gt.0.d0) then
              irr = 1
c             set pu, qu - initial condition for irregular solution 
              pu = (nl*cos(ph0)+jl*sin(ph0)) *rmt * dum1
              qu=(nlp1*cos(ph0)+jlp1*sin(ph0))*factor *rmt * dum1
             
c             test on bessel functions
c             if (ikap.gt.0) print*,'test1',xkmt**2*(jl*nlp1-nl*jlp1)

              call dfovrg (ncycle, ikap, rmt, ilast, jri, p2, dx,
     1              ri, v,vval, dgcn, dpcn, adgc, adpc,
     1              xnval, pu, qu, pn, qn,
     1              iz, ihole, xion, iunf, irr, ic3p)
cc            set N- irregular solution , which is outside
cc            N=(nlp1*cos(ph0)+jlp1*sin(ph0))*factor *rmt * dum1
cc            N = i*R - H*exp(i*ph0)
              temp = exp(coni*ph0)
              do i = 1, ilast
                pn(i) = coni * p(i) - temp * pn(i)
                qn(i) = coni * q(i) - temp * qn(i)
              enddo
            else
              do 150 i = 1, ilast
                pn(i) = 0
                qn(i) = 0
  150         continue
            endif

c           combine regular and irregular solution into the
c           central atom absorption coefficient xsec (mu = dimag(xsec))
c           thus for real energy dimag(xsec)=xsnorm

c           also include TDLDA effects
            do 170 id = 1, 2
              if (id.eq.1) then
                do 131 j = 1,ilast
                  pp(j)  = p(j)*dble(fscf(j))
                  qp(j)  = q(j)*dble(fscf(j))
                  pnp(j)  = pn(j)*dble(fscf(j))
                  qnp(j)  = qn(j)*dble(fscf(j))
  131           continue
              else
                do 132 j = 1,ilast
                  pp(j)  = p(j)*dimag(fscf(j))
                  qp(j)  = q(j)*dimag(fscf(j))
                  pnp(j)  = pn(j)*dimag(fscf(j))
                  qnp(j)  = qn(j)*dimag(fscf(j))
  132           continue
              endif

c           TDLDA theory is written for the r-form of matrix elements
c           so one might want to use ifl=-1,-2 for these calculations
c           on the other hand want ifl=1,2 for DANES calculations
c           since it is more reliable at high energies and gives
c           better results for Cu test.
              ifl = 2
              if (izstd.gt.0) ifl = -2

              call radint(ifl,mult, bf, kinit, dgc0, dpc0, ikap, pp, qp,
     1            pnp, qnp, ri,dx, ilast,iold, xrc, xnc, xrcold, xncold,
     2            xirf1)
              if (ifl.lt.0) xirf1 = xirf1 * xk0**2 * ww**2
              if (id.eq.1) then
                xirf = xirf1
              else
                if (abs(xirf) .eq. 0.d0) then
                  xirf = xirf1
                elseif (abs(xirf1) .eq. 0.d0) then
                  xirf = xirf
                elseif (abs(xirf1) .lt. abs(xirf)) then
                  dum = abs(xirf1) / abs(xirf)
                  xirf = xirf * sqrt(1.d0 + dum**2)
                else
                  dum = abs(xirf) / abs(xirf1)
                  xirf = xirf1 * sqrt(1.d0 + dum**2)
                endif
              endif
  170       continue

            if (ic3.eq.0) then
               xsec(ie) = xsec(ie) - xirf * bmat(0,isp,ind, 0,isp,ind)
            endif

c           ------start of density of states part------------- 
c           added by nesvi 07/12/00
c
c           Calculate rhoc00 and rho_projected on 
c           the same grid as xsect. Need this to calculate the smooth
c           atomic ratio rho_0/mu_0 or rho_proj/mu_0.              
c           The atomic functions are normalized to 1 inside Norman radius.
c           This procedure can be called 'Renormalized atomic sphere method".
c           It gives very reasonable numbers for hole counts. In order to
c           get Mulliken counts one can extend integration limits till very
c           large R, but it's currently not recommended because of the problems
c           with the wave function's tails above Rnm.
 

            jproj =  iorb(ikap)
            if (jproj.eq.0 .and. ikap.lt.0) jproj = iorb(-ikap-1)
            kdif1 = -1
            if(kinit.gt.0) kdif1 =  1
                
            if (kdif .eq. kdif1 .and. ic3.eq.0 .and. jproj.gt.0) then
c              calculate rhoc00 (rho_0)

               temp = (2*lfin+1.0d0) / (1+factor**2) /pi *4*ck /hart
               do 500 i = 1, ilast
                 xrc(i) = pn(i)*p(i) - coni*p(i)*p(i) 
     1                   + qn(i)*q(i) - coni*q(i)*q(i)
  500          continue    
               xirf = 1
c              integration is till Norman radius, not Rmt as in xsect
               i0 = jnrm + 1
               call csomm2 (ri, xrc, dx, xirf, rnrm, i0)
               xrhoce(ie) = - xirf * temp
            
c              calculate rho_projected:              

c              pat, qat - atomic functions that we make projection on.
               do 510 i=1,nrptx
                 pat(i) = dgcn(i,jproj)
                 qat(i) = dpcn(i,jproj)
  510          continue

c     normalize pat and qat in the Norman radius sphere: <n|n>=1,
c     (renormalized atomic sphere method)
     
               do 520  i = 1, ilast
                  xp(i) = pat(i)**2 + qat(i)**2
                  xq(i) = 0
  520          continue
c     nb, xinorm is used for exponent on input to somm 
               xinorm = 2*lfin + 2
               call somm2 (ri, xp, dx, xinorm, rnrm, 0, i0)
c              call somm (ri, xp, xq, dx, xinorm, 0, jnrm)
      
               xinorm = sqrt(xinorm)
               do 530 i=1,nrptx
                  pat(i) = pat(i) / xinorm
                  qat(i) = qat(i) / xinorm
  530          continue
  
c              calculate overlap integral between f and atomic function
c              (integral Rl(r)*Psi_at(r)dr from 0 till r') 
c              intr(i) is that overlap integral. Later it
c              will be multiplied by pr(i)*Psi_at(r') and integrated 
c              till Norman radius.

               do 540 i=1,ilast
                  var(i)=pat(i)*p(i)+qat(i)*q(i)
c                 factor of 2 -integration r< r>  -->2 r r'
  540          continue

c              integration by trapezoid method
               intr(1)=var(1)*ri(1)
               do 550 i=2,ilast
                  intr(i)=intr(i-1)+ (var(i)+var(i-1))*(ri(i)-ri(i-1))
  550          continue 


c         now calculate rho_projected - xrhopr
               temp = (2*lfin+1.0d0) / (1+factor**2) /pi *4*ck /hart
c              temp = abs(ikap) / (1+factor**2) /pi *4*ck /hart
               do 560  i = 1, ilast
                 xrc(i) = pn(i)*pat(i)*intr(i)+ 
     1                    qn(i)*qat(i)*intr(i)
                 xrc(i) = xrc(i) - coni*(p(i)*pat(i)*intr(i) + 
     1                    q(i)*qat(i)*intr(i))
  560          continue

               xirf =  1
               call csomm2 (ri, xrc, dx, xirf, rnrm, i0)
               xrhopr(ie) = - xirf * temp
    
            endif
c           ----------end of density of states part---


            if (iold.gt.0) then
c             calculate cross term contribution to XMCD
c             in both cases coupling between neighbors 
c             need to remove SO interaction (ic3=1) in order
c             to avoid unphysical peak in Gd XMCD. a.l. ankudinov
              k1 = ind - 1
              if (k1.ge.1 .and.k1.le.8) then
              if (lind(k1).eq.lind(ind) .and. lind(k1).gt.0) then
                aa = exp( coni*(ph0 - phold))
                bb = 1/aa
                cc = - ( bmat(0,isp,k1, 0,isp,ind) +
     1                 bmat(0,isp,ind, 0,isp,k1) ) / 2.d0
                xsec(ie) = xsec(ie) - coni * rkk1 * rkk0 * (bb+aa) * cc
cc              combine regular and irregular solution into the
cc              central atom absorption coefficient (mu=dimag(xsec))
cc              thus for real energy dimag(xsec)=xsnorm
                call radint (3, mult, bf, kinit, dgc0, dpc0, ikap, p, q,
     1            pn, qn, ri, dx, ilast, iold, xrc, xnc, xrcold, xncold,
     2            xirf)
                xsec(ie) = xsec(ie) + xirf * cc * bb
  
                call radint (4, mult, bf, kinit, dgc0, dpc0, ikap, p, q,
     1            pn, qn, ri, dx, ilast, iold, xrc, xnc, xrcold, xncold,
     2             xirf)
                xsec(ie) = xsec(ie) + xirf * cc * aa
              endif
              endif
            endif
cc          end of |ispin=1| cross term calculations

c           prepare for ic3=1 cross term calculations if needed
            if (ic3.eq.0 .and. abs(ispin).eq.1) then
              iold = 0
              if (ind.lt.8 .and. lind(ind).gt.0) then
                k1 = ind + 1
                if (lind(k1).eq.lind(ind)) iold = 1
              endif
              if (ind.gt.1 .and. lind(ind).gt.0) then
                k1 = ind - 1
                if (lind(k1).eq.lind(ind)) iold = 2
              endif
c             need to remove SO interaction to calculate cross term
c             big effect for Gd XMCD calculations
              if (iold.gt.0) then
c               repeat calculation for current kdif with SO turned off
                ic3 = 1
                goto 100
              endif
            endif

  300     continue
  350   continue

        if (omega.gt.0.0) then
c         prefac = (8 * pi / 3)  * alphfs * omega  -- nonrelativistic
c         relativistic is (for alpha form)
          prefac = 4 * pi * alpinv / omega * bohr**2
          xsnorm(ie) =  xsnorm(ie) * prefac * 2*abs(ck) 
          xnorm= sqrt( xsnorm(ie) )
          xsec(ie) = xsec(ie) * prefac* 2*ck

c         put complex sqrt(prefactor) into reduced matrix elements rkk
          ck = sqrt ( prefac * (2*ck))
c         guarantee that we have the right root
          if (dimag(ck) .lt. 0) ck = -ck
c         add central atom phase shift here. 
          do 360 kdif = 1 , 8
 360      rkk(ie,kdif)= rkk(ie,kdif) * ck/xnorm * exp(coni*phx(kdif))
        endif
 400  continue
c     end of energy cycle

c     Josh - Close sigma.dat
      close(45)
c     Josh END

      if (ipr2.ge.3) then
c       calculate mu_0/rho_0 for XMCD normalization.
        do 410 ie=1,ne
           chia(ie) = 0
  410   continue
        vrcorr = 0
        vicorr = 0
        call xscorr(1, em, ne1, ne, ik0, xrhoce,xsnorm,chia,
     1     vrcorr, vicorr, cchi)
        do 420 ie = 1, ne1
            xrhoce(ie)  = coni* dimag(xrhoce(ie)+cchi(ie))
  420   continue
        call xscorr(1, em, ne1, ne, ik0, xrhopr,xsnorm,chia,
     1     vrcorr, vicorr, cchi)
        do 425 ie = 1, ne1
            xrhopr(ie)  = coni* dimag(xrhopr(ie)+cchi(ie))
  425   continue    
        call xscorr(1, em, ne1, ne, ik0, xsec,xsnorm,chia,
     1     vrcorr, vicorr, cchi)
        do 430 ie = 1, ne1
            cchi(ie)  = coni* dimag(xsec(ie)+cchi(ie))
  430   continue

        open(unit=3,file='ratio.dat',status='unknown', iostat=ios)
        open(unit=4,file='ratiop.dat',status='unknown', iostat=ios)
c       normalize to xsec at 50 ev above edge
        edg50 = emu +50.0 / hart
        call terp (omega1, xsnorm, ne1, 1, edg50, xsedge)
        write(3,440) xsedge, emu * hart 
  440   format ('# Normalization factor:', e12.4,
     1     ' Angstrom**2. Fermi level at ', f7.1, ' eV.')
        write(3,450)
  450   format ('#   Energy      rho_0        mu_0       rho_0/mu_0 ')
     
        write(4,440) xsedge, emu * hart 
        write(4,455)
  455   format ('#   Energy      rho_proj      mu_0      rho_proj/mu_0',
     1   '    mu_deloc ')

        do 470 ie=1,ne1 
           if (dimag(cchi(ie)).eq.0.d0 .and. ie.lt.ik0) then
              cchi(ie)=cchi(ik0)
              xrhoce(ie)=xrhoce(ik0)
              xrhopr(ie)=xrhopr(ik0)
           endif
           ratio = dimag(xrhoce(ie)) / dimag(cchi(ie)) * xsedge
           ratiop = dimag(xrhopr(ie)) / dimag(cchi(ie)) * xsedge

           write(3,460)  dble(em(ie))*hart, dimag(xrhoce(ie)),
     1          dimag(cchi(ie))/xsedge, ratio*corr
c          corr is the ratio N_av/N_j, responsible for difference in
c          counts due to variation of wave function due to spin-orbit
  460      format(f12.6, 2x, e12.6,2x,e12.6,2x,e12.6,1x,e12.6)      
           write(4,465)  dble(em(ie))*hart, dimag(xrhopr(ie)),
     1          dimag(cchi(ie))/xsedge, ratiop,
     2          dimag(xrhoce(ie)-xrhopr(ie))/ratio 
c     also write contribution to mu_0 from delocalized states defined as
c     (rho-rho_proj)/ratio 
  465      format(f12.6, 2x, e12.6,2x,e12.6,2x,e12.6,1x,e12.6,2x,e12.6)    
      
  470   continue    
        close(unit=3)
        close(unit=4)
      endif 

      return
      end

      subroutine coulom( icoul, npot, ilast, rhoval, edenvl, edens,
     2     nat, rat, iatph, iphat, rnrm, dq, iz, vclap)
c     searches for fermi level in comlex energy plain and 
c     Output:
c       rhoval - new valence density
c       vclap  - coulomb potential
c       qnrm   - charge inside each norman sphere
      implicit double precision (a-h, o-z)

      include '../HEADERS/const.h'
      include '../HEADERS/dim.h'

      dimension ilast(0:nphx)
      dimension ri05(251)
      dimension rhoval(251,0:nphx+1), edenvl(251,0:nphx)
      dimension edens(251,0:nphx), dq(0:nphx), iz(0:nphx)
      dimension rat(3,natx), iatph(0:nphx), iphat(natx), rnrm(0:nphx)
      dimension vclap(251,0:nphx)

c     work space
      dimension  drho(251), dvcl(251)
      external dist

c     make  radial grid with 0.05 step
      dx05=0.05d0
      do 10 i=1,251
         ri05(i) = exp(-8.8d0+dx05*(i-1))
  10  continue

      do 600 ip=0,npot
        do 550 ir=1, ilast(ip)
           drho(ir)= (rhoval(ir,ip)-edenvl(ir,ip))*ri05(ir)**2
  550   continue
        call potslw(dvcl,drho, ri05,dx05, ilast(ip))

        do 560 ir = ilast(ip)+1, 251
           dvcl(ir) = 0.0d0
  560   continue

        if (icoul.eq. 1) then
c         find the change of coulomb potential at norman radius for
c         each type of iph
          jnrm = int((log(rnrm(ip)) + 8.8d0) / 0.05d0)  +  2
          dvnrm = dq(ip) / rnrm(ip)
          iat0 = iatph(ip)
          do 570 iat=1,nat
             if (iat.ne.iat0) then
               rr = dist( rat(1,iat), rat(1,iat0))
               if (rr.lt.rnrm(ip)) rr=rnrm(ip)
               dvnrm = dvnrm + dq(iphat(iat)) / rr
             endif
  570     continue

c         transfer condition to r(jnrm) instead of r_nrm.
          dr = ri05(jnrm) - rnrm(ip)
c         xx = dr/rnrm(ip)
c         correction using linear expansion of drho
c         neglecting terms xx**4 and higher
          bb = (drho(jnrm)-drho(jnrm-1)) / (ri05(jnrm)-ri05(jnrm-1))
c         dvnrm = dvnrm - xx* (dq(ip)/ri05(jnrm) + xx* (drho(jnrm)*
c    1    (rnrm(ip)/ri05(jnrm)-0.5) + xx*(drho(jnrm)-bb*rnrm(ip))/3 ))
          dvnrm = dvnrm - dr / 2 * ( dq(ip) / rnrm(ip)**2 + 
     1       (dq(ip)+drho(jnrm)*dr-bb/2*dr**2) / ri05(jnrm)**2 )


c         dvcl is calculated correct up to constant shift which is
c         fixed by the condition at R_nrm
          dvnrm = dvnrm - dvcl(jnrm)

        else
c         now this is default (icoul=0)
c         then do normalization based on norman picture
c         i.e. total density is approximated by a sum of densities
c          which are zero outside each norman sphere. use this
c         approximation only for the difference between 2 potentials
c         This is needed for infinite solid where the algorithm for
c         icoul=1 is unstable due to long range Coulomb potential
c         probably better fix will be to use Ewald summation to figure
c         out the Madelung constants (icoul=2 optinon to be done later).

          call frnrm (edens(1,ip), iz(ip), rnrm1)
          do 710 i = 1,251
  710     drho(i) = edens(i,ip) - edenvl (i,ip) +rhoval(i,ip)
          call frnrm (drho, iz(ip), rnrm2)
          rmin = min (rnrm1, rnrm2)
          inrm = int((log(rmin) + 8.8d0) / 0.05d0)  +  1
          r0 = ri05(inrm)

          delv = 0.d0
          if (rnrm2.gt.rnrm1) then
            aa = (drho(inrm+1)-drho(inrm)) / (ri05(inrm+1)-ri05(inrm))
            bb = drho(inrm) - aa * ri05(inrm)
            delv = delv - fab (aa, bb, r0, rnrm1, rnrm2)
          else
            aa = (edens(inrm,ip)-edens(inrm+1,ip))
     1           / (ri05(inrm+1)-ri05(inrm))
            bb = - edens(inrm,ip) - aa * ri05(inrm)
            delv = delv - fab (aa, bb, r0, rnrm2, rnrm1)
          endif
          aa = (drho(inrm+1)-drho(inrm)+edens(inrm,ip)-edens(inrm+1,ip))
     1          / (ri05(inrm+1)-ri05(inrm))
          bb = drho(inrm) - edens(inrm,ip) - aa * ri05(inrm)
          delv = delv - fab (aa, bb, r0, r0, rmin)

          dvnrm = delv - dvcl(inrm)
        endif

        do 580 ir=1,ilast(ip)
           vclap(ir,ip) = vclap(ir,ip) + dvcl(ir) + dvnrm 
  580   continue
        do 590 ir=ilast(ip)+1,251
  590   vclap(ir,ip)=0.0d0
  600 continue

      return
      end

      double precision function fab (aa,bb,r0,r1,r2)
c     it is the \int_r1^r2 dr 4\pi\rho(r) r**2 (1/r0 - 1/r)
c     where 4\pi\rho(r) = aa*r + bb
c     you arrive to this integral as a result of norman picture
c     for normalization of coulomb potential just below the rmin
      implicit double precision (a-h, o-z)

      a2 = (r2**2-r1**2)/2.d0
      a3 = (r2**3-r1**3)/3.d0
      a4 = (r2**4-r1**4)/4.d0
      fab = aa*(a4/r0-a3) + bb*(a3/r0-a2)
      return
      end

      subroutine rpotph (io, nhead0, head0, lhead0,
     1             nat, nph, nfr, ihole, gamach, iafolp, intclc,
     1             ixc, vr0, vi0, rs0, iphat, rat, iatph, ifrph, 
     1             xnatph, novr,
     2             iphovr, nnovr, rovr, folp, ion, iz, iprint, 
     2             ixanes, nemax, xkmin, xkmax, potlbl)
      implicit double precision (a-h, o-z)

c     Notes:
c        nat   number of atoms in problem
c        nph   number of unique potentials
c        nfr   number of unique free atoms
c        ihole hole code of absorbing atom
c        iph=0 for central atom
c        ifr=0 for central atom
c        xkmin, xkmax  min and max energy mesh points to consider

      include 'dim.h'

      character*(*) head0(nhead0)
      dimension lhead0(nhead0)

c     End of line comments removed -- see include file arrays.h for
c     comments.
c     Specific atom input data
      dimension iphat(natx)
      dimension rat(3,natx)

c     Unique potential input data
      dimension iatph(0:nphx)
      dimension ifrph(0:nphx)
      dimension xnatph(0:nphx)
      character*6  potlbl(0:nphx)

      dimension folp(0:nphx)
      dimension novr(0:nphx)
      dimension iphovr(novrx,0:nphx)
      dimension nnovr(novrx,0:nphx)
      dimension rovr(novrx,0:nphx)

c     Free atom data
      dimension ion(0:nfrx)
      dimension iz(0:nfrx)

c     read and save header from old file, has carriage control char
      head0(1) = ' '
      call rdhead (io, nhead0, head0, lhead0)
      read(io,*) ihole, gamach, iprint, iafolp, intclc
      read(io,*) ixc, vr0, vi0, rs0
      read(io,*) ixanes, nemax, xkmin, xkmax
      read(io,*) nfr
      do 710  ifr = 0, nfr
         read(io,*)  index, iz(ifr), ion(ifr)
  710 continue
      read(io,*) nat
      do 720  iat = 1, nat
         read(io,*) index, iphat(iat), (rat(j,iat),j=1,3)
  720 continue
      read(io,*) nph
      do 740  iph = 0, nph
         read(io,*) index, iatph(iph), ifrph(iph), xnatph(iph),
     1                folp(iph), novr(iph)
         read(io,*) potlbl(iph)
         do 730  iovr = 1, novr(iph)
            read(io,*) iphovr(iovr,iph), nnovr(iovr,iph),
     1                   rovr(iovr,iph)
  730    continue
  740 continue

      return
      end

! Subroutine getomi finds poles and weights for representing epsInv.
! Written by J. Kas, 2006
      SUBROUTINE getomi(wgrid, epsInv, NPts, NPoles, omi, gi, Deltai,
     &     eps0)
      IMPLICIT NONE
!     Input variables
!     wGrid(NPts)  - grid of omega
!     epsInv(NPts) - loss function
!     NPoles       - Number of poles to represent epsInv
      
!     Output
!     omi          - omega position of poles
!     gi           - pole strengths
!     Deltai       - energry region about omi where
      INTEGER NPoles, NPts
      DOUBLE PRECISION wGrid(NPts), epsInv(NPts), omi(NPoles),
     &     gi(NPoles), Deltai(NPoles), eps0

!     Local variables
      INTEGER maxPts, i1, i2
      PARAMETER (maxPts = 50000)
      DOUBLE PRECISION M0, M0i, M1i, MM1i, M1Old, M1New, omNew, omOld,
     $       pi, Tmp1(maxPts), Tmp2(maxPts), IntGrl, a, b, c, frac

c     INTEGER MaxPoles, iMax, 
c     DOUBLE PRECISION egap
      PARAMETER (pi = 3.14159 26535 89793 23846 26433d0)
      EXTERNAL IntGrl
!     Find zeroth moment
!      frac = (1.d0-0.01d0)
      frac = 0.999d0
      M0 = 0.5d0*epsInv(1)*wGrid(1)
      DO i1 = 2, NPts
         M0 = M0 + 0.5d0*(epsInv(i1)+epsInv(i1-1))*
     &        (wGrid(i1)-wGrid(i1-1))
         Tmp1(i1) = epsInv(i1)/wGrid(i1)
         Tmp2(i1) = epsInv(i1)*wGrid(i1)
      END DO
!     Find gap energy
!      DO i1 = 1, NPts
      
!     Now find energy regions such that the integral of epsinv in each region is
!     equal.
      omOld = 0.d0
      omNew = 0.d0
      M1Old = 0.d0
      M1New = 0.d0
      b     = 0.d0
      ! Save the first 10 poles for low energies.
      DO i1 = 1, NPoles
         M0i = 0.5d0*epsInv(1)*wGrid(1)
         M1New = 0.5d0*epsInv(1)*wGrid(1)**2
         DO i2 = 2, NPts
            IF(M0i.ge.(DBLE(i1)*frac*M0/DBLE(NPoles))) THEN
               omOld = omNew
               omNew = wGrid(i2-1)
               IF(i2.eq.1) THEN
                  M0i = 0.d0
               ELSEIF(i2.eq.2) THEN
                  M0i = 0.5d0*epsInv(1)*wGrid(1)
               ELSE
                  M0i = M0i - 0.5d0*(epsInv(i2-1)+ epsInv(i2-2))*
     $              (wGrid(i2-1)-wGrid(i2-2))
               END IF
               GOTO 5
            ELSE
               M0i = M0i + 0.5d0*(epsInv(i2)+epsInv(i2-1))*
     $              (wGrid(i2)-wGrid(i2-1))
               M1New = M1New + 0.5d0*(epsInv(i2)*wGrid(i2)+ epsInv(i2-1)
     $              *wGrid(i2-1))*(wGrid(i2)-wGrid(i2-1))
            END IF
         END DO
 5       CONTINUE
 
!        The region has been found up to the wGrid accuracy. Now interpolate
!        to find omi
         IF(i2.eq.2) THEN
            a = epsInv(i2-1)/omNew
         ELSE
            a = (epsInv(i2-1) - epsInv(i2-2))/(omNew - wGrid(i2-2))
            b = epsInv(i2-2)
         END IF
         a = MAX(a, 1.d-6)
         c = 2.d0/a*(M0i - frac*M0*(DBLE(i1)/DBLE(NPoles)))

         omNew = wGrid(i2-2) - b/a + SQRT((b/a)**2 - c)
         IF((omNew.lt.wGrid(i2-2)).or.(omNew.gt.wGrid(i2-1))) THEN
            omNew = wGrid(i2-2) - b/a - SQRT((b/a)**2 - c)
         END IF

         IF(.FALSE.) THEN
            omOld = DBLE(i1-1)*500.d0/DBLE(NPoles)
            omNew = DBLE(i1)*500.d0/DBLE(NPoles) 
         END IF
!        Now set omi and g s.t. the inverse and first moments are preserved for
!        this region.
         MM1i = 0.d0
         M1i  = 0.d0
         IF(omOld.eq.0.d0) THEN
            MM1i = 0.5d0*epsInv(1)
            M1i  = 0.5d0*epsInv(1)*wGrid(1)**2
            omOld = wGrid(1)
         END IF
         MM1i = MM1i + IntGrl(omOld, omNew, wGrid, Tmp1, NPts)
         M1i  = M1i + IntGrl(omOld, omNew, wGrid, Tmp2, NPts)
         gi(i1)  = 2.d0/pi*MM1i
         omi(i1) = SQRT(M1i/MM1i)
         Deltai(i1) = omNew-omOld
         M1Old  = M1New
         !PRINT '(a27,i6,20f20.10)', 'i1, omi, omOld, omNew, a, b', i1,
         !&    omi(i1), omOld, omNew, a, b
      END DO

!     Shift and scale the poles to set inverse moment to 1-1/eps0, without changing
!     first moment. (eps0 is input by user)
      CALL getdom(gi,omi,NPoles,eps0)
      
      RETURN
      END

      DOUBLE PRECISION FUNCTION IntGrl(a, b, x, y, n)
      INTEGER n, i, iStart, iLast
      DOUBLE PRECISION x(n), y(n), dx, a, b, 
     &     ya, yb
c      DOUBLE PRECISION aEnd, bEnd,
      
      iStart = -1
      iLast = -1
      IntGrl = 0.d0
      dx = x(2) - x(1)
      
      DO i = 1, n
         IF(x(i).ge.a.and.x(i).lt.b) THEN
            iStart = i
            goto 5
         ELSE
            iStart = -1
         END IF
      END DO
 5    CONTINUE
      
      DO i = n, 1, -1
         IF(x(i).le.b.and.x(i).gt.a) THEN
            iLast = i
            goto 10
         ELSE
            iLast = -1
         END IF
      END DO
 10   CONTINUE

      IF (iStart.lt.0.and.iLast.lt.0) THEN
         CALL terp(x, y, n, 1, a, ya)
         CALL terp(x, y, n, 1, b, yb)
         IntGrl = IntGrl + 0.5d0*(yb+ya)*(b-a)
      ELSE
         DO i = iStart, iLast-1
            dx=x(i+1)-x(i)
            IntGrl = IntGrl + 0.5d0*(y(i)+y(i+1))*dx
         END DO
         
         CALL terp(x, y, n, 1, a, ya)
         CALL terp(x, y, n, 1, b, yb)
         
         IntGrl = IntGrl + 0.5d0*(ya+y(iStart))*(x(iStart) - a)
         IntGrl = IntGrl + 0.5d0*(yb+y(iLast))*(b-x(iLast))
      END IF
      RETURN
      END

! This will change the pole representation of the loss function without
! changing the f-sum rules. Written by J. Kas 2006
      SUBROUTINE getdom(gi,omi,NPoles,eps0)
      IMPLICIT NONE

!     Input/output
      INTEGER NPoles
      DOUBLE PRECISION gi(NPoles), omi(NPoles), eps0

!     Local
      INTEGER i1, i2, MxIter
      DOUBLE PRECISION MM1, tol, dom, dom1, dom2, sumg1, sumg2
      PARAMETER(MxIter = 10000, tol = 1.d-6)
      IF(eps0.lt.-1.5d0) RETURN
      IF(eps0.lt.0.d0) THEN
         MM1 = 1.d0
      ELSE
         MM1   = 1.d0 - 1.d0/eps0
      END IF
      dom1  = -omi(1)*0.999d0
      dom2  = omi(1)*0.999d0
!     Bracket dom between dom1 and dom2
      DO i1 = 1, MxIter
         sumg1 = 0.d0
         sumg2 = 0.d0
         DO i2 = 1, NPoles
            sumg1 = sumg1 + gi(i2)*(omi(i2)/(omi(i2)-dom1))**2
            sumg2 = sumg2 + gi(i2)*(omi(i2)/(omi(i2)-dom2))**2
         END DO
         IF((sumg1.lt.MM1).and.(sumg2.gt.MM1)) GOTO 5
         !IF(sumg1.gt.MM1) dom1 = dom1*2.d0
         !IF(sumg2.lt.MM1) dom2 = dom2/2.d0
         PRINT*, 'Error in getdom.f.'
         PRINT*, 'sumg1, sumg2', i1, sumg1, sumg2, MM1, dom1, dom2
         STOP
      END DO
 5    CONTINUE                  ! dom bracketed

      dom = 0.5d0*(dom1+dom2)
      DO i1 = 1, MxIter
         sumg1 = 0.d0
         DO i2 = 1, NPoles
            sumg1 = sumg1 + gi(i2)*(omi(i2)/(omi(i2)-dom))**2
         END DO
         IF(abs((sumg1-MM1)/MM1).lt.tol) GOTO 10
         IF((sumg1-MM1).gt.0.d0) THEN
            dom2 = dom
         ELSE
            dom1 = dom
         END IF
         dom = 0.5d0*(dom1+dom2)
      END DO
 10   CONTINUE

      DO i1 = 1, NPoles
         gi(i1)  = gi(i1)*(omi(i1)/(omi(i1)-dom))**2
         omi(i1) = omi(i1)-dom
      END DO
      RETURN
      END
      
      

      subroutine ggtf( nsp, i0, ipi, ipf, lipotx, g0, tmatrx, g0t, gg,
     1                 toler1, toler2, lcalc, msord)

      implicit real (a-h,o-z)
      implicit integer (i-n)
c  output
c    gg:  (nsp*lx**2, nsp*lx**2, 0:nphasx) submatrix spanning the entire
c          angular momentum basis for each unique potential
c     TFQMR: Saad, Iterative Methods for Sparse Matrices, p.225 (1996).

      include '../HEADERS/dim.h'
      include 'xparam.h'
      integer  i0 (0:nphx),  lipotx(0:nphx)

      parameter (one = 1, zero = 0)
      complex coni
      parameter (coni = (0,1))

c**** array of state kets at current energy
      common /stkets/ lrstat(4, istatx), istate

      complex   tmatrx(nspx, istatx)
c     big work matrices
      complex   g0( istatx, istatx), g0t( istatx, istatx)
      logical lcalc
      dimension lcalc(0:lx)

      complex xvec(istatx), uvec(istatx), avec(istatx), wvec(istatx)
      complex dvec(istatx), rvec(istatx), vvec(istatx)
      complex alpha, beta, aa, rho, eta
      real tau, nu, cm, err
c     return matrix containing info about each unique potential
      complex   gg(nspx*(lx+1)**2, nspx*(lx+1)**2, 0:nphasx)

      alpha = (1., 0.)

c      notice that in gglu we invert (1-Gt), but here (1-tG).
c     multiply T and G0 matrices together, construct g0t = 1 - T*G0
c     notice that the signs below for g0t ARE correct since 1 is the
c     unit matrix
c     since t is tri-diagonal, this product can be computed in n^2 time
c     also fill up some work matrices for use in eigenvalue and
c     determinant calculations and elsewhere
c     cycle over dimensions of matrix g0t
      do 10 icol = 1,istatx
      do 10 irow = 1,istatx
 10   g0t(irow,icol) = 0

      do 30 icol = 1,istate
        do 20 irow = 1,istate
c         T diagonal contribution T(irow, irow)
          if ( abs( g0(irow, icol)) .gt. toler2 )
     1    g0t(irow,icol)=g0t(irow,icol) - tmatrx(1,irow) * g0(irow,icol) 

c         T off-diagonal contribution T(ist2, irow) in tmatr(2,irow)
c         T off-diagonal contribution T(irow, ist2) in tmatr(2,ist2)
          l1   = lrstat(2,irow)
          m1   = lrstat(3,irow)
          isp1 = lrstat(4,irow)
          m2 = m1+isp1
          if (nsp.eq.2 .and. m2.gt.-l1+1 .and. m2.lt.l1+2) then
c            spin-flip contribution
             ist2 = irow + (-1)**isp1
             if ( abs( g0(ist2, icol)) .gt. toler2)
     1       g0t(irow, icol) = g0t(irow, icol)
     2                   - tmatrx(nsp, ist2) * g0(ist2, icol) 
          endif
 20     continue

        g0t(icol, icol) = g0t(icol, icol) + one
 30   continue

      do 920 ip=ipi, ipf
        ipart = nsp*(lipotx(ip)+1)**2
        do 910 is1 = 1, ipart
          is2 = is1+i0(ip)
          l1   = lrstat(2,is2)
          if (.not.lcalc(l1)) goto 910

c         start first tier with xvec=0
          istart = -1
          msord = 0
          do 40 is = 1, istate
          rvec(is) = 0
          avec(is) = 0
  40      xvec(is) = 0

c         RESTART here if necessary
  50      continue
          istart = istart+1

          if (istart.gt.0) call matvec( istatx,istate,g0t,xvec,avec,1)
          do 90 is = 1,istate
 90       uvec(is) = - avec(is)
c         uvec = bvec - g0t*xvec , in our case bvec(is) = delta_{is,is2}
          uvec(is2) = uvec(is2) + 1
          call matvec( istatx,istate,g0t,uvec,avec,1)
          msord = msord + 1
          do 95 is = 1, istate
 95       wvec(is) = uvec(is)
          do 96 is = 1, istate
 96       vvec(is) = avec(is)
          do 97 is = 1, istate
 97       dvec(is) = 0
          call cdot( istatx, istate, uvec, uvec, aa)
          tau = sqrt(real(aa))
          nu = 0
          eta = 0
c         choose rvec = uvec /aa so that dot products are about 1
          do 98 is = 1, istate
 98       rvec(is) = uvec(is) / aa
          rho = 1

c         it seems ran out of precision for nit>150
          nitx = 20
          do 300 nit = 0, nitx
            if (mod(nit,2).eq.0) then
              call cdot( istatx, istate, rvec, vvec, aa)
              alpha = rho / aa
            else
              call matvec( istatx,istate,g0t,uvec,avec,1)
              msord = msord + 1
            endif

            do 115 is = 1, istate
 115        wvec(is) = wvec(is) - alpha * avec(is)

            aa = nu**2 * eta / alpha
            do 120 is = 1, istate
 120        dvec(is) = uvec(is) + aa * dvec(is)

            call cdot( istatx, istate, wvec, wvec, aa)
            nu = sqrt(real(aa)) / tau
            cm = 1 / sqrt(1+nu**2)
            tau = tau * nu * cm
            eta = cm**2 * alpha
            do 140 is = 1, istate
 140        xvec(is) = xvec(is) + eta * dvec(is)

cc          Check convergence criteria: | rvec | < tol
            err = (1.e0 + nit) / istate
            err = tau * sqrt(err) * 10
            if ( abs(err).lt.toler1) goto 700

            if (mod(nit,2) .ne.0) then
              aa = rho
              call cdot( istatx, istate, rvec, wvec, rho)
              beta = rho / aa
              do 210 is = 1, istate
 210          uvec(is) = wvec(is) + beta * uvec(is)

              do 215 is = 1, istate
 215          vvec(is) = beta * ( avec(is) + beta * vvec(is))
              call matvec( istatx,istate,g0t,uvec,avec,1)
              msord = msord + 1
              do 220 is = 1, istate
 220          vvec(is) = avec(is) + vvec(is)
            else
              do 230 is = 1, istate
 230          uvec(is) = uvec(is) - alpha * vvec(is)
            endif
 300      continue
c         restart since ran out of iterations
          goto 50

c         exit if tolerance has been achieved
 700      continue
c         end of TFQMR iterations

c         at this point xvec = (1-tG)**-1 * bvec  with chosen tolerance
c         pack FMS matrix into an nsp*(lx+1)^2 x nsp*(lx+1)^2 matrix 
c         for each ipot
          do 800 is2=1,ipart
            gg( is2, is1, ip) = zero
            do 790 is = 1,istate
              gg( is2, is1, ip) = gg( is2, is1, ip) +
     1        g0( is2+i0(ip), is) * xvec(is)
 790        continue
 800      continue

 910    continue
 920  continue

      return
      end

      program feff8i
c
c     reads feff.inp file and writes feff8.inp file in new format
      implicit double precision (a-h, o-z)

      character*150  line, linep
      parameter (nwordx = 12)
      character*15 words(nwordx)

      logical iscomm

   10 format (a)
   20 format (bn, i15)
   30 format (bn, f15.0)

      iscmt =0
      ifms  =0

c     Open feff.inp, the input file we're going to read
      open (unit=1, file='feff.inp', status='old', iostat=ios)
      call chopen (ios, 'feff.inp', 'rdinp')

c     Open feff8.inp, the output file we're going to write
      open (unit=2, file='feff8.inp', status='unknown')

c     tokens  0 if not a token
c             4 if CONT (CONTROL)
c             9 if RMAX
c            13 if PRIN (PRINT)
c            36 if SCMT do self-consistency loop
c            37 if FMS  use FMS for cluster of the size rfms
c            38 if LDOS print out l-dos for specified energy range
c            40 if NABS to do configuration average

  200 read(1,10,iostat=ios)  line
         if (ios .lt. 0)  goto 900

         linep = line
         call triml (line)
         if (iscomm(line)) then
            jlen = istrln (linep)
            write (2, 10) linep (1:jlen)
            goto 200
         endif

         nwords = nwordx
         call bwords (line, nwords, words)
         itok = itoken (words(1))

         if (itok .eq. 4)  then
c           CONTROL  mphase, mpath, mfeff, mchi
c            0 - do not run modules, 1 - run module
            if (nwords.eq.5) then
c              feff7 input file
               read(words(2),20,err=900)  mpot
               mphase = mpot
               mfms = mpot
               read(words(3),20,err=900)  mpath
               read(words(4),20,err=900)  mfeff
               read(words(5),20,err=900)  mchi
            else
c              feff8 input file
               read(words(2),20,err=900)  mpot
               read(words(3),20,err=900)  mphase
               read(words(4),20,err=900)  mfms
               read(words(5),20,err=900)  mpath
               read(words(6),20,err=900)  mfeff
               read(words(7),20,err=900)  mchi
            endif
            write (2,100) ' CONTROL', 
     1        mpot, mphase, mfms, mpath, mfeff, mchi
  100       format (a, 6(2x,i1))
         elseif (itok .eq. 9)  then
c           RMAX  rmax (max r for ss and pathfinder)
            read(words(2),30,err=900)  rmax
            write (2, 110) ' RPATH ', rmax
  110       format (a, f8.3)
         elseif (itok .eq. 13)  then
c           PRINT  ipr1  ipr2  ipr3  ipr4 ipr5 ipr6
            if (nwords.eq.5) then
c              feff7 input file
               read(words(2),20,err=900)  ipr1
               ipr2 = ipr1
               ipr3 = ipr1
               read(words(3),20,err=900)  ipr4
               read(words(4),20,err=900)  ipr5
               read(words(5),20,err=900)  ipr6
            else
c              feff8 input file
               read(words(2),20,err=900)  ipr1
               read(words(3),20,err=900)  ipr2
               read(words(4),20,err=900)  ipr3
               read(words(5),20,err=900)  ipr4
               read(words(6),20,err=900)  ipr5
               read(words(7),20,err=900)  ipr6
            endif
            write (2, 100) ' PRINT',ipr1,ipr2,ipr3,ipr4,ipr5,ipr6
         elseif (itok .eq. 36)  then
c           SCMT   rfms [ lfms nscmt  icoul ca1 ]
c           number of cycles, mode of calculating coulomb potential,
c           convergence accelerator
            nscmt = 30
            ca1 = 0.2d0
            icoul = 0
            ecv = 0
            if (nwords.gt.1) read(words(2),20,err=900)  nscmt
            if (nwords.gt.2) read(words(3),30,err=900)  ca1
            if (nwords.gt.3) read(words(4),30,err=900)  ecv
            if (ifms.eq.1) write (2,140) ' SCF ',rfms1, lfms1,
     1         nscmt, ca1, icoul, ecv
            iscmt = 1
         elseif (itok .eq. 37)  then
c           FMS   rfms2  (lfms2)
c           radius of the cluster to do FMS
            read(words(2),30,err=900)  rfms1
            read(words(3),30,err=900)  rfms2
            lfms1=0
            lfms2=0
            if (nwords.gt.3) then
               read(words(4),20,err=900)  lfms1
               lfms1 = 1 - lfms1
            endif
            if (nwords.gt.4) then
               read(words(5),20,err=900)  lfms2
               lfms2 = 1 - lfms2
            endif
            write (2, 130) ' FMS ', rfms2, lfms2
  130       format ( a, f7.3,1x, i2)
            if (iscmt.eq.1) write (2,140) ' SCF ',rfms1, lfms1,
     1         nscmt, ca1, icoul, ecv
  140       format (a, f7.3,1x,i1,1x,i3,1x,f7.3,1x,i2,1x,f6.1)
            ifms = 1
         elseif (itok .eq. 40) then
c           NABS  iphabs nabs rclabs
            read(words(2),20,err=900)  iphabs
            read(words(3),20,err=900)  nabs
            read(words(4),30,err=900)  rclabs
            write (2, 120) ' CAVERAGE ', iphabs, nabs, rclabs
  120       format ( a, i2, i6, f7.3)
         else
            jlen = istrln(linep)
            write(2,10) linep(1:jlen)
         endif
      goto 200

  900 continue
c     We're done reading the input file, close it.
      close (unit=1)
      close (unit=2)

      stop
      end


      function itoken (word)
c     chars in word assumed upper case, left justified
c     returns 0 if not a token, otherwise returns token

      character*(*) word
      character*4   w

      w = word(1:4)
      call upper(w)
      if (w .eq. 'CONT')  then
         itoken = 4
      elseif (w .eq. 'RMAX')  then
         itoken = 9
      elseif (w .eq. 'PRIN')  then
         itoken = 13
      elseif (w .eq. 'SCMT')  then
         itoken = 36
      elseif (w .eq. 'FMS ')  then
         itoken = 37
      elseif (w .eq. 'NABS')  then
         itoken = 40
      else
         itoken = 0
      endif
      return
      end

      logical function iscomm (line)
c     returns true if line is a comment or blank line, false otherwise
      character*(*) line
      iscomm = .false.
      if (istrln(line).le.0  .or.  line(1:1).eq.'*')  iscomm = .true.
      return
      end

      subroutine warnex (string)
      implicit double precision (a-h, o-z)
c     This prints a warning message if the user is using an
c     expert option.
      character*(*) string

      call wlog(string)
      call wlog(' Expert option, please read documentation ' //
     1          'carefully and check your results.')
      return
      end

      subroutine wlog (string)
      character*(*) string

c     This output routine is ued to replace the PRINT statement
c     for output that "goes to the terminal", or to the log file.
c     If you use a window based system, you can modify this routine
c     to handle the running output elegantly.
c     Handle carriage control in the string you pass to wlog.
c
c     The log file is also written here, hard coded here.

c     The log file is unit 11.  The log file is opened in the
c     main program, program feff.

c     make sure not to write trailing blanks


   10 format (a)

      il = istrln (string)
      if (il .eq. 0)  then
         print10
         write(11,10)
      else
         print10, string(1:il)
         write(11,10) string(1:il)
      endif
      return
      end
      subroutine lblank (string)
      character*(*) string
c     add a leading blank, useful for carriage control
      string = ' ' // string
      return
      end
      subroutine chopen (ios, fname, mod)
c     Writes error msg and stops if error in ios flag from open
c     statement.  fname is filename, mod is module with failed open.
      character*(*) fname, mod
      character*512 slog

c     open successful
      if (ios .le. 0)  return

c     error opening file, tell user and die.
      i = istrln(fname)
      j = istrln(mod)
      write(slog,100)  fname(1:i), mod(1:j)
      call wlog(slog)

  100 format (' Error opening file, ', a, 
     2        ' in module ', a)

      call wlog(' Fatal error')
      stop 'CHOPEN'
      end
C FUNCTION ISTRLN (STRING)  Returns index of last non-blank
C                           character.  Returns zero if string is
C                           null or all blank.

      FUNCTION ISTRLN (STRING)
      CHARACTER*(*)  STRING
      CHARACTER BLANK, TAB
      PARAMETER (BLANK = ' ', TAB = '	')
C     there is a tab character here  ^

C  -- If null string or blank string, return length zero.
      ISTRLN = 0
      IF (STRING (1:1) .EQ. CHAR(0))  RETURN
      IF (STRING .EQ. ' ')  RETURN

C  -- Find rightmost non-blank character.
      ILEN = LEN (STRING)
      DO 20  I = ILEN, 1, -1
         IF (STRING(I:I).NE.BLANK .AND. STRING(I:I).NE.TAB)  GOTO 30
   20 CONTINUE
   30 ISTRLN = I

      RETURN
      END
C SUBROUTINE TRIML (STRING)  Removes leading blanks.

      SUBROUTINE TRIML (STRING)
      CHARACTER*(*)  STRING
      CHARACTER*200  TMP
      CHARACTER BLANK, TAB
      PARAMETER (BLANK = ' ', TAB = '	')
C     there is a tab character here  ^

      JLEN = ISTRLN (STRING)

C  -- All blank and null strings are special cases.
      IF (JLEN .EQ. 0)  RETURN

C  -- FInd first non-blank char
      DO 10  I = 1, JLEN
         IF (STRING(I:I).NE.BLANK .AND. STRING(I:I).NE.TAB)  GOTO 20
   10 CONTINUE
   20 CONTINUE

C  -- If I is greater than JLEN, no non-blanks were found.
      IF (I .GT. JLEN)  RETURN

C  -- Remove the leading blanks.
      TMP = STRING (I:)
      STRING = TMP
      RETURN
      END
C SUBROUTINE UPPER (STRING)  Changes a-z to upper case.

      SUBROUTINE UPPER (STRING)
      CHARACTER*(*)  STRING

      JLEN = ISTRLN (STRING)

      DO 10  I = 1, JLEN
         IC = ICHAR (STRING (I:I))
         IF ((IC .LT. 97)  .OR.  (IC .GT. 122))  GOTO 10
         STRING (I:I) = CHAR (IC - 32)
   10 CONTINUE

      RETURN
      END
C SUBROUTINE LOWER (STRING)  Changes A-Z to lower case.

      SUBROUTINE LOWER (STRING)
      CHARACTER*(*)  STRING

      JLEN = ISTRLN (STRING)

      DO 10  I = 1, JLEN
         IC = ICHAR (STRING (I:I))
         IF ((IC .LT. 65) .OR.  (IC .GT. 90))  GOTO 10
         STRING (I:I) = CHAR (IC + 32)
   10 CONTINUE

      RETURN
      END
C***********************************************************************
C
      SUBROUTINE BWORDS (S, NWORDS, WORDS)
C
C     Breaks string into words.  Words are seperated by one or more
C     blanks or tabs, or a comma and zero or more blanks.
C
C     ARGS        I/O      DESCRIPTION
C     ----        ---      -----------
C     S            I       CHAR*(*)  String to be broken up
C     NWORDS      I/O      Input:  Maximum number of words to get
C                          Output: Number of words found
C     WORDS(NWORDS) O      CHAR*(*) WORDS(NWORDS)
C                          Contains words found.  WORDS(J), where J is
C                          greater then NWORDS found, are undefined on
C                          output.
C
C      Written by:  Steven Zabinsky, September 1984
C      Tab char added July 1994.
C
C**************************  Deo Soli Gloria  **************************

C  -- No floating point numbers in this routine.
      IMPLICIT INTEGER (A-Z)

      CHARACTER*(*) S, WORDS(NWORDS)

      CHARACTER BLANK, COMMA, TAB
      PARAMETER (BLANK = ' ', COMMA = ',', TAB = '	')
C     there is a tab character here               ^.

C  -- BETW    .TRUE. if between words
C     COMFND  .TRUE. if between words and a comma has already been found
      LOGICAL BETW, COMFND

C  -- Maximum number of words allowed
      WORDSX = NWORDS

C  -- SLEN is last non-blank character in string
      SLEN = ISTRLN (S)

C  -- All blank string is special case
      IF (SLEN .EQ. 0)  THEN
         NWORDS = 0
         RETURN
      ENDIF

C  -- BEGC is beginning character of a word
      BEGC = 1
      NWORDS = 0

      BETW   = .TRUE.
      COMFND = .TRUE.

      DO 10  I = 1, SLEN
         IF (S(I:I) .EQ. BLANK .OR. S(I:I) .EQ. TAB)  THEN
            IF (.NOT. BETW)  THEN
               NWORDS = NWORDS + 1
               WORDS (NWORDS) = S (BEGC : I-1)
               BETW = .TRUE.
               COMFND = .FALSE.
            ENDIF
         ELSEIF (S(I:I) .EQ. COMMA)  THEN
            IF (.NOT. BETW)  THEN
               NWORDS = NWORDS + 1
               WORDS (NWORDS) = S(BEGC : I-1)
               BETW = .TRUE.
            ELSEIF (COMFND)  THEN
               NWORDS = NWORDS + 1
               WORDS (NWORDS) = BLANK
            ENDIF
            COMFND = .TRUE.
         ELSE
            IF (BETW)  THEN
               BETW = .FALSE.
               BEGC = I
            ENDIF
         ENDIF

         IF (NWORDS .GE. WORDSX)  RETURN

   10 CONTINUE

      IF (.NOT. BETW  .AND.  NWORDS .LT. WORDSX)  THEN
         NWORDS = NWORDS + 1
         WORDS (NWORDS) = S (BEGC :SLEN)
      ENDIF

      RETURN
      END

      subroutine wrtall (nabs)
c     writes data stored in common blocks of allinp.h to 
c     all necessary input files for other modules.
c     version 1.0 written by Alexei Ankudinov, March 2001

c     Note: to add input variable one has to add it to the 
c        appropriate common block in allinp.h, properly initialize
c        it in subroutine iniall and modify subroutine wrtall
c        to write it to the appropriate input file.
c        (i.e. one has to make modifications in 3 places)

      implicit double precision (a-h, o-z)
      include '../HEADERS/dim.h'
      include '../HEADERS/parallel.h'
      include '../RDINP/allinp.h'

      if (.not. master) return

c     standard formats for string, integers and real numbers
  10  format(a)
  20  format (20i4)
  30  format (6f13.5)

cc    atoms.dat to be read by ffsort,
cc    that will write smaller geom.dat file
      open (file='atoms.dat', unit=3, status='unknown',iostat=ios)
        write (3, 35) natt
  35    format ('natx =  ', i7)
        write (3, 10) '    x       y        z       iph  '
        do 40  iat = 1, natt
          write(3,36) ratx(1,iat), ratx(2,iat), ratx(3,iat), iphatx(iat)
  36      format( 3f13.5, i4)
  40    continue
      close(3)

cc    global.inp
      open (file='global.dat', unit=3, status='unknown',iostat=ios)
c       configuration average data
        write (3, 10) ' nabs, iphabs - CFAVERAGE data'
        write (3, 45) nabs, iphabs, rclabs
  45    format ( 2i8, f13.5)
c       global polarization data
        write (3,10) ' ipol, ispin, le2, elpty, angks'
        write (3, 50)  ipol, ispin, le2, elpty, angks
  50    format ( 3i5, 2f12.4)
        write (3, 10) 'evec         xivec        spvec'
        do 60 i = 1,3
          write (3,30) evec(i), xivec(i), spvec(i)
  60    continue
        write (3, 10) ' polarization tensor '
        do 70 i = -1, 1
          write(3,30) dble(ptz(-1,i)), dimag(ptz(-1,i)), dble(ptz(0,i)),
     1                dimag(ptz(0,i)),  dble(ptz(1,i)), dimag(ptz(1,i))
  70    continue
      close(3)
        
cc    mod1.inp
      open (file='mod1.inp', unit=3, status='unknown',iostat=ios)
        write(3,10) 'mpot, nph, ntitle, ihole, ipr1, iafolp, ixc,ispec'
        write(3,20) mpot, nph, ntitle, ihole, ipr1, iafolp, ixc, ispec
        write(3,10) 
     1  'nmix, nohole, jumprm, inters, nscmt, icoul, lfms1, iunf'
        write(3,20)  nmix, nohole, jumprm, inters, nscmt, icoul, lfms1,
     1   iunf
        do 110 ititle = 1, ntitle
  110   write(3,10) title(ititle)
        write(3,10) 'gamach, rgrd, ca1, ecv, totvol, rfms1'
        write(3,30)  gamach, rgrd, ca1, ecv, totvol, rfms1
        write(3,10) ' iz, lmaxsc, xnatph, xion, folp'
  120   format ( 2i5, 4f13.5)
        do 130 ip = 0, nph
  130   write(3,120) iz(ip), lmaxsc(ip), xnatph(ip), xion(ip), folp(ip)
c       for OVERLAP option
        write(3,10) 'OVERLAP option: novr(iph)'
        write(3,20) ( novr(iph), iph=0,nph)
        write(3,10) ' iphovr  nnovr rovr '
  140   format ( 2i5, f13.5)
        do 150 iph = 0, nph
        do 150 iovr = 1, novr(iph)
  150   write(3,140) iphovr(iovr, iph), nnovr(iovr,iph), rovr(iovr,iph)
      close(3)

cc    mod2.inp
      open (file='mod2.inp', unit=3, status='unknown',iostat=ios)
c     Josh - added flag for PLASMON card (iPlsmn = 0, 1, or 2)
!     Josh - added flag for user difined grid (EGRID card).
        write(3,10) 'mphase,ipr2,ixc,ixc0,ispec,lreal,lfms2,nph,l2lp,
     &     iplsmn,igrid'
        write(3,20)  mphase,ipr2,ixc,ixc0,ispec,lreal,lfms2,nph,l2lp,
     &        iPlsmn, iGrid
        write(3,10) 'vr0, vi0'
        write(3,30)  vr0, vi0
        write(3,10) ' lmaxph(0:nph)'
        write(3,20)  (lmaxph(iph),iph=0,nph)
        write(3,10) ' potlbl(iph)'
        write(3,170)  (potlbl(iph),iph=0,nph)
  170   format (13a6)
        write(3,10) 'rgrd, rfms2, gamach, xkstep, xkmax, vixan'
        write(3,30)  rgrd, rfms2, gamach, xkstep, xkmax, vixan
        write(3,30)  (spinph(iph),iph=0,nph)
        write(3,20)  izstd, ifxc, ipmbse, itdlda, nonlocal, ibasis
      close(3)

cc    mod3.inp
      open (file='mod3.inp', unit=3, status='unknown',iostat=ios)
        write(3,10) 'mfms, idwopt, minv'
        write(3,20)  mfms, idwopt, minv
        write(3,10) 'rfms2, rdirec, toler1, toler2'
        write(3,30)  rfms2, rdirec, toler1, toler2
        write(3,10) 'tk, thetad, sig2g'
        write(3,30)  tk, thetad, sig2g
        write(3,10) ' lmaxph(0:nph)'
        write(3,20)  (lmaxph(iph),iph=0,nph)
      close(3)

cc    mod4.inp
      open (file='mod4.inp', unit=3, status='unknown',iostat=ios)
        write(3,10) 'mpath, ms, nncrit, nlegxx, ipr4'
        write(3,20)  mpath, ms, nncrit, nlegxx, ipr4
        write(3,10) 'critpw, pcritk, pcrith,  rmax, rfms2'
        write(3,30)  critpw, pcritk, pcrith,  rmax, rfms2
      close(3)

cc    mod5.inp
      open (file='mod5.inp', unit=3, status='unknown',iostat=ios)
        write(3,10) 'mfeff, ipr5, iorder, critcw, wnstar'
        write(3,180)  mfeff, ipr5, iorder, critcw, wnstar
  180   format ( 2i4, i8, f13.5, L5)
      close(3)

cc    mod6.inp
      open (file='mod6.inp', unit=3, status='unknown',iostat=ios)
        write(3,10) 'mchi, ispec, idwopt, ipr6, mbconv, absolu' !KJ added absolu 3-06
        write(3,20)  mchi, ispec, idwopt, ipr6, mbconv, absolu !KJ added absolu 3-06
        write(3,10) 'vrcorr, vicorr, s02, critcw'
        write(3,30)  vrcorr, vicorr, s02, critcw
        write(3,10) 'tk, thetad, alphat, thetae, sig2g'
        write(3,30)  tk, thetad, alphat, thetae, sig2g
      close(3)

c$$$cc    so2.inp - Josh Kas
c$$$      open (file='s02.inp', unit=3, status='unknown',iostat=ios)
c$$$        write(3,10) 'mso2conv, ipse, ipsk'
c$$$        write(3,20)  mso2conv, ipse, ipsk
c$$$        write(3,10) 'wsigk, cen'
c$$$        write(3,30) wsigk, cen
c$$$        write(3,10) 'ispec, ipr6'
c$$$        write(3,20)  ispec, ipr6
c$$$        write(3,10) 'cfname'
c$$$        write(3,10) cfname
c$$$      close(3)
      return
      end

      double precision function dentfa (dr,dz,ch)
c     analitical approximation of potential is created for electrons in
c     thomas-fermi model for atom or free ion. dr distance from nucleus
c     with charge dz  
c     ch=ionicity = number of electrons-dz-1
      implicit double precision (a-h,o-z)
 
      dentfa=0.0d 00
      if ((dz+ch).lt.1.0d-04) return
      w=dr*(dz+ch)**(1./3.)
      w=sqrt(w/0.8853)
      t=w*(0.60112*w+1.81061)+1.
      w=w*(w*(w*(w*(0.04793*w+0.21465)+0.77112)+1.39515)+1.81061)+1
      dentfa=(dz+ch)*(1.0d 00-(t/w)**2)/dr
      return
      end

      subroutine fdthea(ntext, text, ip, iorder, nleg, deg, reff,
     &       rnrmav, edge, rat, ipot, iz, potlbl, nlines, lines)

c+---------------------------------------------------------------------
c     "Based on or developed using Distribution: FEFF8.5L
c      Copyright (c) [2013] University of Washington"
c
C  See ../HEADERS/license.h for full llicense information
c+---------------------------------------------------------------------
      implicit double precision (a-h, o-z)
      include '../HEADERS/const.h'
      include '../HEADERS/dim.h'
      parameter (npx=15000)

      double precision rat(3,legtot)
      dimension ipot(legtot)
      dimension iz(0:nphx)
      character*6  potlbl(0:nphx)
      character*80 text(nheadx), lines(2*nheadx), thisln
      real deg, reff, rnrmav, edge
      
      external istrln

      nlines = 1
      do 300  itext = 1, ntext
         ltxt = istrln(text(itext))
         write(thisln,160)  text(itext)(1:ltxt)
         lines(nlines) = thisln
         nlines = nlines+1
 300  continue
 160  format (1x, a)

      write(thisln,310) ip, iorder
 310  format (' Path', i5, '      icalc ', i7)
      lines(nlines) = thisln
      nlines = nlines+1

      write(thisln,170)
  170 format (1x, 71('-'))
      lines(nlines) = thisln
      nlines = nlines+1

      write(thisln,320)  nleg, deg, reff*bohr, rnrmav, 
     1       edge*hart
 320  format (1x, i3, f8.3, f9.4, f10.4, f11.5, 
     1       ' nleg, deg, reff, rnrmav(bohr), edge')
      lines(nlines) = thisln
      nlines = nlines+1

      write(thisln,330)
 330  format ('        x         y         z   pot at#')
      lines(nlines) = thisln
      nlines = nlines+1

      write(thisln,340)  (rat(j,nleg)*bohr,j=1,3), ipot(nleg),
     1       iz(ipot(nleg)), potlbl(ipot(nleg))
 340  format (1x, 3f10.4, i3, i4, 1x, a6, '   absorbing atom')
      lines(nlines) = thisln
      nlines = nlines+1

      do 360  ileg = 1, nleg-1
         write(thisln,350)  (rat(j,ileg)*bohr,j=1,3), ipot(ileg),
     1          iz(ipot(ileg)), potlbl(ipot(ileg))
 350     format (1x, 3f10.4, i3, i4, 1x, a6)
         lines(nlines) = thisln
         nlines = nlines+1
 360  continue
      
      write(thisln,370)
 370  format    ('    k   real[2*phc]   mag[feff]  phase[feff]',
     1       ' red factor   lambda     real[p]@#')
      lines(nlines) = thisln

      return
      end

      subroutine fms(lfms, nsp, ispin, inclus, npot, ck, lipotx, xphase,
     1   ik, iverb, minv, rdirec, toler1, toler2, lcalc, gg)

      implicit real (a-h,o-z)
      implicit integer (i-n)
c--------------------------------------------------------------------
c  compute full multiple scattering within some cluster at some
c  energy
c  This uses the LU decomposition package from LAPACK.  Driver
c  routines: cgetrf (decomposition), cgetrs (backsubstitution)
c  coded by b.ravel
c  modified by a.l.ankudinov to include spin and SO interactions
c  feb 2000
c
c  dim.h and xparam.h must be included in the calling routine
c
c  most of the information needed by this package is set into common
c  blocks the companion package xprep.  In that package, the lists of
c  atomic coordinates and potential indeces are organized so that the
c  first npot+1 entries are examples of each of the unique potentials.
c  Consequently, only the upper left hand corner of the FMS matrix
c  need be recomposed to get the set of submatrices necessary to
c  compute chi for each type of atom in the cluster.
c
c  See subroutine fmstot.f for an example of decoding the output of this
c  subroutine. The third index of gg refers to the unique potential with
c  element 0 being the absorbing atom.
c  The first two indeces are related to the |lms> state by the
c  formula:
c       nsp=1, no spin indeces
c       lm  = ( l**2 + 1 ) + ( l + m )
c            thus {1..(lx+1)^2} ==>
c            {0,0 1,-1 1,0 1,1 2,-2 2,-1 2,0 2,1 2,2 ...
c                   lx,lx-1 lx,lx}
c       nsp=2, with spin indeces
c       lms  = 2*( l**2 + 1 ) + 2*( l + m ) + (s-1/2)
c            thus {1...2*(lx+1)^2} ==>
c            {0, 0,-1/2  0. 0,1/2
c             1,-1,-1/2  1,-1,1/2  1,0,-1/2  1,0,1/2  1,1,-1/2 1,1,1/2
c             2,-2,-1/2  2,-2,1/2  2,-1,-1/2 2,-1,1/2 ...    lx,lx,1/2}
c
c  The calling protocol for xpreppack and fmspack is;
c          include 'dim.h'
c          include 'xparam.h'
c          ...
c          call xprep(nat, inclus, npot, iphat, rmax, rat,
c     $            xnrm, izx, temper, thetad)
c          energy loop {
c             ...
c             call fms(nsp, inclus, npot, ck, lipotx, xphase,
c                      ik, iverb, gg)
c             ... }
c
c  fmspack contains the following routines:
c    fms.f:     main routine of fmspack
c    kets.f:    compute all state kets for current energy
c    xclmz.f:   compute hankle-like polynomials for current energy
c    xgllm.f:   compute z-axis propagators for current energy
c    cgetrf.f:  LU decomposition of matrix
c    cgetrs.f:  backsubstitution of LU decomposed matrix
c    lu_misc.f: various routines called by LU package
c
c---------------------------------------------------------------------
c  input
c    nsp:    1) no spin indeces 2) with spin indeces
c    inclus: number of atoms in cluster
c    npot:   number of unique potentials in cluster
c    ck:     complex momentum of current energy point
c    lipotx: (0:nphasx) max l for each unique potential
c    xphase: (0:lx, 0:nphasx) single complex array of partial wave
c            phase shifts for each unique potential
c    ik:     current energy grid index, used for run-time messages
c    iverb:  do nothing when iverb <= 0
c            1  => write a message about grid point and matrix size
c
c  passed in common from xprep package (xstruc.h)
c    xrat:   (3,nclusx) array of coordinates with first npot+1
c            elements each a unique potential
c    xphi:   (nclusx, nclusx) angles between z axis and vectors
c            connecting the atoms in the cluster
c    iphx:   (nclusx) potential index of each atom in the cluster
c    drix:   huge matrix containing all rotation matrix elements
c            needed for computation of free electron propagators
c    xnlm:   matrix of legendre polynomial normalization factors
c    xpsile: matrix containing wave functions for hybridization
c            calculation
c    sigsqr: (nclusx,nclusx) matrix of pair-wise mean square
c            displacements about interatomic distances.  Currently only
c            calculated by the correlated debye model.
c
c  output
c    gg:  (nsp*lx**2, nsp*lx**2, 0:nphasx) submatrix spanning the entire
c          angular momentum basis for each unique potential

      include '../HEADERS/dim.h'
      include '../HEADERS/const.h'
      include '../HEADERS/parallel.h'
      include 'xparam.h'
c====================================================================
c  This common block contains the structural information about the
c  cluster to be used for the full multiple scattering calculation
c  xphi:  matrix of angles between the z axis and pairs of atoms
c  xrat:  xyz coordinates of the atoms in the cluster, the first
c         npot+1 entries are examples of each unique potential
c  iphx:  potential indeces of each atom in the cluster, ordered like
c         xrat
      common /xstruc/ xphi(nclusx,nclusx), xrat(3,nclusx),
     $            iphx(nclusx)
      save /xstruc/
c********************************************************************
c**** rotation matrices for entire cluster
c
      complex drix
      common /rotx/ drix(-lx:lx, -lx:lx, 0:lx, 0:1, nclusx, nclusx)
      save /rotx/
c********************************************************************
c common blocks for saving rotation matrices between xanes and rotxan
       integer    jsavx, jsav, jbmagk
       parameter (jsavx = 150, roteps = 1.e-12,jbmagk=-9999)
       dimension drisav(-lx:lx,-lx:lx,0:lx,jsavx), betsav(jsavx)
       integer   ldsav(jsavx), mdsav(jsavx)
       common /rotsav/  drisav, betsav, ldsav, mdsav, jsav
       save  /rotsav/

c********************************************************************
c**** legendre polynomial normalization constants
c
      common /lnlm/ xnlm(0:lx,0:lx)
      save   /lnlm/

c********************************************************************
c**** legendre polynomial normalization constants
c
      common /xdwf/ sigsqr(nclusx,nclusx)
      save   /xdwf/
c********************************************************************
c**** save Clebsch-Gordon coefficients: <LS|J>
      dimension t3jp(0:lx, -lx:lx, 2), t3jm(0:lx, -lx:lx, 2)
      common /t3j/ t3jp, t3jm
      save   /t3j/

c********************************************************************
      complex   prefac, gllmz, ck(nspx)
c      complex term
      complex   clm(lx+2, 2*lx+3), xclm(0:lx, 0:lx, nclusx, nclusx,nspx)
      complex   xrho( nclusx, nclusx, nspx)
      integer   lipotx(0:nphasx)

c********************************************************************
c**** array of state kets at current energy
      common /stkets/ lrstat(4, istatx), istate
      save   /stkets/
      complex   xphase(nspx, -lx:lx, 0:nphasx)
      complex   tmatrx(nspx, istatx)
c     big work matrices
      complex   g0(istatx,istatx), g0t(istatx,istatx)
      logical lcalc
      dimension lcalc(0:lx)
c     return matrix containing info about each unique potential
      complex   gg(nspx*(lx+1)**2, nspx*(lx+1)**2, 0:nphasx)

      integer i0(0:nphx)
c      character*3  cerr
      character*3  dec
c      character*13 trans
      character*75 messg

c 400  format(i4)

      do 10 i=0,nphx
        if (lipotx(i).le.0)  lipotx(i) = lx
        if (lipotx(i).gt.lx) lipotx(i) = lx
        i0(i) = -1
 10   continue
c     initialize gg to zero
      do 20 i = 0, nphasx
        do 18 j = 1, nspx*(lx+1)**2
          do 16 k = 1, nspx*(lx+1)**2
            gg( k, j, i) = cmplx( zero, zero)
 16       continue
 18     continue
 20   continue

      if (lfms.eq.0) then
        ipi = iphx(1)
        ipf = iphx(1)
      else
        ipi = 0
        ipf = npot
      endif
c --- get basis kets; output array 'lrstat' passed through common
      call getkts(nsp, inclus, iphx, lipotx, i0)

c --- sanity check for i0(ip)
      do 30 ip = ipi, ipf
        if (i0(ip) .lt. 0) then
          call wlog (' Cannot find all representative atoms')
          call wlog (' Increase FMS radius and rerun.')
          call par_stop(' In subroutine FMS')
        endif
  30  continue

c --- runtime message if requested
      if (iverb.gt.0 .and. minv.eq.0) then
         dec = 'LUD'
         write(messg, 4010)this_process,dec, ik, istate
 4010    format('  ',i3,'   FMS matrix (', a, ') at point ', i3,
     $               ', number of state kets =', i4)
         call wlog(messg)
      endif

c --- get all c_lm(z) values for this energy, i,j sum over all atom
c     pairs xrho and xclm are symmetric in ij
c+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
c  nota bene, in the code for setting the clmz, the indexing starts
c  at 1 rather than 0.  To my mind, that is confusing, so here I
c  reindex when I copy from clm to xclm.  See the note about this in
c  subroutine xclmz
c+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
      lplus1 = lx+1
      mplus1 = lx+1
      do 140  i=1,inclus
        do 130 j=1,i

c ------- get and store rho for this pair of atoms   bohr units on
c         r and ck
          r   = zero
          do 100 ix=1,3
            r = r + (xrat(ix,i) - xrat(ix,j))**2
 100      continue
          r   = sqrt(r)

          do 125 isp = 1,nsp
             xrho(i,j,isp) = ck(isp) * r
             xrho(j,i,isp) = xrho(i,j,isp)

c ------- store the c_lm(z) for all the rhos at this energy
c            xclm(i,j) = xclm(j,i) by symmetry
             if (i.ne.j) call xclmz(lplus1,mplus1,xrho(i,j,isp),clm)
             do 120 ll = 0,lx
               do 110 mm = 0,lx
                 if (i.eq.j) then
                     xclm(mm,ll,j,i,isp) = cmplx(zero,zero)
                 else
                     xclm(mm,ll,j,i,isp) = clm(ll+1,mm+1)
                     xclm(mm,ll,i,j,isp) = clm(ll+1,mm+1)
                 endif
 110           continue
 120         continue
 125      continue

 130    continue
 140  continue

c --- fill the G0 and T matrices for this energy
      rdir2 = rdirec**2
      do 220 ist1=1,istate
        iat1 = lrstat(1, ist1)
        l1   = lrstat(2, ist1)
        m1   = lrstat(3, ist1)
        isp1 = lrstat(4, ist1)

        do 210 ist2=1,istate
          iat2 = lrstat(1, ist2)
          l2   = lrstat(2, ist2)
          m2   = lrstat(3, ist2)
          isp2 = lrstat(4, ist2)

          rr = (xrat(1,iat1)-xrat(1,iat2))**2 +
     1    (xrat(2,iat1)-xrat(2,iat2))**2 +(xrat(3,iat1)-xrat(3,iat2))**2

c                               equation 9 in Rehr, Albers
c                               <LR| G |L'R'>

          if (iat1.eq.iat2) then
c             same atom: G=0, calculate T-matrix
              g0(ist1,ist2)     = cmplx(zero,zero)
c             notice that T is tri-diagonal, due to conservation of
c             total momentum.(will be broken by nonspherical potential)
c             --- potential index for this atom
              iph = iphx(iat1)
            if (nsp.eq.1.and.ispin.eq.0) then
              if (ist1.eq.ist2) tmatrx(1, ist1) =
     $                    ( exp(2*coni*xphase(isp1,l1,iph)) - one )
     $                    / (2*coni)
            else
              if (ist1.eq.ist2) then
c                set spin index for t3jm and t3jp
                 is = isp1
                 if (nsp.eq.1) then
c                  special case
                   is = 1
                   if (ispin.gt.0) is = 2
                 endif

c                diagonal matrix element
                 tmatrx(1, ist1) =
     $                    ( exp(2*coni*xphase(isp1,l1,iph)) - one )
     $                    / (2*coni) * t3jm (l1, m1, is)**2  +
     $                    ( exp(2*coni*xphase(isp1,-l1,iph)) - one )
     $                    / (2*coni) * t3jp (l1, m1, is)**2
              elseif (nsp.eq.2.and.l1.eq.l2.and.m1+isp1.eq.m2+isp2) then
c                same orb. mom. and total momentum projections conserved
c                calculate off-diagonal T-matrix element
c                tmatrx(2, ist1) = here only if nspx equal to 2
                 tmatrx(nsp, ist1) =
     $             ( exp(2*coni*xphase(isp1, l1,iph)) - one +
     $               exp(2*coni*xphase(isp2, l1,iph)) - one ) / (4*coni) 
     1             * t3jm (l1, m1, isp1) * t3jm (l1, m2, isp2)  +
     $             ( exp(2*coni*xphase(isp1,-l1,iph)) - one +
     $               exp(2*coni*xphase(isp2,-l1,iph)) - one ) / (4*coni) 
     1             * t3jp (l1, m1, isp1) * t3jp (l1, m2, isp2)
              endif
            endif
          elseif (isp1.eq.isp2 .and. rr.le.rdir2) then
c           different atoms, same spin: T=0, calculate G
            g0(ist1,ist2) = cmplx(zero,zero)
            do 200 mu=-l1,l1
c             --- third arg in drix: 0==>beta, 1==>-beta
              muabs = abs(mu)
              call xgllm(muabs, ist1, ist2, lrstat,
     1                   xclm(0,0,1,1,isp1), gllmz )
              g0(ist1,ist2) = g0(ist1,ist2) +
     2             drix(mu,m1,l1,1,iat2,iat1) *  gllmz *
     3             drix(m2,mu,l2,0,iat2,iat1)
 200        continue
            prefac = exp(coni*xrho(iat1,iat2,isp1)) /
     $                  xrho(iat1,iat2,isp1)
c           use correlated debye model, sigsqr is in AA^2
            prefac = prefac * exp(-1 * sigsqr(iat1,iat2) *
     $                  ck(isp1)**2 / bohr**2)
            g0(ist1,ist2) = prefac * g0(ist1,ist2)
          else
c           different atoms, different spins:T=G=0
            g0(ist1,ist2) = cmplx(zero,zero)
          endif

c -----   end of loops over states
 210    continue
 220  continue

      if (minv.eq.0) then
         call gglu ( nsp, i0, ipi, ipf, lipotx, g0, tmatrx, g0t, gg)
      elseif (minv.eq.1) then
         dec = 'VdV'
         call ggbi ( nsp, i0, ipi, ipf, lipotx, g0, tmatrx, g0t, gg,
     1              toler1, toler2, lcalc, msord)
      elseif (minv.eq.2) then
         dec = 'LLU'
         call ggrm ( nsp, i0, ipi, ipf, lipotx, g0, tmatrx, g0t, gg,
     1              toler1, toler2, lcalc, msord)
      elseif (minv.eq.3) then
         dec = 'GMS'
         call gggm ( nsp, i0, ipi, ipf, lipotx, g0, tmatrx, g0t, gg,
     1              toler1, toler2, lcalc, msord)
      else
         dec = 'TF'
         call ggtf ( nsp, i0, ipi, ipf, lipotx, g0, tmatrx, g0t, gg,
     1              toler1, toler2, lcalc, msord)
      endif
      if (minv.ne.0) then
         write(messg, 410)this_process,dec, ik, istate, msord
 410     format('  ',i3,'. Iterative FMS (', a, ') at point ', i3,
     $               '; matrix size =', i4,'; MS order =',i5)
         call wlog(messg)
      endif

      return
      end
c--------------------------------------------------------------------
      subroutine getkts(nsp, nat, iphx, lipotx, i0)

      implicit real (a-h,o-z)
      implicit integer (i-n)
c--------------------------------------------------------------------
c  construct state kets |iat,l,m> at this energy
c--------------------------------------------------------------------
c  input
c    nat:    number of atoms in cluster
c    npot:   number of unique potentials
c    iphx:   (nclusx) potential index of each atom in the cluster
c    lipotx: (nphasx) maximum angular momentum to consider for each
c            ipot
c  output
c   (istate: number of states  ---  passed in kets.h)
c    i0:     index shift for each potential representative
c   (lrstat: (4, istatx) state kets |iat,l,m> --- passed in kets.h)
c--------------------------------------------------------------------
      include '../HEADERS/dim.h'
      include 'xparam.h'
c********************************************************************
c**** array of state kets at current energy
      common /stkets/ lrstat(4, istatx), istate
      save   /stkets/
      integer   lipotx(0:nphasx), iphx(nclusx), i0(0:nphx)

      istate = 0
      do 120 iat=1,nat
        ip = iphx(iat)
c       i0(ip) - index for the ip-representative atom
c       need for simple find of states for ip-representative.
        if (i0(ip).lt.0) i0(ip) = istate
        lim = min(lx, lipotx(ip))
        do 110 l=0,lim
          do 100 m = -l, l
          do 100 isp = 1, nsp
            istate = istate + 1
            if (istate.gt.istatx) then
                call wlog('Exceeded maximum number of LR states.'//
     $                      '  Stopping')
                call par_stop('GETKTS-1')
            endif
            lrstat(1,istate) = iat
            lrstat(2,istate) = l
            lrstat(3,istate) = m
            lrstat(4,istate) = isp
 100      continue
 110    continue
 120  continue

      return
c end subroutine kets
      end
c    ----------------------------------------------------------------
      subroutine xclmz(lmaxp1,mmaxp1,rho,clm)
      implicit real(a-h,o-z)

c     calculates energy dependent factors needed in subroutine gllm
c     c(il,im) = c_l^(m)z**m/m!=c_lm             by recursion
c     c_l+1,m  = c_l-1,m-(2l+1)z(c_l,m-c_l,m-1)  l ne m
c     c_m,m    = (-z)**m (2m)!/(2**m m!)         with z=1/i rho
c
c  input:
c    lmaxp1, mmaxp1:  largest angular momentum under consideration + 1
c    rho:  distance between atoms * complex momentum at this energy
c          point
c  output:
c    clm(lx+1,lx+1):  Hankle-like polynomials from RA

      include   '../HEADERS/dim.h'
      include   'xparam.h'
      parameter (one = 1, zero = 0)
      complex coni
      parameter (coni = (0,1))
      parameter (ltotb=lx+1,mtotb=ltotb,ntotb=ltotb,mntot=mtotb+ntotb)
      complex z, cmm, clm(ltotb+1,mntot+1), rho

      cmm  = cmplx(one, zero)
      z    = (-coni)/rho

      clm(1,1) = cmplx(one,zero)
      clm(2,1) = clm(1,1) - z

      lmax = lmaxp1-1
      do 20 il=2,lmax
        clm(il+1,1) = clm(il-1,1) - (z * (2*il-1) * clm(il,1))
 20   continue
c+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
c  nota bene:  the 2l-1 factor above is correct, even though in Rehr,
c  Albers equation 4 appears with a 2l+1.  The reason has to do with
c  the indexing.  in RA the subscripts on the c's start at 0.  In this
c  piece of code, the subscripts start at 1.  If you sub l-1 for
c      l, 2l+1 --> 2l-1
c+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+


      mmxp1 = min(lmaxp1, mmaxp1)
      do 40 im=2,mmxp1
        m    = im-1
        imp1 = im+1
        cmm  = (-cmm) * (2*m-1) * z
        clm(im,im)   = cmm
        clm(imp1,im) = cmm * (2*m+1) * (1-im*z)
        do 30 il=imp1,lmax
          clm(il+1,im) = clm(il-1,im) - (2*il-1) * z *
     $                               ( clm(il,im)+clm(il,m) )
c           l = il-1
c           clm(il+1,im) = clm(l,im) - (2*l+1) * z *
c      $                               ( clm(il,im)+clm(il,m) )
 30     continue
 40   continue

      return
c  end subroutine xclmz
      end
      subroutine xgllm(mu, ist1, ist2, lrstat, xclm, gllmz)
c--------------------------------------------------------------------
c  this calculates equations 11,12 from Rehr, Albers PRB v.41,#12,
c  p.8139,  the output is the G term in equation 9 from that paper
c
c  input:
c    mu:         abs val of magnetic state in sum in eqn 11 RA, mu>=0
c    ist1, ist2: state indices of mat. elem., first index of lrstat
c    lrstat:     (4,istatx,nkmin:nex) array of LR states
c    xclm:       (0:lx,0:lx,nclusx,nclusx) array of c_lm(z) for
c                present energy value
c  output:
c    gllmz:      g_ll'^|m|(z), for present state & energy, eqn 11 RA
c--------------------------------------------------------------------
c  this requires that N_lm normalization factors and c_lm(z)
c  polynomials have already been calculated.
c--------------------------------------------------------------------
      implicit real(a-h,o-z)
      implicit integer (i-n)

      include '../HEADERS/dim.h'
      include 'xparam.h'
c====================================================================
c  This header file contains the structural information about the
c  cluster to be used for the full multiple scattering calculation

      common /xstruc/ xphi(nclusx,nclusx), xrat(3,nclusx),
     $            iphx(nclusx)
      save /xstruc/

c  xphi:  matrix of angles between the z axis and pairs of atoms
c  xrat:  xyz coordinates of the atoms in the cluster, the first
c         npot+1 entries are examples of each unique potential
c  iphx:  potential indeces of each atom in the cluster, ordered like
c         xrat
c********************************************************************
c**** rotation matrices for entire cluster
c
      complex drix
      common /rotx/ drix(-lx:lx, -lx:lx, 0:lx, 0:1, nclusx, nclusx)
      save /rotx/
c********************************************************************
c common blocks for saving rotation matrices between xanes and rotxan
       integer    jsavx, jsav, jbmagk
       parameter (jsavx = 150, roteps = 1.e-12,jbmagk=-9999)
       dimension drisav(-lx:lx,-lx:lx,0:lx,jsavx), betsav(jsavx)
       integer   ldsav(jsavx), mdsav(jsavx)
       common /rotsav/  drisav, betsav, ldsav, mdsav, jsav
       save  /rotsav/

c********************************************************************
c**** legendre polynomial normalization constants
c
      common /lnlm/ xnlm(0:lx,0:lx)
      save   /lnlm/

c********************************************************************
c**** legendre polynomial normalization constants
c
      common /xdwf/ sigsqr(nclusx,nclusx)
      save   /xdwf/

c  end of xstruc.h
c********************************************************************

      parameter (zero=0.e0)
      integer    lrstat(4, istatx)
      complex xclm(0:lx, 0:lx, nclusx, nclusx), sum, gllmz
      complex gam, gamtl

      iat1     = lrstat(1, ist1)
      l1       = lrstat(2, ist1)
      iat2     = lrstat(1, ist2)
      l2       = lrstat(2, ist2)
      numax    = min(l1, l2-mu)

      sum      = cmplx(zero, zero)
      do 100 nu=0,numax
        mn    = mu+nu

c       bug for xnlm with nspx=2
        gamtl = (2*l1+1) * xclm(nu, l1, iat2, iat1) / xnlm(mu, l1)
        gam   = (-1)**mu * xclm(mn, l2, iat2, iat1) * xnlm(mu, l2)

        sum   = sum + gamtl * gam
 100  continue

      gllmz = sum

      return
c  end subroutine gllm
      end

c====================================================================

!=======================================================================
!     XSPH
!=======================================================================

module xsph_inp
  use dimsmod
  use global_inp
  use potential_inp
  use ldos_inp
  implicit none
  character(*),parameter,private :: filename='xsph.inp'
  integer mphase, ipr2, ixc0, lreal, iPlsmn
  integer iGammaCH, iGrid, NPoles
  character*6  potlbl(0:nphx)
  !		potlbl(0:nphx)    -   label for user convienence
  double precision xkstep, xkmax, vixan, vr0, vi0, Eps0, EGap
  integer izstd, ifxc, ipmbse, itdlda, nonlocal, ibasis
  !		!KJ for the energy grid card EGRID :
  integer iegrid,egrid3a
  real*8 egrid3b,egrid3c
  character*100 egridfile
  logical lopt

contains

  subroutine xsph_write
    integer iph
    open (file=filename, unit=3, status='unknown')
    !     Josh - added flag for PLASMON card (iPlsmn = 0, 1, or 2)
    write(3,10) 'mphase,ipr2,ixc,ixc0,ispec,lreal,lfms2,nph,l2lp,iPlsmn,NPoles,iGammaCH,iGrid'
    write(3,20)  mphase,ipr2,ixc,ixc0,ispec,lreal,lfms2,nph,l2lp,   &
         &        iPlsmn, NPoles, iGammaCH, iGrid
    write(3,10) 'vr0, vi0'
    write(3,30)  vr0, vi0
    write(3,10) ' lmaxph(0:nph)'
    write(3,20)  (lmaxph(iph),iph=0,nph)
    write(3,10) ' potlbl(iph)'
    write(3,170)  (potlbl(iph),iph=0,nph)
170 format (13a6)
    write(3,10) 'rgrd, rfms2, gamach, xkstep, xkmax, vixan, Eps0, EGap'
    write(3,30)  rgrd, rfms2, gamach, xkstep, xkmax, vixan, Eps0, EGap
    write(3,30)  (spinph(iph),iph=0,nph)
    write(3,20)  izstd, ifxc, ipmbse, itdlda, nonlocal, ibasis
    ! Commented out by Fer
    ! The following lines are commented out because they are not being read
    ! in rexsph (commented out by JK). This screws up anything that comes after
    ! them in mod2.inp (for example, the ChSh parameters that I'm including.
    !!KJ next lines contain EGRID variables ; added 01-07
    !        write(3,10) 'iegrid,egrid3a,egrid3b,egrid3c'
    !          write(3,'(2i4,2f13.5)') iegrid,egrid3a,egrid3b,egrid3c !format statement is a mix of 20 and 30
    !          write(3,10) 'egridfile'
    !          write(3,10) egridfile
    !!KJ
    ! Added by Fer
    ! Correction of the excitation energy for chemical shifts
    write(3,10) 'ChSh_Type:'
    write(3,20) ChSh_Type
    !KJ 7-09 Next 2 lines for feff8q
    write(3,'(a)') ' the number of decomposition channels ; only used for nrixs'
    write(3,'(i5)') ldecmx
    write(3,'(a)') 'lopt'
    write(3,*) lopt
    close(3)
    ! standard formats for string, integers and real numbers
10  format(a)
20  format (20i4)
30  format (20f13.5)
  end subroutine xsph_write

  subroutine xsph_read
    integer iph
    open (file=filename, unit=3, status='old')
    read(3,*) ; read(3,*)  mphase,ipr2,ixc,ixc0,ispec,lreal,lfms2,nph,l2lp,iPlsmn, NPoles, iGammaCH, iGrid
    read(3,*) ; read(3,*)  vr0, vi0
    read(3,*) ; read(3,*)  (lmaxph(iph),iph=0,nph)
    read(3,*) ; read(3,'(13a6)')  (potlbl(iph),iph=0,nph)
    read(3,*) ; read(3,*)  rgrd, rfms2, gamach, xkstep, xkmax, vixan, Eps0, EGap
    read(3,*)  (spinph(iph),iph=0,nph)
    read(3,*)  izstd, ifxc, ipmbse, itdlda, nonlocal, ibasis
    !!KJ next lines contain EGRID variables ; added 01-07
    !          read(3,*) ; read(3,'(2i4,2f13.5)') iegrid,egrid3a,egrid3b,egrid3c !format statement is a mix of 20 and 30
    !          read(3,*) ; read(3,10) egridfile
    read(3,*) ; read(3,*) ChSh_Type
    !KJ 7-09 Next 2 lines for feff8q
    read(3,*) ; read(3,*) ldecmx
    read(3,*) ; read(3,*) lopt
    close(3)
  end subroutine xsph_read

  subroutine xsph_init
    lopt = .false.
    izstd = 0
    ifxc = 0
    ipmbse = 0
    itdlda = 0
    nonlocal = 0
    ibasis = 0
    potlbl(0:nphx) = ' '
    mphase = 1
    ipr2 = 0
    ixc0 = -1
    lreal = 0
    iPlsmn = 0 ! Josh Kas
    NPoles = 100 ! JJK 3/9/2010
    EGap = 0.d0 ! JJK 4/2010
    iGammaCH = 0
    iGrid = 0
    vr0 = 0.d0
    vi0 = 0.d0
    xkmax = 20*1.d0
    xkstep = 0.07*1.d0
    vixan = 0.d0
    iegrid=0 !KJ for EGRID card 1-07
    egridfile=' '
    egrid3a=0
    egrid3b=dble(0)
    egrid3c=dble(0)
  end subroutine xsph_init


end module xsph_inp

      subroutine ovp2mt( nph, vtot, lrewr, qtot,ri,xnatph,lnear,
     1             inrm, imt, rnrm, rmt, cmovp, ipiv, vint, inters)
c  INPUT: nph - number of diferent potentials
c   vtot(i,iph) - potential OR density at point i for potential iph
c   lrewr       - if lrewr .gt. 0 potential will be overwritten
c                   density is never overwritten (lcoul.lt.0)
c                  lrewr=0 density calculation
c                  lrewr=1 potential calculation, vint estimated
c                  lrewr=2 potential calculation, vint is fixed
c   lcoul       -  .gt.0  (potential only) calculate charge for each iph
c                  .eq.0  (potential only) flat interstitial potential 
c                  .lt.0  (density only) calc charge inside MT spheres
c   qtot       -  for density only, total electron charge of cluster
c   ri         -  loucks radial grid
c   xnatph     -  number of atoms of type iph in the cluster
c   cmovp      -  LU decomposed overlapped matrix from movrlp.f
c   ipiv       -  pivoting indices for matrix cmovp
c  OUTPUT
c    vtot    if lrewr.gt.0  decomposed overlapped potential
c            if lrewr.le.0  old prescription for potential inside MT
c              spheres or don't want to overwrite densities
c    vint    mt zero level for potentials; charge outside mt spheres for
c            densities

      implicit double precision (a-h, o-z)

      include '../HEADERS/const.h'
      include '../HEADERS/dim.h'

      dimension vtot(251,0:nphx), xnatph(0:nphx)
      dimension inrm(0:nphx), imt(0:nphx), rmt(0:nphx), rnrm(0:nphx)
      dimension vtotav(0:nphx)
c     work space for linear algebra
      parameter (novp=40)
      complex cmovp(novp*(nphx+1)+1,novp*(nphx+1)+1)
      complex cvovp(novp*(nphx+1)+1)
      integer ipiv(novp*(nphx+1)+1)
      dimension  ri(251)
      character*13 trans
      dimension  crho(251)
      logical lnear
      dimension lnear(0:nphx)
cpot      character*30 fname

c      get ipot and irav from inters
      ipot = mod(inters,2)
      irav = (inters-ipot) / 2
c     prepare cvovp and bvec from vtot
      ncp=0
      do 25 ip1=0,nph
      do 25 i=1,novp
        ncp = ncp + 1
        ix1 = imt(ip1)-novp + i
        cvovp(ncp)= real( vtot(ix1,ip1) )
       if (lrewr.eq.2) cvovp(ncp) = cvovp(ncp) - real(vint)
  25  continue
      do 27 ip1=0,nph
         if (irav .eq. 1) then
           rav = (rmt(ip1) + rnrm(ip1)) / 2
         elseif(irav.eq.0) then
           rav =  rnrm(ip1)
         else
           rav = ri(imt(ip1)+1)
         endif
         if (lnear(ip1)) rav = ri(imt(ip1)+1)
         call terp(ri,vtot(1,ip1),inrm(ip1)+2,3,rav,vtotav(ip1))
  27  continue
      istatx=novp*(nphx+1)+1
      trans = 'NotTransposed'
      nrhs = 1

c     find parameters for interstitial potential
      if (lrewr.gt.0) then
c        dealing with potentials
         if (lrewr.eq.1) then
c           additional equation to find vint
            ncp = ncp + 1
            cvovp(ncp) = 0
            bsum = 0
c           switch from average equation for vint to the local one
            nphlst = 0
            if (ipot .eq. 0) nphlst = nph
            do 430 iph=0,nphlst
               cvovp(ncp) = cvovp(ncp) + real(vtotav(iph)*xnatph(iph))
               bsum = bsum + xnatph(iph)
  430       continue
            cvovp(ncp) = cvovp(ncp) / real(bsum)
         endif

         call cgetrs(trans, ncp, nrhs, cmovp, istatx,
     $               ipiv, cvovp, istatx, info)
         if (info.lt.0) then
             call par_stop('    *** Error in cgetrf')
c            stop
         endif

         if (lrewr.eq.1) vint = dble(real(cvovp(ncp))) /100.0d0

c        rewrite vtot
         do 550 iph=0,nph
 
cpot  to write out ovp tot pot and it's mt approxim, comment out cpot
cpot         write(fname,172)  iph
cpot  172    format('potp', i2.2, '.dat')
cpot         open (unit=1, file=fname, status='unknown', iostat=ios)
cpot         call chopen (ios, fname, 'wpot')

            do 500 i=1,novp
              index1=imt(iph)-novp + i
              index2=i+novp*iph

cpot            write(1,176) i, ri(index1), 
cpot     1             vtot(index1,iph),  dble(real(cvovp(index2)))+vint
cpot  176       format (1x, i4, 1p, 3e12.4)

              vtot(index1,iph) = dble(real(cvovp(index2)))+vint
  500       continue

cpot         close (unit=1)

c           use second order extrapolation
            j=imt(iph)+1
            call terp (ri,vtot(1,iph),imt(iph),2,ri(j),vtot(j,iph))
            do 505 j=imt(iph)+2, 251
  505       vtot(j,iph) = vint
  550    continue
      else
c        dealing with  density calculations. vint  is the total
c        charge inside mt spheres.
c        Divided by interstitial volume in istprm

         call cgetrs(trans, ncp, nrhs, cmovp, istatx,
     $            ipiv, cvovp, istatx, info)
         if (info.lt.0) then
             call par_stop('    *** Error in cgetrf')
c            stop
         endif

         vint = 0
         do 450 iph=0,nph
            do 440 i=1,imt(iph)+2
               if (i.lt.imt(iph)-novp+1) then
                 crho(i) =  vtot(i,iph)*ri(i)**2
               elseif (i.le. imt(iph)) then
                 ix1 = novp*iph +i-imt(iph)+novp
                 crho(i) = dble(real(cvovp(ix1))) * ri(i)**2
c                crho(i) =  vtot(i,iph)*ri(i)**2
               else
                 call terp(ri,crho,imt(iph),2,ri(i), crho(i) )
               endif
  440       continue
            np = imt(iph) + 2
            cdum = 0
            dpas = 0.05d0
            call somm2 (ri,crho,dpas,cdum,rmt(iph),0,np)
            vint = vint + xnatph(iph) * cdum
  450    continue
         vint=qtot-vint
      endif

      return
      end

      double precision function xx (j)
      implicit double precision (a-h, o-z)
c     x grid point at index j, x = log(r), r=exp(x)
      parameter (delta = 0.050d0)
      parameter (c88   = 8.800d0)
c     xx = -8.8 + (j-1)*0.05
      xx = -c88 + (j-1)*delta
      return
      end

      double precision function rr(j)
      implicit double precision (a-h, o-z)
c     r grid point at index j
      rr = exp (xx(j))
      return
      end

      function ii(r)
      implicit double precision (a-h, o-z)
c     index of grid point immediately below postion r
      parameter (delta = 0.050d0)
      parameter (c88   = 8.800d0)
c     ii = (log(r) + 8.8) / 0.05 + 1
      ii = int((log(r) + c88) / delta) + 1
      return
      end

c      subroutine yzkrdc (i,k,flps,ps,qs,aps,aqs,p2, norb)
      subroutine yzkrdc (i,k,flps,ps,qs,aps,aqs)
c       * calculate  function yk *
c yk = r * integral of f(s)*uk(r,s)
c uk(r,s) = rinf**k/rsup**(k+1)   rinf=min(r,s)   rsup=max(r,s)
c j=norb for photoelectron
c f(s)=cg(s,i)*cg(s,j)+cp(s,i)*cp(s,j)
c f(s) is constructed by the calling programm  if i < or =0
c in the last case a function f (lies in the block dg) is supposedly
c tabulated untill point dr(j), and its' devlopment coefficients
c at the origin are in ag and the power in r of the first term is k+2

c the output functions yk and zk are in the blocks dp and dg.
c at the origin  yk = cte * r**(k+1) - developement limit,
c cte lies in ap(1) and development coefficients in ag.
c        this programm uses aprdec and yzktec
 
      implicit double precision (a-h,o-z)
      include '../HEADERS/dim.h'
      complex*16 aprdec,dyzk
c     complex*16 p2
c     complex*16 a1,a2,b1,b2,coni
c     complex*16 xck, temp, ck, phx
c      parameter (coni=(0.d0,1.d0))
      complex*16 ps(nrptx),qs(nrptx),aps(10),aqs(10)
      common/dff/cg(nrptx,30), cp(nrptx,30), bg(10,30), bp(10,30),
     1             fl(30), fix(30), ibgp
      complex*16 dg,ag,dp,ap,bidcom, chg(10)
      common/comdic/cl,dz,dg(nrptx),ag(10),dp(nrptx),ap(10),
     1   bidcom(3*nrptx+30)
      common/ratom1/xnel(30),en(30),scc(30),scw(30),sce(30),
     1   nq(30),kap(30),nmax(30)
      common/tabtec/hx,dr(nrptx),test1,test2,ndor,np,nes,method,idim
      dimension bgi(10),bpi(10)
c#mn
       external aprdec
 
c     construction of the function f
      do  5 l= 1,ibgp
        bgi(l) = bg(l,i)
  5     bpi(l) = bp(l,i)
      id=min(nmax(i),np)
      ap(1)=fl(i)+flps
      do 11 l=1,id
 11   dg(l)=cg(l,i)*ps(l)+cp(l,i)*qs(l)
      do 12 l = id+1,idim
 12    dg(l) = 0.0d0
      do 21 l=1,ndor
 21   ag(l) = aprdec(aps,bgi,l) + aprdec(aqs,bpi,l)

      dyzk = 0
c     if (id .ge. nmax(norb)) then
c        id = nmax(norb)-1
c        ck0 = log(cg(id,i)/cg(id+1,i))  / (dr(id+1)-dr(id))
c        ck = sqrt(2*p2)
c        xck = ck/cl
c        xck = -xck/(1+sqrt(1+xck**2))
c        temp = -ps(id+1) / qs(id+1) *xck
c        xx = dble (temp)
c        yy = dimag(temp)
c        if (xx .ne. 0)  then
c            alph = (1 - xx**2 - yy**2)
c            alph = sqrt(alph**2 + 4*xx**2) - alph
c            alph = alph / (2 * xx)
c            alph = atan (alph)
c        else
c            alph = 0
c        endif
c        beta = (xx**2 + (yy+1)**2) / (xx**2 + (yy-1)**2)
c        beta = log(beta) / 4

c        phx = dcmplx (alph, beta)
c        a1 =   ps(id+1) / sin(phx)
c        a2 = - qs(id+1) / cos(phx)
c        xck=ck*dr(id+1)
c        phx = phx -xck
c        a1 = a1*cg(id+1,i)/2/coni
c        a2 = a2*cp(id+1,i)/2
c        b1=exp(coni*phx) * (a1 - a2)
c        b2=exp(-coni*phx) * (-a1 - a2)
c        xck = (ck0 - coni*ck)*dr(id+1)
c        n = k +1
c        dyzk = dyzk + b1*exp(-xck)/xck
c        dyzk = dyzk + b1*expint(n,xck)
c        xck = (ck0 + coni*ck)*dr(id+1)
c        dyzk = dyzk + b2*exp(-xck)/xck
c        dyzk = dyzk + b2*expint(n,xck)
c        dyzk = dyzk*dr(id+1)
c     endif

      call yzktec (dg,ag,dp,chg,dr,ap(1),hx,k,ndor,id,idim, dyzk)
      return
      end

c     complex*16 function expint(n,x)
c     implicit double precision (a-h,o-z)
c     integer n, maxit
c     complex*16 x, b, c, d, h, del, fact, zero
c     parameter (zero=(0.d0,0.d0))
c     parameter (maxit=100, eps=1.d-7, fpmin=1.d-30, euler=.5772156649)

c     nm1 = n - 1
c     if (n.lt.0 .or. (dble(x).lt.0.d0 .and. dimag(x).eq.0.d0) .or.
c    1     (x.eq.zero .and. (n.eq.0.or.n.eq.1))) then
c        call par_stop('Bad arguments in expint')
c     elseif (n.eq.0) then
c        expint = exp(-x) / x
c     elseif (x.eq.0) then
c        expint = 1.d0 /nm1
c     elseif (dble(x).gt.1) then
c        b = x + n
c        c = 1/fpmin
c        d = 1/b
c        h = d
c        do 10 i=1,maxit
c           a = -i*(nm1+i)
c           b = b + 2
c           d = 1 / (a*d+b)
c           c = b + a/c
c           del = c*d
c           h = h*del
c           if (abs(del-1) .lt. eps) then
c              expint = h * exp(-x)
c              return
c           endif
c 10     continue
c        call par_stop(' continued fraction failed in expint')
c     else
c        if (nm1.ne.0) then
c           expint = 1/nm1
c        else
c           expint = -log(x) - euler
c        endif
c        fact = 1
c        do 30 i=1,maxit
c           fact = - fact *x / i
c           if (i.ne.nm1) then
c              del = - fact / (i-nm1)
c           else
c              psi = - euler
c              do 20 ii=1,nm1
c                 psi = psi + 1.d0 / ii
c 20           continue
c              del = fact*(-log(x)+psi)
c           endif
c           expint = expint + del
c           if (abs(del).lt.abs(expint)*eps) return
c 30     continue
c        call par_stop('series failed in expint')
c     endif
c     return
c     end

c  **************************************************
c  Parallel feff8 routines
c  Jim Sims
c  **************************************************

      subroutine par_begin
c  **************************************************
c  Initializations for parallel version(s)
c  **************************************************

      include '../HEADERS/parallel.h'

c-- So cvd or dbx can attach to a running process
c     call sleep(30) 

      numprocs = 1
      my_rank = 0
      this_process = my_rank

      par_type = 0
      parallel_run = .false.
c-- The following variable will be used for IO that should only be
c-- done in one process.
      master = (my_rank .eq. 0)

      worker = (.not. master)
      if (worker) par_type = 1

      return
      end

      subroutine par_stop (string)
c  **************************************************
c  Abnormal termination of the parallel session
c  **************************************************
      include '../HEADERS/parallel.h'
c     For abnormal exits 
c     If open, close unit = 11
c     Go to the barrier that workers are sitting at
c     Then everyone will call par_end and stop
      logical is_open
      character*(*) string

      inquire(unit=11,opened=is_open)
      if (is_open) then
        call wlog(string)
        close(unit=11)
      else if (string .ne. ' ') then
        print *,string
        print *,'Abnormal termination on processor ',this_process
      endif

      stop ' '
      end

      subroutine par_end
c  **************************************************
c  Terminate the parallel session
c  **************************************************
      return
      end

      subroutine par_barrier
c  **************************************************
c  Calls mpi_barrier
c  **************************************************
      return
      end

      subroutine par_send_int(buf,count,dest,tag)
c  **************************************************
c  Call mpi_send for integer arrays
c  **************************************************
      integer count,dest,tag
      integer buf(*)
      return
      end

      subroutine par_send_cmplx(buf,count,dest,tag)
c  **************************************************
c  Call mpi_send for complex arrays
c  **************************************************
      integer count,dest,tag
      complex buf(*)
      return
      end

      subroutine par_send_dc(buf,count,dest,tag)
c  **************************************************
c  Call mpi_send for double_complex arrays
c  **************************************************
      integer count,dest,tag
      complex*16 buf(*)
      return
      end

      subroutine par_recv_int(buf,count,source,tag)
c  **************************************************
c  Call mpi_recv for integer arrays
c  **************************************************
      integer count,source,tag
      integer buf(*)
      return
      end

      subroutine par_recv_cmplx(buf,count,source,tag)
c  **************************************************
c  Call mpi_recv for complex arrays
c  **************************************************
      integer count,source,tag
      complex buf(*)
      return
      end

      subroutine par_recv_dc(buf,count,source,tag)
c  **************************************************
c  Call mpi_recv for double complex arrays
c  **************************************************
      integer count,source,tag
      complex*16 buf(*)
      return
      end

      subroutine par_bcast_int(buf,count,source)
c  **************************************************
c  Call mpi_bcast for integer arrays
c  **************************************************
      integer count,source
      integer buf(*)
      return
      end

      subroutine par_bcast_cmplx(buf,count,source)
c  **************************************************
c  Call mpi_bcast for complex arrays
c  **************************************************
      integer count,source
      complex buf(*)
      return
      end

      subroutine par_bcast_dc(buf,count,source)
c  **************************************************
c  Call mpi_bcast for double_complex arrays
c  **************************************************
      integer count, source
      complex*16 buf(*)
      return
      end

      subroutine MPE_DECOMP1D( n, num_procs, myid, s, e )
c  ******************************************************
c  A routine for producing a decomposition of a 1-d 
c  array when given a number of processors.  It may 
c  be used in "direct" product decomposition.  The 
c  values returned assume a "global" domain in [1:n]
c  ******************************************************
c  MPE_Decomp1d - Compute a balanced decomposition of
c  a 1-D array
c  ******************************************************
c  Input Parameters:
c  n  - Length of the array
c  num_procs - Number of processors in decomposition
c  myid  - Rank of this processor in the decomposition 
c  (0 <= rank < size)
c  ******************************************************
c  Output Parameters:
c  s,e - Array my_particles are s:e, with the original 
c  array considered as 1:n.  
c  ******************************************************

      integer n, num_procs, myid, s, e
      integer nloc, deficit
 
      nloc  = n / num_procs
      s       = myid * nloc + 1
      deficit = mod(n,num_procs)
      s       = s + min(myid,deficit)
      if (myid .lt. deficit) then
        nloc = nloc + 1
      endif
      e = s + nloc - 1
      if (e .gt. n .or. myid .eq. num_procs-1) e = n

      return
      end

      SUBROUTINE SECONDS( W)
c  ***************************************************
c  SECONDS returns the wall clock times for a process
c  in seconds.
c  ***************************************************
 
      REAL*8      W

      W = 0.0

      RETURN
      END

      subroutine cubic (xk0, wp, alph, rad, qplus, qminus)

c     input:  xk0, wp, alph
c     output: rad, qplus, qminus

      implicit double precision (a-h, o-z)
      complex*16 s1,s13
      parameter (three = 3)
      parameter (third = 1/three)

c     this subroutine finds the roots of the equation
c     4xk0 * q^3  +  (alph-4xk0^2) * q^2  +  wp^2 = 0
c     see abramowitz and stegun pg 17 for formulae.

      a2 = (alph / (4*xk0**2)  -  1) * xk0
      a0 = wp**2 / (4*xk0)
      a1 = 0
      q = a1/3 - a2**2/9
      r = (a1*a2 - 3*a0)/6  -  a2**3/27
      rad = q**3 + r**2
      if (rad .gt. 0) then
         qplus = 0
         qminus = 0
         return
      endif

      s13 = dcmplx (r, sqrt(-rad))
      s1 = s13 ** third
      qz1 = 2*s1 - a2/3
      qz2 = -(s1 + sqrt(three)*dimag(s1) + a2/3)
      qz3 = -(s1 - sqrt(three)*dimag(s1) + a2/3)
      qplus = qz1
      qminus = qz3

      return
      end

      subroutine rdpot ( ntitle, title, rnrmav, xmu, vint, rhoint,
     1                  emu, s02, erelax, wp, ecv,rs,xf, qtotel, 
     2                  imt, rmt, inrm, rnrm, folp, folpx, xnatph,
     3                  dgc0, dpc0, dgc, dpc, adgc, adpc,
     3                  edens, vclap, vtot, edenvl, vvalgs, dmag, xnval,
     4                  eorb, kappa, iorb, qnrm, xnmues, nohole, ihole,
     5                  inters, totvol, iafolp, xion, iunf, iz, jumprm)
c  opens pot.pad file and reads following information
c  General:
c     ntitle - number of title lines
c     title  - title itself
c     emu    - edge position (x-ray energy for final state at Fermi level)
c  Muffin-tin geometry
c     rmt    - muffin-tin radii
c     imt    - index of radial grid just below muffin-tin radii
c     rnrm   - Norman radii
c     inrm   - index of radial grid just below Norman radii
c     rnrmav - average Norman radius
c     folp   - overlap parameter for rmt
c     folpx  - maximum value for folp
c     xnatph - number of atoms of each potential type
c  Atomic orbitals info (Dirac spinors)
c     dgc0   - upper component for initial orbital
c     dpc0   - lower component for initial orbital
c     dgc    - upper components for all atomic orbitals
c     dpc    - lower components for all atomic orbitals
c     adgc   - development coefficient for upper components
c     adpc   - development coefficient for lower components
c     xnval  - number of valence electrons for each atomic orbital
c              used for core-valence separation and non-local exchange
c     eorb  - atomic enrgy of each orbital for the absorber
c  Electron density information 
c     rhoint - interstitial density
c     rs     - r_s estimate from rhoint (4/3 r_s**3 * rhoint = 1)
c     xf     - estimate of momentum at Fermi level from rhoint
c     edens  - total electron density
c     edenvl - density from valence electrons
c     dmag   - density for spin-up minus density for spin-down
c     qtotel - total charge of a cluster
c     qnrm   - charge accumulated inside Norman sphere as result of SCF
c     xnmues - occupation numbers of valence orbitals from SCF procedure
c  Potential information
c     xmu    - Fermi level position
c     ecv    - core-valence separation energy
c     vint   - muffin-tin zero energy (interstitial potential)
c     vclap  - Coulomb potential
c     vtot   - vclap + xc potential from edens
c     vvalgs - vclap + xc potential from edenvl (EXCHANGE 5 model)
c  Specific data for convolution with excitation spectrum (see mbconv)
c     s02    - many body reduction factor S_0^2 
c     erelax - estimate of relaxation energy = efrozen - emu, where
c              efrozen is edge position estimate from Koopmans theorem
c     wp     - estimate of plasmon frequency from rhoint

      implicit double precision (a-h, o-z)
      include '../HEADERS/dim.h'
      dimension adgc(10, 30, 0:nphx)
      dimension adpc(10, 30, 0:nphx)
      dimension dgc(251, 30, 0:nphx)
      dimension dgc0(251)
      dimension dmag(251, 0:nphx)
      dimension dpc(251, 30, 0:nphx)
      dimension dpc0(251)
      dimension edens(251, 0:nphx)
      dimension edenvl(251, 0:nphx)
      dimension eorb(30)
      dimension folp(0:nphx)
      dimension folpx(0:nphx)   
      dimension imt(0:nphx)
      dimension inrm(0:nphx)
      dimension iorb(-4:3,0:nphx)
      dimension iz(0:nphx)
      dimension kappa(30)
      dimension qnrm(0:nphx)
      dimension rmt(0:nphx)
      dimension rnrm(0:nphx)
      dimension vclap(251, 0:nphx)
      dimension vtot(251, 0:nphx)
      dimension vvalgs(251, 0:nphx)
      dimension xion(0:nphx)
      dimension xnatph(0:nphx)
      dimension xnmues(0:lx,0:nphx)
      dimension xnval(30,0:nphx)

      character*80 title(nheadx)

      dimension dum(13)

  10  format(a)

      open (unit=3, file='pot.pad', status='old')
      read(3,30) ntitle, nph, npadx, nohole, ihole, inters, iafolp,
     1            jumprm, iunf
  30  format(9(1x,i4))
c     nph and npadx are not passed to calling subroutine
      do 133  i  = 1, ntitle
         read(3,10) title(i)
         call triml(title(i))
  133 continue
c     Misc double precision stuff from pot.pad
      call rdpadd(3, npadx, dum(1), 13)
      rnrmav = dum(1)
      xmu    = dum(2)
      vint   = dum(3)
      rhoint = dum(4)
      emu    = dum(5)
      s02    = dum(6)
      erelax = dum(7)
      wp     = dum(8)
      ecv    = dum(9)
      rs     = dum(10)
      xf     = dum(11)
      qtotel = dum(12)
      totvol = dum(13)

c     read imt
      read (3, 40) (imt(i),i=0,nph)
  40  format(20(1x,i4))
      call rdpadd(3, npadx, rmt(0), nph+1)
c     read inrm
      read (3, 40) (inrm(i),i=0,nph)
      read (3, 40) (iz(i),i=0,nph)
      read (3, 40) (kappa(i),i=1,30)
      call rdpadd(3, npadx, rnrm(0), nph+1)
      call rdpadd(3, npadx, folp(0), nph+1)
      call rdpadd(3, npadx, folpx(0), nph+1)
      call rdpadd(3, npadx, xnatph(0), nph+1)
      call rdpadd(3, npadx, xion(0), nph+1)
      call rdpadd(3, npadx, dgc0(1), 251)
      call rdpadd(3, npadx, dpc0(1), 251)
      call rdpadd(3, npadx, dgc(1,1,0), 251*30*(nph+1) )
      call rdpadd(3, npadx, dpc(1,1,0), 251*30*(nph+1) )
      call rdpadd(3, npadx, adgc(1,1,0), 10*30*(nph+1) )
      call rdpadd(3, npadx, adpc(1,1,0), 10*30*(nph+1) )
      call rdpadd(3, npadx, edens(1,0), 251*(nph+1) )
      call rdpadd(3, npadx, vclap(1,0), 251*(nph+1) )
      call rdpadd(3, npadx, vtot(1,0), 251*(nph+1) )
      call rdpadd(3, npadx, edenvl(1,0), 251*(nph+1) )
      call rdpadd(3, npadx, vvalgs(1,0), 251*(nph+1) )
      call rdpadd(3, npadx, dmag(1,0), 251*(nph+1) )
      call rdpadd(3, npadx, xnval(1,0), 30*(nph+1) )
      call rdpadd(3, npadx, eorb(1), 30)
      do 50 iph=0,nph
 50   read (3, 60) (iorb(i,iph),i=-4,3)
 60   format(8(1x,i2))
      call rdpadd(3, npadx, qnrm(0), nph+1 )
      nn = (lx+1)*(nph+1)
      call rdpadd(3, npadx, xnmues(0,0), nn )
      close (unit=3)

      return
      end

      subroutine sthead (ntitle, title, ltitle, nph, iz, rmt, rnrm,
     1                  ion, ifrph, ihole, ixc,
     2                  vr0, vi0, rs0, gamach, xmu, xf, vint, rs,
     3                  nhead, lhead, head, shole, sout)

c     SeT HEAD
c     This routine makes the file header, returned in head array.
c     header lines do not include a leading blank.
c     Last header line is not --------- end-of-header line

c     title lines coming into sthead include carriage control, since
c     they were read from potph.dat

      implicit double precision (a-h, o-z)

      include 'const.h'
      include 'dim.h'

      dimension ifrph(0:nphx)
      dimension ion(0:nfrx)
      dimension iz(0:nfrx)
      dimension rmt(0:nphx)
      dimension rnrm(0:nphx)

      character*80 title(ntitle)
      parameter (nheadx = 30)
      character*80 head(nheadx)
      dimension lhead(nheadx), ltitle(ntitle)

      character*10 shole(0:9)
      character*8 sout(0:6)


      character*80 heada(nheadx)
      dimension lheada(nheadx)
      save nheada, lheada, heada
c     heada, etc., are saved for use by entry wthead

cc       common /labels/ shole, sout
      include 'vers.h'
c     character*12 vfeff, vpotph, vpaths, vgenfm, vff2ch
c     common /vers/ vfeff, vpotph, vpaths, vgenfm, vff2ch

c     FiLl head array with HEADer
c     Fills head arrray, n = number of lines used.
c     Does not include line of dashes at the end.

      nhead = 1
      if (ntitle .ge. 1  .and.  ltitle(1).gt.1)  then
         write(head(nhead),100)  title(1)(2:), vfeff, vpotph
      else
         write(head(nhead),102)  vfeff, vpotph
      endif
  100 format(a55, t56, 2a12)
  102 format(t56, 2a12)
      do 120  ititle = 2, ntitle
         if (ltitle(ititle).le.1)  goto 120
         nhead = nhead+1
         write(head(nhead),110) title(ititle)(2:)
  110    format(a79)
  120 continue
      if (ion(0) .ne. 0)  then
         nhead = nhead+1
         write(head(nhead),130)  iz(0), rmt(0)*bohr,
     1                    rnrm(0)*bohr, ion(0), shole(ihole)
      else
         nhead = nhead+1
         write(head(nhead),140)  iz(0), rmt(0)*bohr,
     1                    rnrm(0)*bohr, shole(ihole)
      endif
  130 format('Abs   Z=',i2,' Rmt=',f6.3,' Rnm=',f6.3,' Ion=',i2,1x,a10)
  140 format('Abs   Z=',i2,' Rmt=',f6.3,' Rnm=',f6.3, 1x,a10)

      do 150  iph = 1, nph
         ifr = ifrph(iph)
         if (ion(ifr) .ne. 0)  then
            nhead = nhead+1
            write(head(nhead),160)  iph, iz(ifr),  rmt(iph)*bohr,
     1           rnrm(iph)*bohr, ion(ifr)
         else
            nhead = nhead+1
            write(head(nhead),170)  iph, iz(ifr),  rmt(iph)*bohr,
     1           rnrm(iph)*bohr
         endif
  150 continue
  160 format('Pot',i2,' Z=',i2,' Rmt=',f6.3,' Rnm=',f6.3,' Ion=',i2)
  170 format('Pot',i2,' Z=',i2,' Rmt=',f6.3,' Rnm=',f6.3)
      if (abs(vi0) .gt. 1.0e-8 .or. abs(vr0) .gt. 1.0e-8)  then
         nhead = nhead+1
         write(head(nhead),180)  gamach*ryd, sout(ixc), vi0*ryd,
     1                           vr0*ryd
      else
         nhead = nhead+1
         write(head(nhead),190)  gamach*ryd, sout(ixc)
      endif
      nhead = nhead+1
  180 format('Gam_ch=',1pe9.3, 1x,a8, ' Vi=',1pe10.3, ' Vr=',1pe10.3)
  190 format('Gam_ch=',1pe9.3, 1x,a8)
  200 format('Mu=',1pe10.3, ' kf=',1pe9.3, ' Vint=',1pe10.3,
     x        ' Rs_int=',0pf6.3)
      write(head(nhead),200)  xmu*ryd, xf/bohr, vint*ryd, rs
      if (ixc .eq. 4)  then 
          nhead = nhead+1
          write(head(nhead),210)  rs0
  210     format ('Experimental DH-HL exch, rs0 = ', 1pe14.6)
      endif
      do 220  i = 1, nhead
         lhead(i) = istrln(head(i))
         heada(i) = head(i)
         lheada(i) = lhead(i)
  220 continue
      nheada = nhead

      return

      entry wthead (io)
c     Dump header to unit io, which must be open.  Add carraige control
c     to head array, which doesn't have it.

      do 310 i = 1, nheada
         ll = lheada(i)
         write(io,300)  heada(i)(1:ll)
  300    format (1x, a)
  310 continue
      end

      subroutine rdxsph ( phpad, 
     1     ne, ne1, ne3, nph, ihole, rnrmav, xmu, edge,
     2     ik0, ixc, rs, vint,
     3     em, eref, iz, potlbl, ph, rkk, lmax, lmaxp1)
      implicit double precision (a-h, o-z)
c     reads file 'phase.pad' 
c
c     phpad - specify path to phase.pad     (character*256)
c  Energy grid information
c     em   - complex energy grid
c     eref - V_int + i*gamach/2 + self-energy correction
c     ne   - total number of points in complex energy grid
c     ne1  - number of points on main horizontal axis
c     ne2  - number of points on vertical vertical axis ne2=ne-ne1-ne3
c     ne3  - number of points on auxilary horizontal axis (need for f')
c     xmu  - Fermi energy
c     edge - x-ray frequency for final state at Fermi level
c     ik0  - grid point index at Fermi level
c  Potential type information
c     ixc    - potential model
c     rs     - r_s estimate from rhoint (4/3 r_s**3 * rhoint = 1)
c     vint   - muffin-tin zero energy (interstitial potential) 
c     nph    - number of potential types
c     iz     - charge of nuclei (atomic number)
c     potlbl - label for each potential type
c     lmax   - max orb momentum for each potential type
c     ihole  - index of core-hole orbital for absorber (iph=0)
c     rnrmav - average Norman radius (used in headers only)
c  Main output of xsect and phases module (except that in xsect.bin)
c     ph  - complex scattering phase shifts
c     rkk - complex multipole matrix elements

      include '../HEADERS/dim.h'

      character*256 phpad

      character*6  potlbl
      dimension  potlbl(0:nphx)

      complex*16 ph(nex,-ltot:ltot,nspx,0:nphx), eref(nex,nspx), em(nex)
      complex*16 rkk(nex,8,nspx)
      dimension lmax0(0:nphx), lmax(nex,0:nphx)
      dimension iz(0:nphx)
c     kinit, linit, ilinit,  - initial state kappa and ang. mom.
c     lmaxp1  -largest lmax in problem + 1

c     phmin is min value to use for |phase shift|
      parameter (phmin = 1.0d-7)

c     Local staff
c     use temp to write ph, rkk, since ne < nex
      complex*16 temp(nex*(2*ltot+1))
      dimension dum(3)

      call triml(phpad)
c      print *, istrln(phpad), '--', phpad(1:istrln(phpad)), '--'
      open (unit=1, file=phpad, status='old', iostat=ios, err=3)
      goto 6
 3    continue
      open (unit=1, file='phase.pad', status='old', iostat=ios, err=4)
      goto 5

 4    continue
      stop 'cannot find phase.pad in rdxsph'

 5    continue
      phpad = 'phase.pad'

 6    continue
      call chopen (ios, 'phase.pad', 'rdxsph')

      ixc = 0
      rs = 0.
      vint = 0.
      read(1,10) nsp, ne, ne1, ne3, nph, ihole, ik0, npadx, ixc,
     &     rs, vint
  10  format (9(1x,i4), 2(1x,f10.5))

      call rdpadd(1, npadx, dum(1), 3)
      rnrmav = dum(1)
      xmu    = dum(2)
      edge   = dum(3)

      call rdpadx(1, npadx, em(1), ne)
c     call rdpadx(1, npadx, eref(1), ne)
      call rdpadx (1, npadx, temp(1), ne*nsp)
      ii = 0
      do 60 isp = 1, nsp
      do 60 ie=1, ne
        ii = ii + 1
        eref (ie, isp) = temp(ii)
  60  continue

      do 80  iph = 0, nph
         read(1, 20)  lmax0(iph), iz(iph), potlbl(iph)
  20     format(2(1x,i3), 1x, a6)

         do 75 isp = 1,nsp 
            ii = ne * (2*lmax0(iph)+1)
            call rdpadx (1, npadx, temp(1), ii )
            ii = 0
            do 70  ie = 1, ne
            do 70  ll = -lmax0(iph), lmax0(iph)
               ii = ii+ 1
               ph(ie,ll,isp,iph) = temp(ii)
   70       continue
   75    continue
   80 continue

      call rdpadx (1, npadx, temp(1), ne*8*nsp)
      ii = 0
      do 90 isp = 1,nsp 
      do 90 kdif = 1, 8
      do 90 ie=1, ne
        ii = ii + 1
        rkk (ie, kdif, isp) = temp(ii)
  90  continue

      close (unit=1)

c     make additional data for output
      lmaxp1 = 0
      do 180  iph = 0, nph
      do 180  ie = 1, ne
c        Set lmax to include only non-zero phases
         do 160  il =  lmax0(iph), 0, -1
            lmax(ie,iph) = il
            if (abs(sin(ph(ie, il, 1, iph))) .gt. phmin .or.
     3          abs(sin(ph(ie, il,nsp,iph))) .gt. phmin)  goto 161
  160    continue
  161    continue
         if (lmax(ie,iph)+1 .gt. lmaxp1)  lmaxp1 = lmax(ie,iph)+1
  180 continue

      return
      end

      subroutine rdxbin (s02p, erelax, wp, edgep, s02, gamach, ne1, ik0,
     1                   emxs, omega, xkxs, xsnorm, xsec, nxsec, mbconv,
     2                   title, ntitle)

      implicit double precision (a-h, o-z)
      include '../HEADERS/const.h'
      include '../HEADERS/dim.h'

c     header from xsect.bin
      dimension ltitle(nheadx)
      character*80 title(nheadx)
      complex*16 emxs(nex), xsec(nex)
      dimension omega(nex), xkxs(nex), xsnorm(nex)

      double precision er(nex), ei(nex), xsn(nex)
      double precision col4(nex), col5(nex)

c$$$      open (unit=8, file='xsect.bin', status='old', iostat=ios)
c$$$c     read xsect.bin
c$$$      ntitle = nheadx
c$$$      call rdhead (8, ntitle, title, ltitle)
c$$$c     read method for xsec calculation
c$$$      read(8,*)  s02p, erelax, wp, edgep, emu
c$$$      if (mbconv .gt.0 .or. s02.le.0.1) s02=s02p
c$$$c     read gamach (in eV) for use in atan at absorption edge
c$$$c     and convert to code units
c$$$      read(8,*)  gamach, ne1, ik0
c$$$      gamach = gamach / hart
c$$$c     skip label and read after it
c$$$      read(8,*)
c$$$      i = 1
c$$$  300    read(8,*,end=310)  ereal, eimag, xsnorm(i), dum1, dum2
c$$$         xsec(i) = dum1 + coni*dum2
c$$$c        xsect.bin is in eV and invA, convert to code units here
c$$$         emxs(i) = (ereal + coni*eimag) / hart
c$$$         xkxs(i) = getxk (dble(emxs(i)) - edgep)
c$$$         omega(i) = dble(emxs(i)) - edgep + emu
c$$$         nxsec = i
c$$$         i = i + 1
c$$$         if (i.le.nex) goto 300
c$$$  310 continue
c$$$      close(unit=8)

      call read_xsect(ntitle, title, s02p, erelax, wp, edgep, emu,
     1                gamach, nxsec, ne1, ik0,
     2                er, ei, xsn, col4, col5)

      if (mbconv .gt.0 .or. s02.le.0.1) s02=s02p
      gamach = gamach / hart
      do 1000 i=1,nxsec
         xsec(i) = col4(i) + coni*col5(i)
         emxs(i) = (er(i) + coni*ei(i)) / hart
         xkxs(i) = getxk (dble(emxs(i)) - edgep)
         omega(i) = dble(emxs(i)) - edgep + emu
         xsnorm(i) = xsn(i)
 1000 continue
      do 1010 i=1,ntitle
         ltitle(i) = istrln(title(i))
 1010 continue

      return
      end

      subroutine wrhead (iunit, nhead, head, dwcorr, s02,
     1  tk, thetad, sig2g, alphat, vrcorr, vicorr, critcw)

      implicit double precision (a-h, o-z)

      include '../HEADERS/const.h'
      include '../HEADERS/dim.h'
      include '../HEADERS/vers.h'
      parameter (eps4 = 1.0d-4)
      character*80  head(nheadx)
      logical dwcorr
      character*2 coment
      parameter (coment='# ')

c     write miscellanious staff into headers
c     add feff verdion to the first line
      ll = istrln(head(1))
      if (ll .lt. 0)  then
        head(1)= 'Untitled'
        ll = istrln(head(1))
      endif
      write(iunit,310) coment, head(1)(1:), vfeff//vf85e
  310 format (a2, a45, t48, a30)

c     the rest of the title
      do 330  ihead = 2, nhead
         ll = istrln(head(ihead))
         if (ll .gt. 0)  then
            write(iunit,320) coment, head(ihead)(1:ll)
         endif
  320    format (a2, a)
  330 continue
      if (dwcorr)  then
         write(iunit,340)  coment, s02, tk, thetad, sig2g
  340    format (a2,' S02=', f5.3, '  Temp=', f7.2,'  Debye_temp=',f7.2,
     1        '  Global_sig2=', f8.5)
      else
         write(iunit,341)  coment, s02, sig2g
  341    format (a2, ' S02=', f5.3,
     1   '                                        Global_sig2=', f8.5)
      endif
      if (alphat .gt. zero)  then
         write(iunit,321)  coment, alphat
  321    format (a2, ' 1st and 3rd cumulants, alphat = ', 1pe20.4)
      endif

      if (abs(vrcorr).ge.eps4 .or. abs(vicorr).ge.eps4)  then
         write(iunit,342) coment, vrcorr*hart, vicorr*hart
      endif
  342 format (a2, ' Energy zero shift, vr, vi ', 1p, 2e14.5)

      if (critcw .gt. 0)  write(iunit,350) coment, critcw
  350 format (a2, ' Curved wave amplitude ratio filter ', f7.3, '%')
      write(iunit,360) coment
  360 format (a2, '    file         sig2 tot  cw amp ratio   deg',
     1        '  nlegs   reff  inp sig2')
c     stop writing misc. staff to files

      return
      end


      subroutine dwadd (ntotal,nptot,idwopt,ip,index,crit,critcw,sig2g,
     1  sig2u, dwcorr, rnrmav, nleg, deg, reff, iz, ipot, rat,tk,thetad,
     2  alphat, thetae, mbconv, s02, ne1, ck, achi, phchi, nkx, xk, xk0,
     3  xkp, cchi, iabs, nabs, ispec, ipr4, nhead,
     4  head, vrcorr, vicorr, nused)
      implicit double precision (a-h, o-z)

      include '../HEADERS/const.h'
      include '../HEADERS/dim.h'
      parameter (eps4 = 1.0d-4)
      character*80  head(nheadx)
      parameter (npx=15000)
c     indices of paths to do, read from list.dat
      dimension ip(npx)
      real sig2u(npx)

      parameter (nfinex = 601)
      complex*16 cchi(nfinex), ccpath(nfinex), ccc, ckp
c     to keep Im part of cchi 11.18.97 ala
      complex*16 dw, dw1, dw3
      dimension xkp(nfinex), xk0(nfinex)

      logical dwcorr
      dimension rattmp(3,0:legtot)
      dimension iztmp(0:legtot)
      character*512 slog
      character*12 fname
      real rnrmav
      dimension iz(0:nphx)
c     central atom phase shift at l0
      complex ck(nex)
      real xk(nex)
      dimension index(npx)
      dimension nleg(npx)
      real deg(npx), reff(npx), crit(npx)
      dimension ipot(legtot,npx)
      real rat(3,legtot,npx)
      real achi(nex,npx), phchi(nex,npx)
      dimension sig2x(0:nphx, 0:nphx)
      character*2 coment
      parameter (coment='# ')

c     Keep stats on paths used to make chi
      nused = 0
      xkref = dble(ck(1)**2) - xk(1)*abs(xk(1))

c     open the files for sigrm and sigem
      if (idwopt.eq.1) then
         iem = 111
         open(unit=iem,file='s2_em.dat',status='unknown', iostat=ios)
         call chopen (ios, 's2_em.dat', 'sigem')
      elseif (idwopt.eq.2) then
         irm1 =111
         open(unit=irm1,file='s2_rm2.dat',status='unknown', iostat=ios)
         call chopen (ios, 's2_rm2.dat', 'sigrm')
         irm2 = 112
         open(unit=irm2,file='s2_rm1.dat',status='unknown', iostat=ios)
         call chopen (ios, 's2_rm1.dat', 'sigrm')
      endif
      if (alphat .gt. 0) then
        icum = 113
        open(unit=icum, file='cum.dat', status='unknown', iostat=ios)
        call chopen (ios, 'cum.dat', 'sig3')
        Write(icum, 363)
  363  format('# first and third icumulant for single scattering paths')
        write(icum,364) thetae, alphat
        write(icum,365)
  364   format ('# Einstein-Temp. =',f9.2 ,'   ', 'alpha=',f9.5)
  365   format ('#       file   sig1    sig2    sig3 ')
      endif

      if (idwopt.ge.1) then
c        initialize statistics for max DW for sigrm
         sig2mx=0
         do 400 iph1=0,nphx
         do 400 iph2=0,nphx
  400    sig2x(iph1, iph2) = 0
      endif


c     cycle over all paths in the list
      do 560  ilist = 1, ntotal
c        find index of path
         do 410  j = 1, nptot
            if (ip(ilist) .eq. index(j))  then
               ipath = j
               goto 430
            endif
  410    continue
         write(slog,420)  ilist, ip(ilist)
  420    format (' did not find path i, ip(i) ', 2i10)
         call wlog(slog)
  430    continue
c        Path ipath is the path from feff.pad that corresponds to
c        the path ilist in list.dat.  The index of the path is
c        ip(ilist) and index(ipath).

c        Use this path if it passes critcw filter
         if (crit(ipath) .lt. critcw)  goto 550

c        do debye-waller factors, get sig2d from correlated debye
c        model if required
c        A note about units:  sig2g, sig2u() and sig2d are all in
c        Angs**2.  Convert to code units after we've summed them.
         sig2 = sig2g + sig2u(ilist)
         if (dwcorr .and. idwopt.ge.0)  then
c           note that stuff from feff.pad is single precision and
c           mostly in multidim. arrays.  sigms is double precision
c           and its arrays are dimensioned for a single path, so
c           use tmp variables to call it.  tk, thetad and sig2d are
c           all dp, and therefore OK.  Also note that sigms takes
c           inputs in angstroms, except for rs which is in bohr.
            rs = rnrmav
            do 460  ileg = 1, nleg(ipath)
               iztmp(ileg) = iz(ipot(ileg,ipath))
               do 450  j = 1, 3
                  rattmp(j,ileg) = rat(j,ileg,ipath) * bohr
  450          continue
  460       continue
            iztmp(0) = iztmp(nleg(ipath))
            do 470  j = 1,3
               rattmp(j,0) = rattmp(j,nleg(ipath))
  470       continue
            if (idwopt.eq.0) then
c             use CD model
              call sigms (tk, thetad, rs, legtot, nleg(ipath),
     1                  rattmp, iztmp, sig2d)
            elseif (idwopt.eq.1) then
c             use EM method
              call sigem
     1        (sig2mx,sig2x,iem,tk,ipath,nleg(ipath),rattmp,sig2d)
            elseif (idwopt.eq.3) then  !KJ 7/06 added this section
c             use CL model
              call sigcl (tk, thetad, rs, legtot, nleg(ipath),
     1                  rattmp, iztmp, sig2d)
            else
c             use RM
              call sigrm
     1        (sig2mx,sig2x,irm1,irm2,tk,ipath,nleg(ipath),rattmp,sig2d)
            endif
            sig2 = sig2 + sig2d
         endif
         sig2 = sig2 / (bohr**2)

c        Do first and third cumulants
         sig1 = 0
         sig3 = 0
         if (alphat .gt. zero  .and. nleg(ipath) .eq. 2)  then
           if (thetae.le.0.d0) then
c            call sig3  to get sig1 and sig3 for single scattering paths
c           use reff(ipath) for r, note that reff is single precision
             iz1 = iztmp(nleg(ipath))
             iz2 = iztmp(1)
             call sigte3(iz1, iz2, sig2, alphat, thetad, reff(ipath),
     1                   sig1, sig3)
           else
c            this gets sig1 and sig3 for single scattering paths
c            using Morse potential
             call sigm3(sig1, sig2, sig3, tk, alphat, thetae)
           endif
           write(icum,475) index(ipath),  sig1 * bohr,
     1                 sig2*(bohr**2), sig3*(bohr**3)
  475      format( i10,f9.5,f9.5,' ',f9.7)
         endif

c        put the debye-waller factor and other cumulants into
c        achi and phchi
         if (mbconv .gt. 0) s02 = 1.0
         do 480  i = 1, ne1
            dw = exp(-2 * sig2 * ck(i)**2)
            dw1 = exp (2 * coni * ck(i) * sig1)
            dw3 = exp ((-4 * coni * ck(i)**3 * sig3) / 3)
            dw = dw * dw1 * dw3
            phdw = 0.0
            if (abs(dw).gt.0) phdw = atan2 (dimag(dw), dble(dw))
            achi(i,ipath) = achi(i,ipath) *
     1           real(abs(dw) * s02 * deg(ipath))
            phchi(i,ipath) = phchi(i,ipath) + real(phdw)
  480    continue
c        make sure no 2pi jumps in phase
         do 490  i = 2, ne1
c           phchi is single precision, so use tmp variables
            curr = phchi (i, ipath)
            old = phchi (i-1, ipath)
            call pijump (curr, old)
            phchi (i, ipath) = real(curr)
  490    continue

         do 500  ik = 1, nkx
            call terp1 (xk, achi(1,ipath),  ne1, xk0(ik), achi0)
            call terp1 (xk, phchi(1,ipath), ne1, xk0(ik), phchi0)
            ccpath(ik) =
     1        achi0 * exp (coni * (2 * xk0(ik) * reff(ipath) + phchi0))
c           note that this already includes s02, deg, sig2, etc.
c           sum total complex chi
            cchi(ik) = cchi(ik) + ccpath(ik)
  500    continue
         nused = nused + 1

         if (iabs.eq.nabs) then
c           Put path into chi.dat, xmu.dat as required
            if (abs(sig2u(ilist)) .gt. 0.000001)  then
              write(3,515)  coment, index(ipath), sig2*(bohr**2),
     1          crit(ipath), deg(ipath), nleg(ipath), reff(ipath)*bohr,
     2          sig2u(ilist)
              write(8,515)  coment, index(ipath), sig2*(bohr**2),
     1          crit(ipath), deg(ipath), nleg(ipath), reff(ipath)*bohr,
     2            sig2u(ilist)
            else
              write(3,515) coment, index(ipath), sig2*(bohr**2),
     1          crit(ipath), deg(ipath), nleg(ipath), reff(ipath)*bohr
              write(8,515) coment, index(ipath), sig2*(bohr**2),
     1          crit(ipath), deg(ipath), nleg(ipath), reff(ipath)*bohr
            endif
  515       format(a2, 1x, i10, 5x, f9.5, 2f10.2, i6, f9.4, f9.5)
         endif

c        write out a chinnnn.dat for this path, if necessary.
         if (ipr4 .eq. 2 .and. iabs.eq.nabs .and. ispec.eq.0)  then
c           make filename chipnnnn.dat
            write(fname,520)  index(ipath)
  520       format('chip', i4.4, '.dat')
            open (unit=9, file=fname, status='unknown',iostat=ios)
            call chopen (ios, fname, 'ff2chi')
            do 530  ihead = 1, nhead
               lhead = istrln(head(ihead))
               if (lhead .gt. 0)  then
                  write(9,320) head(ihead)(1:lhead)
  320             format (a)
               endif
  530       continue
            if (dwcorr)  then
               write(9,340)  s02, tk, thetad, sig2g
  340          format (' S02', f7.3, '  Temp', f8.2,'  Debye temp',f8.2,
     1        '  Global sig2', f9.5)
            else
               write(9,341)  s02, sig2g
  341          format (' S02', f7.3,
     1      '                                        Global sig2', f9.5)
            endif
            if (alphat .gt. zero)  then
               write(9,321)  alphat
  321          format (' 1st and 3rd cumulants, alphat = ', 1pe20.4)
            endif

            if (abs(vrcorr).ge.eps4 .or. abs(vicorr).ge.eps4)  then
               write(9,342)  vrcorr, vicorr
  342          format (' Energy zero shift, vr, vi ', 1p, 2e14.5)
            endif
            write(9,*) 'Debye-waller factor ', sig2, sig3

            write(9,610)
  610       format (1x, 71('-'))
            write(9,535)
  535       format ('       k         chi           mag          ',
     1              'phase        phase-2kr  @#')
            do 540  i = 1, nkx
               ckp = sqrt (xkp(i)*abs(xkp(i)) + xkref)
c              it would be better to use interpolation for ckp
c              fix later if complaints about chipnnn.dat files, ala
               xlam0 =  - dimag(ckp)
               ccc = ccpath(i) * exp(2 * reff(ipath) * xlam0)
               phase = 0
               if (abs(ccc) .gt. 0)  phase=atan2(dimag(ccc), dble(ccc))
               if (i .gt. 1)  call pijump (phase, phase0)
               phase0 = phase
               write(9,630)  xkp(i)/bohr, dimag(ccc), abs(ccc), phase,
     1                       phase-2*xk0(i)*reff(ipath)
  630          format (1x, f10.4, 3x, 4(1pe13.6,1x))
  540       continue
            close (unit=9)
         endif

  550    continue
  560 continue

c     close files opened for sigem and sigrem
      if (idwopt.eq.1) then
        close (unit=iem)
      elseif (idwopt.eq.2) then
        close (unit=irm1)
        close (unit=irm2)
      endif
      if (alphat .gt. 0) then
        close (unit=icum)
      endif

      return
      end

      subroutine rdinp (finp, 
     1                  mphase, mpath, mfeff, mchi, ms,
     1                  ntitle, title, ltit,
     2                  critcw,
     1                  ipr2, ipr3, ipr4,
     1                  s02, tk, thetad, sig2g,
     1                  nlegxx,
     1                  rmax, critpw, pcritk, pcrith, nncrit,
     2                  icsig, iorder, vrcorr, vicorr, isporb)

c     Read input for multiple scattering feff
      implicit double precision (a-h, o-z)
	character*128 finp
      include 'const.h'
      include 'dim.h'
      include 'pola.h'

c     Following passed to pathfinder, which is single precision.
c     Be careful to always declare these!
      real rmax, critpw, pcritk, pcrith

c     Data for potph (see arrays.h for comments)
      dimension iphat(natx)
      dimension rat(3,natx)
      dimension iatph(0:nphx)
      dimension ifrph(0:nphx)
      dimension xnatph(0:nphx)
      dimension folp(0:nphx)
      dimension novr(0:nphx)
      dimension iphovr(novrx,0:nphx)
      dimension nnovr(novrx,0:nphx)
      dimension rovr(novrx,0:nphx)
      dimension ion(0:nfrx)
      dimension iz(0:nfrx)

      character*6  potlbl(0:nphx)

c     Local stuff
      character*150  line
      parameter (nwordx = 12)
      character*15 words(nwordx)

      parameter (ntitx = 10)
      character*128  title(ntitx), messag
      dimension ltit(ntitx)
      dimension ionph(0:nphx), izph(0:nphx)
      logical iscomm
      parameter (nssx = 16)
      dimension indss(nssx), iphss(nssx)
      dimension degss(nssx), rss(nssx)
      logical nogeom

   10 format (a)
   20 format (bn, i15)
   30 format (bn, f15.0)

c     initialize things

      ihole = 1
      ntitle = 0
      ixc = 0
      vr0 = 0
      vi0 = 0
      rs0 = 0
      rmax = -1
      tk = 0
      thetad = 0
      sig2g = 0
      rmult = 1
      s02 = 1
      mphase = 1
      mpath = 1
      mfeff = 1
      mchi = 1
      ms = 0
      ipr1 = 0
      ipr2 = 0
      ipr3 = 0
      ipr4 = 0
      nlegxx = 10
      xkmin = 0
      xkmax = 20
      critcw = 4.0
      critpw = 2.5
      pcritk = 0
      pcrith = 0
      nogeom = .false.
      icsig = 1
      iorder = 2
      ixanes = 0
      vrcorr = 0
      vicorr = 0
      iafolp = 0
      intclc = 0
      nemax = nex
      isporb = -1

c     average over polarization by default
      pola = .false.
      elpty = 0
      do 50 i = 1, 3 
         evec(i) = 0
         ivec(i) = 0
  50  continue 

c     nncrit is number of necrit points to use.  necrit is
c     currently 9, this was at once an input used for testing.
      nncrit = 9

      nat = 0
      do 100  iat = 1, natx
         iphat(iat) = -1
  100 continue

      nss = 0
      do 102  iss = 1, nssx
         indss(iss) = 0
         iphss(iss) = 0
         degss(iss) = 0
         rss(iss) = 0
  102 continue

      nph = 0
      do 110  iph = 0, nphx
         iatph(iph) = 0
         ifrph(iph) = -1
         xnatph(iph) = 0
         folp(iph) = 1
         novr(iph) = 0
         ionph(iph) = 0
         izph(iph) = 0
         potlbl(iph) = ' '
  110 continue

      nfr = 0
      do 120  ifr = 0, nfrx
         ion(ifr) = 0
         iz(ifr) = 0
  120 continue

c     Open feff.inp, the input file we're going to read
      open (unit=1, file=finp, status='old', iostat=ios)
      call chopen (ios, finp, 'rdinp')

c     tokens  0 if not a token
c             1 if ATOM (ATOMS)
c             2 if HOLE
c             3 if OVER (OVERLAP)
c             4 if CONT (CONTROL)
c             5 if EXCH (EXCHANGE)
c             6 if ION
c             7 if TITL (TITLE)
c             8 if FOLP
c             9 if RMAX
c            10 if DEBY (DEBYE)
c            11 if RMUL (RMULTIPLIER)
c            12 if SS
c            13 if PRIN (PRINT)
c            14 if POTE (POTENTIALS)
c            15 if NLEG
c            16 if REQU (REQUIRE), now dead
c            17 if KLIM (KLIMIT)
c            18 if CRIT (CRITERIA)
c            19 if NOGEOM
c            20 if CSIG
c            21 if IORDER
c            22 if PCRI (PCRITERIA)
c            23 if SIG2
c            24 if XANE (XANES), disabled for current release
c            25 if CORR (CORRECTIONS)
c            26 if AFOL (AFOLP)
c            27 if NEMA (NEMAX)
c            28 if INTCALC
c            29 if POLA (POLARIZATION)
c            30 if ELLI (ELLIPTICITY) 
c            31 if ISPO (ISPORB)
c            -1 if END  (end)
c     mode flag  0 ready to read a keyword card
c                1 reading atom positions
c                2 reading overlap instructions for unique pot
c                3 reading unique potential definitions

      mode = 0
 200  continue
         line   = ' '
         iret = iread(1, line)
cc         print*, ' line: ', iret, ': ', line(1:40)
         if (iret.eq. 0) goto  200
         if (iret.le.-1) line = 'END'
         call triml (line)
         if (iscomm(line))  goto 200
         nwords = nwordx
         call bwords (line, nwords, words)
         itok = itoken (words(1))

c        process the card using current mode
  210    continue

         if (mode .eq. 0)  then
            if (itok .eq. 1)  then
c              ATOM
c              Following lines are atom postions, one per line
               mode = 1
            elseif (itok .eq. 2)  then
c              HOLE     1  1.0
c                   holecode s02
               read(words(2),20,err=900)  ihole
               read(words(3),30,err=900)  s02
               mode = 0
            elseif (itok .eq. 3)  then
c              OVERLAP iph
c                  iph  n  r
               read(words(2),20,err=900)  iph
               call phstop(iph,line)
               mode = 2
            elseif (itok .eq. 4)  then
c              CONTROL  mphase, mpath, mfeff, mchi
c               0 - do not run modules, 1 - run module
               read(words(2),20,err=900)  mphase
               read(words(3),20,err=900)  mpath
               read(words(4),20,err=900)  mfeff
               read(words(5),20,err=900)  mchi
               mode = 0
            elseif (itok .eq. 5)  then
c              EXCHANGE  ixc  vr0  vi0
c              ixc=0  Hedin-Lunqvist + const real & imag part
c              ixc=1  Dirac-Hara + const real & imag part
c              ixc=2  ground state + const real & imag part
c              ixc=3  Dirac-Hara + HL imag part + const real & imag part
c              ixc=4  DH below rs0 + HL above rs0 + const real
c                     & imag part, form is
c                     EXCHANGE  4  vr0  vi0  rs0
c              vr0 is const imag part of potential
c              vi0 is const imag part of potential
c              Default is HL.
               read(words(2),20,err=900)  ixc
               read(words(3),30,err=900)  vr0
               read(words(4),30,err=900)  vi0
               if (ixc .eq. 4) read(words(5),30,err=900)  rs0
               if (ixc .ge. 3)  call warnex(1)
               mode = 0
            elseif (itok .eq. 6)  then
c              ION  iph ionph(iph)
               read(words(2),20,err=900)  iph
               call phstop(iph,line)
               read(words(3),20,err=900)  ionph(iph)
               mode = 0
            elseif (itok .eq. 7)  then
c              TITLE title...
               ntitle = ntitle + 1
               if (ntitle .le. ntitx)  then
                  title(ntitle) = line(6:)
                  call triml (title(ntitle))
               else
                  call echo ('Too many title lines, title ignored')
                  call echo( line(1:79))
               endif
               mode = 0
            elseif (itok .eq. 8)  then
c              FOLP iph folp (overlap factor, default 1)
               read(words(2),20,err=900)  iph
               call phstop(iph,line)
               read(words(3),30,err=900)  folp(iph)
               mode = 0
            elseif (itok .eq. 9)  then
c              RMAX  rmax (max r for ss and pathfinder)
               read(words(2),30,err=900)  rmax
               mode = 0
            elseif (itok .eq. 10)  then
c              DEBYE  temp debye-temp
c                   temps in kelvin
c                   if tk and thetad > 0, use these instead of sig2g
               read(words(2),30,err=900)  tk
               read(words(3),30,err=900)  thetad
               mode = 0
            elseif (itok .eq. 11)  then
c              RMULTIPLIER  rmult
c              Multiples atom coord, rss, overlap and rmax distances by
c              rmult (default 1).  DOES NOT modify sig2g
               read(words(2),30,err=900)  rmult
               mode = 0
            elseif (itok .eq. 12)  then
c              SS index ipot deg rss
               nss = nss + 1
               if (nss .gt. nssx)  then
                  write(messag,'(1x,a,i4)')
     $                 'Too many SS paths requested, max is ', nssx
                  call echo(messag)
                  call fstop(' at RDINP')
               endif
               read(words(2),20,err=900)  indss(nss)
               read(words(3),20,err=900)  iphss(nss)
               read(words(4),30,err=900)  degss(nss)
               read(words(5),30,err=900)  rss(nss)
               mode = 0
            elseif (itok .eq. 13)  then
c              PRINT  ipr1  ipr2  ipr3  ipr4
c              print flags for various modules
c              ipr1 potph  0 phase.bin only
c                          1 add misc.dat
c                          2 add pot.dat, phase.dat
c                          5 add atom.dat
c                          6 add central atom dirac stuff
c                          7 stop after doing central atom dirac stuff
c              ipr2 pathfinder  0 paths.dat only
c                               1 add crit.dat
c                               2 keep geom.dat
c                               3 add fbeta files
c                               5 special magic code, crit&geom only
c                                 not paths.dat.  Use for path studies
c              ipr3 genfmt 0 files.dat, feff.dats that pass 2/3 of
c                            curved wave importance ratio
c                          1 keep all feff.dats
c              ipr4 ff2chi 0 chi.dat
c                          1 add sig2.dat with debye waller factors
c                          2 add chipnnnn.dat for each path
               read(words(2),20,err=900)  ipr1
               read(words(3),20,err=900)  ipr2
               read(words(4),20,err=900)  ipr3
               read(words(5),20,err=900)  ipr4
               mode = 0
            elseif (itok .eq. 14)  then
c              POTENTIALS
c              Following lines are unique potential defs, 1 per line
               mode = 3
            elseif (itok .eq. 15)  then
c              NLEG nlegmax (for pathfinder)
               read(words(2),20,err=900)  nlegxx
               mode = 0
            elseif (itok .eq. 16)  then
c              REQUIRE rreq, ipot (for pathfinder, require than ms paths
c                            length >rreq contain atom ipot)
               call fstop('REQUIRE card not available')
            elseif (itok .eq. 17)  then
c              KLIMIT xkmin, xkmax
               call echo(' Warning: KLIMIT not available,'//
     $              ' run continues.')
               mode = 0
            elseif (itok .eq. 18)  then
c              CRIT critcw critpw
               read(words(2),30,err=900)  critcw
               read(words(3),30,err=900)  critpw
               mode = 0
            elseif (itok .eq. 19)  then
c              NOGEOM (do not write geom.dat)
               nogeom = .true.
               mode = 0
            elseif (itok .eq. 20)  then
c              CSIG (use complex momentum with debye waller factor)
c              note: this is always on anyway, so this card unnecessary
               icsig = 1
               mode = 0
            elseif (itok .eq. 21)  then
c              IORDER  iorder (used in genfmt, see setlam for meaning)
               read(words(2),20,err=900)  iorder
               call warnex(2)
               mode = 0
            elseif (itok .eq. 22)  then
c              PCRIT  pcritk pcrith
c                     (keep and heap criteria for pathfinder)
               read(words(2),30,err=900)  pcritk
               read(words(3),30,err=900)  pcrith
               mode = 0
            elseif (itok .eq. 23)  then
c              SIG2  sig2g   global sig2 written to files.dat
               read(words(2),30,err=900)  sig2g
               mode = 0
            elseif (itok .eq. 24)  then
c              XANES
c              Use extended k range for xanes
               ixanes = 1
c              to avoid problems with debye waller factors below the
c              edge, always use complex p for debye waller
               icsig = 1
               call fstop('XANES card not available')
            elseif (itok .eq. 25)  then
c              CORRECTIONS  e0-shift, lambda correction
c              e0 shift is in eV, edge will be edge-e0
c              lambda corr is a const imag energy in eV
c              e0 and lambda corr same as vr0 and vi0 in EXCH card
               read(words(2),30,err=900)  vrcorr
               read(words(3),30,err=900)  vicorr
               mode = 0
            elseif (itok .eq. 26)  then
c              AFOLP use generalized automatic folp
               iafolp = 1
               mode =0
            elseif (itok .eq. 27)  then
c              NEMAX  nemax for energy grid
               read(words(2),20,err=900)  nemax
               call warnex(3)
               if (nemax .gt. nex)  then
                  write(messag,'(1x,a,i5,a,i5)')
     $                 'nemax too big, resetting from ',
     $                 nemax, ' to ', nex
                  call echo(messag)
                  nemax = nex
               endif
               mode = 0
            elseif (itok .eq. 28)  then
c              INTCALC  intclc
c              0  use average over all atoms
c              1  use current experimental method 1
c              2  use current experimental method 2
c              read(words(2),20,err=900)  intclc
               call echo(' Warning: INTCALC not available,'//
     $              ' run continues.')            
               mode = 0
            elseif (itok .eq. 29)  then
c              POLARIZATION  X Y Z
               pola = .true.
c              run polarization code if 'pola' is true
c              run usual feff otherwise
               read(words(2),30,err=900)  evec(1)
               read(words(3),30,err=900)  evec(2)
               read(words(4),30,err=900)  evec(3)
               mode = 0
            elseif (itok .eq. 30)  then
c              ELLIPTICITY  E incident direction
               read(words(2),30,err=900)  elpty
               read(words(3),30,err=900)  ivec(1)
               read(words(4),30,err=900)  ivec(2)
               read(words(5),30,err=900)  ivec(3)
               mode = 0
            elseif (itok .eq. 31)  then
c              ISPORB  isporb
               read(words(2),20,err=900)  isporb
               write(messag,'(1x,a,i5)') ' isporb set ', isporb
               call echo(messag)
               mode = 0
            elseif (itok .eq. -1)  then
c              END
               goto 220
            else
               ilen = istrln(words(1))
               write(messag,'(1x,3a,i5)')'Unknown keyword: "',
     $              words(1)(:ilen),'" at line:'
               call echo(messag)
               ilen = istrln(line)
               call echo( '   '//line(:ilen) )
               call echo(' See FEFF document for valid keywords.')
               call fstop(' at RDINP.')
            endif
         elseif (mode .eq. 1)  then
            if (itok .ne. 0)  then
c              We're done reading atoms.
c              Change mode and process current card.
               mode = 0
               goto 210
            endif
            nat = nat+1
            if (nat .gt. natx)  then
               write(messag,'(1x,a,i5)')
     $              'Too many atoms in ATOMS list. Maximum is ', natx
               call fstop(messag)
            endif
            read(words(1),30,err=900)  rat(1,nat)
            read(words(2),30,err=900)  rat(2,nat)
            read(words(3),30,err=900)  rat(3,nat)
            read(words(4),20,err=900)  iphat(nat)
         elseif (mode .eq. 2)  then
            if (itok .ne. 0)  then
c              We're done reading these overlap instructions.
c              Change mode and process current card.
               mode = 0
               goto 210
            endif
            novr(iph) = novr(iph)+1
            iovr = novr(iph)
            if (iovr .gt. novrx)  then
               write(messag,'(1x,a,i5)')
     $              'Too many overlap shells, max is ', novrx
               call fstop(messag)
            endif
            read(words(1),20,err=900) iphovr(iovr,iph)
            read(words(2),20,err=900) nnovr(iovr,iph)
            read(words(3),30,err=900) rovr(iovr,iph)
         elseif (mode .eq. 3)  then
            if (itok .ne. 0)  then
c              We're done reading unique potential definitions
c              Change mode and process current card.
               mode = 0
               goto 210
            endif
            read(words(1),20,err=900)  iph
            if (iph .lt. 0  .or.  iph .gt. nphx)  then
               write(messag,'(1x,a,i3,a,i3)')
     $              'Unique potential ', iph,
     $              ' not allowed. Must be between 0 and ', nphx
               
               call echo(messag)
               call echo(line)
               call fstop('at RDINP')

            endif
            read(words(2),20,err=900)  izph(iph)
c           No potential label if user didn't give us one
c           Default set above is potlbl=' '
            if (nwords .ge. 3)  potlbl(iph) = words(3)
         else
            write(messag,'(1x,a,i4)') 'Unknown mode: ', mode
            call echo(messag)
            call fstop(' at RDINP')
         endif
      goto 200
  220 continue

c     We're done reading the input file, close it.
      close (unit=1)

c     Fix up defaults, error check limits, figure out free atoms, etc.

      if (pola) then
c        make polarization tensor
         call mkptz
      endif

c     Find out how many unique potentials we have
      nph = 0
      do 300  iph = nphx, 0, -1
         if (izph(iph) .gt. 0)  then
            nph = iph
            goto 301
         endif
  300 continue
  301 continue
c     Must have central atom
      if (izph(0) .le. 0)  then
         call fstop(' No absorbing atom (ipot=0) defined')
      endif

c     Then find model atoms for unique pots that have them
      do 330  iph = 0, nphx
c        Use first atom in atom list that is of unique pot iph
         do 320  iat = 1, nat
            if (iph .eq. iphat(iat))  then
               iatph(iph) = iat
               goto 321
            endif
  320    continue
  321    continue
  330 continue
c     if iatph > 0, a model atom has been found.

c     No gaps allowed in unique pots.  Make sure we have enough
c     to overlap all unique pots 0 to nph.
      do 340  iph = 0, nph
         if (iatph(iph) .le. 0  .and.  novr(iph) .le. 0)  then
c           No model atom, no overlap cards, can't do this unique pot
            write(messag,'(1x,a,i5)')
     $           ' No atoms or overlap cards for unique pot ', iph
            call echo(messag)
            call echo(' Cannot calculate potentials, etc.')
            call fstop(' at RDINP')
         endif
  340 continue

c     Need number of atoms of each unique pot, count them.  If none,
c     set to one.
      do 350  iph = 0, nph
         xnatph(iph) = 0
         do 346  iat = 1, nat
            if (iphat(iat) .eq. iph)  xnatph(iph) = xnatph(iph)+1
  346    continue
         if (xnatph(iph) .le. 0)  xnatph(iph) = 1
  350 continue

c     Do the free atom shuffling, do central atom as special case
      iz(0) = izph(0)
      ion(0) = ionph(0)
      ifrph(0) = 0
      nfr = 0
      do 390  iph = 1, nph
         ifrph(iph) = -1
         do 380  ifr = 1, nfr
            if (iz(ifr).eq.izph(iph) .and. ion(ifr).eq.ionph(iph)) then
               ifrph(iph) = ifr
               goto 381
            endif
  380    continue
  381    continue
c        add free atom type if necessary
         if (ifrph(iph) .lt. 0)  then
            nfr = nfr+1
            if (nfr .gt. nfrx)  then
               write(messag,'(1x,a,i5)')
     $              ' Too many free atoms, max is ', nfrx
               call echo(messag)
               call fstop(' at RDINP')
            endif
            ion(nfr) = ionph(iph)
            iz(nfr) = izph(iph)
            ifrph(iph) = nfr
         endif
  390 continue

c     Find central atom (only 1 permitted)
      iatabs = -1
      do 400  iat = 1, nat
         if (iphat(iat) .eq. 0)  then
            if (iatabs .lt. 0)  then
               iatabs = iat
            else
               call echo(' More than one absorbing atom (ipot=0)')
               call echo(' Only one absorbing atom allowed')
               call fstop(' at RDINP')
            endif
         endif
  400 continue

c     Find distance to nearest and most distant atom (use overlap card
c     if no atoms specified.)
      if (iatabs .lt. 0  .or.  nat .lt. 2)  then
         ratmin = rovr(1,0)
         ratmax = rovr(novr(0),0)
      else
         ratmax = 0
         ratmin = 1.0e10
         do 412  iat = 1, nat
c           skip absorbing atom
            if (iat .eq. iatabs)  goto 412
            tmp = dist (rat(1,iat), rat(1,iatabs))
            if (tmp .gt. ratmax)  ratmax = tmp
            if (tmp .lt. ratmin)  ratmin = tmp
  412    continue
      endif

c     Set rmax if necessary
      if (rmax.le.0 .and. nss.le.0)  then
c        set to min (2+ times ratmin, ratmax)
         rmax = min (2.001 * ratmin, ratmax)
      endif

c     Set core hole lifetime (central atom quantity)
      ifr = ifrph(0)
      call setgam (iz(ifr), ihole, gamach)
ccc      print*, ' RDINP SETGAM ', ifr, iz(ifr), ihole, gamach

c     Set s02 if necessary
      if (s02 .le. 1.0e-10)  s02 = 1

c     Convert everything to code units, and use rmult factor
c     rmax is for pathfinder, so leave it in Ang.
      rmax = rmax * rmult
      vr0 = vr0 / ryd
      vi0 = vi0 / ryd
      vrcorr = vrcorr / ryd
      vicorr = vicorr / ryd
      xkmin = xkmin * bohr
      xkmax = xkmax * bohr
      do 430  iat = 1, nat
         do 420  i = 1, 3
            rat(i,iat) = rat(i,iat) * rmult / bohr
  420    continue
  430 continue
      do 460  iph = 0, nph
         do 450  iovr = 1, novr(iph)
            rovr(iovr,iph) = rovr(iovr,iph) * rmult / bohr
  450    continue
  460 continue
      do 462  iss = 1, nss
c        rss used only to make paths.dat, so leave it in Angstroms.
         rss(iss) = rss(iss) * rmult
  462 continue

c     Check if 2 atoms are closer together than 1.75 ryd (~.93 Ang)
      ratmin = 1.0e20
      do 480  iat = 1, nat
         do 470  jat = iat+1, nat
            rtmp = dist(rat(1,iat),rat(1,jat))
            if (rtmp .lt. ratmin)  ratmin = rtmp
            if (rtmp .lt. 1.75)  then
c           if (dist(rat(1,iat),rat(1,jat)) .lt. 1.5)  then
               call echo(' WARNING:  TWO ATOMS VERY CLOSE TOGETHER.'//
     1                 '  CHECK INPUT.')
               write(messag,'(1x,a,2i5)') ' atoms ', iat, jat
               call echo (messag)
               write(messag,'(1x,i4,3f11.5)')  iat,
     $             rat(1,iat)*bohr, rat(2,iat)*bohr, rat(3,iat)*bohr
               call echo(messag)
               write(messag,'(1x,i4,3f11.5)')  jat,
     $             rat(1,jat)*bohr, rat(2,jat)*bohr, rat(3,jat)*bohr
               call echo(messag)
               call echo(' Run continues...')
            endif
  470    continue
  480 continue

c     default to k shell
      if (isporb .lt. 0)  isporb = 1

c     Clean up control flags
      if (mphase .ne. 0)  mphase = 1
      if (mpath  .ne. 0)  mpath = 1
      if (mfeff  .ne. 0)  mfeff = 1
      if (mchi   .ne. 0)  mchi = 1
      if (nss    .le. 0)  ms = 1

      if (ntitle .le. 0)  then
         ntitle = 1
         title(i) = 'No title input'
      endif
      do 490  i = 1, ntitle
         ltit(i) = istrln (title(i))
  490 continue

c     Write output files

c     For potph...
      if (mphase .eq. 1)  then
         open (unit=1, file='potph.dat', status='unknown', iostat=ios)
         call chopen (ios, 'potph.dat', 'rdinp')
         do 705  i = 1, ntitle
            write(1,700)  title(i)(1:ltit(i))
  700       format (1x, a)
  705    continue
         write(1,706)
  706    format (1x, 79('-'))
         write(1,709) ihole, gamach, ipr1, iafolp, intclc
  709    format(i5, 1p, e14.6, 3i4, 
     1         ' ihole, gamach, iprint, iafolp, intclc')
         write(1,702)  ixc, vr0, vi0, rs0
  702    format (i5, 1p, 3e14.6, ' ixc, vr0, vi0, rs0')
         write(1,701)  ixanes, nemax, xkmin, xkmax
  701    format (2i5, 1p, 2e14.6, 
     1           ' ixanes, nemax, xkmin, xkmax (inv bohr)')
         write(1,707) nfr, '  nfr'
  707    format (i5, a)
         do 710  ifr = 0, nfr
            write(1,708)  ifr, iz(ifr), ion(ifr)
  708       format (3i5, ' ifr, iz, ion')
  710    continue
         write(1,707) nat, '  nat.   iat, iph, x, y, z'
         do 720  iat = 1, nat
            write(1,715) iat, iphat(iat), (rat(j,iat),j=1,3)
  715       format (2i5, 3f12.6)
  720    continue
         write(1,707) nph, '  nph'
         do 740  iph = 0, nph
            write(1,722) iph, iatph(iph), ifrph(iph), xnatph(iph),
     1                   folp(iph), novr(iph),
     2                   ' iph, iat, ifr, xnat, folp, novr'
  722       format (3i5, 2f12.6, i5, a)
            write(1,723) potlbl(iph)
  723       format (' ''', a6, '''  potlbl')
            do 730  iovr = 1, novr(iph)
               write(1,724) iphovr(iovr,iph), nnovr(iovr,iph),
     1                      rovr(iovr,iph),
     2                      ' ovr...  iph, n, r'
  724       format (2i5, f12.6, a)
  730       continue
  740    continue
         close (unit=1)
      endif

c     Single scattering paths for genfmt
      if (nss .gt. 0  .and.  mpath .eq. 1)  then
         open (unit=1, file='paths.dat', status='unknown', iostat=ios)
         call chopen (ios, 'paths.dat', 'rdinp')
         do 750  i = 1, ntitle
            write(1,748)  title(i)(1:ltit(i))
  748       format (1x, a)
  750    continue
         write(1,751)
  751    format (' Single scattering paths from ss lines cards',
     1           ' in feff input')
         write(1,706)
         do 760  iss = 1, nss
            if (rmax.le.0  .or.  rss(iss).le.rmax)  then
c              NB, rmax and rss are in angstroms
               write(1,752) indss(iss), 2, degss(iss),
     2              rss(iss)
  752          format ( 2i4, f8.3,
     1             '  index,nleg,degeneracy,r=', f8.4)
               write(1,766)
  766          format (' single scattering')
               write(1,754) rss(iss)*bohr, zero, zero, iphss(iss),
     1                      potlbl(iphss(iss))
               write(1,753) zero, zero, zero, 0, potlbl(0)
  753          format (3f12.6, i4,  1x, '''', a6, '''', '  x,y,z,ipot')
  754          format (3f12.6, i4,  1x, '''', a6, '''')
            endif
  760    continue
         close (unit=1)
      endif

c     Atoms for the pathfinder
      if (nss.le.0  .and.  mpath.eq.1  .and.  nat.gt.0)  then
         if (iatabs .le. 0)  then
            call echo(' Absorbing atom coords not specified.')
            call echo(' Cannot find multiple scattering paths.')
            call fstop(' at RDINP')
         endif
c        if user doesn't want geom.dat, don't do it
         if (nogeom)  goto 792
         open (unit=1, file='geom.dat', status='unknown', iostat=ios)
         call chopen (ios, 'geom.dat', 'rdinp')
c        Echo title cards to geom.dat
         do 770  i = 1, ntitle
            write(1,700)  title(i)(1:ltit(i))
  770    continue
         write(1,706)
c        Central atom first
         ii = 0
         write(1,780)  ii, (rat(j,iatabs)*bohr,j=1,3), 0, 1
c        Rest of the atoms (skip central atom)
         do 790   iat = 1, nat
            if (iat .eq. iatabs)  goto 790
            ii = ii+1
            write(1,780)  ii, (rat(j,iat)*bohr,j=1,3), iphat(iat), 1
  780       format (i4, 3f12.6, 2i4)
  790    continue
         close (unit=1)
      endif
  792 continue

      return

  900 continue
       call echo(' Error reading input, bad line follows:')
       call echo(line)
       call fstop(' at RDINP')
       
      end

      function itoken (word)
c     chars in word assumed upper case, left justified
c     returns 0 if not a token, otherwise returns token

      character*(*) word
      character*4   w

      w = word(1:4)
      if     (w .eq. 'ATOM')  then
         itoken = 1
      elseif (w .eq. 'HOLE')  then
         itoken = 2
      elseif (w .eq. 'OVER')  then
         itoken = 3
      elseif (w .eq. 'CONT')  then
         itoken = 4
      elseif (w .eq. 'EXCH')  then
         itoken = 5
      elseif (w .eq. 'ION ')  then
         itoken = 6
      elseif (w .eq. 'TITL')  then
         itoken = 7
      elseif (w .eq. 'FOLP')  then
         itoken = 8
      elseif (w .eq. 'RMAX')  then
         itoken = 9
      elseif (w .eq. 'DEBY')  then
         itoken = 10
      elseif (w .eq. 'RMUL')  then
         itoken = 11
      elseif (w .eq. 'SS  ')  then
         itoken = 12
      elseif (w .eq. 'PRIN')  then
         itoken = 13
      elseif (w .eq. 'POTE')  then
         itoken = 14
      elseif (w .eq. 'NLEG')  then
         itoken = 15
      elseif (w .eq. 'REQU')  then
         itoken = 16
      elseif (w .eq. 'KLIM')  then
         itoken = 17
      elseif (w .eq. 'CRIT')  then
         itoken = 18
      elseif (w .eq. 'NOGE')  then
         itoken = 19
      elseif (w .eq. 'CSIG')  then
         itoken = 20
      elseif (w .eq. 'IORD')  then
         itoken = 21
      elseif (w .eq. 'PCRI')  then
         itoken = 22
      elseif (w .eq. 'SIG2')  then
         itoken = 23
      elseif (w .eq. 'XANE')  then
         itoken = 24
      elseif (w .eq. 'CORR')  then
         itoken = 25
      elseif (w .eq. 'AFOL')  then
         itoken = 26
      elseif (w .eq. 'NEMA')  then
         itoken = 27
      elseif (w .eq. 'INTC')  then
         itoken = 28
      elseif (w .eq. 'POLA')  then
         itoken = 29
      elseif (w .eq. 'ELLI')  then
         itoken = 30
      elseif (w .eq. 'ISPO')  then
         itoken = 31
      elseif (w .eq. 'END ')  then
         itoken = -1
      else
         itoken = 0
      endif
      return
      end
      logical function iscomm (line)
c     returns true if line is a comment or blank line, false otherwise
      character*(*) line, l1*1,com*3
       parameter(com = '*#;')
       iscomm = .false.
       l1 = line(1:1)
       if (istrln(line).le.0 .or. index(com,l1).ge.1)  iscomm = .true.
       return
      end
      subroutine phstop (iph,line)
      implicit double precision (a-h, o-z)
      character*(*) line, messag*128
      include 'dim.h'
      if (iph .lt. 0  .or.  iph .gt. nphx)  then
         write(messag, 10) iph, nphx, line
   10    format (' Unique potential index', i5, ' out of range.',/,
     1        ' Must be between 0 and', i5, '.  Input line:')
         call echo(messag)
         call echo(line)
         call fstop('at RDINP - PHSTOP')
      endif
      return
      end
      subroutine warnex (i)
      implicit double precision (a-h, o-z)
c     This prints a warning message if the user is using an
c     expert option.
c     i    expert option card
c     1    EXCHANGE with code >= 3
c     2    IORDER
c     3    XANES
c     4    NEMAX
c     5    INTCALC
c     message max of 22 characters to keep warning on 80 char line.
      if (i .eq. 1)  then
         call echo( 'Warning: EXCHANGE with IEXCH> >= 3')
      elseif (i .eq. 2)  then
         call echo( 'Warning: IORDER')
      elseif (i .eq. 3)  then
         call echo( 'Warning: NEMAX')
      endif
       call echo( ' is an "expert user option".')
       call echo( ' Please read documentation'//
     $      ' carefully and check your results:')

      return
      end

!

      double precision function exchee (d,dr)
      implicit double precision (a-h,o-z)
      save
c jm if density= 0,make exchange energy equal to zero
      if (d .eq. 0.0) then
      exchee=0.0
      else
      x=(3.0*dr**2/d)**.333333333333/30.0
      rx=1.0/x
      exchee=.02520*(x**3*log(1.0+rx)+x*.50-x**2-1.0/3.0-0.2020129
     1 2*rx)
      endif
      return
      end

      program makepotph

      implicit double precision (a-h, o-z)

c      include '../HEADERS/dim.h'
c      max number of unique potentials (potph) (nphx must be ODD to
c      avoid compilation warnings about alignment in COMMON blocks)
      integer nphx
      parameter (nphx = 11)
c      max number of atoms in problem for the pathfinder
      integer natx
      parameter (natx =1000)
c      max number of header lines
      integer nheadx
      parameter (nheadx=30)

      character*80 title(nheadx)
      integer ntitle, nat, nph, iphat(natx), ipol, ispin, ihole
      integer lfms1, nmix, icoul, ixc, ixc0, iafolp, iunf, inters
      integer jumprm, nohole, iplsmn
      integer iz(0:nphx), lmaxsc(0:nphx), lmaxph(0:nphx)
      double precision evec(3), xivec(3), spvec(3), spinph(0:nphx)
      complex*16 ptz(-1:1, -1:1)
      double precision rat(3,natx)
      double precision xnatph(0:nphx), folp(0:nphx), xion(0:nphx)
      character*6 potlbl(0:nphx)
      real rfms1
      double precision elpty, angks, gamach, ca1, ecv
      double precision vr0, vi0, rgrd, totvol


      call inipotph(
c     TITLE
     1       ntitle, title,
c     ATOMS
     2       nat, rat, iphat,
c     POTENTIALS
     3       nph, iz, potlbl, lmaxsc, lmaxph, xnatph, spinph,
c     HOLE/EDGE
     4       ihole,
c     SCF
     5       rfms1, lfms1, nscmt, ca1, nmix, ecv, icoul,
c     POLARIZATION, ELLIPTICITY
     6       ipol, evec, elpty, xivec,
c     SPIN
     7       ispin, spvec, angks,
c     computed
     8       ptz, gamach,
c     EXCHANGE
     9       ixc, vr0, vi0, ixc0,
c     AFOLP, FOLP, ION, RGRID, UNFREEZEF
     _       iafolp, folp, xion, rgrd, iunf,
c     INTERSTITIAL, JUMPRM, NOHOLE, PLASMON
     1       inters, totvol, jumprm, nohole, iplsmn)


c*****************************************************************************
c     read the contents of a json file that includes all of global.json,
c     atoms.json, pot.json & xpsh.json (i.e. global.dat, atoms.dat, mod1.inp,
c     and mod2.inp)
c*****************************************************************************
      call json_read_libpotph(
c     TITLE
     1       ntitle, title,
c     ATOMS
     2       nat, rat, iphat,
c     POTENTIALS
     3       nph, iz, potlbl, lmaxsc, lmaxph, xnatph, spinph,
c     HOLE/EDGE
     4       ihole,
c     SCF
     5       rfms1, lfms1, nscmt, ca1, nmix, ecv, icoul,
c     POLARIZATION, ELLIPTICITY
     6       ipol, evec, elpty, xivec,
c     SPIN
     7       ispin, spvec, angks,
c     computed
     8       ptz, gamach,
c     EXCHANGE
     9       ixc, vr0, vi0, ixc0,
c     AFOLP, FOLP, ION, RGRID, UNFREEZEF
     _       iafolp, folp, xion, rgrd, iunf,
c     INTERSTITIAL, JUMPRM, NOHOLE, PLASMON
     1       inters, totvol, jumprm, nohole, iplsmn)


      call libpotph('phase.pad', .true.,
c     TITLE
     1       ntitle, title,
c     ATOMS
     2       nat, rat, iphat,
c     POTENTIALS
     3       nph, iz, potlbl, lmaxsc, lmaxph, xnatph, spinph,
c     HOLE/EDGE
     4       ihole,
c     SCF
     5       rfms1, lfms1, nscmt, ca1, nmix, ecv, icoul,
c     POLARIZATION, ELLIPTICITY
     6       ipol, evec, elpty, xivec,
c     SPIN
     7       ispin, spvec, angks,
c     computed
     8       ptz, gamach,
c     EXCHANGE
     9       ixc, vr0, vi0, ixc0,
c     AFOLP, FOLP, ION, RGRID, UNFREEZEF
     _       iafolp, folp, xion, rgrd, iunf,
c     INTERSTITIAL, JUMPRM, NOHOLE
     1       inters, totvol, jumprm, nohole,
c     PLASMON
     2       iplsmn)
      

      stop
      end

      subroutine conv(omega,xsec,ne1,vicorr)
c     multiply xsec by theta(omega-efermi) and
c     convolute xsec(omega) with  xloss/((omega-omega0)**2+xloss**2)/pi
c     the result is xsec0(omega0)

      implicit double precision (a-h, o-z)
      include '../HEADERS/const.h'
      include '../HEADERS/dim.h'
      dimension  omega(nex)
      complex*16 xsec(nex), xsec0(nex), xsecdx

      complex*16 conv1
      external conv1

      do 100 ie = 1,ne1
         xsec0(ie) = 0.0d0
         omega0 = omega(ie)
c        Add one more point to correct for the finite grid
c        at large energies. Use linear interpolation.
         dx = max( omega(ne1) - omega(ne1-1), 50*vicorr)
         xlast = omega(ne1)+dx
         dx = dx / ( omega(ne1) - omega(ne1-1))
         xsecdx = xsec(ne1)+ (xsec(ne1)-xsec(ne1-1)) * dx

c        first interval
         do 50  i = 1, ne1-1
            xsec0(ie) = xsec0(ie) +
     1      conv1(omega(i),omega(i+1),xsec(i),xsec(i+1),omega0,vicorr)
  50     continue
c        last interval
         xsec0(ie) = xsec0(ie) +
     1   conv1(omega(ne1),xlast,xsec(ne1),xsecdx,omega0,vicorr)
         xsec0(ie) = xsec0(ie) /real(pi)
  100 continue
      do 200 ie = 1, ne1
  200 xsec(ie) = xsec0(ie)

      return
      end

      complex*16 function conv1(x1,x2,y1,y2,x0,xloss)
c     convolution of function 1/(omega-omega0-i*xloss)/pi
c     makes linear interpolation for function between x1,x2 and
c     takes advantage that the integral can be taken analytically.
      implicit double precision (a-h, o-z)
      complex*16  y1, y2, t, coni,dum, a, b
      parameter (coni = (0.d0,1.d0))

      d = (x2-x1) / 2.0
      a = dble(y2-y1) / 2.0
      b = dble(y2+y1) / 2.0
      t = d / ( (x1+x2)/2 - x0 - coni*xloss )
      if (abs(t) .ge. 0.1) then
         dum = 2.0*a + (b - a/t) * log((1+t)/(1-t))
      else
         dum = 2.0*b*(t+t**3 / 3.0) - 2.0/3.0 * a*t**2
      endif
      conv1 = dimag (dum)

      d = (x2-x1) / 2.0
      a = dimag(y2-y1) / 2.0
      b = dimag(y2+y1) / 2.0
      t = d / ( (x1+x2)/2 - x0 - coni*xloss )
      if (abs(t) .ge. 0.1) then
         dum = 2.0*a + (b - a/t) * log((1+t)/(1-t))
      else
         dum = 2.0*b*(t+t**3 / 3.0) - 2.0/3.0 * a*t**2
      endif
      conv1 = conv1 + coni* dimag( dum)

      return
      end

c
c  this holds simple replacements for ifeffit routines
c  to be used by the 'libxafs' routines
c  
c  included in this file are:
c      sca_init  setsca  getsca
c
c  IMPORTANT:  DO NOT link into libifeffit.a!!!
c
c//////////////////////////////////////////////////////////////////////
c Copyright (c) 1997--2000 Matthew Newville, The University of Chicago
c Copyright (c) 1992--1996 Matthew Newville, University of Washington
c
c Permission to use and redistribute the source code or binary forms of
c this software and its documentation, with or without modification is
c hereby granted provided that the above notice of copyright, these
c terms of use, and the disclaimer of warranty below appear in the
c source code and documentation, and that none of the names of The
c University of Chicago, The University of Washington, or the authors
c appear in advertising or endorsement of works derived from this
c software without specific prior written permission from all parties.
c
c THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
c EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
c MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
c IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
c CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
c TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
c SOFTWARE OR THE USE OR OTHER DEALINGS IN THIS SOFTWARE.
c//////////////////////////////////////////////////////////////////////
c
       subroutine sca_init
       implicit none
       include 'compat.h'
       integer i
       do 10 i = 1, mxsca
          sscanam(i) = ''
          sscaval(i) = 0.d0
 10    continue 
       end

       subroutine setsca(str,x)
       implicit none
       character*(*) str
       double precision x
       integer i, ilen, istrln
       include 'compat.h'
       external istrln

       snamtmp = str
       call triml(snamtmp)
       call lower(snamtmp)
       ilen  = istrln(snamtmp)
       do 10 i = 1, mxsca
          if ((snamtmp(1:ilen) .eq. sscanam(i)(1:ilen)) .or.
     $         ('' .eq. sscanam(i)(1:ilen))) go to 20
 10    continue 
       call warn(3,"error: setsca out of memory")
       return
 20    continue
       sscanam(i) = snamtmp(1:ilen)
       sscaval(i) = x
       return
       end

       double precision function getsca(str,iwarn)
       implicit none
       character*(*) str
       integer i, ilen, istrln, iwarn

       include 'compat.h'
       external istrln

       getsca = 0.d0
       snamtmp = str
       call triml(snamtmp)
       call lower(snamtmp)
       ilen  = istrln(snamtmp)
       do 10 i = 1, mxsca
          if (snamtmp(1:ilen) .eq. sscanam(i)(1:ilen))
     $         getsca = sscaval(i)
 10    continue 
       return
       end

      subroutine yzkteg (f,af,g,ag,dr,ap,h,k,nd,np,idim)
c calculation of yk(r)=zk(r)+ r**(k+1) * integral from r to 
c   infinity of  f(u) * u**(-k-1)
c zk(r) = r**(-k) * integral from 0 to r of f(u) * u**k

c at the origin f(r)=sum from i=1 to nd of af(i)*r**(ap+i-1)
c dr tabulation points   h exponential step
c np number of tabulation points for f
c idim dimension of the blocks f,g and dr

c at the origin yk=cte*r**(k+1)-developement limit
c the constant for yk lies in ap
c output functions yk and zk lie in f and g, and their
c development coefficients at the origin in af and ag.

c integration from point to point by a 4 points method.
c integral from r to r+h = h*(-f(r-h)+13*f(r)+13*f(r+h)-f(r+h+h))/24

      implicit double precision (a-h,o-z)
      dimension f(251),af(10),g(251),ag(10),dr(251)
 
c    initialisation and development coefficients of yk
      np= min(np,idim-2)
      b=ap
      ap=0.0d 00
      g(1)=0.0d 00
      g(2)=0.0d 00
      do 15 i=1,nd
         b=b+1.0d 00
         ag(i)=af(i)/(b+k)
         if (af(i).ne.0.0d 00) then
            c=dr(1)**b
            g(1)=g(1)+ag(i)*c
            g(2)=g(2)+ag(i)*(dr(2)**b)
            af(i)=(k+k+1)*ag(i)/(b-k-1)
            ap=ap+af(i)*c
         endif
 15   continue
      do 21 i=1,np
 21   f(i)=f(i)*dr(i)
      np1=np+1
      f(np1)=0.0d 00
      f(np1+1)=0.0d 00

c     calcualation of zk
      eh= exp(h)
      e=eh**(-k)
      b=h/2.4d+01
      c=1.3d+01*b
      ee=e*e*b
      b=b/e
      do 51 i=3,np1
 51   g(i)=g(i-1)*e+(c*(f(i)+f(i-1)*e)-(f(i-2)*ee+f(i+1)*b))
 
c     calcualation of yk
      f(np)=g(np)
      do 61 i=np1,idim
 61   f(i)=f(i-1)*e
      i=k+k+1
      b=i*b*eh
      ee=i*ee/(eh*eh)
      e=e/eh
      c=i*c
      do 71  i=np-1,2,-1
 71   f(i)=f(i+1)*e+(c*(g(i)+g(i+1)*e)-(g(i+2)*ee+g(i-1)*b))
      ee=e*e
      c=8.0d 00*c/1.3d+01
      f(1)=f(3)*ee+c*(g(3)*ee+4.0d 00*e*g(2)+g(1))
      ap=(ap+f(1))/(dr(1)**(k+1))
      return
      end

c     make e mesh for phase
c     input:  iprint, ispec, edge, vi0, gamach, xkmax, xkstep
c     output: ne, ne1, em(ne), ik0 [grid point with k=0]
c             ne -  total number of points in array em
c             ne1 - number of points on horizontal grid 

      subroutine phmesh (iprint, ispec, edge, emu, vi0, gamach,
     1                  xkmax, xkstep, vixan, ne, ne1, em, ik0, ne3)
      implicit double precision (a-h, o-z)
      include '../HEADERS/const.h'
      include '../HEADERS/dim.h'
      complex*16 em(nex), tempc

c     see arrays.h
c#mn
      external getxk

c     nemax - max number of points on horizontal axis
      xloss = gamach/2 + vi0
      if (xloss.lt.0) xloss = 0
      xvert = max(xloss, 0.02/hart)
      xloss = xvert
      aa = 0.5d0
      ne3 = 0
      xim = xloss*aa
      if (vixan.gt.0.0001) xim = vixan
      ik0 = 0

      if (ispec.le.3)  then
c        make energy mesh for XANES with FMS
c        around fermi level step is regular in energy (xloss/2)
c        and regular in k at high energies

c        10 points below Fermi level
         nemax = 10
c        dk = 0.14*bohr
         dk = 2*xkstep
         n1 = int (xim/2/dk**2)         
         n2 = int ( sqrt(n1*2*xim) / dk )
         if ( (dk*(n2+1))**2 .gt. (n1+1)*2*xim ) n1 = n1+1
         n1 = min (n1,nemax)
         do 10 i = 1, n1
  10     em(nemax+1-i) = -xim*i + edge + coni*xloss
         nb = nemax-n1
         do 20 i = 1, nb
  20     em(nb + 1 -i) = -(dk*(n2+i))**2/2 + edge + coni*xloss
         nmin = nemax
         ik0 = nemax+1
      endif

      if (ispec .gt. 0 .and. ispec.le.3)  then
c        make energy mesh for XANES with FMS
c        around fermi level step is regular in energy (xloss/2)
c        and regular in k at high energies
c        90 points above Fermi level
         nemax = 100 - nemax 
         n1 = int (xim/2/xkstep**2)
         n2 = int ( sqrt(n1*2*xim) / xkstep )
         n1 = n1 + 1
         if ( (xkstep*(n2+1))**2 .gt. n1*2*xim ) n1 = n1+1
         n1 = min (n1,nemax)
         if (ispec.ne.2) then
            nb = int (xkmax**2 /xim/2) + 1
         else
            nb = int (abs(edge - xkmax/bohr/hart) /xim) + 1
         endif
         if (nb .le. n1) n1 = nb
         do 30 i = 1, n1
  30     em(nmin+i) = xim*(i-1)
         if (ispec.ne.2) then
            nb = int( xkmax / xkstep)  - n2
         else
            nb = int( sqrt(abs(2*(edge-xkmax/bohr/hart))) / xkstep) - n2
         endif
         nb = min(nb, nemax-n1)
         nb = max(nb,0)
         do 40 i = 1, nb
  40     em(nmin+n1+i) = (xkstep*(n2+i))**2 /2
         ne1 = nmin+n1+nb
         do 50 i = ik0, ne1
  50     em(i) = em(i) + edge + coni*xloss

      elseif (ispec.eq.4) then
c        grid for atomic f' calculation regular in energy
         nemax = 100
         emin = xkmax / bohr /hart
         emax = xkstep / bohr / hart
         ne = 1
         emin = emin - emu + edge
         emax  = emax - emu + edge
         em(1) = emin
         if (emin .lt. emax) then
            if (vixan.le.0.d0) vixan = (emax-emin) / (nemax-1)

  85        ne = ne + 1
            em(ne) = em(ne-1) + vixan
            if ( ne.lt.nemax .and. dble(em(ne)).lt.emax) goto 85
         endif

         ne1 = ne
         nemax = nex-ne
         if (nemax.gt.100) nemax=100
         de = 3.d0 /hart
         elimit = min (2.0d5/hart, 20*emu)
         elimit = max (elimit, 1.0d3/hart)
         elimit = elimit - emu

         ne2 = 0
         ne3 = nemax
         ne = ne1+ne2+ne3
         em(ne1+1) = edge
         do 88 i = 1,ne3-1
            dep = 0
            if (dble(em(ne1+i)).gt.0) 
     1             dep=dble(em(ne1+i) * 
     2             (exp( log( elimit/em(ne1+i) ) / (ne3-i) ) -1))
            if (dep.lt.de) dep = de
            em(ne1+i+1) = em(ne1+i) + dep
  88     continue
      else
c        energy mesh for EXAFS or XANES without FMS
c        20 pts (0 le k le 1.9, delk=0.1 ang(-1) )
c        20 pts (2 le k le 5.8, delk=0.2 ang(-1) )
c         9 pts (6 le k le 10., delk=0.5 ang(-1) )
c        10 pts (11 le k le 20.0, delk=1.0 ang(-1) )
         ne = 0
         if (ispec.lt.0) ne = 10
         nemax = 100
         delk = bohr/10
         do 111 i=1,20
            tempk=(i-1)*delk
            ne = ne+1
            em(ne)=tempk**2/2 +edge + coni*xloss
            if (i.eq.1)  ik0 = ne
  111    continue
         delk = bohr/5
         n2 = 20
         do 112 i=1,n2
            tempk=2*bohr + (i-1)*delk
            ne = ne+1
            em(ne)=tempk**2/2 +edge + coni*xloss
  112    continue
         delk = bohr/2
         do 113 i=1,9
            tempk=6*bohr + (i-1)*delk
            ne = ne+1
            em(ne)=tempk**2/2 +edge + coni*xloss
  113    continue
         delk=bohr
         do 114 i=1,10
            tempk=11*bohr + (i-1)*delk
            ne = ne+1
            em(ne)=tempk**2/2 +edge + coni*xloss
  114    continue

c        while loop
  115    if (tempk. lt.xkmax) then
            tempk = tempk + delk
            ne = ne+1
            em(ne)=tempk**2/2 +edge + coni*xloss
            goto 115
         endif

         ne = min (ne, nemax)
         ne1 = ne
      endif

      if (ispec.le.3)  then
c        make the vertical grid in energy plane
c        first point is at 0.005 ev, second at 0.01 ev and
c        exponential grid with step 0.4 after that up to 50 eV
         tempk = 0.005d0/hart
         em(ne1+1) = edge + coni*tempk
         tempk = tempk*2
         em(ne1+2) = edge + coni*tempk
c        chose delk that point edge+coni*xloss is in the middle of step
c        delk = 0.6 is ok for Cu K edge, but needs more testing
         delk = 0.4d0
         n1 = nint ( log(xloss/tempk)/delk - 0.5d0)
         if (n1.le.0) n1 = 1
         bb = exp(delk)
         aa = 2*xloss /(1+bb)
         aa = aa/bb**n1
         if (aa.le. tempk) aa = aa*bb
cJosh         if (aa.le.tempk .or. aa.ge. xloss) 
cJosh     .     call par_stop(' Bad mesh in phmesh')
c        delk = log (xloss/tempk) /(n1+0.5)
c        n1 = nint( log(1000/hart/tempk) / delk )
c        n1 = nint( log(50/hart/aa) / delk )
         ee = min(50.d0/hart,20.d0*xloss)
c         print*, ee, aa, xloss, n1
         n1 = nint( log(ee/aa) / delk )
         do 60 i = 0, n1
  60     em(ne1+3+i) = edge +coni*aa*exp(delk*i)
         ne = ne1 + n1 + 3

c        for DANES need additional points
         if (abs(ispec).eq.3) then
            ne3 = min(nex,150) - ne
            em(ne+1) = dble(2*em(ne1)-em(ne1-1))
            dk = log(7.d4/dble(em(ne+1))) / (ne3-1)
            dk = exp(dk)
            do 80 i = 1, ne3-1
  80        em(ne+i+1)= em(ne+i)*dk
            do 90 i = 1, ne3
  90        em(ne+i)= em(ne+i)+coni*1.d-8
            ne = ne + ne3
            
         endif
      endif

c     need to reverse order for horizontal grid for XES
      if (ispec.eq.2) then
         do 150 ie = 1, ne1
  150    em(ie) = 2*(edge + coni*xloss) - em(ie)
         np = ne1 / 2
         do 160 ie=1,np
            ip = ne1+1-ie
            tempc = em(ie)
            em(ie) = em(ip)
            em(ip) = tempc
  160    continue
         ik0 = ne1+1-ik0
      endif

      if (iprint .ge. 3)  then
         open (unit=44, file='emesh.dat', status='unknown')
         write(44,*) 'edge, bohr, edge*hart ', edge, bohr, edge*hart
         write(44,*) 'ispec, ik0 ', ispec, ik0
         write(44,*) 'ie, em(ie)*hart, xk(ie)'
         do 230  ie = 1, ne
           write(44,220) ie, dble(em(ie))*hart,
     1                   getxk(dble(em(ie))-edge)/bohr
  220      format (i5, 3f20.5)
  230    continue
         close (unit=44)
      endif

      return
      end

      subroutine wrtjsn (nabs)
c     writes data stored in common blocks of allinp.h to 
c     all necessary input files for other modules.
c     version 1.0 written by Alexei Ankudinov, March 2001

c     Note: to add input variable one has to add it to the 
c        appropriate common block in allinp.h, properly initialize
c        it in subroutine iniall and modify subroutine wrtall
c        to write it to the appropriate input file.
c        (i.e. one has to make modifications in 3 places)

      use json_module

      integer ntoss
      ntoss = nabs

!     initialize the module:
c      call json_initialize()

      call json_initialize()
      call json_mod1()
      call json_mod2()
c      call json_mod3()
      call json_mod4()
      call json_mod5()
      call json_mod6()

c      call json_s02()
      call json_atoms()
      call json_global(nabs)

      call json_libpotph()

      return
      end


c$$$ template for a json export

c$$$      subroutine json_modN
c$$$
c$$$      use json_module
c$$$
c$$$      implicit double precision (a-h, o-z)
c$$$      include '../HEADERS/dim.h'
c$$$      include '../HEADERS/parallel.h'
c$$$      include '../RDINP/allinp.h'
c$$$
c$$$      integer  iunit
c$$$      type(json_value),pointer :: mN
c$$$
c$$$
c$$$      ! root
c$$$      call json_value_create(mN)      ! create the value and associate the pointer
c$$$      call to_object(mN,'modN.json')  ! add the file name as the name of the overall structure
c$$$
c$$$      
c$$$      call json_value_add(mN, 'somevariable', somevariable)
c$$$      
c$$$      open(newunit=iunit, file='modN.json', status='REPLACE')
c$$$      call json_print(mN,iunit)
c$$$      close(iunit)
c$$$
c$$$!     cleanup:
c$$$      call json_destroy(mN)
c$$$
c$$$
c$$$      return
c$$$      end




      subroutine json_mod1

      use json_module

      implicit double precision (a-h, o-z)
      include '../HEADERS/vers.h'
      include '../HEADERS/dim.h'
      include '../HEADERS/parallel.h'
      include '../RDINP/allinp.h'

      integer  iunit
      type(json_value),pointer :: m1
      character*7 vname
      integer itoss(novrx)
      double precision rtoss(novrx)

c     root
      call json_value_create(m1)      ! create the value and associate the pointer
      call to_object(m1,'pot.json')  ! add the file name as the name of the overall structure
      
      call json_value_add(m1, 'mod',    1)
      call json_value_add(m1, 'vfeff',  vfeff)
      call json_value_add(m1, 'vf85e',  vf85e)

      call json_value_add(m1, 'mpot',   mpot)
      call json_value_add(m1, 'nph',    nph)
      call json_value_add(m1, 'ntitle', ntitle)
      call json_value_add(m1, 'ihole',  ihole)
      call json_value_add(m1, 'ipr1',   ipr1)
      call json_value_add(m1, 'iafolp', iafolp)
      call json_value_add(m1, 'ixc',    ixc)
      call json_value_add(m1, 'ispec',  ispec)

      call json_value_add(m1, 'nmix',   nmix)
      call json_value_add(m1, 'nohole', nohole)
      call json_value_add(m1, 'jumprm', jumprm)
      call json_value_add(m1, 'inters', inters)
      call json_value_add(m1, 'nscmt',  nscmt)
      call json_value_add(m1, 'icoul',  icoul)
      call json_value_add(m1, 'lfms1',  lfms1)
      call json_value_add(m1, 'iunf',   iunf)

      call json_value_add(m1, 'gamach', gamach)
      call json_value_add(m1, 'rgrd',   rgrd)
      call json_value_add(m1, 'ca1',    ca1)
      call json_value_add(m1, 'ecv',    ecv)
      call json_value_add(m1, 'totvol', totvol)
      call json_value_add(m1, 'rfms1',  dble(rfms1))

      call json_value_add(m1, 'titles', title)

      call json_value_add(m1, 'iz',     iz)
      call json_value_add(m1, 'lmaxsc', lmaxsc)
      call json_value_add(m1, 'xnatph', xnatph)
      call json_value_add(m1, 'xion',   xion)
      call json_value_add(m1, 'folp',   folp)
      call json_value_add(m1, 'novr',   novr)

c     the following disentangles the 2D arrays used for overlap into
c     arrays that can be stored as json arrays, see POT/reapot.f line
c     188 and following for how this gets reconstructed into a 2D array
      do 10 iph = 0, nph
         write (vname, "(A6,I1)") "iphovr", iph
         do 20 iovr = 1, novrx
            itoss(iovr) = iphovr(iovr, iph)
 20      continue
         call json_value_add(m1, vname, itoss)

         write (vname, "(A5,I1)") "nnovr", iph
         do 30 iovr = 1, novrx
            itoss(iovr) = nnovr(iovr, iph)
 30      continue
         call json_value_add(m1, vname, itoss)

         write (vname, "(A4,I1)") "rovr", iph
         do 40 iovr = 1, novrx
            rtoss(iovr) = rovr(iovr, iph)
 40      continue
         call json_value_add(m1, vname, rtoss)
 10   continue

      open(newunit=iunit, file='pot.json', status='REPLACE')
      call json_print(m1,iunit)
      close(iunit)

!     cleanup:
      call json_destroy(m1)


      return
      end




      subroutine json_mod2

      use json_module

      implicit double precision (a-h, o-z)
      include '../HEADERS/vers.h'
      include '../HEADERS/dim.h'
      include '../HEADERS/parallel.h'
      include '../RDINP/allinp.h'

      integer  iunit
      type(json_value),pointer :: m2


      ! root
      call json_value_create(m2)      ! create the value and associate the pointer
      call to_object(m2,'xsph.json')  ! add the file name as the name of the overall structure

      call json_value_add(m2, 'mod',      2)
      call json_value_add(m2, 'vfeff',    vfeff)
      call json_value_add(m2, 'vf85e',    vf85e)

      call json_value_add(m2, 'mphase',   mphase)
      call json_value_add(m2, 'ipr2',     ipr2)
      call json_value_add(m2, 'ixc',      ixc)
      call json_value_add(m2, 'ixc0',     ixc0)
      call json_value_add(m2, 'ispec',    ispec)
      call json_value_add(m2, 'lreal',    lreal)
      call json_value_add(m2, 'lfms2',    lfms2)
      call json_value_add(m2, 'nph',      nph)
      call json_value_add(m2, 'l2lp',     l2lp)
      call json_value_add(m2, 'iPlsmn',   iPlsmn)
      call json_value_add(m2, 'iGrid',    iGrid)

      call json_value_add(m2, 'vro',      vr0)
      call json_value_add(m2, 'vio',      vi0)

      call json_value_add(m2, 'rgrd',     rgrd)
      call json_value_add(m2, 'rfms2',    rfms2)
      call json_value_add(m2, 'gamach',   gamach)
      call json_value_add(m2, 'xkstep',   xkstep)
      call json_value_add(m2, 'xkmax',    xkmax)
      call json_value_add(m2, 'vixan',    vixan)
      call json_value_add(m2, 'izstd',    izstd)
      call json_value_add(m2, 'ifxc',     ifxc)
      call json_value_add(m2, 'ipmbse',   ipmbse)
      call json_value_add(m2, 'itdlda',   itdlda)
      call json_value_add(m2, 'nonlocal', nonlocal)
      call json_value_add(m2, 'ibasis',   ibasis)

      call json_value_add(m2, 'lmaxph', lmaxph)
      call json_value_add(m2, 'potlbl', potlbl)
      call json_value_add(m2, 'spinph', spinph)



      open(newunit=iunit, file='xsph.json', status='REPLACE')
      call json_print(m2,iunit)
      close(iunit)

!     cleanup:
      call json_destroy(m2)


      return
      end



      subroutine json_mod3

      use json_module

      implicit double precision (a-h, o-z)
      include '../HEADERS/vers.h'
      include '../HEADERS/dim.h'
      include '../HEADERS/parallel.h'
      include '../RDINP/allinp.h'

      integer  iunit
      type(json_value),pointer :: m3


      ! root
      call json_value_create(m3)      ! create the value and associate the pointer
      call to_object(m3,'fms.json')  ! add the file name as the name of the overall structure

      call json_value_add(m3, 'mod',    3)
      call json_value_add(m3, 'vfeff',  vfeff)
      call json_value_add(m3, 'vf85e',  vf85e)

      call json_value_add(m3, 'mfms',   mfms)
      call json_value_add(m3, 'idwopt', idwopt)
      call json_value_add(m3, 'minv',   minv)
      call json_value_add(m3, 'rfms2',  rfms2)
      call json_value_add(m3, 'rdirec', dble(rdirec))
      call json_value_add(m3, 'toler1', dble(toler1))
      call json_value_add(m3, 'toler2', dble(toler2))
      call json_value_add(m3, 'tk',     tk)
      call json_value_add(m3, 'thetad', thetad)
      call json_value_add(m3, 'sig2g',  sig2g)


      call json_value_add(m3, 'lmaxph', lmaxph)

      
      open(newunit=iunit, file='fms.json', status='REPLACE')
      call json_print(m3,iunit)
      close(iunit)

!     cleanup:
      call json_destroy(m3)


      return
      end




      subroutine json_mod4

      use json_module

      implicit double precision (a-h, o-z)
      include '../HEADERS/vers.h'
      include '../HEADERS/dim.h'
      include '../HEADERS/parallel.h'
      include '../RDINP/allinp.h'

      integer  iunit
      type(json_value),pointer :: m4


      ! root
      call json_value_create(m4)      ! create the value and associate the pointer
      call to_object(m4,'path.json')  ! add the file name as the name of the overall structure

      call json_value_add(m4, 'mod',    4)
      call json_value_add(m4, 'vfeff',  vfeff)
      call json_value_add(m4, 'vf85e',  vf85e)

      call json_value_add(m4, 'mpath',  mpath)
      call json_value_add(m4, 'ms',     ms)
      call json_value_add(m4, 'nncrit', nncrit)
      call json_value_add(m4, 'nlegxx', nlegxx)
      call json_value_add(m4, 'ipr4',   ipr4)
      call json_value_add(m4, 'critpw', dble(critpw))
      call json_value_add(m4, 'pcritk', dble(pcritk))
      call json_value_add(m4, 'pcrith', dble(pcrith))
      call json_value_add(m4, 'rmax',   dble(rmax))
      call json_value_add(m4, 'rfms2',  dble(rfms2))
      
      open(newunit=iunit, file='path.json', status='REPLACE')
      call json_print(m4,iunit)
      close(iunit)

!     cleanup:
      call json_destroy(m4)


      return
      end



      subroutine json_mod5

      use json_module

      implicit double precision (a-h, o-z)
      include '../HEADERS/vers.h'
      include '../HEADERS/dim.h'
      include '../HEADERS/parallel.h'
      include '../RDINP/allinp.h'

      integer  iunit
      type(json_value),pointer :: m5


      ! root
      call json_value_create(m5)      ! create the value and associate the pointer
      call to_object(m5,'genfmt.json')  ! add the file name as the name of the overall structure

      call json_value_add(m5, 'mod',    5)
      call json_value_add(m5, 'vfeff',  vfeff)
      call json_value_add(m5, 'vf85e',  vf85e)
      
      call json_value_add(m5, 'mfeff',  mfeff)
      call json_value_add(m5, 'ipr5',   ipr5)
      call json_value_add(m5, 'iorder', iorder)
      call json_value_add(m5, 'critcw', dble(critcw))
      call json_value_add(m5, 'wnstar', wnstar)
     
      open(newunit=iunit, file='genfmt.json', status='REPLACE')
      call json_print(m5,iunit)
      close(iunit)

!     cleanup:
      call json_destroy(m5)


      return
      end





      subroutine json_mod6

      use json_module

      implicit double precision (a-h, o-z)
      include '../HEADERS/vers.h'
      include '../HEADERS/dim.h'
      include '../HEADERS/parallel.h'
      include '../RDINP/allinp.h'

      integer  iunit
      type(json_value),pointer :: m6


      ! root
      call json_value_create(m6)      ! create the value and associate the pointer
      call to_object(m6,'ff2x.json')  ! add the file name as the name of the overall structure

      call json_value_add(m6, 'mod',    6)
      call json_value_add(m6, 'vfeff',  vfeff)
      call json_value_add(m6, 'vf85e',  vf85e)
      
      call json_value_add(m6, 'mchi',   mchi)
      call json_value_add(m6, 'ispec',  ispec)
      call json_value_add(m6, 'idwopt', idwopt)
      call json_value_add(m6, 'ipr6',   ipr6)
      call json_value_add(m6, 'mbconv', mbconv)
      call json_value_add(m6, 'absolu', absolu)
      call json_value_add(m6, 'vrcorr', vrcorr)
      call json_value_add(m6, 'vicorr', vicorr)
      call json_value_add(m6, 's02',    s02)
      call json_value_add(m6, 'critcw', critcw)
      call json_value_add(m6, 'tk',     tk)
      call json_value_add(m6, 'thetad', thetad)
      call json_value_add(m6, 'alphat', alphat)
      call json_value_add(m6, 'thetae', thetae)
      call json_value_add(m6, 'sig2g',  sig2g)

      open(newunit=iunit, file='ff2x.json', status='REPLACE')
      call json_print(m6,iunit)
      close(iunit)

!     cleanup:
      call json_destroy(m6)


      return
      end






      subroutine json_s02

      use json_module

      implicit double precision (a-h, o-z)
      include '../HEADERS/vers.h'
      include '../HEADERS/dim.h'
      include '../HEADERS/parallel.h'
      include '../RDINP/allinp.h'

      integer  iunit
      type(json_value),pointer :: so2


      ! root
      call json_value_create(so2)      ! create the value and associate the pointer
      call to_object(so2,'s02.json')  ! add the file name as the name of the overall structure

      call json_value_add(so2, 'vfeff',  vfeff)
      call json_value_add(so2, 'vf85e',  vf85e)

      call json_value_add(so2, 'mso2conv', mso2conv)
      call json_value_add(so2, 'ipse',     ipse)
      call json_value_add(so2, 'ipsk',     ipsk)
      call json_value_add(so2, 'wsigk',    wsigk)
      call json_value_add(so2, 'cen',      cen)
      call json_value_add(so2, 'ispec',    ispec)
      call json_value_add(so2, 'ipr6',     ipr6)
      call json_value_add(so2, 'cfname',   cfname)

      
      open(newunit=iunit, file='s02.json', status='REPLACE')
      call json_print(so2,iunit)
      close(iunit)

!     cleanup:
      call json_destroy(so2)


      return
      end



      subroutine json_atoms

      use json_module

      implicit double precision (a-h, o-z)
      include '../HEADERS/vers.h'
      include '../HEADERS/dim.h'
      include '../HEADERS/parallel.h'
      include '../RDINP/allinp.h'
      double precision xx(nattx), yy(nattx), zz(nattx)

      integer  iunit
      type(json_value),pointer :: atoms


      ! root
      call json_value_create(atoms)      ! create the value and associate the pointer
      call to_object(atoms,'atoms.json')  ! add the file name as the name of the overall structure

      call json_value_add(atoms, 'vfeff',  vfeff)
      call json_value_add(atoms, 'vf85e',  vf85e)
      
      call json_value_add(atoms, 'natt', natt)
      do 10 i=1,natt
         xx(i) = ratx(1,i)
         yy(i) = ratx(2,i)
         zz(i) = ratx(3,i)
 10   continue
      call json_value_add(atoms, 'x', xx(1:natt))
      call json_value_add(atoms, 'y', yy(1:natt))
      call json_value_add(atoms, 'z', zz(1:natt))
      call json_value_add(atoms, 'iphatx', iphatx(1:natt))

      
      open(newunit=iunit, file='atoms.json', status='REPLACE')
      call json_print(atoms,iunit)
      close(iunit)

!     cleanup:
      call json_destroy(atoms)


      return
      end




      subroutine json_global(nabs)

      use json_module

      implicit double precision (a-h, o-z)
      include '../HEADERS/vers.h'
      include '../HEADERS/dim.h'
      include '../HEADERS/parallel.h'
      include '../RDINP/allinp.h'

      integer  iunit, nabs
      type(json_value),pointer :: global
      character*5 vname

      ! root
      call json_value_create(global)       ! create the value and associate the pointer
      call to_object(global,'global.json') ! add the file name as the name of the overall structure

      call json_value_add(global, 'vfeff',  vfeff)
      call json_value_add(global, 'vf85e',  vf85e)

      call json_value_add(global, 'nabs',   nabs)
      call json_value_add(global, 'iphabs', iphabs)
      call json_value_add(global, 'rclabs', rclabs)
      call json_value_add(global, 'ipol',   ipol)
      call json_value_add(global, 'ispin',  ispin)
      call json_value_add(global, 'le2',    le2)
      call json_value_add(global, 'elpty',  elpty)
      call json_value_add(global, 'angks',  angks)

      call json_value_add(global, 'evec',   evec)
      call json_value_add(global, 'xivec',  xivec)
      call json_value_add(global, 'spvec',  spvec)

      do 10 i = -1, 1
         write (vname, "(A3,I1)") "ptz", i+1
         call json_value_add(global, vname,
     1                 [dble(real(ptz(-1,i))), dble(imag(ptz(-1,i))),
     2                  dble(real(ptz( 0,i))), dble(imag(ptz( 0,i))),
     3                  dble(real(ptz( 1,i))), dble(imag(ptz( 1,i)))])
 10   continue

      open(newunit=iunit, file='global.json', status='REPLACE')
      call json_print(global,iunit)
      close(iunit)

!     cleanup:
      call json_destroy(global)


      return
      end




      subroutine json_geom(iatph, rat, iphat)

      use json_module

      implicit double precision (a-h, o-z)
      include '../HEADERS/vers.h'
      include '../HEADERS/dim.h'
      include '../HEADERS/parallel.h'
      include '../RDINP/allinp.h'
      double precision xx(nattx), yy(nattx), zz(nattx)
      double precision rat(3,natx)
      integer ib(nattx), iphat(natx), iatph(0:nphx)

      integer  iunit
      type(json_value),pointer :: geom


      ! root
      call json_value_create(geom)      ! create the value and associate the pointer
      call to_object(geom,'geom.json')  ! add the file name as the name of the overall structure
      
      call json_value_add(geom, 'vfeff',  vfeff)
      call json_value_add(geom, 'vf85e',  vf85e)

      call json_value_add(geom, 'natt',  natt)
      call json_value_add(geom, 'nph',   nph)
      call json_value_add(geom, 'iatph', iatph)
      do 10 i=1,natt
         xx(i) = rat(1,i)
         yy(i) = rat(2,i)
         zz(i) = rat(3,i)
         ib(i) = 1
 10   continue
      call json_value_add(geom, 'x',   xx(1:natt))
      call json_value_add(geom, 'y',   yy(1:natt))
      call json_value_add(geom, 'z',   zz(1:natt))
      call json_value_add(geom, 'iph', iphat(1:natt))
      call json_value_add(geom, 'ibo', ib(1:natt))

      open(newunit=iunit, file='geom.json', status='REPLACE')
      call json_print(geom,iunit)
      close(iunit)

!     cleanup:
      call json_destroy(geom)

      return
      end


      subroutine json_libpotph()

      use json_module

      implicit double precision (a-h, o-z)
      include '../HEADERS/vers.h'
      include '../HEADERS/dim.h'
      include '../HEADERS/parallel.h'
      include '../RDINP/allinp.h'
      double precision xx(nattx), yy(nattx), zz(nattx)
c      double precision rat(3,natx)

      integer  iunit
      type(json_value),pointer :: lpotph
      character*5 vname

      ! root
      call json_value_create(lpotph)        ! create the value and associate the pointer
      call to_object(lpotph,'lpotph.json')  ! add the file name as the name of the overall structure

c     content of atoms.json
      call json_value_add(lpotph, 'vfeff',  vfeff)
      call json_value_add(lpotph, 'vf85e',  vf85e)

c     TITLE
      call json_value_add(lpotph, 'ntitle',   ntitle)
      call json_value_add(lpotph, 'titles', title)

c     ATOMS
      call json_value_add(lpotph, 'natt', natt)
      do 10 i=1,natt
         xx(i) = ratx(1,i)
         yy(i) = ratx(2,i)
         zz(i) = ratx(3,i)
 10   continue
      call json_value_add(lpotph, 'x', xx(1:natt))
      call json_value_add(lpotph, 'y', yy(1:natt))
      call json_value_add(lpotph, 'z', zz(1:natt))
      call json_value_add(lpotph, 'iphatx', iphatx(1:natt))

c     POTENTIALS
      call json_value_add(lpotph, 'nph',    nph)
      call json_value_add(lpotph, 'iz',     iz)
      call json_value_add(lpotph, 'potlbl', potlbl)
      call json_value_add(lpotph, 'lmaxsc', lmaxsc)
      call json_value_add(lpotph, 'lmaxph', lmaxph)
      call json_value_add(lpotph, 'xnatph', xnatph)
      call json_value_add(lpotph, 'spinph', spinph)

c     HOLE/EDGE
      call json_value_add(lpotph, 'ihole',  ihole)

c     SCF
      call json_value_add(lpotph, 'rfms1',  dble(rfms1))
      call json_value_add(lpotph, 'lfms1',  lfms1)
      call json_value_add(lpotph, 'nscmt',  nscmt)
      call json_value_add(lpotph, 'ca1',    ca1)
      call json_value_add(lpotph, 'nmix',   nmix)
      call json_value_add(lpotph, 'ecv',    ecv)
      call json_value_add(lpotph, 'icoul',  icoul)
      
c     POLARIZATION, ELLIPTICITY
      call json_value_add(lpotph, 'ipol',   ipol)
      call json_value_add(lpotph, 'evec',   evec)
      call json_value_add(lpotph, 'elpty',  elpty)
      call json_value_add(lpotph, 'xivec',  xivec)

c     SPIN
      call json_value_add(lpotph, 'ispin',  ispin)
      call json_value_add(lpotph, 'spvec',  spvec)
      call json_value_add(lpotph, 'angks',  angks)

c     computed: ptz and gamach
      do 20 i = -1, 1
         write (vname, "(A3,I1)") "ptz", i+1
         call json_value_add(lpotph, vname,
     1                 [dble(real(ptz(-1,i))), dble(imag(ptz(-1,i))),
     2                  dble(real(ptz( 0,i))), dble(imag(ptz( 0,i))),
     3                  dble(real(ptz( 1,i))), dble(imag(ptz( 1,i)))])
 20   continue
      call json_value_add(lpotph, 'gamach', gamach)

c     EXCHANGE
      call json_value_add(lpotph, 'ixc',    ixc)
      call json_value_add(lpotph, 'vro',    vr0)
      call json_value_add(lpotph, 'vio',    vi0)
      call json_value_add(lpotph, 'ixc0',   ixc0)
      
c     AFOLP, FOLP, ION, RGRID, UNFREEZEF
      call json_value_add(lpotph, 'iafolp', iafolp)
      call json_value_add(lpotph, 'folp',   folp)
      call json_value_add(lpotph, 'xion',   xion)
      call json_value_add(lpotph, 'rgrd',   rgrd)
      call json_value_add(lpotph, 'iunf',   iunf)

c     INTERSTITIAL, JUMPRM, NOHOLE
      call json_value_add(lpotph, 'inters', inters)
      call json_value_add(lpotph, 'totvol', totvol)
      call json_value_add(lpotph, 'jumprm', jumprm)
      call json_value_add(lpotph, 'nohole', nohole)
      call json_value_add(lpotph, 'iplsmn', iPlsmn)


c     CFAVERAGE
c      call json_value_add(lpotph, 'nabs',   nabs)
c      call json_value_add(lpotph, 'iphabs', iphabs)
c      call json_value_add(lpotph, 'rclabs', rclabs)
c     MULTIPOLE
c      call json_value_add(lpotph, 'le2',    le2)

c The rest are parameters associated with:
c    XANES, FMS, PLASMON, PMBSE, TDLDA, RPHASES
c    CONTROL, PRINT 

c      call json_value_add(lpotph, 'iGrid',    iGrid)
c      call json_value_add(lpotph, 'iPlsmn',   iPlsmn)
c      call json_value_add(lpotph, 'ibasis',   ibasis)
c      call json_value_add(lpotph, 'ifxc',     ifxc)
c      call json_value_add(lpotph, 'ipmbse',   ipmbse)
c      call json_value_add(lpotph, 'ipr1',     ipr1)
c      call json_value_add(lpotph, 'ipr2',     ipr2)
c      call json_value_add(lpotph, 'ispec',    ispec)
c      call json_value_add(lpotph, 'itdlda',   itdlda)
c      call json_value_add(lpotph, 'izstd',    izstd)
c      call json_value_add(lpotph, 'l2lp',     l2lp)
c      call json_value_add(lpotph, 'lfms2',    lfms2)
c      call json_value_add(lpotph, 'lreal',    lreal)
c      call json_value_add(lpotph, 'mphase',   mphase)
c      call json_value_add(lpotph, 'mpot',     mpot)
c      call json_value_add(lpotph, 'nonlocal', nonlocal)


c      call json_value_add(lpotph, 'rfms2',  rfms2)
c      call json_value_add(lpotph, 'xkstep', xkstep)
c      call json_value_add(lpotph, 'xkmax',  xkmax)
c      call json_value_add(lpotph, 'vixan',  vixan)





      open(newunit=iunit, file='libpotph.json', status='REPLACE')
      call json_print(lpotph,iunit)
      close(iunit)

!     cleanup:
      call json_destroy(lpotph)

      return
      end

       subroutine rdfbin(fbfile, nphx, nex, npathx, nlegx,
     $      npaths, ne, npot, ihole, iorder, ilinit,
     $      rnrmav, xmu, edge,  potlbl, iz, phc, ck, xk, index,
     $      nleg, deg, reff, crit, ipot,
     $      rat, beta, eta, ri, achi, phchi)
c
c read path information from PAD-format feff.pad
c  arguments:
c   fbile   name of feff.pad file                             [in]
c   nphx    dimension of  potlbl, iz (both (0:nphx)           [in]
c             max # of potentials
c   nex     dimension of many energy arrays                   [in]
c             max # of energy points
c   npathx     dimension of index,nleg,ipot,deg,reff,crit,    [in]
c           rat,beta, eta, ri, achi, phchi
c             max # of paths
c   nlegx  dimension of  ipot, rat, beta,eta,ri              [in]
c            max # of legs in a path
c   npaths  number of paths read                             [out]
c   ne      maximum number of energy points read             [out]
c   npot    number of potentials read                        [out]
c   rnrmav  average norman radius                            [out]
c   edge    shift in edge energy (?)                         [out]
c   iorder  order of genfmt matrix used                      [out]
c   potlbl  array of potential labels                        [out]
c   iz      array of atomic numbers for potentials           [out]
c   phc     array of central atom phase shift (complex)      [out]
c   ck      array of wavenumbers/momentum (complex)          [out]
c   xk      array of wavenumbers/momentum (real)             [out]
c   index   array of path indices                            [out]
c   nleg    array:  number of legs in path                   [out]
c   deg     array:  path degeneracy                          [out]
c   reff    array:  half path length of path                 [out]
c   crit    array:  importance factor for path               [out]
c   ipot    array:  pots, in order, that make up the path    [out]
c   rat     array:  atomic positions of atoms in path        [out]
c   beta    array:  euler angle for path                     [out]
c   eta     array:  second euler angle for path              [out]
c   ri      array:  path leg distances for path              [out]
c   achi    array:  amplitude of chi for path                [out]
c   phchi   array:  phase of chi for path                    [out]
c
c notes:
c   the data in feff.pad is written completely in printable
c   ascii characters.  The file is however, highly formatted
c   and kept fairly small.  all text is stored as is, but most
c   numerical data in arrays (both real and complex) is stored
c   in a special Packed Ascii Data (PAD) format which uses 6
c   printable characters to represent a real number.
c
c   special markers in the first 1 or 2 characters of each line
c   give hints about the contents of the line:
c      #_    top 2 lines.  The first line must begin "#_feff.pad"
c      #"    title lines / plain text
c      #&    misc info about potentials, calc method
c      #@    potential labels and iz
c      ##    path index,  deg, reff, crit, ipots involved
c      !     PAD characters to be read as a real array
c      $     PAD characters to be read as a complex array
c
c copyright (c) 1999  matt newville:  jan 1999
c modified by alex ankudinov: feb 2000; few fixes for feff8.2
c------------------------------------------------------------------
       include '../HEADERS/const.h'
       integer nphx, nex, npathx, nlegx, npaths
       integer i, j, ivers, nexmax
       character*(*) fbfile
       character*(*) potlbl(0:nphx), filnam*128, str*128
c       character*(*) msg*256
       integer iorder,  index(npathx), nleg(npathx)
       integer ne, npot, ipot(nlegx,npathx), iz(0:nphx)
       integer istrln, ier1, ier2, ier3, nwords, npadx, nwordx
       real    deg(npathx), reff(npathx), crit(npathx)
       real    rnrmav, edge, xk(nex)
       double precision tmpdp
       parameter(nwordx = 20, nexmax = 256)
       character*20 words(nwordx)
       real     rat(3,nlegx,npathx), beta(nlegx,npathx)
       real     eta(nlegx,npathx),  ri(nlegx,npathx)
       real     achi(nex,npathx), phchi(nex,npathx)
c       real tmpr(nexmax)
       complex  phc(nex), ck(nex)
c       complex tmpc(nexmax)
       external  istrln

c open feff.pad
       filnam = ' '
       filnam = fbfile
       call triml(filnam)
       il     = istrln(filnam)
       if (filnam.eq.' ') filnam = 'feff.pad'
cc       print*, ' RDFBIN!  ', filnam(1:il),':',il
       open (unit=3, file=filnam, status='old', err=450)
 10    format(a)
c first line, must match  "#_feff.pad"
       read(3,10,err=920) str
       call triml(str)
       if ((str(1:10).ne.'#_feff.pad')) go to 900
c check version of feff.pad : only support version 3 here!!
       ivers = 0
       if ((str(1:14).eq.'#_feff.pad fil')) ivers = 1
       if ((str(1:14).eq.'#_feff.pad v02')) ivers = 2
       if ((str(1:14).eq.'#_feff.pad v03')) ivers = 3
       if (ivers.ne.3) go to 930
c second line:   npot, ne
       read(3,10,err=920) str
       call triml(str)
       if ((str(1:2).ne.'#_')) go to 900
       nwords = 3
       str    = str(3:)
       call bwords(str,nwords,words)
       if (nwords.ne.3) go to 905
       call str2in(words(1), npot,  ier1)
       call str2in(words(2), ne,    ier2)
       call str2in(words(3), npadx, ier3)
       if ((ier1.ne.0).or.(ier2.ne.0).or.(ier3.ne.0)) go to 910

c  read in misc stuff:  (rnrmav, edge, iorder )
       read(3,10,err=920) str
       call triml(str)
       if (str(1:2).ne.'#&') go to 900
       nwords = 6
       str    = str(3:)
       call bwords(str,nwords,words)
       if (nwords.ne.6) go to 905
       call str2in(words(1), ihole,  ier1)
       call str2in(words(2), iorder, ier2)
       call str2in(words(3), ilinit, ier3)
       if ((ier1.ne.0).or.(ier2.ne.0).or.(ier3.ne.0)) go to 910
       call str2re(words(4), rnrmav, ier1)
       call str2re(words(5), xmu   , ier2)
       call str2re(words(6), edge  , ier3)
       if ((ier1.ne.0).or.(ier2.ne.0).or.(ier3.ne.0)) go to 910
c  read pot label and iz line
       read(3,10,err=920) str
       call triml(str)
       if (str(1:2).ne.'#@') go to 900
       nwords = 2 * npot + 2
c  note: potlbl cannot be blank!!
       str    = str(3:)
       call bwords(str, nwords, words)
       if (nwords.ne.(2 + 2*npot)) go to 905
       do 200 i = 0, npot
          potlbl(i) = words(i+1)
          iz(i) = -1
          call str2in(words(2+npot+i),iz(i),ier1)
          if (ier1.ne.0)  go to 910
 200   continue

c read  numerical data that are the same for all paths
       call rdpadc(3,npadx, phc, ne)
       call rdpadc(3,npadx, ck,ne)
       call rdpadr(3,npadx, xk,ne)
       npaths = 0
c now, for each path:
       do 300  i = 1, npathx
          index(i) = 0
c  read path  info "##" line  and retrieve all the stuff from it
          read(3,10,end=450,err=920) str
          call triml(str)
          if (str(1:2).ne.'##')   go to 900
          nwords = nwordx
          str    = str(3:)
          call bwords(str,nwords,words)
          call str2in(words(1),  index(i), ier1)
          call str2in(words(2),  nleg(i), ier2)
          call str2re(words(3),  deg(i), ier3)
          if ((ier1.ne.0).or.(ier2.ne.0).or.(ier3.ne.0)) go to 910
          call str2dp(words(4),  tmpdp, ier2)
          reff(i) = real(tmpdp / bohr)
          call str2dp(words(5),  tmpdp, ier3)
          crit(i) = real(tmpdp)
          if ((ier1.ne.0).or.(ier2.ne.0).or.(ier3.ne.0)) go to 910
          npaths = npaths + 1
          do 230 j = 1, nleg(i)
             call str2in(words(5+j),ipot(j,i),ier1)
             if (ier1.ne.0) go to 910
 230      continue
c
c  next, read padded arrays for rat,beta, ..., achi, phchi
          call rdpadr(3,npadx, rat(1,1,i),3*nleg(i))
          call rdpadr(3,npadx, beta(1,i),   nleg(i))
          call rdpadr(3,npadx, eta(1,i),    nleg(i))
          call rdpadr(3,npadx, ri(1,i),     nleg(i))
          call rdpadr(3,npadx, achi(1, i),  ne)
          call rdpadr(3,npadx, phchi(1, i), ne)
c  fill in rest of achi and phchi with zeros
          do 270 j = ne+1, nex
             achi(j,i)  = 0
             phchi(j,i) = 0
 270      continue
 300    continue
 450    continue
       close(3)
cc       print*, ' RDFBIN done!'
       return
 900   call wlog (' -- rdfbin error: wrong format : at line')
       go to 990
 905   call wlog (' -- rdfbin error: missing data : at line')
       go to 990
 910   call wlog (' -- rdfbin error:   bad data   : at line')
       go to 990
 920   call wlog (' -- rdfbin error: unknown error: at line')
       go to 990
 930   call wlog (' -- rdfbin error: unknown version of feff.pad')
       go to 990

 990   call wlog (str)
       call par_stop(' -- fatal error reading feff.pad -- ')
       end

       logical function isnum (string)
c  tests whether a string can be a number. not foolproof!
c  to return true, string must contain:
c    - only characters in  'deDE.+-, 1234567890' (case is checked)
c    - no more than one 'd' or 'e' 
c    - no more than one '.'
c  matt newville
       character*(*)  string,  number*20
c note:  layout and case of *number* is important: do not change!
       parameter (number = 'deDE.,+- 1234567890')
       integer   iexp, idec, i, j, istrln
       external  istrln
       iexp  = 0
       idec  = 0
       isnum = .false. 
       do 100  i = 1, max(1, istrln(string))
          j = index(number,string(i:i))
          if (j.le.0)               go to 200
          if((j.ge.1).and.(j.le.4)) iexp = iexp + 1
          if (j.eq.5)               idec = idec + 1
 100   continue
c  every character in "string" is also in "number".  so, if there are 
c  not more than one exponential and decimal markers, it's a number
       if ((iexp.le.1).and.(idec.le.1)) isnum = .true.
 200   continue
       return
c  end logical function isnum
       end

      subroutine etotal (io, kap, xnel, xnval, en, eatom)
c combined from original subroutines tabfgk,tabbre,tabrat.
c io  label for output file atomNN.dat
c kap quantum number "kappa"
c xnel occupation of  orbitals
c en one-electron energies
c fdrirk function calculating radial integrals rk
c akeato angular coefficient for integrals  fk, for the
c integrals fk(i;i) gives angular coefficients multiplied by 2
c bkeato angular coefficient for integrals  gk
c coul ener(1) direct coulomb interaction
c ech  ener(2) exchange coulomb interaction
c        * average value of the breit hamiltonian *
c fdrocc function of the orbitals' occupations.
c bkmrdf is a programm to calculate angular coefficients
c ema ener(3) magnetic energy
c ere ener(4) retardation term
c        this program uses akeato,bkeato
c        fdrocc fdrirk bkmrdf

      implicit double precision (a-h,o-z)
      include '../HEADERS/const.h'

      dimension kap(30),xnel(30),en(30), xnval(30)
      common/itescf/testy,rap(2),teste,nz,norb,norbsc
      dimension mk(12),ener(4)
      dimension cer(17),mbi(9),mii(9),mjj(9)
      common/tabre/cmag(3),cret(3)
      common/inelma/nem
      common/print/iprint
      character*4 iner(4)
      logical io_open

      external akeato, bkeato, fdrirk, fdmocc
      data iner/'coul','ech.','mag.','ret.'/

      do 10 i = 1,4
 10   ener(i)=0.0d 00
      iv=0
c       fk  integrales
      do 40 i=1,norb
         l= abs(kap(i))-1
         do 40 j=1,i
            a=1.0d 00
            if (j.eq.i) a=a+a
            m= abs(kap(j))-1
            kmi=2* min(l,m)
            k=0
 20         iv=iv+1
            cer(iv)=fdrirk(i,i,j,j,k)
            ener(1) = ener(1) + cer(iv) * akeato(i,j,k) / a
            mk(iv)=k
            if (iv.lt.3) go to 30
            iv=0
 30         k=k+2
            if (k.le.kmi) go to 20
 40   continue
      iv=0
      if (norb.gt.1) then
c       gk  integrales
      do 70 i=2,norb
         a = 1.0d0
         if (xnval(i) .gt. 0.0d0) a=0.5d0
         i1=i-1
         do 70 j=1,i1
            if (xnval(j) .gt. 0.0d0) goto 70
            l= abs(kap(i))
            m= abs(kap(j))
            k= abs(l-m)
            if ((kap(i)*kap(j)).lt.0) k=k+1
            kmi=l+m-1
 50         iv=iv+1
            cer(iv)=fdrirk(i,j,i,j,k)
            ener(2) = ener(2) - cer(iv) * bkeato(i,j,k) * a
            mk(iv)=k
            if (iv.lt.3) go to 60
            iv=0
 60         k=k+2
            if (k.le.kmi) go to 50
 70   continue
      endif
c
      nem=1
c       direct  integrals
      ik=0
      do 140 j=1,norb
         jj=2* abs(kap(j))-1
         do 140 i=1,j
            ji=2* abs(kap(i))-1
            k=1
            kma= min(ji,jj)
 110        ik=ik+1
            mbi(ik)=k
            mii(ik)=i
            mjj(ik)=j
            cer(ik)=fdrirk(j,j,i,i,k)
            if (i.ne.j) go to 120
            call bkmrdf (j,j,k)
            ener(3) = ener(3) + (cmag(1) + cmag(2) + cmag(3)) *
     1                cer(ik) * fdmocc(j,j) / 2.0d 00
 120        if (ik.lt.3) go to 130
            ik=0
 130        k=k+2
            if (k.le.kma) go to 110
 140  continue
      if (norb.gt.1) then
c       echange  integrals
      do 201 j=2,norb
         lj= abs(kap(j))
         na=-1
         if (kap(j).gt.0) go to 121
         na=-na
         lj=lj-1
 121     jp=j-1
         do 201 l=1,jp
            ll= abs(kap(l))
            nb=-1
            if (kap(l).gt.0) go to 131
            nb=-nb
            ll=ll-1
 131        b=fdmocc(j,l)
            nm1= abs(lj+na-ll)
            nmp1=ll+lj+nb
            nmm1=ll+lj+na
            np1= abs(ll+nb-lj)
            k= min(nm1,np1)
            kma=max(nmp1,nmm1)
            if (mod(k+ll+lj,2).eq.0) k=k+1
            nb= abs(kap(j))+ abs(kap(l))
 141        call bkmrdf (j,l,k)
            do 151 i=1,3
 151           cer(i)=0.0d 00
            if (nb.le.k.and.kap(l).lt.0.and.kap(j).gt.0) go to 161
            cer(1)=fdrirk(l,j,l,j,k)
            cer(2)=fdrirk(0,0,j,l,k)
 161        if (nb.le.k.and.kap(l).gt.0.and.kap(j).lt.0) go to 171
            cer(3)=fdrirk(j,l,j,l,k)
            if (cer(2).ne.0.0d 00) go to 171
            cer(2)=fdrirk(0,0,l,j,k)
 171        do 185 i = 1, 3
               ener(3) = ener(3) + cmag(i) * cer(i) * b
               ener(4) = ener(4) + cret(i) * cer(i) * b
 185        continue
            k=k+2
            if (k.le.kma) go to 141
 201  continue
      endif

c     total   energy
      eatom = - (ener(1) + ener(2)) + ener(3) + ener(4)
      do 212 j = 1, norb
 212     eatom = eatom + en(j) * xnel(j)
      inquire(unit=io,opened=io_open)
      if (iprint .ge. 5 .and. io_open)
     .  write (io, '(a,1pd18.7)') 'etot', eatom*hart
      do 215 i = 1, 4
        if (iprint.ge.5 .and. io_open)
     .    write(io, '(a4,1pd18.7)') iner(i), ener(i)*hart
 215  continue
      return
      end

      subroutine phash (npat, ipat, rx, ry, rz, dhash)
c     hashes a path into double precision real dhash

      include '../HEADERS/dim.h'
      double precision dhash
      dimension rx(npatx), ry(npatx), rz(npatx), ipat(npatx+1)

      common /atoms/ rat(3,0:natx), ipot(0:natx), i1b(0:natx)

      double precision xx

      parameter (iscale = 1000)
      parameter (factor = 16.12345678)
      parameter (facto2 = 8.57654321)

c     Hashing scheme: Assume about 15 significant digits in a double 
c     precision number.  This is 53 bit mantissa and 11 bits for sign 
c     and exponent, vax g_floating and probably most other machines.
c     With max of 9 legs, 47**9 = 1.12e15, so with a number less than 
c     47, we can use all these digits, scaling each leg's data by 
c     47**(j-1).  Actually, since our numbers can go up to about 10,000,
c     we should keep total number < 1.0e11, 17**9 = 1.18e11, which means
c     a factor a bit less than 17.  Choose 16.12345678, a non-integer,
c     to help avoid hash collisions.

c     iscale and 'int' below are to strip off trailing digits, which
c     may contain roundoff errors

      dhash = 0
      do 210  j = 1, npat
         xx = factor**(j-1)
         dhash = dhash + xx * (nint(rx(j)*iscale) +
     1               nint(ry(j)*iscale)*0.894375 +
     2               nint(rz(j)*iscale)*0.573498)
  210 continue
      do 220  j = 1, npat
         xx = facto2**(j-1)
         dhash = dhash + xx * iscale * ipot(ipat(j))
c        dhash = dhash + xx * ipot(ipat(j))
  220 continue
      dhash = dhash + npat * 40 000 000

      return
      end

      subroutine quinn (x, rs, wp, ef, ei)
      implicit double precision (a-h, o-z)

c     input  x, rs, wp, ef
c     output ei

c***********************************************************************
c
c     quinn: calculates low energy gamma (approx. proportional to e**2)
c             formula taken from john j. quinn, phys. rev. 126,
c             1453 (1962); equation (7).
c             a cut-off is set up at quinn's cutoff + ef = ekc; it is a
c             rounded inverted step function (a fermi function)
c             theta = 1/( 1 + exp((e-ekc)/gam)) )
c             where the rounding factor gam is set to be about 0.3 ekc.
c     modified by j. rehr (oct 1991) based on coding of r. albers
c     subroutines quinn.f and quinnc.f
c
c     variables:
c        x  = p/pf
c        rs = ws density parameter
c        ei = imaginary self energy
c        pfqryd = quinn's prefactor in atomic-rydberg units
c        wkc = quinn's plasmon threshold
c
c***********************************************************************

      include '../HEADERS/const.h'

      parameter (alphaq = 1.d0/ fa)

c     calculate quinn prefactor in atomin Hartree units
      pisqrt = sqrt(pi)
      pfq = pisqrt / (32 * (alphaq*rs)**1.5)
      temp1 = atan (sqrt (pi / (alphaq*rs)))
      temp2 = sqrt(alphaq*rs/pi) / (1 + alphaq*rs/pi)
      pfq = pfq * (temp1 + temp2)

c     calculate quinn cutoff
c     wkc = quinn's plasmon threshold
c     wkc is cut-off of quinn, pr126, 1453, 1962, eq. (11)
c     in formulae below wp=omegap/ef
      wkc = (sqrt(1+wp) - 1)**2
      wkc = (1 + (6./5.) * wkc / wp**2) * wp * ef

c     we add fermi energy to get correct energy for
c     plasma excitations to turn on
      ekc = wkc + ef

c     calculate gamma
c     gamryd = 2 * (pfqryd/x) * (x**2-1)**2
      gam = (pfq/x) * (x**2-1)**2

c     put in fermi function cutoff
      eabs = ef * x**2
      arg = (eabs-ekc) / (0.3*ekc)
      f = 0
      if (arg .lt. 80)  f = 1 / (1 + exp(arg))

      ei = -gam * f / 2

      return
      end

      subroutine feffloss(nph, iz, xnatph, rnrm, npoles, eps0,
     1       write_opcons, write_loss, write_exc, verbose,
     2       wpcorr, gamma, ampfac, delta)

      include '../HEADERS/const.h'
      include '../HEADERS/dim.h'
      include '../HEADERS/parallel.h'

      integer epsmax
      parameter(epsmax = 700)
      
      integer iz(0:nphx), npoles
      character*2 Components(0:nphx)
      double precision NumDens(0:nphx), xnatph(0:nphx)
      double precision rnrm(0:nphx), eps0, sumrl, xNElec, gamma, csumrl
      double precision VTot
      logical write_opcons, write_loss, write_exc, verbose

      double precision wpcorr(MxPole), delta(MxPole), ampfac(MxPole)

      double precision thiseps(epsmax,3,0:nphx)
      double precision energy(epsmax), loss(epsmax)

      character*12 EpsFile
      character*2 atsym
      external atsym

      if (verbose) print*, 'nph, rnrm', nph, rnrm(0:nph)

c     Find the number density of each component.
      VTot = 0.d0
      do 10 iph = 0, nph
         VTot = VTot + xnatph(iph)*4.d0/3.d0*pi*(rnrm(iph)*bohr)**3
         NumDens(iph) = -1.d0
 10   continue

      do 20 iph = 0, nph
         if(NumDens(iph).lt.0.d0) NumDens(iph) = xnatph(iph)/VTot
c        test with numDens = 1. Should give same loss as input file for a single file.
c         if(.false.) then
c            if(iph.ne.0) then
c               NumDens(iph) = 1.d0
c            else
c               NumDens(iph) = 0.d0
c            end if
c         end if
         Components(iph) = atsym(iz(iph))
 20   continue

c     Get opcons{Element}.dat from database.
      do 34 iph = 0, nph
         do 32 i1 = 1,epsmax
            do 30 i2 = 1,3
               thiseps(i1,i2,iph) = 0.d0
 30         continue
 32      continue
         EpsFile = 'opcons' // atsym(iz(iph)) // '.dat'
         if (verbose) print*, Components(iph), NumDens(iph), EpsFile
         call epsdb(iz(iph), thiseps(1,1,iph))
         if (write_opcons)
     &          call write_eps(iz(iph), thiseps(1,1,iph), EpsFile)
 34   continue

      NComps = nph + 1
      call AddEps(NComps, NumDens, thiseps, NDataTot,
     &       energy, loss)
  
c     Open output file and write data.
      if (write_loss) then
         open(file='loss.dat', unit=60, status='replace',iostat=ios)
         call chopen (ios, 'loss.dat', 'libfeffloss')
         write(60,'(A)') '# E(eV)    Loss'
         do 40 i1 = 1, NDataTot
            write(60,*), energy(i1), loss(i1)
 40      continue
      end if
  
c     ! sumrl, xNElec, gamma, and csumrl -- a bit cryptic
      sumrl = 1.d0
      xNElec = 1.d0
      gamma = 0.01
      csumrl= xNElec/sumrl
      do 50 i1 = 1, NDataTot
         loss(i1) = loss(i1)*csumrl
 50   continue

c     getomi finds poles and weights
      call getomi(energy, loss, NDataTot, NPoles,
     $       wpcorr, ampfac, delta, eps0)

      if (write_exc) then
         open(unit=13,file='exc.dat',status='replace')
         write(13,'(A33,I4,A6)') '# Loss function represented with ',
     &          NPoles, ' poles'
         write(13,'(A23,f8.4)') '# Dielectric constant: ', eps0
         do 60 i1 = 1, NPoles
            write(13,'(4f20.10)'), wpcorr(i1), wpcorr(i1)*gamma,
     &              ampfac(i1), Delta(i1)
 60      continue
         close(13)
      end if

      return
      end

      subroutine istval (vtot, rholap, rmt, imt, rws, iws, vint, rhoint,
     1                   ierr)

c     This subroutine calculates interstitial values of v and rho
c     for an overlapped atom.  Inputs are everything except vint and
c     rhoint, which are returned.  vtot includes ground state xc.
c     rhoint is form density*4*pi, same as rholap
c
c     ierr = 0, normal exit
c          =-1, rmt=rws, no calculation possible

      implicit double precision (a-h, o-z)

      include '../HEADERS/dim.h'
      parameter (delta = 0.050 000 000 000 000d0)

      dimension vtot (nrptx)
      dimension rholap (nrptx)

c     Integrations are done in x (r = exp(x), see Louck's grid)
c     Trapezoidal rule, end caps use linear interpolation.
c     imt is grid point immediately below rmt, etc.
c     We will integrate over spherical shell and divide by volume of
c     shell, so leave out factor 4pi, vol = r**3/3, not 4pi*r**3/3,
c     similarly leave out 4pi in integration.

c     If rmt and rws are the same, cannot contribute to interstitial
c     stuff, set error flag
      vol = (rws**3 - rmt**3) / 3
      if (vol .le. 0)  then
         ierr = -1
         return
      endif
      ierr = 0

c     Calculation of vint including exchange correlation
c     Trapezoidal rule from imt+1 to iws
      vint = 0
      do 100  i = imt, iws-1
         fr = rr(i+1)**3 * vtot(i+1)
         fl = rr(i)**3   * vtot(i)
         vint = vint + (fr+fl)*delta/2
  100 continue
c     End cap at rws (rr(iws) to rws)
      xws = log (rws)
      xiws = xx(iws)
      g = xws - xiws
      fr = rr(iws+1)**3 * vtot(iws+1)
      fl = rr(iws)**3   * vtot(iws)
      vint = vint + (g/2) * ( (2-(g/delta))*fl + (g/delta)*fr)
c     End cap at rmt (rmt to rr(imt+1))
      xmt = log (rmt)
      ximt = xx(imt)
      g = xmt - ximt
      fr = rr(imt+1)**3 * vtot(imt+1)
      fl = rr(imt)**3   * vtot(imt)
      vint = vint - (g/2) * ( (2-(g/delta))*fl + (g/delta)*fr)
      vint = vint / vol

c     Calculation of rhoint
c     Trapezoidal rule from imt+1 to iws
      rhoint = 0
      do 200  i = imt, iws-1
         fr = rr(i+1)**3 * rholap(i+1)
         fl = rr(i)**3   * rholap(i)
         rhoint = rhoint + (fr+fl)*delta/2
  200 continue
c     End cap at rws (rr(iws) to rws)
      xws = log (rws)
      xiws = xx(iws)
      g = xws - xiws
      fr = rr(iws+1)**3 * rholap(iws+1)
      fl = rr(iws)**3   * rholap(iws)
      rhoint = rhoint + (g/2) * ( (2-(g/delta))*fl + (g/delta)*fr)
c     End cap at rmt (rmt to rr(imt+1))
      xmt = log (rmt)
      ximt = xx(imt)
      g = xmt - ximt
      fr = rr(imt+1)**3 * rholap(imt+1)
      fl = rr(imt)**3   * rholap(imt)
      rhoint = rhoint - (g/2) * ( (2-(g/delta))*fl + (g/delta)*fr)
      rhoint = rhoint / vol

      return
      end

      subroutine json_read_global(nabs, iphabs, rclabs, ipol, ispin,
     1                            le2, elpty, angks, evec, xivec,
     2                            spvec, ptz)

      use json_module
      implicit double precision (a-h, o-z)

      include '../HEADERS/const.h'
      include '../HEADERS/dim.h'

      logical :: found
      type(json_file) :: json   !the JSON structure read from the file:
      double precision,dimension(:),allocatable :: dbpcs

      integer nabs, iphabs, ipol, ispin, le2
      double precision evec(3), xivec(3), spvec(3), elpty,angks,rclabs
      complex*16 ptz(-1:1, -1:1)

      call json%load_file('global.json')
      if (json_failed()) then   !if there was an error reading the file
         print *, "failed to read global.json"
         stop
      else
         call json%get('nabs', nabs, found)
                 if (.not. found) call bailout('nabs',   'global.json')
         call json%get('iphabs', iphabs, found)
                 if (.not. found) call bailout('iphabs', 'global.json')
         call json%get('rclabs', rclabs, found)
                 if (.not. found) call bailout('rclabs', 'global.json')
         call json%get('ipol', ipol, found)
                 if (.not. found) call bailout('ipol',   'global.json')
         call json%get('ispin', ispin, found)
                 if (.not. found) call bailout('ispin',  'global.json')
         call json%get('le2', le2, found)
                 if (.not. found) call bailout('le2',    'global.json')
         call json%get('elpty', elpty, found)
                 if (.not. found) call bailout('elpty',  'global.json')
         call json%get('angks', angks, found)
                 if (.not. found) call bailout('angks',  'global.json')

         call json%get('evec',  dbpcs, found)
                 if (.not. found) call bailout('evec',   'global.json')
         do 10 i=1,3
            evec(i) = dbpcs(i)
 10      continue
         call json%get('xivec',  dbpcs, found)
                 if (.not. found) call bailout('xivec',  'global.json')
         do 20 i=1,3
            xivec(i) = dbpcs(i)
 20      continue
         call json%get('spvec',  dbpcs, found)
                 if (.not. found) call bailout('spvec',  'global.json')
         do 30 i=1,3
            spvec(i) = dbpcs(i)
 30      continue

         call json%get('ptz0',  dbpcs, found)
                 if (.not. found) call bailout('ptz0',  'global.json')
         ptz(-1,-1) = dcmplx(dbpcs(1), dbpcs(2))
         ptz( 0,-1) = dcmplx(dbpcs(3), dbpcs(4))
         ptz( 1,-1) = dcmplx(dbpcs(5), dbpcs(6))
         call json%get('ptz1',  dbpcs, found)
                 if (.not. found) call bailout('ptz1',  'global.json')
         ptz(-1, 0) = dcmplx(dbpcs(1), dbpcs(2))
         ptz( 0, 0) = dcmplx(dbpcs(3), dbpcs(4))
         ptz( 1, 0) = dcmplx(dbpcs(5), dbpcs(6))
         call json%get('ptz2',  dbpcs, found)
                 if (.not. found) call bailout('ptz2',  'global.json')
         ptz(-1, 1) = dcmplx(dbpcs(1), dbpcs(2))
         ptz( 0, 1) = dcmplx(dbpcs(3), dbpcs(4))
         ptz( 1, 1) = dcmplx(dbpcs(5), dbpcs(6))
         call json%destroy()
      end if

      return
      end

      subroutine outcrt (npat, ipat, ckspc,
     1    nncrit, fbetac, xlamc, ne, ik0, cksp, 
     1    fbeta, xlam, ipot,
     1    xport, xheap, xheapr,
     1    xout, xcalcx)

c     This make pw importance factor for pathsd, also recalculates
c     pathfinder criteria for output.  Pathfinder recalculation
c     is hacked from ccrit, so be sure to update this if ccrit
c     is changed.

      include '../HEADERS/const.h'
      include '../HEADERS/dim.h'
      dimension ipat(npatx)
      dimension ipot(0:natx)
      parameter (necrit=9, nbeta=40)
      dimension fbetac(-nbeta:nbeta,0:nphx,necrit), ckspc(necrit)
      dimension fbeta(-nbeta:nbeta,0:nphx,nex), cksp(nex)
      dimension xlamc(necrit), xlam(nex)

c     local variables
      dimension ri(npatx+1), beta(npatx+1), indbet(npatx+1)
      dimension xporti(nex)
      parameter (eps = 1.0e-6)

c     Space for variables for time reversed path (used in xheapr
c     calculation below)
      dimension ipat0(npatx)
      dimension ri0(npatx+1), indbe0(npatx+1)

c     mrb is 'efficient' way to get only ri and beta
c     note that beta is cos(beta)
      call mrb (npat, ipat, ri, beta)

c     Make index into fbeta array (this is nearest cos(beta) grid point,
c     code is a bit cute [sorry!], see prcrit for grid).
      do 290  i = 1, npat+1
         tmp = abs(beta(i))
         n = int(tmp / 0.025)
         del = tmp - n*0.025
         if (del .gt. 0.0125)  n = n+1
         if (beta(i) .lt. 0)  n = -n
         indbet(i) = n
  290 continue

c     Make pw importance factor by integrating over all points
c     above the edge
c     Path importance factor is integral d|p| of
c        (product of f(beta)/rho for the scatterers) * cos(beta0)/rho0
c     Include mean free path factor, exp(-rtot/xlam)
      rtot = 0
      do 510  i = 1, npat+1
         rtot = rtot + ri(i)
  510 continue
      do 560  ie = ik0, ne
         rho = ri(npat+1) * cksp(ie)
         crit = max (abs(beta(npat+1)), 0.3) / rho
         do 520  iat = 1, npat
            rho = ri(iat) * cksp(ie)
            ipot0 = ipot(ipat(iat))
            crit = crit * fbeta(indbet(iat),ipot0,ie) / rho
  520    continue
         crit = crit * exp (-rtot/xlam(ie))
         xporti(ie) =  abs(crit)
  560 continue


c     integrate from ik0 to ne
      nmax = ne - ik0 + 1
      call strap (cksp(ik0), xporti(ik0), nmax, xport)

c     Stuff for  output.
c     Heap crit thing (see ccrit and mcrith for comments)
c     If a path got time reversed, its xheap may be smaller than
c     it was before it got time-reversed.  So calculate it both
c     ways.
c     xheap for path, xheapr for time-reversed path

      xheap  = -1
      xheapr = -1
      call mcrith (npat, ipat, ri, indbet,
     1             ipot, nncrit, fbetac, ckspc, xheap)

c     Prepare arrays for time reversed path and make xheapr
c     See timrev.f for details on indexing here.

      nleg = npat+1
c     ri
      do 200  i = 1, nleg
         ri0(i) = ri(nleg+1-i)
  200 continue
c     indbet  and ipat
      indbe0(nleg) = indbet(nleg)
      do 210  i = 1, nleg-1
         indbe0(i) = indbet(nleg-i)
         ipat0(i) = ipat(nleg-i)
  210 continue

      call mcrith (npat, ipat0, ri0, indbe0,
     1             ipot, nncrit, fbetac, ckspc, xheapr)

c     Keep crit thing (see mcritk for comments)
      call mcritk (npat, ipat, ri, beta, indbet,
     1             ipot, nncrit, fbetac, xlamc, ckspc, xout, xcalcx)

      return
      end

      SUBROUTINE rdloss(Uloss,Dat,NPts)
      IMPLICIT NONE
c     Variables passed
      INTEGER Uloss, NPts
      DOUBLE PRECISION Dat(50000,2)

      
c     local variables
      INTEGER nterp,n,i
c      DOUBLE PRECISION dum
      CHARACTER(LEN=4) comment
c      CHARACTER ch
c      CHARACTER(200) Line
      comment='#*!c'
      nterp=1
      n=0

c     Read data into Dat
      DO i=1,50000
c     Read past comments
         CALL rdcmt(Uloss,comment)
         READ(Uloss,*,end=250) Dat(i,1), Dat(i,2)
         n=i
      END DO      
 250  CONTINUE
      NPts=n
      
      CLOSE(Uloss)
      RETURN 
      END

      subroutine reapot (mpot, rgrd, ntitle, title, ipr1, ispec,
     1           nohole, ihole, gamach, nph, iz, lmaxsc, xnatph,
     2           xion, iunf, ixc, jumprm, iafolp, folp, inters, totvol,
     3           rfms1, lfms1, nscmt, ca1, nmix, ecv, icoul,
     4           novr, iphovr, nnovr, rovr,
     5           nat, rat, iphat, iatph)

c$$$      use json_module
c$$$      implicit double precision (a-h, o-z)
c$$$      logical :: found
c$$$      character*7 vname
c$$$      type(json_file) :: json   !the JSON structure read from the file:
c$$$      double precision toss
c$$$      integer,dimension(:),allocatable :: intgs
c$$$      character*80,dimension(:),allocatable :: strings
c$$$      double precision,dimension(:),allocatable :: dbpcs

      include '../HEADERS/const.h'
      include '../HEADERS/dim.h'

cc    geom.dat
        integer  nat, iatph(0:nphx), iphat(natx), ibounc(natx)
        double precision  rat(3,natx)
cc    mod1.inp
        character*80 title(nheadx)
c        character*80 head(nheadx)
c        integer lhead(nheadx)
        integer mpot, nph, ntitle, ihole, ipr1, iafolp, ixc, ispec,
     1     iunf, nmix, nohole, jumprm, inters, nscmt, icoul, lfms1
        integer iz(0:nphx), lmaxsc(0:nphx)
        real rfms1
        double precision gamach, rgrd, ca1, ecv, totvol
        double precision  xnatph(0:nphx), folp(0:nphx), xion(0:nphx)
c       for OVERLAP option
        integer novr(0:nphx), iphovr(novrx,0:nphx), nnovr(novrx,0:nphx)
        double precision  rovr(novrx,0:nphx)

c     Local stuff
c      character*512 slog
      character*32 s1, s2, s3

c$$$      intgs   = [INTEGER::]
c$$$      strings = [CHARACTER*80::]
c$$$      dbpcs   = [DOUBLE PRECISION::]


c     standard formats for string, integers and real numbers
c  10  format(a)
c  20  format (20i4)
c  30  format (6f13.5)


c--json--c     Read  geom.dat file
c--json--      open (file='geom.dat', unit=3, status='old',iostat=ios)
c--json--c       read header from geom.dat 
c--json--        nhead = nheadx
c--json--        call rdhead (3, nhead, head, lhead)
c--json--        nat = 0
c--json--        nph = 0
c--json--        do 40 iph = 0, nphx
c--json--  40    iatph(iph) = 0
c--json--  50    continue
c--json--           if (nat .gt. natx)  then
c--json--              write(slog,55) ' nat, natx ', nat, natx
c--json--              call wlog(slog)
c--json--  55          format(a, 2i10)
c--json--              stop 'Bad input'
c--json--           endif
c--json--           nat = nat+1
c--json--           read(3,*,end=60)  idum, (rat(j,nat),j=1,3), iphat(nat), i1b
c--json--           if (iphat(nat).gt.nph) nph = iphat(nat)
c--json--           if ( iatph(iphat(nat)).eq.0) iatph(iphat(nat)) = nat
c--json--        goto 50
c--json--  60    continue
c--json--        nat = nat-1
c--json--      close(3)

      call json_read_geom(nat, nph, iatph, rat, iphat, ibounc)

c     read mod1.inp
c--json--      open (file='mod1.inp', unit=3, status='old',iostat=ios)
c--json--      call chopen (ios, 'mod1.inp', 'reapot')
c--json--        read (3,10) slog
c--json--        read (3,20) mpot, nph, ntitle, ihole, ipr1, iafolp, ixc, ispec
c--json--        read (3,10) slog
c--json--        read (3,20)  nmix, nohole, jumprm, inters, nscmt, icoul, lfms1,
c--json--     1     iunf
c--json--        do 110 ititle = 1, ntitle
c--json--  110   read (3,10) title(ititle)
c--json--        read (3,10) slog
c--json--        read (3,30)  gamach, rgrd, ca1, ecv, totvol, rfms1
c--json--        read (3,10) slog
c--json--  120   format ( 2i5, 4f13.5)
c--json--        do 130 ip = 0, nph
c--json--  130   read (3,120) iz(ip), lmaxsc(ip), xnatph(ip), xion(ip), folp(ip)
c--json--c       for OVERLAP option
c--json--        read (3,10) slog
c--json--        read (3,20) ( novr(iph), iph=0,nph)
c--json--        read (3,10) slog
c--json--  140   format ( 2i5, f13.5)
c--json--        do 150 iph = 0, nph
c--json--        do 150 iovr = 1, novr(iph)
c--json--  150   read (3,140) iphovr(iovr, iph), nnovr(iovr,iph), rovr(iovr,iph)
c--json--      close(3)

      call json_read_pot(mpot, nph, ntitle, ihole, ipr1, iafolp,
     1       ixc, ispec, nmix, nohole, jumprm, inters, nscmt, icoul,
     2       lfms1, iunf, gamach, rgrd, ca1, ecv, totvol, rfms1,
     3       title, iz, lmaxsc, xnatph, xion, folp, novr,
     4       iphovr, nnovr, rovr )
      
c$$$      call json%load_file('pot.json')
c$$$      if (json_failed()) then   !if there was an error reading the file
c$$$         print *, "failed to read pot.json"
c$$$         stop
c$$$      else
c$$$         call json%get('mpot',   mpot, found)
c$$$                   if (.not. found) call bailout('mpot', 'pot.json')
c$$$         call json%get('nph',    nph, found)
c$$$                   if (.not. found) call bailout('nph', 'pot.json')
c$$$         call json%get('ntitle', ntitle, found)
c$$$                   if (.not. found) call bailout('ntitle', 'pot.json')
c$$$         call json%get('ihole',  ihole, found)
c$$$                   if (.not. found) call bailout('ihole', 'pot.json')
c$$$         call json%get('ipr1',   ipr1, found)
c$$$                   if (.not. found) call bailout('ipr1', 'pot.json')
c$$$         call json%get('iafolp', iafolp, found)
c$$$                   if (.not. found) call bailout('iafolp', 'pot.json')
c$$$         call json%get('ixc',    ixc, found)
c$$$                   if (.not. found) call bailout('ixc', 'pot.json')
c$$$         call json%get('ispec',  ispec, found)
c$$$                   if (.not. found) call bailout('ispec', 'pot.json')
c$$$
c$$$         call json%get('nmix',   nmix, found)
c$$$                   if (.not. found) call bailout('nmix', 'pot.json')
c$$$         call json%get('nohole', nohole, found)
c$$$                   if (.not. found) call bailout('nohole', 'pot.json')
c$$$         call json%get('jumprm', jumprm, found)
c$$$                   if (.not. found) call bailout('jumprm', 'pot.json')
c$$$         call json%get('inters', inters, found)
c$$$                   if (.not. found) call bailout('inters', 'pot.json')
c$$$         call json%get('nscmt',  nscmt, found)
c$$$                   if (.not. found) call bailout('nscmt', 'pot.json')
c$$$         call json%get('icoul',  icoul, found)
c$$$                   if (.not. found) call bailout('icoul', 'pot.json')
c$$$         call json%get('lfms1',  lfms1, found)
c$$$                   if (.not. found) call bailout('lfms1', 'pot.json')
c$$$         call json%get('iunf',   iunf, found)
c$$$                   if (.not. found) call bailout('iunf', 'pot.json')
c$$$
c$$$         call json%get('gamach', gamach, found)
c$$$                   if (.not. found) call bailout('gamach', 'pot.json')
c$$$         call json%get('rgrd',   rgrd, found)
c$$$                   if (.not. found) call bailout('rgrd', 'pot.json')
c$$$         call json%get('ca1',    ca1, found)
c$$$                   if (.not. found) call bailout('ca1', 'pot.json')
c$$$         call json%get('ecv',    ecv, found)
c$$$                   if (.not. found) call bailout('ecv', 'pot.json')
c$$$         call json%get('totvol', totvol, found)
c$$$                   if (.not. found) call bailout('totvol', 'pot.json')
c$$$         call json%get('rfms1',  toss, found)   
c$$$                   if (.not. found) call bailout('rfms1', 'pot.json')
c$$$         rfms1 = real(toss)
c$$$
c$$$         call json%get('titles', strings, found)
c$$$                   if (.not. found) call bailout('titles', 'pot.json')
c$$$         do 1000 itit = 1, nheadx
c$$$            title(itit) = strings(itit)            
c$$$ 1000    continue
c$$$         call json%get('iz', intgs, found)
c$$$                   if (.not. found) call bailout('iz', 'pot.json')
c$$$         do 1010 iph = 0, nphx
c$$$            iz(iph) = intgs(iph+1)            
c$$$ 1010    continue
c$$$         call json%get('lmaxsc', intgs, found)
c$$$                   if (.not. found) call bailout('lmaxsc', 'pot.json')
c$$$         do 1020 iph = 0, nphx
c$$$            lmaxsc(iph) = intgs(iph+1)            
c$$$ 1020    continue
c$$$         call json%get('xnatph', dbpcs, found)
c$$$                   if (.not. found) call bailout('xnatph', 'pot.json')
c$$$         do 1030 iph = 0, nphx
c$$$            xnatph(iph) = dbpcs(iph+1)            
c$$$ 1030    continue
c$$$         call json%get('xion', dbpcs, found)
c$$$                   if (.not. found) call bailout('xion', 'pot.json')
c$$$         do 1040 iph = 0, nphx
c$$$            xion(iph) = dbpcs(iph+1)            
c$$$ 1040    continue
c$$$         call json%get('folp', dbpcs, found)
c$$$                   if (.not. found) call bailout('folp', 'pot.json')
c$$$         do 1050 iph = 0, nphx
c$$$            folp(iph) = dbpcs(iph+1)            
c$$$ 1050    continue
c$$$         call json%get('novr', intgs, found)
c$$$                   if (.not. found) call bailout('novr', 'pot.json')
c$$$         do 1060 iph = 0, nphx
c$$$            novr(iph) = intgs(iph+1)            
c$$$ 1060    continue
c$$$
c$$$c        the following reconstructed all the overlap 2D arrays, see
c$$$c        RDINP/wrtjsn.f line 131 and following
c$$$         do 1200 iph = 0, nph
c$$$            write (vname, "(A6,I1)") "iphovr", iph
c$$$            call json%get(vname, intgs, found)
c$$$                      if (.not. found) call bailout(vname, 'pot.json')
c$$$            do 1220 iovr = 1, novr(iph)
c$$$               iphovr(iovr, iph) = intgs(iovr)
c$$$ 1220       continue
c$$$
c$$$            write (vname, "(A5,I1)") "nnovr", iph
c$$$            call json%get(vname, intgs, found)
c$$$                      if (.not. found) call bailout(vname, 'pot.json')
c$$$            do 1230 iovr = 1, novr(iph)
c$$$               nnovr(iovr, iph) = intgs(iovr)
c$$$ 1230       continue
c$$$
c$$$            write (vname, "(A4,I1)") "rovr", iph
c$$$            call json%get(vname, dbpcs, found)
c$$$                      if (.not. found) call bailout(vname, 'pot.json')
c$$$            do 1240 iovr = 1, novr(iph)
c$$$               rovr(iovr, iph) = dbpcs(iovr)
c$$$ 1240       continue
c$$$ 1200    continue
c$$$
c$$$         call json%destroy()
c$$$      end if

c     transform to code units (bohrs and hartrees - atomic unuts)
      rfms1 = rfms1 / real(bohr)
      gamach = gamach / hart
      ecv   = ecv   / hart
      totvol = totvol / bohr**3
      do 210 iat = 1, nat
      do 210 i = 1,3
        rat(i,iat) = rat (i, iat) / bohr
  210 continue
      do 220 iph = 0, nph
      do 220 iovr = 1, novr(iph)
         rovr(iovr,iph) = rovr(iovr,iph) / bohr
  220 continue

c     add lines to the title
      if (mpot.eq.1) then
         ntitle = ntitle + 1
         if (nat.gt.1) then
           if (rfms1.lt.0) rfms1 = 0
           if (nscmt.gt.0) then
             write(s1, 230) nscmt, rfms1*bohr, lfms1
  230        format(' POT  SCF', i4, f8.4, i4)
           else
             write(s1, 235) 
  235        format(' POT  Non-SCF' )
           endif
         else
           write(s1, 240) 
  240      format(' POT  used OVERLAP geometry,')
         endif
         if (nohole.eq.0) then
           write(s2, 310) 
  310      format(', NO core-hole,')
         elseif (nohole.eq.2) then
           write(s2, 315) 
  315      format(', screened core-hole,')
         else
           write(s2, 320) 
  320      format(', core-hole,')
         endif
         if (iafolp.lt.0) then
           write(s3, 330) folp(0)
  330      format(' FOLP (folp(0)=', f6.3, ')' )
         else
           write(s3, 340) folp(0)
  340      format(' AFOLP (folp(0)=', f6.3, ')' )
         endif
c        concatenate 3 strings into 1
         title(ntitle) = ' '
         ilen = istrln(s1)
         istart = 1
         iend = ilen
         title(ntitle)(istart:iend) = s1(1:ilen)
         ilen = istrln(s2)
         istart = iend + 1
         iend = iend + ilen
         title(ntitle)(istart:iend) = s2(1:ilen)
         ilen = istrln(s3)
         istart = iend + 1
         iend = iend + ilen
         title(ntitle)(istart:iend) = s3(1:ilen)
      endif

      return
      end

program opconsAt
  use atoms_inp
  use potential_inp
  use geometry_inp
  use constants
  use AtomicPotIO
  use opcons_inp
  use par
  use errorfile
  implicit none
  integer iph, NComps ! , nnn, iph2, iX, iY, iZ2, iAt, iAt2
  character(2), allocatable :: Components(:)
  ! character(12), allocatable :: EpsFiles(:)
  character(12), allocatable :: thisfile
  character(2),external :: GetElement
  real(8),allocatable :: rnrm(:)
  real(8) VTot ! , rNN, r, rCnt(3), point(3), x2, y2, z2, dX
  ! REAL(8),PARAMETER :: RTol  = (3.d0)**2
  ! INTEGER,PARAMETER :: NGrid = 200

  character(12) EpsFile
  integer i1, i2, NDataTot, iUnit, NPoles
  integer, parameter :: epsmax = 700
  real(8) thiseps(epsmax,3,0:nphx)
  real(8) energy(epsmax), loss(epsmax)
  real(8) g(10000), gamma, omi(10000), Delta(10000), eps0, sumrl, xNElec, csumrl
  character ch

  logical excinp
  logical write_loss, write_opcons, write_exc, verbose
  write_loss   = .true.
  write_opcons = .true.
  write_exc    = .true.
  verbose      = .true.
  NPoles       = 100
  eps0         = -1.d0
  
  !KJ 1-2012:
  call par_begin
  if (worker) go to 400
  call OpenErrorfileAtLaunch('opconsat')

  !CALL opcons_read
  !IF(.NOT.run_opcons) STOP
  !if (.not. run_opcons) goto 400
  call opcons_init

  call atoms_read
  call potential_read

  allocate(Components(0:nph), rnrm(0:nph), thisfile)
  ! allocate(EpsFiles(0:nph))

  
  call ReadAtomicPots(nph, rnrm)
  if (verbose) print*, 'nph, rnrm', nph, rnrm

  ! Find the number density of each component.
  VTot = 0.d0
  do iph = 0, nph
     VTot = VTot + xnatph(iph)*4.d0/3.d0*pi*(rnrm(iph)*bohr)**3
  end do

  do iph = 0, nph
     if(NumDens(iph).lt.0.d0) NumDens(iph) = xnatph(iph)/VTot
     ! test with numDens = 1. Should give same loss as input file for a single file.
     if(.false.) then
        if(iph.ne.0) then
           NumDens(iph) = 1.d0
        else
           NumDens(iph) = 0.d0
        end if
     end if
     Components(iph) = GetElement(iz(iph))
  end do

  ! Get opcons{Element}.dat from database.
  do iph = 0, nph
     do i1 = 1,epsmax
        do i2 = 1,3
           thiseps(i1,i2,iph) = 0.d0
        end do
     end do
     EpsFile = 'opcons' // trim(adjustl(Components(iph))) // '.dat'
     if (verbose) print*, Components(iph), NumDens(iph), EpsFile
     call epsdb(iz(iph), thiseps(:,:,iph))
     if (write_opcons) call write_eps(iz(iph), thiseps(:,:,iph), EpsFile)
  end do

  NComps = nph + 1
  call AddEps(NComps, NumDens, thiseps, NDataTot, energy, loss)
  
  ! Open output file and write data.
  if (write_loss) then
     call OpenFl('loss.dat')
     call GetIOFileInfo('loss.dat', UnitNumber = iUnit)
     write(iUnit,'(A)') '# E(eV)    Loss'
     do i1 = 1, NDataTot
        write(iUnit,*), energy(i1), loss(i1)
     end do
     call CloseFl('loss.dat')
  end if
  
  deallocate(Components, rnrm, thisfile)


  !! sumrl, xNElec, gamma, and csumrl -- a bit cryptic
  sumrl = 1.d0
  xNElec = 1.d0
  inquire( file='exc.inp', exist=excinp ) 
  if (excinp) then
     open(unit=61, file='exc.inp', status='old')
     read(61,*) NPoles
     read(61,*) ch
     if (ch.eq.'y'.or.ch.eq.'Y') then
        eps0 = -1.d0
     else
        read(61,*) ch
        if(ch.eq.'n'.or.ch.eq.'N') then
           eps0 = -2.d0
        else
           read(61,*) eps0
        end if
     end if
     close(61)
  else
     print*, '# Enter number of poles:'
     read*, NPoles
     print*, 'Is this a metal? (y/n)'
     read*, ch
     if(ch.eq.'y'.or.ch.eq.'Y') then
        eps0 = -1.d0
     else
        print*, 'Would you like to set the dielectric constant? (y/n)'
        read*, ch
        if(ch.eq.'n'.or.ch.eq.'N') then
           eps0 = -2.d0
        else
       
           ! This input can be used to correct the dielectric constant,
           ! which is related to the inverse moment.
           ! Use eps0 = -2 to ignore this correction.
           print*, '# Enter dielectric constant: '
           read*, eps0
        end if
     end if
     if (verbose) print*, eps0
  end if
  
  gamma = 0.01
  csumrl= xNElec/sumrl
  do i1 = 1, NDataTot
     loss(i1) = loss(i1)*csumrl
  end do

  ! getomi finds poles and weights
  call getomi(energy, loss, NDataTot, NPoles, omi, g, Delta, eps0)

  if (write_exc) then
     open(unit=13,file='exc.dat',status='replace')
     write(13,'(A33,I4,A6)') '# Loss function represented with ', NPoles, ' poles'
     write(13,'(A23,f8.4)') '# Dielectric constant: ', eps0
     do i1 = 1, NPoles
        write(13,'(4f20.10)'), omi(i1), omi(i1)*gamma, g(i1), Delta(i1)
     end do
     close(13)
  end if
  
  !KJ 1-2012:
400 call par_barrier
  call par_end
  call WipeErrorfileAtFinish
  stop


end program opconsAt

      subroutine mpprmd (npat, ipat, ri, beta, eta)
c     double precision version so angles come out right
c     for output...

c     Used with pathsd, a single precision code, so BE CAREFUL!!
c     No implicit, all variables declared explicitly.

c     make path parameters, ie, ri, beta, eta for each leg for a given
c     path.

c     Input is list of atoms (npat, ipat(npat)), output is
c     ri(npat+1), beta, eta.

      dimension ipat(npat)
      include 'dim.h'

c     /atoms/ is single precision from pathsd
      common /atoms/ rat(3,0:natx), ipot(0:natx), i1b(0:natx)

      complex*16  coni
      parameter (coni = (0,1))

      complex*16  alph(npatx+1), gamm(npatx+2), eieta
      double precision beta(npatx+1)
      double precision ri(npatx+1), eta(npatx+1)

      double precision x, y, z
      double precision ct, st, cp, sp, ctp, stp, cpp, spp
      double precision cppp, sppp

      n = npat + 1
      do 100  j = 1, n

c        get the atoms in this path
c        we actually have them already via the ipat array
c        remember that we'll want rat(,npat+1)=rat(,0) and
c                                 rat(,npat+2)=rat(,1) later on
c        make alpha, beta, and gamma for point i from 1 to N
c        NB: N is npat+1, since npat is number of bounces and N is
c            number of legs, or think of N=npat+1 as the central atom
c            that is the end of the path.
c
c        for euler angles at point i, need th and ph (theta and phi)
c        from rat(i+1)-rat(i)  and  thp and php
c        (theta prime and phi prime) from rat(i)-rat(i-1)
c
c        Actually, we need cos(th), sin(th), cos(phi), sin(phi) and
c        also for angles prime.  Call these  ct,  st,  cp,  sp   and
c                                            ctp, stp, cpp, spp.
c
c        We'll need angles from n-1 to n to 1,
c        so use rat(n+1) = rat(1), so we don't have to write code
c        later to handle these cases.

c        i = ipat(j)
c        ip1 = ipat(j+1)
c        im1 = ipat(j-1)
c        except for special cases...
         if (j .eq. n)  then
c           j central atom, j+1 first atom, j-1 last path atom
            i = 0
            ip1 = ipat(1)
            im1 = ipat(npat)
         elseif (j .eq. npat)  then
c           j last path atom, j+1 central, j-1 next-to last atom
c              unless only one atom, then j-1 central
            i = ipat(j)
            ip1 = 0
            if (npat .eq. 1)  then
               im1 = 0
            else
               im1 = ipat(npat-1)
            endif
         elseif (j .eq. 1)  then
c           j first atom, j+1 second unless only one,
c           then j+1 central, j-1 central
            i = ipat(j)
            if (npat .eq. 1)  then
               ip1 = 0
            else
               ip1 = ipat (j+1)
            endif
            im1 = 0
         else
            i = ipat(j)
            ip1 = ipat(j+1)
            im1 = ipat(j-1)
         endif

         x = rat(1,ip1) - rat(1,i)
         y = rat(2,ip1) - rat(2,i)
         z = rat(3,ip1) - rat(3,i)
         call strigd (x, y, z, ct, st, cp, sp)
         x = rat(1,i) - rat(1,im1)
         y = rat(2,i) - rat(2,im1)
         z = rat(3,i) - rat(3,im1)
         call strigd (x, y, z, ctp, stp, cpp, spp)

c        cppp = cos (phi prime - phi)
c        sppp = sin (phi prime - phi)
         cppp = cp*cpp + sp*spp
         sppp = spp*cp - cpp*sp

c        alph = exp**(i alpha)  in ref eqs 18
c        beta = cos(beta)
c        gamm = exp**(i gamma)
         alph(j) = st*ctp - ct*stp*cppp - coni*stp*sppp
         beta(j) = ct*ctp + st*stp*cppp
c        Watch out for roundoff errors
         if (beta(j) .lt. -1)  beta(j) = -1
         if (beta(j) .gt.  1)  beta(j) =  1
         gamm(j) = st*ctp*cppp - ct*stp + coni*st*sppp
         ri(j) = sdist (rat(1,i), rat(1,im1))
  100 continue

c     Make eta(i) = alpha(i) + gamma(i+1).  We only really need
c     exp(i*eta)=eieta, so that's what we'll calculate.
c     We'll need gamm(N+1)=gamm(npat+2)=gamm(1)
      gamm(npat+2) = gamm(1)
      do 150  j = 1, npat+1
         eieta = alph(j) * gamm(j+1)
         call sargd (eieta, eta(j))
  150 continue

c     Return beta as an angle, ie, acos(beta).  Check for beta >1 or
c     beta <1 (roundoff nasties)
      do 160  j = 1, npat+1
         if (beta(j) .gt.  1)  beta(j) =  1
         if (beta(j) .lt. -1)  beta(j) = -1
         beta(j) = acos(beta(j))
  160 continue

      return
      end
      subroutine strigd (x, y, z, ct, st, cp, sp)
      double precision x, y, z, ct, st, cp, sp, r, rxy
c     returns cos(theta), sin(theta), cos(phi), sin(ph) for (x,y,z)
c     convention - if x=y=0, phi=0, cp=1, sp=0
c                - if x=y=z=0, theta=0, ct=1, st=0
      parameter (eps = 1.0e-6)
      r = sqrt (x**2 + y**2 + z**2)
      rxy = sqrt (x**2 + y**2)
      if (r .lt. eps)  then
         ct = 1
         st = 0
      else
         ct = z/r
         st = rxy/r
      endif
      if (rxy .lt. eps)  then
         cp = 1
         sp = 0
      else
         cp = x / rxy
         sp = y / rxy
      endif

      return
      end
      subroutine sargd (c, th)

      double precision x, y, th
      complex*16  c
      parameter (eps = 1.0e-6)
      x = dble(c)
      y = dimag(c)
      if (abs(x) .lt. eps)  x = 0
      if (abs(y) .lt. eps)  y = 0
      if (abs(x) .lt. eps  .and.  abs(y) .lt. eps)  then
         th = 0
      else
         th = atan2 (y, x)
      endif
      return
      end

c     sub-pro exchange point
      program ffmod1
c     subroutine ffmod1

c     calculate  el. density and potential given atomic positions for
c     cluster atoms or other similar information
c     calculation can vary in complexity: self-consistency (on/off),
c     spin dependency (on/off), etc..
c       coded by a.l. ankudinov 2000, for modular code structure
c       modified by a.l. ankudinov 2001, for new i/o structure

c     INPUT files: mod1.inp, geom.dat
c     OUTPUT file: pot.pad

      implicit double precision (a-h, o-z)
      include '../HEADERS/dim.h'
      include '../HEADERS/parallel.h'
      real*8 wall_start, wall_end

c     use feff8.2 manual to get more information about each CARD
cc    mod1.inp
        character*80 title(nheadx)
        integer mpot, nph, ntitle, ihole, ipr1, iafolp, ixc, ispec,
     1     iunf, nmix, nohole, jumprm, inters, nscmt, icoul, lfms1
        integer iz(0:nphx), lmaxsc(0:nphx)
        real rfms1
        double precision gamach, rgrd, ca1, ecv, totvol
        double precision  xnatph(0:nphx), folp(0:nphx),  xion(0:nphx)
c       CONTROL mpot
c       RGRID  rgrd
c       TITLE title
c        ntitle: number of title lines(default:0)
c        title:  title lines(default:none)
c       PRINT   ipr1:   print option (default:0)
c       EXAFS, XANES, DANES, FPRIME, XES
c        ispec: type of spectroscopy (default:0-EXAFS)
c       NOHOLE: turn on/off core-hole potential
c       HOLE  ihole: index of core-hole orbital
c        gamach: core hole lifetime
c       POTENTIALS card
c        nph  - number of different potential types(default:1)
c        iz - nicleus charge for each potential charge(default:none)
c        lmaxsc - max orb momentum to calculate (default:3)
c        xnatph - relative amount of atoms of each type (default:1)
c       ION card
c        xion - total initial charge for each potential type
c               (iz + el.charge) which might be fractional (default:0)
c       EXCHANGE card: ixc=2 for potential calculation
c       JUMPRM: turn on potential jump removal at mt radius (default:0)
c       AFOLP iafolp: turn on/off automatic overlap of muffintin spheres
c       FOLP  folp: manual setting for overlapping muffin-tin spheres
c       INTERSTITIAL inters (default:0)  totvol (default:0)
c       SCF rfms1 lfms1 nscmt ca1 nmix ecv  icoul 
c       OVERLAP geometry ( rarely used for EXAFS calculations only)
        integer novr(0:nphx), iphovr(novrx,0:nphx), nnovr(novrx,0:nphx)
        double precision  rovr(novrx,0:nphx)

cc    geom.dat
        integer  nat, iatph(0:nphx), iphat(natx)
        double precision  rat(3,natx)
c       ATOM card
c         nat: number of atoms in a clsuter
c         rat: x,y,z coordinates of all atoms
c         iphat: which potential type correspond to each atom
c         iatph: index of representative atom for each potential type

        
        double precision rnrmav, xmu, vint, rhoint, emu, s02, erelax
        double precision wp, rs, xf, qtotel
c       r mesh index just inside rmt
        dimension imt(0:nphx)
c       r mesh index just inside rnorman
        dimension inrm(0:nphx)
c       muffin tin radius
        dimension rmt(0:nphx)
c       norman radius
        dimension rnrm(0:nphx), qnrm(0:nphx)
c       folp(0:nphx)  - overlap factor for rmt calculation
        dimension folpx(0:nphx)
c       need irregular solution for complex potential. fix later
        dimension dgc0(251), dpc0(251)
c       additioal data needed for relativistic version
        dimension dgc(251,30,0:nphx+1), dpc(251,30,0:nphx+1)
        dimension adgc(10,30,0:nphx+1), adpc(10,30,0:nphx+1)
c       Overlap calculation results
c       overlapped density*4*pi
        dimension edens(251,0:nphx)
c       overlapped coul pot
        dimension vclap(251,0:nphx)
c       overlapped total potential
        dimension vtot (251,0:nphx)
        dimension edenvl(251,0:nphx)
        dimension vvalgs (251,0:nphx)
        dimension dmag(251,0:nphx+1)
        dimension xnval(30,0:nphx+1)
        dimension eorb(30,0:nphx+1)
        dimension kappa(30,0:nphx+1), iorb(-4:3,0:nphx+1)
        dimension xnmues(0:lx,0:nphx)
c       Josh use nhtmp to save nohole value
        integer nhtmp


      call par_begin

c     Initialize clock
      call seconds(wall_start)
      wall_comm = 0.0d0

c     open the log file, unit 11.  See subroutine wlog.
      if (master) then
        open (unit=11, file='log1.dat', status='unknown', iostat=ios)
        call chopen (ios, 'log1.dat', 'feff')
      else
        par_type = 2
      endif


c     INPUT: read data in pot.inp  and geom.dat files
c     and transform it to atomic hartree units
      call reapot (mpot, rgrd, ntitle, title, ipr1, ispec,
     1           nohole, ihole, gamach, nph, iz, lmaxsc, xnatph,
     2           xion, iunf, ixc, jumprm, iafolp, folp, inters, totvol,
     3           rfms1, lfms1, nscmt, ca1, nmix, ecv, icoul,
     4           novr, iphovr, nnovr, rovr,
     5           nat, rat, iphat, iatph)

      if (mpot .eq. 1)  then
         call wlog(' Calculating potentials ...')

c$$$         print *, rgrd, nohole,
c$$$     $          inters, totvol, ecv, nscmt, nmix, ntitle,
c$$$     $          nat, nph, ihole, iafolp, ixc
c$$$         print *, 1, rat(1,1), rat(2,1), rat(3,1), iphat(1)
c$$$         print *, 2, rat(1,2), rat(2,2), rat(3,2), iphat(2)
c$$$         print *, 3, rat(1,3), rat(2,3), rat(3,3), iphat(3)
c$$$         print *, 13, rat(1,13), rat(2,13), rat(3,13), iphat(13)
c$$$         print *, 23, rat(1,23), rat(2,23), rat(3,23), iphat(23)

         call pot (.true., rgrd, nohole,
     $          inters, totvol, ecv, nscmt, nmix, ntitle, title,
     $          nat, nph, ihole, iafolp, ixc, iphat, rat, iatph,
     $          xnatph, novr, iphovr, nnovr, rovr,
     $          folp, xion, iunf, iz, ipr1, ispec, jumprm,
     $          lmaxsc, icoul, ca1, rfms1, lfms1,
     $
     -          rnrmav, xmu, vint, rhoint,
     1          emu, s02, erelax, wp, rs, xf, qtotel,
     2          imt, rmt, inrm, rnrm, folpx,
     3          dgc0, dpc0, dgc, dpc, adgc, adpc,
     4          edens, vclap, vtot, edenvl, vvalgs, dmag, xnval,
     5          eorb, kappa, iorb, qnrm, xnmues, nhtmp
     6    )
c        return stuff for wrpot
c                  gamach
c        write stuff into pot.pad
         call wrpot (nph, ntitle, title, rnrmav, xmu, vint, rhoint,
     1          emu, s02, erelax, wp, ecv, rs, xf, qtotel,
     2          imt, rmt, inrm, rnrm, folp, folpx, xnatph,
     3          dgc0, dpc0, dgc, dpc, adgc, adpc,
     3          edens, vclap, vtot, edenvl, vvalgs, dmag, xnval,
     4          eorb(1,0), kappa(1,0), iorb, qnrm, xnmues, nhtmp,
     5          ihole, inters, totvol, iafolp, xion, iunf, iz, jumprm)
         
c        write misc.dat
         if (ipr1 .ge. 1)  then
            open (unit=1, file='misc.dat', status='unknown', iostat=ios)
            call chopen (ios, 'misc.dat', 'potph')
            call wthead(1, ntitle, title)
            close (unit=1)
         endif

         call wlog(' Done with module 1: potentials. ')
      endif

c     OUTPUT: subroutine pot writes main output file pot.pad
c     with information on potentials, necessary for other modules;
c     additional output files can be obtained using PRINT card

      if (master) close (unit=11)

c--   Time at end of run
      call seconds(wall_end)
      if (master .and. parallel_run) then
        write (6,*) 'total time    ', wall_end - wall_start
        write (6,*) 'communicate time', wall_comm
      endif
      call par_end

c     sub-pro exchange point
      stop
c     return
      end

      subroutine bjnser (x, l, jl, nl, ifl)

c-----------------------------------------------------------------------
c
c     subroutine: bjnser (x,l,jl,nl,ifl)
c
c     purpose:  to calculate the spherical bessel functions jl and nl
c
c     arguments:
c       x = argument of jl and nl
c       l = l value calculated (no offset)
c       jl = jl bessel function (abramowitz conventions)
c       nl = nl bessel function (abramowitz yl conventions)
c       ifl = 0 return both jl and nl
c             1 return jl only
c             2 return nl only
c
c     notes:  jl and nl are calculated by a series
c             expansion according to 10.1.2 and 10.1.3
c             in abramowitz and stegun (ninth printing),
c             page 437
c
c             error msgs written with PRINT statements.
c
c     first coded by r. c. albers on 26 jan 83
c
c     version 2
c
c     last modified: 27 jan 83 by r. c. albers
c
c-----------------------------------------------------------------------

      implicit double precision (a-h,o-z)

      complex*16 x,u,ux,del,pj,pn
      complex*16 jl,nl

      parameter (niter = 20, tol = 1.e-15)

       if (l .lt. 0) then
          call echo('Error in bjnser: l<0')
       elseif (dble(x).lt. 0.) then
          call echo('Error in bjnser: x<0')
       else 
          lp1 = l+1
          u = x**2 / 2

c     make djl = 1 * 3 * 5 * ... * (2*l+1),
c          dnl = 1 * 3 * 5 * ... * (2*l-1)
          djl = 1
          fac = -1
          do 50 il = 1, lp1
             fac = fac + 2
             djl = fac * djl
 50       continue
          dnl = djl / (2*l+1)


          if (ifl .eq. 2)   goto 90
c      make jl
c     pj is term in { } in 10.1.2, del is last factor in the series
c     convergence test is (last factor)/(total term) <= tol
          pj = 1
          nf = 1
          nfac = 2*l + 3
          den = nfac
          sgn = -1
          ux = u
          do 60 il = 1, niter
             del = sgn*ux / den
             pj = pj + del
             trel = abs (del / pj)
             if (trel .le. tol)  goto 80
             sgn = -sgn
             ux = u*ux
             nf = nf+1
             nfac = nfac+2
             den = nf * nfac * den
 60       continue
          call echo('Error in bjsner: jl does not converge')
 80       jl = pj * (x**l) / djl

 90       if (ifl.eq.1) return
c     make nl
c      pn is term in { } in 10.1.3, del is last factor in the series
c     convergence test is (last factor)/(total term) <= tol
          pn = 1
          nf = 1
          nfac = 1 - 2*l
          den = nfac
          sgn = -1
          ux = u
          do 100  il = 1, niter
             del = sgn * ux / den
             pn = pn + del
             trel = abs (del / pn)
             if (trel .le. tol) goto 120
             sgn = -sgn
             ux = u*ux
             nf = nf+1
             nfac = nfac+2
             den = nf * nfac * den
 100      continue
          call echo('Error in bjnser: nl does not converge')
 120      continue 
          nl = -pn * dnl / (x**lp1)
       endif

      return
      end

      subroutine ff2xmu (ispec, ipr4, idwopt, critcw, s02, sig2g,
     1                   tk, thetad, mbconv, absolu,  !KJ added absolu 3-06
     1                   vrcorr, vicorr, alphat, thetae, iabs, nabs,
     4            ipmin,ipmax,ipstep)   !KJ added this line 1-06
c     adds the contributions from each path and absorber, including
c     Debye-Waller factors. Writes down main output: chi.dat and xmu.dat
      implicit double precision (a-h, o-z)

      include '../HEADERS/const.h'
      include '../HEADERS/dim.h'
      parameter (eps4 = 1.0d-4)
      integer ipmin,ipmax,ipstep !KJ my variables 1-06
      integer absolu !KJ 3-06

c     header from list.dat
      dimension lhead(nheadx)
      character*80  head(nheadx)
      complex*16 gtr(nex),gtrful(ipmin:ipmax,nex) !KJ added gtrful 1-06

      parameter (npx=15000)
!KJ      parameter (npx = 1200)
c     indices of paths to do, read from list.dat
      dimension ip(npx)
      real sig2u(npx)

      complex*16 cchi(nex), ckp
c     to keep Im part of cchi 11.18.97 ala
      dimension rchtot(nex), xkp(nex)
      complex*16 chia(nex)

      logical dwcorr
      character*512 slog
      character*2 coment
      parameter (coment='# ')

c     Stuff from feff.pad, note that floating point numbers are
c     single precision.  Be careful throughout this routine, especially
c     when passing things to subroutines or intrinsic functions.
      real rnrmav, xmu, edge
      character*80 title(nheadx), titfms
      character*6  potlbl(0:nphx)
      dimension iz(0:nphx)
c     central atom phase shift at l0
      complex phc(nex)
      complex ck(nex)
      real xk(nex)
      dimension index(npx)
      dimension nleg(npx)
      real deg(npx), reff(npx), crit(npx)
      dimension ipot(legtot,npx)
      real rat(3,legtot,npx), beta(legtot,npx), eta(legtot,npx)
      real ri(legtot,npx)
      real achi(nex,npx), phchi(nex,npx)

c     stuff from xsect.bin
      complex*16 emxs(nex), xsec(nex)
      dimension omega(nex), xkxs(nex), xsnorm(nex)

c !KJ locals  1-06
      integer iip,nip
      logical cross
      character*9 f1,f2
      character*10 f0,f3
      complex*16 gtrtemp(nex*(1+ipmax-ipmin))
      complex*16 kxsec(nex)
c !KJ end my variables


c     get gtr - result of FMS
      do 112 ie =1,nex
      gtr(ie)= 0
      do 112 iip =ipmin,ipmax  !KJ I added this variable ip 1-06
  112 gtrful(iip,ie) = 0
      ntfms = 0
      nip=ipmax-ipmin+1 !KJ 1-06

      open (unit=1, file='fms.bin', status='old', iostat=ios)
      if (ios.le.0) then
         ntfms = 1
         read(1, 113) titfms
  113    format(a)
         read(1, 115) ne, ne1, ne3, nph, npadx
  115    format(5(1x,i3))
         call rdpadx(1, npadx, gtrtemp, ne*nip)  !KJ I added *nip, changed gtr to gtrtemp  1-06
      endif
      close (unit=1)
!KJ Next lines my addition to read several spectra at once. 1-06
      i=1
      do iip=ipmin,ipmax
         do j=1,ne
            gtrful(iip,j)=gtrtemp(i+j-1)
         enddo
         i=i+ne
      enddo
c KJ Now we don't need gtrtemp anymore.  End my changes



c     read xsect.bin file
      call  rdxbin (s02p, erelax, wp, edgep, s02, gamach, ne1, ik0,
     2  emxs, omega, xkxs, xsnorm, xsec, nxsec, mbconv, title, ntitle)


c !KJ loop over iip added to process several spectra at once  1-06
c !KJ reading of feff.pad moved inside the loop (used to be before reading
c !KJ xsect.bin
      do iip=ipmin,ipmax,ipstep
        cross=(.not.(iip.eq.1.or.iip.eq.10.or.iip.eq.5.or.iip.eq.9))

c !KJ choose different filename for each spectrum.
        if(iip.eq.1) then
           f1(1:9)='chi.dat  '
           f2(1:9)='xmu.dat  '
           f0(1:10)='feff.pad  '
           f3(1:10)='list.dat  '
        elseif(iip.eq.10) then
           f1(1:9)='chi10.dat'
           f2(1:9)='xmu10.dat'
           f0(1:10)='feff10.bin'
           f3(1:10)='list10.dat'
        elseif(iip.gt.1.and.iip.lt.10) then
           f1(1:4)='chi0'
           f1(5:5)= char(48+iip)
           f1(6:9)='.dat'
           f2(1:4)='xmu0'
           f2(5:5)= char(48+iip)
           f2(6:9)='.dat'
           f0(1:5)='feff0'
           f0(6:6)= char(48+iip)
           f0(7:10)='.bin'
           f3(1:5)='list0'
           f3(6:6)= char(48+iip)
           f3(7:10)='.dat'
        else
           stop 'crazy iip in ff2xmu'
        endif
        do i=1,nex
           gtr(i)=gtrful(iip,i)
        enddo

c     open list.dat and read list of paths we want
      open (unit=1, file= f3, status='old', iostat=ios)!KJ changed 'list.dat' to f3 4-06
      ntotal = 0
      if (ios.le.0) then
        call chopen (ios, f3, 'ff2afs')  !KJ id.
        nhead = nheadx
        call rdhead (1, nhead, head, lhead)
c       skip a label line
        read(1,*)
c       ip is index of path, sig2u is debye-waller from user
        do 100  i = 1, npx
           read(1,*,end=110)  ip(i), sig2u(i)
           ntotal = i
  100   continue
  110   continue
      endif
      close (unit=1)


       call rdfbin (f0, nphx, nex, npx, legtot, !KJ changed 'feff.pad' to f0  1-06
     $     nptot, ne, npot, ihole, iorder, ilinit,
     $     rnrmav, xmu, edge, potlbl, iz, phc, ck, xk,
     $     index, nleg, deg, reff,
     $     crit, ipot, rat, beta, eta, ri, achi, phchi)

c     make combined title
      if (ntfms.eq.1) then
        ntitle = ntitle + 1
        title(ntitle) = titfms
      endif
      do 120 ihead = 1, nhead
 120  title(ntitle+ihead) = head(ihead)
      ntitle = ntitle + nhead

c     write feffnnnn.dat
      if (ipr4.eq.3) then
         call feffdt(ntotal,ip,nptot,ntitle,title,ne,
     $        iorder, ilinit, rnrmav, edge, potlbl,
     $        iz,phc,ck,xk,index,
     $        nleg,deg,reff,crit,ipot,rat,achi,phchi)
       end if

c     If there is a vicorr, will need a mean free path factor xlam0.
c     Use it as  chi(ie) * exp (2 * reff * xlam0)
c     ckp is ck' = ck prime.
      if (abs(vicorr) .ge. eps4) then
         do 180  ie = 1, ne
            ckp = sqrt (ck(ie)**2 + coni*2*vicorr)
            xlam0 = aimag(ck(ie)) - dimag(ckp)
            do 170  ipath = 1, nptot
               achi(ie,ipath) = achi(ie,ipath) *
     1               real(exp (2 * reff(ipath) * xlam0))
  170       continue
  180    continue
      endif

c     k'**2 = k**2 + vr. If there is no real correction
c     (vrcorr = 0), these two grids will be the same.
c           k' is value for output,  k is  value used for
c           interpolations with original grid.

c     vrcorr shifts the edge and the k grid
      if (abs(vrcorr) .gt. eps4)  then
         edge = edge - real(vrcorr)
      endif

c     ik0 is index at fermi level
      do 250  i = 1, ne
         temp = xk(i)*abs(xk(i)) + 2*vrcorr
         if (temp.ge. 0) then
           xkp(i) = sqrt(temp)
         else
           xkp(i) = - sqrt(-temp)
         endif
  250 continue


      dwcorr = .false.
      if (tk .gt. 1.0e-3)  dwcorr = .true.

c     Open chi.dat and xmu.dat (output) and start headers
      if (iabs.eq.nabs) then
         open (unit=3, file=f1, status='unknown', iostat=ios) !KJ changed chi.dat to f1
         call chopen (ios, f1, 'ff2chi') !KJ id.  1-06
         open (unit=8, file=f2, status='unknown', iostat=ios) !KJ changed xmu.dat to f2
         call chopen (ios, f2, 'ff2chi') !KJ id.

c        write miscellaneous staff into headers  !KJ corrected typo
         call wrhead (8, ntitle, title, dwcorr, s02,
     1     tk, thetad, sig2g, alphat, vrcorr, vicorr, critcw)

c        also write information on the screen
         if (alphat .gt. zero)  then
            write(slog,322) alphat
  322       format ('    1st and 3rd cumulants, alphat = ', 1pe20.4)
            call wlog(slog)
         endif
         if (abs(vrcorr).ge.eps4 .or. abs(vicorr).ge.eps4)  then
            write(slog,343) vrcorr*hart, vicorr*hart
  343       format ('    Energy zero shift, vr, vi ', 1p, 2e14.5)
            call wlog(slog)
         endif

         write(slog,370) critcw
         call wlog(slog)
  370    format ('    Use all paths with cw amplitude ratio', f7.2, '%')
         if (dwcorr)  then
            write(slog,380) s02, tk, thetad, sig2g
            call wlog(slog)
         else
            write(slog,381) s02, sig2g
            call wlog(slog)
         endif
  380    format('    S02', f7.3, '  Temp', f8.2, '  Debye temp', f8.2,
     1           '  Global sig2', f9.5)
  381    format('    S02', f7.3, '  Global sig2', f9.5)
      endif


c     make chi and sum it
      do 400  i = 1, nex
         cchi(i) = 0
  400 continue
      do 402  ik = 1, ne
         cchi(ik)= s02 * gtr(ik)
  402 continue


c     add Debye-Waller factors
      call dwadd (ntotal, nptot, idwopt, ip, index, crit, critcw, sig2g,
     1  sig2u, dwcorr, rnrmav, nleg, deg, reff, iz, ipot, rat,tk,thetad,
     2  alphat, thetae, mbconv, s02, ne1, ck, achi, phchi, ne, xk, xkp,
     3  xkp, cchi, iabs, nabs, ispec, ipr4, ntitle,
     4  title, vrcorr, vicorr,  nused)

c     read or initialize chia - result of configuration average
      if (iabs.eq.1) then
         do 635 ie =1, nex
            chia(ie) = 0
  635    continue
      else
         open (unit=1, file='chia.bin', status='old',
     1   access='sequential', form='unformatted', iostat=ios)
         do 640 ie = 1,ne
  640    read(1) chia(ie)
         close (unit=1, status='delete')
      endif

      if(iabs.eq.1) then
c        compare grids in xsect.bin and feff.pad
         do 680 i = 1, nxsec
            print *, del, xk(i)**2, xkxs(i)**2
           del = xk(i)**2 - xkxs(i)**2
           if (abs(del) .gt.  10*eps4)  then
             call wlog(' Emesh in feff.pad and xsect.bin different.')
             call par_stop('FF2XMU-1')
           endif
  680    continue
      endif

c     add contribution from an absorber iabs
c     present scheme assumes that xsec is the same for all iabs.
      do 701 ik = 1, ne
         chia(ik)   = chia(ik)   + cchi(ik)/ nabs
  701 continue
      if (iabs.lt.nabs) then
c        save chia in chia.bin for averaging
         open (unit=1, file='chia.bin', status='unknown',
     1   access='sequential', form='unformatted', iostat=ios)
         do 760 ie=1,ne
  760    write(1) chia(ie)
         close(unit=1)
      endif

      if (iabs.eq.nabs) then
c        The loop over absorbers is finished. Write out the results.
         write(8,600)  coment, nused, ntotal
  600    format ( a2, 1x, i4, '/', i4, ' paths used')
  610    format ( a2, 1x, 71('-'))

         do 702 ik = 1, ne
            rchtot(ik) = dimag (chia(ik))
  702    continue
c        prepare the output grid omega
         efermi = edge + omega(1) - dble(emxs(1))

c        do convolution with excitation spectrum
         if (mbconv .gt. 0) then
            wp = wp / 2.
            call  exconv
     1      (omega, ne1, efermi, s02p, erelax, wp, xsnorm)
            call  exconv
     1      (omega, ne1, efermi, s02p, erelax, wp, rchtot)
         endif

c        normalize to xsec at 50 eV above edge
c        and prepare the output energy grid omega
         edg50 = efermi + 50 / hart
         if (ispec.eq.2) edg50 = efermi
         call terp (omega, xsnorm,  ne1, 1, edg50, xsedge)
         if (absolu.eq.1) xsedge=dble(1)  !KJ 3-06 don't normalize
         write(8,660)  coment, xsedge
  660    format (a2, ' xsedge+ 50, used to normalize mu ', 1pe20.4)
         write(8,610) coment
         write(8,670) coment
  670    format (a2,' omega    e    k    mu    mu0     chi     @#')


         do i=1,nex
            if (.not.cross) then !KJ I added this block 1-06
               kxsec(i)=xsec(i)
            else
               kxsec(i)=dcmplx(0,0)
            endif               !KJ end my code
         enddo

c        do correction using brouder method
         vi0 = 0
         call xscorr(ispec,emxs, ne1, ne, ik0, kxsec,xsnorm,chia,
     1       vrcorr, vi0, cchi) !KJ changed xsec to kxsec  1-06
         do 850 ie=1,ne1
           rchtot(ie)=dimag( kxsec(ie)+xsnorm(ie)*chia(ie)+cchi(ie)) !KJ id.
  850    continue


         do 855 ie=1,ne
           chia(ie) = 0
  855    continue
         call xscorr(ispec, emxs, ne1, ne, ik0, kxsec,xsnorm,chia,
     1       vrcorr, vi0, cchi) !KJ changed xsec to kxsec  1-06
         do 856 ie = 1, ne1
 856     cchi(ie) = dimag(kxsec(ie)+cchi(ie)) * coni+rchtot(ie) !KJ id.

         if (vicorr.gt.eps4 .and. ntotal.eq.0) then
c           add correction due to vicorr
            call conv(omega,cchi,ne1,vicorr)
c           call conv(omega,xsec,ne1,vicorr)
         endif


         do 860 ie = 1, ne1
            em0 = dble(emxs(ie))
            xsec0 = dimag(cchi(ie))
            rchtot(ie) = dble (cchi(ie))
            chi0  = (rchtot(ie) - xsec0)/xsedge
            write(8,700)  omega(ie)*hart, em0*hart, xkp(ie)/bohr,
     1              rchtot(ie)/xsedge, xsec0/xsedge, chi0

c           if you want f'' at the output in el. units use next line
c    1          rchtot(ie)*omega(ie)*prefac, xsec0*omega(ie)*prefac, chi0
c   with        prefac = alpinv / 4 / pi /bohr**2

  700       format (1x, 2f11.3, f8.3, 1p, 3e13.5)
  860    continue

         close (unit=8)
         close (unit=3, status='delete')
      endif
c     for if (iabs=abs); or the last absorber

      enddo !KJ of my iip=ipmin,ipmax,ipstep loop  1-06


      return
      end

      subroutine sclmz (rho, lmaxp1, mmaxp1, ileg)
      implicit double precision (a-h, o-z)

c     Set CLM(Z) for current leg.
c     Makes clm(z) (eq B11).  Fills array clmi in /clmz/ for ileg,
c     elements clm(0,0) -> clm(lmax+1,mmax+1).
c     If mmaxp1 > lmaxp1, fills m only to lmaxp1.

c     calculates energy dependent factors
c     c(il,im) = c_l^(m)z**m/m! = c_lm    by recursion
c     c_l+1,m = c_l-1,m-(2l+1)z(c_l,m-c_l,m-1, l ne m
c     c_m,m = (-z)**m (2m)!/(2**m m!) with z = 1/i rho
c
c     To test pw approx, set z = 0

      include 'const.h'
      include 'dim.h'
      include 'clmz.h'

      complex*16 rho(legtot)
      complex*16 z, cmm

      cmm = 1
      z = -coni / rho(ileg)

      clmi(1,1,ileg) = (1,0)
      clmi(2,1,ileg) = clmi(1,1,ileg) - z

      lmax = lmaxp1-1

      do 10  il = 2, lmax
         clmi(il+1,1,ileg) =
     1           clmi(il-1,1,ileg) - z*(2*il-1)*clmi(il,1,ileg)
   10 continue
      mmxp1 = min (mmaxp1, lmaxp1)
      do 20  im = 2, mmxp1
         m = im-1
         imp1 = im+1
         cmm = -cmm * (2*m-1) * z
         clmi(im,im,ileg) = cmm
         clmi(imp1,im,ileg) = cmm * (2*m+1) * (1-im*z)
         do 20  il = imp1, lmax
            l = il-1
            clmi(il+1,im,ileg) = clmi(l,im,ileg) -
     1          (2*l+1) * z * (clmi(il,im,ileg) + clmi(il,m,ileg))
   20 continue

      return
      end

      subroutine phamp (rmt, pu, qu, ck, jl, nl, jlp, nlp, ikap,
     1                  ph, amp)
c     calculate phase shift at mt radius
c     needs to calculate atan of complex variable (coded below)
      implicit double precision (a-h, o-z)
      include '../HEADERS/const.h'
      include '../HEADERS/dim.h'
      external besjn, atan2c

      complex*16 pu, qu, ck,  jl, nl, jlp, nlp, ph, amp
      complex*16 xkr, a, b, factor

c     initialize staff
      xkr = ck*rmt
      isign=1
      if (ikap.lt.0) isign = -1
      a = ck*alphfs
      factor = isign*a/(1+sqrt(1+a**2))

c     find a and b that pu = rmt*(a*jl+b*nl), qu=factor*rmt*(a*jlp+b*nlp)
      a = isign*ck*xkr* (pu*nlp - qu*nl/factor)
      b = isign*ck*xkr* (qu*jl/factor - pu*jlp)

c     pu =  amp * rmt * (jl*cos(ph) - nl*sin(ph))
c     qu =  amp * rmt * (jlp*cos(ph) - nlp*sin(ph)) * factor
c     tan(ph) = - b/a
      b = -b
      call atan2c ( a, b, amp, ph)

      return
      end
      subroutine atancc(temp, phx)
c     phx=atan(temp), for complex numbers
      implicit double precision (a-h, o-z)
      complex*16 temp, phx

      xx = dble (temp)
      yy = dimag(temp)
      if (xx .ne. 0)  then
         alph = (1 - xx**2 - yy**2)
         alph = sqrt(alph**2 + 4*xx**2) - alph
         alph = alph / (2 * xx)
         alph = atan (alph)
      else
         alph = 0
      endif
      beta = (xx**2 + (yy+1)**2) / (xx**2 + (yy-1)**2)
      beta = log(beta) / 4
      phx = dcmplx (alph, beta)

      return
      end

      subroutine atan2c(a, b, ampl, phx)
c     for complex a, b find complex ampl, phx such that:
c     a= ampl*cos(phx)  and  b= ampl*sin(phx)
c     phx=atan(b/a)
      implicit double precision (a-h, o-z)
      parameter (pi = 3.14159 26535 89793 23846 26433d0)
      complex*16 a, b, ampl, phx, temp

      aa = abs(a)
      bb = abs(b)
      if (aa+bb.eq. 0) then
         ampl=0.d0
         phx =0.d0
      elseif ( aa.gt.bb) then
         temp = b/a
         call atancc ( temp, phx)
         ampl = a / cos(phx)
      else
         temp = a/b
         call atancc ( temp, phx)
         phx = pi / 2 - phx
         ampl = b/sin(phx)
      endif

      if (dble(ampl).lt. 0.d0) then
         ampl = -ampl
         phx = phx + pi
      endif

      return
      end

      subroutine polint( xa, ya, n, x, y, dy)
c     draws a polynimial P(x) of order (n-1) through n points.
c     returns y = P(x) and dy - estimate of the error
c     adapted  from numerical recipies in fortran by Press et al.

      implicit double precision (a-h,o-z)
      integer n, nmax
      parameter (nmax=4)
      dimension xa(nmax), ya(nmax), c(nmax), d (nmax)

      ns = 1
      dif = abs (x-xa(1))
      do 10 i=1,n
         dift = abs(x-xa(i))
         if (dift.lt.dif) then
            ns = i
            dif = dift
         endif
         c(i) = ya(i)
         d(i) = ya(i)
  10  continue
      y = ya(ns)
      ns = ns-1
      do 30 m=1,n-1
         do 20 i=1,n-m
            ho = xa(i)-x
            hp = xa(i+m)-x
            w = c(i+1) - d(i)
            den = ho-hp
c
c Use of a pause is a poor idea, not just because it is deprecated, but
c because it's normal use is probably not what is desired here.  The most
c common intepretation of "pause" is to wait for a carriage return as
c acknowledgment.  In this case, it will result in a divide-by-zero segfault
c with an unhelpful error message.
c I have used a functionally equivalent, write/read replacement, but it's
c still the wrong thing to do. -BR
c
c            if (den.eq.0) pause 'failure in polint'
            if (den.eq.0) then
               write( *, * ) 'failure in polint'
               read( *, * ) 
            end if
            den = w/den
            d(i) = hp*den
            c(i) = ho*den
  20     continue
         if (2*ns .lt. n-m) then
            dy = c(ns+1)
         else
            dy = d(ns)
            ns = ns-1
         endif
         y = y + dy
  30  continue

      return
      end

      subroutine gggm( nsp, i0, ipi, ipf, lipotx, g0, tmatrx, g0t, gg,
     1                 toler1, toler2, lcalc, msord)

      implicit real (a-h,o-z)
      implicit integer (i-n)
c  output
c    gg:  (nsp*lx**2, nsp*lx**2, 0:nphasx) submatrix spanning the entire
c          angular momentum basis for each unique potential
c     Lanczos algorithm: Graves-Morris,Salam, Num.Algor.21,p.213(1999)

      include '../HEADERS/dim.h'
      include 'xparam.h'
      integer  i0 (0:nphx),  lipotx(0:nphx)

      parameter (one = 1, zero = 0)
      complex coni
      parameter (coni = (0,1))

c**** array of state kets at current energy
      common /stkets/ lrstat(4, istatx), istate

      complex   tmatrx(nspx, istatx)
c     big work matrices
      complex   g0( istatx, istatx), g0t( istatx, istatx)
      logical lcalc
      dimension lcalc(0:lx)

c     Lanczos method variables
      complex xvec( istatx), wvec(istatx), x0(istatx), x1(istatx)
      complex avec(istatx), bvec(istatx)
      complex r0(istatx), r1(istatx), t0(istatx), t1(istatx)
      complex aa, dd, aw, wa, ww, e0, e1, alpha, beta, theta, q0, q1
c     return matrix containing info about each unique potential
      complex   gg(nspx*(lx+1)**2, nspx*(lx+1)**2, 0:nphasx)

c      notice that in gglu we invert (1-Gt), but here (1-tG).
c     multiply T and G0 matrices together, construct g0t = 1 - T*G0
c     notice that the signs below for g0t ARE correct since 1 is the
c     unit matrix
c     since t is tri-diagonal, this product can be computed in n^2 time
c     also fill up some work matrices for use in eigenvalue and
c     determinant calculations and elsewhere
c     cycle over dimensions of matrix g0t
      do 10 icol = 1,istatx
      do 10 irow = 1,istatx
 10   g0t(irow,icol) = 0

      do 30 icol = 1,istate
        do 20 irow = 1,istate
c         T diagonal contribution T(irow, irow)
          if ( abs( g0(irow, icol)) .gt. toler2 )
     1    g0t(irow,icol)=g0t(irow,icol) + tmatrx(1,irow) * g0(irow,icol) 

c         T off-diagonal contribution T(ist2, irow) in tmatr(2,irow)
c         T off-diagonal contribution T(irow, ist2) in tmatr(2,ist2)
          l1   = lrstat(2,irow)
          m1   = lrstat(3,irow)
          isp1 = lrstat(4,irow)
          m2 = m1+isp1
          if (nsp.eq.2 .and. m2.gt.-l1+1 .and. m2.lt.l1+2) then
c            spin-flip contribution
             ist2 = irow + (-1)**isp1
             if ( abs( g0(ist2, icol)) .gt. toler2)
     1       g0t(irow, icol) = g0t(irow, icol)
     2                   + tmatrx(nsp, ist2) * g0(ist2, icol) 
          endif
 20     continue

c       g0t(icol, icol) = g0t(icol, icol) + one
 30   continue

      do 920 ip=ipi, ipf
        ipart = nsp*(lipotx(ip)+1)**2
        do 910 is1 = 1, ipart
          is2 = is1+i0(ip)
          l1   = lrstat(2,is2)
          if (.not.lcalc(l1)) goto 910

c         start first tier with xvec=0
          istart = -1
          msord = 0
          do 40 is = 1, istate
          bvec(is) = 0
  40      xvec(is) = 0
c         rvec = bvec - A*xvec , in our case bvec(is) = delta_{is,is2}
          bvec(is2) = 1

c         RESTART here if necessary
  50      continue
          istart = istart+1

          if (istart.gt.0) then
            do 60 is = 1, istate
  60        xvec(is) = xvec(is) + x0(is) / q0
            call matvec( istatx,istate,g0t,xvec,avec,1)
            do 70 is = 1, istate
  70        bvec(is) = avec(is) - xvec(is)
            bvec(is2) = bvec(is2) + 1
          endif
          do 80 is = 1,istate
 80       r0(is) = bvec(is)
          do 90 is = 1,istate
 90       x0(is) = 0
          do 95 is = 1, istate
 95       x1(is) = bvec(is)
          call matvec( istatx,istate,g0t,bvec,r1,1)
          msord = msord + 1

c         choose wvec that del and delp close to one
          call cdot( istatx, istate, r0, r0, ww)
          call cdot( istatx, istate, r1, r1, aa)
          call cdot( istatx, istate, r0, r1, wa)
          aw = real(wa) - coni* aimag(wa)
          dd = aa*ww - aw*wa
          if (abs(dd/aa/ww) .lt.1.e-8) then
            do 96 is = 1,istate
  96        wvec(is) = r0(is) / ww
          else
            ww = ( ww - aw ) / dd
            aa = ( wa - aa) / dd
            do 97 is = 1,istate
  97        wvec(is) = r0(is) * aa + r1(is) * ww
          endif
c         update dot products to avoid round off errors
          call cdot( istatx, istate, wvec, r0, e0)
          call cdot( istatx, istate, wvec, r1, e1)
          q0 = 1
          q1 = 1

c         it seems ran out of precision for nit>150
          nitx = 10
          do 500 nit = 1, nitx
            tol = toler1 * abs(q1) /10
cc          Check convergence criteria: |r1| < tol / 10
cc          so mostly code will not exit here
            ipass = 1
            do 98 is = 1, istate
              if ( abs(real(r1(is))).gt.tol) goto 99
              if ( abs(aimag(r1(is))).gt.tol) goto 99
  98        continue
            ipass = 0
  99        continue
            if (ipass.eq.0) then
              do 100 is = 1, istate
 100          xvec(is) = xvec(is) + x1(is) / q1
              goto 700
            endif

            alpha = e1 / e0
            do 130 is = 1, istate
 130        t0(is) = r1(is) - alpha* r0(is)
            call matvec( istatx,istate,g0t,t0,t1,1)
            msord = msord + 1

            call cdot( istatx, istate, t0, t1, wa)
            call cdot( istatx, istate, t0, t0, ww)
            call cdot( istatx, istate, t1, t1, aa)
            aw = real(wa) - coni* aimag(wa)
            theta = (wa - aa) / (ww - aw)

            do 145 is = 1, istate
 145        r0(is) = t1(is) - theta * t0(is)
            dd = 1- theta
            do 150 is = 1, istate
 150        x0(is) = t0(is) + dd * (x1(is) - alpha*x0(is))
            q0 = dd * (q1 - alpha*q0)
            tol = toler1 * abs(q0)

cc          Check convergence criteria: |r0| < tol
            ipass = 1
            do 370 is = 1, istate
              if ( abs(real(r0(is))).gt.tol) goto 380
              if ( abs(aimag(r0(is))).gt.tol) goto 380
 370        continue
            ipass = 0
 380        continue
            if (ipass.eq.0) then 
              do 390 is = 1, istate
 390          xvec(is) = xvec(is) + x0(is) / q0
              goto 700
            endif

c           prepare for next iteration
            call cdot( istatx, istate, wvec, r0, e0)
            beta = e0 / e1
            do 255 is = 1, istate
 255        t0(is) = r0(is) - beta * r1(is)
            call matvec( istatx,istate,g0t,t0,avec,1)
            msord = msord + 1
            dd = beta * theta
            do 260 is = 1, istate
 260        r1(is) = avec(is) + dd * r1(is)
            call cdot( istatx, istate, wvec, r1, e1)

            dd = beta * (1-theta)
            do 270 is = 1, istate
 270        x1(is) = x0(is) - dd * x1(is) + t0(is)
            q1 = q0 - (1-theta) * beta * q1
 500      continue
c         restart since ran out of iterations
          goto 50

c         exit if tolerance has been achieved
 700      continue
c         end of GM iterations

c         at this point xvec = (1-tG)**-1 * bvec  with chosen tolerance
c         pack FMS matrix into an nsp*(lx+1)^2 x nsp*(lx+1)^2 matrix 
c         for each ipot
          do 800 is2=1,ipart
            gg( is2, is1, ip) = zero
            do 790 is = 1,istate
              gg( is2, is1, ip) = gg( is2, is1, ip) +
     1        g0( is2+i0(ip), is) * xvec(is)
 790        continue
 800      continue

 910    continue
 920  continue

      return
      end

      subroutine cpl0 (x, pl0, lmaxp1)
      implicit double precision (a-h, o-z)

c-----------------------------------------------------------------------
c
c     cpl0:  Calculate associated legendre polynomials p_l0(x)
c            by recursion.
c            Adapted from aslgndr.
c
c     first written: (25 june 86) by j. j. rehr
c
c     version 1 (25 june 86) (aslgndr)
c     version 2 (March, 1992) siz
c
c-----------------------------------------------------------------------

      dimension pl0 (lmaxp1)

      lmax = lmaxp1-1

c     calculate legendre polynomials p_l0(x) up to l=lmax
      pl0(1) = 1
      pl0(2) = x
      do 10  il = 2, lmax
         l = il-1
         pl0(il+1) = ( (2*l+1)*x*pl0(il) - l*pl0(l) ) / il
   10 continue

      return
      end

      subroutine timrep (npat, ipat, rx, ry, rz, dhash)

c     subroutine timrev(...) is modified for polarization case 
c     Time-orders path and returns path in standard order,
c     standard order defined below.
c     Input:  npat, ipat
c     Output: ipat in standard order (time reversed if necessary)
c             rx, ry, rz   contain x,y,z coordinates of the path atoms,
c             where z-axis is along polarization vector or first leg, if
c               running usual feff,
c             x-axis is chosen so that first atom, which does not lie on
c               z-axis, lies in xz-plane,
c               for elliptically polarized light, x-axis is along the
c               incidence direction
c             y-axis is cross product of two previos unit vectors
c             Standarrd order is defined so that first nonzero x,y and z
c             coords are positive.(Otherwise we use the inversion of
c             the corresponding unit vector)
c             dhash double precision hash key for path in standard
c                order

      include 'dim.h'
      common /atoms/ rat(3,0:natx), ipot(0:natx), ilb(0:natx)
      dimension ipat(npatx+1), rx(npatx), ry(npatx), rz(npatx)
      dimension ipat0(npatx+1), rx0(npatx), ry0(npatx), rz0(npatx)

      double precision dhash, dhash0

c     Time reverses path if time reversing it will put it
c     in standard order.  Standard order is defined by min hash
c     number, using path hash algorithm developed for the path
c     degeneracy checker.  See subroutine phash for details.
c     Symmetrical paths are, of course, always standard ordered.
c     Also returns hash number for standard ordered path.

c     Use suffix 0 for (') in variable names

c     If no time-reversal standard ordering needed, make hash number
c     and return.  No timrev needed if 2 leg path (symmetrical).
      nleg = npat + 1
      ipat(nleg) = 0
      do 10 i = 1, npatx
         rx(i)   = 0
         ry(i)   = 0
         rz(i)   = 0
         rx0(i)   = 0
         ry0(i)   = 0
         rz0(i)   = 0
   10 continue
      call mpprmp(npat, ipat, rx, ry, rz)
      call phash (npat, ipat, rx, ry, rz, dhash)

      if (npat .le. 1)  then
         return
      endif

c     Make time reversed path

      ipat0(nleg) = ipat(nleg)
      do 210  i = 1, npat
         ipat0(i) = ipat(nleg-i)
  210 continue
      call mpprmp(npat, ipat0, rx0, ry0, rz0)
      call phash (npat, ipat0, rx0, ry0, rz0, dhash0)

c     Do the comparison using hash numbers
c     Want representation with smallest hash number
      if (dhash0 .lt. dhash)  then
c        time reversed representation is smaller, so return
c        that version of the path
         dhash = dhash0
         do 300  i = 1, npat
            ipat(i) = ipat0(i)
            rx(i)   = rx0(i)
            ry(i)   = ry0(i)
            rz(i)   = rz0(i)
  300    continue
      endif

      return
      end

      subroutine wpot (nph, edens, ifrph, imt, inrm,
     1                 rho, vclap, vcoul, vtot)

c     Writes potentials to file name POTxx.DAT for each unique pot.

      implicit double precision (a-h, o-z)

      include 'const.h'
      include 'dim.h'

      dimension ifrph(0:nphx)
      dimension rho(251,0:nfrx)
      dimension vcoul(251,0:nfrx)
      dimension edens(nrptx,0:nphx)
      dimension vclap(nrptx,0:nphx)
      dimension vtot (nrptx,0:nphx)
      dimension imt(0:nphx)
      dimension inrm(0:nphx)

      character*30 fname

c     note units --
c     potentials in rydbergs, so that v * 13.6 -> eV
c     density in #/(bohr)**3, so rho * e / (.529)**3 -> e/(Ang)**3

      do 180  iph = 0, nph
         ifr = ifrph(iph)
c        prepare file for unique potential data
         write(fname,172)  iph
  172    format('pot', i2.2, '.dat')
         open (unit=1, file=fname, status='unknown', iostat=ios)
         call chopen (ios, fname, 'wpot')
         call wthead(1)
         write(1,173)  iph, imt(iph), inrm(iph)
  173    format (1x, 3i4, '  Unique potential, I_mt, I_norman.',
     1          '    Following data in atomic units.')
         write(1,*) ' ifr ', ifr
         write(1,174)
  174    format ('   i      r         vcoul        rho',
     1           '     ovrlp vcoul  ovrlp vtot  ovrlp rho')
         do 178  i = 1, nrptx
            write(1,176) i, rr(i), vcoul(i,ifr), rho(i,ifr)/(4*pi),
     1                vclap(i,iph), vtot(i,iph), edens(i,iph)/(4*pi)
  176       format (1x, i3, 1p, 6e12.4)
  178    continue
         close(unit=1)
  180 continue

      return
      end

c     sub-program exchange
      program  ffmod2
c     subroutine ffmod2

c     cross-section and phase shifts calculations
c     coded by a.ankudinov 2000

c     INPUT: mod2.inp geom.dat global.inp and pot.pad
c     OUTPUT: xsect.bin and xsph.bin

      implicit double precision (a-h, o-z)

      include '../HEADERS/dim.h'
      include '../HEADERS/parallel.h'
      character*6 potlbl
      dimension potlbl(0:nphx)
      dimension lmaxph(0:nphx), iatph(0:nphx), spinph(0:nphx)
      dimension rat(3, natx), iphat(natx)
      complex*16 ptz(-1:1, -1:1)

c     necessary input information from feff.inp file
c     see CARDs description in feff8 manual for more details
c     CONTROL mphase: 1-run (0-don't run)  the program
c     PRINT ipr2: for auxialry output files (default=0)
c     ispec: spectroscopy type (EXAFS, XANES, XES, DANES, FPRIME) 
c     vixan, xkstep, xkmax: energy grid for chosen spectroscopy
c     RDRIG rgrid: radial grid (default=0.05)
c     POTENTIAL info
c       nph: number of unique potentials
c       lmaxph: max orbital momentum for xsph calculations
c       potlbl: labels for unique potentials
c      ATOMS
c       nat: number of atoms
c       rat: their coordinates
c       iphat: type of potential for each site
c       iatph: representative atoms indices in atoms list
c      EXCHANGE ixc  vr0  vi0  ixc0 - exchange correlation model
c      RSIGMA (RPHASES) lreal (default=0)
c      FMS  rfms2 lfms2
       real rfms2
       integer lfms2
c      Global data
c        ipol - polarization type (default:0 - polarization average)
c        ispin - spin type (default=0 - spin independent)
c        le2 - include/exclude quad. transitions (default=2 - include)
c        angks - angle between x-ray propagation and spin (default=0)
c        ptz - polarization tenzor (default=0 for ipol=0)
      integer iPl, iGrid

c     parameters related to rdpot, to be passed to newly modified pot()
      character*80 title(nheadx)
      integer ntitle, nohole, ihole, inters, iafolp, iunf, jumprm
      double precision rnrmav, xmu, vint, rhoint, emu, s02, erelax
      double precision wp, ecv, rs, xf, qtotel, totvol
      dimension adgc(10,30,0:nphx)
      dimension adpc(10,30,0:nphx)
      dimension dgc(251,30,0:nphx)
      dimension dgc0(251)
      dimension dmag(251,0:nphx)
      dimension dpc(251,30,0:nphx)
      dimension dpc0(251)
      dimension edens(251,0:nphx)
      dimension edenvl(251,0:nphx)
      dimension eorb(30)
      dimension folp(0:nphx)
      dimension folpx(0:nphx)
      dimension imt(0:nphx)
      dimension inrm(0:nphx)
      dimension iorb(-4:3,0:nphx)
      dimension iz(0:nphx)
      dimension kappa(30)
      dimension qnrm(0:nphx)
      dimension rmt(0:nphx)
      dimension rnrm(0:nphx)
      dimension vclap (251,0:nphx)
      dimension vtot (251,0:nphx)
      dimension vvalgs (251,0:nphx)
      dimension xion(0:nphx)
      dimension xnatph(0:nphx)
      dimension xnmues(0:lx,0:nphx)
      dimension xnval(30,0:nphx)


      call par_begin
      if (worker) go to 400

c     open the log file, unit 11.  See subroutine wlog.
      open (unit=11, file='log2.dat', status='unknown', iostat=ios)
      call chopen (ios, 'log2.dat', 'feff')

c     read  INPUT data files: geom.dat, global.dat and mod2.inp.
c     Josh - added flag iPl for PLASMON card
      call rexsph(mphase, ipr2, ispec, vixan, xkstep,xkmax,gamach,rgrd,
     1             nph, lmaxph, potlbl, spinph, iatph, nat, rat, iphat,
     2             ixc, vr0, vi0, ixc0, lreal, rfms2, lfms2, l2lp,
     3             ipol, ispin, le2, angks, ptz, iPl, iGrid,
     4             izstd, ifxc, ipmbse, itdlda, nonlocal, ibasis)

      if (mphase .eq. 1)  then
         call wlog(' Calculating cross-section and phases...')
         call rdpot ( ntitle, title, rnrmav, xmu, vint, rhoint,
     1          emu, s02, erelax, wp, ecv,rs,xf, qtotel,
     2          imt, rmt, inrm, rnrm, folp, folpx, xnatph,
     3          dgc0, dpc0, dgc, dpc, adgc, adpc,
     3          edens, vclap, vtot, edenvl, vvalgs, dmag, xnval,
     4          eorb, kappa, iorb, qnrm, xnmues, nohole, ihole,
     5          inters, totvol, iafolp, xion, iunf, iz, jumprm)

c                   wrxsec, verbse, phpad,
         call xsph (.true., .true., 'phase.pad',
     -          ipr2, ispec, vixan, xkstep, xkmax, gamach, rgrd,
     1          nph, lmaxph, potlbl, spinph, iatph, nat, rat, iphat,
     2          ixc, vr0, vi0, ixc0, lreal, rfms2, lfms2, l2lp,
     3          ipol, ispin, le2, angks, ptz, iPl,
     4          izstd, ifxc, ipmbse, itdlda, nonlocal,
c        pass parameters from rdpot
     1          ntitle, title, rnrmav, xmu, vint, rhoint,
     2          emu, s02, erelax, wp, ecv, rs, xf, qtotel,
     3          imt, rmt, inrm, rnrm, folp, folpx, xnatph,
     4          dgc0, dpc0, dgc, dpc, adgc, adpc,
     5          edens, vclap, vtot, edenvl, vvalgs, dmag, xnval,
     6          iorb, nohole, ihole,
     7          inters, totvol, iafolp, xion, iunf, iz, jumprm)
c squelch compiler warning about unused dummy variables, apparently
c removed from f85e
c     iGrid, (after iPl)
c   , ibasis)

         call wlog(' Done with module 2: cross-section and phases...')
      endif

c     OUTPUT: data for the next modules is written in xsph.bin
c     auxilary output can be obtained using 'ipr2' (see feff8.2 manual)

      close (unit=11)
  400 call par_barrier
      call par_end

c     sub-program exchange
      stop
c     return
      end

      subroutine inmuac (ihole, xionin, iunf, ikap)
      implicit double precision (a-h,o-z)
      include '../HEADERS/dim.h'
      common/dff/cg(nrptx,30),cp(nrptx,30),bg(10,30),bp(10,30),fl(30),
     1    fix(30), ibgp
      common/itescf/testy,rap(2),teste,nz,norb,norbsc
c the meaning of common variables is described below
      common/ratom1/xnel(30),en(30),scc(30),scw(30),sce(30),
     1nq(30),kap(30),nmax(30)
c en one-electron energies
c scc factors for acceleration of convergence
c scw precisions of wave functions
c sce precisions of one-electron energies
c nmax number of tabulation points for orbitals
      common/scrhf1/eps(435),nre(30),ipl
c eps non diagonal lagrange parameters
c nre distingue: - the shell is closed (nre <0)
c                  the shell is open (nre>0)
c                - the orbitals in the integral rk if abs(nre) > or =2
c ipl define the existence of lagrange parameters (ipl>0)
      common/snoyac/dvn(nrptx),anoy(10),nuc
c dvn nuclear potential
c anoy development coefficients at the origin of nuclear potential
c this development is supposed to be written anoy(i)*r**(i-1)
c nuc index of nuclear radius (nuc=1 for point charge)
      common/tabtec/hx,dr(nrptx),test1,test2,ndor,np,nes,method,idim
      dimension xnval(30), iorb(-4:3)
      data nucm/11/

      testy=10.**(-5)
c testy precision for the wave functions

      call getorb (nz, ihole, xionin, iunf, norb, norbsc, iorb,
     1            iholep, nq, kap, xnel, xnval, en)
c     don't need xmag here, so use en as a dummy

      ipl=0
      do 40 i=1,norb
         en(i) = 0.d0
         nre(i)=-1
         llq= abs(kap(i))
         l=llq+llq
c       find last tabulation point
         nmax(i)=0
         do 100  j = idim, 1, -1
            if ( abs(cg(j,i)) .ge. 1.0d-11 .or.
     1           abs(cp(j,i)) .ge. 1.0d-11 )  then
               nmax(i) = j
               goto 16
            endif
  100    continue
   16    continue

         scc(i)=0.3
         if (xnel(i) .lt. l)  nre(i)=1
         if (ikap.eq.kap(i)) ipl=ipl+1
  40  continue
      norbsc=norb
      norb = norb+1
      xnel(norb)=1
      kap(norb)=ikap
      nq(norb) =9
c nz atomic number     noi ionicity (nz-number of electrons)
c norb number of orbitals
c xnel(i) number of electrons on orbital i.
      nuc=nucm
c nuc number of points inside nucleus (11 by default)

      return
      end

      subroutine bjnser (x, l, jl, nl, ifl)

c-----------------------------------------------------------------------
c
c     subroutine: bjnser (x,l,jl,nl,ifl)
c
c     purpose:  to calculate the spherical bessel functions jl and nl
c
c     arguments:
c       x = argument of jl and nl
c       l = l value calculated (no offset)
c       jl = jl bessel function (abramowitz conventions)
c       nl = nl bessel function (abramowitz yl conventions)
c       ifl = 0 return both jl and nl
c             1 return jl only
c             2 return nl only
c
c     notes:  jl and nl are calculated by a series
c             expansion according to 10.1.2 and 10.1.3
c             in abramowitz and stegun (ninth printing),
c             page 437
c
c             error msgs written with PRINT statements.
c
c     first coded by r. c. albers on 26 jan 83
c
c     version 2
c
c     last modified: 27 jan 83 by r. c. albers
c
c-----------------------------------------------------------------------

      implicit double precision (a-h,o-z)

      complex*16 x,u,ux,del,pj,pn
      complex*16 jl,nl

      character*512 slog

      parameter (niter = 160, tol = 1.e-15)

      if (l .lt. 0) then
         call wlog(' l .lt. 0 in bjnser')
         stop 'bjnser 1'
      endif
      if (dble(x).lt. 0.) then
         write(slog,30) x
         call wlog(slog)
   30    format (' x = ', 1p, 2e14.6, ' is .le. 0 in bjnser')
         stop 'bjnser 2'
      endif

      lp1 = l+1
      u = x**2 / 2

c     make djl = 1 * 3 * 5 * ... * (2*l+1),
c          dnl = 1 * 3 * 5 * ... * (2*l-1)
      djl = 1
      fac = -1
      do 50 il = 1, lp1
         fac = fac + 2
         djl = fac * djl
   50 continue
      dnl = djl / (2*l+1)


      if (ifl .eq. 2)   goto 90
c     make jl
c     pj is term in { } in 10.1.2, del is last factor in the series
c     convergence test is (last factor)/(total term) <= tol
      pj = 1
      nf = 1
      nfac = 2*l + 3
      den = nfac
      sgn = -1
      ux = u
      do 60 il = 1, niter
         del = sgn*ux / den
         pj = pj + del
         trel = abs (del / pj)
         if (trel .le. tol)  goto 80
         sgn = -sgn
         ux = u*ux
         nf = nf+1
         nfac = nfac+2
         den = nf * nfac * den
   60 continue
      stop  'jl does not converge in bjnser'
   80 jl = pj * (x**l) / djl

   90 if (ifl.eq.1) return
c     make nl
c     pn is term in { } in 10.1.3, del is last factor in the series
c     convergence test is (last factor)/(total term) <= tol
      pn = 1
      nf = 1
      nfac = 1 - 2*l
      den = nfac
      sgn = -1
      ux = u
      do 100  il = 1, niter
         del = sgn * ux / den
         pn = pn + del
         trel = abs (del / pn)
         if (trel .le. tol) goto 120
         sgn = -sgn
         ux = u*ux
         nf = nf+1
         nfac = nfac+2
         den = nf * nfac * den
  100 continue
      stop  'nl does not converge in bjnser'
  120 nl = -pn * dnl / (x**lp1)

      return
      end

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Information about last revision of $RCSfile: m_constants.f90,v $:
! $Revision: 1.3 $
! $Author: jorissen $
! $Date: 2010/12/16 18:30:30 $
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!*************************************************************************
module constants

  implicit none

  ! Symbolic names for kind types of 4-, 2-, and 1-byte integers:
  integer, parameter :: I4 = selected_int_kind(9)
  integer, parameter :: I2 = selected_int_kind(4)
  integer, parameter :: I1 = selected_int_kind(2)
  ! Symbolic names for kind types of single- and double-precision reals:
  integer, parameter :: SP  = kind(1.0)
  integer, parameter :: DP  = kind(1.0D0)
  ! Symbolic names for kind types of single- and double-precision complex:
  integer, parameter :: SZ  = kind((1.0,1.0))
  integer, parameter :: DZ  = kind((1.0D0,1.0D0))
  ! Symbolic name for kind type of default logical:
  integer, parameter :: LGT = kind(.true.)
  private i1,i2,i4,sp,dp,sz,dz,lgt

  real(dp), parameter :: pi2 = 6.283185307179586476925286766559_dp
  real(dp), parameter :: pi  = 3.1415926535897932384626433832795_dp
  real(dp), parameter :: one = 1.0_dp
  real(dp), parameter :: zero  = 0.0_dp
  real(dp), parameter :: third = 1.0_dp/3.0_dp
  real(dp), parameter :: raddeg = 180.0_dp/pi
  !     kf = fa/rs with fa = (9*pi/4)**third, see Ash&Merm, pg 37
  real(dp), parameter :: fa = 1.919158292677512811_dp
  complex(dz), parameter :: coni = (0.0_dp,1.0_dp)
  real(dp), parameter :: bohr = 0.529177249_dp
  real(dp), parameter :: ryd  = 13.605698_dp
  real(dp), parameter :: hart = 2.0_dp*ryd
  real(dp), parameter :: alpinv = 137.03598956_dp
  real(dp), parameter :: alphfs = 1.0_dp/alpinv

  ! from moduleseels.f 
  ! conversion from eV to Ry :
  real(dp), parameter :: ev2Ry = 1.0_dp/13.6058_dp
  !  h/2pi c in units eV a.u.
  real(dp), parameter :: hbarc_eV = 1973.2708_dp/0.529177_dp
  real(dp), parameter :: hbarc_atomic = 137.04188_dp  ! i.e. in Ha, hence 27.2 times smaller than above
  ! electron rest mass times c^2 in au (ie, 1 * alfa * alfa), times eV/Ha (27.2)
  real(dp), parameter :: MeC2 =  511004.0_dp
  REAL(dp), parameter :: HOnSqrtTwoMe = 23.1761_dp
  ! Me c / hbar = 2.5896 10^12 m^(-1) = 137.04188 a.u.^(-1)
  real(dp), parameter :: MeCOnHbar = 137.04188_dp

end module constants

      subroutine json_read_onepath(index, iorder, ipol, nleg, deg, rat,
     &        ipot, elpty, evec, xivec, nnnn_out, json_out)

      use json_module
      implicit double precision (a-h, o-z)

      include '../HEADERS/const.h'
      include '../HEADERS/dim.h'

      logical :: found
      type(json_file) :: json   !the JSON structure read from the file:
      double precision,dimension(:),allocatable :: dbpcs, dbpcx

      integer index, nleg, ipot(0:legtot)
      double precision rat(3,0:legtot+1)
      logical nnnn_out, json_out
      double precision evec(3), xivec(3)

      character*5 vname

      elpty = 0
      do 5 ix=1,3
         evec(ix)  = 0
         xivec(ix) = 0
 5    continue


      call json%load_file('feffpath.json')
      if (json_failed()) then   !if there was an error reading the file
         print *, "failed to read feffpath.json"
         stop
      else
         call json%get('index', index, found)
             if (.not. found) call bailout('index', 'feffpath.json')
         call json%get('nleg',  nleg,  found)
             if (.not. found) call bailout('nleg',  'feffpath.json')
         call json%get('deg',   deg,   found)
             if (.not. found) call bailout('deg',  'feffpath.json')

         call json%get('iorder', iorder, found)
             if (.not. found) call bailout('iorder', 'feffpath.json')
         call json%get('ipol',   ipol,   found)
             if (.not. found) call bailout('ipol',   'feffpath.json')
         call json%get('ellipticity', elpty,  found)
           if (.not. found) call bailout('ellipticity', 'feffpath.json')


         call json%get('nnnn_out', nnnn_out, found)
             if (.not. found) call bailout('nnnn_out', 'feffpath.json')
         call json%get('json_out', json_out, found)
             if (.not. found) call bailout('json_out', 'feffpath.json')

         do 10 iat=1,nleg
            write (vname, "(A4,I1)") "atom", iat
            call json%get(vname, dbpcs, found)
                 if (.not. found) call bailout(vname, 'feffpath.json')
            
c           convert distances to code units
            rat(1,iat)  = dbpcs(1)/bohr
            rat(2,iat)  = dbpcs(2)/bohr
            rat(3,iat)  = dbpcs(3)/bohr
            ipot(iat)   = int(dbpcs(4)+0.5)
 10      continue

         call json%get('evec',  dbpcs, found)
              if (.not. found) call bailout('evec',  'feffpath.json')
         call json%get('xivec', dbpcx, found)
              if (.not. found) call bailout('xivec', 'feffpath.json')
         do 20 ix=1,3
            evec(ix)  = dbpcs(ix)
            xivec(ix) = dbpcx(ix)
 20      continue


         call json%destroy()
      end if


      return
      end


      subroutine json_read_geometry(nleg, rat, ipot)

      use json_module
      implicit double precision (a-h, o-z)

      include '../HEADERS/const.h'
      include '../HEADERS/dim.h'

      integer nleg, ipot(0:legtot)
      double precision rat(3,0:legtot+1)
      character*5 vname


      logical :: found
      type(json_file) :: json   !the JSON structure read from the file:
c      double precision,dimension(:),allocatable :: dbpcs

      call json%load_file('feffpath.json')
      if (json_failed()) then   !if there was an error reading the file
         print *, "failed to read feffpath.json"
         stop
      else
         call json%get('nleg',  nleg,  found)
             if (.not. found) call bailout('nleg',  'feffpath.json')
         do 10 iat=1,nleg
            write (vname, "(A4,I1)") "atom", iat
            call json%get(vname, dbpcs, found)
                 if (.not. found) call bailout(vname, 'feffpath.json')
            
c           convert distances to code units
            rat(1,iat)  = dbpcs(1)/bohr
            rat(2,iat)  = dbpcs(2)/bohr
            rat(3,iat)  = dbpcs(3)/bohr
            ipot(iat)   = int(dbpcs(4)+0.5)
 10      continue

         call json%destroy()
      end if


      return
      end

      double precision function determ(array,nord,nrows)
c
c     calculate determinate of a square matrix
c        (from bevington "data reduction and error analysis
c         for the physical sciences" pg 294)
c     array: matrix to be analyzed
c     nord: order of matrix
c     nrows:  first dimension of matrix in calling routine
c
      double precision array(nrows,nrows)
      determ = 1.
      do 150 k=1,nord
c
c
        if (array(k,k).ne.0) go to 130
        do 100 j=k,nord
          if (array(k,j).ne.0) go to 110
  100   continue
        determ = 0.
        go to 160
c
  110   do 120 i=k,nord
          saved = array(i,j)
          array(i,j) = array(i,k)
  120   array(i,k) = saved
        determ = -determ
c
  130   determ = determ*array(k,k)
        if (k.ge.nord) go to 150
        k1 = k+1
        do 140 i=k1,nord
          do 140 j=k1,nord
  140   array(i,j) = array(i,j)-array(i,k)*array(k,j)/array(k,k)
  150 continue
  160 return
c end double precision function determ
      end

      subroutine fdtxdi(ntext, text, ip, iorder, nleg, deg, reff,
     &       rnrmav, edge, rat, ipot, iz, potlbl, nlines, lines)

c+---------------------------------------------------------------------
c     write a feffNNNN.dat equivalent in the XDI format
c     all header information is treated as XDI metadata in the
c     "feff8l" namespace, save for the absorber element and edge,
c     extracted from the header line for potential 0 and presented
c     as Element.edge and Element.symbol
c+---------------------------------------------------------------------
c     "Based on or developed using Distribution: FEFF8.5L
c      Copyright (c) [2013] University of Washington"
c
C  See ../HEADERS/license.h for full llicense information
c+---------------------------------------------------------------------

      implicit double precision (a-h, o-z)
      include '../HEADERS/const.h'
      include '../HEADERS/dim.h'
      include '../HEADERS/vers.h'
      parameter (npx=15000)

      double precision rat(3,legtot)
      dimension ipot(legtot)
      dimension iz(0:nphx)
      character*6  potlbl(0:nphx)
      character*2  atsym
      character*10 v
      character*80 text(nheadx), lines(2*nheadx), buff, thisln
      real deg, reff, rnrmav, edge

      parameter (nwordx = 20)
      character*20 words(nwordx)
      
      external istrln, triml, atsym

      nlines = 1
 10   format('# XDI/1.0 feff8l/', a10)
      v = vf85e
      call triml(v)
      write(thisln,10) v
      lines(nlines) = thisln
      nlines = nlines+1

c     absorber line, eg: Abs   Z=29 Rmt= 0.000 Rnm= 0.000 K  shell
      buff = text(2)
      nwords = nwordx
      call bword2(buff, nwords, words)
 20   format('# Element.edge:    ', a2)
      write(thisln,20) words(8)
      lines(nlines) = thisln
      nlines = nlines+1

 22   format('# Element.symbol:  ', a2)
      read(words(3), *) i
      write(thisln,22) atsym(i)
      lines(nlines) = thisln
      nlines = nlines+1

      lines(nlines) = '# Column.1:        k inverse Angstrom'
      nlines = nlines+1
      lines(nlines) = '# Column.2:        real_phc'
      nlines = nlines+1
      lines(nlines) = '# Column.3:        magnitude_feff'
      nlines = nlines+1
      lines(nlines) = '# Column.4:        phase_feff'
      nlines = nlines+1
      lines(nlines) = '# Column.5:        reduction_factor'
      nlines = nlines+1
      lines(nlines) = '# Column.6:        lambda'
      nlines = nlines+1
      lines(nlines) = '# Column.7:        real_p'
      nlines = nlines+1
      
 40   format('# feff8l.path_index: ', i4)
      write(thisln,40) ip
      lines(nlines) = thisln
      nlines = nlines+1

 200  format('# feff8l.nleg:        ', i1)
      write(thisln,200) nleg
      lines(nlines) = thisln
      nlines = nlines+1

 210  format('# feff8l.degen:       ', f6.3)
      write(thisln,210) deg
      lines(nlines) = thisln
      nlines = nlines+1
      
 220  format('# feff8l.reff:        ', f7.4, ' Angstrom')
      write(thisln,220) reff*bohr
      lines(nlines) = thisln
      nlines = nlines+1
      
 50   format('# feff8l.iorder:     ', i2)
      write(thisln,50) iorder
      lines(nlines) = thisln
      nlines = nlines+1

c     still on Abs line
 60   format('# feff8l.abs_radii:   ', a5, '/', a5)
      write(thisln,60) words(5), words(7)
      lines(nlines) = thisln
      nlines = nlines+1
      
      do 199 i=3,ntext
         buff = text(i)
         nwords = nwordx
         call bword2(buff, nwords, words)
         if (words(1) .eq. 'Gam_ch') then

 100        format('# feff8l.gamma_ch:    ', a10, ' eV')
            write(thisln, 100) words(2)
            lines(nlines) = thisln
            nlines = nlines+1
            
 110        format('# feff8l.exchange:    ', a10)
            write(thisln, 110) words(3)
            lines(nlines) = thisln
            nlines = nlines+1
            
         elseif (words(1) .eq. 'Mu') then

 120        format('# feff8l.mu:          ', a10, ' eV')
            write(thisln, 120) words(2)
            lines(nlines) = thisln
            nlines = nlines+1
            
 130        format('# feff8l.kf:          ', a10,
     1             ' inverse Angstrom')
            write(thisln, 130) words(4)
            lines(nlines) = thisln
            nlines = nlines+1
            
 140        format('# feff8l.vint:        ', a10, ' eV')
            write(thisln, 140) words(6)
            lines(nlines) = thisln
            nlines = nlines+1
            
 150        format('# feff8l.rs_int:      ', a10, ' Angstrom')
            write(thisln, 150) words(8)
            lines(nlines) = thisln
            nlines = nlines+1

c        this is a POT line
         elseif (words(1) .eq. 'Pot')  then

 160        format('# feff8l.pot', a1, ':        ', a2)
            read(words(4), *) j
            write(thisln, 160) words(2), atsym(j)
            lines(nlines) = thisln
            nlines = nlines+1

 170        format('# feff8l.pot', a1, '_radii:  ', a5, '/', a5)
            write(thisln,170) words(2), words(6), words(8)
            lines(nlines) = thisln
            nlines = nlines+1
            
         end if
 199  continue


 230  format('# feff8l.rnrmav:      ', f7.4, ' Angstrom')
      write(thisln,230) rnrmav
      lines(nlines) = thisln
      nlines = nlines+1
      
 240  format('# feff8l.edge:        ', f9.5, ' eV')
      write(thisln,240) edge*hart
      lines(nlines) = thisln
      nlines = nlines+1


 300  format('# feff8l.atom0:       ', 3f10.4, i3, i4, 1x, a6)
      write(thisln,300)  (rat(j,nleg)*bohr,j=1,3), ipot(nleg),
     1       iz(ipot(nleg)), potlbl(ipot(nleg))
      lines(nlines) = thisln
      nlines = nlines+1
      
      do 399  ileg = 1, nleg-1
 310     format('# feff8l.atom', i1,
     1          ':       ', 3f10.4, i3, i4, 1x, a6)
         write(thisln,310)  ileg, (rat(j,ileg)*bohr,j=1,3), ipot(ileg),
     1          iz(ipot(ileg)), potlbl(ipot(ileg))
         lines(nlines) = thisln
         nlines = nlines+1
 399  continue

      lines(nlines) = '# -----'
      nlines = nlines+1
      write(thisln,370)
 370  format    ('#   k   real[2*phc]   mag[feff]  phase[feff]',
     1       ' red factor   lambda     real[p]')
      lines(nlines) = thisln

      
      return
      end
      



      SUBROUTINE BWORD2 (S, NWORDS, WORDS)
C
C     Breaks string into words.  Words are seperated by one or more
C     blanks or tabs, or a comma or an equal sign and zero or more blanks.
C
C     ARGS        I/O      DESCRIPTION
C     ----        ---      -----------
C     S            I       CHAR*(*)  String to be broken up
C     NWORDS      I/O      Input:  Maximum number of words to get
C                          Output: Number of words found
C     WORDS(NWORDS) O      CHAR*(*) WORDS(NWORDS)
C                          Contains words found.  WORDS(J), where J is
C                          greater then NWORDS found, are undefined on
C                          output.
C
C      Written by:  Steven Zabinsky, September 1984
C      Tab char added July 1994.
C      Equal char added by BR September 2015
C
C**************************  Deo Soli Gloria  **************************

C  -- No floating point numbers in this routine.
      IMPLICIT INTEGER (A-Z)

      CHARACTER*(*) S, WORDS(NWORDS)

      CHARACTER BLANK, COMMA, EQUAL, TAB
      PARAMETER (BLANK = ' ', COMMA = ',', EQUAL = '=', TAB = '	')
C     there is a tab character here                            ^.

C  -- BETW    .TRUE. if between words
C     COMFND  .TRUE. if between words and a comma has already been found
      LOGICAL BETW, COMFND

C  -- Maximum number of words allowed
      WORDSX = NWORDS

C  -- SLEN is last non-blank character in string
      SLEN = ISTRLN (S)

C  -- All blank string is special case
      IF (SLEN .EQ. 0)  THEN
         NWORDS = 0
         RETURN
      ENDIF

C  -- BEGC is beginning character of a word
      BEGC = 1
      NWORDS = 0

      BETW   = .TRUE.
      COMFND = .TRUE.

      DO 10  I = 1, SLEN
         IF (S(I:I) .EQ. BLANK .OR. S(I:I) .EQ. TAB)  THEN
            IF (.NOT. BETW)  THEN
               NWORDS = NWORDS + 1
               WORDS (NWORDS) = S (BEGC : I-1)
               BETW = .TRUE.
               COMFND = .FALSE.
            ENDIF
         ELSEIF (S(I:I) .EQ. COMMA .OR. S(I:I) .EQ. EQUAL)  THEN
            IF (.NOT. BETW)  THEN
               NWORDS = NWORDS + 1
               WORDS (NWORDS) = S(BEGC : I-1)
               BETW = .TRUE.
            ELSEIF (COMFND)  THEN
               NWORDS = NWORDS + 1
               WORDS (NWORDS) = BLANK
            ENDIF
            COMFND = .TRUE.
         ELSE
            IF (BETW)  THEN
               BETW = .FALSE.
               BEGC = I
            ENDIF
         ENDIF

         IF (NWORDS .GE. WORDSX)  RETURN

   10 CONTINUE

      IF (.NOT. BETW  .AND.  NWORDS .LT. WORDSX)  THEN
         NWORDS = NWORDS + 1
         WORDS (NWORDS) = S (BEGC :SLEN)
      ENDIF

      RETURN
      END
      

      subroutine istprm (nph, nat, iphat, rat, iatph, xnatph,
     1                   novr, iphovr, nnovr, rovr, folp, edens,
     2                   vclap, vtot, imt, inrm, rmt, rnrm, 
     2                   rhoint,
     3                   vint, rs, xf, xmu, rnrmav, intclc)

c     Finds interstitial parameters, rmt, vint, etc.
      implicit double precision (a-h, o-z)

      include 'const.h'
      include 'dim.h'

      dimension iphat(natx)
      dimension rat(3,natx)
      dimension iatph(0:nphx)
      dimension xnatph(0:nphx)
      dimension novr(0:nphx)
      dimension iphovr(novrx,0:nphx)
      dimension nnovr(novrx,0:nphx)
      dimension rovr(novrx,0:nphx)
      dimension folp(0:nphx)
      dimension edens(nrptx,0:nphx)
      dimension vclap(nrptx,0:nphx)
      dimension vtot (nrptx,0:nphx)
      dimension imt(0:nphx)
      dimension inrm(0:nphx)
      dimension rmt(0:nphx)
      dimension rnrm(0:nphx)

       character*128 messag
c     intclc = 0, average evenly over all atoms
c              1, weight be lorentzian, 1 / (1 + 3*x**2), x = r/rnn,
c                 r   = distance to central atom,
c                 rnn = distance of near neighbor to central atom

c Find muffin tin radii.  We'll find rmt based on norman prescription,
c ie, rmt(i) = R * folp * rnrm(i) / (rnrm(i) + rnrm(j)),
c a simple average
c based on atoms i and j.  We average the rmt's from each pair of
c atoms, weighting by the volume of the lense shape formed by the
c overlap of the norman spheres.
c NB, if folp=1, muffin tins touch without overlap, folp>1 gives
c overlapping muffin tins.
c
c rnn is distance between sphere centers
c rnrm is the radius of the norman sphere
c xl_i is the distance to the plane containing the circle of the
c    intersection
c h_i  = rnrm_i - xl_i is the height of the ith atom's part of
c    the lense
c vol_i = (pi/3)*(h_i**2 * (3*rnrm_i - h_i))
c
c xl_i = (rnrm_i**2 - rnrm_j**2 + rnn**2) / (2*rnn)

      do 140  iph = 0, nph
         voltot = 0
         rmtavg = 0
         if (novr(iph) .gt. 0)  then
c           Overlap explicitly defined by overlap card
            do 124  iovr = 1, novr(iph)
               rnn  = rovr(iovr,iph)
               inph = iphovr(iovr,iph)
c              Don't avg if norman spheres don't overlap
               if (rnrm(iph)+rnrm(inph) .le. rnn)  goto 124
               voltmp = calcvl (rnrm(iph), rnrm(inph), rnn)
               voltmp = voltmp + calcvl (rnrm(inph), rnrm(iph), rnn)
               rmttmp = rnn * folp(iph) * rnrm(iph) /
     1                  (rnrm(iph) + rnrm(inph))
               ntmp = nnovr(iovr,iph)
               rmtavg = rmtavg + rmttmp*voltmp*ntmp
               voltot = voltot + voltmp*ntmp
  124       continue
         else
            iat = iatph(iph)
            do 130  inat = 1, nat
               if (inat .eq. iat)  goto 130
               rnn = dist (rat(1,inat), rat(1,iat))
               inph = iphat(inat)
c              Don't avg if norman spheres don't overlap
               if (rnrm(iph)+rnrm(inph) .lt. rnn)  goto 130
               voltmp = calcvl (rnrm(iph), rnrm(inph), rnn)
               voltmp = voltmp + calcvl (rnrm(inph), rnrm(iph), rnn)
               rmttmp = rnn * folp(iph) * rnrm(iph) /
     1                  (rnrm(iph) + rnrm(inph))
               rmtavg = rmtavg + rmttmp*voltmp
               voltot = voltot + voltmp
  130       continue
         endif
         if (rmtavg .le. 0)  then
            write(messag, 132) iat, iph
            call echo(messag)
  132       format (' WARNING: NO ATOMS CLOSE ENOUGH TO OVERLAP ATOM',
     1              i5, ',  UNIQUE POT', i5, '!!', /,
     2              '          Rmt set to Rnorman.  May be error in ',
     3              'input file.')
            rmt(iph) = rnrm(iph)
         else
            rmt(iph) = rmtavg / voltot
         endif
  140 continue

c     Need potential with ground state xc, put it into vtot
      do 160  iph = 0, nph
         call sidx (edens(1,iph), 250, rmt(iph), rnrm(iph),
     1              imax, imt(iph), inrm(iph))
         do 150  i = 1, imax
            rs = (edens(i,iph)/3)**(-third)
c           vhedbr from Von Barth Hedin paper, 1971
            vhedbr = -1.22177412/rs - 0.0504*log(30/rs + 1)
            vtot(i,iph) = vclap(i,iph) + vhedbr
  150    continue
  160 continue

c     What to do about interstitial values?
c     Calculate'em for all atoms, print'em out for all unique pots along
c     with derivative quantities, like fermi energy, etc.
c     Interstitial values will be average over all atoms in problem.

c     rnrmav is averge norman radius,
c     (4pi/3)rnrmav**3 = (sum((4pi/3)rnrm(i)**3)/n, sum over all atoms
c     in problem
      rnrmav = 0
      xn = 0
      rs = 0
      vint   = 0
      rhoint = 0
c     volint is total interstitial volume
      volint = 0

      do 170  iph = 0, nph
c        Use all atoms
         call istval (vtot(1,iph), edens(1,iph), rmt(iph), imt(iph),
     2                rnrm(iph), inrm(iph), vintx, rhintx, ierr)
c        if no contribution to interstitial region, skip this unique pot
         if (ierr .ne. 0)  goto 170
         call fermi (rhintx, vintx, xmu, rs, xf)
c        (factor 4pi/3 cancel in numerator and denom, so leave out)
         volx = (rnrm(iph)**3 - rmt(iph)**3)
         if (volx .le. 0)  goto 170
         volint = volint + volx * xnatph(iph)
         vint   = vint   + vintx * volx * xnatph(iph)
         rhoint = rhoint + rhintx* volx * xnatph(iph)
  170 continue
c     If no contribution to interstitial from any atom, die.
      if (volint .le. 0)  then
         call echo(' No interstitial density.  Check input file.')
         call fstop(' at ISTPRM')
      endif
      vint   = vint   / volint
      rhoint = rhoint / volint
      call fermi (rhoint, vint, xmu, rs, xf)
      do 180  iph = 0, nph
         rnrmav = rnrmav + xnatph(iph) * rnrm(iph)**3
         xn = xn + xnatph(iph)
  180 continue
      rnrmav = (rnrmav/xn) ** third


      return
      end

      double precision function calcvl (r1, r2, r)
      implicit double precision (a-h, o-z)
      include 'const.h'
      xl = (r1**2 - r2**2 + r**2) / (2*r)
      h = r1 - xl
      calcvl = (pi/3) * h**2 * (3*r1 - h)
      return
      end

      subroutine fixvar (rmt, edens, vtot,
     1                   vint, rhoint, nr, dx, x0, ri,
     2                   vtotph, rhoph)

      implicit double precision (a-h, o-z)

      include 'dim.h'
      include 'const.h'

      dimension edens(nrptx), vtot (nrptx)
      dimension vtotph(nr), rhoph(nr)
      dimension ri(nr)

c     PHASE needs
c     vtot = total potential including gs xcorr, no r**2
c     edens = rho, charge density, no factor of 4*pi, no r**2
c     From overlapping, vtot = potential only, ok as is
c                       edens = density*4*pi, so fix this here.

c     If new grid is different from old one, be sure to interpolate
c     somehow...

c     Only values inside the muffin tin are used, except that XCPOT
c     (in PHASE) uses values at imt+1 and requires these to be the
c     interstitial values.  So set the last part of the arrays to
c     interstitial values...

      imt = ii(rmt)

      do 190  i = 1, imt
         vtotph(i) = vtot(i)
         rhoph(i) = edens(i)/(4*pi)
  190 continue
      do 200  i = imt+1, nrptx
         vtotph(i) = vint
         rhoph(i) = rhoint/(4*pi)
  200 continue

      return
      end

      program feff
c
c  EXAFS only version of FEFF6 
c  Modified by Matt Newville from original code by John Rehr
c  see LICENSE for copying details
c
       implicit none
       include 'vers.h'
       include 'dim.h'
       include 'const.h'

       integer ntitx
       parameter (ntitx = 16)
       character*128  title(ntitx), tmpstr*32, fname*64
       integer       ltit(ntitx)

       integer ibeta, ipotn, ik0, ipot, ios, ne, ie
       integer nlegx, nncrit, isporb, ipotnn, i, nlegxx
       integer ipr2, ipr3, ipr4,  iorder, icsig
       integer mphase, mpath, mfeff, mchi, ms, ntitle
       double precision s02, tk, thetad, sig2g, critcw
       double precision  angle, cosb, vicorr, vrcorr
c     Following passed to pathfinder, which is single precision.
c     Be careful to always declare these!
       integer necrit, nbeta
      parameter (necrit=9, nbeta=40)
      real fbetac(-nbeta:nbeta,0:npotx,necrit), ckspc(necrit)
      real fbeta(-nbeta:nbeta,0:npotx,nex), cksp(nex)
      real rmax, critpw, pcritk, pcrith
      character*6  potlbl(0:npotx)
      character*128 inpfil, lfile

      character*10 shole(0:9)
      character*8 sout(0:6)

      integer istat, il, iox, istrln
      external istrln

   10 format (1x, a)
ccc      vfeff = 'Feff 6L.02'


       call sca_init
       call echo_init
       call open_echofile('feff.run')
       call fstop_init('feff.err')
       call echo(vfeff)
       

       shole(0) = 'no hole'
       shole(1) = 'K shell'
       shole(2) = 'LI shell'
       shole(3) = 'LII shell'
       shole(4) = 'LIII shell'
       shole(5) = 'MI shell'
       shole(6) = 'MII shell'
       shole(7) = 'MIII shell'
       shole(8) = 'MIV shell'
       shole(9) = 'MV shell'

       sout(0) = 'H-L exch'
       sout(1) = 'D-H exch'
       sout(2) = 'Gd state'
       sout(3) = 'DH - HL '
       sout(4) = 'DH + HL '
       sout(5) = 'HLnoimag'
       sout(6) = 'Gs HL   '

       call get_inpfile('feff.inp',inpfil,istat)

       call rdinp (inpfil,
     $      mphase, mpath, mfeff, mchi, ms,
     1      ntitle, title, ltit,
     2      critcw, 
     1      ipr2, ipr3, ipr4,
     1      s02, tk, thetad, sig2g,
     1      nlegxx,
     1      rmax, critpw, pcritk, pcrith, nncrit,
     2      icsig, iorder, vrcorr, vicorr, isporb)

      do 20  i = 1, ntitle
         call echo(title(i)(1:ltit(i)))
   20 continue

      if (mphase .eq. 1)  then
         call echo( 'Calculating potentials and phases...')
         call potph (isporb, shole, sout)
         open (unit=1, file='potph.dat', status='old', iostat=ios)
         call chopen (ios, 'potph.dat', 'feff')
         close (unit=1, status='delete')
      endif

      if (ms.eq.1  .and.  mpath.eq.1)  then


         call echo('Preparing plane wave scattering amplitudes...')
cc         print*, 'feff-> prcrit  ne, nncrit = ' , ne, nncrit
         call prcrit (ne, nncrit, ik0, cksp, fbeta, ckspc, 
     1                fbetac, potlbl)
cc         print*, 'after prcrit  ne, nncrit = ' , ne, nncrit

c        Dump out fbetac for central atom and first pot
         if (ipr2 .ge. 3 .and. ipr2.ne.5)  then
            do 260  ipot = 0, 1
               do 250  ie = 1, nncrit
                  write(fname,200)  ie, ipot
  200             format ('fbeta', i1, 'p', i1, '.dat')
                  open (unit=1, file=fname)
                  write(1,210)  ipot, ie, ckspc(ie)
  210             format ('# ipot, ie, ckspc(ie) ', 2i5, 1pe20.6, /
     1                    '#  angle(degrees), fbeta/|p|,  fbeta')
                  do 240  ibeta = -nbeta, nbeta
                     cosb = .025 * ibeta
                     if (cosb .gt.  1)  cosb =  1
                     if (cosb .lt. -1)  cosb = -1
                     angle = acos (cosb)
                     write(1,230)  angle*raddeg, 
     1                  fbetac(ibeta,ipot,ie)/ckspc(ie),
     2                  fbetac(ibeta,ipot,ie)
  230                format (f10.4, 1p, 2e15.6)
  240             continue
                  close (unit=1)
  250          continue
  260       continue
         endif

         call echo('Searching for paths...')
         call paths (ckspc, fbetac, pcritk, pcrith, nncrit,
     1               rmax, nlegxx, ipotnn)

         call echo('Eliminating path degeneracies...')
         call pathsd (ckspc, fbetac, ne, ik0, cksp, fbeta,
     1                critpw, ipotnn, ipr2, 
     1                pcritk, pcrith, nncrit, potlbl)

         if (ipr2 .lt. 2)  then
            open (unit=1, file='geom.dat', status='old')
            call chopen (ios, 'geom.dat', 'feff')
            close (unit=1, status='delete')
         endif
      endif

      if (mfeff .eq. 1)  then
         call echo('Calculating EXAFS parameters...')
         call genfmt (ipr3, critcw, sig2g, iorder)
      endif

c      if (mchi .eq. 1)  then
c         call echo('Calculating chi...')
c         call ff2chi (ipr4, critcw, s02, tk, thetad, icsig,
c     1        vrcorr, vicorr)
c      endif

       call echo('Feff done.  Have a nice day.')
       end

      subroutine rdhead (io, nhead, head, lhead)
      implicit double precision (a-h, o-z)

c     Reads title line(s) from unit io.  Returns number of lines
c     read.  If more than nheadx lines, skips over them.  End-of-header
c     marker is a line of 1 blank, 71 '-'s.
c     lhead is length of each line w/o trailing blanks.
c     header lines returned will have 1st space on line blank for
c     carriage control

      character*80 head(nhead)
      dimension lhead(nhead)
      character*80  line

      n = 0
      nheadx = nhead
      nhead = 0
   10 read(io,20)  line
   20    format(a)
         if (line(4:11) .eq. '--------')  goto 100
         n = n+1
         if (n .le. nheadx)  then
            head(n) = line
            lhead(n) = istrln(head(n))
            nhead = n
         endif
      goto 10
  100 continue
      return
      end

      subroutine xcpot (iph, ie, nr, index, ifirst, jri,
     1                  em, xmu, vi0, rs0, gamach,
     2                  vr, densty,
     3                  eref, v,
     4                  vxcrmu, vxcimu)

      implicit double precision (a-h, o-z)

c     INPUT
c     iph, ie used only for debug and labels.
c     nr          number of points in current Loucks r-grid
c     index       0  Hedin-Lunqvist + const real & imag part
c                 1  Dirac-Hara + const real & imag part
c                 2  ground state + const real & imag part
c                 3  Dirac-Hara + HL imag part + const real & imag part
c                 4  See rdinp for comment
c     ifirst      first entry flag, set to zero before first call for
c                 each unique potential, see vxcrmu and vxcimu below
c     jri         index of first interstitial point in current
c                 Loucks r grid
c     em          current energy grid point
c     xmu         fermi level
c     vi0         const imag part to subtract from potential
c     rs0         user input density cutoff, index=4 only
c     gamach      core hole lifetime
c     vr(nr)      total potential (coulomb and gs exchange corr)
c     densty(nr)  electron density
c
c     OUTPUT
c     eref        complex energy reference for current energy
c     v(nr)       complex potential including energy dep xc
c
c     WORKSPACE
c     vxcrmu and vxcimu are calculated only on first entry for a
c     particular unique potential, re-used on subsequent entries.
c     vxcrmu(nr)  real part of xc at fermi level
c     vxcimu(nr)  imag part of xc at fermi level
c
c     This subroutine uses atomic (hartree) units for energy,
c     phase uses rydbergs.  All inputs to and outputs from xcpot are
c     in rydbergs.  (Factor of 2 to convert from one to the other.)


      include 'const.h'
      include 'dim.h'

      dimension   vr(nr), densty(nr)
      complex*16  eref, v(nr)
      dimension   vxcrmu(nr), vxcimu(nr)
       character*128 messag
      complex*16  delta

c     First calculate vxc to correct the local momentum dispersion
c     relation, delta = vxc(e,k) - vxc(mu,k), and
c               p^2 = k^2 -mu + kf^2 - delta.
c     In jr theory, v(e,r) = vcoul(r) + vxc(e,r) =
c                          = vcoul(r) + vxcgs(r) + delta(e,r).

      if (index .eq. 2)  then
c        Ground state exchange, no self energy calculation
         do 10  i = 1, jri
            v(i) = vr(i)
   10    continue
      else
c        Add the self energy correction
         do 20  i = 1, jri
            rs = (3 / (4*pi*densty(i))) ** third
c           xf = 1.9191.../rs
            xf = fa / rs

c           xk2 is the local momentum squared, p^2 = k^2 - mu + kf^2,
c           k^2 represents energy measured from vacuum.
c           See formula 2.15 in Lee and Beni's paper with the last 2
c           terms neglected.  (complete reference?)
            xk2 = em + xf**2 - xmu

            if (xk2 .lt. 0)  then
               call echo(' error at XCPOT: xk2<0')
               call echo('  i, jri, rs, densty(i):')
               write(messag,'(2x,2i8,2g15.6)') i, jri, rs, densty(i)
               call echo(messag)
               call echo('  xf, fa, em, xmu, xk2:')
               write(messag,'(2x,5g15.6)')  xf, fa, em, xmu, xk2
               call echo(messag)
               call fstop(' at XCPOT-1')
            endif
            xk = sqrt(xk2)
            if (index .eq. 0)  call rhl(rs,xk,vxcr,vxci)
            if (index .eq. 1)  call edp(rs,xk,vi0,vxcr,vxci)
            if (index .eq. 3)  then
               call edp(rs,xk,vi0,vxcr,vxci)
               call imhl(rs,xk,vxci,icusp)
            elseif (index .eq. 4)  then
               rstmp = (1/rs**3 - 1/rs0**3) ** (-third)
               call edp(rstmp,xk,vi0,vxcr1,vxci1)
               call rhl(rs0,xk,vxcr2,vxci2)
               vxcr = vxcr1 + vxcr2
               vxci = vxci1 + vxci2
            endif

            if (ifirst .eq. 0)  then
c              vxc_mu indep of energy, calc only once
c              Calculate vxc at fermi level e = mu, j.m. 1/12/89
               xk = xf * 1.00001
               if (index .eq. 0) call rhl(rs,xk,vxcrmu(i),vxcimu(i))
               if (index .eq. 1) call edp(rs,xk,vi0,vxcrmu(i),vxcimu(i))
               if (index .eq. 3) then
                  call edp(rs,xk,vi0,vxcrmu(i),vxcimu(i))
                  call imhl (rs,xk,vxcimu(i),icusp)
               elseif (index .eq. 4)  then
                  rstmp = (1/rs**3 - 1/rs0**3) ** (-third)
                  call edp(rstmp,xk,vi0,vxcr1,vxci1)
                  call rhl(rs0,xk,vxcr2,vxci2)
                  vxcrmu(i) = vxcr1 + vxcr2
                  vxcimu(i) = vxci1 + vxci2
               endif
            endif

            delta = dcmplx (vxcr-vxcrmu(i), vxci-vxcimu(i))

c           Correct local momentum according to the formula
c           p^2 = k^2 - mu + kf^2 - delta.  Note that imag part
c           of delta is ignored, since xk2 is a real quantity.
            xk2 = em + xf**2 - xmu - delta
            if (xk2 .lt. 0)  then
               call echo(' error at XCPOT: xk2<0')
               call echo('   i, ie, iph, xk2, em, xf**2,'//
     $              ' xmu, delta') 
               write(messag,'(2x,3i7,5g15.6)')
     $              i, ie, iph, xk2, em, xf**2, xmu, delta
               call echo(messag)
               call fstop(' at XCPOT-2')
            endif
            xk = sqrt (xk2)

c           recalculate vxc(e,k) and vxc(mu,k) with the corrected
c           local momentum
            if (index .eq. 0)  call rhl(rs,xk,vxcr, vxci)
            if (index .eq. 1)  call edp(rs,xk,vi0,vxcr,vxci)
            if (index .eq. 3)  then
               call edp(rs,xk,vi0,vxcr,vxci)
               call imhl (rs,xk,vxci,icusp)
            elseif (index .eq. 4)  then
               rstmp = (1/rs**3 - 1/rs0**3) ** (-third)
               call edp(rstmp,xk,vi0,vxcr1,vxci1)
               call rhl(rs0,xk,vxcr2,vxci2)
               vxcr = vxcr1 + vxcr2
               vxci = vxci1 + vxci2
            endif

c           delta corrected calculated with new local momentum
            delta = dcmplx (vxcr-vxcrmu(i), vxci-vxcimu(i))

c           Note multiplication by 2 in the exchange correlation part to
c           to convert it to rydberg units.
   19       continue
            v(i) = vr(i) + 2*delta

   20    continue
      endif

c     Reference the potential with respect to mt potential, ie,
c     first interstitial point.  v(jri) = 0

c     Note that the reference does not contain the core hole lifetime
c     since the total atomic potential should have it. However in the
c     perturbation  deltav = v - vmt it cancels out.
c     ( deltav = vat - igamma - (vatmt-igamma) ).

      eref = v(jri)
      do 11  i = 1, jri
         v(i) = v(i) - eref
   11 continue

c     igamma added to the reference so that k^2 = E - Eref, where
c     Eref = Vat(mt) - igamma / 2
      eref = eref - coni * gamach / 2

c     Add const imag part
      eref = eref - coni * vi0

      ifirst = 1
      return
      end

      subroutine mcritk (npat, ipat, ri, beta, indbet,
     1                   ipot, nncrit, fbetac, ckspc, xout, xcalcx)

      include 'const.h'
      include 'dim.h'
      dimension ipat(npatx)
      dimension ri(npatx+1), beta(npatx+1), indbet(npatx+1)
      dimension ipot(0:natx)
      parameter (necrit=9, nbeta=40)
      dimension fbetac(-nbeta:nbeta,0:npotx,necrit), ckspc(necrit)

c     xcalcx is max xcalc encountered so far.  Set to -1 to reset it --
c     otherwise it gets passed in and out as mcritk gets called.

c     We may want path in heap so that other paths built from this
c     path will be considered, but do not want this path to be
c     written out for itself.  Decide that now and save the flag
c     in the heap, so we won't have to re-calculate the mpprm
c     path parameters later.

c     Do not want it for output if last atom is central atom,
c     use xout = -1 as flag for undefined, don't keep it.
      if (ipat(npat) .eq. 0)  then
         xout = -1
         return
      endif

c     Make xout, output inportance factor.  This is sum over p of
c     (product of f(beta)/rho for the scatterers) * 
c                                 (cos(beta0)/rho(npat+1).
c     Compare this to xoutx, max xout encountered so far.
c     Multiply by 100 so we can think in percent.
      xcalc = 0
      do 460  icrit = 1, nncrit
         rho = ri(npat+1) * ckspc(icrit)
c        when beta(0)=90 degrees, get zero, so fudge with cos=.2
         x = max (abs(beta(npat+1)), 0.2) / rho
         do 420  iat = 1, npat
            rho = ri(iat) * ckspc(icrit)
            ipot0 = ipot(ipat(iat))
            x = x * fbetac(indbet(iat),ipot0,icrit) / rho
  420    continue
         xcalc = xcalc + x
  460 continue
      if (xcalc .gt. xcalcx)  xcalcx = xcalc
      xout = 100 * xcalc / xcalcx
      return
      end

      subroutine yzktec (f,af,g,ag,dr,ap,h,k,nd,np,idim, dyzk)
c calculation of yk(r)=zk(r)+ r**(k+1) * integral from r to 
c   infinity of  f(u) * u**(-k-1)
c zk(r) = r**(-k) * integral from 0 to r of f(u) * u**k

c at the origin f(r)=sum from i=1 to nd of af(i)*r**(ap+i-1)
c dr tabulation points   h exponential step
c np number of tabulation points for f
c idim dimension of the blocks f,g and dr

c at the origin yk=cte*r**(k+1)-developement limit
c the constant for yk lies in ap
c output functions yk and zk lie in f and g, and their
c development coefficients at the origin in af and ag.

c integration from point to point by a 4 points method.
c integral from r to r+h = h*(-f(r-h)+13*f(r)+13*f(r+h)-f(r+h+h))/24

      implicit double precision (a-h,o-z)
      include '../HEADERS/dim.h'
      complex*16 f,af,g,ag,ap, dyzk
      dimension f(nrptx),af(10),g(nrptx),ag(10),dr(nrptx)
 
c    initialisation and development coefficients of yk
      np= min(np,idim-1)
      f(np+1)=0.0d0
      b = dble(ap)
      ap=0.0d 00
      g(1)=0.0d 00
      do 15 i=1,nd
         b=b+1.0d 00
         ag(i)=af(i)/(b+k)
         if (af(i).ne.0.0d 00) then
            c=dr(1)**b
            g(1)=g(1)+ag(i)*c
c         for irregular solution b-k-1 can become zero
            if (abs(b-k-1) .le. 0.00001) then
               af(i) = 0.0
               b = b - 1.0d0
            else
               af(i)=(k+k+1)*ag(i)/(b-k-1)
            endif
            ap=ap+af(i)*c
         endif
 15   continue
      do 21 i=1,np
 21   f(i)=f(i)*dr(i)

c     calcualation of zk
      hk=h*k
      e = exp(-h)
      ehk = e**k 

      if (k.ne.0)then
       b1 = (ehk-1.0d0 +hk) / (hk*k)
      else
       b1=h/2.0
      endif

      b0 = h-(1.0+hk)*b1
      do 51 i=1,np
 51      g(i+1)=g(i)*ehk+b0*f(i)+f(i+1)*b1
 
c     calculation of yk
      f(np+1)=g(np+1) + dyzk
      ehk=ehk*e
      i=k+k+1
      hk=hk+h
      b1 = i*(ehk-1.0d0 +hk) / (hk*(k+1))
      b0 = i*h-(1.0+hk)*b1
      do 75  i=np,1,-1
 75      f(i) = f(i+1)*ehk+b0*g(i+1)+b1*g(i)

      ap=(ap+f(1))/(dr(1)**(k+1))
      return
      end

c     These heap routines maintain a heap (array h) and an index
c     array (array ih) used to keep other data associated with the heap
c     elements.

      subroutine hup (h, ih, n)
c     heap is in order except for last element, which is new and must
c     be bubbled through to its proper location
c     new element is at i, j = index of parent
      integer  n,i,j
      integer  ih(n)
      dimension h(n)

      i = n

   10 j = i/2
c     if no parent, we're at the top of the heap, and done
      if (j .eq. 0)  return
      if (h(i) .lt. h(j))  then
         call swap (h(i), h(j))
         call iswap (ih(i), ih(j))
         i = j
         goto 10
      endif
      return
      end

      subroutine hdown (h, ih, n)
c     h is in order, except that 1st element has been replaced.
c     Bubble it down to its proper location.  New element is i,
c     children are j and k.

      integer  n,i,j,k
      integer  ih(n)
      dimension h(n)

      i = 1

   10 continue
      j = 2*i
      k = j + 1

c     if j > n, new element is at bottom, we're done
      if (j .gt. n)  return
c     handle case where new element has only one child
      if (k .gt. n)  k = j

      if (h(j) .gt. h(k))  j = k
c     j is now index of smallest of children

      if (h(i) .gt. h(j))  then
         call swap (h(i), h(j))
         call iswap (ih(i), ih(j))
         i = j
         goto 10
      endif

      return
      end

      subroutine swap (a, b)
      t = a
      a = b
      b = t
      return
      end

      subroutine iswap (i, j)
      integer  i,j,k
      k = i
      i = j
      j = k
      return
      end

      subroutine tabrat
c      tabulation of the results
c do identifications of orbitals
c nmax number of tabulation points for wave function
c      this programm uses dsordf

      implicit double precision (a-h,o-z)
      include '../HEADERS/const.h'
      common/itescf/testy,rap(2),teste,nz,norb,norbsc
      common/ratom1/xnel(30),en(30),scc(30),scw(30),sce(30),
     1nq(30),kap(30),nmax(30)
      character*2  titre(30)
      character*2  ttire(9)
      dimension at(8),mbi(8)
      logical open_16

      external dsordf
      data ttire /'s ', 'p*', 'p ', 'd*', 'd ', 'f*', 'f ','g*', 'g '/

      do 110 i=1,norb
         if (kap(i) .gt. 0) then
           j=2*kap(i)
         else
           j=-2*kap(i)-1
         endif
         titre(i)=ttire(j)
 110  continue

c     tabulation of number of points and of average values of
c                   r**n (n=6,4,2,1,-1,-2,-3)
      inquire(unit=16,opened=open_16)
      do 201 i=2,8
 201     mbi(i)=8-i-i/3-i/4+i/8
      if(open_16) then
        write(16,*)
     1  'number of electrons nel and average values of r**n in a.u.'
        write(16,2061) (mbi(k),k=2,8)
 2061   format (5x,'nel     -E ','     n=',7(i2,8x))
      endif
      do 251 i=1,norb
         llq= abs(kap(i))-1
         j=8
         if (llq.le.0) j=7
         do 241 k=2,j
 241        at(k)=dsordf(i,i,mbi(k),1, zero)
 251     if (open_16)
     .     write(16,2071) nq(i),titre(i),xnel(i),-en(i)*hart,
     1                  (at(k),k=2,j)
 2071 format(i1,a2,f6.3,8(1pe10.3))

c      overlap integrals
      if (norb.le.1) return
      if (open_16) write(16,321)
 321  format(10x,'overlap integrals')
      do 351 i=1,norb-1
         do 331 j=i+1,norb
            if (kap(j).ne.kap(i)) go to 331
            at(1)=dsordf(i,j,0,1, zero)
            if(open_16)
     .        write(16,2091)  nq(i),titre(i),nq(j),titre(j),at(1)
 331     continue
 351  continue
 2091 format (4x,i3,a2,i3,a2,f14.7)
      return
      end

c***********************************************************************
c
c     this subroutine calculates the ' energy dependent
c     exchange-correlation potential' (or 'dirac- hara potential')
c     ref.: paper by s.h.chou, j.j.rehr, e.a.stern, e.r.davidson (1986)
c
c     inputs:    rs in a.u.
c                xk momentum in a.u.
c                vi0 constant imaginary part in rydbergs
c     outputs:   vr --- dirac potential (Hartrees)
c                vi --- constant imag part of the potential (Hartrees)
c     written by j. mustre 8/31/87
c**********************************************************************

      subroutine edp (rs, xk, vi0, vr, vi)
      implicit double precision (a-h, o-z)
      include 'const.h'

      xf = fa / rs

c     p = sqrt (k^2 + kf^2) is the local momentum, and x = p / kf
c     Reference formula 23 in Role of Inelastic effects in EXAFS
c     by Rehr and Chou. EXAFS1 conference editted by Bianconi.
c     x is local momentum in units of fermi momentum

      x = xk / xf
      x = x + 1.0e-5
c     set to fermi level if below fermi level
      if (x .lt. 1.00001) x = 1.00001
      c = abs( (1+x) / (1-x) )
      c = log(c)
      vr = - (xf/pi) * (1 + c * (1-x**2) / (2*x))

c     Note vi=vi0/2 to have both real and imaginary part in hartrees
c     to be consistent with  other subroutines.
      vi = vi0 / 2
      return
      end

      subroutine mkptz
c     makes polarization temsor ptz if necessary
      implicit double precision (a-h, o-z)

c     all input and output through common area /pol/
      include 'pola.h'
      include 'const.h'

c     addittonal local stuff to create polarization tensor ptz(i,j)
      real e2(3)
      complex*16  e(3),eps,epc
      dimension eps(-1:1),epc(-1:1)
       character*128 messag

c     Begin to make polarization tensor
c     Normalize polarization vector
      x = sqrt (evec(1)**2 + evec(2)**2 + evec(3)**2)
      if (x .eq. 0.0) then
         call fstop(
     $        ' at MKPTZ: Polarization vector has zero length')
      endif
      do 290  i = 1, 3
         evec(i) = evec(i) / x
  290 continue
      if (elpty .eq. 0.0) then
c        run linear polarization code
         do 291 i = 1, 3
            ivec(i) = 0.0
  291    continue
      endif
      x = sqrt (ivec(1)**2 + ivec(2)**2 + ivec(3)**2)
      if (x .gt. 0) then
c        run elliptical polarization code
         do 293  i = 1, 3
            ivec(i) = ivec(i) / x
  293    continue
         x = evec(1)*ivec(1)+evec(2)*ivec(2)+evec(3)*ivec(3)
 2935    format(1x,a,3g14.5)
         if (abs(x) .gt. 0.9) then
            write(messag,2935) ' polarization  ',
     $           evec(1), evec(2), evec(3)
            call echo(messag)
            write(messag,2935) ' incidence  ',
     $           ivec(1), ivec(2), ivec(3)
            call fstop(' at MKPTZ: Polarization '//
     $           'almost parallel to the incidence')
         endif
         if (x .ne. 0.0) then
c          if ivec not normal to evec then make in normal, keeping the
c          plane based on two vectors
           do 294 i = 1,3
              ivec(i) = ivec(i) - x*evec(i)
  294      continue
           x = sqrt (ivec(1)**2 + ivec(2)**2 + ivec(3)**2)
           do 295  i = 1, 3
              ivec(i) = ivec(i) / x
  295      continue
         endif
      else
         elpty = 0.0
      endif 
     
      e2(1) = ivec(2)*evec(3)-ivec(3)*evec(2)
      e2(2) = ivec(3)*evec(1)-ivec(1)*evec(3)
      e2(3) = ivec(1)*evec(2)-ivec(2)*evec(1)
      do 296  i = 1,3
        e(i) = (evec(i)+elpty*e2(i)*coni)
  296 continue 
      eps(-1) =  (e(1)-coni*e(2))/sqrt(2.0)
      eps(0)  =   e(3)
      eps(1)  = -(e(1)+coni*e(2))/sqrt(2.0)
      do 297  i = 1,3
        e(i) = (evec(i)-elpty*e2(i)*coni)
  297 continue 
      epc(-1) =  (e(1)-coni*e(2))/sqrt(2.0)
      epc(0)  =   e(3)
      epc(1)  = -(e(1)+coni*e(2))/sqrt(2.0)
      do 298 i = -1,1
      do 298 j = -1,1
c        ptz(i,j) = ((-1.0)**i)*epc(-i)*eps(j)/(1+elpty**2)
c       above - true polarization tensor for given ellipticity, 
c       below - average over left and right in order to have
c       path reversal simmetry
        ptz(i,j) = ((-1.0)**i)*(epc(-i)*eps(j)+eps(-i)*epc(j))
     1               /(1+elpty**2)/2.0
  298 continue
c     end of making polarization tensor

      return
      end

      subroutine scmtmp (verbse, npr, iscmt, ecv, nph, nat, vclap,
     2                edens, edenvl, vtot, vvalgs, rmt, rnrm,qnrm,
     2                ixc, rhoint, vint, xmu, jumprm,
     3                xnferm, xnvmu, xnval,
     4                x0, ri, dx, xnatph, xion, iunf, iz,
     5                adgc, adpc, dgc,dpc, ihole,
     7                rat,iatph,iphat, lmaxsc, rhoval, xnmues, ok,
     8                rgrd, nohole, nscmt, icoul, ca1, rfms1, lfms1,
     9                gtr, xrhole, xrhoce, yrhole, yrhoce )

c     Finds new Fermi level (xmu), electron counts (qnrm)
c     and new valence densities (rhoval).

      implicit double precision (a-h, o-z)
      include '../HEADERS/dim.h'
      include '../HEADERS/const.h'
      include '../HEADERS/parallel.h'
      real*8 wall_commend, wall_commst
      Parameter (Maxprocs = 1)

      logical verbse
c     input
      dimension dmagx(nrptx), dmag0(251)
      dimension vclap(251,0:nphx)
      dimension vtot (251,0:nphx), vvalgs (251,0:nphx)
      dimension xnvmu(0:lx,0:nphx+1), rmt(0:nphx),rnrm(0:nphx)
      dimension xnval (30,0:nphx)
      dimension qnrm(0:nphx), dq(0:nphx)
      dimension ri(nrptx), ri05(251), nr05(0:nphx)
      dimension xnatph(0:nphx), iz(0:nphx), xion(0:nphx)
      dimension rat(3,natx),iatph(0:nphx),iphat(natx), lmaxsc(0:nphx)
      real  rfms1
c     input and output
      dimension edens(251,0:nphx), edenvl(251,0:nphx)
      dimension rhoval(251,0:nphx+1)

c     work space
      dimension xnmues(0:lx, 0:nphx)
      dimension dum(nrptx), vtotph(nrptx),vvalph(nrptx)
      dimension dgc(251,30,0:nphx+1), dpc(251,30,0:nphx+1)
      dimension adgc(10,30,0:nphx+1), adpc(10,30,0:nphx+1)
      dimension dgcn(nrptx,30), dpcn(nrptx,30)
      complex*16 ph(lx+1, 0:nphx)
      complex*16 xrhocp(0:lx,0:nphx), yrhocp(251,0:nphx)

c     special dimension for MPI
c     Maxprocs = max number of processors for parallel execution
c--   This is set in parallel.h
c     npr - actual number of processors is passed to this subroutine
      complex gtr(0:lx, 0:nph, Maxprocs)
      complex*16 xrhoce(0:lx,0:nph,Maxprocs)
      complex*16 xrhole(0:lx,0:nph,Maxprocs)
      complex*16 yrhoce(251,0:nph,Maxprocs)
      complex*16 yrhole(251,0:lx,0:nph,Maxprocs)

      integer iph
c     complex energy grid emg is decomposed into em and eref
      parameter (negx = 80)
      complex*16 emg(negx), em, eref, ee, ep, fl, fr, fxa
c     nflrx should be odd and defines the max of Im energy for
c     the countour
      parameter (nflrx = 17)
      dimension step(nflrx)
c     stuff from feff.f for rdinp, pathfinder and genfmt
      logical ok
c      logical wnstar
c     Following passed to pathfinder, which is single precision.
      character*512 slog
      integer ient
      data ient /0/

c     save stuff from rdinp, so no need to call it again
      save   ri05, ient

      xndif = 0.0d0
      xndifp = 0.0d0
      ient = ient + 1
      if (ient.eq.1) then
         xmu = -0.25d0
         do 15 i= 1,251
  15     ri05(i) = exp (-8.8d0+0.05d0*(i-1))
      endif

      if (verbse) then
         write (slog,10) iscmt, nscmt
 10      format('              SCF ITERATION NUMBER',i3,'  OUT OF',i3)
         call wlog(slog)

         call wlog (' Calculating energy and space dependent l-DOS.')
         call wlog (' It takes time ...')
      endif

c     initialize new valence density
      do 16 iph=0,nphx
      do 16 ir=1,251
  16  rhoval(ir,iph) = 0

c     polarization average in scmt and ldos

      call grids (ecv, xmu, negx, neg, emg, step, nflrx)

c     ie - is number of energy points calculated
      ietot0 = 1
      ee = emg(1)
      ep = dble(ee)
      do 21 ipr=1,Maxprocs
      do 21 iph=0,nph
      do 21 il=0,lx
  21    xrhoce(il,iph, ipr) = 0
      do 22 iph=0,nphx
      do 22 il=0,lx
  22    xnmues(il,iph) = 0
      do 23 ipr=1,Maxprocs
      do 23 iph=0,nph
      do 23  ir = 1,251
  23  yrhoce(ir,iph,ipr) = 0
      iflr = nflrx
      iflrp = nflrx

      nproc = min(npr, Maxprocs)
      n1 = 1
      n2 = min(neg, nproc)

c     Start the cycle over energy points (ie)
  25  continue

c     slow loop for MPI execution
      ie = this_process + n1
      ietot = ietot0 + this_process
      if (ie .gt. n2) go to 200
        ipr = 1 + ie - n1
        if (worker) par_type = 3

c       print *,'process n1 n2 ietot',this_process,n1,n2,ietot

        if (ietot.eq.1 .or. mod(ietot,20).eq.0) then
           if (verbse) then
              write(slog,30) ietot, dble(emg(ie))*hart
 30           format('     point # ', i3, '  energy = ', f7.3)
              call wlog(slog)
           endif
        endif

        do 100  iph = 0, nph
          do 35 i=1, 251
  35      dmag0(i) = 0.d0
cc        use spin-unpolarized case to get SCF. set dmagx to zero
cc        may want to replace dmag0 with dmag(1,iph) for spin-dependent
cc        extension of SCF procedure.
          call fixvar (rmt(iph),edens(1,iph),vtot(1,iph),dmag0,
     1                  vint, rhoint, dx, rgrd, jumprm,
     2                  vjump, ri, vtotph, dum, dmagx)
          if (mod(ixc,10) .ge.5) then
            if (jumprm .gt. 0) jumprm = 2
            call fixvar (rmt(iph), edenvl(1,iph), vvalgs(1,iph),
     1                dmag0, vint, rhoint, dx, rgrd , jumprm,
     2                vjump, ri, vvalph, dum, dmagx)
            if (jumprm .gt. 0) jumprm = 1
          endif

          call fixdsx (iph, dx, rgrd , dgc, dpc, dgcn, dpcn)
          jri = int((log(rmt(iph)) + x0) / rgrd) + 2
          jri1 = jri+1
          eref = vtotph(jri1)
          do 40 i = 1, jri1
  40      vtotph(i) = vtotph(i) - dble(eref)
          if (ixc.ge.5) then
            do 50 i = 1, jri1
  50        vvalph(i) = vvalph(i) - dble(eref)
          else
            do 60 i = 1, jri1
  60        vvalph(i) = vtotph(i)
          endif

           itmp = 0
           if (iph.eq.0 .and. nohole.lt.0) itmp = ihole
           call rholie( ri05, nr05(iph), rgrd, x0, ri, emg(ie), ixc,
     2           rmt(iph), rnrm(iph), vtotph, vvalph, xnval(1,iph),
     3           dgcn, dpcn, eref, adgc(1,1,iph), adpc(1,1,iph),
     4           xrhole(0,iph,ipr), xrhoce(0,iph,ipr),
     5           yrhole(1,0,iph,ipr), yrhoce(1,iph,ipr),
     6           ph(1,iph), iz(iph), xion(iph), iunf, itmp,lmaxsc(iph))
  100   continue

c       Write out phases for fmsie
c       transform neg,emg to em,ne,eref first
        em= dble(emg(ie))
        eref=dble(eref)-coni*dimag(emg(ie))

cc      call fms for a cluster around central atom
        do 115 iph0 = 0,nph
        do 115 il = 0, lx
  115   gtr(il,iph0,ipr) = 0
        if (rfms1 .gt. 0) then
          if (lfms1 .ne. 0) then
            iph0 = 0
c           set logic to call yprep on every processor
            lfms = lfms1
            if (ietot0.eq.1) lfms = 2
            call fmsie(verbse, iph0, nph, lmaxsc, ietot, em, eref, ph,
     1           rfms1, lfms, nat, iphat, rat, gtr(0,0,ipr))
          else
            do 190 iph0 = 0, nph
  190       call fmsie(verbse, iph0, nph, lmaxsc, ietot, em, eref, ph,
     1           rfms1, lfms1, nat, iphat, rat, gtr(0,0,ipr))
          endif
        endif
  200 continue
c     end of slow loop for MPI execution

      ietot0 = ietot0 + n2 - n1 + 1
      if (worker) par_type = 2

      ixl = (lx + 1) * (nph + 1)
      ixly = ixl * 251
      ixlc = (nph + 1) * 251
      if (nproc .gt. 1) then
        call seconds(wall_commst)
        if (worker .and. (ie .le. n2)) then
c-- Send pointers for gtr buffer to master
          call par_send_int(ixl,1,0,this_process)
          call par_send_int(ixly,1,0,this_process)
          call par_send_int(ixlc,1,0,this_process)
c-- Send buffer
          if (ixl .ne. 0) then
            call par_send_cmplx(gtr(0,0,ipr),ixl,0,this_process)
            call par_send_dc(xrhoce(0,0,ipr),ixl, 0, this_process)
            call par_send_dc(xrhole(0,0,ipr),ixl, 0, this_process)
          endif
          if (ixly .ne. 0)
     .      call par_send_dc(yrhole(1,0,0,ipr),ixly, 0, this_process)
          if (ixlc .ne. 0)
     .      call par_send_dc(yrhoce(1,0,ipr),ixlc, 0, this_process)
        else if (master) then
          do i = 1,n2-n1
c-- Receive pointers for gtr buffer from i
            call par_recv_int(ixl,1,i,i)
            call par_recv_int(ixly,1,i,i)
            call par_recv_int(ixlc,1,i,i)
c-- Receive buffer from i
            if (ixl .ne. 0) then
              call par_recv_cmplx(gtr(0,0,i+1),ixl,i,i)
              call par_recv_dc(xrhoce(0,0,i+1),ixl,i,i)
              call par_recv_dc(xrhole(0,0,i+1),ixl,i,i)
            endif
            if (ixly .ne. 0)
     .        call par_recv_dc(yrhole(1,0,0,i+1),ixly,i,i)
            if (ixlc .ne. 0)
     .        call par_recv_dc(yrhoce(1,0,i+1),ixlc,i,i)
          enddo
        endif
c-- Broadcast gtr
c-- Needed here since we aren't done yet
        ilen = ixl * (n2 - n1 + 1)
        ileny = ilen * 251
        ilenc = (nph + 1) * (n2 - n1 + 1) * 251
        call par_bcast_cmplx(gtr(0,0,1),ilen,0)
        call par_bcast_dc(xrhoce(0,0,1),ilen,0)
        call par_bcast_dc(xrhole(0,0,1),ilen,0)
        call par_bcast_dc(yrhole(1,0,0,1),ileny,0)
        call par_bcast_dc(yrhoce(1,0,1),ilenc,0)
        call seconds(wall_commend)
        wall_comm = wall_comm + wall_commend - wall_commst
      endif

c     fast loop (does not need parallel execution)
c     uses results of the above loop to find Fermi level
c     and to decide on next set of energy points
      do 300 ie = n1, n2
        ipr = 1+ ie -n1
        ee = emg(ie)

        if (ie.eq.1 .and. iflrp.ne.1) then
c         the absolutely first point on energy grid
          do 206 iph = 0,nph
          do 206 il = 0,lx
  206     xrhocp(il,iph) = xrhoce(il,iph, ipr)
          do 207 iph = 0,nph
          do 207 i = 1,251
  207     yrhocp(i,iph) = yrhoce(i,iph, ipr)
        endif

        xntot = 0
        if (ie.eq.neg .and. iflrp.gt.1) iflr = 1
        fl = 0
        fr = 0
        do 210 iph = 0,nph
c         calculate density and integrated number of electrons in each
c         channel for each type of atoms density, etc., find xntot.
          call ff2g (gtr(0,iph,ipr), iph,ie, nr05(iph), xrhoce(0,0,ipr), 
     1      xrhole(0,iph,ipr), xrhocp, ee, ep, yrhole(1,0,iph,ipr),
     2      yrhoce(1,iph,ipr),yrhocp(1,iph),rhoval(1,iph),
     3      xnmues(0,iph), xnatph(iph), xntot, iflr, iflrp, fl, fr,iunf)
  210   continue

c       check whether Fermi level is found between points n1 and n2
c       and decide on next set of energy points;
        if (ie.ne.1 .or. iflrp.eq.1) xndifp = xndif
        xndif = xntot - xnferm
c       if (master) print*,'xndif = ', xndif, 'xntot = ',xntot

c       check if the fermi level is found
        if ( iflr.eq.1) then
          if (xndifp*xndif .le. 0.d0) then
c         Fermi level is found ; exit from energy loop
             if (xndif.eq.0) then
               xmunew = dble(emg(ie))
               a=0
             else
               a = xndif/(xndif-xndifp)
               do 220 i = 1,4
                 fxa = a*fl + (1-a)*fr
                 bb = dimag(dcmplx((ep-ee)*(fr+fxa)/2 +
     1                coni*dimag(ee)*(fr-fl)))
                 xndif1 = xndif + a * bb
                 a = a - xndif1 / bb
  220          continue
               xmunew = dble((1-a)*ee+a*ep)
             endif

c            add end cap corrections to the configuration and density
c            factor 2 for spin degeneracy
             do 250 iph = 0,nph
               do 230 il = 0,lx
                if (il.le.2 .or. iunf.ne.0) then
                 fl = xrhocp(il,iph) * 2
                 fr = xrhoce(il,iph,ipr) * 2
                 fxa = a*fl + (1-a)*fr
                 bb = dimag(dcmplx((ep-ee)*(fr+fxa)/2 +
     $                coni*dimag(ee)*(fr-fl)))
                 xnmues(il,iph) = xnmues(il,iph) + a * bb
                endif
  230          continue
               do 240 ir = 1,nr05(iph)
                 fl = yrhocp(ir,iph) * 2
                 fr = yrhoce(ir,iph,ipr) * 2
                 fxa = a*fl + (1-a)*fr
                 bb = dimag(dcmplx((ep-ee)*(fr+fxa)/2 +
     $                coni*dimag(ee)*(fr-fl)))
                 rhoval(ir,iph) = rhoval(ir,iph) + a * bb
  240          continue
  250        continue

c            exit from the energy loop
             goto 305
          endif
        endif
        ep = emg(ie)
        do 256 iph = 0,nph
        do 256 il = 0,lx
  256   xrhocp(il,iph) = xrhoce(il,iph, ipr)
        do 257 iph = 0,nph
        do 257 i = 1,251
  257   yrhocp(i,iph) = yrhoce(i,iph, ipr)

 300  continue

      if (n2.lt.neg .and. iflrp.gt.1) then
        n1 = n2+1
        n2 = min(neg, n2+nproc)
      else
c       set direction of search
        iflr = 1
        iflrp = 1
        idir = -1
        if (xndif.lt.0) idir = 1
        n1 = 1
        n2 = min(nproc, negx)
        do 303 ie = n1, n2
 303    emg(ie) = ep+ idir*step(iflr) * ie
      endif
      goto 25

c     END of the loop over energy in complex plane.
c     new fermi level and densities are calculated.
 305  continue

c     report configuration; repeat iteration if found bad counts.
      ok = .true.
      if (verbse) then
         call wlog('  Electronic configuration')
         call wlog('   iph    il      N_el')
      endif
 310  format (2i6, f9.3)
      do 320 ip= 0,nph
      do 320 il = 0,lx
         if (verbse) then
            write (slog,310) ip,il,xnmues(il,ip)
            call wlog(slog)
         endif
c        check that occupation numbers are consistent with those
c        set in getorb.f
         diff = abs(xnmues(il,ip) - xnvmu(il,ip))
         if (diff.gt.13.1d0 .or. (il.eq.2 .and. diff.gt. 9.1d0) .or.
     1   (il.eq.1 .and. diff.gt.5.1d0) .or.
     2   (il.eq.0 .and. diff.gt.1.95d0)) then
            call wlog (' Found bad counts.')
            write (slog,311) xnvmu(il,ip)
  311       format('  Occupation number in getorb is ', f9.3)
            call wlog(slog)
            call wlog ('  Will repeat this iteration ')
            if (ient.gt.1) ok = .false.
         endif
 320  continue

c     if (.not. ok) then will restart SCF loop
      if (ok) then
         xmu = xmunew
c        find rhoval via Broyden algorithm
         call broydn( iscmt, ca1, nph, xnvmu,
     1         nr05 , xnatph, rnrm, qnrm, edenvl, rhoval, dq)

c        calculate new vclap - overlap coulomb potential
         call coulom (icoul, nph, nr05 , rhoval, edenvl, edens,
     2     nat, rat, iatph, iphat, rnrm, dq, iz, vclap)

c       update array edens
        do 350 ip=0,nph
           do 330 ir=1,nr05 (ip)
             edens(ir,ip)=edens(ir,ip)-edenvl(ir,ip)+rhoval(ir,ip)
  330      continue
           do 340 ir=nr05 (ip)+1,251
             edens(ir,ip)=0.0d0
             edenvl(ir,ip)=0.0d0
  340      continue
  350   continue
      endif

      return
      end

      subroutine potph (isporb, shole, sout)

c     Cluster code -- multiple shell single scattering version of FEFF
c     This program (or subroutine) calculates potentials and phase
c     shifts for unique potentials specifed by atoms and overlap cards.
c
c     Input files:  potph.inp    input data, atoms, overlaps, etc.
c     Output:       phases.bin   phase shifts for use by the rest of the
c                                program
c                   xxx.dat      various diagnostics

      implicit double precision (a-h, o-z)

      include 'const.h'
      include 'dim.h'

      include 'arrays.h'
      common /print/ iprint

      parameter (nheadx = 30)
      character*80 head(nheadx), messag*128
      dimension lhead(nheadx)

      character*10 shole(0:9)
      character*8 sout(0:6)

c     head0 is header from potph.dat, include carriage control
      character*80 head0(nheadx)
      dimension lhead0(nheadx)

      dimension em(nex)
      dimension dgc0(251), dpc0(251)
      dimension xsec(nex), xsatan(nex)

c     nrx = max number of r points for phase r grid
      parameter (nrx = 250)
      dimension ri(nrptx), vtotph(nrx), rhoph(nrx)

      logical DO_pad_io
      DO_pad_io = .true.

   10 format (4x, a, i5)

c     Read input from file potph.inp
      open (unit=1, file='potph.dat', status='old', iostat=ios)
      call chopen (ios, 'potph.dat', 'potph')
      nhead0 = nheadx
      call rpotph (1, nhead0, head0, lhead0, nat, nph,
     1             nfr, ihole, gamach, iafolp, intclc,
     1             ixc, vr0, vi0, rs0, iphat, rat, iatph, ifrph, 
     1             xnatph, novr,
     2             iphovr, nnovr, rovr, folp, ion, iz, iprint, 
     2             ixanes, nemax, xkmin, xkmax, potlbl)
      close (unit=1)

c     Free atom potentials and densities
c     NB wsatom is needed in SUMAX, if changed here, change it there
      wsatom = 15
c     do not save spinors
      ispinr = 0
      do 20  ifr = 0, nfr
         itmp = 0
         if (ifr .eq. 0)  itmp = ihole
         write(messag,10)
     $        'free atom potential and density for atom type', ifr
         call echo(messag)
         call atom (head0(1)(1:40), ifr, iz(ifr), itmp, wsatom,
     1              ion(ifr), vcoul(1,ifr), rho(1,ifr),
     2              ispinr, dgc0, dpc0, et)
c        etfin is absorbing atom final state total energy
c        etinit is absorbing atom initial state (no hole)
         if (ifr .eq. 0)  etfin = et
   20 continue
      if (ixanes .gt. 0)  then
         call echo( '    initial state energy')
c        save spinor for core hole orbital
         ispinr = ihole
c        if no hole, use orbital from isporb
         if (ihole .eq. 0)  ispinr = isporb
         itmp = 0
         call atom (head0(1)(1:40), 0, iz(0), itmp, wsatom,
     1              ion(0), vcoul(1,nfr+1), rho(1,nfr+1),
     2              ispinr, dgc0, dpc0, etinit)
      endif
c     Need etfin if xanes and no hole, use K shell for this
      if (ixanes .gt. 0 .and. ihole .eq. 0)  then
c        K hole
         itmp = 1
         ispinr = 0
         call atom (head0(1)(1:40), 0, iz(0), itmp, wsatom,
     1              ion(0), vcoul(1,nfr+1), rho(1,nfr+1),
     2              ispinr, dgc0, dpc0, etfin)
      endif

c     Overlap potentials and densitites
      do 40  iph = 0, nph
         write(messag,10) 
     1    'overlapped potential and density for unique potential', iph
         call echo(messag)
         call ovrlp (iph, iphat, rat, iatph, ifrph, novr,
     1               iphovr, nnovr, rovr, iz, nat, rho, vcoul,
     2               edens, vclap, rnrm)
   40 continue

c     Find muffin tin radii, add gsxc to potentials, and find
c     interstitial parameters
       call echo('    muffin tin radii and interstitial parameters')
      call istprm (nph, nat, iphat, rat, iatph, xnatph,
     1             novr, iphovr, nnovr, rovr, folp, edens,
     2             vclap, vtot, imt, inrm, rmt, rnrm, rhoint,
     3             vint, rs, xf, xmu, rnrmav, intclc)

c     Automatic max reasonable overlap
      if (iafolp .eq. 1)  then
         call echo('    automatic overlapping')
         call echo('   iph, rnrm(iph)*bohr,'//
     $        ' rmt(iph)*bohr, folp(iph)')
         do 400  iph = 0, nph
            folp(iph) = 1 + 0.7*(rnrm(iph)/rmt(iph) - 1)
            write(messag,'(3x,i8,3g15.6)') iph,
     $           rnrm(iph)*bohr, rmt(iph)*bohr, folp(iph)
            call echo(messag)
 400     continue
         call istprm (nph, nat, iphat, rat, iatph, xnatph,
     1                novr, iphovr, nnovr, rovr, folp, edens,
     2                vclap, vtot, imt, inrm, rmt, rnrm, rhoint,
     3                vint, rs, xf, xmu, rnrmav, intclc)
      endif

c     Initialize header routine and write misc.dat
      call sthead (nhead0, head0, lhead0, nph, iz, rmt, rnrm,
     1             ion, ifrph, ihole, ixc,
     2             vr0, vi0, rs0, gamach, xmu, xf, vint, rs,
     3             nhead, lhead, head, shole, sout)
      if (iprint .ge. 1)  then
         open (unit=1, file='misc.dat', status='unknown', iostat=ios)
         call chopen (ios, 'misc.dat', 'potph')
         call wthead(1)
         close (unit=1)
      endif

      if (iprint .ge. 2)  then
         call wpot (nph, edens, ifrph, imt, inrm,
     1              rho, vclap, vcoul, vtot)
      endif

c     Phase shift calculation
c     Make energy mesh and position grid
      nr = 250
      dx = .05d0
      x0 = 8.8d0
      edge = xmu - vr0
cc      print*,  'potph -> phmesh ', ne

      call phmesh (nr, dx, x0, nemax, iprint,
     1             ixanes, edge, xmu, vint, vr0,
     1             imt, edens, nph,
     2             ri, ne, em, ik0)

cc      print*,  'potph after phmesh ', ne
c     Cross section calculation, use phase mesh for now
c     remove xanes calculation in feff6l

      do 60  iph = 0, nph
         write(messag,10) 'phase shifts for unique potential', iph
         call echo(messag)
c        fix up variable for phase
         call fixvar (rmt(iph), edens(1,iph), vtot(1,iph),
     1                vint, rhoint, nr, dx, x0, ri,
     2                vtotph, rhoph)

cc         print*,  'potph -> phase ', ne
         call phase (iph, nr, dx, x0, ri, ne, em, edge,
     1               ixc, rmt(iph), xmu, vi0, rs0, gamach,
     2               vtotph, rhoph,
     3               eref, ph(1,1,iph), lmax(iph))
cc         print*,  'potph after phase ', ne
   60 continue

      if (iprint .ge. 2)  then
         call wphase (nph, em, eref, lmax, ne, ph)
      endif

c     Write out phases for genfmt
c     May need stuff for use with headers only
      open (unit=1, file='phase.bin', access='sequential',
     1      form='unformatted', status='unknown', iostat=ios)
      call chopen (ios, 'phase.bin', 'potph')
      write(1) nhead
      do 62  i = 1, nhead
         write(1) head(i)
         write(1) lhead(i)
   62 continue
      write(1) ne, nph, ihole, rnrmav, xmu, edge, ik0
      write(1) (em(ie),ie=1,ne)
      write(1) (eref(ie),ie=1,ne)
      do 80  iph = 0, nph
         write(1) lmax(iph), iz(ifrph(iph))
         write(1) potlbl(iph)
         do 70  ie = 1, ne
            write(1)  (ph(ie,ll,iph), ll=1,lmax(iph)+1)
   70    continue
   80 continue
      close (unit=1)

cc
cc optionally, write phase.pad 
cc

      if (do_pad_io) then
         lun  = 9
         npack = 10
         call openfl(lun, 'phase.pad',  'unknown', iex, ier)
         if ((ier.lt.0).or.(iex.lt.0)) then
            call echo(' *** Error: cannot open Potentials.bin')
            return
         end if
         write(lun,'(a,i3)') '#:FEFF6X POT File: npad = ', npack
         write(lun,'(a,i9,i9,i9,i9)') '#:ne,nph,ihole,ik0 =  ',
     $        ne, nph, ihole, ik0
         write(lun, '(a,g22.15)') '#% rnrmav = ', rnrmav
         write(lun, '(a,g22.15)') '#% xmu    = ', xmu
         write(lun, '(a,g22.15)') '#% edge   = ', edge
         call wrpadd(lun,npack,em,ne)
         call wrpadx(lun,npack,eref,ne)
         do 420  iph = 0, nph
            write(lun, '(2a,3i9)') '#:label,iph,lmax,iz  ', potlbl(iph),
     $           iph, lmax(iph), iz(ifrph(iph))
            do 410  l = 1, lmax(iph)+1
               call wrpadx(lun,npack,ph(1,l,iph),ne)
 410        continue
 420     continue 
         close(lun)
      endif



      return
      end

c     make e and r mesh for phase
c     input:  nr, dx, x0, nemax, iprint,
c             ixanes, edge, xmu, vint, vr0, imt, edens, nph
c             edge, xmu... used only with ixanes = 1
c     output: ri(nr), ne, em(ne), ik0 [grid point with k=0]
c
c     set nemax = nex (from dim.h) for max number of points

      subroutine phmesh (nr, dx, x0, nemax, iprint,
     1                   ixanes, edge, xmu, vint, vr0,
     1                   imt, edens, nph,
     2                   ri, ne, em, ik0)
      implicit double precision (a-h, o-z)
      include 'const.h'
      include 'dim.h'
      dimension ri(nr), em(nex)

c     edens       overlapped density*4*pi
c     imt         r mesh index just inside rmt
c     see arrays.h
      dimension edens(nrptx,0:nphx)
      dimension imt(0:nphx)

c     r mesh
      do 100  i = 1, nr
         ri(i) = rr(i)
  100 continue

c     xkmin needed only with ixanes
      if (ixanes .gt. 0)  then
c        Need xf**2 min for all unique potentials, take rho(imt) as
c        min rho
         xf2int = xmu-vint
         xf2min = xf2int
         do 400  i = 0, nph
            rs = (3 / edens(imt(i),i)) ** third
            xf2 = (fa / rs) ** 2
            if (xf2 .le. xf2min) xf2min = xf2
  400    continue

         xkmin2 = xf2min - vr0
         if (xkmin2 .lt. 0)  then
c            print*, ' xf2min, vr0, xkmin2'
c            print*, xf2min, vr0, xkmin2
c            print*, 'bad vr0 in phmesh'
            call fstop(' at PHMESH: bad vr0')
         endif

         delk = bohr/5
         xkmin = sqrt (xkmin2)
         n = int(xkmin/delk) - 1
      else
         xkmin = 0
         n = 0
      endif

c     energy mesh
c      n pts (-2 le k lt 0,  delk=0.2 ang(-1) ) (only if xanes)
c     30 pts (0 le k le 5.8, delk=0.2 ang(-1) )
c      9 pts (6 le k le 10., delk=0.5 ang(-1) )
c     10 pts (11 le k le 20.0, delk=1.0 ang(-1) )
      ne = 0
      delk = bohr/5
      if (ixanes .gt. 0)  then
         xkmin = n*delk
         do 110 i=1,n
            tempk=-xkmin+(i-1)*delk
            ne = ne+1
            em(ne)=-tempk**2+edge
  110    continue
      endif
      delk = bohr/5
      do 112 i=1,30
         tempk=(i-1)*delk
         ne = ne+1
         em(ne)=tempk**2+edge
         if (i.eq.1)  ik0 = ne
  112 continue
      delk = bohr/2
      do 113 i=1,9
         tempk=6.*bohr + (i-1)*delk
         ne = ne+1
         em(ne)=tempk**2+edge
  113 continue
      delk=bohr
      do 114 i=1,10
         tempk=11.*bohr + (i-1)*delk
         ne = ne+1
         em(ne)=tempk**2+edge
  114 continue

c     print*, 'phmesh: ne, nex, nemax before setting ne ',
c    1                 ne, nex, nemax
      ne = min (ne, nemax)
c     print*, 'phmesh: ne, nex, nemax after  setting ne ',
c    1                 ne, nex, nemax


      if (iprint .ge. 3)  then
         open (unit=44, file='emesh.dat')
         write(44,*) 'edge, bohr, edge*ryd ', edge, bohr, edge*ryd
         write(44,*) 'ixanes, ik0 ', ixanes, ik0
         write(44,*) vint, xkmin, n, ' vint, xkmin, n'
         write(44,*) 'ie, em(ie), xk(ie)'
         do 230  ie = 1, ne
            write(44,220)  ie, em(ie), getxk(em(ie)-edge)/bohr
  220       format (i5, 2f20.5)
  230    continue
         close (unit=44)
      endif

      return
      end

       subroutine feffdt(ntotal,iplst,nptot,ntext,text,ne,
     $      iorder, l0, rnrmav, edge, potlbl,
     $      iz,phc,ck,xk,index,
     $      nleg,deg,reff,crit,ipot,rat,achi,phchi)
c
c     removed ihole, neptsm, npot, xmu from arg list
c
c     writes feffnnnn.dat files and files.dat
c     for compatibility with the old feff
c
      implicit double precision (a-h, o-z)

      include '../HEADERS/const.h'
      include '../HEADERS/dim.h'
      include '../HEADERS/vers.h'
      parameter (eps4 = 1.0d-4)
      parameter (eps = 1.0d-16)

      parameter (npx=15000)
      character*12 fname(npx)
      character*512 slog
      dimension iplst(npx)

c     Stuff from feff.pad, note that floating point numbers are
c     single precision
cc      character*78 string
      real rnrmav, edge
c      real xmu
cc      dimension ltext(nheadx)
      character*80 text(nheadx), lines(2*nheadx)
      character*6  potlbl(0:nphx)
      dimension iz(0:nphx)
c     central atom phase shift at l0
      complex phc(nex)
      complex ck(nex)
      real xk(nex)
      dimension index(npx)
      dimension nleg(npx)
      real deg(npx), reff(npx), crit(npx)
      dimension ipot(legtot,npx)
      real rat(3,legtot,npx)
cc      real beta(legtot,npx)
cc      real eta(legtot,npx)
cc      real ri(legtot,npx)
      real achi(nex,npx), phchi(nex,npx)
      integer istrln
c      complex*16 cchi, cfms
      dimension col1(nex), col2(nex), col3(nex), col4(nex), col5(nex)
      dimension col6(nex), col7(nex)
      real amff(nex), phff(nex)
      dimension ipoths(legtot)
      dimension thsrat(3,legtot)


      external istrln

      call wlog (' feffdt, feff.pad to feff.dat conversion: ' // vfeff
     1            // 'release ' // vf85e)

c     read feff.pad
c     Use single precision for all fp numbers in feff.pad
      do 20  itext = 1, ntext
         ltxt = istrln(text(itext))
c        text(itext) does not have carriage control
         call wlog (' ' // text(itext)(1:ltxt))
   20 continue

      write(slog,60)  nptot
   60 format (i8, ' paths to process')
      call wlog (slog)

c     make files.dat
  160 format (1x, a)
  170 format (1x, 71('-'))

c     Save filenames of feff.dat files
      open (unit=2, file='files.dat', status='unknown', iostat=ios)
      call chopen (ios, 'files.dat', 'genfmt')
c     Put phase header on top of files.dat
      do 200  itext = 1, ntext
         ltxt = istrln( text(itext))
         write(2,160)  text(itext)(1:ltxt)
  200 continue
      write(2,170)
      write(2,210)
  210 format ('    file        sig2   amp ratio    ',
     1        'deg    nlegs  r effective')
c     do each path
      call wlog ('    path     filename')

      do 500  ilist = 1, ntotal
c        find index of path
         do 410  j = 1, nptot
            if (iplst(ilist) .eq. index(j))  then
               i = j
               goto 430
            endif
  410    continue
         write(slog,420)  ilist, iplst(ilist)
  420    format (' did not find path i, iplst(i) ', 2i10)
         call wlog(slog)
  430    continue
c        Path i is the path from feff.pad that corresponds to
c        the path ilist in list.dat.  The index of the path is
c        iplst(ilist) and index(i).

c        Prepare output file feffnnnn.dat
         write(fname(i),220)  index(i)
  220    format ('feff', i4.4, '.dat')
         write(slog,230)  i, fname(i)
  230    format (i8, 5x, a)
         call wlog(slog)
c        zero is debye-waller factor column
         write(2,240) fname(i), zero, crit(i), deg(i),
     1                   nleg(i), reff(i)*bohr
  240    format(1x, a, f8.5, 2f10.3, i6, f9.4)

         ip = i
c     Write feff.dat's
         open (unit=3, file=fname(ip), status='unknown', iostat=ios)
         call chopen (ios, fname(ip), 'feffdt')
c        put header on feff.dat
c$$$         do 300  itext = 1, ntext
c$$$            ltxt = istrln(text(itext))
c$$$            write(3,160)  text(itext)(1:ltxt)
c$$$  300    continue
c$$$
c$$$         write(3,310) ip, iorder
c$$$  310    format (' Path', i5, '      icalc ', i7)
c$$$         write(3,170)
c$$$         write(3,320)  nleg(ip), deg(ip), reff(ip)*bohr, rnrmav,
c$$$     1                 edge*hart
c$$$  320    format (1x, i3, f8.3, f9.4, f10.4, f11.5,
c$$$     1           ' nleg, deg, reff, rnrmav(bohr), edge')
c$$$         write(3,330)
c$$$  330    format ('        x         y         z   pot at#')
c$$$         write(3,340)  (rat(j,nleg(ip),ip)*bohr,j=1,3),
c$$$     1                 ipot(nleg(ip),ip),
c$$$     1                 iz(ipot(nleg(ip),ip)), potlbl(ipot(nleg(ip),ip))
c$$$  340    format (1x, 3f10.4, i3, i4, 1x, a6, '   absorbing atom')
c$$$         do 360  ileg = 1, nleg(ip)-1
c$$$            write(3,350)  (rat(j,ileg,ip)*bohr,j=1,3), ipot(ileg,ip),
c$$$     1                    iz(ipot(ileg,ip)), potlbl(ipot(ileg,ip))
c$$$  350       format (1x, 3f10.4, i3, i4, 1x, a6)
c$$$  360    continue
c$$$
c$$$         write(3,370)
c$$$  370    format    ('    k   real[2*phc]   mag[feff]  phase[feff]',
c$$$     1              ' red factor   lambda     real[p]@#')

         do 900 nl = 1, nleg(ip)
            ipoths(nl) = ipot(nl, ip)
            do 910 i = 1, 3
               thsrat(i, nl) = rat(i, nl, ip)
 910        continue
 900     continue
         call fdthea(ntext, text, ip, iorder, nleg(ip), deg(ip),
     &          reff(ip), rnrmav, edge, thsrat, ipoths, iz, potlbl,
     &          nlines, lines)
         do 920 i=1, nlines
            ltxt = istrln(lines(i))
            write(3, 930) lines(i)(1:ltxt)
 920     continue
 930     format(a)

         do 1000 ie = 1, ne
            amff(ie) = achi(ie,ip)
            phff(ie) = phchi(ie,ip)
 1000    continue
         call fdtarr(ne, reff(ip), l0, amff, phff, phc, xk, ck,
     &       col1, col2, col3, col4, col5, col6, col7)
         do 1005 ie = 1, ne
            write(3,400) col1(ie), col2(ie), col3(ie), col4(ie),
     &             col5(ie), col6(ie), col7(ie)
 1005    continue

c        Make the feff.dat stuff and write it to feff.dat
c        Also write out for inspection to fort.66
c        note that dimag takes complex*16 argument, aimag takes
c        single precision complex argument.  Stuff from feff.pad
c        is single precision, cchi is complex*16
c$$$         do 450  ie = 1, ne
c$$$c           Consider chi in the standard XAFS form.  Use R = rtot/2.
c$$$            cchi = achi(ie,ip) * exp (coni*phchi(ie,ip))
c$$$            xlam = 1.0e10
c$$$            if (abs(aimag(ck(ie))) .gt. eps) xlam = 1/aimag(ck(ie))
c$$$            redfac = exp (-2 * aimag (phc(ie)))
c$$$            cdelt = 2*dble(phc(ie))
c$$$            cfms = cchi * xk(ie) * reff(ip)**2 *
c$$$     1           exp(2*reff(ip)/xlam) / redfac
c$$$            if (abs(cchi) .lt. eps)  then
c$$$               phff = 0
c$$$            else
c$$$               phff = atan2 (dimag(cchi), dble(cchi))
c$$$            endif
c$$$c           remove 2 pi jumps in phases
c$$$            if (ie .gt. 1)  then
c$$$               call pijump (phff, phffo)
c$$$               call pijump (cdelt, cdelto)
c$$$            endif
c$$$            phffo = phff
c$$$            cdelto = cdelt
c$$$c           write 1 k, momentum wrt fermi level k=sqrt(p**2-kf**2)
c$$$c                 2 central atom phase shift (real part),
c$$$c                 3 magnitude of feff,
c$$$c                 4 phase of feff,
c$$$c                 5 absorbing atom reduction factor,
c$$$c                 6 mean free path = 1/(Im (p))
c$$$c                 7 real part of local momentum p
c$$$
c$$$            write(3,400)
c$$$     1         xk(ie)/bohr,
c$$$     2         cdelt + l0*pi,
c$$$     3         abs(cfms) * bohr,
c$$$     4         phff - cdelt - l0*pi,
c$$$     5         redfac,
c$$$     6         xlam * bohr,
c$$$     7         dble(ck(ie))/bohr
c$$$
c$$$  450    continue

 400     format (1x, f6.3, 1x, 3(1pe11.4,1x),1pe10.3,1x,
     1          2(1pe11.4,1x))

c        Done with feff.dat
         close (unit=3)
  500 continue
      close (unit=2)

      return
      end

      subroutine genfmt_writefeffdat(ipath, ntext, text,
     $     nleg, deg, reff, rnrmav, edge, rat, iz, ipot,
     $     potlbl, l0, il0, ne, xk, ck, ph, cchi)
c
c  write feffNNNN.dat file for NNNN=ipath
      implicit none

      include 'const.h'
      include 'dim.h'
      include 'vers.h'
      double precision eps
      parameter (eps = 1.0d-16)

      integer ipath, ntext, nleg, l0, il0, ne, it, istrln
      integer ipot(0:legtot), iz(0:npotx), jpot, ileg, ie, ios

      double precision deg, reff, rnrmav, edge, getxk
      double precision rat(3, 0:legtot+1)
      double precision xlam, redfac, phff, phffo, cdelt, cdelto
      double precision xk(nex), ckmag(nex)

      complex*16 ph(nex, ltot+1, 0:npotx)
      complex*16 cchi(nex), ck(nex), cfms

      character fname*16
      character*80 text(40)
      character*6 potlbl(0:npotx)

      external istrln, getxk

 50   format (a)
 60   format (1x, a)
 70   format (1x, 79('-'))

      write(fname, 241)  ipath
 241  format ('feff', i4.4, '.dat')
      open (unit=3, file=fname, status='unknown', iostat=ios)
      call chopen (ios, fname, 'genfmt')
c     put header on feff.dat
      do 245  it = 1, ntext
         write(3,60)  text(it)(1:istrln(text(it)))
 245  continue
      write(3,250) ipath, 2, vfeff, vgenfm
 250  format (' Path', i5, '      icalc ', i7, t57, 2a12)
      write(3,70)
      write(3,290)  nleg, deg, reff*bohr, rnrmav, edge*ryd
 290  format (1x, i3, f8.3, f9.4, f10.4, f11.5,
     1     ' nleg, deg, reff, rnrmav(bohr), edge')

c
      write(3,300)
 300  format ('        x         y         z   pot at#')
      jpot = ipot(nleg)
      write(3,310)  rat(1,nleg)*bohr, rat(2,nleg)*bohr,
     $     rat(3,nleg)*bohr, jpot, iz(jpot), potlbl(jpot)
 310  format (1x, 3f10.4, i3, i4, 1x, a6, '   absorbing atom')
 311  format (1x, 3f10.4, i3, i4, 1x, a6)
      do 330  ileg = 1, nleg-1
         jpot = ipot(ileg)
         write(3,311)  rat(1,ileg)*bohr, rat(2,ileg)*bohr,
     $        rat(3,ileg)*bohr, jpot, iz(jpot), potlbl(jpot)
 330  continue


      write(3,340)
 340  format    ('    k   real[2*phc]   mag[feff]  phase[feff]',
     1     ' red factor   lambda      real[p]@#')

c     Make the feff.dat stuff and write it to feff.dat
      do 900  ie = 1, ne
c     Consider chi in the standard XAFS form.  Use R = rtot/2.
         xlam = 1.0e10
         if (abs(dimag(ck(ie))) .gt. eps) xlam = 1/dimag(ck(ie))
         redfac = exp (-2 * dimag (ph(ie,il0,ipot(nleg))))
         cdelt = 2*dble(ph(ie,il0,ipot(nleg)))
         cfms = cchi(ie) * xk(ie) * reff**2 *
     1        exp(2*reff/xlam) / redfac
         if (abs(cchi(ie)) .lt. eps)  then
            phff = 0
         else
            phff = atan2 (dimag(cchi(ie)), dble(cchi(ie)))
         endif
c     remove 2 pi jumps in phases
         if (ie .gt. 1)  then
            call pijump (phff, phffo)
            call pijump (cdelt, cdelto)
         endif
         phffo = phff
         cdelto = cdelt

c     write 1 k, momentum wrt fermi level k=sqrt(p**2-kf**2)
c           2 central atom phase shift (real part),
c           3 magnitude of feff,
c           4 phase of feff,
c           5 absorbing atom reduction factor,
c           6 mean free path = 1/(Im (p))
c           7 real part of local momentum p
         write(3,640)
     1        xk(ie)/bohr,
     2        cdelt + l0*pi,
     3        abs(cfms) * bohr,
     4        phff - cdelt - l0*pi,
     5        redfac,
     6        xlam * bohr,
     7        dble(ck(ie))/bohr
 640     format (1x, f6.3, 1x, 3(1pe11.4,1x),0pe11.4,1x,
     1        2(1pe11.4,1x))
 900  continue

      close(3)
      return
      end

      subroutine calc_zabinsky(ne, ik0, deg, ck, cchi, xportx, crit)
c
c calculate Zabinsky Curved Wave Importance Factor for a Path
c
c  input:  ne    number of energy points
c          ik0
c          deg   degeneracy
c          ck    complex k
c          cchi  complex chi(k)
c          xport max importance factor so far
c  output: xport max importance factor so far
c          crit  importance / max importance

      implicit none
      include 'dim.h'
      complex*16 cchi(nex), ck(nex)
      double precision ckmag(nex), ffmag(nex)
      double precision xport, xportx, deg, crit
      integer ie, ne, ik0, nemax

      do 10  ie = 1, ne
         ckmag(ie) = abs(ck(ie))
         ffmag(ie) = abs(cchi(ie))
 10   continue

c     integrate from edge (ik0) to ne
      nemax = ne - ik0 + 1
      call trap(ckmag(ik0), ffmag(ik0), nemax, xport)
      xport = abs(deg*xport)
      if (xport .gt. xportx)  xportx = xport
      crit = 100 * xport / xportx

      return
      end

      subroutine onepath(phpad, index, nleg, deg, iorder,
     &     cxc, rs, vint, xmu, edge, xkf, rnrmav, gamach,
     &     versn, ipot, rat, iz,
     &     ipol, evec, elpty, xivec,
     &     innnn, ixdi, ivrbse, ri, beta, eta,
     &     ne1,col1,col2,col3,col4,col5,col6,col7)

      implicit double precision (a-h, o-z)

c+---------------------------------------------------------------------
c     "Based on or developed using Distribution: FEFF8.5L
c      Copyright (c) [2013] University of Washington"
c
C  See ../HEADERS/license.h for full llicense information
c+---------------------------------------------------------------------
c  compute a single path, generating the F matrix then returning the
c  information contained in a feffNNNN.dat file
c
c  INPUT:
c    phpad:    path to phase.pad file                character*256
c    index:    path index                            integer
c    nleg:     number of legs in path                integer
c    deg:      path degeneracy                       double
c    iorder:   order of approximation in genfmt      integer
c    ipot:     array of unique potentials            integer(legtot)
c    rat:      cartesian coordinates of scatterers   double(3,0:legtot+1)
c    ipol:     flag to do polarization               integer
c    evec:     polarization vector                   double(3)
c    elpty:    ellipticity                           double
c    xivec:    direction of travel                   double(3)
c    innnn:    flag to write feffNNNN.dat file       integer
c    ixdi:     flag to write feffNNNN.xdi file       integer
c    ivrbse:   flag to write screen messages         integer
c
c    also requires a phase.pad file from an earlier run of xsph
c
c  OUTPUT
c    ri:       leg lengths                           double(legtot)
c    beta:     beta angles                           double(legtot+1)
c    eta:      eta angles                            double(legtot+2)
c    ne:       number of k-grid points               integer
c    col1:     k-grid                                double(nex)
c    col2:     central atom phase shifts             double(nex)
c    col3:     magnitude of F_eff                    double(nex)
c    col4:     phase of F_eff                        double(nex)
c    col5:     reduction factor                      double(nex)
c    col6:     mean free path                        double(nex)
c    col7:     real part of complex momentum         double(nex)
c
c  Potential information:
c    cxc:      description of the potential model    character*8
c    rs:       approximate interstitial radius       double
c    vint:     interstitial potential                double
c    xmu:      Fermi energy                          double
c    edge:     threshold relative to atomic value    double
c    xkf:      k value at Fermi energy               double
c    rnrmav:   average Norman radius                 double
c    versn:    Feff versioning                       character*__
c+---------------------------------------------------------------------

      include '../HEADERS/const.h'
      include '../HEADERS/dim.h'
      include '../HEADERS/vers.h'

      character*256 phpad

c+---------------------------------------------------------------------
c     parameters related to the call to regenf
c
c     Input flags:
c     iorder, order of approx in f-matrix expansion (see setlam)
c             (normal use, 2.  Do ss exactly regardless of iorder)
c+---------------------------------------------------------------------
      double precision evec(3), xivec(3), spvec(3)
      complex*16 ptz(-1:1, -1:1)
      integer  iorder
c     integer  mfeff, ipr5
      logical  wnstar
      double precision angks, elpty
c     double precision critcw
      logical nnnn, xdi, verbse
      integer innnn, ixdi, ivrbse

c+----------------------------------------------------------------------
c     removing local common blocks, replacing them with explicit passing
c     of the various data srtuctures
c+----------------------------------------------------------------------
c     include 'clmz.h'
      complex*16 clmi(ltot+1,mtot+ntot+1,legtot)
c     include 'fmatrx.h'
      complex*16 fmati(lamtot,lamtot,legtot)
c     include 'lambda.h'
c     .   mlam(lamtot),     !mu for each lambda
c     .   nlam(lamtot),     !nu for each lambda
c     .   lamx,             !max lambda in problem
c     .   laml0x,           !max lambda for vectors involving absorbing atom
c     .   mmaxp1, nmax      !max mu in problem + 1, max nu in problem
      integer mlam(lamtot), nlam(lamtot), lamx, laml0x, mmaxp1, nmax
c     include 'nlm.h'
      dimension xnlm(ltot+1,mtot+1)
c     include 'rotmat.h'
      dimension dri(ltot+1,2*mtot+1,2*mtot+1,legtot+1)
c     include 'pdata.h'
c      character*80 text(5)
      character*6  potlbl(0:nphx)
      complex*16 ph(nex,-ltot:ltot,0:nphx), eref(nex), em(nex)
      complex caps(nex)
      double precision rat(3,0:legtot+1), rathea(3,legtot)
      double precision ri(legtot), beta(legtot+1), eta(0:legtot+1)
      double precision deg, rnrmav, xmu, edge, rs, vint
      integer lmax(nex,0:nphx), ipot(0:legtot), ipthea(legtot),
     &       iz(0:nphx)


c+----------------------------------------------------------------------
c     parameters used for calling sthead
c+----------------------------------------------------------------------
      double precision xion(0:nphx), rmt(0:nphx), rnrm(0:nphx)
      logical lreal


c      integer ltext(5), ntext
      integer nsc, nleg, npot, ne, ik0, ihole, ixc
      integer kinit, linit, ilinit, lmaxp1
c     common /pdata/ ph(nex,-ltot:ltot,0:nphx), !complex phase shifts ipot=0
c     .  eref(nex),                             !complex energy reference
c     .  rat(3,0:legtot+1),                     !position of each atom, code units(bohr)
c     .  em(nex),                               !energy mesh
c     .  ri(legtot), beta(legtot+1), eta(0:legtot+1), !r, beta, eta for each leg
c     .  deg, rnrmav, xmu, edge,                !(output only)
c     .  lmax(nex,0:nphx),                      !max l with non-zero phase for each energy
c     .  ipot(0:legtot),                        !potential for each atom in path
c     .  iz(0:nphx),                            !atomic number (output only)
c     .  ltext (5),                             !length of each string
c     .  nsc, nleg,                             !nscatters, nlegs (nleg = nsc+1)
c     .  npot, ne,                              !number of potentials, energy points
c     .  ik0,                                   !index of energy grid corresponding to k=0 (edge)
c     .  ipath, ihole,                          !index of current path  and hole (output only)
c     .  kinit, linit, ilinit,                  ! initial state kappa and ang. mom.
c     .  lmaxp1,                                !largest lmax in problem + 1
c     .  ntext                                  !number of text  lines


c+----------------------------------------------------------------------
c     parameters used in the code taken from GENFMT/genfmt.f
c+----------------------------------------------------------------------
      complex*16  rho(legtot), pmati(lamtot,lamtot,2)
      complex*16  pllp, ptrac, srho, prho, cfac
      complex*16  cchi(nex), rkk(nex,8), rkk2(nex,8,nspx)
      complex*16  eref2(nex,nspx), ph4(nex,-ltot:ltot, nspx, 0:nphx)
      complex*16  bmati(-mtot:mtot, 8, -mtot:mtot, 8)
      complex*16  ck(nex), lind(8)
      dimension   xk(nex), ckmag(nex)
c     ckp and ffmag are used to compute importance factor
c     complex*16  ckp
c     dimension   ffmag(nex)
      dimension   eps1(3), eps2(3), vec1(3), vec2(3)

      character*512 slog
      integer ntit
      character*80 titles(nheadx), lines(2*nheadx)

c+----------------------------------------------------------------------
c     parameters related to using padlib
c+----------------------------------------------------------------------
      real phff(nex), amff(nex)
      double precision xkr(nex)
      integer  mpadx
      parameter (mpadx = 8)

c+----------------------------------------------------------------------
c     parameters related to using fdtarr.f and fdthea.f
c+----------------------------------------------------------------------
      character*12 fname
      dimension col1(nex), col2(nex), col3(nex), col4(nex), col5(nex)
      dimension col6(nex), col7(nex)
      real sxk(nex)
      complex sck(nex)

      double precision gamach

c     used for divide-by-zero and trig tests
      parameter (eps = 1.0d-16)
      external xstar

      dimension atarr(3,natx)

      character*30 versn
      character*8 cxc, sout(0:7)
      data sout /'H-L exch', 'D-H exch', 'Gd state', 'DH - HL ',
     1           'DH + HL ', 'val=s+d ', 'sigmd(r)', 'sigmd=c '/

      do 5 i=1,natx
         atarr(1, i) = 0
         atarr(2, i) = 0
         atarr(3, i) = 0
 5    continue
c     atarr is a dummy array used to call mkptz
c     CAUTION: atom coordinates may have been changed by Feff for some
c     funny polarization or ellipticity.  need a test case of funny
c     pol/ell

      wnstar = .false.
c+----------------------------------------------------------------------
c     read genfmt.json and global.json
c keep at input: iorder, ipol, evec, elpty, xivec
c+----------------------------------------------------------------------
c      call regenf(mfeff, ipr5, critcw, iorder, wnstar,
c     &       ipol, ispin, le2, angks, elpty, evec, xivec, ptz)



c+----------------------------------------------------------------------
c     initialize everything needed for the genfmt calculation
c+----------------------------------------------------------------------
      do 10 i=0,nphx
         iz(i) = 0
 10   continue
      call genfmt_prep(phpad, ispin,
c     arguments for rdxsph
     &       ne, ne1, ne3, npot, ihole, rnrmav,
     &       xmu, edge, ik0, ixc, rs, vint,
     &       em, eref2, iz, potlbl, ph4, rkk2, lmax, lmaxp1,
c     arguments for setkap
     &       kinit, linit, ilinit,
c     argument for snlm (an output)
     &       xnlm,
c     things set in genfmt_prep
     &       eref, ph, xk, ck, ckmag, xkr,
     &       nsp, ll, npath, ntotal, nused, xportx)

c      print *, "ik0  mu  kf  edge  rnrmav"
c      print *, ik0, real(em(ik0))*hart, real(ck(ik0))/bohr, edge*hart,
c     &     rnrmav
      xkf = real(ck(ik0))
      cxc = sout(ixc)
      write(versn,12)  vfeff//vf85e
      call setgam(iz(0), ihole, gamach)
c      print *, "iz(0), ihole, gamach", iz(0), ihole, gamach
 12   format( a30)

c+----------------------------------------------------------------------
c     pull out the central atom phase shifts
c+----------------------------------------------------------------------
      do 100 ie=1,ne
         caps(ie) = cmplx(ph(ie, ll, 0))
 100  continue

c+----------------------------------------------------------------------
c     read the input JSON file for this program: onepath.json
c     return ri, beta, eta, rat (like ri, but with 0th and (n++1)th atom)
c+----------------------------------------------------------------------
      le2      = 0
      ispin    = 0
      spvec(1) = 0
      spvec(2) = 0
      spvec(3) = 0
c     call json_read_onepath(index, iorder, ipol,
c    &       nleg, deg, rat, ipot, elpty, evec, xivec, nnnn, json)
      call pathgeom(nleg, nsc, ipol, rat, ipot, ri, beta, eta)
      call mkptz(ipol, elpty, evec, xivec, ispin, spvec, natx, atarr,
     &       angks, le2, ptz)

      nnnn = .false.
      if (innnn .gt. 0) nnnn=.true.
      xdi = .false.
      if (ixdi .gt. 0) xdi=.true.
      verbse = .false.
      if (ivrbse .gt. 0) verbse=.true.

c+----------------------------------------------------------------------
c     fetch the standard output header lines from xsect.json
c+----------------------------------------------------------------------
      ntit = 0
c      call read_titles(ntit, titles)

c+----------------------------------------------------------------------
c  this section is cut-n-pasted from genfmt
c  this is the loop over paragraphs in the paths.dat file
c  the call to rdpath is replaced by the reading of the onepath.json file (for now)
c+----------------------------------------------------------------------
      npath = npath + 1
      ntotal = ntotal + 1
      if (wnstar)  then
c        should be ipol=1
         do 1150 ic =1,3
            vec1(ic) = rat(ic,1) - rat(ic,0)
            vec2(ic) = rat(ic,nleg-1) - rat(ic,0)
            eps1(ic) = evec(ic)
 1150    continue
         if (elpty.ne.0.0) then
            eps2(1) = xivec(2)*evec(3)-xivec(3)*evec(2)
            eps2(2) = xivec(3)*evec(1)-xivec(1)*evec(3)
            eps2(3) = xivec(1)*evec(2)-xivec(2)*evec(1)
         endif
         ndeg = nint (deg)
         xxstar = xstar(eps1, eps2, vec1, vec2, ndeg, elpty,
     &          ilinit)
c        write(4,'(1x,i6,f10.3)')  npath, xxstar
      endif

c     Need reff in code units
      reff = 0
      do 1200  i = 1, nleg
         reff = reff + ri(i)
 1200 continue
      reff = reff/2

c     Set lambda for low k
      call setlam(iorder, 1, beta, nsc, nleg, ilinit,
     &       mlam, nlam, lamx, laml0x, mmaxp1, nmax)

c     Calculate and store rotation matrix elements
      do 1300  isc = 1, nleg
         call rot3i (lmaxp1, mmaxp1, isc, beta, dri)
 1300 continue
      if (ipol.gt.0)  then
c        one more rotation in polarization case
c        NEED MORE rot3j FOR CENTRAL ATOM ( l \pm 1 )
         call rot3i (ilinit+1, ilinit+1, nleg+1, beta, dri)
      endif

c     Start cycle over spin
      do ie = 1, ne
         cchi(ie) = 0
      enddo

      do 6000 is = 1, nsp
         if (nsp.eq.1) then
            call mmtr(bmati, ipol, ispin, le2, angks, ptz, lind,
     &             dri, eta, nsc, nleg, kinit, ilinit)
         else
            call mmtr(bmati, ipol, is, le2, angks, ptz, lind,
     &             dri, eta, nsc, nleg, kinit, ilinit)
         endif
         do 510 ie = 1, ne
            eref(ie) = eref2(ie,is)
 510     continue
         do 520 iph = 0, npot
            do 522 ie = 1, ne
               do 524 il = -lmax(ie, iph), lmax(ie, iph)
                  ph(ie,il, iph) = ph4(ie, il, is, iph)
 524           continue
 522        continue
 520     continue
         do 530 ie = 1, ne
            do 532 kdif = 1, 8
               rkk(ie,kdif) = rkk2(ie,kdif,is)
 532        continue
 530     continue
         do 540 ie = 1, ne
            ck(ie) = sqrt (2* (em(ie) - eref(ie)))
 540     continue

c        Big energy loop
         do 5000  ie = 1, ne
c           complex rho
            do 2010  ileg = 1, nleg
               rho(ileg) = ck(ie) * ri(ileg)
 2010       continue
c           if ck is zero, xafs is undefined.  Make it zero and jump
c           to end of calc part of loop.
            if (abs(ck(ie)) .le. eps)  then
               cchi(ie) = cchi(ie) + 0
               write(slog,2055)  ie, ck(ie)
 2055          format (' genfmt: ck=0.  ie, ck(ie)',i5,1p,2e14.5)
               call wlog(slog)
               goto 4990
            endif
c           Calculate and store spherical wave factors c_l^(m)z^m/m!
c           in a matrix clmi(il,im,ileg), ileg=1...nleg.
c           Result is that common /clmz/ is updated for use by fmtrxi.
c
c           zero clmi arrays
            do 2100  ileg = 1, legtot
               do 2102 im = 1, mtot+ntot+1
                  do 2104  il = 1, ltot+1
                     clmi(il,im,ileg) = 0
 2104             continue
 2102          continue
 2100       continue
            mnmxp1 = mmaxp1 + nmax
            do 2150  ileg = 1, nleg
               isc0 = ileg-1
               if (isc0.eq.0) isc0=nleg
               isc1 = ileg
               lxp1 = max (lmax(ie,ipot(isc0))+1,
     &                lmax(ie,ipot(isc1))+1)
               mnp1 = min (lxp1, mnmxp1)
               call sclmz (rho, lxp1, mnp1, ileg, clmi)
 2150       continue

c           Calculate and store scattering matrices fmati.
c           First matrix
            call fmtrxi(lamx, laml0x, ie, 2, 1,
     &             clmi, mlam, nlam, xnlm, dri,
     &             ph, eta, lmax, ipot, fmati)
c           Last matrix if needed
            if (nleg .gt. 2)  then
               call fmtrxi(laml0x, lamx, ie, nleg, nleg-1,
     &                clmi, mlam, nlam, xnlm, dri,
     &                ph, eta, lmax, ipot, fmati)
            endif
c           Intermediate scattering matrices
            do 2200  ilegp = 2, nsc-1
               ileg = ilegp + 1
               call fmtrxi(lamx, lamx, ie, ileg, ilegp,
     &                clmi, mlam, nlam, xnlm, dri,
     &                ph, eta, lmax, ipot, fmati)
 2200       continue

c           Big matrix multiplication loops.
c           Calculates trace of matrix product
c           M(1,N) * f(N,N-1) * ... * f(3,2) * f(2,1), as in reference.
c           We will calculate the trace over lambda_N, working from
c           right to left.
c           Use only 2 pmati arrays, alternating indp (index p)
c           1 and 2.

c           to start f(2,1) -> pmat(1)
            indp = 1
            do 2250 lmp = 1, laml0x
               do 2252 lm = 1, lamx
                  pmati(lm,lmp,indp)= fmati(lm,lmp,1)
 2252          continue
 2250       continue

c           f(N,N-1) * ... * f(3,2) * [f(2,1)]
c           Term in [] is pmat(1)
            do 2900 isc = 2, nleg-1
c              indp is current p matrix, indp0 is previous p matrix
               indp = 2 - mod(isc,2)
               indp0 = 1 + mod(indp,2)
               do 2850  lmp = 1, laml0x
                  do 2852  lm = 1, lamx
                     pllp=0
                     do 2800 lmi = 1, lamx
                        pllp = pllp +
     1                         fmati(lm,lmi,isc)*pmati(lmi,lmp,indp0)
 2800                continue
                     pmati(lm,lmp,indp) = pllp
 2852             continue
 2850          continue
 2900       continue

c           srho=sum pr(i), prho = prod pr(i)
            srho=0
            prho=1
            do 3200  ileg = 1, nleg
               srho = srho + rho(ileg)
               prho = prho * rho(ileg)
 3200       continue

c           Termination matrix, fmati(...,nleg)
c           Polarization enters only this matrix
c           this will fill fmati(...,nleg) (NO LONGER in common /fmtrxi/)
            call mmtrxi(rkk, laml0x, bmati, ie, 1, nleg,lind,
     &             clmi, mlam, nlam, xnlm, eta, fmati)

c           Final trace over matrix
            ptrac=0
            do 4400  lm = 1, laml0x
               do 4402  lmp = 1, laml0x
                  ptrac = ptrac + fmati(lm,lmp,nleg) *
     &                   pmati(lmp,lm,indp)
 4402          continue
 4400       continue

c           Calculate xafs
c           Complex chi (without 2kr term)
c           ipot(nleg) is central atom
c           cdel1 = exp(2*coni*ph(ie,ilinit+1,0))
c           central atom phase shift are included in normalized
c           reduced matrix elements rkk(....)
            cfac = exp(coni*(srho-2*xk(ie)*reff)) / prho

c           now factor 1/(2*l0+1) is inside termination matrix
c           cchi(ie) = ptrac * cfac/(2*l0+1)
            if (nsp.eq.2 .and. is.eq.1) cfac = -cfac
            cchi(ie) = cchi(ie) + ptrac * cfac
c           write(7,5) xk(ie), -12*dimag(cchi(ie)*exp(coni*2*xk(ie)*reff))
c           5              format (3f13.5)

c           When ck(ie)=0, xafs is set to zero.  Calc above undefined.
c           Jump to here from ck(ie)=0 test above.
 4990       continue

 5000    continue
c        end of energy loop
 6000 continue
c     end of loop over spins

c+----------------------------------------------------------------------
c     compute the importance factor of this path
c+----------------------------------------------------------------------
c     call import(ne1, nsp, ik0, deg, ckmag, em, eref2,
c     &       cchi, xportx, crit)


c+----------------------------------------------------------------------
c     compute mag and phase arrays for F_eff, set single precision
c     arrays for xk and ck
c+----------------------------------------------------------------------
      phffo = 0
      do 15 ie = 1, ne1
         phff(ie) = 0
         if (abs(cchi(ie)) .ge. eps) then
            phff(ie) = real(atan2 (dimag(cchi(ie)), dble(cchi(ie))))
         end if

c        remove 2 pi jumps in phase
         if (ie.gt.1) call pijump (dble(phff(ie)), phffo)
         phffo    = dble(phff(ie))
         amff(ie) = real(abs(cchi(ie)))
         sxk(ie)  = real(xk(ie))
         sck(ie)  = cmplx(ck(ie))
 15   continue

c+----------------------------------------------------------------------
c  the following get stored in feff.pad for each path:
c        ipath, nleg, deg, reff (*bohr), crit, ipot(1, nleg)
c        rat beta eta ri amff phff
c
c  instead, we'll skip straight to the chore performed in feffdt where
c  the stuff from feff.pad has been read and is written out to the form
c  of a feffNNNN.dat file
c+----------------------------------------------------------------------

c+----------------------------------------------------------------------
c        compute the columns of feffNNNN.dat
c+----------------------------------------------------------------------
      call fdtarr(ne1, real(reff), ilinit, amff, phff, caps, sxk, sck,
     &       col1, col2, col3, col4, col5, col6, col7)

      if (nnnn .or. xdi) then
         do 36 il=1,legtot
            ipthea(il) = ipot(il)
            do 33 ix=1,3
               rathea(ix,il) = rat(ix,il)
 33         continue
 36      continue

         do 38 ip = 0, nphx
            xion(ip) = 0.
            rmt(ip)  = 0.
            rnrm(ip) = 0.
 38      continue
         lreal  = .false.
         rgrd   = 0.05
         vr0    = 0.
         vi0    = 0.
         gamach = gamach/hart
         call sthead (ntit, titles, npot, iz, rmt, rnrm,
     1          xion, ihole, ixc,
     2          vr0, vi0, gamach, xmu, xkf, vint, rs,
     2          lreal, rgrd)
         gamach = gamach*hart
      endif

      if (nnnn) then
c        Prepare output file feffnnnn.dat
         write(fname,20)  index
 20      format ('f3ff', i4.4, '.dat')
         write(slog,30)  index, fname
 30      format (i8, 5x, a)
         if (verbse) print *, slog(1:40)
c         call wlog(slog)

c        Write feff.dat's
         open (unit=3, file=fname, status='unknown', iostat=ios)
         call chopen (ios, fname, 'onepath')


c+----------------------------------------------------------------------
c        write out the feffNNNN.dat header
c+----------------------------------------------------------------------

         call fdthea(ntit, titles, index, iorder, nleg, real(deg),
     &          real(reff), real(rnrmav), real(edge), rathea, ipthea,
     &          iz, potlbl, nlines, lines)
         do 40 i=1, nlines
            write(3, 50)lines(i)
 40      continue

 50      format(a)

c+----------------------------------------------------------------------
c        write out the feffNNNN.dat columns
c+----------------------------------------------------------------------
         do 60 ie = 1, ne1
            write(3,70) col1(ie), col2(ie), col3(ie), col4(ie),
     &             col5(ie), col6(ie), col7(ie)

 60      continue
 70      format (1x, f6.3, 1x, 3(1pe11.4,1x),1pe10.3,1x,
     1          2(1pe11.4,1x))

c        Done with feff.dat
         close (unit=3)
      end if
c     end of conditional for writing feffNNNN.dat



      if (xdi) then
c        Prepare output file feffnnnn.xdi
         write(fname,120)  index
 120     format ('feff', i4.4, '.xdi')
         write(slog,130)  index, fname
 130     format (i8, 5x, a)
         if (verbse) print *, slog(1:40)
c         call wlog(slog)

c        Write feff.xdi's
         open (unit=3, file=fname, status='unknown', iostat=ios)
         call chopen (ios, fname, 'onepath')


c+----------------------------------------------------------------------
c        write out the feffNNNN.xdi header
c+----------------------------------------------------------------------

         call fdtxdi(ntit, titles, index, iorder, nleg, real(deg),
     &          real(reff), real(rnrmav), real(edge), rathea, ipthea,
     &          iz, potlbl, nlines, lines)
         do 140 i=1, nlines
            write(3, 150)lines(i)
 140     continue
 150     format(a)

c+----------------------------------------------------------------------
c        write out the feffNNNN.xdi columns
c+----------------------------------------------------------------------
         do 160 ie = 1, ne1
            write(3,170) col1(ie), col2(ie), col3(ie), col4(ie),
     &             col5(ie), col6(ie), col7(ie)

 160     continue
 170     format (1x, f6.3, 1x, 3(1pe11.4,1x),1pe10.3,1x,
     1          2(1pe11.4,1x))

c        Done with feff.dat
         close (unit=3)
      end if
c     end of conditional for writing feffNNNN.xdi

      end

      double precision function cwig3j (j1,j2,j3,m1,m2,ient)
c     wigner 3j coefficient for integers  (ient=1)
c                         or semiintegers (ient=2)
c     other arguments should be multiplied by ient
 
      implicit double precision (a-h,o-z)
      parameter (idim = 58)
      character*512 slog
c     dimensions  modified for larger arguments by ala 12.12.94
      dimension al(idim+1),m(12)
      save ini, al
      data ini/1/
c     idim-1 is the largest argument of factorial to calculate

      m3=-m1-m2
      if (ini) 1,21,1
c        initialisation of the log's of the factorials
 1    ini=0
      al(1)=0.0d 00
      do 11 i=1,idim
         b=i
 11      al(i+1)=al(i)+ log(b)
 21   cwig3j=0.0d 00
      if (((ient-1)*(ient-2)).ne.0) go to 101
      ii=ient+ient
c        test triangular inequalities, parity and maximum values of m
      if (( abs(m1)+ abs(m2)).eq.0.and.mod(j1+j2+j3,ii).ne.0) go to 99
      m(1)=j1+j2-j3
      m(2)=j2+j3-j1
      m(3)=j3+j1-j2
      m(4)=j1+m1
      m(5)=j1-m1
      m(6)=j2+m2
      m(7)=j2-m2
      m(8)=j3+m3
      m(9)=j3-m3
      m(10)=j1+j2+j3+ient
      m(11)=j2-j3-m1
      m(12)=j1-j3+m2
      do 41 i=1,12
         if (i.gt.10) go to 31
         if (m(i).lt.0) go to 99
 31      if (mod(m(i),ient).ne.0) go to 101
         m(i)=m(i)/ient
         if (m(i).gt.idim) go to 101
 41   continue

c        calculate 3j coefficient
      max0= max(m(11),m(12),0)+1
      min0= min(m(1),m(5),m(6))+1
      isig=1
      if (mod(max0-1,2).ne.0) isig=-isig
      c=-al(m(10)+1)
      do 61 i=1,9
 61   c=c+al(m(i)+1)
      c=c/2.0d 00
      do 71 i=max0,min0
      j=2-i
      b=al(i)+al(j+m(1))+al(j+m(5))+al(j+m(6))+al(i-m(11))+al(i-m(12))
      cwig3j=cwig3j+isig* exp(c-b)
 71   isig=-isig
      if (mod(j1-j2-m3,ii).ne.0) cwig3j=-cwig3j
 99   return
 101     write(slog,'(a,6i5)') 'error in cwig3j ',j1,j2,j3,m1,m2,ient
         call wlog(slog)
      stop
      end

      subroutine chopen (ios, fname, mod)
c     Writes error msg and stops if error in ios flag from open
c     statement.  fname is filename, mod is module with failed open.
      character*(*) fname, mod
      character*512 slog

c     open successful
      if (ios .le. 0)  return

c     error opening file, tell user and die.
      i = istrln(fname)
      j = istrln(mod)
      write(slog,100)  fname(1:i), mod(1:j)
      call wlog(slog)

  100 format (' Error opening file, ', a, 
     2        ' in module ', a)

      call wlog(' Fatal error')
      call par_stop('CHOPEN')
      end

      subroutine xmult (k, kp, ls, lb, xm1, xm2)

      implicit double precision (a-h, o-z)
      complex*16 xm1, xm2, alslb
      include '../HEADERS/const.h'
c     xm1, xm2 both either real or pure imaginary
      integer a, ap

c     see Grant eq. 6.30. calculate the factors 
c     <k|alpha*A( l, L)|k'> = (-)**(j-m) * 3j( j L j'; -m p m')*R_k,k'
c     R_k,k'(l,L) = \int dr (xm1*P_k*Q_k'+ xm2*Q_k*P_k') * j_l(wr)

c     set the factor in front of bessel function (eq.6.26)
      if (ls+1.eq.lb) then
c        e.g. dipole and quadrupole transition
         aa = (2*lb-1) * (lb+1) / 2.d0
         alslb = coni**ls * sqrt(aa)
      elseif (ls-1.eq.lb) then
c        e.g. cross dipole-octupole
         aa = (2*lb+3) * lb / 2.d0
         alslb = coni**ls * sqrt(aa)
      elseif (ls.eq.lb) then
c        e.g. magnetic dipole
         alslb = coni**ls * (2*lb+1) /sqrt(2.d0)
      else
         alslb = 0
      endif

c     set all angular momenta
      j2 = 2*abs(k) -1
      a = 1
      if (k.gt.0) a=-1
      jp2 = 2*abs(kp) -1
      ap = 1
      if (kp.gt.0) ap=-1

c     calculate xm1 (beta=1 in eq.6.30)
c     check out 2 Kronecker symbols
      lam = (j2-a) / 2
      lamp = (jp2+ap) / 2
      if ( 2*lam.eq.j2-a .and. 2*lamp.eq.jp2+ap) then
         call ninej (lam, lamp, ls, j2,jp2, lb, aa)
         xm1 = alslb * aa * cwig3j(lam, ls, lamp, 0, 0, 1) * (-1)**lam
     1        * sqrt(6.d0*(j2+1)*(jp2+1)*(2*lb+1)*(2*lam+1)*(2*lamp+1) )
         xm1 = xm1 * coni
      else
         xm1 = 0
      endif

c     calculate xm2 (beta=-1 in eq.6.30)
c     check out 2 Kronecker symbols
      lam = (j2+a) / 2
      lamp = (jp2-ap) / 2
      if ( 2*lam.eq.j2+a .and. 2*lamp.eq.jp2-ap) then
         call ninej (lam, lamp, ls, j2,jp2, lb, aa)
         xm2 = alslb * aa * cwig3j(lam, ls, lamp, 0, 0, 1) * (-1)**lam
     1       * sqrt(6.d0*(j2+1)*(jp2+1)*(2*lb+1)*(2*lam+1)*(2*lamp+1) )
c        factor -1 due to complex conjugation of i*Q_k
         xm2 = - coni * xm2
      else
         xm2 = 0
      endif

      return
      end

      subroutine ninej (lam, lamp, ls, j2,jp2, lb, aa)
      implicit double precision (a-h, o-z)
c     calculate 9j-symbol in 6.30 of Grant using eq. C.41 in Messiah

      if (ls.gt.lb) then
        aa = - (ls+lb+1)* sixj(1,2,2*lb,ls+lb,2*ls) *
     1       sixj(2*lb, ls+lb, 2*lamp, jp2, j2) *
     1       sixj(ls+lb,2*ls, 2*lam, j2, 2*lamp)
      elseif (ls.lt.lb) then
        aa = - (ls+lb+1)* sixj(1,2,2*lb,ls+lb,2*ls) *
     1       sixj(ls+lb, 2*lb, jp2, 2*lamp, j2) *
     1       sixj(2*ls, ls+lb, j2, 2*lam, 2*lamp)
      else
c       ls=lb (magnetic dipole)
        aa = -(2*ls+2) * sixj(1,2,2*lb,2*lb+1,2*lb) *
     1       sixj(2*lb, 2*lb+1, 2*lamp, jp2, j2) *
     1       sixj(2*lb, 2*lb+1, j2, 2*lam, 2*lamp)
        aa = aa -(2*ls) * sixj(1,2,2*lb,2*lb-1,2*lb) *
     1       sixj(2*lb-1, 2*lb, jp2, 2*lamp, j2) *
     1       sixj(2*lb-1, 2*lb, 2*lam, j2, 2*lamp)
      endif

      return
      end

      double precision function sixj(j1,j2,j3,j4,j5)
      implicit double precision (a-h, o-z)
c     calculate 6j symbols in eq. c.38, c39 of Messiah
c     all input angular momenta are multiplied by 2 and
c     j2 should be equal to j1+1
      integer g2

      aa = 0
      if (j2.eq.j1+1) then
        if (j4.eq.j3+1) then
c         eq.c.38
          g2 = j5 - 1
          if (g2.ge.abs(j1-j3) .and. g2.le.j1+j3) then
            aa = (1.d0 + (g2+j1-j3)/2.d0) * (1.d0 +(g2-j1+j3)/2.d0) /
     1           (j1+1) /(j1+2)/(j3+1)/(j3+2)
            aa = sqrt(aa) * (-1)**(nint(1+(g2+j1+j3)/2.d0))
          endif
        elseif(j3.eq.j4+1) then
c         eq.c.39
          g2 = j5
          if (g2.ge.abs(j1-j4) .and. g2.le.j1+j4) then
            aa = (1.d0 - (g2-j1-j4)/2.d0) * (2.d0 +(g2+j1+j4)/2.d0) /
     1           (j1+1) /(j1+2)/(j4+1)/(j4+2)
            aa = sqrt(aa) * (-1)**(nint(1+(g2+j1+j4)/2.d0))
          endif
        endif
      endif
      sixj = aa

      return
      end

      subroutine phase (iph, nr, dx, x0, ri, ne, em, edge,
     1                  index, rmt, xmu, vi0, rs0, gamach,
     2                  vtot, edens,
     3                  eref, ph, lmax)

      implicit double precision (a-h, o-z)

c     INPUT
c     iph          unique pot index (used for messages only)
c     nr, dx, x0, ri(nr)
c                  Loucks r-grid, ri=exp((i-1)*dx-x0)
c     ne, em(ne)   number of energy points, real energy grid
c     edge         energy for k=0 (note, edge=xmu-vr0)
c     index        0  Hedin-Lunqist + const real & imag part
c                  1  Dirac-Hara + const real & imag part
c                  2  ground state + const real & imag part
c                  3  Dirac-Hara + HL imag part + const real & imag part
c                  4, 5, 6, see rdinp or xcpot
c     rmt          r muffin tin
c     xmu          fermi level
c     vi0          const imag part to add to complex potential
c     rs0          user input density cutoff, used only with ixc=4
c     gamach       core hole lifetime
c     vtot(nr)     total potential, including gsxc
c     edens(nr)    density
c
c     OUTPUT
c     eref(ne)     complex energy reference including energy dep xc
c     ph(nex,ltot+1) complex scattering phase shifts
c     lmax         max l (lmax = kmax*rmt)

      include 'dim.h'
      parameter (bohr = 0.529 177 249, ryd  = 13.605 698)

      dimension   ri(nr), em(nex), vtot(nr), edens(nr)
      complex*16  eref(nex)
      complex*16  ph(nex,ltot+1)

c     work space for xcpot
      dimension   vxcrmu(nrptx), vxcimu(nrptx)
c     work space for fovrg
      complex*16 p(nrptx), q(nrptx), ps(nrptx), qs(nrptx), vm(nrptx)

      complex*16  p2, xkmt, temp, dny, pu, qu
      complex*16 jl(ltot+2), nl(ltot+2)
      complex*16 v(nrptx)
      external besjn

c     zero phase shifts (some may not be set below)
      do 100  ie = 1, ne
         do 90  il = 1, ltot+1
            ph(ie,il) = 0
   90    continue
  100 continue

c     limit l, lmax = kmax * rmt
c     lmax = rmt * sqrt(em(ne)-edge)
c     Use kmax = 20 so we get enough l-points even if kmax is small
      lmax = rmt * (20 * bohr)
      lmax = min (lmax, ltot)

c     set imt and jri (use general Loucks grid)
c     rmt is between imt and jri (see function ii(r) in file xx.f)
      imt = (log(rmt) + x0) / dx  +  1
      jri = imt+1
      if (jri .gt. nr)  call fstop(' at PHASE: jri > nr')
c     xmt is floating point version of imt, so that
c     rmt = (exp (x-1)*dx - x0).  xmt used in fovrg
      xmt = (log(rmt) + x0) / dx  +  1

      ifirst = 0
c     calculate phase shifts
      do 220 ie = 1, ne

         ihard = 0
         call xcpot (iph, ie, nr, index, ifirst, jri,
     1               em(ie), xmu, vi0, rs0, gamach,
     2               vtot, edens,
     3               eref(ie), v,
     4               vxcrmu, vxcimu)

c        fovrg needs v in form pot*r**2
         do 120  i = 1, jri
            v(i) = v(i) * ri(i)**2
  120    continue

c        p2 is (complex momentum)**2 referenced to energy dep xc
         p2 = em(ie) - eref(ie)
         xkmt = rmt * sqrt (p2)
         call besjn (xkmt, jl, nl)

         do 210  il = 1, lmax+1
            l = il - 1

            call fovrg (il, ihard, rmt, xmt, jri, p2, 
     1                  nr, dx, ri, v, dny,
     1                  pu, qu, p, q, ps, qs, vm)


            temp = (jl(il)*(dny-l) + xkmt*jl(il+1))  /
     1             (nl(il)*(dny-l) + xkmt*nl(il+1))
            xx = dble (temp)
            yy = dimag(temp)
            if (xx .ne. 0)  then
               alph = (1 - xx**2 - yy**2)
               alph = sqrt(alph**2 + 4*xx**2) - alph
               alph = alph / (2 * xx)
               alph = atan (alph)
            else
               alph = 0
            endif
            beta = (xx**2 + (yy+1)**2) /
     1             (xx**2 + (yy-1)**2)
            beta = log(beta) / 4

            ph(ie,il) = dcmplx (alph, beta)

c           cut phaseshift calculation if they become too small
            if (abs(ph(ie,il)) .lt. 1.0e-6)  goto 220

  210    continue

  220 continue


c     Warn user if fovrg failed ihard test.
      if (ihard .gt. 0)  then
         call echo('  Hard tests failed in fovrg.')
         call echo(' Muffin-tin radius may be too large;'//
     1               ' coordination number too small.')
      endif

      return
      end

      subroutine str2dp(str,dpval,ierr)
c  return dp number "dpval" from character string "str"
c  if str cannot be a number, ierr < 0 is returned.
      character*(*) str, fmt*15 
      double precision dpval
      integer  ierr , lenmax
      parameter ( lenmax = 40)
      logical  isnum
      external isnum
      ierr = -99
      if (isnum(str)) then
         ierr = 0
         write(fmt, 10) min(lenmax, len(str))
 10      format('(bn,f',i3,'.0)')
         read(str, fmt, err = 20, iostat=ierr) dpval
      end if    
      if (ierr.gt.0) ierr = -ierr
      return
 20   continue
      ierr = -98
      return
c end subroutine str2dp
      end
      subroutine str2re(str,val,ierr)
c  return real from character string "str"
      character*(*) str 
      double precision dpval
      real     val
      integer  ierr
      call str2dp(str,dpval,ierr)
      if (ierr.eq.0) val = real(dpval)
      return
c end subroutine str2re
      end
      subroutine str2in(str,intg,ierr)
c  return integer from character string "str"
c  returns ierr = 1 if value was clearly non-integer
      character*(*) str 
      double precision val, tenth
      parameter (tenth = 1.d-1)
      integer  ierr, intg
      call str2dp(str,val,ierr)
      if (ierr.eq.0) then
         intg = int(val)
         if ((abs(intg - val) .gt. tenth))  ierr = 1
       end if
      return
c end subroutine str2in
      end

c      subroutine solin (en,fl,agi,api,kap,rmt,jri,imax,ic3,vm, iwkb)
      subroutine solin (en,fl,kap,jri,imax,ic3,vm, iwkb)
c                  resolution of the dirac equation
c                   p' - kap*p/r = - ( en/cl-v )*g - eg/r
c                   g' + kap*g/r = ( 2*cl+en/cl-v )*p + ep/r
c at the origin v approximately is -z/(r*cl) due to the point nucleus
c en one-electron energy in atomic units and negative
c fl power of the first term in development at the origin
c agi (api) initial values of the first development coefficient
c at the origin of the large(small)component
c kap quantum number kappa
c imax the last point of tabulation of the wave function

      implicit double precision (a-h,o-z)
      include '../HEADERS/dim.h'
      include '../HEADERS/const.h'
      parameter (npi=6, test=1.0d+5)
      complex*16 en,c3,vmh
c      complex*16 agi,api
      complex*16 gg,ag,gp,ap,dv,av,eg,ceg,ep,cep, vm(nrptx)
      common/comdic/cl,dz,gg(nrptx),ag(10),gp(nrptx),ap(10),dv(nrptx),
     1   av(10),eg(nrptx),ceg(10),ep(nrptx),cep(10)

      complex*16 ec,eph,f,g,ac,bc,acp,bcp,dg,dp
c      complex*16 egh, vh
c      complex*16 dg2, dp2, dg3, dp3, dg4, dp4
      dimension dg(npi), dp(npi)

c gg,gp -output, dv,eg,ep - input
c
c cl speed of light (approximately 137.037 in atomic units)
c dz nuclear charge
c gg (gp) large (small) component
c dv direct potential (v)     eg and ep exchange potentials
c ag,ap,av,ceg and cep are respectively the
c development coefficients for gg,gp,dv,eg and ep
c
      common/tabtec/hx,dr(nrptx),test1,test2,ndor,np,nes,method,idim
c hx exponential step
c dr radial mesh
c test1,test2,nes,method are dummy.
c  ndor number of terms for the developments at the origin
c np maximum number of the tabulation points
c idim dimension of the block dr
      complex*16 jl(0:ltot+1), hl(0:ltot+1), xkmt, ck, dum1, factor
      external besjh

      ccl=cl+cl
      ihard = 0
      ec=en/cl
      do 115 i=2,ndor
         ag(i)=0.0d0
 115     ap(i)=0.0d0
c     integration of the inhomogenious system
c     no need in normalization, since we can use 
c     normalization agi=ag(1)=const
 
c            solution of the inhomogenios dirac equation
c gg gp initially exch. terms, at the time of return are wave functions
c ag and ap development coefficients of  gg and gp
c en one-electron energy
c fl power of the first development term at the origin
c agi (api) initial values of the first development coefficients
c at the origin of a large (small) component
 
c     started with h_l above jri inside dfovrg
      vmh = cl * dv(jri+1)
      ck = sqrt(2*(en-vmh) + (alphfs*(en-vmh))**2)
      il = abs(kap)
      if (kap.lt. 0) il = il - 1
      ilp = il - 1
      if (kap .lt. 0) ilp = il + 1
      ilx = il+1
      if (ilp.gt.il) ilx=ilp+1
      xsign = -1.d0
      if (kap.gt.0) xsign = 1.d0
      factor = ck*alphfs
      factor = xsign * factor/(1+sqrt(1+factor**2))
      dum1 = 1/ sqrt(1+factor**2)

      iflat = min ( jri, iwkb)
      do i = jri, imax
        j= iflat + npi - i
        xkmt = ck * dr(i)
        call besjh( xkmt, ilx, jl, hl)
        gg(i) = hl(il) * dr(i) * dum1
        gp(i) = hl(ilp) * dr(i) * dum1 * factor
        if (j.gt.0) then
          f = (ec - dv(i))*dr(i)
          g = f + ccl * dr(i)
          c3 = ic3*vm(i)/g**2
          dg(j) = -(  g*gp(i) - kap*gg(i) )
          dp(j) = -(  kap*gp(i) - (f-c3)*gg(i) )
c         neglect exchage term outside jri
c         dg(j) = -(  g*gp(i) - kap*gg(i) + ep(i) )
c         dp(j) = -(  kap*gp(i) - (f-c3)*gg(i) - eg(i) )
        endif
      enddo

c     use flatv between iwkb and jri
      do i = jri-1, iflat, -1
         j= iflat + npi - i
         if (i.eq.iwkb) then
            eph = cl* ( 3*dv(iwkb+1) - dv(iwkb+2)) /2
            if (iwkb.eq.jri-1) eph=  cl* (dv(i) + dv(i+1)) /2
         else
            eph = cl* (dv(i) + dv(i+1)) /2
         endif
         if (ic3.gt.0) then
           rav = (dr(i)+dr(i+1)) / 2
           ec = rav**3 * ( ccl+ (en - eph) / cl )**2
           eph = eph + ic3 * cl / ec * (vm(i) + vm(i+1)) / 2
         endif
         call flatv( dr(i+1), dr(i), gg(i+1), gp(i+1), en, eph, kap,
     1               gg(i), gp(i))
         if (j.gt.0) then
          f = (ec - dv(i))*dr(i)
          g = f + ccl * dr(i)
          c3 = ic3*vm(i)/g**2
          dg(j) = -(  g*gp(i) - kap*gg(i) + ep(i) )
          dp(j) = -(  kap*gp(i) - (f-c3)*gg(i) - eg(i) )
         endif
      enddo

c     integration of the inhomogenious system
      a1 = hx * 3.3
      a2 = -hx * 4.2
      a3 = hx * 7.8
      a4 = hx * 14.0/45.0
      a5 = hx * 64.0/45.0
      a6 = hx * 24.0/45.0
c     do 55 i = jri - npi + 1 , 2, -1
      do 55 i = iflat, 2, -1
         nit = 0
c        predictor
         acp=gg(i+5)+a1*(dg(npi)+dg(npi-4))+a2*(dg(npi-1)+dg(npi-3))
     1       +a3*dg(npi-2)
         bcp=gp(i+5)+a1*(dp(npi)+dp(npi-4))+a2*(dp(npi-1)+dp(npi-3))
     1       +a3*dp(npi-2)
c        ac,bc -corrector w/o contribution from derivatives at i+1
         ac=gg(i+3)+a4*dg(npi-3)+a5*(dg(npi)+dg(npi-2))+a6*dg(npi-1)
         bc=gp(i+3)+a4*dp(npi-3)+a5*(dp(npi)+dp(npi-2))+a6*dp(npi-1)
         do 61 j=1,npi-1
            dg(j)=dg(j+1)
 61         dp(j)=dp(j+1)
         f=(ec-dv(i-1))*dr(i-1)
         g=f+ccl*dr(i-1)
         c3 = ic3*vm(i-1)/g**2
 64      dg(npi)= -( g*bcp-kap*acp+ep(i-1) )
         dp(npi)= -( kap*bcp-(f-c3)*acp-eg(i-1) )
c        corrected values
         gg(i-1)=ac+a4*dg(npi)
         gp(i-1)=bc+a4*dp(npi)
         if ( abs(test*(gg(i-1)-acp)) .gt. abs(gg(i-1)) .or.
     1        abs(test*(gp(i-1)-bcp)) .gt. abs(gp(i-1)) ) then
c           test failed
            if (nit.lt.40) then
               acp = gg(i-1)
               bcp = gp(i-1)
               nit = nit + 1
               goto 64
            else
               ihard = ihard+1
            endif
         endif
 55   continue

      do 741 i=imax+1,np
         gg(i)=0.0d 00
 741     gp(i)=0.0d 00
      ag(1)=gg(1)* dr(1)**(-fl)
      ap(1)=gp(1)* dr(1)**(-fl)

      return
      end

      double precision function ffq (q, ef, xk, wp, alph)
      implicit double precision (a-h,o-z)

c     input:  q, wp, alph, ef, xk
c             q is dimensionless, normalized to fermi momentum
c             xk is momentum in invBohrs
c     output: ffq only

      wq = sqrt (wp**2 + alph*q**2 + q**4)
      ffq = (wp+wq)/(q**2) + alph/(2*wp)
      ffq = ((ef*wp) / (4*xk))  * log(ffq)

      return
      end

      subroutine exconv (omega, nk, efermi, s02, erelax, wp, xmu)
      parameter (nfinex = 601)
c     convolution of xmu(e) with excitation spectrum, which is modeled
c     by: f(e) = s02*delta(e) + theta(e)*exp(-e/ed)*x1 + fp(e)
c     plasmon contribution modeled by fp(e) = theta(e-wp)*exp(-e/wp)*x2
c     normalization factors x1, x2 and distribution parameter ed are
c     found from conditions: 1) integral d(e)*f(e) = 1 
c     2) integral d(e)*fp(e) = wwp  0<=wwp<1  s02+wwp<=1
c     3) integral d(e)*e*f(e) = erelax
c     Input:
c       omega - enrgy grid (e)
c       nk    - number of points in energy grid
c       efermi- fermi level
c       s02   - overlap with fully relaxed orbitals
c       erelax- relaxation energy 
c       wp    - plasmon frequency
c       xmu   - original absorption coefficient
c     Output
c       xmu  - result of convolution, rewritten at the end. 
c     This subroutine uses the fact, that if convolution is made for
c     e(i), then for e(i+1), the convolution integral with exp(-e/ed)
c     for e<e(i) is simply scaled by exp((e(i)-e(i+1)) / ed). This makes
c     this convolution fast.
c     written by ala. december 1995
c     
      implicit double precision (a-h,o-z)
      dimension  omega(nk), xmu(nk)
c     work space
      dimension  slope(nfinex), dmu(nfinex), xmup(nfinex)

      if (s02 .ge. 0.999) return
      if (wp .le. 0.0) wp = 0.00001
      if (nk .gt. nfinex) then
         call par_stop('check nfinex in subroutine exconv')
      endif
c     change weight for plasmon excitation here
      wwp = 0.00
c     sm1 - weight for shake up (off) processes
      sm1 = 1.0 - s02 - wwp
      edp = wp
      ed = (erelax - wwp * (wp + edp)) / sm1
      i0 = locat (efermi, nk, omega)
      do 10 i = 1, i0
         slope(i) = 0.0
         dmu(i) = 0.0
 10   continue
      do 20 i = i0, nk - 1
 20     slope(i) = ed * (xmu(i+1) - xmu(i)) / (omega(i+1) - omega(i))
      call terp (omega, xmu, nk, 1, efermi, xmuf)

c     start induction
      xmult = exp ((efermi - omega(i0+1)) / ed)
      dmu(i0+1) = xmu(i0+1) - slope(i0) - xmult * (xmuf - slope(i0))
      do 50 i = i0 + 1, nk - 1
         xmult = exp ((omega(i) - omega(i+1)) / ed)
         dmu(i+1) = xmu(i+1) - slope(i) + xmult*(dmu(i)-xmu(i)+slope(i))
 50   continue
      do 55 i = 1, nk
 55   xmup(i) = s02 * xmu(i) + sm1 * dmu(i)

c     do convolution with plasmon pole
      do 60 i = i0, nk - 1
 60     slope(i) = slope(i) / ed * edp
      xmult = exp ((efermi - omega(i0+1)) / edp)
      dmu(i0+1) = xmu(i0+1) - slope(i0) - xmult * (xmuf - slope(i0))
      do 70 i = i0 + 1, nk - 1
         xmult = exp ((omega(i) - omega(i+1)) / edp)
         dmu(i+1) = xmu(i+1) - slope(i) + xmult*(dmu(i)-xmu(i)+slope(i))
 70   continue

      do 90 i = 1, nk
        en = omega(i) - wp
        j0 = locat(en, nk, omega)
        if (en .gt. efermi) then
           xmult = exp ((omega(j0) - en) / edp)
           dif = xmu(j0) - slope(j0)
           xmup(i) = xmup(i) + wwp * (xmult * (dmu(j0) - dif) + dif +
     1                            slope(j0) * (en - omega(j0)) / edp)
        endif
 90   continue

      do 200 i = 1, nk
 200  xmu(i) = xmup(i)

      return
      end

      subroutine lagdat (ia,iex)
c        * non diagonal lagrange parameteres *
c lagrange parameters involving orbital ia if ia is positive
c all lagrange parameters are calculated if ia is negative or zero
c contribution of the exchange terms is omitted if iex=0
c        this program uses akeato(bkeato) fdrirk multrk

      implicit double precision (a-h,o-z)
      common/itescf/testy,rap(2),teste,nz,norb,norbsc
      common/ratom1/xnel(30),en(30),scc(30),scw(30),sce(30),
     1nq(30),kap(30),nmax(30)
      common/scrhf1/eps(435),nre(30),ipl
      dimension ni(2),nj(2)
c#mn
       external akeato, bkeato, fdrirk
 
      i1= max(ia,1)
      idep=1
      if (ia.gt.0) go to 15
 11   idep=i1+1
 15   ni(1)=i1
      nj(2)=i1
      ji1=2* abs(kap(i1))-1
      do 201 i2=idep,norbsc
         if (i2.eq.i1.or.kap(i2).ne.kap(i1)) go to 201
         if (nre(i1).lt.0.and.nre(i2).lt.0) go to 201
c the following line was included to handle the case of 1 electron in
c 2 s-shells.
c Probably need to use schmidt orthogonalization in this case
         if (xnel(i1).eq.xnel(i2)) go to 201
         ni(2)=i2
         nj(1)=i2
         d=0.0d 00
         do 101 l=1,norbsc
            k=0
            jjl=2* abs(kap(l))-1
            kma= min(ji1,jjl)
 41         a=akeato(l,i1,k)/xnel(i1)
            b=a-akeato(l,i2,k)/xnel(i2)
            c=b
            if (a.ne.0.0d 00) c=c/a
            if ( abs(c).lt.1.0d-07) go to 51
            d=d+b*fdrirk(l,l,i1,i2,k)
 51         k=k+2
            if (k.le.kma) go to 41
            if (iex.eq.0) go to 101
            kma=(ji1+jjl)/2
            k= abs(jjl-kma)
            if ((kap(i1)*kap(l)).lt.0) k=k+1
 61         a=bkeato(l,i2,k)/xnel(i2)
            b=a-bkeato(l,i1,k)/xnel(i1)
            c=b
            if (a.ne.0.0d 00) c=c/a
            if ( abs(c).lt.1.0d-07) go to 71
            d=d+b*fdrirk(i1,l,i2,l,k)
 71         k=k+2
            if (k.le.kma) go to 61
 101     continue
         i= min(i1,i2)
         j= max(i1,i2)
         eps(i+((j-1)*(j-2))/2)=d/(xnel(i2)-xnel(i1))
 201  continue
      if (ia.gt.0) go to 999
      i1=i1+1
      if (i1.lt.norbsc) go to 11
 999  return
      end

      subroutine exjlnl (z, l, jl, nl)

c     purpose:  to calculate the spherical bessel functions jl and nl
c               for l = 0 to 6  using exact analytic expression
c
c     arguments:
c       z = argument of jl and nl
c       l = integer order of spherical bessel function
c       jl = jl bessel function (abramowitz conventions)
c       nl = nl bessel function (abramowitz yl conventions)
c            Note that this nl = abramowitz yl.
c
c       analytic expressions from abramowitz 10.1.11 and 10.1.12
c       recurrence relation to get analytic j4,n4  eqns 10.1.19-22 ala

      implicit double precision (a-h, o-z)

      complex*16 z, jl, nl

      complex*16 cosz, sinz

c     Exact formulae unstable for very small z, so use series
c     expansion there.  Limit of .3 chosen for 9 digit agreement.
      if (abs(z) .lt. 0.3)  then
         call bjnser (z, l, jl, nl, 0)
      else
c        use analytic formulae
         cosz = cos(z)
         sinz = sin(z)

         if (l .eq. 0)  then
            jl =  sinz / z
            nl = -cosz / z

         elseif (l .eq. 1)  then
            jl =  sinz/z**2 - cosz/z
            nl = -cosz/z**2 - sinz/z

         elseif (l .eq. 2)  then
            jl = ( 3/z**3 - 1/z)*sinz - 3*cosz/z**2
            nl = (-3/z**3 + 1/z)*cosz - 3*sinz/z**2

         elseif (l .eq. 3)  then
            jl = ( 15/z**4 - 6/z**2)*sinz + (-15/z**3 + 1/z)*cosz
            nl = (-15/z**4 + 6/z**2)*cosz + (-15/z**3 + 1/z)*sinz

         elseif (l .eq. 4)  then
            jl = ( 105/z**5 - 45/z**3 + 1/z )*sinz + 
     1                ( -105/z**4 + 10/z**2 )*cosz
            nl = (-105/z**5 + 45/z**3 - 1/z )*cosz + 
     1                ( -105/z**4 + 10/z**2 )*sinz

         elseif (l .eq. 5)  then
            jl = ( 945/z**6 - 420/z**4 + 15/z**2 )*sinz + 
     1              ( -945/z**5 + 105/z**3 - 1/z )*cosz
            nl = (-945/z**6 + 420/z**4 - 15/z**2 )*cosz + 
     1              ( -945/z**5 + 105/z**3 - 1/z )*sinz

         elseif (l .eq. 6)  then
            jl = ( 10395/z**7 - 4725/z**5 + 210/z**3 - 1/z )*sinz + 
     1              ( -10395/z**6 + 1155/z**4 - 21/z**2 )*cosz
            nl = (-10395/z**7 + 4725/z**5 - 210/z**3 + 1/z )*cosz + 
     1              ( -10395/z**6 + 1155/z**4 - 21/z**2 )*sinz

         else
            stop 'exjlnl, l out of range'
         endif
      endif

      return
      end

      subroutine rexsph ( mphase, ipr2, ispec, vixan, xkstep, xkmax,
     1             gamach, rgrd,
     1             nph, lmaxph, potlbl, spinph, iatph, nat, rat, iphat,
     2             ixc, vr0, vi0, ixc0, lreal, rfms2, lfms2, l2lp,
     3             ipol, ispin, le2, angks, ptz, iPl, iGrid,
     4             izstd, ifxc, ipmbse, itdlda, nonlocal, ibasis)

      use json_module
      implicit double precision (a-h, o-z)
      logical :: found
      type(json_file) :: json   !the JSON structure read from the file:
      double precision toss
      integer,dimension(:),allocatable :: intgs
      character*80,dimension(:),allocatable :: strings
      double precision,dimension(:),allocatable :: dbpcs

      include '../HEADERS/const.h'
      include '../HEADERS/dim.h'

cc    geom.dat
      integer  nat, iatph(0:nphx), iphat(natx), ibounc(natx)
      double precision  rat(3,natx)
cc    global.dat 
c       configuration average
        integer nabs, iphabs
c       global polarization data
        integer  ipol, ispin, le2
        double precision evec(3), xivec(3), spvec(3), elpty,angks,rclabs
        complex*16 ptz(-1:1, -1:1)
cc    mod2.inp
        integer mphase, ipr2, ixc, ixc0, ispec, lreal, lfms2, l2lp, iPl, 
     &       iGrid
        double precision rgrd, gamach, xkstep, xkmax, vixan
        double precision vr0, vi0, spinph(0:nphx)
        real rfms2
        integer lmaxph(0:nphx)
        character*6  potlbl(0:nphx)
        integer izstd, ifxc, ipmbse, itdlda, nonlocal, ibasis

c     Local stuff
c      character*512 slog
c      character*80 head(nheadx)
c      dimension lhead(nheadx)

c     standard formats for string, integers and real numbers
c  10  format(a)
c  20  format (20i4)
c  30  format (6f13.5)


      call json_read_geom(nat, nph, iatph, rat, iphat, ibounc)

      call json_read_global(nabs, iphabs, rclabs, ipol, ispin, le2,
     1                      elpty, angks, evec, xivec, spvec, ptz)


c--json--c     Read  geom.dat file
c--json--      open (file='geom.dat', unit=3, status='old',iostat=ios)
c--json--c       read header from geom.dat
c--json--        nhead = nheadx
c--json--        call rdhead (3, nhead, head, lhead)
c--json--        nat = 0
c--json--        nph = 0
c--json--        do 40 iph = 0, nphx
c--json--  40    iatph(iph) = 0
c--json--  50    continue
c--json--           nat = nat+1
c--json--           if (nat .gt. natx)  then
c--json--              write(slog,55) ' nat, natx ', nat, natx
c--json--              call wlog(slog)
c--json--  55          format(a, 2i10)
c--json--              stop 'Bad input'
c--json--           endif
c--json--           read(3,*,end=60)  idum, (rat(j,nat),j=1,3), iphat(nat), i1b
c--json--           if (iphat(nat).gt.nph) nph = iphat(nat)
c--json--           if ( iatph(iphat(nat)).eq.0) iatph(iphat(nat)) = nat
c--json--        goto 50
c--json--  60    continue
c--json--        nat = nat-1
c--json--      close(3)


cc    global.inp
c--json--      open (file='global.dat', unit=3, status='unknown',iostat=ios)
c--json--c       configuration average data
c--json--        read  (3, 10) slog
c--json--        read  (3, 65) nabs, iphabs, rclabs
c--json--  65    format ( 2i8, f13.5)
c--json--c       global polarization data
c--json--        read  (3,10)   slog
c--json--        read  (3, 70)  ipol, ispin, le2, elpty, angks
c--json--  70    format ( 3i5, 2f12.4)
c--json--        read  (3, 10) slog
c--json--        do 80 i = 1,3
c--json--          read  (3,30) evec(i), xivec(i), spvec(i)
c--json--  80    continue
c--json--        read  (3, 10) slog
c--json--        do 90 i = -1, 1
c--json--          read (3,30) a1, b1, a2, b2, a3, b3
c--json--          ptz(-1,i)= dcmplx(a1,b1)
c--json--          ptz(0,i) = dcmplx(a2,b2)
c--json--          ptz(1,i) = dcmplx(a3,b3)
c--json--  90    continue
c--json--      close(3)


c--json--c     read mod2.inp
c--json--c     Josh - added flag iPl for PLASMON card
c--json--c     Josh - added flag iGrid for user controlled grids.
c--json--      open (file='mod2.inp', unit=3, status='old',iostat=ios)
c--json--        read (3,10)  slog
c--json--        read (3,20)  mphase,ipr2,ixc,ixc0,ispec,lreal,lfms2,nph,l2lp,
c--json--     &       iPl,iGrid
c--json--        read (3,10)  slog
c--json--        read (3,30)  vr0, vi0
c--json--        read (3,10)  slog
c--json--        read (3,20)  (lmaxph(iph),iph=0,nph)
c--json--        read (3,10)  slog
c--json--        read (3,170)  (potlbl(iph),iph=0,nph)
c--json--  170   format (13a6)
c--json--        read (3,10)  slog
c--json--        read (3,30)  rgrd, rfms2, gamach, xkstep, xkmax, vixan
c--json--        read (3,30)  (spinph(iph),iph=0,nph)
c--json--        read (3,20)  izstd, ifxc, ipmbse, itdlda, nonlocal, ibasis
c--json--      close(3)

      call json%load_file('xsph.json')
      if (json_failed()) then   !if there was an error reading the file
         print *, "failed to read xsph.json"
         stop
      else
         call json%get('mphase',   mphase, found)
                   if (.not. found) call bailout('mphase', 'xsph.json')
         call json%get('ipr2',   ipr2, found)
                   if (.not. found) call bailout('ipr2', 'xsph.json')
         call json%get('ixc',   ixc, found)
                   if (.not. found) call bailout('ixc', 'xsph.json')
         call json%get('ixc0',   ixc0, found)
                   if (.not. found) call bailout('ixc0', 'xsph.json')
         call json%get('ispec',   ispec, found)
                   if (.not. found) call bailout('ispec', 'xsph.json')
         call json%get('lreal',   lreal, found)
                   if (.not. found) call bailout('lreal', 'xsph.json')
         call json%get('lfms2',   lfms2, found)
                   if (.not. found) call bailout('lfms2', 'xsph.json')
         call json%get('nph',   nph, found)
                   if (.not. found) call bailout('nph', 'xsph.json')
         call json%get('l2lp',   l2lp, found)
                   if (.not. found) call bailout('l2lp', 'xsph.json')
         call json%get('iPlsmn', iPl, found)
                   if (.not. found) call bailout('iPlsmn', 'xsph.json')
         call json%get('iGrid',   iGrid, found)
                   if (.not. found) call bailout('iGrid', 'xsph.json')

         call json%get('vro',   vr0, found)
                   if (.not. found) call bailout('vr0', 'xsph.json')
         call json%get('vio',   vi0, found)
                   if (.not. found) call bailout('vi0', 'xsph.json')

         call json%get('rgrd',   rgrd, found)
                   if (.not. found) call bailout('rgrd', 'xsph.json')
         call json%get('rfms2',  toss, found)
                   if (.not. found) call bailout('rfms2', 'xsph.json')
         rfms2 = real(toss)
         call json%get('gamach',   gamach, found)
                   if (.not. found) call bailout('gamach', 'xsph.json')
         call json%get('xkstep',   xkstep, found)
                   if (.not. found) call bailout('xkstep', 'xsph.json')
         call json%get('xkmax',   xkmax, found)
                   if (.not. found) call bailout('xkmax', 'xsph.json')
         call json%get('vixan',   vixan, found)
                   if (.not. found) call bailout('vixan', 'xsph.json')

         call json%get('izstd',   izstd, found)
                   if (.not. found) call bailout('izstd')
         call json%get('ifxc',   ifxc, found)
                   if (.not. found) call bailout('ifxc')
         call json%get('ipmbse',   ipmbse, found)
                   if (.not. found) call bailout('ipmbse')
         call json%get('itdlda',   itdlda, found)
                   if (.not. found) call bailout('itdlda')
         call json%get('nonlocal',   nonlocal, found)
                   if (.not. found) call bailout('nonlocal')
         call json%get('ibasis',   ibasis, found)
                   if (.not. found) call bailout('ibasis')

         call json%get('potlbl', strings, found)
                   if (.not. found) call bailout('potlbl', 'xsph.json')
         do 1000 itit = 1, nphx
c            potlbl(itit-1) = strings(itit)
            potlbl(itit-1) = strings(itit)(1:6)
 1000    continue
         call json%get('lmaxph', intgs, found)
                   if (.not. found) call bailout('lmaxph', 'xsph.json')
         do 1010 iph = 0, nphx
            lmaxph(iph) = intgs(iph+1)            
 1010    continue
         call json%get('spinph', dbpcs, found)
                   if (.not. found) call bailout('spinph', 'xsph.json')
         do 1020 iph = 0, nphx
            spinph(iph) = dbpcs(iph+1)            
 1020    continue

         call json%destroy()
      end if


c     transform to code units (bohrs and hartrees - atomic unuts)
      rfms2 = rfms2 / real(bohr)
      vr0   = vr0 / hart
      vi0   = vi0 / hart
      gamach = gamach / hart
      vixan = vixan / hart
      xkstep = xkstep * bohr
      xkmax  = xkmax  * bohr
      do 210 i = 1,3
      do 210 iat = 1, nat
        rat(i,iat) = rat(i,iat) / bohr
 210  continue

      return
      end

      subroutine fmsie(verbse, iph0, nph, lipotx, ie, em, eref, ph,
     1                 rfms, lfms, nat, iphat, rath, gtr)

c     full multiple scattering code for single energy point
c     written by a.ankudinov 06.1997 using earlier written subroutines
c     coded by b.ravel
c     modified by a.ankudinov 2001 for new matrix inversion algorithms
c     Feb. 2002, a.ankudinov: fixed logic for MPI calculations
c       lfms=0  - extended system calculataions (e.g. crystal)
c       lfms=1  - small system calculations (e.g. molecule)
c       lfms=2  - same as 1 for MPI run (forces call yprep)

      implicit double precision (a-h, o-z)
      include '../HEADERS/dim.h'

c     input
      dimension iphat(natx), rath(3,natx)
      real rat(3,natx), rfms, rdirec, toler1, toler2
      real rpart,aipart
      integer nph
c      dimension iz(0:nphx)
      complex*16 ph(lx+1, 0:nphx)

c     work space
      integer iph0
      complex*16 em, eref
      character*512 slog
      logical lcalc, verbse
      dimension lcalc(0:lx)
c     fms staff
      integer lipotx(0:nphx)
      complex gg(nspx*(lx+1)**2, nspx*(lx+1)**2, 0:nphx)
      complex gtr(0:lx, 0:nphx)
      complex xphase(nspx, -lx:lx, 0:nphx), ck(nspx)
      complex*16 dck
      complex conis
      parameter (conis = (0.0, 1.0))
      real  temper, thetax, sig2
      save

      if (rfms .le. 0.0) goto 900

c     set default (LU) inv method
      minv = 0
      rdirec = 2*rfms
      toler1 = 0.e0
      toler2 = 0.e0

      do 30 iat=1,nat
      do 30 j=1,3
   30 rat(j,iat) = real (rath(j,iat))

c     transform to single precision
      temper =0.0e0
      thetax =0.0e0
      sig2  = 0.0e0

c      it will be nice to call yprep once for all energy points,
c      fix later, and now call it every time
      if (ie.eq.1 .or. lfms.eq.0 .or. lfms.eq.2)
     1  call yprep(iph0, nat, inclus, iphat, rfms, rat)

      if (inclus.gt.1) then

cc     call fms for a cluster around central atom
       if (ie.eq.1 .and. verbse) then
          write (slog,35) inclus, iph0
  35      format ('        Doing FMS for a cluster of ',i3,
     1    ' atoms around iph = ',i2)
          call wlog (slog)
       endif

       dck=sqrt(2*(em-eref))
       rpart  = real(dble(dck))
       aipart = real(dimag(dck))
       ck(1) = cmplx(rpart, aipart)
       do 1020 ipp = 0,nph
         do 1010 ill = -lipotx(ipp), lipotx(ipp)
           rpart  = real(dble (ph( 1+abs(ill), ipp)))
           aipart = real(dimag(ph( 1+abs(ill), ipp)))
           xphase(1, ill, ipp) = cmplx(rpart, aipart)
 1010    continue
 1020  continue
       iverb=0
       if (ie.eq.1) iverb = 1
       if (.not. verbse) iverb = 0
       nsp = 1
       ispin = 0
       do 1011 ill = 0,lx
 1011  lcalc(ill) = .true.
       call fms(lfms, nsp, ispin, inclus, nph, ck, lipotx, xphase, ie,
     1  iverb, minv, rdirec, toler1, toler2, lcalc, gg)

c      make ck= i, since coni is c*16
       do 1030 ip=0,nph
         if (lfms.ne.0 .or. ip.eq.iph0) then
           do 1040 il=0,lipotx(ip)
             ix = il**2
             do 1050 im=1,2*il+1
               gtr(il, ip) = gtr(il, ip) + gg(ix+im,ix+im,ip)
 1050        continue
             gtr(il,ip)= gtr(il,ip)*
     1            exp(2*conis*xphase(1,il,ip))/(2*il+1)
 1040      continue
         endif
 1030  continue
      endif

 900  continue
      return
      end

      subroutine imhl (rs, xk, eim, icusp)
      implicit double precision (a-h,o-z)

c     what is xk?  k**2 - mu + kf**2?

c written by j. mustre (march 1988)
c code is based on analytical expression derived by john rehr.
c it leaves the real part, calculated in rhl unchanged.
c
c modified by j. rehr  (oct 1991) - adds quinn approximation for
c losses due to electron-hole pairs below the plasmon turn on
c see new subroutine quinn.f, which incorporates r. albers coding of
c j.j. quinn's approximations for details.

      include 'const.h'
c     alph is Hedin-Lundquist parameter
      parameter (alph = 4.0 / 3.0)
      external ffq

      integer icount
      save icount
      data icount /0/

      icusp=0
      xf = fa / rs
      ef = xf**2 / 2

c     xk0 is xk normalized by k fermi.
      xk0 = xk/xf
c     set to fermi level if below fermi level
      if (xk0 .lt. 1.00001) then
         xk0 = 1.00001
      endif

c     wp is given in units of the fermi energy in the formula below.
      wp = sqrt (3 / rs**3) / ef
      xs = wp**2 - (xk0**2 - 1)**2

      eim = 0
      if (xs .lt. 0.)  then
         q2 = sqrt ( (sqrt(alph**2-4*xs) - alph) / 2 )
         qu = min (q2, (1+xk0))
         d1 = qu - (xk0 - 1)
         if (d1 .gt. 0)  then
            eim = ffq (qu,ef,xk,wp,alph) - ffq (xk0-1,ef,xk,wp,alph)
         endif
      endif
      call cubic (xk0, wp, alph, rad, qplus, qminus)

      if (rad .le. 0) then
         d2 = qplus - (xk0 + 1)
         if (d2 .gt. 0)  then
            eim = eim + ffq (qplus,ef,xk,wp,alph) - 
     1                  ffq (xk0+1,ef,xk,wp,alph)
         endif
         d3 = (xk0-1) - qminus
         if (d3 .gt. 0)  then
            eim = eim + ffq (xk0-1,ef,xk,wp,alph) - 
     1                  ffq (qminus,ef,xk,wp,alph)
c           beginning of the imaginary part and position of the cusp x0
            icusp = 1
         endif
      endif

      call quinn (xk0, rs, wp, ef, ei)
      if (eim .ge. ei)  eim = ei

      icount = icount+1
      return
      end

!=======================================================================
!     OPCONS
!=======================================================================
MODULE opcons_inp
  USE dimsmod
  LOGICAL run_opcons, print_eps
  REAL(8) NumDens(0:nphx)
  character(*),parameter,private :: filename='opcons.inp'

CONTAINS
  SUBROUTINE opcons_init
    run_opcons = .FALSE.
    print_eps  = .FALSE.
    NumDens(:) = -1.d0
  END SUBROUTINE opcons_init

  SUBROUTINE opcons_write
    ! INTEGER iph

    OPEN(FILE=filename,UNIT=8,STATUS='REPLACE')

    WRITE(8,'(A)') 'run_opcons'
    WRITE(8,*) run_opcons
    WRITE(8,'(A)') 'print_eps'
    WRITE(8,*) print_eps
    WRITE(8,'(A)') 'NumDens(0:nphx)'
    WRITE(8,*) NumDens(0:nphx)

    CLOSE(8)
  END SUBROUTINE opcons_write

  SUBROUTINE opcons_read
    ! INTEGER iph

    OPEN(FILE=filename,UNIT=8,STATUS='OLD')

    READ(8,*)
    READ(8,*) run_opcons
    READ(8,*)
    READ(8,*) print_eps
    READ(8,*)
    READ(8,*) NumDens(0:nphx)
  END SUBROUTINE opcons_read

END MODULE opcons_inp

      subroutine ggrm( nsp, i0, ipi, ipf, lipotx, g0, tmatrx, g0t, gg,
     1                 toler1, toler2, lcalc, msord)

      implicit real (a-h,o-z)
      implicit integer (i-n)
c  output
c    gg:  (nsp*lx**2, nsp*lx**2, 0:nphasx) submatrix spanning the entire
c          angular momentum basis for each unique potential

      include '../HEADERS/dim.h'
      include 'xparam.h'
      integer  i0 (0:nphx),  lipotx(0:nphx)

      parameter (one = 1, zero = 0)
      complex coni
      parameter (coni = (0,1))

c**** array of state kets at current energy
      common /stkets/ lrstat(4, istatx), istate

      complex   tmatrx(nspx, istatx)
c     big work matrices
      complex   g0( istatx, istatx), g0t( istatx, istatx)
      logical lcalc
      dimension lcalc(0:lx)

      complex xvec( istatx), xket( istatx), xbra( istatx)
      complex xketp(istatx), xbrap(istatx)
      complex zvec(istatx), rvec(istatx), svec(istatx)
      complex tket(istatx), tbra(istatx)
c      double precision  dum1, dum2
      complex alphac, betac, aa, bb, yy, aac, bbc, gamma
c      real alpha, beta
c     return matrix containing info about each unique potential
      complex   gg(nspx*(lx+1)**2, nspx*(lx+1)**2, 0:nphasx)

c      notice that in gglu we invert (1-Gt), but here (1-tG).
c     multiply T and G0 matrices together, construct g0t = 1 - T*G0
c     notice that the signs below for g0t ARE correct since 1 is the
c     unit matrix
c     since t is tri-diagonal, this product can be computed in n^2 time
c     also fill up some work matrices for use in eigenvalue and
c     determinant calculations and elsewhere
c     cycle over dimensions of matrix g0t
      do 10 icol = 1,istatx
      do 10 irow = 1,istatx
 10   g0t(irow,icol) = 0

      do 30 icol = 1,istate
        do 20 irow = 1,istate
c         T diagonal contribution T(irow, irow)
          if ( abs( g0(irow, icol)) .gt. toler2 )
     1    g0t(irow,icol)=g0t(irow,icol) - tmatrx(1,irow) * g0(irow,icol) 

c         T off-diagonal contribution T(ist2, irow) in tmatr(2,irow)
c         T off-diagonal contribution T(irow, ist2) in tmatr(2,ist2)
          l1   = lrstat(2,irow)
          m1   = lrstat(3,irow)
          isp1 = lrstat(4,irow)
          m2 = m1+isp1
          if (nsp.eq.2 .and. m2.gt.-l1+1 .and. m2.lt.l1+2) then
c            spin-flip contribution
             ist2 = irow + (-1)**isp1
             if ( abs( g0(ist2, icol)) .gt. toler2)
     1       g0t(irow, icol) = g0t(irow, icol)
     2                   - tmatrx(nsp, ist2) * g0(ist2, icol) 
          endif
 20     continue

        g0t(icol, icol) = g0t(icol, icol) + one
 30   continue

      do 920 ip=ipi, ipf
        ipart = nsp*(lipotx(ip)+1)**2
        do 910 is1 = 1, ipart
          is2 = is1+i0(ip)
          l1   = lrstat(2,is2)
          if (.not.lcalc(l1)) goto 910

c         start first tier with xvec=0
          istart = -1
          msord=0
          do 40 is = 1, istate
          rvec(is) = 0
  40      xvec(is) = 0

c         RESTART here if necessary
  50      continue
          istart = istart+1

          if (istart.gt.0) call matvec( istatx,istate,g0t,xvec,rvec,1)
c         rvec = g0t*xvec - bvec, in our case bvec(is) = delta_{is,is2}
          rvec(is2) = rvec(is2) - 1
          do 90 is = 1,istate
 90       xket(is) = - rvec(is)
          call cdot( istatx, istate, xket, xket, bb)
          if (abs(bb).eq.0) goto 700

          xfnorm = 1.e0 / real(dble(bb))
          do 91 is = 1, istate
 91       xbra(is) = xket(is) * xfnorm
c         |t> = A |n> ; |n> - xket, |n-1> - xketp
          call matvec ( istatx, istate, g0t, xket, tket, 1)
          msord = msord + 1
          call cdot( istatx, istate, xbra, tket, aa)
          aac = real(aa) - coni*aimag(aa)
          bb = 0
          bbc= 0
          betac = aa
          yy = 1
c         initialize vectors
          do 110 is = 1,istate
            xketp(is) = 0
            xbrap(is) = 0
            zvec(is) = xket(is)
            xvec(is) = xvec(is) + zvec(is)/betac
 110      continue

          do 120 is = 1, istate
 120      svec(is) = tket(is)
          do 130 is = 1, istate
 130      rvec(is) = rvec(is) + svec(is) / betac

c         it seems ran out of precision for nit>150
          nitx = 100
          do 300 nit = 1, nitx
c           use recursion method to calculate a_n+1, b_n, |n+1>, <n+1|
            do 140 is = 1, istate
 140        tket(is) = tket(is) - aa*xket(is) - bb*xketp(is)
            call matvec ( istatx, istate, g0t, xbra, tbra, 2)
            do 150 is = 1, istate
 150        tbra(is) = tbra(is) - aac*xbra(is) - bbc*xbrap(is)
            call cdot( istatx, istate, tbra, tket, bb)
            if (abs(bb).eq.0) goto 700

            bb = sqrt (bb)
            bbc = real(bb) - coni*aimag(bb)
            do 160 is = 1, istate
              xketp(is) = xket(is)
              xbrap(is) = xbra(is)
 160        continue
            do 170 is = 1, istate
              xket(is) = tket(is) / bb
              xbra(is) = tbra(is) / bbc
 170        continue
            call matvec ( istatx, istate, g0t, xket, tket, 1)
            msord = msord + 1
            call cdot( istatx, istate, xbra, tket, aa)
            aac = real(aa) - coni*aimag(aa)
            
c           update iterative solution xvec, 
c           and residual rvec = g0t*xvec - |1>
            alphac = bb / betac
            do 210 is = 1, istate
 210        zvec(is) = xket(is) - alphac * zvec(is)
            do 220 is = 1, istate
 220        svec(is) = tket(is) - alphac * svec(is)

            betac = aa - alphac*bb
            yy = - alphac * yy
            gamma = yy / betac
            do 230 is = 1, istate
 230        xvec(is) = xvec(is) + gamma * zvec(is)
            do 240 is = 1, istate
 240        rvec(is) = rvec(is) + gamma * svec(is)

cc          Check convergence criteria: | rvec | < tol
c           call vecvec( istatx, istate, rvec, rvec, dum2)
c           if (dum2.le.tol) goto 700
cc          Check convergence criteria: | rvec | < tol
            ipass = 1
            do 250 is = 1, istate
              if ( abs(real(rvec(is))).gt.toler1) goto 260
              if ( abs(aimag(rvec(is))).gt.toler1) goto 260
 250        continue
            ipass = 0
 260        continue
            if (ipass.eq.0) goto 700

 300      continue
c         restart since ran out of iterations
          goto 50

c         exit if tolerance has been achieved
 700      continue
c         end of RM iterations

c         at this point xvec = (1-tG)**-1 * bvec  with chosen tolerance
c         pack FMS matrix into an nsp*(lx+1)^2 x nsp*(lx+1)^2 matrix 
c         for each ipot
          do 800 is2=1,ipart
            gg( is2, is1, ip) = zero
            do 790 is = 1,istate
              gg( is2, is1, ip) = gg( is2, is1, ip) +
     1        g0( is2+i0(ip), is) * xvec(is)
 790        continue
 800      continue

 910    continue
 920  continue

      return
      end

      subroutine cdot ( istatx, istate, abra, aket, cc)
c     dot product of two vectors
c     notice that we keep bra  vector as it's complex conjugate
c     thus need to conjugate abra here
      implicit real (a-h,o-z)
      implicit integer (i-n)
      complex coni
      parameter (coni = (0,1))
      complex abra, aket, cc, aa
      dimension abra(istatx), aket(istatx)

      cc = 0
      do 10 is = 1,istate
        aa = real(abra(is)) - coni*aimag(abra(is))
        cc = cc + aa * aket(is)
 10   continue
      return
      end

      subroutine vecvec ( istatx, istate, avec, bvec, cc)
c     dot product of two vectors
      implicit real (a-h,o-z)
      implicit integer (i-n)
      complex avec, bvec
      double precision cc, aa, bb
      dimension avec(istatx), bvec(istatx)

      cc = 0
      do 10 is = 1,istate
        aa = dble(real(avec(is))) * dble(real(bvec(is)))
        bb = dble(aimag(avec(is))) * dble(aimag(bvec(is)))
        cc = cc + aa + bb
 10   continue
      return
      end

      subroutine matvec (istatx, istate, amat, bvec, cvec, itrans)
c     itrans = 1  cvec = amat * bvec
c     itrans = 2  cvec = amat^+ * bvec
c     itrans = 3  cvec = amat^T * bvec
      implicit real (a-h,o-z)
      implicit integer (i-n)
      complex coni, aa
      parameter (coni = (0,1))
      complex amat, bvec, cvec
      dimension amat(istatx, istatx), bvec(istatx), cvec(istatx)

c     initialize cvec
      do 10 is = 1,istatx
 10   cvec(is) = 0

c     cycle over dimensions of amat
      do 20 icol = 1,istate
      do 20 irow = 1,istate
        if (itrans.eq.1) then
          cvec(irow) = cvec(irow) + amat(irow, icol) * bvec(icol)
        elseif(itrans.eq.2) then
          aa = real(amat(irow, icol)) - coni*aimag(amat(irow, icol))
          cvec(icol) = cvec(icol) + aa * bvec(irow)
        else
          cvec(icol) = cvec(icol) + amat(irow, icol) * bvec(irow)
        endif
 20   continue

      return
      end

      subroutine dfovrg (ncycle, ikap, rmt, jlast, jri, p2, dx,
     1                  ri, vxc, vxcval, dgcn, dpcn, adgc, adpc,
     2                  xnval, pu, qu, ps, qs,
     2                  iz, ihole, xion, iunf, irr, ic3)
c     Dirac equation solver for complex energy
c     coded by a.ankudinov 1996
c     modified by a.ankudinov 1997 to get irregular solution 

c     fully relativistic version of subroutine fovrg.f
c     input:
c        ncycle  times to calculate photoelectron wave function
c                with nonlocal exchange
c        ikap    quantum number kappa for photoelectron
c        rmt     muffin-tin radius
c        jri     first interstitial grid point (imt + 1)
c        jlast   last point for integration of Dirac eq.
c        p2      current complex energy
c        dx      dx in loucks' grid (usually .05)
c        ri(nr)  loucks' position grid, r = exp ((i-1)*dx - 8.8)
c        vxc(nr) coulomb+xc potential for total density
c        vxcval  coulomb+xc potential for valence density
c        both vxc and vxcval include coulomb and nuclear potential
c        dgcn(dpcn) large(small) dirac components for 'iph' atom
c        adgc(adpc) their development coefficients
c     work space:
c        must be dimensioned in calling program.  coded like this
c        to make using different r-grids with different nrmax easy.
c
c     output:
c        pu, qu  upper and lower components at muffin tin
c        ps and qs are  upper and lower components for photoelectron

      implicit double precision (a-h, o-z)
      include '../HEADERS/dim.h'
      include '../HEADERS/const.h'

      complex*16 vxc(nrptx), vxcval(nrptx), p2
      dimension ri(nrptx)
      complex*16 pu, qu, vu, vm(nrptx)
      complex*16 ps(nrptx), qs(nrptx), aps(10),aqs(10)
c      complex*16 ph0, amp

c     all atoms' dirac components and their development coefficients
      dimension dgcn(nrptx,30), dpcn(nrptx,30)
      dimension adgc(10,30), adpc(10,30)
 
c     iph atom's dirac components and their development coefficients
      common/dff/cg(nrptx,30), cp(nrptx,30), bg(10,30), bp(10,30),
     1             fl(30), fix(30), ibgp
c     fl power of the first term of development limits.
c     ibgp first dimension of the arrays bg and bp (=10)

      complex*16 gg,gp,ag,ap,dv,av,bid
      common/comdic/cl,dz,gg(nrptx),ag(10),gp(nrptx),ap(10),
     1              dv(nrptx),av(10),bid(2*nrptx+20)
c      gg,gp are the input and output for solout
      common/itescf/testy,rap(2),teste,nz,norb,norbsc
      common/mulabc/afgkc
      dimension afgkc(-ltot-1:ltot,30,0:3)
      common/messag/dlabpr,numerr
      character*8 dlabpr
c      xnel here - number of core electrons only
      common/ratom1/xnel(30),en(30),scc(30),scw(30),sce(30),
     1nq(30),kap(30),nmax(30)
      common/scrhf1/eps(435),nre(30),ipl
      common/snoyac/dvn(nrptx),anoy(10),nuc
      common/tabtec/hx,dr(nrptx),test1,test2,ndor,np,nes,method,idim
      dimension xnval(30)

c     initialize the data and test parameters
      ndor = 3
      cl = alpinv
      if (irr.gt.0) then
c        for irregular solution
         ndor=2
         aps(1) =  pu
         aqs(1) =  qu
         do 5 i=1, jri
           gg(i) = ps(i)
           gp(i) = qs(i)
 5       continue
      endif
      do 9 i = jri+1,nrptx
         vxc(i)=vxc(jri+1)
 9       vxcval(i)=vxc(jri+1)
      ibgp=10
      numerr = 0
      nz = iz
      hx = dx
      idim= 1 + nint(250*0.05/dx)
      if (idim .gt. nrptx) idim = nrptx
      if (mod(idim,2) .eq. 0) idim=idim-1
      
c     numerical integration of Dirac eq. works if you have 6 grid points
c     for one period of oscillations, switch to analytical expression
c     for a steplike potential  at large distances
      aa = 0.5
c     if (irr.gt.0) aa = 0.05
      rwkb = aa / dx / sqrt(abs(2*p2+(p2/cl)**2))
      x0 = 8.8
      iwkb= int((log(rwkb) + x0) / dx)  +  2
      if (iwkb.gt.idim) iwkb = idim
      if (iwkb.lt. 10) iwkb = 10
      
c     copy information into common's of atomic code
      do 13 j=1,30
      do 13 i=1,10
         bg(i,j)=adgc(i,j) 
 13      bp(i,j)=adpc(i,j) 
      do 15 j=1,30
      do 15 i=1,idim
         cg(i,j)=dgcn(i,j) 
 15      cp(i,j)=dpcn(i,j) 

      call inmuac (ihole, xion, iunf, ikap)
      nmax(norb)=jlast
      if (iwkb.ge. jlast-1) iwkb = idim
c     note that here norb correspond to photoelectron

c     calculate initial photoelectron orbital using lda
      call diff (vxc,ri,ikap,cl,hx,jri,vm)
      do 18 i = jri, nrptx
  18  vm(i)=0.0d0
      call wfirdc (p2,kap,nmax,vxc,ps,qs,aps,aqs,irr,ic3,vm,
     1             jri, iwkb)
c     1             rmt,jri, iwkb)

      if (numerr .ne. 0) call par_stop('error in wfirdc')
      if (ncycle .eq. 0) go to 999

c     to get orthogonalized photo e w.f., use alternative exit below
c     in general it should not be orthogonolized. Use for testing only 
c     ala

c     further need only core electrons for exchange term
      do 40 i=1, norb-1
  40  xnel(i) = xnel(i) - xnval(i)
c     take vxcval at the origin as vxcval=vcoul +const1 + i*const2
      av(2)=av(2)+(vxcval(1)-vxc(1))/cl
      do 50 i=1,iwkb
  50  dv(i)=vxcval(i)/cl
c     keep dv=vxc/cl above iwkb

      nter=0
 
c     angular coefficients 
      call muatcc(xnval)

c     no orthogonalization needed. Looking for g.f., not w.f.
c     if (ipl.ne.0) call ortdac (ikap,ps,qs,aps,aqs)
c     ortdac orthogonalizes photoelectron orbital to core orbitals
c     have to use exchange 5 card to exit here; also want vxc=vxcval
c     if (ncycle .eq. 0) go to 999

c     iteration over the number of cycles
 101  continue
         nter=nter+1
c        calculate exchange potential
         jriwkb = min (jri, iwkb)
         call potex( ps, qs, aps, aqs, jriwkb)
c         call potex( ps, qs, aps, aqs, jriwkb, p2)

c        resolution of the dirac equation
         if (irr.lt.0) then
c            call solout (p2, fl(norb), aps(1), aqs(1), ikap, rmt,
c     1        jri, nmax(norb), ic3, vm, iwkb)
            call solout (p2, fl(norb), aps(1), aqs(1), ikap,
     1        jri, nmax(norb), ic3, vm, iwkb)
         else
c            call solin (p2, fl(norb), pu, qu, ikap, rmt,
c     1        jri, nmax(norb), ic3, vm, iwkb)
            call solin (p2, fl(norb), ikap,
     1        jri, nmax(norb), ic3, vm, iwkb)
         endif

c     no orthogonalization needed. Looking for g.f., not w.f.
c        if (ipl.ne.0) call ortdac (ikap,gg,gp,ag,ap)

c        acceleration of the convergence 
         scc(norb)=1.0d0
         do 151 i=1,idim
            ps(i)=gg(i)
 151        qs(i)=gp(i)
         do 155 i=1,ndor
            aps(i) =ag(i) 
 155        aqs(i) =ap(i) 

      if (nter.le.ncycle) go to 101

 999  if (numerr .eq. 0) then
        if (irr.lt.0 ) then
cc        need pu, qu for regular solution
cc        want to have vxc(jri)-smooth and vxc(jri+1)=v_mt
cc        assume no exchange beyond jri 
           vu=vxc(jri+1)
           call flatv 
     1     (ri(jri), rmt, ps(jri), qs(jri), p2, vu, ikap, pu, qu)
           jlast = nmax(norb)
c          jlast might change on very rare occasion
        endif

      else
        call par_stop('error in dfovrg.f')
      endif

      return
      end

      subroutine flatv (r1, r2, p1, q1, en, vav, ikap, p2, q2)
      implicit double precision (a-h, o-z)
      include '../HEADERS/const.h'
      include '../HEADERS/dim.h'
c     solution of Dirac equation for flat potential for ikap is known
c     exactly (see e.g. in Loucks T.L. eq. 4-19)
c     given p1 and q1 at point r1 this subrotuine finds p2, q2 at r2
c     for given energy(en) and average potential (vav)
c     en and vav in hartrees
      external besjn, atancc

      complex*16 p1, q1, en, vav, p2, q2
      complex*16 ck, xkr, jl(ltot+2), nl(ltot+2), a,b, factor 

c     initialize staff
      ck = sqrt(2*(en-vav) + (alphfs*(en-vav))**2)
      xkr = ck*r1
      if (ikap.lt.0) then
        isign = -1
        lp = -ikap - 1
        lq = lp + 1
      else
        isign = 1
        lp = ikap
        lq = lp - 1
      endif
      a = ck * alphfs
      factor = isign*a/(1+sqrt(1+a**2))

c     find a and b that p1 = r1*(a*jl+b*nl), q1=factor*r1*(a*jl'+b*nl')
      call besjn (xkr, jl, nl)
      a = isign*ck*xkr* (p1*nl(lq+1) - q1*nl(lp+1)/factor)
      b = isign*ck*xkr* (q1*jl(lp+1)/factor - p1*jl(lq+1))

c     get values at r2
      xkr = ck * r2
      call besjn (xkr, jl, nl)
      p2 =  r2 * (jl(lp+1)*a + nl(lp+1)*b)
      q2 =  r2* factor * (jl(lq+1)*a + nl(lq+1)*b)

      return
      end

      double precision function xstar(eps1,eps2, vec1,vec2, ndeg, elpty,
     &       ilinit)
      implicit double precision (a-h, o-z)
c     calculating nstar=deg*cos(eps r1)*cos(eps rN)
c     written by alexei ankudinov 08.13.96
c     calculate the plane wave approximation for central atom
c     vec1 - direction to the first atom in path
c     vec2 - direction to the last atom in path
c     ndeg - may be not equal to 'deg' in diff. paths
c             subroutines

      include '../HEADERS/const.h'
      include '../HEADERS/dim.h'
c      include 'pdata.h'
      integer ilinit 


      dimension eps1(3), eps2(3), vec1(3), vec2(3)

      lfin = ilinit
      x = xxcos(vec1, vec2)
      iav = 1
      y = xxcos(eps1,vec1)
      z = xxcos(eps1,vec2)
      xtemp = ystar(lfin, x, y, z, iav)
      if (elpty .ne. 0.0) then
        y = xxcos(eps2,vec1)
        z = xxcos(eps2,vec2)
        xtemp = xtemp + elpty**2 * ystar(lfin, x, y, z, iav)
      endif
      xstar = ndeg * xtemp /(1+elpty**2)

      return
      end

      double precision function xxcos (veca, vecb)
      implicit double precision (a-h, o-z)
      dimension veca(3), vecb(3)

      x1 = 0
      do 23 j = 1,3
         x1 = x1 + veca(j) * vecb(j)
   23 continue
      xnorma = 0
      xnormb = 0
      do 24 j = 1,3
         xnorma = xnorma + veca(j)**2
         xnormb = xnormb + vecb(j)**2
   24 continue
      xxcos = x1/sqrt(xnorma*xnormb)
      return
      end

      double precision function ystar (lfin, x , y, z, iav)
      implicit double precision (a-h, o-z)
c     
      dimension pln (0:4,4)
      data pln /0.0  , 1.0, 0.0 , 0.0, 0.0,
     2         -0.5  , 0.0, 1.5 , 0.0, 0.0,
     3          0.0  ,-1.5, 0.0 , 2.5, 0.0,
     4          0.375, 0.0,-3.75, 0.0, 4.375/

      pln0  = pln(0,lfin)
      do 40 i = 1, lfin
         pln0  = pln0  + pln(i, lfin) * x**i
  40  continue
      if (iav.eq.0) then
         ystar = pln0/(2*lfin+1)
      else
         pln1  = pln(1,lfin)
         do 50 i = 2, lfin
            pln1  = pln1  + pln(i, lfin)*i*x**(i-1)
  50     continue
         pln2  = 2* pln(2,lfin)
         do 60 i = 3, lfin
            pln2  = pln2  + pln(i, lfin)*i*(i-1)*x**(i-2)
  60     continue
         ytemp = - lfin*pln0 + pln1*(x+y*z) - pln2*(y**2+z**2-2*x*y*z)
         ystar = ytemp * 3/lfin/(4*lfin**2-1)
      endif
      return
      end

      subroutine gglu( nsp, i0, ipi, ipf, lipotx, g0, tmatrx, g0t, gg)

      implicit real (a-h,o-z)
      implicit integer (i-n)
c  output
c    gg:  (nsp*lx**2, nsp*lx**2, 0:nphasx) submatrix spanning the entire
c          angular momentum basis for each unique potential

      include '../HEADERS/dim.h'
      include 'xparam.h'
      integer  i0 (0:nphx),  lipotx(0:nphx)

      parameter (one = 1, zero = 0)
      integer   ipiv(istatx)

c**** array of state kets at current energy
      common /stkets/ lrstat(4, istatx), istate

      complex   tmatrx(nspx, istatx)
c     big work matrices
      complex   g0( istatx, istatx), g0t( istatx, istatx)
      complex   g0s( istatx, nspx*(lx+1)**2)
c     return matrix containing info about each unique potential
      complex   gg(nspx*(lx+1)**2, nspx*(lx+1)**2, 0:nphasx)

      character*3  cerr
      character*13 trans

 400  format(i4)


c -------------------- LU gg
c     multiply T and G0 matrices together, construct g0t = 1 - G0*T
c     notice that the signs below for g0t ARE correct since 1 is the
c     unit matrix
c     since t is tri-diagonal, this product can be computed in n^2 time
c     also fill up some work matrices for use in eigenvalue and
c     determinant calculations and elsewhere
      do 320 icol = 1,istate
        do 310 irow = 1,istate
c         T diagonal contribution
          g0t(irow, icol) = - g0(irow, icol) * tmatrx(1, icol)
c         T off-diagonal contribution
          l1   = lrstat(2,icol)
          m1   = lrstat(3,icol)
          isp1 = lrstat(4,icol)
          m2 = m1+isp1
          if (nsp.eq.2 .and. m2.gt.-l1+1 .and. m2.lt.l1+2) then
             ist2 = icol + (-1)**isp1
             g0t(irow, icol) = g0t(irow, icol)
     1                   - g0(irow, ist2) * tmatrx(nsp, icol)
          endif
 310    continue

        g0t(icol, icol) = g0t(icol, icol) + one

 320  continue

c --- invert matrix by LU decomposition
c     call cgetrf from lapack.  this performs an LU decomposition on
c     the matrix g0t = 1 - g0*T
      call cgetrf( istate, istate, g0t, istatx, ipiv, info )
      if (info.lt.0) then
          call wlog('    *** Error in cgetrf when computing G')
          write(cerr,400)abs(info)
          call wlog('        Argument #'//cerr//
     $                ' had an illegal value.')
      elseif (info.gt.0) then
          call wlog('    *** Error in cgetrf when computing G')
          write(cerr,400)info
          call wlog('        g0t('//cerr// ','//cerr//
     $                ') is exactly 0 -- '//
     $                'this matrix cannot be decomposed.')
      endif

c     now we want g_c = (g0t)^-1 * g0.  Rather than calculating
c     the inverse of g0t from the LU decomposition, we can compute
c     g0t^-1 * g0 directly by backsubstituting the columns of G0.
c     See sect. 2.3 in Numerical Recipes or LAPACK Users' Guide
c     sect. 2.3

c     third arg in number of output columns, istate for full
c     matrix, ipart(ik) for just the parts of the matrix needed
c     to contruct fine structure + DOS functions

      do 620 ip=ipi, ipf
        ipart = nsp*(lipotx(ip)+1)**2
        do 590 is1 = 1, istate
        do 590 is2 = 1, ipart
          g0s(is1,is2) = g0(is1, is2 + i0(ip))
  590   continue

        trans = 'NotTransposed'
        call cgetrs(trans, istate, ipart, g0t, istatx,
     $                ipiv, g0s, istatx, info)
        if (info.lt.0) then
            call wlog('    *** Error in cgetrf')
            write(cerr,400) abs(info)
            call wlog('        Argument #'//cerr//
     $              ' had an invalid value.')
        endif

c **** at this point g0s contains the full MS ****

c  pack FMS matrix into an nsp*(lx+1)^2 x nsp*(lx+1)^2 matrix for each
c  ipot

        do 600 is2=1,ipart
        do 600 is1=1,ipart
          gg( is1, is2, ip) = g0s( is1+i0(ip), is2)
 600    continue
 620  continue

      return
      end

      subroutine reff2x(mchi, ispec, ipr6, idwopt, critcw, s02, sig2g,
     1                   tk, thetad, mbconv, absolu,  !KJ added absolu 3-06
     1                   vrcorr, vicorr, alphat, thetae, nabs,
     4            elnes,ipmin,ipmax,ipstep)   !KJ added this line  1-06     

      use json_module
      implicit double precision (a-h, o-z)
      logical :: found
      type(json_file) :: json   !the JSON structure read from the file:

      include '../HEADERS/const.h'
      include '../HEADERS/dim.h'

cc    global.dat 
c       configuration average
        integer nabs, iphabs
c       global polarization data
        integer ipol, ispin, le2
        double precision rclabs
        double precision evec(3), xivec(3), spvec(3), angks, elpty
        complex*16 ptz(-1:1, -1:1)
cc    mod6.inp
        integer  mchi, idwopt, ipr6, mbconv, absolu  !KJ added absolu 3-06
        double precision  vrcorr, vicorr, s02, tk, thetad
        double precision  alphat, thetae, sig2g

        integer elnes,ipmin,ipmax,ipstep  !KJ my variables  1-06
c     Local stuff
c      character*512 slog

c     standard formats for string, integers and real numbers
c  10  format(a)
c  20  format (20i4)
c  30  format (6f13.5)

c--json--cc    read global.inp
c--json--      open (file='global.dat', unit=3, status='unknown',iostat=ios)
c--json--c       configuration average data
c--json--        read  (3, 10) slog
c--json--        read  (3, 45) nabs, iphabs, rclabs
c--json--  45    format ( 2i8, f13.5)
c--json--      close(3)
c--json--c     read mod6.inp
c--json--      open (file='mod6.inp', unit=3, status='old',iostat=ios)
c--json--        read (3,10)  slog
c--json--        read (3,20)  mchi, ispec, idwopt, ipr6, mbconv, absolu !KJ added absolu 3-06
c--json--        read (3,10)  slog
c--json--        read (3,30)  vrcorr, vicorr, s02, critcw
c--json--        read (3,10)  slog
c--json--        read (3,30)  tk, thetad, alphat, thetae, sig2g
c--json--      close(3)

      call json_read_global(nabs, iphabs, rclabs, ipol, ispin, le2,
     1                      elpty, angks, evec, xivec, spvec, ptz)


      call json%load_file('ff2x.json')
      if (json_failed()) then   !if there was an error reading the file
         print *, "failed to read ff2x.json"
         stop
      else
         call json%get('mchi',   mchi, found)
                   if (.not. found) call bailout('mchi', 'ff2x.json')
         call json%get('ispec',   ispec, found)
                   if (.not. found) call bailout('ispec', 'ff2x.json')
         call json%get('idwopt',   idwopt, found)
                   if (.not. found) call bailout('idwopt', 'ff2x.json')
         call json%get('ipr6',   ipr6, found)
                   if (.not. found) call bailout('ipr6', 'ff2x.json')
         call json%get('mbconv',   mbconv, found)
                   if (.not. found) call bailout('mbconv', 'ff2x.json')
         call json%get('absolu',   absolu, found)
                   if (.not. found) call bailout('absolu', 'ff2x.json')
         call json%get('vrcorr',   vrcorr, found)
                   if (.not. found) call bailout('vrcorr', 'ff2x.json')
         call json%get('vicorr',   vicorr, found)
                   if (.not. found) call bailout('vicorr', 'ff2x.json')
         call json%get('s02',   s02, found)
                   if (.not. found) call bailout('s02', 'ff2x.json')
         call json%get('critcw',   critcw, found)
                   if (.not. found) call bailout('critcw', 'ff2x.json')
         call json%get('tk',   tk, found)
                   if (.not. found) call bailout('tk', 'ff2x.json')
         call json%get('thetad',   thetad, found)
                   if (.not. found) call bailout('thetad', 'ff2x.json')
         call json%get('alphat',   alphat, found)
                   if (.not. found) call bailout('alphat', 'ff2x.json')
         call json%get('thetae',   thetae, found)
                   if (.not. found) call bailout('thetae', 'ff2x.json')
         call json%get('sig2g',   sig2g, found)
                   if (.not. found) call bailout('sig2g', 'ff2x.json')
         call json%destroy()
      end if
      
      elnes  = 0
      ipstep = 1
      ipmax  = 1
      ipmin  = 1

c     transform energies to atomic units
      vrcorr = vrcorr / hart
      vicorr = vicorr / hart

      return
      end

      subroutine paths (ckspc, fbetac, pcritk, pcrith, nncrit,
     1                  rmax, nlegxx, ipotnn)

c     finds multiple scattering paths
c     This is single precision, units are Angstroms.  BE CAREFUL!

c     pcrith is cut-off fraction used when building paths
c            (path criterion for heap)
c     pcritk is cut-off fraction used on output
c            (path criterion for keeping)

c     ipotnn is output, used by pathsd to duplicate paths criteria,
c     which are used only for diagnostic output.

      include 'dim.h'
      parameter (necrit=9, nbeta=40)
      dimension fbetac(-nbeta:nbeta,0:npotx,necrit), ckspc(necrit)

      include 'vers.h'

c     This common in pathsd, mpprm
      common /atoms/ rat(3,0:natx), ipot(0:natx), i1b(0:natx)

      dimension m(-1:natx,0:natx)
      dimension mindex(natx+1)
c     Used for packed integers
      dimension iout(3)

c     ok true if all paths to rmax found.  If heap full, npx exceeded,
c     etc., last general shell may be incomplete, set ok=.false.
      logical ok

c     Heap data structure:
c     index is the pointer to the element of the data structure.
c     Each element contains
c        r        total path length
c                 Note that r is sorted along with index -- this keeps
c                 the heap maintenance routines fast.
c        mi, mj   m matrix elements used to place last atom in this path
c        npat     number of atoms in this path
c        ipat(npatx) indices of atoms in this path
c     next is the index of the next data structure element available.
c     If an element is freed, npat is the index of the free element
c     to use after using current "next" element.
c     nx is max number in heap
      integer    nx
      parameter (nx = 10 000)
c     parameter (nx = 60 000)
c     r also used in making m matrix, must have nx >= natx+1
      integer   index(nx), npx, np, n, ip, i
c     parameter (npx = 100 000)
      parameter (npx = 4 000 000)
      dimension r(nx), mi(nx), mj(nx)
      dimension npat(nx)
      dimension ipat (npatx,nx)
c     Keep this path on output
      logical keep1(nx), kp1tmp

c     Used with ipack, so need ipat(8)
      dimension ipat0(8)

c     paths are typically about 10 or 20 Ang
      parameter (big = 1.0e3)

      parameter (nheadx = 30)
      character*80  head(nheadx)
      character*80  title, messag*128
      dimension lhead(nheadx)

c     Returned from criterion checker, false if path fails criterion
       logical keep
       external sdist

c     read input
c     header...
c     i, x, y, z, ipot, i1b   of nat+1 atoms (i=0 is central atom)
      open (1, file='geom.dat', status='old', iostat=ios)
      call chopen (ios, 'geom.dat', 'paths')
      nhead = nheadx
      call rdhead (1, nhead, head, lhead)
c     header from geom.dat includes carriage control...
c     nlegxx is max number of legs user wants to consider.
c     nlegs = npat+1, so set npatxx = min (npatx, nlegxx-1)
      npatxx = min (npatx, nlegxx-1)
c     Input rmax is one-way distances
      rmax = rmax*2
      nat = -1
c     ratx is distance to most distant atom, used to check rmax
      ratx = 0
   10 continue
         nat = nat+1
         if (nat .gt. natx)  then
            write(messag,'(1x,a,2i5)') ' PATHS: nat, natx ',
     $           nat, natx
            call echo(messag)
            call fstop(' at PATHS: bad input')
         endif
         read(1,*,end=20)  idum, (rat(j,nat),j=1,3), ipot(nat), i1b(nat)
         rtmp = sdist(rat(1,nat),rat(1,0))
         if (rtmp .gt. ratx)  ratx = rtmp
      goto 10
   20 continue
      nat = nat-1
      close (unit=1)

c     Warn user if rmax > dist to most distant atom
      if (rmax/2 .gt. ratx+.02)  then
         call echo('   WARNING in PATHS Module:')
         call echo('      rmax > distance to most distant atom.')
         call echo('      Some paths may be missing.')
         write(messag,'(1x,a,2f12.5)') ' rmax, ratx ',
     $        rmax/2.d0, ratx
         call echo(messag)
      endif

c     Count number of 1st bounce atoms (at least 1 required).
      n1b = 0
      do 30  i = 1, nat
         if (i1b(i) .gt. 0)  n1b = n1b + 1
   30 continue
      if (n1b .lt. 1) call fstop(' at PATHS: at least one '//
     $     '1st bounce atoms required.')

       if (rmax .ge. big)
     $     call fstop(' at PATHS: get real with rmax!')

c     Make title for this run, include carriage control because head
c     (read above) includes carriage control.
      write(title,32)  rmax/2, pcritk, pcrith, vfeff, vpaths
   32 format(' Rmax', f8.4, ',  keep limit', f7.3,
     1       ', heap limit', f7.3, t57, 2a12)

       write(messag, 34) rmax/2, pcritk, pcrith
       call echo(messag)
   34 format ('    Rmax', f8.4,
     1        '  keep and heap limits', 2f12.7)

       call echo('   Preparing neighbor table')

c     prepare table telling distance from atom i to atom j and then
c     back to central atom
c     First bounce is m(-1,...), m(0,...) is bounces from central
c     atom that are not first bounces.
      do 60  i = -1, nat
         ir = i
         if (i .eq. -1)  ir = 0
         do 40  j = 0, nat
c           r begins with element 1 so sort routine later will work
            r(j+1) = sdist (rat(1,ir), rat(1,j))
            r(j+1) = r(j+1) + sdist (rat(1,j), rat(1,0))
c           we don't need m(i,i), since this will be = shortest
c           of the r(j), so just set it to something very big,
c           it will sort to the end of this row and it won't
c           bother us
            if (j .eq. ir)  r(j+1) = big
c           If we're doing first bounce, use only the allowed first
c           bounce paths.
            if (i .eq. -1)  then
               if (i1b(j) .le. 0)  r(j+1) = big
            endif
   40    continue

c        prepare row i of m table
c        m is a distance table ordered such that distance from
c               i to m(i,0) to 0 <
c               i to m(i,1) to 0 <
c               i    m(i,2)    0 <
c               :    :    :
c               i    m(i,nat)  0
c
c        That is, m(i,0) is index of atom that gives shortest path,
c                 m(i,1)                        next shortest path, etc.
c        Note that m(0,0) is shortest single bounce path.

c        Again, r and mindex go from 1 to nat+1, m goes from 0 to nat
         call sortir (nat+1, mindex, r)
         do 50  j = 0, nat
            m(i,j) = mindex(j+1)-1
   50    continue
   60 continue

       call echo('    nfound  nheap  nheapx  nsc    r')

c     initialize heap data space "next" pointers
      do 70  i = 1, nx-1
         npat(i) = i+1
   70 continue
      npat(nx) = -1
c     initial condition:  make the first path
c     n    number in heap
c     nna  number skipped counter
c     nhx  number used in heap max, a counter
      n = 1
      nna = 0
      nhx = n
      nwrote = 0
      index(n) = 1
      ip = index(n)
      next = 2
      mi(ip) = -1
      mj(ip) = 0
      npat(ip) = 1
      ipat(npat(ip),1) = m(mi(ip),mj(ip))

c     near neighbor is atom ipat(npat(ip),1) for first path into heap
      ipotnn = ipot(ipat(npat(ip),1))

c     Someday change keep and keep1 to lkeep and lheap to match
c     ccrit variable names.
c     Initialize keep criterion
      xcalcx = -1
      call ccrit (npat(ip), ipat(1,ip), ckspc,
     1    fbetac, rmax, pcrith, pcritk, nncrit, ipotnn, ipot,
     2    r(n), keep, keep1(ip), xcalcx)

      open (file='paths.bin', unit=3, access='sequential',
     1      form='unformatted', status='unknown', iostat=ios)
      call chopen (ios, 'paths.bin', 'paths')
c     These strings are all char*80 and include carriage control
      write(3) nhead+1
      do 88  ihead = 1, nhead
         write(3) head(ihead)
         write(3) lhead(ihead)
   88 continue
      write(3) title
      write(3) istrln(title)
      write(3)  nat
      do 90  i = 0, nat
         write(3) (rat(j,i),j=1,3), ipot(i), i1b(i)
   90 continue

c     r is the heap, index is the pointer to the rest of the data
c     np is the number of paths found and saved
      np = 0
c     nbx  mpat max (Number of Bounces maX)
      nbx = 0

c     done if path at top of heap is longer than longest path we're
c        interested in
c     done if max number of paths we want have been found
c     begin 'while not done' loop
      ok = .false.
  800 continue
         if (r(1) .gt. rmax  .or.  np .ge. npx .or. n.le.0)  then
c           n=0 means heap is empty
            if (n.le.0)  ok=.true.
c           if (n.le.0)  call echo('   Heap empty')
            goto 2000
         endif

c        save element at top of heap in arrays labeled 0
c        dump to unit 3 (unformatted)
         ip = index(1)
         npat0 = npat(ip)
         do 100  i = 1, npat0
            ipat0(i) = ipat(i,ip)
  100    continue
         r0 = r(1)

c        Don't write out path if last atom is central atom, or
c        if it doesn't meet pcritk
         if (ipat0(npat0).eq.0 .and. keep1(ip)) then
            write(messag,'(1x,a,2i6)')
     $           ' paths: odd case at npat0,ip= ', npat0,ip
            call echo(messag)
         endif
         if (ipat0(npat0).ne.0 .and. keep1(ip))  then
            np = np+1
c           pack integers
            call ipack (iout, npat0, ipat0)
            write(3)  r0, iout
            nwrote = nwrote+1
c           write status report to screen
            if (mod(np,1000) .eq. 0)  then
               write(messag, 132) np, n, nhx, nbx, r0/2
  132          format (4x, i6, i7, i8, i4, f10.4)
               call echo(messag)
            endif
         endif

         if (np .ge. npx)  then
            write(messag,'(1x,i5,a)') np,
     $           ' paths found. (np >= npx)'
            call echo(messag)
            goto 2000
         endif

c        Make new path by replacing last atom in path from top of heap,
c        put this path on top of heap and buble it down.  If row is
c        finished, or new path is too long, don't add it, instead
c        move last path in heap to the top.
c        If working on row mi=-1 (first bounce atoms), don't
c        use them if not allowed 1st bounce atoms.
         mj(ip) = mj(ip) + 1
         if (mi(ip).eq.-1  .and.  i1b(m(mi(ip),mj(ip))).le.0)  then
c           not allowed first bounce atom
            r(1) = big
            keep = .false.
c           call echo('1st bounce limit!')
         elseif (mj(ip) .ge. nat)  then
c           we've finished a row of m matrix
            r(1) = big
            keep = .false.
         else
c           new path has same indices, etc.  Only need to replace
c           last atom.
            ipat(npat(ip),ip) = m(mi(ip),mj(ip))
            call ccrit (npat(ip), ipat(1,ip), ckspc,
     1                  fbetac, rmax, pcrith, pcritk, nncrit,
     1                  ipotnn, ipot,
     2                  r(1), keep, keep1(ip), xcalcx)
         endif

c        If r is bigger than rmax or keep=false, remove element from
c        heap by taking the last element in the heap and moving it to
c        the top.  Then bubble it down.  When removing an element
c        from the heap, be sure to save the newly freed up index.
c        r(1) and index(1) are new path, set above
         if (r(1).gt.rmax .and. keep)  then
            call echo('odd case rmax...')
         endif
         if (r(1).gt.rmax .or. .not.keep)  then
            index(1) = index(n)
            r(1) = r(n)
c           use npat as pointer to next free location
            npat(ip) = next
            next = ip
            n = n-1
c           nna is Number Not Added to heap
            nna = nna + 1
c           Maybe heap may be empty here, but that's alright
         endif
         if (npat(index(1)).gt.nbx .and. n.gt.0)  nbx = npat(index(1))

c        If heap is empty, don't call hdown.
         if (n.gt.0)  call hdown (r, index, n)

c        and make a new path by adding an atom onto the end of the path
c        we saved, put this at the end of the heap and bubble it up.
c        Do this only if it won't be too many bounces.
         if (npat0+1 .le. npatxx)  then
            ip = next
            if (ip .lt. 0)  then
c              call echo('   Heap full')
               goto 2000
            endif
            next0 = npat(ip)
            do 200  i = 1, npat0
               ipat(i,ip) = ipat0(i)
  200       continue
            mi(ip) = ipat0(npat0)
            mj(ip) = 0
            npat(ip) = npat0+1
            ipat(npat(ip),ip) = m(mi(ip),mj(ip))
            call ccrit (npat(ip), ipat(1,ip), ckspc,
     1                  fbetac, rmax, pcrith, pcritk, nncrit,
     1                  ipotnn, ipot,
     2                  rtmp, keep, kp1tmp, xcalcx)
            if (rtmp .gt. rmax  .and.  keep)  then
               call echo(' odd case rmax and tmp...')
            endif
            if (rtmp .gt. rmax  .or.  .not.keep)  then
               npat(ip) = next0
               nna = nna+1
            else
c              add it to the heap
               next = next0
               n = n+1
               if (n .gt. nhx)  nhx = n
               index(n) = ip
               r(n) = rtmp
               keep1(ip) = kp1tmp
               if (npat(index(n)) .gt. nbx)  nbx = npat(index(n))
               call hup (r, index, n)
            endif
         endif

      goto 800
 2000 continue
c     end of 'while not done' loop
      if (.not. ok)  then
         call echo('   Internal path finder limit exceeded -- '//
     1           'path list may be incomplete.')
      endif
      close (unit=3)
       write(messag, 2010) np, nhx, nbx
 2010 format ('    Paths found', i9, 3x,
     1        '(nheapx, nbx', i8, i4, ')')
       call echo(messag)
      end

      subroutine ipack (iout, n, ipat)

c     Input:  n          number of things to pack, nmax=8
c             ipat(1:n)  integers to pack
c     Output: iout(3)    packed version of n and ipat(1:n)
c
c     Packs n and ipat(1:n) into 3 integers, iout(1:3).  Algorithm
c     packs three integers (each between 0 and 1289 inclusive) into a
c     single integer.  Single integer must be INT*4 or larger, we assume
c     that one bit is wasted as a sign bit so largest positive int
c     is 2,147,483,647 = (2**31 - 1).
c     This version is specifically for the path finder and
c     degeneracy checker.

      dimension iout(3), ipat(n)
      dimension itmp(8)
      parameter (ifac1 = 1290, ifac2 = 1290**2)

      if (n .gt. 8)  call par_stop('ipack n too big')

      do 10  i = 1, n
         itmp(i) = ipat(i)
   10 continue
      do 20  i = n+1, 8
         itmp(i) = 0
   20 continue

      iout(1) = n       + itmp(1)*ifac1 + itmp(2)*ifac2
      iout(2) = itmp(3) + itmp(4)*ifac1 + itmp(5)*ifac2
      iout(3) = itmp(6) + itmp(7)*ifac1 + itmp(8)*ifac2

      return
      end
      subroutine upack (iout, n, ipat)

c     retrieve n and ipat from iout
c     Input:  iout(3)  packed integers
c             n        max number to get, must be .le. 8
c     Output: n        number unpacked
c             ipat(1:n) unpacked integers

      dimension iout(3), ipat(n)
      dimension itmp(8)
      parameter (ifac1 = 1290, ifac2 = 1290**2)

      nmax = n
      if (nmax .gt. 8)  call par_stop('nmax .gt. 8 in upack')

      n = mod (iout(1), ifac1)
      if (n .gt. nmax)  call par_stop('nmax in upack too small')

      itmp(1) = mod (iout(1), ifac2) / ifac1
      itmp(2) = iout(1) / ifac2
      itmp(3) = mod (iout(2), ifac1)
      itmp(4) = mod (iout(2), ifac2) / ifac1
      itmp(5) = iout(2) / ifac2
      itmp(6) = mod (iout(3), ifac1)
      itmp(7) = mod (iout(3), ifac2) / ifac1
      itmp(8) = iout(3) / ifac2

      do 10  i = 1, n
         ipat(i) = itmp(i)
   10 continue

      return
      end

      subroutine regenf (mfeff, ipr5, critcw, iorder, wnstar,
     1            ipol, ispin, le2, angks, elpty, evec, xivec, ptz)

      use json_module
      implicit double precision (a-h, o-z)
      logical :: found
      type(json_file) :: json   !the JSON structure read from the file:

      include '../HEADERS/const.h'
      include '../HEADERS/dim.h'
      
      integer elnes,ipmin,ipmax,ipstep  !KJ added these variables 1-06      

cc    global.dat 
c       configuration average
        integer nabs, iphabs
c       global polarization data
        integer  ipol, ispin, le2
        double precision evec(3), xivec(3), spvec(3), elpty,angks,rclabs
        complex*16 ptz(-1:1, -1:1)
cc    mod5.inp
        integer  mfeff, ipr5, iorder
        logical  wnstar
        double precision critcw

c     Local stuff
c      character*512 slog

c     standard formats for string, integers and real numbers
c  10  format(a)
c  20  format (20i4)
c  30  format (6f13.5)

c--json--cc    read global.inp
c--json--      open (file='global.dat', unit=3, status='unknown',iostat=ios)
c--json--c       configuration average data
c--json--        read  (3, 10) slog
c--json--        read  (3, 45) nabs, iphabs, rclabs
c--json--  45    format ( 2i8, f13.5)
c--json--c       global polarization data
c--json--        read  (3,10)   slog
c--json--        read  (3, 50)  ipol, ispin, le2, elpty, angks
c--json--  50    format ( 3i5, 2f12.4)
c--json--        read  (3, 10) slog
c--json--        do 60 i = 1,3
c--json--          read  (3,30) evec(i), xivec(i), spvec(i)
c--json--  60    continue
c--json--        read  (3, 10) slog
c--json--        do 70 i = -1, 1
c--json--          read (3,30) a1, b1, a2, b2, a3, b3
c--json--          ptz(-1,i)= dcmplx(a1,b1)
c--json--          ptz(0,i) = dcmplx(a2,b2)
c--json--          ptz(1,i) = dcmplx(a3,b3)
c--json--  70    continue
c--json--      close(3)

      call json_read_global(nabs, iphabs, rclabs, ipol, ispin, le2,
     1                      elpty, angks, evec, xivec, spvec, ptz)


c--json--c     read mod5.inp
c--json--      open (file='mod5.inp', unit=3, status='old',iostat=ios)
c--json--        read (3,10)  slog
c--json--        read (3,180)  mfeff, ipr5, iorder, critcw, wnstar
c--json--  180   format ( 2i4, i8, f13.5, L5)
c--json--      close(3)


      call json%load_file('genfmt.json')
      if (json_failed()) then   !if there was an error reading the file
         print *, "failed to read genfmt.json"
         stop
      else
         call json%get('mfeff',   mfeff, found)
                  if (.not. found) call bailout('mfeff', 'genfmt.json')
         call json%get('ipr5',   ipr5, found)
                  if (.not. found) call bailout('ipr5', 'genfmt.json')
         call json%get('iorder',   iorder, found)
                  if (.not. found) call bailout('iorder', 'genfmt.json')
         call json%get('critcw',   critcw, found)
                  if (.not. found) call bailout('critcw', 'genfmt.json')
         call json%get('wnstar',   wnstar, found)
                  if (.not. found) call bailout('wnstar', 'genfmt.json')
         call json%destroy()
      end if

      elnes  = 0
      ipstep = 1
      ipmax  = 1
      ipmin  = 1

      return
      end

c     sub-program exchange
      program ffmod3
c     subroutine ffmod3

c     full multiple scattering code (inversion of big matrix)
c     written by a.ankudinov 2000 using earlier written subroutines
c     coded by b.ravel
c     modified by a.ankudinov 2001 for new matrix inversion algorithms
c     and new I/O structure

c     INPUT:  geom.dat, global.dat and mod3.inp
c     OUTPUT:  fms.bin

      implicit double precision (a-h, o-z)

      include '../HEADERS/dim.h'
      include '../HEADERS/parallel.h'
      real*8 wall_start, wall_end
      dimension lmaxph(0:nphx), rat(3,natx), iphat(natx)
      complex*16 ptz(-1:1, -1:1)

      real  rfms2, rdirec, toler1, toler2

      call par_begin

c     Initialize clock
      call seconds(wall_start)
      wall_comm = 0.0

c     open the log file, unit 11.  See subroutine wlog.
      if (master) then
        open (unit=11, file='log3.dat', status='unknown', iostat=ios)
        call chopen (ios, 'log3.dat', 'feff')
      else
        par_type = 2
      endif

c     read  INPUT: files geom.dat, global.dat and mod3.inp
      call reafms(mfms, rfms2, idwopt, tk, thetad, sig2g,
     1            lmaxph, nat, iphat, rat,
     2            ipol, ispin, le2, angks, ptz,
     3            minv, rdirec, toler1, toler2)

      if (mfms.eq.1 )  then
c        first do fms inside rfms2
         call fmstot(rfms2, idwopt, tk, thetad, sig2g, 
     1            lmaxph, nat, iphat, rat,
     2            ipol, ispin, le2, angks, ptz,
     3            minv, rdirec, toler1, toler2,elnes,ipmin,ipmax,ipstep)
         call wlog(' Done with module 3: FMS.')
      endif

c     OUTPUT: gtr.bin file for the next modules

      if (master) close (unit=11)

c--   Time at end of run
      call seconds(wall_end)
      if (master .and. parallel_run) then
        write (6,*) 'total time     ', wall_end - wall_start
        write (6,*) 'communicate time', wall_comm
      endif

      call par_end

c     sub-program exchange
      stop
c     return

      end

      double precision function dsordf (i,j,n,jnd,a)
c              * calculation of diff. integrals*
c        integration by simpson method of the   hg*(r**n)
c        hg(l)=cg(l,i)*cg(l,j)+cp(l,i)*cp(l,j)  if jnd=1
c        hg=expression above multiplied by  dg  if jnd=-1
c        hg(l)=cg(l,i)*cp(l,j)                  if jnd=2
c        hg=expression above multiplied by  dg  if jnd=-2
c        hg(l)=dg(l)*cg(l,i)+dp(l)*cp(l,j)      if jnd=3
c        hg(l)=dg(l)*dg(l)+dp(l)*dp(l)          if jnd=4
c        hg is constructed by calling program   if jnd>=5
c                  cg(l,i)  large component of the orbital i
c                  cp(l,j)  small component of the orbital j
c        a is such that dg,dp or hg following the case
c        behave at the origin as cte*r**a
c        the integration is made as far as dr(j) for jnd>3
c
c        the development limits at the origin (used for calculation
c        of integral form 0 to dr(1) ) of functions dg,dp and hg are
c        supposed to be in blocks ag,ap and chg respectively
c        this program uses  aprdev
c
      implicit double precision (a-h,o-z)
      common cg(251,30), cp(251,30), bg(10,30), bp(10,30),
     1         fl(30), fix(30), ibgp
      common/comdir/cl,dz,dg(251),ag(10),dp(251),ap(10),bidcom(783)
      dimension hg(251),chg(10)
      common/ratom1/xnel(30),en(30),scc(30),scw(30),sce(30),
     1nq(30),kap(30),nmax(30)
      common/tabtes/hx,dr(251),test1,test2,ndor,np,nes,method,idim
      dimension bgi(10),bgj(10),bpi(10),bpj(10)

c        construction of the array hg
      b=0
      if (jnd.le.3) go to 11
      max0=j
      b=a
      go to 101

 11   max0= min(nmax(i),nmax(j))
      do  15 l= 1,ibgp
        bgi(l) = bg(l,i)
        bgj(l) = bg(l,j)
        bpi(l) = bp(l,i)
 15     bpj(l) = bp(l,j)
      if ( abs(jnd)-2) 21,55,101
 21   do 31 l=1,max0
 31      hg(l)=cg(l,i)*cg(l,j)+cp(l,i)*cp(l,j)
      do 45 l=1,ndor
 45   chg(l)=aprdev(bgi,bgj,l)+aprdev(bpi,bpj,l)
      go to 81

 55   do 61 l=1,max0
 61      hg(l)=cg(l,i)*cp(l,j)
      do 71 l=1,ndor
 71      chg(l)=aprdev(bgi,bpj,l)
 81   b=fl(i)+fl(j)
      if (jnd.gt.0) go to 301

      do 85 l=1,max0
 85      hg(l)=hg(l)*dg(l)
      do 87 l=1,ndor
 87      ap(l)=chg(l)
      b=b+a
      do 95 l=1,ndor
 95      chg(l)=aprdev(ap,ag,l)
      go to 301

 101  if (jnd-4) 201,111,301
 111  do 121 l=1,max0
 121     hg(l)=dg(l)*dg(l)+dp(l)*dp(l)
      b=b+b
      do 131 l=1,ndor
 131     chg(l)=aprdev(ag,ag,l)+aprdev(ap,ap,l)
      go to 301

 201  do 221 l=1,max0
 221     hg(l)=dg(l)*cg(l,i)+dp(l)*cp(l,j)
      b=a+fl(i)
      do 241 l=1,ndor
 241     chg(l)=aprdev(bgi,ag,l)+aprdev(bpj,ap,l)

c        integration of the hg
 301  dsordf=0.0d 00
      io=n+1
      do 305 l=1,max0
 305     hg(l)=hg(l)*(dr(l)**io)
      do 311 l=2,max0,2
 311     dsordf=dsordf+hg(l)+hg(l)+hg(l+1)
      dsordf=hx*(dsordf+dsordf+hg(1)-hg(max0))/3.0d 00
c        integral from 0 to dr(1)
      b=b+n
      do 331 l=1,ndor
         b=b+1.0d 00
 331     dsordf=dsordf+chg(l)*(dr(1)**b)/b
      return
      end

c      subroutine potex( ps, qs, aps, aqs, jri, p2)
      subroutine potex( ps, qs, aps, aqs, jri)
c        this programm uses bkeato,aprdec,multrk,yzkrdc
      implicit double precision (a-h,o-z)
      include '../HEADERS/dim.h'
      complex*16 aprdec
c      complex*16 p2
      complex*16 ps(nrptx),qs(nrptx),aps(10),aqs(10)
      common/dff/cg(nrptx,30),cp(nrptx,30),bg(10,30),bp(10,30),
     1             fl(30), fix(30), ibgp
      complex*16 dg,ag,dp,ap,dv,av,eg,ceg,ep,cep
      common/comdic/cl,dz,dg(nrptx),ag(10),dp(nrptx),ap(10),dv(nrptx),
     2          av(10),eg(nrptx),ceg(10),ep(nrptx),cep(10)
c     dg,dp to get data from yzkrdc, dv,eg,ep -output for soldir
      common/itescf/testy,rap(2),teste,nz,norb,norbsc
      common/ratom1/xnel(30),en(30),scc(30),scw(30),sce(30),
     1nq(30),kap(30),nmax(30)
      common/tabtec/hx,dr(nrptx),test1,test2,ndor,np,nes,method,idim
      common/mulabc/afgkc
      dimension afgkc(-ltot-1:ltot,30,0:3)
      dimension bgj(10),bpj(10)
c#mn
       external aprdec
 
c     ia=norb
      jia=2* abs(kap(norb))-1
      do 9 i=1,10
         cep(i)=0.0d 00
 9       ceg(i)=0.0d 00
      do 11 i=1,idim
         ep(i)=0.0d 00
 11      eg(i)=0.0d 00
 
c     exchange terms
      do 201 j=1,norb-1
         jj=2* abs(kap(j))-1
         kma=(jj+jia)/2
         k= abs(jj-kma)
         if ((kap(j)*kap(norb)).lt.0) k=k+1
         kmin = k
c        kma=min(kma,15)
c        if (k.lt.kma) goto 201

c111     a=bkeato(j,ia,k)/xnel(ia)
 111     a=afgkc(kap(norb),j,(k-kmin)/2)
         if (a.eq.0.0d 00) go to 151
c         call yzkrdc (j,k,fl(norb),ps,qs,aps,aqs, p2, norb)
         call yzkrdc (j,k,fl(norb),ps,qs,aps,aqs)
         do 121 i=1,idim
            eg(i)=eg(i)+a*dg(i)*cg(i,j)
 121        ep(i)=ep(i)+a*dg(i)*cp(i,j)
         n=k+1+ abs(kap(j))- abs(kap(norb))
c         differrent for irregular solution
         if (fl(norb) .lt.0.0) n=k+1+ abs(kap(j)) + abs(kap(norb))
         if (n.gt.ndor) go to 141
         do 135 i=n,ndor
            ceg(i)=ceg(i)+bg(i+1-n,j)*a*ap(1)*fix(j)/fix(norb)
 135        cep(i)=cep(i)+bp(i+1-n,j)*a*ap(1)*fix(j)/fix(norb)
 141     i=2* abs(kap(j))+1
         if (i.gt.ndor) go to 151
         do 143 ix = 1,10
            bgj(ix) = bg(ix,j)
 143        bpj(ix) = bp(ix,j)
         do 145 n=i,ndor
            nx = n + 1 - i
            ceg(n) = ceg(n) - a * aprdec(ag,bgj,nx)*fix(j)**2
 145        cep(n) = cep(n) - a * aprdec(ag,bpj,nx)*fix(j)**2
 151     k=k+2
         if (k.le.kma) go to 111
 201  continue
 
c    division of potentials and
c    their development limits by speed of light
      do 527 i=1,ndor
         cep(i)=cep(i)/cl
 527     ceg(i)=ceg(i)/cl
      do 531 i=1,jri
         ep(i)=ep(i)/cl
 531     eg(i)=eg(i)/cl
      do 532 i=jri+1,nrptx
         ep(i)=0.0d0
 532     eg(i)=0.0d0

      return
      end

c//////////////////////////////////////////////////////////////////////
c Copyright (c) 1997--2000 Matthew Newville, The University of Chicago
c Copyright (c) 1992--1996 Matthew Newville, University of Washington
c
c Permission to use and redistribute the source code or binary forms of
c this software and its documentation, with or without modification is
c hereby granted provided that the above notice of copyright, these
c terms of use, and the disclaimer of warranty below appear in the
c source code and documentation, and that none of the names of The
c University of Chicago, The University of Washington, or the authors
c appear in advertising or endorsement of works derived from this
c software without specific prior written permission from all parties.
c
c THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
c EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
c MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
c IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
c CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
c TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
c SOFTWARE OR THE USE OR OTHER DEALINGS IN THIS SOFTWARE.
c//////////////////////////////////////////////////////////////////////

       subroutine getfln(strin, filnam, ierr)
c  strip off the matched delimeters from string, as if getting
c  a filename from "filename", etc.
       implicit none
       integer idel, iend, istrln, ierr, ilen
       character*(*) strin, filnam, tmp*144, ope*8, clo*8
       external istrln
       data ope, clo /'"{(<''[',  '"})>'']'/

c
       ierr  = 0
       tmp   = strin
       call triml(tmp)
       ilen  = istrln(tmp)
       idel  = index(ope,tmp(1:1))
       if (idel.ne.0) then
          iend = index(tmp(2:), clo(idel:idel) )
          if (iend.le.0) then
             ierr = -1
             iend = ilen 
          end if
          filnam = tmp(2:iend)
       else
          iend = index(tmp,' ') - 1
          if (iend.le.0) iend  = istrln(tmp) 
          filnam = tmp(1:iend)
       end if
       return
c end  subroutine getfln
       end

       subroutine newfil(file, iofile)
c  
c  open a new file to unit iofile
c     if iofile > 0 , that file is closed
c     if an old file named file exists, it is deleted!
       implicit none
       character*(*) file, str*256
       integer   iofile, iex, ier
       logical   exist
       str  = file
       if (iofile.gt.0) then 
          close(iofile)
cc          iofile = 0
       end if
       inquire(file=str, exist=exist)
       if (exist) then 
          call openfl(iofile, str, 'old', iex, ier)
          close(iofile,status='delete')
cc          iofile = 0
       end if
cc       iofile = 3
       call openfl(iofile, str, 'unknown', iex, ier)
       if ((iex.lt.0).or. (ier.ne.0))  iofile = -1
c end subroutine newfil
       return
       end
       subroutine openfl(iunit, file, status, iexist, ierr)
c  
c  open a file, 
c   if unit <= 0, the first unused unit number greater than 7 will 
c                be assigned.
c   if status = 'old', the existence of the file is checked.
c   if the file does not exist iexist is set to -1
c   if the file does exist, iexist = iunit.
c   if any errors are encountered, ierr is set to -1.
c
c   note: iunit, iexist, and ierr may be overwritten by this routine
       implicit none
       character*(*)  file, status, stat*10
       integer    iunit, iexist, ierr
       logical    exist, open
c
c make sure there is a unit number, and that it's pointing to
c an unopened logical unit number other than 5 or 6
       ierr   = -3
       iexist =  0
       iunit  = max(1, iunit)
 10    continue 
       inquire (unit=iunit, opened=open)
       if (open) then
          iunit = iunit + 1
          if ((iunit.eq.5).or.(iunit.eq.6)) iunit = 7
          goto 10
       endif
c
c if status = 'old', check that the file name exists
       ierr = -2
       stat =  status                          
       call lower(stat)
       if (stat.eq.'old') then
          iexist = -1
          inquire(file=file, exist=exist)
          if (.not.exist) return
          iexist = iunit
       end if
c 
c open the file
       ierr = -1
cc       print*, ' openfl, unit ', iunit, ' file ', file(:40)
       open(unit=iunit, file=file, status=status, err=100)
       ierr = 0
 100   continue
       return
c end  subroutine openfl
       end

      subroutine cqdrtc(Coef,Sol,NSol)
c     Combutes the zeros of a quadratic polynomial
ccccccccccccccccccccccccccccccccccccccccccccccccc
c     Input
c     Coef - array of coefficients
      COMPLEX*16 Coef(3)
ccccccccccccccccccccccccccccccccccccccccccccccccc
c     Output
c     Sol  - Array of solutions
c     NSol - # of solutions (only one if Coef(1) = 0 etc.)
c     NSol = -1 means a and b are zero
      COMPLEX*16 Sol(2)
      INTEGER NSol
ccccccccccccccccccccccccccccccccccccccccccccccccc
c     Local Variables
      COMPLEX*16 q, Sqrt
      DOUBLE PRECISION Sgn

      IF(Coef(1).eq.0.d0) THEN
         IF(Coef(2).eq.0.d0) THEN
            NSol = -1
            RETURN
         ELSE
            NSol = 1
            Sol(1) = -Coef(3)/Coef(2)
         END IF
      ELSE
         NSol = 2
         Root = Sqrt(Coef(2)**2-4.d0*Coef(1)*Coef(3))
         Sgn  = SIGN(DBLE(CONJG(Coef(2))*Root),1.d0)
         q    = -0.5d0*(Coef(2) + Sgn*Root)

         Sol(1) = q/Coef(1)
         Sol(2) = Coef(3)/q
      END IF

      RETURN
      END


      subroutine ccubic(Coef,Sol,NSol)
c     Combutes the zeros of a cubic polynomial
ccccccccccccccccccccccccccccccccccccccccccccccccc
c     Input
c     Coef - array of coefficients
      COMPLEX*16 Coef(4)
ccccccccccccccccccccccccccccccccccccccccccccccccc
c     Output
c     Sol  - Array of solutions
c     NSol - # of solutions (only one if Coef(1) = 0 etc.)
c     NSol = -1 means a, b, and c are zero
      COMPLEX*16 Sol(4)
      INTEGER NSol
ccccccccccccccccccccccccccccccccccccccccccccccccc
c     Local Variables
      COMPLEX*16 P1, P2, Q, R, Coef2(3), a, b, c
      DOUBLE PRECISION Sgn, Theta
c     PARAMETERS
      COMPLEX*16 I
      PARAMETER(I = (0.d0, 1.d0))
      DOUBLE PRECISION Pi
      PARAMETER(Pi = 3.141592653589793238462643d0)

      IF(Coef(1).eq.0.d0) THEN
         Coef2(1) = Coef(2)
         Coef2(2) = Coef(3)
         Coef2(3) = Coef(4)
         CALL CQdrtc(Coef2,Sol,NSol)
      ELSE
         a = Coef(2)/Coef(1)
         b = Coef(3)/Coef(1)
         c = Coef(4)/Coef(1)
         NSol = 3
         Q = (a**2 - 3.d0*b)/9.d0
         R = (2.d0*a**3 - 9.d0*a*b + 27.d0*c)/54.d0

         IF(((DIMAG(Q).eq.0.d0).and.(DIMAG(R).eq.0.d0)).and.
     &        (DIMAG(R**2).lt.DIMAG(Q**3))) THEN
            Theta = ACOS (DBLE(R/SQRT(Q**3)))
            Sol(1) = -2*SQRT(Q)*Cos(Theta/3.d0) - a/3.d0
            Sol(2) = -2*SQRT(Q)*Cos((Theta+2.d0*Pi)/3.d0) - a/3.d0
            Sol(3) = -2*SQRT(Q)*Cos((Theta-2.d0*Pi)/3.d0) - a/3.d0
         ELSE
            Sgn = SIGN(1.d0, DBLE(CONJG(R)*SQRT(R**2-Q**3)))
            P1 = -(R + Sgn*SQRT(R**2-Q**3))**(1.d0/3.d0)
            IF(P1.eq.0.d0) THEN
               P2 = 0.d0
            ELSE
               P2 = Q/P1
            END IF
            Sol(1) = (P1 + P2) - a/3.d0
            Sol(2) = -0.5d0*(P1 + P2) - a/3.d0 +
     &           I*SQRT(3.d0)/2.d0*(P1-P2)
            Sol(3) = -0.5d0*(P1 + P2) - a/3.d0 -
     &           I*SQRT(3.d0)/2.d0*(P1-P2)
         END IF
      END IF

      RETURN
      END

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Information about last revision of $RCSfile: m_atomicpotio.f90,v $:
! $Revision: 1.16 $
! $Author: jorissen $
! $Date: 2010/12/14 00:22:37 $
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
MODULE AtomicPotIO
  USE ErrorMod
  USE IOMod
  USE dimsmod
  IMPLICIT NONE

  CHARACTER(3),PRIVATE :: FileType
  !PARAMETER(FileType = 'PAD')
  PARAMETER(FileType = 'TXT')


CONTAINS
  SUBROUTINE WriteAtomicPots(nph, iz, ihole, rho, dmag, rhoval, vcoul, dgc0, dpc0, dgc, dpc, &
       & adgc, adpc, erelax, emu, xnvmu, xnval, norb, eorb, drho, dvcoul, iphat,    &
       & rat, iatph, novr, iphovr, nnovr, rovr, nat, edens, edenvl, vclap, rnrm,    &
       & kappa, iorb, s02)

    ! Scalar data
    INTEGER,INTENT(IN) :: nph, nat, ihole
    DOUBLE PRECISION, INTENT(IN) :: emu, erelax, s02

    ! 1D data
    INTEGER,INTENT(IN) :: iz(:), norb(:), iphat(:), iatph(:), novr(:)
    DOUBLE PRECISION,INTENT(IN) :: dgc0(:), dpc0(:), drho(:), dvcoul(:), rnrm(:)

    ! 2D data
    INTEGER,INTENT(IN) :: iphovr(:,:), nnovr(:,:), kappa(:,:), iorb(:,:)
    DOUBLE PRECISION,INTENT(IN) :: rho(:,:), dmag(:,:), rhoval(:,:), vcoul(:,:), &
         & xnvmu(:,:), xnval(:,:), eorb(:,:), rat(:,:), rovr(:,:), edens(:,:),   &
         & edenvl(:,:), vclap(:,:)

    ! 3D data
    DOUBLE PRECISION,INTENT(IN) :: dgc(:,:,:), dpc(:,:,:), adgc(:,:,:), adpc(:,:,:)




    CHARACTER*80 Headers(20)
    CHARACTER*20 ColumnLabels(20)

    INTEGER iph

    ! Initialize stuff.
    Headers(:) = ' '
    ColumnLabels(:) = ' '

    ! Define some headers.
    Headers(1) = 'This file contains information about the free atom potentials.'
    Headers(2) = 'nat    - number of atoms.'
    Headers(3) = 'nph    - number of unique potentials'      
    Headers(3) = 'ihole  - hole index'      
    Headers(4) = 'erelax - relaxation energy for each occupied orbital.'
    Headers(5) = 'emu - edge energy for each occupied orbital.'
    Headers(6) = 's02 - many body amplitude reduction.'
    ColumnLabels(1) = 'nph'
    ColumnLabels(2) = 'nat'
    ColumnLabels(3) = 'ihole'
    ColumnLabels(4) = 'erelax'
    ColumnLabels(5) = 'emu'
    ColumnLabels(6) = 's02'
    ! Write headers along with the first line and columnlabels.
    ! Write scalar data.
    CALL WriteData('apot.bin', Int1 = nph, Int2 = nat, Int3 = ihole, Double4 = erelax, Double5 = emu, &
         & Double6 = s02, Headers = Headers, ColumnLabels = ColumnLabels, FileType = FileType, &
         ForceNewSection = .TRUE. ) !KJ 7-09 added ForceNewSection bc otherwise doesn't work on my Windows pc
    Headers(:) = ' '
    ColumnLabels(:) = ' '

    ! Write iz, iatph, novr, rnrm.
    Headers(1) = 'iz(0:nphx)    - atomic number for each unique potential'
    Headers(2) = 'iatph(0:nphx) - given unique pot, which atom is model?'
    Headers(3) = 'novr(0:nphx)  - number of overlap shells for each unique pot'
    Headers(4) = 'rnrm(0:nphx)  - norman radius for each unique potential.'
    ColumnLabels(1) = 'iz'
    ColumnLabels(2) = 'iatph'
    ColumnLabels(3) = 'novr'
    ColumnLabels(4) = 'rnrm'
    CALL WriteArrayData('apot.bin', Int1 = iz, Int2 = iatph, Int3 = novr, Double4 = rnrm, &
         & Headers = Headers, ColumnLabels = ColumnLabels, FileType = FileType,           &
         & ForceNewSection = .TRUE.)
    Headers(:) = ' '
    ColumnLabels(:) = ' '

    ! Write norb
    Headers(1) = 'norb(0:nphx+1) - number of occupied orbitals for each unique potential'
    CALL WriteArrayData('apot.bin', Int1 = norb, Headers = Headers, &
         & FileType = FileType, ForceNewSection = .TRUE.)

    ! Write iphat
    Headers(1) = 'iphat(natx) - given specific atom, which unique pot?'
    CALL WriteArrayData('apot.bin', Int1 = iphat, Headers = Headers, &
         & FileType = FileType, ForceNewSection = .TRUE.)

    ! Write dgc0, dpc0, drho, and dvcoul
    Headers(1) = 'dgc0   - upper component of core hole orbital'
    Headers(2) = 'dpc0   - lower component of core hole orbital'
    Headers(3) = 'drho   - core hole density.'
    Headers(4) = 'dvcoul - core hole coulomb potential.'
    ColumnLabels(1) = 'dgc0'
    ColumnLabels(2) = 'dpc0'
    ColumnLabels(3) = 'drho'
    ColumnLabels(4) = 'dvcoul'
    CALL WriteArrayData('apot.bin', Double1 = dgc0, Double2 = dpc0, Double3 = drho, &
         & Double4 = dvcoul, Headers = Headers, ColumnLabels = ColumnLabels,          &
         & FileType = FileType, ForceNewSection = .TRUE.)
    Headers(:) = ' '
    ColumnLabels(:) = ' '

    ! Write iphovr.
    Headers(1) = 'iphovr(novrx,0:nphx) - unique pot for each overlap shell'
    CALL Write2D('apot.bin', iphovr, Headers = Headers, FileType = FileType)

    ! Write nnovr.
    Headers(1) = 'nnovr(novrx,0:nphx) - number of atoms in overlap shell'
    CALL Write2D('apot.bin', nnovr, Headers = Headers, FileType = FileType)

    ! Write rho.
    Headers(1) = 'rho(r,0:nphx+1) - atomic density for each unique potential'
    Headers(2) = '                  nph+1 holds final state potential for absorber'
    CALL Write2D('apot.bin', rho, Headers = Headers, FileType = FileType)
    Headers(:) = ' '

    ! Write dmag.
    Headers(1) = 'dmag(r,nph+1) - ?'
    CALL Write2D('apot.bin', dmag, Headers = Headers, FileType = FileType)

    ! Write rhoval.
    Headers(1) = 'rhoval(r,nph+1) - atomic valence density for each unique potential.'
    CALL Write2D('apot.bin', rhoval, Headers = Headers, FileType = FileType)

    ! Write vcoul.
    Headers(1) = 'vcoul(r,nph) - coulomb potential for each unique potential.'
    CALL Write2D('apot.bin', vcoul, Headers = Headers, FileType = FileType)

    ! Write xnvmu.
    Headers(1) = 'xnvmu(0:lx,0:nphx+1) - number of val. el, w/in norman sphere for each channel'
    CALL Write2D('apot.bin', xnvmu, Headers = Headers, FileType = FileType)

    ! Write xnval.
    Headers(1) = 'xnval(30,nph) - occupation of each orbital.'
    CALL Write2D('apot.bin', xnval, Headers = Headers, FileType = FileType)

    ! Write eorb.
    Headers(1) = 'eorb(norb,iph)'
    CALL Write2D('apot.bin', eorb, Headers = Headers, FileType = FileType)

    ! Write rat.
    Headers(1) = 'rat(3,nat) - cartesian coordinates for each atom.'
    CALL Write2D('apot.bin', rat, Headers = Headers, FileType = FileType)

    ! Write rovr
    Headers(1) = 'rovr(novrx,0:nphx) - r for overlap shell'
    CALL Write2D('apot.bin', rovr, Headers = Headers, FileType = FileType)

    ! Write edens.
    Headers(1) = 'edens(r,0:nphx) - overlapped density for each unique potential.'
    CALL Write2D('apot.bin', edens, Headers = Headers, FileType = FileType)

    ! Write edenvl
    Headers(1) = 'edenvl(r,0:nphx) - overlapped density of valence electrons?'
    CALL Write2D('apot.bin', edenvl, Headers = Headers, FileType = FileType)


    ! Write vclap.
    Headers(1) = 'vclap(r,0:nphx) - overlapped coulomb potential.'
    CALL Write2D('apot.bin', vclap, Headers = Headers, FileType = FileType)

    ! Write kappa.
    Headers(1) = 'kappa(norb,0:nph) - quntum number kappa for each orbital and potential.'
    CALL Write2D('apot.bin', kappa, Headers = Headers, FileType = FileType)

    ! Write iorb.
    Headers(1) = 'iorb(-4:3,0:nphx+1) - last occupied orbital of a particular kappa or 0 if none.'
    CALL Write2D('apot.bin', iorb, Headers = Headers, FileType = FileType)

    ! Write dgc.
    Headers(1) = 'dgc(r,30,nph) - upper component of each obital for each unique potential.'
    CALL WriteData('apot.bin',Headers = Headers)
    DO iph = 1, SIZE(dgc,3)
       IF(iph.eq.1) THEN
          Headers(1) = 'dgc(r,30,nph) - upper component of each obital for each unique potential.'
          Headers(2) = 'dgc(r,norb,' // ACHAR(iph+48) // ')'
       ELSEIF(iph.lt.10) THEN
          Headers(1) = 'dgc(r,norb,' // ACHAR(iph+48) // ')'
       ELSEIF(iph.lt.100) THEN
          Headers(1) = 'dgc(r,norb,' // ACHAR((iph/10)+48) // ACHAR(mod(iph,10)+48) // ')'
       ELSE
          stop 'ERROR iph too large in WriteAtomicPots'
       END IF
       CALL Write2D('apot.bin', dgc(:,:,iph), Headers = Headers, FileType = FileType)
    END DO

    ! Write dpc.
    Headers(1) = 'dpc(r,30,nph) - lower component of each obital and unique potential.'
    CALL WriteData('apot.bin',Headers = Headers)
    DO iph = 1, SIZE(dpc,3)
       IF(iph.eq.1) THEN
          Headers(1) = 'dpc(r,30,nph) - lower component of each obital and unique potential.'
          Headers(2) = 'dpc(r,norb,' // ACHAR(iph+48) // ')'
       ELSEIF(iph.lt.10) THEN
          Headers(1) = 'dpc(r,norb,' // ACHAR(iph+48) // ')'
       ELSEIF(iph.lt.100) THEN
          Headers(1) = 'dpc(r,norb,' // ACHAR((iph/10)+48) // ACHAR(mod(iph,10)+48) // ')'
       ELSE
          stop 'ERROR iph too large in WriteAtomicPots'
       END IF
       CALL Write2D('apot.bin', dpc(:,:,iph), Headers = Headers, FileType = FileType)
    END DO

    ! Write adgc.
    DO iph = 1, SIZE(adgc,3)
       IF(iph.eq.1) THEN
          Headers(1) = 'adgc(r,30,nph) - upper devel. coeficients for each obital and unique potential.'
          WRITE(Headers(2),'(A,I10,A)') 'adgc(r,norb,', iph, ')'
       ELSE
          WRITE(Headers(1),'(A,I10,A)') 'adgc(r,norb,', iph, ')'
       END IF
       CALL Write2D('apot.bin', adgc(:,:,iph), Headers = Headers, FileType = FileType)
    END DO

    ! Write adpc.
    Headers(1) = 'adpc(r,30,nph) - lower devel. coeficients for each obital and unique potential.'
    CALL WriteData('apot.bin',Headers = Headers)
    DO iph = 1, SIZE(adpc,3)
       IF(iph.eq.1) THEN
          Headers(1) = 'adpc(r,30,nph) - lower devel. coeficients for each obital and unique potential.'
          WRITE(Headers(2),'(A,I10,A)') 'adpc(r,norb,', iph, ')'
       ELSE
          WRITE(Headers(1),'(A,I10,A)') 'adpc(r,norb,', iph, ')'
       END IF
       CALL Write2D('apot.bin', adpc(:,:,iph), Headers = Headers, FileType = FileType)
    END DO

    ! Close the file so that we can read it later.
    CALL CloseFl('apot.bin')
  END SUBROUTINE WriteAtomicPots


  SUBROUTINE ReadAtomicPots(nph, rnrm)
    INTEGER nph
    INTEGER imt(0:nphx), rmt(0:nphx), inrm(0:nphx)
    REAL(8) folp(0:nphx), folpx(0:nphx), dgc0(251), dpc0(251)
    REAL(8) dgc(251, 30, 0:nphx), dpc(251, 30, 0:nphx)
    REAL(8) adgc(10, 30, 0:nphx), adpc(10, 30, 0:nphx)
    REAL(8) edens(251, 0:nphx), vclap(251, 0:nphx)
    REAL(8) vtot(251, 0:nphx), edenvl(251, 0:nphx)
    REAL(8) vvalgs(251, 0:nphx), dmag(251, 0:nphx)
    REAL(8) xnval(30,0:nphx), qnrm(0:nphx), xnmues(0:lx,0:nphx)
    REAL(8) eorb(30), kappa(30), rnrm(0:nphx)
    INTEGER iorb(-4:3,0:nphx), iz(0:nphx), xion(0:nphx), iafolp, ihole, &
         &        inters, iunf, jumprm, nohole, ntitle
    REAL(8) xnatph(0:nphx), ecv, emu, erelax, qtotel, rhoint, rnrmav,   &
         &        rs, s02, totvol, vint, wp, xf, xmu

    character*80 title(nheadx)

    CALL rdpot ( ntitle, title, rnrmav, xmu, vint, rhoint, &
         emu, s02, erelax, wp, ecv,rs,xf, qtotel,          &
         imt, rmt, inrm, rnrm, folp, folpx, xnatph,        &
         dgc0, dpc0, dgc, dpc, adgc, adpc,                 &
         edens, vclap, vtot, edenvl, vvalgs, dmag, xnval,  &
         eorb, kappa, iorb, qnrm, xnmues, nohole, ihole,   &
         inters, totvol, iafolp, xion, iunf, iz, jumprm)
  END SUBROUTINE ReadAtomicPots

  ! Hack for Fer's mt potentials
  SUBROUTINE WriteExternalPot(vtot, vint, edens, rhoint, rat, xmu, imt, rmt)
    DOUBLE PRECISION vtot(:,:), vint, edens(:,:), rhoint, rat(:,:), xmu, rmt(:), RadialGrid(251), xNElOut
    DOUBLE PRECISION,ALLOCATABLE :: ratTranspose(:,:)
    INTEGER nat, NRPts, i1, i2, imt(:), ncoord
    INTEGER,ALLOCATABLE :: iat(:)
    CHARACTER(30) FileName

    ncoord = 3
    FileName = 'extpot.aip'
    nat = 2
    ! Read number of atoms
    CALL WriteData(FileName, Int1 = nat, ForceNewSection = .TRUE.)

    ! Read atomic numbers
    ALLOCATE(iat(nat))
    iat(1) = 6
    iat(2) = 8
    CALL WriteArrayData(FileName, Int1 = iat, ForceNewSection = .TRUE.)

    ! Read coordinates
    ALLOCATE(ratTranspose(nat,3))
    DO i1 = 1, nat
       DO i2 = 1, 3
          ratTranspose(i1,i2) = rat(i2, i1)
       END DO
    END DO
    CALL Write2D(FileName, ratTranspose)

    ! Read number of radial points
    NRPts = 210
    CALL WriteData(FileName, Int1 = NRPts, ForceNewSection = .TRUE.)

    ! Read Interstitial potential
    CALL WriteData(FileName, Double1 = vint, ForceNewSection = .TRUE.)

    ! Read Fermi energy
    CALL WriteData(FileName, Double1 = xmu, ForceNewSection = .TRUE.)

    ! Read number of electrons outside muffin tins.
    xNElOut = 1
    CALL WriteData(FileName, Double1 = xNElOut, ForceNewSection = .TRUE.)

    ! Read muffin tin radii and jri.
    CALL WriteArrayData(FileName, Int1 = imt, Double2 = rmt, ForceNewSection = .TRUE.)

    ! Read radial grid, vtot, and edens
    DO i1 = 1, nat
       DO i2 = 1, NRPts
          CALL WriteData(FileName, Double1 = RadialGrid(i2), Double2 = vtot(i2,i1), Double3 = edens(i2,i1))
       END DO
    END DO

    CALL CloseFl(FileName)
  END SUBROUTINE WriteExternalPot


  ! Hack for Fer's mt potentials
  SUBROUTINE ReadExternalPot(vtot, vint, edens, rhoint, rat, xmu, imt, rmt)
    USE Mtdp
    USE IOFiles

    DOUBLE PRECISION vtot(:,:), vint, edens(:,:), rhoint, rat(:,:), xmu, rmt(:) ! , RadialGrid(251), vTmp , xNElOut
    DOUBLE PRECISION :: rmt2(SIZE(rmt)), vtot2(SIZE(vtot,1),SIZE(vtot,2)), edens2(SIZE(edens,1),SIZE(edens,2)) 
    INTEGER nat, NRPts, i1, i2, imt(:), ncoord, iSort(200), iunit ! , iError
    INTEGER :: imt2(SIZE(imt)) ! , iz(SIZE(imt))
    CHARACTER(30) PotFile, SortFile, mtdpFile
    TYPE(Mtdp_Data_Type) :: Mtdp_Data
    ncoord = 3
    PotFile  = 'extpot.aip'
    SortFile = 'sort.aip'
    mtdpFile = 'GeCl4.04.dft.mtdp'

    ! Read mtdp file.
    CALL OpenFl(mtdpFile,FileStatus='OLD',FileAction='READ')
    CALL GetIOFileInfo(mtdpFile, UnitNumber = iunit)
    CALL Read_Mtdp(iunit,Mtdp_Data)

    ! Number of points in the radial grid
    NRPts = Mtdp_Data%nR

    ! Number of atoms
    nat = Mtdp_Data%nAt

    ! For now atomic numbers are not needed.

    ! Atomic coordinates - ignore for now
    !      rat(:,:) = Mtdp_Data%At_XYZ

    ! Muffin-Tin Radii
    rmt2(:nat) = Mtdp_Data%At_R(:)

    ! Index of the radii on the radial grid
    imt2(:nat) = Mtdp_Data%At_iR(:)

    ! Electron density inside each Muffin-Tin
    edens2(:,:nat) = Mtdp_Data%At_Den(:,:)

    ! Potential (H+XC) inside each Muffin-Tin
    vtot2(:,:nat) = Mtdp_Data%At_Pot(:,:)

    ! Empty spheres

    ! muffin tin radii
    rmt2(nat+1:Mtdp_Data%nESph+nat) = Mtdp_Data%ESph_R(:)

    ! muffin tin index
    imt2(nat+1:Mtdp_Data%nESph+nat) = Mtdp_Data%ESph_iR(:)

    ! Electron density inside each empty sphere
    edens2(:,nat+1:Mtdp_Data%nESph+nat) = Mtdp_Data%ESph_Den(:,:)

    ! Potential (H+XC) inside each empty sphere
    vtot2(:,nat+1:Mtdp_Data%nESph+nat) = Mtdp_Data%ESph_Pot(:,:)

    PRINT*, 'Old vint = ', vint
    ! Interstitial potential
    vint = Mtdp_Data%V_Int
    PRINT*, 'Enter vint: '
    READ*, vint    

    ! HOMO energy
    xmu = (Mtdp_Data%V_HOMO + Mtdp_Data%V_LUMO)/2.d0
    !      xmu = Mtdp_Data%V_HOMO
    nat = nat + Mtdp_Data%nESph
    ! Read isort out of sort.aip. This tells which potentials go with which atoms in feff.
    iSort(:) = -1
    ! PRINT*, 'Reading iSort'
    CALL ReadArrayData(SortFile, Int1 = iSort)
    ! iSort(i1) is the unique potential given the i1th potential defined in the extpot.aip file.
    ! iSort can be zero, but arrays here are defined from 1, so we need to shift.
    DO i1 = 1, SIZE(iSort)
       iSort(i1) = iSort(i1) + 1
    END DO

    ! Fill vtot, edens, rmt, and imt with the proper values based on iSort
    DO i1 = 1, SIZE(iSort)
       IF(iSort(i1).gt.0) THEN
          ! Fill rmt and imt
          IF(iSort(i1).gt.nat) CALL Error('ERROR: Number of potentials defined '// &
               & 'in sort.aip is greater than number defined in extpot.aip.')
          rmt(iSort(i1)) = rmt2(i1)
          imt(iSort(i1)) = imt2(i1)

          ! Fill vtot and edens
          DO i2 = 1, NRPts
             vtot(i2,iSort(i1)) = vtot2(i2,i1)
             edens(i2,iSort(i1)) = edens2(i2,i1)
          END DO
       END IF
    END DO

    ! If vint is too close to zero, reset it.
    !      IF(vint.gt.-0.1d0) vint = -0.1d0
    DO i1 = 1, nat
       DO i2 = NRPts + 1, 251
          vtot(i2,i1) = vint
          edens(i2,i1) = rhoint
       END DO
    END DO

    !      DO i1 = 1, 251
    !         vtot(i2,nat+1) = vtot(NRPts,1)
    !         edens(i2,nat+1) = edens(NRPts,1)
    !      END DO

    CALL CloseFl(SortFile)
    CALL CloseFl(mtdpFile)
    ! PRINT*, 'Done reading external potential.'
  END SUBROUTINE ReadExternalPot

  !     SUBROUTINE SplitMtDP(PotFiles,mtdpFile)
  !       USE Mtdp
  !       USE IOFiles
  !       ! This subroutine reads an mtdp file and splits it into nph pot files.
  !       ! Input is the array of potential file names.
  !       CHARACTER PotFiles(:)

  !       INTEGER iunit, iat
  !       CHARACTER AtomLabel

  !       CALL OpenFl(mtdpFile)
  !       CALL GetIOFileInfo(UnitNumber = iunit)
  !       CALL Read_Mtdp(iunit,Mtdp_Data)

  !       DO iat = 1, Mtdp_Data%nAt
  !          ! Number of points in the radial grid
  !          Mtdp_Data%nR

  !          CALL WriteData



  SUBROUTINE ReadExternalPotWien2k   ! (vtot, vint, edens, rhoint, rat, xmu, imt, rmt)

  END SUBROUTINE ReadExternalPotWien2k



END MODULE AtomicPotIO

c     Josh - argument iPl has been added to arguments of xsect
      subroutine phase (iph, dx, x0, ri, ne, ne1, ne3, em,
     1                  ixc, nsp, lreal, rmt,rnrm, xmu,
     2                  iPl,
     2                  vtot, vvalgs, edens, dmag, edenvl,
     3                  dgcn, dpcn, adgc, adpc, eref, ph, lmax,
     2                  iz, ihole, xion, iunf, xnval, ispin)
c     2                  vi0, iPl, gamach,

      implicit double precision (a-h, o-z)

c     INPUT
c     iph          unique pot index (used for messages only)
c     dx, x0, ri(nr)
c                  Loucks r-grid, ri=exp((i-1)*dx-x0)
c     ne, em(ne)   number of energy points, real energy grid
c     ixc        0  Hedin-Lunqist + const real & imag part
c                  1  Dirac-Hara + const real & imag part
c                  2  ground state + const real & imag part
c                  3  Dirac-Hara + HL imag part + const real & imag part
c                  4, 5, 6, see rdinp or xcpot
c     lreal        1 for real self energy and 2 for real phase shifts 
c     rmt          r muffin tin
c     xmu          fermi level
c     vi0          const imag part to add to complex potential
c     gamach       core hole lifetime
c     vtot(nr)     total potential, including gsxc
c     vvalgs(nr)   overlap Coulomb+gsxc potential for valence electrons
c     edens(nr)    density
c     dmag(nr)     density magnetization
c     edenvl(nr)  valence charge density
c     dgcn(dpcn)   large (small) dirac components for 'iph' atom
c     adgc(adpc)   their development coefficients
c
c     OUTPUT
c     eref(ne)     complex energy reference including energy dep xc
c     ph(nex,ltot+1) complex scattering phase shifts
c     lmax         max l (lmax = kmax*rmt)

      include '../HEADERS/dim.h'
      include '../HEADERS/const.h'

      complex*16 em(nex)
      dimension  ri(nrptx), vtot(nrptx), edens(nrptx)
      dimension  dmag(nrptx), vvalgs(nrptx), edenvl(nrptx)
      dimension  adgc(10,30), adpc(10,30), xnval(30)
      dimension  dgcn(nrptx,30), dpcn(nrptx,30)
      complex*16  eref(nex)
      complex*16  ph(nex,-ltot:ltot)
      integer ispin

c     work space for xcpot
      dimension   vxcrmu(nrptx), vxcimu(nrptx), gsrel(nrptx)
      dimension   vvxcrm(nrptx), vvxcim(nrptx)
c     p and q were needed in xsect to calc. matrix elements.
      complex*16 p(nrptx), q(nrptx)

      complex*16  p2, ck, xkmt, temp, pu, qu
      complex*16 jl(ltot+2), nl(ltot+2)
c      complex*16 xkmtp, nlp(ltot+2), jlp(ltot+2)

      complex*16 v(nrptx), vval(nrptx)
      character*512 slog
c     Josh - Added iPl switch for PLASMON card
c          - and WpCorr = Wi/Wp, Gamma, AmpFac
c          - to describe Im[eps^-1]
      integer iPl, ipole
      double precision WpCorr(MxPole), Gamma(MxPole), AmpFac(MxPole),
     &     rnrm
c     Josh END

c{#mn: g77 (and other compilers) have an intrinsic function besjn, 
c      so besjn should be declared  external 
         external besjn
c#mn}

      do 5 i=1,MxPole
         WpCorr(1) = -1.d30
 5    continue


      clz = 0.d0

c     zero phase shifts (some may not be set below)
      xkmax = 0
      ne12 = ne - ne3
      do 100  ie = 1, ne
         do 90  il = -ltot, ltot
            ph(ie,il) = 0
   90    continue
         if (ie.le.ne12 .and. xkmax.lt.dble(em(ie))) xkmax= dble(em(ie))
  100 continue
      xkmax = sqrt(xkmax * 2)

c     Use kmax to find accurate l-points
c     limit l, lmax = prefac* kmax * rmt
c     prefac is set not to have warning message for Cu metal for kmax=20
      prefac = 0.7d0
      lmax = int(prefac * rmt * xkmax)
      lmax = max(lmax, 5)
      if (lmax.gt.ltot) then
        ik = nint( ltot / rmt / bohr / prefac )
        write (slog, 110) ik
  110   format('      Phase shift calculation is accurate to k=', i2)
        call wlog(slog)
        write (slog, 120)
  120   format('      See FEFF document to increase the range.')
        call wlog(slog)
      endif
      lmax = min (lmax, ltot)
c     set imt and jri (use general Loucks grid)
c     rmt is between imt and jri (see function ii(r) in file xx.f)
      imt = int((log(rmt) + x0) / dx)  +  1
      jri = imt+1
      jri1 = jri+1
      if (jri1 .gt. nrptx)  call par_stop('jri .gt. nrptx in phase')

      ifirst = 0
      index = ixc
c     Josh - if PLASMON card is set, and using HL exc,
c          - read pole information from epsinv.dat
      IF( (iPl.gt.0).and.(ixc.eq.0) ) THEN
         open(file='exc.dat', unit=47, status='old',iostat=ios)
         call chopen(ios,'exc.dat','ffmod2(phase)')
         DO ipole = 1, MxPole
            call rdcmt(47,'#*cC')
            read(47,*,END=125) WpCorr(ipole), Gamma(ipole),
     &           AmpFac(ipole)
            Gamma(ipole)  = Gamma(ipole)/hart
            WpCorr(ipole) = (WpCorr(ipole)/hart) /
     &           SQRT(3.d0/((3 / (4*pi*edens(jri+1))) ** third)**3)
         END DO
 125     CONTINUE
         WpCorr(ipole) = -1.d30
         CLOSE(47)
      END IF
c$$$      IF(ixc.eq.0) THEN
c$$$c     Write wp as calculated from density to sigma.dat
c$$$         open(file='mpse.dat', unit=45, status='replace', iostat=ios)
c$$$         call chopen(ios, 'sigma.dat', 'ffmod2(phase)')
c$$$         write(45,*) '# ', 'rs      wp(eV)'
c$$$         write(45,*) '# ', (3 / (4*pi*edens(jri+1))) ** third, 
c$$$     &        SQRT(3.d0/((3 / (4*pi*edens(jri+1))) ** third)**3)*hart
c$$$         write(45,*) '# mu (eV)'
c$$$         write(45,*) '# ', xmu
c$$$         write(45,'(a)') 
c$$$     &         '# E-EFermi (eV)   Re[Sigma(E)] (eV)   Im[Sigma(E)] (eV)'
c$$$     &       // '   Re[Z]   Im[Z]   Mag[Z]   Phase[Z]   Lambda(E) (/A)'
c$$$      END IF
c     Josh END
      
c     calculate phase shifts
      do 220 ie = 1, ne12

c        Josh - xcpot now has new arguments:
c             - iPl, WpCorr, Gamma, AmpFac         
         call xcpot (iph, ie, index, lreal, ifirst, jri,
     1               em(ie), xmu,
     2               vtot, vvalgs, edens, dmag, edenvl,
     3               eref(ie), v, vval, iPl, WpCorr, AmpFac,
     4               vxcrmu, vxcimu, gsrel, vvxcrm, vvxcim, rnrm)
c         call xcpot (iph, ie, index, lreal, ifirst, jri,
c     1               em(ie), xmu,
c     2               vtot, vvalgs, edens, dmag, edenvl,
c     3               eref(ie), v, vval, iPl, WpCorr, Gamma, AmpFac,
c     4               vxcrmu, vxcimu, gsrel, vvxcrm, vvxcim, rnrm)

         if (dble(em(ie)).lt.-10.d0 .or. dble(em(ie)) .gt.3.d2) goto 220
c        p2 is (complex momentum)**2 referenced to energy dep xc
c        notice that constant Im part (gamach/2+vi0) is cancelled,
c        since it is also present in v and vval.
         p2 = em(ie) - eref(ie) 
         if (lreal.gt.1 .and. ie.le.ne1) p2 = dble(p2)
         ck =  sqrt (2*p2+ (p2*alphfs)**2)
         xkmt = rmt * ck
         if (dble(p2).le.0.d0 .and. dimag(p2) .le.0.d0) goto 220

c{#mn  see note above about declaring besjn as external
c#mn}
         call besjn (xkmt, jl, nl)

         if (mod(ixc,10) .lt. 5) then
             ncycle = 0
         else
             ncycle = 3
         endif

         do 210  ll = -lmax, lmax
            il = abs(ll) +  1
c           nonlocal exchange is unstable for high il.
c           need to do integrals instead of diff. eq. fix later
c           use local xc for high il
            if (il*dx.gt.0.50) then
               ncycle=0
            endif

c  v should be V_N+V_COUL+V_XCtotal-V_mt, vval= V_N+V_COUL+V_XCVAL-V_mt
            ikap = ll - 1
            if ( ll.gt.0 ) ikap=ll
            ilp = il + 1
            if (ikap.gt.0) ilp = il - 1
            ic3 = 0

            if(nsp.eq.1 .and. ispin.eq.0) then
c              remove spin-orbit interaction
c              otherwise, get wrong results e.g. for Pt metal
               if (ll.ne.0) ic3 = 1
               ikap = -1 - abs(ll)
               ilp = il + 1
            endif

c_lz  add term (C L_z) (p.32 of Ankoudinov's thesis) 
c     currently just add constant potential only within mt radius
c     keep intersitial level the same
c OPC for U for jj coupling
c           if (ll.eq.3 .and. iph.eq.1) then
c              clz = -0.5d0 / hart
c              if (ispin.lt.0) clz = -clz
c              do 180 i = 1, jri
c                 v(i) = v(i) + clz
c                 vval(i) = vval(i) + clz
c180           continue
c           endif
c OPC for U for LS coupling
            if (abs(ll).eq.3 .and. iph.eq.1 .and. ispin.eq.1) then
               clz = -0.0d0 / hart
               if (ikap.lt.0) clz = -clz
               do 180 i = 1, jri
                  v(i) = v(i) + clz
                  vval(i) = vval(i) + clz
 180           continue
            endif

c           never use irr=0, only positive or negative
            irr = -1
            call dfovrg (ncycle, ikap, rmt, jri, jri, p2, dx,
     1               ri, v,vval, dgcn, dpcn, adgc, adpc,
     1               xnval, pu, qu, p, q,
     1               iz, ihole, xion, iunf, irr, ic3)

c        restore potential for clz=0
c OPC for U for jj coupling
c           if (ll.eq.3 .and. iph.eq.1) then
c OPC for U for LS coupling
            if (abs(ll).eq.3 .and. iph.eq.1 .and. ispin.eq.1) then
               do 190 i = 1, jri
                  v(i) = v(i) - clz
                  vval(i) = vval(i) - clz
 190           continue
            endif
            call phamp (rmt, pu, qu, ck, jl(il), nl(il),
     1                  jl(ilp), nl(ilp), ikap, ph(ie,ll), temp)

c           cut phaseshift calculation if they become too small
            if (abs(ph(ie,ll)) .lt. 1.0e-6 .and. ll.ge.4)  goto 220
c           new cut function introduced by Rivas
            if(abs(exp((0,2)*ph(ie,ll))-1.).lt.1.0e-5) ph(ie,ll)=0
            if (abs(ph(ie,ll)) .lt. 1.0e-5 .and. ll.ge.4)  goto 220

  210    continue
  220 continue
c     Josh - Close sigma.dat
      close(45)
c     Josh END

      do 230 ie = ne12+1, ne
  230 eref(ie) = eref(ne1)

      return
      end

      subroutine besjh (x, lbmax, jl, hl)

c-----------------------------------------------------------------------
c
c     purpose:  to calculate the spherical bessel functions jl and hl
c               for l = 0 to lbmax (no offset)
c
c     arguments:
c       x = argument of jl and nl
c       lbmax
c       jl = jl bessel function (abramowitz conventions)
c       hl = hl^+ bessel function (messiah conventions) for Im x >=0
c       hl = hl^- bessel function (messiah conventions) for Im x < 0
c       jl and hl must be dimensioned
c            complex*16 jl(0:lbmax), hl(0:lbmax),
c
c     notes:  jl and hl should be calculated at least to 10 place
c             accuracy for the range 0<x<100 according to spot
c             checks with tables
c
c     error messages written with PRINT statement.
c
c     first coded by r. c. albers on 14 dec 82
c
c     version 3
c
c     last modified: 27 jan 83 by r. c. albers
c     dimension of jl,nl changed from 31 to 26  (10 aug 89) j. rehr
c     modified again, siz, June 1992
c     rewritten for jl and hl by a.l. ankudinov feb 2000
c
c-----------------------------------------------------------------------

      implicit double precision (a-h, o-z)
      include '../HEADERS/dim.h'

      complex*16 x
      complex*16 jl(0:lbmax), nl(ltot+2)
      complex*16 hl(0:lbmax)
      complex*16 cjl(ltot+2), sjl(ltot+2)

      complex*16 xjl,xnl,asx,acx, epx
      complex*16 xi,xi2,xi3,xi4,xi5,xi6,xi7,xi8,xi9,xi10,xi11

      parameter (xcut = 1.d0, xcut1 = 7.51d0, xcut2 = 5.01d0)
      complex*16 coni
      parameter (coni=(0.d0, 1.d0))

      if (dble(x) .lt. 0)  stop 'Re(x) is .lt. zero in besjh'

      lmax = min(lbmax, ltot+1)
      lmaxp1 = lmax + 1

      if (dble(x) .lt. xcut .and. abs(dimag(x)) .lt. xcut)  then
c        case Re(x) < 1, just use series expansion
         do 10 ll = 0,lmax
            ifl = 0
            call bjnser (x,ll,xjl,xnl,ifl)
            jl(ll) = xjl
            hl(ll) = -xnl + coni*xjl
   10    continue

      elseif (dble(x) .lt. xcut1 .and. abs(dimag(x)) .lt. xcut1)  then

c        case 1 <= Re(x) < 7.5

         call bjnser (x,lmax,xjl,xnl,1)
         jl(lmax) = xjl

         call bjnser (x,lmax-1,xjl,xnl,1)
         jl(lmax-1) = xjl

         if (dble(x) .lt. xcut2 .and. abs(dimag(x)) .lt. xcut2)  then
c           Re(x) < 5
            call bjnser (x,0,xjl,xnl,2)
            nl(1) = xnl
            call bjnser (x,1,xjl,xnl,2)
            nl(2) = xnl
         else
c           Re(x) >= 5
            asx = sin(x)
            acx = cos(x)
            xi = 1 / x
            xi2 = xi**2
            nl(1) = -acx*xi
            nl(2) = -acx*xi2 - asx*xi
         endif

c        Use recursion relation 10.1.19 to get nl and jl
         do 50 lp1 = 3, lmaxp1
            l = lp1 - 2
            tlxp1 = 2*l + 1
            nl(lp1) = tlxp1 * nl(lp1-1) / x  -  nl(lp1-2)
   50    continue

         do 60 lxx = 3,lmaxp1
            lp1 = lmaxp1+1-lxx
            l = lp1-1
            tlxp3 = 2*l + 3
            jl(l) = tlxp3 * jl(l+1) / x  -  jl(l+2)
   60    continue

         do 65 il = 1, lmaxp1
            l = il - 1
            hl(l) = -nl(il) + coni*jl(l)
   65    continue

      else
c        case Re(x) > 7.5
c        Use AS 10.1.8 and 10.1.9, sjl=P, qjl=Q, note that AS formulae
c        use cos (z - n*pi/2), etc., so cos and sin terms get a bit
c        scrambled (mod 4) here, since n is integer.  These are hard-
c        coded into the terms below.
         xi = 1 / x
         xi2  = xi*xi
         xi3  = xi*xi2
         xi4  = xi*xi3
         xi5  = xi*xi4
         xi6  = xi*xi5
         xi7  = xi*xi6
         xi8  = xi*xi7
         xi9  = xi*xi8
         xi10 = xi*xi9
         xi11 = xi*xi10

         sjl(1) = xi
         sjl(2) = xi2
         sjl(3) = 3*xi3 - xi
         sjl(4) = 15*xi4 - 6*xi2
         sjl(5) = 105*xi5 - 45*xi3 + xi
         sjl(6) = 945*xi6 - 420*xi4 + 15*xi2
         sjl(7) = 10395*xi7 - 4725*xi5 + 210*xi3 - xi
         sjl(8) = 135135*xi8 - 62370*xi6 + 3150*xi4 - 28*xi2
         sjl(9) = 2027025*xi9 - 945945*xi7 + 51975*xi5
     1            - 630*xi3 + xi
         sjl(10) = 34459425*xi10 - 16216200*xi8 + 945945*xi6
     1            - 13860*xi4 + 45*xi2
         sjl(11) = 654729075*xi11 - 310134825*xi9 + 18918900*xi7
     1            - 315315*xi5 + 1485*xi3 - xi
         cjl(1) = 0
         cjl(2) = -xi
         cjl(3) = -3*xi2
         cjl(4) = -15*xi3 + xi
         cjl(5) = -105*xi4 + 10*xi2
         cjl(6) = -945*xi5 + 105*xi3 - xi
         cjl(7) = -10395*xi6 + 1260*xi4 - 21*xi2
         cjl(8) = -135135*xi7 + 17325*xi5 - 378*xi3 + xi
         cjl(9) = -2027025*xi8 + 270270*xi6 - 6930*xi4 + 36*xi2
         cjl(10) = -34459425*xi9 + 4729725*xi7 - 135135*xi5
     1             + 990*xi3 - xi
         cjl(11) = -654729075*xi10 + 91891800*xi8 - 2837835*xi6
     1             + 25740*xi4 - 55*xi2
         do 90 lp1 = 12,lmaxp1
            l = lp1-2
            tlxp1 = float(2*l+1)
            sjl(lp1) = tlxp1*xi*sjl(lp1-1)-sjl(lp1-2)
            cjl(lp1) = tlxp1*xi*cjl(lp1-1)-cjl(lp1-2)
   90    continue
         asx = sin(x)
         acx = cos(x)
         if (dimag(x).ge. 0.d0) then
           epx = exp(coni*x)
         else
           epx = exp(-coni*x)
         endif
         do 110 ll = 0,lmax
            lp1 = ll + 1
            jl(ll) = asx*sjl(lp1)+acx*cjl(lp1)
            if (dimag(x).ge. 0.d0) then
              hl(ll) = (sjl(lp1)+coni*cjl(lp1)) * epx
            else
              hl(ll) = (sjl(lp1)-coni*cjl(lp1)) * epx
            endif
  110    continue
      endif

      return
      end

      subroutine inth (dp,dq,dv,dr)
c
c integration by the 5-point method of adams for the large
c component dp and the small component dq at the point dr;
c dv being the potential at this point
c **********************************************************************
      implicit double precision (a-h,o-z)
      save
      common /ps1/ dep(5), deq(5), db, dvc, dsal, dk, dm
c
c dep,deq the derivatives of dp and dq; db=energy/dvc;
c dvc=speed of light in atomic units; dsal=2.*dvc; dk=kappa quantum numb
c dm=exponential step/720.
c dkoef1=405./502., dkoef2=27./502.
c **********************************************************************
      data dkoef1 /.9462151394422310/, dkoef2 /.5378486055776890d-1/
      dpr=dp+dm*((251.0*dep(1)+2616.0*dep(3)+1901.0*dep(5))-(1274.0
     1 *dep(2)+2774.0*dep(4)))
      dqr=dq+dm*((251.0*deq(1)+2616.0*deq(3)+1901.0*deq(5))-(1274.0
     1 *deq(2)+2774.0*deq(4)))
      do 10 i=2,5
      dep(i-1)=dep(i)
   10 deq(i-1)=deq(i)
      dsum=(db-dv/dvc)*dr
      dep(5)=-dk*dpr+(dsal*dr+dsum)*dqr
      deq(5)=dk*dqr-dsum*dpr
      dp=dp+dm*((106.0*dep(2)+646.0*dep(4)+251.0*dep(5))-(19.0*dep(1
     1 )+264.0*dep(3)))
      dq=dq+dm*((106.0*deq(2)+646.0*deq(4)+251.0*deq(5))-(19.0*deq(1
     1 )+264.0*deq(3)))
      dp=dkoef1*dp+dkoef2*dpr
      dq=dkoef1*dq+dkoef2*dqr
      dep(5)=-dk*dp+(dsal*dr+dsum)*dq
      deq(5)=dk*dq-dsum*dp
      return
      end

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Information about last revision of $RCSfile: m_iomod.f90,v $:
! $Revision: 1.11 $
! $Author: hebhop $
! $Date: 2010/02/23 23:52:06 $
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
MODULE IOMod
  USE ErrorMod
  USE IOFiles
  USE PADIO

  IMPLICIT NONE

  INTEGER,PRIVATE :: npadxDefault, npadrDefault, MaxStrLen, iFileTypeDefault
  PARAMETER(npadxDefault = 8, npadrDefault = 8, MaxStrLen = 80, iFileTypeDefault = 1)
  ! LOGICAL,PRIVATE,SAVE :: WriteDataDescription(100)
  CHARACTER(30),PRIVATE :: DefaultFileStatus, DefaultFilePosition, &
       & DefaultFileAction
  CHARACTER(10),PRIVATE :: DefaultCommentCharacters
  PARAMETER(DefaultFileStatus = 'UNKNOWN', DefaultFilePosition = 'REWIND')
  PARAMETER(DefaultFileAction = 'READWRITE', DefaultCommentCharacters = '#!cC')

  INTERFACE Write2D
     MODULE PROCEDURE WriteInt2D
     MODULE PROCEDURE WriteReal2D
     MODULE PROCEDURE WriteDouble2D
     MODULE PROCEDURE WriteComplex2D
     MODULE PROCEDURE WriteDComplex2D
     MODULE PROCEDURE WriteString2D
  END INTERFACE

  INTERFACE Read2D
     MODULE PROCEDURE ReadInt2D
     MODULE PROCEDURE ReadReal2D
     MODULE PROCEDURE ReadDouble2D
     MODULE PROCEDURE ReadComplex2D
     MODULE PROCEDURE ReadDComplex2D
     MODULE PROCEDURE ReadString2D
  END INTERFACE

CONTAINS

  ! OpenFl finds the first available unit and opens the file if it is not already open.
  ! In addition, a new IOFile is created and added to the FileStack. The FileStack holds 
  ! valuable information about the files that are open. See IOFiles.f90 for more info.
  ! If the file is already open, OpenFl does nothing.
  !
  ! FileName.
  ! FileName     - Name of file to open.
  ! FileStatus   - Optional: Can be any legal fortran 90 file status.
  !                Argument is passed directly to OPEN(iUnit, STATUS = FileStatus ...
  ! FilePosition - Optional: Can be any legal file position.
  !                Agument is passed directly to OPEN(iUnit, POSITION = FilePosition ...
  ! FileAction   - This can be 'READ', 'WRITE', or 'WREADWRITE'. Case insensitive.
  SUBROUTINE OpenFl(FileName, FileStatus, FilePosition, FileAction, ErrorMessage)
    CHARACTER*(*) FileName
    CHARACTER*(*),OPTIONAL :: FileStatus, FilePosition, FileAction, ErrorMessage(:)

    LOGICAL FileIsOpen
    INTEGER,SAVE :: iOpenUnit
    INTEGER IOError, iUnit
    LOGICAL :: UnitIsUsed, FileExists
    CHARACTER(300) messg, FStatus, FPosition, FAction

    FStatus   = DefaultFileStatus
    FPosition = DefaultFilePosition
    FAction   = DefaultFileAction

    IF(PRESENT(FileStatus)) FStatus = FileStatus
    IF(PRESENT(FilePosition)) FPosition = FilePosition
    IF(PRESENT(FileAction)) FAction = FileAction

    ! Is file already open?
    INQUIRE(FILE=FileName,OPENED=FileIsOpen,EXIST=FileExists)
    IF(FileIsOpen) THEN
       ! This file is already open. Do nothing.
       RETURN
    ELSE
       ! File was not open. Find first available unit.
       DO iOpenUnit = 5, 100
          INQUIRE(UNIT=iOpenUnit,OPENED=UnitIsUsed)
          IF(.not.UnitIsUsed) THEN
             iUnit = iOpenUnit
             EXIT
          END IF
       END DO

       ! Open file.
       OPEN(UNIT=iUnit,FILE=FileName,STATUS=FStatus,POSITION=FPosition,ACTION=FAction,IOSTAT=IOError)
       IF(IOError.ne.0) THEN
          ! OPEN passed back an error
          CALL Error('Error opening file: ' // FileName, StopProgram = .FALSE.)
          IF(PRESENT(ErrorMessage)) CALL Error(ErrorMessage, StopProgram = .FALSE.)
          WRITE(messg,'(A,i4)') 'OPEN returned error number ', IOError
          CALL Error(messg)
       END IF

       ! Create new IOFile
       CALL AddIOFile(FileName)

       ! Set file options 
       CALL SetIOFileInfo(FileName,ExistedOnOpen = FileExists, UnitNumber = iUnit,IsOpen = .TRUE., &
            & FileAction = FAction)
    END IF
  END SUBROUTINE OpenFl

  ! Subroutine CloseFl closes the file associated with FileName, and deletes the IOFile
  ! from the filestack. If FileName = 'ALL' (case insensitive), all open files are closed
  ! and deleted from the filestack.
  SUBROUTINE CloseFl(FileName)
    CHARACTER*(*),INTENT(IN) :: FileName
    CHARACTER(10) TmpStr ! , FileAction
    INTEGER iUnit, iUnits(100), NFiles, i1

    TmpStr = TRIM(ADJUSTL(FileName))
    CALL Upper(TmpStr)

    IF(TmpStr.ne.'ALL') THEN
       CALL GetIOFileInfo(FileName,UnitNumber = iUnit)
       CLOSE(iUnit)
       CALL DeleteIOFile(FileName)
    ELSE
       CALL GetFileStackInfo(NFiles, UnitNumbers = iUnits)
       DO i1 = 1, NFiles
          CLOSE(iUnits(i1))
       END DO
       CALL DeleteIOFile(FileName)
    END IF
  END SUBROUTINE CloseFl


  ! Subroutine WriteData writes scalar data to the file filename.
  ! Up to 10 pieces of data can be written each specified by using
  ! the optional arguments Int1 - Int10, Real1 - Real10, etc.  
  ! Thus you can write all integer data, all real data, etc. or a mixture 
  ! of various types. The column that each data piece goes in is set by
  ! specifying the number of each type, for example, a call to write a
  ! real number followed by an integer is as follows:
  !
  ! CALL WriteData(FileName, Real1 = RealVar, Int2 = IntVar) 
  !
  ! To write a complex variable followed by a string variable then a real 
  ! variable,
  !
  ! CALL WriteData(FileName, Complex1 = ComplexVar, String2 = StringVar, Real3 = RealVar)
  !
  ! Assigning two variables to the same column will produce an error, i.e.
  !
  ! CALL WriteData(FileName, Complex1 = ComplexVar, Int1 = IntVar)
  !
  ! will produce an error since we are trying to write two variables to the first column.
  !
  ! WriteData will also write a section liine (beginning with #SN#) and a data type line
  ! (beginning with #DT#). New sections are started when the types or number of the data 
  ! arguments are changed, or the optional ForceNewSection argument is set to true.
  ! In addition, the user can specify an array of headers to be written above the data,
  ! as well as an array of column labels to describe the data. 
  !
  ! Arguments
  ! FileName - Name of file to write to. Note that if the file is already open for reading,
  !            you will get an error. Note that this is the only non-optional argument.
  !
  ! The following arguments give the data to be written to the file. Note that all of 
  ! these arguments are optional.
  ! Int1, Real1, ... String1    - Argument to go in the first column.
  ! Int2, Real2, ... String2    - Argument to go in the second column.
  ! .
  ! .
  ! .
  ! Int10, Real10, ... String10 - Argument to go in the tenth column.
  !
  ! Headers - Optional: Array of headers to be written out above the data. Note that
  !           this argument can be given without any data, and the headers will be written
  !           alone. Also, headers will only be written at the beginning of a section, so
  !           that the user can set headers and use WriteData in a loop, and the headers
  !           will only be written in the first call inside the loop.
  !
  ! ColumnLabels - Optional: Array of strings to describe the data being passed to 
  !                WriteData. These will be written directly above the data in a formatted
  !                manner. Note that column labels will not extend past the length of the 
  !                data in a particular column. Thus the length of each column label is 
  !                restricted by the formats which are used to write that data. The default 
  !                formats can be found in IOFiles.f90, and may be set for a particular 
  !                file by using the SetIOFileInfo subroutine.
  !
  ! WriteDataInHeader - When set to .TRUE. data will be written with #HD# inserted at the 
  !                     beginning of the line. This is usefull for files which contain
  !                     various information, including scalar information (which would be
  !                     written in the header) as well a set of arrays written in columns
  !                     which the user would like to be able to plot.
  !
  ! ForceNewSection - In the case where two sets of data have the same types. The user may
  !                   force a new section so that the section line, data type line,any 
  !                   headers, and the column labels will be written.
  SUBROUTINE WriteData(FileName,                                      &
       & Int1, Int2, Int3, Int4, Int5, Int6, Int7, Int8, Int9, Int10, &
       & Real1, Real2, Real3, Real4, Real5, Real6, Real7, Real8,      &
       & Real9, Real10,                                               &
       & Double1, Double2, Double3, Double4, Double5, Double6,        &
       & Double7, Double8, Double9, Double10,                         &
       & Complex1, Complex2, Complex3, Complex4, Complex5, Complex6,  &
       & Complex7, Complex8, Complex9, Complex10,                     &
       & DComplex1, DComplex2, DComplex3, DComplex4, DComplex5,       &
       & DComplex6, DComplex7, DComplex8, DComplex9, DComplex10,      &
       & String1, String2, String3, String4, String5, String6,        &
       & String7, String8, String9, String10,                         &
       & Headers, ColumnLabels, WriteDataInHeader, ForceNewSection,   &
       & FileType)
    ! Passed variables
    CHARACTER*(*), INTENT(IN) :: FileName
    INTEGER, INTENT(IN), OPTIONAL :: Int1, Int2, Int3, Int4, Int5,    &
         & Int6, Int7, Int8, Int9, Int10
    REAL, INTENT(IN), OPTIONAL :: Real1, Real2, Real3, Real4, Real5,  &
         & Real6, Real7, Real8, Real9, Real10
    DOUBLE PRECISION, INTENT(IN), OPTIONAL :: Double1, Double2,       &
         & Double3, Double4, Double5, Double6, Double7, Double8,      &
         & Double9, Double10
    COMPLEX, INTENT(IN), OPTIONAL :: Complex1, Complex2, Complex3,    &
         & Complex4, Complex5,                                        &
         & Complex6, Complex7, Complex8, Complex9, Complex10
    COMPLEX*16, INTENT(IN), OPTIONAL :: DComplex1, DComplex2,         &
         & DComplex3, DComplex4, DComplex5, DComplex6, DComplex7,     &
         & DComplex8, DComplex9, DComplex10
    CHARACTER*(*), INTENT(IN), OPTIONAL :: String1, String2, String3, &
         & String4, String5, String6, String7, String8, String9,      &
         & String10

    CHARACTER*(*),INTENT(IN),OPTIONAL :: Headers(:), ColumnLabels(:), &
         & FileType
    LOGICAL,INTENT(IN),OPTIONAL :: WriteDataInHeader, ForceNewSection

    ! Local variables
    ! NumArgs - Number of data arguments passed
    ! iUnit   - unit number associated with FileName
    ! NColumnLabels - will hold the size of the ColumnLabels array.
    INTEGER NumArgs, iUnit, NColumnLabels

    ! IsPresent  - If IsPresent(i) is true then the ith argument has already been defined.
    ! HeaderData - If true, write data in header format (beginning with #HD#).
    ! txt, pad  - These are here in anticipation of enabling various formats for output,
    !              including text, paded ascii to start, and possibly further formats 
    !              such as xml.
    ! NewSection - If true, force a new section.
    ! FlType     - 
    LOGICAL IsPresent(10), HeaderData, txt, pad, NewSection
    ! DataArray - Array of strings to hold the data. Data is first written to DataArray,
    !             then DataArray(1:NumArgs) is written to the file.
    CHARACTER(MaxStrLen) DataArray(10)
    ! DataTypeLine - The data type line lists the types of data that have been specified
    !                by the user to be written to file. This line will be written above
    !                the data, and above any column label line if present. The line 
    !                begins with #DT#
    CHARACTER(120) DataTypeLine
    ! IntFormat, RealFormat, ... StringFormat - These hold the format strings which will
    !                                           be used to write the data to the 
    !                                           character array DataArray and eventually
    !                                           to the file.
    !
    ! FileAction - String variable that holds the action associated with the IOFile
    !              specified by FileName.
    CHARACTER(20) IntFormat, RealFormat, DoubleFormat, ComplexFormat, &
         & DComplexFormat, StringFormat, FileAction
    ! ColumnLabelFormat - This will be used to hold the format string to write the
    !                     column labels if any.
    CHARACTER(80) ColumnLabelFormat
    ! CLFormats - This holds the separate formats for each column label. They will be
    !             combined to create ColumnLabelFormat
    CHARACTER(10) CLFormats(20)
    ! TmpStr - used when creating column label formats.
    CHARACTER(4) TmpStr, FlType

    ! NSection - number of the current section.
    INTEGER NSections

    ! Loop variables
    INTEGER i1

    ! Initialization
    HeaderData    = .FALSE.
    IsPresent(:)  = .FALSE.
    NumArgs       = 0
    txt           = .TRUE.
    pad           = .FALSE.
    DataTypeLine  = ''
    FlType = 'TXT'

    ! Set the type of file. Default is txt.
    IF(PRESENT(FileType)) THEN
       FlType = TRIM(ADJUSTL(FileType))
       CALL Upper(FlType)
       IF(TRIM(FlType).eq.'TXT') THEN
          txt = .TRUE.
          pad = .FALSE.
       ELSEIF(TRIM(FlType).eq.'PAD') THEN
          pad = .TRUE.
          txt = .FALSE.
       ELSE
          CALL Error('Error: Illegal file type passed to WriteData')
       END IF
    END IF

!KJ next section was commented out "!NS" but I activated it again 7-09
    IF(PRESENT(ForceNewSection)) THEN
       NewSection = ForceNewSection
    ELSE
       NewSection = .FALSE.
    END IF
!KJ

    IF(PRESENT(WriteDataInHeader)) HeaderData = WriteDataInHeader

    IF(PRESENT(ColumnLabels)) THEN
       NColumnLabels = 0
    ELSE
       NColumnLabels = -1
    END IF

    ! Open the file.
    CALL OpenFl(FileName, FileStatus = 'REPLACE', FileAction = 'WRITE')

    ! Get the formats for each data type.
    CALL GetIOFileInfo(FileName, IFormat = IntFormat, RFormat = RealFormat, &
         & DFormat = DoubleFormat, CFormat = ComplexFormat, &
         & DCFormat = DComplexFormat, SFormat = StringFormat, FileAction = FileAction)

    ! Check that this file was not already opened for READ.
    IF(TRIM(FileAction).eq.'READ') THEN 
       CALL Error('Error: file ' // FileName // &
            & ' was already opened for reading.', StopProgram = .FALSE.)
       CALL Error("Please use CALL CloseFl('" // FileName // "') before writing.")
    END IF
    
    ! The SetArgType(Arg,ColumnNumber) subroutines checks the presence of Arg. If Arg
    ! is present, the data is written to DataArray(ColumnNumber). Also, NumArgs is incremented,
    ! CLFormats(ColumnNumber) is set, and the data type is appended to DataTypeLine.
    ! In addition, various errors are checked.
    ! Find the 1st argument.
    IF(PRESENT(Int1)) CALL SetArgInt(Int1, 1)
    IF(PRESENT(Real1)) CALL SetArgReal(Real1, 1)
    IF(PRESENT(Double1)) CALL SetArgDouble(Double1, 1)
    IF(PRESENT(Complex1)) CALL SetArgComplex(Complex1, 1)
    IF(PRESENT(DComplex1)) CALL SetArgDComplex(DComplex1, 1)
    IF(PRESENT(String1)) CALL SetArgString(String1, 1)

    ! Find the 2nd argument.
    IF(PRESENT(Int2)) CALL SetArgInt(Int2, 2)
    IF(PRESENT(Real2)) CALL SetArgReal(Real2, 2)
    IF(PRESENT(Double2)) CALL SetArgDouble(Double2, 2)
    IF(PRESENT(Complex2)) CALL SetArgComplex(Complex2, 2)
    IF(PRESENT(DComplex2)) CALL SetArgDComplex(DComplex2, 2)
    IF(PRESENT(String2)) CALL SetArgString(String2, 2)

    ! Find the 3rd argument.
    IF(PRESENT(Int3)) CALL SetArgInt(Int3, 3)
    IF(PRESENT(Real3)) CALL SetArgReal(Real3, 3)
    IF(PRESENT(Double3)) CALL SetArgDouble(Double3, 3)
    IF(PRESENT(Complex3)) CALL SetArgComplex(Complex3, 3)
    IF(PRESENT(DComplex3)) CALL SetArgDComplex(DComplex3, 3)
    IF(PRESENT(String3)) CALL SetArgString(String3, 3)

    ! Find the 4th argument.
    IF(PRESENT(Int4)) CALL SetArgInt(Int4, 4)
    IF(PRESENT(Real4)) CALL SetArgReal(Real4, 4)
    IF(PRESENT(Double4)) CALL SetArgDouble(Double4, 4)
    IF(PRESENT(Complex4)) CALL SetArgComplex(Complex4, 4)
    IF(PRESENT(DComplex4)) CALL SetArgDComplex(DComplex4, 4)
    IF(PRESENT(String4)) CALL SetArgString(String4, 4)

    ! Find the 5th argument.
    IF(PRESENT(Int5)) CALL SetArgInt(Int5, 5)
    IF(PRESENT(Real5)) CALL SetArgReal(Real5, 5)
    IF(PRESENT(Double5)) CALL SetArgDouble(Double5, 5)
    IF(PRESENT(Complex5)) CALL SetArgComplex(Complex5, 5)
    IF(PRESENT(DComplex5)) CALL SetArgDComplex(DComplex5, 5)
    IF(PRESENT(String5)) CALL SetArgString(String5, 5)

    ! Find the 6th argument.
    IF(PRESENT(Int6)) CALL SetArgInt(Int6, 6)
    IF(PRESENT(Real6)) CALL SetArgReal(Real6, 6)
    IF(PRESENT(Double6)) CALL SetArgDouble(Double6, 6)
    IF(PRESENT(Complex6)) CALL SetArgComplex(Complex6, 6)
    IF(PRESENT(DComplex6)) CALL SetArgDComplex(DComplex6, 6)
    IF(PRESENT(String6)) CALL SetArgString(String6, 6)

    ! Find the 7th argument.
    IF(PRESENT(Int7)) CALL SetArgInt(Int7, 7)
    IF(PRESENT(Real7)) CALL SetArgReal(Real7, 7)
    IF(PRESENT(Double7)) CALL SetArgDouble(Double7, 7)
    IF(PRESENT(Complex7)) CALL SetArgComplex(Complex7, 7)
    IF(PRESENT(DComplex7)) CALL SetArgDComplex(DComplex7, 7)
    IF(PRESENT(String7)) CALL SetArgString(String7, 7)

    ! Find the 8th argument.
    IF(PRESENT(Int8)) CALL SetArgInt(Int8, 8)
    IF(PRESENT(Real8)) CALL SetArgReal(Real8, 8)
    IF(PRESENT(Double8)) CALL SetArgDouble(Double8, 8)
    IF(PRESENT(Complex8)) CALL SetArgComplex(Complex8, 8)
    IF(PRESENT(DComplex8)) CALL SetArgDComplex(DComplex8, 8)
    IF(PRESENT(String8)) CALL SetArgString(String8, 8)

    ! Find the 9th argument.
    IF(PRESENT(Int9)) CALL SetArgInt(Int9, 9)
    IF(PRESENT(Real9)) CALL SetArgReal(Real9, 9)
    IF(PRESENT(Double9)) CALL SetArgDouble(Double9, 9)
    IF(PRESENT(Complex9)) CALL SetArgComplex(Complex9, 9)
    IF(PRESENT(DComplex9)) CALL SetArgDComplex(DComplex9, 9)
    IF(PRESENT(String9)) CALL SetArgString(String9, 9)

    ! Find the 10th argument.
    IF(PRESENT(Int10)) CALL SetArgInt(Int10, 10)
    IF(PRESENT(Real10)) CALL SetArgReal(Real10, 10)
    IF(PRESENT(Double10)) CALL SetArgDouble(Double10, 10)
    IF(PRESENT(Complex10)) CALL SetArgComplex(Complex10, 10)
    IF(PRESENT(DComplex10)) CALL SetArgDComplex(DComplex10, 10)
    IF(PRESENT(String10)) CALL SetArgString(String10, 10)

    ! Get the unit number and section number.
    CALL GetIOFileInfo(FileName,UnitNumber = iUnit, NSections = NSections)

    ! If data type line is different that last, or user has forced a new section
    ! write a new section header and data type line. Also write any headers and
    ! column labels that have been specified.
    IF(WritingNewSection(FileName,DataTypeLine).or.NewSection) THEN

       NSections = NSections + 1

       WRITE(iUnit,'(A,I4)') '#SN#   Section: ', NSections
       WRITE(iUnit,'(A)') '#DF# This section written in ' // FlType // '.'
       WRITE(iUnit,'(A)') '#H#'

       ! Only write a data type line if it is not blank       
       IF(LEN_TRIM(DataTypeLine).ne.0) THEN
          WRITE(iUnit,'(A)') '#H# The following data types are written in this section.'
          WRITE(iUnit,'(2A)') '#DT# ', TRIM(DataTypeLine)
       END IF

       ! If headers are present, write them.
       IF(PRESENT(Headers)) THEN
          DO i1 = 1, SIZE(Headers)
             ! Write only non-blank, non-null headers.
             IF((LEN_TRIM(Headers(i1)).gt.0).and.(ICHAR(Headers(i1)).ne.0)) &
                  & WRITE(iUnit,'(2A)') '#H# ', TRIM(Headers(i1))
          END DO
       END IF

       ! If column labels are present, get the columnlable format and write them.
       IF(PRESENT(ColumnLabels)) THEN
          ColumnLabelFormat = '(A5, '
          DO i1 = 1, NColumnLabels - 1
             ColumnLabelFormat = TRIM(ColumnLabelFormat) // TRIM(CLFormats(i1)) // ', '
          END DO
          ColumnLabelFormat = TRIM(ColumnLabelFormat) // TRIM(CLFormats(NColumnLabels)) // ')'
          WRITE(iUnit,ColumnLabelFormat) '#CL# ', (TRIM(ColumnLabels(i1)) // ' ', i1 = 1, NColumnLabels)
       END IF

       ! Set the section number and data type line.
       CALL SetIOFileInfo(FileName, DataTypeLine = DataTypeLine, NSections = NSections)

    ELSEIF(PRESENT(Headers).and.(NumArgs.eq.0)) THEN
       ! If only headers are present, write the headers without changing the section number.
       DO i1 = 1, SIZE(Headers)
          ! Write only non-blank, non-null headers.
          IF((LEN_TRIM(Headers(i1)).gt.0).and.(ICHAR(Headers(i1)).ne.0)) &
               & WRITE(iUnit,'(2A)') '#H# ', TRIM(Headers(i1))
       END DO
       CALL SetIOFileInfo(FileName, DataTypeLine = DataTypeLine)
    END IF


    ! Write data line.
    IF(NumArgs.gt.0) THEN
       IF(HeaderData) THEN
          WRITE(iUnit, '(11A)') '#HD# ', (TRIM(DataArray(i1)) // ' ', i1 = 1, NumArgs)
       ELSE
          WRITE(iUnit, '(11A)') (TRIM(DataArray(i1)) // ' ', i1 = 1, NumArgs)
       END IF
    END IF
  CONTAINS

    ! The SetArgType(Arg,ColumnNumber) subroutines check the presence of Arg. If Arg
    ! is present, the data is written to DataArray(ColumnNumber). Also, NumArgs is incremented,
    ! CLFormats(ColumnNumber) is set, and the data type is appended to DataTypeLine.
    ! In addition, various errors are checked.

    SUBROUTINE SetArgInt(Arg, iArg)
      INTEGER,INTENT(IN) :: Arg
      INTEGER,INTENT(IN) :: iArg

      ! Check for errors, increment number of args,
      ! set numdata if this is the first argument, and write data to string
      ! array.
      CALL CheckForErrors(iArg,'Int')

      ! Write the data to the character array with the right format.
      ! For now fileformat is txt only.
      IF(txt) THEN
         WRITE(DataArray(iArg), IntFormat) Arg
      ELSEIF(pad) THEN
         CALL WritePAD(DataArray(iArg),Arg)
      END IF

      ! Set the columnlabel format string if ColumnLabels is passed.
      IF(PRESENT(ColumnLabels)) THEN
         IF(SIZE(ColumnLabels).gt.NColumnLabels) THEN
            NColumnLabels = NColumnLabels + 1
            IF((iArg.eq.1).and.txt) THEN
               WRITE(TmpStr,'(I3)') LEN_TRIM(DataArray(iArg)) - 4
            ELSE
               WRITE(TmpStr,'(I3)') LEN_TRIM(DataArray(iArg)) + 1
            END IF
            CLFormats(NColumnLabels) = 'A' // TRIM(ADJUSTL(TmpStr))
         END IF
      END IF

    END SUBROUTINE SetArgInt

    SUBROUTINE SetArgReal( Arg, iArg)
      REAL,INTENT(IN) :: Arg
      INTEGER,INTENT(IN) :: iArg
      REAL TmpArg(2)
      ! Check for errors, increment number of args,
      ! set numdata if this is the first argument, and write data to string
      ! array.
      CALL CheckForErrors(iArg,'Real')

      ! Write the data to the character array with the right format.
      ! For now fileformat is txt only.
      IF(txt) THEN
         WRITE(DataArray(iArg), RealFormat) Arg
      ELSEIF(pad) THEN
         TmpArg(1) = Arg
         CALL WritePAD(DataArray(iArg),npadrDefault,Arg)
      END IF

      ! Set the columnlabel format string
      IF(PRESENT(ColumnLabels)) THEN
         IF(SIZE(ColumnLabels).gt.NColumnLabels) THEN
            NColumnLabels = NColumnLabels + 1
            IF((iArg.eq.1).and.txt) THEN
               WRITE(TmpStr,'(I3)') LEN_TRIM(DataArray(iArg)) - 4
            ELSE
               WRITE(TmpStr,'(I3)') LEN_TRIM(DataArray(iArg)) + 1
            END IF
            CLFormats(NColumnLabels) = 'A' // TRIM(ADJUSTL(TmpStr))
         END IF
      END IF
    END SUBROUTINE SetArgReal

    SUBROUTINE SetArgDouble( Arg, iArg)
      DOUBLE PRECISION,INTENT(IN) :: Arg
      INTEGER,INTENT(IN) :: iArg
      ! Check for errors, increment number of args,
      ! set numdata if this is the first argument, and write data to string
      ! array.
      CALL CheckForErrors(iArg,'Double')

      ! Write the data to the character array with the right format.
      ! For now fileformat is txt only.
      IF(txt) THEN
         WRITE(DataArray(iArg), DoubleFormat) Arg
      ELSEIF(pad) THEN
         CALL WritePAD(DataArray(iArg),npadrDefault,Arg)
      END IF

      ! Set the columnlabel format string
      IF(PRESENT(ColumnLabels)) THEN
         IF(SIZE(ColumnLabels).gt.NColumnLabels) THEN
            NColumnLabels = NColumnLabels + 1
            IF((iArg.eq.1).and.txt) THEN
               WRITE(TmpStr,'(I3)') LEN_TRIM(DataArray(iArg)) - 4
            ELSE
               WRITE(TmpStr,'(I3)') LEN_TRIM(DataArray(iArg)) + 1
            END IF
            CLFormats(NColumnLabels) = 'A' // TRIM(ADJUSTL(TmpStr))
         END IF
      END IF
    END SUBROUTINE SetArgDouble

    SUBROUTINE SetArgComplex( Arg, iArg)
      COMPLEX,INTENT(IN) :: Arg
      INTEGER,INTENT(IN) :: iArg

      ! Check for errors, increment number of args,
      ! set numdata if this is the first argument, and write data to string
      ! array.
      CALL CheckForErrors(iArg,'Complex')

      ! Write the data to the character array with the right format.
      ! For now fileformat is txt only.
      IF(txt) THEN
         WRITE(DataArray(iArg), ComplexFormat) REAL(Arg), IMAG(Arg)
      ELSEIF(pad) THEN
         CALL WritePAD(DataArray(iArg),npadrDefault,Arg)
      END IF

      ! Set the columnlabel format string
      IF(PRESENT(ColumnLabels)) THEN
         IF(SIZE(ColumnLabels).gt.NColumnLabels+1) THEN
            NColumnLabels = NColumnLabels + 2
            IF((iArg.eq.1).and.txt) THEN
               WRITE(TmpStr,'(I3)') INT(LEN_TRIM(DataArray(iArg))/2) - 4
               CLFormats(NColumnLabels - 1) = 'A' // TRIM(ADJUSTL(TmpStr))
               WRITE(TmpStr,'(I3)') INT(LEN_TRIM(DataArray(iArg))/2) + 1
               CLFormats(NColumnLabels) = 'A' // TRIM(ADJUSTL(TmpStr))
            ELSE
               WRITE(TmpStr,'(I3)') INT(LEN_TRIM(DataArray(iArg))/2) + 1
               CLFormats(NColumnLabels - 1) = 'A' // TRIM(ADJUSTL(TmpStr))
               CLFormats(NColumnLabels) = 'A' // TRIM(ADJUSTL(TmpStr))
            END IF
         END IF
      END IF
    END SUBROUTINE SetArgComplex

    SUBROUTINE SetArgDComplex( Arg, iArg)
      COMPLEX*16,INTENT(IN) :: Arg
      INTEGER,INTENT(IN) :: iArg

      ! Check for errors, increment number of args,
      ! set numdata if this is the first argument, and write data to string
      ! array.
      CALL CheckForErrors(iArg,'DComplex')

      ! Write the data to the character array with the right format.
      ! For now fileformat is txt only.
      IF(txt) THEN
         WRITE(DataArray(iArg), DComplexFormat) DBLE(Arg), DIMAG(Arg)
      ELSEIF(pad) THEN
         CALL WritePAD(DataArray(iArg),npadrDefault,Arg)
      END IF

      ! Set the columnlabel format string
      IF(PRESENT(ColumnLabels)) THEN
         IF(SIZE(ColumnLabels).gt.NColumnLabels+1) THEN
            NColumnLabels = NColumnLabels + 2
            IF((iArg.eq.1).and.txt) THEN
               WRITE(TmpStr,'(I3)') INT(LEN_TRIM(DataArray(iArg))/2) - 4
               CLFormats(NColumnLabels - 1) = 'A' // TRIM(ADJUSTL(TmpStr))
               WRITE(TmpStr,'(I3)') INT(LEN_TRIM(DataArray(iArg))/2) + 1
               CLFormats(NColumnLabels) = 'A' // TRIM(ADJUSTL(TmpStr))
            ELSE
               WRITE(TmpStr,'(I3)') INT(LEN_TRIM(DataArray(iArg))/2) + 1
               CLFormats(NColumnLabels - 1) = 'A' // TRIM(ADJUSTL(TmpStr))
               CLFormats(NColumnLabels) = 'A' // TRIM(ADJUSTL(TmpStr))
            END IF
         END IF
      END IF
    END SUBROUTINE SetArgDComplex

    SUBROUTINE SetArgString( Arg, iArg)
      CHARACTER*(*),INTENT(IN) :: Arg
      CHARACTER(MaxStrLen) TmpStr
      INTEGER,INTENT(IN) :: iArg
      ! Check for errors, increment number of args,
      ! set numdata if this is the first argument, and write data to string
      ! array.
      CALL CheckForErrors(iArg,'String')

      TmpStr = TRIM(ADJUSTL(Arg))
      IF(LEN_TRIM(Arg).gt.MaxStrLen) CALL Error('Warning: String argument is too long in WriteData. ' // &
           & 'Will be truncated.', StopProgram = .FALSE.)

      ! Write the data to the character array with the right format.
      ! For now fileformat is txt only.
      IF(txt) THEN
         WRITE(DataArray(iArg), StringFormat) TRIM(TmpStr)
      ELSEIF(pad) THEN
         CALL WritePAD(DataArray(iArg),TRIM(TmpStr))
      END IF

      ! Set the columnlabel format string
      IF(PRESENT(ColumnLabels)) THEN
         IF(SIZE(ColumnLabels).gt.NColumnLabels) THEN
            NColumnLabels = NColumnLabels + 1
            IF((iArg.eq.1).and.txt) THEN
               WRITE(TmpStr,'(I3)') LEN_TRIM(DataArray(iArg)) - 4
            ELSE
               WRITE(TmpStr,'(I3)') LEN_TRIM(DataArray(iArg)) + 1
            END IF
            CLFormats(NColumnLabels) = 'A' // TRIM(ADJUSTL(TmpStr))
         END IF
      END IF
    END SUBROUTINE SetArgString

    ! CheckForErrors checks for the following errors and stops if it finds one:
    ! 
    ! 1. 'Error in WriteData multiple arguments in place' - This error occurs 
    !    when the user has specified that two arguments should be written into
    !    one column, i.e. WriteData(FileName, Int1 = I, Real1 = R, ...)
    !
    ! 2. 'Too many arguments passed to WriteData. Max is 10.' - user has specified
    !    more than 10 aguments. This one is redundant, and error 1. should always 
    !    occur if this happens.
    !
    ! In addition, CheckForErrors appends the type to DataTypeLine
    SUBROUTINE CheckForErrors(iArg,DTL)
      INTEGER,INTENT(IN) :: iArg
      CHARACTER*(*) DTL
      CHARACTER(2) ArgNum
      ! INTEGER iAllocateError
      ArgNum=''
      WRITE(ArgNum,'(I2)') iArg

      IF(IsPresent(iArg)) THEN
         CALL Error('Error in WriteData multiple arguments in place ' // TRIM(ArgNum) // '.')
      END IF

      ! Set IsPresent(iArg)
      IsPresent(iArg) = .TRUE.

      ! Check that number of arguments is not too large. Redundant, but oh well.
      IF(NumArgs.ge.iArg) CALL Error('Too many arguments passed to WriteData. Max is 10.')
      NumArgs = NumArgs + 1

      ! Set data type line
      DataTypeLine = TRIM(DataTypeLine) // ' ' // TRIM(DTL)
    END SUBROUTINE CheckForErrors

  END SUBROUTINE WriteData


  ! SUBROUTINE ReadData reads scalar data from the file filename.
  ! Up to 10 pieces of data can be read, each specified by using
  ! the optional arguments Int1 - Int10, Real1 - Real10, etc.  
  ! Thus you can read all integer data, all real data, etc. or a mixture 
  ! of various types. The column that each data piece comes from is set by
  ! specifying the number of each type, for example, a call to read a
  ! real number followed by an integer is as follows:
  !
  ! CALL ReadData(FileName, Real1 = RealVar, Int2 = IntVar) 
  !
  ! To read a complex variable followed by a string variable then a real 
  ! variable,
  !
  ! CALL ReadData(FileName, Complex1 = ComplexVar, String2 = StringVar, Real3 = RealVar)
  !
  ! Assigning two variables to the same column will produce an error, i.e.
  !
  ! CALL ReadData(FileName, Complex1 = ComplexVar, Int1 = IntVar)
  !
  ! will produce an error since we are trying to write two variables to the first column.
  !
  ! ReadData will also read section lines (beginning with #SN#) if they exist and a data 
  ! type lines (beginning with #DT#) if they exist. If the arguments passed to the routine
  ! do not match with the data type line for the current section, or (in the case where no
  ! data type line is present) do not match with the types found in the file, an error will
  ! occur. In addition, the user can specify an array of headers to be read from above the data.
  ! These headers will include any column labels that are defined.
  !
  ! Arguments
  ! FileName - Name of file to read from. Note that if the file is already open for writing,
  !            you will get an error. Note that this is the only non-optional argument.
  !
  ! The following arguments give the data to be read from the file. Note that all of 
  ! these arguments are optional.
  ! Int1, Real1, ... String1    - Argument to come from the first column.
  ! Int2, Real2, ... String2    - Argument to come from second column.
  ! .
  ! .
  ! .
  ! Int10, Real10, ... String10 - Argument to come from the tenth column.
  !
  ! SectionNumber - data will be read from the section number supplied if any. If no section
  !                 number is supplied, data is read sequentially from the current section.
  !                 Note: If the section number supplied is equal to the current section 
  !                 number, data continues to be read sequentially from this section.
  !
  ! Headers - Optional: Array of headers to be read from above the data. Note that
  !           this argument can be given without any data, and the headers will be read
  !           alone. 
  !
  ! ReadDataFromHeader - When set to .TRUE., lines beginning with #HD# will be interpretted
  !                     as data. This is usefull for files which contain
  !                     various information, including scalar information (which would be
  !                     written in the header) as well a set of arrays written in columns
  !                     which the user would like to be able to plot.
  !
  ! CommentCharacters - String of characters, any of which, when found at the beginning of a line,
  !                     will cause the line to be interpreted as a header. The default is '#!cC*'
  !
  ! NewSection - If a new section is found and this argument is present, data will not be read,
  !              and the routine will return NewSection = .TRUE.
  !              This helps when reading an unknown number of data lines from a section. 
  SUBROUTINE ReadData(FileName,                                      &
       & Int1, Int2, Int3, Int4, Int5, Int6, Int7, Int8, Int9, Int10, &
       & Real1, Real2, Real3, Real4, Real5, Real6, Real7, Real8,      &
       & Real9, Real10,                                               &
       & Double1, Double2, Double3, Double4, Double5, Double6,        &
       & Double7, Double8, Double9, Double10,                         &
       & Complex1, Complex2, Complex3, Complex4, Complex5, Complex6,  &
       & Complex7, Complex8, Complex9, Complex10,                     &
       & DComplex1, DComplex2, DComplex3, DComplex4, DComplex5,       &
       & DComplex6, DComplex7, DComplex8, DComplex9, DComplex10,      &
       & String1, String2, String3, String4, String5, String6,        &
       & String7, String8, String9, String10,                         &
       & SectionNumber, Headers, ReadDataFromHeader, CommentCharacters, &
       & NewSection, FileType, ExpectNewSection, ErrorMessage)
    CHARACTER*(*), INTENT(IN) :: FileName
    CHARACTER*(*), INTENT(IN), OPTIONAL :: ErrorMessage(:)
    INTEGER, INTENT(OUT), OPTIONAL :: Int1, Int2, Int3, Int4, Int5,    &
         & Int6, Int7, Int8, Int9, Int10
    REAL, INTENT(OUT), OPTIONAL :: Real1, Real2, Real3, Real4, Real5,  &
         & Real6, Real7, Real8, Real9, Real10
    DOUBLE PRECISION, INTENT(OUT), OPTIONAL :: Double1, Double2,       &
         & Double3, Double4, Double5, Double6, Double7, Double8,      &
         & Double9, Double10
    COMPLEX, INTENT(OUT), OPTIONAL :: Complex1, Complex2, Complex3,    &
         & Complex4, Complex5,                                        &
         & Complex6, Complex7, Complex8, Complex9, Complex10
    COMPLEX*16, INTENT(OUT), OPTIONAL :: DComplex1, DComplex2,         &
         & DComplex3, DComplex4, DComplex5, DComplex6, DComplex7,     &
         & DComplex8, DComplex9, DComplex10
    CHARACTER*(*), INTENT(OUT), OPTIONAL :: String1, String2, String3, &
         & String4, String5, String6, String7, String8, String9,      &
         & String10

    CHARACTER*(*),INTENT(OUT),OPTIONAL :: Headers(:)
    CHARACTER*(*),INTENT(IN),OPTIONAL :: CommentCharacters, FileType
    LOGICAL,INTENT(IN),OPTIONAL :: ReadDataFromHeader, ExpectNewSection
    LOGICAL,INTENT(OUT),OPTIONAL :: NewSection
    INTEGER,INTENT(IN),OPTIONAL :: SectionNumber

    ! Local variables
    ! NumArgs - Number of data arguments passed
    ! iArg    - The current argument.
    ! iUnit   - unit number associated with FileName
    INTEGER NumArgs, iUnit ! , iArg
    ! IsPresent  - If IsPresent(i) is true then the ith argument has already been defined.
    ! HeaderData - If true, interpret lines beginning with #HD# as data.
    ! txt, pad  - These are here in anticipation of enabling various formats,
    !              including text, paded ascii to start, and possibly further formats 
    !              such as xml.
    ! NewSection - If a new section is found, return set to true and return without reading.
    LOGICAL IsPresent(10), HeaderData, txt, pad, ExpNewSect
    ! DataArray - Array of strings to hold the data. Data line is split into words contained 
    !             in DataArray, then the arguments are read from DataArray(iArg)
    ! CHARACTER(MaxStrLen) DataArray(10)
    ! DataTypeLine - The data type line lists the types of data that have been specified
    !                in the file on a line beginning with #DT#. The arguments specified by
    !                the user will be checked against the types defined in the file.
    CHARACTER(120) DataTypeLine
    ! DataTypes - Array of types. 'Int', 'Real', 'Double' ...
    CHARACTER(20) DataTypes(10)
    ! ! FileAction - String variable that holds the action associated with the IOFile
    !                specified by FileName.
    CHARACTER(80) Args(20), FileAction
    ! String of comment characters.
    CHARACTER(10) CmtChars, FlType
    ! String holding the current line.
    CHARACTER(1000) Line
    ! NSections  - number of current section.
    ! NDataTypes - number of data types specified on the data type line in the file.
    ! NFields - number of columns in the current line.
    ! iField - current column.
    INTEGER NSections, NDataTypes, NFields, iField ! , i1

    ! Initialization
    HeaderData   = .FALSE.
    IsPresent(:) = .FALSE.
    NumArgs      = 0
    txt          = .TRUE.
    pad         = .FALSE.
    DataTypeLine = ''
    DataTypes(:) = 'Unknown'
    NDataTypes = 0
    iField = 0
    FlType = 'TXT'
    ExpNewSect = .FALSE.

    IF(PRESENT(ExpectNewSection)) ExpNewSect = ExpectNewSection
    ! Set the type of file. Default is txt.
    IF(PRESENT(FileType)) THEN
       FlType = TRIM(ADJUSTL(FileType))
       CALL Upper(FlType)
       IF(TRIM(FlType).eq.'TXT') THEN
          txt = .TRUE.
          pad = .FALSE.
       ELSEIF(TRIM(FlType).eq.'PAD') THEN
          pad = .TRUE.
          txt = .FALSE.
       ELSE
          CALL Error('Error: Illegal file type passed to WriteData')
       END IF
    END IF

    IF(PRESENT(CommentCharacters)) THEN 
       CmtChars = CommentCharacters
    ELSE
       CmtChars = '#!cC*'
    END IF

    IF(PRESENT(ReadDataFromHeader)) HeaderData = ReadDataFromHeader

    ! Open the file.
    IF(PRESENT(ErrorMessage)) THEN
       CALL OpenFl(FileName, FileStatus = 'OLD', FileAction = 'READ', ErrorMessage = ErrorMessage)
    ELSE
       CALL OpenFl(FileName, FileStatus = 'OLD', FileAction = 'READ')
    END IF

    ! Get the unit number, the section number, and the fileaction (Read or Write).
    CALL GetIOFileInfo(FileName,UnitNumber = iUnit,NSections = NSections, FileAction = FileAction)    
    ! If this is the first call, set NSections to 1
    IF(NSections.eq.0) NSections = 1

    ! Check that the FileAction is 'READ' not 'WRITE'.
    IF(FileAction(1:5).eq.'WRITE') CALL Error('Error in ReadData. File ' // FileName // &
         & ' is already open for writing.')

    ! If section number has been supplied, and is not equal to the current section number
    ! read to the specified section. 
    IF(PRESENT(SectionNumber)) THEN
       IF(SectionNumber.ne.NSections) CALL ReadToSection(FileName,SectionNumber)
       NSections = SectionNumber
       ! If we have reached the end of the file, return.
       IF(EndOfFile(FileName)) RETURN
    END IF

    ! Read the headers, keeping them in Headers array if supplied. This will also update the
    ! DataTypeLine and section number if they are found.
    IF(PRESENT(Headers)) THEN
       CALL ReadHeaders(FileName,Line,CommentCharacters = CmtChars, Headers = Headers)
    ELSE
       CALL ReadHeaders(FileName,Line,CommentCharacters = CmtChars)
    END IF

    ! If end of file or end of section, return.
    IF(EndOfFile(FileName).or.ReadingNewSection(FileName,NSections)) THEN
       IF(.NOT.ExpNewSect) THEN
          IF(PRESENT(NewSection)) NewSection = .TRUE.
          RETURN
       END IF
    END IF

    ! Get the DataTypeLine
    CALL GetIOFileInfo(FileName, DataTypeLine = DataTypeLine, NSections = NSections)
    ! If the DataTypeLine is not defined in the file, ignore.
    IF(TRIM(ADJUSTL(DataTypeLine)).ne.'Unknown') THEN
       NDataTypes = 10
       CALL bwords(DataTypeLine,NDataTypes,DataTypes)
    END IF

    ! Read the Line.
    Line = TRIM(ADJUSTL(Line))

    ! If Line starts with #HD#, this is header data. Ignore #HD# and 
    ! break the rest of the line.
    IF(Line(1:4).eq.'#HD#') Line = Line(5:LEN(Line))
    NFields = 20
    CALL bwords_nc(Line,NFields, Args)


    ! Find the 1st argument.
    IF(PRESENT(Int1)) CALL GetArgInt(Int1, 1)
    IF(PRESENT(Real1)) CALL GetArgReal(Real1, 1)
    IF(PRESENT(Double1)) CALL GetArgDouble(Double1, 1)
    IF(PRESENT(Complex1)) CALL GetArgComplex(Complex1, 1)
    IF(PRESENT(DComplex1)) CALL GetArgDComplex(DComplex1, 1)
    IF(PRESENT(String1)) CALL GetArgString(String1, 1)

    ! The GetArgType(Arg,ColumnNumber) subroutines checks the presence of Arg. If Arg
    ! is present, the data is read into DataArray(ColumnNumber). Also
    ! iField is incremented.
    ! In addition, various errors are checked.
    ! Find the 2nd argument.
    IF(PRESENT(Int2)) CALL GetArgInt(Int2, 2)
    IF(PRESENT(Real2)) CALL GetArgReal(Real2, 2)
    IF(PRESENT(Double2)) CALL GetArgDouble(Double2, 2)
    IF(PRESENT(Complex2)) CALL GetArgComplex(Complex2, 2)
    IF(PRESENT(DComplex2)) CALL GetArgDComplex(DComplex2, 2)
    IF(PRESENT(String2)) CALL GetArgString(String2, 2)

    ! Find the 3rd argument.
    IF(PRESENT(Int3)) CALL GetArgInt(Int3, 3)
    IF(PRESENT(Real3)) CALL GetArgReal(Real3, 3)
    IF(PRESENT(Double3)) CALL GetArgDouble(Double3, 3)
    IF(PRESENT(Complex3)) CALL GetArgComplex(Complex3, 3)
    IF(PRESENT(DComplex3)) CALL GetArgDComplex(DComplex3, 3)
    IF(PRESENT(String3)) CALL GetArgString(String3, 3)

    ! Find the 4th argument.
    IF(PRESENT(Int4)) CALL GetArgInt(Int4, 4)
    IF(PRESENT(Real4)) CALL GetArgReal(Real4, 4)
    IF(PRESENT(Double4)) CALL GetArgDouble(Double4, 4)
    IF(PRESENT(Complex4)) CALL GetArgComplex(Complex4, 4)
    IF(PRESENT(DComplex4)) CALL GetArgDComplex(DComplex4, 4)
    IF(PRESENT(String4)) CALL GetArgString(String4, 4)

    ! Find the 5th argument.
    IF(PRESENT(Int5)) CALL GetArgInt(Int5, 5)
    IF(PRESENT(Real5)) CALL GetArgReal(Real5, 5)
    IF(PRESENT(Double5)) CALL GetArgDouble(Double5, 5)
    IF(PRESENT(Complex5)) CALL GetArgComplex(Complex5, 5)
    IF(PRESENT(DComplex5)) CALL GetArgDComplex(DComplex5, 5)
    IF(PRESENT(String5)) CALL GetArgString(String5, 5)

    ! Find the 6th argument.
    IF(PRESENT(Int6)) CALL GetArgInt(Int6, 6)
    IF(PRESENT(Real6)) CALL GetArgReal(Real6, 6)
    IF(PRESENT(Double6)) CALL GetArgDouble(Double6, 6)
    IF(PRESENT(Complex6)) CALL GetArgComplex(Complex6, 6)
    IF(PRESENT(DComplex6)) CALL GetArgDComplex(DComplex6, 6)
    IF(PRESENT(String6)) CALL GetArgString(String6, 6)

    ! Find the 7th argument.
    IF(PRESENT(Int7)) CALL GetArgInt(Int7, 7)
    IF(PRESENT(Real7)) CALL GetArgReal(Real7, 7)
    IF(PRESENT(Double7)) CALL GetArgDouble(Double7, 7)
    IF(PRESENT(Complex7)) CALL GetArgComplex(Complex7, 7)
    IF(PRESENT(DComplex7)) CALL GetArgDComplex(DComplex7, 7)
    IF(PRESENT(String7)) CALL GetArgString(String7, 7)

    ! Find the 8th argument.
    IF(PRESENT(Int8)) CALL GetArgInt(Int8, 8)
    IF(PRESENT(Real8)) CALL GetArgReal(Real8, 8)
    IF(PRESENT(Double8)) CALL GetArgDouble(Double8, 8)
    IF(PRESENT(Complex8)) CALL GetArgComplex(Complex8, 8)
    IF(PRESENT(DComplex8)) CALL GetArgDComplex(DComplex8, 8)
    IF(PRESENT(String8)) CALL GetArgString(String8, 8)

    ! Find the 9th argument.
    IF(PRESENT(Int9)) CALL GetArgInt(Int9, 9)
    IF(PRESENT(Real9)) CALL GetArgReal(Real9, 9)
    IF(PRESENT(Double9)) CALL GetArgDouble(Double9, 9)
    IF(PRESENT(Complex9)) CALL GetArgComplex(Complex9, 9)
    IF(PRESENT(DComplex9)) CALL GetArgDComplex(DComplex9, 9)
    IF(PRESENT(String9)) CALL GetArgString(String9, 9)

    ! Find the 10th argument.
    IF(PRESENT(Int10)) CALL GetArgInt(Int10, 10)
    IF(PRESENT(Real10)) CALL GetArgReal(Real10, 10)
    IF(PRESENT(Double10)) CALL GetArgDouble(Double10, 10)
    IF(PRESENT(Complex10)) CALL GetArgComplex(Complex10, 10)
    IF(PRESENT(DComplex10)) CALL GetArgDComplex(DComplex10, 10)
    IF(PRESENT(String10)) CALL GetArgString(String10, 10)

  CONTAINS

    ! The GetArgType(Arg,ColumnNumber) subroutines checks the presence of Arg. If Arg
    ! is present, the data is read into DataArray(ColumnNumber). Also
    ! iField is incremented.
    ! In addition, various errors are checked.    
    SUBROUTINE GetArgInt(Arg, iArg)
      INTEGER,INTENT(OUT) :: Arg
      INTEGER,INTENT(IN) :: iArg

      ! Check for errors, increment number of args,
      ! set numdata if this is the first argument, and write data to string
      ! array.
      CALL CheckForErrors(iArg,'Int')

      ! Read the next argument
      iField = iField + 1
      IF(txt) THEN
         READ(Args(iField),*) Arg
      ELSEIF(pad) THEN
         CALL ReadPAD(Args(iField),Arg)
      END IF
    END SUBROUTINE GetArgInt

    SUBROUTINE GetArgReal( Arg, iArg)
      REAL,INTENT(OUT) :: Arg
      INTEGER,INTENT(IN) :: iArg
      ! Check for errors, increment number of args,
      ! set numdata if this is the first argument, and write data to string
      ! array.
      CALL CheckForErrors(iArg,'Real')

      ! Read the next argument
      iField = iField + 1
      IF(txt) THEN
         READ(Args(iArg),*) Arg
      ELSEIF(pad) THEN
         CALL ReadPAD(Args(iField), npadrDefault, Arg)
      END IF
    END SUBROUTINE GetArgReal

    SUBROUTINE GetArgDouble( Arg, iArg)
      DOUBLE PRECISION,INTENT(OUT) :: Arg
      INTEGER,INTENT(IN) :: iArg
      ! Check for errors, increment number of args,
      ! set numdata if this is the first argument, and write data to string
      ! array.
      CALL CheckForErrors(iArg,'Double')

      ! Read the next argument
      iField = iField + 1
      IF(txt) THEN
         READ(Args(iArg),*) Arg
      ELSEIF(pad) THEN
         CALL ReadPAD(Args(iField), npadxDefault, Arg)
      END IF
    END SUBROUTINE GetArgDouble

    SUBROUTINE GetArgComplex( Arg, iArg)
      COMPLEX,INTENT(OUT) :: Arg
      INTEGER,INTENT(IN) :: iArg
      REAL ReArg, ImArg
      ! Check for errors, increment number of args,
      ! set numdata if this is the first argument, and write data to string
      ! array.
      CALL CheckForErrors(iArg,'Complex')

      ! Read the next argument
      iField = iField + 1
      IF(txt) THEN
         READ(Args(iField),*) ReArg
      ELSEIF(pad) THEN
         CALL ReadPAD(Args(iField), npadrDefault, ReArg)
      END IF

      ! Check that the number of Fields in the data file is >= to iField. This was checked in
      ! CheckForErrors, but we need to check it again since we are reading again.
      IF(iField.ge.NFields) CALL Error('Too many arguments passed to ReadData when compared ' //&
           & 'number of fields in file ' // FileName)
      iField = iField + 1
      IF(txt) THEN
         READ(Args(iField),*) ImArg
      ELSEIF(pad) THEN
         CALL ReadPAD(Args(iField), npadrDefault, ImArg)
      END IF
      Arg = ReArg + (0.0, 1.0)*ImArg
    END SUBROUTINE GetArgComplex

    SUBROUTINE GetArgDComplex( Arg, iArg)
      COMPLEX*16,INTENT(OUT) :: Arg
      INTEGER,INTENT(IN) :: iArg

      DOUBLE PRECISION ReArg, ImArg
      ! Check for errors, increment number of args,
      ! set numdata if this is the first argument, and write data to string
      ! array.
      CALL CheckForErrors(iArg,'DComplex')

      ! Read the next argument
      iField = iField + 1
      IF(txt) THEN
         READ(Args(iField),*) ReArg
      ELSEIF(pad) THEN
         CALL ReadPAD(Args(iField), npadxDefault, ReArg)
      END IF

      ! Check that the number of Fields in the data file is >= to iField. This was checked in
      ! CheckForErrors, but we need to check it again since we are reading again.
      IF(iField.ge.NFields) CALL Error('Too many arguments passed to ReadData when compared ' //&
           & 'number of fields in file ' // FileName)
      iField = iField + 1
      IF(txt) THEN
         READ(Args(iField),*) ImArg
      ELSEIF(pad) THEN
         CALL ReadPAD(Args(iField), npadxDefault, ImArg)
      END IF
      Arg = ReArg + (0.d0, 1.d0)*ImArg
    END SUBROUTINE GetArgDComplex

    SUBROUTINE GetArgString( Arg, iArg)
      CHARACTER*(*),INTENT(OUT) :: Arg
      INTEGER,INTENT(IN) :: iArg
      ! Check for errors, increment number of args,
      ! set numdata if this is the first argument, and write data to string
      ! array.
      CALL CheckForErrors(iArg,'String')

      ! Read the next argument
      iField = iField + 1
      IF(txt) THEN
      READ(Args(iField),*) Arg
      ELSEIF(pad) THEN
         CALL ReadPAD(Args(iField),Arg)
      END IF
    END SUBROUTINE GetArgString

    ! CheckForErrors checks for the following errors and stops if it finds one:
    ! 
    ! 1. 'Error in ReadData multiple arguments in place' - This error occurs 
    !    when the user has specified that two arguments should be written into
    !    one column, i.e. WriteData(FileName, Int1 = I, Real1 = R, ...)
    !
    ! 2. 'Too many arguments passed to ReadData. Max is 10.' - user has specified
    !    more than 10 aguments. This one is redundant, and error 1. should always 
    !    occur if this happens.
    !
    ! 3. 'Too many arguments passed to ReadData when compared to
    !     number of fields in file FileName' - user has specified
    !     more (or different) arguments than are available in file.
    !
    ! 4. 'Error: Number of arguments passed to ReadData does not
    !     match that defined in the file FileName' - user has
    !     specified more arguments than are defined in the data type
    !     line in the file.  
    !
    ! 5.  'Error: Arguments passed to ReadData are of different type
    !      than those defined in the file FileName.' - user is trying
    !      to read different types than those defined by the data
    !      type line in the file.
    !
    ! In addition, CheckForError increments the number of arguments.
    SUBROUTINE CheckForErrors(iArg,DTL)
      INTEGER,INTENT(IN) :: iArg
      CHARACTER*(*) DTL
      CHARACTER(2) ArgNum
      ! INTEGER iAllocateError
      ArgNum=''
      WRITE(ArgNum,'(I2)') iArg

      IF(IsPresent(iArg)) THEN
         CALL Error('Error in ReadData multiple arguments in place ' // TRIM(ArgNum) // '.')
      END IF

      ! Set IsPresent(iArg)
      IsPresent(iArg) = .TRUE.

      ! Check that number of arguments is not too large. Redundant, but oh well.
      IF(NumArgs.ge.10) CALL Error('Too many arguments passed to ReadData. Max is 10.')
      NumArgs = NumArgs + 1

      ! Check that the number of Fields in the data file is >= to iField
      IF(iField.ge.NFields) CALL Error('Too many arguments passed to ReadData when compared ' //&
           & 'number of fields in file ' // FileName)

      ! If data types have been defined in this file, check for data type errors.
      IF(NDataTypes.gt.0) THEN
         ! Check that there are not more arguments than data types.
         IF(iArg.gt.NDataTypes) THEN
            CALL Error('Error: Number of arguments passed to ReadData does not match ' // &
                 & 'that defined in the file ' // FileName)
         END IF

         ! Check that this argument is compatible with the datatype described in DataTypeLine.
         IF( TRIM(ADJUSTL(DataTypes(iArg))).ne.TRIM(ADJUSTL(DTL)) ) THEN
            CALL Error('Error: Arguments passed to ReadData are of different type than those' // &
                 & ' defined in the file ' // FileName // '.')
         END IF
      END IF
    END SUBROUTINE CheckForErrors

  END SUBROUTINE ReadData


  ! SUBROUTINE ReadArrayData reads up to 10 arrays out of the file
  ! FileName. This routine is almost identical to ReadData except
  ! that the data arguments are arbitrary length arrays. See
  ! description of ReadData for more information. The following
  ! information gives differences to ReadData.
  ! 
  ! ReadArrayData will read multiple lines into the given arrays
  ! until it reaches the end of the section, or the end of the file.
  ! Each column of data in the file is interpreted as a single array.
  ! All arrays passed to the routine must be the same length. If the
  ! arrays are not long enough to hold the data specified in the
  ! section to be read, an error will occur.
  !
  ! It has one additional optional argument when compared to ReadData.
  ! NumElements - ReadArrayData will return the number of elements it
  ! read from the specified file.
  SUBROUTINE ReadArrayData(FileName,                                      &
       & Int1, Int2, Int3, Int4, Int5, Int6, Int7, Int8, Int9, Int10, &
       & Real1, Real2, Real3, Real4, Real5, Real6, Real7, Real8,      &
       & Real9, Real10,                                               &
       & Double1, Double2, Double3, Double4, Double5, Double6,        &
       & Double7, Double8, Double9, Double10,                         &
       & Complex1, Complex2, Complex3, Complex4, Complex5, Complex6,  &
       & Complex7, Complex8, Complex9, Complex10,                     &
       & DComplex1, DComplex2, DComplex3, DComplex4, DComplex5,       &
       & DComplex6, DComplex7, DComplex8, DComplex9, DComplex10,      &
       & String1, String2, String3, String4, String5, String6,        &
       & String7, String8, String9, String10,                         &
       & SectionNumber, Headers, ReadDataFromHeader, CommentCharacters, &
       & NewSection, NumElements, FileType, ExactLength)
    CHARACTER*(*), INTENT(IN) :: FileName
    INTEGER, INTENT(OUT), OPTIONAL :: Int1(:), Int2(:), Int3(:), Int4(:), Int5(:),    &
         & Int6(:), Int7(:), Int8(:), Int9(:), Int10(:)
    REAL, INTENT(OUT), OPTIONAL :: Real1(:), Real2(:), Real3(:), Real4(:), Real5(:),  &
         & Real6(:), Real7(:), Real8(:), Real9(:), Real10(:)
    DOUBLE PRECISION, INTENT(OUT), OPTIONAL :: Double1(:), Double2(:),       &
         & Double3(:), Double4(:), Double5(:), Double6(:), Double7(:), Double8(:),      &
         & Double9(:), Double10(:)
    COMPLEX, INTENT(OUT), OPTIONAL :: Complex1(:), Complex2(:), Complex3(:),    &
         & Complex4(:), Complex5(:),                                        &
         & Complex6(:), Complex7(:), Complex8(:), Complex9(:), Complex10(:)
    COMPLEX*16, INTENT(OUT), OPTIONAL :: DComplex1(:), DComplex2(:),         &
         & DComplex3(:), DComplex4(:), DComplex5(:), DComplex6(:), DComplex7(:),     &
         & DComplex8(:), DComplex9(:), DComplex10(:)
    CHARACTER*(*), INTENT(OUT), OPTIONAL :: String1(:), String2(:), String3(:), &
         & String4(:), String5(:), String6(:), String7(:), String8(:), String9(:),      &
         & String10(:)

    CHARACTER*(*),INTENT(OUT),OPTIONAL :: Headers(:)
    CHARACTER*(*),INTENT(IN),OPTIONAL :: CommentCharacters, FileType
    LOGICAL,INTENT(IN),OPTIONAL :: ReadDataFromHeader, ExactLength
    LOGICAL,INTENT(OUT),OPTIONAL :: NewSection
    INTEGER,INTENT(IN),OPTIONAL :: SectionNumber
    INTEGER,INTENT(OUT),OPTIONAL :: NumElements

    INTEGER NumArgs, iUnit, NumData, NColumnLabels ! , iArg
    LOGICAL IsPresent(10), HeaderData, txt, pad, ExactLen
    CHARACTER(MaxStrLen),ALLOCATABLE :: DataArray(:,:)
    CHARACTER(120) DataTypeLine
    CHARACTER(20) DataTypes(10)
    CHARACTER(20) FileAction ! , ComplexFormat, DComplexFormat, DoubleFormat, IntFormat, RealFormat, StringFormat
    CHARACTER(80) Args(20)
    CHARACTER(10) CLFormats(30), CmtChars
    CHARACTER(1000) Line
    CHARACTER(10) TmpStr, FlType

    INTEGER i1, NSections, NDataTypes, NFields, iField, MaxData, iAllocateError

    ! Initialization
    TmpStr = ' '
    HeaderData   = .FALSE.
    IsPresent(:) = .FALSE.
    NumArgs      = 0
    txt          = .TRUE.
    pad          = .FALSE.
    DataTypeLine = ''
    DataTypes(:) = 'Unknown'
    CLFormats(:) = ''
    NColumnLabels = 0
    NDataTypes = 0
    iField = 0
    MaxData = 0
    FlType = 'TXT'
    ExactLen = .TRUE.

    IF(PRESENT(ExactLength)) ExactLen = ExactLength

    ! Set the type of file. Default is txt.
    IF(PRESENT(FileType)) THEN
       FlType = TRIM(ADJUSTL(FileType))
       CALL Upper(FlType)
       IF(TRIM(FlType).eq.'TXT') THEN
          txt = .TRUE.
          pad = .FALSE.
       ELSEIF(TRIM(FlType).eq.'PAD') THEN
          pad = .TRUE.
          txt = .FALSE.
       ELSE
          CALL Error('Error: Illegal file type passed to WriteData')
       END IF
    END IF

    IF(PRESENT(CommentCharacters)) THEN 
       CmtChars = CommentCharacters
    ELSE
       CmtChars = DefaultCommentCharacters
    END IF

    IF(PRESENT(ReadDataFromHeader)) HeaderData = ReadDataFromHeader

    ! Open the file.
    CALL OpenFl(FileName, FileStatus = 'OLD', FileAction = 'READ')

    ! Get the unit number, and the section number.
    CALL GetIOFileInfo(FileName,UnitNumber = iUnit,NSections = NSections, FileAction = FileAction)
    IF(NSections.eq.0) NSections = 1

    ! Check that the FileAction is read.
    IF(FileAction(1:5).eq.'WRITE') CALL Error('Error in ReadData. File ' // FileName // &
         & ' is already open for writing.')

    ! If section number has been supplied, read to that section. 
    IF(PRESENT(SectionNumber)) THEN
       IF(SectionNumber.ne.NSections) CALL ReadToSection(FileName,SectionNumber)
       NSections = SectionNumber
       IF(EndOfFile(FileName)) RETURN
    END IF

    ! Read the headers, keeping them in Headers if supplied. This will also update the
    ! DataTypeLine and section number if they are found.
    IF(PRESENT(Headers)) THEN
       CALL ReadHeaders(FileName,Line, CommentCharacters = CmtChars, Headers = Headers)
    ELSE
       CALL ReadHeaders(FileName,Line,CommentCharacters = CmtChars)
    END IF
    IF(EndOfFile(FileName)) RETURN

    ! Get the DataTypeLine
    CALL GetIOFileInfo(FileName, DataTypeLine = DataTypeLine, NSections = NSections)
    IF(TRIM(ADJUSTL(DataTypeLine)).ne.'Unknown') THEN
       NDataTypes = 10
       CALL bwords(DataTypeLine,NDataTypes,DataTypes)
    END IF

    ! Get the maximum number of data lines.
    CALL GetMaxData

    ! Allocate space for string data array.
    ALLOCATE(DataArray(MaxData,20), STAT = iAllocateError)
    CALL CheckAllocation(iAllocateError, 'Error: Failed to allocate space for DataArray' //&
         & ' in subroutine WriteArrayData.')
    ! Read all the lines in this section, and split them into words.
    ! ReadHeaders reads the line.

    DO i1 = 1, MaxData 
       NFields = 20
       ! Clean up the line.
       Line = ADJUSTL(Line)
       ! If this is header data, remove the #HD# marker.
       IF(Line(1:4).eq.'#HD#') Line = Line(5:LEN(Line))
       ! Split line into words and copy to DataArray.
       CALL bwords_nc(Line,NFields,Args)
       DO iField = 1, NFields
          DataArray(i1,iField) = Args(iField)
       END DO

       ! If we have reached the end of the section or the end of the 
       ! file, return.
       IF(EndOfFile(FileName).or.ReadingNewSection(FileName,NSections)) THEN
          IF(PRESENT(NewSection)) NewSection = .TRUE.
          EXIT
       ELSE
          NumData = i1
       END IF
       IF(i1.eq.MaxData) EXIT
       ! Read past any comments and output next line.
       CALL ReadHeaders(FileName,Line,CommentCharacters = CmtChars)
    END DO
    ! Check that the next line is not data. If it is. The arrays that were passed
    ! are not long enough to hold all of the data in the file. Error.
    IF(.not.ExactLen) THEN
       IF(NextLineIsData(FileName)) THEN
          WRITE(TmpStr,'(I4)') NSections
          CALL Error('Error: Arrays passed to ReadArrayData are not long enough to hold', StopProgram = .FALSE.)
          CALL Error('the data defined in section ' // TRIM(ADJUSTL(TmpStr)) // ' of ' // TRIM(FileName), StopProgram = .FALSE.)
       END IF
    END IF

    iField = 0
    ! Find the 1st argument and read all elements into DataArray
    IF(PRESENT(Int1)) CALL GetArrayArgInt(Int1, 1)
    IF(PRESENT(Real1)) CALL GetArrayArgReal(Real1, 1)
    IF(PRESENT(Double1)) CALL GetArrayArgDouble(Double1, 1)
    IF(PRESENT(Complex1)) CALL GetArrayArgComplex(Complex1, 1)
    IF(PRESENT(DComplex1)) CALL GetArrayArgDComplex(DComplex1, 1)
    IF(PRESENT(String1)) CALL GetArrayArgString(String1, 1)

    ! Find the 2nd argument.
    IF(PRESENT(Int2)) CALL GetArrayArgInt(Int2, 2)
    IF(PRESENT(Real2)) CALL GetArrayArgReal(Real2, 2)
    IF(PRESENT(Double2)) CALL GetArrayArgDouble(Double2, 2)
    IF(PRESENT(Complex2)) CALL GetArrayArgComplex(Complex2, 2)
    IF(PRESENT(DComplex2)) CALL GetArrayArgDComplex(DComplex2, 2)
    IF(PRESENT(String2)) CALL GetArrayArgString(String2, 2)

    ! Find the 3rd argument.
    IF(PRESENT(Int3)) CALL GetArrayArgInt(Int3, 3)
    IF(PRESENT(Real3)) CALL GetArrayArgReal(Real3, 3)
    IF(PRESENT(Double3)) CALL GetArrayArgDouble(Double3, 3)
    IF(PRESENT(Complex3)) CALL GetArrayArgComplex(Complex3, 3)
    IF(PRESENT(DComplex3)) CALL GetArrayArgDComplex(DComplex3, 3)
    IF(PRESENT(String3)) CALL GetArrayArgString(String3, 3)

    ! Find the 4th argument.
    IF(PRESENT(Int4)) CALL GetArrayArgInt(Int4, 4)
    IF(PRESENT(Real4)) CALL GetArrayArgReal(Real4, 4)
    IF(PRESENT(Double4)) CALL GetArrayArgDouble(Double4, 4)
    IF(PRESENT(Complex4)) CALL GetArrayArgComplex(Complex4, 4)
    IF(PRESENT(DComplex4)) CALL GetArrayArgDComplex(DComplex4, 4)
    IF(PRESENT(String4)) CALL GetArrayArgString(String4, 4)

    ! Find the 5th argument.
    IF(PRESENT(Int5)) CALL GetArrayArgInt(Int5, 5)
    IF(PRESENT(Real5)) CALL GetArrayArgReal(Real5, 5)
    IF(PRESENT(Double5)) CALL GetArrayArgDouble(Double5, 5)
    IF(PRESENT(Complex5)) CALL GetArrayArgComplex(Complex5, 5)
    IF(PRESENT(DComplex5)) CALL GetArrayArgDComplex(DComplex5, 5)
    IF(PRESENT(String5)) CALL GetArrayArgString(String5, 5)

    ! Find the 6th argument.
    IF(PRESENT(Int6)) CALL GetArrayArgInt(Int6, 6)
    IF(PRESENT(Real6)) CALL GetArrayArgReal(Real6, 6)
    IF(PRESENT(Double6)) CALL GetArrayArgDouble(Double6, 6)
    IF(PRESENT(Complex6)) CALL GetArrayArgComplex(Complex6, 6)
    IF(PRESENT(DComplex6)) CALL GetArrayArgDComplex(DComplex6, 6)
    IF(PRESENT(String6)) CALL GetArrayArgString(String6, 6)

    ! Find the 7th argument.
    IF(PRESENT(Int7)) CALL GetArrayArgInt(Int7, 7)
    IF(PRESENT(Real7)) CALL GetArrayArgReal(Real7, 7)
    IF(PRESENT(Double7)) CALL GetArrayArgDouble(Double7, 7)
    IF(PRESENT(Complex7)) CALL GetArrayArgComplex(Complex7, 7)
    IF(PRESENT(DComplex7)) CALL GetArrayArgDComplex(DComplex7, 7)
    IF(PRESENT(String7)) CALL GetArrayArgString(String7, 7)

    ! Find the 8th argument.
    IF(PRESENT(Int8)) CALL GetArrayArgInt(Int8, 8)
    IF(PRESENT(Real8)) CALL GetArrayArgReal(Real8, 8)
    IF(PRESENT(Double8)) CALL GetArrayArgDouble(Double8, 8)
    IF(PRESENT(Complex8)) CALL GetArrayArgComplex(Complex8, 8)
    IF(PRESENT(DComplex8)) CALL GetArrayArgDComplex(DComplex8, 8)
    IF(PRESENT(String8)) CALL GetArrayArgString(String8, 8)

    ! Find the 9th argument.
    IF(PRESENT(Int9)) CALL GetArrayArgInt(Int9, 9)
    IF(PRESENT(Real9)) CALL GetArrayArgReal(Real9, 9)
    IF(PRESENT(Double9)) CALL GetArrayArgDouble(Double9, 9)
    IF(PRESENT(Complex9)) CALL GetArrayArgComplex(Complex9, 9)
    IF(PRESENT(DComplex9)) CALL GetArrayArgDComplex(DComplex9, 9)
    IF(PRESENT(String9)) CALL GetArrayArgString(String9, 9)

    ! Find the 10th argument.
    IF(PRESENT(Int10)) CALL GetArrayArgInt(Int10, 10)
    IF(PRESENT(Real10)) CALL GetArrayArgReal(Real10, 10)
    IF(PRESENT(Double10)) CALL GetArrayArgDouble(Double10, 10)
    IF(PRESENT(Complex10)) CALL GetArrayArgComplex(Complex10, 10)
    IF(PRESENT(DComplex10)) CALL GetArrayArgDComplex(DComplex10, 10)
    IF(PRESENT(String10)) CALL GetArrayArgString(String10, 10)

    IF(PRESENT(NumElements)) NumElements = NumData
    DEALLOCATE(DataArray)
  CONTAINS

    SUBROUTINE GetArrayArgInt(Arg, iArg)
      INTEGER,INTENT(OUT) :: Arg(:)
      INTEGER,INTENT(IN) :: iArg
      ! INTEGER iData

      ! Check for errors, increment number of args,
      ! set numdata if this is the first argument, and write data to string
      ! array.
      CALL CheckArrayForErrors(iArg,'Int')

      IF(MaxData.ne.SIZE(Arg)) THEN
         CALL Error('Error in ReadArrayData: All arrays must be same size.')
      END IF
      ! Read the next column.
      iField = iField + 1
      IF(txt) THEN
         DO i1 = 1, NumData
            READ(DataArray(i1,iField),*) Arg(i1)
         END DO
      ELSEIF(pad) THEN
         DO i1 = 1, NumData
            CALL ReadPAD(DataArray(i1,iField),Arg(i1))
         END DO
      END IF
    END SUBROUTINE GetArrayArgInt

    SUBROUTINE GetArrayArgReal( Arg, iArg)
      REAL,INTENT(OUT) :: Arg(:)
      INTEGER,INTENT(IN) :: iArg
      ! Check for errors, increment number of args,
      ! set numdata if this is the first argument, and write data to string
      ! array.
      CALL CheckArrayForErrors(iArg,'Real')

      IF(MaxData.ne.SIZE(Arg)) THEN
         CALL Error('Error in writearray: All arrays must be same size.')
      END IF

      ! Read the next argument
      iField = iField + 1
      IF(txt) THEN
         DO i1 = 1, NumData
            READ(DataArray(i1,iField),*) Arg(i1)
         END DO
      ELSEIF(pad) THEN
         DO i1 = 1, NumData
            CALL ReadPAD(DataArray(i1, iField), npadrDefault, Arg(i1))
         END DO
      END IF
    END SUBROUTINE GetArrayArgReal

    SUBROUTINE GetArrayArgDouble( Arg, iArg)
      DOUBLE PRECISION,INTENT(OUT) :: Arg(:)
      INTEGER,INTENT(IN) :: iArg
      ! Check for errors, increment number of args,
      ! set numdata if this is the first argument, and write data to string
      ! array.
      CALL CheckArrayForErrors(iArg,'Double')

      IF(MaxData.ne.SIZE(Arg)) THEN
         CALL Error('Error in writearray: All arrays must be same size.')
      END IF

      ! Read the next argument
      iField = iField + 1
      IF(txt) THEN
         DO i1 = 1, NumData
            READ(DataArray(i1,iField),*) Arg(i1)
         END DO
      ELSEIF(pad) THEN
         DO i1 = 1, NumData
            CALL ReadPAD(DataArray(i1, iField), npadrDefault, Arg(i1))
         END DO
      END IF
    END SUBROUTINE GetArrayArgDouble

    SUBROUTINE GetArrayArgComplex( Arg, iArg)
      COMPLEX,INTENT(OUT) :: Arg(:)
      INTEGER,INTENT(IN) :: iArg
      REAL ReArg, ImArg
      ! Check for errors, increment number of args,
      ! set numdata if this is the first argument, and write data to string
      ! array.
      CALL CheckArrayForErrors(iArg,'Complex')

      IF(MaxData.ne.SIZE(Arg)) THEN
         CALL Error('Error in writearray: All arrays must be same size.')
      END IF

      ! Read the next argument
      iField = iField + 1
      IF(iField.ge.NFields) CALL Error('Too many arguments passed to ReadData when compared ' //&
           & 'number of fields in file ' // FileName)
      iField = iField + 1
      IF(txt) THEN
         DO i1 = 1, NumData
            READ(DataArray(i1,iField-1),*) ReArg
            READ(DataArray(i1,iField),*) ImArg
            Arg(i1) = ReArg + (0.0,1.0)*ImArg
         END DO
      ELSEIF(pad) THEN
         DO i1 = 1, NumData
            CALL ReadPAD(DataArray(i1, iField-1), npadrDefault, ReArg)
            CALL ReadPAD(DataArray(i1, iField), npadrDefault, ImArg)
            Arg(i1) = ReArg + (0.0,1.0)*ImArg
         END DO
      END IF
    END SUBROUTINE GetArrayArgComplex

    SUBROUTINE GetArrayArgDComplex( Arg, iArg)
      COMPLEX*16,INTENT(OUT) :: Arg(:)
      INTEGER,INTENT(IN) :: iArg

      DOUBLE PRECISION ReArg, ImArg
      ! Check for errors, increment number of args,
      ! set numdata if this is the first argument, and write data to string
      ! array.
      CALL CheckArrayForErrors(iArg,'DComplex')

      IF(MaxData.ne.SIZE(Arg)) THEN
         CALL Error('Error in writearray: All arrays must be same size.')
      END IF

      ! Read the next column
      iField = iField + 1
      IF(iField.ge.NFields) CALL Error('Too many arguments passed to ReadData when compared ' //&
           & 'number of fields in file ' // FileName)
      iField = iField + 1
      IF(txt) THEN
         DO i1 = 1, NumData
            READ(DataArray(i1,iField-1),*) ReArg
            READ(DataArray(i1,iField),*) ImArg
            Arg(i1) = ReArg + (0.0,1.0)*ImArg
         END DO
      ELSEIF(pad) THEN
         DO i1 = 1, NumData
            CALL ReadPAD(DataArray(i1, iField-1), npadxDefault, ReArg)
            CALL ReadPAD(DataArray(i1, iField), npadxDefault, ImArg)
            Arg(i1) = ReArg + (0.d0,1.d0)*ImArg
         END DO
      END IF
    END SUBROUTINE GetArrayArgDComplex

    SUBROUTINE GetArrayArgString( Arg, iArg)
      CHARACTER*(*),INTENT(OUT) :: Arg(:)
      INTEGER,INTENT(IN) :: iArg
      ! Check for errors, increment number of args,
      ! set numdata if this is the first argument, and write data to string
      ! array.
      CALL CheckArrayForErrors(iArg,'String')

      IF(MaxData.ne.SIZE(Arg)) THEN
         CALL Error('Error in writearray: All arrays must be same size.')
      END IF

      ! Read the next column
      iField = iField + 1
      IF(txt) THEN
         DO i1 = 1, NumData
            READ(DataArray(i1,iField),*) Arg(i1)
         END DO
      ELSEIF(pad) THEN
         DO i1 = 1, NumData
            CALL ReadPAD(DataArray(i1, iField),Arg(i1))
         END DO
      END IF
    END SUBROUTINE GetArrayArgString
      
    SUBROUTINE CheckArrayForErrors(iArg,DTL)
      INTEGER,INTENT(IN) :: iArg
      CHARACTER*(*) DTL
      CHARACTER(2) ArgNum
      ! INTEGER iAllocateError
      ArgNum=''
      WRITE(ArgNum,'(I2)') iArg

      IF(IsPresent(iArg)) THEN
         CALL Error('Error in ReadData: multiple arguments in place ' // TRIM(ArgNum) // '.')
      END IF

      ! Set IsPresent(iArg)
      IsPresent(iArg) = .TRUE.

      ! Check that number of arguments is not too large. Redundant, but oh well.
      IF(NumArgs.ge.10) CALL Error('Too many arguments passed to ReadData. Max is 10.')
      NumArgs = NumArgs + 1
      ! Check that the number of Fields in the data file is >= to iField
      IF(iField.ge.NFields) CALL Error('Too many arguments passed to ReadData when compared ' //&
           & 'number of fields in file ' // FileName)

      ! If data types have been defined in this file, check for data type errors.
      IF(DataTypes(1).ne.'Unknown') THEN
         ! Check that there are not more arguments than data types.
         IF(iArg.gt.NDataTypes) THEN
            CALL Error('Error: Number of arguments passed to ReadData does not match ' // &
                 & 'that defined in the file ' // FileName)
         END IF

         ! Check that this argument is compatible with the datatype described in DataTypeLine.
         IF( TRIM(ADJUSTL(DataTypes(iArg))).ne.TRIM(ADJUSTL(DTL)) ) THEN
            CALL Error('Error: Arguments passed to ReadData are of different type than those' // &
                 & ' defined in the file ' // FileName // '.')
         END IF
      END IF
    END SUBROUTINE CheckArrayForErrors

    SUBROUTINE GetMaxData
      ! Find the 1st argument.
      IF(PRESENT(Int1)) MaxData = SIZE(Int1)
      IF(PRESENT(Real1)) MaxData = SIZE(Real1)
      IF(PRESENT(Double1)) MaxData = SIZE(Double1)
      IF(PRESENT(Complex1)) MaxData =SIZE(Complex1)
      IF(PRESENT(DComplex1)) MaxData =SIZE(DComplex1)
      IF(PRESENT(String1)) MaxData = SIZE(String1)
    END SUBROUTINE GetMaxData

  END SUBROUTINE ReadArrayData

  ! Subroutine WriteArrayData writes scalar data to the file filename.
  ! Up to 10 arrays of data can be written each specified by using
  ! the optional arguments Int1 - Int10, Real1 - Real10, etc.  
  ! WriteArrayData is very similar to WriteData, except that the data
  ! arguments are arbitrary length arrays instead of scalar valued
  ! variables. All data arrays passed to the routine must be the same
  ! length.
  SUBROUTINE WriteArrayData(FileName,                                      &
       & Int1, Int2, Int3, Int4, Int5, Int6, Int7, Int8, Int9, Int10, &
       & Real1, Real2, Real3, Real4, Real5, Real6, Real7, Real8,      &
       & Real9, Real10,                                               &
       & Double1, Double2, Double3, Double4, Double5, Double6,        &
       & Double7, Double8, Double9, Double10,                         &
       & Complex1, Complex2, Complex3, Complex4, Complex5, Complex6,  &
       & Complex7, Complex8, Complex9, Complex10,                     &
       & DComplex1, DComplex2, DComplex3, DComplex4, DComplex5,       &
       & DComplex6, DComplex7, DComplex8, DComplex9, DComplex10,      &
       & String1, String2, String3, String4, String5, String6,        &
       & String7, String8, String9, String10,                         &
       & Headers, ColumnLabels, WriteDataInHeader, ForceNewSection,   &
       & FileType)
    CHARACTER*(*), INTENT(IN) :: FileName
    INTEGER, INTENT(IN), OPTIONAL :: Int1(:), Int2(:), Int3(:), Int4(:),  Int5(:),    &
         & Int6(:), Int7(:), Int8(:), Int9(:), Int10(:)
    REAL, INTENT(IN), OPTIONAL :: Real1(:), Real2(:), Real3(:), Real4(:), Real5(:),  &
         & Real6(:), Real7(:), Real8(:), Real9(:), Real10(:)
    DOUBLE PRECISION, INTENT(IN), OPTIONAL :: Double1(:), Double2(:),       &
         & Double3(:), Double4(:), Double5(:), Double6(:), Double7(:), Double8(:),      &
         & Double9(:), Double10(:)
    COMPLEX, INTENT(IN), OPTIONAL :: Complex1(:), Complex2(:), Complex3(:),    &
         & Complex4(:), Complex5(:),                                        &
         & Complex6(:), Complex7(:), Complex8(:), Complex9(:), Complex10(:)
    COMPLEX*16, INTENT(IN), OPTIONAL :: DComplex1(:), DComplex2(:),         &
         & DComplex3(:), DComplex4(:), DComplex5(:), DComplex6(:), DComplex7(:),     &
         & DComplex8(:), DComplex9(:), DComplex10(:)
    CHARACTER*(*), INTENT(IN), OPTIONAL :: String1(:), String2(:), String3(:), &
         & String4(:), String5(:), String6(:), String7(:), String8(:), String9(:),      &
         & String10(:)

    CHARACTER*(*),INTENT(IN),OPTIONAL :: Headers(:), ColumnLabels(:), FileType
    LOGICAL,INTENT(IN),OPTIONAL :: WriteDataInHeader, ForceNewSection

    INTEGER NumArgs, NumData, iUnit
    LOGICAL IsPresent(10), HeaderData, txt, pad, NewSection
    CHARACTER(80),ALLOCATABLE :: DataArray(:,:)
    CHARACTER(120) DataTypeLine
    CHARACTER(20) IntFormat, RealFormat, DoubleFormat, ComplexFormat, &
         & DComplexFormat, StringFormat, FileAction
    CHARACTER(80) ColumnLabelFormat
    CHARACTER(10) CLFormats(20)
    CHARACTER(4) TmpStr, FlType

    INTEGER i1, i2, NSections, NColumnLabels
    
    ! Initialization
    HeaderData   = .FALSE.
    IsPresent(:) = .FALSE.
    NumArgs      = 0
    txt          = .TRUE.
    pad         = .FALSE.
    DataTypeLine = ''
    CLFormats(:) = ''
    NColumnLabels = 0
    FlType = 'TXT'

    ! Set the type of file. Default is txt.
    IF(PRESENT(FileType)) THEN
       FlType = TRIM(ADJUSTL(FileType))
       CALL Upper(FlType)
       IF(TRIM(FlType).eq.'TXT') THEN
          txt = .TRUE.
          pad = .FALSE.
       ELSEIF(TRIM(FlType).eq.'PAD') THEN
          pad = .TRUE.
          txt = .FALSE.
       ELSE
          CALL Error('Error: Illegal file type passed to WriteData')
       END IF
    END IF

    IF(PRESENT(ForceNewSection)) THEN
       NewSection = ForceNewSection
    ELSE
       NewSection = .FALSE.
    END IF

    IF(PRESENT(WriteDataInHeader)) HeaderData = WriteDataInHeader

    ! Open the file.
    CALL OpenFl(FileName, FileStatus = 'REPLACE', FileAction = 'WRITE')

    ! Get the formats for each data type, and the FileAction.
    CALL GetIOFileInfo(FileName, IFormat = IntFormat, RFormat = RealFormat, &
         & DFormat = DoubleFormat, CFormat = ComplexFormat, &
         & DCFormat = DComplexFormat, SFormat = StringFormat, FileAction = FileAction)

    ! Check that this file was not already opened for READ.
    IF(TRIM(FileAction).eq.'READ') THEN 
       CALL Error('Error: file ' // FileName // &
            & ' was already opened for reading.', StopProgram = .FALSE.)
       CALL Error("Please use CALL CloseFl('" // FileName // "') before writing.")
    END IF

    ! Find the 1st argument.
    IF(PRESENT(Int1)) CALL SetArgInt(Int1, 1)
    IF(PRESENT(Real1)) CALL SetArgReal(Real1, 1)
    IF(PRESENT(Double1)) CALL SetArgDouble(Double1, 1)
    IF(PRESENT(Complex1)) CALL SetArgComplex(Complex1, 1)
    IF(PRESENT(DComplex1)) CALL SetArgDComplex(DComplex1, 1)
    IF(PRESENT(String1)) CALL SetArgString(String1, 1)

    ! Find the 2nd argument.
    IF(PRESENT(Int2)) CALL SetArgInt(Int2, 2)
    IF(PRESENT(Real2)) CALL SetArgReal(Real2, 2)
    IF(PRESENT(Double2)) CALL SetArgDouble(Double2, 2)
    IF(PRESENT(Complex2)) CALL SetArgComplex(Complex2, 2)
    IF(PRESENT(DComplex2)) CALL SetArgDComplex(DComplex2, 2)
    IF(PRESENT(String2)) CALL SetArgString(String2, 2)

    ! Find the 3rd argument.
    IF(PRESENT(Int3)) CALL SetArgInt(Int3, 3)
    IF(PRESENT(Real3)) CALL SetArgReal(Real3, 3)
    IF(PRESENT(Double3)) CALL SetArgDouble(Double3, 3)
    IF(PRESENT(Complex3)) CALL SetArgComplex(Complex3, 3)
    IF(PRESENT(DComplex3)) CALL SetArgDComplex(DComplex3, 3)
    IF(PRESENT(String3)) CALL SetArgString(String3, 3)

    ! Find the 4th argument.
    IF(PRESENT(Int4)) CALL SetArgInt(Int4, 4)
    IF(PRESENT(Real4)) CALL SetArgReal(Real4, 4)
    IF(PRESENT(Double4)) CALL SetArgDouble(Double4, 4)
    IF(PRESENT(Complex4)) CALL SetArgComplex(Complex4, 4)
    IF(PRESENT(DComplex4)) CALL SetArgDComplex(DComplex4, 4)
    IF(PRESENT(String4)) CALL SetArgString(String4, 4)

    ! Find the 5th argument.
    IF(PRESENT(Int5)) CALL SetArgInt(Int5, 5)
    IF(PRESENT(Real5)) CALL SetArgReal(Real5, 5)
    IF(PRESENT(Double5)) CALL SetArgDouble(Double5, 5)
    IF(PRESENT(Complex5)) CALL SetArgComplex(Complex5, 5)
    IF(PRESENT(DComplex5)) CALL SetArgDComplex(DComplex5, 5)
    IF(PRESENT(String5)) CALL SetArgString(String5, 5)

    ! Find the 6th argument.
    IF(PRESENT(Int6)) CALL SetArgInt(Int6, 6)
    IF(PRESENT(Real6)) CALL SetArgReal(Real6, 6)
    IF(PRESENT(Double6)) CALL SetArgDouble(Double6, 6)
    IF(PRESENT(Complex6)) CALL SetArgComplex(Complex6, 6)
    IF(PRESENT(DComplex6)) CALL SetArgDComplex(DComplex6, 6)
    IF(PRESENT(String6)) CALL SetArgString(String6, 6)

    ! Find the 7th argument.
    IF(PRESENT(Int7)) CALL SetArgInt(Int7, 7)
    IF(PRESENT(Real7)) CALL SetArgReal(Real7, 7)
    IF(PRESENT(Double7)) CALL SetArgDouble(Double7, 7)
    IF(PRESENT(Complex7)) CALL SetArgComplex(Complex7, 7)
    IF(PRESENT(DComplex7)) CALL SetArgDComplex(DComplex7, 7)
    IF(PRESENT(String7)) CALL SetArgString(String7, 7)

    ! Find the 8th argument.
    IF(PRESENT(Int8)) CALL SetArgInt(Int8, 8)
    IF(PRESENT(Real8)) CALL SetArgReal(Real8, 8)
    IF(PRESENT(Double8)) CALL SetArgDouble(Double8, 8)
    IF(PRESENT(Complex8)) CALL SetArgComplex(Complex8, 8)
    IF(PRESENT(DComplex8)) CALL SetArgDComplex(DComplex8, 8)
    IF(PRESENT(String8)) CALL SetArgString(String8, 8)

    ! Find the 9th argument.
    IF(PRESENT(Int9)) CALL SetArgInt(Int9, 9)
    IF(PRESENT(Real9)) CALL SetArgReal(Real9, 9)
    IF(PRESENT(Double9)) CALL SetArgDouble(Double9, 9)
    IF(PRESENT(Complex9)) CALL SetArgComplex(Complex9, 9)
    IF(PRESENT(DComplex9)) CALL SetArgDComplex(DComplex9, 9)
    IF(PRESENT(String9)) CALL SetArgString(String9, 9)

    ! Find the 10th argument.
    IF(PRESENT(Int10)) CALL SetArgInt(Int10, 10)
    IF(PRESENT(Real10)) CALL SetArgReal(Real10, 10)
    IF(PRESENT(Double10)) CALL SetArgDouble(Double10, 10)
    IF(PRESENT(Complex10)) CALL SetArgComplex(Complex10, 10)
    IF(PRESENT(DComplex10)) CALL SetArgDComplex(DComplex10, 10)
    IF(PRESENT(String10)) CALL SetArgString(String10, 10)

    ! Get the unit number
    CALL GetIOFileInfo(FileName,UnitNumber = iUnit,NSections = NSections)

    ! If data type line is different that last, write a new section header and 
    ! data type line.
    IF(WritingNewSection(FileName,DataTypeLine).or.NewSection) THEN
       NSections = NSections + 1

       WRITE(iUnit,'(A,I4)') '#SN#   Section: ', NSections
       WRITE(iUnit,'(A)') '#DF# This section written in ' // FlType // '.'
       WRITE(iUnit,'(A)') '#H#'

       WRITE(iUnit,'(A)') '#H# The following data types are written in this section.'
       WRITE(iUnit,'(2A)') '#DT# ', TRIM(DataTypeLine)
       CALL SetIOFileInfo(FileName,NSections = NSections, DataTypeLine = TRIM(DataTypeLine))

       ! If headers are present, write them
       IF(PRESENT(Headers)) THEN
          DO i1 = 1, SIZE(Headers)
             IF((LEN_TRIM(Headers(i1)).gt.0).and.(ICHAR(Headers(i1)(1:1)).ne.0)) &
                  & WRITE(iUnit,'(2A)') '#H# ', TRIM(Headers(i1))
          END DO
       END IF

       ! If column labels are present, get the columnlable format and write them.
       IF(PRESENT(ColumnLabels)) THEN
          ColumnLabelFormat = '(A5, '
          DO i1 = 1, NColumnLabels - 1
             ColumnLabelFormat = TRIM(ColumnLabelFormat) // TRIM(CLFormats(i1)) // ', '
          END DO
          ColumnLabelFormat = TRIM(ColumnLabelFormat) // TRIM(CLFormats(NColumnLabels)) // ')'
          WRITE(iUnit,ColumnLabelFormat) '#CL# ', (TRIM(ColumnLabels(i1)) // ' ', i1 = 1, NColumnLabels)
       END IF
       ! If only headers are present, don't update the section or write a data type line.
    ELSEIF(PRESENT(Headers).and.(NumArgs.eq.0)) THEN
       DO i1 = 1, SIZE(Headers)
          IF((LEN_TRIM(Headers(i1)).gt.0).and.(ICHAR(Headers(i1)(1:1)).ne.0)) &
               & WRITE(iUnit,'(2A)') '#H# ', TRIM(Headers(i1))
       END DO
    END IF

    ! Write data line.
    IF(HeaderData) THEN
       DO i1 = 1, NumData
          WRITE(iUnit, '(11A)') '#HD# ', (TRIM(DataArray(i1,i2)) // ' ', i2 = 1, NumArgs)
       END DO
    ELSE
       DO i1 = 1, NumData
          WRITE(iUnit, '(11A)') (TRIM(DataArray(i1,i2)) // ' ', i2 = 1, NumArgs)
       END DO
    END IF

    DEALLOCATE(DataArray)

  CONTAINS

    SUBROUTINE SetArgInt(Arg, iArg)
      INTEGER,INTENT(IN) :: Arg(:)
      INTEGER,INTENT(IN) :: iArg

      ! Check for errors, increment number of args,
      ! set numdata if this is the first argument, and write data to string
      ! array.
      CALL CheckForErrors(iArg,SIZE(Arg),'Int')

      ! Write the data to the character array with the right format.
      ! For now fileformat is txt only.
      IF(txt) THEN
         DO i1 = 1, NumData
            WRITE(DataArray(i1, iArg), IntFormat) Arg(i1)
         END DO
      ELSEIF(pad) THEN
         DO i1 = 1, NumData
            CALL WritePAD(DataArray(i1, iArg),Arg(i1))
         END DO
      END IF

      ! Set the columnlabel format string
      IF(PRESENT(ColumnLabels)) THEN
         NColumnLabels = NColumnLabels + 1
         IF((iArg.eq.1).and.txt) THEN
            WRITE(TmpStr,'(I3)') LEN_TRIM(DataArray(1,iArg)) - 4
         ELSE
            WRITE(TmpStr,'(I3)') LEN_TRIM(DataArray(1,iArg)) + 1
         END IF
         CLFormats(NColumnLabels) = 'A' // TRIM(ADJUSTL(TmpStr))
      END IF
    END SUBROUTINE SetArgInt

    SUBROUTINE SetArgReal( Arg, iArg)
      REAL,INTENT(IN) :: Arg(:)
      INTEGER,INTENT(IN) :: iArg
      ! Check for errors, increment number of args,
      ! set numdata if this is the first argument, and write data to string
      ! array.
      CALL CheckForErrors(iArg,SIZE(Arg),'Real')

      ! Write the data to the character array with the right format.
      ! For now fileformat is txt only.
      IF(txt) THEN
         DO i1 = 1, NumData
            WRITE(DataArray(i1, iArg), RealFormat) Arg(i1)
         END DO
      ELSEIF(pad) THEN
         DO i1 = 1, NumData
            CALL WritePAD(DataArray(i1, iArg), npadrDefault, Arg(i1))
         END DO
      END IF

      ! Set the columnlabel format string
      IF(PRESENT(ColumnLabels)) THEN
         NColumnLabels = NColumnLabels + 1
         IF((iArg.eq.1).and.txt) THEN
            WRITE(TmpStr,'(I3)') LEN_TRIM(DataArray(1,iArg)) - 4
         ELSE
            WRITE(TmpStr,'(I3)') LEN_TRIM(DataArray(1,iArg)) + 1
         END IF
         CLFormats(NColumnLabels) = 'A' // TRIM(ADJUSTL(TmpStr))
      END IF
    END SUBROUTINE SetArgReal

    SUBROUTINE SetArgDouble( Arg, iArg)
      DOUBLE PRECISION,INTENT(IN) :: Arg(:)
      INTEGER,INTENT(IN) :: iArg
      ! Check for errors, increment number of args,
      ! set numdata if this is the first argument, and write data to string
      ! array.
      CALL CheckForErrors(iArg,SIZE(Arg),'Double')

      ! Write the data to the character array with the right format.
      ! For now fileformat is txt only.
      IF(txt) THEN
         DO i1 = 1, NumData
            WRITE(DataArray(i1, iArg), DoubleFormat) Arg(i1)
         END DO
      ELSEIF(pad) THEN
         DO i1 = 1, NumData
            CALL WritePAD(DataArray(i1, iArg), npadxDefault, Arg(i1))
         END DO
      END IF

      ! Set the columnlabel format string
      IF(PRESENT(ColumnLabels)) THEN
         NColumnLabels = NColumnLabels + 1
         IF((iArg.eq.1).and.txt) THEN
            WRITE(TmpStr,'(I3)') LEN_TRIM(DataArray(1,iArg)) - 4
         ELSE
            WRITE(TmpStr,'(I3)') LEN_TRIM(DataArray(1,iArg)) + 1
         END IF
         CLFormats(NColumnLabels) = 'A' // TRIM(ADJUSTL(TmpStr))
      END IF
    END SUBROUTINE SetArgDouble

    SUBROUTINE SetArgComplex( Arg, iArg)
      COMPLEX,INTENT(IN) :: Arg(:)
      INTEGER,INTENT(IN) :: iArg
      ! Check for errors, increment number of args,
      ! set numdata if this is the first argument, and write data to string
      ! array.
      CALL CheckForErrors(iArg,SIZE(Arg),'Complex')

      ! Write the data to the character array with the right format.
      ! For now fileformat is txt only.
      IF(txt) THEN
         DO i1 = 1, NumData
            WRITE(DataArray(i1, iArg), ComplexFormat) REAL(Arg(i1)), IMAG(Arg(i1))
         END DO
      ELSEIF(pad) THEN
         DO i1 = 1, NumData
            CALL WritePAD(DataArray(i1, iArg), npadrDefault, Arg(i1))
         END DO
      END IF

      ! Set the columnlabel format string
      IF(PRESENT(ColumnLabels)) THEN
         NColumnLabels = NColumnLabels + 2
         IF((iArg.eq.1).and.txt) THEN
            WRITE(TmpStr,'(I3)') INT(LEN_TRIM(DataArray(1, iArg))/2) - 4
            CLFormats(NColumnLabels - 1) = 'A' // TRIM(ADJUSTL(TmpStr))
            WRITE(TmpStr,'(I3)') INT(LEN_TRIM(DataArray(1, iArg))/2) + 1
            CLFormats(NColumnLabels) = 'A' // TRIM(ADJUSTL(TmpStr))
         ELSE
            WRITE(TmpStr,'(I3)') INT(LEN_TRIM(DataArray(1, iArg))/2) + 1
            CLFormats(NColumnLabels - 1) = 'A' // TRIM(ADJUSTL(TmpStr))
            CLFormats(NColumnLabels) = 'A' // TRIM(ADJUSTL(TmpStr))
         END IF
      END IF
    END SUBROUTINE SetArgComplex

    SUBROUTINE SetArgDComplex( Arg, iArg)
      COMPLEX*16,INTENT(IN) :: Arg(:)
      INTEGER,INTENT(IN) :: iArg
      ! Check for errors, increment number of args,
      ! set numdata if this is the first argument, and write data to string
      ! array.
      CALL CheckForErrors(iArg,SIZE(Arg),'DComplex')

      ! Write the data to the character array with the right format.
      ! For now fileformat is txt only.
      IF(txt) THEN
         DO i1 = 1, NumData
            WRITE(DataArray(i1, iArg), DComplexFormat) DBLE(Arg(i1)), DIMAG(Arg(i1))
         END DO
      ELSEIF(pad) THEN
         DO i1 = 1, NumData
            CALL WritePAD(DataArray(i1, iArg), npadxDefault, Arg(i1))
         END DO
      END IF

      ! Set the columnlabel format string
      IF(PRESENT(ColumnLabels)) THEN
         NColumnLabels = NColumnLabels + 2
         IF((iArg.eq.1).and.txt) THEN
            WRITE(TmpStr,'(I3)') INT(LEN_TRIM(DataArray(1, iArg))/2) - 4
            CLFormats(NColumnLabels - 1) = 'A' // TRIM(ADJUSTL(TmpStr))
            WRITE(TmpStr,'(I3)') INT(LEN_TRIM(DataArray(1, iArg))/2) + 1
            CLFormats(NColumnLabels) = 'A' // TRIM(ADJUSTL(TmpStr))
         ELSE
            WRITE(TmpStr,'(I3)') INT(LEN_TRIM(DataArray(1, iArg))/2) + 1
            CLFormats(NColumnLabels - 1) = 'A' // TRIM(ADJUSTL(TmpStr))
            CLFormats(NColumnLabels) = 'A' // TRIM(ADJUSTL(TmpStr))
         END IF
      END IF
    END SUBROUTINE SetArgDComplex

    SUBROUTINE SetArgString( Arg, iArg)
      CHARACTER*(*),INTENT(IN) :: Arg(:)
      CHARACTER(MaxStrLen) TmpStr
      INTEGER,INTENT(IN) :: iArg
      ! Check for errors, increment number of args,
      ! set numdata if this is the first argument, and write data to string
      ! array.
      CALL CheckForErrors(iArg,SIZE(Arg),'String')

      ! Write the data to the character array with the right format.
      ! For now fileformat is txt only.
      IF(txt) THEN
         DO i1 = 1, NumData
            ! Check that the string is not too long.
            TmpStr = TRIM(ADJUSTL(Arg(i1)))
            IF(LEN_TRIM(Arg(i1)).gt.MaxStrLen) CALL Error('Warning: String argument is too long in WriteArrayData. ' // &
                 & 'Will be truncated.' , StopProgram = .FALSE.)
            WRITE(DataArray(i1, iArg), StringFormat) TRIM(TmpStr)
         END DO
      ELSEIF(pad) THEN
         DO i1 = 1, NumData
            ! Check that the string is not too long.
            TmpStr = TRIM(ADJUSTL(Arg(i1)))
            IF(LEN_TRIM(Arg(i1)).gt.MaxStrLen) CALL Error('Warning: String argument is too long in WriteArrayData. ' // &
                 & 'Will be truncated.' , StopProgram = .FALSE.)

            CALL WritePAD(DataArray(i1,iArg),TRIM(TmpStr))
         END DO
      END IF

      ! Set the columnlabel format string
      IF(PRESENT(ColumnLabels)) THEN
         NColumnLabels = NColumnLabels + 1
         IF((iArg.eq.1).and.txt) THEN
            WRITE(TmpStr,'(I3)') LEN_TRIM(DataArray(1,iArg)) - 4
         ELSE
            WRITE(TmpStr,'(I3)') LEN_TRIM(DataArray(1,iArg)) + 1
         END IF
         CLFormats(NColumnLabels) = 'A' // TRIM(ADJUSTL(TmpStr))
      END IF
    END SUBROUTINE SetArgString

    SUBROUTINE CheckForErrors(iArg,ArgSize,DTL)
      INTEGER,INTENT(IN) :: iArg, ArgSize
      CHARACTER*(*) DTL
      CHARACTER(2) ArgNum
      INTEGER iAllocateError
      ArgNum=''
      WRITE(ArgNum,'(I2)') iArg

      IF(IsPresent(iArg)) THEN
         CALL Error('Error in WriteData multiple arguments in place ' // TRIM(ArgNum) // '.')
      END IF

      ! Set IsPresent(iArg)
      IsPresent(iArg) = .TRUE.

      ! Check that number of arguments is not too large. Redundant, but oh well.
      IF(NumArgs.ge.iArg) CALL Error('Too many arguments passed to WriteData. Max is 10.')
      NumArgs = NumArgs + 1

      ! If this is the first data argument, set the size of the arrays and allocate space, 
      ! otherwise check that this array is the same size as the first array.        
      IF(iArg.eq.1) THEN
         NumData = ArgSize
         ALLOCATE(DataArray(NumData,10), STAT = iAllocateError)
         CALL CheckAllocation(iAllocateError, 'Error: Failed to allocate space for DataArray' //&
              & ' in subroutine WriteArrayData.')
      ELSE
         IF(NumData.ne.ArgSize) THEN
            CALL Error('Error in writearray: All arrays must be same size.')
         END IF
      END IF

      ! Set data type line
      DataTypeLine = TRIM(DataTypeLine) // ' ' // TRIM(DTL)
    END SUBROUTINE CheckForErrors

  END SUBROUTINE WriteArrayData


  ! SUBROUTINE WriteInt2D writes a 2D integer array to file.
  SUBROUTINE WriteInt2D(FileName,IntArray,Headers, FileType, WriteDataInHeader)
    CHARACTER*(*),INTENT(IN) :: FileName
    INTEGER,INTENT(IN) :: IntArray(:,:)
    CHARACTER*(*),INTENT(IN),OPTIONAL :: Headers(:), FileType
    LOGICAL,INTENT(IN),OPTIONAL :: WriteDataInHeader

    INTEGER iUnit, N1, N2, i1, i2, iError, NSections, iFlType
    CHARACTER(100) IntFormat, DataStr
    CHARACTER(4) FlType
    LOGICAL HeaderData

    ! Define file types.
    INTEGER itxt, ipad
    PARAMETER(itxt = 1, ipad = 2)
    
    HeaderData = .FALSE.
    IF(PRESENT(WriteDataInHeader)) HeaderData = WriteDataInHeader

    IF(PRESENT(FileType)) THEN
       FlType = TRIM(ADJUSTL(FileType))
       CALL Upper(FlType)
       IF(TRIM(FlType).eq.'TXT') THEN
          iFlType = itxt
       ELSEIF(TRIM(FlType).eq.'PAD') THEN
          iFlType = ipad
       ELSE
          CALL Error('Illegal FileType passed to Write2D.')
       END IF
    END IF

    CALL OpenFl(FileName)
    CALL GetIOFileInfo(FileName, UnitNumber = iUnit, IFormat = IntFormat, &
         & NSections = NSections)

    N1 = SIZE(IntArray,1)
    N2 = SIZE(IntArray,2)

    ! Write the section number.
    WRITE(iUnit,'(A,I4)') '#SN#   Section: ', NSections + 1
    WRITE(iUnit,'(A)') '#DF# This section written in ' // FlType // '.'
    WRITE(iUnit,'(A)') '#H#'

    ! Write info about this array
    WRITE(iUnit,'(A,I4,I4)') '#DT# 2D integer array with sizes ', N1, N2
    WRITE(iUnit,'(A)') '#H# File is organized as follows:  Array(1,i)     Array(1,i+1)    Array(1,i+2)  . . .'
    WRITE(iUnit,'(A)') '#H#                                Array(2,i)'
    WRITE(iUnit,'(A)') '#H#                                     .'
    WRITE(iUnit,'(A)') '#H#                                     .'
    WRITE(iUnit,'(A)') '#H#                                     .'

    ! Write headers if they exist
    IF(PRESENT(Headers)) THEN
       CALL WriteData(FileName, Headers = Headers)
    END IF

    ! Write data to file.
    DO i1 = 1, N1
       ! If User has specified that data should be written in the header, do so
       IF(HeaderData.and.(iFlType.eq.itxt)) WRITE(iUnit, '(A)', ADVANCE = 'NO', IOSTAT = iError) '#HD# '
       DO i2 = 1, N2
          IF(iFlType.eq.itxt) THEN
             WRITE(iUnit,IntFormat, ADVANCE = 'NO',IOSTAT = iError) IntArray(i1,i2)
             IF(iError.ne.0) CALL Error('Error in WriteInt2D while trying to write to file: ' //&
                  & FileName)
          ELSEIF(iFlType.eq.ipad) THEN
             CALL WritePAD(DataStr,IntArray(i1,i2))
             WRITE(iUnit,'(A)', ADVANCE = 'NO',IOSTAT = iError) TRIM(DataStr) // ' '
          END IF
       END DO
       WRITE(iUnit,*, IOSTAT = iError)
    END DO

    ! Increment the section number
    CALL SetIOFileInfo(FileName, NSections = NSections + 1)
  END SUBROUTINE WriteInt2D

  ! SUBROUTINE WriteReal2D writes a 2D integer array to file.
  SUBROUTINE WriteReal2D(FileName,RealArray,Headers,FileType,WriteDataInHeader)
    CHARACTER*(*),INTENT(IN) :: FileName
    CHARACTER*(*),INTENT(IN),OPTIONAL :: Headers(:), FileType
    REAL,INTENT(IN) :: RealArray(:,:)
    LOGICAL,INTENT(IN),OPTIONAL :: WriteDataInHeader

    INTEGER iUnit, N1, N2, i1, i2, iError, NSections, iFlType
    CHARACTER(100) RealFormat, DataStr ! , IntFormat
    CHARACTER(4) FlType
    LOGICAL HeaderData

    ! Define file types.
    INTEGER itxt, ipad
    PARAMETER(itxt = 1, ipad = 2)

    HeaderData = .FALSE.
    IF(PRESENT(WriteDataInHeader)) HeaderData = WriteDataInHeader
    
    IF(PRESENT(FileType)) THEN
       FlType = TRIM(ADJUSTL(FileType))
       CALL Upper(FlType)
       IF(TRIM(FlType).eq.'TXT') THEN
          iFlType = itxt
       ELSEIF(TRIM(FlType).eq.'PAD') THEN
          iFlType = ipad
       ELSE
          CALL Error('Illegal FileType passed to Write2D.')
       END IF
    END IF

    CALL OpenFl(FileName)
    CALL GetIOFileInfo(FileName, UnitNumber = iUnit, RFormat = RealFormat, &
         & NSections = NSections)

    N1 = SIZE(RealArray,1)
    N2 = SIZE(RealArray,2)

    ! Write the section number.
    WRITE(iUnit,'(A,I4)') '#SN#   Section: ', NSections + 1
    WRITE(iUnit,'(A)') '#DF# This section written in ' // FlType // '.'
    WRITE(iUnit,'(A)') '#H#'

    ! Write some other information
    WRITE(iUnit,'(A,I4,I4)') '#DT# 2D real array with sizes ', N1, N2
    WRITE(iUnit,'(A)') '#H# File is organized as follows:  Array(1,i)     Array(1,i+1)    Array(1,i+2)  . . .'
    WRITE(iUnit,'(A)') '#H#                                Array(2,i)'
    WRITE(iUnit,'(A)') '#H#                                     .'
    WRITE(iUnit,'(A)') '#H#                                     .'
    WRITE(iUnit,'(A)') '#H#                                     .'

    ! Write headers if they exist
    IF(PRESENT(Headers)) THEN
       CALL WriteData(FileName, Headers = Headers)
    END IF

    ! Write the data.
    DO i1 = 1, N1
       ! If User has specified that data should be written in the header, do so
       IF(HeaderData.and.(iFlType.eq.itxt)) WRITE(iUnit, '(A)', ADVANCE = 'NO', IOSTAT = iError) '#HD# '
       DO i2 = 1, N2
          IF(iFlType.eq.itxt) THEN
             WRITE(iUnit,RealFormat, ADVANCE = 'NO',IOSTAT = iError) RealArray(i1,i2)
             IF(iError.ne.0) CALL Error('Error in WriteReal2D while trying to write to file: ' //&
                  & FileName)
          ELSEIF(iFlType.eq.ipad) THEN
             CALL WritePAD(DataStr,npadrDefault,RealArray(i1,i2))
             WRITE(iUnit,'(A)', ADVANCE = 'NO',IOSTAT = iError) TRIM(DataStr) // ' '
             IF(iError.ne.0) CALL Error('Error in WriteReal2D while trying to write to file: ' //&
                  & FileName)
          END IF
       END DO
       WRITE(iUnit,*, IOSTAT = iError)
    END DO

    ! Increment the section number
    CALL SetIOFileInfo(FileName, NSections = NSections + 1)
  END SUBROUTINE WriteReal2D

  ! SUBROUTINE WriteReal2D writes a 2D integer array to file.
  SUBROUTINE WriteDouble2D(FileName,DoubleArray,Headers,FileType,WriteDataInHeader)
    CHARACTER*(*),INTENT(IN) :: FileName
    CHARACTER*(*),INTENT(IN),OPTIONAL :: Headers(:), FileType
    DOUBLE PRECISION,INTENT(IN) :: DoubleArray(:,:)
    LOGICAL,INTENT(IN),OPTIONAL :: WriteDataInHeader

    INTEGER iUnit, N1, N2, i1, i2, iError, NSections, iFlType
    CHARACTER(100) DoubleFormat, DataStr ! , IntFormat
    CHARACTER(4) FlType
    LOGICAL HeaderData

    ! Define file types.
    INTEGER itxt, ipad
    PARAMETER(itxt = 1, ipad = 2)

    HeaderData = .FALSE.
    IF(PRESENT(WriteDataInHeader)) HeaderData = WriteDataInHeader

    iFlType = 1
    IF(PRESENT(FileType)) THEN
       FlType = TRIM(ADJUSTL(FileType))
       CALL Upper(FlType)
       IF(TRIM(FlType).eq.'TXT') THEN
          iFlType = itxt
       ELSEIF(TRIM(FlType).eq.'PAD') THEN
          iFlType = ipad
       ELSE
          CALL Error('Illegal FileType passed to Write2D.')
       END IF
    END IF

    CALL OpenFl(FileName)
    CALL GetIOFileInfo(FileName, UnitNumber = iUnit, DFormat = DoubleFormat, &
         & NSections = NSections)

    N1 = SIZE(DoubleArray,1)
    N2 = SIZE(DoubleArray,2)

    ! Write the section number.
    WRITE(iUnit,'(A,I4)') '#SN#   Section: ', NSections + 1
    WRITE(iUnit,'(A)') '#DF# This section written in ' // FlType // '.'
    WRITE(iUnit,'(A)') '#H#'

    ! Write some other information
    WRITE(iUnit,'(A,I4,I4)') '#DT# 2D double array with sizes ', N1, N2
    WRITE(iUnit,'(A)') '#H# File is organized as follows:  Array(1,i)     Array(1,i+1)    Array(1,i+2)  . . .'
    WRITE(iUnit,'(A)') '#H#                                Array(2,i)'
    WRITE(iUnit,'(A)') '#H#                                     .'
    WRITE(iUnit,'(A)') '#H#                                     .'
    WRITE(iUnit,'(A)') '#H#                                     .'

    ! Write headers if they exist
    IF(PRESENT(Headers)) THEN
       CALL WriteData(FileName, Headers = Headers)
    END IF

    ! Write the data.
    DO i1 = 1, N1
       ! If User has specified that data should be written in the header, do so
       IF(HeaderData.and.(iFlType.eq.itxt)) WRITE(iUnit, '(A)', ADVANCE = 'NO', IOSTAT = iError) '#HD# '
       DO i2 = 1, N2
          IF(iFlType.eq.itxt) THEN
             WRITE(iUnit,DoubleFormat,IOSTAT = iError, ADVANCE = 'NO') DoubleArray(i1,i2)
             IF(iError.ne.0) CALL Error('Error in WriteReal2D while trying to write to file: ' //&
                  & FileName)
          ELSEIF(iFlType.eq.ipad) THEN
             CALL WritePAD(DataStr,npadxDefault,DoubleArray(i1,i2))
             WRITE(iUnit,'(A)',IOSTAT = iError, ADVANCE = 'NO') TRIM(DataStr) // ' '
             IF(iError.ne.0) CALL Error('Error in WriteReal2D while trying to write to file: ' //&
                  & FileName)
          END IF
       END DO
       WRITE(iUnit,*)
    END DO

    ! Increment the section number
    CALL SetIOFileInfo(FileName, NSections = NSections + 1)
  END SUBROUTINE WriteDouble2D

  ! SUBROUTINE WriteComplex2D writes a 2D integer array to file.
  SUBROUTINE WriteComplex2D(FileName,ComplexArray,Headers,FileType,WriteDataInHeader)
    CHARACTER*(*),INTENT(IN) :: FileName
    CHARACTER*(*),INTENT(IN),OPTIONAL :: Headers(:), FileType
    COMPLEX,INTENT(IN) :: ComplexArray(:,:)
    LOGICAL,INTENT(IN),OPTIONAL :: WriteDataInHeader

    INTEGER iUnit, N1, N2, i1, i2, iError, NSections, iFlType
    CHARACTER(100) ComplexFormat, DataStr ! , IntFormat
    CHARACTER(4) FlType
    LOGICAL HeaderData

    ! Define file types.
    INTEGER itxt, ipad
    PARAMETER(itxt = 1, ipad = 2)

    HeaderData = .FALSE.
    IF(PRESENT(WriteDataInHeader)) HeaderData = WriteDataInHeader
    
    iFlType = itxt
    IF(PRESENT(FileType)) THEN
       FlType = TRIM(ADJUSTL(FileType))
       CALL Upper(FlType)
       IF(TRIM(FlType).eq.'TXT') THEN
          iFlType = itxt
       ELSEIF(TRIM(FlType).eq.'PAD') THEN
          iFlType = ipad
       ELSE
          CALL Error('Illegal FileType passed to Write2D.')
       END IF
    END IF

    CALL OpenFl(FileName)
    CALL GetIOFileInfo(FileName, UnitNumber = iUnit, CFormat = ComplexFormat, &
         & NSections = NSections)

    N1 = SIZE(ComplexArray,1)
    N2 = SIZE(ComplexArray,2)
    ! Write the section number.
    WRITE(iUnit,'(A,I4)') '#SN#   Section: ', NSections + 1
    WRITE(iUnit,'(A)') '#DF# This section written in ' // FlType // '.'
    WRITE(iUnit,'(A)') '#H#'

    ! Write some other information
    WRITE(iUnit,'(A,I4,I4)') '#DT# 2D complex array with sizes ', N1, N2
    WRITE(iUnit,'(A)') '#H# File is organized as follows:  Array(1,i)     Array(1,i+1)    Array(1,i+2)  . . .'
    WRITE(iUnit,'(A)') '#H#                                Array(2,i)'
    WRITE(iUnit,'(A)') '#H#                                     .'
    WRITE(iUnit,'(A)') '#H#                                     .'
    WRITE(iUnit,'(A)') '#H#                                     .'

    ! Write headers if they exist
    IF(PRESENT(Headers)) THEN
       CALL WriteData(FileName, Headers = Headers)
    END IF

    ! Write the data.
    DO i1 = 1, N1
       ! If User has specified that data should be written in the header, do so
       IF(HeaderData.and.(iFlType.eq.itxt)) WRITE(iUnit, '(A)', ADVANCE = 'NO', IOSTAT = iError) '#HD# '
       DO i2 = 1, N2
          IF(iFlType.eq.itxt) THEN
             WRITE(iUnit,ComplexFormat, ADVANCE = 'NO',IOSTAT = iError) REAL(ComplexArray(i1,i2)),  &
                  & IMAG(ComplexArray(i1,i2))
             IF(iError.ne.0) CALL Error('Error in WriteComplex2D while trying to write to file: ' //&
                  & FileName)
          ELSEIF(iFlType.eq.ipad) THEN
             CALL WritePAD(DataStr,npadrDefault,ComplexArray(i1,i2))
             WRITE(iUnit,'(A)', ADVANCE = 'NO',IOSTAT = iError) TRIM(DataStr) // ' '
             IF(iError.ne.0) CALL Error('Error in WriteReal2D while trying to write to file: ' //&
                  & FileName)
          END IF
       END DO
       WRITE(iUnit,*, IOSTAT = iError)
    END DO

    ! Increment the section number
    CALL SetIOFileInfo(FileName, NSections = NSections + 1)
  END SUBROUTINE WriteComplex2D

  ! SUBROUTINE WriteDComplex2D writes a 2D integer array to file.
  SUBROUTINE WriteDComplex2D(FileName,DComplexArray,Headers,FileType,WriteDataInHeader)
    CHARACTER*(*),INTENT(IN) :: FileName
    CHARACTER*(*),INTENT(IN),OPTIONAL :: Headers(:), FileType
    COMPLEX*16,INTENT(IN) :: DComplexArray(:,:)
    LOGICAL,INTENT(IN),OPTIONAL :: WriteDataInHeader

    INTEGER iUnit, N1, N2, i1, i2, iError, NSections, iFlType
    CHARACTER(100) DComplexFormat, DataStr
    CHARACTER(4) FlType
    LOGICAL HeaderData

    ! Define file types.
    INTEGER itxt, ipad
    PARAMETER(itxt = 1, ipad = 2)

    HeaderData = .FALSE.
    IF(PRESENT(WriteDataInHeader)) HeaderData = WriteDataInHeader
    
    IF(PRESENT(FileType)) THEN
       FlType = TRIM(ADJUSTL(FileType))
       CALL Upper(FlType)
       IF(TRIM(FlType).eq.'TXT') THEN
          iFlType = itxt
       ELSEIF(TRIM(FlType).eq.'PAD') THEN
          iFlType = ipad
       ELSE
          CALL Error('Illegal FileType passed to Write2D.')
       END IF
    END IF

    CALL OpenFl(FileName)
    CALL GetIOFileInfo(FileName, UnitNumber = iUnit, DCFormat = DComplexFormat, &
         & NSections = NSections)

    N1 = SIZE(DComplexArray,1)
    N2 = SIZE(DComplexArray,2)

    ! Write the section number.
    WRITE(iUnit,'(A,I4)') '#SN#   Section: ', NSections + 1
    WRITE(iUnit,'(A)') '#DF# This section written in ' // FlType // '.'
    WRITE(iUnit,'(A)') '#H#'

    ! Write some other information
    WRITE(iUnit,'(A,I4,I4)') '#DT# 2D double complex array with sizes ', N1, N2
    WRITE(iUnit,'(A,I4,I4)') '#DT# 2D complex array with sizes ', N1, N2
    WRITE(iUnit,'(A)') '#H# File is organized as follows:  Array(1,i)     Array(1,i+1)    Array(1,i+2)  . . .'
    WRITE(iUnit,'(A)') '#H#                                Array(2,i)'
    WRITE(iUnit,'(A)') '#H#                                     .'
    WRITE(iUnit,'(A)') '#H#                                     .'
    WRITE(iUnit,'(A)') '#H#                                     .'

    ! Write headers if they exist
    IF(PRESENT(Headers)) THEN
       CALL WriteData(FileName, Headers = Headers)
    END IF

    ! Write the data.
    DO i1 = 1, N1
       ! If User has specified that data should be written in the header, do so
       IF(HeaderData.and.(iFlType.eq.itxt)) WRITE(iUnit, '(A)', ADVANCE = 'NO', IOSTAT = iError) '#HD# '
       DO i2 = 1, N2
          IF(iFlType.eq.itxt) THEN
             WRITE(iUnit,DComplexFormat, ADVANCE = 'NO',IOSTAT = iError) DBLE(DComplexArray(i1,i2)),  &
                  & DIMAG(DComplexArray(i1,i2))
             IF(iError.ne.0) CALL Error('Error in WriteDComplex2D while trying to write to file: ' // &
                  & FileName)
          ELSEIF(iFlType.eq.ipad) THEN
             CALL WritePAD(DataStr,npadrDefault,DComplexArray(i1,i2))
             WRITE(iUnit,'(A)', ADVANCE = 'NO',IOSTAT = iError) TRIM(DataStr) // ' '
             IF(iError.ne.0) CALL Error('Error in WriteReal2D while trying to write to file: ' //&
                  & FileName)
          END IF
       END DO
       WRITE(iUnit,*, IOSTAT = iError)
    END DO

    ! Increment the section number
    CALL SetIOFileInfo(FileName, NSections = NSections + 1)
  END SUBROUTINE WriteDComplex2D

  ! SUBROUTINE WriteString2D writes a 2D integer array to file.
  SUBROUTINE WriteString2D(FileName,StringArray,Headers,FileType,WriteDataInHeader)
    CHARACTER*(*),INTENT(IN) :: FileName
    CHARACTER*(*),INTENT(IN),OPTIONAL :: Headers(:), FileType
    CHARACTER*(*),INTENT(IN) :: StringArray(:,:)
    LOGICAL,INTENT(IN),OPTIONAL :: WriteDataInHeader

    INTEGER iUnit, N1, N2, i1, i2, iError, NSections
    CHARACTER(100) StringFormat
    ! CHARACTER(4) FlType
    INTEGER iFlType
    LOGICAL HeaderData

    ! Define file types.
    INTEGER itxt ! , ipad
    PARAMETER(itxt = 1) ! , ipad = 2)

    iFlType = 1
    HeaderData = .FALSE.
    IF(PRESENT(WriteDataInHeader)) HeaderData = WriteDataInHeader
    
    CALL OpenFl(FileName)
    CALL GetIOFileInfo(FileName, UnitNumber = iUnit, SFormat = StringFormat, &
         & NSections = NSections)

    N1 = SIZE(StringArray,1)
    N2 = SIZE(StringArray,2)

    ! Write the section number.
    WRITE(iUnit,'(A,I4)') '#SN#   Section: ', NSections + 1
    WRITE(iUnit,'(A)') '#H#'

    ! Write some other information
    WRITE(iUnit,'(A,I4,I4)') '#DT# 2D double complex array with sizes ', N1, N2
    WRITE(iUnit,'(A,I4,I4)') '#DT# 2D double complex array with sizes ', N1, N2
    WRITE(iUnit,'(A,I4,I4)') '#DT# 2D complex array with sizes ', N1, N2
    WRITE(iUnit,'(A)') '#H# File is organized as follows:  Array(1,i)     Array(1,i+1)    Array(1,i+2)  . . .'
    WRITE(iUnit,'(A)') '#H#                                Array(2,i)'
    WRITE(iUnit,'(A)') '#H#                                     .'
    WRITE(iUnit,'(A)') '#H#                                     .'
    WRITE(iUnit,'(A)') '#H#                                     .'

    ! Write headers if they exist
    IF(PRESENT(Headers)) THEN
       CALL WriteData(FileName, Headers = Headers)
    END IF

    ! Write the data.
    DO i1 = 1, N1
       ! If User has specified that data should be written in the header, do so
       IF(HeaderData.and.(iFlType.eq.itxt)) WRITE(iUnit, '(A)', ADVANCE = 'NO', IOSTAT = iError) '#HD# '
       DO i2 = 1, N2
          WRITE(iUnit,StringFormat, ADVANCE = 'NO',IOSTAT = iError) TRIM(ADJUSTL(StringArray(i1,i2)))
          IF(iError.ne.0) CALL Error('Error in WriteString2D while trying to write to file: ' //&
               & FileName)

          ! Write some space between elements
          WRITE(iUnit,'(A)', ADVANCE = 'NO') '  '
       END DO
       WRITE(iUnit,*, IOSTAT = iError)
    END DO

    ! Increment the section number
    CALL SetIOFileInfo(FileName, NSections = NSections + 1)
  END SUBROUTINE WriteString2D

  ! SUBROUTINE ReadInt2D reads a 2D integer array from file.
  SUBROUTINE ReadInt2D(FileName,IntArray, N1, N2, SectionNumber, Headers, ReadDataFromHeader, &
       & FileType, CommentCharacters)
    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    ! Input: 
    ! FileName          - name of file to read.
    ! FileType          - 'PAD' or 'TXT'
    ! CommentCharacters - string of characters, any of which can signify a header line. By default
    !                     'TXT' headers start with '#', '!', 'c', 'C', or '*'. When reading 'PAD' data
    !                     comment character is '#' only.
    CHARACTER*(*),INTENT(IN) :: FileName
    CHARACTER*(*),INTENT(IN),OPTIONAL :: FileType, CommentCharacters
    INTEGER,INTENT(IN),OPTIONAL :: SectionNumber
    LOGICAL,INTENT(IN),OPTIONAL :: ReadDataFromHeader
    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    ! Output:
    ! Headers           - Read header lines into this variable.
    ! IntArray       - Holds data read from file.
    ! N1, N2            - Dimensions of the array as read from file.
    CHARACTER*(*),INTENT(OUT),OPTIONAL :: Headers(:)
    INTEGER,INTENT(OUT) :: IntArray(:,:)
    INTEGER,INTENT(OUT) :: N1, N2

    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    ! Local Variables:
    ! iUnit        - unit number of the file.
    ! iError       - error code passed back from read.
    ! NSections    - Current section of file.
    ! iFlType      - index of file type. (1 = txt, 2 = pad)
    ! NE1, NE2     - used to hold the dimensions of the array as read from file.
    ! Length       - Length of the current word.
    ! IntFormat - Format to use for double precision data.
    ! CmtChars     - Holds string of possible comment characters.
    ! DataTypeLine - Holds the type of data being read from file, if defined.
    ! DataStr      - Holds the current word as read from file.
    ! FlType       - Holds the file type ('TXT' or 'PAD').
    ! EOF/EOR      - True if end of file/record has been reached
    ! IsHead       - True if a comment character has been found at beginning of line.
    INTEGER iUnit, iError, NSections, iFlType, NE1, NE2, Length
    CHARACTER(100) IntFormat, CmtChars ! , DataTypeLine
    CHARACTER(40) DataStr
    CHARACTER(4) FlType
    LOGICAL EOF, EOR, IsHeader, HeaderData
 
    ! Loop Variables: 
    INTEGER i1, i2

    ! Define file types.
    INTEGER itxt, ipad
    PARAMETER(itxt = 1, ipad = 2)
    
    ! Initialization
    NE1 = 0
    NE2 = 0
    
    HeaderData = .FALSE.
    IF(PRESENT(ReadDataFromHeader)) HeaderData = ReadDataFromHeader

    IF(PRESENT(SectionNumber)) THEN
       CALL ReadToSection(FileName, SectionNumber)
    END IF

    iFlType = iFileTypeDefault
    IF(PRESENT(CommentCharacters)) THEN 
       CmtChars = CommentCharacters
    ELSE
       CmtChars = DefaultCommentCharacters
    END IF

    IF(PRESENT(FileType)) THEN
       FlType = TRIM(ADJUSTL(FileType))
       CALL Upper(FlType)
       IF(TRIM(FlType).eq.'TXT') THEN
          iFlType = itxt
       ELSEIF(TRIM(FlType).eq.'PAD') THEN
          ! If filetype is 'PAD' comment characters must be '#' only.
          iFlType = ipad
          CmtChars='#'
       ELSE
          CALL Error('Illegal FileType passed to Write2D.')
       END IF
    END IF
    ! End Initialization

    ! Open the file for reading.
    CALL OpenFl(FileName, FileAction = 'READ')

    ! Get some info about the file.
    CALL GetIOFileInfo(FileName, UnitNumber = iUnit, IFormat = IntFormat, &
         & NSections = NSections)

    ! Set the maximum size of the array to be read.
    N1 = SIZE(IntArray,1)
    N2 = SIZE(IntArray,2)

    ! Read headers and save if Headers has been passed.
    IF(PRESENT(Headers)) THEN
       CALL ReadHeaders(FileName, DataStr, CommentCharacters = CmtChars, Headers = Headers)
    ELSE
       CALL ReadHeaders(FileName, DataStr, CommentCharacters = CmtChars)
    END IF

    ! Backspace since ReadHeaders reads one line passed the last header.
    BACKSPACE(iUnit)

    ! Loop over dimensions of the array.
    DO i1 = 1, N1
       DO i2 = 1, N2

          ! Read the next word from the file and save in DataStr
          CALL ReadNextWord(iUnit,DataStr,Length,IsHeader,EOR,EOF,CmtChars)

          ! If end of file, set EOF and return.
          IF(EOF) THEN
             CALL SetIOFileInfo(FileName, EOF = EOF)
             RETURN
          END IF

          ! If this is a header line backspace and read headers.
          IF(IsHeader) THEN
             BACKSPACE(iUnit)
             CALL ReadHeaders(FileName, DataStr, CommentCharacters = CmtChars)
             
             ! Check if we are reading a new section. If so, return.
             IF(ReadingNewSection(FileName, NSections)) RETURN
          END IF

          ! If line is not blank, set the data array element.
          IF(Length.gt.0) THEN
             IF(iFlType.eq.itxt) THEN
                READ(DataStr(1:Length),FMT=*,IOSTAT = iError) IntArray(i1,i2)
                IF(iError.ne.0) CALL Error('Error in Read2D while trying to read from file: ' //&
                     & FileName)
             ELSEIF(iFlType.eq.ipad) THEN
                IF(Length.gt.0) CALL ReadPAD(DataStr(1:Length),IntArray(i1,i2))
             END IF

             ! Set dimension 2.
             NE2 = i2
          END IF

          ! If end of record reached, exit this loop.
          IF(EOR) EXIT

       END DO

       ! Advance to the next line.
       IF(.not.EOR) READ(iUnit,*,END=20)              

       ! Set dimension 1
       N1 = i1

    END DO

    ! Increment the section number
    CALL SetIOFileInfo(FileName, NSections = NSections + 1)

    ! End of file reached.
20  CONTINUE
    CALL SetIOFileInfo(FileName, EOF = .TRUE.)
  END SUBROUTINE ReadInt2D


  ! SUBROUTINE ReadReal2D reads a 2D integer array from file.
  SUBROUTINE ReadReal2D(FileName,RealArray, N1, N2, SectionNumber, Headers, ReadDataFromHeader, &
       & FileType, CommentCharacters)
    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    ! Input: 
    ! FileName          - name of file to read.
    ! FileType          - 'PAD' or 'TXT'
    ! CommentCharacters - string of characters, any of which can signify a header line. By default
    !                     'TXT' headers start with '#', '!', 'c', 'C', or '*'. When reading 'PAD' data
    !                     comment character is '#' only.
    CHARACTER*(*),INTENT(IN) :: FileName
    CHARACTER*(*),INTENT(IN),OPTIONAL :: FileType, CommentCharacters
    INTEGER,INTENT(IN),OPTIONAL :: SectionNumber
    LOGICAL,INTENT(IN),OPTIONAL :: ReadDataFromHeader
    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    ! Output:
    ! Headers           - Read header lines into this variable.
    ! RealArray       - Holds data read from file.
    ! N1, N2            - Dimensions of the array as read from file.
    CHARACTER*(*),INTENT(OUT),OPTIONAL :: Headers(:)
    REAL,INTENT(OUT) :: RealArray(:,:)
    INTEGER,INTENT(OUT) :: N1, N2

    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    ! Local Variables:
    ! iUnit        - unit number of the file.
    ! iError       - error code passed back from read.
    ! NSections    - Current section of file.
    ! iFlType      - index of file type. (1 = txt, 2 = pad)
    ! NE1, NE2     - used to hold the dimensions of the array as read from file.
    ! Length       - Length of the current word.
    ! RealFormat - Format to use for double precision data.
    ! CmtChars     - Holds string of possible comment characters.
    ! DataTypeLine - Holds the type of data being read from file, if defined.
    ! DataStr      - Holds the current word as read from file.
    ! FlType       - Holds the file type ('TXT' or 'PAD').
    ! EOF/EOR      - True if end of file/record has been reached
    ! IsHead       - True if a comment character has been found at beginning of line.
    INTEGER iUnit, iError, NSections, iFlType, NE1, NE2, Length
    CHARACTER(100) RealFormat, CmtChars ! , DataTypeLine
    CHARACTER(40) DataStr
    CHARACTER(4) FlType
    LOGICAL EOF, EOR, IsHeader, HeaderData
 
    ! Loop Variables: 
    INTEGER i1, i2

    ! Define file types.
    INTEGER itxt, ipad
    PARAMETER(itxt = 1, ipad = 2)
    
    ! Initialization
    NE1 = 0
    NE2 = 0

    HeaderData = .FALSE.
    IF(PRESENT(ReadDataFromHeader)) HeaderData = ReadDataFromHeader

    IF(PRESENT(SectionNumber)) THEN
       CALL ReadToSection(FileName, SectionNumber)
    END IF

    iFlType = iFileTypeDefault
    IF(PRESENT(CommentCharacters)) THEN 
       CmtChars = CommentCharacters
    ELSE
       CmtChars = DefaultCommentCharacters
    END IF

    IF(PRESENT(FileType)) THEN
       FlType = TRIM(ADJUSTL(FileType))
       CALL Upper(FlType)
       IF(TRIM(FlType).eq.'TXT') THEN
          iFlType = itxt
       ELSEIF(TRIM(FlType).eq.'PAD') THEN
          ! If filetype is 'PAD' comment characters must be '#' only.
          iFlType = ipad
          CmtChars='#'
       ELSE
          CALL Error('Illegal FileType passed to Write2D.')
       END IF
    END IF
    ! End Initialization

    ! Open the file for reading.
    CALL OpenFl(FileName, FileAction = 'READ')

    ! Get some info about the file.
    CALL GetIOFileInfo(FileName, UnitNumber = iUnit, RFormat = RealFormat, &
         & NSections = NSections)

    ! Set the maximum size of the array to be read.
    N1 = SIZE(RealArray,1)
    N2 = SIZE(RealArray,2)

    ! Read headers and save if Headers has been passed.
    IF(PRESENT(Headers)) THEN
       CALL ReadHeaders(FileName, DataStr, CommentCharacters = CmtChars, Headers = Headers)
    ELSE
       CALL ReadHeaders(FileName, DataStr, CommentCharacters = CmtChars)
    END IF

    ! Backspace since ReadHeaders reads one line passed the last header.
    BACKSPACE(iUnit)

    ! Loop over dimensions of the array.
    DO i1 = 1, N1
       DO i2 = 1, N2

          ! Read the next word from the file and save in DataStr
          CALL ReadNextWord(iUnit,DataStr,Length,IsHeader,EOR,EOF,CmtChars)

          ! If end of file, set EOF and return.
          IF(EOF) THEN
             CALL SetIOFileInfo(FileName, EOF = EOF)
             RETURN
          END IF

          ! If this is a header line backspace and read headers.
          IF(IsHeader) THEN
             BACKSPACE(iUnit)
             CALL ReadHeaders(FileName, DataStr, CommentCharacters = CmtChars)
             
             ! Check if we are reading a new section. If so, return.
             IF(ReadingNewSection(FileName, NSections)) RETURN
          END IF

          ! If line is not blank, set the data array element.
          IF(Length.gt.0) THEN
             IF(iFlType.eq.itxt) THEN
                READ(DataStr(1:Length),FMT=*,IOSTAT = iError) RealArray(i1,i2)
                IF(iError.ne.0) CALL Error('Error in Read2D while trying to write to file: ' //&
                     & FileName)
             ELSEIF(iFlType.eq.ipad) THEN
                IF(Length.gt.0) CALL ReadPAD(DataStr(1:Length),npadrDefault,RealArray(i1,i2))
             END IF

             ! Set dimension 2.
             NE2 = i2
          END IF

          ! If end of record reached, exit this loop.
          IF(EOR) EXIT

       END DO

       ! Advance to the next line.
       IF(.not.EOR) READ(iUnit,*,END=20)              

       ! Set dimension 1
       N1 = i1

    END DO

    ! Increment the section number
    CALL SetIOFileInfo(FileName, NSections = NSections + 1)

    ! End of file reached.
20  CONTINUE
    CALL SetIOFileInfo(FileName, EOF = .TRUE.)
  END SUBROUTINE ReadReal2D


  ! SUBROUTINE ReadDouble2D reads a 2D integer array from file.
  SUBROUTINE ReadDouble2D(FileName,DoubleArray, N1, N2, SectionNumber,  Headers, ReadDataFromHeader,&
       & FileType, CommentCharacters)
    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    ! Input: 
    ! FileName          - name of file to read.
    ! FileType          - 'PAD' or 'TXT'
    ! CommentCharacters - string of characters, any of which can signify a header line. By default
    !                     'TXT' headers start with '#', '!', 'c', 'C', or '*'. When reading 'PAD' data
    !                     comment character is '#' only.
    CHARACTER*(*),INTENT(IN) :: FileName
    CHARACTER*(*),INTENT(IN),OPTIONAL :: FileType, CommentCharacters
    INTEGER,INTENT(IN),OPTIONAL :: SectionNumber
    LOGICAL,INTENT(IN),OPTIONAL :: ReadDataFromHeader
    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    ! Output:
    ! Headers           - Read header lines into this variable.
    ! DoubleArray       - Holds data read from file.
    ! N1, N2            - Dimensions of the array as read from file.
    CHARACTER*(*),INTENT(OUT),OPTIONAL :: Headers(:)
    DOUBLE PRECISION,INTENT(OUT) :: DoubleArray(:,:)
    INTEGER,INTENT(OUT) :: N1, N2

    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    ! Local Variables:
    ! iUnit        - unit number of the file.
    ! iError       - error code passed back from read.
    ! NSections    - Current section of file.
    ! iFlType      - index of file type. (1 = txt, 2 = pad)
    ! NE1, NE2     - used to hold the dimensions of the array as read from file.
    ! Length       - Length of the current word.
    ! DoubleFormat - Format to use for double precision data.
    ! CmtChars     - Holds string of possible comment characters.
    ! DataTypeLine - Holds the type of data being read from file, if defined.
    ! DataStr      - Holds the current word as read from file.
    ! FlType       - Holds the file type ('TXT' or 'PAD').
    ! EOF/EOR      - True if end of file/record has been reached
    ! IsHead       - True if a comment character has been found at beginning of line.
    INTEGER iUnit, iError, NSections, iFlType, NE1, NE2, Length
    CHARACTER(100) DoubleFormat, CmtChars ! , DataTypeLine
    CHARACTER(40) DataStr
    CHARACTER(200) line
    CHARACTER(4) FlType
    LOGICAL EOF, EOR, IsHeader, HeaderData
 
    ! Loop Variables: 
    INTEGER i1, i2

    ! Define file types.
    INTEGER itxt, ipad
    PARAMETER(itxt = 1, ipad = 2)
    
    ! Initialization
    NE1 = 0
    NE2 = 0

    HeaderData = .FALSE.
    IF(PRESENT(ReadDataFromHeader)) HeaderData = ReadDataFromHeader

    IF(PRESENT(SectionNumber)) THEN
       CALL ReadToSection(FileName, SectionNumber)
    END IF

    iFlType = iFileTypeDefault
    IF(PRESENT(CommentCharacters)) THEN 
       CmtChars = CommentCharacters
    ELSE
       CmtChars = DefaultCommentCharacters
    END IF

    IF(PRESENT(FileType)) THEN
       FlType = TRIM(ADJUSTL(FileType))
       CALL Upper(FlType)
       IF(TRIM(FlType).eq.'TXT') THEN
          iFlType = itxt
       ELSEIF(TRIM(FlType).eq.'PAD') THEN
          ! If filetype is 'PAD' comment characters must be '#' only.
          iFlType = ipad
          CmtChars='#'
       ELSE
          CALL Error('Illegal FileType passed to Read2D.')
       END IF
    END IF
    ! End Initialization

    ! Open the file for reading.
    CALL OpenFl(FileName, FileAction = 'READ')

    ! Get some info about the file.
    CALL GetIOFileInfo(FileName, UnitNumber = iUnit, DFormat = DoubleFormat, &
         & NSections = NSections)

    ! Set the maximum size of the array to be read.
    N1 = SIZE(DoubleArray,1)
    N2 = SIZE(DoubleArray,2)

    ! Read headers and save if Headers has been passed.
    IF(PRESENT(Headers)) THEN
       CALL ReadHeaders(FileName, line, CommentCharacters = CmtChars, Headers = Headers)
    ELSE
       CALL ReadHeaders(FileName, line, CommentCharacters = CmtChars)
    END IF

    ! Backspace since ReadHeaders reads one line passed the last header.
    BACKSPACE(iUnit)

    ! Loop over dimensions of the array.
    DO i1 = 1, N1
       DO i2 = 1, N2

          ! Read the next word from the file and save in DataStr
          CALL ReadNextWord(iUnit,DataStr,Length,IsHeader,EOR,EOF,CmtChars)

          ! If end of file, set EOF and return.
          IF(EOF) THEN
!             CALL SetIOError('Array_Too_Small')
             CALL SetIOFileInfo(FileName, EOF = EOF)
             RETURN
          END IF
          
          ! If this is a header line backspace and read headers.
          IF(IsHeader) THEN
             BACKSPACE(iUnit)
             CALL ReadHeaders(FileName, line, CommentCharacters = CmtChars)
             
             ! Check if we are reading a new section. If so, return.
             IF(ReadingNewSection(FileName, NSections)) THEN
                RETURN
             ELSE
                ! Set Comment_Error to true. By default, this will produce a warning.
                CALL Error('Unexpected comment character found in file ' // FileName // '.')
                CALL Error(line)
             END IF
          END IF

          ! If line is not blank, set the data array element.
          IF(Length.gt.0) THEN
             IF(iFlType.eq.itxt) THEN
                READ(DataStr(1:Length),FMT=*,IOSTAT = iError) DoubleArray(i1,i2)
                IF(iError.ne.0) CALL Error('Error in Read2D while trying to write to file: ' //&
                     & FileName)
             ELSEIF(iFlType.eq.ipad) THEN
                IF(Length.gt.0) CALL ReadPAD(DataStr(1:Length),npadrDefault,DoubleArray(i1,i2))
             END IF

             ! Set dimension 2.
             NE2 = i2
          END IF

          ! If end of record reached, exit this loop.
          IF(EOR) EXIT

       END DO

       ! Advance to the next line if needed.
       IF(.not.EOR) READ(iUnit,*,END=20)              

       ! Set dimension 1
       N1 = i1

    END DO

    ! Increment the section number
    CALL SetIOFileInfo(FileName, NSections = NSections + 1)

    RETURN
    ! End of file reached.
20  CONTINUE
    CALL SetIOFileInfo(FileName, EOF = .TRUE.)
  END SUBROUTINE ReadDouble2D


  ! SUBROUTINE ReadComplex2D reads a 2D integer array from file.
  SUBROUTINE ReadComplex2D(FileName,ComplexArray, N1, N2, SectionNumber, Headers, ReadDataFromHeader, &
       & FileType, CommentCharacters)
    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    ! Input: 
    ! FileName          - name of file to read.
    ! FileType          - 'PAD' or 'TXT'
    ! CommentCharacters - string of characters, any of which can signify a header line. By default
    !                     'TXT' headers start with '#', '!', 'c', 'C', or '*'. When reading 'PAD' data
    !                     comment character is '#' only.
    CHARACTER*(*),INTENT(IN) :: FileName
    CHARACTER*(*),INTENT(IN),OPTIONAL :: FileType, CommentCharacters
    INTEGER,INTENT(IN),OPTIONAL :: SectionNumber
    LOGICAL,INTENT(IN),OPTIONAL :: ReadDataFromHeader
    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    ! Output:
    ! Headers           - Read header lines into this variable.
    ! ComplexArray       - Holds data read from file.
    ! N1, N2            - Dimensions of the array as read from file.
    CHARACTER*(*),INTENT(OUT),OPTIONAL :: Headers(:)
    COMPLEX,INTENT(OUT) :: ComplexArray(:,:)
    INTEGER,INTENT(OUT) :: N1, N2

    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    ! Local Variables:
    ! iUnit        - unit number of the file.
    ! iError       - error code passed back from read.
    ! NSections    - Current section of file.
    ! iFlType      - index of file type. (1 = txt, 2 = pad)
    ! NE1, NE2     - used to hold the dimensions of the array as read from file.
    ! Length       - Length of the current word.
    ! ComplexFormat - Format to use for double precision data.
    ! CmtChars     - Holds string of possible comment characters.
    ! DataTypeLine - Holds the type of data being read from file, if defined.
    ! DataStr      - Holds the current word as read from file.
    ! FlType       - Holds the file type ('TXT' or 'PAD').
    ! EOF/EOR      - True if end of file/record has been reached
    ! IsHead       - True if a comment character has been found at beginning of line.
    REAL ReData, ImData
    INTEGER iUnit, iError, NSections, iFlType, NE1, NE2, ReLength, ImLength
    CHARACTER(100) ComplexFormat, CmtChars ! , DataTypeLine
    CHARACTER(40) ReDataStr, ImDataStr
    CHARACTER(4) FlType
    LOGICAL EOF, EOR, IsHeader, HeaderData
 
    ! Loop Variables: 
    INTEGER i1, i2

    ! Define file types.
    INTEGER itxt, ipad
    PARAMETER(itxt = 1, ipad = 2)
    
    ! Initialization
    NE1 = 0
    NE2 = 0

    HeaderData = .FALSE.
    IF(PRESENT(ReadDataFromHeader)) HeaderData = ReadDataFromHeader

    IF(PRESENT(SectionNumber)) THEN
       CALL ReadToSection(FileName, SectionNumber)
    END IF

    iFlType = iFileTypeDefault
    IF(PRESENT(CommentCharacters)) THEN 
       CmtChars = CommentCharacters
    ELSE
       CmtChars = DefaultCommentCharacters
    END IF

    IF(PRESENT(FileType)) THEN
       FlType = TRIM(ADJUSTL(FileType))
       CALL Upper(FlType)
       IF(TRIM(FlType).eq.'TXT') THEN
          iFlType = itxt
       ELSEIF(TRIM(FlType).eq.'PAD') THEN
          ! If filetype is 'PAD' comment characters must be '#' only.
          iFlType = ipad
          CmtChars='#'
       ELSE
          CALL Error('Illegal FileType passed to Write2D.')
       END IF
    END IF
    ! End Initialization

    ! Open the file for reading.
    CALL OpenFl(FileName, FileAction = 'READ')

    ! Get some info about the file.
    CALL GetIOFileInfo(FileName, UnitNumber = iUnit, CFormat = ComplexFormat, &
         & NSections = NSections)

    ! Set the maximum size of the array to be read.
    N1 = SIZE(ComplexArray,1)
    N2 = SIZE(ComplexArray,2)

    ! Read headers and save if Headers has been passed.
    IF(PRESENT(Headers)) THEN
       CALL ReadHeaders(FileName, ReDataStr, CommentCharacters = CmtChars, Headers = Headers)
    ELSE
       CALL ReadHeaders(FileName, ReDataStr, CommentCharacters = CmtChars)
    END IF

    ! Backspace since ReadHeaders reads one line passed the last header.
    BACKSPACE(iUnit)

    ! Loop over dimensions of the array.
    DO i1 = 1, N1
       DO i2 = 1, N2
          ! Read the next word from the file and save in ReDataStr
          CALL ReadNextWord(iUnit,ReDataStr,ReLength,IsHeader,EOR,EOF,CmtChars)
          IF(EOF.or.EOR) CALL Error('Error: Unexpected end of record while reading from ' // FileName // '.')
          ! Read the next word from the file and save in ImDataStr
          CALL ReadNextWord(iUnit,ImDataStr,ImLength,IsHeader,EOR,EOF,CmtChars)

          ! If end of file, set EOF and return.
          IF(EOF) THEN
             CALL SetIOFileInfo(FileName, EOF = EOF)
             RETURN
          END IF

          ! If this is a header line backspace and read headers.
          IF(IsHeader) THEN
             BACKSPACE(iUnit)
             CALL ReadHeaders(FileName, ReDataStr, CommentCharacters = CmtChars)
             
             ! Check if we are reading a new section. If so, return.
             IF(ReadingNewSection(FileName, NSections)) RETURN
          END IF

          ! If line is not blank, set the data array element.
          IF(iFlType.eq.itxt) THEN
             IF(ReLength.gt.0) THEN
                READ(ReDataStr(1:ReLength),FMT=*, iostat = iError) ReData
                IF(iError.ne.0) CALL Error('Error in Read2D while trying to read to file: ' //&
                     & FileName)
             END IF
             IF(ImLength.gt.0) THEN
                READ(ImDataStr(1:ImLength),FMT=*, iostat = iError) ImData
                IF(iError.ne.0) CALL Error('Error in Read2D while trying to read to file: ' //&
                     & FileName)
             ENDIF
          ELSEIF(iFlType.eq.ipad) THEN
             IF(ReLength.gt.0) CALL ReadPAD(ReDataStr(1:ReLength),npadrDefault,ReData)
             IF(ImLength.gt.0) CALL ReadPAD(ImDataStr(1:ImLength),npadrDefault,ImData)
          END IF

          ! Set the data array.
          ComplexArray(i1,i2) = ReData + (0.0,1.0)*ImData

          ! Set dimension 2.
          NE2 = i2
          
          ! If end of record reached, exit this loop.
          IF(EOR) EXIT

       END DO

       ! Advance to the next line.
       IF(.not.EOR) READ(iUnit,*,END=20)              

       ! Set dimension 1
       N1 = i1

    END DO

    ! Increment the section number
    CALL SetIOFileInfo(FileName, NSections = NSections + 1)

    ! End of file reached.
20  CONTINUE
    CALL SetIOFileInfo(FileName, EOF = .TRUE.)
  END SUBROUTINE ReadComplex2D


  ! SUBROUTINE ReadInt2D reads a 2D integer array from file.
  SUBROUTINE ReadDComplex2D(FileName,DComplexArray, N1, N2, SectionNumber, Headers, ReadDataFromHeader, &
       & FileType, CommentCharacters)
    CHARACTER*(*),INTENT(IN) :: FileName
    CHARACTER*(*),INTENT(OUT),OPTIONAL :: Headers(:)
    CHARACTER*(*),INTENT(IN),OPTIONAL :: FileType, CommentCharacters
    COMPLEX*16,INTENT(OUT) :: DComplexArray(:,:)
    INTEGER,INTENT(OUT) :: N1, N2
    INTEGER,INTENT(IN),OPTIONAL :: SectionNumber
    LOGICAL,INTENT(IN),OPTIONAL :: ReadDataFromHeader

    INTEGER iUnit, i1, i2, iError, NSections, iFlType, NE1, NE2, Length ! , NWords
    CHARACTER(100) DComplexFormat, CmtChars ! , DataTypeLine
    CHARACTER(100) ReDataStr, ImDataStr
    ! CHARACTER(20) Words(20)
    CHARACTER(4) FlType
    LOGICAL EOF, EOR, IsHeader, HeaderData
    DOUBLE PRECISION ReArg, ImArg

    ! Define file types.
    INTEGER itxt, ipad
    PARAMETER(itxt = 1, ipad = 2)
    
    NE1 = 0
    NE2 = 0

    HeaderData = .FALSE.
    IF(PRESENT(ReadDataFromHeader)) HeaderData = ReadDataFromHeader

    IF(PRESENT(SectionNumber)) THEN
       CALL ReadToSection(FileName, SectionNumber)
    END IF

    iFlType = iFileTypeDefault
    IF(PRESENT(CommentCharacters)) THEN 
       CmtChars = CommentCharacters
    ELSE
       CmtChars = DefaultCommentCharacters
    END IF

    IF(PRESENT(FileType)) THEN
       FlType = TRIM(ADJUSTL(FileType))
       CALL Upper(FlType)
       IF(TRIM(FlType).eq.'TXT') THEN
          iFlType = itxt
       ELSEIF(TRIM(FlType).eq.'PAD') THEN
          iFlType = ipad
       ELSE
          CALL Error('Illegal FileType passed to Write2D.')
       END IF
    END IF

    CALL OpenFl(FileName, FileAction = 'READ')
    CALL GetIOFileInfo(FileName, UnitNumber = iUnit, DCFormat = DComplexFormat, &
         & NSections = NSections)

    N1 = SIZE(DComplexArray,1)
    N2 = SIZE(DComplexArray,2)

    ! Read headers and save if they exist
    IF(PRESENT(Headers)) THEN
       CALL ReadHeaders(FileName, ReDataStr, CommentCharacters = CmtChars, Headers = Headers)
    ELSE
       CALL ReadHeaders(FileName, ReDataStr, CommentCharacters = CmtChars)
    END IF
    BACKSPACE(iUnit)

    ! Read data from file.
    DO i1 = 1, N1
       DO i2 = 1, N2
          CALL ReadNextWord(iUnit,ReDataStr,Length,IsHeader,EOR,EOF,CmtChars)
          CALL ReadNextWord(iUnit,ImDataStr,Length,IsHeader,EOR,EOF,CmtChars)
          IF(EOF) EXIT
          ! If this is a header line backspace and read headers.
          IF(ReDataStr(1:1).eq.'#') THEN
             BACKSPACE(iUnit)
             CALL ReadHeaders(FileName, ReDataStr, CommentCharacters = CmtChars)
             IF(ReadingNewSection(FileName, NSections)) RETURN
          END IF
          IF((LEN_TRIM(ReDataStr).gt.0).and.(LEN_TRIM(ImDataStr).gt.0)) THEN
             IF(iFlType.eq.itxt) THEN
                READ(ReDataStr,FMT=*,IOSTAT = iError) ReArg
                READ(ImDataStr,*,IOSTAT = iError) ImArg
                IF(iError.ne.0) CALL Error('Error in Read2D while trying to read from file: ' //&
                     & FileName)
             ELSEIF(iFlType.eq.ipad) THEN
                CALL ReadPAD(ReDataStr,npadrDefault,ReArg)
                CALL ReadPAD(ImDataStr,npadrDefault,ImArg)
             END IF
             DComplexArray(i2,i1) = ReArg + (0.0,1.0)*ImArg
             NE1 = NE1 + 1
          END IF
          IF(EOR) EXIT
       END DO
       IF(EOF) EXIT
       NE2 = NE2 + 1
    END DO
    EOF = .FALSE.
    ! 5   CONTINUE

    ! Increment the section number
    CALL SetIOFileInfo(FileName, NSections = NSections + 1)
  END SUBROUTINE ReadDComplex2D

  ! SUBROUTINE ReadInt2D reads a 2D integer array from file.
  SUBROUTINE ReadString2D(FileName, StringArray, N1, N2, SectionNumber, Headers, ReadDataFromHeader, &
       & FileType, CommentCharacters)
    CHARACTER*(*),INTENT(IN) :: FileName
    CHARACTER*(*),INTENT(OUT),OPTIONAL :: Headers(:)
    CHARACTER*(*),INTENT(IN),OPTIONAL :: FileType, CommentCharacters
    CHARACTER*(*),INTENT(OUT) :: StringArray(:,:)
    INTEGER,INTENT(OUT) :: N1, N2
    INTEGER,INTENT(IN),OPTIONAL :: SectionNumber
    LOGICAL,INTENT(IN),OPTIONAL :: ReadDataFromHeader

    INTEGER iUnit, i1, i2, NSections, iFlType, NE1, NE2, Length ! , iError, NWords
    CHARACTER(100) StringFormat, CmtChars ! , DataTypeLine
    CHARACTER(MaxStrLen) DataStr
    ! CHARACTER(20) Words(20)
    CHARACTER(4) FlType
    LOGICAL EOF, EOR, IsHeader, HeaderData

    ! Define file types.
    INTEGER itxt, ipad
    PARAMETER(itxt = 1, ipad = 2)
    
    NE1 = 0
    NE2 = 0

    HeaderData = .FALSE.
    IF(PRESENT(ReadDataFromHeader)) HeaderData = ReadDataFromHeader

    IF(PRESENT(SectionNumber)) THEN
       CALL ReadToSection(FileName, SectionNumber)
    END IF

    iFlType = iFileTypeDefault
    IF(PRESENT(CommentCharacters)) THEN 
       CmtChars = CommentCharacters
    ELSE
       CmtChars = DefaultCommentCharacters
    END IF

    IF(PRESENT(FileType)) THEN
       FlType = TRIM(ADJUSTL(FileType))
       CALL Upper(FlType)
       IF(TRIM(FlType).eq.'TXT') THEN
          iFlType = itxt
       ELSEIF(TRIM(FlType).eq.'PAD') THEN
          iFlType = ipad
       ELSE
          CALL Error('Illegal FileType passed to Read2D.')
       END IF
    END IF

    CALL OpenFl(FileName, FileAction = 'READ')
    CALL GetIOFileInfo(FileName, UnitNumber = iUnit, SFormat = StringFormat, &
         & NSections = NSections)

    N1 = SIZE(StringArray,1)
    N2 = SIZE(StringArray,2)

    ! Read headers and save if they exist
    IF(PRESENT(Headers)) THEN
       CALL ReadHeaders(FileName, DataStr, CommentCharacters = CmtChars, Headers = Headers)
    ELSE
       CALL ReadHeaders(FileName, DataStr, CommentCharacters = CmtChars)
    END IF
    BACKSPACE(iUnit)

    ! Read data to file.
    DO i1 = 1, N1
       DO i2 = 1, N2
          CALL ReadNextWord(iUnit,DataStr,Length,IsHeader,EOR,EOF,CmtChars)
          IF(EOF) EXIT
          ! If this is a header line backspace and read headers.
          IF(DataStr(1:1).eq.'#') THEN
             BACKSPACE(iUnit)
             CALL ReadHeaders(FileName, DataStr, CommentCharacters = CmtChars)
             IF(ReadingNewSection(FileName, NSections)) RETURN
          END IF
          IF(LEN_TRIM(DataStr).gt.0) THEN
             StringArray(i2,i1) = TRIM(ADJUSTL(DataStr))
             NE1 = NE1 + 1
          END IF
          IF(EOR) EXIT
       END DO
       IF(EOF) EXIT
       NE2 = NE2 + 1
    END DO
    ! 10  CONTINUE

    ! Increment the section number
    CALL SetIOFileInfo(FileName, NSections = NSections + 1)
  END SUBROUTINE ReadString2D

  ! Reads through the file FileName until it finds the section specified by
  ! SectionNumber. 
  SUBROUTINE ReadToSection(FileName,SectionNumber)
    CHARACTER*(*),INTENT(IN) :: FileName
    INTEGER,INTENT(IN) :: SectionNumber

    INTEGER iUnit, NSections, iError
    CHARACTER(10) ErrorNum
    CHARACTER(20) TmpStr
    CHARACTER(1000) Line

    ! Get the unit number.
    CALL GetIOFileInfo(FileName,UnitNumber = iUnit, NSections = NSections)

    ! Rewind to start of file
    REWIND(iUnit)

    ! Read until section.
    NSections = 0
    DO
       READ(iUnit,'(A)',IOSTAT = iError, END = 5) Line

       ! If error stop.          
       IF(iError.ne.0) THEN
          WRITE(ErrorNum,'(I5)') iError
          CALL Error('Error ocurred in ReadToSection', StopProgram = .FALSE.)
          CALL Error('while reading from file ' // TRIM(ADJUSTL(FileName)) // &
               & '.',StopProgram = .FALSE.)
          CALL Error('Error: ' // ErrorNum)
       END IF

       TmpStr = ADJUSTL(Line)
       IF(TmpStr(1:4).eq.'#SN#') NSections = NSections + 1
       IF(NSections.eq.SectionNumber) EXIT
    END DO

    ! Set the section number.
    CALL SetIOFileInfo(FileName, NSections = NSections)

    RETURN

5   CONTINUE ! End of file reached. Set EOF and return.
    CALL SetIOFileInfo(FileName, EOF = .TRUE.)

  END SUBROUTINE ReadToSection

  ! Reads lines until it finds one that is not a header. The next non
  !-header (non-blank) line will be passed back in Line.
  ! FileName - name of file to read from.
  ! Line - next data line
  ! CommentCharacters - string of characters, any of which will be
  ! interpreted as comment characters when found at the beginning of
  ! a line.
  ! Headers - optional: will store the headers found in Headers.
  SUBROUTINE ReadHeaders(FileName,Line,CommentCharacters,Headers)
    CHARACTER*(*),INTENT(IN) :: FileName
    CHARACTER*(*),INTENT(OUT) :: Line
    CHARACTER*(*),INTENT(IN),OPTIONAL :: CommentCharacters
    CHARACTER*(*),INTENT(OUT),OPTIONAL :: Headers(:)

    INTEGER iUnit, iError, NHead, MaxNHead, NSections
    CHARACTER(10) ErrorNum, CmtChars
    CHARACTER(200) TmpStr

    LOGICAL IsHead

    INTEGER i1

    ! Initialization
    IsHead = .TRUE.
    IF(PRESENT(Headers)) MaxNHead = SIZE(Headers)
    NHead = 0
    IF(PRESENT(CommentCharacters)) THEN
       CmtChars = CommentCharacters
    ELSE
       CmtChars = DefaultCommentCharacters
    END IF

    ! Get the unit number.
    CALL GetIOFileInfo(FileName,UnitNumber = iUnit, NSections = NSections)
    
    ! Read until next non-header line, saving header lines if Headers variable
    ! is provided.
    DO
       READ(iUnit,'(A)',IOSTAT = iError, END = 5) Line

       ! If error stop.          
       IF(iError.ne.0) THEN
          WRITE(ErrorNum,'(I5)') iError
          CALL Error('Error ocurred in ReadHeaders', StopProgram = .FALSE.)
          CALL Error('while reading from file ' // TRIM(ADJUSTL(FileName)) // &
               & '.',StopProgram = .FALSE.)
          CALL Error('Error: ' // ErrorNum)
       END IF

       TmpStr = TRIM(ADJUSTL(Line))

       ! First run through a few cases that look like headers but are not.
       IF(TmpStr(1:4).eq.'#SN#') THEN 
          ! New section has been reached. Increment section #
          CALL SetIOFileInfo(FileName,NSections = NSections + 1)
          NSections = NSections + 1

       ELSEIF(TmpStr(1:4).eq.'#DT#') THEN
          ! This is a data type line. Set DataTypeLine and continue.
          TmpStr = TRIM(ADJUSTL(Line(5:LEN(Line))))
          CALL SetIOFileInfo(FileName, DataTypeLine = TmpStr)

       ELSEIF(TmpStr(1:4).eq.'#DF#') THEN
          ! This is a data format line. Eventually add an automatic reader.
          CONTINUE

       ELSEIF(TmpStr(1:4).eq.'#HD#') THEN
          ! This is header data: return.
          IF(NSections.eq.0) NSections = 1
          CALL SetIOFileInfo(FileName, NSections = NSections)
          RETURN

       ELSEIF(LEN_TRIM(TmpStr).ne.0) THEN ! This is not a blank line, check for header line.
          ! Header lines are anything that start with any of the CommentCharacters
          ! if provided, otherwise they start with #, *, c, C, or ! 
          IsHead = .FALSE.
          DO i1 = 1, LEN_TRIM(CmtChars)
             IF(TmpStr(1:1).eq.CmtChars(i1:i1)) THEN
                ! if this is a header, set headers if specified
                IF(PRESENT(Headers)) THEN
                   NHead = NHead + 1
                   IF(MaxNHead.le.NHead) Headers(NHead) = TRIM(ADJUSTL(Line))
                END IF
                IsHead = .TRUE.
                EXIT
             END IF
          END DO

          ! If this line was not a header, backspace and return.
          IF(.not.IsHead) THEN
             IF(NSections.eq.0) NSections = 1
             CALL SetIOFileInfo(FileName, NSections = NSections)
             RETURN
          END IF
       END IF
    END DO

5   CONTINUE ! End of file reached. Set EOF for this file.
    CALL SetIOFileInfo(FileName, EOF = .TRUE.)
    
  END SUBROUTINE ReadHeaders

  ! Checks if the end of the file has been reached.
  LOGICAL FUNCTION EndOfFile(FileName)
    CHARACTER*(*) FileName

    CALL GetIOFileInfo(FileName, EOF = EndOfFile)
  END FUNCTION EndOfFile

  ! Checks if the next line is data (not a header), and backspaces.
  LOGICAL FUNCTION NextLineIsData(FileName, CommentCharacters)
    CHARACTER*(*),INTENT(IN) :: FileName
    CHARACTER*(*),INTENT(IN),OPTIONAL :: CommentCharacters

    INTEGER iUnit, iError, i1
    CHARACTER(1000) Line
    CHARACTER(20) TmpStr, CmtChars
    CHARACTER(5) ErrorNum
    LOGICAL IsHead, EOF

    NextLineIsData = .FALSE.
    IF(PRESENT(CommentCharacters)) THEN
       CmtChars = CommentCharacters
    ELSE
       CmtChars = DefaultCommentCharacters
    END IF

    ! Get the unit number.
    CALL GetIOFileInfo(FileName,UnitNumber = iUnit, EOF = EOF)
    
    ! If EOF, return false.
    IF(EOF) THEN
       NextLineIsData = .FALSE.
       RETURN
    END IF

    ! Read the next line.
    READ(iUnit,'(A)',IOSTAT = iError, END = 5) Line

    ! If error stop.          
    IF(iError.ne.0) THEN
       WRITE(ErrorNum,'(I5)') iError
       CALL Error('Error ocurred in NextLineIsData', StopProgram = .FALSE.)
       CALL Error('while reading from file ' // TRIM(ADJUSTL(FileName)) // &
            & '.',StopProgram = .FALSE.)
       CALL Error('Error: ' // ErrorNum)
    END IF

    TmpStr = TRIM(ADJUSTL(Line))

    ! First run through a few cases that look like headers but are not.
    IF(TmpStr(1:4).eq.'#SN#') THEN 
       NextLineIsData = .FALSE.
    ELSEIF(TmpStr(1:4).eq.'#DT#') THEN
       NextLineIsData = .FALSE.
    ELSEIF(TmpStr(1:4).eq.'#HD#') THEN
       ! Header Data 
       NextLineIsData = .TRUE.
    ELSEIF(TmpStr(1:4).eq.'#DF#') THEN
       NextLineIsData = .FALSE.
    ELSEIF(LEN_TRIM(TmpStr).ne.0) THEN ! This is not a blank line, check for header line.
       ! Header lines are anything that start with any of the CommentCharacters
       ! if provided, otherwise they start with #, *, c, C, or ! 
       IsHead = .FALSE.
       DO i1 = 1, LEN_TRIM(CmtChars)
          IF(TmpStr(1:1).eq.CmtChars(i1:i1)) THEN
             IsHead = .TRUE.
             EXIT
          END IF
       END DO

       ! If this line was not a header, backspace and return.
       IF(.not.IsHead) THEN          
          NextLineIsData = .TRUE.
       END IF
    END IF
5   CONTINUE
    BACKSPACE(iUnit)
    
  END FUNCTION NextLineIsData

  SUBROUTINE ReadNextWord(iUnit,Word,Length,IsHeader,EOR,EOF,CommentCharacters)
    INTEGER,INTENT(IN) :: iUnit
    CHARACTER,INTENT(IN) :: CommentCharacters
    INTEGER,INTENT(OUT) :: Length
    CHARACTER*(*),INTENT(OUT) :: Word
    LOGICAL,INTENT(OUT) :: EOR, EOF, IsHeader
    CHARACTER c
    ! CHARACTER(200) line
    INTEGER i1, clen

    EOR = .FALSE.
    EOF = .FALSE.
    IsHeader = .FALSE.
    Length = 0
    Word = ' '
    ! Read until we hit the first character. If we hit the end of the line, keep reading.
    DO
       READ(iUnit,'(A1)',ADVANCE = 'NO', EOR = 5, END = 10) c
       
       ! If c is not blank. Set Word(1:1) and exit
       clen = LEN_TRIM(c)
       IF(clen.gt.0) THEN
          Word(1:1) = c
          EXIT
       ENDIF          
    END DO

    ! Now check if this is a comment line.
    DO i1 = 1, LEN(CommentCharacters)
       IF(c.eq.CommentCharacters(i1:i1)) THEN
          IsHeader = .TRUE.
          READ(iUnit,*)
          RETURN
       END IF
    END DO

    Length = 1
    ! Now read until we hit a blank character.
    DO
       READ(iUnit,'(A)',ADVANCE = 'NO', EOR = 5, END = 10) c
       IF(LEN_TRIM(c).gt.0) THEN
          Word = TRIM(Word) // c
          Length = Length + 1
       ELSE
          EXIT
       END IF
    END DO
    RETURN
    
    ! End of record has been reached.
5   CONTINUE
    EOR = .TRUE.
    RETURN

    ! End of file has been reached.
10  CONTINUE
    EOF = .TRUE.
  END SUBROUTINE ReadNextWord
  
  ! Strips #HD# from the beginning of header data lines.
  SUBROUTINE StripHDLine(iUnit, IsHeader, EOR, EOF)
    INTEGER,INTENT(IN) :: iUnit
    INTEGER iError
    CHARACTER(4) HDString
    LOGICAL IsHeader, EOR, EOF

    EOR = .FALSE.
    EOF = .FALSE.
    IsHeader = .FALSE.

    READ(iUnit,'(A4)',ADVANCE = 'NO', EOR = 5, END = 10, IOSTAT = iError) HDString 
    CALL ReadError(iUnit = iUnit, Routine = 'StripHDLine', iError = iError)

    ! If HDString = #HD#, good, return
    IF(HDString.eq.'#HD#') THEN
       RETURN
    ELSEIF(TRIM(ADJUSTL(HDString(1:1))).eq.'#') THEN
       ! This is a header, but not data. 
       IsHeader = .TRUE.       
       RETURN
    ELSE
       ! This is not a header line or header data. Error
       CALL ReadError(iUnit = iUnit, Routine = 'StripHDLine')
    END IF

5   CONTINUE
    ! End of record found. Return
    EOR = .TRUE.
    RETURN

10  CONTINUE
    ! End of file found.
    EOF = .TRUE.
  END SUBROUTINE StripHDLine

  ! Handles read errors. Prints error number, file name, and calling routine.
  SUBROUTINE ReadError(FileName, iUnit, Routine, iError)
    CHARACTER*(*),INTENT(IN),OPTIONAL :: FileName, Routine
    INTEGER,INTENT(IN),OPTIONAL :: iUnit, iError
    CHARACTER(300) Messg(3), FlName, ErrorNum

    IF(PRESENT(FileName)) THEN
       FlName = FileName
    ELSEIF(PRESENT(iUnit)) THEN
       INQUIRE(UNIT = iUnit, NAME = FlName)
    ELSE
       CALL Error('ReadError called without either FileName or UnitNumber present.')
    END IF

    Messg(1) = 'READ ERROR:'

    IF(PRESENT(iError)) THEN
       WRITE(ErrorNum,*) iError
       Messg(1) = TRIM(Messg(1)) // ' ' // TRIM(ADJUSTL(ErrorNum))
    END IF

    Messg(2) = 'Read error occured while reading from file ' // TRIM(FlName) // '.'

    IF(PRESENT(Routine)) Messg(3) = 'This error occured inside the ' // TRIM(Routine) // ' routine.'

    CALL Error(Messg)

  END SUBROUTINE ReadError

  INTEGER Function NumberOfLines(FileName)
    CHARACTER*(*) FileName
    INTEGER iUnit ! , i1
    CHARACTER c
    CHARACTER(200) Line
    ! Find the number of lines that contain data
    CALL ReadHeaders(FileName,Line)
    CALL GetIOFileInfo(FileName,UnitNumber=iUnit)    
    BACKSPACE(iUnit)
    NumberOfLines = 0
    DO
       READ(iUnit,'(a)',END=10) c
       NumberOfLines = NumberOfLines + 1
    END DO
10  CONTINUE
    REWIND(iUnit)
  END Function NumberOfLines

END MODULE IOMod

      subroutine mmtr(t3j,mmati)
c     calculates the part of matrix M which does not depend on energy
c     point.( see Rehr and Albers paper)

      implicit double precision (a-h, o-z)

c     all commons are inputs
c     inputs:
c        t3j: appropriate table of the 3j symbols
c     Inputs from common:
c        rotation matrix for ilegp
c        path data, eta(ilegp) and ipot(ilegp)
c        mtot,l0
c     Output:  mmati(...) 

      include 'const.h'
      include 'dim.h'
      include 'pola.h'
      include 'rotmat.h'
      include 'pdata.h'

      complex*16 mmati
      dimension mmati(-mtot:mtot,-mtot:mtot),t3j(-mtot-1:mtot+1,-1:1)

      do 10 i = -mtot,mtot
      do 10 j = -mtot,mtot
         mmati(i,j)=0
  10  continue
      li = l0-1
c     l0 is final orb. momentum. Thus here we need to change code
c     in case when initial momemtum larger than final one.
      lx = min(mtot,l0)

      do 60 mu1 = -lx,lx
         mu1d = mu1+mtot+1
         do 50 mu2 = -lx,lx
            mu2d = mu2+mtot+1
            do 35  m0 = -li,li 
               do 34 i = -1,1
               do 34 j = -1,1
                  m1 = m0-j
                  m2 = m0-i
                  m1d = m1 + mtot+1
                  m2d = m2 + mtot+1
                  if (abs(m1).gt.lx .or. abs(m2).gt.lx)  goto 34
                  mmati(mu1,mu2) = mmati(mu1,mu2) + 
     1              dri(il0,mu1d,m1d,nsc+2)*dri(il0,m2d,mu2d,nleg)
     2              *exp(-coni*(eta(nsc+2)*m2+eta(0)*m1))
     3              *t3j(-m0,i)*t3j(-m0,j)*ptz(i,j)

c           dri(nsc+2)  is angle between z and leg1
c           dri(nsc+1)  is angle between last leg and z
c           eta(nsc+3)  is gamma between eps and rho1,
c           eta(nsc+2)  is alpha between last leg and eps
c           t3j(m0,i)    are 3j symbols multiplied by sqrt(3) 
   34          continue
   35       continue
            mmati(mu1,mu2) = mmati(mu1,mu2)*exp(-coni*eta(1)*mu1)
   50    continue
   60  continue

      return
      end

      subroutine wphase (nph, em, eref, lmax, ne, ph, ntitle, title)

c     Writes phase data to file PHASExx.DAT for each shell

      implicit double precision (a-h, o-z)

      include '../HEADERS/dim.h'

      complex*16 eref(nex, nspx)
      complex*16 ph( nex, -ltot:ltot, nspx, 0:nphx)
      complex*16  em(nex)
      dimension lmax(0:nphx)
      character*30  fname
      character*80  title(ntitle)
      character*2 coment
      parameter (coment='# ')

c     Dump phase data, eref and complex phase for each shell
      do 200  iph = 0, nph
         linit = 0
         if (linit .ge. lmax(iph)-1) linit = lmax(iph)-2
         if (linit .lt. 0) linit = 0

c        prepare files for shell's phase data

         write(fname,20)  iph
  20     format('phase', i2.2, '.dat')
         open (unit=1, file=fname, status='unknown', iostat=ios)
         call chopen (ios, fname, 'wphase')

         write(fname,30)  iph
  30     format('phmin', i2.2, '.dat')
         open (unit=2, file=fname, status='unknown', iostat=ios)
         call chopen (ios, fname, 'wphase')

         do 50 i = 1, ntitle
            ll = istrln(title(i))
            write(1,40)  coment, title(i)(1:ll)
            write(2,40)  coment, title(i)(1:ll)
  40        format (a,a)
  50     continue
c        write out unique pot and lmax
         write(1,60)   coment, iph, lmax(iph), ne
         write(2,60)   coment, iph, lmax(iph), ne
  60     format (a, 1x, 3i4, '   unique pot,  lmax, ne')
         write(2,70) coment, linit,linit+1,linit+2
  70     format (a,'      energy      re(eref)     re(p)    phase( ',i2,
     1         ')  phase(',i2,') phase(',i2,')' ) 

c        for each energy
c        ie, em, eref, p=sqrt(2*(em-eref))
c        ph array from 0 to ltot, 5 values per line
         do 150  ie = 1, ne
           write(1,110) coment, ie, dble(em(ie)), eref(ie,1),
     1                  sqrt(2*(em(ie)-eref(ie,1)))
  110      format (a, '   ie        energy      re(eref)',
     1             '      im(eref)',
     2             '         re(p)         im(p)', /,
     3             1x, i4, 1p, 5e14.6)

           write(1,120)  (ph(ie,ll,1,iph), ll=0,lmax(iph))
  120      format (1x, 1p, 4e14.6)

           write(2,130) dble(em(ie)), dble(eref(ie,1)),
     1     dble(sqrt(2*(em(ie)-eref(ie,1)))),
     2     (dble(ph(ie,ll,1,iph)), ll=linit,linit+2)
  130       format (1p, 6e13.5)
  150    continue
         close(unit=1)
         close(unit=2)
  200 continue

      return
      end

      subroutine genfmt (ipr3, critcw, sig2g, iorder)
      implicit double precision (a-h, o-z)

      include 'const.h'
      include 'dim.h'
      include 'clmz.h'
      include 'fmatrx.h'
      include 'lambda.h'
      include 'pdata.h'
      include 'nlm.h'
      include 'rotmat.h'

      include 'vers.h'
      include 'pola.h'

      complex*16  rho(legtot), pmati(lamtot,lamtot,2)
      complex*16  pllp, ptrac, srho, prho, cdel1, cfac
      complex*16  cchi(nex), cfms, mmati
      dimension   mmati(-mtot:mtot,-mtot:mtot)
      dimension   t3j(-mtot-1:mtot+1,-1:1)
      dimension   xk(nex), ckmag(nex)
      complex*16  ck(nex)
      dimension   ffmag(nex)

      character*12 fname, messag*128

      logical done

c     Input flags:
c     iorder, order of approx in f-matrix expansion (see setlam)
c             (normal use, 2.  Do ss exactly regardless of iorder)

c     used for divide-by-zero and trig tests
      parameter (eps = 1.0e-16)

c     Read phase calculation input, data returned via commons
      open (unit=1, file='phase.bin', status='old',
     1      access='sequential', form='unformatted', iostat=ios)
      call chopen (ios, 'phase.bin', 'genfmt')
      call rphbin (1)
      close (unit=1)

c     Open path input file (unit in) and read title.  Use unit 1.
      ntitle = 5
      open (unit=1, file='paths.dat', status='old', iostat=ios)
      call chopen (ios, 'paths.dat', 'genfmt')
      call rdhead (1, ntitle, title, ltitle)
      if (ntitle .le. 0)  then
         title(1) = ' '
         ltitle(1) = 1
      endif

c     cgam = gamma in mean free path calc (eV).  Set to zero in this
c     version.  Set it to whatever you want if you need it.
c     cgam = 0
c     cgam = cgam / ryd
c     add cnst imag part to eref
c     do 20  ie = 1, ne
c        eref(ie) = eref(ie) - coni*cgam/2
c  20 continue

   50 format (a)
   60 format (1x, a)
   70 format (1x, 79('-'))

c     Save filenames of feff.dat files for use by ff2chi
      open (unit=2, file='files.dat', status='unknown', iostat=ios)
      call chopen (ios, 'files.dat', 'genfmt')
c     Put phase header on top of files.dat
      do 100  itext = 1, ntext
         write(2,60)  text(itext)(1:ltext(itext))
  100 continue
      write(2,70)
      write(2,120)
  120 format ('    file        sig2   amp ratio    ',
     1        'deg    nlegs  r effective')

c     Set crit0 for keeping feff.dat's
      if (ipr3 .le. 0)  crit0 = 2*critcw/3
c     Make a header for the running messages.
       write(messag, 130) critcw
       call echo(messag)
  130 format ('    Curved wave chi amplitude ratio', f7.2, '%')
      if (ipr3 .le. 0)  then
         write(messag, 131) crit0
         call echo(messag)
       endif
  131 format ('    Discard feff.dat for paths with cw ratio <',
     1         f7.2, '%')
       write(messag, 132)
       call echo(messag)
  132 format ('    path  cw ratio     deg    nleg  reff')

c     Set nlm factors in common /nlm/ for use later
      call snlm (ltot+1, mtot+1)

      if (pola) then
c        Make 3j factors in t3j  (multiplied by sqrt(3*(2l0+1)) for
c        further convinience - the same expression for chi)
c        l0 - final momentum, initial momentum = l0-1.
         do 140  m0 = -l0+1,l0-1
            t3j(m0, 1) = (-1)**(l0+1+m0)*sqrt(3.0d0*(l0+m0)*(l0+m0+1)
     1                /(2*l0)/(2*l0-1))
            t3j(m0, 0) = (-1)**(l0+m0)*sqrt(3.0d0*(l0*l0-m0*m0)/
     1                l0/(2*l0-1))
  140    continue
         do 145  m0 = -l0+1,l0-1
            t3j(m0,-1) = t3j(-m0,1)
  145    continue
      endif

c     While not done, read path, find feff.
      open (unit=4,file='nstar.dat', status='unknown', iostat=ios)
      write(4,198, iostat=ios) evec
  198 format('polarization  ',3f8.4)
      write(4,199, iostat=ios)
  199 format('npath  nstar')
      npath = 0
      ntotal = 0
      nused = 0
      xportx = -1
  200 continue

c        Read current path
         call rdpath (1, pola, done,xstar)
         icalc = iorder
         if (done)  goto  1000
         npath = npath + 1
         ntotal = ntotal + 1

         write (4,201,iostat=ios) npath, xstar
  201    format (i5, f8.4)

c        Need reff
         reff = 0
         do 220  i = 1, nleg
            reff = reff + ri(i)
  220    continue
         reff = reff/2

c        Set lambda for low k
         call setlam (icalc, 1)

c        Calculate and store rotation matrix elements
c        Only need to go to (il0, il0, ...) for isc=nleg and
c        nleg+1 (these are the paths that involve the 'z' atom
         call rot3i (il0, il0, nleg)
         do 400  isc = 1, nsc
            call rot3i (lmaxp1, mmaxp1, isc)
  400    continue
         if (pola) then
c           one more rotation in polarization case
            call rot3i (il0, il0, nleg+1)
            call mmtr(t3j,mmati)
         endif 


c        Big energy loop
         do 800  ie = 1, ne

c           real momentum (k)
            xk(ie) = getxk (em(ie) - edge)

c           complex momentum (p)
            ck(ie) = sqrt (em(ie) - eref(ie))
            ckmag(ie) = abs(ck(ie))
c           complex rho
            do 420  ileg = 1, nleg
               rho(ileg) = ck(ie) * ri(ileg)
  420       continue

c           if ck is zero, xafs is undefined.  Make it zero and jump
c           to end of calc part of loop.
            if (abs(ck(ie)) .le. eps)  then
               cchi(ie) = 0
               goto 620
            endif

c           Calculate and store spherical wave factors c_l^(m)z^m/m!
c           in a matrix clmi(il,im,ileg), ileg=1...nleg.
c           Result is that common /clmz/ is updated for use by fmtrxi.

c           zero clmi arrays
            do 440  ileg = 1, legtot
            do 440  il = 1, ltot+1
            do 440  im = 1, mtot+ntot+1
               clmi(il,im,ileg) = 0
  440       continue

            mnmxp1 = mmaxp1 + nmax

            lxp1 = max (lmax(ie,ipot(1))+1, l0+1)
            mnp1 = min (lxp1, mnmxp1)
            call sclmz (rho, lxp1, mnp1, 1)

            lxp1 = max (lmax(ie,ipot(nsc))+1, l0+1)
            mnp1 = min (lxp1, mnmxp1)
            call sclmz (rho, lxp1, mnp1, nleg)

            do 460  ileg = 2, nleg-1
               isc0 = ileg-1
               isc1 = ileg
               lxp1 = max (lmax(ie,ipot(isc0))+1, lmax(ie,ipot(isc1))+1)
               mnp1 = min (lxp1, mnmxp1)
               call sclmz (rho, lxp1, mnp1, ileg)
  460       continue

c           Calculate and store scattering matrices fmati.

            if (pola) then
c              Polarization version, make new m matrix
c              this will fill fmati(...,nleg) in common /fmtrxi/
               call mmtrxi (laml0x, mmati, ie, 1, nleg)
            else 
c              Termination matrix, fmati(...,nleg)
               iterm = 1
               call fmtrxi (laml0x, laml0x, ie, iterm, 1, nleg)
            endif

            iterm = -1
c           First matrix
            call fmtrxi (lamx, laml0x, ie, iterm, 2, 1)
c           Last matrix if needed
            if (nleg .gt. 2)  then
               call fmtrxi (laml0x, lamx, ie, iterm, nleg, nleg-1)
            endif
c           Intermediate scattering matrices
            do 480  ilegp = 2, nsc-1
               ileg = ilegp + 1
               call fmtrxi (lamx, lamx, ie, iterm, ileg, ilegp)
  480       continue

c           Big matrix multiplication loops.
c           Calculates trace of matrix product
c           M(1,N) * f(N,N-1) * ... * f(3,2) * f(2,1), as in reference.
c           We will (equivalently) calculate the trace over lambda_N of
c           f(N,N-1) * ... * f(3,2) * f(2,1) * M(1,N), working from
c           right to left.
c           Use only 2 pmati arrays, alternating indp (index p)
c           1 and 2.

c           f(2,1) * M(1,N) -> pmat(1)
            indp = 1
            do 520  lmp = 1, laml0x
            do 520  lm = 1, lamx
               pllp = 0
               do 500  lmi = 1, laml0x
                  pllp = pllp + fmati(lm,lmi,1) * fmati(lmi,lmp,nleg)
  500          continue
               pmati(lm,lmp,indp)=pllp
  520       continue

c           f(N,N-1) * ... * f(3,2) * [f(2,1) * M(1,N)]
c           Term in [] is pmat(1)
            do 560 isc = 2, nleg-1
c              indp is current p matrix, indp0 is previous p matrix
               indp = 2 - mod(isc,2)
               indp0 = 1 + mod(indp,2)
               do 550  lmp = 1, laml0x
               do 550  lm = 1, lamx
                  pllp=0
                  do 540 lmi = 1, lamx
                     pllp = pllp +
     1                      fmati(lm,lmi,isc)*pmati(lmi,lmp,indp0)
  540             continue
  550          pmati(lm,lmp,indp) = pllp
  560       continue

c           Final trace over matrix
            ptrac=0
            do 580  lm = 1, laml0x
               ptrac = ptrac + pmati(lm,lm,indp)
  580       continue

c           Calculate xafs
c           srho=sum pr(i), prho = prod pr(i)
            srho=0
            prho=1
            do 600  ileg = 1, nleg
               srho = srho + rho(ileg)
               prho = prho * rho(ileg)
  600       continue
c           Complex chi (without 2kr term)
c           ipot(nleg) is central atom
            cdel1 = exp(2*coni*ph(ie,il0,ipot(nleg)))
            cfac = cdel1 * exp(coni*(srho-2*xk(ie)*reff)) / prho

            cchi(ie) = ptrac * cfac/(2*l0+1)

c           When ck(ie)=0, xafs is set to zero.  Calc above undefined.
c           Jump to here from ck(ie)=0 test above.
  620       continue

c        end of energy loop
  800    continue

c        Make importance factor, deg*(integral (|chi|*d|p|))
c        make ffmag (|chi|)
c        xport   importance factor
         do 810  ie = 1, ne
               ffmag(ie) = abs(cchi(ie))
  810    continue

c        integrate from edge (ik0) to ne
         nemax = ne - ik0 + 1
         call trap (ckmag(ik0), ffmag(ik0), nemax, xport)
         xport = abs(deg*xport)
         if (xport .gt. xportx)  xportx = xport
         crit = 100 * xport / xportx

c        Write output if path is important enough (ie, path is

c        Write feff.dat if we need it.
         if (ipr3 .ge. 1  .or.  crit .ge. crit0)  then
c           Prepare output file feffnnnn.dat (unit 3)
            write(fname,241)  ipath
  241       format ('feff', i4.4, '.dat')
            open (unit=3, file=fname, status='unknown', iostat=ios)
            call chopen (ios, fname, 'genfmt')
c           put header on feff.dat
            do 245  itext = 1, ntext
               write(3,60)  text(itext)(1:ltext(itext))
  245       continue
            write(3,250) ipath, icalc, vfeff, vgenfm
  250       format (' Path', i5, '      icalc ', i7, t57, 2a12)
            write(3,70)
            write(3,290)  nleg, deg, reff*bohr, rnrmav, edge*ryd
  290       format (1x, i3, f8.3, f9.4, f10.4, f11.5, 
     1              ' nleg, deg, reff, rnrmav(bohr), edge')
            write(3,300)
  300       format ('        x         y         z   pot at#')
            write(3,310)  (rat(j,nleg)*bohr,j=1,3), ipot(nleg),
     1                    iz(ipot(nleg)), potlbl(ipot(nleg))
  310       format (1x, 3f10.4, i3, i4, 1x, a6, '   absorbing atom')
            do 330  ileg = 1, nleg-1
               write(3,320)  (rat(j,ileg)*bohr,j=1,3), ipot(ileg),
     1                       iz(ipot(ileg)), potlbl(ipot(ileg))
  320          format (1x, 3f10.4, i3, i4, 1x, a6)
  330       continue

            write(3,340)
  340       format    ('    k   real[2*phc]   mag[feff]  phase[feff]',
     1                 ' red factor   lambda      real[p]@#')

c           Make the feff.dat stuff and write it to feff.dat
            do 900  ie = 1, ne
c              Consider chi in the standard XAFS form.  Use R = rtot/2.
               xlam = 1.0e10
               if (abs(dimag(ck(ie))) .gt. eps) xlam = 1/dimag(ck(ie))
               redfac = exp (-2 * dimag (ph(ie,il0,ipot(nleg))))
               cdelt = 2*dble(ph(ie,il0,ipot(nleg)))
               cfms = cchi(ie) * xk(ie) * reff**2 *
     1              exp(2*reff/xlam) / redfac
               if (abs(cchi(ie)) .lt. eps)  then
                  phff = 0
               else
                  phff = atan2 (dimag(cchi(ie)), dble(cchi(ie)))
               endif
c              remove 2 pi jumps in phases
               if (ie .gt. 1)  then
                  call pijump (phff, phffo)
                  call pijump (cdelt, cdelto)
               endif
               phffo = phff
               cdelto = cdelt

c              write 1 k, momentum wrt fermi level k=sqrt(p**2-kf**2)
c                    2 central atom phase shift (real part),
c                    3 magnitude of feff,
c                    4 phase of feff,
c                    5 absorbing atom reduction factor,
c                    6 mean free path = 1/(Im (p))
c                    7 real part of local momentum p

               write(3,640)
     1            xk(ie)/bohr,
     2            cdelt + l0*pi,
     3            abs(cfms) * bohr,
     4            phff - cdelt - l0*pi,
     5            redfac,
     6            xlam * bohr,
     7            dble(ck(ie))/bohr
  640          format (1x, f6.3, 1x, 3(1pe11.4,1x),0pe11.4,1x,
     1                               2(1pe11.4,1x))
  900       continue

c           Done with feff.dat
            close (unit=3)

c           Put feff.dat and stuff into files.dat
            write(2,820) fname, sig2g, crit, deg,
     1                   nleg, reff*bohr
  820       format(1x, a, f8.5, 2f10.3, i6, f9.4)

c           Tell user about the path we just did
            write(messag, 210) ipath, crit, deg, nleg, reff*bohr
            call echo(messag)            
  210       format (3x, i4, 2f10.3, i6, f9.4)
            nused = nused+1

         else
c           path unimportant, tell user
            write(messag, 211) ipath, crit, deg, nleg, reff*bohr
            call echo(messag)
  211       format (3x, i4, 2f10.3, i6, f9.4, ' neglected')
         endif

c        Do next path
         goto 200

c     Done with loop over paths
 1000 continue
c     close paths.dat, files.dat
      close (unit=1)
      close (unit=2)
      close (unit=4)
       write(messag,1010) nused, ntotal
       call echo(messag)
 1010 format (1x, i4, ' paths kept, ', i4, ' examined.')

      return
      end

      subroutine fixdsx (iph, dxorg, dxnew, dgc, dpc, dgcn, dpcn)

c     This fixes up the dirac spinor components (dgc and dpc) from ATOM
c     for the xsect and phase codes.

      implicit double precision (a-h, o-z)

      include '../HEADERS/dim.h'
      include '../HEADERS/const.h'

      dimension dgc(251,30,0:nphx+1), dpc(251,30,0:nphx+1)
      dimension dgcn(nrptx,30), dpcn(nrptx,30)

      dimension xorg(nrptx), xnew(nrptx)

      parameter (xx00 = 8.8d0)

c     statement functions to do indexing.  delta is 'dx' for current
c     grid.  jjj is index of grid point immediately before 'r'
      xxx(j) = -xx00 + (j-1)*delta
      rrr(j) = exp (-xx00 + (j-1)*delta)
      jjj(r) = int((log(r) + xx00) / delta) + 1

c     Use linear interpolation in x whether necessary or not.  If
c     new grid is same as old, it shouldn't make any difference.

c     relation between x, r, and j.  xx00 = 8.8 for all grids
c     in this version, change it if more flexibility is necessary.
c     xx = -xx00 + (j-1)*delta
c     rr = exp (xx)
c     jj = (log(r) + xx00) / delta + 1; this is j immediately BELOW r

c     The dgc and dpc arrays are zero beyond a certain point, usually
c     inside the muffin tin radius.  Find this distance.

      delta = dxorg
      do 10  j = 1, 251
         xorg(j) = xxx(j)
   10 continue

      delta = dxnew
      do 20  j = 1, nrptx
         xnew(j) = xxx(j)
   20 continue

      do 200 iorb = 1, 30
         imax = 0
         do 100  i = 251, 1, -1
            if ( abs(dgc(i,iorb,iph)) .ge. 1.0d-11 .or.
     1           abs(dpc(i,iorb,iph)) .ge. 1.0d-11 )  then
               imax = i
               goto 16
            endif
  100    continue
   16    continue
         if (imax .eq. 0) then
            jnew = 0
            goto 35
         endif
c        jmax is the first point where both dpc and dgc are zero in
c        the original grid
         jmax = imax + 1
         if (jmax .gt. 251) jmax = 251

         delta = dxorg
         rmax = rrr(jmax)

c        How far out do we go in the new grid?  To the last new grid
c        point before jmax.  Everything will be zero beyond jmax.
         delta = dxnew
         jnew = jjj(rmax)

c        interpolate to new grid using x, only inside of rmax
         do 30  j = 1, jnew
            call terp(xorg,dgc(1,iorb,iph),jmax,3, xnew(j),dgcn(j,iorb))
            call terp(xorg,dpc(1,iorb,iph),jmax,3, xnew(j),dpcn(j,iorb))
   30    continue

c        and zero the arrays past rmax
   35    do 40  j = jnew+1, nrptx
            dgcn(j,iorb) = 0
            dpcn(j,iorb) = 0
   40    continue
  200 continue

      return
      end

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Information about last revision of $RCSfile: m_controls.f90,v $:
! $Revision: 1.7 $
! $Author: bmattern $
! $Date: 2012/02/09 18:04:57 $
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!*****************************************************************************
!       CONTROL THE WAY FEFF WORKS
!*****************************************************************************
module controls
  !    Switch to 1 for real space, 0 for reciprocal space
  integer spacy
  !    Read sprkkr-structure file
  integer sprkkrstruct
  !    Read sprkkr-potential file
  integer sprkkrpot
  !    Read sprkkr-klist file
  integer sprkkrklist
  !    Switch between real and complex spherical harmonics for the KKR structure factors
  !    F for real, T for complex
  logical,parameter :: cplxylm=.false.
  !    Arrays are allocated via kprep
  logical allocated
  !    Use spin/relativistic matrices or not (LM basis) :
  integer irel
  !    Set verbosity of SPRKKR subroutines
  integer iprint
  !    Set up k-mesh in ffmod3
  logical makekmeshnow
  !    Use a core hole or not
  logical corehole
  !    Strength of the core hole - 1 is normal, 0 is nohole
  real*8 cholestrength       ! multiply core hole t-matrix by this number.  Currently strongly suggested to stay away from it!
  !    Use single precision in strbbdd
  logical,parameter :: singleprec=.false.
  !    Use full potential (t-matrix) or muffin tin potential (phases)
  logical fullpot      
  logical gglu_save_slice !BAM 2/2012

contains
  
  subroutine init_controls
    spacy=1  ! real space
    sprkkrstruct=0
    sprkkrpot=0
    sprkkrklist=0
    makekmeshnow=.false. !use k-mesh from file
    allocated=.false.  ! not yet been in kprep
    irel=1  ! work in LM-basis
    iprint=0
    corehole=.false. !no core hole
    cholestrength=dble(1)
    open(96,file='ini.inp',status='old',err=2341)
    read(96,*,err=2341,end=2341) sprkkrstruct,sprkkrpot,sprkkrklist
    close(96)
2341 continue
    fullpot=(sprkkrpot.eq.1)
    gglu_save_slice = .false. ! BAM - save slice of g with n=0 in gglu
    return
  end subroutine init_controls

end module controls

      subroutine muatcc(xnval) 
c               * angular coefficients *
c        sous programmes utilises  cwig3j
c
      implicit double precision (a-h,o-z)
      include '../HEADERS/dim.h'
      dimension xnval(30)
      common/itescf/testy,rap(2),teste,nz,norb,norbsc
      common/mulabc/afgkc
      dimension afgkc(-ltot-1:ltot,30,0:3)
      common/ratom1/xnel(30),en(30),scc(30),scw(30),sce(30),
     1nq(30),kap(30),nmax(30)
c#mn
       external cwig3j

      do 511 i=-ltot-1,ltot
      do 511 j=1,30
      do 511 k=0,3
 511  afgkc(i,j,k)=0.0d 00
      do 701 ikap=-ltot-1,ltot
         if (ikap .eq. 0) go to 701
         li= abs(ikap)*2-1
         do 700 j=1,norb-1
            lj= abs(kap(j))*2-1
            kmax=(li+lj)/2
            kmin= abs(li-lj)/2
            if ((ikap*kap(j)).lt.0) kmin=kmin+1
            if (xnval(j) .gt. 0.0d0) goto 700
c calculate b_k(i,j)
            do 675 k = kmin, kmax,2
               index=(k-kmin)/2
               afgkc(ikap,j,index)=xnel(j)*(cwig3j(li,k*2,lj,1,0,2)**2)
 675        continue
 700     continue
 701  continue
      return
      end

      subroutine ykdir (ia,ib,nk1,nag)

      implicit double precision (a-h,o-z)
      save
      common /atomco/ den(30), dq1(30), dfl(30), ws, nqn(30), nql(30),
     1                nk(30), nmax(30), nel(30), norb, norbco
      common /dira/ dv(251), dr(251), dp(251), dq(251), dpas, tets,
     1              z, nstop, nes, np, nuc
      common /deux/ dvn(251), dvf(251), d(251), dc(251), dgc(251,30),
     1 dpc(251,30)
      common /trois/ dpno(4,30), dqno(4,30)
      dimension dpn1(4)
      dpah=exp(dpas)
      dpyk=dpas/24.0
      id=min0(nmax(ia)+2,nmax(ib)+2,np)
      idm1=id-1
      if (nag.ne.0) go to 30
      do 10 i=1,id
   10 dq(i)=dr(i)*(dgc(i,ia)*dgc(i,ib)+dpc(i,ia)*dpc(i,ib))
      do 20 i=1,4
      dpn1(i)=0.0
      do 20 j=1,i
   20 dpn1(i)=dpn1(i)+dpno(j,ia)*dpno(i+1-j,ib)+dqno(j,ia)*dqno(i+1-j,ib
     1 )
      go to 60
   30 do 40 i=1,id
   40 dq(i)=dr(i)*dgc(i,ia)*dpc(i,ib)
      do 50 i=1,4
      dpn1(i)=0.0
      do 50 j=1,i
   50 dpn1(i)=dpn1(i)+dpno(j,ia)*dqno(i+1-j,ib)
   60 di=dfl(ia)+dfl(ib)+nk1
      dp(1)=0.0
      dp(2)=0.0
      do 70 i=1,4
      di=di+1.0
      dp(1)=dp(1)+(dr(1)**di)*dpn1(i)/di
   70 dp(2)=dp(2)+(dr(2)**di)*dpn1(i)/di
      dm=dpah**(-nk1)
      dim2=-dpyk*dm*dm
      dim1=13.0*dpyk*dm
      di=13.0*dpyk
      dip1=-dpyk/dm
      do 80 i=3,idm1
   80 dp(i)=dp(i-1)*dm+dim2*dq(i-2)+dip1*dq(i+1)+dim1*dq(i-1)+di*dq(i)
      dq(id-2)=dp(id-2)
      do 90 i=idm1,np
   90 dq(i)=dq(i-1)*dm
      i=nk1+nk1+1
      dm=dm/dpah
      dim2=i*dim2/(dpah*dpah)
      dim1=i*dim1/dpah
      di=i*di
      dip1=i*dip1*dpah
      i=id-3
  100 dq(i)=dq(i+1)*dm+dim2*dp(i+2)+dip1*dp(i-1)+dim1*dp(i+1)+di*dp(i)
      i=i-1
      if (i-1) 110,110,100
  110 dq(1)=dq(3)*dm*dm+8.0*((di*dp(1)+4.0*dim1*dp(2))/13.0-dim2*dp(3
     1 ))
      return
      end

      subroutine fmstot( rclust, idwopt, tk, thetad, sigma2,
     1                  lmaxph, nat, iphat, ratdbl,
     2                  ipol, ispin, le2, angks, ptz,
     3                  minv, rdirec, toler1, toler2,
     4                  elnes,ipmin,ipmax,ipstep)   !KJ added this line  1-06     
c     Calculates FMS contribution to absorption
c     uses Bruce Ravel subroutine to do FMS in self-consistency loop
c     notice that it can do FMS with polarization dependence and
c     always include l-->l-1 cahnnel.
c     written by alexei ankudinov 06.1997

      implicit double precision (a-h, o-z)
      include '../HEADERS/dim.h'
      include '../HEADERS/const.h'
      include '../HEADERS/parallel.h'
      real*8 wall_commend, wall_commst
      parameter (npadx=8)
      parameter (iblock=1)

c     input
      dimension iphat(natx),  ratdbl(3,natx)
      real rat(3,natx), rclust, rdirec, toler1, toler2
      real rpart,aipart, rnrmax, thetax, temper, sig2
      integer ne, ne1, ne3,  nph, ihole
      dimension iz(0:nphx)
      integer elnes,ipmin,ipmax,ipstep  !KJ added variables 1-06      
c     polarization data
      complex*16 ptz
      dimension ptz(-1:1,-1:1)

c     work space
      complex*16 ph(nex, -ltot:ltot, nspx, 0:nphx)
      dimension lmax(nex, 0:nphx)
c     complex energy grid emg is decomposed into em and eref to have
c     the same structure in phase.pad
      complex*16 em(nex), eref(nex, nspx)
      character*6  potlbl(0:nphx)
      character*(*) phpad
      character*512 slog
c     fms staff
      integer lmaxph(0:nphx)
      integer map(nex)
      complex gg(nspx*(lx+1)**2, nspx*(lx+1)**2, 0:nphx)
      complex gtr(ipmin:ipmax,nex),gtrloc(ipmin:ipmax,nex) !KJ I added ip index 1-06
      complex xphase(nspx, -lx:lx, 0:nphx), ck(nspx)
      complex*16 dck, bmat
      dimension kind(8), lind(8)
      logical ltrace, lcalc
      dimension lcalc(0:lx)
!KJ commented out  1-06    dimension bmat(-lx:lx,0:1,8, -lx:lx,0:1,8)
      dimension bmat(-lx:lx,0:1,8, -lx:lx,0:1,8,ipmin:ipmax) !KJ added last index
      complex*16 rkk(nex,8,nspx)
      complex*16 bmat0(-lx:lx,0:1,8, -lx:lx,0:1,8)  !KJ new variable 1-06      
      complex*16 dum(nex)
      integer  npot, nsp, ie, iverb, lfms
      integer ip,nip !KJ 1-06 added this variable - just local index
      integer i1,i2,i3,i4,i5,i6  !KJ for stupid f77 3-06
      integer jsize !KJ added for MPI communication      
      save

      call setkap (ihole,ikap,linit)

      do 10 ie = 1,nex
      do 10 ip = ipmin,ipmax !KJ I added this line
  10  gtr(ie,ip) = 0  !KJ added ip
  
      do 14 iph = 0,nphx
         do 13 ill = -lx, lx
            do 12 isp =  1,nspx
               xphase(isp, ill, iph) = 0
 12         continue
 13      continue
 14   continue

c     need less data than rphpad.f provides, also dimensions of ph
c     array are different.
      phpad = 'phase.pad'
      call rdxsph (phpad, ne, ne1, ne3, nph, ihole, rnrmav, xmu, edge,
     1     ik0, ixc, rs, vint,
     2     em, eref, iz, potlbl, ph, rkk, lmax, lmaxp1)
      call setkap (ihole, kinit, linit)
      npot = nph
      if (rclust.le.0.0) goto 100

      write(slog,15) ' Number of energy points = ', ne
  15  format(a, i3)
      call wlog(slog)

      do 20 iat=1,nat
      do 20 j=1,3
  20  rat(j,iat) = real (ratdbl(j,iat))

c     transform to single precision
      rnrmax = real(rnrmav)
      temper = real(tk)
      thetax = real(thetad)
      sig2 = real(sigma2)
      idwopx = idwopt

      iph0 = 0
      call xprep(iph0, idwopx, nat, inclus, npot, iphat, rclust,
     1 rat, iz, rnrmax, temper, thetax, sig2, minv, rdirec)

      if (inclus.gt.1) then
cc      call fms for a cluster around central atom
        write (slog,25) inclus, iph0
  25    format 
     1     (' Doing FMS for a cluster of ',i3,' atoms around iph = ',i2)
        call wlog (slog)
        call wlog (' Please, wait (updates every 20 points) ...')

        nsp = 1
        if (abs(ispin).eq.1 ) nsp = nspx
c       if (abs(ispin).eq.1) nsp = 2
c       if (nsp.gt.nspx) call par_stop(' FMS: increase nspx and rerun.')

        ltrace = .false.
!KJ 1-06  I added the do-loop around the call to bcoef for ELNES calcul.
            do i1=1,8
            do i2=0,1
            do i3=-lx,lx
            do i4=1,8
            do i5=0,1
            do i6=-lx,lx
            do ip=ipmin,ipmax
              bmat(i6,i5,i4,i3,i2,i1,ip)=dcmplx(0,0)
            enddo
            enddo
            enddo
            enddo
            enddo
            enddo
            enddo
        do ip=ipmin,ipmax,ipstep
                open(7,file='ptz.dat',form='formatted',status='unknown')
            if (elnes.eq.1) call iniptz(ptz,ip,2)  !KJ Only change ptz for ELNES !!
            call bcoef(kinit, ipol, ptz, le2, ltrace, ispin, angks, 
     1           kind, lind, bmat0)
                do i=-1,1
                write(7,'(i3,6f10.3)') ip,(ptz(i,i1),i1=-1,1)
                enddo
            do i1=1,8
            do i2=0,1
            do i3=-lx,lx
            do i4=1,8
            do i5=0,1
            do i6=-lx,lx
              bmat(i6,i5,i4,i3,i2,i1,ip)=bmat0(i6,i5,i4,i3,i2,i1)
            enddo
            enddo
            enddo
            enddo
            enddo
            enddo
!!                 bmat(:,:,:,:,:,:,ip)=bmat0(:,:,:,:,:,:)
        enddo
c !KJ end my changes to the call to bcoef        

        istart = this_process*iblock + 1
        isize = 0
        do 90 ii=istart,ne,numprocs*iblock
           do 90 ie = ii, MIN(ii+iblock-1,ne) 
            if (worker) par_type = 3
          do 30  isp = 1, nsp
            dck=sqrt(2*(em(ie)-eref(ie,isp)))
            rpart  = real( dble(dck))
            aipart = real(dimag(dck))
            ck(isp) = cmplx(rpart, aipart)
  30      continue
          do 35 ipp = 0,nph
          do 35 isp = 1, nsp
          do 35 ill = -lmaxph(ipp), lmaxph(ipp)
              rpart  = dble( ph(ie, ill, isp, ipp))
              aipart = dimag(ph(ie, ill, isp, ipp)) 
              xphase(isp, ill, ipp) = cmplx(rpart, aipart)
  35      continue
          iverb=0
          if (mod(ie,20) .eq. 0) iverb=1

          lfms = 0
          do 68  k1 = 0, lx
  68      lcalc(k1) = .false.
          do 69  k1 = 1,8
  69      if (lind(k1).ge.0.and.lind(k1).le.lx) lcalc(lind(k1)) = .true.
          call fms(lfms, nsp, ispin, inclus, npot, ck, lmaxph, xphase,
     1         ie, iverb, minv, rdirec, toler1, toler2, lcalc, gg)

          do 70  k1 = 1,8
          do 70  is1 = 1,nsp
          do 70  k2 = 1,8
          do 70  is2 = 1,nsp
            ind = ms1 + 2 * ms2
            ix1 = nsp * ( lind(k1)**2 +  lind(k1) )
            ix2 = nsp * ( lind(k2)**2 +  lind(k2) )
            ms1 = is1 - 1
            ms2 = is2 - 1
            if (lind(k2).ge.0 .and. lind(k1).ge.0) then
             do 60  m1=-lind(k1), lind(k1)
             do 60  m2=-lind(k2), lind(k2)
             
             
c !KJ I added the do-loop around the calculation of gtr for elnes
c  calculations.  1-06
    
c !KJ original call :
c !KJ              gtr(ie)=gtr(ie) + gg(ix1+nsp*m1+is1, ix2+nsp*m2+is2,0) *
c !KJ     1        bmat(m2,ms2,k2, m1,ms1,k1) * rkk(ie,k1,is1)*rkk(ie,k2,is2)
               do ip=ipmin,ipmax,ipstep
                 gtr(ip,ie) = gtr(ip,ie) +
     1                        gg(ix1+nsp*m1+is1,ix2+nsp*m2+is2,0) *
     2                        bmat(m2,ms2,k2, m1,ms1,k1,ip)
     3                      * rkk(ie,k1,is1)*rkk(ie,k2,is2)
               enddo
c !KJ end my changes
               

 60          continue

            endif
 70       continue
          
          if (worker) then
            isize = isize + 1
            do ip=ipmin,ipmax
            gtrloc(ip,isize) = gtr(ip,ie)  !KJ added :,  1-06
            enddo
          endif
 90     continue
        if (worker) par_type = 2
      endif

      nip=ipmax-ipmin+1 !KJ 1-06
      jsize=isize*nip !KJ

      if (numprocs .gt. 1) then
        call seconds(wall_commst)
c Collect gtr
        if (worker) then
c-- Send pointers for gtr buffer to master
          call par_send_int(jsize,1,0,this_process) !KJ isize -> jsize 1-06
c-- Send buffer
          if (jsize .ne. 0) 
     .      call par_send_cmplx(gtrloc,jsize,0,this_process) !Josh Kas isize -> jsize
        else
c Set up map of gtr to processor 
          do is = 1,numprocs-1
            istart = is*iblock + 1 
            do ii=istart,ne,numprocs*iblock
              do ie = ii, MIN(ii+iblock-1,ne) 
                 map(ie) = is
              enddo
            enddo
          enddo
          do i = 1,numprocs-1
c-- Receive pointers for gtr buffer from i
            call par_recv_int(jsize,1,i,i) !KJ isize -> jsize  1-06
c-- Receive buffer from i
            if (jsize .ne. 0) then
              call par_recv_cmplx(gtrloc,jsize,i,i) !Josh Kas isize -> jsize
              indx = 1
              do j = 1,ne
                if (map(j) .eq. i) then
c                 Josh Kas - changed gtrloc(ipmin:ipmax,indx)
                  do ip=ipmin,ipmax
                  gtr(ip,j) = gtrloc(ip,indx) !indx:indx+nip-1) !KJ used to be gtr(j)=gtrloc(indx) 
                  enddo
                  indx = indx + 1  !KJ replaced 1 by nip   1-06 - Josh Kas - nip back to 1
                endif
              enddo
            endif
          enddo
        endif
        call seconds(wall_commend)
        wall_comm = wall_comm + wall_commend - wall_commst
      endif

c     write fms.bin


 100  continue
      if (master) then
        open (unit=1, file='fms.bin', status='unknown', iostat=ios)
c        write down title line
         write(1,105) rclust*bohr
 105     format('FMS rfms=', f7.4)
         write(1, 110) ne, ne1, ne3,  nph, npadx, nip  !KJ added nip 1-06
 110     format(6(1x,i3))  !KJ changed 5 to 6
         do ip=ipmin,ipmax      !KJ I added the do loop
            do 120 ie = 1, ne
               aa = dble ( real ( gtr(ip,ie) ) ) !KJ I added ip index
               bb = dble (aimag ( gtr(ip,ie) ) ) !KJ ditto
               dum(ie) = dcmplx (aa,bb) !KJ ditto
 120        continue
            call wrpadx(1, npadx, dum(1), ne)
         enddo                  !KJ end of my loop
         close (unit=1)
      endif
      call par_barrier

      return
      end

      subroutine intdir(gg,gp,ag,ap,ggmat,gpmat,en,fl,agi,api,ainf,max0)
c            solution of the inhomogenios dirac equation
c gg gp initially exch. terms, at the time of return are wave functions
c ag and ap development coefficients of  gg and gp
c ggmat gpmat  values at the matching point for the inward integration
c en one-electron energy
c fl power of the first development term at the origin
c agi (api) initial values of the first development coefficients
c at the origin of a large (small) component
c ainf initial value for large component at point dr(max0) 
c   - at the end of tabulation of gg gp
 
      implicit double precision (a-h,o-z)
      common/comdir/cl,dz,bid1(522),dv(251),av(10),bid2(522)
      common/tabtes/hx,dr(251),test1,test2,ndor,np,nes,method,idim
      common/subdir/ell,fk,ccl,imm,nd,node,mat
      common/messag/dlabpr,numerr
      character*8 dlabpr
      dimension gg(251),gp(251),ag(10),ap(10),coc(5),cop(5),dg(5),dp(5)
      save
      data cop/2.51d+02,-1.274d+03,2.616d+03,-2.774d+03,1.901d+03/,
     1coc/-1.9d+01,1.06d+02,-2.64d+02,6.46d+02,2.51d+02/,
     2cmixn/4.73d+02/,cmixd/5.02d+02/,hxd/7.2d+02/,npi/5/,icall/0/
 
c numerical method is a 5-point predictor-corrector method
c predicted value    p(n) = y(n-1) + c * somme de i=1,5 cop(i)*y'(n-i)
c corrected value    c(n) = y(n-1) + c * somme de i=1,4 coc(i)*y'(n-i)
c                                  + coc(5)*p'(n)
c final value        y(n) = cmix*c(n) + (1.-cmix)*p(n)
c                           cmix=cmixn/cmixd
 
      if (icall.eq.0) then
         icall=1
         c=cmixn/cmixd
         a=1.0d 00-c
         cmc=c*coc(5)
         f=coc(1)
         do 1 j=2,npi
            g=coc(j)
            coc(j)=c*f+a*cop(j)
 1          f=g
         coc(1)=c*cop(1)
      endif
      c=hx/hxd
      ec=en/cl
      ag(1)=agi
      ap(1)=api
      if (imm) 81,15,26
c      search for the second sign change point
 15   mat=npi
      j=1
 16   mat=mat+2
         if (mat.ge.np) then
c   i had trouble with screened k-hole for la, for f-electrons.
c   below i still define matching point if one electron energy not less
c   than -1ev.
            if (ec .gt. -0.0003) then
              mat = np - 12
              go to 25
            endif
            numerr=56011
c          * fail to find matching point
            return
         endif
         f=dv(mat)+ell/(dr(mat)*dr(mat))
         f=(f-ec)*j
         if (f) 25,25,16
 25      j=-j
      if (j.lt.0) go to 16
      if (mat .ge. np-npi) mat=np-12
 
c     initial values for the outward integration
 26   do 35 j=2,ndor
         k=j-1
         a=fl+fk+k
         b=fl-fk+k
         ep=a*b+av(1)*av(1)
         f=(ec+ccl)*ap(k)+ap(j)
         g=ec*ag(k)+ag(j)
         do 31 i=1,k
            f=f-av(i+1)*ap(j-i)
 31         g=g-av(i+1)*ag(j-i)
 
         ag(j)=(b*f+av(1)*g)/ep
 35      ap(j)=(av(1)*f-a*g)/ep
      do 41 i=1,npi
         gg(i)=0.0d 00
         gp(i)=0.0d 00
         dg(i)=0.0d 00
         dp(i)=0.0d 00
         do 41 j=1,ndor
            a=fl+j-1
            b=dr(i)**a
            a=a*b*c
            gg(i)=gg(i)+b*ag(j)
            gp(i)=gp(i)+b*ap(j)
            dg(i)=dg(i)+a*ag(j)
 41         dp(i)=dp(i)+a*ap(j)
      i=npi
      k=1
      ggmat=gg(mat)
      gpmat=gp(mat)
 
c     integration of the inhomogenious system
 51   cmcc=cmc*c

 55   continue
         a=gg(i)+dg(1)*cop(1)
         b=gp(i)+dp(1)*cop(1)
         i=i+k
         ep=gp(i)
         eg=gg(i)
         gg(i)=a-dg(1)*coc(1)
         gp(i)=b-dp(1)*coc(1)
         do 61 j=2,npi
            a=a+dg(j)*cop(j)
            b=b+dp(j)*cop(j)
            gg(i)=gg(i)+dg(j)*coc(j)
            gp(i)=gp(i)+dp(j)*coc(j)
            dg(j-1)=dg(j)
 61         dp(j-1)=dp(j)
         f=(ec-dv(i))*dr(i)
         g=f+ccl*dr(i)
         gg(i)=gg(i)+cmcc*(g*b-fk*a+ep)
         gp(i)=gp(i)+cmcc*(fk*b-f*a-eg)
         dg(npi)=c*(g*gp(i)-fk*gg(i)+ep)
         dp(npi)=c*(fk*gp(i)-f*gg(i)-eg)
      if (i.ne.mat) go to 55

      if (k.lt.0) go to 999
      a=ggmat
      ggmat=gg(mat)
      gg(mat)=a
      a=gpmat
      gpmat=gp(mat)
      gp(mat)=a
      if (imm.ne.0) go to 81
 
c     initial values for inward integration
      a=test1* abs(ggmat)
      if (ainf.gt.a) ainf=a
      max0=np+2
 73   a=7.0d+02/cl
 75   max0=max0-2
         if ((max0+1).le.(mat+npi)) then
            numerr=138021
c          *the last tabulation point is too close to the matching point
            return
         endif
      if (((dv(max0)-ec)*dr(max0)*dr(max0)).gt.a) go to 75

 81   c=-c
      a=- sqrt(-ec*(ccl+ec))
      if ((a*dr(max0)).lt.-1.7d+02) go to 73
      b=a/(ccl+ec)
      f=ainf/ exp(a*dr(max0))
      if (f.eq.0.0d 00) f=1.0d 00
      do 91 i=1,npi
         j=max0+1-i
         gg(j)=f* exp(a*dr(j))
         gp(j)=b*gg(j)
         dg(i)=a*dr(j)*gg(j)*c
 91      dp(i)=b*dg(i)
      i=max0-npi+1
      k=-1
      go to 51

 999  return
      end

      subroutine json_read_geom(nat, nph, iatph, rat, iphat, ibounc)

      use json_module
      implicit double precision (a-h, o-z)

      include '../HEADERS/const.h'
      include '../HEADERS/dim.h'

      logical :: found
      type(json_file) :: json   !the JSON structure read from the file:
      integer,dimension(:),allocatable :: intgs, intgb
      double precision,dimension(:),allocatable :: dbpcs, dbpcy, dbpcz

      integer nat, nph, iatph(0:nphx), iphat(natx), ibounc(natx)
      double precision  rat(3,natx)

      nph = 0
      do 10 iph = 0, nphx
         iatph(iph) = 0
 10   continue

      call json_initialize()
      call json%load_file(filename='geom.json')
      if (json_failed()) then   !if there was an error reading the file
         print *, "failed to read geom.json"
         stop
      else
         call json%get('natt',   nat, found)
                   if (.not. found) call bailout('natt', 'geom.json')
c         call json%get('nph',   nph, found)
c                   if (.not. found) call bailout('nph', 'geom.json')
c         call json%get('iatph', intgs, found)
c                   if (.not. found) call bailout('iatph', 'geom.json')
c         do 2000 iph = 0, nphx
c            iatph(iph) = intgs(iph+1)            
c 2000    continue
         call json%get('x', dbpcs, found)
                   if (.not. found) call bailout('x', 'geom.json')
         call json%get('y', dbpcy, found)
                   if (.not. found) call bailout('y', 'geom.json')
         call json%get('z', dbpcz, found)
                   if (.not. found) call bailout('z', 'geom.json')
         call json%get('iph', intgs, found)
                   if (.not. found) call bailout('iph', 'geom.json')
         call json%get('ibo', intgb, found)
                   if (.not. found) call bailout('ibo', 'geom.json')
         do 20 i=1,nat
            iphat(i)  = intgs(i)
            rat(1,i)  = dbpcs(i)
            rat(2,i)  = dbpcy(i)
            rat(3,i)  = dbpcz(i)
            ibounc(i) = intgb(i)
c     iatph is NOT set from the similar line written to geom.json
c     this line follows how iatph was set as data was read from geom.dat
            if (iphat(i).gt.nph) nph = iphat(i)
            if ( iatph(iphat(i)).eq.0) iatph(iphat(i)) = i
 20      continue
      end if
      call json%destroy()
         
      return
      end

      subroutine libpotph(phpad, verbse,
     1       ntitle, title,                                             ! TITLE
     2       nat, rat, iphat,                                           ! ATOMS
     3       nph, iz, potlbl, lmaxsc, lmaxph, xnatph, spinph,           ! POTENTIALS
     4       ihole,                                                     ! HOLE/EDGE
     5       rfms1, lfms1, nscmt, ca1, nmix, ecv, icoul,                ! SCF
     6       ipol, evec, elpty, xivec,                                  ! POLARIZATION, ELLIPTICITY
     7       ispin, spvec, angks,                                       ! SPIN
     8       ptz, gamach,                                               ! computed
     9       ixc, vr0, vi0, ixc0,                                       ! EXCHANGE
     _       iafolp, folp, xion, rgrd, iunf,                            ! AFOLP, FOLP, ION, RGRID, UNFREEZEF
     1       inters, totvol, jumprm, nohole,                            ! INTERSTITIAL, JUMPRM, NOHOLE
     2       iplsmn)                                                    ! PLASMON
      
c##****f* feff85exafs/libpotph
c##  NAME
c##     libpotph
c##
c##  SYNOPSIS
c##     libpotph(ntitle, title, nat, rat, iphat, nph, iz, potlbl, lmaxsc,
c##    $         lmaxph, xnatph, spinph, ihole, rfms1, lfms1, nscmt, ca1,
c##    $         nmix, ecv, icoul, ipol, evec, elpty, xivec, ispin, spvec,
c##    $         angks, ptz, gamach, ixc, vr0, vi0, ixc0, iafolp, folp,
c##    $         xion, rgrd, iunf, inters, totvol, jumprm, nohole)
c##
c##  FUNCTION
c##     compute potentials and phases from an input atoms list
c##
c##  INPUTS
c##    phpad         path/name of output phases.pad file
c##    verbse        boolean flag, true=write screen messages
c##    ntitle        number of header lines                               TITLE
c##    titles        (nheadx) array of header string                      TITLE
c##    nat           number of atoms in cluster                           ATOMS
c##    rat           (3,natx) cartesian coordinates of atoms in cluster   ATOMS
c##    iphat         (natx) unique potential indeces of atoms in cluster  ATOMS
c##    nph           number of unique potentials                          POTENTIALS
c##    iz            (0:nphx) Z numbers of unique potentials              POTENTIALS
c##    potlbl        (0:nphx) labels of unique potentials                 POTENTIALS
c##    lmaxsc        (0:nphx) l max for SCF for each potential            POTENTIALS
c##    lmaxph        (0:nphx) l max for FMS for each potential            POTENTIALS
c##    xnatph        (0:nphx) stoichiometry of each potential             POTENTIALS
c##    spinph        (0:nphx) spin on each unique potential               POTENTIALS
c##    ihole         edge index, 1=K, 4=L3, etc                           HOLE/EDGE
c##    rscf          cluster radius for self-consistent calculation       SCF
c##    lscf          0=solid, 1=molecule                                  SCF
c##    nscmt         max number of self-consistency iterations            SCF
c##    ca            self-consistency convergence accelerator             SCF
c##    nmix          number of mixing iterations before Broyden           SCF
c##    ecv           core/valence separation energy                       SCF
c##    icoul         obsolete param. for handling Coulomb potential       SCF
c##    ipol          1=do polarization calculation                        POLARIZATION
c##    evec          (3) polarization array                               POLARIZATION
c##    elpty         eccentricity of elliptical light                     ELLIPTICITY
c##    xivec         (3) ellipticity array                                ELLIPTICITY
c##    ispin         +/-2 = do spin calculation                           SPIN
c##    spvec         (3) spin array                                       SPIN
c##    angks         angle between spin and incidient beam                SPIN
c##    ixc           exchange index                                       EXCHANGE
c##    vr0           Fermi level offset                                   EXCHANGE
c##    vi0           constant broadening                                  EXCHANGE
c##    ixc0          exchange index for background function               EXCHANGE
c##    iafolp        1=do automated overlapping                           FOLP & AFOLP
c##    folp          (0:nphx) overlapping fractions                       FOLP & AFOLP
c##    xion          (0:nphx) potential ionizations                       ION
c##    rgrd          radial grid used for the potentials/phases           RGRID
c##    iunf          1=unfreeze f electrons                               UNFREEZEF
c##    inters                                                             INTERSTITIAL
c##    totvol                                                             INTERSTITIAL
c##    jumprm        1=remove potential jumps at muffin tin radii         JUMPRM
c##    nohole        1=compute without core-hole                          NOHOLE
c##    iplsmn        1=compute multi-pole self-energy                     PLASMON
c##
c##  RESULT
c##    ptz           (-1:1,-1:1) polarization tensor
c##    gamach        tabulated core-hole lifetime
c##
c##  BUGS
c##    Report bugs and other issues at https://github.com/xraypy/feff85exafs
c##
c##  LICENSE
c##    See src/HEADERS/license.h for the terms of the parts of feff85exafs derived directly from Feff
c##
c##    nxjson.c and nxjson.h are Copyright (c) 2013 Yaroslav Stavnichiy <yarosla@gmail.com>.  See
c##    https://bitbucket.org/yarosla/nxjson/src
c##
c##    The C wrapper around this subroutine is released to the public domain
c##
c##  SEE ALSO
c##    The pot and xsph stand-alone programs, the libfeffphases.c wrapper
c##
c##****


      implicit double precision (a-h, o-z)

      include '../HEADERS/const.h'
      include '../HEADERS/dim.h'
      include '../HEADERS/parallel.h'


c     dimension/types of atoms & global.json things
      integer nat, iphat(natx), nabs, iphabs, ipol, ispin, le2, iabs
      double precision evec(3), xivec(3), spvec(3), elpty,angks,rclabs
      complex*16 ptz(-1:1, -1:1)
      double precision rat(3,natx)

c     name of output phase.pad file
      character*256 phpad
      logical verbse

c     dimension/type os mod1/pot things
      integer  iatph(0:nphx)
c      integer ibounc(natx)
      character*80 title(nheadx)
c      character*80 head(nheadx)
c      integer lhead(nheadx)
c      integer mpot, mphase
      integer nph, ntitle, ihole, ipr1, iafolp, ixc, 
     1       iunf, nmix, nohole, jumprm, inters, nscmt, icoul, lfms1
      integer iz(0:nphx), lmaxsc(0:nphx)
      real rfms1
      double precision gamach, rgrd, ca1, ecv, totvol
      dimension xnatph(0:nphx), folp(0:nphx), xion(0:nphx)

c     dimension/type os mod2/xpsh things
      integer ipr2, ixc0, ispec, lreal, lfms2, l2lp, iplsmn
c      integer iGrid
      double precision xkstep, xkmax, vixan
      double precision vr0, vi0, spinph(0:nphx)
      real rfms2
      integer lmaxph(0:nphx)
      character*6  potlbl(0:nphx)
      integer izstd, ifxc, ipmbse, itdlda, nonlocal

c     for OVERLAP option -- DISABLED IN FEFF85EXAFS
      dimension novr(0:nphx), iphovr(novrx,0:nphx), nnovr(novrx,0:nphx)
      dimension rovr(novrx,0:nphx)

      parameter (big = 1.0d5)


c**********************************************************************
c     these parameters pass stuff from pot to wrpot and xsph
      double precision rnrmav, xmu, vint, rhoint, emu, s02, erelax
      double precision wp, rs, xf, qtotel
c     r mesh index just inside rmt
      dimension imt(0:nphx)
c     r mesh index just inside rnorman
      dimension inrm(0:nphx)
c     muffin tin radius
      dimension rmt(0:nphx)
c     norman radius
      dimension rnrm(0:nphx), qnrm(0:nphx)
c     folp(0:nphx)  - overlap factor for rmt calculation
      dimension folpx(0:nphx)
c     need irregular solution for complex potential. fix later
      dimension dgc0(251), dpc0(251)
c     additional data needed for relativistic version
      dimension dgc(251,30,0:nphx+1), dpc(251,30,0:nphx+1)
      dimension adgc(10,30,0:nphx+1), adpc(10,30,0:nphx+1)
c     Overlap calculation results
c     overlapped density*4*pi
      dimension edens(251,0:nphx)
c     overlapped coul pot
      dimension vclap(251,0:nphx)
c     overlapped total potential
      dimension vtot (251,0:nphx)
      dimension edenvl(251,0:nphx)
      dimension vvalgs (251,0:nphx)
      dimension dmag(251,0:nphx+1)
      dimension xnval(30,0:nphx+1)
      dimension eorb(30,0:nphx+1)
      dimension kappa(30,0:nphx+1), iorb(-4:3,0:nphx+1)
      dimension xnmues(0:lx,0:nphx)
c     Josh use nhtmp to save nohole value
      integer nhtmp


      logical write_loss, write_opcons, write_exc, verbose
      integer npoles
      double precision eps0
      double precision wpcorr(MxPole), delta(MxPole), ampfac(MxPole)


      
c      print *, "libpotph: >", phpad(1:istrln(phpad)), "<"
c*****************************************************************************
c     the following parameters are for features not present or not used
c     in feff85exafs
c     they are all set to default/turned-off values

c     CONTROL and PRINT (ipr1=1 for misc.dat)
c      mpot     = 1
c      mphase   = 1
      ipr1     = 0
      ipr2     = 0
c     ispec=0 for EXAFS, >0 other spectroscopies
      ispec    = 0
c     CFAVERAGE
      nabs     = 1
      iphabs   = 0
      rclabs   = big
c     MULTIPOLE
      le2      = 0
      l2lp     = 0
c     FMS
      rfms2    = real(-1.)
      lfms2    = 0
c     XANES
      vixan    = dble(0) / hart
      xkstep   = dble(0.07) * bohr
      xkmax    = dble(20) * bohr
c     RPHASES
      lreal    = 0
c     PMBSE
      ifxc     = 0
      ipmbse   = 0
      nonlocal = 0
c      ibasis   = 0
c     TDLDA
      izstd    = 0
      itdlda   = 0
c     PLASMON
c      iGrid    = 0

c     OVERLAP
      do 20 i=0,nphx
         novr(i) = 0;
         do 10 j=1,novrx
            iphovr(j,i) = 0
            nnovr(j,i)  = 0
            rovr(j,i)   = dble(0.)
 10      continue
 20   continue
c      do 30 i=1,natx
c         ibounc(i) = 1
c     30   continue

c     multi-pole stuff      
      write_loss   = .false.
      write_opcons = .false.
      write_exc    = .false.
      verbose      = .false.
      npoles       = 100
      eps0         = -1.d0
      do 40 i=1,MxPole
         wpcorr(i) = 0.d0
c        gamma ?
         delta(i)  = 0.d0
         ampfac(i) = 0.d0
 40   continue
      
      
c*****************************************************************************

c$$$         print *, 1, rat(1,1), rat(2,1), rat(3,1), iphat(1)
c$$$         print *, 2, rat(1,2), rat(2,2), rat(3,2), iphat(2)
c$$$         print *, 3, rat(1,3), rat(2,3), rat(3,3), iphat(3)
c$$$         print *, 13, rat(1,13), rat(2,13), rat(3,13), iphat(13)
c$$$         print *, 23, rat(1,23), rat(2,23), rat(3,23), iphat(23)
c$$$         print *, 177, rat(1,177), rat(2,177), rat(3,177), iphat(177)
c$$$


c     iabs != 0 has something to do with CFAVERAGE, outside scope of feff85exafs
      iabs = 1

      call ffsort(iabs, nat, rat, iphat,
     1       nabs, iphabs, rclabs, ipol, ispin, le2,
     2       elpty, angks, evec, xivec, spvec, ptz,
     3       iatph)

      call pot(verbse, rgrd, nohole,
     $       inters, totvol, ecv, nscmt, nmix, ntitle, title,
     $       nat, nph, ihole, iafolp, ixc, iphat, rat, iatph, xnatph,
     $       novr, iphovr, nnovr, rovr, folp, xion, iunf, iz, ipr1,
     $       ispec, jumprm, lmaxsc, icoul, ca1, rfms1, lfms1,
     $
     -       rnrmav, xmu, vint, rhoint,
     1       emu, s02, erelax, wp, rs, xf, qtotel,
     2       imt, rmt, inrm, rnrm, folpx,
     3       dgc0, dpc0, dgc, dpc, adgc, adpc,
     4       edens, vclap, vtot, edenvl, vvalgs, dmag, xnval,
     5       eorb, kappa, iorb, qnrm, xnmues, nhtmp
     6       )
c     return stuff for passing to xsph and skipping pot.pad

c     could make a conditional call to wrpot here

      if (iplsmn .gt. 0) then
c         call feffloss(nph, iz, xnatph, rnrm, npoles, eps0,
c     1          write_opcons, write_loss, write_exc, verbose,
c     2          wpcorr, gamma, ampfac, delta)
      end if
c     need to send <<wpcorr, gamma, ampfac, delta>> into xsph, then into
c     phase and xsect for use when iplsmn is > 0

c               wrxsec      
      call xsph(.false., verbse, phpad,
     -       ipr2, ispec, vixan, xkstep, xkmax, gamach, rgrd,
     1       nph, lmaxph, potlbl, spinph, iatph, nat, rat, iphat,
     2       ixc, vr0, vi0, ixc0, lreal, rfms2, lfms2, l2lp,
     3       ipol, ispin, le2, angks, ptz, iplsmn,
     4       izstd, ifxc, ipmbse, itdlda, nonlocal,
     _
     1       ntitle, title, rnrmav, xmu, vint, rhoint,
     2       emu, s02, erelax, wp, ecv, rs, xf, qtotel,
     3       imt, rmt, inrm, rnrm, folp, folpx, xnatph,
     4       dgc0, dpc0, dgc, dpc, adgc, adpc,
     5       edens, vclap, vtot, edenvl, vvalgs, dmag, xnval,
     6       iorb, nohole, ihole,
     7       inters, totvol, iafolp, xion, iunf, iz, jumprm)
c     second block is the parameters from rdpot, skipping pot.pad

      return
      end

      subroutine xprep(iph0, idwopt, nat, inclus, npot,
     $            iphat, rmax, rat,
     $            izx, rnrmav, temper, thetad, sig2,
     $            minv, rdirec )

      implicit real (a-h,o-z)
      implicit integer (i-n)
c--------------------------------------------------------------------
c This subroutine prepares geometrical information for a subsequent
c call to the fms full multiple scattering package.  Information is
c passed to fms via common blocks (which live in header files during
c development).
c
c These header files are required:  dim.h xparam.h  xstruc.h
c dim.h and xparam.h must be included in the calling routine
c This routine calls wlog, so must be compiled with it
c
c This is the main file of xpreppack for use with the full multiple
c scattering package (fmspack).  The calling protocol for xpreppack
c and fmspack is;
c
c      include '../HEADERS/dim.h'
c      include 'xparam.h'
c      ...
c      call xprep(iph0, idwopt, nat, inclus, npot, iphat, rmax, rat,
c $        izx, rnrmav, temper, thetad)
c      energy loop {
c         ...
c         call fms(nsp, inclus, npot, ck, lipotx, xphase, ik, iverb, gg)
c         ... }
c
c xpreppack contains the following routines:
c   xprep:  main routine of xpreppack
c   getang: determine angles between the z axis and all pairs of atoms
c   rotxan: get all rotation matrix elements for the cluster
c   rotint: initialize arrays used in the construction of rotation
c           matrices
c   sortat: organize atoms and potentials lists for computational and
c             organizational efficiency
c   atheap: heap sort extended cluster by distance from central atom
c   xanlm:  get all legendre normalization factor
c   factst: part of legendre factor computation
c
c xpreppack currently supports use of the Debye-Waller factors for
c   estimating the effect of thermal disorder on the xanes spectrum.
c   It does this by filling a matrix with the pairwise mean square
c   displacement between atoms.  Other forms of this calculation may
c   be included in the future.  Note that it is strictly impossible
c   to correctly model disorder in the MS scattering contribution to
c   the spectrum when using the FMS technique.
c--------------------------------------------------------------------
c  input:
c     iph0:   potential index for DOS calculations (added by ala to
c             handle other-than-the-central atom) (iph0=0 for the
c             absorbing atom)
c     nat:    number of atoms in extended cluster
c     npot:   number of unique potentials in cluster
c     iphat:  (natxx) potential index for each atom in extended
c             cluster
c     rmax:   radial size of cluster
c     rat:    (3, natxx) coordiantes of each atom in extended cluster
c             as read from geometry file
c  input for correlated debye model:
c     izx:    (natxx) Z number of each atom in the cluster
c     rnrmav: average norman radius in cluster (from phase.pad)
c     temper: sample temperature
c     thetad: Debye temperature
c
c  output:
c     inclus: number of atoms in cluster (inclus <= nat)
c
c  output (all via commmon blocks in xstruc.h):
c     xphi:  matrix of angles between the z axis and pairs of atoms
c     xrat:  xyz coordinates of the atoms in the cluster, the first
c            npot+1 entries are examples of each unique potential
c     iphx:  potential indeces of each atom in the cluster, ordered
c            like xrat
c     drix:  huge matrix containing all rotation matrix elements
c            needed for computation of free elctron propagators
c     xnlm:  matrix of legendre polynomial normalization factors
c--------------------------------------------------------------------

      include '../HEADERS/dim.h'
      include '../HEADERS/const.h'
      include '../HEADERS/parallel.h'
      include 'xparam.h'
c====================================================================
c  This header file contains the structural information about the
c  cluster to be used for the full multiple scattering calculation

      common /xstruc/ xphi(nclusx,nclusx), xrat(3,nclusx),
     $            iphx(nclusx)
      save /xstruc/

c  xphi:  matrix of angles between the z axis and pairs of atoms
c  xrat:  xyz coordinates of the atoms in the cluster, the first
c         npot+1 entries are examples of each unique potential
c  iphx:  potential indeces of each atom in the cluster, ordered like
c         xrat
c********************************************************************
c**** rotation matrices for entire cluster
      complex drix
      common /rotx/ drix(-lx:lx, -lx:lx, 0:lx, 0:1, nclusx, nclusx)
      save /rotx/
c********************************************************************
c common blocks for saving rotation matrices between xanes and rotxan
       integer    jsavx, jsav, jbmagk
       parameter (jsavx = 150, roteps = 1.e-12,jbmagk=-9999)
       dimension drisav(-lx:lx,-lx:lx,0:lx,jsavx), betsav(jsavx)
       integer   ldsav(jsavx), mdsav(jsavx)
       common /rotsav/  drisav, betsav, ldsav, mdsav, jsav
       save  /rotsav/
c********************************************************************
c**** legendre polynomial normalization constants
c
      common /lnlm/ xnlm(0:lx,0:lx)
      save   /lnlm/

c********************************************************************
c**** legendre polynomial normalization constants
c
      common /xdwf/ sigsqr(nclusx,nclusx)
      save   /xdwf/
c********************************************************************
c**** save Clebsch-Gordon coefficients: <LS|J>
      dimension t3jp(0:lx, -lx:lx, 2), t3jm(0:lx, -lx:lx, 2)
      common /t3j/ t3jp, t3jm
      save   /t3j/
c********************************************************************
      integer   iphat(natxx), iphat2(natxx), izx(0:nphasx), izpair(0:2)
      dimension rat(3,natxx), rat2(3,natxx)
      double precision ra(natxx)
      character*78 line
c     sigms is written in double precision.  these are the variables
c     that it uses
      double precision dtemp, dthet, drs, dsigsq, pair(3,0:2)
      double precision sig2mx, sig2x(0:nphx,0:nphx)
c     iwarn - needed to wrtite waqrning just one time
      integer iwarn
      save iwarn
      data  iwarn /0/
      double precision cwig3j
      external cwig3j

c     Josh - logical flag for reading in dw factors
      logical readdw
c     Josh END

c  initialize geometrical arrays
      do 30 i=1,nclusx
        do 10 j=1,nclusx
          xphi(j,i) = zero
 10     continue
        do 20 j=1,3
          xrat(j,i) = zero
 20     continue
        iphx(i) = 0
 30   continue
      inclus = 0

c --- find the central atom, ipot=iph0 (iph0=0 for the absorbing atom)
      icen = 0
      do 40 i=1,nat
        iphat2(i) = iphat(i)
        if (iphat(i).eq.iph0) then
            if (icen.eq.0) then
                icen = i
            elseif (iph0.eq.0) then
                call wlog('* * * ERROR!  More than one atom '//
     $                      'in the extended cluster have ipot=0')
                call wlog('      You may only have one central atom.')
                call wlog('      Stopping in xprep.')
                call par_stop('XPREP-1')
            endif
        endif
 40   continue
c --- make sure central atom is at (0,0,0)
      do 45 i=1,nat
        rat2(1,i) = rat(1,i)-rat(1,icen)
        rat2(2,i) = rat(2,i)-rat(2,icen)
        rat2(3,i) = rat(3,i)-rat(3,icen)
 45   continue

c --- sort the atoms from extended cluster by distance from central
c     atom.
      call atheap(nat, rat2, iphat2, ra)

c --- define cluster from extended cluster by as those closer than
c     rmax to central atom
      inclus=0
      rmax2 = rmax**2
      do 50 i=1,nat
        rr = (rat2(1,i)**2 + rat2(2,i)**2 + rat2(3,i)**2)
        if (rr .gt. rmax2) then
            inclus = i-1
            goto 60
        endif
 50   continue
 60   continue
      if (inclus.eq.0) inclus=nat

c --- sanity check size of cluster
      if (inclus.gt.nclusx) then
        if (iwarn.eq.0) then
          call wlog('* * * WARNING preparing cluster for '//
     $                'FMS calculation.')
          write(line,400) inclus
 400      format('      You specified a cluster of ', i3,
     $                ' atoms for the FMS calculation.')
          call wlog(line)
          write(line,410)nclusx
          call wlog(line)
 410      format('      This exceeds the hard wired limit of ', i3,
     $                ' atoms.')
          write(line,420)nclusx
          call wlog(line)
 420      format('      The cluster size was reset to ', i3,
     $                ' and the calculation will continue.')
          iwarn = 1
        endif
        inclus = nclusx
      endif

c --- make the first few entries in xrat represent each of the
c     unique potentials, sorting around the chosen center
c     (iph0=0 for the absorbing atom)
c     call sortat(iph0, inclus, npot, iphat2, iphx, rat2, xrat)
      do 430 iat = 1, inclus
          iphx(iat) = iphat2(iat)
          xrat(1,iat) = real (rat2(1,iat))
          xrat(2,iat) = real (rat2(2,iat))
          xrat(3,iat) = real (rat2(3,iat))
 430  continue

c --- Calculate and store rotation matrix elements and phi angles
c     the k loop calculates the forward then the backward rotation
c     for an atom pair (ij). k = 0-->forward, 1-->backward
      call rotint
      lplus1 = lx+1
      mplus1 = lx+1
      do 150  i=1,inclus
        do 140 j=1,inclus
          rr = (xrat(1,i)-xrat(1,j))**2 + (xrat(2,i)-xrat(2,j))**2 +
     1         (xrat(3,i)-xrat(3,j))**2
c         if (rr.gt. rdirec**2) goto 140

          call getang(nclusx, xrat, i, j, xbeta, xphi(i,j))
          if (i.eq.j) goto 140
          do 130 k=0,1
            if (k.eq.1) xbeta = (-1) * xbeta
            call rotxan(lplus1, mplus1, xbeta, i, j, k)
 130      continue
 140    continue
 150  continue

c --- calculate spherical harmonic normalization factors
      call xanlm(lplus1,mplus1)

c --- calculate array of correlated debye waller factors
c     initialize
      do 200 iat2=1,nclusx
      do 200 iat1=1,nclusx
        sigsqr(iat1,iat2) = zero
 200  continue

c            Josh - open dwfac.dat for reading precalculated dw factors
c                   and set logical flag readdw
c             open(unit=47,file='dwfac.dat',status='unknown',iostat=ios)
c            Temporary - write output file sigsqr.dat
c             open(unit=48,file='sigsqr.dat',status='replace')
c             if(ios.le.0) readdw = .true.
c            Josh END

c     open files for sigrm and sigem
      if (idwopt.eq.1.and.master) then
         iem = 111
         open(unit=iem,file='s2_em.dat',status='unknown', iostat=ios)
         call chopen (ios, 's2_em.dat', 'sigem')
      endif
      if (idwopt.ge.1) then
         if(master) then
           irm1 =113
           open(unit=irm1,file='s2_rm2.dat',status='unknown',
     .          iostat=ios)
           call chopen (ios, 's2_rm2.dat', 'sigrm')
           irm2 = 112
           open(unit=irm2,file='s2_rm1.dat',status='unknown',
     .          iostat=ios)
           call chopen (ios, 's2_rm1.dat', 'sigrm')
         endif

c        initialize statistics for max DW factors and set rmaxem
         sig2mx=0
         do 446 iph1=0,nphx
         do 446 iph2=0,nphx
  446    sig2x(iph1,iph2) = 0
         rmaxem = 20.0
         do 447 i = 2,inclus
           rr = 0
           do 448 j=1,3
  448      rr = rr + (xrat(j,i)-xrat(j,1))**2
           rr = sqrt(rr)
           if (rr.lt.rmaxem) rmaxem = rr
  447    continue
         rmaxem = max(2.2*rmaxem, 5.0/bohr)
      endif

      npair = 0
      do 250 iat1=1,inclus-1
        do 240 iat2=iat1+1, inclus
          rr = (xrat(1,iat1)-xrat(1,iat2))**2 +
     1    (xrat(2,iat1)-xrat(2,iat2))**2 +(xrat(3,iat1)-xrat(3,iat2))**2
c         if (rr.gt. rdirec**2) goto 240

          if (idwopt.ge.0) then
             do 230 ipair=1,3
               pair(ipair,0) = dble(xrat(ipair, iat1)*bohr)
               pair(ipair,1) = dble(xrat(ipair, iat2)*bohr)
               pair(ipair,2) = dble(pair(ipair,0))
 230         continue
             izpair(0) = izx(iphx(iat1))
             izpair(1) = izx(iphx(iat2))
             izpair(2) = izpair(0)
             dtemp = dble(temper)
             dthet = dble(thetad)
             drs   = dble(rnrmav)
             ipath0=0
             if (idwopt.eq.0) then
c               use CD model
                call sigms(dtemp,dthet,drs,2,2,pair,izpair,dsigsq)
             elseif (idwopt.eq.1) then
                xr12 = (xrat(1,iat1) - xrat(1,iat2))**2
                yr12 = (xrat(2,iat1) - xrat(2,iat2))**2
                zr12 = (xrat(3,iat1) - xrat(3,iat2))**2
                rr12 = sqrt(xr12 +yr12 +zr12)
                if (rr12.le.rmaxem) then
c                  use EM method
                   npair = npair + 1
                   if (mod(npair,100).eq.0) then
                      write (line, 337) npair
  337                 format('    Doing DW factors via EM method for',
     1                ' the pair number ', i5)
                      call wlog(line)
                   endif
                   call sigem
     1             (sig2mx,sig2x,iem,dtemp,ipath0,2,pair,dsigsq)
                else
c                  use RM method
                   call sigrm
     1             (sig2mx,sig2x,irm1,irm2,dtemp,ipath0,2,pair,dsigsq)
                endif
             else
c               use RM
                call sigrm
     1          (sig2mx,sig2x,irm1,irm2,dtemp,ipath0,2,pair,dsigsq)
             endif
             sigsqr(iat1,iat2) = real(dsigsq)
c            Josh - Temporary. write to sigsqr.dat
c             write(48,*) iat1, iat2, sigsqr(iat1,iat2)
          endif
          sigsqr(iat1,iat2) = sigsqr(iat1,iat2) + sig2
          sigsqr(iat2,iat1) = sigsqr(iat1,iat2)
 240    continue
 250  continue

c     Josh - if file dwfac.dat exists, read lines
c            iat1   iat2   dwfac
c            from it and set sigsqr(iat1,iat2) = dwfac
c      if(readdw) then
c         do i = 1, 1000
c            call RdCmt(47,'#*cC')
c            read(47,*, end=255) iat1, iat2, sigsqr(iat1,iat2)
c         end do
c 255     continue
c      end if
c      close(47)
c     Josh END

c     close output for sigem sigrm
      if (master) then
        if (idwopt.eq.1) close (unit=iem)
        if (idwopt.ge.1) close (unit=irm1)
        if (idwopt.ge.1) close (unit=irm2)
      endif

c     Calculate Clebsch-Gordon coefficients <LS|J>
      do 70  l1 = 0, lx
      do 70  mm = -l1, l1
      do 70  isp1 = 1, 2
        j1 = 2 * l1
        j2 = 1
        j3p = j1 + 1
        j3m = j1 - 1
        m1 = 2*mm
        m2 = 2*isp1 - 3
c  j = l+1/2
        t3jp( l1, mm, isp1) = sqrt( j3p + 1.0e0 ) *
     1                 real( cwig3j( j1, j2, j3p, m1, m2, 2) )
        if (mod( (j2-j1-m1-m2)/2 , 2) .ne.0)
     1          t3jp( l1, mm, isp1) = - t3jp( l1, mm, isp1)

c  j = l-1/2
        t3jm( l1, mm, isp1) = sqrt( j3m + 1.0e0 ) *
     1                 real( cwig3j( j1, j2, j3m, m1, m2, 2) )
        if (mod( (j2-j1-m1-m2)/2 , 2) .ne.0)
     1          t3jm( l1, mm, isp1) = - t3jm( l1, mm, isp1)
  70  continue

      return
c  end subroutine xprep
      end

!=======================================================================
!     ATOMS
!=======================================================================

module atoms_inp
  ! The geom.dat file
  use dimsmod,only: natx,nphx,nheadx
  implicit none
  integer nat, nph, iatph(0:nphx), iphat(natx), ibounc(natx)
  ! ibounc is currently set to 1 for all atoms in ffsort.  Path uses it.  Probably discontinued variable but ah well. !KJ
  double precision  rat(3,natx)
  character(*),parameter,private :: filename='geom.dat'
  !		iphat(natx)  -  given specific atom, which unique pot?
  !		rat(3,natx)  -  cartesian coords of specific atom
  !		iatph(0:nphx)  - given unique pot, which atom is model?
  !                      (0 if none specified for this unique pot)

contains

  subroutine atoms_read
    !		Read  geom.dat file
    implicit none
    character*512 slog
    character*80 head(nheadx)
    integer lhead(nheadx),j1,nhead ! ,j
    real*8 rdum1(3)
    integer idum1,idum2

    call json_read_geom(nat, nph, iatph, rat, iphat, ibounc)
    
!     open (file=filename, unit=3, status='old')
!     !			read header
!     nhead = nheadx
!     call rdhead (3, nhead, head, lhead)
!     nat = 0
!     nph = 0
!     iatph(:)=0
! 50  continue
!     !KJ I switched up statements below so that code doesn't falsely abort when nat=natx.
!     !KJ			nat = nat+1
!     if (nat .gt. natx)  then
!        write(slog,'(a, 2i10)') ' nat, natx ', nat, natx
!        call wlog(slog)
!        stop 'Bad input'
!     endif
!     read(3,*,end=60) j1,rdum1(1:3),idum1,idum2
!     nat = nat+1
!     rat(1:3,nat)=rdum1(1:3)
!     iphat(nat)=idum1
!     ibounc(nat)=idum2
!     !KJ			read(3,*,end=60)  j1, (rat(j,nat),j=1,3), iphat(nat), ibounc(nat) !KJ j2  !KJ put ibounc back in for program PATH
!     if (iphat(nat).gt.nph) nph = iphat(nat)
!     if ( iatph(iphat(nat)).eq.0) iatph(iphat(nat)) = nat
!     goto 50
! 60  continue
!     !KJ			nat = nat-1
!     close(3)
  end subroutine atoms_read

end module atoms_inp

      double precision function getxk (e)
      implicit double precision (a-h, o-z)

c     Make xk from energy as
c          k =  sqrt( e)  for e > 0  (above the edge)
c          k = -sqrt(-e)  for e < 0  (below the edge)

      getxk = sqrt(abs(e))
      if (e .lt. 0)  getxk = - getxk
      return
      end

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Information about last revision of $RCSfile: m_kinds.f90,v $:
! $Revision: 1.3 $
! $Author: hebhop $
! $Date: 2010/02/23 23:52:06 $
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
module m_Kinds

  ! Definition of the standard kinds used throughout the program

  integer, parameter :: i04 = selected_int_kind(4)
  integer, parameter :: i08 = selected_int_kind(8)
  integer, parameter :: i16 = selected_int_kind(16)

  integer, parameter :: r04 = selected_real_kind(4)
  integer, parameter :: r08 = selected_real_kind(8)
  integer, parameter :: r16 = selected_real_kind(16)

end module m_Kinds

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Information about last revision of $RCSfile: m_strfacs.f90,v $:
! $Revision: 1.4 $
! $Author: jorissen $
! $Date: 2011/11/23 22:57:43 $
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!*****************************************************************************
!       THE KKR STRUCTURE FACTORS
!*****************************************************************************
module strfacs
  !    Ewald parameter
  real*8 streta
  !    R-space cutoff
  real*8 strrmax
  !    K-space cutoff
  real*8 strgmax
  !    Energy broadening
  real*8 eimag
  !    Structure factor
  complex,allocatable :: gk(:,:,:)

contains
  
  subroutine init_strfacs
    !streta=dble(0)
    !strrmax=dble(0)
    !strgmax=dble(0)
    eimag=dble(0)
    !	   open(98,file='eimag.txt',err=1010)
    !	   read(98,*,err=1010,end=1010) eimag
    !	   close(98)
    return
    eimag=dble(0);return
  end subroutine init_strfacs

  subroutine init_gk(n,j)
    implicit none
    integer n,j
    allocate(gk(n,n,j))  !nkkrmax,nkkrmax,nemax,nktabmax)
    gk=cmplx(0,0)
  end subroutine init_gk

  subroutine exit_gk
    deallocate(gk)
  end subroutine exit_gk

end module strfacs

c     Linear interpolation and extrapolation.
c     Input x and y arrays, returns y value y0 at requested x value x0.
c     Dies on error.

      subroutine terp (x, y, n, x0, y0)
      implicit double precision (a-h, o-z)

      dimension x(n), y(n)

c     Find out between which x points x0 lies
      i = locat (x0, n, x)
c     if i < 1, set i=1, if i > n-1, set i=n-1
      i = max (i, 1)
      i = min (i, n-1)

      if (x(i+1) - x(i) .eq. 0)  call fstop(' at TERP-1')

      y0 = y(i) +  (x0 - x(i)) * (y(i+1) - y(i)) / (x(i+1) - x(i))

      return
      end

      function locat (x, n, xx)
      double precision x, xx(n)
      integer  u, m, n

c     Binary search for index of grid point immediately below x.
c     Array xx required to be monotonic increasing.
c     Returns
c     0            x <  xx(1)
c     1            x =  xx(1)
c     i            x =  xx(i)
c     n            x >= xx(n)

      locat = 0
      u = n+1

   10 if (u-locat .gt. 1)  then
         m = (u + locat) / 2
         if (x .lt. xx(m))  then
            u = m
         else
            locat = m
         endif
         goto 10
      endif

      return
      end

!=======================================================================
!     PATHS
!=======================================================================

module paths_inp
  use ldos_inp
  implicit none
  character(*),parameter,private :: filename='paths.inp'
  integer  mpath, ms, nncrit, nlegxx, ipr4, ica  !KJ added ica 6-06
  !KJ nncrit seems to be bogus input, i.e. not set in rdinp at all ; fully internal to PATH.  Set to 0 and kept here for compatibility.
  real critpw, pcritk, pcrith,  rmax

contains

  subroutine paths_write
    implicit none
    open (file=filename, unit=3, status='unknown')
    write(3,10) 'mpath, ms, nncrit, nlegxx, ipr4'
    write(3,20)  mpath, ms, nncrit, nlegxx, ipr4
    write(3,10) 'critpw, pcritk, pcrith,  rmax, rfms2'
    write(3,30)  critpw, pcritk, pcrith,  rmax, rfms2
    write(3,10) 'ica' !KJ 6-06
    write(3,20)  ica  !KJ 6-06
    close(3)
    ! standard formats for string, integers and real numbers
10  format(a)
20  format (20i4)
30  format (9f13.5)
  end subroutine paths_write

  subroutine paths_read
    open (file=filename, unit=3, status='old')
    read(3,*) ; read(3,*)  mpath, ms, nncrit, nlegxx, ipr4
    read(3,*) ; read(3,*)  critpw, pcritk, pcrith,  rmax, rfms2
    read(3,*) ; read(3,*)  ica  !KJ 6-06
    close(3)
  end subroutine paths_read

  subroutine paths_init
    mpath = 1
    ms = 0
    ipr4 = 0
    ica=-1 !KJ 6-06
    critpw = 2.5*1.e0
    pcritk = 0.e0
    pcrith = 0.e0
    rmax = -1 * 1.e0
    nlegxx = 10
    nncrit = 0
  end subroutine paths_init

end module paths_inp

      subroutine ggbi( nsp, i0, ipi, ipf, lipotx, g0, tmatrx, g0t, gg,
     1                 toler1, toler2, lcalc, msord)

      implicit real (a-h,o-z)
      implicit integer (i-n)
c  output
c    gg:  (nsp*lx**2, nsp*lx**2, 0:nphasx) submatrix spanning the entire
c          angular momentum basis for each unique potential
c     BiCGStab algorithm: Saad, Iterative methods for ..., p. 220 (1996)

      include '../HEADERS/dim.h'
      include 'xparam.h'
      integer  i0 (0:nphx),  lipotx(0:nphx)

      parameter (one = 1, zero = 0)
      complex coni
      parameter (coni = (0,1))

c**** array of state kets at current energy
      common /stkets/ lrstat(4, istatx), istate

      complex   tmatrx(nspx, istatx)
c     big work matrices
      complex   g0( istatx, istatx), g0t( istatx, istatx)
      logical lcalc
      dimension lcalc(0:lx)

c     Lanczos method variables
      complex xvec( istatx), yvec(istatx), avec(istatx), asve(istatx)
      complex rvec(istatx), pvec(istatx), svec( istatx)
      complex aa, dd, aw, wa, ww
      complex del, delp, omega, chi, psi
c     return matrix containing info about each unique potential
      complex   gg(nspx*(lx+1)**2, nspx*(lx+1)**2, 0:nphasx)

c      notice that in gglu we invert (1-Gt), but here (1-tG).
c     multiply T and G0 matrices together, construct g0t = 1 - T*G0
c     notice that the signs below for g0t ARE correct since 1 is the
c     unit matrix
c     since t is tri-diagonal, this product can be computed in n^2 time
c     also fill up some work matrices for use in eigenvalue and
c     determinant calculations and elsewhere
c     cycle over dimensions of matrix g0t
      do 10 icol = 1,istatx
      do 10 irow = 1,istatx
 10   g0t(irow,icol) = 0

      do 30 icol = 1,istate
        do 20 irow = 1,istate
c         T diagonal contribution T(irow, irow)
          if ( abs( g0(irow, icol)) .gt. toler2 )
     1    g0t(irow,icol)=g0t(irow,icol) - tmatrx(1,irow) * g0(irow,icol) 

c         T off-diagonal contribution T(ist2, irow) in tmatr(2,irow)
c         T off-diagonal contribution T(irow, ist2) in tmatr(2,ist2)
          l1   = lrstat(2,irow)
          m1   = lrstat(3,irow)
          isp1 = lrstat(4,irow)
          m2 = m1+isp1
          if (nsp.eq.2 .and. m2.gt.-l1+1 .and. m2.lt.l1+2) then
c            spin-flip contribution
             ist2 = irow + (-1)**isp1
             if ( abs( g0(ist2, icol)) .gt. toler2)
     1       g0t(irow, icol) = g0t(irow, icol)
     2                   - tmatrx(nsp, ist2) * g0(ist2, icol) 
          endif
 20     continue

        g0t(icol, icol) = g0t(icol, icol) + one
 30   continue

      do 920 ip=ipi, ipf
        ipart = nsp*(lipotx(ip)+1)**2
        do 910 is1 = 1, ipart
          is2 = is1+i0(ip)
          l1   = lrstat(2,is2)
          if (.not.lcalc(l1)) goto 910

c         start first tier with xvec=0
          istart = -1
          msord = 0
          do 40 is = 1, istate
          avec(is) = 0
  40      xvec(is) = 0

c         RESTART here if necessary
  50      continue
          istart = istart+1

          if (istart.gt.0) call matvec( istatx,istate,g0t,xvec,avec,1)
          do 90 is = 1,istate
 90       rvec(is) = - avec(is)
c         rvec = bvec - g0t*xvec , in our case bvec(is) = delta_{is,is2}
          rvec(is2) = rvec(is2) + 1
cc          Check convergence criteria: |r_n+1| < tol
            ipass = 1
            do 92 is = 1, istate
              if ( abs(real(rvec(is))).gt.toler1) goto 93
              if ( abs(aimag(rvec(is))).gt.toler1) goto 93
 92         continue
            ipass = 0
 93         continue
            if (ipass.eq.0) goto 700

          do 95 is = 1, istate
 95       pvec(is) = rvec(is)
          call matvec( istatx,istate,g0t,pvec,avec,1)
          msord = msord + 1

c         choose yvec that del and delp close to one
          call cdot( istatx, istate, avec, avec, aa)
          call cdot( istatx, istate, rvec, avec, wa)
          aw = real(wa) - coni* aimag(wa)
          call cdot( istatx, istate, rvec, rvec, ww)
          dd = aa*ww - aw*wa
          if (abs(dd/aa/ww) .lt.1.e-8) then
            do 96 is = 1,istate
  96        yvec(is) = rvec(is) / ww
          else
            ww = ( ww - aw ) / dd
            aa = ( wa - aa) / dd
            do 97 is = 1,istate
  97        yvec(is) = rvec(is) * aa + avec(is) * ww
          endif
          call cdot( istatx, istate, yvec, rvec, del)

c         it seems ran out of precision for nit>150
          nitx = 30
          do 500 nit = 0, nitx
            call cdot( istatx, istate, yvec, avec, delp)
            omega = del / delp

            do 120 is = 1, istate
 120        svec(is) = rvec(is) - omega * avec(is)
cc          Check convergence criteria: |s_n+1| < tol
            ipass = 1
            do 122 is = 1, istate
              if ( abs(real(svec(is))).gt.toler1) goto 123
              if ( abs(aimag(svec(is))).gt.toler1) goto 123
 122        continue
            ipass = 0
 123        continue
            if (ipass.eq.0)  then
              do 124 is = 1, istate
 124          xvec(is) = xvec(is) + omega*pvec(is)
              goto 700
            endif

            call matvec( istatx,istate,g0t,svec,asve,1)
            msord = msord + 1
            call cdot( istatx, istate, asve, asve, aa)
            call cdot( istatx, istate, asve, svec, wa)
            chi = wa / aa
            do 125 is = 1, istate
 125        xvec(is) = xvec(is) + omega*pvec(is) + chi*svec(is)

            do 130 is = 1, istate
 130        rvec(is) = svec(is) - chi* asve(is)

cc          Check convergence criteria: |r_n+1| < tol
            ipass = 1
            do 370 is = 1, istate
              if ( abs(real(rvec(is))).gt.toler1) goto 380
              if ( abs(aimag(rvec(is))).gt.toler1) goto 380
 370        continue
            ipass = 0
 380        continue
            if (ipass.eq.0) goto 700

c           prepare for next iteration
            call cdot( istatx, istate, yvec, rvec, del)
            psi = del / (delp * chi)

            do 135 is = 1, istate
 135        pvec(is) = rvec(is) + psi * (pvec(is)-chi*avec(is))
            call matvec( istatx,istate,g0t,pvec,avec,1)
            msord = msord + 1

 500      continue
c         restart since ran out of iterations
          goto 50

c         exit if tolerance has been achieved
 700      continue
c         print*, ' BI iterations:', nit + istart*nitx
c         end of BI iterations

c         at this point xvec = (1-tG)**-1 * bvec  with chosen tolerance
c         pack FMS matrix into an nsp*(lx+1)^2 x nsp*(lx+1)^2 matrix 
c         for each ipot
          do 800 is2=1,ipart
            gg( is2, is1, ip) = zero
            do 790 is = 1,istate
              gg( is2, is1, ip) = gg( is2, is1, ip) +
     1        g0( is2+i0(ip), is) * xvec(is)
 790        continue
 800      continue

 910    continue
 920  continue

      return
      end

      subroutine szlz (verbse,
     1       ispin, ecv, nph, nat, rgrd, nohole, rfms2, lfms2,
     2       lmaxph, edens, edenvl, dmag, vtot, vvalgs, rmt, rnrm,
     3       ixc, rhoint, vint, xmu, jumprm,
     4       xnval, iorb, x0, dx, xion, iunf, iz,
     5       adgc, adpc, dgc, dpc, ihole, rat, iphat, corr)


c     Finds new Fermi level (xmu), electron counts 

      implicit double precision (a-h, o-z)
      include '../HEADERS/dim.h'
      include '../HEADERS/const.h'
      integer ispin
      logical verbse

c     input
      dimension dmagx(nrptx), dmag(251,0:nphx+1)
      dimension vtot (251,0:nphx), vvalgs (251,0:nphx)
      dimension rmt(0:nphx),rnrm(0:nphx)
      dimension xnval (30,0:nphx), iorb (-4:3,0:nphx)
      dimension ri(nrptx)
      dimension iz(0:nphx), xion(0:nphx), lmaxph(0:nphx)
      dimension rat(3,natx),iphat(natx)
      real  rfms, rfms2
c     input and output
      dimension edens(251,0:nphx), edenvl(251,0:nphx)

c     work space
      dimension xnmues(3,0:lx,0:nphx)
      complex*16 fl(3,0:lx,0:nphx), fr(3,0:lx,0:nphx)
      complex gtr(2,2, 3,0:lx, 0:nphx)
      real amat(-lx:lx,2,2, 3,0:lx), gctr(2,2, 3,0:lx,0:nphx)
      dimension dum(nrptx), vtotph(nrptx),vvalph(nrptx)
      dimension dgc(251,30,0:nphx+1), dpc(251,30,0:nphx+1)
      dimension adgc(10,30,0:nphx+1), adpc(10,30,0:nphx+1)
      dimension dgcn(nrptx,30), dpcn(nrptx,30)
      complex*16 xrhoce(-4:3, -4:3, 0:nphx), xrhole(-4:3, -4:3, 0:nphx)
      complex*16 ph(lx+1, 0:nphx)
      integer iph
c     complex energy grid emg is decomposed into em and eref
      parameter (negx = 80)
      complex*16 emg(negx), em, eref, ee, ep, cchi, de
c     nflrx should be odd and defines the max of Im energy for
c     the countour 
      parameter (nflrx = 17)
      dimension step(nflrx)
      character*512 slog

      call setkap(ihole, kinit, linit)

      if (ispin.eq.0) then
        write (slog,8)
   8    format('              N_l, N_j- and N_j+ calculation')
        write (slog,9)
   9    format('              ONLY central atom contribution! ')
      elseif (abs(ispin).le.1) then
        write (slog,10)
  10    format('              S_z, L_z and t_z calculation')
      else 
        write (slog,11)
  11    format('              S_z, N_l and N_j calculation')
      endif
      call wlog(slog)

      call wlog (' Calculating energy and space dependent l-DOS.')
      call wlog (' It takes time ...')

c     calculate energy independent matrix of angular coefficients
      call acoef(ispin, amat)

      call grids (ecv, xmu, negx, neg, emg, step, nflrx)

c     ie - is number of energy points calculated
      ie = 0
      ee = emg(1)
      ep = dble(ee)
      do 22 iph=0,nphx
      do 22 il=0,lx
      do 22 i=1,3
        xnmues(i, il,iph) = 0
  22  continue

c     Start the cycle over energy points (ie)
  25  continue
      ie = ie + 1

      if (ie.eq.1 .or. mod(ie,20).eq.0) then
         write(slog,30) ie, dble(ee)*hart
   30    format('     point # ', i3, '  energy = ', f7.3)
         call wlog(slog)
      endif

      do 100  iph = 0, nph

         call fixvar (rmt(iph),edens(1,iph),vtot(1,iph),dmag(1,iph),
     1                vint, rhoint, dx, rgrd, jumprm,
     2                vjump, ri, vtotph, dum, dmagx)
         if (mod(ixc,10) .ge.5) then
            if (jumprm .gt. 0) jumprm = 2
            call fixvar (rmt(iph), edenvl(1,iph), vvalgs(1,iph),
     1                dmag(1,iph), vint, rhoint, dx, rgrd , jumprm,
     2                vjump, ri, vvalph, dum, dmagx)
            if (jumprm .gt. 0) jumprm = 1
         endif

         call fixdsx (iph, dx, rgrd , dgc, dpc, dgcn, dpcn)
        jri = int((log(rmt(iph)) + x0) / rgrd) + 2
        jri1 = jri+1
        eref = vtotph(jri1)
        do 40 i = 1, jri1
  40    vtotph(i) = vtotph(i) - dble(eref)
        if (ixc.ge.5) then
           do 50 i = 1, jri1
  50       vvalph(i) = vvalph(i) - dble(eref)
        else
           do 60 i = 1, jri1
  60       vvalph(i) = vtotph(i)
        endif

         itmp = 0
c        icount=1 for Renormalized atom counts
c        icount=2 for Mulliken counts
         icount = 0
         if (iph.eq.0 .and. nohole.lt.0) itmp = ihole
         if (icount.gt.0) then
            call rholat( icount, rgrd, x0, ri, ee,
     2           ixc, rmt(iph), rnrm(iph),
     3           vtotph, vvalph, xnval(1,iph), iorb(-4,iph),
     3           dgcn, dpcn, eref,
     4           adgc(1,1,iph), adpc(1,1,iph), xrhole(-4,-4,iph),
     5           xrhoce(-4,-4,iph), ph(1,iph),
     6           iz(iph), xion(iph), iunf, itmp,3)
         else
            call rholsz( rgrd, x0, ri, ee,
     2           ixc, rmt(iph), rnrm(iph),
     3           vtotph, vvalph, xnval(1,iph), dgcn, dpcn, eref,
     4           adgc(1,1,iph), adpc(1,1,iph), xrhole(-4,-4,iph),
     5           xrhoce(-4,-4,iph), ph(1,iph),
     6           iz(iph), xion(iph), iunf, itmp,3)
         endif
  100 continue

c     Write out phases for fmssz
c     transform neg,emg to em,ne,eref first
      em= dble(ee)
      eref=dble(eref)-coni*dimag(ee)

cc    call fms for a cluster around central atom
      do 195 iph0 = 0,nph
      do 195 il = 0, lx
      do 195 i = 1, 3
      do 195 i2= 1, 2
      do 195 i1= 1, 2
         gtr( i1,i2, i, il, iph0) = 0
         gctr(i1,i2, i, il, iph0) = 0
  195 continue

      rfms = 0
c     only central atom contribution for ispin = 0
ctemp if (ispin.ne.0)  rfms = rfms2
      rfms = rfms2

      if (lfms2 .ne. 0) then
        iph0 = 0
        call fmssz(verbse, iph0, ie,  em, eref, ph, nph,
     1        rfms, lfms2, nat, iphat, rat, amat, lmaxph, gctr, gtr)
      else
        do 190 iph0 = 0, nph 
  190   call fmssz(verbse, iph0,  ie, em, eref, ph, nph,
     1        rfms, lfms2, nat, iphat, rat, amat, lmaxph, gctr, gtr)
      endif

      de = ee-ep
      do 300 iph = 0,nph
      do 300 lpp = 0,lx
      do 300 iop = 1,3
c       calculate density and integrated number of electrons in each
c       channel for each type of atoms density, etc.
        if (ie.gt.1) fl(iop,lpp,iph) = fr( iop,lpp,iph)
        fr( iop,lpp,iph) = 0
        call kfromi (1, lpp, j1, kk1)
        call kfromi (2, lpp, j1, kk2)
        do 200 i1=1,2
        do 200 i2=1,2
          call kfromi (i1, lpp, j1, k1)
          call kfromi (i2, lpp, j1, k2)
          if (k1.eq.0 .or. k2.eq.0) goto 200

          cchi =  dble( real( gtr(i1,i2, iop,lpp,iph) )) + 
     1           coni* dble(aimag( gtr(i1,i2, iop,lpp,iph) ))
c         fr( iop,lpp,iph) = fr( iop,lpp,iph) + cchi * xrhole(k1,k2,iph)
c         use above kk1,kk1 for j- value, kk2,kk2 for j+ value
          if (ispin.ne.0 .or. iop.eq.1) then
            fr( iop,lpp,iph) = fr( iop,lpp,iph) + cchi*xrhole(k1,k2,iph)
          elseif(iop.eq.2) then
            fr( iop,lpp,iph) = fr( iop,lpp,iph)+cchi*xrhole(kk1,kk1,iph)
          elseif(iop.eq.3) then
            fr( iop,lpp,iph) = fr( iop,lpp,iph)+cchi*xrhole(kk2,kk2,iph)
          endif

c         add central atom part
          cchi =  dble(  gctr(i1,i2, iop,lpp,iph) ) 
          if (ispin.ne.0 .or. iop.eq.1) then
            fr( iop,lpp,iph) = fr( iop,lpp,iph) + cchi*xrhoce(k1,k2,iph)
c           use above k1,k1 for j- value, k2,k2 for j+ value
          elseif(iop.eq.2) then
            fr( iop,lpp,iph) = fr( iop,lpp,iph)+cchi*xrhoce(kk1,kk1,iph)
          elseif(iop.eq.3) then
            fr( iop,lpp,iph) = fr( iop,lpp,iph)+cchi*xrhoce(kk2,kk2,iph)
          endif
 200    continue

c       do integral over energy with trapezoidal rule
        if (ie.eq.1)  fl( iop,lpp,iph) = fr( iop,lpp,iph)
        xnmues(iop,lpp,iph) =  xnmues(iop,lpp,iph) +
     1  dimag((fl(iop,lpp,iph) + fr(iop,lpp,iph)) * de /2)
        if (ie.eq.neg) then
c          end point correction
           xnmues(iop,lpp,iph) =  xnmues(iop,lpp,iph) +
     1     dimag( fr(iop,lpp,iph) * (dble(ee)-ee) )
        endif

  300 continue

c     next energy point
      if (ie.lt.neg) then
         ep = ee
         ee = emg(ie+1)
         goto 25
      endif

c     report configuration; repeat iteration if found bad counts.
      call wlog('  Electronic configuration')
      call wlog('  Electronic configuration:Mulliken counts')
      if (ispin.eq.0) then
         call wlog('   iph    il      N_l   N_j-  N_j+')
      elseif (abs(ispin).eq.1) then
         call wlog('   iph    il      S_z   L_z   T_z')
      else
         call wlog('   iph    il      S_z   N_l   N_j')
      endif
 310  format (2i6, 3f9.4)
      do 320 ip= 0,nph
      do 320 il = 0,lx
         write (slog,310) ip,il,(xnmues(i,il,ip), i=1,3)
         call wlog(slog)
 320  continue
      corr = 1.d0
      if (ispin.eq.0 .and. kinit.ne.-1) then
c       calculation  changes in counts due to spin-orbit interaction
        ip = 2
        if (kinit.lt.0) ip = 3
        il = linit + 1
        if (linit.eq.3) il = linit - 1
        corr = xnmues(1,il,0) /xnmues (ip,il, 0)
      endif

      return
      end

      subroutine renorm (dexv, vcoul, srho)

      implicit double precision (a-h,o-z)
      save

      common /print/ iprint
      common /atomco/ den(30), dq1(30), dfl(30), ws, nqn(30), nql(30),
     1                nk(30), nmax(30), nel(30), norb, norbco
      common /dira/ dv(251), dr(251), dp(251), dq(251), dpas, tets,
     1              z, nstop, nes, np, nuc
      common /deux/ dvn(251), dvf(251), d(251), dc(251), dgc(251,30),
     1 dpc(251,30)

c     vcoul is the coulomb potential (no factor of r**2) (output)
      dimension vcoul(251)
c     srho is charge density in form 4*pi*density*r**2 output)
      dimension srho(251)
c jm  9/23/87 added srho renormalized charge density to be used
c     in cphase
       external exchan
      do 10 i=1,np
         dv(i)=0.0
         d(i)=0.0
   10 continue
      ddjri=log(ws/dr(1))/dpas
      jri=1.0+ddjri
      jr1=jri
      ddjr1=ddjri-jr1+1.0

      if (jri-2*(jri/2).ne.0) go to 20
         jri=jri+1
   20 continue

      ddjri=ddjri-jri+1.0
c  ddjri = (log(ws)-dri)/dpas
c  dri  =  log(dr(jri))

      da=0.0
      do 30 j=1,norb
      do 30 i=1,np
   30    d(i)=d(i)+nel(j)*(dgc(i,j)**2+dpc(i,j)**2)

      do 50 i=jri,np
         dl=dr(i)
         if (i.eq.jri.or.i.eq.np) go to 40
            dl=dl+dl
            if ((i-2*(i/2)).eq.0) dl=dl+dl
   40    dd=d(i)*dl
         da=da+dd
   50 continue

      da=dpas*da/3.0
      dfo=dr(jri-1)*d(jri-1)
      df1=dr(jri)*d(jri)
      df2=dr(jri+1)*d(jri+1)
      dcor=-dpas*(df1*ddjri+(df2+dfo-2.0*df1)*ddjri**3/6.0+(df2-dfo)
     1 *ddjri**2*.25)
      da=da+dcor
      if (iprint .ge. 5)  write(16,60) da
   60 format (1h ,' no. of electrons outside the ws-radius',e16.8)
      db=0.0

      do 80 i=jri,np
         dl=1.0
         if (i.eq.jri.or.i.eq.np) go to 70
            dl=dl+dl
            if ((i-2*(i/2)).eq.0) dl=dl+dl
   70    dd=d(i)*dl
         db=db+dd
   80 continue

      db=dpas*db/3.0
      df0=d(jri-1)
      df1=d(jri)
      df2=d(jri+1)
      dcor=-dpas*(df1*ddjri+(df2+df0-2.0*df1)*ddjri**3/6.0+(df2-df0)
     1 *ddjri**2*.25)
      db=db+dcor
      if (iprint .ge. 5)  write(16,90) db
   90 format (1h ,' db= ',e16.8)

      call potslw (dvn,d,dp,dr,dpas,np)

      du=da*3.0/(ws**3)

      do 120 i=1,np
         if (i.gt.jr1+1) then
            srho(i)=0.0
            go to 100
         endif
            d(i)=d(i)+du*dr(i)**2
            srho(i)=d(i)
  100    continue
         dumm=-exchan(d(i),dr(i),dexv)/dr(i)
         dvf(i)=dumm
         if (i.gt.jr1) go to 110
            dvn(i)=dvn(i)-z/dr(i)+da*(1.50/ws-.50*dr(i)**2/ws**3)-db
            go to 120
  110    continue
            dvn(i)=0.0
  120 dv(i)=dvn(i)+dumm

c ad1 write the mt index and radius
      if (iprint .ge. 5)  write(16,55)jr1,dr(jr1)
  55  format(' jr1 = ',i10,10x,'wigner-seitz radius = ',e16.8)

c ad1 output 2.*dvn*r**2 for use in phase (dvn = normalised coulomb)
c     write(17,200)((2.0*dvn(i)*dr(i)*dr(i)),i=1,np)
c 200 format(1p5e16.8)
c      passvc formerly used to pass data directly to PHASE
c      do 151  i = 1, np
c         passvc (i) = 2.0 * dvn(i) * dr(i) * dr(i)
c  151 continue
c
c     passvc above is vcoul*r**2
      do 151  i = 1, np
         vcoul(i) = 2 * dvn(i)
  151 continue


c jm  output renormalized charge density for use in cphase
c                                          (d=4pi*rho*r^2)
c     write(18,200) srho

cjm write out rs as function of r
c     do 8934 i=1,jr1
c     xxrs=(3*dr(i)*dr(i)/srho(i))**.33333333
c8934 write(19,140) dr(i), xxrs
      return
      end

!=======================================================================
!     GENFMT
!=======================================================================

module genfmt_inp
  use global_inp
  implicit none
  character(*),parameter,private :: filename='genfmt.inp'
  integer  mfeff, ipr5, iorder
  logical  wnstar
  double precision critcw

contains

  subroutine genfmt_write
    open (file=filename, unit=3, status='unknown')
    write(3,10) 'mfeff, ipr5, iorder, critcw, wnstar'
    write(3,180)  mfeff, ipr5, iorder, critcw, wnstar
180 format ( 2i4, i8, f13.5, L5)
    !KJ 7-09 Next 2 lines for feff8q
    write(3,'(a24)') ' the number of decomposition channels'
    write(3,'(i5)') ldecmx
    close(3)
    ! standard formats for string, integers and real numbers
10  format(a)
    ! 20  format (20i4)
    ! 30  format (9f13.5)
  end subroutine genfmt_write

  subroutine genfmt_read
    open (file=filename, unit=3, status='old')
    read(3,*) ; read(3,*)  mfeff, ipr5, iorder, critcw, wnstar
    !KJ 7-09 Next line for feff8q
    read(3,*) ; read(3,*) ldecmx
    close(3)
  end subroutine genfmt_read

  subroutine genfmt_init
    mfeff = 1
    ipr5 = 0
    iorder = 2
    wnstar = .false.
    critcw = 4*1.d0
  end subroutine genfmt_init

end module genfmt_inp

      subroutine json_read_pot(mpot, nph, ntitle, ihole, ipr1, iafolp,
     1       ixc, ispec, nmix, nohole, jumprm, inters, nscmt, icoul,
     2       lfms1, iunf, gamach, rgrd, ca1, ecv, totvol, rfms1,
     3       title, iz, lmaxsc, xnatph, xion, folp, novr,
     4       iphovr, nnovr, rovr )


      use json_module
      implicit double precision (a-h, o-z)
      logical :: found
      character*7 vname
      type(json_file) :: json   !the JSON structure read from the file:
      double precision toss
      integer,dimension(:),allocatable :: intgs
      character*80,dimension(:),allocatable :: strings
      double precision,dimension(:),allocatable :: dbpcs


      include '../HEADERS/const.h'
      include '../HEADERS/dim.h'

cc    mod1.inp
        character*80 title(nheadx)
c        character*80 head(nheadx)
c        integer lhead(nheadx)
        integer mpot, nph, ntitle, ihole, ipr1, iafolp, ixc, ispec,
     1     iunf, nmix, nohole, jumprm, inters, nscmt, icoul, lfms1
        integer iz(0:nphx), lmaxsc(0:nphx)
        real rfms1
        double precision gamach, rgrd, ca1, ecv, totvol
        double precision  xnatph(0:nphx), folp(0:nphx), xion(0:nphx)
c       for OVERLAP option
        integer novr(0:nphx), iphovr(novrx,0:nphx), nnovr(novrx,0:nphx)
        double precision  rovr(novrx,0:nphx)
      

      call json%load_file('pot.json')
      if (json_failed()) then   !if there was an error reading the file
         print *, "failed to read pot.json"
         stop
      else
         call json%get('mpot',   mpot, found)
                   if (.not. found) call bailout('mpot', 'pot.json')
         call json%get('nph',    nph, found)
                   if (.not. found) call bailout('nph', 'pot.json')
         call json%get('ntitle', ntitle, found)
                   if (.not. found) call bailout('ntitle', 'pot.json')
         call json%get('ihole',  ihole, found)
                   if (.not. found) call bailout('ihole', 'pot.json')
         call json%get('ipr1',   ipr1, found)
                   if (.not. found) call bailout('ipr1', 'pot.json')
         call json%get('iafolp', iafolp, found)
                   if (.not. found) call bailout('iafolp', 'pot.json')
         call json%get('ixc',    ixc, found)
                   if (.not. found) call bailout('ixc', 'pot.json')
         call json%get('ispec',  ispec, found)
                   if (.not. found) call bailout('ispec', 'pot.json')

         call json%get('nmix',   nmix, found)
                   if (.not. found) call bailout('nmix', 'pot.json')
         call json%get('nohole', nohole, found)
                   if (.not. found) call bailout('nohole', 'pot.json')
         call json%get('jumprm', jumprm, found)
                   if (.not. found) call bailout('jumprm', 'pot.json')
         call json%get('inters', inters, found)
                   if (.not. found) call bailout('inters', 'pot.json')
         call json%get('nscmt',  nscmt, found)
                   if (.not. found) call bailout('nscmt', 'pot.json')
         call json%get('icoul',  icoul, found)
                   if (.not. found) call bailout('icoul', 'pot.json')
         call json%get('lfms1',  lfms1, found)
                   if (.not. found) call bailout('lfms1', 'pot.json')
         call json%get('iunf',   iunf, found)
                   if (.not. found) call bailout('iunf', 'pot.json')

         call json%get('gamach', gamach, found)
                   if (.not. found) call bailout('gamach', 'pot.json')
         call json%get('rgrd',   rgrd, found)
                   if (.not. found) call bailout('rgrd', 'pot.json')
         call json%get('ca1',    ca1, found)
                   if (.not. found) call bailout('ca1', 'pot.json')
         call json%get('ecv',    ecv, found)
                   if (.not. found) call bailout('ecv', 'pot.json')
         call json%get('totvol', totvol, found)
                   if (.not. found) call bailout('totvol', 'pot.json')
         call json%get('rfms1',  toss, found)   
                   if (.not. found) call bailout('rfms1', 'pot.json')
         rfms1 = real(toss)

         call json%get('titles', strings, found)
                   if (.not. found) call bailout('titles', 'pot.json')
         do 1000 itit = 1, nheadx
            title(itit) = strings(itit)            
 1000    continue
         call json%get('iz', intgs, found)
                   if (.not. found) call bailout('iz', 'pot.json')
         do 1010 iph = 0, nphx
            iz(iph) = intgs(iph+1)            
 1010    continue
         call json%get('lmaxsc', intgs, found)
                   if (.not. found) call bailout('lmaxsc', 'pot.json')
         do 1020 iph = 0, nphx
            lmaxsc(iph) = intgs(iph+1)            
 1020    continue
         call json%get('xnatph', dbpcs, found)
                   if (.not. found) call bailout('xnatph', 'pot.json')
         do 1030 iph = 0, nphx
            xnatph(iph) = dbpcs(iph+1)            
 1030    continue
         call json%get('xion', dbpcs, found)
                   if (.not. found) call bailout('xion', 'pot.json')
         do 1040 iph = 0, nphx
            xion(iph) = dbpcs(iph+1)            
 1040    continue
         call json%get('folp', dbpcs, found)
                   if (.not. found) call bailout('folp', 'pot.json')
         do 1050 iph = 0, nphx
            folp(iph) = dbpcs(iph+1)            
 1050    continue
         call json%get('novr', intgs, found)
                   if (.not. found) call bailout('novr', 'pot.json')
         do 1060 iph = 0, nphx
            novr(iph) = intgs(iph+1)            
 1060    continue

c        the following reconstructed all the overlap 2D arrays, see
c        RDINP/wrtjsn.f line 131 and following
         do 1200 iph = 0, nph
            write (vname, "(A6,I1)") "iphovr", iph
            call json%get(vname, intgs, found)
                      if (.not. found) call bailout(vname, 'pot.json')
            do 1220 iovr = 1, novr(iph)
               iphovr(iovr, iph) = intgs(iovr)
 1220       continue

            write (vname, "(A5,I1)") "nnovr", iph
            call json%get(vname, intgs, found)
                      if (.not. found) call bailout(vname, 'pot.json')
            do 1230 iovr = 1, novr(iph)
               nnovr(iovr, iph) = intgs(iovr)
 1230       continue

            write (vname, "(A4,I1)") "rovr", iph
            call json%get(vname, dbpcs, found)
                      if (.not. found) call bailout(vname, 'pot.json')
            do 1240 iovr = 1, novr(iph)
               rovr(iovr, iph) = dbpcs(iovr)
 1240       continue
 1200    continue

         call json%destroy()
      end if

      return
      end

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Information about last revision of $RCSfile: m_errormod.f90,v $:
! $Revision: 1.3 $
! $Author: hebhop $
! $Date: 2010/02/23 23:52:06 $
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
MODULE ErrorMod
  IMPLICIT NONE
  INTEGER :: MxErrLines
  PARAMETER( MxErrLines = 5 )
  LOGICAL,PRIVATE :: FirstErrorCall = .TRUE.

  TYPE ErrorType
     ! ErrorName - name of errror
     CHARACTER(30)  ErrorName
     CHARACTER(150) Message(MxErrLines)
     CHARACTER(10)  Action
     LOGICAL        ErrorOccured
     INTEGER        NErrLines
  END TYPE ErrorType

  CHARACTER(300),PRIVATE :: ErrorMessage
  LOGICAL,PRIVATE :: MessageIsSet = .FALSE.

  INTERFACE Error
     MODULE PROCEDURE ErrorSM
     MODULE PROCEDURE ErrorMM
  END INTERFACE Error

CONTAINS

  ! Set the message to report when an error occurs.
  SUBROUTINE SetErrorMessage(Message)
    CHARACTER*(*) Message

    ErrorMessage = Message
    MessageIsSet = .TRUE.

    RETURN 
  END SUBROUTINE SetErrorMessage


  ! Returns true if error message is set, false otherwise.
  FUNCTION ErrorMessageIsSet()
    LOGICAL ErrorMessageIsSet
    ErrorMessageIsSet = MessageIsSet
    RETURN
  END FUNCTION ErrorMessageIsSet


  ! Print ErrorMessage if Message is not supplied,
  ! otherwise, Message is printed. Then STOP.
  SUBROUTINE ErrorSM(Message,StopProgram)
    CHARACTER*(*),INTENT(IN),OPTIONAL :: Message
    LOGICAL,INTENT(IN),OPTIONAL :: StopProgram
    ! If this is the first call to Error, print buffer.
    IF(FirstErrorCall) THEN
       PRINT*
       PRINT '(A)', '************************************************************************************'
       PRINT '(A)', '************************************************************************************'
       FirstErrorCall = .FALSE.
    END IF

    IF(PRESENT(Message)) THEN         
       PRINT*, TRIM(Message)
    ELSE
       IF(MessageIsSet) THEN
          PRINT*, TRIM(ErrorMessage)
       ELSE
          PRINT*, 'Unknown Error'
       END IF
    END IF

    IF(PRESENT(StopProgram)) THEN
       IF(StopProgram) THEN
          PRINT '(A)', '************************************************************************************'
          PRINT '(A)', '************************************************************************************'
          PRINT*
       END IF
    ELSE
       PRINT '(A)', '************************************************************************************'
       PRINT '(A)', '************************************************************************************'
       PRINT*
       STOP
    END IF

  END SUBROUTINE ErrorSM

  SUBROUTINE ErrorMM(Messg,StopProgram)
    CHARACTER*(*),INTENT(IN) :: Messg(:)
    INTEGER iMessg, NMessg
    LOGICAL,OPTIONAL,INTENT(IN) :: StopProgram

    NMessg = SIZE(Messg)
    DO iMessg = 1, NMessg - 1
       IF(PRESENT(StopProgram)) THEN
          CALL ErrorSM(Messg(iMessg), StopProgram = StopProgram)
       ELSE
          CALL ErrorSM(Messg(iMessg), StopProgram = .FALSE.)
       END IF
    END DO

    CALL ErrorSM(Messg(NMessg), StopProgram = .TRUE.)

  END SUBROUTINE ErrorMM

  SUBROUTINE CheckError(ErrType)
    TYPE(ErrorType),INTENT(IN) :: ErrType
    LOGICAL StopOnError
    CHARACTER(10) Action
    INTEGER i1

    ! If the error did not occur, return
    IF(.not.ErrType%ErrorOccured) RETURN

    ! Set the action. Stop, warn, or do nothing.
    Action = ADJUSTL(ErrType%Action)
    CALL Upper(Action)
    IF(Action(1:4).eq.'STOP') THEN              
       StopOnError = .TRUE.
       CALL Error('ERROR:', StopProgram = .FALSE.)
    ELSEIF(Action(1:4).eq.'WARN') THEN
       StopOnError = .FALSE.
       CALL Error('WARNING:', StopProgram = .FALSE.)
    ELSE
       RETURN
    END IF

    ! Print the errror messages
    DO i1 = 1, ErrType%NErrLines
       CALL Error(ErrType%Message(i1), StopProgram = .FALSE.)
    END DO

    ! If Action = 'STOP' Stop.
    IF(StopOnError) STOP
  END SUBROUTINE CheckError


  SUBROUTINE CheckErrors(ErrorTypes)
    TYPE(ErrorType) ErrorTypes(:)
    INTEGER i1

    DO i1 = 1, SIZE(ErrorTypes)
       CALL CheckError(ErrorTypes(i1))
    END DO
  END SUBROUTINE CheckErrors


  ! Check Allocation.
  SUBROUTINE CheckAllocation(iErr,Message)
    INTEGER,INTENT(IN) :: iErr
    CHARACTER*(*),INTENT(IN) :: Message

    IF(iErr.ne.0) CALL Error(Message)

    RETURN
  END SUBROUTINE CheckAllocation

END MODULE ErrorMod

      subroutine istprm ( nph, nat, iphat, rat, iatph, xnatph,
     1                novr, iphovr, nnovr, rovr, folp, folpx, iafolp,
     1                edens, edenvl, idmag,
     2                dmag, vclap, vtot, vvalgs, imt, inrm, rmt, rnrm, 
     2                ixc, rhoint, vint, rs, xf, xmu, xmunew,
     3                rnrmav, qtotel, inters, totvol)

c     Finds interstitial parameters, rmt, vint, etc.
      implicit double precision (a-h, o-z)

      include '../HEADERS/const.h'
      include '../HEADERS/dim.h'

      dimension iphat(natx)
      dimension rat(3,natx)
      dimension iatph(0:nphx)
      dimension xnatph(0:nphx)
      dimension novr(0:nphx)
      dimension iphovr(novrx,0:nphx)
      dimension nnovr(novrx,0:nphx)
      dimension rovr(novrx,0:nphx)
      dimension folp(0:nphx), folpx(0:nphx)
      dimension edens(251,0:nphx), edenvl(251,0:nphx)
      dimension dmag(251,0:nphx+1)
      dimension vclap(251,0:nphx)
      dimension vtot (251,0:nphx), vvalgs (251,0:nphx)
      dimension imt(0:nphx)
      dimension inrm(0:nphx)
      dimension rmt(0:nphx)
      dimension rnrm(0:nphx)
      parameter (big = 5000)
      character*512 slog
      logical lnear
      dimension lnear(0:nphx), inn(0:nphx), rnnmin(0:nphx)
c#mn
      external dist

c     work space for linear algebra
      dimension ri(251)
      parameter (novp=40)
      complex cmovp(novp*(nphx+1)+1,novp*(nphx+1)+1)
      integer ipiv(novp*(nphx+1)+1)
      save lnear

c Find muffin tin radii.  We'll find rmt based on norman prescription,
c ie, rmt(i) = R * folp * rnrm(i) / (rnrm(i) + rnrm(j)),
c a simple average
c based on atoms i and j.  We average the rmt's from each pair of
c atoms, weighting by the volume of the lense shape formed by the
c overlap of the norman spheres.
c NB, if folp=1, muffin tins touch without overlap, folp>1 gives
c overlapping muffin tins.
c
c rnn is distance between sphere centers
c rnrm is the radius of the norman sphere
c xl_i is the distance to the plane containing the circle of the
c    intersection
c h_i  = rnrm_i - xl_i is the height of the ith atom's part of
c    the lense
c vol_i = (pi/3)*(h_i**2 * (3*rnrm_i - h_i))
c
c xl_i = (rnrm_i**2 - rnrm_j**2 + rnn**2) / (2*rnn)

c     find rmt from rnrm only on first call of istprm (rmt(0)=-1)
      if (rmt(0).le.0.0d0) then
      do 10 iph=0,nph
  10  lnear(iph)=.false.
      do 140  iph = 0, nph
         voltot = 0
         rmtavg = 0
         inrm(iph) = ii(rnrm(iph))
         if (novr(iph) .gt. 0)  then
c           Overlap explicitly defined by overlap card
            rnear = big
            inters = mod(inters,6)
c           use Norman prescription only in this case

            do 124  iovr = 1, novr(iph)
               rnn  = rovr(iovr,iph)
               inph = iphovr(iovr,iph)
               if (rnn .le. rnear) then
                  rnear = rnn
                  rnnmin(iph) = rnn
                  inn(iph) = inph
               endif
c              Don't avg if norman spheres don't overlap
               if (rnrm(iph)+rnrm(inph) .le. rnn)  goto 124
               voltmp = calcvl (rnrm(iph), rnrm(inph), rnn)
               voltmp = voltmp + calcvl (rnrm(inph), rnrm(iph), rnn)
               rmttmp = rnn * folp(iph) * rnrm(iph) /
     1                  (rnrm(iph) + rnrm(inph))
               ntmp = nnovr(iovr,iph)
               rmtavg = rmtavg + rmttmp*voltmp*ntmp
               voltot = voltot + voltmp*ntmp
  124       continue
         else
            iat = iatph(iph)
            rnear = big
            rmt(iph) = big
            do 130  inat = 1, nat
               if (inat .eq. iat)  goto 130
               rnn = dist (rat(1,inat), rat(1,iat))
               inph = iphat(inat)
               if (rnn .le. rnear) then
                  rnear = rnn
                  rnnmin(iph) = rnn
                  inn(iph) = inph
               endif
c              Don't avg if norman spheres don't overlap
               if (rnrm(iph)+rnrm(inph) .lt. rnn)  goto 130

               if (inters.lt.6) then
c                Norman prescription
                 voltmp = calcvl (rnrm(iph), rnrm(inph), rnn)
                 voltmp = voltmp + calcvl (rnrm(inph), rnrm(iph), rnn)
                 rmttmp = rnn * folp(iph) * rnrm(iph) /
     1                  (rnrm(iph) + rnrm(inph))
                 rmtavg = rmtavg + rmttmp*voltmp
                 voltot = voltot + voltmp
               else
c                Matching point prescription
                 do 125 i=inrm(iph),1,-1
                   j=ii(rnn-rnrm(iph))
                   if (vclap(i,iph).le.vclap(j,inph)) then
                     d1 = (vclap(i+1,iph)-vclap(i,iph))/(rr(i+1)-rr(i))
                     d2 =(vclap(j,inph)-vclap(j-1,inph))/(rr(j)-rr(j-1))
                     rmtavg = rr(i) + 
     1               (vclap(j,inph)+d2*(rnn-rr(i)-rr(j))-vclap(i,iph))
     2               /(d1+d2)
                     goto 127
c                    exit from the loop
                   endif
  125            continue
  127            continue
                 if (rmtavg.lt.rmt(iph)) rmt(iph) = rmtavg
               endif
  130       continue
         endif

c        special situation if rnrm is too close or larger than
c        the nearest neighbor distance
         if (rnrm(iph).ge.rnear) lnear(iph) = .true.

         if (rmtavg .le. 0)  then
            write(slog,132) iat, iph
            call wlog(slog)
  132       format (' WARNING: NO ATOMS CLOSE ENOUGH TO OVERLAP ATOM',
     1              i5, ',  UNIQUE POT', i5, '!!  ', 
     2              'Rmt set to Rnorman.  May be error in ',
     3              'input file.')
            rmt(iph) = rnrm(iph)
         elseif(inters.lt.6) then
c           Norman prescription
            rmt(iph) = rmtavg / voltot
            if (rmt(iph) .ge. rnear)  then
c              print*,iph, rmt(iph), rnear
               call wlog(' Rmt >= distance to nearest neighbor.  ' //
     1            'Not physically, meaningful.')
               call wlog(' FEFF may crash.  Look for error in ATOM '//
     1            'list or OVERLAP cards.')
            endif
            if (rnrm(iph) .ge. rnear) then
              imax = ii(rnear) - 1
c             begin until loop
 133            if (vclap(imax,iph).lt.vclap(imax+1,iph)) goto 134
                imax = imax-1
                goto 133
c             end of until loop
 134          continue
              rmt(iph) = exp(xx(imax)) - 0.0001d0
            endif
         endif

  140 continue

c     set maximum value for folp(iph) if AFOLP is in use
c     LMTO lore says no more than 15% overlap
c     do 144 iph = 0, nph
c 144 folpx(iph) = 1.15
c     already done in pot.f

      do 145 iph = 0, nph
         if (iafolp. gt. 0 ) then
            temp = 0.2d0 + 0.8d0 * rnrm(iph) / rmt(iph)
         else
            temp = 0.3d0 + 0.7d0 * rnrm(iph) / rmt(iph)
         endif
         if (temp.lt.folpx(iph)) folpx(iph) = temp
         temp = rnnmin(iph)/rmt(iph)/1.06d0
         if (temp.lt.folpx(iph)) folpx(iph) = temp
         temp = exp( -(novp-3)*0.05d0)
c      make sure that with given folpx(iph) the construction
c      of the overlapping matrix in movrlp will not fail
         if (lnear(iph)) then
c           lnear=.true. only when hydrogens are present in the system.
c           want to scale both rmt for iph and inn, so that overlapping
c           matrix calculations will not fail
            temp = rnnmin(iph) / (rmt(iph)*1.05d0 + temp*rmt(inn(iph)))
            if (temp.lt.folpx(iph)) folpx(iph) = temp
            if (temp.lt.folpx(inn(iph))) folpx(inn(iph)) = temp
         else
            temp = (rnnmin(iph) - rnrm(iph))/ (temp*rmt(inn(iph)))
            if (temp.lt.folpx(inn(iph))) folpx(inn(iph)) = temp
         endif
  145 continue

      endif
c     end of finding rmt from rnrm on first call of istprm.

c     Need potential with ground state xc, put it into vtot
      do 160  iph = 0, nph
         call sidx (edens(1,iph), 250, rmt(iph), rnrm(iph),
     1              imax, imt(iph), inrm(iph))
         do 150  i = 1, imax
            if (edens(i,iph).le.0) then
             if(mod(i,10).eq.0) then
               write(slog, 149) 'negative dens ', i,iph
  149          format (a, 2i3)
               call wlog(slog)
             endif
             rs = 100
             xmag=1.0d0
            else
              rs = (edens(i,iph)/3)**(-third)
c     spin dependent xc potential for ground state from Von Barth, Hedin
c     J.Phys.C:Solid State Phys., 5, 1629 (1972).
c     xmag/2 -fraction of spin up or down, depending on sign in renorm.f
c     put xmag = 1.0 to calculate cmd with external potential difference
              xmag = 1.0d0 + idmag*dmag(i,iph)
            endif
c           wrong for ferromagnets, need to overlap dmag(i)

c           vvbh from Von Barth Hedin paper, 1971
            call vbh(rs,xmag,vvbh)
            vtot(i,iph) = vclap(i,iph) + vvbh

            if (mod(ixc,10).eq.5) then
              rsval = 10.0d0
              if (edenvl(i,iph) .gt. 0.00001d0) 
     1           rsval = (edenvl(i,iph)/3)**(-third)
              if (rsval.gt.10.0d0) rsval = 10.0d0
              xmagvl = 1.0d0 + idmag * dmag(i,iph) 
     1                      * edens(i,iph) / edenvl(i,iph)
              call vbh(rsval,xmagvl,vvbhvl)
              vvalgs(i,iph) = vclap(i,iph) + vvbhvl
            elseif (mod(ixc,10) .ge. 6) then
              if (edens(i,iph).le.edenvl(i,iph)) then
                 rscore =101.0d0
              else
                 rscore = ((edens(i,iph)-edenvl(i,iph)) / 3)**(-third)
              endif
              rsmag = (edens(i,iph)*(1+idmag*dmag(i,iph)) / 3)**(-third)
              xfmag = fa/rsmag
              call edp(rscore,xfmag,vrdh)
              vvalgs(i,iph) = vclap(i,iph) + vvbh - vrdh
            else
              vvalgs(i,iph) = 0.d0
            endif
  150    continue
  160 continue

c     What to do about interstitial values?
c     Calculate'em for all atoms, print'em out for all unique pots along
c     with derivative quantities, like fermi energy, etc.
c     Interstitial values will be average over all atoms in problem.

c     rnrmav is averge norman radius,
c     (4pi/3)rnrmav**3 = (sum((4pi/3)rnrm(i)**3)/n, sum over all atoms
c     in problem
      rnrmav = 0
      xn = 0
c     volint is total interstitial volume
      volint = 0
      do 180  iph = 0, nph
         rnrmav = rnrmav + xnatph(iph) * rnrm(iph)**3
         volint=volint-xnatph(iph) * rmt(iph)**3
         xn = xn + xnatph(iph)
  180 continue
      if (totvol.le.0.0d0) then
         volint=4*pi/3 *(volint+rnrmav)
      else
         volint=4*pi/3 *volint + totvol
      endif
c     volume of lenses from overlapping mt spheres is added in movrlp.
      rnrmav = (rnrmav/xn) ** third

      rs = 0
      vint   = 0
      rhoint = 0
      rsval = 0

      call movrlp(nph, nat, iphat, rat, iatph, xnatph,
     1            novr, iphovr, nnovr, rovr,
     2            imt, rmt, rnrm, ri, lnear,
     3            cmovp,ipiv, volint,inters)

c     If no contribution to interstitial from any atom, die.
      if (volint .le. 0)  then
         call wlog(' No interstitial density.  Check input file.')
         call par_stop('ISTPRM')
      endif

c     find interstitial density

      call ovp2mt(nph, edens, 0, qtotel, ri, xnatph, lnear,
     1            inrm, imt, rnrm, rmt, cmovp,ipiv, rhoint,inters)
      rhoint = 4*pi * rhoint / volint

      if (ixc.ge.5) then
c        find valence potential inside mt sphere (vintvl -dummy)
         call ovp2mt(nph, vvalgs, 1, qtotel, ri, xnatph, lnear,
     1           inrm, imt, rnrm, rmt, cmovp, ipiv, vintvl,inters)
      endif

c     find potential inside mt sphere and vint
      call ovp2mt(nph, vtot, 1, qtotel, ri, xnatph, lnear,
     1            inrm, imt, rnrm, rmt, cmovp, ipiv, vint,inters)

      if (vint.ge.xmu) then
        write(slog,'(a)')
     1  ' WARNING:interstitial level found above Fermi level'
        call wlog(slog)
        write(slog,'(a)')
     1  '  Results may be unreliable. See manual for details'
        call wlog(slog)
        vint = xmu - 0.05d0
        call ovp2mt(nph, vtot, 2, qtotel, ri, xnatph, lnear,
     1            inrm, imt, rnrm, rmt, cmovp, ipiv, vint,inters)
      endif
      call fermi (rhoint, vint, xmunew, rs, xf)

      return
      end

      double precision function calcvl (r1, r2, r)
      implicit double precision (a-h, o-z)
      include '../HEADERS/const.h'
      xl = (r1**2 - r2**2 + r**2) / (2*r)
      h = r1 - xl
      calcvl = (pi/3) * h**2 * (3*r1 - h)
      return
      end

      subroutine axafs(em, emu, xsec,ne1,ik0)
c     extract axafs from xsec
c     written by a.l.ankudinov Dec. 1998

c     the file axafs.dat (format as in xmu.dat) will be written if
c     you use PRINT 0 1 0 0 0 0 (ipr2 > 0), and ran the second module.

c     the code draws a parabola using least mean square method
c     through xsec(i) * ee (i)**xn 
c     the weight for each point i, is defined as (ee(i)-E_F)**mm*
c     (ee(i+1)- ee(i-1)), where the last multiplier is used since the 
c     grid is not regular in energy.
c     E_F - energy that corresponds to Fermi level.

      implicit double precision (a-h, o-z)
      include '../HEADERS/dim.h'
      include '../HEADERS/const.h'

      complex*16 em(nex), xsec(nex)
      dimension ee(nex), xmu(nex), wt(nex)
      dimension xx(0:4), yy(0:2), xm(3,3)

c     empirically I found that the best curve is drawn if xn=0 and mm=1
c     alex ankudinov, january 1999.
      xn = 0
      mm = 1
      np = ne1 - ik0
      ef = emu

      do 10 ie = 1, np
        ee(ie) = dble(em(ik0+ie)-em(ik0)) +emu
        xmu(ie) = dimag(xsec(ik0+ie)) * ee(ie)**xn
  10  continue
      do 20 ie = 1, np
        if (ie.eq.1) then
          wt(ie) = (ee(ie+1)-ef) * (abs(ee(ie)-ef))**mm
        elseif (ie.eq.np) then
          wt(ie) = (ee(ie)-ee(ie-1)) * (ee(ie)-ef)**mm
        else
          wt(ie) = (ee(ie+1)-ee(ie-1)) * (ee(ie)-ef)**mm
        endif
  20  continue
      do 30 i = 0, 4
  30  xx(i) = 0
      do 40 i = 0, 2
  40  yy(i) = 0

      do 100 ie = 1, np
         do 80 i = 0,4
  80     xx(i) = xx(i) + wt(ie)*ee(ie)**i
         do 90 i = 0,2
  90     yy(i) = yy(i) + wt(ie)*xmu(ie)*ee(ie)**i
 100  continue

      do 105 i=1,3
      do 105 j=1,3
 105  xm(i,j) = xx(i+j-2)
      denom = determ (xm, 3, 3)

      do 110 i=1,3
      do 110 j=1,3
 110  xm(i,j) = xx(i+j-2)
      do 120 i=1,3
 120  xm(i,1) = yy (i-1)
      aa = determ (xm,3,3)
      aa = aa / denom

      do 210 i=1,3
      do 210 j=1,3
 210  xm(i,j) = xx(i+j-2)
      do 220 i=1,3
 220  xm(i,2) = yy (i-1)
      bb = determ (xm,3,3)
      bb = bb / denom

      do 310 i=1,3
      do 310 j=1,3
 310  xm(i,j) = xx(i+j-2)
      do 320 i=1,3
 320  xm(i,3) = yy (i-1)
      cc = determ (xm,3,3)
      cc = cc / denom

c     find normalization at edge+100 eV
      eee = ee(1) + 100/hart
      xnorm = (aa+bb*eee+cc*eee**2) / eee**xn

      open (unit=1,file='axafs.dat', status='unknown')
      write (1,*) '# File contains AXAFS. See manual for details.'
      write (1,*)
     1 '#--------------------------------------------------------------'
      write(1,*) '#  e, e(wrt edge), k,',
     1           ' mu_at=(1+chi_at)*mu0_at, mu0_at, chi_at @#'
      do 400 ie = 1, np
        xmu(ie) = dimag(xsec(ie+ik0))
        xmu0 = (aa+bb*ee(ie)+cc*ee(ie)**2) / ee(ie)**xn
        chiat = (xmu(ie) - xmu0) / xmu0
        eee = ee(ie) -ef
        if (eee.ge.0.d0) then
           xk = sqrt(2*eee) /bohr
        else
           xk = -sqrt(-2*eee) /bohr
        endif
        write (1, 410) ee(ie)*hart, (ee(ie)-emu)*hart, xk,
     1              xmu(ie)/xnorm, xmu0/xnorm, chiat
 410    format (1x, 2f11.3, f8.3, 1p, 3e13.5)
 400  continue
      close (unit=1)

      return
      end
         

      subroutine paths (ckspc, fbetac, xlamc, pcritk, pcrith, critpw,
     1                  nncrit, rmax, nlegxx, rfms,
     2                  nat, ratdp, iphat, ibounc)

c     finds multiple scattering paths
c     This is single precision, units are Angstroms.  BE CAREFUL!

c     pcrith is cut-off fraction used when building paths
c            (path criterion for heap)
c     pcritk is cut-off fraction used on output
c            (path criterion for keeping)

      include '../HEADERS/dim.h'
      parameter (necrit=9, nbeta=40)
      dimension fbetac(-nbeta:nbeta,0:nphx,necrit), ckspc(necrit)
      dimension xlamc(necrit)

c     This common in pathsd, mpprm
      common /atoms/ rat(3,0:natx), ipot(0:natx), i1b(0:natx)
      double precision ratdp(3,natx)
      integer  iphat(natx), ibounc(natx)

      dimension m(-1:natx,0:natx)
      dimension mindex(natx+1)
c     Used for packed integers
      dimension iout(3)

c     ok true if all paths to rmax found.  If heap full, npx exceeded,
c     etc., last general shell may be incomplete, set ok=.false.
      logical ok
c     is label nfound, etc, written yet?
      logical wlabel

c     Heap data structure:
c     index is the pointer to the element of the data structure.
c     Each element contains
c        r        total path length
c                 Note that r is sorted along with index -- this keeps
c                 the heap maintenance routines fast.
c        mi, mj   m matrix elements used to place last atom in this path
c        npat     number of atoms in this path
c        ipat(npatx) indices of atoms in this path
c     next is the index of the next data structure element available.
c     If an element is freed, npat is the index of the free element
c     to use after using current "next" element.
c     nx is max number in heap
      integer    nx
c     parameter (nx = 10 000)
      parameter (nx = 6000 000)
c     r also used in making m matrix, must have nx >= natx+1
      integer   index(nx), npx, np, n, ip, i, iat0, idum
c     parameter (npx = 100 000)
      parameter (npx = 100000000)
      dimension r(nx), mi(nx), mj(nx)
      dimension npat(nx)
      dimension ipat (npatx,nx)
c     Keep this path on output
      logical keep1(nx), kp1tmp
c     to remmember atoms outside rfms
      dimension iclus(0:natx) 

c     Used with ipack, so need ipat(8)
      dimension ipat0(8)

c     paths are typically about 10 or 20 Ang
      parameter (big = 1.0e3)

      character*80  title

c     Returned from criterion checker, false if path fails criterion
      logical keep
      character*512 slog

      external sdist

c     transform to single precision for pathfinder
c     also count in pathfinder starts with 0, not with 1
      do 15 iat = 1, nat
        j = iat-1
        do 10 i = 1, 3
          rat(i, j) = real (ratdp(i,iat))
 10     continue
        ipot(j) = iphat(iat)
        i1b(j) = ibounc(iat)
 15   continue
      nat = nat - 1

c     nlegxx is max number of legs user wants to consider.
c     nlegs = npat+1, so set npatxx = min (npatx, nlegxx-1)
      npatxx = min (npatx, nlegxx-1)
c     Input rmax is one-way distances
      rmax = rmax*2
c     ratx is distance to most distant atom, used to check rmax
      ratx = 0
      iat0 = -1
      i1b(0) = 0

c     find index for the central atom
      do 20 iat = 0, nat
         if (ipot(iat).eq.0 .and. iat0.lt.0) iat0=iat
   20 continue

c     iclus = 0 for atoms inside rfms cluster, 1 for atoms outside
      do 21 iat = 0,nat
        rtmp = sdist(rat(1,iat),rat(1,iat0))
        if (rtmp.gt.rfms) iclus(iat)=1
        iclus(iat)=0
        if (rtmp.gt.rfms) iclus(iat)=1
   21 continue

      if (iat0.ne. 0) then
c       permute atoms 0 and iat0
c       do not need to permute i1b, since all of them are 1 in
c       this case, except i1b(0) = 0, which we want to keep.
        do 25 j=1,3
          temp = rat(j,0)
          rat(j,0) = rat(j,iat0)
          rat(j,iat0) = temp
   25   continue
        idum = ipot(0)
        ipot(0) = ipot(iat0)
        ipot(iat0) = idum
        idum = iclus(0)
        iclus(0) = iclus(iat0)
        iclus(iat0) = idum
      endif

c     Warn user if rmax > dist to most distant atom
c     1.01 to avoid roundoff error, matches rdinp where rmax default set
      if (rmax/2 .gt. 1.01 * ratx)  then
         call wlog('   WARNING:  rmax > distance to most distant atom.')
         call wlog('             Some paths may be missing.')
         write(slog,22) rmax/2, ratx
         call wlog(slog)
   22    format('             rmax, ratx ', 1p, 2e13.5)
      endif

c     Count number of 1st bounce atoms (at least 1 required).
      n1b = 0
      do 30  i = 1, nat
         if (i1b(i) .gt. 0)  n1b = n1b + 1
   30 continue
      if (n1b .lt. 1) 
     .  call par_stop('At least one 1st bounce atoms required.')

      if (rmax .ge. big)  call par_stop('Hey, get real with rmax!')

c     Make title for this run, include carriage control because head
c     (read above) includes carriage control.
      write(title,32)  rmax/2, pcritk, pcrith, critpw
   32 format('PATH  Rmax=', f6.3, ',  Keep_limit=', f5.2,
     1       ', Heap_limit', f5.2,'  Pwcrit=', f5.2, '%')

      write(slog,34) rmax/2, pcritk, pcrith
      call wlog(slog)
   34 format ('    Rmax', f8.4,
     1        '  keep and heap limits', 2f12.7)

      call wlog('    Preparing neighbor table')

c   36 format (1x, a)
c     prepare table telling distance from atom i to atom j and then
c     back to central atom
c     First bounce is m(-1,...), m(0,...) is bounces from central
c     atom that are not first bounces.
      do 60  i = -1, nat
         ir = i
         if (i .eq. -1)  ir = 0
         do 40  j = 0, nat
c           r begins with element 1 so sort routine later will work
            r(j+1) = sdist (rat(1,ir), rat(1,j))
            r(j+1) = r(j+1) + sdist (rat(1,j), rat(1,0))
c           we don't need m(i,i), since this will be = shortest
c           of the r(j), so just set it to something very big,
c           it will sort to the end of this row and it won't
c           bother us
            if (j .eq. ir)  r(j+1) = big
c           If we're doing first bounce, use only the allowed first
c           bounce paths.
            if (i .eq. -1)  then
               if (i1b(j) .le. 0)  r(j+1) = big
            endif
   40    continue

c        prepare row i of m table
c        m is a distance table ordered such that distance from
c               i to m(i,0) to 0 <
c               i to m(i,1) to 0 <
c               i    m(i,2)    0 <
c               :    :    :
c               i    m(i,nat)  0
c
c        That is, m(i,0) is index of atom that gives shortest path,
c                 m(i,1)                        next shortest path, etc.
c        Note that m(0,0) is shortest single bounce path.

c        Again, r and mindex go from 1 to nat+1, m goes from 0 to nat
         call sortir (nat+1, mindex, r)
         do 50  j = 0, nat
            m(i,j) = mindex(j+1)-1
   50    continue
   60 continue

c     label for nfound, heap size, etc written?
      wlabel = .false.
c     initialize heap data space "next" pointers
      do 70  i = 1, nx-1
         npat(i) = i+1
   70 continue
      npat(nx) = -1
c     initial condition:  make the first path
c     n    number in heap
c     nna  number skipped counter
c     nhx  number used in heap max, a counter
      n = 1
      nna = 0
      nhx = n
      nwrote = 0
      index(n) = 1
      ip = index(n)
      next = 2
      mi(ip) = -1
      mj(ip) = 0
      npat(ip) = 1
      ipat(npat(ip),1) = m(mi(ip),mj(ip))

c     Someday change keep and keep1 to lkeep and lheap to match
c     ccrit variable names.
c     Initialize keep criterion
      xcalcx = -1
      call ccrit (npat(ip), ipat(1,ip), ckspc,
     1    fbetac, xlamc, rmax, pcrith, pcritk, nncrit, ipot,
     2    r(n), keep, keep1(ip), xcalcx, iclus)

      open (file='paths.bin', unit=3, access='sequential',
     1      form='unformatted', status='unknown', iostat=ios)
      call chopen (ios, 'paths.bin', 'paths')
c     These strings are all char*80 and include carriage control
c     temporary fix for zero title lines: fix later
      nhead = 1
      write(3) nhead
      write(3) title
      write(3)  nat
      do 90  i = 0, nat
         write(3) (rat(j,i),j=1,3), ipot(i), i1b(i)
   90 continue

c     r is the heap, index is the pointer to the rest of the data
c     np is the number of paths found and saved
      np = 0
c     nbx  mpat max (Number of Bounces maX)
      nbx = 0

c     done if path at top of heap is longer than longest path we're
c        interested in
c     done if max number of paths we want have been found
c     begin 'while not done' loop
      ok = .false.
  800 continue
         if (r(1) .gt. rmax  .or.  np .ge. npx .or. n.le.0)  then
c           n=0 means heap is empty
            if (n.le.0)  ok=.true.
            goto 2000
         endif

c        save element at top of heap in arrays labeled 0
c        dump to unit 3 (unformatted)
         ip = index(1)
         npat0 = npat(ip)
         do 100  i = 1, npat0
            ipat0(i) = ipat(i,ip)
  100    continue
         r0 = r(1)

c        Don't write out path if last atom is central atom, or
c        if it doesn't meet pcritk
         if (ipat0(npat0).ne.0 .and. keep1(ip))  then
            np = np+1
c           pack integers
            call ipack (iout, npat0, ipat0)
            write(3)  r0, iout
            nwrote = nwrote+1
c           write status report to screen
            if (mod(np,1000) .eq. 0)  then
               if (.not. wlabel)  then
                  call wlog('    nfound  heapsize  maxheap' //
     1               '  maxscatt   reff')
                  wlabel = .true.
               endif
               write(slog,132) np, n, nhx, nbx, r0/2
               call wlog(slog)
  132          format (4x, i6, i9, i9, i7, f12.4)
            endif
         endif

         if (np .ge. npx)  then
            write(slog,134) np
            call wlog(slog)
  134       format(i15, ' paths found.  (np .ge. npx)')
            goto 2000
         endif

c        Make new path by replacing last atom in path from top of heap,
c        put this path on top of heap and buble it down.  If row is
c        finished, or new path is too long, don't add it, instead
c        move last path in heap to the top.
c        If working on row mi=-1 (first bounce atoms), don't
c        use them if not allowed 1st bounce atoms.
         mj(ip) = mj(ip) + 1
         if (mi(ip).eq.-1  .and.  i1b(m(mi(ip),mj(ip))).le.0)  then
c           not allowed first bounce atom
            r(1) = big
            keep = .false.
c           type*, '1st bounce limit!'
         elseif (mj(ip) .ge. nat)  then
c           we've finished a row of m matrix
            r(1) = big
            keep = .false.
         else
c           new path has same indices, etc.  Only need to replace
c           last atom.
            ipat(npat(ip),ip) = m(mi(ip),mj(ip))
            call ccrit (npat(ip), ipat(1,ip), ckspc,
     1                  fbetac, xlamc, rmax, pcrith, pcritk, nncrit,
     2                  ipot, r(1), keep, keep1(ip), xcalcx, iclus)
         endif

c        If r is bigger than rmax or keep=false, remove element from
c        heap by taking the last element in the heap and moving it to
c        the top.  Then bubble it down.  When removing an element
c        from the heap, be sure to save the newly freed up index.
c        r(1) and index(1) are new path, set above
         if (r(1).gt.rmax .and. keep)  then
            call wlog(' odd case rmax...')
         endif
         if (r(1).gt.rmax .or. .not.keep)  then
            index(1) = index(n)
            r(1) = r(n)
c           use npat as pointer to next free location
            npat(ip) = next
            next = ip
            n = n-1
c           nna is Number Not Added to heap
            nna = nna + 1
c           Maybe heap may be empty here, but that's alright
         endif
         if (npat(index(1)).gt.nbx .and. n.gt.0)  nbx = npat(index(1))

c        If heap is empty, don't call hdown.
         if (n.gt.0)  call hdown (r, index, n)

c        and make a new path by adding an atom onto the end of the path
c        we saved, put this at the end of the heap and bubble it up.
c        Do this only if it won't be too many bounces.
         if (npat0+1 .le. npatxx)  then
            ip = next
            if (ip .lt. 0)  then
c              call wlog('   Heap full')
               goto 2000
            endif
            next0 = npat(ip)
            do 200  i = 1, npat0
               ipat(i,ip) = ipat0(i)
  200       continue
            mi(ip) = ipat0(npat0)
            mj(ip) = 0
            npat(ip) = npat0+1
            ipat(npat(ip),ip) = m(mi(ip),mj(ip))
            call ccrit (npat(ip), ipat(1,ip), ckspc,
     1                  fbetac, xlamc, rmax, pcrith, pcritk, nncrit,
     2                  ipot, rtmp, keep, kp1tmp, xcalcx, iclus)
            if (rtmp .gt. rmax  .and.  keep)  then
               call wlog(' odd case rmax and tmp...')
            endif
            if (rtmp .gt. rmax  .or.  .not.keep)  then
               npat(ip) = next0
               nna = nna+1
            else
c              add it to the heap
               next = next0
               n = n+1
               if (n .gt. nhx)  nhx = n
               index(n) = ip
               r(n) = rtmp
               keep1(ip) = kp1tmp
               if (npat(index(n)) .gt. nbx)  nbx = npat(index(n))
               call hup (r, index, n)
            endif
         endif

      goto 800
 2000 continue
c     end of 'while not done' loop
      if (.not. ok)  then
         call wlog('   Internal path finder limit exceeded -- ' //
     1             'path list may be incomplete.')
      endif
      close (unit=3)
      write(slog,2010) np, nhx, nbx
      call wlog(slog)
 2010 format ('    Paths found', i9, 3x,
     1        '(maxheap, maxscatt', i8, i4, ')')

c     restore the value of rmax
      rmax = rmax/2

      end

      subroutine rphbin (in)
      implicit double precision (a-h, o-z)

c     Reads input from unit in.  Returns (via /pdata/)
c       energy mesh (ne, em and eref),
c       ph (npot, lmax, lmaxp1, ph),
c       final state (l0, il0)
c
c     phmin is min value to use for |phase shift|

      include 'dim.h'
      include 'pdata.h'

      parameter (phmin = 1.0e-8)

c     These header lines do not include carriage control
      read(in) ntext
      do 62  i = 1, ntext
         read(in) text(i)
         read(in) ltext(i)
   62 continue
      read(in) ne, npot, ihole, rnrmav, xmu, edge, ik0
      read(in) (em(ie),ie=1,ne)
      read(in) (eref(ie),ie=1,ne)
      lmaxp1 = 0
      do 80  iph = 0, npot
         read(in) lmax0, iz(iph)
         read(in) potlbl(iph)
         do 70  ie = 1, ne
            read(in)  (ph(ie,ll,iph), ll=1,lmax0+1)
            lmax(ie,iph) = 0
c           Set lmax to include only non-zero phases
            do 60  il = 1, lmax0+1
               if (abs(ph(ie,il,iph)) .lt. phmin)  goto 61
               lmax(ie,iph) = il-1
   60       continue
   61       continue
            if (lmax(ie,iph)+1 .gt. lmaxp1)  lmaxp1 = lmax(ie,iph)+1
   70    continue
   80 continue

c-----l0 is angular momentum of final state
c     Selection rule says that final state has angmom = l_init+1
c     ihole  initial state from ihole         final state
c     1      K    1s      L=0 -> linit=0   L0=1 -> lfinal=1
c     2      LI   2s      L=0 -> linit=0   L0=1 -> lfinal=1
c     3      LII  2p 1/2  L=1 -> linit=1   L0=2 -> lfinal=2
c     4      LIII 2p 3/2  L=1 -> linit=1   L0=2 -> lfinal=2
c     5+     M -- think about this later...
      if (ihole .le. 2)  then
c        hole in s state (1s or 2s)
         linit = 0
         lfinal = 1
      elseif (ihole .le. 4)  then
c        hole in p state (2p 1/2  or  2p 3/2)
         linit = 1
         lfinal = 2
      else
c        some m hole, n=3, could go to d state
         call echo(' Feff6L only does K and L shells')
         call fstop(' at RPHBIN')
      endif
      l0 = lfinal
      il0 = l0 + 1

      return
      end

      subroutine somm (dr,dp,dq,dpas,da,m,np)
c
c integration by the method of simpson of (dp+dq)*dr**m from
c 0 to r=dr(np)
c dpas=exponential step;
c for r in the neighborhood of zero (dp+dq)=cte*r**da
c **********************************************************************
      implicit double precision (a-h,o-z)
      dimension dr(np), dp(np), dq(np)
      mm=m+1
      d1=da+mm
      da=0.0
      db=0.0
      do 70 i=1,np
      dl=dr(i)**mm
      if (i.eq.1.or.i.eq.np) go to 10
      dl=dl+dl
      if ((i-2*(i/2)).eq.0) dl=dl+dl
   10 dc=dp(i)*dl
      if (dc) 20,40,30
   20 db=db+dc
      go to 40
   30 da=da+dc
   40 dc=dq(i)*dl
      if (dc) 50,70,60
   50 db=db+dc
      go to 70
   60 da=da+dc
   70 continue
      da = dpas * (da + db) / 3.0
      dc=exp(dpas)-1.0
      db=d1*(d1+1.0)*dc*exp((d1-1.0)*dpas)
      db=dr(1)*(dr(2)**m)/db
      dc=(dr(1)**mm)*(1.0+1.0/(dc*(d1+1.0)))/d1
      da=da+dc*(dp(1)+dq(1))-db*(dp(2)+dq(2))
      return
      end

      subroutine import(ne1, nsp, ik0, reff, deg, ckmag, em, eref2,
     &        cchi, xportx, crit)

      implicit double precision (a-h, o-z)
      include '../HEADERS/const.h'
      include '../HEADERS/dim.h'

      complex*16  ckp
      dimension   ffmag(nex), ckmag(nex)
      complex*16  eref(nex), em(nex), eref2(nex,nspx), cchi(nex)
      complex*16  ck(nex)

      external trap

c     Make importance factor, deg*(integral (|chi|*d|p|))
c     make ffmag (|chi|)
c     xport   importance factor
      do 10  ie = 1, ne1
c        this gets ck(ie) set correctly; see lines 257 and 272 in genfmt.f
         ck(ie) = sqrt (2* (em(ie) - eref2(ie,1)))
         if (nsp.eq.2) then
            eref(ie) = (eref2(ie,1) + eref2(ie,nsp)) /2
c           !KJ eref(ie) = (eref2(ie,1) + eref2(ie,2)) /2
            ck(ie) = sqrt (2* (em(ie) - eref(ie)))
         endif
         ckp = ck(ie)
         xlam0 = dimag(ck(ie)) - dimag(ckp)
         ffmag(ie) = abs( cchi(ie) * exp(2*reff*xlam0) )
 10   continue

c     integrate from edge (ik0) to ne
      nemax = ne1 - ik0 + 1
      call trap (ckmag(ik0), ffmag(ik0), nemax, xport)
      xport = abs(deg*xport)
      if (xportx.le.0)  xportx = xport
      crit = 100 * xport / xportx
c     use line below to disable importance factor (e.g. for dichroism)
c     crit = crit0+1

      return
      end

      subroutine rholie ( ri05, nr05, dx, x0, ri, em,
     2                  ixc, rmt, rnrm,
     3                  vtot, vvalgs, xnval, dgcn, dpcn, eref,
     4                  adgc, adpc, xrhole, xrhoce, yrhole, yrhoce, ph,
     i                  iz, xion, iunf, ihole, lmaxsc)

      implicit double precision (a-h, o-z)

c     INPUT
c     dx, x0, ri(nr)
c                  Loucks r-grid, ri=exp((i-1)*dx-x0)
c     ne, em(ne)   number of energy points,  complex energy grid
c     ixc          0  Hedin-Lunqist + const real & imag part
c                  1  Dirac-Hara + const real & imag part
c                  2  ground state + const real & imag part
c                  3  Dirac-Hara + HL imag part + const real & imag part
c                  5  Dirac-Fock exchange with core electrons +
c                     ixc=0 for valence electron density
c     rmt          r muffin tin
c     rnrm         r norman
c     vtot(nr)     total potential, including gsxc, final state
c     dgcn(dpcn)   large (small) dirac components for central atom
c     adgc(adpc)   their development coefficients
c
c     OUTPUT
c     xrhole(0:lx)  integral over r of density function
c     xrhoce(0:lx)  the same integral for embedded atom only
c     yrhole(251,0:lx)   density function
c     yrhoce(251)        density function for embedded atom


      include '../HEADERS/const.h'
      include '../HEADERS/dim.h'

c     max number allowed in xsect r-grid
      parameter (nrx = nrptx)

c     output
      complex*16  xrhole(0:lx)
      complex*16  xrhoce(0:lx)
      complex*16  yrhole(251,0:lx), yrhoce(251)
      complex*16  ph(lx+1)

      dimension ri(nrptx), ri05(251)
      dimension  vtot(nrptx), vvalgs(nrptx)
      complex*16 vtotc(nrptx), vvalc(nrptx)
      dimension xnval(30), dgcn(nrptx,30), dpcn(nrptx,30)
      dimension adgc(10,30), adpc(10,30)

c     energy grid in complex e-plane
      complex*16 em, eref

c     work space for dfovrg: regular and irregular solutions
      complex*16 pr(nrx), qr(nrx), pn(nrx), qn(nrx)

      complex*16  p2, xkmt, ck
c      complex*16  xck
      complex*16  pu, qu
      complex*16  xfnorm, xirf
      complex*16  temp,  phx, tempc

      complex*16 jl,jlp1,nl,nlp1
      complex*16  xpc(nrx)

c     initialize
      lmax=lmaxsc
      if (lmax.gt.lx) lmax = lx
      if (iz.le.4) lmax=2
      if (iz.le.2) lmax=1
      do 20 i = 1, nrptx
         vtotc(i)=vtot(i)
         vvalc(i)= vvalgs(i)
  20  continue
c     set imt and jri (use general Loucks grid)
c     rmt is between imt and jri (see function ii(r) in file xx.f)
      imt  = int((log(rmt) + x0) / dx)  +  1
      jri  = imt+1
      if (jri .gt. nrptx)  call par_stop('jri .gt. nrptx in phase')
      inrm = int((log(rnrm) + x0) / dx)  +  1
      jnrm = inrm+1

c     set limits for tabulations
      nr05= int((log(rnrm) + x0) / 0.05d0) + 5
      if (nr05.gt.251) nr05 = 251
c     ilast is the last integration point
c     it is larger than jnrm for better interpolations
      ilast = nint( (nr05-1) *0.05d0 / dx ) + 1
      if (ilast.gt.nrptx) ilast=nrptx

      do 10 lll = 0, lx
      do 10 j = 1, 251
         yrhole(j,lll) = 0
  10  continue
      do 30 j = 1, 251
  30  yrhoce(j) = 0

c     p2 is 0.5*(complex momentum)**2 referenced to energy dep xc
c     need hartree units for dfovrg
      p2 = em - eref
      if (mod(ixc,10) .lt. 5) then
        ncycle = 0
      else
        ncycle = 3
      endif
      ck = sqrt(2*p2 + (p2*alphfs)**2)
      xkmt = rmt * ck

      do 200 lll=0,lx
        if (lll.gt.lmax) then
           ph(lll+1) = 0
           xrhoce(lll) = 0
           xrhole(lll) = 0
           do 110 i = 1,251
  110      yrhole(i,lll) = 0
           goto 200
        endif

c       may want to use ihole=0 for new screening. 
c       don't want ro use it now
c       ihole = 0
        ikap = -1-lll
        irr = -1
        ic3 = 1
        if (lll.eq.0) ic3 = 0
        call dfovrg ( ncycle, ikap, rmt, ilast, jri, p2, dx,
     $                ri, vtotc, vvalc, dgcn, dpcn, adgc, adpc,
     $                xnval, pu, qu, pn, qn,
     $                iz, ihole, xion, iunf, irr, ic3)
        call exjlnl (xkmt, lll, jl, nl)
        call exjlnl (xkmt, lll+1, jlp1, nlp1)
        call phamp (rmt, pu, qu, ck,  jl, nl, jlp1, nlp1, ikap,
     1                  phx, temp)
        ph(lll+1)=phx

c     Normalize final state  at rmt to
c     rmt*(jl*cos(delta) - nl*sin(delta))
        xfnorm = 1 / temp
c     normalize regular solution
        do 133  i = 1,ilast
          pr(i)=pn(i)*xfnorm
          qr(i)=qn(i)*xfnorm
  133   continue

c      find irregular solution
        irr = 1
        pu = ck*alphfs
        pu = - pu/(1+sqrt(1+pu**2))
c       set pu, qu - initial condition for irregular solution at ilast
c       qu=(nlp1*cos(phx)+jlp1*sin(phx))*pu *rmt
c       pu = (nl*cos(phx)+jl*sin(phx)) *rmt
        qu=(nlp1*cos(phx)+jlp1*sin(phx))*pu *rmt 
        pu = (nl*cos(phx)+jl*sin(phx)) *rmt 

        call dfovrg (ncycle, ikap, rmt, ilast, jri, p2, dx,
     1              ri, vtotc,vvalc, dgcn, dpcn, adgc, adpc,
     1              xnval, pu, qu, pn, qn,
     1              iz, ihole, xion, iunf, irr, ic3)
cc      set N- irregular solution , which is outside
cc      N=(nlp1*cos(ph0)+jlp1*sin(ph0))*factor *rmt * dum1
cc      N = i*R - H*exp(i*ph0)
        temp = exp(coni*phx)
c       calculate wronskian
        qu = 2 * alpinv * temp * ( pn(jri)*qr(jri) - pr(jri)*qn(jri) )
        qu = 1 /qu / ck
c       qu should be close to 1
        do i = 1, ilast
          pn(i) = coni * pr(i) - temp * pn(i)*qu
          qn(i) = coni * qr(i) - temp * qn(i)*qu
        enddo

c     ATOM,  dgc0 is large component, ground state hole orbital
c     .      dpc0 is small component, ground state hole orbital
c     FOVRG, p    is large component, final state photo electron
c     .      q    is small component, final state photo electron

            
c    combine all constant factors to temp
c    add relativistic correction to normalization and factor 2*lll+1
        pu = ck*alphfs
        pu = - pu/(1+sqrt(1+pu**2))
        temp = (2*lll+1.0d0)/(1+pu**2) /pi *ck * 2
c    also scale by appropriate step in complex energy
        do 190  i = 1, ilast
          xpc(i) = pr(i) * pr(i) + qr(i) * qr(i) 
 190    continue
          
        do 191 ir=1,nr05
           call terpc(ri, xpc, ilast, 3, ri05(ir), tempc)
           tempc = tempc * temp
           yrhole(ir,lll)= tempc
 191    continue

        xirf = lll*2 + 2
c       i0 should be less or equal to  ilast
        i0=jnrm+1
        call csomm2 (ri, xpc, dx, xirf, rnrm, i0)
c       print out xirf for Bruce
        xrhole(lll) = xirf*temp

c     only central atom contribution needs irregular solution
        do 195  i = 1, ilast
          xpc(i) = pn(i)*pr(i)-coni*pr(i)*pr(i)
     1           + qn(i)*qr(i)-coni*qr(i)*qr(i)
c         yrhoce(i)=yrhoce(i) - temp*xpc(i)
 195    continue
        do 196 ir=1,nr05
           call terpc(ri, xpc, ilast, 3, ri05(ir), tempc)
           yrhoce(ir)=yrhoce(ir) - temp*tempc
 196    continue

        xirf =  1
        call csomm2 (ri, xpc, dx, xirf, rnrm, i0)
        xrhoce(lll) =  - xirf* temp
 200  continue 

      return
      end

      double precision function akeato(i,j,k)
c     angular coefficient by the direct coulomb integral fk for orbitals
c     i and j
      implicit double precision (a-h,o-z)
      common/mulabk/afgk
      dimension afgk(30,30,0:3)
 
c     afgk angular coefficients by integrales fk and gk
c        coefficient of integral fk(i;j) is in  afgk(min,max)
c        and that of integral gk(i;j) is in  afgk(max,min)
c        max=max(i,j) min=min(i,j)
 
      if (i .le. j) then 
         akeato=afgk(i,j,k/2)
      else
         akeato=afgk(j,i,k/2)
      endif
      return

      entry bkeato (i,j,k)
c     angular coefficient at the exchange coulomb integral gk
 
      bkeato=0.0d0
      if (i .lt. j) then
         bkeato=afgk(j,i,k/2)
      elseif (i.gt.j) then
         bkeato=afgk(i,j,k/2)
      endif
      return
      end

c//////////////////////////////////////////////////////////////////////
c Copyright (c) 1997--2000 Matthew Newville, The University of Chicago
c Copyright (c) 1992--1996 Matthew Newville, University of Washington
c
c Permission to use and redistribute the source code or binary forms of
c this software and its documentation, with or without modification is
c hereby granted provided that the above notice of copyright, these
c terms of use, and the disclaimer of warranty below appear in the
c source code and documentation, and that none of the names of The
c University of Chicago, The University of Washington, or the authors
c appear in advertising or endorsement of works derived from this
c software without specific prior written permission from all parties.
c
c THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
c EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
c MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
c IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
c CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
c TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
c SOFTWARE OR THE USE OR OTHER DEALINGS IN THIS SOFTWARE.
c//////////////////////////////////////////////////////////////////////
       integer function iread(iunit,line)
c
c reads line from an open file unit (iunit)
c  return values:
c   line length on success
c            -1 on 'end'
c            -2 on 'error'
       implicit none
       character*(*) line
       integer    iunit, istrln, ilen
       external   istrln
       line = ' '
 10    continue 
       read(iunit, '(a)', end = 40, err = 50) line
       call sclean(line)
       call triml(line)
       iread = istrln(line)
       if (iread .eq. 0) goto 10
       return
 40    continue 
       ilen = istrln(line)
       if (ilen.ge.1) then
          call sclean(line)
          call triml(line)
          iread = ilen
       else 
          line = ' '
          iread= -1
       endif
          
       return
 50    continue 
       line = ' '
       iread = -2
       return
       end
       integer function iread_ky(iunit,key,line)
c
c reads line from an open file unit (iunit)
c and extracts a 2character key (as for PAD files)
c return values:
c   line length on success
c            -1 on 'end'
c            -2 on 'error'
       implicit none
       character*(*) line, key
       integer    iunit, iread, ilen
       external    iread
       key = ' '
       line = ' '
       ilen = iread(iunit, line)
       if (ilen.gt.2) then
          key  = line(1:2)
          line = line(3:)
          ilen = ilen - 2
       endif
       iread_ky = ilen
       return
       end

       subroutine sclean(str) 
c
c  clean a string so that all: 
c     char(0), and char(10)...char(15) are end-of-line comments,
c        so that all following characters are explicitly blanked.
c     all other characters below char(31) (including tab) are
c        replaced by a single blank
c
c  note that this is mostly useful when getting a string generated
c  by a non-fortran process (say, a C program) and for dealing with
c  dos/unix/max line-ending problems
       character*(*) str, blank*1
       parameter (blank = ' ')
       integer i,j,is
       do 20 i = 1, len(str)
          is = ichar(str(i:i))
          if ((is.eq.0) .or. ((is.ge.10) .and. (is.le.15))) then
             do 10 j= i, len(str)
                str(j:j) = blank
 10          continue
             return
          endif
          if (is.le.31) str(i:i)  = blank
 20    continue 
       return
c end subroutine sclean
       end

!=======================================================================
!     FMS
!=======================================================================

module fms_inp
  use ldos_inp
  use global_inp,only: ldecmx
  implicit none
  character(*),parameter,private :: filename='fms.inp'
  integer mfms, idwopt, ipr3 !ipr3 is currently dummy - not in fms.inp
  real rprec
  !KJ rprec seems to be bogus input, i.e. not used anywhere in entire FEFF90.  Set to 0 and kept here for compatibility.
  double precision   tk, thetad, sig2g

contains

  subroutine fms_write
    implicit none
    integer iph
    open (file=filename, unit=3, status='unknown')
    write(3,10) 'mfms, idwopt, minv'
    write(3,20)  mfms, idwopt, minv
    write(3,10) 'rfms2, rdirec, toler1, toler2'
    write(3,30)  rfms2, rdirec, toler1, toler2
    write(3,10) 'tk, thetad, sig2g'
    write(3,30)  tk, thetad, sig2g
    write(3,10) ' lmaxph(0:nph)'
    write(3,20)  (lmaxph(iph),iph=0,nph)
    !KJ 7-09 Next 2 lines for feff8q
    write(3,'(a24)') ' the number of decomposition channels'
    write(3,'(i5)') ldecmx
    close(3)
    ! standard formats for string, integers and real numbers
10  format(a)
20  format (20i4)
30  format (9f13.5)
  end subroutine fms_write

  subroutine fms_read
    integer iph
    open (file=filename, unit=3, status='unknown')
    read(3,*) ; read(3,*)  mfms, idwopt, minv
    read(3,*) ; read(3,*)  rfms2, rdirec, toler1, toler2
    read(3,*) ; read(3,*)  tk, thetad, sig2g
    read(3,*) ; read(3,*)  (lmaxph(iph),iph=0,nph)
    !KJ 7-09 Next line for feff8q
    read(3,*) ; read(3,*) ldecmx
    close(3)
  end subroutine fms_read

  subroutine fms_init
    mfms = 1
    idwopt = -1
    sig2g = 0.d0
    thetad = 0.d0
    tk = 0.d0
    ipr3 = 0
    rprec = 0.e0
  end subroutine fms_init

end module fms_inp

      subroutine movrlp ( nph, nat, iphat, rat, iatph, xnatph,
     1                novr, iphovr, nnovr, rovr,
     2                imt, rmt, rnrm, ri, lnear,
     3                cmovp, ipiv, volint, inters)

c     Constructs overlap matrix based on geometry of overlapped
c     muffin-tin spheres. Uses LU decomposition for inversion of matrix
c     
      implicit double precision (a-h, o-z)

      include '../HEADERS/const.h'
      include '../HEADERS/dim.h'

      dimension iphat(natx)
      dimension rat(3,natx)
      dimension iatph(0:nphx)
      dimension xnatph(0:nphx)
      dimension novr(0:nphx)
      dimension iphovr(novrx,0:nphx)
      dimension nnovr(novrx,0:nphx)
      dimension rovr(novrx,0:nphx)
      dimension imt(0:nphx)
      dimension rmt(0:nphx)
      dimension rnrm(0:nphx)
      logical lnear
      dimension lnear(0:nphx)
c     local
      character*512 slog
c     work space for linear algebra
      dimension ri(251)
      parameter (novp=40)
      complex cmovp(novp*(nphx+1)+1,novp*(nphx+1)+1)
      real bmat(nphx+1,novp*(nphx+1))
      integer ipiv(novp*(nphx+1)+1)
c#mn
       external dist, ii

      ntmp = 0
      iat0 = -999

c     get ipot and irav from inters
      ipot = mod(inters,2)
      irav = (inters-ipot) / 2
      do 20 i=1,251
  20  ri(i)=exp(-8.8d0+(i-1)*0.05d0)
      exphx=exp(0.025d0)

c     initiallly cmovp is a unit matrix up to ncp
      ncp = novp*(nph+1)+1
      do 30 i2=1,ncp
      do 30 i1=1,ncp
        cmovp(i1,i2) = 0.
        if ( i1.eq.i2 ) cmovp(i1,i2) = 1.
        if (i2.eq.ncp) cmovp(i1,i2) = 0.01
  30  continue
      do 40 i2=1,ncp-1
      do 40 i1=1,nph+1
        bmat (i1,i2) = 0.e0
  40  continue
      xn = 0.d0

      do 200 ip1=0,nph
        if (novr(ip1) .gt. 0 ) then
           nlast = novr(ip1)
        else
           iat0 = iatph(ip1)
           ntmp = 1
           nlast = nat
        endif
        if (irav.eq.1) then
          rav = (rmt(ip1) + rnrm(ip1)) / 2
        elseif (irav.eq.0) then
          rav =  rnrm(ip1)
        else
          rav=ri(imt(ip1)+1)
        endif
        if (lnear(ip1)) rav=ri(imt(ip1)+1)

        do 190 iat = 1,nlast
          if (novr(ip1) .gt. 0 ) then
             ntmp = nnovr(iat,ip1)
             ip2 = iphovr(iat,ip1)
             rnn = rovr(iat,ip1)
          else
            if (iat.eq.iat0) goto 190
            ip2 = iphat(iat)
            rnn = dist (rat(1,iat0), rat(1,iat))
          endif

c         correct for double counting volume and area
          if (rnn .lt. rmt(ip1)+rmt(ip2)) then
c            correct interstitial volume
             volint = volint + xnatph(ip1) * ntmp *
     1       (calcvl( rmt(ip1), rmt(ip2), rnn) +
     2       calcvl(rmt(ip1), rmt(ip2), rnn)) / 2.d0
          endif

c         using expression for vtot(jri) ,(jri=i1)
c         first fill  matrix bmat
          ix1 = ip1+1

          if (rav+rmt(ip2) .le. rnn) goto 100
          imin2 = ii( rnn-rav )
          if (imt(ip2)-imin2 .ge. novp-1) then
             write(slog,132) ip1
  132        format(' FOLP for POTENTIAL type ',i3,' is too big.')
             call wlog (slog)
             write(slog,'(a)') ' Reduce overlap using FOLP and rerun'
             call wlog (slog)
             call par_stop('MOVRLP-1')
          endif
          imin2=imt(ip2)-novp+1

          do 80 i2 = imin2,imt(ip2)
             r1=ri(i2)/exphx
             r2=ri(i2)*exphx
             if (i2.eq.imt(ip2)) r2=rmt(ip2)
             if (i2.eq.imt(ip2))   r1=(r1+2*ri(imt(ip2))-rmt(ip2))/2.d0
             if (i2.eq.imt(ip2)-1) r2=(r2+2*ri(imt(ip2))-rmt(ip2))/2.d0
             if (r2+rav .lt. rnn) goto 80
             if (r1+rav .lt. rnn) then
c               use linear interpolation between cases xr=0, xr=1
                xr = (rnn-rav-r1)/ (r2-r1)
                r1 = rnn-rav   
                temp =  (r2**2 - r1**2) / (4*rnn*rav) * ntmp
                ind2=i2+1
                if (i2.eq.imt(ip2))  ind2=i2-1
                xr = xr * (r2-ri(i2)) / (ri(ind2)-ri(i2))
                ix2 = ip2*novp + i2 - imin2 + 1
                bmat (ix1,ix2) = bmat (ix1,ix2) + real(temp*(1-xr))
                ix2 = ip2*novp + ind2 - imin2 + 1
                bmat (ix1,ix2)=bmat (ix1,ix2) + real(temp*xr)
             else
                temp = (r2**2 - r1**2) / (4*rnn*rav   ) * ntmp
                ix2 = ip2*novp + i2 - imin2 + 1
                bmat (ix1,ix2) = bmat (ix1,ix2) + real( temp)
             endif
  80      continue

c         using expression for vtot(i) ,(i<jri)
c         construct matrix  cmovp
 100      if (rmt(ip1)+rmt(ip2) .le. rnn) goto 190

          imin1=ii(rnn-rmt(ip2))
          imin2=ii(rnn-rmt(ip1))
          if (imt(ip1)-imin1.ge.novp-1 .or. imt(ip2)-imin2.ge.novp-1) 
     1               call par_stop('tell authors to INCREASE NOVP')
          imin1=imt(ip1)-novp+1
          imin2=imt(ip2)-novp+1

          do 180 i1 = imin1,imt(ip1)
            ri1=ri(i1)/exphx
            ri2=ri(i1)*exphx
            if (i1.eq.imt(ip1)) ri2=rmt(ip1)
            if (i1.eq.imt(ip1)) ri1=(ri1+2*ri(imt(ip1))-rmt(ip1))/2.d0
            if (i1.eq.imt(ip1)-1)
     1                         ri2=(ri2+2*ri(imt(ip1))-rmt(ip1))/2.d0
            ix1 = i1-imin1+1  + ip1*novp
            do 170 i2 = imin2,imt(ip2)
              r1=ri(i2)/exphx
              r2=ri(i2)*exphx
              if (i2.eq.imt(ip2)) r2=rmt(ip2)
              if (i2.eq.imt(ip2))   r1=(r1+2*ri(imt(ip2))-rmt(ip2))/2.d0
              if (i2.eq.imt(ip2)-1) r2=(r2+2*ri(imt(ip2))-rmt(ip2))/2.d0
              if (r2+ri2.lt.rnn) goto 170

c             calculate volume of intersection
              temp = calcvl(ri2,r2,rnn) + calcvl(r2,ri2,rnn)
              if (ri1+r2.gt.rnn)
     1          temp = temp - calcvl(ri1,r2,rnn) - calcvl(r2,ri1,rnn)
              if (ri2+r1.gt.rnn)
     1          temp = temp - calcvl(ri2,r1,rnn) - calcvl(r1,ri2,rnn)
              if (ri1+r1.gt.rnn)
     1          temp = temp + calcvl(ri1,r1,rnn) + calcvl(r1,ri1,rnn)
c             volume of intersection (temp) should be devided by volume
c             volume between spheres ri1 and ri2
              temp=temp / ( 4.d0/3.d0*pi * (ri2**3-ri1**3) ) * ntmp

              if (r1+ri2.lt.rnn) then
c               use linear interpolation between cases xr=0, xr=1
                xr = (rnn-ri(i1)-r1)/ (r2-r1)

                ind2=i2+1
                if (i2.eq.imt(ip2))  ind2=i2-1
                xr = xr * (r2-ri(i2)) / (ri(ind2)-ri(i2))
                ix2 = i2-imin2+1 + ip2*novp
                cmovp(ix1,ix2)=cmovp(ix1,ix2) 
     1                              +cmplx (real(temp*(1-xr)))
                ix2 = ind2-imin2+1 + ip2*novp
                cmovp(ix1,ix2)=cmovp(ix1,ix2) 
     1                               +cmplx (real(temp*xr))
                r1=rnn-ri2
              else
                ix1 = i1-imin1+1 + ip1*novp
                ix2 = i2-imin2+1 + ip2*novp
                cmovp(ix1,ix2)=cmovp(ix1,ix2)  +cmplx (real(temp))
              endif
 170        continue
 180      continue

 190     continue
         xn = xn + xnatph(ip1)
  200 continue

c     using matrix bmat fill in the last row of matrix cmvovp
c     this is additional equation to find Vint.
c     switch to local equation from average over all atoms
      if (ipot .eq. 0) then
         do 260 iph=0, nph
c          xn may differ from nat, if atom list have more natx atoms
c          see rdinp.f
           aa = xnatph(iph)/xn
           do 250 ix1 = 1, ncp-1
  250      cmovp(ncp,ix1) = cmovp(ncp, ix1) +
     &             cmplx(real(aa)*bmat(iph+1,ix1))
  260    continue
      else  
         iph=0
         do 270 ix1 = 1, ncp-1
  270    cmovp(ncp,ix1) = cmovp(ncp, ix1) + bmat(iph+1,ix1)
      endif

c --- invert matrices by LU decomposition
c     call cgetrf from lapack.  this performs an LU decomposition on
c     the matrix 
      istatx=novp*(nphx+1) + 1
      call cgetrf( ncp, ncp, cmovp, istatx, ipiv, info )
      if (info.ne.0) then
          call wlog('    *** Error in cgetrf when computing cmovp')
      endif

c     have to check that the last was not permuted, otherwise
c     the density calculation will be wrong
c     this is also why we put 0.01 in last column and not 1.0
      if (ipiv(ncp).ne.ncp) 
     .  call par_stop('illegal permutation in ipiv ')

      return
      end

      subroutine vbh(rs,xmag,vxc)

      implicit double precision (a-h, o-z)

c   INPUT: density parameter rs, 2* fraction of given spin orientation.
c   OUTPUT: xc potential for given spin orientation.
c   Reference: Von Barth, Hedin, J.Phys.C, 5, 1629, (1972). eq.6.2
c   xmag is twice larger than 'x' in their paper
c   effect of tau was also found to be small. thus tau is not used

c     parameter (asm = 2.0**(-1.0/3.0) )
c     parameter (gamma = 4.0/3.0*asm/(1-asm) )
c APS parameter (gamma = 5.129762496709890 ) changed
      parameter (gamma = 5.129762802484098d0 )

      vxc = 0.0d0
      if (rs.gt.1000) goto 999
      epc  = -0.0504d0 * flarge(rs/30)
      efc  = -0.0254d0 * flarge(rs/75)
      xmup = -0.0504d0 * log(1.0d0 + 30.d0/rs)
c     xmuf = -0.0254d0 * log(1.0d0 + 75.d0/rs)
      vu   =  gamma*(efc - epc)
c     tau = xmuf-xmup-(efc-epc)*4.0/3.0

      alg = -1.22177412d0/rs + vu
      blg = xmup - vu
      vxc = alg*xmag**(1.0d0/3.0d0) + blg
c     vxc = alg*xmag**(1.0/3.0) + blg +tau*fsmall(xmag/2.0)

 999  continue
c     transform to code units (Hartrees) from Rydbergs
      vxc = vxc / 2.d0

      return
      end

      double precision function flarge(x)
      implicit double precision (a-h, o-z)
      flarge = (1+x*x*x)*log(1+1/x) + x/2 - x*x - 1.d0/3.d0
      return
      end

c     double precision function fsmall(x)
c     implicit double precision (a-h, o-z)
c     parameter (a = 2.0**(-1.0/3.0) )
c       fsmall = ( x**(4/3) + (1.0-x)**(4/3) - a ) / (1.0-a)
c     return
c     end

      subroutine totale (dval)
      implicit double precision (a-h,o-z)
      save
      common /print/ iprint
      common /dira/ dv(251), dr(251), dp(251), dq(251), dpas, tets,
     1              z, nstop, nes, np, nuc
      common /deux/ dvn(251), dvf(251), d(251), dc(251), dgc(251,30),
     1 dpc(251,30)
       external exchee
      dc(1)=1
      do 10 i=1,np
   10 dp(i)=d(i)/dr(i)
      if (nuc.le.0) go to 30
      do 20 i=1,nuc
   20 dp(i)=d(i)*(3.0-dr(i)*dr(i)/(dr(nuc)*dr(nuc)))/(dr(nuc)+dr(nuc))
      dc(1)=4
   30 call somm (dr,dp,dq,dpas,dc(1),0,np)
      dc(1)=-z*dc(1)
      do 40 i=1,np
      dp(i)=d(i)*dvf(i)
      dvn(i)=d(i)*dvn(i)
   40 d(i)=d(i)*exchee(d(i),dr(i))
      dc(2)=2
      dc(3)=1
      dc(5)=2
      if (nuc.ne.0) dc(3)=4
      call somm (dr,dp,dq,dpas,dc(3),0,np)
      call somm (dr,dvn,dq,dpas,dc(5),0,np)
      call somm (dr,d,dq,dpas,dc(2),0,np)
      dc(4)=dval-dc(3)
      dval=dval-.50*dc(5)-dc(2)
      dc(2)=dc(3)-dc(1)-dc(5)-dc(2)
      dc(3)=.50*dc(5)
      if (iprint .ge. 5)  write(16,50) dval,dc(4),dc(3),dc(2),dc(1)
   50 format (1h0,5x,'et=',1pe14.7,5x,'ec=',1pe14.7,5x,'ee=',1pe14.7,5x,
     1 'ex=',1pe14.7,5x,'en=',1pe14.7)
      return
      end

      double precision function aprdev (a,b,l)
c     the result of this function is the coefficient for the term of 
c     power (l-1) for the product of two polynomes, whose coefficients
c     are in rows a and b 
 
      implicit double precision (a-h,o-z)
      dimension a(10),b(10)
 
      aprdev=0.0d 00
      do 11 m=1,l
 11      aprdev=aprdev+a(m)*b(l+1-m)
      return
      end

!=======================================================================
!     FF2X
!=======================================================================

module ff2x_inp
  use global_inp
  use xsph_inp
  use fms_inp
  use genfmt_inp
  implicit none
  character(*),parameter,private :: filename='ff2x.inp'
  integer  mchi, ipr6, mbconv, absolu !KJ added absolu 3-06
  double precision  vrcorr, vicorr, s02, alphat, thetae


contains

  subroutine ff2x_write
    integer i
    open (file=filename, unit=3, status='unknown')
    write(3,10) 'mchi, ispec, idwopt, ipr6, mbconv, absolu, iGammaCH' !KJ added absolu 3-06
    write(3,20)  mchi, ispec, idwopt, ipr6, mbconv, absolu, iGammaCH !KJ added absolu 3-06
    write(3,10) 'vrcorr, vicorr, s02, critcw'
    write(3,30)  vrcorr, vicorr, s02, critcw
    write(3,10) 'tk, thetad, alphat, thetae, sig2g'
    write(3,30)  tk, thetad, alphat, thetae, sig2g
    !KJ 7-09 next 4 lines for feff8q
    write(3,10) 'momentum transfer'
    write(3, '(3f13.5)') (xivec(i),i=1,3)
    write(3,'(a24)') ' the number of decomposition channels'
    write(3,'(i5)') ldecmx
    close(3)
    ! standard formats for string, integers and real numbers
10  format(a)
20  format (20i4)
30  format (9f13.5)
  end subroutine ff2x_write

  subroutine ff2x_read
    integer i
    open (file=filename, unit=3, status='old')
    read(3,*) ; read(3,*)  mchi, ispec, idwopt, ipr6, mbconv, absolu, iGammaCH !KJ added absolu 3-06
    read(3,*) ; read(3,*)  vrcorr, vicorr, s02, critcw
    read(3,*) ; read(3,*)  tk, thetad, alphat, thetae, sig2g
    read(3,*) ; read(3, *) (xivec(i),i=1,3)
    read(3,*) ; read(3,*) ldecmx
    close(3)
  end subroutine ff2x_read

  subroutine ff2x_init
    absolu=0  !KJ 3-06 for ABSOLUTE card
    mchi = 1
    ipr6 = 0
    mbconv = 0
    vicorr = 0.d0
    vrcorr = 0.d0
    s02 = 1.d0
    alphat = 0.d0
    thetae = 0.d0
  end subroutine ff2x_init

end module ff2x_inp

!*****************************************************************************************
    module json_module
!*****************************************************************************************
!****h* JSON/json_module
!
!  NAME
!    json_module
!
!  DESCRIPTION
!    JSON-FORTRAN: A Fortran 2008 JSON (JavaScript Object Notation) API.
!
!  NOTES
!    -Based on fson by Joseph A. Levin (see License below)
!        -The original F95 code was split into four files:
!            fson_path_m.f95, fson_string_m.f95, fson_value_m.f95, fson.f95
!        -The code has been extensively modified and combined into this 
!            one module (json_module.f90).
!        -Some Fortran 2003/2008 features are now used 
!            (e.g., allocatable strings, associate, newunit, generic, class, 
!            and abstract interface)
!    -The headers in this file follow the ROBODoc conventions.
!            Compile with: robodoc --src ./ --doc ./doc --multidoc --html 
!                                  --tabsize 4 --ignore_case_when_linking 
!                                  --syntaxcolors --source_line_numbers --index
!
!  HISTORY
!    Joseph A. Levin : March 2012
!    Jacob Williams : 2/8/2013 : Extensive modifications to the original code.
!
!  SEE ALSO
!    [1] http://github.com/jacobwilliams/json-fortran [json-fortran development site]
!    [2] http://jacobwilliams.github.io/json-fortran [json-fortran online documentation]
!    [3] http://www.json.org/ [JSON website]
!    [4] http://jsonlint.com/ [JSON validator]
!
!  COPYRIGHT
!
!    -------------------------------------------------------------------------------------
!    json-fortran License:
!
!    JSON-FORTRAN: A Fortran 2003/2008 JSON API
!    http://github.com/jacobwilliams/json-fortran
!
!    Copyright (c) 2014, Jacob Williams
!    All rights reserved.
!
!    Redistribution and use in source and binary forms, with or without modification,
!    are permitted provided that the following conditions are met:
!
!    * Redistributions of source code must retain the above copyright notice, this
!      list of conditions and the following disclaimer.
!
!    * Redistributions in binary form must reproduce the above copyright notice, this
!      list of conditions and the following disclaimer in the documentation and/or
!      other materials provided with the distribution.
!
!    * The names of its contributors may not be used to endorse or promote products 
!      derived from this software without specific prior written permission.
!
!    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
!    ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
!    WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
!    DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
!    ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
!    (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
!    LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
!    ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
!    (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
!    SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
!
!    -------------------------------------------------------------------------------------
!    Original FSON License:
!
!    http://github.com/josephalevin/fson [FSON code retrieved on 12/2/2013]
!
!    Copyright (c) 2012 Joseph A. Levin
!
!    Permission is hereby granted, free of charge, to any person obtaining a copy of this
!    software and associated documentation files (the "Software"), to deal in the Software
!    without restriction, including without limitation the rights to use, copy, modify, merge,
!    publish, distribute, sublicense, and/or sell copies of the Software, and to permit
!    persons to whom the Software is furnished to do so, subject to the following conditions:
!
!    The above copyright notice and this permission notice shall be included in all copies or
!    substantial portions of the Software.
!
!    THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
!    INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
!    PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
!    LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT
!    OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
!    DEALINGS IN THE SOFTWARE.
!
!*****************************************************************************************

    implicit none

    private

    !parameters:
    integer,parameter,public :: wp = selected_real_kind(15,307)    !double precision reals
    character(len=*),parameter,public :: json_ext = '.json'        !JSON file extension
    
    character(len=1),parameter :: space             = ' '         !special characters
    character(len=1),parameter :: bspace            = achar(8)
    character(len=1),parameter :: horizontal_tab    = achar(9)
    character(len=1),parameter :: newline           = achar(10)  
    character(len=1),parameter :: formfeed          = achar(12)
    character(len=1),parameter :: carriage_return   = achar(13)
    character(len=1),parameter :: quotation_mark    = achar(34)
    character(len=1),parameter :: slash             = achar(47)
    character(len=1),parameter :: backslash         = achar(92)  
       
    character(len=*),parameter :: real_fmt  = '(E30.16E3)'      !format for real numbers
    character(len=*),parameter :: int_fmt   = '(I10)'           !format for integers

    ! The types of data:
    integer,parameter,public :: json_unknown   = 0
    integer,parameter,public :: json_null      = 1
    integer,parameter,public :: json_object    = 2
    integer,parameter,public :: json_array     = 3
    integer,parameter,public :: json_logical   = 4
    integer,parameter,public :: json_integer   = 5
    integer,parameter,public :: json_real      = 6
    integer,parameter,public :: json_string    = 7

    !*********************************************************
    !****ic* json_module/json_data_non_polymorphic
    !
    !  NAME
    !    json_data_non_polymorphic
    !
    !  DESCRIPTION
    !    The data in a json_value class
    !
    !  SOURCE
    
        type :: json_data_non_polymorphic

            integer :: var_type = json_unknown

            logical,allocatable             :: log_value
            integer,allocatable             :: int_value
            real(wp),allocatable            :: dbl_value
            character(len=:),allocatable    :: str_value

        contains

            procedure :: destroy => destroy_json_data_non_polymorphic

        end type json_data_non_polymorphic
    !*********************************************************

    !*********************************************************
    !****c* json_module/json_value
    !
    !  NAME
    !    json_value
    !
    !  DESCRIPTION
    !    Type used to construct the linked-list json structure
    !
    !  SOURCE
    
        type,public :: json_value

        !variable name:
        character(len=:),allocatable :: name

        !the data for this variable:
        type(json_data_non_polymorphic) :: data

        !for the linked list:
        type(json_value), pointer :: next => null()
        type(json_value), pointer :: parent => null()
        type(json_value), pointer :: children => null()

        end type json_value
    !*********************************************************

    !*********************************************************
        type,public :: json_file
    !*********************************************************
    !****c* json_module/json_file
    !
    !  NAME
    !    json_file
    !
    !  DESCRIPTION
    !  The json_file is the main public class that is
    !    used to open a file and get data from it.
    !
    !  EXAMPLE
    !    type(json_file) :: json
    !    call json%load_file(filename)
    !    call json%print_file()
    !    call json%get('var.i',ival,found)
    !    call json%get('var.d',rval,found)
    !    call json%get('var.c',cval,found)
    !    call json%destroy()
    !
    !  AUTHOR
    !    Jacob Williams : 12/9/2013
    !
    !  SOURCE

        private

        type(json_value), pointer :: p => null()    !the JSON structure read from the file

        contains

        procedure,public :: load_file   => load_json_file
        procedure,public :: print_file  => print_json_file
        procedure,public :: destroy     => destroy_json_file

        procedure,public :: info        => variable_info_in_file

        generic,public :: get => get_pointer,&
                                 get_integer,&
                                 get_double,&
                                 get_logical,&
                                 get_chars,&
                                 get_double_vec,&
                                 get_char_vec,&
                                 get_integer_vec,&
                                 get_logical_vec

        !scalars:
        procedure :: get_pointer        => get_object_from_json_file
        procedure :: get_integer        => get_integer_from_json_file
        procedure :: get_double         => get_double_from_json_file
        procedure :: get_logical        => get_logical_from_json_file
        procedure :: get_chars          => get_chars_from_json_file

        !vectors:
        procedure :: get_integer_vec    => get_integer_vec_from_json_file
        procedure :: get_double_vec     => get_double_vec_from_json_file
        procedure :: get_logical_vec    => get_logical_vec_from_json_file
        procedure :: get_char_vec       => get_char_vec_from_json_file

    !*********************************************************
        end type json_file
    !*********************************************************

    !array element callback function
    abstract interface
        subroutine array_callback_func(element, i, count)
            import :: json_value
            implicit none
            type(json_value), pointer,intent(in) :: element
            integer,intent(in) :: i        !index
            integer,intent(in) :: count    !size of array
        end subroutine array_callback_func
    end interface
    
    interface json_value_get           !consider renaming this json_value_get_child
        module procedure get_by_index
        module procedure get_by_name_chars
    end interface json_value_get

    interface json_value_add
        module procedure :: json_value_add_member
        module procedure :: json_value_add_integer, json_value_add_integer_vec
        module procedure :: json_value_add_real,    json_value_add_real_vec
        module procedure :: json_value_add_logical, json_value_add_logical_vec
        module procedure :: json_value_add_string,  json_value_add_string_vec
    end interface json_value_add
    
    interface json_get
        module procedure :: json_get_by_path
        module procedure :: json_get_integer, json_get_integer_vec
        module procedure :: json_get_double, json_get_double_vec
        module procedure :: json_get_logical, json_get_logical_vec
        module procedure :: json_get_chars, json_get_char_vec
        module procedure :: json_get_array
    end interface json_get
    
    interface json_print_to_string
        module procedure :: json_value_to_string
    end interface
    
    interface json_destroy
        module procedure :: json_value_destroy
    end interface

    !public routines:
    public :: json_initialize            !to initialize the module
    public :: json_destroy               !clear a JSON structure (destructor)
    public :: json_parse                 !read a JSON file and populate the structure
    public :: json_clear_exceptions      !clear exceptions
    public :: json_check_for_errors      !check for error and get error message
    public :: json_failed                !check for error
    public :: json_value_get             !use either a 1 based index or member 
                                         ! name to get a json_value.
    public :: json_value_add             !add data to a JSON structure
    public :: json_get                   !get data from the JSON structure  
    public :: json_print                 !print the JSON structure to a file
    public :: json_print_to_string       !write the JSON structure to a string
    public :: json_value_create          !initialize a json_value pointer
    public :: json_value_count           !count the number of children
    public :: json_info                  !get info about a json_value
    public :: to_logical                 !set the data type of a json_value
    public :: to_integer                 !
    public :: to_string                  !
    public :: to_real                    !
    public :: to_null                    !
    public :: to_object                  !
    public :: to_array                   !
    
    public :: integer_to_string          !basic integer to string routine

    !exception handling [private variables]
    logical :: exception_thrown = .false.            !the error flag
    character(len=:),allocatable :: err_message      !the error message
    logical,parameter :: print_tracebacks = .false.  !used when debugging

    ! POP/PUSH CHARACTER [private variables]
    integer :: char_count = 0
    integer :: line_count = 1
    integer :: pushed_index = 0
    character (len = 10) :: pushed_char              !JW : what is this magic number 10??

    contains
!*****************************************************************************************

!*****************************************************************************************
!****f* json_module/destroy_json_data_non_polymorphic
!
!  NAME
!    destroy_json_data_non_polymorphic
!
!  USAGE
!    call me%destroy()
!
!  DESCRIPTION
!    Destroy the nonpolymorphic data type.
!
!  AUTHOR
!    Jacob Williams
!
!  SOURCE

    subroutine destroy_json_data_non_polymorphic(me)

    implicit none

    class(json_data_non_polymorphic),intent(inout) :: me

    me%var_type = 0

    if (allocated(me%log_value)) deallocate(me%log_value)
    if (allocated(me%int_value)) deallocate(me%int_value)
    if (allocated(me%dbl_value)) deallocate(me%dbl_value)
    if (allocated(me%str_value)) deallocate(me%str_value)

    end subroutine destroy_json_data_non_polymorphic
!*****************************************************************************************

!*****************************************************************************************
!****f* json_module/destroy_json_file
!
!  NAME
!    destroy_json_file
!
!  USAGE
!    call me%destroy()
!
!  DESCRIPTION
!    Destroy the JSON file.
!
!  AUTHOR
!    Jacob Williams : 12/9/2013
!
!  SOURCE

    subroutine destroy_json_file(me)
    
    implicit none

    class(json_file),intent(inout) :: me

    if (associated(me%p)) call json_value_destroy(me%p)

    end subroutine destroy_json_file
!*****************************************************************************************

!*****************************************************************************************
!****f* json_module/load_json_file
!
!  NAME
!    load_json_file
!
!  USAGE
!    call me%load_file(filename)
!
!  DESCRIPTION
!    Load the JSON file.
!
!  AUTHOR
!    Jacob Williams : 12/9/2013
!
!  SOURCE

    subroutine load_json_file(me, filename)

    implicit none

    class(json_file),intent(inout) :: me
    character(len=*),intent(in) :: filename

    call json_parse(filename, me%p)

    end subroutine load_json_file
!*****************************************************************************************

!*****************************************************************************************
!****f* json_module/print_json_file
!
!  NAME
!    print_json_file
!
!  USAGE
!    call me%print_file()
!
!  DESCRIPTION
!    Print the JSON file.
!    Prints to the specified file unit (if not present, then prints to the console)
!
!  AUTHOR
!    Jacob Williams : 12/9/2013
!
!  SOURCE

    subroutine print_json_file(me, iunit)

    use, intrinsic :: iso_fortran_env,    only: output_unit

    implicit none

    class(json_file),intent(inout) :: me
    integer,intent(in),optional :: iunit  !must be non-zero

    integer :: i
    character(len=:),allocatable :: dummy

    if (present(iunit)) then
        if (iunit/=0) then
            i = iunit
        else
            call throw_exception('Error in print_json_file: iunit must be nonzero.')
            return
        end if
    else
        i = output_unit
    end if

    call json_value_print(me%p,iunit=i,str=dummy)

    end subroutine print_json_file
!*****************************************************************************************

!*****************************************************************************************
!****f* json_module/variable_info_in_file
!
!  NAME
!    variable_info_in_file
!
!  USAGE
!    call me%info(path,found,var_type,n_children)
!
!  DESCRIPTION
!    Returns information about a variable in a file.
!
!  AUTHOR
!    Jacob Williams : 2/3/2014
!
!  SOURCE

    subroutine variable_info_in_file(me,path,found,var_type,n_children)

    implicit none

    class(json_file),intent(inout) :: me
    character(len=*),intent(in)    :: path
    logical,intent(out)            :: found
    integer,intent(out)            :: var_type
    integer,intent(out)            :: n_children

    type(json_value),pointer :: p

    !initialize:
    nullify(p)

    !get a pointer to the variable (if it is there):
    call me%get(path,p,found)

    if (found) then

        !get info:
        call json_info(p,var_type,n_children)

    else

        !set to dummy values:
        var_type = json_unknown
        n_children = 0

    end if

    !cleanup:
    nullify(p)

    end subroutine variable_info_in_file
!*****************************************************************************************

!*****************************************************************************************
!****f* json_module/json_info
!
!  NAME
!    json_info
!
!  USAGE
!    call me%info(path,found,var_type,n_children)
!
!  DESCRIPTION
!    Returns information about a json_value
!
!  AUTHOR
!    Jacob Williams : 2/13/2014
!
!  SOURCE

    subroutine json_info(p,var_type,n_children)

    implicit none

    type(json_value),pointer        :: p
    integer,intent(out),optional    :: var_type
    integer,intent(out),optional    :: n_children
        
    if (present(var_type))    var_type = p%data%var_type        !variable type
    if (present(n_children))  n_children = json_value_count(p)  !number of children
    
    end subroutine json_info
!*****************************************************************************************
    
!*****************************************************************************************
!****f* json_module/get_object_from_json_file
!
!  NAME
!    get_object_from_json_file
!
!  USAGE
!    call me%get(path,p,found)
!
!  DESCRIPTION
!    Get a pointer to an object from a JSON file.
!
!  AUTHOR
!    Jacob Williams : 2/3/2014
!
!  SOURCE

    subroutine get_object_from_json_file(me, path, p, found)
    
    implicit none

    class(json_file),intent(inout)          :: me
    character(len=*),intent(in)             :: path
    type(json_value),pointer,intent(out)    :: p
    logical,intent(out),optional            :: found

    call json_get_by_path(me%p, path=path, p=p, found=found)

    end subroutine get_object_from_json_file
!*****************************************************************************************

!*****************************************************************************************
!****f* json_module/get_integer_from_json_file
!
!  NAME
!    get_integer_from_json_file
!
!  USAGE
!    call me%get(path,val)
!
!  DESCRIPTION
!    Get an integer from a JSON file.
!
!  AUTHOR
!    Jacob Williams : 12/9/2013
!
!  SOURCE

    subroutine get_integer_from_json_file(me, path, val, found)

    implicit none

    class(json_file),intent(inout)    :: me
    character(len=*),intent(in)       :: path
    integer,intent(out)               :: val
    logical,intent(out),optional      :: found

    call json_get(me%p, path=path, value=val, found=found)

    end subroutine get_integer_from_json_file
!*****************************************************************************************

!*****************************************************************************************
!****f* json_module/get_integer_vec_from_json_file
!
!  NAME
!    get_integer_vec_from_json_file
!
!  USAGE
!    call me%get(path,vec)
!
!  DESCRIPTION
!    Get an integer vector from a JSON file.
!
!  AUTHOR
!    Jacob Williams : 1/20/2014
!
!  SOURCE

    subroutine get_integer_vec_from_json_file(me, path, vec, found)

    implicit none

    class(json_file),intent(inout)                  :: me
    character(len=*),intent(in)                     :: path
    integer,dimension(:),allocatable,intent(out)    :: vec
    logical,intent(out),optional                    :: found


    call json_get(me%p, path, vec, found)

    end subroutine get_integer_vec_from_json_file
!*****************************************************************************************

!*****************************************************************************************
!****f* json_module/get_double_from_json_file
!
!  NAME
!    get_double_from_json_file
!
!  USAGE
!    call me%get(path,val,found)
!
!  DESCRIPTION
!    Get a double from a JSON file.
!
!  AUTHOR
!    Jacob Williams : 12/9/2013
!
!  SOURCE

    subroutine get_double_from_json_file (me, path, val, found)

    implicit none

    class(json_file),intent(inout)  :: me
    character(len=*),intent(in)     :: path
    real(wp),intent(out)            :: val
    logical,intent(out),optional    :: found

    call json_get(me%p, path=path, value=val, found=found)

    end subroutine get_double_from_json_file
!*****************************************************************************************

!*****************************************************************************************
!****f* json_module/get_double_vec_from_json_file
!
!  NAME
!    get_double_vec_from_json_file
!
!  USAGE
!    call me%get(path,vec,found)
!
!  DESCRIPTION
!    Get a double vector from a JSON file.
!
!  AUTHOR
!    Jacob Williams : 1/19/2014
!
!  SOURCE

    subroutine get_double_vec_from_json_file(me, path, vec, found)
    
    implicit none

    class(json_file),intent(inout)                  :: me
    character(len=*),intent(in)                     :: path
    real(wp),dimension(:),allocatable,intent(out)   :: vec
    logical,intent(out),optional                    :: found

    call json_get(me%p, path, vec, found)

    end subroutine get_double_vec_from_json_file
!*****************************************************************************************

!*****************************************************************************************
!****f* json_module/get_logical_from_json_file
!
!  NAME
!    get_logical_from_json_file
!
!  USAGE
!    call me%get(path,val,found)
!
!  DESCRIPTION
!    Get an logical from a JSON file.
!
!  AUTHOR
!    Jacob Williams : 12/9/2013
!
!  SOURCE

    subroutine get_logical_from_json_file(me,path,val,found)

    implicit none

    class(json_file),intent(inout)  :: me
    character(len=*),intent(in)     :: path
    logical,intent(out)             :: val
    logical,intent(out),optional    :: found

    call json_get(me%p, path=path, value=val, found=found)

    end subroutine get_logical_from_json_file
!*****************************************************************************************

!*****************************************************************************************
!****f* json_module/get_logical_vec_from_json_file
!
!  NAME
!    get_logical_vec_from_json_file
!
!  USAGE
!    call me%get(path,vec)
!
!  DESCRIPTION
!    Get a logical vector from a JSON file.
!
!  AUTHOR
!    Jacob Williams : 1/20/2014
!
!  SOURCE

    subroutine get_logical_vec_from_json_file(me, path, vec, found)

    implicit none

    class(json_file),intent(inout)                 :: me
    character(len=*),intent(in)                    :: path
    logical,dimension(:),allocatable,intent(out)   :: vec
    logical,intent(out),optional                   :: found
    
    call json_get(me%p, path, vec, found)

    end subroutine get_logical_vec_from_json_file
!*****************************************************************************************

!*****************************************************************************************
!****f* json_module/get_chars_from_json_file
!
!  NAME
!    get_chars_from_json_file
!
!  USAGE
!    call me%get(path,val)
!
!  DESCRIPTION
!    Get a character string from a json file.
!    Note: val is an allocatable character string.
!
!  AUTHOR
!    Jacob Williams : 12/9/2013
!
!  SOURCE

    subroutine get_chars_from_json_file(me, path, val, found)

    implicit none

    class(json_file),intent(inout)              :: me
    character(len=*),intent(in)                 :: path
    character(len=:),allocatable,intent(out)    :: val
    logical,intent(out),optional                :: found

    call json_get(me%p, path=path, value=val, found=found)

    end subroutine get_chars_from_json_file
!*****************************************************************************************

!*****************************************************************************************
!****f* json_module/get_char_vec_from_json_file
!
!  NAME
!    get_char_vec_from_json_file
!
!  USAGE
!    call me%get(path,vec)
!
!  DESCRIPTION
!    Get a char vector from a JSON file.
!
!  AUTHOR
!    Jacob Williams : 1/19/2014
!
!  SOURCE

    subroutine get_char_vec_from_json_file(me, path, vec, found)

    implicit none

    class(json_file),intent(inout)                         :: me
    character(len=*),intent(in)                            :: path
    character(len=*),dimension(:),allocatable,intent(out)  :: vec
    logical,intent(out),optional                           :: found

    call json_get(me%p, path, vec, found)

    end subroutine get_char_vec_from_json_file
!*****************************************************************************************

!*****************************************************************************************
!****f* json_module/json_initialize
!
!  NAME
!    json_initialize
!
!  DESCRIPTION
!    Initialize the module.
!    Should be called before the routines are used.
!    It can also be called after using the module and encountering exceptions.
!
!  AUTHOR
!    Jacob Williams : 12/4/2013
!
!  SOURCE

    subroutine json_initialize()

    implicit none

    !clear any errors from previous runs:
    call json_clear_exceptions()

    !Just in case, clear these global variables also:
    pushed_index = 0
    pushed_char = ''
    char_count = 0
    line_count = 1

    end subroutine json_initialize
!*****************************************************************************************

!*****************************************************************************************
!****f* json_module/json_clear_exceptions
!
!  NAME
!    json_clear_exceptions
!
!  DESCRIPTION
!    Clear exceptions in the JSON module.
!
!  AUTHOR
!    Jacob Williams : 12/4/2013
!
!  SOURCE

    subroutine json_clear_exceptions()

    implicit none

    !clear the flag and message:
    exception_thrown = .false.
    err_message = ''

    end subroutine json_clear_exceptions
!*****************************************************************************************

!*****************************************************************************************
!****f* json_module/throw_exception
!
!  NAME
!    throw_exception
!
!  DESCRIPTION
!    Throw an exception in the JSON module.
!    This routine sets the error flag, and prevents any subsequent routine
!    from doing anything, until json_clear_exceptions is called.
!
!  AUTHOR
!    Jacob Williams : 12/4/2013
!
!  SOURCE
 
    subroutine throw_exception(msg)

    !use ifcore,    only: tracebackqq    !Intel routine

    implicit none

    character(len=*),intent(in) :: msg    !the error message

    exception_thrown = .true.
    err_message = trim(msg)

    !if (print_tracebacks) then
    !
    !    !This is a feature of the Intel Fortran Compiler:
    !    !Throw a traceback and return control to the user.
    !    call tracebackqq(string=trim(msg), user_exit_code=-1)
    !
    !    !write(*,'(A)') trim(msg)        !gfortran version
    !    !stop
    !
    !end if

    end subroutine throw_exception
!*****************************************************************************************

!*****************************************************************************************
!****f* json_module/json_check_for_errors
!
!  NAME
!    json_check_for_errors
!
!  DESCRIPTION
!    Retrieve error code from the module.
!    This should be called after json_parse to check for errors.
!    If an error is thrown, before using the module again, json_initialize
!    should be called to clean up before it is used again.
!
!  AUTHOR
!    Jacob Williams : 12/4/2013
!
!  SOURCE

    subroutine json_check_for_errors(status_ok, error_msg)

    implicit none

    logical,intent(out) :: status_ok
    character(len=:),allocatable,intent(out) :: error_msg

    status_ok = .not. exception_thrown

    if (.not. status_ok) then
        if (allocated(err_message)) then
            error_msg = err_message
        else
            error_msg = 'Unknown Error'
        end if
    else
        error_msg = ''
    end if

    end subroutine json_check_for_errors
!*****************************************************************************************

!*****************************************************************************************
!****f* json_module/json_failed
!
!  NAME
!    json_failed
!
!  DESCRIPTION
!    Logical function to indicate if an exception has been thrown.
!
!  USAGE
!    if (json_failed()) then
!        !do something about it
!        call json_clear_exceptions()
!    end if
!
!  AUTHOR
!    Jacob Williams : 12/5/2013
!
!  SOURCE

    function json_failed() result(failed)

    implicit none

    logical :: failed

    failed = exception_thrown

    end function json_failed
!*****************************************************************************************

!*****************************************************************************************
!****f* json_module/json_value_create
!
!  NAME
!    json_value_create
!
!  DESCRIPTION
!    Allocate a json_value pointer variable.
!    This should be called before adding data to it.
!    Example:
!        type(json_value),pointer :: var
!        call json_value_create(var)
!        call to_real(var,1.0d0)
!
!  NOTES
!    This routine does not check for exceptions.
!    The pointer should not already be allocated.
!
!  SOURCE

    subroutine json_value_create(p)

    implicit none

    type(json_value), pointer :: p

    nullify(p)
    allocate(p)

    end subroutine json_value_create
!*****************************************************************************************

!*****************************************************************************************
!****f* json_module/json_value_destroy
!
!  NAME
!    json_value_destroy
!
!  DESCRIPTION
!    Destroy a json_value linked-list structure.
!
!  NOTES
!    This routine does not check for exceptions.
!    I believe the original version of this routine was not
!        properly freeing the memory.  It has been rewritten.
!
!  AUTHOR
!    Jacob Williams : 1/22/2014
!
!  SOURCE

    recursive subroutine json_value_destroy(this)

    implicit none

    type(json_value),pointer :: this

    if (associated(this)) then

        if (allocated(this%name)) deallocate(this%name)

        call this%data%destroy()

        if (associated(this%children))    call json_value_destroy(this%children)

        if (associated(this%next))        call json_value_destroy(this%next)

        deallocate(this)

        nullify(this)

    end if

    end subroutine json_value_destroy
!*****************************************************************************************

!*****************************************************************************************
!****f* json_module/json_value_add_member
!
!  NAME
!    json_value_add_member
!
!  DESCRIPTION
!    Adds the member to the linked list
!
!  SOURCE

    subroutine json_value_add_member(this, member)

    implicit none

    type(json_value), pointer :: this, member

    type(json_value), pointer :: p

    if (.not. exception_thrown) then

        nullify(p)

        ! associate the parent
        member % parent => this

        ! add to linked list
        if (associated(this % children)) then

            ! get to the tail of the linked list
            p => this % children
            do while (associated(p % next))
                p => p % next
            end do

            p % next => member

            nullify(p)    !cleanup

        else

            this % children => member

        end if

    end if

    end subroutine json_value_add_member
!*****************************************************************************************

!*****************************************************************************************
!****f* json_module/json_value_add_real
!
!  NAME
!    json_value_add_real
!
!  DESCRIPTION
!    Add a real value to the structure.
!
!    These routines are part of the public API that can be
!        used to build a json structure using data.
!
!  AUTHOR
!    Jacob Williams : 1/19/2014
!
!  SOURCE

    subroutine json_value_add_real(me, name, val)

    implicit none

    type(json_value), pointer   :: me
    character(len=*),intent(in) :: name
    real(wp),intent(in)         :: val

    type(json_value),pointer :: var

    !create the variable:
    call json_value_create(var)
    call to_real(var,val,name)

    !add it:
    call json_value_add(me, var)

    !cleanup:
    nullify(var)

    end subroutine json_value_add_real
!*****************************************************************************************

!*****************************************************************************************
!****f* json_module/json_value_add_real_vec
!
!  NAME
!    json_value_add_real_vec
!
!  DESCRIPTION
!    Add a real vector to the structure.
!
!    These routines are part of the public API that can be
!        used to build a json structure using data.
!
!  AUTHOR
!    Jacob Williams : 1/20/2014
!
!  SOURCE

    subroutine json_value_add_real_vec(me, name, val)

    implicit none

    type(json_value), pointer         :: me
    character(len=*),intent(in)       :: name
    real(wp),dimension(:),intent(in)  :: val

    type(json_value),pointer :: var
    integer :: i

    !create the variable as an array:
    call json_value_create(var)
    call to_array(var,name)

    !populate the array:
    do i=1,size(val)
        call json_value_add(var, '', val(i))
    end do

    !add it:
    call json_value_add(me, var)

    !cleanup:
    nullify(var)

    end subroutine json_value_add_real_vec
!*****************************************************************************************

!*****************************************************************************************
!****f* json_module/json_value_add_integer
!
!  NAME
!    json_value_add_integer
!
!  DESCRIPTION
!    Add an integer value to the structure.
!
!    These routines are part of the public API that can be
!        used to build a json structure using data.
!
!  AUTHOR
!    Jacob Williams : 1/20/2014
!
!  SOURCE

    subroutine json_value_add_integer(me, name, val)

    implicit none

    type(json_value), pointer     :: me
    character(len=*),intent(in)   :: name
    integer,intent(in)            :: val

    type(json_value),pointer :: var

    !create the variable:
    call json_value_create(var)
    call to_integer(var,val,name)

    !add it:
    call json_value_add(me, var)

    !cleanup:
    nullify(var)

    end subroutine json_value_add_integer
!*****************************************************************************************

!*****************************************************************************************
!****f* json_module/json_value_add_integer_vec
!
!  NAME
!    json_value_add_integer_vec
!
!  DESCRIPTION
!    Add an integer vector to the structure.
!
!    These routines are part of the public API that can be
!        used to build a json structure using data.
!
!  AUTHOR
!    Jacob Williams : 1/20/2014
!
!  SOURCE

    subroutine json_value_add_integer_vec(me, name, val)

    implicit none

    type(json_value), pointer       :: me
    character(len=*),intent(in)     :: name
    integer,dimension(:),intent(in) :: val

    type(json_value),pointer :: var
    integer :: i    !counter

    !create the variable as an array:
    call json_value_create(var)
    call to_array(var,name)

    !populate the array:
    do i=1,size(val)
        call json_value_add(var, '', val(i))
    end do

    !add it:
    call json_value_add(me, var)

    !cleanup:
    nullify(var)

    end subroutine json_value_add_integer_vec
!*****************************************************************************************

!*****************************************************************************************
!****f* json_module/json_value_add_logical
!
!  NAME
!    json_value_add_logical
!
!  DESCRIPTION
!    Add a logical value to the structure.
!
!    These routines are part of the public API that can be
!        used to build a json structure using data.
!
!  AUTHOR
!    Jacob Williams : 1/20/2014
!
!  SOURCE

    subroutine json_value_add_logical(me, name, val)

    implicit none

    type(json_value), pointer   :: me
    character(len=*),intent(in) :: name
    logical,intent(in)          :: val

    type(json_value),pointer :: var

    !create the variable:
    call json_value_create(var)
    call to_logical(var,val,name)

    !add it:
    call json_value_add(me, var)

    !cleanup:
    nullify(var)

    end subroutine json_value_add_logical
!*****************************************************************************************

!*****************************************************************************************
!****f* json_module/json_value_add_logical_vec
!
!  NAME
!    json_value_add_logical_vec
!
!  DESCRIPTION
!    Add a logical vector to the structure.
!
!    These routines are part of the public API that can be
!        used to build a json structure using data.
!
!  AUTHOR
!    Jacob Williams : 1/20/2014
!
!  SOURCE

    subroutine json_value_add_logical_vec(me, name, val)

    implicit none

    type(json_value), pointer       :: me
    character(len=*),intent(in)     :: name
    logical,dimension(:),intent(in) :: val

    type(json_value),pointer :: var
    integer :: i    !counter

    !create the variable as an array:
    call json_value_create(var)
    call to_array(var,name)

    !populate the array:
    do i=1,size(val)
        call json_value_add(var, '', val(i))
    end do

    !add it:
    call json_value_add(me, var)

    !cleanup:
    nullify(var)

    end subroutine json_value_add_logical_vec
!*****************************************************************************************

!*****************************************************************************************
!****f* json_module/json_value_add_string
!
!  NAME
!    json_value_add_string
!
!  DESCRIPTION
!    Add a character string the structure.
!
!    These routines are part of the public API that can be
!        used to build a json structure using data.
!
!  AUTHOR
!    Jacob Williams : 1/19/2014
!
!  SOURCE

    subroutine json_value_add_string(me, name, val)

    implicit none

    type(json_value), pointer   :: me
    character(len=*),intent(in) :: name
    character(len=*),intent(in) :: val

    type(json_value),pointer        :: var
    character(len=:),allocatable    :: str

    !add escape characters if necessary:
    call escape_string(val, str)

    !create the variable:
    call json_value_create(var)
    call to_string(var,str,name)

    !add it:
    call json_value_add(me, var)

    !cleanup:
    nullify(var)

    end subroutine json_value_add_string
!*****************************************************************************************

!*****************************************************************************************
!****f* json_module/escape_string
!
!  NAME
!    escape_string
!
!  DESCRIPTION
!    Add the escape characters to a string for adding to JSON.
!
!  AUTHOR
!    Jacob Williams : 1/21/2014
!
!  SOURCE

    subroutine escape_string(str_in, str_out)

    implicit none

    character(len=*),intent(in)              :: str_in
    character(len=:),allocatable,intent(out) :: str_out

    integer :: i
    character(len=1) :: c

    str_out = ''

    !go through the string and look for special characters:
    do i=1,len(str_in)

        c = str_in(i:i)    !get next character in the input string
             
        select case(c)
        case(quotation_mark,backslash,slash)
            str_out = str_out//backslash//c
        case(bspace)
            str_out = str_out//'\b'
        case(formfeed)
            str_out = str_out//'\f'
        case(newline)
            str_out = str_out//'\n'
        case(carriage_return)
            str_out = str_out//'\r'
        case(horizontal_tab)
            str_out = str_out//'\t'
        case default
            str_out = str_out//c
        end select

    end do

    end subroutine escape_string
!*****************************************************************************************

!*****************************************************************************************
!****f* json_module/json_value_add_string_vec
!
!  NAME
!    json_value_add_string_vec
!
!  DESCRIPTION
!    Add an array of character string to the structure.
!
!    These routines are part of the public API that can be
!        used to build a json structure using data.
!
!  AUTHOR
!    Jacob Williams : 1/19/2014
!
!  SOURCE

    subroutine json_value_add_string_vec(me, name, val, trim_str, adjustl_str)

    implicit none

    type(json_value), pointer                :: me
    character(len=*),intent(in)              :: name
    character(len=*),dimension(:),intent(in) :: val
    logical,intent(in),optional              :: trim_str
    logical,intent(in),optional              :: adjustl_str

    type(json_value),pointer :: var
    integer :: i
    logical :: trim_string, adjustl_string
    character(len=:),allocatable :: str

    !if the string is to be trimmed or not:
    if (present(trim_str)) then
        trim_string = trim_str
    else
        trim_string = .false.
    end if
    if (present(adjustl_str)) then
        adjustl_string = adjustl_str
    else
        adjustl_string = .false.
    end if

    !create the variable as an array:
    call json_value_create(var)
    call to_array(var,name)

    !populate the array:
    do i=1,size(val)

        !the string to write:
        str = val(i)
        if (adjustl_string) str = adjustl(str)
        if (trim_string)    str = trim(str)

        !write it:
        call json_value_add(var, '', str)

        !cleanup
        deallocate(str)

    end do

    !add it:
    call json_value_add(me, var)

    !cleanup:
    nullify(var)

    end subroutine json_value_add_string_vec
!*****************************************************************************************

!*****************************************************************************************
!****f* json_module/json_value_count
!
!  NAME
!    json_value_count
!
!  DESCRIPTION
!    Count the number of children.
!
!  SOURCE

    function json_value_count(this) result(count)

    implicit none

    integer :: count
    type(json_value),pointer,intent(in) :: this

    type(json_value), pointer :: p

    if (.not. exception_thrown) then

        count = 0
        
        if (associated(this)) then

            if (associated(this%children)) then

                p => this%children

                do while (associated(p))
                    count = count + 1
                    p => p%next
                end do

                nullify(p)

            end if
            
        end if
        
    end if

    end function json_value_count
!*****************************************************************************************

!*****************************************************************************************
!****f* json_module/get_by_index
!
!  NAME
!    get_by_index
!
!  DESCRIPTION
!    Returns a child in the object given the index.
!
!  SOURCE

    subroutine get_by_index(this, idx, p)

    implicit none

    type(json_value),pointer,intent(in) :: this
    integer,intent(in)                  :: idx
    type(json_value), pointer           :: p

    integer :: i

    if (.not. exception_thrown) then

        nullify(p)

        if (associated(this%children)) then

            p => this%children

            do i = 1, idx - 1

                if (associated(p%next)) then
                    p => p%next
                else
                    call throw_exception('Error in get_by_index:'//&
                                         ' p%next is not associated.')
                    return
                end if

            end do

        else

            call throw_exception('Error in get_by_index:'//&
                                 ' this%children is not associated.')

        end if

    end if

    end subroutine get_by_index
!*****************************************************************************************

!*****************************************************************************************
!****f* json_module/get_by_name_chars
!
!  NAME
!    get_by_name_chars
!
!  DESCRIPTION
!    Returns a child in the object given the name string.
!
!  SOURCE

    subroutine get_by_name_chars(this, name, p)

    implicit none

    type(json_value),pointer,intent(in) :: this
    character(len=*),intent(in)         :: name
    type(json_value),pointer            :: p

    integer :: i

    if (.not. exception_thrown) then

        if (associated(this)) then

            nullify(p)

            if (this%data%var_type==json_object) then
                do i=1, json_value_count(this)
                    call json_value_get(this, i, p)
                    if (allocated(p%name)) then
                        if (p%name == name) return
                    end if
                end do
            end if

            !did not find anything:
            nullify(p)

        else
            call throw_exception('Error in get_by_name_chars: pointer is not associated.')
        end if

    end if

    end subroutine get_by_name_chars
!*****************************************************************************************

!*****************************************************************************************
!****f* json_module/json_value_to_string
!
!  NAME
!    json_value_to_string
!
!  DESCRIPTION
!    Print the JSON structure to an allocatable string.
!
!  AUTHOR
!    Jacob Williams : 2/12/2014
!
!  SOURCE

    subroutine json_value_to_string(me,str)

    implicit none
    
    type(json_value),pointer,intent(in)        :: me
    character(len=:),intent(out),allocatable   :: str
    
    str = ''
    call json_value_print(me, iunit=0, str=str)
        
    end subroutine json_value_to_string
!*****************************************************************************************

!*****************************************************************************************
!****f* json_module/json_print
!
!  NAME
!    json_print
!
!  DESCRIPTION
!    Print the JSON structure to a file
!
!  AUTHOR
!    Jacob Williams, 6/20/2014
!
!  SOURCE

    subroutine json_print(me,iunit)
    
    implicit none
    
    type(json_value),pointer,intent(in)  :: me
    integer,intent(in) :: iunit                   !must be non-zero
    
    character(len=:),allocatable :: dummy
    
    if (iunit/=0) then
        call json_value_print(me,iunit,str=dummy)
    else
        call throw_exception('Error in json_print: iunit must be nonzero.')
    end if
    
    end subroutine json_print
    
!*****************************************************************************************
!****if* json_module/json_value_print
!
!  NAME
!    json_value_print
!
!  DESCRIPTION
!    Print the JSON structure to a string or a file.
!
!  NOTES
!    This is an internal routine called by the wrapper routines
!        json_print and json_value_to_string
!    The reason the str argument is non-optional is because of a 
!        bug in v4.9 of the gfortran compiler.  
!
!  SOURCE

    recursive subroutine json_value_print(this,iunit,indent,need_comma,colon,str)

    implicit none

    type(json_value),pointer,intent(in)  :: this
    integer,intent(in)                   :: iunit     !file unit to write to (6=console)
    integer,intent(in),optional          :: indent
    logical,intent(in),optional          :: need_comma
    logical,intent(in),optional          :: colon
    character(len=:),intent(inout),allocatable :: str !if iunit==0, then the structure is 
                                                      ! printed to this string rather than 
                                                      ! a file. This mode is used by 
                                                      ! json_value_to_string.

    type(json_value), pointer :: element
    integer :: tab, i, count, spaces
    character(len=32) :: tmp    !for val to string conversions
    logical :: print_comma
    logical :: print_spaces
    logical :: write_file, write_string

    if (.not. exception_thrown) then
            
        !whether to write a string or a file (one or the other):
        write_string = (iunit==0)
        write_file = .not. write_string
        
        !if the comma will be printed after the value
        ! [comma not printed for the last elements]
        if (present(need_comma)) then
            print_comma = need_comma
        else
            print_comma = .false.
        end if
        !if the colon was the last thing written
        if (present(colon)) then
            print_spaces = .not. colon
        else
            print_spaces = .true.
        end if

        if (present(indent)) then
            tab = indent
        else
            tab = 0
        end if

        if (print_spaces) then
            spaces = tab * 2
        else
            spaces = 0
        end if
        
        nullify(element)

        !associate (d => this%data)

            select case (this%data%var_type)

            case (json_object)
                
                call write_it( repeat(space, spaces)//'{' )
                 
                count = json_value_count(this)
                do i = 1, count

                    ! get the element
                    call json_value_get(this, i, element)

                    ! print the name
                    if (allocated(element%name)) then
                        call write_it(repeat(space, spaces)//'"'//&
                                      trim(element % name)//'": ',advance=.false.)
                    else
                        call throw_exception('Error in json_value_print:'//&
                                             ' element%name not allocated')
                        call cleanup()
                        return
                    end if

                    ! recursive print of the element
                    call json_value_print(element, iunit=iunit, indent=tab + 1, &
                                          need_comma=i<count, colon=.true., str=str)

                end do

                call write_it( repeat(space, spaces)//'}', comma=print_comma )

            case (json_array)

                call write_it( '[' )
                count = json_value_count(this)

                do i = 1, count

                    ! get the element
                    call json_value_get(this, i, element)

                    ! recursive print of the element
                    call json_value_print(element, iunit=iunit, indent=tab + 1, &
                                          need_comma=i<count, str=str)

                end do
                
                !indent the closing array character:
                call write_it( repeat(space, tab * 2)//']', comma=print_comma ) 

            case (json_null)

                call write_it( repeat(space, spaces)//'null', comma=print_comma )

            case (json_string)

                if (allocated(this%data%str_value)) then
                    call write_it( repeat(space, spaces)//'"'// &
                                   trim(this%data%str_value)//'"', comma=print_comma )
                else
                    call throw_exception('Error in json_value_print:'//&
                                         ' this%value_string not allocated')
                    call cleanup()
                    return
                end if

            case (json_logical)

                if (this%data%log_value) then
                    call write_it( repeat(space, spaces)// 'true', comma=print_comma )
                else
                    call write_it( repeat(space, spaces)//'false', comma=print_comma )
                end if

            case (json_integer)

                call integer_to_string(this%data%int_value,tmp)

                call write_it( repeat(space, spaces)//trim(tmp), comma=print_comma )

            case (json_real)

                call real_to_string(this%data%dbl_value,tmp)

                call write_it( repeat(space, spaces)//trim(tmp), comma=print_comma )

            case default

                call throw_exception('Error in json_value_print: unknown data type')

            end select

        !end associate

        call cleanup()

    end if

    contains

        !-------------------------------
        ! cleanup routine
        !-------------------------------
        subroutine cleanup()
        implicit none

        if (associated(element)) nullify(element)

        end subroutine cleanup
         !-------------------------------
   
        !-------------------------------
        ! write the string to the file (or the output string)
        !-------------------------------
        subroutine write_it(s,advance,comma)

        implicit none

        character(len=*),intent(in) :: s
        logical,intent(in),optional :: advance
        logical,intent(in),optional :: comma
       
        logical :: add_line_break, add_comma
        character(len=:),allocatable :: s2
        
        if (present(comma)) then
            add_comma = comma
        else
            add_comma = .false. !default is not to add comma
        end if
         
        if (present(advance)) then
            add_line_break = advance
        else
            add_line_break = .true. !default is to advance
        end if
        
        !string to print:
        s2 = s
        if (add_comma) s2 = s2 // ','
        
        if (write_file) then
        
            if (add_line_break) then
                write(iunit,fmt='(A)') s2
            else
                write(iunit,fmt='(A)',advance='NO') s2
            end if
            
        else    !write string
               
            str = str // s2
            if (add_line_break) str = str // newline
           
        end if
        
        !cleanup:
        if (allocated(s2)) deallocate(s2)
        
        end subroutine write_it
        !-------------------------------

    end subroutine json_value_print
!*****************************************************************************************

!*****************************************************************************************
!****f* json_module/json_get_by_path
!
!  NAME
!    json_get_by_path
!
!  DESCRIPTION
!
!
!  NOTES
!     $         root
!     @         this
!     .         child object member
!     [] or ()  child array element
!
!  SOURCE

    subroutine json_get_by_path(this, path, p, found)

    implicit none

    type(json_value),pointer,intent(in)     :: this
    character(len=*),intent(in)             :: path
    type(json_value),pointer,intent(out)    :: p
    logical,intent(out),optional            :: found

    integer :: i, length, child_i
    character(len=1) :: c
    logical :: array
    type(json_value),pointer :: tmp

    if (.not. exception_thrown) then

        nullify(p)

        ! default to assuming relative to this
        p => this

        child_i = 1

        array = .false.

        length = len_trim(path)

        do i=1, length

            c = path(i:i)

            select case (c)
            case ('$')

                ! root
                do while (associated (p % parent))
                    p => p % parent
                end do
                child_i = i + 1

            case ('@')

                ! this
                p => this
                child_i = i + 1

            case ('.')

                ! get child member from p
                if (child_i < i) then
                    nullify(tmp)
                    call json_value_get(p, path(child_i:i-1), tmp)
                    p => tmp
                    nullify(tmp)
                else
                    child_i = i + 1
                    cycle
                end if

                if (.not.associated(p)) then
                    call throw_exception('Error in json_get_by_path:'//&
                                         ' Error getting child member.')
                    exit
                end if

                child_i = i+1

            case ('[','(')

                !....Modified to allow for 'var[3]' style syntax
                !Note: jmozmoz/fson has a slightly different version of this...

                ! start looking for the array element index
                array = .true.

                ! get child member from p
                if (child_i < i) then
                    nullify(tmp)
                    call json_value_get(p, path(child_i:i-1), tmp)
                    p => tmp
                    nullify(tmp)
                else
                    child_i = i + 1
                    cycle
                end if
                if (.not.associated(p)) then
                    call throw_exception('Error in json_get_by_path:'//&
                                         ' Error getting array element')
                    exit
                end if
                child_i = i + 1

            case (']',')')

                if (.not.array) then
                    call throw_exception('Error in json_get_by_path: Unexpected ]')
                    exit
                end if
                array = .false.
                child_i = string_to_integer(path(child_i:i-1))

                nullify(tmp)
                call json_value_get(p, child_i, tmp)
                p => tmp
                nullify(tmp)

                child_i= i + 1

            end select

        end do

        if (exception_thrown) then

            if (present(found)) then
                found = .false.
                call json_clear_exceptions()
            end if

        else

            ! grab the last child if present in the path
            if (child_i <= length) then
                nullify(tmp)
                call json_value_get(p, path(child_i:i-1), tmp)
                p => tmp
                nullify(tmp)
            end if
            if (associated(p)) then
                if (present(found)) found = .true.    !everything seems to be ok
            else
                call throw_exception('Error in json_get_by_path:'//&
                                     ' variable not found: '//trim(path))
                if (present(found)) then
                    found = .false.
                    call json_clear_exceptions()
                end if
            end if
            
        end if

    else
        if (present(found)) found = .false.
    end if

    end subroutine json_get_by_path
!*****************************************************************************************

!*****************************************************************************************
!****f* json_module/string_to_integer
!
!  NAME
!    string_to_integer
!
!  DESCRIPTION
!    Convert a string into an integer.
!
!  NOTES
!    Replacement for the parse_integer function in the original code.
!
!  AUTHOR
!    Jacob Williams : 12/10/2013 : Rewrote routine.  Added error checking.
!
!  SOURCE

    function string_to_integer(str) result(ival)

    implicit none

    integer                     :: ival
    character(len=*),intent(in) :: str

    integer :: ierr

    if (.not. exception_thrown) then

        read(str,*,iostat=ierr) ival        !string to integer

        if (ierr/=0) then                   !if there was an error
            ival = 0
            call throw_exception('Error in string_to_integer:'//&
                                 ' string cannot be converted to an integer: '//trim(str))
        end if

    end if

    end function string_to_integer
!*****************************************************************************************

!*****************************************************************************************
!****f* json_module/string_to_double
!
!  NAME
!    string_to_double
!
!  DESCRIPTION
!    Convert a string into a double.
!
!  AUTHOR
!    Jacob Williams : 1/19/2014
!
!  SOURCE

    function string_to_double(str) result(rval)

    implicit none

    real(wp)                    :: rval
    character(len=*),intent(in) :: str

    integer :: ierr

    if (.not. exception_thrown) then

        read(str,fmt=real_fmt,iostat=ierr) rval    !string to double

        if (ierr/=0) then    !if there was an error
            rval = 0.0_wp
            call throw_exception('Error in string_to_double:'//&
                                 ' string cannot be converted to a double: '//trim(str))
        end if

    end if

    end function string_to_double
!*****************************************************************************************

!*****************************************************************************************
!****f* json_module/json_get_integer
!
!  NAME
!    json_get_integer
!
!  DESCRIPTION
!    Get an integer value from an json_value.
!
!  SOURCE

    subroutine json_get_integer(this, path, value, found)

    implicit none

    type(json_value),pointer,intent(in)  :: this
    character(len=*),optional            :: path
    integer,intent(out)                  :: value
    logical,intent(out),optional         :: found

    type(json_value), pointer :: p

    if (.not. exception_thrown) then

        nullify(p)
        if (present(path)) then
            call json_get_by_path(this=this, path=path, p=p)
        else
            p => this
        end if

        if (.not.associated(p)) then

            call throw_exception('Error in json_get_integer:'//&
                                 ' Unable to resolve path: '// trim(path))

        else

            !associate (d => p%data)
                select case(p%data%var_type)
                case (json_integer)
                    value = p%data%int_value
                case (json_real)
                    value = int(p%data%dbl_value)
                case (json_logical)
                    if (p%data%log_value) then
                        value = 1
                    else
                        value = 0
                    end if
                case default
                    call throw_exception('Error in get_integer:'//&
                                         ' Unable to resolve value to integer: '//&
                                         trim(path))
                end select
            !end associate

            nullify(p)

        end if

        if (exception_thrown) then
            if (present(found)) then
                found = .false.
                call json_clear_exceptions()
            end if
        else
            if (present(found)) found = .true.
        end if

    else

        value = 0
        if (present(found)) found = .false.

    end if

    end subroutine json_get_integer
!*****************************************************************************************

!*****************************************************************************************
!****f* json_module/json_get_integer_vec
!
!  NAME
!    json_get_integer_vec
!
!  DESCRIPTION
!    Get an integer vector from a JSON value.
!
!  AUTHOR
!    Jacob Williams : 5/14/2014
!
!  SOURCE

    subroutine json_get_integer_vec(me, path, vec, found)

    implicit none

    type(json_value), pointer                       :: me
    character(len=*),intent(in)                     :: path
    integer,dimension(:),allocatable,intent(out)    :: vec
    logical,intent(out),optional                    :: found

    logical :: initialized

    initialized = .false.

    if (allocated(vec)) deallocate(vec)

    !the callback function is called for each element of the array:
    call json_get(me, path=path, array_callback=get_int_from_array, found=found)

    contains

        ! callback function for integer
        subroutine get_int_from_array(element, i, count)
        implicit none

        type(json_value),pointer,intent(in)     :: element
        integer,intent(in)                      :: i        !index
        integer,intent(in)                      :: count    !size of array

        !size the output array:
        if (.not. initialized) then
            allocate(vec(count))
            initialized = .true.
        end if

        !populate the elements:
        call json_get(element, value=vec(i))

        end subroutine get_int_from_array

!*****************************************************************************************
    end subroutine json_get_integer_vec
!*****************************************************************************************

!*****************************************************************************************
!****f* json_module/json_get_double
!
!  NAME
!    json_get_double
!
!  DESCRIPTION
!    Get a double value from an json_value.
!
!  SOURCE

    subroutine json_get_double(this, path, value, found)

    implicit none

    type(json_value), pointer       :: this
    character(len=*), optional      :: path
    real(wp),intent(out)            :: value
    logical,intent(out),optional    :: found

    type(json_value), pointer :: p

    if (.not. exception_thrown) then

        nullify(p)

        if (present(path)) then
            call json_get_by_path(this=this, path=path, p=p)
        else
            p => this
        end if

        if (.not.associated(p)) then

            call throw_exception('Error in json_get_double:'//&
                                 ' Unable to resolve path: '//trim(path))

        else

            !associate (d => p%data)
                select case (p%data%var_type)
                case (json_integer)
                    value = p%data%int_value
                case (json_real)
                    value = p%data%dbl_value
                case (json_logical)
                    if (p%data%log_value) then
                        value = 1.0_wp
                    else
                        value = 0.0_wp
                    end if
                case default
                    call throw_exception('Error in json_get_double:'//&
                                         ' Unable to resolve value to double: '//&
                                         trim(path))
                end select
            !end associate

            nullify(p)

        end if

        if (exception_thrown) then
            if (present(found)) then
                found = .false.
                call json_clear_exceptions()
            end if
        else
            if (present(found)) found = .true.
        end if

    else

        value = 0.0_wp
        if (present(found)) found = .false.

    end if

    end subroutine json_get_double
!*****************************************************************************************

!*****************************************************************************************
!****f* json_module/json_get_double_vec
!
!  NAME
!    json_get_double_vec
!
!  DESCRIPTION
!    Get a double vector from a JSON value.
!
!  AUTHOR
!    Jacob Williams : 5/14/2014
!
!  SOURCE

    subroutine json_get_double_vec(me, path, vec, found)

    implicit none

    type(json_value), pointer                       :: me
    character(len=*),intent(in)                     :: path
    real(wp),dimension(:),allocatable,intent(out)    :: vec
    logical,intent(out),optional                    :: found

    logical :: initialized

    initialized = .false.

    if (allocated(vec)) deallocate(vec)

    !the callback function is called for each element of the array:
    call json_get(me, path=path, array_callback=get_double_from_array, found=found)

    contains

        ! callback function for double
        subroutine get_double_from_array(element, i, count)
        implicit none

        type(json_value),pointer,intent(in)     :: element
        integer,intent(in)                      :: i        !index
        integer,intent(in)                      :: count    !size of array

        !size the output array:
        if (.not. initialized) then
            allocate(vec(count))
            initialized = .true.
        end if

        !populate the elements:
        call json_get(element, value=vec(i))

        end subroutine get_double_from_array

    end subroutine json_get_double_vec
!*****************************************************************************************

!*****************************************************************************************
!****f* json_module/json_get_logical
!
!  NAME
!    json_get_logical
!
!  DESCRIPTION
!    Get a logical value from an json_value.
!
!  SOURCE

    subroutine json_get_logical(this, path, value, found)

    implicit none

    type(json_value),pointer,intent(in) :: this
    character(len=*),optional           :: path
    logical                             :: value
    logical,intent(out),optional        :: found

    type(json_value), pointer :: p

    if (.not. exception_thrown) then

        nullify(p)

        if (present(path)) then
            call json_get_by_path(this=this, path=path, p=p)
        else
            p => this
        end if

        if (.not.associated(p)) then

            call throw_exception('Error in json_get_logical:'//&
                                 ' Unable to resolve path: '//trim(path))

        else

            !associate (d => p%data)
                select case (p%data%var_type)
                case (json_integer)
                    value = (p%data%int_value > 0)
                case (json_logical)
                    value = p%data % log_value
                case default
                    call throw_exception('Error in json_get_logical:'//&
                                         ' Unable to resolve value to logical: '//&
                                         trim(path))
                end select
            !end associate

            nullify(p)

        end if

        if (exception_thrown) then
            if (present(found)) then
                found = .false.
                call json_clear_exceptions()
            end if
        else
            if (present(found)) found = .true.
        end if

    else

        value = .false.
        if (present(found)) found = .false.

    end if

    end subroutine json_get_logical
!*****************************************************************************************

!*****************************************************************************************
!****f* json_module/json_get_logical_vec
!
!  NAME
!    json_get_logical_vec
!
!  DESCRIPTION
!    Get a logical vector from a JSON value.
!
!  AUTHOR
!    Jacob Williams : 5/14/2014
!
!  SOURCE

    subroutine json_get_logical_vec(me, path, vec, found)

    implicit none

    type(json_value),pointer,intent(in)            :: me
    character(len=*),intent(in)                    :: path
    logical,dimension(:),allocatable,intent(out)   :: vec
    logical,intent(out),optional                   :: found

    logical :: initialized

    initialized = .false.

    if (allocated(vec)) deallocate(vec)

    !the callback function is called for each element of the array:
    call json_get(me, path=path, array_callback=get_logical_from_array, found=found)

    contains

        ! callback function for logical
        subroutine get_logical_from_array(element, i, count)
        implicit none

        type(json_value),pointer,intent(in)  :: element
        integer,intent(in)                   :: i        !index
        integer,intent(in)                   :: count    !size of array

        !size the output array:
        if (.not. initialized) then
            allocate(vec(count))
            initialized = .true.
        end if

        !populate the elements:
        call json_get(element, value=vec(i))

        end subroutine get_logical_from_array

    end subroutine json_get_logical_vec
!*****************************************************************************************

!*****************************************************************************************
!****f* json_module/json_get_chars
!
!  NAME
!    json_get_chars
!
!  DESCRIPTION
!    Get a character string from a json_value.
!
!  SOURCE

    subroutine json_get_chars(this, path, value, found)

    implicit none

    type(json_value),pointer,intent(in)         :: this
    character(len=*),intent(in),optional        :: path
    character(len=:),allocatable,intent(out)    :: value
    logical,intent(out),optional                :: found

    type(json_value), pointer :: p
    character(len=:),allocatable :: s,pre,post
    integer :: j,jprev,n
    character(len=1) :: c

    if (.not. exception_thrown) then

        nullify(p)

        if (present(path)) then
            call json_get_by_path(this=this, path=path, p=p)
        else
            p => this
        end if

        if (.not.associated(p)) then

            call throw_exception('Error in json_get_chars:'//&
                                 ' Unable to resolve path: '//trim(path))

        else

            !associate (d => p%data)
                select case (p%data%var_type)
                case (json_string)
                    if (allocated(p%data%str_value)) then

                        !get the value as is:
                        s = p%data%str_value

                        ! Now, have to remove the escape characters:
                        !
                        ! '\"'        quotation mark
                        ! '\\'        reverse solidus
                        ! '\/'        solidus
                        ! '\b'        backspace
                        ! '\f'        formfeed
                        ! '\n'        newline (LF)
                        ! '\r'        carriage return (CR)
                        ! '\t'        horizontal tab
                        ! '\uXXXX'    4 hexadecimal digits
                        !

                        !initialize:
                        n = len(s)
                        j = 1

                        do

                            jprev = j                      !initialize
                            j = index(s(j:n),backslash)    !look for an escape character

                            if (j>0) then            !an escape character was found
                            
                                !index in full string of the escape character:
                                j = j + (jprev-1)   

                                if (j<n) then

                                    !save the bit before the escape character:
                                    if (j>1) then
                                        pre = s( 1 : j-1 )
                                    else
                                        pre = ''
                                    end if

                                    !character after the escape character:
                                    c = s( j+1 : j+1 )

                                    select case (c)
                                    case(quotation_mark,backslash,slash,&
                                         'b','f','n','r','t')

                                        !save the bit after the escape characters:
                                        if (j+2<n) then
                                            post = s(j+2:n)
                                        else
                                            post = ''
                                        end if

                                        select case(c)
                                        case(quotation_mark,backslash,slash)
                                            !use c as is
                                        case('b')
                                            c = bspace
                                        case('f')
                                            c = formfeed
                                        case('n')
                                            c = newline
                                        case('r')
                                            c = carriage_return
                                        case('t')
                                            c = horizontal_tab
                                        end select

                                        s = pre//c//post

                                        n = n-1    !backslash character has been 
                                                   ! removed from the string

                                    case('u')    !expecting 4 hexadecimal digits after 
                                                 ! the escape character    [\uXXXX]

                                        !for now, we are just printing them as is
                                        ![not checking to see if it is a valid hex value]

                                        if (j+5<=n) then
                                            j=j+4
                                        else
                                            call throw_exception(&
                                                'Error in json_get_chars:'//&
                                                ' Invalid hexadecimal sequence'//&
                                                ' in string: '//trim(c))
                                            exit
                                        end if

                                    case default
                                        !unknown escape character
                                        call throw_exception('Error in json_get_chars:'//&
                                                ' unknown escape sequence in string "'//&
                                                trim(s)//'" ['//backslash//c//']')
                                        exit
                                    end select

                                    j=j+1    !go to the next character

                                    if (j>=n) exit    !finished

                                else
                                    !an escape character is the last character in 
                                    ! the string [this may not be valid syntax, 
                                    ! but just keep it]
                                    exit
                                end if

                            else
                                exit    !no more escape characters in the string
                            end if

                        end do

                        if (exception_thrown) then
                            if (allocated(value)) deallocate(value)
                        else
                            value = s
                        end if

                    else
                        call throw_exception('Error in json_get_chars:'//&
                                             ' p%data%value not allocated')
                    end if

                !class default
                case default

                    call throw_exception('Error in json_get_chars:'//&
                                         ' Unable to resolve value to characters: '//&
                                         trim(path))

                    ! Note: for the other cases, we could do val to string conversions.

                end select
            !end associate

        end if

        if (allocated(value) .and. .not. exception_thrown) then
            if (present(found)) found = .true.
        else
            if (present(found)) then
                found = .false.
                call json_clear_exceptions()
            end if
        end if

        !cleanup:
        if (associated(p)) nullify(p)
        if (allocated(s)) deallocate(s)
        if (allocated(pre)) deallocate(pre)
        if (allocated(post)) deallocate(post)

    else

        value = ''
        found = .false.

    end if

    end subroutine json_get_chars
!*****************************************************************************************

!*****************************************************************************************
!****f* json_module/json_get_char_vec
!
!  NAME
!    json_get_char_vec
!
!  DESCRIPTION
!    Get a char vector from a JSON file.
!
!  AUTHOR
!    Jacob Williams : 5/14/2014
!
!  SOURCE

    subroutine json_get_char_vec(me, path, vec, found)

    implicit none

    type(json_value),pointer,intent(in)                    :: me
    character(len=*),intent(in)                            :: path
    character(len=*),dimension(:),allocatable,intent(out)  :: vec
    logical,intent(out),optional                           :: found

    logical :: initialized

    initialized = .false.

    if (allocated(vec)) deallocate(vec)

    !the callback function is called for each element of the array:
    call json_get(me, path=path, array_callback=get_chars_from_array, found=found)

    contains

        ! callback function for chars
        subroutine get_chars_from_array(element, i, count)
        
        implicit none

        type(json_value),pointer,intent(in)  :: element
        integer,intent(in)                   :: i        !index
        integer,intent(in)                   :: count    !size of array

        character(len=:),allocatable :: cval

        !size the output array:
        if (.not. initialized) then
            allocate(vec(count))
            initialized = .true.
        end if

        !populate the elements:
        call json_get(element, value=cval)
        if (allocated(cval)) then
            vec(i) = cval
            deallocate(cval)
        else
            vec(i) = ''
        end if

        end subroutine get_chars_from_array

    end subroutine json_get_char_vec
!*****************************************************************************************

!*****************************************************************************************
!****f* json_module/json_get_array
!
!  NAME
!    json_get_array
!
!  DESCRIPTION
!    Get an array from an json_value.
!    This routine calls the user-supplied array_callback subroutine
!        for each element in the array.
!
!  SOURCE

    subroutine json_get_array(this, path, array_callback, found)

    implicit none

    type(json_value),pointer,intent(in)  :: this
    character(len=*),intent(in),optional :: path
    procedure(array_callback_func)       :: array_callback
    logical,intent(out),optional         :: found

    type(json_value), pointer :: element,p
    integer :: i, count

    if (.not. exception_thrown) then

        nullify(p)

        ! resolve the path to the value
        if (present(path)) then
            call json_get_by_path(this=this, path=path, p=p)
        else
            p => this
        end if

        if (.not.associated(p)) then

            call throw_exception('Error in json_get_array:'//&
                                 ' Unable to resolve path: '//trim(path))

        else

            !associate (d => p%data)
                select case (p%data%var_type)
                case (json_array)
                    count = json_value_count(p)
                    do i = 1, count
                        call json_value_get(p, i, element)
                        call array_callback(element, i, count)
                    end do
                case default
                    call throw_exception('Error in json_get_array:'//&
                                         ' Resolved value is not an array. '//trim(path))
                end select
            !end associate

            !cleanup:
            if (associated(p))       nullify(p)
            if (associated(element)) nullify(element)

        end if

        if (exception_thrown) then
            if (present(found)) then
                found = .false.
                call json_clear_exceptions()
            end if
        else
            if (present(found)) found = .true.
        end if

    else
        if (present(found)) found = .false.
    end if

    end subroutine json_get_array
!*****************************************************************************************

!*****************************************************************************************
!****f* json_module/json_parse
!
!  NAME
!    json_parse
!
!  DESCRIPTION
!    Parse the JSON file and populate the json_value tree.
!
!  NOTES
!    When calling this routine, any exceptions thrown from previous
!        calls will automatically be cleared.
!
!  SOURCE
 
    subroutine json_parse(file, p, unit)

    implicit none

    character(len=*),intent(in) :: file
    type(json_value),pointer    :: p
    integer,intent(in),optional :: unit

    integer :: iunit, istat
    character(len=:),allocatable :: line, arrow_str
    character(len=10) :: line_str, char_str
    logical :: is_open

    !clean any exceptions and initialize:
    call json_initialize()

    if (present(unit)) then
        
        iunit = unit   
        
        !check to see if the file is already open
        ! if it is, then use it, otherwise open the file.
        inquire(unit=iunit, opened=is_open, iostat=istat)
        if (istat==0 .and. .not. is_open) then
           ! open the file
            open (  unit        = iunit, &
                    file        = file, &
                    status      = 'OLD', &
                    action      = 'READ', &
                    form        = 'FORMATTED', &
                    position    = 'REWIND', &
                    iostat      = istat)
        end if
        
    else
    
        ! open the file with a new unit number:
        open (  newunit     = iunit, &
                file        = file, &
                status      = 'OLD', &
                action      = 'READ', &
                form        = 'FORMATTED', &
                position    = 'REWIND', &
                iostat      = istat)
    
    end if

    if (istat==0) then

        ! create the value and associate the pointer
        call json_value_create(p)

        !add the file name as the name of the overall structure:
        p%name = trim(file)

        ! parse as a value
        call parse_value(unit = iunit, value = p)

        !
        !  If there was an error reading the file, then
        !   can print the line where the error occurred:
        !
        if (exception_thrown) then
        
            call get_current_line_from_file(iunit,line)
            
            !the counters for the current line and the last character read:
            call integer_to_string(line_count, line_str)
            call integer_to_string(char_count, char_str)
            
            !draw the arrow string that points to the current character:
            arrow_str = repeat('-',max( 0, char_count - 1) )//'^'

            !create the error message:
            err_message = err_message//newline//&
                           'line: '//trim(adjustl(line_str))//', '//&
                           'character: '//trim(adjustl(char_str))//newline//&
                           trim(line)//newline//arrow_str
                                        
            if (allocated(line)) deallocate(line)
                        
        end if

        ! close the file
        close (iunit, iostat=istat)

    else

        call throw_exception('Error in json_parse: Error opening file: '//trim(file))

    end if

    end subroutine json_parse
!*****************************************************************************************

!*****************************************************************************************
!****f* json_module/get_current_line_from_file
!
!  NAME
!    get_current_line_from_file
!
!  DESCRIPTION
!    Rewind the file to the beginning of the current line, and return this line.
!    The file is assumed to be opened.
!
!  AUTHOR
!    Jacob Williams
!
!  SOURCE

    subroutine get_current_line_from_file(iunit,line)
    
    implicit none
    
    integer,intent(in)    :: iunit
    character(len=:),allocatable,intent(out)    :: line
    
    integer,parameter           :: n_chunk = 256      !chunk size [arbitrary]
    character(len=*),parameter  :: nfmt = '(A256)'    !corresponding format statement
    
    character(len=n_chunk) :: chunk
    integer :: istat,isize
    
    !initialize:
    line = ''

    !rewind to beginning of the current record:
    backspace(iunit, iostat=istat)

    !loop to read in all the characters in the current record.
    ![the line is read in chunks until the end of the line is reached]
    if (istat==0) then
        do
            read(iunit,fmt=nfmt,advance='NO',size=isize,iostat=istat) chunk
            if (istat==0) then            
                line = line//chunk
            else
                if (isize>0) line = line//chunk(1:isize)
                exit
            end if
        end do
    end if
    
    end subroutine get_current_line_from_file
!*****************************************************************************************
    
!*****************************************************************************************
!****f* json_module/parse_value
!
!  NAME
!    parse_value
!
!  DESCRIPTION
!
!
!  SOURCE

    recursive subroutine parse_value(unit, value)

    implicit none

    integer, intent(in)       :: unit
    type(json_value), pointer :: value

    logical :: eof
    character(len=1) :: c
    character(len=:),allocatable :: tmp  !this is a work-around for a bug 
                                         !  in the gfortran 4.9 compiler.

    if (.not. exception_thrown) then

        !the routine is being called incorrectly.
        if (.not. associated(value)) then
            call throw_exception('Error in parse_value: value pointer not associated.')
        end if

        ! pop the next non whitespace character off the file
        c = pop_char(unit, eof = eof, skip_ws = .true.)

        if (eof) then
            return
        else
            select case (c)
            case ('{')

                ! start object
                call to_object(value)    !allocate class
                call parse_object(unit, value)

            case ('[')

                ! start array
                call to_array(value)    !allocate class
                call parse_array(unit, value)

            case (']')

                ! end an empty array
                call push_char(c)
                nullify(value)

            case ('"')

                ! string
                call to_string(value)    !allocate class

                 !associate (d => value%data)
                    !select type (value%data)
                    select case (value%data%var_type)
                    !type is (json_string)
                    case (json_string)
                        call parse_string(unit, tmp)  !write to a tmp variable because of
                        value%data%str_value = tmp    ! a bug in 4.9 gfortran compiler.
                        deallocate(tmp)
                    end select
                !end associate

            case ('t')

                !true
                call parse_for_chars(unit, 'rue')
                !allocate class and set value:
                if (.not. exception_thrown) call to_logical(value,.true.)    

            case ('f')

                !false
                call parse_for_chars(unit, 'alse')
                !allocate class and set value:
                if (.not. exception_thrown) call to_logical(value,.false.)

            case ('n')

                call parse_for_chars(unit, 'ull')
                if (.not. exception_thrown) call to_null(value)    !allocate class

            case('-', '0': '9')

                call push_char(c)
                call parse_number(unit, value)

            case default

                call throw_exception('Error in parse_value:'//&
                                     ' Unexpected character while parsing value. "'//&
                                     c//'"')

            end select
        end if

    end if

    end subroutine parse_value
!*****************************************************************************************

!*****************************************************************************************
!****f* json_module/to_logical
!
!  NAME
!    to_logical
!
!  DESCRIPTION
!    Change the variable to a logical.
!
!  AUTHOR
!    Jacob Williams
!
!  SOURCE

    subroutine to_logical(me,val,name)

    implicit none

    type(json_value), intent(inout)        :: me
    character(len=*),intent(in),optional   :: name
    logical,intent(in),optional            :: val

    !set type and value:
    !associate (d => me%data)
        call me%data%destroy()
        me%data%var_type = json_logical
        allocate(me%data%log_value)
        if (present(val)) then
            me%data%log_value = val
        else
            me%data%log_value = .false.    !default value
        end if
    !end associate

    !name:
    if (present(name)) me%name = trim(name)

    end subroutine to_logical
!*****************************************************************************************

!*****************************************************************************************
!****f* json_module/to_integer
!
!  NAME
!    to_integer
!
!  DESCRIPTION
!    Change the variable to an integer.
!
!  AUTHOR
!    Jacob Williams
!
!  SOURCE

    subroutine to_integer(me,val,name)

    implicit none

    type(json_value), intent(inout)        :: me
    character(len=*),intent(in),optional   :: name
    integer,intent(in),optional            :: val

    !set type and value:
    !associate (d => me%data)
        call me%data%destroy()
        me%data%var_type = json_integer
        allocate(me%data%int_value)
        if (present(val)) then
            me%data%int_value = val
        else
            me%data%int_value = 0    !default value
        end if
    !end associate

    !name:
    if (present(name)) me%name = trim(name)

    end subroutine to_integer
!*****************************************************************************************

!*****************************************************************************************
!****f* json_module/to_real
!
!  NAME
!    to_real
!
!  DESCRIPTION
!    Change the variable to a double.
!
!  AUTHOR
!    Jacob Williams
!
!  SOURCE

    subroutine to_real(me,val,name)

    implicit none

    type(json_value), intent(inout)        :: me
    character(len=*),intent(in),optional   :: name
    real(wp),intent(in),optional           :: val

    !set type and value:
    !associate (d => me%data)
        call me%data%destroy()
        me%data%var_type = json_real
        allocate(me%data%dbl_value)
        if (present(val)) then
            me%data%dbl_value = val
        else
            me%data%dbl_value = 0.0_wp    !default value
        end if
    !end associate

    !name:
    if (present(name)) me%name = trim(name)

    end subroutine to_real
!*****************************************************************************************

!*****************************************************************************************
!****f* json_module/to_string
!
!  NAME
!    to_string
!
!  DESCRIPTION
!    Change the variable to a string.
!
!  AUTHOR
!    Jacob Williams
!
!  SOURCE

    subroutine to_string(me,val,name)

    implicit none

    type(json_value), intent(inout)        :: me
    character(len=*),intent(in),optional   :: name
    character(len=*),intent(in),optional   :: val

    !set type and value:
    !associate (d => me%data)
        call me%data%destroy()
        me%data%var_type = json_string
        if (present(val)) then
            me%data%str_value = val
        else
            me%data%str_value = ''    !default value
        end if
    !end associate

    !name:
    if (present(name)) me%name = trim(name)

    end subroutine to_string
!*****************************************************************************************

!*****************************************************************************************
!****f* json_module/to_null
!
!  NAME
!    to_null
!
!  DESCRIPTION
!    Change the variable to a null.
!
!  AUTHOR
!    Jacob Williams
!
!  SOURCE

    subroutine to_null(me,name)

    implicit none

    type(json_value), intent(inout)        :: me
    character(len=*),intent(in),optional   :: name

    !set type and value:
    !associate (d => me%data)
        call me%data%destroy()
        me%data%var_type = json_null
    !end associate

    !name:
    if (present(name)) me%name = trim(name)

    end subroutine to_null
!*****************************************************************************************

!*****************************************************************************************
!****f* json_module/to_object
!
!  NAME
!    to_object
!
!  DESCRIPTION
!    Change the variable to an object.
!
!  AUTHOR
!    Jacob Williams
!
!  SOURCE

    subroutine to_object(me,name)

    implicit none

    type(json_value), intent(inout)        :: me
    character(len=*),intent(in),optional   :: name

    !set type and value:
    !associate (d => me%data)
        call me%data%destroy()
        me%data%var_type = json_object
    !end associate

    !name:
    if (present(name)) me%name = trim(name)

    end subroutine to_object
!*****************************************************************************************

!*****************************************************************************************
!****f* json_module/to_array
!
!  NAME
!    to_array
!
!  DESCRIPTION
!    Change the variable to an array.
!
!  AUTHOR
!    Jacob Williams
!
!  SOURCE

    subroutine to_array(me,name)

    implicit none

    type(json_value), intent(inout)        :: me
    character(len=*),intent(in),optional   :: name

    !set type and value:
    !associate (d => me%data)
        call me%data%destroy()
        me%data%var_type = json_array
    !end associate

    !name:
    if (present(name)) me%name = trim(name)

    end subroutine to_array
!*****************************************************************************************

!*****************************************************************************************
!****f* json_module/parse_object
!
!  NAME
!    parse_object
!
!  DESCRIPTION
!
!
!  SOURCE

    recursive subroutine parse_object(unit, parent)

    implicit none

    integer, intent(in)       :: unit
    type(json_value), pointer :: parent

    type(json_value), pointer :: pair
    logical :: eof
    character(len=1) :: c
    character(len=:),allocatable :: tmp  !this is a work-around for a bug 
                                         !  in the gfortran 4.9 compiler.

    if (.not. exception_thrown) then

        !the routine is being called incorrectly.
        if (.not. associated(parent)) then
            call throw_exception('Error in parse_object: parent pointer not associated.')
        end if

        nullify(pair)    !probably not necessary

        ! pair name
        c = pop_char(unit, eof = eof, skip_ws = .true.)
        if (eof) then
            call throw_exception('Error in parse_object:'//&
                                 ' Unexpected end of file while parsing start of object.')
            call cleanup()
            return
        else if ('}' == c) then
            ! end of an empty object
            call cleanup()
            return
        else if ('"' == c) then
            call json_value_create(pair)
            call parse_string(unit, tmp)   !write to a tmp variable because of
            pair % name = tmp              ! a bug in 4.9 gfortran compiler.
            deallocate(tmp)
            if (exception_thrown) return
        else
            call throw_exception('Error in parse_object: Expecting string: "'//c//'"')
            call cleanup()
            return
        end if

        ! pair value
        c = pop_char(unit, eof = eof, skip_ws = .true.)
        if (eof) then
            call throw_exception('Error in parse_object:'//&
                                 ' Unexpected end of file while parsing object member.')
            call cleanup()
            return
        else if (':' == c) then
            ! parse the value
            call parse_value(unit, pair)
            if (exception_thrown) return
            call json_value_add(parent, pair)
        else
            call throw_exception('Error in parse_object:'//&
                                 ' Expecting : and then a value: '//c)
            call cleanup()
            return
        end if

        ! another possible pair
        c = pop_char(unit, eof = eof, skip_ws = .true.)
        if (eof) then
            call cleanup()
            return
        else if (',' == c) then
            ! read the next member
            call parse_object(unit = unit, parent = parent)
        else if ('}' == c) then
            call cleanup()
            return
        else
            call throw_exception('Error in parse_object: Expecting end of object: '//c)
            call cleanup()
            return
        end if

        call cleanup()

    end if

    contains

        !cleanup routine:
        subroutine cleanup()
        
        implicit none

        if (associated(pair)) nullify(pair)

        end subroutine cleanup

    end subroutine parse_object
!*****************************************************************************************

!*****************************************************************************************
!****if* json_module/parse_array
!
!  NAME
!    parse_array
!
!  DESCRIPTION
!
!
!  SOURCE

    recursive subroutine parse_array(unit, array)

    implicit none

    integer, intent(in)       :: unit
    type(json_value), pointer :: array

    type(json_value), pointer :: element
    logical :: eof
    character(len=1) :: c

    if (.not. exception_thrown) then
        nullify(element)

        ! try to parse an element value
        call json_value_create(element)
        call parse_value(unit, element)
        if (exception_thrown) return

        ! parse value will disassociate an empty array value
        if (associated(element)) then
            call json_value_add(array, element)
            nullify(element)    !cleanup
        end if

        ! popped the next character
        c = pop_char(unit, eof = eof, skip_ws = .true.)

        if (eof) then
            return
        else if (',' == c) then
            ! parse the next element
            call parse_array(unit, array)
            if (exception_thrown) return
        else if (']' == c) then
            ! end of array
            return
        end if

    end if

    end subroutine parse_array
!*****************************************************************************************

!*****************************************************************************************
!****if* json_module/parse_string
!
!  NAME
!    parse_string
!
!  DESCRIPTION
!    Parses a string while reading a json file
!
!  HISTORY
!    JW : 6/16/2014 : added hex validation.
!
!  SOURCE

    subroutine parse_string(unit, string)

    implicit none

    integer, intent(in)                      :: unit
    character(len=:),allocatable,intent(out) :: string

    logical :: eof, is_hex, escape
    character(len=1) :: c, last
    character(len=4) :: hex
    integer :: i
    
    !at least return a blank string if there is a problem:
    string = '' 

    if (.not. exception_thrown) then

        !initialize:
        last = space
        is_hex = .false.
        escape = .false.
        i = 0
        
        do
        
            !get the next character from the file:
            c = pop_char(unit, eof = eof, skip_ws = .false.)
        
            if (eof) then
            
                call throw_exception('Error in parse_string: Expecting end of string')
                return
                
            else if ('"' == c .and. last /= backslash) then
            
                if (is_hex) call throw_exception('Error in parse_string:'//&
                                                 ' incomplete hex string: \u'//trim(hex))
                exit
                    
            else
            
                !append to string:
                string = string//c    
                
                !hex validation:
                if (is_hex) then  !accumulate the four characters after '\u'
                    
                    i=i+1
                    hex(i:i) = c
                    if (i==4) then
                        if (valid_json_hex(hex)) then
                            i = 0
                            hex = ''
                            is_hex = .false.                            
                        else
                            call throw_exception('Error in parse_string:'//&
                                                 ' invalid hex string: \u'//trim(hex))
                            exit
                        end if
                    end if
                    
                else
                    
                    !when the '\u' string is encountered, then
                    !  start accumulating the hex string (should be the next 4 characters)
                    if (escape) then
                        escape = .false.
                        is_hex = (c=='u')    !the next four characters are the hex string
                    else
                        escape = (c==backslash)
                    end if
                    
                end if
                
                !update for next char:
                last = c
                
            end if
            
        end do

    end if

    end subroutine parse_string
!*****************************************************************************************

!*****************************************************************************************
!****if* json_module/parse_for_chars
!
!  NAME
!    parse_for_chars
!
!  DESCRIPTION
!
!
!  SOURCE

    subroutine parse_for_chars(unit, chars)

    implicit none

    integer, intent(in)            :: unit
    character(len = *), intent(in) :: chars

    integer :: i, length
    logical :: eof
    character(len=1) :: c

    if (.not. exception_thrown) then

        length = len_trim(chars)

        do i = 1, length
            c = pop_char(unit, eof = eof, skip_ws = .true.)
            if (eof) then
                call throw_exception('Error in parse_for_chars:'//&
                                     ' Unexpected end of file while parsing array.')
                return
            else if (c /= chars(i:i)) then
                call throw_exception('Error in parse_for_chars:'//&
                                     ' Unexpected character.: "'//c//'" '//chars(i:i))
                return
            end if
        end do

    end if

    end subroutine parse_for_chars
!*****************************************************************************************

!*****************************************************************************************
!****if* json_module/parse_number
!
!  NAME
!
!  DESCRIPTION
!    Read a numerical value from the file.
!    The routine will determine if it is an integer or a double, and
!    allocate the type accordingly.
!
!  NOTES
!    Complete rewrite of the original FSON routine, which had some problems.
!
!  AUTHOR
!    Jacob Williams : 1/20/2014
!
!  SOURCE

    subroutine parse_number(unit, value)

    implicit none

    integer, intent(in)       :: unit
    type(json_value), pointer :: value

    character(len=:),allocatable :: str
    character(len=1) :: c
    logical :: eof
    real(wp) :: rval
    integer :: ival
    logical :: first
    logical :: is_integer

    if (.not. exception_thrown) then

        str = ''
        first = .true.
        is_integer = .true.    !assume it may be an integer,unless otherwise determined

        !read one character at a time and accumulate the string:
        do

            !get the next character:
            c = pop_char(unit, eof = eof, skip_ws = .true.)

            if (eof) then
                call throw_exception('Error in parse_number:'//&
                                     ' Unexpected end of file while parsing number.')
                return
            else

                select case (c)
                case('-','+')    !note: allowing a '+' as the first character here.

                    if (is_integer .and. (.not. first)) is_integer = .false.

                    !add it to the string:
                    str = str // c

                case('.','E','e')    !can be present in real numbers

                    if (is_integer) is_integer = .false.

                    !add it to the string:
                    str = str // c

                case('0':'9')    !valid characters for numbers

                    !add it to the string:
                    str = str // c

                case default

                    !push back the last character read:
                    call push_char(c)

                    !string to value:
                    if (is_integer) then
                        ival = string_to_integer(str)
                        call to_integer(value,ival)
                    else
                        rval = string_to_double(str)
                        call to_real(value,rval)
                    end if

                    exit    !finished

                end select

            end if
            if (first) first = .false.

        end do

        !cleanup:
        if (allocated(str)) deallocate(str)

    end if

    end subroutine parse_number
!*****************************************************************************************

!*****************************************************************************************
!****if* json_module/pop_char
!
!  NAME
!    pop_char
!
!  DESCRIPTION
!    Get the next character from the file.
!
!  NOTES
!    This routine ignores non-printing ascii characters (iachar<=31) that
!    are in strings.
!
!  SOURCE

    recursive function pop_char(unit, eof, skip_ws) result(popped)
    
    implicit none

    character(len=1)              :: popped
    integer, intent(in)           :: unit
    logical, intent(out)          :: eof
    logical, intent(in), optional :: skip_ws

    integer :: ios
    character(len=1) :: c
    logical :: ignore

    if (.not. exception_thrown) then

        eof = .false.
        if (.not.present(skip_ws)) then
            ignore = .false.
        else
            ignore = skip_ws
        end if

        do

            if (pushed_index > 0) then

                ! there is a character pushed back on, most likely from the number parsing
                c = pushed_char(pushed_index:pushed_index)
                pushed_index = pushed_index - 1

            else

                read (unit = unit, fmt = '(A)', advance = 'NO', iostat = ios) c
                char_count = char_count + 1    !character count in the current line

                if (IS_IOSTAT_EOR(ios)) then            !JW : use intrinsic

                    char_count = 0
                    line_count = line_count + 1
                    cycle

                else if (IS_IOSTAT_END(ios)) then        !JW : use intrinsic

                    char_count = 0
                    eof = .true.
                    exit

                end if

            end if

            if (iachar(c) <= 31) then         !JW : fixed so it will read spaces 
                                              !      in the string (was 32)

                ! non printing ascii characters
                cycle

            else if (ignore .and. c == space) then

                cycle

            else

                popped = c
                exit

            end if

        end do

    end if

    end function pop_char
!*****************************************************************************************

!*****************************************************************************************
!****if* json_module/push_char
!
!  NAME
!    push_char
!
!  DESCRIPTION
!
!
!  SOURCE

    subroutine push_char(c)
    
    implicit none

    character(len=1), intent(in) :: c

    character(len=32) :: istr

    if (.not. exception_thrown) then

        pushed_index = pushed_index + 1

        if (pushed_index>0 .and. pushed_index<=len(pushed_char)) then
            pushed_char(pushed_index:pushed_index) = c
        else
            call integer_to_string(pushed_index,istr)
            call throw_exception('Error in push_char:'//&
                                 ' invalid valid of pushed_index: '//trim(istr))
        end if

    end if

    end subroutine push_char
!*****************************************************************************************

!*****************************************************************************************
!****f* json_module/integer_to_string
!
!  NAME
!    integer_to_string
!
!  DESCRIPTION
!    Convert an integer to a string.
!
!  AUTHOR
!    Jacob Williams : 12/4/2013
!
!  SOURCE

    subroutine integer_to_string(ival,str)

    implicit none

    integer,intent(in)           :: ival
    character(len=*),intent(out) :: str

    integer :: istat

    write(str,fmt=int_fmt,iostat=istat) ival

    if (istat==0) then
        str = adjustl(str)
    else
        str = repeat('*',len(str))
    end if

    end subroutine integer_to_string
!*****************************************************************************************

!*****************************************************************************************
!****if* json_module/real_to_string
!
!  NAME
!    real_to_string
!
!  DESCRIPTION
!    Convert a real value to a string.
!
!  AUTHOR
!    Jacob Williams : 12/4/2013
!
!  SOURCE

    subroutine real_to_string(rval,str)

    implicit none

    real(wp),intent(in)          :: rval
    character(len=*),intent(out) :: str

    integer :: istat

    write(str,fmt=real_fmt,iostat=istat) rval

    if (istat==0) then
        str = adjustl(str)
    else
        str = repeat('*',len(str))
    end if

    end subroutine real_to_string
!*****************************************************************************************

!*****************************************************************************************
!****if* json_module/valid_json_hex
!
!  NAME
!    valid_json_hex
!
!  DESCRIPTION
!    Returns true if the string is a valid 4-digit hex string.
!
!  EXAMPLE
!    valid_json_hex('0000')  !returns true
!    valid_json_hex('ABC4')  !returns true    
!    valid_json_hex('AB')    !returns false (< 4 characters)
!    valid_json_hex('WXYZ')  !returns false (invalid characters)
!
!  AUTHOR
!    Jacob Williams : 6/14/2014
!
!  SOURCE

    function valid_json_hex(str) result(valid)

    implicit none

    character(len=*),intent(in) :: str
    logical :: valid
    
    integer :: n,i
    
    !an array of the valid hex characters:
    character(len=1),dimension(16),parameter :: valid_chars = &
        ['0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F']

    !initialize
    valid = .false.   
    
    !check all the characters in the string:
    n = len(str)
    if (n==4) then
        do i=1,n
            if (.not. any(str(i:i)==valid_chars)) return
        end do
        valid = .true.    !all are in the set, so it is OK
    end if

    end function valid_json_hex
!*****************************************************************************************
    
!*****************************************************************************************
    end module json_module
!*****************************************************************************************

      function itoken (word,flname)
c     chars in word assumed upper case, left justified
c     returns 0 if not a token, otherwise returns token

      character*(*) word
      character*4   w
      character*20 flname
      integer itoken

      itoken = 0
      w = word(1:4)
      call upper(w)
      
c     Tokens for feff.inp
cccccccccccccccccccccccccccccccccccccccccccccccccccccc
      if (flname(1:8).eq.'feff.inp') then
         if     (w .eq. 'ATOM')  then
            itoken = 1
         elseif (w .eq. 'HOLE')  then
            itoken = 2
         elseif (w .eq. 'OVER')  then
            itoken = 3
         elseif (w .eq. 'CONT')  then
            itoken = 4
         elseif (w .eq. 'EXCH')  then
            itoken = 5
         elseif (w .eq. 'ION ')  then
            itoken = 6
         elseif (w .eq. 'TITL')  then
            itoken = 7
         elseif (w .eq. 'FOLP')  then
            itoken = 8
         elseif (w .eq. 'RPAT' .or. w .eq. 'RMAX')  then
            itoken = 9
         elseif (w .eq. 'DEBY')  then
            itoken = 10
         elseif (w .eq. 'RMUL')  then
            itoken = 11
         elseif (w .eq. 'SS  ')  then
            itoken = 12
         elseif (w .eq. 'PRIN')  then
            itoken = 13
         elseif (w .eq. 'POTE')  then
            itoken = 14
         elseif (w .eq. 'NLEG')  then
            itoken = 15
         elseif (w .eq. 'CRIT')  then
            itoken = 16
         elseif (w .eq. 'NOGE')  then
            itoken = 17
         elseif (w .eq. 'IORD')  then
            itoken = 18
         elseif (w .eq. 'PCRI')  then
            itoken = 19
         elseif (w .eq. 'SIG2')  then
            itoken = 20
         elseif (w .eq. 'XANE')  then
            itoken = 21
         elseif (w .eq. 'CORR')  then
            itoken = 22
         elseif (w .eq. 'AFOL')  then
            itoken = 23
         elseif (w .eq. 'EXAF')  then
            itoken = 24
         elseif (w .eq. 'POLA')  then
            itoken = 25
         elseif (w .eq. 'ELLI')  then
            itoken = 26
         elseif (w .eq. 'RGRI')  then
            itoken = 27
         elseif (w .eq. 'RPHA')  then
            itoken = 28
         elseif (w .eq. 'NSTA')  then
            itoken = 29
         elseif (w .eq. 'NOHO')  then
            itoken = 30
         elseif (w .eq. 'SIG3')  then
            itoken = 31
         elseif (w .eq. 'JUMP')  then
            itoken = 32
         elseif (w .eq. 'MBCO')  then
            itoken = 33
         elseif (w .eq. 'SPIN')  then
            itoken = 34
         elseif (w .eq. 'EDGE')  then
            itoken = 35
         elseif (w .eq. 'SCF ')  then
            itoken = 36
         elseif (w .eq. 'FMS ')  then
            itoken = 37
         elseif (w .eq. 'LDOS')  then
            itoken = 38
         elseif (w .eq. 'INTE')  then
            itoken = 39
         elseif (w .eq. 'CFAV')  then
            itoken = 40
         elseif (w .eq. 'S02 ')  then
            itoken = 41
         elseif (w .eq. 'XES ')  then
            itoken = 42
         elseif (w .eq. 'DANE')  then
            itoken = 43
         elseif (w .eq. 'FPRI')  then
            itoken = 44
         elseif (w .eq. 'RSIG')  then
            itoken = 45
         elseif (w .eq. 'XNCD')  then
            itoken = 46
         elseif (w .eq. 'XMCD')  then
            itoken = 46
         elseif (w .eq. 'MULT')  then
            itoken = 47
         elseif (w .eq. 'UNFR')  then
            itoken = 48
         elseif (w .eq. 'TDLD')  then
            itoken = 49
         elseif (w .eq. 'PMBS')  then
            itoken = 50
         elseif (w .eq. 'PLAS')  then
            itoken = 51
         elseif (w .eq. 'SO2C')  then
            itoken = 52
         elseif (w .eq. 'SELF')  then
            itoken = 53
         elseif (w .eq. 'SFSE')  then
            itoken = 54
         elseif (w .eq. 'RCONV') then
            itoken = 55
         elseif (w .eq. 'ELNE') then !KJ new card for EELS 1-06
            itoken = 56
         elseif (w .eq. 'EXEL') then !KJ new card for EELS 1-06
            itoken = 57
         elseif (w .eq. 'MAGI') then !KJ new card for EELS 1-06
            itoken = 58
         elseif (w .eq. 'ABSO') then !KJ new card 3-06
            itoken = 59    
         elseif (w .eq. 'EGRI')  then !Josh Kas
            itoken = 60
         elseif (w .eq. 'END ')  then
            itoken = -1            
         else
            itoken = 0
         endif
      elseif (flname(1:10).eq.'spring.inp') then
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     These tokens are for spring.inp (input for eq of motion method)
         if (w .eq. 'STRE')  then
            itoken = 1
         elseif (w .eq. 'ANGL')  then
            itoken = 2
         elseif (w .eq. 'VDOS')  then
            itoken = 3
         elseif (w .eq. 'PRDOS') then
            itoken = 4
         elseif (w .eq. 'END ')  then
            itoken = -1            
         else
            itoken = 0
         endif
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      endif
      return
      end

      subroutine read_xsect(ntit, titles, s02x, erelax, wpx, edge,
     1                      emu, gamma, ne, ne1, ik0,
     2                      er, ei, xsn, col4, col5)

      use json_module
      implicit double precision (a-h, o-z)

      include '../HEADERS/const.h'
      include '../HEADERS/dim.h'

      logical :: found
      type(json_file) :: json   !the JSON structure read from the file:
      double precision,dimension(:),allocatable :: dbpc1, dbpc2, dbpc3
      double precision,dimension(:),allocatable :: dbpc4, dbpc5
      character*80,dimension(:),allocatable :: strings


      character*80 titles(nheadx)
      double precision er(nex), ei(nex), xsn(nex)
      double precision col4(nex), col5(nex)

      call json%load_file('xsect.json')
      if (json_failed()) then   !if there was an error reading the file
         print *, "failed to read xsect.json"
         stop
      else
         call json%get('ntitle', ntit, found)
                   if (.not. found) call bailout('s02',   'xsect.json')
         call json%get('title',   strings, found)
                   if (.not. found) call bailout('title', 'xsect.json')
         do 10 i=1,ntit
            titles(i) = strings(i)
 10      continue
         

         call json%get('s02',    s02x, found)
                   if (.not. found) call bailout('s02',    'xsect.json')
         call json%get('erelax', erelax, found)
                   if (.not. found) call bailout('erelax', 'xsect.json')
         call json%get('wp',     wpx, found)
                   if (.not. found) call bailout('wp',     'xsect.json')
         call json%get('edge',   edge, found)
                   if (.not. found) call bailout('edge',   'xsect.json')
         call json%get('emu',    emu, found)
                   if (.not. found) call bailout('emu',    'xsect.json')
         call json%get('gamach', gamma, found)
                   if (.not. found) call bailout('gamach', 'xsect.json')
         call json%get('ne',     ne, found)
                   if (.not. found) call bailout('ne',     'xsect.json')
         call json%get('ne1',    ne1, found)
                   if (.not. found) call bailout('ne1',    'xsect.json')
         call json%get('ik0',    ik0, found)
                   if (.not. found) call bailout('ik0',    'xsect.json')

         call json%get('ereal',   dbpc1, found)
                   if (.not. found) call bailout('er',     'xsect.json')
         call json%get('eimag',   dbpc2, found)
                   if (.not. found) call bailout('ei',     'xsect.json')
         call json%get('xsnorm',  dbpc3, found)
                   if (.not. found) call bailout('xsn',    'xsect.json')
         call json%get('dum1',   dbpc4, found)
                   if (.not. found) call bailout('col4',   'xsect.json')
         call json%get('dum2',   dbpc5, found)
                   if (.not. found) call bailout('col5',   'xsect.json')

         do 20 i=1,ne
            er(i)   = dbpc1(i)
            ei(i) = dbpc2(i)
            xsn(i) = dbpc3(i)
            col4(i) = dbpc4(i)
            col5(i) = dbpc5(i)
 20      continue
         call json%destroy()
      end if

      return
      end

      subroutine read_titles(ntit, titles)
      use json_module
      implicit double precision (a-h, o-z)

      include '../HEADERS/const.h'
      include '../HEADERS/dim.h'

      logical :: found
      type(json_file) :: json   !the JSON structure read from the file:
      character*80,dimension(:),allocatable :: strings

      character*80 titles(nheadx)

      call json%load_file('xsect.json')
      if (json_failed()) then   !if there was an error reading the file
         print *, "failed to read xsect.json"
         stop
      else
         call json%get('ntitle', ntit, found)
                   if (.not. found) call bailout('s02',   'xsect.json')
         call json%get('title',   strings, found)
                   if (.not. found) call bailout('title', 'xsect.json')
         do 10 i=1,ntit
            titles(i) = strings(i)
 10      continue
         call json%destroy()
      end if

      return
      end

      double precision function fdrirk (i,j,l,m,k)
c                       * calculate radial integrales rk *
c        rk = integral of f(r) * uk(r,s) * g(s)
c uk(r,s) = rinf**k / rsup**(k+1)    rinf=min(r,s)   rsup=max(r,s)
c        if nem=0  f(.)=cg(.,i)*cg(.,j)+cp(.,i)*cp(.,j)
c                  g(.)=cg(.,l)*cg(.,m)+cp(.,l)*cp(.,m)
c        if nem non zero f(.)=cg(.,i)*cp(.,j)
c                        g(.)=cg(.,l)*cp(.,m)
c                  cg (cp) large (small) componenents of the orbitales
c moreover if nem > or =0 the integration is made from 0 to infinity,
c and otherwise from 0 to r.
c        this programm uses yzkrdf and dsordf
 
      implicit double precision (a-h,o-z)
      common/ratom1/xnel(30),en(30),scc(30),scw(30),sce(30),
     1nq(30),kap(30),nmax(30)
      common/comdir/cl,dz,dg(251),ag(10),dp(251),ap(10),bidcom(783)
c comdir is used just to exchange variables between dsordf,yzkrdf,fdrirk
      dimension hg(251)
      common/inelma/nem
      common/tabtes/hx,dr(251),test1,test2,ndor,np,nes,method,idim
      save
 
      fdrirk=0.0d 00
      if (i.le.0.or.j.le.0) go to 201
      call yzkrdf (i,j,k)
      nn= abs(kap(i))+ abs(kap(j))
      nn=max(nn-k,1)
      a=k+1
      do 21 n=1,ndor
 21   hg(n)=0.0d 00
      do 31 n=1,ndor
         if (nn.gt.ndor) go to 31
         hg(nn)=-ag(n)
 31      nn=nn+1
      do 41 n=1,ndor
 41      ag(n)=hg(n)
      ag(1)=ag(1)+ap(1)

 201  if (l.le.0.or.m.le.0) return
      n=-1
      if (nem.ne.0) n=-2
      fdrirk=dsordf(l,m,-1,n,a)
      return
      end

      subroutine inmuat (ihole, xionin, iunf, xnval, iholep, xmag, iorb)
      implicit double precision (a-h,o-z)
      dimension xnval(30), xmag(30), iorb(-4:3)
      common/itescf/testy,rap(2),teste,nz,norb,norbsc
c the meaning of common variables is described below
      common/ratom1/xnel(30),en(30),scc(30),scw(30),sce(30),
     1nq(30),kap(30),nmax(30)
c en one-electron energies
c scc factors for acceleration of convergence
c scw precisions of wave functions
c sce precisions of one-electron energies
c nmax number of tabulation points for orbitals
      common/scrhf1/eps(435),nre(30),ipl
c eps non diagonal lagrange parameters
c nre distingue: - the shell is closed (nre <0)
c                  the shell is open (nre>0)
c                - the orbitals in the integral rk if abs(nre) > or =2
c ipl define the existence of lagrange parameters (ipl>0)
      common/snoyau/dvn(251),anoy(10),nuc
c dvn nuclear potential
c anoy development coefficients at the origin of nuclear potential
c this development is supposed to be written anoy(i)*r**(i-1)
c nuc index of nuclear radius (nuc=1 for point charge)
      common/tabtes/hx,dr(251),test1,test2,ndor,np,nes,method,idim
      data nucm/11/,nesn/50/,ideps/435/

      ndor=10
      testy=1.0d-05
c testy precision for the wave functions
      teste=5.0d-06
c teste precision for the one-electron energies
      rap(1)=100.
      rap(2)=10.
c rap tests of precision for soldir
      do 10 i = 1, 30
        en(i) = 0.d0
        xmag(i) = 0
  10  xnval(i) = 0

      call getorb (nz, ihole, xionin, iunf, norb, norbsc, iorb,
     1             iholep, nq, kap, xnel, xnval, xmag)
      xk=0
      do 411 i=1,norb
 411  xk=xk+xnel(i)
      if ( abs(nz-xionin-xk) .gt. 0.001) then
         call par_stop('check number of electrons in getorb.f')
c        stop
      endif
      norbsc=norb
c nz atomic number     noi ionicity (nz-number of electrons)
c norb number of orbitals
c xnel(i) number of electrons on orbital i.
c first norbsc orbitals will be determined selfconsistently,
c the rest of orbitals are orthogonolized if iorth is non null,
c and their energies are those on cards if iene is non null
c or otherwise are the values obtained from solving dirac equation
      nes=nesn
c nes number of attempts in program soldir
      nuc=nucm
c nuc number of points inside nucleus (11 by default)
      do 171 i=1,ideps
 171  eps(i)=0.0d 00

      idim = 251
      if (mod(idim,2) .eq. 0) idim=idim-1

      ipl=0
c if ipl non null, it permits a repartition of tabulation points
c and certain precision tests.
      do 401 i=1,norb
         nre(i)=-1
         llq= abs(kap(i))
         l=llq+llq
         if (kap(i).lt.0) llq=llq-1
         if (llq.lt.0.or.llq.ge.nq(i).or.llq.gt.3) then
            call par_stop('kappa out of range, check getorb.f')
c           stop
         endif
         nmax(i)=idim
         scc(i)=0.3
         if (xnel(i) .lt. l)  nre(i)=1
         if (xnel(i) .lt. 0.5)  scc(i)=1.0
         do 385 j=1,i-1
            if (kap(j).ne.kap(i)) go to 385
            if (nre(j).gt.0.or.nre(i).gt.0) ipl=ipl+1
 385     continue
 401  continue
      return
      end

      subroutine wrpot ( nph, ntitle, title, rnrmav, xmu, vint, rhoint,
     1                  emu, s02, erelax, wp, ecv,rs,xf, qtotel, 
     2                  imt, rmt, inrm, rnrm, folp, folpx, xnatph,
     3                  dgc0, dpc0, dgc, dpc, adgc, adpc,
     3                  edens, vclap, vtot, edenvl, vvalgs, dmag, xnval,
     4                  eorb, kappa, iorb, qnrm, xnmues, nohole, ihole,
     5                  inters, totvol, iafolp, xion, iunf, iz, jumprm)
c  opens pot.pad file and writes following information
c  General:
c     ntitle - number of title lines
c     title  - title itself
c     emu    - edge position (x-ray energy for final state at Fermi level)
c  Muffin-tin geometry
c     rmt    - muffin-tin radii
c     imt    - index of radial grid just below muffin-tin radii
c     rnrm   - Norman radii
c     inrm   - index of radial grid just below Norman radii
c     rnrmav - average Norman radius
c     folp   - overlap parameter for rmt
c     folpx  - maximum value for folp
c  Atomic orbitals info (Dirac spinors)
c     dgc0   - upper component for initial orbital
c     dpc0   - lower component for initial orbital
c     dgc    - upper components for all atomic orbitals
c     dpc    - lower components for all atomic orbitals
c     adgc   - development coefficient for upper components
c     adpc   - development coefficient for lower components
c     xnval  - number of valence electrons for each atomic orbital
c     eorb   - atomic energy of occupied orbitals
c     kappa  - quantum number kappa of occupied orbitals
c     iorb   - index of last occupied orbital for each kappa
c              used for core-valence separation and non-local exchange
c  Electron density information 
c     rhoint - interstitial density
c     rs     - r_s estimate from rhoint (4/3 r_s**3 * rhoint = 1)
c     xf     - estimate of momentum at Fermi level from rhoint
c     edens  - total electron density
c     edenvl - density from valence electrons
c     dmag   - density for spin-up minus density for spin-down
c     qtotel - total charge of a cluster
c     qnrm   - charge accumulated inside Norman sphere as result of SCF
c     xnmues - occupation numbers of valence orbitals from SCF procedure
c  Potential information
c     xmu    - Fermi level position
c     ecv    - core-valence separation energy
c     vint   - muffin-tin zero energy (interstitial potential)
c     vclap  - Coulomb potential
c     vtot   - vclap + xc potential from edens
c     vvalgs - vclap + xc potential from edenvl (EXCHANGE 5 model)
c  Specific data for convolution with excitation spectrum (see mbconv)
c     s02    - many body reduction factor S_0^2 
c     erelax - estimate of relaxation energy = efrozen - emu, where
c              efrozen is edge position estimate from Koopmans theorem
c     wp     - estimate of plasmon frequency from rhoint

      implicit double precision (a-h, o-z)
      include '../HEADERS/dim.h'
      parameter (npadx=8)
      dimension imt(0:nphx), rmt(0:nphx), inrm(0:nphx),  rnrm(0:nphx)
      dimension folp(0:nphx), folpx(0:nphx), dgc0(251), dpc0(251)
      dimension dgc(251, 30, 0:nphx), dpc(251, 30, 0:nphx)
      dimension adgc(10, 30, 0:nphx), adpc(10, 30, 0:nphx)
      dimension edens(251, 0:nphx), vclap(251, 0:nphx)
      dimension vtot(251, 0:nphx), edenvl(251, 0:nphx)
      dimension vvalgs(251, 0:nphx), dmag(251, 0:nphx)
      dimension xnval(30,0:nphx), qnrm(0:nphx), xnmues(0:lx,0:nphx)
      dimension eorb(30), kappa(30)
      dimension iorb(-4:3,0:nphx), iz(0:nphx), xion(0:nphx)
      dimension xnatph(0:nphx)
      character*80 title(nheadx)

      dimension dum(13)
      character*75 wfmt

  10  format(a)
      write (wfmt, 35) nph + 1
  35  format( '(', i3, '(1x,i4))' )

      open (unit=3, file='pot.pad', status='unknown', iostat=ios)
      call chopen (ios, 'pot.pad', 'pot')
      write(3,20) ntitle, nph, npadx, nohole, ihole, inters, iafolp,
     1            jumprm, iunf
  20  format (9(1x,i4))
      do 133  i  = 1, ntitle
         ll = istrln(title(i))
         write(3,10) title(i)(1:ll)
  133 continue
c     Misc stuff from pot.pad
      dum(1)  = rnrmav
      dum(2)  = xmu
      dum(3)  = vint
      dum(4)  = rhoint
      dum(5)  = emu
      dum(6)  = s02
      dum(7)  = erelax
      dum(8)  = wp
      dum(9)  = ecv
      dum(10)  = rs
      dum(11)  = xf
      dum(12)  = qtotel
      dum(13)  = totvol
      call wrpadd(3, npadx, dum(1), 13)

      write (3, 40) (imt(i),i=0,nph)
  40  format(20(1x,i4))
      
      call wrpadd(3, npadx, rmt(0), nph+1)

      write (3, 40) (inrm(i),i=0,nph)
      write (3, 40) (iz(i),i=0,nph)
      write (3, 40) (kappa(i),i=1,30)
      
      call wrpadd(3, npadx, rnrm(0), nph+1)
      call wrpadd(3, npadx, folp(0), nph+1)
      call wrpadd(3, npadx, folpx(0), nph+1)
      call wrpadd(3, npadx, xnatph(0), nph+1)
      call wrpadd(3, npadx, xion(0), nph+1)
      call wrpadd(3, npadx, dgc0(1), 251)
      call wrpadd(3, npadx, dpc0(1), 251)
      call wrpadd(3, npadx, dgc(1,1,0), 251*30*(nph+1) )
      call wrpadd(3, npadx, dpc(1,1,0), 251*30*(nph+1) )
      call wrpadd(3, npadx, adgc(1,1,0), 10*30*(nph+1) )
      call wrpadd(3, npadx, adpc(1,1,0), 10*30*(nph+1) )
      call wrpadd(3, npadx, edens(1,0), 251*(nph+1) )
      call wrpadd(3, npadx, vclap(1,0), 251*(nph+1) )
      call wrpadd(3, npadx, vtot(1,0), 251*(nph+1) )
      call wrpadd(3, npadx, edenvl(1,0), 251*(nph+1) )
      call wrpadd(3, npadx, vvalgs(1,0), 251*(nph+1) )
      call wrpadd(3, npadx, dmag(1,0), 251*(nph+1) )
      call wrpadd(3, npadx, xnval(1,0), 30*(nph+1) )
      call wrpadd(3, npadx, eorb(1), 30)
      
      do 50 iph=0,nph
        write (3, 60) (iorb(i,iph),i=-4,3)
 50   continue
 60   format(8(1x,i2))
      call wrpadd(3, npadx, qnrm(0), nph+1 )
      call wrpadd(3, npadx, xnmues(0,0), (lx+1)*(nph+1) )
      close (unit=3)

      return
      end

c---------------------------------------------------------------------
c     program sigcl.f
c
c     calculates debye-waller factors for each multiple
c     scattering path using Debye-Model correlations
c
c     files:  input  pathd_all.dat  multiple scattering path data
c             output fort.3  sig**2 vs path
c                    fort.2  long output
c
c     version 1  (29 july 91)
c
c     coded by j. rehr
c     path data from s. zabinsky
c
c     modified to use pdata.inp, Dec 1991, siz
c     Subroutine version, Dec 1991, siz
c     Hacked for classical Debye Model, 7/2006, Kevin Jorissen  !KJ
c
c---------------------------------------------------------------------

      subroutine sigcl (tk, thetad, rs, nlegx, nleg, rat, iz, sig2)
c               tk temperature in degrees K
c               thetad debye temp in degrees K
c               rs=wigner seitz or norman radius in bohr, averaged
c                  over entire problem
c                  (4pi/3)*rs**3 = sum( (4pi/3)rnrm**3 ) / N
c                  (sum is over all atoms in the problem)
c               nlegx used in dimensions of rat and iz
c               nleg nlegs in path
c               rat positions of each atom in path
c               iz atomic number of each atom in path
c               NB Units of distance in this routine
c                  are angstroms, including sig**2.  rs is in bohr.
c               sig2 is output debye waller factor

      implicit double precision (a-h,o-z)

      include '../HEADERS/const.h'

c     nlegx is max number of atoms in any one path
      dimension rat(3,0:nlegx)
      dimension iz(0:nlegx)
c#mn
       external dist

c      parameters
c               x = k_d*R   (distance parameter)
c               R distance in angstroms
c               y = hbar omegad/kT = thetad/t
c               thetad debye temp in degrees K
c               tk temperature in degrees K
c               k_d = (6*pi**2 N/V) = debye wave number
c               N/V=1/(4pi/3rs**3)
c               rs=wigner seitz or norman radius in bohr
c               ami, amj masses at sites i and j in amu
c               I = int_0^1 (y/x) dw sin(wx)coth(wy/2)

c     Note:  There are nleg atoms including the central atom
c            index 0 and index nleg both refer to central atom,
c            which makes special code unnecessary later.

      sigtot=0
      do 800 il=1,nleg
      do 800 jl=il,nleg

c        calculate r_i-r_i-1 and r_j-r_j-1

         rij = dist (rat(1,il), rat(1,jl))
         call corrfn2 (rij, cij, thetad, tk, iz(il), iz(jl), rs)
         sig2ij=cij

         rimjm = dist (rat(1,il-1), rat(1,jl-1))
         call corrfn2 (rimjm, cimjm, thetad, tk, iz(il-1), iz(jl-1), rs)
         sig2ij=sig2ij+cimjm

         rijm = dist (rat(1,il), rat(1,jl-1))
         call corrfn2 (rijm, cijm, thetad, tk, iz(il), iz(jl-1), rs)
         sig2ij=sig2ij-cijm

         rimj = dist (rat(1,il-1), rat(1,jl))
         call corrfn2 (rimj, cimj, thetad, tk, iz(il-1), iz(jl), rs)
         sig2ij=sig2ij-cimj

         riim = dist (rat(1,il), rat(1,il-1))
         rjjm = dist (rat(1,jl), rat(1,jl-1))

         ridotj=(rat(1,il)-rat(1,il-1))*(rat(1,jl)-rat(1,jl-1))+
     1          (rat(2,il)-rat(2,il-1))*(rat(2,jl)-rat(2,jl-1))+
     2          (rat(3,il)-rat(3,il-1))*(rat(3,jl)-rat(3,jl-1))
         ridotj=ridotj/(riim*rjjm)

c        double count i .ne. j  terms
         if(jl.ne.il) sig2ij=2*sig2ij
         sig2ij=sig2ij*ridotj
         sigtot=sigtot+sig2ij

  800 continue
      sig2=sigtot/4

c     sig2 is in bohr**2, just as we wanted for ff2chi
      return
      end



      subroutine corrfn2(rij,cij,thetad,tk,iz1,iz2,rsavg)
c     subroutine calculates correlation function
c     c(ri,rj)=<xi xj> in the Debye approximation
c
c             =(1/N)sum_k exp(ik.(Ri-Rj))(1/sqrt(mi*mj))*
c              (hbar/2w_k)*coth(beta hbar w_k/2)
c             = (3kT/mu w_d**2)*sqrt(mu**2/mi*mj)*I
c
c      parameters
c               x = k_d*R   (distance parameter)
c               R distance in angstroms
c               y = hbar omegad/kT = thetad/t
c               thetad debye temp in degrees K
c               tk temperature in degrees K
c               k_d = (6*pi**2 N/V) = debye wave number
c               N/V=1/(4pi/3rs**3)
c               rs=wigner seitz or norman radius in bohr
c               ami, amj masses at sites i and j in amu
c               I = int_0^1 (y/x) dw sin(wx)coth(wy/2)
c
c      solution by numerical integration
c
      implicit double precision (a-h, o-z)
      common /xy/ x, yinv

      include '../HEADERS/const.h'

c     con=hbar**2/kB*amu)*10**20   in ang**2 units
c     hbar, amu, kb updated 2017
      parameter (con = 48.50875019927435d0)
c#mn
       external atwtd

c     external fn
c     rij=2.55
c     tk=295
c     thetad=315
c     ami=amj=63.55 at wt for Cu
c     rs=2.7

      ami=atwtd(iz1)
      amj=atwtd(iz2)
      rs=rsavg
c     thetad in degrees K, t temperature in degrees K
c     y=thetad/tk
      yinv=tk/thetad
      xkd=(9*pi/2)**(third)/(rs*bohr)
      fac=(3/2.)*con/(thetad*sqrt(ami*amj))
      rj=rij
      x=xkd*rj
c     call numerical integration
      call bingrt2 (grater, eps, nx)
      cij=fac*grater
      return
      end
      double precision function fn2(w)
      implicit double precision (a-h,o-z)
      common/xy/x,yinv
c     fn=(sin(wx)/x)*coth(wy/2)
c     change code to allow t=0 without bombing
c     fn=2/y
      fn2=2*yinv
      if(w.lt.1.e-20) return
      fac=w
      if(x.gt.0.) fac=sin(w*x)/x
!      emwy=0.
!      if(yinv.gt.0.0125) emwy=exp(-w/yinv)
!      emwy=exp(-w/yinv)
!      fn2=fac*(1+emwy)/(1-emwy)
      fn2=fac*2*yinv/w  !KJ coup de grace
      return
      end
c-----------------------------------------------
      subroutine bingrt2 (b, eps, n)
c     subroutine calculates integrals between [0,1]
c      b = int_0^1 f(z) dz
c     by trapezoidal rule and binary refinement
c     (romberg integration)
c     coded by j rehr (10 Feb 92)
c     see, e.g., numerical recipes for discussion
c     and a much fancier version
c-----------------------------------------------
c     del=dz  itn=2**n tol=1.e-5
c     starting values
      implicit double precision (a-h,o-z)
      common /xy/x,yinv
      character*512 slog
c     external fn
c     error is approximately 2**(-2n) ~ 10**(-.6n)
c     so nmax=10 implies an error of 1.e-6
      parameter(nmax = 10, tol = 1.d-5)
      parameter(zero=0.d0, one=1.d0)
      n=0
      itn=1
      del=1.
      bn=(fn2(zero)+fn2(one))/2
      bo=bn
 10   continue
c     nth iteration
c     b_n+1=(b_n)/2+deln*sum_0^2**n f([2n-1]deln)
      n=n+1
      if(n.gt.nmax) go to 40
      del=del/2
      sum=0.
      do 20 i=1, itn
      zi=(2*i-1)*del
 20   sum=sum+fn2(zi)
c     bnp1=b_n+1 is current value of integral
      bnp1=bn/2+del*sum
c     cancel leading error terms b=[4b-bn]/3
c     note: this is the first term in the
c     neville table - remaining errors were
c     found too small to justify the added code
      b=(4*bnp1-bn)/3
      eps=abs((b-bo)/b)
      if(eps.lt.tol) goto 60
      bn=bnp1
      bo=b
      itn=itn*2
      goto 10
 40   write(slog,50) n,itn, b,eps
      call wlog(slog)
 50   format(' not converged, n,itn,b,eps=',
     1  2i4,2e14.6)
      return
 60   continue
      return
      end

      subroutine fixvar (rmt, edens, vtot, dmag,
     1                   vint, rhoint, dxorg, dxnew, jumprm,
     2                   vjump, ri, vtotph, rhoph, dmagx)

      implicit double precision (a-h, o-z)

      include '../HEADERS/dim.h'
      include '../HEADERS/const.h'


      dimension edens(251), vtot (251), dmag(251)
      dimension vtotph(nrptx), rhoph(nrptx), dmagx(nrptx)
      dimension ri(nrptx)
      dimension xorg(nrptx), xnew(nrptx)

      parameter (xx00 = 8.8d0)

c     statement functions to do indexing.  delta is 'dx' for current
c     grid.  jjj is index of grid point immediately before 'r'
      xxx(j) = -xx00 + (j-1)*delta
      rrr(j) = exp (-xx00 + (j-1)*delta)
      jjj(r) = int((log(r) + xx00) / delta) + 1

c     PHASE needs
c     vtot = total potential including gs xcorr, no r**2
c     edens = rho, charge density, no factor of 4*pi, no r**2
c     From overlapping, vtot = potential only, ok as is
c                       edens = density*4*pi, so fix this here.
c     ri = r grid through imt+1

c     Only values inside the muffin tin are used, except that XCPOT
c     (in PHASE) uses values at imt+1 and requires these to be the
c     interstitial values.  So set the last part of the arrays to
c     interstitial values...

c     Use linear interpolation in x whether necessary or not.  If
c     new grid is same as old, it shouldn't make any difference.

c     relation between x, r, and j.  xx00 = 8.8 for all grids
c     in this version, change it if more flexibility is necessary.

c     xx = -xx00 + (j-1)*delta
c     rr = exp (xx)
c     jj = (log(r) + xx00) / delta + 1; this is j immediately BELOW r

      delta = dxorg
      jmtorg = jjj(rmt)
      jriorg = jmtorg + 1
      jrior1 = jriorg + 1
      do 10  j = 1, jrior1
         xorg(j) = xxx(j)
   10 continue

      delta = dxnew
      jmtnew = jjj(rmt)
      jrinew = jmtnew + 1
      jrine1 = jrinew + 1
      do 20  j = 1, jrine1
         xnew(j) = xxx(j)
   20 continue

c     interpolate to new grid using x, only inside of muffintin
c     jri (first interstitial point) must be set to interstitial value
      do 30  j = 1, jrinew
         call terp (xorg, vtot,  jriorg, 3, xnew(j), vtotph(j))
         call terp (xorg, edens, jrior1, 3, xnew(j), rhoph(j))
         call terp (xorg, dmag,  jrior1, 3, xnew(j), dmagx(j))
   30 continue

      if (jumprm .eq. 1) then
         xmt = log(rmt)
         call terp (xorg, vtot,  jriorg, 3, xmt, vmt)
         vjump = vint - vmt
      endif
      if (jumprm .gt. 0) then
         do 90  j = 1, jrinew
            vtotph(j) = vtotph(j) + vjump
   90    continue
      endif

      delta = dxnew
      do 180  j = 1, nrptx
         ri(j) = rrr(j)
  180 continue
      do 190  j = 1, jrinew
         rhoph(j) = rhoph(j)/(4*pi)
  190 continue
      do 200  j = jrinew+1, nrptx
         vtotph(j) = vint
         rhoph(j) = rhoint/(4*pi)
c fix later : need to calculate interstitial dmint
c      want interpolation beyond mt also
         dmagx(j) = 0.0d0
  200 continue

      return
      end

      subroutine rot3i (lxp1, mxp1, ileg)
      implicit double precision (a-h,o-z)

c     input:  lxp1, mxp1, ileg (lmax+1, mmax+1)
c             also beta(ileg) used from common /pdata/
c     output: dri(...ileg) in common /rotmat/

c     subroutine rot3 calculates rotation matrices for l = 0,lxp1-1

c     subroutine rot3 calculates the beta dependence of rotation
c     matrix elements using recursion of an iterated version of
c     formula (4.4.1) in edmonds.
c
c     first written:(september 17,1986) by j. mustre
c     version 2  (17 sep 86)
c     version 3  (22 feb 87) modified by j. rehr
c     version for genfmt, modified by s. zabinsky, Sept 1991
c     Initialized dri0.  Some elements may be used before being
c        initialized elsewhere -- rot3i needs to be carefully
c        checked.  S. Zabinsky, April 1993
c
c******************** warning******************************************
c     ltot must be at least lxp1 or overwriting will occur
c     nmax must be at least nm or overwriting will occur
c----------------------------------------------------------------------
c     notation dri0(l,m,n) =  drot_i(l'm'n')
c     l = l'+1, n' = n-l, m' = m-l, primes denoting subscripts
c     thus dri0(1,1,1) corresponds to the rotation matrix with
c     l' = 0, and n' and m' = 0; dri0(3,5,5) : l' = 2,n' = 2,m' = 2.
c--------------------------------------------------------------------

      include 'dim.h'
      include 'rotmat.h'
      include 'pdata.h'
c     dri0 is larger than needed for genfmt, but necessary for
c     this calculation algorithm.  Copy result into smaller
c     dri arrays (in common) at end of this routine.
      dimension  dri0 (ltot+1, 2*ltot+1, 2*ltot+1)

c     initialize dri0
      do 200 il = 1, ltot+1
         do 200 im = 1, 2*ltot+1
            do 200 in = 1, 2*ltot+1
               dri0(il,im,in) = 0
  200 continue

      nm = mxp1
      ndm = lxp1+nm-1
      xc = cos(beta(ileg)/2)
      xs = sin(beta(ileg)/2)
      s = sin(beta(ileg))
      dri0(1,1,1) = 1
      dri0(2,1,1) = xc**2
      dri0(2,1,2) = s/sqrt(2.0d0)
      dri0(2,1,3) = xs**2
      dri0(2,2,1) = -dri0(2,1,2)
      dri0(2,2,2) = cos(beta(ileg))
      dri0(2,2,3) = dri0(2,1,2)
      dri0(2,3,1) = dri0(2,1,3)
      dri0(2,3,2) = -dri0(2,2,3)
      dri0(2,3,3) = dri0(2,1,1)
      do 30  l = 3, lxp1
         ln = 2*l - 1
         lm = 2*l - 3
         if (ln .gt. ndm)  ln = ndm
         if (lm .gt. ndm)  lm = ndm
         do 20  n = 1, ln
            do 10  m = 1, lm
               t1 = (2*l-1-n) * (2*l-2-n)
               t = (2*l-1-m) * (2*l-2-m)
               f1 = sqrt (t1/t)
               f2 = sqrt ((2*l-1-n) * (n-1) / t)
               t3 = (n-2) * (n-1)
               f3 = sqrt(t3/t)
               dlnm = f1 * xc**2 * dri0(l-1,n,m)
               if (n-1 .gt. 0) dlnm = dlnm - f2*s*dri0(l-1,n-1,m)
               if (n-2 .gt. 0) dlnm = dlnm + f3*xs**2*dri0(l-1,n-2,m)
               dri0(l,n,m) = dlnm
               if (n .gt. (2*l-3))
     1            dri0(l,m,n) = (-1)**(n-m) * dri0(l,n,m)
   10       continue
            if (n .gt. (2*l-3)) then
               dri0(l,2*l-2,2*l-2) = dri0(l,2,2)
               dri0(l,2*l-1,2*l-2) = -dri0(l,1,2)
               dri0(l,2*l-2,2*l-1) = -dri0(l,2,1)
               dri0(l,2*l-1,2*l-1) = dri0(l,1,1)
            endif
   20    continue
   30 continue
   40 continue

c-----test sum rule on d
c     open (19,file='rotmat.dat',status='new',carriagecontrol='list')
c     write(19,*)  ' l, m, sum'
c     write(19,*) ' (dri0(il,im,in),in = 1,ln)'
c     do 70 il = 1,lxp1
c        l = il-1
c        ln = 2*l+1
c        if(ln.gt.ndm) ln = ndm
c        do 37 im = 1,ln
c           sum = 0
c           do 50 in = 1,ln
c              m = im-il
c              term = dri0(il,im,in)
c  50       sum = sum+term**2
c           write(19,60) l,m,sum
c           write(19,62) (dri0(il,im,in),in = 1,ln)
c  60       format(2i3,e30.20)
c  62       format(5e14.6)
c  70 continue
c     close(19)
c-----end test------------------------

c     Copy result into dri(...ileg) in /rotmat/ (zero it first...)
      do 90  il = 1, ltot+1
         do 90  m1 = 1, 2*mtot+1
            do 90  m2 = 1, 2*mtot+1
               dri(il,m1,m2,ileg) = 0
   90 continue

      do 120  il = 1, lxp1
         mx = min (il-1, mxp1-1)
         do 110  m1 = -mx, mx
            do 100  m2 = -mx, mx
               dri(il,m1+mtot+1,m2+mtot+1,ileg)=dri0(il,m1+il,m2+il)
  100       continue
  110    continue
  120 continue

      return
      end

      subroutine nucdev (av,dr,dv,dz,hx,nuc,np,ndor,dr1)
c        * construction of nuclear potential *
c av coefficients of the development at the origin of nuclear potential
c dr  tabulation points
c dv  nuclear potential 
c dz  nuclear charge 
c hx  exponential step
c nuc index of the nuclear radius
c np  number of tabulation points
c ndor number of the coefficients for development at the origin
c the declared below arguments are saved, dr1 is the first
 
      implicit double precision (a-h,o-z)
      dimension av(10),dr(251),dv(251),at(251)

c    specify atomic mass and thickness of nuclear shell
c a atomic mass (negative or null for the point charge)
c epai parameter of the fermi density distribution
c (negative or null for uniform distribution), which is
c       cte / (1. + exp((r-rn)/epai) )
c with nuclear radius rn= 2.2677e-05 * (a**(1/3))

c calculate radial mesh
      a = 0.0
      epai = 0.0

      if (a.le.1.0d-01) then
         nuc=1
      else
         a=dz*(a**(1./3.))*2.2677d-05
         b=a/ exp(hx*(nuc-1))
         if (b.le.dr1) then
            dr1=b
         else
            b=log(a/dr1)/hx
            nuc=3+2*int(b/2.0)
            if (nuc.ge.np) call par_stop('dr1 too small')
c           index of atomic radius larger than dimension of dr
            dr1=a*exp(-(nuc-1)*hx)
         endif
      endif

      dr(1)=dr1/dz
      do 181 l=2,np
 181  dr(l)=dr(1)* exp(hx*(l-1))

      if (ndor.lt.5) then
c       * it should be at least 5 development coefficients
         call par_stop
     .     ('stopped in programm nucdev, ndor should be > 4.')
c        stop
      endif
c  calculate nuclear potential on calculated radial mesh
      do 11 i=1,ndor
 11      av(i)=0.0d 00
      if (epai.le.0.0) then
         do 15 i=1,np
 15         dv(i)=-dz/dr(i)
         if (nuc.le.1) then
            av(1)=-dz
         else
            av(2)=-3.0d 00*dz/(dr(nuc)+dr(nuc))
            av(4)=-av(2)/(3.0d 00*dr(nuc)*dr(nuc))
            l=nuc-1
            do 25 i=1,l
 25            dv(i)=av(2)+av(4)*dr(i)*dr(i)
         endif
      else
         b= exp(-dr(nuc)/epai)
         b=1.0d 00/(1.0d 00+b)
         av(4)=b
         av(5)=epai*b*(b-1.0d 00)
         if (ndor.le.5) go to 45
         at(1)=1.0d 00
         at(2)=1.0d 00
         nf=1
         do 41 i=6,ndor
            n=i-4
            nf=n*nf
            dv(1)=n*at(1)
            n1=n+1
            dv(n1)=1.0d 00
            do 35 j=2,n
 35         dv(j)=(n-j+2)*at(j-1)+(n-j+1)*at(j)
            do 37 j=1,n1
               m=n+1-j
               l=1
               if (mod(j,2).eq.0) l=-l
               av(i)=av(i)+l*dv(j)*(b**m)
 37            at(j)=dv(j)
 41         av(i)=b*av(i)*(epai**n)/nf
 45      do 47 i=1,np
            b=1.0d 00+ exp((dr(i)-dr(nuc))/epai)
            if ((b*av(4)).gt.1.0d+15) go to 51
            dv(i)=dr(i)*dr(i)*dr(i)/b
 47         l=i
 51      if (l.ge.(np-1)) l=np-2
         k=l+1
         do 55 i=k,np
 55         dv(i)=0.0d 00
         at(1)=0.0d 00
         at(2)=0.0d 00
         k=2
         do 61 i=4,ndor
            k=k+1
            do 58 j=1,2
 58         at(j)=at(j)+av(i)*(dr(j)**k)/k
            av(i)=av(i)/(k*(k-1))
 61         av(2)=av(2)+av(i)*(dr(1)**k)
         a=hx/2.4d+01
         b=a*1.3d+01
         k=l+1
         do 71 i=3,k
 71      at(i)=at(i-1)+b*(dv(i-1)+dv(i))-a*(dv(i-2)+dv(i+1))
         dv(l)=at(l)
         do 75 i=k,np
 75      dv(i)=dv(l)
         e= exp(hx)
         c=1.0d 00/(e*e)
         i=l-1
 83      dv(i)=dv(i+1)/e+b*(at(i+1)/e+at(i))-a*(at(i+2)*c+at(i-1)*e)
         i=i-1
         if (i-1) 85,85,83
 85      dv(1)=dv(3)*c+hx*(at(1)+4.0d 00*at(2)/e+at(3)*c)/3.0d 00
         av(2)=(av(2)+dv(1))/dr(1)
         a=-dz/dv(l)
         do 95 i=4,ndor
 95      av(i)=-a*av(i)
         av(2)=a*av(2)
         do 97 i=1,np
 97      dv(i)=a*dv(i)/dr(i)
      endif

      return
      end

      subroutine iniptz(ptz,iptz,modus)
        !KJ This routine rewrites the ptz-matrix.

      implicit none
c     which polarization tensor to create
      integer iptz
c     two ways of working
      integer modus
c     the polarization tensor
      complex*16 ptz(-1:1,-1:1)

      complex*16 zero,one,coni
      parameter (zero=(0.d0,0.d0),one=(1.d0,0.d0),coni=(0.d0,1.d0))
      integer i,j
      real*8 unity(3,3)



      if (iptz.lt.1.or.iptz.gt.10) then
          call wlog('Inieln sees weird iptz - returns without
     1      changing ptz - danger of calculating nonsense !!')
      endif


      do i=1,3
      do j=1,3
        unity(i,j)=dble(0)
      enddo
      unity(i,i)=dble(1)/dble(3)
      enddo
      do i=-1,1
      do j=-1,1
        ptz(i,j)=zero
      enddo
      enddo


      if (modus.eq.1) then
! work in spherical coordinates

         if(iptz.eq.10) then
        do i=-1,1
        do j=-1,1
           ptz(i,j)=unity(i+2,j+2)
        enddo
        enddo
         else
            i=(iptz-1)/3+1  ! row index
            j=iptz-3*(i-1)  ! column index
            i=i-2 !shift from 1..3 to -1..1
            j=j-2
            ptz(i,j)=one
         endif


      elseif(modus.eq.2) then
! work in carthesian coordinates

      if (iptz.eq.10) then ! orientation averaged spectrum
        do i=-1,1
        do j=-1,1
           ptz(i,j)=unity(i+2,j+2)
        enddo
        enddo

        elseif (iptz.eq.1) then   ! x x*
          ptz(1,1)=one/dble(2)
        ptz(-1,-1)=one/dble(2)
        ptz(-1,1)=-one/dble(2)
        ptz(1,-1)=-one/dble(2)
        elseif (iptz.eq.5) then ! y y*
          ptz(1,1)=one/dble(2)
        ptz(-1,-1)=one/dble(2)
        ptz(-1,1)=one/dble(2)
        ptz(1,-1)=one/dble(2)
         elseif (iptz.eq.9) then ! z z*
        ptz(0,0)=one
        elseif (iptz.eq.2) then ! x y*
          ptz(1,1)=one*coni/dble(2)
        ptz(-1,-1)=-one*coni/dble(2)
        ptz(-1,1)=-one*coni/dble(2)
        ptz(1,-1)=one*coni/dble(2)
        elseif (iptz.eq.4) then ! x* y
          ptz(1,1)=-one*coni/dble(2)
        ptz(-1,-1)=one*coni/dble(2)
        ptz(-1,1)=-one*coni/dble(2)
        ptz(1,-1)=one*coni/dble(2)
        elseif (iptz.eq.3) then ! x z*
          ptz(-1,0)=one/dsqrt(dble(2))
        ptz(1,0)=-one/dsqrt(dble(2))
        elseif (iptz.eq.7) then ! x* z
          ptz(0,-1)=one/dsqrt(dble(2))
        ptz(0,1)=-one/dsqrt(dble(2))
        elseif (iptz.eq.6) then ! y z*
          ptz(-1,0)=-one*coni/dsqrt(dble(2))
        ptz(1,0)=-one*coni/dsqrt(dble(2))
        elseif (iptz.eq.8) then ! y* z
          ptz(0,-1)=one*coni/dsqrt(dble(2))
        ptz(0,1)=one*coni/dsqrt(dble(2))
      endif


        else
          stop 'alien modus in inieln'
        endif


      return
      end

      subroutine radint (ifl, mult, bf, kinit, dgc0, dpc0, ikap, p, q,
     1   pn, qn, ri, dx, ilast, iold, xrc, xnc, xrcold, xncold, xirf)
c     performs radial integration for multipole matrix element
c     or central atom absorption depending on flag 'ifl'.
      implicit double precision (a-h, o-z)

c     INPUT
c     ifl - number corresponds to the calling order in xsect.f
c         - 1 - calculate matrix element (rkk)
c         - -1 - calculate matrix element (rkk) in nonrelativistic limit
c         - 2 - calculate cross section (xsec)
c             cross term needed for spin-dependent potential only
c         - 3 - cross term (xsec) with irregular part for current kappa
c         - 4 - cross term (xsec) with regular part for current kappa
c     mult - specifies multipole transition
c     bf - bessel functions for x-ray k-vector for l=0,1,2
c     kinit - initial kappa
c     dgc0,dpc0 - large (small) dirac components for initial orbital 
c     ikap  = final state kappa
c     p,q   Dirac components for regular (R) final state solution
c     pn,qn  Dirac components for irregular(N) final state solution
c     ri,dx - radial grid
c     ilast - last integration point
c     iold  - 0 - do nothing to xrcold, xncold (ic3=0 case)
c             1 - store intermediate results in xrcold, xncold (ic3=1)
c             2 - use intermediate results in xrcold, xncold (ic3=1)
c
c     OUTPUT
c     xrcold,xncold - coupling to regular (R) and irregular(N) solutions
c                     both output and input
c     xirf  - value of the radial integral

      include '../HEADERS/dim.h'
      dimension ri(nrptx), dgc0(nrptx), dpc0(nrptx)
      dimension bf(0:2, nrptx)
      complex*16 p(nrptx), q(nrptx), pn(nrptx), qn(nrptx)
c     storage for calculation of cross term (SPIN 1 only)
      complex*16 xrcold(nrptx) , xncold(nrptx)
      complex*16  xirf, temp

c     local staff
      complex*16  xm(4)
      complex*16 xrc(nrptx), xnc(nrptx)
      complex*16 coni
      parameter (coni = (0.d0, 1.d0))

      temp = (1.,0.)

      linit = kinit
      if (kinit.lt.0) linit = - kinit - 1
      lfin = ikap
      if (ikap.lt.0) lfin = - ikap - 1
c     set multipliers  from Grant,Advan.Phys.,v.19,747(1970) eq. 6.30,
c     using Messiah's "Q.M." appendices to calculate 9j,3j symbols
      if (ifl.lt.0) then
        ji2 = 2*abs(kinit)-1
        jf2 = 2*abs(ikap)-1
        if (mult.eq.0 .or. mult.eq.2) then
           ll = 1
           if (mult.eq.2) ll = 2
           ll2 = 2*ll
           temp = sqrt(dble((ji2+1)*(jf2+1))) *cwig3j(jf2,ll2,ji2,1,0,2)
c          sign of temp is (-)**(j+1/2): compare eq. 6.2 and 6.30 
c          of Grant, Adv. Phys. 19, 747 (1970).
           temp = temp * (-1)**(abs(ikap))
           ls = ll-1
           xm(1) = temp * (ll2+1) *coni**ls *(2*ls+1) *
     1     cwig3j(ls,1,ll,0,0,1) * cwig3j(ls,1,ll,0,1,1)
           ls = ll+1
           xm(3) = 0
c          xm(3) = temp * (ll2+1) *coni**ls *(2*ls+1) *
c    1     cwig3j(ls,1,ll,0,0,1) * cwig3j(ls,1,ll,0,1,1)
        else
c          if (mult.eq.1) then
           stop 'not set up for M1 transition in nonrelativistic limit'
        endif
      elseif (mult.eq.0) then
        call xmult( ikap, kinit, 0, 1, xm(1), xm(2))
        call xmult( ikap, kinit, 2, 1, xm(3), xm(4))
      else
        xm(3) = 0
        xm(4) = 0
        if (mult.eq.2) then
          call xmult( ikap, kinit, 1, 2, xm(1), xm(2))
        else
c         mult=1 - M1 transition
          call xmult( ikap, kinit, 1, 1, xm(1), xm(2))
        endif
      endif

c     radial integrals depending on case
      ia = abs(ifl)
      is = ifl /ia
      if (ia.eq.1) then
c       single radial integral for rkk - reduced matrix elements
c       xirf = <f |p| i> relativistic version of dipole m.e.
        do 10  i = 1, ilast
          xnc(i) = 0.0d0
          if (is.gt.0) then
           call xrci(mult,xm,dgc0(i),dpc0(i),p(i),q(i),bf(0,i),xrc(i))
          else
c          nonrelativistic case 
           if (mult.eq.0) then
             temp = xm(1)*bf(0,i)+ xm(3)*bf(2,i)
           elseif (mult.eq.2) then
             temp = xm(1)*bf(1,i)
           endif
           temp = temp *coni
           xrc(i) = ri(i) * (dgc0(i)*p(i) + dpc0(i)*q(i)) *temp
c          xrc(i) = ri(i) * (dgc0(i)*p(i) ) *temp
          endif

c         store xrc if needed
          if (iold.eq.1) xrcold(i) = xrc(i)
  10    continue
        xirf=lfin+linit+2
        if (mult.gt.0) xirf = xirf + 1
        call csomm (ri, xrc, xnc, dx, xirf, 0, ilast)
      else
c       need to perform double radial integral in all cases below
        if (ia.eq.2) then
c         combine regular(kdif) and irregular(kdif) solution into
c         the central atom absorption coefficient xsec (mu = dimag(xsec))
c         thus for real energy dimag(xsec)=xsnorm
          do 20  i = 1, ilast
           if (is.gt.0) then
           call xrci(mult,xm,dgc0(i),dpc0(i),pn(i),qn(i),bf(0,i),xnc(i))
           call xrci(mult,xm,dgc0(i),dpc0(i),p(i),q(i),bf(0,i),xrc(i))
           else
c            nonrelativistic case 
             if (mult.eq.0) then
               temp = xm(1)*bf(0,i)+ xm(3)*bf(2,i)
             elseif (mult.eq.2) then
               temp = xm(1)*bf(1,i)
             endif
             temp = temp*coni
             xrc(i) = ri(i) * (dgc0(i)*p(i) + dpc0(i)*q(i)) *temp
             xnc(i) = ri(i) * (dgc0(i)*pn(i) + dpc0(i)*qn(i)) *temp
c            xrc(i) = ri(i) * (dgc0(i)*p(i) ) *temp
c            xnc(i) = ri(i) * (dgc0(i)*pn(i) ) *temp
           endif
c           store irregular contribution for later use
            if (iold.eq.1) xncold(i) = xnc(i)
  20      continue
        elseif (ifl.eq.3 .and. iold.eq.2) then
c         combine regular(k1) and irregular (kdif) solutions into the
c         central atom absorption coefficient xsec (mu = dimag(xsec))
c         nonzero only for |ispin=1| and same angular momenta in k1,kdif
          do 30  i = 1, ilast
            xrc(i)= xrcold(i)
           call xrci(mult,xm,dgc0(i),dpc0(i),pn(i),qn(i),bf(0,i),xnc(i))
  30      continue
        elseif(ifl.eq.4 .and. iold.eq.2) then
c         combine regular(kdif) and irregular (k1) solutions into the
c         central atom absorption coefficient xsec (mu = dimag(xsec))
c         nonzero only for |ispin=1| and same angular momenta in k1,kdif
          do 40  i = 1, ilast
            call xrci( mult,xm,dgc0(i),dpc0(i),p(i),q(i),bf(0,i),xrc(i))
            xnc(i) = xncold(i)
  40      continue
        endif

c       same staff for all double integrals
        if ((iold.eq.0.and.ia.eq.2) .or. (ifl.gt.2.and.iold.eq.2)) then
c          do radial integration for r'>r first
c          power of xrc near zero
           lpwr = lfin + linit +2
c          factor 2 since integral(r<r')=integral(r>r')
           xirf = 2 * xrc(1) * ri(1) /(lpwr+1)
           xnc(1) = xnc(1) * xirf
           do 70 i = 2, ilast
             xirf = xirf + (xrc(i-1)+xrc(i)) * (ri(i)-ri(i-1))
             xnc(i) = xnc(i) * xirf
  70       continue
           do 80 i = 1,ilast
  80       xrc(i) = 0
           xirf = lpwr+1+linit+1-lfin
c          ready for second integral over r from 0 to \infty
           call csomm (ri, xrc, xnc, dx, xirf, 0, ilast)
        endif
      endif

      return
      end

      subroutine xrci( mult, xm, dgc0, dpc0, p, q, bf, value)
c     r-dependent multipole matrix element (before r-integration)
      implicit double precision (a-h, o-z)
      complex*16 xm(4), p, q, value
      dimension bf(0:2)

      if (mult.eq.0) then
c       el. dipole transition with both j0 and j2 contributions
        value = dgc0*q* (xm(2)*bf(0) + xm(4)*bf(2)) +
     1         dpc0*p* (xm(1)*bf(0) + xm(3)*bf(2))
       else
         value = (xm(2)*dgc0*q+xm(1)*dpc0*p) * bf(1)
       endif

      return
      end

      subroutine ovrlp (iph, iphat, rat, iatph, novr, iphovr,
     1                nnovr, rovr, iz, nat, rho, dmag,
     2                rhoval, vcoul, edens, edenvl, vclap, rnrm)

c     Overlaps coulomb potentials and electron densities for current
c     unique potential
      implicit double precision (a-h, o-z)

      include '../HEADERS/const.h'
      include '../HEADERS/dim.h'

      dimension iphat(natx)
      dimension rat(3,natx)
      dimension iatph(0:nphx)
      dimension novr(0:nphx)
      dimension iphovr(novrx,0:nphx)
      dimension nnovr(novrx,0:nphx)
      dimension rovr(novrx,0:nphx)
      dimension iz(0:nphx)
      dimension rho(251,0:nphx+1), dmag(251,0:nphx+1)
      dimension vcoul(251,0:nphx+1), rhoval(251,0:nphx+1)
      dimension edens(251,0:nphx), edenvl(251,0:nphx)
      dimension vclap(251,0:nphx)
      dimension rnrm(0:nphx)
c#mn
       external dist

c     start with free atom values for current atom
      do 100  i = 1, 251
         vclap(i,iph) = vcoul(i,iph)
         edens(i,iph) = rho  (i,iph)
         
cc       investigate effect of central atom spin only
c        if (iph.ge.1) dmag(i,iph) = 0.0

         edenvl(i,iph) = rhoval  (i,iph)
  100 continue

      if (novr(iph) .gt. 0)  then
         do 104  iovr = 1, novr(iph)
            rnn  = rovr(iovr,iph)
            ann  = nnovr(iovr,iph)
            infr = iphovr(iovr,iph)
            call sumax (rnn, ann, vcoul(1,infr), vclap(1,iph))
            call sumax (rnn, ann, rho  (1,infr), edens(1,iph))
            call sumax (rnn, ann, rho  (1,infr), edenvl(1,iph))
  104    continue
      else
c        Do overlapping from geometry with model atom iat
         iat = iatph(iph)

c        overlap with all atoms within r overlap max (rlapx)
c        12 au = 6.35 ang  This number pulled out of a hat...
         rlapx = 12
c        inat is Index of Neighboring ATom
         do 110  inat = 1, nat
c           don't overlap atom with itself
            if (inat .eq. iat)  goto 110

c           if neighbor is too far away, don't overlap it
            rnn = dist (rat(1,inat), rat(1,iat))
            if (rnn .gt. rlapx)  goto 110

            infr = iphat(inat)
            call sumax (rnn, one, vcoul(1,infr), vclap(1,iph))
            call sumax (rnn, one, rho  (1,infr), edens(1,iph))
            call sumax (rnn, one, rho  (1,infr), edenvl(1,iph))
cala        call sumax (rnn, one, rhoval(1,infr), edenvl(1,iph))
  110       continue
      endif

c     set norman radius
      call frnrm (edens(1,iph), iz(iph), rnrm(iph))

c     remember ratio dmag/edens , not dmag itself
      do 200 i = 1,251
        if (edens(i,iph) .gt. 0.d0) then
          dmag(i,iph) = dmag(i,iph) / edens(i,iph)
        else
          dmag(i,iph) = 0.d0
        endif
 200  continue

      return
      end

      subroutine ortdat (ia)
c        * orthogonalization by the schmidt procedure*
c the ia orbital is orthogonalized toa all orbitals of the same
c symmetry if ia is positive, otherwise all orbitals of the same
c symmetry are orthogonalized
c        this program uses dsordf
 
      implicit double precision (a-h,o-z)
      common cg(251,30), cp(251,30), bg(10,30), bp(10,30),
     1         fl(30), fix(30), ibgp
      common/comdir/cl,dz,dg(251),ag(10),dp(251),ap(10),bidcom(783)
c  dg,ag,dp,ap are used to exchange data only with dsordf
      common/itescf/testy,rap(2),teste,nz,norb,norbsc
      common/ratom1/xnel(30),en(30),scc(30),scw(30),sce(30),
     1nq(30),kap(30),nmax(30)
      common/tabtes/hx,dr(251),test1,test2,ndor,np,nes,method,idim
c#mn
       external dsordf
 
      m=norb
      l= max(ia,1)
      if (ia.gt.0) go to 11
 5    m=l
      l=l+1
      if (l.gt.norb) go to 999
 11   do 15 i=1,idim
         dg(i)=0.0d 00
 15      dp(i)=0.0d 00
      maxl=nmax(l)
      do 21 i=1,maxl
         dg(i)=cg(i,l)
 21      dp(i)=cp(i,l)
      do 25 i=1,ndor
         ag(i)=bg(i,l)
 25      ap(i)=bp(i,l)
      do 51 j=1,m
         if (j.eq.l.or.kap(j).ne.kap(l)) go to 51
         max0=nmax(j)
         a=dsordf (j,j,0,3,fl(l))
         do 41 i=1,max0
            dg(i)=dg(i)-a*cg(i,j)
 41         dp(i)=dp(i)-a*cp(i,j)
         do 45 i=1,ndor
            ag(i)=ag(i)-a*bg(i,j)
 45         ap(i)=ap(i)-a*bp(i,j)
         maxl= max(maxl,max0)
 51   continue
      max0= maxl
      nmax(l)=max0
      a=dsordf (l,max0,0,4,fl(l))
      a= sqrt(a)
      do 71 i=1,max0
         cg(i,l)=dg(i)/a
 71      cp(i,l)=dp(i)/a
      do 75 i=1,ndor
         bg(i,l)=ag(i)/a
 75      bp(i,l)=ap(i)/a
      if (ia.le.0) go to 5
 999  return
      end

      subroutine fpf0 ( iz, iholep, srho, dr, hx,
     1     dgc0, dpc0, dgc, dpc, 
     2     eatom, xnel, norb, eorb, kappa)
c      everything is input. output is written in fpf0.dat
c      to be read by ff2afs.f to get scattering amplitude

      use json_module
      implicit double precision (a-h,o-z)
      integer  iunit
      type(json_value),pointer :: fp
      double precision,dimension(81) :: qval, xirfval

      include '../HEADERS/dim.h'
      include '../HEADERS/const.h'
      include '../HEADERS/parallel.h'
c     save central atom dirac components, see comments below.
      dimension dgc0(251), dpc0(251)
      dimension dgc(251, 30, 0:nphx), dpc(251, 30, 0:nphx)
      dimension xnel(30), eorb(30), kappa(30)
      dimension srho(251), dr(251), xpc(251), xqc(251)
      logical open_16
 
c     output arrays
      dimension enosc(13), oscstr(13), index(13)
 
      if (master) then
        open (unit=16, file='fpf0.dat', status='unknown', iostat=ios)
        fpcorr =  -(iz/82.5)**2.37
        write (16,*)  ' atom Z = ', iz
        write (16,10)  eatom *alphfs**2 *5/3, fpcorr,
     1        ' total energy part of fprime - 5/3*E_tot/mc**2'
  10    format (2(1pe19.5), a)
        open_16 = .true.
        
        call json_value_create(fp)
        call to_object(fp,'fpf0.json')
        call json_value_add(fp, 'iz', iz)
        call json_value_add(fp, 'comment',
     1       'total energy part of fprime - 5/3*E_tot/mc**2')
        call json_value_add(fp, 'etot', eatom *alphfs**2 *5/3)
        call json_value_add(fp, 'fpcorr', fpcorr)
      else
        open_16 = .false.
      endif

c     get oscillator strengths
      do 20 i=1,13
        oscstr(i)=0.d0
        enosc(i)=0.d0
  20  continue
      enosc(1)= eorb(iholep)
      index(1)= iholep
      kinit = kappa(iholep)
      oscstr(1) = 2*abs(kinit)
c     always will use first spot to represent initial state
      nosc=1
      np = 251
      xmult1 = 0.0d0
      xmult2 = 0.0d0
      do 30 iorb =1, norb
        if (xnel(iorb) .gt.0.d0) then
c         it is core orbital, check if it satisfies dipole selection
          jkap = kappa(iorb)
          if (jkap+kinit.eq.0 .or. abs(jkap-kinit).eq.1) then
             nosc = nosc+1
c            calculate reduced dipole matrix element
             kdif= jkap-kinit
             if (abs(kdif).gt.1) kdif=0
c            xirf = <i |p| f> relativistic version of dipole m.e.
c            from Grant,Advan.Phys.,v.19,747(1970) eq. 6.30, using
c            Messiah's "Q.M." appendices to reduce 9j,3j symbols
c            to simple coefficients xmult1,2. ala 12.12.95
             twoj = 2.0d0*abs(kinit) - 1.0d0
             if (kdif.eq.-1 .and. kinit.gt.0) then
                xmult1 = 0.0d0
                xmult2 = sqrt(2.0d0 * (twoj+1)*(twoj-1)/twoj )
             elseif (kdif.eq.-1 .and. kinit.lt.0) then
                xmult1 = 0.0d0
                xmult2 = - sqrt(2.0d0 * (twoj+1)*(twoj+3)/(twoj+2) )
             elseif (kdif.eq. 0 .and. kinit.gt.0) then
                xmult1 = - sqrt( (twoj+1)*twoj/(twoj+2) )
                xmult2 = - sqrt( (twoj+1)*(twoj+2)/twoj )
             elseif (kdif.eq. 0 .and. kinit.lt.0) then
                xmult1 = sqrt( (twoj+1)*(twoj+2)/twoj )
                xmult2 = sqrt( (twoj+1)*twoj/(twoj+2) )
             elseif (kdif.eq. 1 .and. kinit.gt.0) then
                xmult1 = sqrt(2.0d0 * (twoj+1)*(twoj+3)/(twoj+2) )
                xmult2 = 0.0d0
             elseif (kdif.eq. 1 .and. kinit.lt.0) then
                xmult1 = - sqrt(2.0d0 * (twoj+1)*(twoj-1)/twoj )
                xmult2 = 0.0d0
             endif
             xk0 = abs(eorb(iorb)-eorb(iholep)) * alphfs
             do 190  i = 1, np
                xj0 = sin(xk0*dr(i))/(xk0*dr(i))
                xpc(i) = (xmult1*dgc0(i)*dpc(i,iorb,0)+
     1            xmult2*dpc0(i)*dgc(i,iorb,0)) * xj0
                xqc(i) = 0.0d0
  190        continue
c            xirf=lfin+linit+2
             xirf=2
             call somm (dr, xpc, xqc, hx, xirf, 0, np)
             oscstr(nosc) = xirf**2/3.0d0 
             enosc(nosc) = eorb(iorb)
             index(nosc) = iorb
          endif
        endif
  30  continue

c     write down information about oscillators
      if(open_16) then
        write(16, *) nosc
        do 210 i=1,nosc
          write(16,220) oscstr(i), enosc(i), index(i)
  220     format ( f9.5, f12.3, i4)
  210   continue
        call json_value_add(fp, 'nosc',   nosc)
        call json_value_add(fp, 'oscstr', oscstr(1:nosc))
        call json_value_add(fp, 'enosc',  enosc(1:nosc))
        call json_value_add(fp, 'index',  index(1:nosc))
      endif

c     calculate and write out f0(Q) on grid delq=0.5 Angstorm**(-1)
      dq=0.5*bohr 
      do 300 iq = 1,81
         xk0 = dq*(iq-1)
c        srho is 4*pi*density 
         do 560  i = 1, np
            xj0 = 1.d0
            if(iq.gt.1) xj0 = sin(xk0*dr(i))/(xk0*dr(i))
            xpc(i) = srho(i) * (dr(i)**2) *xj0
            xqc(i) = 0.d0
  560    continue
         xirf = 2.d0
         call somm (dr, xpc, xqc, hx, xirf, 0, np)
         if (open_16) then
            write (16, 570) 0.5*(iq-1), xirf
            qval(iq) = 0.5*(iq-1)
            xirfval(iq) = xirf
         endif
  570    format ( f5.1, 1x, f9.4)
  300 continue
      if (open_16) then
        call json_value_add(fp, 'qval',    qval)
        call json_value_add(fp, 'xirfval', xirfval)         
        open(newunit=iunit, file='fpf0.json', status='REPLACE')
        call json_print(fp,iunit)
        close(iunit)
        call json_destroy(fp)
      endif

      if (open_16) close(unit=16)

      return
      end

      subroutine ff2chi (ispec, ipr4, idwopt, critcw, s02, sig2g,
     1     tk, thetad, mbconv, absolu, !KJ added absolu 3-06
     1     vrcorr, vicorr, alphat, thetae, iabs, nabs,
     4     ipmin,ipmax,ipstep) !KJ added this line  1-06
c     adds the contributions from each path and absorber, including
c     Debye-Waller factors. Writes down main output: chi.dat and xmu.dat
      implicit double precision (a-h, o-z)

      include '../HEADERS/const.h'
      include '../HEADERS/dim.h'
      parameter (eps4 = 1.0d-4)
      integer ipmin,ipmax,ipstep  !KJ my variables  1-06
      integer absolu !KJ 3-06

c     header from list.dat
      dimension lhead(nheadx)
      character*80  head(nheadx)

      parameter (npx=15000)
!KJ      parameter (npx = 1200)
c     indices of paths to do, read from list.dat
      dimension ip(npx)
      real sig2u(npx)

      parameter (nfinex = 601)
      complex*16 cchi(nfinex), ckck(nfinex), ccc, ckp
c     to keep Im part of cchi 11.18.97 ala
      dimension rchtot(nfinex)
      complex*16 chia(nfinex)
      dimension xkp(nfinex), xk0(nfinex)

      logical dwcorr
      character*512 slog
      character*2 coment
      parameter (coment='# ')

c     Stuff from feff.pad, note that floating point numbers are
c     single precision.  Be careful throughout this routine, especially
c     when passing things to subroutines or intrinsic functions.
      real rnrmav, xmu, edge
      character*80 title(nheadx)
      character*6  potlbl(0:nphx)
      dimension iz(0:nphx)
c     central atom phase shift at l0
      complex phc(nex)
      complex ck(nex)
      real xk(nex)
      dimension index(npx)
      dimension nleg(npx)
      real deg(npx), reff(npx), crit(npx)
      dimension ipot(legtot,npx)
      real rat(3,legtot,npx), beta(legtot,npx), eta(legtot,npx)
      real ri(legtot,npx)
      real achi(nex,npx), phchi(nex,npx)

c     stuff from xsect.bin
      complex*16 emxs(nex), xsec(nex)
      dimension omega(nex), xkxs(nex), xsnorm(nex)
      dimension omegax(nfinex)
c#mn
      external getxk

c !KJ locals  1-06
      integer iip
      logical cross
      character*9 f1,f2
      character*10 f0,f3
      complex*16 kxsec(nex)
!KJ end my variables


c     lines below allow to skip FMS module for DANES
c     after XANES calculations
      open (unit=1, file='phase.pad', status='old', iostat=ios)
      if (ios.le.0 .and. abs(ispec).eq.3) then
        read(1,*) ne3, ne3, ne3, ne3
      endif
      close (unit=1)


c !KJ loop over iip added to process several spectra at once  1-06
c !KJ reading of feff.pad and list.dat moved inside the loop (used to be before reading
c !KJ xsect.bin
      do iip=ipmin,ipmax,ipstep
        cross=(.not.(iip.eq.1.or.iip.eq.10.or.iip.eq.5.or.iip.eq.9))

c !KJ choose different filename for each spectrum.
        if(iip.eq.1) then
           f1(1:9)='chi.dat  '
           f2(1:9)='xmu.dat  '
           f0(1:10)='feff.pad  '
           f3(1:10)='list.dat  '
        elseif(iip.eq.10) then
           f1(1:9)='chi10.dat'
           f2(1:9)='xmu10.dat'
           f0(1:10)='feff10.bin'
           f3(1:10)='list10.dat'
        elseif(iip.gt.1.and.iip.lt.10) then
           f1(1:4)='chi0'
           f1(5:5)= char(48+iip)
           f1(6:9)='.dat'
           f2(1:4)='xmu0'
           f2(5:5)= char(48+iip)
           f2(6:9)='.dat'
           f0(1:5)='feff0'
           f0(6:6)= char(48+iip)
           f0(7:10)='.bin'
           f3(1:5)='list0'
           f3(6:6)= char(48+iip)
           f3(7:10)='.dat'
        else
           stop 'crazy iip in ff2xmu'
        endif

c     open list.dat and read list of paths we want
      open (unit=1, file = f3, status='old', iostat=ios) !KJ changed 'list.dat' to f3 1-06
      call chopen (ios, f3, 'ff2chi') !KJ id.
      nhead = nheadx
      call rdhead (1, nhead, head, lhead)
c     skip a label line
      read(1,*)
      ntotal = 0
c     ip is index of path, sig2u is debye-waller from user
      do 100  i = 1, npx
         read(1,*,end=110)  ip(i), sig2u(i)
         ntotal = i
  100 continue
  110 continue
      close (unit=1)


c     read 'xsect.bin'
      call  rdxbin (s02p, erelax, wp, edgep, s02, gamach, ne1, ik0,
     2  emxs, omega, xkxs, xsnorm, xsec, nxsec, mbconv, title, ntitle)
c !KJ I have put rdxbin inside the loop since omega is 'recycled' below,
c !KJ which is a problem if the loop executes more than once.
c !KJ Simply reading the file again and again is the lazy solution,
c !KJ but it avoids confusing changes to the code (eg., new variables).

       call rdfbin (f0, nphx, nex, npx, legtot,  !KJ changed 'feff.pad' to f0  1-06
     $      nptot, ne, npot, ihole, iorder, ilinit,
     $      rnrmav, xmu, edge, potlbl, iz, phc, ck, xk, index,
     $      nleg, deg, reff, crit, ipot,
     $      rat, beta, eta, ri, achi, phchi)

c     make combined title
      do 120 ihead = 1, nhead
  120 title(ntitle+ihead) = head(ihead)
      ntitle = ntitle + nhead

c     write feffnnnn.dat
      if (ipr4.eq.3) then
         call feffdt(ntotal,ip,nptot,ntitle,title,ne1,
     $        iorder, ilinit, rnrmav, edge, potlbl,
     $        iz,phc,ck,xk,index,
     $        nleg,deg,reff,crit,ipot,rat,achi,phchi)
       end if

      if (iabs.eq.1) then
c        compare grids in xsect.bin and feff.pad
         do 680 i = 1, nxsec
           del = xk(i)**2 - xkxs(i)**2
           if (abs(ispec).ne.3 .and. abs(del) .gt. 10*eps4)  then
             call wlog(' Emesh in feff.pad and xsect.bin different.')
             call wlog
     1       (' Results may be meaningless, check input files.')
             call wlog
     1       (' Either use XANES card or remove xsect.bin file.')
             write(slog,670)  i, xk(i)/bohr, xkxs(i)/bohr, del
             call wlog(slog)
  670        format(i7, 1p, 3e13.5)
             call par_stop('FF2CHI-1')
           endif
  680    continue
      endif

c     If there is a vicorr, will need a mean free path factor xlam0.
c     Use it as  chi(ie) * exp (2 * reff * xlam0)
c     ckp is ck' = ck prime.
      if (abs(vicorr) .ge. eps4) then
         do 170  ipath = 1, nptot
            do 180  ie = 1, ne
               ckp = sqrt (ck(ie)**2 + coni*2*vicorr)
               xlam0 = aimag(ck(ie)) - dimag(ckp)
               achi(ie,ipath) = achi(ie,ipath) *
     1              real(exp (2 * reff(ipath) * xlam0))
 180        continue
 170     continue
      endif

c     Decide on fine grid.  We need two, k' evenly spaced by
c     delk (0.05 invA) and k0 being the place in the original k
c     grid corresponding to each k'.  k0 will not in general be on
c     an original grid point.  Define k' by k'**2 = k**2 + vr.
c     If there is no real correction (vrcorr = 0), these two grids
c     will be the same.
c           k' is value for output, k0 is k value used for
c           interpolations with original grid.

c     vrcorr shifts the edge and the k grid
      if (abs(vrcorr) .gt. eps4)  then
         edge = edge - real(vrcorr)
      endif

c     Find xkmin, beginning of k' grid
      delk = 0.05 * bohr
      tmp = sign (real(one), xk(1))
      e = tmp * xk(1)**2 / 2 + vrcorr
      xkpmin = getxk (e)
      n = int(xkpmin / delk)
c     need 1st int ABOVE xkpmin/delk
      if (xkpmin .gt. 0)  n = n + 1
c     First k grid point moved by vrcorr
      xkmin = n * delk

c     Make xkp (k') and xk0 (k0) fine grids
c     ik0 is index at fermi level
      if (abs(ispec).ne.3) ik0 = 1
      ik0p = 1
      do 250  i = 1, nfinex
         xkp(i) = xkmin + delk * (i - 1)
         tmp = sign (one, xkp(i))
         e = tmp * xkp(i)**2 /2 - vrcorr
         xk0(i) = getxk(e)
         if (xk0(i).lt.eps4)  ik0p = i
         if (xk0(i) .gt. xk(ne1)+eps4)  goto 260
         nkx = i
  250 continue
  260 continue

      dwcorr = .false.
      if (tk .gt. 1.0e-3)  dwcorr = .true.

c     Open chi.dat and xmu.dat (output) and start headers
      if (iabs.eq.nabs) then
         open (unit=3, file=f1, status='unknown', iostat=ios) !KJ changed chi.dat to f1 1-06
         call chopen (ios, f1, 'ff2chi') !KJ id.
         open (unit=8, file=f2, status='unknown', iostat=ios) !KJ changed xmu.dat to f2  1-06
         call chopen (ios, f2, 'ff2chi') !KJ id.

c        write miscellaneous staff into headers  !KJ corrected typo
         call wrhead (3, ntitle, title, dwcorr, s02,
     1        tk, thetad, sig2g, alphat, vrcorr, vicorr, critcw)

         call wrhead (8, ntitle, title, dwcorr, s02,
     1        tk, thetad, sig2g, alphat, vrcorr, vicorr, critcw)

c        also write information on the screen
         if (alphat .gt. zero)  then
            write(slog,322) alphat
  322       format ('    1st and 3rd cumulants, alphat = ', 1pe20.4)
            call wlog(slog)
         endif
         if (abs(vrcorr).ge.eps4 .or. abs(vicorr).ge.eps4)  then
            write(slog,343) vrcorr*hart, vicorr*hart
  343       format ('    Energy zero shift, vr, vi ', 1p, 2e14.5)
            call wlog(slog)
         endif

         write(slog,370) critcw
         call wlog(slog)
  370    format ('    Use all paths with cw amplitude ratio', f7.2, '%')
         if (dwcorr)  then
            write(slog,380) s02, tk, thetad, sig2g
  380       format('    S02', f7.3, '  Temp', f8.2, '  Debye temp',f8.2,
     1           '  Global sig2', f9.5)
            call wlog(slog)
         else
            write(slog,381) s02, sig2g
  381       format('    S02', f7.3, '  Global sig2', f9.5)
            call wlog(slog)
         endif
      endif


c     make chi and sum it
      do 400  i = 1, nfinex
         cchi(i) = 0
  400 continue

c     add Debye-Waller factors
      call dwadd (ntotal, nptot, idwopt, ip, index, crit, critcw, sig2g,
     1  sig2u, dwcorr, rnrmav, nleg, deg, reff, iz, ipot,rat, tk,thetad,
     2  alphat, thetae, mbconv, s02, ne1, ck, achi, phchi, nkx, xk, xk0,
     3  xkp, cchi, iabs, nabs, ispec, ipr4, ntitle,
     4  title, vrcorr, vicorr, nused)

c     read or initialize chia - result of configuration average
      if (iabs.eq.1) then
         do 635 ie =1, nfinex
            chia(ie) = 0
  635    continue
      else
         open (unit=1, file='chia.bin', status='old',
     1   access='sequential', form='unformatted', iostat=ios)
         do 640 ie = 1,nkx
  640    read(1) chia(ie)
         close (unit=1, status='delete')
      endif

c     add contribution from an absorber iabs
c     present scheme assumes that xsec is the same for all iabs.
      do 701 ik = 1, nkx
         chia(ik)   = chia(ik)   + cchi(ik)/ nabs
  701 continue
      if (iabs.lt.nabs) then
c        save chia in chia.bin for averaging
         open (unit=1, file='chia.bin', status='unknown',
     1   access='sequential', form='unformatted', iostat=ios)
         do 760 ie=1,nkx
  760    write(1) chia(ie)
         close(unit=1)
      endif

      if (iabs.eq.nabs) then
c        the loop over absorbers finished, ready to report results

c        Write it out
         write(3,600)  coment, nused, ntotal
         write(8,600)  coment, nused, ntotal
  600    format (a2, 1x, i4, '/', i4, ' paths used')
         write(3,610) coment
  610    format (a2, 1x, 71('-'))
         write(3,620) coment
  620    format(a2,
     1         '      k          chi          mag           phase @#')

         do 702 ik = 1, nkx
           if (abs(ispec).ne.3) then
            rchtot(ik) = dimag (chia(ik))
           else
            rchtot(ik) = dble (chia(ik))
           endif
  702    continue
c        prepare the output grid omegax
         efermi = edge + omega(1) - dble(emxs(1))
         do 590  ik = 1, nkx
            if (xkp(ik) .lt. 0.0) then
               omegax(ik) = - xkp(ik) * xkp(ik) / 2  + efermi
            else
               omegax(ik) = xkp(ik) * xkp(ik) / 2  + efermi
            endif
  590    continue

c        do convolution with excitation spectrum
c        it is currently screwed up since xsnorm is rewritten
c        fix later
         if (mbconv .gt. 0) then
            wp = wp / 2.
            call  exconv
     1      (omega, ne1, efermi, s02p, erelax, wp, xsnorm)
            call  exconv
     1      (omegax, nkx, efermi, s02p, erelax, wp, rchtot)
         endif


c        write to 'chi.dat'
         do 660 ik = 1, nkx
            ccc = chia(ik)
            phase = 0
            if (abs(ccc) .gt. 0)  then
               phase = atan2 (dimag(ccc), dble(ccc))
            endif
            if (ik .gt. 1)  call pijump (phase, phase0)
            phase0 = phase
            if (ipr4.ne.4) then
              write(3,630)  xkp(ik)/bohr, rchtot(ik), abs(ccc), phase0
  630         format (1x, f10.4, 3x, 3(1pe13.6,1x))
            else
c             need to report ck into chi.dat for Conradson's program
c             complex*16 should be used in terpc
              do 625 i=1,ne
  625         ckck(i) = dble(real(ck(i))) +coni*dble(aimag(ck(i)))
              call terpc (xkxs, ckck, ne, 3, xk0(ik), ckp)
              write(3,650)  xkp(ik)/bohr, rchtot(ik), abs(ccc), phase0,
     1        dble(ckp)/bohr, dimag(ckp)/bohr
  650         format (1x, f10.4, 3x, 5(1pe13.6,1x))
            endif
  660    continue
         close (unit=3)

c        write to 'xmu.dat'
c        normalize to xsec at 50 eV above edge
c        and prepare the output energy grid omegax
         edg50 = efermi + 50 / hart
         call terp (omega, xsnorm,  ne1, 1, edg50, xsedge)
         if (absolu.eq.1) xsedge=dble(1) !KJ 1-06 don't normalize
         write(8,690)  coment, xsedge
  690    format (a2, ' xsedge+50, used to normalize mu ', 1pe20.4)
         write(8,610) coment
         write(8,695) coment
  695    format (a2,' omega    e    k    mu    mu0     chi     @#')

         do i=1,nex
            if (.not.cross) then !KJ I added this block 1-06
               kxsec(i)=xsec(i)
            else
               kxsec(i)=dcmplx(0,0)
            endif               !KJ end my code
         enddo

c        do edge correction and write down results to xmu.dat, chi.dat
         do 710 ie = 1, ne
  710    chia(ie) = 0
         if (abs(ispec).eq.3) then
c          transform from cross section in Angstrom**2 to f"/m*c**2
           do 697 ie = 1,ne
             energy = dble(emxs(ie)) + efermi
             prefac = 4 * pi * alpinv / energy * bohr**2
c            add alpha**2 to convert to units for f'
             kxsec(ie) = kxsec(ie) / prefac * alpinv**2   !KJ changed xsec to kxsec  1-06
             xsnorm(ie) = xsnorm(ie) / prefac * alpinv**2
  697      continue
           ne2 = ne - ne1 - ne3
           call fprime(efermi, emxs, ne1, ne3,ne,ik0, kxsec,xsnorm,chia,
     1       vrcorr, vicorr, cchi)  !KJ changed xsec to kxsec 1-06
           do 850 ie=1,ne1
             omega(ie) = dble(cchi(ie))
  850      continue
         else
           call xscorr (ispec, emxs, ne1, ne, ik0, kxsec, xsnorm, chia,
     1       vrcorr, vicorr, cchi) !KJ xsec to kxsec 7/06
c          omega is not used as energy array, but as xsec array below
           do 711 ie = 1, ne1
  711      omega(ie) = dimag(kxsec(ie)+cchi(ie))  !KJ xsec to kxsec 7/06
         endif

         do 750  ik = 1, nkx
            em0 = omegax(ik) - efermi + edge
            call terp (xkxs, omega,  ne1, 1, xk0(ik), xsec0)
            call terp (xkxs, xsnorm,  ne1, 1, xk0(ik), xsnor0)
            if (omegax(ik).ge.efermi) then
              chi0 = xsnor0 * rchtot(ik)
            else
              chi0 = xsnor0 * rchtot(ik0p)
            endif
            if (abs(ispec).ne.3) then
              write(8,700)  omegax(ik)*hart, em0*hart, xkp(ik)/bohr,
     1              ( chi0 + dble(xsec0) )/xsedge,
     1              xsec0 /xsedge, rchtot(ik)
            else
c             signs to comply with Cromer-Liberman notation for f', f"
              write(8,700)  omegax(ik)*hart, em0*hart, xkp(ik)/bohr,
     1             -(xsec0+chi0), -xsec0, -chi0
            endif
  700       format (1x, 2f11.3, f8.3, 1p, 3e13.5)
  750    continue
         close (unit=8)
      endif
c     for if (iabs=abs); or the last absorber


      enddo !KJ of my iip=ipmin,ipmax,ipstep loop   1-06

      return
      end

      subroutine broydn( iscmt, ca, nph, xnvmu,
     1          ilast, xnatph, rnrm, qnrm, edenvl, rhoval, dq)
c     calculates new density using Broyden algorithm
c     (J.Phys.A, 17,L317(1984))
c     
c      Also handes the charge inside each norman sphere properly.
c     INPUT:
c       ca     - convergence accelerator factor
c       rhoval - new density from integration up to mu
c       edenvl - old valence density
c       qnrm   - the charge inside each norman sphere
c       xnvmu  - valence electron counts in getorb.f
c       also some information from feff.inp file.(nph,etc.)
c     Output:
c       rhoval - new valence density after mixing
c                notice that at input rhoval = density*4*pi*r**2
c       dq     - change of the charge inside each norman sphere
      implicit double precision (a-h, o-z)

      include '../HEADERS/const.h'
      include '../HEADERS/dim.h'

      dimension ilast(0:nphx),xnatph(0:nphx), xnvmu(0:lx, 0:nphx+1)
      dimension ri05(251)
      dimension rhoval(251,0:nphx+1), edenvl(251,0:nphx)
      dimension dq(0:nphx)
      dimension qnrm(0:nphx), rnrm(0:nphx)

c     work space
      dimension xpc(251)
c     work space for Broyden algorithm
      parameter (nbr=30)
      dimension cmi(nbr,nbr), frho(251,0:nphx,nbr), urho(251,0:nphx,nbr)
      dimension xnorm(nbr), wt(251), rhoold(251,0:nphx)
      save cmi, frho, urho, xnorm, wt, rhoold, ri05

c     make  radial grid with 0.05 step
      dx05=0.05d0
      if(iscmt.eq.1) then
        do 10 i=1,251
           ri05(i) = exp(-8.8d0+dx05*(i-1))
           wt(i) = ri05(i)**3
  10    continue
      endif

c     record F(\rho_i)
      do 30 iph = 0, nph
      do 30 ir = 1, ilast(iph)
        frho(ir,iph,iscmt)=rhoval(ir,iph)*ri05(ir)-edenvl(ir,iph)*wt(ir)
  30  continue

c     dq here is set to the total number of valence electron for
c     the initial (atomic overlap) density inside corresponding
c     norman sphere, and xnferm is  the total number for the cluster.
      xnferm = 0
      do 330 ip= 0,nph
        dq(ip) = 0
        do 320 il = 0,lx
         dq(ip) = dq(ip) + xnvmu(il, ip)
 320    continue
        xnferm = xnferm + dq(ip)*xnatph(ip)
 330  continue 

      if (iscmt.gt.1) then
c       get normalization factor
        xnorm(iscmt) = 0
        do 510 iph = 0, nph
        do 510 ir = 1,ilast(iph)
          xnorm(iscmt) = xnorm(iscmt) +
     1    (frho(ir,iph,iscmt)-frho(ir,iph,iscmt-1))**2
  510   continue

c       calculate c_m,i
        do 530 j = 2, iscmt
          cmi(iscmt,j) = 0
          do 520 iph = 0, nph
          do 520 ir = 1,ilast(iph)
            cmi(iscmt,j) = cmi(iscmt,j) + frho(ir,iph,iscmt) *
     1      (frho(ir,iph,j)-frho(ir,iph,j-1))
  520     continue
          cmi(iscmt,j) = cmi(iscmt,j)/xnorm(j)
  530   continue

c       calculate U_i - vector of lagrange multipliers
        do 550 iph = 0, nph
        do 550 ir = 1,ilast(iph)
         urho(ir,iph,iscmt)=ca*(frho(ir,iph,iscmt)-frho(ir,iph,iscmt-1))
     1     + (edenvl(ir,iph) - rhoold(ir,iph))*wt(ir)
  550   continue

        do 570 j = 2, iscmt-1
        do 570 iph = 0, nph
        do 570 ir = 1,ilast(iph)
          urho(ir,iph,iscmt)= urho(ir,iph,iscmt) - urho(ir,iph,j) *
     1      (cmi(iscmt,j)-cmi(iscmt-1,j))
  570   continue
      endif

c     construct new density, finally
      do 600 iph = 0, nph
      do 600 ir = 1, ilast(iph)
        rhoold(ir,iph) = edenvl(ir,iph)
        rhoval(ir,iph) = edenvl(ir,iph) + ca*frho(ir,iph,iscmt)/wt(ir)
        do 610 j = 2, iscmt
  610   rhoval(ir,iph)=rhoval(ir,iph)-cmi(iscmt,j)*urho(ir,iph,j)/wt(ir)
  600 continue

c     calculate e charge inside norman sphere
c     dq - extra number of e (charge transfer) 
      x0 = 8.8d0
      dqav=0.0d0
      xnat = 0.d0
      do 700 iph = 0, nph
        jnrm =  int((log(rnrm(iph)) + x0) / dx05)  +  2
        i0=jnrm+1
        xirf = 2
        do 710 ir = 1, ilast(iph)
           xpc(ir) = rhoval(ir,iph)*ri05(ir)**2
  710   continue
        call somm2 (ri05, xpc, dx05, xirf, rnrm(iph),0,i0)
c       dq is how many new electrons are within norman sphere
        dq(iph) = xirf - qnrm(iph) - dq(iph)
        dqav=dqav+xnatph(iph)*dq(iph)
        xnat = xnat + xnatph(iph)
  700 continue


c     to keep charge neutrality add/subtract part of previous density
      aa = dqav/xnferm
      dqav=dqav/xnat
      do 800 iph = 0, nph
        dq(iph) = dq(iph) - dqav
        qnrm(iph) = qnrm(iph) + dq(iph)
        do 810 ir = 1, ilast(iph)
  810   rhoval(ir,iph) = rhoval(ir,iph) - aa*edenvl(ir,iph)
  800 continue

      return
      end

      subroutine json_nnnn(fjson, ntit, titles, rat, ipot, ri, beta,eta,
     &          index, iorder, nleg, deg, reff, rnrmav, edge,
     &          ne, col1, col2, col3, col4, col5, col6, col7)
c+----------------------------------------------------------------------
c  Write a JSON file conatining all the information of a traditional
c  feffNNNN.dat file.
c
c  The keys for the entries in the JSON file are chosen to be the same 
c  as the corresponding attributes in a Larch FeffPath or _feffdat group
c  See http://xraypy.github.io/xraylarch/xafs/feffpaths.html#feffpath-and-feffpath-groups
c
c  Much of the header of a traditional feffNNNN.dat file is stored as
c  an array of text strings.  Degeneracy, nleg, and Reff have their
c  own keys in the JSON.
c
c  The leg lengths and beta & eta angles are also included in the JSON
c
c  Also included are the atom positions of the atoms in the path.  The
c  keys are "atomN" where N is an integer from 1 to nleg.  Each is a 
c  4-element array containing x,y,z,ipot of the atom.  Note that the
c  ipot is stored as a double and will have to be converted back to an
c  integer when imported.
c
c  fjson contains the path/name of the output JSON file
c
c  the colN inputs are the columns of the traditional feffNNNN.dat file.
c  they are computed in GENFMT/fdtarr.f
c+----------------------------------------------------------------------

      use json_module

      implicit double precision (a-h, o-z)
      include '../HEADERS/vers.h'
      include '../HEADERS/dim.h'
      include '../HEADERS/const.h'
      parameter (eps = 1.0D-8)

      character*13 fjson
      character*5  vname
      character*80 titles(nheadx)
      dimension col1(nex), col2(nex), col3(nex), col4(nex), col5(nex)
      dimension col6(nex), col7(nex)
      double precision rat(3,0:legtot+1), atom(4)
      double precision ri(legtot),  beta(legtot+1),  eta(0:legtot+1)
      double precision ria(legtot), betad(legtot+1), etad(0:legtot+1)
      integer ipot(0:legtot)

      integer  iunit
      type(json_value),pointer :: nnnnj
      call json_value_create(nnnnj)
      call to_object(nnnnj,fjson)

      call json_value_add(nnnnj, 'vfeff',   vfeff)
      call json_value_add(nnnnj, 'vf85e',   vf85e)

      call json_value_add(nnnnj, 'titles',  titles(1:ntit))

      call json_value_add(nnnnj, 'index',   index)
      call json_value_add(nnnnj, 'iorder',  iorder)
      call json_value_add(nnnnj, 'nleg',    nleg)
      call json_value_add(nnnnj, 'degen',   deg)
      call json_value_add(nnnnj, 'reff',    reff*bohr)
      call json_value_add(nnnnj, 'rnorman', rnrmav)
      call json_value_add(nnnnj, 'edge',    edge*hart)
c     call json_value_add(nnnnj, 'ne',      ne)

      do 10 i=1,nleg
         ria(i)   = ri(i)*bohr
         betad(i) = beta(i)*180/pi 
         etad(i)  = eta(i)*180/pi 
         if (abs(etad(i)-360) .lt. eps) then
            etad(i) = 0   
         end if
 10   continue
      call json_value_add(nnnnj, 'ri',       ria(1:nleg))
      call json_value_add(nnnnj, 'beta',     betad(1:nleg))
      call json_value_add(nnnnj, 'eta',      etad(1:nleg))
c     call json_value_add(nnnnj, 'ipot',     ipot(0:nleg))

      do 20 iat=1,nleg
         write (vname, "(A4,I1)") "atom", iat
         do 30 ix=1,3
            atom(ix) = rat(ix, iat)*bohr
 30      continue
         atom(4) = dble(ipot(iat))
         call json_value_add(nnnnj, vname, atom)
 20   continue

      call json_value_add(nnnnj, 'k',        col1(1:ne))
      call json_value_add(nnnnj, 'real_phc', col2(1:ne))
      call json_value_add(nnnnj, 'mag_feff', col3(1:ne))
      call json_value_add(nnnnj, 'pha_feff', col4(1:ne))
      call json_value_add(nnnnj, 'red_fact', col5(1:ne))
      call json_value_add(nnnnj, 'lam',      col6(1:ne))
      call json_value_add(nnnnj, 'rep',      col7(1:ne))

      open(newunit=iunit, file=fjson, status='REPLACE')
      call json_print(nnnnj,iunit)
      close(iunit)
      call json_destroy(nnnnj)

      return
      end

      double precision function rotwig (beta, jj, m1, m2, ient)
c     uses Wigner formula (Messiah eq.C.72) to calculate rotation matrix
c     for integers  (ient=1)  or semiintegers (ient=2)
c     other arguments (except beta) should be multiplied by ient
 
      implicit double precision (a-h,o-z)
      parameter (idim = 58)
c     dimensions  modified for larger arguments by ala 12.12.94
      dimension al(idim+1),m(12)
      save ini, al
      data ini/1/
c     idim-1 is the largest argument of factorial to calculate

      if (((ient-1)*(ient-2)).ne.0) stop ' Illegal ient in rotwig.'

      if (ini.eq.1) then
c       initialisation of the log's of the factorials
        ini=0
        al(1)=0.0d 00
        do 11 i=1,idim
           b=i
 11        al(i+1)=al(i)+ log(b)
      endif
      rotwig = 0.d0

      if ( m1.ge.0 .and. abs(m1).ge.abs(m2)) then
         m1p = m1 
         m2p = m2
         betap = beta
         isign = 1
      elseif (m2.ge.0 .and. abs(m2).ge.abs(m1)) then
         m1p = m2
         m2p = m1
         betap = - beta
         isign = 1
      elseif (m1.le.0 .and. abs(m1).ge.abs(m2)) then
         m1p = - m1
         m2p = - m2
         betap = beta
         isign = (-1)**( (m1-m2)/ient ) 
      else
         m1p = - m2
         m2p = - m1
         betap = - beta
         isign = (-1)**( (m2-m1)/ient ) 
      endif

      temp = 0.d0
      zeta = cos ( betap / 2.d0 )
      eta  = sin ( betap / 2.d0 )
      do 100 it = m1p - m2p, jj - m2p, ient
        m(1) = 1 + (jj+m1p) / ient
        m(2) = 1 + (jj-m1p) / ient
        m(3) = 1 + (jj+m2p) / ient
        m(4) = 1 + (jj-m2p) / ient
        m(5) = 1 + (jj+m1p-it) / ient
        m(6) = 1 + (jj-m2p-it) / ient
        m(7) = 1 + it / ient
        m(8) = 1 + (m2p-m1p+it) / ient
        m(9)  = (2*jj+m1p-m2p-2*it) / ient 
        m(10) = (2*it-m1p+m2p) / ient 
        factor = 0.d0
        do 110 i = 1,4
  110     factor = factor + al(m(i))/2.d0 - al(m(i+4))
c       special cases to resolve 0.d0**0 problem (a.ankudinov, may 2001)
        if (m(10).eq.0 .and. m(9).eq.0) then
          temp = temp + (-1)**(it/ient)*exp(factor)
        elseif (m(10).eq.0) then
          temp = temp + (-1)**(it/ient)*zeta**m(9)*exp(factor)
        elseif (m(9).eq.0) then
          temp = temp + (-1)**(it/ient)*eta**m(10)*exp(factor)
        else
c         general expression
          temp = temp+ (-1)**(it/ient)*zeta**m(9)*eta**m(10)*exp(factor)
        endif
  100 continue

      rotwig = isign * temp
     
      return
      end

      SUBROUTINE phmesh2 (iprint, ispec, edge, emu, vi0, gamach,
     &     xkmax, xkstep, vixan, ne, ne1, em, ik0, ne3, iGrid)
!     This subroutine makes the energy mesh used for phases and cross sections,
!     as well as for the fms routine, path, and genfmt. For EXAFS, the final output
!     chi is on a different (usually finer) grid with mu0 interpolated.
!     This will reproduce the old (FEFF84) grids, as well as any combination of user
!     defined energy, k, exponential, or arbitrary (read from file) grids. The input
!     for the user defined grids is read from grid.inp. Details of grid.inp are given
!     in rdgrid.f
      include '../HEADERS/const.h'
      include '../HEADERS/dim.h'

!     Input:
!     iprint - if > 3, print emesh.dat
!     ispec  - controls which grid to use (0=EXAFS,1=XANES,2=XES,3=DANES,4=FPRIME)
!     edge   - This name is misleading and is not the x-ray edge energy.
!              edge = xmu - vr0, where vr0 is given as an the first option in the
!              EXCHANGE card.
!     vi0    - Contant imaginary part added to the potential, second option in the
!              EXCHANGE card.
!     gamach - Core-Hole broadening. Gives an additional constant imaginary part to
!              the potential.
!     xkmax  - maximum k value for EXAFS/XANES calculations. holds emin for f'
!              calculations.
!     xkstep - k-grid spacing for XANES calculations. holds emax for f' calculations
!     vixan  - energy step for FMS calculations (grid is even in energy near edge)
      INTEGER iprint, ispec
      DOUBLE PRECISION edge, emu, vi0, gamach, xkmax, xkstep, vixan
      
!     Output:
!     ne     - Total number of energy points.
!     ne1    - Number of energy points on the horizontal grid.
!     ik0    - point where k=0
!     em(ne) - energy array
      INTEGER ne, ne1, ik0
      COMPLEX*16 em(nex)

!     Local Variables:
!     xloss  - total constant imaginary part of em
!     xim    - energy step near the fermi level
!     deltak - k step
!     emin   - minimum e for exponential grid used by DANES
!     emax   - maximum e for exponential grid used by DANES
!     del    - step for exponential grid
!     ios    - i/o errors
!     nemax  - temp variable to hold max # of energy points
      DOUBLE PRECISION xloss, xim, deltak, emin, emax, del
      INTEGER ios
!     User defined grid variables
!     nGridMax  - max number of grids
!     nGrid     - number of grids.
!     iGridType - Type of grid (1 = energy, 2 = k, 3 = exp)
!     GridMin   - minimum k or E of grid. k for k-grids, e for others
!     GridMax   - Maximum k or E of grid
!     GridStep  - step size.
      INTEGER nGridMax
      PARAMETER(nGridMax=10)
      INTEGER nGrid, iGridType(nGridMax)
      DOUBLE PRECISION GridMin(nGridMax), GridMax(nGridMax),
     &     GridStep(nGridMax)
      
!     Loop Variables:
      INTEGER i1
      DOUBLE PRECISION getxk
      EXTERNAL getxk
!     Initialization
!     Set total imaginary part, must be >= 0.02 eV
      xloss = MAX(gamach/2.d0 + vi0, 0.02/hart)
!     Set energy step to half of imaginary part, or
!     vixan if vixan is set.
      IF(vixan.gt.0.0001) THEN
         xim = vixan
      ELSE
         xim = xloss/2.d0
      END IF

      ik0 = 0
      
      IF(iGrid.eq.0) THEN
!     Use FEFF84 grids
         IF(ispec.eq.0) THEN
            ne = 1
            CALL ExafsGrid84(em, xkmax, ne, nex)
            ne1 = ne
            ik0 = 1
         ELSEIF((ABS(ispec).gt.0).and.(ABS(ispec).lt.4)) THEN
!     Use same grid for XANES, XES, DANES
            CALL XanesGrid84(em, xkmax, xkstep, xim, ne, ik0, nex)            
            ne1 = ne
         ELSEIF(ispec.eq.4) THEN
!     FPRIME
            CALL FPrimeGrid84(em, xkmax, xkstep, vixan, emu, edge, ne,
     &           ne1, ne3, nex)
         END IF
         
!     If ispec is negative, we are not running FMS. Make EXAFS grid
!     for points above the fermi level.
         IF(ispec.lt.0) THEN
            ne = 11
            CALL ExafsGrid84(em, xkmax, ne, nex)
            ne1 = ne
         END IF
      ELSE
!     User defined grids.
         ! Make sure there are enough points left over to make vertical grid etc.
         nemax = nex - 50
         ne = 0
         CALL RdGrid(em,ne,nGrid,iGridType,GridMin,GridMax,GridStep,
     &        nGridMax,nemax)

         DO i1 = 1, nGrid
            IF(iGridType(i1).eq.1) THEN
               ! grid is regular in energy
               ne = ne + 1
               CALL MkEMesh(em, ne, GridMin(i1), GridMax(i1),
     &              GridStep(i1), NPts, nex)
               ne = MIN(ne + NPts, nemax)
            ELSEIF(iGridType(i1).eq.2) THEN
               ! grid is regular in k
               ne = ne + 1
               CALL MkKMesh(em, ne, GridMin(i1), GridMax(i1),
     &              GridStep(i1), NPts, nex)
               ne = MIN(ne + NPts, nemax)
            ELSEIF(iGridType(i1).eq.3) THEN
               ! grid is exponential
               ne = ne + 1
               CALL MkExpMesh(em, ne, GridMin(i1), GridMax(i1),
     &              GridStep(i1), NPts, nex)
               ne = MIN(ne + NPts, nemax)
            END IF
         END DO
         
!        Add a point at E = 0 in case there is not one.
         IF(ne+1.lt.nex) THEN
            em(ne+1) = 0.d0
            ne = ne + 1
         ELSE
            em(ne) = 0.d0
         END IF
!        Now, sort energy grid and remove degenerate points.
         CALL SortE(em,ne,ik0,nex)
         ne1 = ne
      END IF

!     If XES, flip grid about 0.0
      IF(ABS(ispec).eq.2) CALL ReverseGrid(em,ne,0.d0)
         
!     Shift horizontal grid by edge + coni*xloss.
      IF(ispec.ne.4) THEN
         DO i1 = 1, ne
            em(i1) = em(i1) + edge + coni*xloss
         END DO
      END IF

!     If not fprime calculation, make vertical grid
      IF(ispec.ne.4) THEN
         ne = ne + 1
         CALL MkVGrid84(em, ne, xloss, nex)
!     Shift vertical grid by edge.
         DO i1 = ne1+1, ne
            em(i1) = em(i1) + edge
         END DO
      END IF
         
      IF(ABS(ispec).eq.3) THEN
!     DANES: add more points to horizontal grid.
         ne3  = MIN(nex,150) - ne
         emin = DBLE(2*em(ne1)-em(ne1-1))
         emax = 7.d4
         del  = LOG(emax/emin)/(ne3-1)
         ne = ne + 1
         CALL MkExpMesh(em, ne, emin, emax, del, ne3, nex)
         DO i1 = 0, ne3 - 1
            em(ne+i1) = em(ne+i1) + coni*1.d-8
         END DO
         ne = ne + ne3
      END IF      

      IF (iprint .ge. 3)  THEN
         OPEN (unit=44, file='emesh.dat', status='unknown')
         WRITE(44,*) 'edge, bohr, edge*hart ', edge, bohr, edge*hart
         WRITE(44,*) 'ispec, ik0 ', ispec, ik0
         WRITE(44,*) 'ie, em(ie)*hart, xk(ie)'
         DO ie = 1, ne
           WRITE (44,'(i5, 3f20.5)') ie, dble(em(ie))*hart,
     &                   getxk(dble(em(ie))-edge)/bohr
        END DO
         CLOSE(unit=44)
      endif

      RETURN
      END

      SUBROUTINE MkVGrid84(em, ne, xloss, nex)
!     make the vertical grid in energy plane
!     first point is at 0.005 ev, second at 0.01 ev and
!     exponential grid with step 0.4 after that up to 50 eV
      include '../HEADERS/const.h'
!     Input:
!     ne    - first energy point
!     nex   - length of em array
!     xloss - total imaginary part of horizontal grid
      INTEGER ne, nex
      DOUBLE PRECISION xloss

!     Output:
!     ne      - number of energy points
!     em(nex) - energy grid
      COMPLEX*16 em(nex)

!     Local Variables:
!     n1     - number of points in exponential grid
!     estep0 - first two points are at estep0/2 and estep0
!     del    - spacing: em(j) = emin*exp(j*del)
!     expdel - exp(del)
!     emin   - minimum energy in exponential grid.
!     emax   - max energy in exponential grid
      INTEGER n1
      DOUBLE PRECISION estep0, del, expdel, emin, emax

!     Loop Variables:
      INTEGER i1

      estep0 = 0.01/hart
      em(ne) = coni*estep0/2
      em(ne+1) = coni*estep0
      ne = ne + 2
!     Exponential grid em(ne+1*j) = emin*exp(j*del)
!     del = 0.6 is ok for Cu K edge, but needs more testing
      del = 0.4d0

!     n1 is the # of points in a grid defined by estep0*exp(j*del) that lie below xloss.
      n1 = NINT(LOG(xloss/estep0)/del - 0.5)
      if (n1.le.0) n1 = 1

!     Now redefine the grid so that xloss is halfway between em(n) and em(n+1) 
!     Solving
!     xloss = [em(n1) + em(n1+1)]/2 = emin*[exp(n1*del) + exp((n1+1)*del)]/2
!     gives
!     emin = 2*xloss/(1+exp(del))*exp(-n1*del)
      expdel = EXP(del)
      emin = 2*xloss /(1+expdel)/expdel**n1
      if (emin.le.estep0) emin = emin*expdel

c     Josh         if (emin.le.estep0 .or. emin.ge.xloss) 
c     Josh     .     call par_stop(' Bad mesh in phmesh')
c     delk = log (xloss/tempk) /(n1+0.5)

!     Now change grid so that endpoint is at emax.
      emax = MIN(50.d0/hart,20.d0*xloss)
      CALL MkExpMesh(em, ne, emin, emax, del, n1, nex)
      DO i1 = 0, n1
         em(ne+i1) = (0,1)*em(ne+i1)
      END DO
      ne = ne + n1

      RETURN
      END
      
      SUBROUTINE MkExpMesh(em, iStart, emin, emax, del, NPts, nex)
      
      INTEGER iStart, nex
      DOUBLE PRECISION emin, emax, del
      COMPLEX*16 em(nex)
      
      INTEGER NPts

      INTEGER i1

      NPts = NINT( log(emax/emin) / del )

!     Fill grid
      DO i1 = 0, NPts
         em(iStart+i1) = emin*exp(del*i1)
      END DO
         
      RETURN
      END


      SUBROUTINE ExafsGrid84(em, xkmax, ne, nex)
!     Make old (FEFF8.4) grid for EXAFS calculations.
      include '../HEADERS/const.h'
!     Input: 
!     xkmax - maximum k for grid
!     nex   - length of array em
      INTEGER nex
      DOUBLE PRECISION xkmax

!     Output:
!     em(nex) - energy grid array
!     ne      - number of points in energy grid
      COMPLEX*16 em(nex)
      INTEGER ne

!     Local Variables:
!     NPts   - Number of points that have been added to grid after a call
!              to MkKMesh
!     nemax  - maximum number of energy points (100)
!     deltak - k step (used when calling MkKMesh)
!     xkmin  - minimum (k used when calling MkKMesh)
!     xkmax2 - maximum (k used when calling MkKMesh)
      INTEGER NPts, nemax
      DOUBLE PRECISION deltak, xkmin, xkmax2, eps
      PARAMETER (small = 1.d-20)
      nemax = 100

!     20 pts (0 le k le 1.9, delk=0.1 ang(-1) )
      deltak = bohr/10
      xkmin = 0.d0
      xkmax2  = bohr*1.9d0*1.01d0
      CALL MkKMesh(em, ne, xkmin, xkmax2, deltak, NPts, nex)

!     20 pts (2 le k le 5.8, delk=0.2 ang(-1) )
      ne = ne + NPts + 1
      deltak = bohr/5
      xkmin  = bohr*2.d0
      xkmax2 = bohr*5.8d0*1.01d0
      CALL MkKMesh(em, ne, xkmin, xkmax2, deltak, NPts, nex)

!     9 pts (6 le k le 10., delk=0.5 ang(-1) )
      ne = ne + NPts + 1
      xkmin = bohr*6.d0
      xkmax2 = bohr*10.d0*1.01d0
      deltak = bohr*0.5d0
      CALL MkKMesh(em, ne, xkmin, xkmax2, deltak, NPts, nex)

!     make the rest of the points pts with deltak = 1.0 ang(-1)
      ne = ne + NPts + 1
      deltak = bohr
      xkmin = SQRT(2*DBLE(em(ne-1))) + deltak
!     Fill to end of grid, or max # of points.
      NPts = MIN(nemax-ne,NINT((xkmax-xkmin)/deltak)+1)
      xkmax2 = xkmin + (NPts)*deltak*1.01d0
      CALL MkKMesh(em, ne, xkmin, xkmax2, deltak, NPts, nex)
      ne = ne + NPts

      RETURN
      END

      SUBROUTINE XanesGrid84(em, xkmax, xkstep, estep, ne, ik0, nex)
!     Make old (FEFF8.4) grid for XANES calculations.
      include '../HEADERS/const.h'
!     Input: 
!     xkmax  - maximum k for grid
!     xkstep - kstep at high k
!     estep  - estep near the fermi level
!     nex    - length of array em
      INTEGER nex
      DOUBLE PRECISION xkmax, xkstep, estep

!     Output:
!     emin    - -xim*n1
!     em(nex) - energy grid array
!     ik0     - zero point for k grid
      INTEGER ne
      COMPLEX*16 em(nex)

!     Local Variables:
      INTEGER n1, n2, nk, nemax, NPts
      DOUBLE PRECISION emin, emax, xkmin, dk, xkmax2
!     Make 10 points below fermi level
      nemax = 10
!     double k step below fermi level 
      dk = 2*xkstep
!     Not sure why to pick this number of steps regular in e?
      n1 = INT(estep/2/dk**2)
!     n2 is starting point of k grid minus 1 (int(k(emax)/dk) + 1)
      n2 = INT(SQRT(n1*2*estep)/dk)
!     If we can fit one more point in the egrid, do it
      If( (dk*(n2+1))**2 .gt. (n1+1)*2*estep ) n1 = n1+1

!     Make sure we don't use more than nemax points
      n1 = MIN(n1,nemax)
!     nk is number of points in k grid
      nk = nemax - n1

!     Fill k grid
      xkmin = -dk*(n2+nk)
      xkmax2 = -dk*(n2+1)
      ne = 1
      CALL MkKMesh(em, ne, xkmin, xkmax2, dk, nk, nex)  
      
!     Fill e grid
      ne = ne + nk + 1
      emin = -estep*n1
      emax = 0.d0
      CALL MkEMesh(em, ne, emin, emax, estep, NPts, nex)
      ne = ne + NPts + 1
      ik0 = ne
!     Fill grid above the fermi level.
!     Same grid as before except that k spacing is xkstep, and 90 points
      nemax = 90
!     Not sure why to pick this number of steps regular in e?
      n1 = INT(estep/2/xkstep**2)
!     n2 is starting point of k grid minus 1
      n2 = INT(SQRT(n1*2*estep)/xkstep)
      n1 = n1 + 1
!     If we can fit one more point in the egrid, do it
      If( (xkstep*(n2+1))**2 .gt. (n1)*2*xim ) n1 = n1+1
!     Make sure we don't use more than nemax points
      n1 = MIN(n1,nemax)

!     nk is number of points in k grid
      nk = nemax - n1

!     This time fill e grid first
      emin = estep
      emax = (n1-1)*estep
!     If k(emax) > xkmax set emax = e(xkmax) and nk = 0
      IF(SQRT(2*emax).gt.xkmax) THEN
         emax = xkmax**2/2
         nk = 0
      END IF
      CALL MkEMesh(em, ne, emin, emax, estep, NPts, nex)
 
!     Now fill k grid
      ne = ne + NPts + 1
      xkmin = xkstep*(n2+1)
      xkmax2 = xkstep*(n2+nk)
!     if xkmax2 > xkmax, set xkmax2 = xkmax
      IF(xkmax2.gt.xkmax) xkmax2 = xkmax
      CALL MkKMesh(em, ne, xkmin, xkmax2, xkstep, NPts, nex)  
      ne = ne + NPts
      
      RETURN
      END
      
      SUBROUTINE FPrimeGrid84(em,emin,emax,estep,emu,edge,ne,
     &     ne1,ne3,nex)
!     Make old (FEFF84) grid for FPRIME calculation
      include '../HEADERS/const.h'
c      include '../HEADERS/dim.h'
!     Input:
!     emin  - minimum energy
!     emax  - maximum energy
!     estep - energy step
!     emu   - x-ray edge energy
!     edge  - fermi level (xmu-vr0)
!     nex   - size of em array
      DOUBLE PRECISION emin, emax, estep, emu, edge
      INTEGER nex

!     Output:
!     ne      - total number of points in energy grid
!     ne1     - number of energy points in regular grid
!     em(nex) - energy grid
      INTEGER ne, ne1, ne3
      COMPLEX*16 em(nex)
      
!     Local variables:
!     nemax - maximum number of points in constant energy grid
!     del   - step for exponential grid.
!     
      INTEGER nemax
      DOUBLE PRECISION del, del2, elimit
!     Loop Variables:
      INTEGER i1
!     Initialization
      nemax = 100

      emin  = emin/bohr/hart - emu 
      emax  = emax/bohr/hart - emu

!     Fill a grid from emin to emax taking steps estep.
      em(1) = emin
      ne = 1
      IF(emin.lt.emax) THEN
         IF(estep.le.0.d0) estep = (emax-emin)/(nemax-1)
         ne = MIN(nemax,NINT((emax-emin)/estep))       
         DO i1 = 1, ne
            em(i1) = emin + (i1)*estep
         END DO
      END IF
      ne1 = ne

!     Now fill another grid for the KK-Transform
      nemax = MIN(nex-ne,100)
      del = 3.d0/hart

!     Set elimit = 20*emu, but make sure that 1.d3 .le. elimit .le. 2.d5
      elimit = MAX(1.d3/hart,MIN(20*emu,2.d5/hart))
      elimit = elimit - emu
      
      ne3 = nemax
      em(ne1+1) = edge
      DO i1 = 1, ne3-1
         del2 = 0
         IF(DBLE(em(ne1+i1)).gt.0.d0) del2 = em(ne1+i1)*
     &        (EXP( LOG( elimit/em(ne1+i1) ) / (ne3-i1) ) -1)
         em(ne1+i1+1) = em(ne1+i1) + MAX(del,del2)
      END DO
      ne = ne1 + ne3

      RETURN
      END

      SUBROUTINE ReverseGrid(em,ne,ZeroPoint)
!     Flips a grid about ZeroPoint.
!     Input:
!     em(ne)    - array to flip
!     ne        - number of elements
!     ZeroPoint - point to flip about
      INTEGER ne
      COMPLEX*16 em(ne), eTmp
      DOUBLE PRECISION ZeroPoint

!     Loop Variables
      INTEGER i1, i2, np
      np = ne/2
      DO i1 = 1, ne
         em(i1) = ZeroPoint - em(i1)
      END DO

      DO i1 = 1, np
         eTmp = em(i1)
         em(i1) = em(ne+1-i1)
         em(ne+1-i1) = eTmp
      END DO            
      
      RETURN
      END

      SUBROUTINE MkEMesh(em, iStart, emin, emax, estep, NPts, nex)
!     Make a grid even in k-space from xkmin to xkmax with grid spacing
!     deltak. If xkmin > xkmax, do nothing
      IMPLICIT NONE
!     Input
!     em(nex) - energy grid
!     iStart  - index of em to start at.
!     emin    - starting k
!     emax    - ending k
!     estep   - k spacing
!     nex     - lenth of em array
      INTEGER iStart, nex
      COMPLEX*16 em(nex)
      DOUBLE PRECISION estep, emin, emax

!     Output:
!     NPts    - index of the last point added to the energy grid.
      INTEGER NPts

!     Loop variables
      INTEGER i1

      NPts = NINT((emax - emin)/estep) 
      IF(NPts.le.0) THEN
         NPts = 0
         RETURN
      END IF
      DO i1=0, NPts
         IF(i1.le.nex) THEN 
            em(iStart + i1) = emin + estep*i1
         ELSE
c            CALL wlog('Energy grid is too large: truncating.')
            EXIT
         END IF
      END DO

      RETURN
      END

      
      SUBROUTINE MkKMesh(em, iStart, xkmin, xkmax, deltak, NPts, nex)
!     Make a grid even in k-space from xkmin to xkmax with grid spacing
!     deltak.
      IMPLICIT NONE
!     Input
!     em(nex) - energy grid
!     iStart  - index of em to start at.
!     xkmin   - starting k
!     xkmax   - ending k
!     deltak  - k spacing
!     nex     - lenth of em array
      INTEGER iStart, nex
      COMPLEX*16 em(nex)
      DOUBLE PRECISION deltak, xkmin, xkmax

!     Output:
!     NPts    - index of the last point added to energy grid.
      INTEGER NPts

!     Loop variables
      INTEGER i1, isgn

      NPts = NINT((xkmax - xkmin)/deltak) 
      IF(NPts.le.0) THEN
         NPts = 0
         RETURN
      END IF
      isgn = 1
      IF(xkmin.lt.0.d0) isgn = -1
      DO i1=0, NPts
         IF(i1.le.nex) THEN 
            em(iStart + i1) = isgn*(xkmin + deltak*(i1))**2/2
         ELSE
c            CALL wlog('Energy grid is too large: truncating.')
            EXIT
         END IF
      END DO

      RETURN
      END
 

      SUBROUTINE WrtE(em, ne, fl)
!     WrtE made for debugging.
      INTEGER ne, iU
      COMPLEX*16 em(ne)
      CHARACTER*(*) fl
      CHARACTER(300) fl2
      INTEGER i1

      fl2 = 'DEBUG/' // fl
      iU = 23
      OPEN(unit=iU,file=fl2,status='replace')
      DO i1 = 1, ne
         WRITE(iU,*) i1, em(i1)
      END DO
      CLOSE(iU)

      RETURN
      END

      SUBROUTINE SortE(em,ne,ik0,nex)
!     Sorts energy array em, eliminating degenerate points.
!     Also, set ik0.
!     Input:
!     ne     - number of energy points
!     em(ne) - energy grid
      INTEGER ne
      COMPLEX*16 em(ne)

!     Output: sorted array of energies, and number of unique energy points.
!     Also ik0
      INTEGER ik0

!     Local Variables:
!     RealE(nex)  - Re[em]
!     iOrder(nex) - Holds ordering for em.
!     nUE         - number of unique energy points
!     tol         - tolerence for degeneracy of energy points (in eV)
      DOUBLE PRECISION RealE(nex), E0, tol
      INTEGER iOrder(nex), nUE
      
!     Loop Variables:
      INTEGER i1, i2
      
      PARAMETER(tol = 0.001d0)
      ik0 = -1
      
      DO i1 = 1, ne
         RealE(i1) = DBLE(em(i1))
      END DO

!     Do sorting of RealE.
      CALL qsorti(iOrder,ne,RealE)
      
!     Replace em with sorted values and remove degeneracy.
      nUE   = 1
      IF((ABS(RealE(iOrder(1))).lt.tol)) THEN
         em(1) = 0.d0
         ik0 = 1
      ELSE
         em(1) = RealE(iOrder(1))
      END IF

!     Remove degenerate points
      DO i1 = 2, ne
         
!        find next point that is not degenerate and set next em to the
!        value of the non-degenerate point.
         DO i2 = i1, ne
            PRINT*, ABS(RealE(iOrder(i2))-DBLE(em(i1-1)))
            IF(ABS(RealE(iOrder(i2))-DBLE(em(i1-1))).gt.tol) THEN
               nUE = nUE + 1
               em(nUE) = RealE(iOrder(i2))
               EXIT
            END IF
         END DO
      END DO
      PRINT*, nUE, ne      
      ne = nUE
      
!     Set ik0
      ik0 = 1
      E0 = ABS(DBLE(em(1)))
      DO i1 = 1, nUE
         IF(ABS(DBLE(em(i1))).lt.E0) THEN
            PRINT*, em(i1), E0
            E0 = ABS(DBLE(em(i1)))
            ik0 = i1
         END IF
      END DO
      PRINT*, ik0
      em(ik0) = 0.d0
      
      RETURN
      END

      subroutine yzkrdf (i,j,k)
c       * calculate  function yk *
c yk = r * integral of f(s)*uk(r,s)
c uk(r,s) = rinf**k/rsup**(k+1)   rinf=min(r,s)   rsup=max(r,s)
c f(s)=cg(s,i)*cg(s,j)+cp(s,i)*cp(s,j)      if nem=0
c f(s)=cg(s,i)*cp(s,j)                      if nem is non zero
c f(s) is constructed by the calling programm  if i < or =0
c in the last case a function f (lies in the block dg) is supposedly
c tabulated untill point dr(j), and its' devlopment coefficients
c at the origin are in ag and the power in r of the first term is k+2

c the output functions yk and zk are in the blocks dp and dg.
c at the origin  yk = cte * r**(k+1) - developement limit,
c cte lies in ap(1) and development coefficients in ag.
c        this programm uses aprdev and yzkteg
 
      implicit double precision (a-h,o-z)
      common cg(251,30), cp(251,30), bg(10,30), bp(10,30),
     1         fl(30), fix(30), ibgp
      common/comdir/cl,dz,dg(251),ag(10),dp(251),ap(10),bidcom(783)
      dimension chg(10)
      common/ratom1/xnel(30),en(30),scc(30),scw(30),sce(30),
     1nq(30),kap(30),nmax(30)
      common/tabtes/hx,dr(251),test1,test2,ndor,np,nes,method,idim
      common/inelma/nem
      dimension bgi(10),bgj(10),bpi(10),bpj(10)
c#mn
       external aprdev
 
      if (i.le.0) go to 51
c     construction of the function f
      do  5 l= 1,ibgp
        bgi(l) = bg(l,i)
        bgj(l) = bg(l,j)
        bpi(l) = bp(l,i)
  5     bpj(l) = bp(l,j)
      id= min(nmax(i),nmax(j))
      ap(1)=fl(i)+fl(j)
      if (nem.ne.0) go to 31
      do 11 l=1,id
 11   dg(l)=cg(l,i)*cg(l,j)+cp(l,i)*cp(l,j)
      do 21 l=1,ndor
 21   ag(l)=aprdev(bgi,bgj,l)+aprdev(bpi,bpj,l)
      go to 55

 31   do 35 l=1,id
 35   dg(l)=cg(l,i)*cp(l,j)
      do 41 l=1,ndor
 41   ag(l)=aprdev(bgi,bpj,l)
      go to 55

 51   ap(1)=k+2
      id=j
 55   call yzkteg (dg,ag,dp,chg,dr,ap(1),hx,k,ndor,id,idim)
      return
      end

      subroutine intpol (a,b,fa,fb,fma,fmb,x,fx,fmx)
      implicit double precision (a-h,o-z)
c     Only output is fx, fmx
      complex*16 fa,fb,fma,fmb,fx,fmx
      dx=b-a
      d=(x-a)/dx
c      if (d*(1.0-d).lt.0.0) stop 'Died in intpol'
      if (d*(1.0-d).lt.0.0) then
c         print*, 'a, b, dx'
c         print*, a, b, dx
c         print*, 'x, x-a'
c         print*, x, x-a
c         print*, 'd, d*(1-d)'
c         print*, d, d*(1-d)
         call fstop(' at INTPOL')
      endif
      c2=3.0*(fb-fa)-(fmb+2.0*fma)*dx
      c3=2.0*(fa-fb)+(fma+fmb)*dx
      fx=fa+d*(dx*fma+d*(c2+d*c3))
      fmx=fma+d*(2.0*c2+3.0*c3*d)/dx
      return
      end

      subroutine inouh (dp,dq,dr,dq1,dfl,dv,z,test,nuc,nstop,jc)
c
c initial values for the outward integration
c dp=large component;     dq=small component;     dr=radial mesh
c dq1=slope at the origin of dp or dq;  dfl=power of the first term
c du=developpement limite;  dv=potential at the first point
c z=atomic number      test=test of the precision
c finite nuclear size if nuc is non-zero
c nstop controls the convergence  du developpement limite
c **********************************************************************
      implicit double precision (a-h,o-z)
      save
      common /ps1/ dep(5), deq(5), dd, dvc, dsal, dk, dm
c
c dep,deq=derivatives of dp and dq; dd=energy/dvc;
c dvc=speed of light in a.u.;
c dsal=2.*dvc   dk=kappa quantum number
c dm=exponential step/720.
c **********************************************************************
      common /trois/ dpno(4,30), dqno(4,30)
      dimension dp(251), dq(251), dr(251)
      do 10 i=1,10
      dp(i)=0.0
   10 dq(i)=0.0
      if (nuc) 20,20,60
   20 dval=z/dvc
      deva1=-dval
      deva2=dv/dvc+dval/dr(1)-dd
      deva3=0.0
      if (dk) 30,30,40
   30 dbe=(dk-dfl)/dval
      go to 50
   40 dbe=dval/(dk+dfl)
   50 dq(10)=dq1
      dp(10)=dbe*dq1
      go to 90
   60 dval=dv+z*(3.0-dr(1)*dr(1)/(dr(nuc)*dr(nuc)))/(dr(nuc)+dr(nuc))
      deva1=0.0
      deva2=(dval-3.0*z/(dr(nuc)+dr(nuc)))/dvc-dd
      deva3=z/(dr(nuc)*dr(nuc)*dr(nuc)*dsal)
      if (dk) 70,70,80
   70 dp(10)=dq1
      go to 90
   80 dq(10)=dq1
   90 do 100 i=1,5
      dp(i)=dp(10)
      dq(i)=dq(10)
      dep(i)=dp(i)*dfl
  100 deq(i)=dq(i)*dfl
      m=1
  110 dm=m+dfl
      dsum=dm*dm-dk*dk+deva1*deva1
      dqr=(dsal-deva2)*dq(m+9)-deva3*dq(m+7)
      dpr=deva2*dp(m+9)+deva3*dp(m+7)
      dval=((dm-dk)*dqr-deva1*dpr)/dsum
      dsum=((dm+dk)*dpr+deva1*dqr)/dsum
      j=-1
      do 130 i=1,5
      dpr=dr(i)**m
      dqr=dsum*dpr
      dpr=dval*dpr
      if (m.eq.1) go to 120
  120 dp(i)=dp(i)+dpr
      dq(i)=dq(i)+dqr
      if (abs(dpr/dp(i)).le.test.and.abs(dqr/dq(i)).le.test) j=1
      dep(i)=dep(i)+dpr*dm
  130 deq(i)=deq(i)+dqr*dm
      if (j.eq.1) go to 140
      dp(m+10)=dval
      dq(m+10)=dsum
      m=m+1
      if (m.le.20) go to 110
      nstop=45
  140 do 150 i=1,4
      dpno(i,jc)=dp(i+9)
  150 dqno(i,jc)=dq(i+9)
      return
      end

      subroutine mmtrxi (lam1x, mmati, ie, ileg, ilegp)
c     calculates matrix M in Rehr,Albers paper.
c     in polarization case
      implicit double precision (a-h, o-z)

c     all commons except for /fmat/ are inputs

c     inputs:
c       lam1x:  limits on lambda and lambda'
c       ie:  energy grid points
c       ileg, ilegp: leg and leg'
c
c     Inputs from common:
c        phases, use ph(ie,...,ilegp), and lmax(ie,ilegp)
c        lambda arrays
c        rotation matrix for ilegp
c        clmz for ileg and ilegp
c        path data, eta(ilegp) and ipot(ilegp)
c        xnlm array
c
c     Output:  fmati(...,ilegp) in common /fmatrx/ is set for
c              current energy point.

c     calculate scattering amplitude matrices
c     f(lam,lam') = sum_l tl gam(l,m,n)dri(l,m,m',ileg)gamt(l,m',n')
c                 *cexp(-i*m*eta),  eta = gamma+alpha'
c     lam lt lam1x, lam' lt lam2x such that m(lam) lt l0, n(lam) lt l0
c     gam = (-)**m c_l,n+m*xnlm, gamt = (2l+1)*c_ln/xnlm,
c     gamtl = gamt*tl

      include 'const.h'
      include 'dim.h'
      include 'nlm.h'
      include 'lambda.h'
      include 'clmz.h'
      include 'pola.h'
      include 'fmatrx.h'
      include 'rotmat.h'
      include 'pdata.h'

      complex*16 cam, camt, tltl,mmati
      dimension mmati(-mtot:mtot,-mtot:mtot)
      complex*16 gam(ltot+1,mtot+1,ntot+1),
     1           gamtl(ltot+1,mtot+1,ntot+1)

c     calculate factors gam and gamtl
      iln = il0
      ilx = il0
      do 30  il = iln, ilx
         tltl = 2*il - 1
         do 20  lam = 1, lam1x
            m = mlam(lam)
            if (m .lt. 0)  goto 20
            im = m+1
            if (im .gt. il)  goto 20
            in = nlam(lam) + 1
            imn = in + m
            if (lam .gt. lam1x)  goto 10
            cam = xnlm(il,im) * (-1)**m
            if (imn .le. il)  gam(il,im,in) = cam * clmi(il,imn,ileg)
            if (imn .gt. il)  gam(il,im,in) = 0
   10       if (lam .gt. lam1x) goto 20
            camt = tltl / xnlm(il,im)
            gamtl(il,im,in) = camt * clmi(il,in,ilegp)
   20    continue
   30 continue

      do 60 lam1 = 1,lam1x
         m1 = mlam(lam1)
         in1 = nlam(lam1) + 1
         iam1 = abs(m1) + 1
         do 50  lam2 = 1, lam1x
            m2 = mlam(lam2)
            in2 = nlam(lam2) + 1
            iam2 = iabs(m2) + 1
            imn1 = iam1 + in1 - 1
            fmati(lam1,lam2,ilegp) = mmati(m1,m2)*
     1                       gam(il0,iam1,in1)*gamtl(il0,iam2,in2)
   50    continue
   60 continue

      return
      end

      subroutine bwords_nc (s, nwords, words)
c
c     Breaks string into words.  Words are seperated by one or more
c     blanks or tabs, but not a comma.  This is just like the normal
c     bwords, excpet for the comma
c
c     ARGS        I/O      DESCRIPTION
c     ----        ---      -----------
c     S            I       CHAR*(*)  String to be broken up
c     NWORDS      I/O      Input:  Maximum number of words to get
c                          Output: Number of words found
c     WORDS(NWORDS) O      CHAR*(*) WORDS(NWORDS)
c                          Contains words found.  WORDS(J), where J is
c                          greater than NWORDS found, are undefined on
c                          output.
c
c      Written by:  Steven Zabinsky, September 1984
c      Tab char added July 1994.
c
c**************************  Deo Soli Gloria  **************************

c  -- No floating point numbers in this routine.
      implicit integer (a-z)

      character*(*) s, words(nwords)

      character blank, tab
      parameter (blank = ' ', tab = '	')
c     there is a tab character here               ^.

c  -- BETW    .TRUE. if between words
c     COMFND  .TRUE. if between words and a comma has already been found
      logical betw, comfnd

c  -- Maximum number of words allowed
      wordsx = nwords

c  -- SLEN is last non-blank character in string
      slen = istrln (s)

c  -- All blank string is special case
      if (slen .eq. 0)  then
         nwords = 0
         return
      endif

c  -- BEGC is beginning character of a word
      begc = 1
      nwords = 0

      betw   = .true.
      comfnd = .true.

      do 10  i = 1, slen
         if (s(i:i) .eq. blank .or. s(i:i) .eq. tab)  then
            if (.not. betw)  then
               nwords = nwords + 1
               words (nwords) = s (begc : i-1)
               betw = .true.
               comfnd = .false.
            endif
         else
            if (betw)  then
               betw = .false.
               begc = i
            endif
         endif

         if (nwords .ge. wordsx)  return

   10 continue

      if (.not. betw  .and.  nwords .lt. wordsx)  then
         nwords = nwords + 1
         words (nwords) = s (begc :slen)
      endif

      return
      end

!=======================================================================
!     GLOBAL
!=======================================================================

module global_inp
  
  implicit none

  integer,private ::  ihuge
  double precision,private :: ten, huge, tiny, one
  parameter(ihuge = 10)
  parameter(one=1.d0, ten = 10.d0)
  parameter(huge = ten**ihuge, tiny = one/huge)

  !	the variables evnorm, xivnorm, spvnorm and l2lp are exclusive to nrixs (feffq) calculations
  !	le2 has different meaning for feffq calculations
  !	xivec serves many different functions depending on spectroscopy : xas/eels/nrixs
  integer do_nrixs,lj,ldecmx !KJ 7-09 for feff8q
  !	configuration average data :
  integer nabs, iphabs
  real*8 rclabs
  !	global polarization data :
  integer ipol, ispin, le2, l2lp
  real*8 elpty, angks
  real*8 evec(3), xivec(3), spvec(3)
  complex*16 ptz(-1:1,-1:1)
  double precision evnorm, xivnorm, spvnorm
  !   moved here because I think it belongs here !KJ 7-09
  integer ispec
  character(*),parameter,private :: filename='global.inp'  !KJ used to be global.dat !!!
  !       How many q-vectors:  (impulse transfer)
  integer nq
  !       Are we doing direction averaged impulse transfer?  (Note: this means q || e_z, which is not really averaging!)		
  logical qaverage
  !       The list of q-vectors and their norm:
  real*8,allocatable :: qs(:,:),qn(:)
  !       Weights of q-vectors in the cross-section (probably calculated by another code):
  complex*16,allocatable :: qw(:)
  !       Are we doing q,q' crossterms in the NRIXS code?
  logical mixdff
  !       If entering q, q' as length(q), length(q'), angle(q,q'), this is cosine(angle(q,q'))
  real*8,allocatable :: cosmdff(:,:)
  !       and this is norm(q')
  real*8 qqmdff
  !       A rotation matrix for each q-vector  (containing cos(theta),sin(theta),cos(fi),sin(fi) for each q)
  real*8,allocatable :: qtrig(:,:)  !compare to Adam's code qtrig(iq,1)=qcst(iq); 2)=qsnt; 3)=qcsf; 4)=qsnf
  !       Should the mdff program run? !11-2010
  integer imdff

contains

  subroutine init_feffq
    !	called to calculate some variables for nrixs
    integer i
    evnorm=0.0d0
    xivnorm=0.0d0
    spvnorm=0.0d0
    do i=1,3
       evnorm=evnorm+evec(i)*evec(i)
       xivnorm=xivnorm+xivec(i)*xivec(i)
       spvnorm=spvnorm+spvec(i)*spvec(i)
    end do
    spvnorm=sqrt(spvnorm)
    xivnorm=sqrt(xivnorm)
    evnorm=sqrt(evnorm)
  end subroutine init_feffq

  subroutine global_write(iniq)
    integer i
    logical,intent(in) :: iniq
    if(iniq) call init_feffq
    open (file=filename, unit=3, status='unknown')
    write (3, 10) ' nabs, iphabs - CFAVERAGE data'
    write (3, 45) nabs, iphabs, rclabs
45  format ( 2i8, f13.5)
    write (3,10) ' ipol, ispin, le2, elpty, angks, l2lp, do_nrixs, ldecmx, lj' !KJ last 4 added for feff8q.  Note le2 new meaning in feff8q
    write (3, 50)  ipol, ispin, le2, elpty, angks, l2lp, do_nrixs, ldecmx, lj !KJ
50  format ( 3i5, 2f12.4, 10i5)  !KJ
    write (3, 10) 'evec                   xivec            spvec'
    do 60 i = 1,3
       write (3,30) evec(i), xivec(i), spvec(i)
60     continue
       write (3, 10) ' polarization tensor '
       do 70 i = -1, 1
          write(3,30) dble(ptz(-1,i)), dimag(ptz(-1,i)), dble(ptz(0,i)), dimag(ptz(0,i)),  dble(ptz(1,i)), dimag(ptz(1,i))
70        continue
          !KJ for feff8q - was in different place in file in feff8q:
          write(3,10) 'evnorm, xivnorm, spvnorm - only used for nrixs'
          write (3,30) evnorm, xivnorm, spvnorm !KJ
          !KJ for a list of q-vectors (NRIXS) and MDFF calculation (NRIXS) - only relevant for NRIXS calculations  12-2010
          write(3,10) "nq,    imdff,   qaverage,   mixdff"
          write(3,*) nq,imdff,qaverage,mixdff
          write(3,*) 'q-vectors : qx, qy, qz, q(norm), weight, qcosth, qsinth, qcosfi, qsinfi'
          if(nq.gt.0) then    !note that this is redundant with xivec if nq=1, but ah well.
             do i=1,nq
                write(3,30) qs(i,:),qn(i),qw(i),qtrig(i,1:4)
             enddo
          endif
          if(mixdff) then
             write(3,*) "   qqmdff,   cos<q,q'>"
             write(3,*) qqmdff,cosmdff
          endif
          close(3)
          ! standard formats for string, integers and real numbers
10        format(a)
!20        format (20i4)
30        format (20f13.5)

        end subroutine global_write

        subroutine global_read
          real*8 aa1,bb1,aa2,bb2,aa3,bb3
          integer i
          open (file=filename, unit=3, status='old')
          read  (3,*)
          read  (3,*) nabs, iphabs, rclabs
          read  (3,*)
          read  (3,*)  ipol, ispin, le2, elpty, angks, l2lp, do_nrixs, ldecmx, lj
          read  (3,*)
          do i = 1,3
             read  (3,*) evec(i), xivec(i), spvec(i)
          enddo
          read  (3,*)
          do i = -1, 1
             read (3,*) aa1, bb1, aa2, bb2, aa3, bb3 !KJ changed names of dummies to avoid confusion with my WELL DEFINED arrays (f*cking "implicit" people !#$&%)
             ptz(-1,i)= dcmplx(aa1,bb1)  !KJ changed cmplx to dcmplx to satisfy thorough compilers
             ptz(0,i) = dcmplx(aa2,bb2)
             ptz(1,i) = dcmplx(aa3,bb3)
          enddo
          read (3,*)
          read (3,*) evnorm, xivnorm, spvnorm !KJ
          if(do_nrixs .ne. 0) then !compatibility with (most) old files
             read(3,*)
             read(3,*) nq,imdff,qaverage,mixdff
             read(3,*)
             call make_qlist(nq)
             if(nq.gt.0) then    !note that this is redundant with xivec if nq=1, but ah well.
                do i=1,nq
                   read(3,30) qs(i,:),qn(i),qw(i),qtrig(i,1:4)
                enddo
             endif
             if(mixdff) then
                read(3,*)
                read(3,*) qqmdff,cosmdff
             endif
30           format (20f13.5)
          endif
          close(3)
        end subroutine global_read

        subroutine make_qlist(n)
          implicit none
          integer,intent(in) :: n
          allocate(qs(n,3),qn(n),qw(n),qtrig(n,4),cosmdff(n,n))
          qs(:,:)=0.d0
          qn(:)=0.d0
          qw(:)=1.d0
          qtrig(:,:)=0.d0
          qtrig(:,1)=1.d0
          qtrig(:,3)=1.d0 !corresponding to not rotating at all
          cosmdff(:,:)=1.d0
          return
        end subroutine make_qlist

        subroutine make_qtrig
          !          simple routine to get rotation angles; copied from mkptz      
          implicit none
          double precision rr,rsp
          integer iq
          do iq=1,nq
             if (qn(iq).gt.0.0d0) then
                rsp = qn(iq)
                rr = qs(iq,1)**2 + qs(iq,2)**2
                if (rr.lt. tiny) then
                   qtrig(iq,1) = - 1.d0
                   qtrig(iq,2) = 0.d0
                   qtrig(iq,3) = 1.d0
                   qtrig(iq,4) = 0.d0
                elseif (qs(iq,3).lt.0) then !meaning forward scattering ??
                   !                  rotation is defined by angles theta and fi
                   rr = sqrt(rr)
                   qtrig(iq,1) = qs(iq,3) / rsp
                   qtrig(iq,2) = rr / rsp
                   qtrig(iq,3) = qs(iq,1) / rr
                   qtrig(iq,4) = qs(iq,2) / rr
                else
                   qtrig(iq,1)=1.0d0
                   qtrig(iq,2)=0.0d0
                   qtrig(iq,3)=1.0d0 !surely this is a bug??  Shouldn't this be 1? !KJ 12-2011 changed 0->1 because produces NaN in genfmt otherwise
                   qtrig(iq,4)=0.0d0
                end if
             else
                call wlog(' FATAL error: one of the q-vectors is zero')
                call par_stop(' ')
             endif
          enddo !iq
          return
        end subroutine make_qtrig

        subroutine global_init
          ispec = 0
          ldecmx=-1 ! initialize the number of decomposition channels - KJ 7-09 for feff8q
          nabs = 1
          iphabs = 0
          rclabs = 0.d0
          ipol = 0
          ispin = 0
          le2 = 0
          l2lp = 0
          elpty = 0.d0
          angks = 0.d0
          evec(:) = 0.d0
          xivec(:) = 0.d0
          spvec(:) = 0.d0
          ptz(:,:) = dcmplx(0.d0,0.d0)
          evnorm=0.0d0
          xivnorm=0.0d0
          spvnorm=0.0d0
          do_nrixs=0 ! no nrixs calculation
          lj = -1
          nq=0
          qaverage=.true.
          imdff=0 !no mdff
          mixdff=.false. !no mdff in NRIXS
          !	cosmdff=1.d0  ! q || q'  => cos(0)=1     !KJ 11-2011 this is now an allocatable array.  Instruction fails on gfortran.
          qqmdff=-1.d0 ! leads to q=q' (norm only)
        end subroutine global_init

      end module global_inp

      subroutine mcritk (npat, ipat, ri, beta, indbet,
     1      ipot, nncrit, fbetac, xlamc, ckspc, xout, xcalcx)

      include '../HEADERS/const.h'
      include '../HEADERS/dim.h'
      dimension ipat(npatx)
      dimension ri(npatx+1), beta(npatx+1), indbet(npatx+1)
      dimension ipot(0:natx)
      parameter (necrit=9, nbeta=40)
      dimension fbetac(-nbeta:nbeta,0:nphx,necrit), ckspc(necrit)
      dimension xlamc(necrit)

cc    xcalcx is max xcalc encountered so far.  Set to -1 to reset it --
cc    otherwise it gets passed in and out as mcritk gets called.
c     calculation of xcalcx changed by ala. It is calculated only
c     a first call, i.e. for the NN SS path, and is not recalculated

c     We may want path in heap so that other paths built from this
c     path will be considered, but do not want this path to be
c     written out for itself.  Decide that now and save the flag
c     in the heap, so we won't have to re-calculate the mpprm
c     path parameters later.

c     Do not want it for output if last atom is central atom,
c     use xout = -1 as flag for undefined, don't keep it.
      if (ipat(npat) .eq. 0)  then
         xout = -1
         return
      endif

c     Make xout, output inportance factor.  This is sum over p of
c     (product of f(beta)/rho for the scatterers) * 
c                                 (cos(beta0)/rho(npat+1).
c     Compare this to xoutx, max xout encountered so far.
c     Use mean free path factor, exp(-rtot/xlam)
c     Multiply by 100 so we can think in percent.

      xcalc = 0
      rtot = 0
      do 410  i = 1, npat+1
         rtot = rtot + ri(i)
  410 continue
      do 460  icrit = 1, nncrit
         rho = ri(npat+1) * ckspc(icrit)
c        when beta(0)=90 degrees, get zero, so fudge with cos=.2
         x = max (abs(beta(npat+1)), 0.3) / rho
         do 420  iat = 1, npat
            rho = ri(iat) * ckspc(icrit)
            ipot0 = ipot(ipat(iat))
            x = x * fbetac(indbet(iat),ipot0,icrit) / rho
  420    continue
         x = x * exp (-rtot/xlamc(icrit))
         xcalc = xcalc + x
  460 continue
      if (xcalcx.le.0)  xcalcx = xcalc
      xout = 100 * xcalc / xcalcx
      return
      end

      subroutine bcoef(kinit, ipol, ptz, le2, ltrace, ispin, angks,
     1                 kind, lind, bmat)
c     written by alexei ankudinov; march 2000
c     calculate bmat: the energy independent sum over polarization and
c     angular momenta indices
c     bmat = \sum_{p,p', all m_j} <LS|J><J|R|J1><J1|\alpha_p exp(i kz)|I>
c                    ptz(p,p')
c            <I|\alpha_p'^* exp(-i kz) J2><J2|R'|J'><J'|L'S'>
c     where R is rotation from spin vector to x-ray k-vector
c     and R' is rotation back
c     see Eq.10 and 11 in Ankudinov,Rehr, Phys.Rev.B (accepted),
c     Theory of solid state contribution to the x-ray elastic scattering
c     aditional rotation matrices are needed when x-ray k-vector
c     is not along the spin-axis (see rotations in rdinp)

c     more precisely it is
c     bmat(l1 l1' j l ml ms; l2 l2' j' l' ml' ms') =
c        (-)**(j-j'+l2'+1) i**(l'-l) \sum_{p,p',mi,m1,mj,m2,mj'}
c        <LS|J>   r^j_{m1,mj}(angks)   3j( j l1 i ; -m1 p mi)
c        (-p)**(l1+l1'+1) ptz(p,p') (-p')**(l2+l2'+1)
c        3j( j' l2 i ; -m2  p' mi)   r^j'_{m2,mj'}(angks)   <J'|L'S'>
c     where l1 l1' are set by the multipole moment(E1-l1=1,l1'=0;
c     E2-l1=2,l1'=1; M1-l1=1,l1'=1; etc.;
c     j and l define quantum number kappa and for each multipole moment
c     Only few final kappa's are allowed and  it is convinient
c     to denote (l1 l1' j l) by one index 'k'
c     thus  k=1-8 to include both E1 and E2 transitions;
c     ml and ms are projections of orbital and spin moments.

c     bmat  is used to calculate absorption fine structure (chi) via
c       chi = \sum_{k ms,k' ms'}  rkk(k,ms)  rkk(k',ms')
c       \sum_{ml,ml'}  bmat(k ml ms; k' ml' ms')  G_(l' ml' ms';l ml ms)
c     where sum over spins can be moved from first sum to second for
c     spin independent systems. The above expression is suitable for FMS
c     and for MS expansion on can use Eq.15 in RA paper to obtain
c     expression for the termination   matrix
c     T_{lam1 ms,lamN ms'} = \sum_{k k'} rkk(k,ms) rkk(k',ms')
c       \sum_{ml,ml'}  bmat(k ml ms; k' ml' ms') gam(l,lam1,rho1,ms)
c        gamtl(l',lamN,rhoN,ms')
c     Notice that for spin-dependent systems the scattering F matrices
c     in RA paper also should have additional spin indices. In genfmt
c     we currently neglect spin-flip processes which simplifies
c     calculations with MS expansion. (T and F are diagonal in ms,ms')

c     This subroutine is written for general spin-dependent asymmetric
c     system and arbitrary polarization tenzor. The symmetry of the
c     system and polarization tenzor can be used
c     to speed up FMS or MS calculations in appropriate subroutines.
c     (see comments in subroutines mpprmp, fmstot)

c     input:
c       kinit - kappa for initial orbital
c       ipol - polarization type measurement
c       ptz  - polarization tensor (needed only for ipol=1 case)
c       le2  - sets which multipole moments to include (see mkptz)
c       ltrace- .true. for xsect.f, where need to perform trace over ml
c       angks - angle between k-vector and spin-vector

c     output
c       lind  - orb.mom.(kappa)  needed in fmstot only (for indexing)
c       bmat  - energy independent matrix to calculate absorption
c       in many cases bmat is diagonal due to the choice of xyz frame,
c       but for general case full 16*(2*lx+1)*16*(2*lx+1) matrix is kept

      implicit double precision (a-h,o-z)
      include '../HEADERS/dim.h'
      complex*16 coni
      parameter (coni = (0.d0,1.d0))

c     need only parameter lx to set max orb momentum
      complex*16 ptz, bmat, pmat, tmat
      dimension ptz(-1:1,-1:1),  bmat(-lx:lx,0:1,8, -lx:lx,0:1,8)
c       to include all possible dipole and quadrupole transitions
c       final kp, and kpp have 8 possibilities
      logical ltrace

c     local staff
      dimension  t3j( 8, 0:1, -lx:lx+1), x3j(8, -1:1, -lx:lx+1)
c     qmat = <J2|R'|J'><J'|L'S'> - diagonal in kappa index
      dimension qmat( -lx:lx+1, -lx:lx, 0:1, 8)
c     pmat = <J1|\alpha_j exp(i kz)|I> ptz <I|\alpha_k^* exp(-i kz)|J2>
      dimension pmat( -lx:lx+1, 8, -lx:lx+1, 8)
c     tmat = pmat*qmat ; bmat = qmat^T*tmat
      dimension tmat( -lx:lx+1, 8, -lx:lx, 0:1, 8)
c     total and orbital momenta for 8 possible final kappa
      dimension jind(8), lind(8), kind(8)

      external cwig3j

      do 10 i6 = 1, 8
      do 10 i5 = 0 ,1
      do 10 i4 = -lx,lx
      do 10 i3 = 1, 8
      do 10 i2 = 0 ,1
      do 10 i1 = -lx,lx
         bmat( i1, i2, i3, i4, i5, i6) = 0
  10  continue

c     3 dipole transitions
      do 20 k=-1,1
         kap=kinit+k
         if (k.eq.0) kap=-kap
         jkap = abs(kap)
         lkap = kap
         if (kap.le.0) lkap = abs(kap) -1
c        check that orbital momentum does not exceed max allowed
         if (lkap .gt. lx) then
c          set final j and l to unphysical values
           jkap = 0
           lkap = -1
           kap = 0
         endif
         jind(k+2) = jkap
         lind(k+2) = lkap
         kind(k+2) = kap
  20  continue

c     include 5 quadrupole or 3 mag.dipole  transitions
      do 120 k=-2,2
         jkap = abs(kinit) + k
         if (jkap.le.0) jkap = 0
         kap= jkap
         if (kinit.lt.0 .and. abs(k).ne.1) kap=-jkap
         if (kinit.gt.0 .and. abs(k).eq.1) kap=-jkap
         lkap = kap
         if(kap.le.0) lkap = - kap - 1
         if (lkap.gt.lx .or. le2.eq.0
     1                  .or. (le2.eq.1 .and. abs(k).eq.2)) then
c           set unphysical jkap and lkap to make shorter calculations
            jkap = 0
            lkap = -1
            kap = 0
         endif
         jind(k+6) = jkap
         lind(k+6) = lkap
         kind(k+6) = kap
 120  continue

      if (ipol.eq.0) then
c       polarization average case; bmat is diagonal and simple
        do 100 k = 1, 8
        do 100 ms = 0 ,1
        do 100 ml = -lind(k), lind(k)
c         i2 = (2*l1+1) , where l1 is defined by multipole moment
          i2 = 3
          if (le2.eq.2 .and. k.gt.3) i2 = 5
          bmat(ml,ms,k, ml,ms,k) = 0.5d0 / (2*lind(k)+1.d0) / i2
          if (k.le.3) bmat(ml,ms,k, ml,ms,k) = - bmat(ml,ms,k, ml,ms,k)
 100    continue
      else
c       more complicated bmat for linear(ipol=1) and circular(ipol=2)
c       polarizations
c       Put 3j factors in x3j and t3j. t3j are multiplied by
c       sqrt(2*j'+1) for  further convinience.
        do 30  mp=-lx,lx+1
        do 30  ms=0,1
        do 30  k1=1,8
  30    t3j(k1,ms,mp) = 0.0d0
        do 40  mp=-lx,lx+1
        do 40  ms=-1,1
        do 40  k1=1,8
  40      x3j(k1,ms,mp) = 0.0d0

        do 70  k1 = 1,8
        do 70  mp = -jind(k1)+1,jind(k1)
          do 50 ms=0,1
            j1 = 2 * lind(k1)
            j2 = 1
            j3 = 2 * jind(k1) - 1
            m1 = 2*(mp-ms)
            m2 = 2*ms - 1
            t3j(k1,ms,mp)=sqrt(j3+1.0d0) * cwig3j(j1,j2,j3,m1,m2,2)
            if (mod( (j2-j1-m1-m2)/2 , 2) .ne.0)
     1          t3j(k1,ms,mp) = - t3j(k1,ms,mp)
c           t3j(m0,i)    are Clebsch-Gordon coefficients
  50      continue
          do 60 i=-1,1
            j1 = 2 * jind(k1) - 1
            j2 = 2
            if (k1.gt.3 .and. le2.eq.2) j2 = 4
            j3 = 2 * abs(kinit) - 1
            m1 = -2*mp + 1
            m2 = 2*i
            x3j(k1,i,mp)= cwig3j(j1,j2,j3,m1,m2,2)
  60      continue
  70    continue

c       calculate qmat
        do 220 i=1,8
        do 220 ms=0,1
        do 220 ml= -lind(i), lind(i)
        do 220 mj= -jind(i)+1, jind(i)
          mp = ml+ms
          jj = 2*jind(i) - 1
          mmj = 2*mj - 1
          mmp = 2*mp - 1
          value = rotwig(angks, jj, mmj, mmp, 2)
          qmat(mj,ml,ms,i) = value * t3j(i,ms,mp)
 220    continue

c       calculate pmat
        do 240 i2 = 1,8
        do 240 m2 = -jind(i2)+1, jind(i2)
        do 240 i1 = 1,8
        do 240 m1 = -jind(i1)+1, jind(i1)
          pmat(m1,i1,m2,i2) = 0
          if (abs(m2-m1).le.2) then
            do 230 j=-1,1
            do 230 i=-1,1
c             check that initial moment is the same
              if (m1-i.eq.m2-j) then
                is = 1
c               (-p) factors for M1 transitions
                if (le2.eq.1 .and. i.gt.0 .and. i1.gt.3) is = -is
                if (le2.eq.1 .and. j.gt.0 .and. i2.gt.3) is = -is
                pmat(m1,i1,m2,i2) = pmat(m1,i1,m2,i2) +
     1          is * x3j(i1,i,m1) * ptz(i,j) * x3j(i2,j,m2)
              endif
 230        continue
c           multiply by (-)^(j-j'+l2'+1) i**(l'-l) factor
c           additional (-) is from Eq.10 (-2*ck)
            is = 1
            if (mod(jind(i1)-jind(i2), 2) .ne.0) is = -is
            if (i2.le.3) is = -is
            pmat(m1,i1,m2,i2) = pmat(m1,i1,m2,i2) * is
     1           * coni**(lind(i2)-lind(i1))
          endif
 240    continue

c       calculate tmat = pmat*qmat
        do 270 i1=1,8
        do 270 ms=0,1
        do 270 ml=-lind(i1), lind(i1)
        do 270 i2=1,8
        do 270 mj=-jind(i2)+1, jind(i2)
          tmat(mj,i2, ml,ms,i1) = 0
          do 260 mp = -jind(i1)+1, jind(i1)
            tmat(mj,i2, ml,ms,i1) = tmat(mj,i2, ml,ms,i1)+
     1           pmat(mj,i2,mp,i1) * qmat(mp,ml,ms,i1)
 260      continue
 270    continue

c       calculate bmat = qmat^T * tmat
        do 300 i1=1,8
        do 300 ms1=0,1
        do 300 ml1=-lind(i1), lind(i1)
        do 300 i2=1,8
        do 300 ms2=0,1
        do 300 ml2=-lind(i2), lind(i2)
          bmat(ml2,ms2,i2, ml1,ms1,i1) = 0
          do 280 mj=-jind(i2)+1, jind(i2)
            bmat(ml2,ms2,i2, ml1,ms1,i1) = bmat(ml2,ms2,i2, ml1,ms1,i1)+
     1      qmat(mj,ml2,ms2,i2) * tmat(mj,i2,ml1,ms1,i1)
 280      continue
 300    continue
c       end of ipol=1,2 cases
      endif

      if (ltrace) then
c       need to trace bmat over ml for xsect.f
        do 390 i1 = 1, 8
        do 390 ms1 = 0,1
        do 390 i2 = 1, 8
        do 390 ms2 = 0,1
          if (lind(i1).ne.lind(i2) .or. ms1.ne.ms2) then
               bmat(0,ms2,i2, 0,ms1,i1) = 0
          else
             do 360 ml = 1, lind(i1)
               bmat(0,ms1,i2, 0,ms1,i1) =  bmat(0,ms1,i2, 0,ms1,i1) +
     1         bmat(-ml,ms1,i2, -ml,ms1,i1) + bmat(ml,ms1,i2, ml,ms1,i1)
 360         continue
          endif
 390    continue
      endif

      if (ispin .eq. 0) then
c       G(Ls,L's') is spin diagonal; trace over spin
        do 480 i1 = 1, 8
        do 480 i2 = 1, 8
        do 480 ml1 = -lind(i1), lind(i1)
        do 480 ml2 = -lind(i2), lind(i2)
           bmat(ml2,0,i2, ml1,0,i1) =   bmat(ml2,0,i2, ml1,0,i1) +
     1                                  bmat(ml2,1,i2, ml1,1,i1)
 480    continue
      elseif (ispin.eq.2 .or. (ispin.eq.1 .and. nspx.eq.1)) then
c       move spin up part into the position of spin-down
        do 490 i1 = 1, 8
        do 490 i2 = 1, 8
        do 490 ml1 = -lind(i1), lind(i1)
        do 490 ml2 = -lind(i2), lind(i2)
           bmat(ml2,0,i2, ml1,0,i1) =   bmat(ml2,1,i2, ml1,1,i1)
 490    continue

      endif

      return
      end

      subroutine rhl (rs, xk, erl, eim)
      implicit double precision (a-h, o-z)

c     input:  rs, xk
c     output: erl, eim

c     This is a new hl subroutine, using interpolation for the
c     real part while the imaginary part is calculated analytically.
c     It uses hl to calculate values at the mesh points for the inter-
c     polation of the real part. The imaginary part is calculated
c     using subroutine imhl.
c
c     written by jose mustre
c     polynomial in rs has a 3/2 power term. j.m.


c     for the right branch the interpolation has the form:
c     hl(rs,x) = e/x + f/x**2 + g/x**3
c     where e is known and
c        f = sum (i=1,3) ff(i) rs**(i+1)/2
c        g = sum (i=1,3) gg(i) rs**(i+1)/2
c
c
c     lrs=number of rs panels, in this case one has 4 panels
c     nrs=number of standard rs values, also order of rs expansion
c     if you change nrs you need to change the expansion of hl
c     in powers of rs that only has 3 terms!
c     nleft=number of coefficients for x<x0
c     nright=number of coefficients for x>x0

      parameter (lrs=4, nrs=3, nleft=4, nright=2)
      include '../HEADERS/const.h'

      dimension cleft(nleft), cright(nright)

      dimension rcfl(lrs,nrs,nleft), rcfr(lrs,nrs,nright)
      data rcfr/-0.173963d+00,-0.173678d+00,-0.142040d+00,-0.101030d+00,
     1     -0.838843d-01,-0.807046d-01,-0.135577d+00,-0.177556d+00,
     2     -0.645803d-01,-0.731172d-01,-0.498823d-01,-0.393108d-01,
     3     -0.116431d+00,-0.909300d-01,-0.886979d-01,-0.702319d-01,
     4      0.791051d-01,-0.359401d-01,-0.379584d-01,-0.419807d-01,
     5     -0.628162d-01, 0.669257d-01, 0.667119d-01, 0.648175d-01/
      data rcfl/ 0.590195d+02, 0.478860d+01, 0.812813d+00, 0.191145d+00,
     1     -0.291180d+03,-0.926539d+01,-0.858348d+00,-0.246947d+00,
     2      0.363830d+03, 0.460433d+01, 0.173067d+00, 0.239738d-01,
     3     -0.181726d+03,-0.169709d+02,-0.409425d+01,-0.173077d+01,
     4      0.886023d+03, 0.301808d+02, 0.305836d+01, 0.743167d+00,
     5     -0.110486d+04,-0.149086d+02,-0.662794d+00,-0.100106d+00,
     6      0.184417d+03, 0.180204d+02, 0.450425d+01, 0.184349d+01,
     7     -0.895807d+03,-0.318696d+02,-0.345827d+01,-0.855367d+00,
     8      0.111549d+04, 0.156448d+02, 0.749582d+00, 0.117680d+00,
     9     -0.620411d+02,-0.616427d+01,-0.153874d+01,-0.609114d+00,
     1      0.300946d+03, 0.109158d+02, 0.120028d+01, 0.290985d+00,
     2      -0.374494d+03,-0.535127d+01,-0.261260d+00,-0.405337d-01/

c
c     calculate hl using interpolation coefficients
      rkf = fa/rs
      ef  = rkf**2/2
      wp  = sqrt (3/rs**3)
c    quick fix to remove jump at wp in rhl. ala 08.01.95
c    use smooth transition between 2 curves in energy range dwp
      dwp = wp/3.0

      call imhl (rs, xk, eim, icusp)

c     eim already has a factor of ef in it j.m.
c     eim also gives the position of the cusp

      xx = xk / rkf
c     set to fermi level if below fermi level
      if (xx .lt. 1.00001) then
          xx = 1.00001
      endif
c    quick fix to remove jump at wp in rhl. ala 08.01.95
      deltae = ((xx**2-1.0)*ef - wp-dwp)/dwp

c     calculate right hand side coefficients
      if (rs .lt. 0.2) then
         mrs=1
      elseif (rs .lt. 1.0) then
         mrs=2
      elseif (rs .lt. 5.0) then
         mrs=3
      else
         mrs=4
      endif

      do 210 j=1,nright
         cright(j) = rcfr(mrs,1,j)*rs + rcfr(mrs,2,j)*rs*sqrt(rs)
     1               + rcfr(mrs,3,j)*rs**2
  210 continue
      eee=-pi*wp/(4*rkf*ef)

c     if (icusp .ne. 1) then
c    quick fix to remove jump at wp in rhl. ala 08.01.95
      if (icusp .ne. 1 .or. abs(deltae).lt.1.0) then

         do 230 j=1,nleft
            cleft(j) = rcfl(mrs,1,j)*rs + rcfl(mrs,2,j)*rs**1.5
     1                 + rcfl(mrs,3,j)*rs**2
  230    continue
         erl=cleft(1)
         do 250 j=2,nleft
            erl=erl+cleft(j)*xx**(j-1)
  250    continue

c     else
c    quick fix to remove jump at wp in rhl. ala 08.01.95
      endif
      if(icusp .eq. 1 .or. abs(deltae).lt.1.0) then
c        right branch
         erlr=eee/xx
         do 280 j=1,nright
            erlr=erlr+cright(j)/xx**(j+1)
  280    continue
         if (abs(deltae).lt.1.0) then
            if (deltae.lt.0) then
               wr = (1.0 + deltae)**2/2.0
            else
               wr = 1.0 - (1.0-deltae)**2/2.0
            endif
            erl=wr*erlr + (1.0-wr)*erl
         else
            erl= erlr
         endif
      endif

      erl = erl * ef

      return
      end

      subroutine setkap(ihole, kinit, linit)
      implicit double precision (a-h, o-z)

c     Set initial state ang mom and quantum number kappa
c     ihole  initial state from ihole    
c     1      K    1s      L=0 -> linit=0 
c     2      LI   2s      L=0 -> linit=0
c     3      LII  2p 1/2  L=1 -> linit=1
c     4      LIII 2p 3/2  L=1 -> linit=1
c     5+     etc.
      if (ihole.le. 2 .or. ihole.eq. 5 .or. ihole.eq.10 .or.
     1    ihole.eq.17 .or. ihole.eq.24 .or. ihole.eq.27)  then
c        hole in s state
         linit = 0
         kinit = -1
      elseif (ihole.eq. 3 .or. ihole.eq. 6 .or. ihole.eq.11 .or.
     1        ihole.eq.18 .or. ihole.eq.25 .or. ihole.eq.30)  then
c        hole in p 1/2 state
         linit = 1
         kinit = 1
      elseif (ihole.eq. 4 .or. ihole.eq. 7 .or. ihole.eq.12 .or.
     1        ihole.eq.19 .or. ihole.eq.26)  then
c        hole in p 3/2 state
         linit = 1
         kinit = -2
      elseif (ihole.eq. 8 .or. ihole.eq.13 .or.
     1        ihole.eq.20 .or. ihole.eq.27)  then
c        hole in d 3/2 state
         linit = 2
         kinit = 2
      elseif (ihole.eq. 9 .or. ihole.eq.14 .or.
     1        ihole.eq.21 .or. ihole.eq.28)  then
c        hole in d 5/2 state
         linit = 2
         kinit = -3
      elseif (ihole.eq.15 .or. ihole.eq.22)  then
c        hole in  f 5/2 state
         linit = 3
         kinit = 3
      elseif (ihole.eq.16 .or. ihole.eq.23)  then
c        hole in  f 7/2 state
         linit = 3
         kinit = -4
      else
c        some unknown hole
         call par_stop('invalid hole number in setkap')
      endif

      return
      end

      subroutine sortir (n, index, r)

c     SORT by rearranges Indices, keys are Real numbers
c     Heap sort, following algorithm in Knuth using r as key
c     Knuth, The Art of Computer Programming,
c     Vol 3 / Sorting and Searching, pp 146-7
c     Array r is not modified, instead array index is returned
c     ordered so that r(index(1)) is smallest, etc.
c     rr is temporary r storage (Knuth's R), irr is index of stored r

      dimension r(n), index(n)

c     Initialize index array
      do 10  i = 1, n
         index(i) = i
   10 continue
c     only 1 element is already sorted
      if (n .eq. 1)  return

c     H1: initialize
      l = n/2 + 1
      ir = n

c     H2: Decrease l or ir
   20 continue
      if (l .gt. 1)  then
         l = l-1
         irr = index(l)
         rr = r(irr)
      else
         irr = index(ir)
         rr = r(irr)
         index(ir) = index(1)
         ir = ir-1
         if (ir .eq. 1) then
            index(1) = irr
            return
         endif
      endif

c     H3: Prepare for sift-up
      j = l

c     H4: Advance downward
   40 continue
      i = j
      j = 2 * j
      if (j .eq. ir)  goto 60
      if (j .gt. ir)  goto 80

c     H5: Find larger son of i
      if (r(index(j)) .lt. r(index(j+1)))  j = j+1

c     H6: Son larger than rr?
   60 continue
      if (rr .ge. r(index(j)))  goto 80

c     H7: Move son up
      index(i) = index(j)
      goto 40

c     H8: Store rr in it's proper place
   80 continue
      index(i) = irr
      goto 20

      end
      subroutine sortii (n, index, k)

c     SORT by rearranges Indices, keys are Integers
c     Heap sort, following algorithm in Knuth using r as key
c     Knuth, The Art of Computer Programming,
c     Vol 3 / Sorting and Searching, pp 146-7
c     Array r is not modified, instead array index is returned
c     ordered so that r(index(1)) is smallest, etc.
c     rr is temporary r storage (Knuth's R), irr is index of stored r

      dimension k(n)
      dimension index(n)

c     Initialize index array
      do 10  i = 1, n
         index(i) = i
   10 continue
c     only 1 element is already sorted
      if (n .eq. 1)  return

c     H1: initialize
      l = n/2 + 1
      ir = n

c     H2: Decrease l or ir
   20 continue
      if (l .gt. 1)  then
         l = l-1
         irr = index(l)
         kk = k(irr)
      else
         irr = index(ir)
         kk = k(irr)
         index(ir) = index(1)
         ir = ir-1
         if (ir .eq. 1) then
            index(1) = irr
            return
         endif
      endif

c     H3: Prepare for sift-up
      j = l

c     H4: Advance downward
   40 continue
      i = j
      j = 2 * j
      if (j .eq. ir)  goto 60
      if (j .gt. ir)  goto 80

c     H5: Find larger son of i
      if (k(index(j)) .lt. k(index(j+1)))  j = j+1

c     H6: Son larger than kk?
   60 continue
      if (kk .ge. k(index(j)))  goto 80

c     H7: Move son up
      index(i) = index(j)
      goto 40

c     H8: Store kk in it's proper place
   80 continue
      index(i) = irr
      goto 20

      end
      subroutine sortid (n, index, r)

c     SORT by rearranges Indices, keys are Double precision numbers
c     Heap sort, following algorithm in Knuth using r as key
c     Knuth, The Art of Computer Programming,
c     Vol 3 / Sorting and Searching, pp 146-7
c     Array r is not modified, instead array index is returned
c     ordered so that r(index(1)) is smallest, etc.
c     rr is temporary r storage (Knuth's R), irr is index of stored r

      implicit double precision (a-h, o-z)
      dimension r(n), index(n)

c     Initialize index array
      do 10  i = 1, n
         index(i) = i
   10 continue
c     only 1 element is already sorted
      if (n .eq. 1)  return

c     H1: initialize
      l = n/2 + 1
      ir = n

c     H2: Decrease l or ir
   20 continue
      if (l .gt. 1)  then
         l = l-1
         irr = index(l)
         rr = r(irr)
      else
         irr = index(ir)
         rr = r(irr)
         index(ir) = index(1)
         ir = ir-1
         if (ir .eq. 1) then
            index(1) = irr
            return
         endif
      endif

c     H3: Prepare for sift-up
      j = l

c     H4: Advance downward
   40 continue
      i = j
      j = 2 * j
      if (j .eq. ir)  goto 60
      if (j .gt. ir)  goto 80

c     H5: Find larger son of i
      if (r(index(j)) .lt. r(index(j+1)))  j = j+1

c     H6: Son larger than rr?
   60 continue
      if (rr .ge. r(index(j)))  goto 80

c     H7: Move son up
      index(i) = index(j)
      goto 40

c     H8: Store rr in it's proper place
   80 continue
      index(i) = irr
      goto 20

      end

c     sub-program exchange
      program ffmod5
c     subroutine ffmod5

c     scattering F-matrix multiplication for each MS path
c     written by a.ankudinov 2000, using subroutines
c     which were written earlier by j.rehr and others
c     modified by a.ankudinov 2001 for new I/O structure

c     INPUT: phase.pad, paths.dat, mod5.inp and global.dat
c     OUTPUT: feff.pad and list.dat files
      implicit double precision (a-h, o-z)

      include '../HEADERS/dim.h'
      include '../HEADERS/parallel.h'
      double precision evec(3), xivec(3)
      complex*16 ptz(-1:1, -1:1)
      integer  mfeff, ipr5, iorder
      logical  wnstar
      double precision critcw, angks, elpty


      call par_begin
      if (worker) go to 400

c     open the log file, unit 11.  See subroutine wlog.
      open (unit=11, file='log5.dat', status='unknown', iostat=ios)
      call chopen (ios, 'log5.dat', 'feff')

c                 read  mod5.inp 
      call regenf(mfeff, ipr5, critcw, iorder, wnstar,
c                 and global.dat
     1            ipol, ispin, le2, angks, elpty, evec, xivec, ptz)
      if (nspx.gt.1) ispin = abs(ispin)

      if (mfeff .eq. 1)  then
         call wlog(' Calculating EXAFS parameters...')
         call genfmt (ipr5, critcw, iorder, wnstar,
     1                ipol, ispin, le2, angks, elpty, evec, xivec, ptz)
         call wlog(' Done with module 5: F_eff.')
      endif
      close (unit=11)

 400  call par_barrier
      call par_end

c     sub-program exchange
      stop
c     return

      end

c
c PAD library:   Packed Ascii Data 
c   these routines contain code for handling packed-ascii-data  
c   (pad) arrays for writing printable character strings that 
c   represent real or complex scalars and arrays to a file.
c
c routines included in padlib are (dp==double precision):
c   wrpadd     write a dp array as pad character strings
c   wrpadx     write a dp complex array as pad character strings
c   rdpadr     read a pad character array as a real array
c   rdpadd     read a pad character array as a dp  array
c   rdpadc     read a pad character array as a complex array
c   rdpadx     read a pad character array as a dp complex array
c   pad        internal routine to convert dp number to pad string
c   unpad      internal routine to pad string to dp number
c
c routines not included, but required by padlib:
c     triml, istrln, echo, iread, sclean
c
c//////////////////////////////////////////////////////////////////////
c Copyright (c) 1997--2001 Matthew Newville, The University of Chicago
c Copyright (c) 1992--1996 Matthew Newville, University of Washington
c
c Permission to use and redistribute the source code or binary forms of
c this software and its documentation, with or without modification is
c hereby granted provided that the above notice of copyright, these
c terms of use, and the disclaimer of warranty below appear in the
c source code and documentation, and that none of the names of The
c University of Chicago, The University of Washington, or the authors
c appear in advertising or endorsement of works derived from this
c software without specific prior written permission from all parties.
c
c THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
c EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
c MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
c IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
c CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
c TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
c SOFTWARE OR THE USE OR OTHER DEALINGS IN THIS SOFTWARE.
c//////////////////////////////////////////////////////////////////////
c
       subroutine wrpadd(iout,npack,array,npts)
c
c write a dp array to a file in packed-ascii-data format
c
c inputs:  [ no outputs / no side effects ]
c   iout   unit to write to (assumed open)
c   npack  number of characters to use (determines precision)
c   array  real array 
c   npts   number of array elements to read
c notes:
c   real number converted to packed-ascii-data string using pad
       include 'padlib.h'
       integer    iout, npack, npts, mxl, js, i
       character  str*128
       double precision array(*), xr
       js  = 0
       str = ' '
       mxl = maxlen - npack + 1
       do 20 i = 1, npts
          js = js+npack
          xr = array(i)
          call pad(xr, npack, str(js-npack+1:js))
          if ((js.ge.mxl).or.(i.eq.npts)) then
             write(iout,100) cpadr, str(1:js)
             js = 0
          end if
 20    continue
       return
 100   format(a1,a)
       end
c --padlib--

       subroutine wrpadx(iout,npack,array,npts)
c write complex*16 array as pad string
       include 'padlib.h'
       integer    iout, npack, npts, mxl, js, i
       complex*16 array(*)
       character  str*128
       double precision xr, xi
       js = 0
       str  = ' '
       mxl  = maxlen - 2 * npack + 1
       do 20 i = 1, npts
          js = js  + 2 * npack
          xr = dble(array(i))
          xi = dimag(array(i))
          call pad(xr, npack, str(js-2*npack+1:js-npack))
          call pad(xi, npack, str(js-npack+1:js))
          if ((js.ge.mxl).or.(i.eq.npts)) then
             write(iout,100) cpadc, str(1:js)
             js = 0
          end if
 20    continue
       return
 100   format(a1,a)
       end
c --padlib--
       subroutine wrpadr(iout,npack,array,npts)
c
c write a real array to a file in packed-ascii-data format
c
c inputs:  [ no outputs / no side effects ]
c   iout   unit to write to (assumed open)
c   npack  number of characters to use (determines precision)
c   array  real array 
c   npts   number of array elements to read
c notes:
c   real number converted to packed-ascii-data string using pad
       include 'padlib.h'
       integer    iout, npack, npts, mxl, js, i
       character  str*128
       real    array(*)
       double precision xr
       js  = 0
       str = ' '
       mxl = maxlen - npack + 1
       do 20 i = 1, npts
          js = js+npack
          xr = dble(array(i))
          call pad(xr, npack, str(js-npack+1:js))
          if ((js.ge.mxl).or.(i.eq.npts)) then
             write(iout,100) cpadr, str(1:js)
             js = 0
          end if
 20    continue
       return
 100   format(a1,a)
       end
c --padlib--
       subroutine wrpadc(iout,npack,array,npts)
c write complex (*8) array as pad string
       include 'padlib.h'
       integer    iout, npack, npts, mxl, js, i
       complex    array(*)
       character  str*128
       double precision xr, xi
       js = 0
       str  = ' '
       mxl  = maxlen - 2 * npack + 1
       do 20 i = 1, npts
          js = js  + 2 * npack
          xr = dble(array(i))
          xi = aimag(array(i))
          call pad(xr, npack, str(js-2*npack+1:js-npack))
          call pad(xi, npack, str(js-npack+1:js))
          if ((js.ge.mxl).or.(i.eq.npts)) then
             write(iout,100) cpadc, str(1:js)
             js = 0
          end if
 20    continue
       return
 100   format(a1,a)
       end
c --padlib--
       subroutine rdpadd(iou,npack,array,npts)
c read dparray from packed-ascii-data file
c arguments:
c   iou    unit to read from (assumed open)                   (in)
c   npack  number of characters to use (determines precision) (in)
c   array  real array                                         (out)
c   npts   number of array elements to read / number read     (in/out)
c notes:
c   packed-ascii-data string converted to real array using  unpad
       include 'padlib.h'
       integer iou, npack, npts, ndline, i, istrln, ipts, iread
       double precision    array(*), unpad , tmp
       character  ctest, ccomp
       character  str*128
       external  unpad, istrln, iread
       ccomp = cpadr
       ipts = 0
 10    continue 
          i = iread(iou, str)
          if (i.lt.0) go to 50
          call triml(str)
          ctest  = str(1:1)
          str    = str(2:)
          ndline = i/npack
          if ((ctest.ne.ccomp).or.(ndline.le.0)) go to 200
          do 30 i = 1, ndline
             ipts  = ipts + 1
             tmp   = unpad(str(1-npack+i*npack:i*npack),npack)
             array(ipts) = tmp
             if (ipts.ge.npts) go to 50
 30       continue 
          go to 10
 50    continue 
       return
 200   continue
       call warn(3,' -- Read_PAD error:  bad data at line:')
       i = istrln(str)
       call echo(str(:i))
       call fstop(' -- bad data in PAD data file -- ')
       end
c --padlib--
       subroutine rdpadr(iou,npack,array,npts)
c read real array from packed-ascii-data file
c arguments:
c   iou    unit to read from (assumed open)                   (in)
c   npack  number of characters to use (determines precision) (in)
c   array  real array                                         (out)
c   npts   number of array elements to read / number read     (in/out)
c notes:
c   packed-ascii-data string converted to real array using  unpad
       include 'padlib.h'
       integer iou, npack, npts, ndline, i, istrln, ipts, iread
       real    array(*)
       double precision unpad , tmp
       character  ctest, ccomp
       character  str*128
       external  unpad, istrln, iread
       ccomp = cpadr
       ipts = 0
 10    continue 
          i = iread(iou, str)
          if (i.lt.0) go to 50
          call triml(str)
          ctest  = str(1:1)
          str    = str(2:)
          ndline = i/npack
          if ((ctest.ne.ccomp).or.(ndline.le.0)) go to 200
          do 30 i = 1, ndline
             ipts  = ipts + 1
             tmp   = unpad(str(1-npack+i*npack:i*npack),npack)
             array(ipts) = real(tmp)
             if (ipts.ge.npts) go to 50
 30       continue 
          go to 10
 50    continue 
       return
 200   continue
       call warn(3, ' -- Read_PAD error:  bad data at line:')
       i = istrln(str)
       call echo(str(:i))
       call fstop(' -- bad data in PAD data file -- ')
       end
c --padlib--
       subroutine rdpadc(iou,npack,array,npts)
c read complex array from packed-ascii-data file
c arguments:
c   iou    unit to read from (assumed open)                  (in)
c   npack  number of characters to use (determines precision)(in)
c   array  complex array                                     (out)
c   npts   number of array elements to read / number read    (in/out)
c notes:
c   packed-ascii-data string converted to real array using  unpad
       include 'padlib.h'
       integer iou, npack,npts, ndline, i, istrln, ipts, np, iread
       double precision  unpad, tmpr, tmpi
       complex  array(*)
       character  ctest, ccomp
       character  str*128
       external  unpad, istrln, iread
       ccomp = cpadc
       ipts = 0
       np   = 2 * npack
 10    continue 
          i = iread(iou, str)
          if (i.lt.0) go to 50
          call triml(str)
          ctest  = str(1:1)
          str    = str(2:)
          ndline = i / np
          if ((ctest.ne.ccomp).or.(ndline.le.0)) go to 200
          do 30 i = 1, ndline
             ipts = ipts + 1
             tmpr = unpad(str(1-np+i*np:-npack+i*np),npack)
             tmpi = unpad(str(1-npack+i*np:i*np),npack)
             array(ipts) = cmplx(tmpr, tmpi)
             if (ipts.ge.npts) go to 50
 30       continue 
          go to 10
 50    continue 
       return
 200   continue
       call warn(3, ' -- Read_PAD error:  bad data at line:')
       i = istrln(str)
       call echo(str(:i))
       call fstop(' -- bad data in PAD data file -- ')
       end
       subroutine rdpadx(iou,npack,array,npts)
c read complex*16 array from packed-ascii-data file
c arguments:
c   iou    unit to read from (assumed open)                  (in)
c   npack  number of characters to use (determines precision)(in)
c   array  complex array                                     (out)
c   npts   number of array elements to read / number read    (in/out)
c notes:
c   packed-ascii-data string converted to real array using  unpad
       include 'padlib.h'
       integer iou, npack,npts, ndline, i, istrln, ipts, np, iread
       double precision  unpad, tmpr, tmpi
       complex*16  array(*)
       character  ctest, ccomp
       character  str*128
       external  unpad, istrln, iread
       ccomp = cpadc
       ipts = 0
       np   = 2 * npack
 10    continue 
          i = iread(iou, str)
          if (i.lt.0) go to 50
          call triml(str)
          ctest  = str(1:1)
          str    = str(2:)
          ndline = i / np
          if ((ctest.ne.ccomp).or.(ndline.le.0)) go to 200
          do 30 i = 1, ndline
             ipts = ipts + 1
             tmpr = unpad(str(1-np+i*np:-npack+i*np),npack)
             tmpi = unpad(str(1-npack+i*np:i*np),npack)
             array(ipts) = cmplx(tmpr, tmpi)
             if (ipts.ge.npts) go to 50
 30       continue 
          go to 10
 50    continue 
       return
 200   continue
       call warn(3,' -- Read_PAD error:  bad data at line:')
       i = istrln(str)
       call echo(str(:i))
       call fstop(' -- bad data in PAD data file -- ')
       end

c --padlib--
       subroutine pad(xreal,npack,str)
c  convert dp number *xreal* to packed-ascii-data string *str*
       include 'padlib.h'
       integer  iexp, itmp, isgn, i, npack, iok, j
       double precision xreal, xwork, xsave
       double precision tenth, tenmm, half, small
       parameter (tenth = 0.1d0, tenmm = 0.099999999994d0)
       parameter (half  = 0.5d0, small = 1.d-10 )
       character str*(*)
c
       str      = ' '
       xsave    = min(huge, max(-huge, xreal))
       isgn     = 1
       if (xsave.le.0) isgn = 0
c
       xwork    = dabs( xsave )
       iexp     = 0
       if ((xwork.lt.huge).and.(xwork.gt.tiny))  then
          iexp  =   1 + int(log(xwork) / tenlog  )
       else if (xwork.ge.huge) then
          iexp  = ihuge
          xwork = one
       else if (xwork.le.tiny)  then
          xwork = zero
       end if
c force xwork between ~0.1 and ~1
c note: this causes a loss of precision, but 
c allows backward compatibility
       xwork    = xwork / (ten ** iexp)
 20    continue
       if (xwork.ge.one) then
          xwork = xwork * tenth
          iexp  = iexp + 1
       else if (xwork.le.tenmm) then
          xwork = xwork * ten
          iexp  = iexp - 1
       endif
       if (xwork.ge.one) go to 20

       itmp     = int ( ibas2 * xwork ) 
       str(1:1) = char(iexp  + ioff + ibas2 )
       str(2:2) = char( 2 * itmp + isgn + ioff)
       xwork    = xwork * ibas2 - itmp
       if (npack.gt.2) then
          do 100 i = 3, npack
             itmp     = int( base * xwork + small)
             str(i:i) = char(itmp + ioff)
             xwork    = xwork * base - itmp
 100      continue
       end if
       if (xwork.ge.half) then
          i = itmp + ioff + 1
          if (i.lt.(ibase+ioff)) then
             str(npack:npack)= char(i)
          else 
             j = ichar(str(npack-1:npack-1))
             if (j.lt.(ibase+ioff-1)) then
                str(npack-1:npack-1) = char(j+1)
                str(npack:npack)     = char(ioff)
             endif 
          endif
       endif
       return
       end
c --padlib--
       double precision function unpad(str,npack)
c
c  convert packed-ascii-data string *str* to dp number *unpad*
       include 'padlib.h'
       double precision sum
       integer   iexp, itmp, isgn, i, npack
       character str*(*)
       unpad = zero
       if (npack.le.2) return
       iexp  =     (ichar(str(1:1)) - ioff   ) - ibas2
       isgn  = mod (ichar(str(2:2)) - ioff, 2) * 2 - 1
       itmp  =     (ichar(str(2:2)) - ioff   ) / 2
       sum   = dble(itmp/(base*base))
       do 100 i = npack, 3, -1
          sum = sum + dble(ichar(str(i:i)) - ioff) / base**i
 100   continue
       unpad = 2 * isgn * ibase * sum * (ten ** iexp)
cc       print*, sum, iexp,unpad
       return
       end
c --padlib--
c end of pad library
c ----------

      subroutine wlog (string)
      character*(*) string

      include '../HEADERS/parallel.h'

c     This output routine is used to replace the PRINT statement
c     for output that "goes to the terminal", or to the log file.
c     If you use a window based system, you can modify this routine
c     to handle the running output elegantly.
c     Handle carriage control in the string you pass to wlog.
c
c     The log file is also written here, hard coded here.

c     The log file is unit 11.  The log file is opened in the
c     main program, program feff.

c     make sure not to write trailing blanks

   10 format (a)

c     Suppress output in sequential loops
      if (par_type .eq. 2) return

      il = istrln (string)
      if (il .eq. 0)  then
         print10
         if (par_type .ne. 3) write(11,10)
      else
         print10, string(1:il)
         if (par_type .ne. 3) write(11,10) string(1:il)
      endif
      return
      end
      subroutine lblank (string)
      character*(*) string
c     add a leading blank, useful for carriage control
      string = ' ' // string
      return
      end

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Information about last revision of $RCSfile: m_padio.f90,v $:
! $Revision: 1.2 $
! $Author: hebhop $
! $Date: 2010/02/23 23:52:06 $
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
! PAD library:   Packed Ascii Data 
!   these routines contain code for handling packed-ascii-data  
!   (pad) arrays for writing printable character strings that 
!   represent real or complex scalars and arrays to a file.
!
! routines included in padlib are (dp==double precision):
!   wrpadd     write a dp array as pad character strings
!   wrpadx     write a dp complex array as pad character strings
!   rdpadr     read a pad character array as a real array
!   rdpadd     read a pad character array as a dp  array
!   rdpadc     read a pad character array as a complex array
!   rdpadx     read a pad character array as a dp complex array
!   pad        internal routine to convert dp number to pad string
!   unpad      internal routine to pad string to dp number
!
! routines not included, but required by padlib:
!     triml, istrln, wlog
!
!//////////////////////////////////////////////////////////////////////
! Copyright (c) 1997--2001 Matthew Newville, The University of Chicago
! Copyright (c) 1992--1996 Matthew Newville, University of Washington
!
! Permission to use and redistribute the source code or binary forms of
! this software and its documentation, with or without modification is
! hereby granted provided that the above notice of copyright, these
! terms of use, and the disclaimer of warranty below appear in the
! source code and documentation, and that none of the names of The
! University of Chicago, The University of Washington, or the authors
! appear in advertising or endorsement of works derived from this
! software without specific prior written permission from all parties.
!
! THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
! EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
! MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
! IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
! CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
! TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
! SOFTWARE OR THE USE OR OTHER DEALINGS IN THIS SOFTWARE.
!//////////////////////////////////////////////////////////////////////
! License is applicable for routines below, until otherwise specified.
!
MODULE PADIO
  USE ErrorMod

  ! padlib.h -*-fortran-*-
  !  header of parameters for packed-ascii-data (pad) routines
  implicit none
  character,private :: cpadr, cpadi, cpadc
  integer,private ::  maxlen, ibase, ioff, ihuge, ibas2
  double precision,private :: ten, tenlog, huge, tiny, one, zero, base
  parameter(cpadr = '!', cpadc = '$', cpadi = '%')
  parameter(ibase = 90, ioff = 37, ihuge = 38, maxlen = 82)
  parameter(ibas2 = ibase/2, zero=0d0, one=1.d0, ten = 10.d0)
  parameter(tenlog= 2.302585092994045684d0)
  parameter(huge = ten**ihuge, tiny = one/huge)
  parameter(base = ibase*one)

  INTERFACE WritePAD
     MODULE PROCEDURE wrpaddsc
     MODULE PROCEDURE wrpadrsc
     MODULE PROCEDURE wrpadxsc
     MODULE PROCEDURE wrpadcsc
     MODULE PROCEDURE wrpadisc
     MODULE PROCEDURE wrpadssc
  END INTERFACE

  INTERFACE ReadPAD
     MODULE PROCEDURE rdpaddsc
     MODULE PROCEDURE rdpadrsc
     MODULE PROCEDURE rdpadxsc
     MODULE PROCEDURE rdpadcsc
     MODULE PROCEDURE rdpadisc
     MODULE PROCEDURE rdpadssc
  END INTERFACE

CONTAINS

  subroutine wrpaddsc(strval, npack,val)
    !
    ! write a dp scalar to a file in packed-ascii-data format
    !
    ! inputs:  [ no outputs / no side effects ]
    !   iout   unit to write to (assumed open)
    !   npack  number of characters to use (determines precision)
    !   array  real array 
    ! notes:
    !   real number converted to packed-ascii-data string using pad

    !integer    iout, npts, i
    integer npack, mxl, js
    character*(*) :: strval
    character  str*128
    double precision val, xr
    js  = 0
    str = ' '
    mxl = maxlen - npack + 1

    js = js+npack
    xr = val
    call padx(xr, npack, str(js-npack+1:js))

    ! Trim trailing zeros.
!    DO i = js, 4, -1
!       IF(str(i:i).eq.'%') THEN
!          str(i:i) = ' '
!       ELSE
!          EXIT
!       END IF
!    END DO
    strval = str(1:js)
    js = 0
    
    return
    ! 100 format(a1,a)
  end subroutine wrpaddsc

!   subroutine wrpadd(iout,npack,array,npts)
!     !
!     ! write a dp array to a file in packed-ascii-data format
!     !
!     ! inputs:  [ no outputs / no side effects ]
!     !   iout   unit to write to (assumed open)
!     !   npack  number of characters to use (determines precision)
!     !   array  real array 
!     !   npts   number of array elements to read
!     ! notes:
!     !   real number converted to packed-ascii-data string using pad

!     integer    iout, npack, npts, mxl, js, i
!     character  str*128
!     double precision array(*), xr
!     js  = 0
!     str = ' '
!     mxl = maxlen - npack + 1
!     do i = 1, npts
!        js = js+npack
!        xr = array(i)
!        call padx(xr, npack, str(js-npack+1:js))
!        if ((js.ge.mxl).or.(i.eq.npts)) then
!           write(iout,100) cpadr, str(1:js)
!           js = 0
!        end if
!     end do
!     return
! 100 format(a1,a)
!   end subroutine wrpadd
  ! --padlib--
  subroutine wrpadxsc(strval,npack,val)
    ! write complex*16 scalar as pad string
    character*(*) strval
    !integer    iout, i
    integer    npack, mxl, js
    complex*16 val
    character  str1*128, str2*128
    double precision xr, xi
    js = 0
    str1  = ' '
    str2 = ' '
    mxl  = maxlen - 2 * npack + 1
    js = js  + 2 * npack + 1
    xr = dble(val)
    xi = dimag(val)
    call padx(xr, npack, str1(1:npack))

    ! Trim trailing zeros.
!    DO i = js, 4, -1
!       IF(str1(i:i).eq.'%') str1(i:i) = ' '
!    END DO
    
    call padx(xi, npack, str2(1:npack))

    ! Trim trailing zeros.
!    DO i = js, 4, -1
!       IF(str2(i:i).eq.'%') str2(i:i) = ' '
!    END DO


    strval = TRIM(ADJUSTL(str1)) // ' ' // TRIM(ADJUSTL(str2))
    js = 0
    
    
    return
    ! 100 format(a1,a)
  end subroutine wrpadxsc

!   subroutine wrpadx(iout,npack,array,npts)
!     ! write complex*16 array as pad string

!     integer    iout, npack, npts, mxl, js, i
!     complex*16 array(npts)
!     character  str*128
!     double precision xr, xi
!     js = 0
!     str  = ' '
!     mxl  = maxlen - 2 * npack + 1
!     do i = 1, npts
!        js = js  + 2 * npack
!        xr = dble(array(i))
!        xi = dimag(array(i))
!        call padx(xr, npack, str(js-2*npack+1:js-npack))
!        call padx(xi, npack, str(js-npack+1:js))
!        if ((js.ge.mxl).or.(i.eq.npts)) then
!           write(iout,100) cpadc, str(1:js)
!           js = 0
!        end if
!     end do
!     return
! 100 format(a1,a)
!   end subroutine wrpadx
!   ! --padlib--

  subroutine wrpadrsc(strval,npack,val)
    !
    ! write a real array to a file in packed-ascii-data format
    !
    ! inputs:  [ no outputs / no side effects ]
    !   iout   unit to write to (assumed open)
    !   npack  number of characters to use (determines precision)
    !   array  real array 
    !   npts   number of array elements to read
    ! notes:
    !   real number converted to packed-ascii-data string using pad
    character*(*) strval
    !integer    iout, i
    integer    npack, mxl, js
    character  str*128
    real    val
    double precision xr
    js  = 0
    str = ' '
    mxl = maxlen - npack + 1

    js = js+npack
    xr = dble(val)
    call padx(xr, npack, str(js-npack+1:js))

    ! Trim trailing zeros.
!    DO i = js, 4, -1
!       IF(str(i:i).eq.'%') str(i:i) = ' '
!    END DO

    strval = str(1:js)
    js = 0

    return
    ! 100 format(a1,a)
  end subroutine wrpadrsc

!   subroutine wrpadr(iout,npack,array,npts)
!     !
!     ! write a real array to a file in packed-ascii-data format
!     !
!     ! inputs:  [ no outputs / no side effects ]
!     !   iout   unit to write to (assumed open)
!     !   npack  number of characters to use (determines precision)
!     !   array  real array 
!     !   npts   number of array elements to read
!     ! notes:
!     !   real number converted to packed-ascii-data string using pad

!     integer    iout, npack, npts, mxl, js, i
!     character  str*128
!     real    array(npts)
!     double precision xr
!     js  = 0
!     str = ' '
!     mxl = maxlen - npack + 1
!     do i = 1, npts
!        js = js+npack
!        xr = dble(array(i))
!        call padx(xr, npack, str(js-npack+1:js))
!        if ((js.ge.mxl).or.(i.eq.npts)) then
!           write(iout,100) cpadr, str(1:js)
!           js = 0
!        end if
!     end do
!     return
! 100 format(a1,a)
!   end subroutine wrpadr

!   ! --padlib--
  subroutine wrpadcsc(strval,npack,val)
    ! write complex (*8) scalar as pad string
    character*(*) strval
    ! integer    iout, i
    integer    npack, mxl, js
    complex    val
    character  str1*128, str2*128
    double precision xr, xi
    js = 0
    str1  = ' '
    str2  = ' ' 
    mxl  = maxlen - 2 * npack + 1

    js = js  + 2 * npack + 1
    xr = dble(val)
    xi = aimag(val)
    call padx(xr, npack, str1(1:npack))
    ! Trim trailing zeros.
!    DO i = js, 4, -1
!       IF(str1(i:i).eq.'%') str1(i:i) = ' '
!    END DO

    call padx(xi, npack, str2(1:npack))
    ! Trim trailing zeros.
!    DO i = js, 4, -1
!       IF(str2(i:i).eq.'%') str2(i:i) = ' '
!    END DO

    strval = TRIM(ADJUSTL(str1)) // ' ' // TRIM(ADJUSTL(str2))
    js = 0
    
    return
    ! 100 format(a1,a)
  end subroutine wrpadcsc
  ! --padlib--
!   subroutine wrpadc(iout,npack,array,npts)
!     ! write complex (*8) array as pad string
!     integer    iout, npack, npts, mxl, js, i
!     complex    array(*)
!     character  str*128
!     double precision xr, xi
!     js = 0
!     str  = ' '
!     mxl  = maxlen - 2 * npack + 1
!     do i = 1, npts
!        js = js  + 2 * npack
!        xr = dble(array(i))
!        xi = aimag(array(i))
!        call padx(xr, npack, str(js-2*npack+1:js-npack))
!        call padx(xi, npack, str(js-npack+1:js))
!        if ((js.ge.mxl).or.(i.eq.npts)) then
!           write(iout,100) cpadc, str(1:js)
!           js = 0
!        end if
!     end do
!     return
! 100 format(a1,a)
!   end subroutine wrpadc
  ! --padlib--
  subroutine wrpadisc(strval,val)
    character*(*) strval
    ! integer iou, imin
    integer iabs, val, n, irem, iend
    character sign
    
    strval = ' '

    ! Set the sign
    if(val.lt.0) then
       sign = '-'
    else
       sign = '+'
    end if
    iend = LEN(strval)
    iabs = ABS(val)
    n = 0

    do
       IF(iabs.le.75**(n+1)) THEN
          strval(iend-n:iend-n) = ACHAR(INT(iabs/75**n)+48)
          strval(iend-n-1:iend-n-1) = sign
          strval = TRIM(ADJUSTL(strval))
          EXIT
       ELSE
          irem = MOD(iabs,75**(n+1))
          strval(iend-n:iend-n) = ACHAR(INT(irem/75**n)+48)
          iabs = iabs - irem
       END IF
       n = n + 1
       IF(n.eq.100) CALL Error('Error in wrpadisc: integer too large.')
    end do
    
  end subroutine wrpadisc

!  subroutine wrpadi(iou,val,npts)
!    integer iou, val(:), npts, ipts
!    do ipts = 1, npts
!       call wrpadisc(iou,val(i))
!    end do
!  end subroutine wrpadi    

  subroutine wrpadssc(strval,val)    
    ! integer iou
    character*(*) val, strval

    ! This is a string. Just write it.
    strval = TRIM(ADJUSTL(val))
  end subroutine wrpadssc

!  subroutine wrpads(iou,val,npts)
!    integer iou, npts, ipts
!    character val(:)

!    do ipts = 1, npts
!       call wrpadssc(iou,val(ipts))
!    end do
!  end subroutine wrpads
    
  ! --padlib--
  subroutine rdpaddsc(str,npack,val)
    ! read dp scalar from packed-ascii-data file
    ! arguments:
    !   iou    unit to read from (assumed open)                   (in)
    !   npack  number of characters to use (determines precision) (in)
    !   val  double variable                                         (out)
    ! notes:
    !   packed-ascii-data string converted to real array using  unpad

    ! integer iou
    integer npack, ndline, i, istrln, ipts, np
    double precision    val, tmp
    ! character ctest
    character ccomp
    character*(*)  str
    external  istrln
    ccomp = cpadr
    ipts = 0
    call sclean(str)
    i = istrln(str)
    if (i.lt.0) go to 50
    call triml(str)
    np = i
    ndline = i/np
    if (ndline.le.0) go to 200
    tmp   = unpadx(str(1:np),np)
    val = tmp
50  continue 
    return
200 continue
    call error(' -- Read_PAD error:  bad data at line:',StopProgram = .FALSE.)
    i = istrln(str)
    call error(str(:i), StopProgram = .FALSE.)
    call error(' -- fatal error in reading PAD data file -- ')
  end subroutine rdpaddsc

!   subroutine rdpadd(iou,npack,array,npts)
!     ! read dparray from packed-ascii-data file
!     ! arguments:
!     !   iou    unit to read from (assumed open)                   (in)
!     !   npack  number of characters to use (determines precision) (in)
!     !   array  real array                                         (out)
!     !   npts   number of array elements to read / number read     (in/out)
!     ! notes:
!     !   packed-ascii-data string converted to real array using  unpad

!     integer iou, npack, npts, ndline, i, istrln, ipts
!     double precision    array(*), tmp
!     character  ctest, ccomp
!     character  str*128
!     external  istrln
!     ccomp = cpadr
!     ipts = 0
!     do
!        i = iread(iou, str)
!        if (i.lt.0) go to 50
!        call triml(str)
!        ctest  = str(1:1)
!        str    = str(2:)
!        ndline = i/npack
!        if ((ctest.ne.ccomp).or.(ndline.le.0)) go to 200
!        do i = 1, ndline
!           ipts  = ipts + 1
!           tmp   = unpadx(str(1-npack+i*npack:i*npack),npack)
!           array(ipts) = tmp
!           if (ipts.ge.npts) go to 50
!        end do
!     end do
! 50  continue 
!     return
! 200 continue
!     call error(' -- Read_PAD error:  bad data at line:',StopProgram = .FALSE.)
!     i = istrln(str)
!     call error(str(:i), StopProgram = .FALSE.)
!     call error(' -- fatal error in reading PAD data file -- ')
!   end subroutine rdpadd

  ! --padlib--
  subroutine rdpadrsc(str,npack,val)
    ! read real array from packed-ascii-data file
    ! arguments:
    !   iou    unit to read from (assumed open)                   (in)
    !   npack  number of characters to use (determines precision) (in)
    !   array  real array                                         (out)
    !   npts   number of array elements to read / number read     (in/out)
    ! notes:
    !   packed-ascii-data string converted to real array using  unpad

    !integer iou
    integer npack, ndline, i, istrln, ipts, np
    real    val
    double precision tmp
    ! character ctest
    character ccomp
    character*(*)  str
    external  istrln
    ccomp = cpadr
    ipts = 0
    call sclean(str)
    i = istrln(str)
    if (i.lt.0) go to 50
    call triml(str)
    np = i
    ndline = i/np
    if (ndline.le.0) go to 200
    
    tmp   = unpadx(str(1:np),np)
    val = real(tmp)

50  continue 
    return
200 continue
    call error(' -- Read_PAD error:  bad data at line:',StopProgram = .FALSE.)
    i = istrln(str)
    call error(str(:i),StopProgram = .FALSE.)
    call error(' -- fatal error in reading PAD data file -- ')
  end subroutine rdpadrsc

!   ! --padlib--
!   subroutine rdpadr(iou,npack,array,npts)
!     ! read real array from packed-ascii-data file
!     ! arguments:
!     !   iou    unit to read from (assumed open)                   (in)
!     !   npack  number of characters to use (determines precision) (in)
!     !   array  real array                                         (out)
!     !   npts   number of array elements to read / number read     (in/out)
!     ! notes:
!     !   packed-ascii-data string converted to real array using  unpad

!     integer iou, npack, npts, ndline, i, istrln, ipts
!     real    array(*)
!     double precision tmp
!     character  ctest, ccomp
!     character  str*128
!     external  istrln
!     ccomp = cpadr
!     ipts = 0
! 10  continue 
!     i = iread(iou, str)
!     if (i.lt.0) go to 50
!     call triml(str)
!     ctest  = str(1:1)
!     str    = str(2:)
!     ndline = i/npack
!     if ((ctest.ne.ccomp).or.(ndline.le.0)) go to 200
!     do i = 1, ndline
!        ipts  = ipts + 1
!        tmp   = unpadx(str(1-npack+i*npack:i*npack),npack)
!        array(ipts) = real(tmp)
!        if (ipts.ge.npts) go to 50
!     end do
!     go to 10
! 50  continue 
!     return
! 200 continue
!     call error(' -- Read_PAD error:  bad data at line:',StopProgram = .FALSE.)
!     i = istrln(str)
!     call error(str(:i),StopProgram = .FALSE.)
!     call error(' -- fatal error in reading PAD data file -- ')
!   end subroutine rdpadr
  ! --padlib--
  subroutine rdpadcsc(str,npack,val)
    ! read complex array from packed-ascii-data file
    ! arguments:
    !   iou    unit to read from (assumed open)                  (in)
    !   npack  number of characters to use (determines precision)(in)
    !   array  complex array                                     (out)
    !   npts   number of array elements to read / number read    (in/out)
    ! notes:
    !   packed-ascii-data string converted to real array using  unpad

    ! integer iou, npts
    integer npack, ndline, i, istrln, ipts, np
    double precision  tmpr, tmpi
    complex  val
    ! character ctest
    character ccomp
    character*(*)  str
    external  istrln
    ccomp = cpadc
    ipts = 0
    np   = 2 * npack

    call sclean(str)
    i = istrln(str)
    if (i.lt.0) go to 50
    call triml(str)

    ndline = i / np
    if (ndline.le.0) go to 200
    
    tmpr = unpadx(str(1:npack),npack)
    tmpi = unpadx(str(npack+1:2*npack),npack)
    val = cmplx(real(tmpr), real(tmpi))
    
50  continue 
    return
200 continue
    call error(' -- Read_PAD error:  bad data at line:',StopProgram = .FALSE.)
    i = istrln(str)
    call error(str(:i),StopProgram = .FALSE.)
    call error(' -- fatal error in reading PAD data file -- ')
  end subroutine rdpadcsc

!   subroutine rdpadc(iou,npack,array,npts)
!     ! read complex array from packed-ascii-data file
!     ! arguments:
!     !   iou    unit to read from (assumed open)                  (in)
!     !   npack  number of characters to use (determines precision)(in)
!     !   array  complex array                                     (out)
!     !   npts   number of array elements to read / number read    (in/out)
!     ! notes:
!     !   packed-ascii-data string converted to real array using  unpad

!     integer iou, npack,npts, ndline, i, istrln, ipts, np
!     double precision  tmpr, tmpi
!     complex  array(*)
!     character  ctest, ccomp
!     character  str*128
!     external  istrln
!     ccomp = cpadc
!     ipts = 0
!     np   = 2 * npack
! 10  continue 
!     i = iread(iou, str)
!     if (i.lt.0) go to 50
!     call triml(str)
!     ctest  = str(1:1)
!     str    = str(2:)
!     ndline = i / np
!     if ((ctest.ne.ccomp).or.(ndline.le.0)) go to 200
!     do i = 1, ndline
!        ipts = ipts + 1
!        tmpr = unpadx(str(1-np+i*np:-npack+i*np),npack)
!        tmpi = unpadx(str(1-npack+i*np:i*np),npack)
!        array(ipts) = cmplx(tmpr, tmpi)
!        if (ipts.ge.npts) go to 50
!     end do
!     go to 10
! 50  continue 
!     return
! 200 continue
!     call error(' -- Read_PAD error:  bad data at line:',StopProgram = .FALSE.)
!     i = istrln(str)
!     call error(str(:i),StopProgram = .FALSE.)
!     call error(' -- fatal error in reading PAD data file -- ')
!   end subroutine rdpadc
  subroutine rdpadxsc(str,npack,val)
    ! read complex*16 array from packed-ascii-data file
    ! arguments:
    !   iou    unit to read from (assumed open)                  (in)
    !   npack  number of characters to use (determines precision)(in)
    !   array  complex array                                     (out)
    !   npts   number of array elements to read / number read    (in/out)
    ! notes:
    !   packed-ascii-data string converted to real array using  unpad

    ! integer iou, npts
    integer npack, ndline, i, istrln, ipts, np
    double precision  tmpr, tmpi
    complex*16  val
    ! character ctest
    character  ccomp
    character*(*)  str
    external  istrln
    ccomp = cpadc
    ipts = 0
    np   = 2 * npack

    call sclean(str)
    i = istrln(str)
    if (i.lt.0) go to 50
    call triml(str)

    ndline = i / np
    if (ndline.le.0) go to 200

    tmpr = unpadx(str(1:npack),npack)
    tmpi = unpadx(str(npack+1:2*npack),npack)
    val = dcmplx(tmpr, tmpi)

50  continue 
    return
200 continue
    call error(' -- Read_PAD error:  bad data at line:',StopProgram = .FALSE.)
    i = istrln(str)
    call error(str(:i),StopProgram = .FALSE.)
    call error(' -- fatal error in reading PAD data file -- ')
  end subroutine rdpadxsc
!   subroutine rdpadx(iou,npack,array,npts)
!     ! read complex*16 array from packed-ascii-data file
!     ! arguments:
!     !   iou    unit to read from (assumed open)                  (in)
!     !   npack  number of characters to use (determines precision)(in)
!     !   array  complex array                                     (out)
!     !   npts   number of array elements to read / number read    (in/out)
!     ! notes:
!     !   packed-ascii-data string converted to real array using  unpad

!     integer iou, npack,npts, ndline, i, istrln, ipts, np
!     double precision  tmpr, tmpi
!     complex*16  array(*)
!     character  ctest, ccomp
!     character  str*128
!     external  istrln
!     ccomp = cpadc
!     ipts = 0
!     np   = 2 * npack
! 10  continue 
!     i = iread(iou, str)
!     if (i.lt.0) go to 50
!     call triml(str)
!     ctest  = str(1:1)
!     str    = str(2:)
!     ndline = i / np
!     if ((ctest.ne.ccomp).or.(ndline.le.0)) go to 200
!     do i = 1, ndline
!        ipts = ipts + 1
!        tmpr = unpadx(str(1-np+i*np:-npack+i*np),npack)
!        tmpi = unpadx(str(1-npack+i*np:i*np),npack)
!        array(ipts) = cmplx(tmpr, tmpi)
!        if (ipts.ge.npts) go to 50
!     end do
!     go to 10
! 50  continue 
!     return
! 200 continue
!     call error(' -- Read_PAD error:  bad data at line:',StopProgram = .FALSE.)
!     i = istrln(str)
!     call error(str(:i),StopProgram = .FALSE.)
!     call error(' -- fatal error in reading PAD data file -- ')
!   end subroutine rdpadx

  subroutine rdpadisc(strval,val)
    ! integer iou, imin, irem
    integer iabs, val, n, iend, ic, sign
    character*(*) strval
    character str*128
    character c

    iabs = 0
    str = TRIM(ADJUSTL(strval))
    iend = LEN_TRIM(str)
    IF(str(1:1).eq.'+') THEN
       sign = 1
    ELSE
       sign = -1
    END IF
    do n = iend, 2, -1
       c = str(n:n)
       ic = IACHAR(c) - 48
       iabs = iabs + ic*75**(iend - n)
    end do
    val = sign*iabs
  end subroutine rdpadisc

  subroutine rdpadssc(strval,val)
    character*(*) strval, val
    val = TRIM(ADJUSTL(strval))
  end subroutine rdpadssc
!   subroutine rdpadi(iou,val,npts)
!     integer iou, val(:), npts, ipts
!     do ipts = 1, npts
!        call rdpadisc(iou,val(ipts))
!     end do
!   end subroutine rdpadi
    
  ! --padlib--
  ! --padlib--
  subroutine padx(xreal,npack,str)
    !  convert dp number *xreal* to packed-ascii-data string *str*

    integer  iexp, itmp, isgn, i, npack, j
    ! double precision onem
    double precision xreal, xwork, xsave, tenth
    !parameter (onem  =  0.99999999997d0)
    parameter (tenth =  0.099999999994d0)
    character str*(*)
    !
    str      = ' '
    xsave    = min(huge, max(-huge, xreal))
    isgn     = 1
    if (xsave.le.0) isgn = 0
    !
    xwork    = dabs( xsave )
    iexp     = 0
    if ((xwork.lt.huge).and.(xwork.gt.tiny))  then
       iexp  =   1 + int(log(xwork) / tenlog  )
    else if (xwork.ge.huge) then
       iexp  = ihuge
       xwork = one
    else if (xwork.le.tiny)  then
       xwork = zero
    end if
    ! force xwork between ~0.1 and ~1
    ! note: this causes a loss of precision, but 
    ! allows backward compatibility
    xwork    = xwork / (ten ** iexp)
20  continue
    if (xwork.ge.one) then
       xwork = xwork * 0.100000000000000d0
       iexp  = iexp + 1
    else if (xwork.le.tenth) then
       xwork = xwork * ten
       iexp  = iexp - 1
    endif
    if (xwork.ge.one) go to 20

    itmp     = int ( ibas2 * xwork ) 
    str(1:1) = char(iexp  + ioff + ibas2 )
    str(2:2) = char( 2 * itmp + isgn + ioff)
    xwork    = xwork * ibas2 - itmp
    if (npack.gt.2) then
       do i = 3, npack
          itmp     = int( base * xwork + 1.d-9)
          str(i:i) = char(itmp + ioff)
          xwork    = xwork * base - itmp
       end do
    end if
    if (xwork.ge.0.5d0) then
       i = itmp + ioff + 1
       if (i.le.126) then
          str(npack:npack)= char(i)
       else 
          j = ichar(str(npack-1:npack-1))
          if (j.lt.126) then
             str(npack-1:npack-1) = char(j+1)
             str(npack:npack)     = char(37)
          endif
       endif
    endif
    return
  end subroutine padx

    
  ! --padlib--
  double precision function unpadx(str,npack)
    !
    !  convert packed-ascii-data string *str* to dp number *unpad*

    double precision sum
    integer   iexp, itmp, isgn, i, npack
    character str*(*)
    unpadx = zero
    if (npack.le.2) return
    iexp  =     (ichar(str(1:1)) - ioff   ) - ibas2
    isgn  = mod (ichar(str(2:2)) - ioff, 2) * 2 - 1
    itmp  =     (ichar(str(2:2)) - ioff   ) / 2
    sum   = dble(itmp/(base*base))
    !       do 100 i = 3, npack
    !          sum = sum + dble(ichar(str(i:i)) - ioff) / base**i
    ! 100   continue
    do i = npack, 3, -1
       sum = sum + dble(ichar(str(i:i)) - ioff) / base**i
    end do
    unpadx = 2 * isgn * ibase * sum * (ten ** iexp)
    !c       print*, sum, iexp,unpad
    return
  end function unpadx
  ! --padlib--
  ! end of pad library
  ! ----------
!   integer function iread(lun,string)
!     !
!     ! generalized internal read:
!     !    read a string the next line of an opened file 
!     !    unit, returning the real length of string
!     ! 
!     ! inputs:   
!     !   lun     opened file unit number
!     ! outputs:
!     !   string  string read from file
!     ! returns:
!     !   iread   useful length of string, as found from 
!     !                  sending string to 'sclean' to 
!     !                  remove non-printable characters
!     !                   and then istrln  
!     !           or
!     !              -1   on 'end-of-file'
!     !              -2   on 'error'
!     !
!     ! copyright (c) 1999  Matthew Newville
!     implicit none
!     character*(*) string
!     integer    lun, istrln
!     external   istrln
!     string = ' '
! 10  format(a)
!     read(lun, 10, end = 40, err = 50) string
!     call sclean(string)
!     iread = istrln(string)
!     return
! 40  continue 
!     string = ' '
!     iread = -1
!     return
! 50  continue 
!     string = ' '
!     iread = -2
!     return
!   end function iread
  subroutine sclean(str) 
    !
    !  clean a string, especially for strings passed between 
    !  different file systems, or from C functions:
    !
    !   1. characters in the range char(0), or char(10)...char(15) 
    !      are interpreted as end-of-line characters, so that all
    !      remaining characters are explicitly blanked.
    !   2. all other characters below char(31) (including tab) are
    !      replaced by a single blank
    !
    !  this is mostly useful when getting a string generated by a C 
    !  function and for handling dos/unix/max line-endings.
    !
    ! copyright (c) 1999  Matthew Newville
    character*(*) str, blank*1
    parameter (blank = ' ')
    integer i,j,is
    do i = 1, len(str)
       is = ichar(str(i:i))
       if ((is.eq.0) .or. ((is.ge.10) .and. (is.le.15))) then
          do j= i, len(str)
             str(j:j) = blank
          end do
          return
       elseif (is.le.31)  then
          str(i:i)  = blank
       end if
    end do
    return
    ! end subroutine sclean
  end subroutine sclean
END MODULE PADIO

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Information about last revision of $RCSfile: m_dimsmod.f90,v $:
! $Revision: 1.30 $
! $Author: jorissen $
! $Date: 2012/06/29 01:05:24 $
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
module DimsMod
  ! This module contains dimensions for data arrays

  ! The file in which dimensions current to the calculation are saved :
  character*20, parameter :: dimFName = '.dimensions.dat'
  ! Set the following according to max. available memory on your system :
  ! The hardcoded limit on cluster size that can NEVER be exceeded :
  integer, parameter :: nclusxhardlimit = 3000
  ! The hardcoded upper limit on l-values that can NEVER be exceeded :
  integer, parameter :: lxhardlimit = 20
  ! The hardcoded upper limit on the number of potentials that can NEVER be exceeded :
  integer, parameter :: nphxhardlimit = 31
  private dimFName, lxhardlimit, nclusxhardlimit !! Meaning no other code can change these ...

  integer,parameter :: nclxtd = 100     ! Maximum number of atoms for tdlda module.
  integer,parameter :: nspx   = 1       ! Max number of spins: 1 for spin average; 2 for spin-dep
  integer,parameter :: natx   = 1000    ! Max number of atoms in problem for the pathfinder and ffsort
  integer,parameter :: nattx  = 1000   ! Max number of atoms in problem for the rdinp
  integer,parameter :: nphx   = 11      ! Max number of unique potentials (potph)
  integer,parameter :: ltot   = 24      ! Max number of ang mom (arrays 1:ltot+1)
  integer,parameter :: nrptx  = 1251    ! Loucks r grid used through overlap and in phase work arrays
  integer,parameter :: nex    = 150     ! Number of energy points genfmt, etc.
  integer,parameter :: lamtot = 15      ! Max number of distinct lambda's for genfmt 15 handles iord 2 and exact ss
  integer,parameter :: mtot   = 4       ! Vary mmax and nmax independently
  integer,parameter :: ntot   = 2 
  integer,parameter :: npatx  = 8       ! Max number of path atoms, used  in path finder, NOT in genfmt
  integer,parameter :: legtot = npatx+1 ! Matches path finder, used in GENFMT
  integer,parameter :: novrx  = 8       ! Max number of overlap shells (OVERLAP card)
  integer,parameter :: nheadx = 30      ! Max number of header lines
  !integer,parameter :: nheadx = 20+nphxhardlimit      ! Max number of header lines !KJ 7-09 added term to accomodate large systems in xsect.bin header
  integer,parameter :: MxPole = 1000    ! Max number of poles that can be used to model epsilon^-1 for HL multipole self energy
  integer,parameter :: nwordx = max(100,2+2*nphxhardlimit)     ! An infuriatingly stupid parameter that shows up in a few places. KJ added 7-09.  used to be 20 - must be at least 2*(1+nphx) for feff.bin header.
  integer,parameter :: novp = 40 ! For istprm, movrlp, ovp2mt - an atom list cutoff that should be high enough to include one atom of each potential type.  Added 2-2011 !KJ

  ! NON PARAMETER STATEMENTS
  integer :: nclusx    ! Maximum number of atoms for FMS.
  integer :: lx = 4       ! Max orbital momentum for FMS module.

  ! OLD XPARAM.H MODULE
  integer,parameter :: natxx = natx
  integer,parameter :: nexx = nex
  integer,parameter :: nkmin = 1
  integer,parameter :: nphasx = nphx
  integer :: istatx

contains

  subroutine write_dimensions(nclusxuserlimit,lxuserlimit)
    implicit none
    ! Write dimension data to a file
    integer,intent(in) :: nclusxuserlimit,lxuserlimit
    integer :: ios  ! IO Status

    !   3/ Apply hardcoded dimension limits
    if(nclusxuserlimit.gt.0) then
       nclusx=min(nclusx,nclusxuserlimit)
    else
       nclusx=min(nclusx,nclusxhardlimit)
    endif
    if(lxuserlimit.ge.0) then
       lx=min(lx,lxuserlimit)
    else
       lx=min(lx,lxhardlimit)
    endif
    open(10,FILE=trim(dimFName),STATUS='unknown',FORM='formatted',IOSTAT=ios)
    call chopen(ios,trim(dimFName),'dimsmod')
    if (ios.ne.0) stop "Error writing dimensions.dat.  Quiting."

    write(10,*) nclusx,lx
    close(10)
  end subroutine write_dimensions


  subroutine init_dimensions
    implicit none
    ! Read dimensions from file
    integer :: ios  ! IO Status
    open(10,FILE=trim(dimFName),STATUS='old',FORM='formatted',IOSTAT=ios)
    call chopen(ios,trim(dimFName),'dimsmod')
    read(10,*) nclusx,lx
    close(10)
    ! OLD XPARAM DIMENSIONS
    istatx=(lx+1)**2*nclusx*nspx
  end subroutine init_dimensions


end module DimsMod

      subroutine wpot (nph, edens, imt, inrm,
     1                 rho, vclap, vcoul, vtot, ntitle, title)

c     Writes potentials to file name POTxx.DAT for each unique pot.

      implicit double precision (a-h, o-z)

      include '../HEADERS/const.h'
      include '../HEADERS/dim.h'

      dimension rho(251,0:nphx+1)
      dimension vcoul(251,0:nphx+1)
      dimension edens(251,0:nphx)
      dimension vclap(251,0:nphx)
      dimension vtot (251,0:nphx)
      dimension imt(0:nphx)
      dimension inrm(0:nphx)
      character*80 title(ntitle)

      character*30 fname
c#mn
       external rr

c     note units --
c     potentials in hartrees, so that v * 27.2 -> eV
c     density in #/(bohr)**3, so rho * e / (.529)**3 -> e/(Ang)**3

      do 180  iph = 0, nph
c        prepare file for unique potential data
         write(fname,172)  iph
  172    format('pot', i2.2, '.dat')
         open (unit=1, file=fname, status='unknown', iostat=ios)
         call chopen (ios, fname, 'wpot')
         call wthead(1, ntitle, title)
         write(1,173)  iph, imt(iph), inrm(iph)
  173    format (1x, 3i4, '  Unique potential, I_mt, I_norman.',
     1          '    Following data in atomic units.')
         write(1,*) ' iph ', iph
         write(1,174)
  174    format ('   i      r         vcoul        rho',
     1           '     ovrlp vcoul  ovrlp vtot  ovrlp rho')
c        need some limit here, 1250 points is silly.  Use
c        r <= 38, which gives 249 points with usual rgrid
         do 178  i = 1, 251
            if (rr(i) .gt. 38)  goto 179
            write(1,176) i, rr(i), vcoul(i,iph), rho(i,iph)/(4*pi),
     1                vclap(i,iph), vtot(i,iph), edens(i,iph)/(4*pi)
  176       format (1x, i4, 1p, 6e12.4)
  178    continue
  179    continue
         close(unit=1)
  180 continue

      return
      end

      subroutine pathsd (ckspc, fbetac, ne, ik0, cksp, fbeta,
     1                   critpw, ipotnn, ipr2, 
     1                   pcritk, pcrith, nncrit, potlbl)

c     New degeneracy checker, cute and hopefully fast for large
c     problems

c     pcritk and pcrith used only for analysis after outcrt

      include 'const.h'
      include 'dim.h'
      include 'pola.h'
      common /atoms/ rat(3,0:natx), ipot(0:natx), i1b(0:natx)

c     np1x  number of paths to consider at 1 time
      parameter (np1x = 40 000)
c     parameter (np1x = 60 000)
      dimension iout(3,np1x), iout0(3)

      dimension index(np1x)
      double precision dhash(np1x), dcurr, ddum
      dimension rx(npatx), ry(npatx), rz(npatx), ipat(npatx+1)
      dimension rx0(npatx), ry0(npatx), rz0(npatx), ipat0(npatx+1)
      double precision rid(npatx+1), betad(npatx+1), etad(npatx+1)

      parameter (nheadx = 40)
      character*80 head(nheadx)
      dimension lhead(nheadx)

      character*6  potlbl(0:npotx)
       character*128 messag
c     eps5 for rtotal range, eps3 for individual leg parameters.
c     eps3 large since code single precision and don't want round-off
c     error to reduce degeneracy.
      parameter (eps5 = 2.0e-5)
      parameter (eps3 = 2.0e-3)

      logical ldiff, last
      parameter (necrit=9, nbeta=40)
      real fbetac(-nbeta:nbeta,0:npotx,necrit), ckspc(necrit)
      real fbeta(-nbeta:nbeta,0:npotx,nex), cksp(nex)

       write(messag,30) critpw
       call echo(messag)
   30 format ('    Plane wave chi amplitude filter', f7.2, '%')

c     Read atoms info
      open (file='paths.bin', unit=3, access='sequential',
     1      form='unformatted', status='old', iostat=ios)
      call chopen (ios, 'paths.bin', 'pathsd')
      read(3) nhead
      do 40  ihead = 1, nhead
         read(3)  head(ihead)
         read(3)  lhead(ihead)
   40 continue
c     Header lines above include carriage control
      read(3)  nat
      do 50  i = 0, nat
         read(3) (rat(j,i),j=1,3), ipot(i), i1b(i)
   50 continue

c     Initialize stuff...
c     nptot  number of total paths, incl all degeneracies
c     nuptot number of unique paths for which must calc xafs
c     ngs    number of generalized shells (unique distances)
      nptot = 0
      nuptot = 0
      ngs = 0
      xportx = eps5
      ndegx = 1
      c0lim = 1.0e10
      c1lim = 1.0e10
c     Initialize keep criterion
      xcalcx = -1

c     write output to paths.dat
      if (ipr2 .ne. 5)  then
         open (unit=1, file='paths.dat', status='unknown', iostat=ios)
         call chopen (ios, 'paths.dat', 'pathsd')
         do 60  ihead = 1, nhead
            write(1,58)  head(ihead)(1:lhead(ihead))
   58       format(a)
   60    continue
         write(1,61)  critpw
   61    format (' Plane wave chi amplitude filter', f7.2, '%')
         write(1,62)
   62    format (1x, 79('-'))
      endif

c     Write crit.dat (criteria information)
      if (ipr2 .ge. 1)  then
         open (unit=4, file='crit.dat', status='unknown', iostat=ios)
         call chopen (ios, 'crit.dat', 'pathsd')
         do 65  ihead = 1, nhead
            write(4,58)  head(ihead)(1:lhead(ihead))
   65    continue
         write(4,61)  critpw
         write(4,62)
         write(4,80)
   80    format (' ipath nleg ndeg     r       pwcrit    ',
     1           'xkeep   accuracy   xheap    accuracy')
      endif

c     Read path data for each total path length range

c     Prepare for first path.
      read(3,end=999)  r0, iout0

c     Begin next total path length range
      last = .false.
  100 continue
      ngs = ngs+1
      rcurr = r0
      np = 1
      do 110  i = 1,3
         iout(i,np) = iout0(i)
  110 continue
  120 read(3,end=140)  r0, iout0
         if (abs(r0-rcurr) .lt. eps3)  then
            np = np+1
            if (np .gt. np1x) then
               write(messag,'(1x,2a,i8,a)') ' Warning: Pathfinder ',
     $              'stopping at ', np1x, ' paths.'
               call echo(messag)
               goto 200
            endif
            do 130  i = 1, 3
               iout(i,np) = iout0(i)
  130       continue
         else
c           r0 is the rtot for the next set
c           iout0 is the packed atom list for the first path of the
c           next set
            goto 200
         endif
      goto 120
  140 continue
c     Get here only if end-of-file during read
      last = .true.

  200 continue

      nupr = 0
c     variable nuprtt was nuprtot, changed to be six chars, SIZ 12/93
      nuprtt = 0

c     Hash each path into an integer
      iscale = 1000
      do 230  ip = 1, np

         npat = npatx
         call upack (iout(1,ip), npat, ipat)

c        Get hash key for this path.
c        If two paths are the same, except time-reversed, the xafs
c        will be the same, so check for this type of degeneracy.
c        We do this by choosing a 'standard order' for a path --
c        if it's the other-way-around, we time-reverse here.
         call timrep (npat, ipat, rx, ry, rz, dhash(ip))

  230 continue

c     Do a heap sort on these things
      call sortid (np, index, dhash)

c     Find beginning and end of range with same hash key
c     i0 is beginning of hash range, i1 is end of the range

      i0 = 1
  300 continue
         i1 = np + 1
         dcurr = dhash(index(i0))
         do 310  ip = i0+1, np
            if (dhash(index(ip)) .ne. dcurr)  then
c              end of a hash range
               i1 = ip
               goto 311
            endif
  310    continue
  311    continue
         i1 = i1-1

c        At this point, i0 is the first path and i1 the last
c        of a hash range.  Do whatever you want with them!

c        Sum degeneracy, including degeneracy from 1st bounce atom.
c        Check this range to see if all of the paths are actually 
c        degenerate.  Make sure time-ordering is standard.
         npat0 = npatx
         call upack (iout(1,index(i0)), npat0, ipat0)
         call timrep (npat0, ipat0, rx0, ry0, rz0, ddum)

         ndeg = 0
         do 430  ii = i0, i1
            npat = npatx
            call upack (iout(1,index(ii)), npat, ipat)
c           Note that if path gets time-reversed, we lose 1st bounce 
c           flag (since first atom is now last...), so save path deg
            ndpath = i1b(ipat(1))
            call timrep (npat, ipat, rx, ry, rz, ddum)
c           Sum degeneracy here.
            ndeg = ndeg + ndpath
c           Check for hash collisons begins here.
            ldiff = .false.
            if (npat .ne. npat0)  then
               ldiff = .true.
               goto 430
            endif
            do 320  iat = 1, npat
               if (ipot(ipat(iat)) .ne. ipot(ipat0(iat)))  then
                  ldiff = .true.
                  goto 400
               endif
  320       continue
            do 330  ileg = 1, npat
               if (abs(rx(ileg)-rx0(ileg)) .gt. eps3  .or.
     1             abs(ry(ileg)-ry0(ileg)) .gt. eps3  .or.
     2             abs(rz(ileg)-rz0(ileg)) .gt. eps3)  then
                  ldiff = .true.
                  goto 400
               endif
  330       continue
  400       continue
            if (ldiff)  then
               call echo(' Pathsd WARNING:')
               call echo(' two non-degenerate paths hashed '//
     1                 'to the same hash key!!')
               
               write(messag,'(1x,2g14.6)')
     $              dhash(index(i0)), dhash(index(ii))
               call echo(messag)
               write(messag,'(1x,a,2i8)') '  npat0, npat = ',
     $              npat0, npat 
               call echo(messag)
               call echo('  iat, ipot0, ipot, ipat0, ipat')
               do 410  iat = 1, npat
                  write(messag,'(3x,5i8)')  iat,
     $                 ipot(ipat0(iat)), ipot(ipat(iat)),
     $                 ipat0(iat), ipat(iat)
                  call echo(messag)
  410          continue
               call echo('  ileg, rx0,ry0,rz0,  rx1,ry1,rz1')
 412           format(1x,i7,2f12.6)
               do 420  ileg = 1, npat
                  write(messag,412) ileg, rx0(ileg), rx(ileg)
                  call echo(messag)                  
                  write(messag,412) ileg, ry0(ileg), ry(ileg)
                  call echo(messag)                  
                  write(messag,412) ileg, rz0(ileg), rz(ileg)
                  call echo(messag)                  
  420          continue
               call fstop(' at PATHSD: hash error')
            endif
  430    continue

c        Find path pw importance factors, and recalculate 
c        pathfinder crits for output
         call outcrt (npat0, ipat0, ckspc,
     1                nncrit, fbetac, ne, ik0, cksp, fbeta, 
     1                ipotnn, ipot,
     1                xport, xheap, xheapr, xkeep, xcalcx)

         if (xport*ndeg .gt. xportx*ndegx)  then
            xportx = xport
c           ndegx is degeneracy of path that makes xportx, used for
c           testing new path keep crit
            ndegx = ndeg
         endif
c        frac is fraction of max importance to use for test
         frac = 100*ndeg*xport/(ndegx*xportx)

c        Write output if path is important enough (ie, path is
c        at least critpw % important as most important path found
c        so far.)
         if (frac .ge. critpw)  then
            nupr = nupr+1
            nuprtt = nuprtt+ndeg
            nptot = nptot + ndeg
            nuptot = nuptot + 1

c           Write path info to paths.dat
c           mpprmd is double precision, used to get angles
c           180.000 instead of 179.983, etc.
            call mpprmd (npat0, ipat0, rid, betad, etad)
c           skip paths.dat if not necessary
            if (ipr2 .eq. 5)  goto 576
            write(1,500) nuptot, npat0+1, real(ndeg),
     1              rcurr/2
  500       format (1x, 2i5, f8.3,
     1             '  index, nleg, degeneracy, r=', f8.4)
            write(1,502)
  502       format ('      x           y           z     ipot  ',
     1              'label      rleg      beta        eta')
            do 510  i = 1, npat0
               iat = ipat0(i)
               write(1,506)  rat(1,iat), rat(2,iat),
     1                  rat(3,iat), ipot(iat), potlbl(ipot(iat)),
     1                  rid(i), betad(i)*raddeg, etad(i)*raddeg
  506          format (3f12.6, i4, 1x, '''', a6, '''', 1x, 3f10.4)
  510       continue
            write(1,506)  rat(1,0), rat(2,0), rat(3,0), ipot(0), 
     1         potlbl(ipot(0)),
     1         rid(npat0+1), betad(npat0+1)*raddeg, etad(npat0+1)*raddeg
c           End of paths.dat writing for this path

c           Write to crit.dat here (unit 4, opened above)
  576       continue

c           cmpk is degeneracy corrected xkeep, should equal frac
            cmpk = xkeep*ndeg/ndegx
c           cmpk is accuracy of xkeep, 100 is perfect
            cmpk = 100 - 100*(abs(frac-cmpk)/frac)

c           cmph is same thing for xheap
            if (xheap .lt. 0)  then
               cmph = 100
            else
               cmph = xheap*ndeg/ndegx
               cmph = 100 - 100*(abs(frac-cmph)/frac)
            endif

            if (ipr2 .ge. 1)  then
               write(4,560)  nuptot, npat0+1, ndeg, rcurr/2, frac,
     1             xkeep, cmpk, xheap, cmph
  560          format (i6, i4, i6, 3f10.4, f8.2, f10.4, 1pe14.3)
            endif

c           write out fraction error between xkeep and critpw
         endif

c        And do next ihash range
         i0 = i1+1
      if (i0 .le. np)  goto 300

c     print 600,  ngs, rcurr, nupr
c      write(messag,600)
c      call echo(messag)
  600 format (1x, i5, f12.6, i7, ' igs, rcurr, nupr')
c     write(80,601)  ngs, rcurr/2, nupr, nuprtt
  601 format (1x, i8, f12.6, 2i9)

      if (.not. last) goto 100

      if (ipr2 .ne. 5)  close (unit=1)
c     delete paths.bin when done...
      close (unit=3, status='delete')
      close (unit=4)

       write(messag, 620) nuptot, nptot
       call echo(messag)
  620 format ('    Unique paths', i7, ',  total paths', i8)

c     Do not let user accidently fill up their disk
      if (nuptot .gt. 10000)  then
         call echo(' You have found more than 10000 paths.')
         call echo(' To continue this calculation, restart')
         call echo(' with current paths.dat and at GENFMT')
         call echo(' 3rd module of CONTROL card')
         call fstop(' at PATHSD: user must verify large run.')
      endif
      return
  999 call fstop( ' at PATHSD: no input')
      end

!=======================================================================
!     COMPTON
!=======================================================================


module compton_inp
  implicit none
  character(*),parameter,private :: filename='compton.inp'

  ! spatial and momentum grid parameters
  integer :: ns, nphi, nz, nzp, npq
  real :: smax, phimax, zmax, zpmax, pqmax

  ! flags
  logical :: do_compton, do_rhozzp
  logical :: force_jzzp
  integer run_compton_module

  ! apodization function type
  integer :: window
  real :: window_cutoff

  real :: temperature
  logical ::  set_chemical_potential
  real :: chemical_potential

  integer, parameter :: WINDOW_STEP = 0, WINDOW_HANNING = 1
contains
  subroutine compton_write
    if (do_compton .or. do_rhozzp) then
       run_compton_module=1
    else
       run_compton_module=0
    endif
    open (file=filename, unit=3, status='unknown')
    write(3,10) 'run compton module?'
    write(3,*)  run_compton_module 
    write(3,10) 'pqmax, npq'
    write(3,*) pqmax, npq
    write(3,10) 'ns, nphi, nz, nzp'
    write(3,20) ns, nphi, nz, nzp
    write(3,10) 'smax, phimax, zmax, zpmax'
    write(3,30) smax, phimax, zmax, zpmax
    write(3,10) 'jpq? rhozzp? force_recalc_jzzp?'
    write(3,*) do_compton, do_rhozzp, force_jzzp
    write(3,10) 'window_type (0=Step, 1=Hann), window_cutoff'
    write(3,*) window, window_cutoff
    write(3,10) 'temperature (in eV)'
    write(3,30) temperature
    write(3,10) 'set_chemical_potential? chemical_potential(eV)'
    write(3,*) set_chemical_potential, chemical_potential
    close(3)
    ! standard formats for string, integers, real numbers
10  format(a)
20  format (20i4)
30  format (9f13.5)
  end subroutine compton_write

  subroutine compton_read
    open (file=filename, unit=3, status='old',err=100)
    read(3,*,end=100,err=100) ; read(3,*,end=100,err=100) run_compton_module
    read(3,*,end=100,err=100) ; read(3,*,end=100,err=100) pqmax, npq
    read(3,*,end=100,err=100) ; read(3,*,end=100,err=100) ns, nphi, nz, nzp
    read(3,*,end=100,err=100) ; read(3,*,end=100,err=100) smax, phimax, zmax, zpmax
    read(3,*,end=100,err=100) ; read(3,*,end=100,err=100) do_compton, do_rhozzp, force_jzzp
    read(3,*,end=100,err=100) ; read(3,*,end=100,err=100) window, window_cutoff
    read(3,*,end=100,err=100) ; read(3,*,end=100,err=100) temperature
    read(3,*,end=100,err=100) ; read(3,*,end=100,err=100) set_chemical_potential, chemical_potential
    close(3)
    return
100 run_compton_module=0  ! no compton.inp -> don't do compton
    return
  end subroutine compton_read

  subroutine compton_init
    real, parameter :: pi  = 3.1415926535897932384626433832795
    ns   = 32
    nphi = 32
    nz   = 32
    nzp  = 144

    smax   = 0
    phimax = 2*pi
    zmax   = 0
    zpmax  = 10.0

    npq   = 1000
    pqmax = 5.0

    do_compton     = .false.
    do_rhozzp  = .false.
    force_jzzp = .false.
    run_compton_module=0

    window = WINDOW_HANNING
    window_cutoff = 0

    temperature = 0.0
    set_chemical_potential = .false.
    chemical_potential = 0
  end subroutine compton_init
end module compton_inp

       subroutine triml (string)
c removes leading blanks.
       character*(*)  string, blank*1
       parameter (blank = ' ')
c-- all blank and null strings are special cases.
       jlen = istrln(string)
       if (jlen .eq. 0)  return
c-- find first non-blank char
       do 10  i = 1, jlen
          if (string (i:i) .ne. blank)  goto 20
 10    continue
 20    continue
c-- if i is greater than jlen, no non-blanks were found.
       if (i .gt. jlen)  return
c-- remove the leading blanks.
       string = string (i:)
       return
c end subroutine triml
       end
       function istrln(str)
c returns index of last non-blank character,
c         0 if string is null or blank.
       character*(*) str, blank*1
       parameter (blank = ' ')
       ilen   = len(str)
       istrln = 0
       if ((str(1:1).eq.char(0)) .or. (str.eq.blank)) return
       do 10  l = ilen, 1, -1
          if (str(l:l) .ne. blank)  then
             istrln = l
             return
          endif
 10    continue
       return
c end function istrln
       end
      subroutine smcase (str, contrl)
c  convert case of string *str*to be the same case
c  as the first letter of string *contrl*
c  if contrl(1:1) is not a letter, *str* will be made lower case.
      character*(*) str, contrl, s1*1, t1*1
      s1 = contrl(1:1)
      t1 = s1
      call lower(t1)
      if (t1.eq.s1)  call lower(str)
      if (t1.ne.s1)  call upper(str)
      return
c end subroutine smcase
      end
      subroutine lower (str)
c  changes a-z to lower case.  ascii specific
      character*(*) str
      parameter(iupa= 65, iupz= 90, idif= 32)
      do 10 j = 1, len(str)
         i = ichar(str(j:j))
         if ((i.ge.iupa).and.(i.le.iupz)) str(j:j) = char(i+idif)
   10 continue
      return
c end subroutine lower
      end
      subroutine upper (str)
c  changes a-z to upper case.  ascii specific
      character*(*) str
      parameter(iloa= 97, iloz=122, idif= 32)
      do 10 j = 1, len(str)
         i = ichar(str(j:j))
         if ((i.ge.iloa).and.(i.le.iloz)) str(j:j) = char(i-idif)
   10 continue
      return
c end subroutine upper
      end
       subroutine unblnk (string)
c
c remove blanks from a string
       integer        i, ilen, j
       character*(*)  string, str*2048, blank*1
       parameter (blank = ' ')       
       ilen = min(2048, max(1, istrln(string)))
       j   = 0
       str = blank
       do 10 i = 1, ilen
         if (string(i:i).ne.blank) then
            j = j+1
            str(j:j) = string(i:i)
         end if
 10   continue
      string = blank
      string = str(1:j)
      return
c end subroutine unblnk
      end
       subroutine untab(string)
c replace tabs with blanks :    tab is ascii dependent
       integer      itab , i
       parameter    (itab = 9)
       character*(*) string, blank
       parameter (blank = ' ')        
 10    continue
       i = index(string, char(itab))
       if (i .ne. 0) then
          string(i:i) = blank
          go to 10
       end if
       return
c end subroutine untab
       end

       subroutine strsplit(sinp, nwords, words, delim)
c
c  breaks string into words using a single delimeter
c  nwords:  max number of words (input), number of words (output)
c  words:   pieces of the string
c  delim:   delimeter to split string on.  Can be multi-character,
c           but cannot be 'multi-blanks' -- these are folded into
c           a delimiter of a single blank (the default).
       implicit none
       integer ldel, i, j, nwords, mwords, istrln
       character*(*) sinp, words(nwords), delim
       external istrln

       ldel = istrln(delim)
       if ((delim.eq.' ').or.(ldel.lt.1)) then
          ldel = 1
          delim = ' '
       endif
       mwords = nwords
       nwords = 0
       call triml(sinp)
       if (istrln(sinp) .eq. 0) return

       j = 1
 30    continue
       i = index(sinp(j:),delim(1:ldel))
       if ((i.gt.0).and.(nwords.lt.mwords-1)) then
c this ignores blank words (multiple delimeters)
          if (i.gt.1) then   
             nwords = nwords + 1
             words(nwords) = sinp(j:j+i-2)
          endif
          j = j+i+ldel-1 
          go to 30
       end if
       nwords = nwords + 1
       words(nwords) = sinp(j:)

       return
c end subroutine strsplit
       end

       subroutine strreplace(s,s1,s2)
c replace s1 with s2 in string s
       integer      i, j, i1, i2, istrln, n
       character*(*) s, s1, s2
       i1 = istrln(s1)
       i2 = istrln(s2)

       j = 1
       n = 0
 30    continue
       i = index(s(j:),s1(1:i1))
       n = n+1
       if ((n.le.1024).and.(i .ne. 0)) then
          i = i+j-1
          s = s(1:i-1)//s2(1:i2)//s(i+i1:)
          j = i + i2
          go to 30
       end if
       return
c end subroutine strreplace
       end

      subroutine uncomm(str)
c
c purpose: remove comments from a string
c
c arguments:
c      str  string to modify        [in/out]
c notes:
c   1. '*' is a comment iff it occurs in col 1
c   2. char(10) and char(12) are end-of-line comments
c   3. '!', '#', and '%'  are end-of-line comments that
c       can be protected by matching " ", ' ', ( ), [], or {}
c
c requires:  istrln, triml, echo
c
c copyright 1997  matt newville
       integer i, istrln, ilen, iprot
       character*(*) str, copen*5, cclose*5, eol*3, spec*2, s*1
       character*1 blank, star
       parameter(blank = ' ',star = '*')
       external  istrln
       data copen, cclose, eol  / '[{"''(',  ']}"'')', '!#%' /
c
       spec(1:2) = char(10)//char(12)
       call triml(str)
       ilen = istrln(str)
       if ((ilen.le.0).or.(str(1:1).eq.star)) then
          str = blank
          i   = 1
       else
          iprot = 0
          do 50 i = 1, ilen
             s  = str(i:i)
             if (iprot.le.0) then
                iprot = index(copen,s)
             elseif (iprot.le.5) then
                if (s.eq.cclose(iprot:iprot)) iprot = 0
             else
cc                call echo('** uncomm confusion: iprot out of range')
                return
             end if
c if the string is unprotected, look for end-of-line comment characters
             if (((iprot.eq.0).and.(index(eol,s).ne.0)).or.
     $             index(spec,s).ne.0)  go to 60
 50       continue
          i  = ilen + 1
 60       continue
       end if
       str  = str(1:i-1)
c end subroutine uncomm
       return
       end
      subroutine strclp(str,str1,str2,strout)
c
c  a rather complex way of clipping a string:
c      strout = the part of str that begins with str2.
c  str1 and str2 are subsrtings of str, (str1 coming before str2),
c  and even if they are similar, strout begins with str2
c  for example:
c   1.  str =  "title title my title" with  str1 = str2 = "title"
c       gives strout = "title my title"
c   2.  str =  "id  1  1st path label" with str1 = "1", str2 = "1st"
c       gives strout = "1st path label"
c
      character*(*)  str, str1, str2, strout
      integer  i1, i2, ibeg, iend, istrln, ilen
      external istrln
      ilen   = len(strout)
      i1     = max(1, istrln(str1))
      i2     = max(1, istrln(str2))
      i1e    = index(str,str1(1:i1)) + i1
      ibeg   = index(str(i1e:),str2(1:i2) ) + i1e - 1
      iend   = min(ilen+ibeg, istrln(str) )
      strout = str(ibeg:iend)
      return
c end subroutine strclp
      end
       subroutine rmdels(s,s1,s2)
c
c  remove general enclosing delimeters from a string
       character*(*) s, s1, s2, t*2048
       call triml(s)
       i  = istrln(s)
       t  = s
       if ((s(1:1).eq.s1) .and. (s(i:i).eq.s2)) s = t(2:i-1)
       return
       end
c 
c        subroutine rmpars(str)
c c  remove enclosing parentheses for a string
c        character*(*) str
c        call rmdels(str,'(',')')
c        return
c        end

       subroutine rmquot(str)
c  remove enclosing single or double quotes from a string
       character*(*) str
       call rmdels(str,'''','''')
       call rmdels(str,'"','"')
       return
       end
       subroutine undels(s)
c  remove an enclosing delimiter from a string
       character*(*) s, op*5, cl*5
       integer j
       data op, cl / '[{"''(',  ']}"'')'/
       j = index(op,s(1:1))
       if (j.ne.0) then
          call rmdels(s, op(j:j), cl(j:j) )
       end if
       return
       end
      subroutine str2dp(str,dpval,ierr)
c  return dp number "dpval" from character string "str"
c  if str cannot be a number, ierr < 0 is returned.
      character*(*) str, fmt*15 
      double precision dpval
      integer  ierr 
      logical  isnum
      external isnum
      ierr = -999
      if (isnum(str)) then
         ierr = 0
         write(fmt, 10) min(999,max(2,len(str)))
 10      format('(bn,f',i3,'.0)')
         read(str, fmt, err = 20, iostat=ierr) dpval
      end if    
      if (ierr.gt.0) ierr = -ierr
      return
 20   continue
      ierr = -998
      return
c end subroutine str2dp
      end
      subroutine str2re(str,val,ierr)
c  return real from character string "str"
      character*(*) str 
      double precision dpval
      real     val
      integer  ierr
      call str2dp(str,dpval,ierr)
      if (ierr.eq.0) val = real(dpval)
      return
c end subroutine str2re
      end
      subroutine str2in(str,intg,ierr)
c  return integer from character string "str"
c  returns ierr = 1 if value was clearly non-integer
      character*(*) str 
      double precision val, tenth
      parameter (tenth = 1.d-1)
      integer  ierr, intg
      call str2dp(str,val,ierr)
      if (ierr.eq.0) then
         intg = int(val)
         if ((abs(intg - val) .gt. tenth))  ierr = 1
       end if
      return
c end subroutine str2in
      end
      subroutine str2lg(str,flag,ierr)
c  return logical "flag" from character string "str".
c  flag is true unless the first character is
c     '0', 'f' or 'n' (not case-sensitive)
      character*(*) str, test*5
      parameter (test = 'fnFN0')
      logical    flag
      integer    ierr
      ierr  = 0
      flag  = index(test,str(1:1)).eq.0
      return
c end subroutine str2lg
      end
       subroutine str2il(str,miar,niar,iar,ierr)
c  convert a string into an integer _list_, 
c  supporting syntax like '1-2,12,4,6-8' returns
c  iar =   1,2,4,6,7,8,12    niar = 7
c
c  returns ierr = -1 if string clearly non-integer
       character*(*) str, s*1024, sint*64
       integer  miar, niar, iar(miar), ierr, istrln
       integer  i, ibeg
       logical  dash
       external  istrln

       s    = str
       call triml(s)
       if ((s.eq.'all') .or.(s.eq.'all,')) then 
          write(sint, 10)  miar
          call triml(sint)
          s   = '1-'//sint(1:istrln(sint))//','
          call triml(s)
       endif
 10    format(i6)
       ilen = istrln(s)+1
       s    = s(1:ilen-1)//'^'

       do 20 i = 1, miar
          iar(i) = 0
 20    continue 
       niar =  0
       ierr = -1
       ix1  =  0
       dash = .false.
       if (ilen.gt.1) then
          i    = 1
          ibeg = 1
 100      continue 
          i = i + 1
          if ((s(i:i).eq.',') .or. (s(i:i).eq.'^')) then
             sint = s(ibeg:i-1)
             ibeg = i+1
             if (dash) then
                call str2in(sint,ix,ierr)
                do 130 j = ix1, ix
                   niar = niar + 1
                   iar(niar) = j
 130            continue 
             else
                call str2in(sint,ix,ierr)
                niar = niar + 1
                iar(niar) = ix
             end if
             dash = .false.
          elseif (s(i:i).eq.'-') then
             sint = s(ibeg:i-1)
             dash = .true.
             call str2in(sint,ix1,ierr)
             ibeg = i+1
          end if
          if (s(i:i).ne.'^') go to 100
       end if
c now remove the zeroth one!
       niar = niar - 1
c
       return
c end subroutine str2il
       end

      logical function is_comment(line)
c
c  returns true if line is a comment or blank line, false otherwise
c  comment lines start with one of:  '#', '*', ';', '%'
      character*(*) line, l1*1, com*4
      parameter(com = '#*;%')
      integer istrln
      external istrln
      is_comment = .false.
      l1 = line(1:1)
      if ((istrln(line).le.0) .or. (index(com,l1).ge.1)) then
         is_comment = .true.
      endif
      return
      end

       
       logical function isnum (string)
c  tests whether a string can be a number. not foolproof!
c  to return true, string must contain:
c    - only characters in  'deDE.+-, 1234567890' (case is checked)
c    - no more than one 'd' or 'e' 
c    - no more than one '.'
c    - if '+' or '-' is seen after a digit, 'deDE' must be seen.
c  matt newville
       character*(*)  string,  number*20
c note:  layout and case of *number* is important: do not change!
       parameter (number = 'deDE.,+- 1234567890')
       integer   iexp, idec, i, j, istrln, isign
       integer   jexp
       logical   ldig, l_op
       external  istrln
c       str   = string
c       call triml(str)
       iexp  = 0
       jexp  = 0
       idec  = 0
       isign = 0
       ldig  = .false.
       l_op  = .false.
       isnum = .false. 
       do 100  i = 1, max(1, istrln(string))
          j = index(number,string(i:i))
cc          print*, 'X  ' , i, j, ' : ' , str(i:i)
          if (j.le.0)               go to 200
          if (j.ge.10)              ldig = .true.
          if((j.ge.1).and.(j.le.4)) then 
             iexp = iexp + 1
             jexp = i
          endif
          if (j.eq.5)               idec = idec + 1
          if ((j.eq.7).or.(j.eq.8)) then
             isign= isign +1
             if ((i .gt. 1) .and. (i .ne. (jexp+1))) then
                l_op = .true.
             endif
          endif
 100   continue
c  every character in "string" is also in "number".  so, if there are 
c  not more than one exponential and decimal markers, it's a number
       if ((iexp.le.1).and.(idec .le.1)) isnum = .true.
       if ((iexp.eq.0).and.(isign.gt.1)) isnum = .false.
       if (jexp.eq.1)  isnum = .false.
       isnum = isnum .and. (.not.l_op)
cc       print*, 'ISNUM: ', string(1:istrln(string))
cc       print*, '       ', isnum, l_op, iexp, idec, isign
 200   continue
       return
c  end logical function isnum
       end
       logical function isdat(string)
c  tests if string contains numerical data
c    returns true if the first (up to eight) words in string can
c    all be numbers. requires at least two words, and tests only
c    the first eight columns
       integer nwords, mwords, i
       parameter (mwords = 8)
       character*30  string*(*), words(mwords), line*2048
       logical isnum
       external isnum
c
       isdat = .false.
       do 10 i = 1, mwords
          words(i) = 'no'
 10    continue
c
       nwords = mwords
       line   = string
       call triml(line)
       call untab(line)
       call bwords(line, nwords, words)
       if (nwords.ge.1) then
          isdat = .true.
          do 50 i = 1, nwords
             isdat = isdat .and. isnum(words(i))
 50       continue
       end if
       return
       end
       subroutine bwords (str, nwords, words)
c
c     breaks string into words.  words are separated by a
c     whitespace (blank or tab), comma, or equal sign,
c     plus zero or more whitespaces.
c
c     args        i/o      description
c     ----        ---      -----------
c     s            i       char*(*)  string to be broken up
c     nwords      i/o      input:  maximum number of words to get
c                          output: number of words found
c     words(nwords) o      char*(*) words(nwords)
c                          contains words found.  words(j), where j is
c                          greater then nwords found, are undefined on
c                          output.
c
c      written by:  steven zabinsky, september 1984
c      altered by:  matt newville
c**************************  deo soli gloria  **************************
c-- no floating point numbers in this routine.
       character*(*) str, words(nwords)
       character blank, comma, equal, s
       parameter (blank = ' ', comma = ',', equal = '=')
       external istrln
c-- betw    .true. if between words
c   comfnd  .true. if between words and a comma or equal has
c                                         already been found
      logical betw, comfnd
c-- define tab character (ascii dependent)
       mwords = nwords
       nwords = 0
       call untab (str)
       call triml (str)
       ilen = istrln (str)
c-- all blank string is special case
       if (ilen .eq. 0) return
c-- ibeg is beginning character of a word
       ibeg = 1
       betw   = .true.
       comfnd = .true.
       do 10  i = 1, ilen
          s = str(i:i)
          if (s .eq. blank)  then
             if (.not. betw)  then
                nwords = nwords + 1
                words (nwords) = str (ibeg : i-1)
                betw = .true.
                comfnd = .false.
             endif
          elseif ((s.eq.comma).or.(s.eq.equal))  then
             if (.not. betw)  then
                nwords = nwords + 1
                words (nwords) = str(ibeg : i-1)
                betw = .true.
             elseif (comfnd)  then
                nwords = nwords + 1
                words (nwords) = blank
             endif
             comfnd = .true.
          else
             if (betw)  then
                betw = .false.
                ibeg = i
             endif
          endif
          if (nwords .ge. mwords)  return
 10    continue
c
       if (.not. betw  .and.  nwords .lt. mwords)  then
          nwords = nwords + 1
          words (nwords) = str (ibeg :ilen)
       endif
       return
c end subroutine bwords
       end
       subroutine bkeys(str, mkeys, keys, values, nkeys)
c
c purpose:  break a string into {key,value} pairs.
c arguments:
c      str     string to break into pairs           [in]
c      mkeys   dimension of arrays keys and values  [in]
c      keys    character array of keys              [out]
c      values  character array of values            [out]
c      nkeys   number of keys found                 [out]
c
c parsing rules:
c  1. a key is a word terminated by whitespace, an equal sign,
c     a comma, or the final close paren.  keys are converted to
c     lower case before returning.
c
c  2. a value is a more general string, terminated by either
c     an "unprotected" comma or the final "unprotected" close paren.
c     Any part of the string can be "protected" by either matching
c     single quotes, double quotes, parens, braces, or brackets.
c     In fact, *all* of these pairs must be matched for the
c     value to terminate.  the values are left in their original case.
c
c  3. If a key does not have a value (because a comma or the last close
c     paren gets in the way) the value will be set to '%undef%'.
c     note that str2lg will interpret this as "true"!, and that it
c     will never make sense as any other value.
c
c example:  x =13.214, File = B.dat, Verbose, sig = sqrt(A + min(b,c))
c   will return these pairs:
c        key        value
c        x          13.214
c        file       B.dat
c        verbose    %undef%
c        sig        sqrt(A + min(b,c))
c
c  routines needed: istrln, triml, lower, rmdels, echo
c
c  copyright (c) 1998  matt newville
c
       integer   istrln, i, j, ilen, ibeg
       integer   nkeys, mkeys, nk, jprot
       character*(*) str, keys(mkeys), values(mkeys), tmp*2048
       character s, t, u, blank, comma, equal, semicl
       character copen*3, cclose*3, undef*8
       logical   lcomma, seek_key, have_key
       parameter (blank = ' ',comma = ',',equal = '=',semicl = ';')
       parameter (undef = '%undef%')
       external istrln
       data copen, cclose / '[{(',  ']})'/
c
c initialize
       nkeys = 0
       do 10 i = 1, mkeys
          keys(i)   = blank
          values(i) = undef
 10    continue
       have_key = .false.
       seek_key = .true.
       lcomma   = .false.
       ibeg     = 1
       iprot    = 0
       jprot    = 0
c
c check for valid string to parse
       ilen = istrln(str)
cc       print*,'BKEYS:',str(1:ilen),':', ilen
       if (ilen .eq. 0)  return
c
c loop through string
       i = 0
 100   continue 
       i = i + 1
       s  = str(i:i)
c test for opening/closing delimiters
c and march over protected strings
       if ((s.eq.'''').or.(s.eq.'"')) then 
          t = s
cc          print*, ' quote: ', t
 120      continue
          i  = i + 1
          if ((str(i:i).ne.t).and.(i.lt.ilen)) goto 120
       else
          iprot = index(copen,s)
          if ((iprot.ge.1).and.(iprot.le.3)) then
cc             print*, ' iprot = ',iprot , s, i
             jprot= jprot + 1
             t = copen(iprot:iprot)
             u = cclose(iprot:iprot)
 130         continue
             i  = i + 1
             if (str(i:i).eq.t)  jprot = jprot + 1
             if (str(i:i).eq.u)  jprot = jprot - 1
             if ((i.lt.ilen).and.(jprot.ne.0)) goto 130
          end if
       endif
       lcomma = s.eq.comma
c looking for keyword:
c   we've seen the beginning of a keyword, and now we see the end:
c   keyword  ends at "=",","," ", or the final positon
       if (seek_key) then
          if (((s.eq.equal).or.lcomma.or.(i.eq.ilen))) then
             nkeys  = nkeys + 1
             if (nkeys .ge. mkeys) go to 150
             keys(nkeys) = str(ibeg:i-1)
             if ((i.eq.ilen).and.(.not.lcomma).and.(s.ne.equal))
     $            keys(nkeys) = str(ibeg:i)
cc             print*, 'found key : ', nkeys, ' ', keys(nkeys)(1:32)
             ibeg   = min(i + 1, ilen)
             seek_key = .false.
             have_key = .false.
c      a bare word counts as a key with value= undefined (as above)
             if (lcomma .or.(i.eq.ilen) ) then
                seek_key = .true.
                call triml(keys(nkeys))
                ij = istrln(keys(nkeys))
                if  (index(keys(nkeys)(1:ij),blank).ne.0) then
                   tmp = keys(nkeys)(1:ij)
c      c                        call echo(' syntax error: '//tmp)
                   keys(nkeys)  = blank
                end if
             end if
          elseif (.not.have_key) then
             have_key = s.ne.blank
          end if
c      looking for a value:  ends at a comma or the final postion
       else
          if (lcomma.or.(i.eq.ilen)) then
             values(nkeys) = str(ibeg:i-1)
             if ((i.eq.ilen).and.(.not.lcomma))
     $            values(nkeys) = str(ibeg:)
             ibeg   = min( i + 1, ilen)
             seek_key = .true.
          end if
       end if
       if (i.le.ilen) goto 100
 150   continue 
c
c  finally, we may have ended with a one-letter keyword, in which case
c   have_key is true
       if (have_key) then
          nkeys       = nkeys + 1
          keys(nkeys) = str(ibeg:)
          call triml(keys(nkeys))
       end if
c
c now clean up keys and values, eliminate blank and invalid keys

       nk = nkeys
       nkeys = 0
       do 500 i = 1, nk
          if (keys(i).ne.blank .and. keys(i).ne.comma .and.
     $         keys(i).ne.equal .and. keys(i).ne.semicl) then
             nkeys = nkeys + 1
             keys(nkeys) = keys(i)
             call triml( values(i))
             if (values(i)(1:1).eq.equal) then 
                values(i) = values(i)(2:)
                call triml(values(i) )
             end if
             call rmquot(values(i))
             do 470 j = 1, 2
                call rmdels(values(i),copen(j:j),cclose(j:j))
 470         continue
             call triml( values(i))
             values(nkeys) = values(i)
             if (values(nkeys).ne.undef) call lower(keys(nkeys))
             call triml(keys(nkeys))
          end if
          lk = istrln(keys(i))
          lv = istrln(values(i))
cc          print*, i,' |', keys(i)(1:lk),' | ', values(i)(1:lv), '|'
 500   continue
       return
c end subroutine bkeys
       end

      subroutine pathgeom(nleg, nsc, ipol, rat, ipot, ri, beta, eta)

      implicit double precision (a-h, o-z)
      include '../HEADERS/const.h'
      include '../HEADERS/dim.h'

      integer nleg, nsc, ipol, ipot(0:legtot)
      double precision rat(3,0:legtot+1)
      double precision ri(legtot), beta(legtot+1), eta(0:legtot+1)
      complex*16  alph, gamm
      dimension  alpha(0:legtot), gamma(legtot)

c+---------------------------------------------------------------------
c     "Based on or developed using Distribution: FEFF8.5L
c      Copyright (c) [2013] University of Washington"
c
C  See ../HEADERS/license.h for full llicense information
c+---------------------------------------------------------------------
c+---------------------------------------------------------------------
c  the following is cut-n-pasted from rdpath
c  using the coordinates of the path's constituent atoms,
c  compute ri, beta, and eta

      nsc = nleg-1

c     We need the 'z' atom so we can use it below.  Put
c     it in rat(nleg+1).  No physical significance, just a handy
c     place to put it.
      if (ipol.gt.0) then
         rat(1,nleg+1) = rat(1,nleg)
         rat(2,nleg+1) = rat(2,nleg)
         rat(3,nleg+1) = rat(3,nleg) + 1.0
      endif

c     add rat(0) and ipot(0) (makes writing output easier)
      do 22 j = 1, 3
         rat(j,0) = rat(j,nleg)
   22 continue
      ipot(0) = ipot(nleg)

      nangle = nleg
      if (ipol.gt.0) then 
c        in polarization case we need one more rotation
         nangle = nleg + 1
      endif
      do 100  j = 1, nangle

c        for euler angles at point i, need th and ph (theta and phi)
c        from rat(i+1)-rat(i)  and  thp and php
c        (theta prime and phi prime) from rat(i)-rat(i-1)
c
c        Actually, we need cos(th), sin(th), cos(phi), sin(phi) and
c        also for angles prime.  Call these  ct,  st,  cp,  sp

c        i = (j)
c        ip1 = (j+1)
c        im1 = (j-1)
c        except for special cases...
         ifix = 0
         if (j .eq. nsc+1)  then
c           j+1 'z' atom, j central atom, j-1 last path atom
            i = 0
            ip1 = 1
            if (ipol.gt.0) then
               ip1 = nleg+1
            endif
            im1 = nsc

         elseif (j .eq. nsc+2)  then
c           j central atom, j+1 first path atom, j-1 'z' atom
            i = 0
            ip1 = 1
            im1 = nleg+1
            ifix = 1
         else
            i = j
            ip1 = j+1
            im1 = j-1
         endif

         x = rat(1,ip1) - rat(1,i)
         y = rat(2,ip1) - rat(2,i)
         z = rat(3,ip1) - rat(3,i)
         call trig (x, y, z, ctp, stp, cpp, spp)
         x = rat(1,i) - rat(1,im1)
         y = rat(2,i) - rat(2,im1)
         z = rat(3,i) - rat(3,im1)
         call trig (x, y, z, ct, st, cp, sp)

c        Handle special case, j=central atom, j+1 first
c        path atom, j-1 is 'z' atom.  Need minus sign
c        for location of 'z' atom to get signs right.
         if (ifix .eq. 1)  then
            x = 0
            y = 0
            z = 1.0
            call trig (x, y, z, ct, st, cp, sp)
            ifix = 0
         endif

c        cppp = cos (phi prime - phi)
c        sppp = sin (phi prime - phi)
         cppp = cp*cpp + sp*spp
         sppp = spp*cp - cpp*sp
         phi  = atan2(sp,cp)
         phip = atan2(spp,cpp)

c        alph = exp(i alpha)  in ref eqs 18
c        beta = cos (beta)         
c        gamm = exp(i gamma)
         alph = -(st*ctp - ct*stp*cppp - coni*stp*sppp)
         beta(j) = ct*ctp + st*stp*cppp
c        watch out for roundoff errors
         if (beta(j) .lt. -1) beta(j) = -1
         if (beta(j) .gt.  1) beta(j) =  1
         gamm = -(st*ctp*cppp - ct*stp + coni*st*sppp)
         call arg(alph,phip-phi,alpha(j))
         beta(j) = acos(beta(j))
         call arg(gamm,phi-phi,gamma(j))
c       Convert from the rotation of FRAME used before to the rotation 
c       of VECTORS used in ref.
         dumm = alpha(j)
         alpha(j) =  pi- gamma(j)
         gamma(j) =  pi- dumm

         if (j .le. nleg)  then
            ri(j) = dist (rat(1,i), rat(1,im1))
         endif
  100 continue

c     Make eta(i) = alpha(i-1) + gamma(i). 
c     We'll need alph(nangle)=alph(0)
      alpha(0) = alpha(nangle)
      do 150  j = 1, nleg
         eta(j) = alpha(j-1) + gamma(j)
  150 continue
      if (ipol.gt.0) then
         eta(0) = gamma(nleg+1)
         eta(nleg+1) = alpha(nleg)
      endif


      return
      end

      subroutine pot (verbse, rgrd, nohole,
     $       inters, totvol, ecv0, nscmt, nmix, ntitle, title,
     $       nat, nph, ihole, iafolp, ixc, iphat, rat, iatph, xnatph,
     $       novr, iphovr, nnovr, rovr, folp0, xion, iunf, iz, ipr1,
     $       ispec, jumprm, lmaxsc, icoul, ca1, rfms1, lfms1,
     $
     -       rnrmav, xmu, vint, rhoint,
     1       emu, s02, erelax, wp, rs, xf, qtotel,
     2       imt, rmt, inrm, rnrm, folpx,
     3       dgc0, dpc0, dgc, dpc, adgc, adpc,
     4       edens, vclap, vtot, edenvl, vvalgs, dmag, xnval,
     5       eorb, kappa, iorb, qnrm, xnmues, nhtmp
     6       )
c                                                                   !     return stuff for use in wrpot & xsph
c gamach

c##****f* feff85exafs/pot
c##  NAME
c##     pot
c##
c##  SYNOPSIS
c##     pot(rgrd, nohole,
c##    $    inters, totvol, ecv0, nscmt, nmix, ntitle, title,
c##    $    nat, nph, ihole, iafolp, ixc, iphat, rat, iatph, xnatph,
c##    $    novr, iphovr, nnovr, rovr, folp0, xion, iunf, iz, ipr1,
c##    $    ispec, jumprm, lmaxsc, icoul, ca1, rfms1, lfms1,
c##    $    rnrmav, xmu, vint, rhoint,
c##    $    emu, s02, erelax, wp, rs, xf, qtotel,
c##    $    imt, rmt, inrm, rnrm, folpx,
c##    $    dgc0, dpc0, dgc, dpc, adgc, adpc,
c##    $    edens, vclap, vtot, edenvl, vvalgs, dmag, xnval,
c##    $    eorb, kappa, iorb, qnrm, xnmues, nhtmp)
c##
c##  FUNCTION
c##     Compute potentials for an input atomic cluster, returning data needed to compute phase shifts
c##
c##
c##  INPUTS
c##     verbse      boolean flag, true=write screen messages
c##     rgrd        radial grid spacing (RGRD)
c##     nohole      flag to compute with no hole on absorber (NOHOLE)
c##     inters      parameter of the interstitial calculation (INTERSTITIAL)
c##     totvol      parameter of the interstitial calculation (INTERSTITIAL)
c##     ecv0        core/valence separation (EXCHANGE)
c##     nscmt       max number of self-conmsistentcy iterations (SCF)
c##     nmix        number of iterations before switching to Broyden (SCF)
c##     ntitle      number of title lines (TITLE)
c##     title       title lines (TITLE)
c##     nat         number of atoms in cluster (ATOMS)
c##     nph         number of unique potentials in cluster (POTENTIALS)
c##     ihole       edge index, 1=K, 4=L3, etc (EDGE/HOLE)
c##     iafolp      flag indicating automatic overlapping (AFOLP)
c##     ixc         exchange index (EXCHANGE)
c##     iphat       unique potential indeces of atoms in cluster (ATOMS)
c##     rat         cartesian coordinates of atoms in cluster (ATOMS)
c##     iatph       example of each unique potential in cluster
c##     xnatph      stoichiometries of each potential index (POTENTIALS)
c##     novr        number of overlap shells for unique potential (obsolete in feff85exafs)
c##     iphovr      unique potential for this overlap shell (obsolete in feff85exafs)
c##     nnovr       number of atoms in overlap shell (obsolete in feff85exafs)
c##     rovr        r for overlap shell (obsolete in feff85exafs)
c##     folp0       overlap factor for rmt calculation (FOLP/AFOLP)
c##     xion        ioniziation of each potential (ION)
c##     iunf        flag to unfreeze f eectrons (UNFREEZEF)
c##     iz          Z numbers of each potential (POTENTIALS)
c##     ipr1        print flag (not used in library)
c##     ispec       spectroscopy index, 1=EXAFS (always set to 1 in feff85exafs)
c##     jumprm      flag to remove jumps at muffin tin radii (JUMPRM)
c##     lmaxsc      l max for SCF for each potential (POTENTIALS)
c##     icoul       obsolete param. for handling Coulomb potential (SCF)
c##     ca1         self-consistency convergence accelerator (SCF)
c##     rfms1       cluster radius for self-consistent calculation (SCF)
c##     lfms1       0=solid, 1=molecule (SCF)
c##     rnrmav      average Norman radius in cluster
c##     xmu         Fermi level in hartrees
c##     vint        interstitial energy
c##     rhoint      interstitial density * 4 * pi
c##
c##
c##  RESULT
c##     emu         ionization energy in adiabatic approximation
c##     s02         computed S02
c##     erelax      ionization energy - emu
c##     wp          plasmon frequency in hartrees
c##     rs          interstitial density parameter (see istprm.f and fermi.f)
c##     xf          interstital fermi momentum
c##     qtotel      total number of e in a cluster
c##     imt         r mesh index just inside rmt
c##     rmt         muffin tin radii
c##     inrm        r mesh index just inside rnorman
c##     rnrm        Norman radii
c##     folpx       overlap factor for rmt calculation
c##     dgc0        additional data needed for relativistic version
c##     dpc0        additional data needed for relativistic version
c##     dgc         additional data needed for relativistic version
c##     dpc         additional data needed for relativistic version
c##     adgc        additional data needed for relativistic version
c##     adpc        additional data needed for relativistic version
c##     edens       core density
c##     vclap       overlapped Coulomb potential
c##     vtot        overlapped Coulomb potential
c##     edenvl      additional data needed for relativistic version
c##     vvalgs      additional data needed for relativistic version
c##     dmag        data for single configuration Dirac-Fock atom code
c##     xnval       data for single configuration Dirac-Fock atom code
c##     eorb        data for single configuration Dirac-Fock atom code
c##     kappa       data for single configuration Dirac-Fock atom code
c##     iorb        data for single configuration Dirac-Fock atom code
c##     qnrm        Norman radii after ovrlp.f
c##     xnmues      
c##     nhtmp       holds nohole value
c##    
c##
c##  NOTES
c##    Call wrpot to write the pot.pad file.  Call reapot to read the potph.json (potph.inp) file.
c##    See ffmod1.f for the use of this subroutine in the conventional stand-alone program.
c##
c##  BUGS
c##    Report bugs and other issues at https://github.com/xraypy/feff85exafs
c##
c##  LICENSE
c##    See src/HEADERS/license.h for the terms of the parts of feff85exafs derived directly from Feff
c##
c##    nxjson.c and nxjson.h are Copyright (c) 2013 Yaroslav Stavnichiy <yarosla@gmail.com>.  See
c##    https://bitbucket.org/yarosla/nxjson/src
c##
c##    The C wrapper around this subroutine is released to the public domain
c##
c##  SEE ALSO
c##    The pot and xsph stand-alone programs, the libfeffphases.c wrapper
c##
c##****



c     Cluster code -- multiple shell single scattering version of FEFF
c     This program (or subroutine) calculates potentials and phase
c     shifts for unique potentials specifed by atoms and overlap cards.
c
c     Input files:  potph.inp    input data, atoms, overlaps, etc.
c     Output:       phases.bin   phase shifts for use by the rest of the
c                                program
c                   xxx.dat      various diagnostics

      implicit double precision (a-h, o-z)
      include '../HEADERS/const.h'
      include '../HEADERS/parallel.h'
      include '../HEADERS/dim.h'
      Parameter (Maxprocs = 1)

      logical verbse

c     Notes:
c        nat    number of atoms in problem
c        nph    number of unique potentials
c        ihole  hole code of absorbing atom
c        iph=0 for central atom

c     Specific atom input data
c     iphat - given specific atom, which unique pot?
      dimension iphat(natx)
c     rat(3,natx)  -  cartesian coords of specific atom
      dimension rat(3,natx)
      real rfms1

c     Unique potential input data
c     iatph(0:nphx) - given unique pot, which atom is model?
c                   (0 if none specified for this unique pot)
      dimension iatph(0:nphx)
c     xnatph(0:nphx) - given unique pot, how many atoms are there
c                      of this type? (used for interstitial calc)
      dimension xnatph(0:nphx)

c     folp(0:nphx)  - overlap factor for rmt calculation
      dimension folp(0:nphx), folp0(0:nphx), folpx(0:nphx)
c     novr(0:nphx)  - number of overlap shells for unique pot
      dimension novr(0:nphx)
c     iphovr(novrx,0:nphx)  - unique pot for this overlap shell
      dimension iphovr(novrx,0:nphx)
c     nnovr(novrx,0:nphx)  -  number of atoms in overlap shell
      dimension nnovr(novrx,0:nphx)
c     rovr(novrx,0:nphx)   -  r for overlap shell
      dimension rovr(novrx,0:nphx)

c     Free atom data
c     xion(0:nphx)  - ionicity, input
      dimension xion(0:nphx)
c     iz(0:nphx)  -   atomic number, input
      dimension iz(0:nphx)

c     ATOM output
c     Note that ATOM output is dimensioned 251, all other r grid
c     data is set to nrptx, currently 250
c     rho(251,0:nphx+1)     -   density*4*pi
      dimension rho(251,0:nphx+1)
c     vcoul(251,0:nphx+1)   -   coulomb potential
      dimension vcoul(251,0:nphx+1)
      dimension dr(251), drho(251), dvcoul(251)

c     Overlap calculation results
c     overlapped density*4*pi
      dimension edens(251,0:nphx)
c     overlapped coul pot
      dimension vclap(251,0:nphx), vclapp(251,0:nphx)
c     overlapped total potential
      dimension vtot (251,0:nphx)

c     Muffin tin calculation results
c     r mesh index just inside rmt
      dimension imt(0:nphx)
c     r mesh index just inside rnorman
      dimension inrm(0:nphx)
c     muffin tin radius
      dimension rmt(0:nphx)
c     norman radius
      dimension rnrm(0:nphx), qnrm(0:nphx), qold(0:nphx), lmaxsc(0:nphx)
      dimension xnmues(0:lx,0:nphx)
      character*80 title(nheadx)

      logical ok

      complex gtr((lx + 1) * (nphx + 1) * Maxprocs)
      complex*16 xrhoce((lx + 1) * (nphx + 1) * Maxprocs)
      complex*16 xrhole((lx + 1) * (nphx + 1) * Maxprocs)
      complex*16 yrhoce(251 * (nphx + 1) * Maxprocs )
      complex*16 yrhole(251 * (lx + 1) * (nphx + 1) * Maxprocs )
c     need irregular solution for complex potential. fix later
      dimension dgc0(251), dpc0(251)

c     additioal data needed for relativistic version
      dimension dgc(251,30,0:nphx+1), dpc(251,30,0:nphx+1)
      dimension adgc(10,30,0:nphx+1), adpc(10,30,0:nphx+1)
      dimension rhoval(251,0:nphx+1), edenvl(251,0:nphx)
      dimension vvalgs (251,0:nphx)

c     nrx = max number of r points for phase and xsect r grid
c      parameter (nrx = nrptx)
      dimension ri(nrptx)
      dimension dmag(251,0:nphx+1), xnvmu(0:lx,0:nphx+1)
      dimension xnval(30,0:nphx+1), norb(0:nphx+1), eorb(30,0:nphx+1)
      dimension kappa(30,0:nphx+1), iorb(-4:3,0:nphx+1)
c       criteria for self-consistency
      parameter (tolq = 1.D-3)
      parameter (tolmu = 3.D-3)
      logical lpass
      character*512 slog
c     Josh use nhtmp to save nohole value
      integer nhtmp

      do 4 i=1,30
         do 2 j=0,nphx+1
            kappa(i,j) = 0
            eorb(i,j) = 0
 2       continue
 4    continue

   10 format (4x, a, i5)

c     Josh - for now if nohole=2 reset to 0 so that regular nohole
c     potential is used
      nhtmp = nohole
      if (nohole.eq.2) nohole = 0
c     Josh

c     variables ecv0 and folp0 serve as input only; do not change them
c     since it will change file feff.ior content
c     ecv and folp are passed through pot.pad to next modules.
      ecv = ecv0
      do 12 i = 0, nph
   12 folp(i) = folp0(i)

      call inipot (dgc, dpc, edenvl, vvalgs, xnmues)

c     increase the length of hydrogen bonds for potential only
      call moveh (nat, iphat, iz, rat)

      nfree = 1
      do 17 i=0,nph
        if (abs(xion(i)) .gt. 1.d-3) nfree = 2
  17  continue

c     Free atom potentials and densities
c     Final state is (usually) with a core hole, initial state is 
c     w/o a corehole.
c     NB wsatom is needed in SUMAX, if changed here, change it there
c     wsatom = 15
c     do not save spinors
c     Call twice if any of xion.neq.0 ( first time with xion=0 to set
c     rnrm)

      do 99 ifree = 1, nfree

      ispinr = 0
      etfin  = 0
      do 20  iph = 0, nph
         if (verbse) then
            write(slog,10) 
     1             'free atom potential and density for atom type', iph
            call wlog(slog)
         endif
c        Include corehole if absorber (unless user says nohole)
         if (iph .eq. 0)  then
            itmp = ihole
         else
            itmp = 0
         endif
         if (nohole.ge.0 .and. iph.eq.0) then
           xionp = xion(0)
           if (nfree.eq.2 .and. ifree.eq.1) xionp = 0
           call scfdat ( ipr1, nph+1, nph, iz(0), itmp, xionp, iunf,
     1     vcoul(1,nph+1), rho(1,nph+1), dmag(1,nph+1), rhoval(1,nph+1),
     2     ispinr, dgc0, dpc0, dgc, dpc, adgc, adpc, 
     3     s02, efrozn, et, xnvmu(0,nph+1),
     4     xnval(1,nph+1), iorb(-4,nph+1), norb(nph+1),
     5     eorb(1,nph+1), kappa(1,nph+1) )
         else
           xionp = xion(iph)
           if (nfree.eq.2 .and. ifree.eq.1) xionp = 0
           call scfdat ( ipr1, iph, nph, iz(iph), itmp, xionp, iunf,
     1         vcoul(1,iph), rho(1,iph), dmag(1,iph), rhoval(1,iph),
     2         ispinr, dgc0, dpc0, dgc, dpc, adgc, adpc, 
     3         s02, efrozn, et, xnvmu(0,iph),
     4         xnval(1,iph), iorb(-4,iph), norb(iph),
     5         eorb(1,iph), kappa(1,iph) )
         endif
c        etfin is absorbing atom final state total energy, see nohole
c           case below
         if (iph .eq. 0) etfin = et
   20 continue

      if (verbse) then
         write(slog,10) 'initial state energy'
         call wlog(slog)
      endif
c     Save initial state energy and spinors for core hole orbital,
c     do not save potentials, except for nohole.
      ispinr = ihole
      itmp = 0
      if (nohole.ge.0) then
         iph = 0
         xionp = xion(iph)
         if (nfree.eq.2 .and. ifree.eq.1) xionp = 0
         call scfdat ( ipr1, iph, nph, iz(iph), itmp, xionp, iunf,
     1         vcoul(1,iph), rho(1,iph), dmag(1,iph), rhoval(1,iph),
     2         ispinr, dgc0, dpc0, dgc, dpc, adgc, adpc, 
     3         s02, efrozn, etinit, xnvmu(0,iph),
     4         xnval(1,iph), iorb(-4,iph), norb(iph),
     5         eorb(1,iph), kappa(1,iph) )
      else
         xionp = xion(0)
         if (nfree.eq.2 .and. ifree.eq.1) xionp = 0
         call scfdat ( ipr1, nph+1, nph, iz(0), itmp, xionp, iunf,
     1     vcoul(1,nph+1), rho(1,nph+1), dmag(1,nph+1), rhoval(1,nph+1),
     2     ispinr, dgc0, dpc0, dgc, dpc, adgc, adpc, 
     3     s02, efrozn, etinit, xnvmu(0,nph+1),
     4     xnval(1,nph+1), iorb(-4,nph+1), norb(nph+1),
     5     eorb(1,nph+1), kappa(1,nph+1) )
      endif

c     testing new potential for the final state. ala
      hx = 0.05d0
      x0 = -8.8d0
      if (nohole.gt.0) then
         idim = 251
         do 30 i = 1,idim
  30     dr(i) = exp(x0+hx*(i-1))
         if (nohole.eq.1) then
            do 40 i = 1,idim
  40        drho(i) = dgc0(i)**2 + dpc0(i)**2
         else
            do 50 i = 1,idim
               drho(i)=dr(i)**2 *
     1         (rho(i,0)-rhoval(i,0)-rho(i,nph+1)+rhoval(i,nph+1))
  50        continue
         endif
         call potslw ( dvcoul, drho, dr, hx,idim)
         do 60 i=1,idim
c           drho(i) = drho(i)/ dr(i)**2
c           use 1/2 of core-hole as in transition state
            drho(i) = drho(i)/2.0d0/ dr(i)**2
  60     continue
      else
         do 70 i=1,251
            drho(i) = 0
            dvcoul(i) = 0
  70     continue
      endif

c     etinit is absorbing atom initial state (no hole)
c     efrozn is ionization energy with frozen orbitals (koopman's
c      theorem)
c     etfin-etinit is ionization energy in adiabatic approximation
      erelax= -efrozn - ( etfin - etinit)
      emu = etfin - etinit

c     Overlap potentials and densitites
      do 90  iph = 0, nph
         if (verbse) then
            write(slog,10)
     1      'overlapped potential and density for unique potential', iph
            call wlog(slog)
         endif
         call ovrlp (iph, iphat, rat, iatph, novr, iphovr,
     1               nnovr, rovr, iz, nat, rho, dmag,
     2               rhoval, vcoul, edens, edenvl, vclap, qnrm)
         if (iph.eq.0) emu = emu - vclap(1,0)+vcoul(1,0)
   90 continue

      if (ifree.eq.1) then
c       Set the Norman radii 
        do 92 iph =0, nph
   92   rnrm(iph) = qnrm(iph)
      endif

   99 continue
c  end of free atom calculations (might be done twice if ION used)

cc new patch
c     itest = 1
c     if (itest.eq.1) then
cc      use orbitals with core-hole for initial orbitals
cc      orthogonaliztion problem for NRIXS calculations
c       do i = 1, 251
c         dgc0(i) = dgc(i,0)
c         dpc0(i) = dpc(i,0)
c       enddo
c     endif
cc end new patch
     
c     Find total charges for istprm
c     qtotel - total number of e in a cluster
      qtotel = 0
      do 80 iph = 0,nph
         qtotel = qtotel + (iz(iph)-xion(iph)) * xnatph(iph)
  80  continue
c     photoelectron moves out of the system
c     do not remove now since we are putting screening electron back


c     Find muffin tin radii, add gsxc to potentials, and find
c     interstitial parameters
      if (verbse) then
         write(slog,10) 'muffin tin radii and interstitial parameters'
         call wlog(slog)
      endif

      rmt(0) = -1
      xmu = 100.d0
      if (iafolp.ge.0) then
        do 101 iph=0,nph
          folpx(iph) = folp(iph)
          folp(iph) = 1
  101   continue
      endif
        
      idmag = 0
      call istprm (nph, nat, iphat, rat, iatph, xnatph,
     1            novr, iphovr, nnovr, rovr, folp, folpx, iafolp,
     1            edens, edenvl, idmag,
     2            dmag, vclap, vtot, vvalgs, imt, inrm, rmt, rnrm,
     3            ixc, rhoint,vint, rs, xf, xmu, xmunew,
     4            rnrmav, qtotel, inters, totvol)
      xmu = xmunew

c     Automatic max reasonable overlap
      if (iafolp .ge. 0)  then
         call afolp (verbse, nph, nat, iphat, rat, iatph, xnatph,
     1               novr, iphovr, nnovr, rovr, folp, folpx, iafolp,
     1               edens, edenvl,
     2               dmag, vclap, vtot, vvalgs, imt, inrm, rmt, rnrm,
     3               ixc, rhoint,vint, rs, xf, xmu, xmunew,
     4               rnrmav, qtotel, inters, totvol)
         xmu =xmunew
      endif

c     wp is plasmon frequency in hart
      wp = sqrt(12.d0*rs/fa**4) * xf**2 / 2.d0

c     Phase shift calculation
c     Atom r grid
      dx = 0.05d0
      x0 = 8.8d0

c     Find self-consistent muffin-tin potential.
      do 105 iph=0,nph
         qnrm(iph) = 0
         qold(iph) = 0
  105 continue

  100 continue
      if (nscmt.gt.0 .or. (ispec.ne.0 .and. ispec.lt.4)) call corval
     1                 (verbse, ecv, xnvmu, eorb, norb, xnval,
     1                  kappa, rgrd, nohole,
     2                  nph, edens, edenvl, vtot, vvalgs,
     3                  rmt, rnrm, ixc, rhoint, vint, jumprm,
     4                  x0, ri, dx, xion, iunf, iz,
     5                  adgc, adpc, dgc, dpc, ihole, lmaxsc)


c     find a total number of valence electrons
c     xntot - required number of valence electrons below fermi level
c     xnvmu(iph) = xnvmu(iph)-xion(iph)
c     xnvmu - number of valence electron within norman sphere
      xntot=0.0d0
      do 120 iph=0,nph
         xnvmup = 0
         do 110  i = 0,lx
  110    xnvmup = xnvmup + xnvmu(i,iph)
c x35 and earlier   xntot = xntot + xnatph(iph)*(xnvmup+xion(iph))
         xntot = xntot + xnatph(iph) * xnvmup
  120 continue

c     need to update vxcval in case if the core-valence separation was
c     made in subroutine corval. Need vxcval only for nonlocal exchange.
      if (mod(ixc,10).ge.5) then
         call  istprm (nph, nat, iphat, rat, iatph, xnatph,
     1               novr, iphovr, nnovr, rovr, folp, folpx, iafolp,
     1               edens, edenvl, idmag,
     2               dmag, vclap, vtot, vvalgs, imt, inrm, rmt, rnrm,
     3               ixc, rhoint,vint, rs, xf, xmu, xmunew,
     5               rnrmav, qtotel, inters, totvol)
         xmunew = xmu
      endif

      if (verbse) then
         write(slog,130) xmu*hart
 130     format('    : mu_old= ',f9.3)
         call wlog(slog)
      endif

c     do first nmix iterations with mixing scheme. Need for f-elements.
  140 nmix=nmix-1

c     number of processors for parallel execution
      npr = numprocs
      do 200 iscmt =1,nscmt
c        need to store coulomb potential
         do 145 ip=0,nph
         do 145 ir=1,251
  145    vclapp(ir,ip) = vclap(ir,ip)

         if (npr.le.1) then
           call scmt (verbse, iscmt, ecv, nph, nat, vclap, edens,
     1                edenvl, vtot, vvalgs, rmt, rnrm, qnrm,
     2                ixc, rhoint, vint, xmunew, jumprm,
     3                xntot, xnvmu, xnval,
     4                x0, ri, dx, xnatph, xion, iunf, iz,
     5                adgc, adpc, dgc,dpc, ihole,
     7                rat, iatph, iphat, lmaxsc, rhoval, xnmues, ok,
     8                rgrd, nohole, nscmt, icoul, ca1, rfms1, lfms1)
         else
           call scmtmp(verbse, npr, iscmt, ecv, nph, nat, vclap, edens,
     1                edenvl, vtot, vvalgs, rmt, rnrm, qnrm,
     2                ixc, rhoint, vint, xmunew, jumprm,
     3                xntot, xnvmu, xnval,
     4                x0, ri, dx, xnatph, xion, iunf, iz,
     5                adgc, adpc, dgc,dpc, ihole,
     7                rat, iatph, iphat, lmaxsc, rhoval, xnmues, ok,
     8                rgrd, nohole, nscmt, icoul, ca1, rfms1, lfms1,
     9                gtr, xrhole, xrhoce, yrhole, yrhoce )
         endif

         if (.not. ok) goto 100
c        if need to change core-valence separation then
c        start scmt loop all over again

c        write out Fermi level and charge transfers 
c        and do tests of self-consistency
         lpass = .true.
         if (iscmt.lt.nscmt .and. iscmt.le.3) lpass =.false.
         if (verbse) then
            write (slog,150)   xmunew*hart
 150        format (' mu_new= ', f9.3)
            call wlog(slog)
         endif
         if (abs (xmunew - xmu) .gt. tolmu) lpass = .false.
         xmu = xmunew
c        print out charge 
         if (verbse) call wlog(' Charge transfer:  iph  charge(iph) ')
         do 170 iph=0,nph
            if (verbse) then
               write (slog,180) iph, -qnrm(iph) + xion(iph)
               call wlog(slog)
            endif
            if (abs(qnrm(iph)-qold(iph)).gt.tolq) lpass = .false.
            qold(iph) = qnrm(iph)

c           check self-consistency of charges
            sum = -qnrm(iph)
            do 160 il=0,lx
  160       sum = sum + xnmues(il,iph) - xnvmu(il,iph)
            if (abs(sum).gt.0.05d0) lpass = .false.
  170    continue
  180    format('     ',i3, 2f9.3)

c        recalculate core density (edens) here. fix later. ala
c        call scfdat
c        for now use the old core density
         if (iscmt.eq.nscmt .or. lpass) then
c           restore  total density from previous iteration
            do 190 ip=0,nph
              do 185 ir=1,251
c                need total density for istprm
                 edens(ir,ip) = edens(ir,ip)-rhoval(ir,ip)+edenvl(ir,ip)
                 vclap(ir,ip) = vclapp(ir,ip)
  185         continue
c             remember the reported charge transfer
              qnrm(ip) = -qnrm(ip) + xion(ip)
  190       continue
c           exit self-consistency loop
            goto 210
         else
c           update valence density
            do 195 ip=0,nph
            do 195 ir=1,251
c              need total density for istprm
               edenvl(ir,ip) = rhoval(ir,ip)
  195       continue
         endif

         call  istprm (nph, nat, iphat, rat, iatph, xnatph,
     1               novr, iphovr, nnovr, rovr, folp, folpx, iafolp,
     1               edens, edenvl, idmag,
     2               dmag, vclap, vtot, vvalgs, imt, inrm, rmt, rnrm,
     3               ixc, rhoint,vint, rs, xf, xmu, xmunew,
     5               rnrmav, qtotel, inters, totvol)
         xmunew = xmu
         if (nmix.gt.0) goto 140

  200 continue
c     suspicious exit: run out of iterations (iscmt=nscmt)

c     right exit from the loop: self-consistency is achieved
  210 continue
      if (worker) go to 400

      if (nohole.gt.0) then
c        testing new final state potential
         do 220 j = 1,251
  220    edens(j,0) = edens(j,0) - drho(j)
         
c        notice that vclap is actually for the next iteration
c        in SCMT loop, thus vclap may be wrong if self-consistency
c        has not been reached
         do 230 j = 1,251
  230    vclap(j,0) = vclap(j,0) - dvcoul(j)

         call  istprm (nph, nat, iphat, rat, iatph, xnatph,
     1      novr, iphovr, nnovr, rovr, folp, folpx, iafolp,
     1      edens, edenvl, idmag,
     2      dmag, vclap, vtot, vvalgs, imt, inrm, rmt, rnrm,
     3      ixc, rhoint,vint, rs, xf, xmu, xmunew,
     5      rnrmav, qtotel, inters, totvol)
      endif

c    correct the excitation energy
c     emu = emu -vclap(1,0) + vcoul(1,0) done also above
c     emu = emu+xmu  should be done in principle but leads
c     to worse estimate of edge position. fix later. ala

      if (ipr1 .ge. 2)  then
         call wpot (nph, edens, imt, inrm,
     1              rho, vclap, vcoul, vtot, ntitle, title)
      endif


  400 call par_barrier

      return
      end

c====================================================================
      integer function nxtunt(iunit)

c  this function returns the value of the next unopened unit number
c  equal to or larger than iunit.  it will return neither unit numbers
c  0, 5, or 6 nor a negative unit number
c $Id: nxtunt.f,v 1.1.1.1 2006/01/12 06:37:42 hebhop Exp $
c $Log: nxtunt.f,v $
c Revision 1.1.1.1  2006/01/12 06:37:42  hebhop
c New version of feff. feff8.5 (Extension of feff8.4)
c Includes:
c 	1) All feff8.4 capabilities.
c 	2) Screened core hole (calculation of W).
c 	3) Multiple pole self energy calculation.
c 	4) Convolution with spectral function.
c New cards and options:
c 	1) NOHOLE 2      (screened hole)
c 	2) PLASMON ipl   (multiple pole self energy)
c 	3) SO2CONV       (convolve output with spectral function)
c 	4) SELF          (print on shell self energy as calculated by Luke)
c 	5) SFSE k0        (print off shell self energy Sigma(k0,e) )
c
c Revision 1.1.1.1  2000/02/11 02:23:58  alex
c Initialize feff82
c
c Revision 1.10  1999/04/02 21:32:47  newville
c cleaned up nxtunt (matt)
c
c Revision 1.9  1999/02/11 20:08:08  alex
c x39 version: dim.h + misc. small changes
c
c Revision 1.8  1998/12/29 23:59:07  alex
c feff8x35 version
c
c Revision 1.7  1998/11/19 03:23:11  alex
c feff8x32 version
c
c Revision 1.6  1998/10/26 14:11:16  ravel
c no comments beyond column 71
c
c Revision 1.5  1998/10/18 21:47:51  alex
c feff8x30 version implements Broyden algorithm for self-consistency
c
c Revision 1.4  1998/02/24 18:31:37  ravel
c I should really be more careful.  This is the last commitment done
c      cright.
c
c Revision 1.1.1.1  1997/04/27 20:18:03  ravel
c Initial import of xanes sources, version 0.37
c
c Revision 1.1  1996/06/23 16:05:02  bruce
c Initial revision
c

       integer iunit
       logical open

       nxtunt = max(1, iunit) - 1
 10    continue
       nxtunt = nxtunt + 1
       if ((nxtunt.eq.5).or.(nxtunt.eq.6)) nxtunt = 7
       inquire (unit=nxtunt, opened=open)
       if (open) go to 10
       return
c  end integer function nxtunt
       end

c====================================================================

      subroutine iniall
c     initializes all input variables contained in the
c     common blocks of the header file allinp.h 
c     written by Alexei Ankudinov , march 2001.
c     following the suggested by Bruce Ravel subroutine iorini
      implicit double precision (a-h, o-z)

      real szero, sone
      double precision dzero, done
      parameter(szero = 0.e0, dzero = 0.d0)
      parameter(sone = 1.e0,  done = 1.d0)
      include '../HEADERS/dim.h'
      include '../RDINP/allinp.h'

c     initialize character string arrays
      do 10 i=1,nheadx
        title(i) = ' '
 10   continue

c  initialize integer scalars
      iGrid = 0 ! Josh Kas
      ntitle = 0
      nat = 0
      natt = 0
      nph = 0

      iafolp = 0
      idwopt = -1
      ihole = 1
      inters = 0
      iorder = 2
      ipr1 = 0
      ipr2 = 0
      ipr3 = 0
      ipr4 = 0
      ipr5 = 0
      ipr6 = 0
      ipse = 0
      ipsk = 0
      ispec = 0
      ixc = 0
      ixc0 = -1
      jumprm = 0
      lfms1 = 0
      lfms2 = 0
      minv = 0
      lreal = 0
      mbconv = 0
      mchi = 1
      mfeff = 1
      mfms = 1
      mpath = 1
      mphase = 1
      mldos = 0
      mpot = 1
      ms = 0
      iPlsmn = 0 ! Josh Kas
      mso2conv = 0 ! Josh Kas
      nlegxx = 10
      nmix = 1
      nohole = -1
      nscmt = 0
      icoul = 0
      iunf = 0
      izstd = 0
      ifxc = 0
      ipmbse = 0
      itdlda = 0
      nonlocal = 0
      ibasis = 0

cc initialize reals
      critpw = 2.5*sone
      pcritk = szero
      pcrith = szero
      rmax = -1 * sone
      rfms1 = -1 * sone
      rfms2 = -1 * sone
      rdirec = -1 * sone
      toler1 = 1.e-3
      toler2 = 1.e-3

cc initialize double precision scalars
      alphat = dzero
      thetae = dzero
      ca1 = dzero
      critcw = 4*done
      eimag = -1*done
      ecv = -40*done 
      emax = dzero
      emin = 1000*done
      rclabs = dzero
      rgrd = 0.05 * done
      s02 = done
      sig2g = dzero
      thetad = dzero
      tk = dzero
      totvol = dzero
      vr0 = dzero
      vi0 = dzero
      vicorr = dzero
      vrcorr = dzero
      xkmax = 20*done
      xkstep = 0.07*done
      vixan = dzero
      wsigk = dzero ! Josh Kas
      cen = dzero ! Josh Kas
      
cc initialize logicals
      wnstar = .false.


c  initialize loops of number of potentials
      do 110 i=0,nphx
        xnatph(i) = dzero
        spinph(i) = dzero
        iz(i) = 0
        xion(i) = dzero
        folp(i) = done
        novr(i) = 0
        lmaxsc(i) = 0
        lmaxph(i) = 0
        potlbl(i) = ' '
 110  continue

      do 114 i=0,nphx
         do 112 j=1,novrx
            iphovr(j,i)=0
            nnovr(j,i)=0
            rovr(j,i)=dzero
 112     continue
 114  continue

c  initialize polarization data
      ipol = 0
      ispin = 0
      le2 = 0
      l2lp = 0
      elpty = dzero
      angks = dzero
      do 130 i=1,3
        evec(i) = dzero
        xivec(i) = dzero
        spvec(i) = dzero
 130  continue
      do 150 i=-1,1
        do 140 j=-1,1
          ptz(j,i) = dcmplx(dzero,dzero)
 140    continue
 150  continue

c  initialize atom list data
      do 170 i=1,nattx
 170  iphatx(i) = -1

c  initialize character strings - Josh Kas
      cfname = 'NULL'
      
c  initialize EELS variables !KJ 1-06
      ebeam=dzero
        aconv=dzero
        acoll=dzero
        nqr=0
        nqf=0
        magic=0
        emagic=dzero
        eels=0
        relat=1
        cross=1
        aver=0
      thetax=dzero
        thetay=dzero
        ipmin=1
        ipmax=9
        ipstep=1
        iinput=1  !5/6
       spcol=4
c KJ 

c for ABSOLUTE card  !KJ 3-06
        absolu=0  !KJ 3-06

      return
      end
c  end subroutine iniall

      subroutine rdcmt(iunt, cmt)
      integer iunt, i1
c      character(300) line
      character(4) cmt
      character tmpcmt(4), ch
      logical cmtlin

      cmtlin = .true.
      do i1 = 1, 4
         tmpcmt(i1) = cmt(i1:i1)
      end do
 5    continue
      read(iunt,*,end=10) ch
      do i1 = 1, 4
         if(ch.eq.tmpcmt(i1)) goto 5
      end do
      
 10   continue
      backspace(iunt)
      
      return
      end

      program feff
      integer iabs, nabs
      logical ceels !KJ added ceels 5-06

      call rdinp(nabs,ceels)
      call ffmod1
      call ffmod2
      do 900 iabs = 1, nabs
        if (nabs.gt.1) call ffsort (iabs,ceels) !KJ 5-6 added second argument
        call ffmod4
        call ffmod5
        call ffmod6(iabs)
        call ffmod9
 900  continue
      stop
      end

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Information about last revision of $RCSfile: m_kklist.f90,v $:
! $Revision: 1.8 $
! $Author: jorissen $
! $Date: 2012/01/30 06:01:58 $
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!*****************************************************************************
!       THE K-MESH TO SAMPLE THE BRILLOUIN ZONE
!*****************************************************************************
module kklist
  !    Number of k-points for the BZ mesh
  integer nkp
  !    BZ mesh size, specified as nkx x nky x nkz
  integer nkx,nky,nkz
  !    Use symmetry (1) or not (0) for this mesh
  integer usesym
  !    Type of k-mesh
  integer ktype
  ! ktype=1  :  regular mesh of nkp points for all modules
  ! ktype=2  :  use nkp points for ldos/fms and nkp/5 points for pot  (significant time savings)
  ! ktype=3  :  use nkp points for ldos/fms and nkp/5 points for pot (near edge) ; reduce nkp for all modules as we get away from near-edge
  !    Rotation matrices for spherical harmonics
  !complex*16 drot(32,32,48,2)  !lx=3
  complex*16 drot(50,50,48,2)   !lx=4
  complex*16, allocatable :: mrot(:,:,:)
  !    The k-mesh itself!
  real*8, allocatable :: bk(:,:)
  !    Corresponding integration weights
  real*8, allocatable :: weight(:)
  !    Sum of the integration weights
  real*8 sumweights
  !    Correspondence between wien2k and sprkkr symmetry matrices
  integer symid(2,48)
  !    Arrays that code for the relation between full and reduced k-mesh
  integer,allocatable :: intn(:),inti(:,:,:)
  !    Which symmetries are actually used for the k-mes
  integer symact(48)
  !    More arrays
  real*8,allocatable :: intw(:,:)


contains
  
  subroutine init_kklist(n,nsym) !KJ 6-09
    !            use struct,only: nsym !KJ 6-09
    implicit none
    integer,intent(in) :: n,nsym !KJ added nsym 6-09
    allocate(bk(3,n),weight(n))
    allocate(intn(n),inti(n,nsym,2),intw(n,nsym))
    intn=0
    inti=0
    intw=dble(0)
    symact=0
    bk=dble(0)
    weight=dble(0)
    sumweights=dble(0)
    symid=0
  end subroutine init_kklist

  subroutine destroy_kklist
    if(allocated(bk)) deallocate(bk)
    if(allocated(weight)) deallocate(weight)
    if(allocated(inti)) deallocate(inti)
    if(allocated(intn)) deallocate(intn)
    if(allocated(intw)) deallocate(intw)
  end subroutine destroy_kklist

end module kklist

!=======================================================================
!     SCREEN
!=======================================================================

module screen_inp
  use atoms_inp,only: nph
  implicit none

  TYPE ScreenInputVars
     integer ner, nei, maxl, irrh, iend, lfxc, nrptx0
     double precision emin, emax, eimax, ermin, rfms
  END TYPE ScreenInputVars

  character(*),parameter,private :: filename='screen.inp'
  TYPE(ScreenInputVars) ScreenI

contains

  subroutine screen_write
    open(unit=3,file=filename,status='unknown')
    write(3,*) 'ner',ScreenI%ner
    write(3,*) 'nei',ScreenI%nei
    write(3,*) 'maxl',ScreenI%maxl
    write(3,*) 'irrh',ScreenI%irrh
    write(3,*) 'iend',ScreenI%iend
    write(3,*) 'lfxc',ScreenI%lfxc
    write(3,*) 'emin',ScreenI%emin
    write(3,*) 'emax',ScreenI%emax
    write(3,*) 'eimax',ScreenI%eimax
    write(3,*) 'ermin',ScreenI%ermin
    write(3,*) 'rfms',ScreenI%rfms
    write(3,*) 'nrptx0',ScreenI%nrptx0
    close(3)
    return
  end subroutine screen_write

  subroutine screen_inp_parse(str,vars)
    implicit none
    character*3,intent(in) :: str
    real*8,intent(in) ::  vars
    if (str .eq. 'ner') then
       ScreenI%ner   = int(vars)
    elseif (str .eq. 'nei') then
       ScreenI%nei   = int(vars)
    elseif (str .eq. 'max') then
       ScreenI%maxl  = int(vars)
    elseif (str .eq. 'irr') then
       ScreenI%irrh  = int(vars)
    elseif (str .eq. 'ien') then
       ScreenI%iend  = int(vars)
    elseif (str .eq. 'lfx') then
       ScreenI%lfxc  = int(vars)
    elseif (str .eq. 'emi') then
       ScreenI%emin  = vars
    elseif (str .eq. 'ema') then
       ScreenI%emax  = vars
    elseif (str .eq. 'eim') then
       ScreenI%eimax = vars
    elseif (str .eq. 'erm') then
       ScreenI%ermin = vars
    elseif (str .eq. 'rfm') then
       ScreenI%rfms  = vars
    elseif (str .eq. 'nrp')then
       ScreenI%nrptx0  = int(vars)
    else
       call wlog("Unrecognized keyword submitted to screen.inp in SCREEN_INP_PARSE ; aborting.")
       stop
    endif
    return
  end subroutine screen_inp_parse

  subroutine screen_inp_parse_and_write(str,vars)
    !KJ No longer used (1-2012).  Used in a previous version of feff.
    implicit none
    character*3,intent(in) :: str
    real*8,intent(in) ::  vars
    open(unit=3,file=filename,status='unknown',access='append')
    if (str .eq. 'ner') then
       ScreenI%ner   = int(vars)
       write(3,*) 'ner',ScreenI%ner
    elseif (str .eq. 'nei') then
       ScreenI%nei   = int(vars)
       write(3,*) 'nei',ScreenI%nei
    elseif (str .eq. 'max') then
       ScreenI%maxl  = int(vars)
       write(3,*) 'maxl',ScreenI%maxl
    elseif (str .eq. 'irr') then
       ScreenI%irrh  = int(vars)
       write(3,*) 'irrh',ScreenI%irrh
    elseif (str .eq. 'ien') then
       ScreenI%iend  = int(vars)
       write(3,*) 'iend',ScreenI%iend
    elseif (str .eq. 'lfx') then
       ScreenI%lfxc  = int(vars)
       write(3,*) 'lfxc',ScreenI%lfxc
    elseif (str .eq. 'emi') then
       ScreenI%emin  = vars
       write(3,*) 'emin',ScreenI%emin
    elseif (str .eq. 'ema') then
       ScreenI%emax  = vars
       write(3,*) 'emax',ScreenI%emax
    elseif (str .eq. 'eim') then
       ScreenI%eimax = vars
       write(3,*) 'eimax',ScreenI%eimax
    elseif (str .eq. 'erm') then
       ScreenI%ermin = vars
       write(3,*) 'ermin',ScreenI%ermin
    elseif (str .eq. 'rfm') then
       ScreenI%rfms  = vars
       write(3,*) 'rfms',ScreenI%rfms
    elseif (str .eq. 'nrp')then
       ScreenI%nrptx0  = int(vars)
       write(3,*) 'nrptx0',ScreenI%nrptx0
    else
       call wlog("Unrecognized keyword submitted to screen.inp ; aborting.")
       stop
    endif
    close(3)
    return
  end subroutine screen_inp_parse_and_write


  subroutine screen_read
    ! Reads screen.inp.  This routine is set up a little different from its brothers in the other input modules.
    ! This is to keep it compatible with situations where there either is no screen.inp file (in which case defaults are used for all variables),
    ! and with situations where screen.inp contains only the variables for which non-default values are specified.
    ! This is because I've only added mandatory screen.inp files being written by rdinp now 1-2012.  KJ
    integer i
    character*8 strs
    character*3 str
    double precision vars
    call screen_init  !KJ set defaults in case screen.inp doesn't exist!
    open (file=filename, unit=3, status='old', err=60)
    !KJ			read (3,*)  !KJ 11-2011 removing header line from screen.inp because it is incompatible with screen_inp_and_parse above.
    do i = 1, 12
       read(3,*,end=60)  strs, vars
       str = strs(1:3)
       if (str .eq. 'ner') ScreenI%ner   = nint(vars)
       if (str .eq. 'nei') ScreenI%nei   = nint(vars)
       if (str .eq. 'max') ScreenI%maxl  = nint(vars)
       if (str .eq. 'irr') ScreenI%irrh  = nint(vars)
       if (str .eq. 'ien') ScreenI%iend  = nint(vars)
       if (str .eq. 'lfx') ScreenI%lfxc  = nint(vars)
       if (str .eq. 'emi') ScreenI%emin  = vars
       if (str .eq. 'ema') ScreenI%emax  = vars
       if (str .eq. 'eim') ScreenI%eimax = vars
       if (str .eq. 'erm') ScreenI%ermin = vars
       if (str .eq. 'rfm') ScreenI%rfms  = vars
       if (str .eq. 'nrp') ScreenI%nrptx0  = nint(vars)
    end do
60  continue
    close(3)
    return
  end subroutine screen_read

  subroutine screen_init
    ScreenI%ner   = 40
    ScreenI%nei   = 20
    ScreenI%maxl  = 4
    ScreenI%irrh  = 1
    ScreenI%iend  = 0
    ScreenI%emin  = -40.0d0 !KJ This and next 3 values are in eV ; converted to Ha at a later point in the code (screen/rdgeom.f90)
    ScreenI%emax  = 0.0d0
    ScreenI%eimax = 2.0d0
    ScreenI%ermin = 0.001d0
    ScreenI%lfxc  = 0
    ScreenI%rfms  = 4.0d0
    ScreenI%nrptx0 = 251
  end subroutine screen_init

end module screen_inp

      block data feffbd

      implicit double precision (a-h, o-z)

      character*10 shole(0:9)
      character*8 sout(0:6)
      common /labels/ shole, sout

      include 'vers.h'
c     character*12 vfeff, vpotph, vpaths, vgenfm, vff2ch
c     common /vers/ vfeff, vpotph, vpaths, vgenfm, vff2ch

      data shole /'no hole',    'K shell',
     1            'LI shell',   'LII shell',
     2            'LIII shell', 'MI shell',
     3            'MII shell',  'MIII shell',
     4            'MIV shell',  'MV shell'/
      data sout /'H-L exch', 'D-H exch', 'Gd state', 
     1           'DH - HL ', 'DH + HL ', 'HLnoimag', 'Gs HL   '/

c                   123456789012
      data vfeff  /'  Feff 6.02l'/
      data vpotph /'  potph 4.12'/
      data vpaths /'  paths 3.05'/
      data vgenfm /' genfmt 1.44'/
      data vff2ch /' ff2chi 2.01'/

c     6.01l EXAFS only lite version 10/02 jjr
c     5.05a is current working version
c     5.05j is jjr's version 6/93
c     6.00 Alexey's polarization and XANES 
c     6.01 Release version of FEFF6 including bug fixes ala and jjr
c     4.04 Major code reorganization.  Muffin tin finder modified -- now
c     uses average of all possible muffin tin radii instead of minimum.
c     26 March, 1991   Steven Zabinsky
c     4.05 Yet another improvement to muffin tin finder, now averages
c     based on volume of lense-shaped overlapping region, April, 1991
c     4.06 Bug fix in sumax, april 1991
c     4.07 Several minor changes involving non-standard F77 6/6/91, siz
c     4.08 ION card added 7/24/91, siz
c     4.08a, bug in header for ION card fixed 9/10/91, siz
c     4.09, quinn correction added to imhl, interstitial calculation
c           corrected, rmt modified to handle too few neighbors and
c           error msg in phase about hard test in fovrg modified,
c           folp card added
c     POTPH 4.1  Same as feff4.09, but version hacked to work with
c     module potph of feff5, Mar 1992, siz
c
c     new version common added, siz, Mar 1992
c     feff 5.03, first 'real' release, lots of little changes.
c                4 criteria added is the big change.  siz, April 1992
c     feffx 5.04, intermediate intermittent version of code with
c                 background, xsect, xmu, timereversal, lots
c                 of input cards, xanes, etc.  July 1992, siz
c     e REQUIRE card removed, Oct 92, siz
c     f, and paths 3.04, new crits, 9 points. Oct 92
c     g: major bug in xsect -  ixc not passed to xcpot, beginning with
c        5.04g, it's fixed.
c     h use gs for xsect (hard coded)
c     i fixed init and final state mixup in xsect
c     Feff 5.05, release version with all of the above in it.  XANES
c        is turned off in RDINP for the release -- turn it back on
c        there for development.
c     Feff 6 includes polarization (Alexey) and XANES (Steve Z.)
c     Feff 6.01 is the first release version of FEFF6.
c     Feff 6.01l EXAFS only lite version 10/02 jjr

      end

      subroutine prcrit (neout, nncrit, ik0out, cksp, fbeta, ckspc, 
     1                   fbetac, potlb0, xlam, xlamc)
      implicit double precision (a-h, o-z)

c     Prepare fbeta arrays, etc., for pathfinder criteria
c
c     Note that path finder is single precision, so be sure that
c     things are correct precision in calls and declarations!
c     See declarations below for details.
c     
c     Inputs:  Reads phase.pad
c     Output:  neout   'ne', number of energy grid points
c              ik0out  index of energy grid with k=0
c              cksp    |p| at each energy grid point in single precision
c              fbeta   |f(beta)| for each angle, npot, energy point, sp
c              ckspc   |p| at each necrit point in single precision
c              fbetac  |f(beta)| for each angle, npot, nncrit point, sp
c              potlb0  unique potential labels
c              xlam    mean free path for each energy point in Ang, sp
c              xlamc   mean free path for each nncrit point in Ang, sp

      include '../HEADERS/const.h'
      include '../HEADERS/dim.h'
      character*6  potlbl
      dimension  potlbl(0:nphx)

c     staff originally kept in common blocks of pdata.h
      complex*16 ph, eref, em
      double precision rnrmav, xmu, edge
      dimension ph( nex, ltot+1, 0:nphx), eref(nex), em(nex),
     1 lmax(nex,0:nphx), iz(0:nphx)

c     Output variables SINGLE PRECISION for use with path finder.
c     BE CAREFUL!!
      parameter (necrit=9, nbeta=40)
      real fbetac(-nbeta:nbeta,0:nphx,necrit), ckspc(necrit)
      real fbeta(-nbeta:nbeta,0:nphx,nex), cksp(nex)
      real xlamc(necrit)
      real xlam(nex)
      character*6  potlb0(0:nphx)

c     Local variables
      complex*16 cfbeta, tl, cktmp
      dimension dcosb(-nbeta:nbeta)
      dimension pl(ltot+1)
      dimension iecrit(necrit)
      parameter (eps = 1.0e-16)
      complex*16 rkk(nex,8,nspx), eref2(nex,nspx)
      complex*16 ph4(nex, -ltot:ltot, nspx, 0:nphx)

      character*256 phpad

c     Need stuff from phase.pad
c     Read phase calculation input, data returned via commons
      phpad = 'phase.pad'
      call rdxsph (phpad, ne, ne1, ne3, npot, ihole,
     1     rnrmav, xmu, edge, ik0, ixc, rs, vint,
     2     em, eref2, iz, potlbl, ph4, rkk, lmax, lmaxp1  )
 
      do 10 ie = 1, ne
  10  eref(ie) = eref2(ie,1)
      do 20 iph = 0, npot
      do 20 ie = 1, ne
      do 20 il = 0, lmax(ie, iph)
  20  ph(ie,il+1, iph) = ph4(ie, -il, 1, iph)

      neout = ne1
      ik0out = ik0
      do 40  i = 0, nphx
         potlb0(i) = potlbl(i)
   40 continue

c     |p| at each energy point (path finder uses invA, convert here)
c     Also make mfp (xlam) in Ang
      do 100  ie = 1, ne
         cktmp = sqrt (2*(em(ie) - eref(ie)))
         cksp(ie) = real(dble (cktmp) / bohr)
c        xlam code lifted from genfmt
         xlam(ie) = 1.0e10
         if (abs(dimag(cktmp)) .gt. eps) xlam(ie) = real(1/dimag(cktmp))
         xlam(ie) = xlam(ie) * real(bohr)
  100 continue

c     Make the cos(beta)'s
c     Grid is from -40 to 40, 81 points from -1 to 1, spaced .025
      do 200  ibeta = -nbeta, nbeta
         dcosb(ibeta) = 0.025 * ibeta
  200 continue
c     watch out for round-off error
      dcosb(-nbeta) = -1
      dcosb(nbeta)  =  1

c     make fbeta (f(beta) for all energy points
      do 280  ibeta = -nbeta, nbeta
         call cpl0 (dcosb(ibeta), pl, lmaxp1)
         do 260  iii = 0, npot
            do 250  ie = 1, ne
               cfbeta = 0
               do 245  il = 1, lmax(ie,iii)+1
                  tl = (exp (2*coni*ph(ie,il,iii)) - 1) / (2*coni)
                  cfbeta = cfbeta + tl*pl(il)*(2*il-1)
  245          continue
               fbeta(ibeta,iii,ie) = real( abs(cfbeta) )
  250       continue
  260    continue
  280 continue

c     Make similar arrays for only the icrit points

c     Use 9 points at k=0,1,2,3,4,6,8,10,12 invA
c     See phmesh for energy gid definition.  These seem to work fine, 
c     and results aren't too sensitive to choices of k.  As few as 4
c     points work well (used 0,3,6,9), but time penalty for 9 points
c     is small and increased safety seems to be worth it.
      iecrit(1) = ik0
      iecrit(2) = ik0 + 5
      iecrit(3) = ik0 + 10
      iecrit(4) = ik0 + 15
      iecrit(5) = ik0 + 20
      iecrit(6) = ik0 + 30
      iecrit(7) = ik0 + 34
      iecrit(8) = ik0 + 38
      iecrit(9) = ik0 + 40

c     make sure that we have enough energy grid points to use all
c     9 iecrits
      nncrit = 0
      do 290  ie = 1, necrit
         if (iecrit(ie) .gt. ne)  goto 295
         nncrit = ie
  290 continue
  295 continue
      if (nncrit .eq. 0) call par_stop('bad nncrit in prcrit')
            

      do 320  icrit = 1, nncrit
         ie = iecrit(icrit)
         ckspc(icrit) = cksp(ie)
         xlamc(icrit) = xlam(ie)
         do 310  ibeta = -nbeta, nbeta
            do 300  iii = 0, npot
               fbetac(ibeta,iii,icrit) = fbeta(ibeta,iii,ie)
  300       continue
  310    continue
  320 continue

      return
      end

      subroutine wphase (nph, em, eref, lmax, ne, ph)

c     Writes phase data to file PHASExx.DAT for each shell

      implicit double precision (a-h, o-z)

      include 'dim.h'

      complex*16 eref(nex)
      complex*16 ph(nex,ltot+1,0:nphx)
      dimension em(nex)
      dimension lmax(0:nphx)
      character*30  fname

c     Dump phase data, eref and complex phase for each shell
      do 260  iph = 0, nph
c        prepare file for shell's phase data
         write(fname,242)  iph
  242    format('phase', i2.2, '.dat')
         open (unit=1, file=fname, status='unknown', iostat=ios)
         call chopen (ios, fname, 'wphase')
         call wthead  (1)
c        write out unique pot and lmax
         write(1,244)   iph, lmax(iph), ne
  244    format (1x, 3i4, '   unique pot,  lmax, ne ')
c        for each energy
c        ie, em, eref, p=sqrt(em-eref)
c        ph array to ltot+1, 5 values per line
         do 250  ie = 1, ne
            xp = sqrt(em(ie) - eref(ie))
            write(1,246)  ie, em(ie), eref(ie), sqrt(em(ie)-eref(ie))
  246       format ('   ie        energy      re(eref)',
     1              '      im(eref)',
     2              '         re(p)         im(p)', /,
     3              1x, i4, 1p, 5e14.6)
            write(1,248)  (ph(ie,ll,iph), ll=1,lmax(iph)+1)
  248       format (1x, 1p, 4e14.6)
  250    continue
         close(unit=1)
  260 continue

      return
      end

c      subroutine vlda(ia, xnval,srho, srhovl,vtrho, ilast, idfock)
      subroutine vlda(xnval,srho, srhovl,vtrho, ilast, idfock)
c    this program calculates xc potential, using core-vlaence separation
c    discussed in ankuodinov's thesis.  
c    written by alexei ankoudinov. 11.07.96
      implicit double precision (a-h,o-z)
      include '../HEADERS/const.h'
      dimension xnval(30), srho (251), srhovl(251), vtrho(251)
      common cg(251,30), cp(251,30), bg(10,30), bp(10,30),
     1        fl(30), fix(30), ibgp
      common/comdir/cl,dz,dg(251),ag(10),dp(251),ap(10),dv(251),av(10),
     2              eg(251),ceg(10),ep(251),cep(10)
      common/itescf/testy,rap(2),teste,nz,norb,norbsc
      common/ratom1/xnel(30),en(30),scc(30),scw(30),sce(30),
     1nq(30),kap(30),nmax(30)
      common/tabtes/hx,dr(251),test1,test2,ndor,np,nes,method,idim
 
      do 10 i = 1, 251
        srho(i)   = zero
        srhovl(i) = zero
 10   continue 
c  find total and valence densities. Remove self-interaction if SIC
      do 50 j = 1, norb
         a = xnel(j)
         b = xnval(j)
c     use to test SIC
c       if (j .eq. ia) a=a-1.0d0
c       if (j .eq. ia) b=b-1.0d0
         do 50 i = 1, nmax(j)
            srho(i)   = srho(i)   + a * (cg(i,j)**2+cp(i,j)**2)
            srhovl(i) = srhovl(i) + b * (cg(i,j)**2+cp(i,j)**2)
 50   continue 

c  constract lda potential. Put your favorite model into vbh.f.
c  exch=5,6 correspond to 2 ways of core-valence separation of V_xc.
      rhoc = zero
      do 90 i = 1, 251
        rho = srho(i) / (dr(i)**2)
        if (idfock.eq.5) then
c          for exch=5 valence density*4*pi
           rhoc = srhovl(i) / (dr(i)**2)
        elseif (idfock.eq.6) then
c          for exch=6 core density*4*pi
           rhoc = (srho(i)-srhovl(i)) / (dr(i)**2)
        elseif (idfock.eq.1) then
           rhoc = zero
        elseif (idfock.eq.2) then
           rhoc = srho(i) / (dr(i)**2)
        else
            call par_stop(' undefined idfock in subroutine vlda')
        endif

        if (rho .gt. zero ) then
           rs = (rho/3)**(-third)
           rsc = 101.d0
           if (rhoc .gt.zero) rsc = (rhoc/3)**(-third)
           xm = one
c          vbh and edp in Hartrees
           if (idfock.eq.5 .or. idfock.eq.2) then
c             for exch=5, 2
              call vbh(rsc, xm, vxcvl)
           elseif (idfock.eq.6) then
c             for exch=6
              call vbh(rs, xm, vvbh)
                 xf = fa/rs
              call edp(rsc,xf,vdh)
              vxcvl = vvbh - vdh
           elseif (idfock.eq.1) then
c          for pure Dirac-Fock
              vxcvl = zero
           endif

c   contribution to the total energy from V_xc:=\int d^3 r V_xc * rho/2
           if (ilast.gt.0) vtrho (i) = vtrho(i) +
     1         vxcvl * srho(i)
c    1         vxcvl * xnel(ia)*(cg(i,ia)**2+cp(i,ia)**2)
c           use to test SIC

c  add to the total potential and correct it's development coefficients
           if (i.eq.1) av(2) = av(2) +vxcvl/cl
           dv(i) = dv(i) +vxcvl/cl
        endif
 90   continue

      return
      end

      subroutine fprime( ei, emxs ,ne1, ne3, ne, ik0, xsec, xsnorm,chia,
     1                  vrcorr, vicorr, cchi)
c     calculate f' including solid state and lifetime effects.
c     using algorithm in Ankudinov, Rehr danes paper.
c     the output correction is returned via cchi. The rest is input
c      mu(omega) = xsec + xsnorm*chia  + (cchi)

      implicit double precision (a-h, o-z)
      include '../HEADERS/const.h'
      include '../HEADERS/dim.h'

      dimension  xsnorm(nex), omega(nex)
      complex*16 emxs(nex), xsec(nex), chia(nex), cchi(nex) 
      complex*16 xmu(nex), aa, bb, temp
c      complex*16 c1, ec, x1, x2
      complex*16 xmup(nex)
      dimension emp(nex)
      parameter (eps4 = 1.0d-4)
      complex*16 lorenz, funlog, value
      external lorenz, funlog
      dimension dout(7,nex)
c      character*72 string
c      dimension oscstr(14),enosc(14)
      integer ient
      data ient /0/

c$$$c     read data from fpf0.dat
c$$$      open (unit=16, file='fpf0.dat', status='old', iostat=ios)
c$$$      read  (16,*)  string
c$$$      read  (16,*)  eatom
c$$$      read  (16,*)  nosc
c$$$      do 5 i=1, nosc
c$$$        read (16,*) oscstr(i), enosc(i)
c$$$   5  continue
c$$$c     the rest is f0(Q) and is not currently needed
c$$$      close (unit=16)
c$$$      call json_read_fpf0(nosc, oscstr, enosc)

      ient = ient+1
      ifp = 1
      efermi = dble(emxs(ne1+1)) 
      xloss = dimag(emxs(1))
      ne2 = ne-ne1-ne3
      if (ne2.gt.0) then
c        DANES
         do 10 ie = 1,ne1
   10    xmu(ie) = coni*xsnorm(ie) +  xsnorm(ie)*chia(ie)
         do 11 ie = ne1+1,ne1+ne2
   11    xmu (ie) = xsnorm(ie)*chia(ie)
         do 12 ie = ne-ne3+1, ne
   12    xmu (ie) =  coni*xsnorm(ie)
      else
c        FPRIME
         do 13 ie = 1,ne
   13    xmu (ie) = xsec(ie) + xsnorm(ie)*chia(ie)
      endif

      if (abs(vrcorr).gt.eps4) then
         bb = xmu(ik0)
         efermi = efermi - vrcorr
         do 20 ie = 1,ne1
   20    omega(ie) = dble(emxs(ie))
         call terpc(omega, xmu ,ne1, 1, efermi, bb)
         do 30 ie = 1, ne2
   30    emxs(ne1+ie) = emxs(ne1+ie) - vrcorr
         if (abs(xmu(ik0)).gt. eps4) bb = bb/xmu(ik0)
c        rescale values on vertical axis
         do 60 ie = ne1+1, ne-ne3
   60    xmu(ie) = xmu (ie) * bb 
      endif
              

      if (vicorr.gt.eps4) then
         xloss = xloss + vicorr
         do 40 ie=1,ne2
   40    omega(ie) = dimag(emxs(ne1+ie))
         call terpc(omega, xmu(ne1+1) ,ne2, 1, xloss, aa)
         do 50 ie = 1, ne1
            xx = vicorr**2 /(vicorr**2 + (dble(emxs(ie))-efermi)**2)
            xmu(ie) = xmu(ie)*(1.0d0 - xx) + aa * xx
            emxs(ie) = emxs(ie) + coni*vicorr
   50    continue
      endif

      do 200 ie = 1, ne1
c        cycle over energy points on horizontal grid

         dout(1,ie) = dble(emxs(ie)) * hart
         dele = dble(emxs(ie)) - efermi
c        delp correspond to pole with negative frequency
c        see Sakurai for details

         delp = -dele - 2*ei
c        delp = dele
c        dele = delp

         cchi(ie) = 0
         if (ne2.gt.0) then
            if (abs(dele).lt.eps4) dele = 0.0d0
            w1 = dimag(emxs(ne1+1))
            w2 = dimag(emxs(ne1+2))
            w3 = dimag(emxs(ne1+3))

c           matsubara pole
            temp = lorenz(xloss,w1,dele)*xmu(ne1+1)*2*coni*w1
            temp = temp + lorenz(xloss,w1,delp)*xmu(ne1+1)*2*coni*w1
            dout(2,ie)=dble(temp)
c           sommerfeld correction
            temp = coni*w1**2/ 6*(lorenz(xloss,w3,dele)*xmu(ne1+3)-
     2      lorenz(xloss,w2,dele)*xmu(ne1+2)) / (w3-w2) 
            dout(3,ie)=dble(temp)

            cchi(ie) = lorenz(xloss,w1,dele)*xmu(ne1+1) *2*coni*w1
     1      + coni * w1**2 / 6 * (lorenz(xloss,w3,dele)*xmu(ne1+3)-
     2      lorenz(xloss,w2,dele)*xmu(ne1+2)) / (w3-w2) 
c           from negative pole has additional minus sign
            cchi(ie) = cchi(ie) + 
     1      lorenz(xloss,w1,delp)*xmu(ne1+1) *2*coni*w1
     1      + coni * w1**2 / 6 * (lorenz(xloss,w3,delp)*xmu(ne1+3)-
     2      lorenz(xloss,w2,delp)*xmu(ne1+2)) / (w3-w2) 

c           theta funcion contribution only for positive pole
            if (dele .lt. eps4)    cchi(ie) = cchi(ie) - xmu(ie)
            if (abs(dele).lt.eps4) cchi(ie) = cchi(ie) + xmu(ie)/2

c           anomalous contribution
            temp = 0
            wp = 2*ei
            if (dele.ge.eps4) temp = xmu(ie)
            if (abs(dele).lt.eps4) temp = xmu(ie)/2
            temp = temp + xmu(ik0)*  funlog(1,xloss,wp,dele)
c               xmu(iko) + xsec(ik0)  if n3 >0
            dout(4,ie)=dble(temp) 

c           integration over vertical axis to final point
            n1 = ne1+2
            n2 = ne-ne3
            call fpint (emxs, xmu, n1, n2, dele, xloss, eps4, efermi,
     1                  value)
            cchi(ie) = cchi(ie) + value
c           add contribution from other pole
            call fpint (emxs, xmu, n1, n2, delp, xloss, eps4, efermi,
     1                  value)
            cchi(ie) = cchi(ie) + value
         endif 

c        integration over horizontal axis to final point
         temp = 0
         if (ne2.gt.0) then
c           DANES
            n1 = ne1-ik0 + 1
            do 120 i = ik0, ne1
              emp(i-ik0+1) = dble(emxs(i))
              xmup(i-ik0+1) = coni*xsnorm(i)
  120       continue
            do 130 i = 1, ne3
              emp(i+n1) = dble(emxs(i+ne-ne3))
              xmup(i+n1) = xmu(i+ne-ne3)
  130       continue
            n2 = n1 + ne3
         else
c           FPRIME
            n1 = 0
            do 140 i = 1, ne1
              if (n1.eq.0 .and. dble(emxs(i)).gt. dble(emxs(ne1+1))) 
     1            n1 = i
  140       continue
            do 150 i = 1, ne3
               emp(i) =  dble(emxs(ne1+i))
               xmup(i) =  xmu(ne1+i)
  150       continue
            n2 = ne3
         endif
         call fpintp (emp, xmup , n2, dele, xloss, efermi, value)
         temp  = temp + value
c        add contribution from other pole
         call fpintp (emp, xmup , n2, delp, xloss, efermi, value)
         temp  = temp + value

c         was used before
cc          contribution to fp from poles of the core states
c           temp=0
c           do 110  i=2, nosc
cc             eif = E_f- E_i  in hartrees
cc             eif = enosc(i)-enosc(1) 
cc             deltaf = deltaf - oscstr(i)*2*alpinv**2/eif
c              temp = temp + alpinv**2 * oscstr(i)* (dele -
c    1      enosc(i)+efermi-1)/ ((dele-enosc(i)+efermi-1)**2+xloss**2)
c              temp = temp + alpinv**2 * oscstr(i)* (delp -
c    1      enosc(i)+efermi-1)/ ((delp-enosc(i)+efermi-1)**2+xloss**2)
c 110       continue

         dout(5,ie) = dble(temp)
         cchi(ie) = cchi(ie) + temp

c        total contribution (not normalized)
         temp = xmu(ie) + cchi(ie)
         dout(6,ie) = dble(temp)
c        (integral w2 to wmax) minus (cusp formula)
         dout (7,ie) = dout(6,ie)-dout(4,ie)
  200 continue

c     restore the input energy mesh
      if (vicorr.gt.eps4) then
         do 250 ie = 1, ne1
  250    emxs(ie) = emxs(ie) - coni*vicorr
      endif
      if (abs(vrcorr).gt.eps4) then
         do 260 ie = 1, ne2
  260    emxs(ne1+ie) = emxs(ne1+ie) + vrcorr
      endif

c     if (ient.eq.1) then
      open(unit=3,file='danes.dat', status='unknown', iostat=ios)
      write(3,310) '# E  matsub. sommerf. anomal. tale, total, differ.'
  310 format (a)
      do 300 ie = 1, ne1
         write(3,320) (dout(i,ie), i=1,7)
  320    format ( 7(1x,1pe11.4))
  300 continue
      close(unit=3)
c     endif

      return
      end

      complex*16 function funlog (icase, xloss, w, dele)
c     anomalous fp should have all main features of total fp
c     except smooth difference 
c     analytic expression for anomalous fp (without integral)
c     is obtained by adding and subtracting G(Ef + i*Gamma) / E-w
c     and performing integral for Im axis analytically
c     icase = 1 simplified expression (compared to 2) 
c     icase=2  use real w 
c     icase=3  pure imaginary w (absolute value is input)
      implicit double precision (a-h, o-z)
      include '../HEADERS/const.h'
      parameter (eps4 = 1.0d-4)
      funlog = (0.d0,0.d0)

      if (icase.eq.1) then 
         if (abs(dele).ge.eps4) then 
            funlog= coni/2/pi*
     1      (log((-xloss+coni*dele)/w)+ log((xloss+coni*dele)/w))

         else
            funlog= coni/pi*log(abs(xloss/w))
         endif

      elseif (icase.eq.2) then
        if (abs(dele).ge.eps4) then
          funlog= coni/2/pi* (w+coni*xloss) * (
     1    ( log((-xloss+coni*dele)/w)) / (w+dele+coni*xloss) +
     2    ( log(( xloss+coni*dele)/w)) / (w+dele-coni*xloss))
        else
          funlog= coni/pi*(log(abs(xloss/w)))*
     1    (1 + coni*xloss/(w-coni*xloss))
        endif

      elseif (icase.eq.3) then
        if (abs(dele).ge.eps4) then
          funlog= -(w+xloss)/2/pi* (
     1    log((-xloss+coni*dele)/w) / (dele+coni*(w+xloss)) +
     2    log(( xloss+coni*dele)/w) / (dele+coni*(w-xloss)) )
        else
          funlog= coni/pi* log(abs(xloss/w))*
     1    (1 + xloss/(w-xloss))
        endif
      
      endif

      return
      end

      subroutine fpint (emxs, xmu, n1, n2, dele, xloss, eps4, efermi,
     1                  value)
c     performs integral for fp calculations between points n1 and n2.
      implicit double precision (a-h, o-z)
      include '../HEADERS/const.h'
      include '../HEADERS/dim.h'

      complex*16 emxs(nex), xmu(nex), value
      complex*16  z1, z2, aa, bb, c1

c     last interval - similar to Matsubara pole ( shift and - sign)
c     notice that this also works for horizontal axis if last value
c     is small
      z1 = emxs(n2)-efermi
      z2 = emxs(n2-1)-efermi
      value =  - coni/pi * (z1-dele) / (xloss**2+(z1-dele)**2)
     1          *xmu(n2) * (2 * (z1-z2))
c     all other intervals
      do  300 i = n1, n2-2
         z1 = emxs(i) - efermi
         z2 = emxs(i+1) - efermi
         bb=(xmu(i+1)*(z2-dele) - xmu(i)*(z1-dele)) / xloss / (z2-z1)
         aa = xmu(i)*(z1-dele)/xloss - bb * z1
         c1 = (aa+bb*(dele+coni*xloss )) / 2 /coni
         if (abs(dele-dble(z1)).lt.eps4 .and.
     1       abs(dele-dble(z2)).lt.eps4) then
            value = value  -  coni/pi *c1*
     1      log( abs((z2-dele-coni*xloss)/(z1-dele-coni*xloss)) )
         else
            value    = value   -  coni/pi *c1*
     1      log((z2-dele-coni*xloss)/(z1-dele-coni*xloss))
         endif
         c1 = -(aa+bb*(dele-coni*xloss )) / 2 /coni
         value    = value    -  coni/pi *c1*
     1   log((z2-dele+coni*xloss)/(z1-dele+coni*xloss))
  300  continue

      return
      end

      subroutine fpintp (em, xmu, n2, dele, xloss, efermi, value)
c     performs integral for fp calculations between points 1 and n2.
c     and adds tail to infinity
      implicit double precision (a-h, o-z)
      include '../HEADERS/const.h'
      include '../HEADERS/dim.h'

      dimension em(nex)
      complex*16 xmu(nex), value
      complex*16  z1, z2, aa, bb, cc

      value = 0
c     all intervals 
      do  300 i = 1, n2-1
         x1 = em(i) - efermi
         x2 = em(i+1) - efermi
         de = (x2-x1)/2
         x0 = (em(i) + em(i+1)) / 2
         call terpc(em, xmu, n2, 3, x0, aa)
         bb=(xmu(i+1) - xmu(i)) / (x2-x1)
         cc = (xmu(i+1) - aa - bb * de) / de**2
         z1 =  dele - x0 + efermi - coni*xloss
         z2 =  dele - x0 + efermi + coni*xloss
         value    = value  + 2*de*bb + 2*z1*de*cc +
     1    log((de-z1)/(-de-z1)) * (aa+bb*z1+cc*z1**2)
         value    = value  + 2*de*bb + 2*z2*de*cc +
     1    log((de-z2)/(-de-z2)) * (aa+bb*z2+cc*z2**2)
  300 continue

c     tail of xmu to infinity approximated by aa/(w-bb)**2
      x1 = em(n2-1)
      x2 = em(n2)
      a = sqrt ( dble(xmu(n2-1)/xmu(n2)) )
      b = ( a*x1 - x2) / (a-1)
      if (b.gt. x1) b = 0
      aa = xmu(n2) * (x2-b)**2
      z1 = dele -coni*xloss - b
      z2 = dele +coni*xloss - b
      x0 = x2 - b
      value = value + log( x0/(x0-z1) ) *aa/z1**2 - aa/z1/x0
      value = value + log( x0/(x0-z2) ) *aa/z2**2 - aa/z2/x0

c     multiply by constant factor
      value = - coni /2 /pi *value

      return
      end

      subroutine setgam (iz, ihole, gamach)

c     Sets gamach, core hole lifetime.  Data comes from graphs in
c     K. Rahkonen and K. Krause,
c     Atomic Data and Nuclear Data Tables, Vol 14, Number 2, 1974.

      implicit double precision (a-h, o-z)

      dimension gamk(6), zk(6)
      dimension gaml1(6), zl1(6)
      dimension gaml2(6), zl2(6)
      parameter (ryd  = 13.6058)

      save ienter

c     Note that 0.99 replaces 1.0, 95.1 replaces 95.0 to avoid roundoff
c     trouble.
c     Gam arrays contain the gamma values.
c     We will take log10 of the gamma values so we can do linear
c     interpolation from a log plot.

      data  zk   / 0.99,  10.0, 20.0,  40.0,  60.0,   95.1/
      data  gamk / 0.07,   0.3,  0.75,  5.0,  20.0,  100.0/

      data  zl1   / 0.99,  20.0, 35.0, 50.0,  75.0,  95.1/
      data  gaml1 / 0.07,   4.0,  7.0,  4.0,   8.0,  19.0/

      data  zl2   / 0.99,  26.0, 31.0, 60.0,  80.0,  95.1/
      data  gaml2 / 0.001,  1.7,  0.8,  3.5,   5.0,  10.0/

      data ienter /0/

c     Call this only once, if it gets called a second time the gamma
c     values will be messed up by repeated taking of log10

      if (ienter .gt. 0)  then
         call fstop(' at SETGAM-1: re-entered SETGAM')
      endif
      ienter = 1

      if (ihole .le. 0)  then
         call echo(' setgam: no hole, setting gamach=0')
         return
      endif
      if (ihole .gt. 4)  then
         call echo(' Feff6L only does K and L shells')
         call fstop(' at SETGAM-2')
      endif

      zz = iz
      if (ihole .le. 1)  then
         do 10  i = 1, 6
            gamk(i) = log10 (gamk(i))
   10    continue
         call terp (zk, gamk, 6, zz, gamach)
      else if (ihole .le. 2)  then
         do 20  i = 1, 6
            gaml1(i) = log10 (gaml1(i))
   20    continue
         call terp (zl1, gaml1, 6, zz, gamach)
      else if (ihole .le. 4)  then
c        note that LII and LIII have almost exactly the same
c        core hole lifetimes
         do 30  i = 1, 6
            gaml2(i) = log10 (gaml2(i))
   30    continue
         call terp (zl2, gaml2, 6, zz, gamach)
      endif

c     Change from log10 (gamma) to gamma
      gamach = 10.0 ** gamach

c     Table values are in eV, code requires atomic units
      gamach = gamach / ryd

      return
      end

!=======================================================================
!     EELS
!=======================================================================

module eels_inp
  !		Beam direction in crystal frame of feff.inp (a.u.)
  use global_inp,only: xivec
  implicit none
  character(*),parameter,private :: filename='eels.inp'
  !		Beam energy in eV :
  real*8 ebeam
  !		Convergence semiangle in rad :
  real*8 aconv
  !		Collection semiangle in rad :
  real*8 acoll
  !		Integration mesh for q-vectors (radial/angular mesh size)
  integer nqr,nqf
  !		Detector position ; angles in rad w.r.t. x and y directions
  real*8 thetax,thetay
  !       what kind of q-mesh : uniform (U), logarithmic (L), or one dimensional logarithmic (1)
  !       not currently in eels.inp/feff.inp
  character*1      qmodus
  !		Parameter for logarithmic mesh - not currently in eels.inp/feff.inp
  real*8 th0
  !		Make magic angle plot if magic=1
  integer        magic
  !		Evaluate magic angle at this energy point
  real*8        emagic
  !		Orientation sensitive?
  integer        aver
  !		Do we have cross-terms?
  integer        cross
  !		Do we do anything at all?
  integer        eels
  !		How many spectra to combine
  integer ipmin,ipmax,ipstep ,nip
  !		Where do we take input from :
  integer iinput           
  !		Which column? - to be replaced by more advanced switch
  integer spcol
  !       Relativistic calculation or not?  Converted into logical inside eels-module.
  integer relat

contains

  subroutine eels_write
    open (file=filename, unit=3, status='unknown')
    write(3,10) 'calculate ELNES?'
    write(3,20) eels
    write(3,10) 'average? relativistic? cross-terms? Which input?'
    write(3,20) aver, relat, cross, iinput, spcol
    write(3,10) 'polarizations to be used ; min step max'
    write(3,20) ipmin,ipstep,ipmax
    write(3,10) 'beam energy in eV'
    write(3,30) ebeam
    write(3,10) 'beam direction in arbitrary units'
    write(3,30) xivec
    write(3,10) 'collection and convergence semiangle in rad'
    write(3,30) acoll,aconv
    write(3,10) 'qmesh - radial and angular grid size'
    write(3,20) nqr,nqf
    write(3,10) 'detector positions - two angles in rad'
    write(3,30) thetax,thetay
    write(3,10) 'calculate magic angle if magic=1'
    write(3,20) magic
    write(3,10) 'energy for magic angle - eV above threshold'
    write(3,30) emagic
    close(3)
    ! standard formats for string, integers and real numbers
10  format(a)
20  format (20i4)
30  format (9f13.5)
  end subroutine eels_write

  subroutine eels_read
    open (file=filename, unit=3, status='old',err=100)
    read(3,*) ; read(3,*,end=100,err=100) eels
    read(3,*) ; read(3,*,err=209) aver, relat, cross, iinput,spcol ; goto 210
209 iinput=1;spcol=4;relat=1;cross=1;aver=0  !restore defaults - this construction for older files.
210 read(3,*) ; read(3,*) ipmin,ipstep,ipmax  !KJ this un-Kevin-like construction for older files ...
    nip=1+((ipmax-ipmin)/ipstep)
    read(3,*) ; read(3,*) ebeam
    read(3,*) ; read(3,*) xivec
    read(3,*) ; read(3,*) acoll,aconv
    read(3,*) ; read(3,*) nqr,nqf
    read(3,*) ; read(3,*) thetax,thetay
    read(3,*) ; read(3,*) magic
    read(3,*) ; read(3,*) emagic
    close(3)
    return
100 eels = 0  ; ipmin=1 ; ipmax=1 ; ipstep=1 ! no eels.inp -> don't do eels
    return
  end subroutine eels_read


  subroutine eels_init !default values for everything (except xivec)
    ebeam  = 0.d0
    aconv  = 0.d0
    acoll  = 0.d0
    nqr    = 0
    nqf    = 0
    magic  = 0
    emagic = 0.d0
    eels   = 0
    relat  = 1
    cross  = 1
    aver   = 0
    thetax = 0.d0
    thetay = 0.d0
    ipmin  = 1
    ipmax  = 1
    nip    = 1
    ipstep = 1
    iinput = 1  ! xmu.dat - files from ff2x
    spcol  = 4   ! xmu.dat - use spectrum mu(omega)
    qmodus = 'U'  !  U for uniform grid 
    th0    = 0.d0
  end subroutine eels_init

end module eels_inp

c     sub-program exchange
      program  ffmod4
c     subroutine ffmod4

c     makes paths list using cluster geometry and phase shifts
c     written by a.ankudinov 2000 using earlier subroutines
c     written by s.zabinsky
c     modified by a.ankudinov 2001 for new I/O structure

c     INPUT FILES
c       global.dat, geom.dat - global infomation file is read here 
c       mod4.inp - specific information for present module
c       phase.pad - output of XSPH module is read using subroutine 
c                  'rdxsph' inside subroutine 'prcrit'.
c                   needed  data: (list of variables)
c                  (ne, ne1, npot, ik0, em, eref2, potlbl, ph4)
c     OUTPUT FILE
c       paths.dat - list of filtered paths

      implicit double precision (a-h, o-z)

      include '../HEADERS/dim.h'
      include '../HEADERS/const.h'
      include '../HEADERS/parallel.h'

      
c      dimension lmaxph(0:nphx)
      dimension rat(3,natx), iphat(natx), ibounc(natx)
      double precision evec(3), xivec(3)
      character*6  potlbl(0:nphx)
        integer  mpath, ms, nncrit, nlegxx, ipr4
        real critpw, pcritk, pcrith,  rmax, rfms2

      integer eels !KJ added 5/06
      character*30 fname

c     Following passed to pathfinder, which is single precision.
c     Be careful to always declare these!
      parameter (necrit=9, nbeta=40)
      real fbetac(-nbeta:nbeta,0:nphx,necrit), ckspc(necrit)
      real fbeta(-nbeta:nbeta,0:nphx,nex), cksp(nex)
      real xlamc(necrit), xlam(nex)

      call par_begin
      if (worker) go to 400
      
c     open the log file, unit 11.  See subroutine wlog.
      open (unit=11, file='log4.dat', status='unknown', iostat=ios)
      call chopen (ios, 'log4.dat', 'feff')

c     INPUT: read geom.dat, global.dat, mod4.inp
      call repath (ms, mpath, ipr4,  pcritk, pcrith, nncrit, rmax,
     1             nlegxx, rfms2, critpw,
c                  geom.dat
     2             nat, rat, iphat, ibounc,
c                  global.dat
     3             ipol, ispin, evec, xivec)
c ,eels) !KJ added eels 5/06
      eels=0
       if (nspx.gt.1) ispin = abs(ispin)

      if (ms.eq.1  .and.  mpath.eq.1)  then
         call wlog(' Preparing plane wave scattering amplitudes...')
         call prcrit (ne, nncrit, ik0, cksp, fbeta, ckspc, 
     1                fbetac, potlbl, xlam, xlamc)

c        Dump out fbetac for central atom and first pot
         if (ipr4 .ge. 3 .and. ipr4.ne.5)  then
            do 260  iph = 0, 1
               do 250  ie = 1, nncrit
                  write(fname,200)  ie, iph
  200             format ('fbeta', i1, 'p', i1, '.dat')
                  open (unit=1, file=fname, status='unknown')
                  write(1,210)  iph, ie, ckspc(ie)
  210             format ('# iph, ie, ckspc(ie) ', 2i5, 1pe20.6, /
     1                    '#  angle(degrees), fbeta/|p|,  fbeta')
                  do 240  ibeta = -nbeta, nbeta
                     cosb = .025 * ibeta
                     if (cosb .gt.  1)  cosb =  1
                     if (cosb .lt. -1)  cosb = -1
                     angle = acos (cosb)
                     write(1,230)  angle*raddeg, 
     1                  fbetac(ibeta,iph,ie)/ckspc(ie),
     2                  fbetac(ibeta,iph,ie)
  230                format (f10.4, 1p, 2e15.6)
  240             continue
                  close (unit=1)
  250          continue
  260       continue
         endif

         call wlog(' Searching for paths...')
         call paths (ckspc, fbetac, xlamc, pcritk, pcrith, critpw,
     1               nncrit, rmax, nlegxx, rfms2,
     2               nat, rat, iphat, ibounc) 
         call wlog(' Eliminating path degeneracies...')
         call pathsd (ckspc, fbetac, xlamc, ne, ik0, cksp, 
     1                fbeta, xlam, critpw, ipr4, nncrit, potlbl,
     1            ipol, ispin, evec, xivec,eels) !KJ added eels 5/06
         call wlog(' Done with module 4: pathfinder.')
      endif
      close (unit=11)

  400 call par_barrier
      call par_end

c     sub-program exchange
      stop
c     return

      end

!=======================================================================
!     POTENTIAL
!=======================================================================

module potential_inp
  use dimsmod, only: nheadx, nphx, novrx
  use global_inp, only: ispec
  use atoms_inp, only : nph
  implicit none
  character(*),parameter,private :: filename='mod1.inp'

  character*80 title(nheadx)
  integer mpot, ntitle, ihole, ipr1, iafolp, iunf,             &
       nmix, nohole, jumprm, inters, nscmt, icoul, lfms1, ixc
  integer iz(0:nphx)
  !		iz(0:nphx)    - atomic number, input
  integer lmaxsc(0:nphx)
  real rfms1
  double precision gamach, rgrd, ca1, ecv, totvol
  double precision  xnatph(0:nphx), folp(0:nphx), spinph(0:nphx)
  !		xnatph(0:nphx) - given unique pot, how many atoms are there
  !                      of this type? (used for interstitial calc)
  !		folp(0:nphx) -  overlap factor for rmt calculation
  double precision  xion(0:nphx)
  !		xion(0:nphx)  - ionicity, input
  logical ExternalPot
  !     for OVERLAP option
  logical StartFromFile
  ! read potential from pot.bin file and start from there
  integer novr(0:nphx), iphovr(novrx,0:nphx), nnovr(novrx,0:nphx)
  double precision  rovr(novrx,0:nphx)
  !		novr(0:nphx) -  number of overlap shells for unique pot
  !		iphovr(novrx,0:nphx) -  unique pot for this overlap shell
  !		nnovr(novrx,0:nphx) -   number of atoms in overlap shell
  !		rovr(novrx,0:nphx)  -   r for overlap shell
  ! Added by Fer
  ! Used to correct the excitation energy for chemical shifts
  integer  ChSh_Type
  integer configtype !KJ 12-2010 : which method for choosing atomic configuration?
  double precision corval_emin  !KJ 12-2012 defines energy window for search for core-valence separation energy.

  !       criteria for self-consistency
  real*8,parameter :: tolmu = 1.D-3  ! Fermi level (Ha)
  real*8,parameter :: tolq = 1.D-3   ! net charge on atom iph (e)
  real*8,parameter :: tolqp = 2.D-4  ! partial charge (e.g. l=1) on atom iph (e)
  real*8,parameter :: tolsum = 0.05  ! total valence charge in Norman sphere compared to formal valence charge


contains

  subroutine potential_write
    integer ititle,ip,iph,iovr
    open (file=filename, unit=3, status='unknown')
    write(3,10) 'mpot, nph, ntitle, ihole, ipr1, iafolp, ixc,ispec'
    write(3,20) mpot, nph, ntitle, ihole, ipr1, iafolp, ixc, ispec
    write(3,10) 'nmix, nohole, jumprm, inters, nscmt, icoul, lfms1, iunf'
    write(3,20)  nmix, nohole, jumprm, inters, nscmt, icoul, lfms1, iunf
    do ititle = 1, ntitle
       write(3,10) title(ititle)
    enddo
    write(3,10) 'gamach, rgrd, ca1, ecv, totvol, rfms1, corval_emin'
    write(3,30)  gamach, rgrd, ca1, ecv, totvol, rfms1, corval_emin
    write(3,10) ' iz, lmaxsc, xnatph, xion, folp'
120 format ( 2i5, 4f13.5)
    do ip = 0, nph
       write(3,120) iz(ip), lmaxsc(ip), xnatph(ip), xion(ip), folp(ip)
    enddo
    write(3,10) 'ExternalPot switch, StartFromFile switch'
    write(3,*) ExternalPot,StartFromFile
    !       for OVERLAP option
    write(3,10) 'OVERLAP option: novr(iph)'
    write(3,20) ( novr(iph), iph=0,nph)
    write(3,10) ' iphovr  nnovr rovr '
140 format ( 2i5, f13.5)
    do iph = 0, nph
       do iovr = 1, novr(iph)
          write(3,140) iphovr(iovr, iph), nnovr(iovr,iph), rovr(iovr,iph)
       enddo
    enddo
    ! Added by Fer
    ! Correction of the excitation energy for chemical shifts
    write(3,10) 'ChSh_Type:'
    write(3,20) ChSh_Type
    write(3,10) 'ConfigType:'
    write(3,20) configtype
    close(3)
    ! standard formats for string, integers and real numbers
10  format(a)
20  format (20i4)
30  format (9f13.5)
  end subroutine potential_write

  subroutine potential_read
    ! integer ititle,ip,iph,iovr

    call json_read_pot(mpot, nph, ntitle, ihole, ipr1, iafolp, &
         ixc, ispec, nmix, nohole, jumprm, inters, nscmt, icoul, &
         lfms1, iunf, gamach, rgrd, ca1, ecv, totvol, rfms1, &
         title, iz, lmaxsc, xnatph, xion, folp, novr, &
         iphovr, nnovr, rovr )
    
    ! open (file=filename, unit=3, status='old')
    ! read(3,*) ; read(3,*) mpot, nph, ntitle, ihole, ipr1, iafolp, ixc, ispec
    ! read(3,*) ; read(3,*)  nmix, nohole, jumprm, inters, nscmt, icoul, lfms1, iunf
    ! do ititle = 1, ntitle
    !    read(3,*) title(ititle)
    ! enddo
    ! read(3,*) ; read(3,*)  gamach, rgrd, ca1, ecv, totvol, rfms1 !, corval_emin
    ! read(3,*)
    ! do ip = 0, nph
    !    read(3,*) iz(ip), lmaxsc(ip), xnatph(ip), xion(ip), folp(ip)
    ! enddo
    ! !read(3,*) ; read(3,*) ExternalPot, StartFromFile
    ! read(3,*) ; read(3,*) (novr(iph), iph=0,nph)
    ! read(3,*)
    ! do iph = 0, nph
    !    do iovr = 1, novr(iph)
    !       read(3,*) iphovr(iovr, iph), nnovr(iovr,iph), rovr(iovr,iph)
    !    enddo
    ! enddo
    ! !read(3,*) ; read(3,*) ChSh_Type
    ! !read(3,*,end=55) ; read(3,*,end=55) configtype
    ! ! 55  continue
    ! close(3)
  end subroutine potential_read

  subroutine potential_init
    title(:) = ' '
    mpot = 1
    nph = 0
    ntitle = 0
    ihole = 1
    ipr1 = 0
    iafolp = 0
    iunf = 0
    nmix = 1
    nohole = -1
    jumprm = 0
    inters = 0
    nscmt = 0
    icoul = 0
    ixc = 0
    lfms1 = 0
    iz(:) = -1
    lmaxsc(:) = 0
    rfms1 = -1 * 1.e0
    ca1 = 0.d0
    ecv = -40*1.d0
    rgrd = 0.05 * 1.d0
    totvol = 0.d0
    gamach = 0.d0 !initialized later by setgam
    xnatph(:) = 0.d0
    spinph(:) = 0.d0
    xion(:) = 0.d0
    folp(:) = 1.d0
    ExternalPot = .false.
    StartFromFile = .false. !KJ added 12-10
    novr(:) = 0
    iphovr(:,:)=0 !KJ added 7-09
    nnovr(:,:)=0 !KJ
    rovr(:,:) = 0.d0 !KJ
    ChSh_Type = 0 !Fer : standard feff
    configtype=1 !KJ 12-2010 standard feff9
    corval_emin=-70.d0 ! eV
  end subroutine potential_init

end module potential_inp

      subroutine frnrm (rho, iz, rnrm)
      implicit double precision (a-h, o-z)
      include '../HEADERS/dim.h'
      dimension rho(nrptx)
      dimension xpc(251), ri(251)
c#mn
      external rr
      x=0

c     finds norman radius

c     Need overlapped densities.  We'll get them in the form
c     4*pi*density = rho.  Also need z of atom

c     Then integrate out to the point where the integral of
c     4*pi*density*r**2 is equal to iz
      sum= (9*rho(1)*rr(1)**3+28*rho(2)*rr(2)**3+23*rho(3)*rr(3)**3)/480
c     add initial point (r=0) correction (see subroutine somm2)
      dpas = 0.05d0
      d1 = 3.0d0
      dd=exp(dpas)-1.0d0
      db=d1*(d1+1.0d0)*dd*exp((d1-1.0d0)*dpas)
      db=rr(1)/db
      dd=rr(1)*(1.0d0+1.0d0/(dd*(d1+1.0d0)))/d1
      sum = sum + dd*rho(1)*rr(1)**2 - db*rho(2)*rr(2)**2

      fl = rho(4) *rr(4)**3
      fr = rho(5) *rr(5)**3
      frr = rho(6) *rr(6)**3
      sum = sum + (25*fl + 12 *fr -frr)/480
      do 10  i = 7, nrptx
         fll = fl
         fl = fr
         fr = frr
         frr = rho(i) * rr(i)**3
         sumsav = sum
         sum = sum + (13*(fr+fl) -fll -frr)/480
         if (sum .ge. iz)  then
            inrm = i-2
            x= (iz-sumsav)/(sum-sumsav)
            goto 20
         endif
   10 continue
      call wlog(' FRNRM Could not integrate enough charge to reach' //
     1          ' required z.')
      call par_stop('FRNRM-1')
   20 continue
      rnrm = rr(inrm)*(1 + x*0.05d0)
     
c     add next order correction ALA 3/97
        dx05 = 0.05d0
        x0 = 8.8d0
        jnrm =  int((log(rnrm) + x0) / dx05)  +  2
        i0=jnrm+1
        xirf = 2
        do 710 ir = 1, jnrm+2
           ri(ir) = rr(ir)
           xpc(ir) = rho(ir)*ri(ir)**2
  710   continue

        call somm2 (ri, xpc, dx05, xirf, rnrm,0,i0)
c       dq is how many new electrons are within norman sphere
        dn1 = xirf-iz
        x2 = x - dn1/((1-x)*xpc(inrm) + x*xpc(inrm+1))
        if (abs(x2-x).gt.0.0001d0) then
          xirf = 2
          rnrm = rr(inrm)*(1 + x2*0.05d0)
          call somm2 (ri, xpc, dx05, xirf, rnrm,0,i0)
          dn2 = xirf-iz
c         Newton-Raphson methof to find zeroes
          x = x2 - dn2 * (x2-x)/(dn2-dn1)
        endif
        rnrm = rr(inrm)*(1 + x*0.05d0)

      return
      end

      function sdist (r0, r1)
c     find distance squared between cartesian points r0 and r1
c     single precision
      dimension r0(3), r1(3)
      sdist = 0
      do 10  i = 1, 3
         sdist = sdist + (r0(i) - r1(i))**2
   10 continue
      sdist = sqrt(sdist)
      return
      end

      subroutine mpprmp (npat, ipat, xp, yp, zp,
     1                   ipol, ispin, evec, xivec,ica)   !KJ added ica 5/06

c     make path parameters,  xp, yp,zp for each atom for a given
c     path. The allowed symmetry operations are restricted by
c     polarization type ipol (evec, xivec) and spin type (ispin)
c     of calculations
c      ipol=0 - polarization average 
c      ipol=1 - linear (admixture of 2 linear for elpty.ne.0)
c      ipol=2 - circular dichroism
c      ispin=0 - spin-independent system V_up=V_dn=V_av
c      |ispin|=1 - V_up .ne. V_dn, sum over up and down calculations
c      ispin= 2 - V_up portion of |ispin|=1 
c      ispin=-2 - V_dn portion of |ispin|=1 
c    all possible cases fall into 7 categories of allowed symmetries
c    Spin-independent calculations 
c     1) IF ipol=0 
c        any path rotation, reflection and reversal are allowed
c     2) ELSEIF ispin=0 ipol=1  xivec.eq.0 (dipole transitions only)
c        any rotation around evec, reflections in planes normal
c        and parallel to evec, path reversal
c     3) ELSEIF ispin=0 ipol=1   xivec.ne.0
c        reflections in 2 planes (xivec, evec) and (xivec, B field)
c        reflection in (evec, B field) probably does not conserve
c        E1-E2 cross term (currently used; check and fix later)
c     4) ELSEIF ispin=0 ipol=2  
c        rotations around xivec, path reversal (? -check for XNCD)
c    Spin systems (only ispin.ne.0, ipol.ne.0 below)
c     5) ELSEIF  xivec(1)=xivec(2)=0 .and. ( ipol.eq.2 .or. 
c                 ( ipol.eq.1 .and.xivec(3)=evec(1)=evec(2)=0 ) )
c        rotations around spin axis
c     6) ELSEIF ipol=1 xivec(1)=xivec(2)=evec(3)=0 (XMLD)
c        only 180 degrees rotation around spin axis
c     7) ELSE   ipol=1,2 .and. (xivec(1).ne.0 or xivec(2).ne.0 )
c        NO symmetry operations
c    Disclaimer: the symmetry rules for might be
c    too restrictive and were checked for ipol=2 calculations (case=5)
c    One can always check the symmetry rules by comparing with case=7.

c    To exploit above symmetry, every path is recorded in a new frame of
c    reference, constructed for the calculations specified.

c     Input is list of atoms (npat, ipat(npat)), output are
c     x,y,z coord. of path in standard frame of reference
c     (see comments in timrep.f or here below)

      include '../HEADERS/dim.h'
      double precision evec(3), xivec(3)
      double precision  ro2, norm, zvec, xvec, yvec, ri, xp1, yp1, zp1
      dimension ipat(npatx+1), zvec(3), xvec(3), yvec(3)

      common /atoms/ rat(3,0:natx), ipot(0:natx), i1b(0:natx)

      dimension xp(npatx), yp(npatx), zp(npatx)
      dimension xp1(npatx), yp1(npatx), zp1(npatx)
      dimension ri(3,npatx)
      logical lkvec, lkz, lez
      integer ica !KJ new input parameter. overrides icase if positive.

      parameter (eps4 = 1.0E-4)

c     the atoms in this path are passed via the ipat and rat arrays


      if (ica.gt.0.and.ica.lt.8) then !KJ added this and next 2 lines
!KJ Purpose : for eels calculations, we want a result for many k and q.
!KJ This means we cannot use the symmetry operations.
         icase=ica
      else
      
c        determine which case we are dealing with (see above comments)
c        default is icase =7 - no symmetry at all (safe for untested cases)
c        logical lkvec answers whether xivec is a vector
         lkvec = .false.
         if (xivec(1)**2+xivec(2)**2+xivec(3)**2.gt.eps4) lkvec = .true.
c        logical lkz answers whether xivec is a vector along z at most
         lkz = .true.
         if (xivec(1)**2+xivec(2)**2.gt.eps4) lkz = .false.
c        logical lez answers whether evec is a vector along z at most
         lez = .true.
         if (evec(1)**2+evec(2)**2.gt.eps4) lez = .false.

         icase = 7
         if (ipol.eq.0) then
           icase = 1
         elseif (ispin.eq.0) then
           if (ipol.eq.1 .and. (.not.lkvec)) icase = 2
           if (ipol.eq.1 .and. lkvec) icase = 3
           if (ipol.eq.2) icase=4
         else
           if (ipol.eq.2 .and. lkz) icase = 5
           if (ipol.eq.1 .and. .not.lkvec  .and. lez) icase = 5
           if (ipol.eq.1 .and. lkz .and. evec(3)**2.lt.eps4) icase = 6
         endif

 
       endif  !KJ my block. 5/06


c     initialize staff
      do 10 j = 1, npatx
         xp(j) = 0
         yp(j) = 0
         zp(j) = 0
         xp1(j) = 0
         yp1(j) = 0
         zp1(j) = 0
   10 continue
      nleg = npat + 1
      do 20  j = 1, npat
      do 20  i = 1, 3
         ri(i,j) = rat(i,ipat(j)) - rat(i,0)
   20 continue
      do 30  j = nleg, npatx
      do 30  i = 1, 3
         ri(i,j) = 0
   30 continue
      do 40 i =1, 3
         xvec(i) = 0
         yvec(i) = 0
         zvec(i) = 0
   40 continue

      if (icase.eq.1) then
c        z-axis along first leg
         norm = ri(1,1)*ri(1,1)+ri(2,1)*ri(2,1)+ri(3,1)*ri(3,1)
         norm = sqrt(norm)
         do 140 i = 1, 3
           zvec(i) = ri(i,1)/norm
  140    continue
      elseif (icase.eq.2 .or. icase.eq.3) then
c        z-axis in direction of polarization
         do 120 i = 1, 3
           zvec(i) = evec(i)
  120    continue
      else 
c        keep z-axis
         zvec(3) = 1.d0
      endif

      do 160 j = 1,npat
      do 160 i = 1, 3
        zp1(j) = zp1(j) + zvec(i)*ri(i,j)
  160 continue
c     if no symmetries, don't waste time
      if (icase.eq.7) then
         xvec(1) = 1.d0
         yvec(2) = 1.d0
         goto 390
      endif

      if (icase.eq.1 .or. icase.ge.4) goto 240
c     use z-->-z symmetry 
      num = 1
  200 continue
      if (abs(zp1(num)) .gt. eps4) then
         if (zp1(num) .lt. 0) then
c           inverse all z-coordinates and zvec, if 
c           first nonzero z-coordinate is negative 
            do 210 j = 1, 3
               zvec(j) = - zvec(j)
  210       continue
            do 220 j = 1, npat
               zp1(j) = - zp1(j)
  220       continue
         endif
         goto 240
      endif
      num = num +1
      if (num .lt. nleg) then
         goto 200
      endif
c     z--> -z symmetry has been used
  240 continue

c     use rotations around z and reflections containing z
      num = 1
  300 continue
      ro2 = 0
      do 310 i =1, 3
         ro2 = ro2 + ri(i,num)*ri(i,num)
  310 continue
c     looking for first atom which is not on z-axis
      ro2 = ro2 - zp1(num)*zp1(num)
      ro2 = sqrt(abs(ro2))
      if (ro2 .ge. eps4) then
c     if atom not on the z-axis then
         if (icase.eq.1.or.icase.eq.2.or.icase.eq.4.or.icase.eq.5) then
c           any rotation around z is allowed
c           choose x-axis so that x-coord. positive and y=0.
            do 320 i = 1, 3
               xvec(i) = ri(i,num) - zvec(i)*zp1(num)
  320       continue
            do 330 i = 1, 3
               xvec(i) = xvec(i)/ro2
  330       continue
         elseif (icase.eq.3) then
c           if elliptical polarization then
c           choose x-axis along incident beam
            do 350 i =1, 3
               xvec(i) = xivec(i)
  350       continue
         else
c           icase.eq.6 choose x-axis so that x-coord is positive
            xvec(1) = 1.d0
            if (ri(1,num).lt.0) xvec(1) = -1.d0
         endif
         yvec(1) = zvec(2)*xvec(3) - zvec(3)*xvec(2)
         yvec(2) = zvec(3)*xvec(1) - zvec(1)*xvec(3)
         yvec(3) = zvec(1)*xvec(2) - zvec(2)*xvec(1)
         goto 390
      endif
      num = num + 1
      if (num .lt. nleg) then
         goto 300
      endif

  390 continue

c     calculate x,y coord for each atom in chosen frame of reference
      do 400 j = 1, npat
      do 400 i =1,3
         xp1(j) = xp1(j) + xvec(i)*ri(i,j)
         yp1(j) = yp1(j) + yvec(i)*ri(i,j)
  400 continue

      if (icase.eq.3) then
c        check that first nonzero  x-coordinate is positive,
c        no need to check it in other cases.
         num = 1
  500    continue
         if (abs(xp1(num)) .ge. eps4) then
            if (xp1(num) .lt. 0) then
               do 510 j = 1, npat
                  xp1(j) = - xp1(j)
  510          continue
            endif
            goto 520
         endif
         num = num + 1
         if (num .lt. nleg) then
            goto 500
         endif
  520    continue
      endif

      if (icase.ge.4) goto 590
      num = 1
  570 continue
c     inverse all y-coordinates if first nonzero y-coord is negative
      if (abs(yp1(num)) .ge. eps4) then
         if (yp1(num) .lt. 0) then
            do 580 j = 1, npat
               yp1(j) = - yp1(j)
  580       continue
         endif
         goto 590
      endif
      num = num + 1
      if (num .lt. nleg) then
         goto 570
      endif
  590 continue

      do 595 j = 1, npat
        xp(j) = real(xp1(j))
        yp(j) = real(yp1(j))
        zp(j) = real(zp1(j))
  595 continue
c     now xp,yp,zp represent the path in standard order
      return
      end

       subroutine rdline(jinit, line)
c
c  return next "real" command line from input file(s)
c    -  allows use of "include file" or "load file" for reading
c       from other files, and manages the set of include files
c    -  checks for and ignores comment lines and blank lines.
c    -  opens and closes all input files, including initial file.
c
c   jinit  initialization/clean-up flag     [in]
c   line   next command line to parse   [in/out]
c
c notes:
c   1. to initialize, set jinit<0 and line= main_input_file_name.inp
c      if line=' ', routine will stop program.
c   2. returned line will be sent through triml and untab.
c   3. uses routine iscomm to test if line is a comment line.
c   4. special returned values:
c        'read_line_end'  = done reading all inputs
c        'read_line_error'= an error has occurred. the calling routine
c                        should probably stop
c   5. to clean up all open files, call with jinit=0
c
c matt newville march 1999
       implicit none
       integer mwords, ilen, i, jinit, mfil, nfil
       parameter (mwords=2, mfil=10)
       character*(*) line, stat*8
       character*90  files(mfil), errmsg, words(mwords)
       parameter (stat='old')
       integer   iunit(mfil), istrln, nwords, ierr, iexist
       logical   iscomm, open
       external  istrln, iscomm
       save      files, iunit, nfil
c
c jinit=-1: initialize
       if (jinit.eq.-1) then
          jinit  = 1
          do 10 i = 1, mfil
             iunit(i) = 0
             files(i) = ' '
 10       continue
          nfil     = 1
          files(1) = line
          call triml(files(1))
          call openfl(iunit(1), files(1), stat, iexist, ierr)
          if (iexist .lt. 0) go to 2600
          if (ierr   .lt. 0) go to 2800
c
c  jinit=0:  close all opened files (except unit 5!)
       elseif (jinit.eq.0) then
          jinit = 1
          do 25, i = 1, mfil
             if ((iunit(i).gt.0).and.(iunit(i).ne.5)) then 
                inquire(unit = iunit(i), opened=open)
                if (open) then
                   close(iunit(i))
                   iunit(i) = 0
                   files(i) = ' '
                endif 
             endif 
 25       continue 
          return
       end if
c  read next line from current input file
 100   continue
cc       print*, 'rdline 100: nfil , files(nfil), iunit = ',
cc     $      nfil,files(nfil)(:20), iunit(nfil)
       line   = ' '
       read(iunit(nfil),'(a)', err =1000, end = 500) line
c
c  check if command line is 'include filename'.
c  if so, open that file, and put it in the files stack
       call untab(line)
       call triml(line)
       if (iscomm(line)) go to 100
       nwords = mwords
       words(2) = ' '
       call bwords(line, nwords, words)
       call lower(words(1))
       if (((words(1) .eq. 'include').or.(words(1) .eq. 'load'))
     $      .and. (nwords .gt. 1)) then
          nfil = nfil + 1
          if (nfil .gt. mfil) go to 2000
          call getfln(words(2), files(nfil), ierr)
          if (ierr. ne. 0) go to 2400
c  test for recursion:
          do 400 i = 1, nfil - 1
             if (files(nfil) .eq. files(i)) go to 3000
 400      continue
          call openfl(iunit(nfil), files(nfil), stat, iexist, ierr)
          if (iexist .lt. 0) go to 2600
          if (ierr   .lt. 0) go to 2800
          go to 100
       end if
       return
c
c  end-of-file for command line file: drop nfil by 1,
c  return to get another command line
 500   continue
       inquire(unit = iunit(nfil), opened=open)
       if (open .and. (iunit(nfil) .ne. 5)) then
          close(iunit(nfil))
       end if
       iunit(nfil) = 0
       files(nfil) = ' '
       nfil = nfil - 1
       if (nfil.gt.0) go to 100
       line = 'read_line_end'
       return
c   error messages
 1000  continue
       call wlog(' # read error: general error')
       go to 4500
 2000  continue
       call wlog(' # read error: too many nested "include"s')
       write(errmsg, '(1x,a,i3)') ' # current limit is ', mfil
       ilen  = istrln(errmsg)
       call wlog(errmsg(1:ilen))
       go to 4500
 2400  continue
       call wlog(' # read error: cannot determine file name')
       go to 4500
 2600  continue
       call wlog(' # read error: cannot find file')
       go to 4500
 2800  continue
       call wlog(' # read error: cannot open file')
       go to 4500
 3000  continue
       call wlog(' # read error: recursive use of file')
       go to 4500
 4500  continue
       errmsg = ' # >> file name = '//files(nfil)(1:72)
       ilen   = istrln(errmsg)
       call wlog(errmsg(1:ilen) )
       line = 'read_line_error'
       return
c end subroutine read_line
       end
       subroutine getfln(strin, filnam, ierr)
c  strip off the matched delimeters from string, as if getting
c  a filename from "filename", etc.
       integer idel, iend, istrln, ierr
       character*(*) strin, filnam, tmp*144, ope*8, clo*8
       data ope, clo /'"{(<''[',  '"})>'']'/
c
       ierr  = 0
       tmp   = strin
       call triml(tmp)
       ilen  = istrln(tmp)
       idel  = index(ope,tmp(1:1))
       if (idel.ne.0) then
          iend = index(tmp(2:), clo(idel:idel) )
          if (iend.le.0) then
             ierr = -1
             iend = ilen 
          end if
          filnam = tmp(2:iend)
       else
          iend = index(tmp,' ') - 1
          if (iend.le.0) iend  = istrln(tmp) 
          filnam = tmp(1:iend)
       end if
       return
c end  subroutine getfln
       end
       subroutine openfl(iunit, file, status, iexist, ierr)
c  
c  open a file, 
c   if unit <= 0, the first unused unit number greater than 7 will 
c                be assigned.
c   if status = 'old', the existence of the file is checked.
c   if the file does not exist iexist is set to -1
c   if the file does exist, iexist = iunit.
c   if any errors are encountered, ierr is set to -1.
c
c   note: iunit, iexist, and ierr may be overwritten by this routine
       character*(*)  file, status, stat*10
       integer        iunit, iexist, ierr
       logical        exist

c make sure there is a unit number and file name
       ierr   = -3
       iexist =  -1
       if (file .eq. ' ') return
       iexist = 0
       iunit  = nxtunt(iunit)
c
c if status = 'old', check that the file name exists
       ierr = -2
       stat =  status                          
       call lower(stat)
       if (stat.eq.'old') then
          iexist = -1
          inquire(file=file, exist = exist)
          if (.not.exist) return
          iexist = iunit
       end if
c 
c open the file
       ierr = -1
       open(unit=iunit, file=file, status=status, err=100)
       ierr = 0
 100   continue
       return
c end  subroutine openfl
       end

      subroutine ovrlp (iph, iphat, rat, iatph, ifrph, novr,
     1                  iphovr, nnovr, rovr, iz, nat, rho, vcoul,
     2                  edens, vclap, rnrm)

c     Overlaps coulomb potentials and electron densities for current
c     unique potential
      implicit double precision (a-h, o-z)

      include 'const.h'
      include 'dim.h'

      dimension iphat(natx)
      dimension rat(3,natx)
      dimension iatph(0:nphx)
      dimension ifrph(0:nphx)
      dimension novr(0:nphx)
      dimension iphovr(novrx,0:nphx)
      dimension nnovr(novrx,0:nphx)
      dimension rovr(novrx,0:nphx)
      dimension iz(0:nfrx)
      dimension rho(251,0:nfrx)
      dimension vcoul(251,0:nfrx)
      dimension edens(nrptx,0:nphx)
      dimension vclap(nrptx,0:nphx)
      dimension rnrm(0:nphx)

c     find out which free atom we're dealing with
      ifr = ifrph(iph)

c     start with free atom values for current atom
      do 100  i = 1, 250
         vclap(i,iph) = vcoul(i,ifr)
         edens(i,iph) = rho  (i,ifr)
  100 continue

      if (novr(iph) .gt. 0)  then
         do 104  iovr = 1, novr(iph)
            rnn  = rovr(iovr,iph)
            ann  = nnovr(iovr,iph)
            infr = ifrph(iphovr(iovr,iph))
            call sumax (250, rnn, ann, vcoul(1,infr), vclap(1,iph))
            call sumax (250, rnn, ann, rho  (1,infr), edens(1,iph))
  104    continue
      else
c        Do overlapping from geometry with model atom iat
         iat = iatph(iph)

c        overlap with all atoms within r overlap max (rlapx)
c        12 au = 6.35 ang  This number pulled out of a hat...
         rlapx = 12
c        inat is Index of Neighboring ATom
         do 110  inat = 1, nat
c           don't overlap atom with itself
            if (inat .eq. iat)  goto 110

c           if neighbor is too far away, don't overlap it
            rnn = dist (rat(1,inat), rat(1,iat))
            if (rnn .gt. rlapx)  goto 110

            infr = ifrph(iphat(inat))
            call sumax (250, rnn, one, vcoul(1,infr), vclap(1,iph))
            call sumax (250, rnn, one, rho  (1,infr), edens(1,iph))
  110       continue
      endif

c     set norman radius
      call frnrm (edens(1,iph), iz(ifr), rnrm(iph))

      return
      end

      subroutine ortdac(ikap,ps,qs,aps,aqs)
c        * orthogonalization by the schmidt procedure*
c the ia orbital is orthogonalized toa all orbitals of the same
c symmetry if ia is positive, otherwise all orbitals of the same
c symmetry are orthogonalized
c        this program uses dsordc
 
      implicit double precision (a-h,o-z)
      include '../HEADERS/dim.h'
      complex*16 dsordc
      complex*16 ps(nrptx), qs(nrptx), aps(10),aqs(10)
      common/dff/ cg(nrptx,30), cp(nrptx,30), bg(10,30), bp(10,30),
     1             fl(30), fix(30), ibgp
      common/itescf/testy,rap(2),teste,nz,norb,norbsc
      common/ratom1/xnel(30),en(30),scc(30),scw(30),sce(30),
     1   nq(30),kap(30),nmax(30)
      common/tabtec/hx,dr(nrptx),test1,test2,ndor,np,nes,method,idim
      complex*16 a
 
      do 51 j=1,norb-1
         if (kap(j).ne.ikap .or. xnel(j).le.0) go to 51
         a = dsordc(j,fl(norb),ps,qs,aps,aqs)
         do 41 i=1,idim
            ps(i)=ps(i)-a*cg(i,j)
 41         qs(i)=qs(i)-a*cp(i,j)
         do 42 i=1,ndor
            aps(i)=aps(i)-a*bg(i,j)
 42         aqs(i)=aqs(i)-a*bp(i,j)
 51   continue
      return
      end

      subroutine fermi (rhoint, vint, xmu, rs, xf)

      implicit double precision (a-h, o-z)

      include '../HEADERS/const.h'

c     calculate fermi level of the system (mu) according to formula
c     mu=vcoulomb(interstitial)+vxc(interstitial)+kf(interstitial)^2
c     formula  2.13 in lee and beni, phys. rev. b15,2862(1977)

c     note that vint includes both coulomb and ground state
c     exchange-correlation potentials

c     den is the interstitial density
c     rs is the density parameter
c     xf is the interstital fermi momentum
c     xmu is the fermi level in hartrees

      den = rhoint / (4*pi)
      rs = (3 / (4*pi*den)) ** third
      xf = fa / rs
      xmu = vint + xf**2 / 2

      return
      end

      subroutine json_xsect(ntit, titles, s02x, erelax, wpx, edge,
     1                      emu, gamma, ne, ne1, ik0,
     2                      er, ei, xsn, col4, col5)

      use json_module

      implicit double precision (a-h, o-z)
      include '../HEADERS/vers.h'
      include '../HEADERS/dim.h'
      include '../HEADERS/parallel.h'
      include '../RDINP/allinp.h'

      character*80 titles(nheadx)
      double precision er(nex), ei(nex), xsn(nex)
      double precision col4(nex), col5(nex)

      integer  iunit
      type(json_value),pointer :: xsectj
      call json_value_create(xsectj)
      call to_object(xsectj,'xsect.json')

      call json_value_add(xsectj, 'vfeff',  vfeff)
      call json_value_add(xsectj, 'vf85e',  vf85e)

      call json_value_add(xsectj, 'ntitle', ntit)
      call json_value_add(xsectj, 'title',  titles(1:ntit))

      call json_value_add(xsectj, 's02',    s02x)
      call json_value_add(xsectj, 'erelax', erelax)
      call json_value_add(xsectj, 'wp',     wpx)
      call json_value_add(xsectj, 'edge',   edge)
      call json_value_add(xsectj, 'emu',    emu)

      call json_value_add(xsectj, 'gamach', gamma)
      call json_value_add(xsectj, 'ne',     ne)
      call json_value_add(xsectj, 'ne1',    ne1)
      call json_value_add(xsectj, 'ik0',    ik0)

      call json_value_add(xsectj, 'ereal',  er(1:ne))
      call json_value_add(xsectj, 'eimag',  ei(1:ne))
      call json_value_add(xsectj, 'xsnorm', xsn(1:ne))
      call json_value_add(xsectj, 'dum1',   col4(1:ne))
      call json_value_add(xsectj, 'dum2',   col5(1:ne))

      open(newunit=iunit, file='xsect.json', status='REPLACE')
      call json_print(xsectj,iunit)
      close(iunit)
      call json_destroy(xsectj)

      return
      end

      subroutine wlog (string)
      character*(*) string

c      include '../HEADERS/parallel.h'

c     This replaces wlog for use in libpotph


   10 format (a)

c     Suppress output in sequential loops
c      if (par_type .eq. 2) return

      il = istrln (string)
      if (il .eq. 0)  then
         print 10
c         if (par_type .ne. 3) write(11,10)
      else
         print 10, string(1:il)
c         if (par_type .ne. 3) write(11,10) string(1:il)
      endif
      return
      end

      program makepath
      implicit double precision (a-h, o-z)

c     taken from feff's HEADERS/dim.h
      integer nex
      parameter (nex = 150)
      integer npatx
      parameter (npatx = 8)
      integer legtot
      parameter (legtot=npatx+1)
      integer nphx
      parameter (nphx = 11)
c      parameter (pi = 3.14159 26535 89793 23846 26433d0)


c+---------------------------------------------------------------------
c     block of parameter declarations for onepath
      character*256 phpad
      character*8 cxc
      character*30 versn
      integer index, iorder, innnn, ixdi, ivrbse, ixc
      double precision evec(3), xivec(3)
      double precision elpty, rs, vint, xmu, edge, xkf, rnrmav, gamach

      double precision rat(3,0:legtot+1)
      integer ipot(0:legtot), iz(0:nphx)

      double precision ri(legtot), beta(legtot+1), eta(0:legtot+1)
      dimension col1(nex), col2(nex), col3(nex), col4(nex), col5(nex)
      dimension col6(nex), col7(nex)
c+---------------------------------------------------------------------

c     initialize everything
      call inipath(index, nleg, deg, iorder,
     &       cxc, rs, vint, xmu, edge, xkf, rnrmav, gamach,
     &       versn, ipot, rat, iz, ipol, evec, elpty, xivec,
     &       innnn, ixdi, ivrbse, ri, beta, eta,
     &       ne,col1,col2,col3,col4,col5,col6,col7)
      innnn  = 1
      ixdi   = 1
      ivrbse = 1
c      phpad  = 'phase_orig.pad'
      phpad  = 'phase.pad'

c+---------------------------------------------------------------------
c  compute a single path, generating the F matrix then returning the 
c  information contained in a feffNNNN.dat file
c
c  INPUT:
c    index:    path index                            integer
c    nleg:     number of legs in path                integer
c    deg:      path degeneracy                       double
c    iorder:   order of approximation in genfmt      integer
c    ipot:     array of unique potentials            integer(legtot)
c    rat:      cartesian coordinates of scatterers   double(3,0:legtot+1)
c    ipol:     flag to do polarization               integer
c    evec:     polarization vector                   double(3)
c    elpty:    ellipticity                           double
c    xivec:    direction of travel                   double(3)
c    innnn:    flag to write feffNNNN.dat file       integer
c    ixdi:     flag to write feffNNNN.xdi file       integer
c    ivrbse:   flag to write screen messages         integer
c
c    also requires a phase.pad file from an earlier run of xsph
c
c  OUTPUT
c
c    ri:       leg lengths                           double(legtot)
c    beta:     beta angles                           double(legtot+1)
c    eta:      eta angles                            double(legtot+2)
c    ne:       number of k-grid points               integer
c    col1:     k-grid                                double(nex)
c    col2:     central atom phase shifts             double(nex)
c    col3:     magnitude of F_eff                    double(nex)
c    col4:     phase of F_eff                        double(nex)
c    col5:     reduction factor                      double(nex)
c    col6:     mean free path                        double(nex)
c    col7:     real partof complex momentum          double(nex)
c+---------------------------------------------------------------------

c     compute first shell of Copper (SS, deg=12)
      index = 1
      nleg  = 2
      deg   = 12
      call addatom(1,  1.805, 0.,  1.805, 1, ipot, rat)

      call onepath(phpad, index, nleg, deg, iorder,
     &     cxc, rs, vint, xmu, edge, xkf, rnrmav, gamach,
     &     versn, ipot, rat, iz, ipol, evec, elpty, xivec,
     &     innnn, ixdi, ivrbse, ri, beta, eta,
     &     ne,col1,col2,col3,col4,col5,col6,col7)

c     this bit writes the data table from feff0001.dat to the screen
c         do 100 i=1,ne
c            write(*,400) col1(i), col2(i), col3(i), col4(i), col5(i),
c        &          col6(i), col7(i)
c    100  continue
c    400  format (1x, f6.3, 1x, 3(1pe11.4,1x),1pe10.3,1x,
c        1       2(1pe11.4,1x))


c     compute fourth shell of Copper (DS, deg=48)
      call inipath(index, nleg, deg, iorder,
     &       cxc, rs, vint, xmu, edge, xkf, rnrmav, gamach,
     &       versn, ipot, rat, iz, ipol, evec, elpty, xivec,
     &       innnn, ixdi, ivrbse, ri, beta, eta,
     &       ne,col1,col2,col3,col4,col5,col6,col7)
      innnn  = 1
      ixdi   = 1
      ivrbse = 1

      index = 4
      nleg  = 3
      deg   = 48
      call addatom(1,  0.,     0., -3.61,  1, ipot, rat)
      call addatom(2, -1.805,  0., -1.805, 1, ipot, rat)

      call onepath(phpad, index, nleg, deg, iorder,
     &       cxc, rs, vint, xmu, edge, xkf, rnrmav, gamach,
     &       versn, ipot, rat, iz, ipol, evec, elpty, xivec,
     &       innnn, ixdi, ivrbse, ri, beta, eta,
     &       ne,col1,col2,col3,col4,col5,col6,col7)

      end


      subroutine addatom(leg, x, y, z, ip, ipot, rat)
      implicit double precision (a-h, o-z)
      integer npatx, legtot
      parameter (npatx = 8, legtot=npatx+1)

      integer leg, ip
      real x, y, z
      double precision rat(3,0:legtot+1)
      integer ipot(0:legtot)
      double precision bohr
      parameter (bohr = 0.529 177 249d0)

      ipot(leg)  = ip
      rat(1,leg) = dble(x) / bohr
      rat(2,leg) = dble(y) / bohr
      rat(3,leg) = dble(z) / bohr
      return
      end


      subroutine inipath(index, nleg, deg, iorder,
     &       cxc, rs, vint, xmu, edge, xkf, rnrmav, gamach,
     &       versn, ipot, rat, iz, ipol, evec, elpty, xivec,
     &       innnn, ixdi, ivrbse, ri, beta, eta,
     &       ne,col1,col2,col3,col4,col5,col6,col7)
      implicit double precision (a-h, o-z)

c     taken from feff's HEADERS/dim.h
      integer nex, npatx, legtot, ixc
      parameter (nex = 150, npatx = 8, legtot=npatx+1, nphx=11)

      integer index, iorder, innnn, ivrbse
      double precision evec(3), xivec(3)
      double precision elpty,rs, vint, xmu, edge, xkf, rnrmav, gamach

      double precision rat(3,0:legtot+1)
      integer ipot(0:legtot), iz(0:nphx)

      double precision ri(legtot), beta(legtot+1), eta(0:legtot+1)
      dimension col1(nex), col2(nex), col3(nex), col4(nex), col5(nex)
      dimension col6(nex), col7(nex)
      character*256 phpad
      character*8 cxc
      character*30 versn

      index  = 9999
      nleg   = 0
      deg    = 1.
      iorder = 2
      innnn  = 0
      ixdi   = 0 
      ivrbse = 0
      ipol   = 0 
      elpty  = 0.
      ne     = 0

      versn  = ""
      cxc    = ""
      rs     = 0.
      vint   = 0.
      xmu    = 0.
      edge   = 0.
      xkf    = 0.
      rnrmav = 0.
      gamach = 0.
      
      do 5  i=1,3
         evec(i)  = 0
         xivec(i) = 0
 5    continue
      do 10 i=0, legtot
         rat(1,i) = 0
         rat(2,i) = 0
         rat(3,i) = 0
         ipot(i)  = 0
         eta(i)   = 0
         if (i>0) then
            ri(i)   = 0
            beta(i) = 0
            eta(i)  = 0
         endif
 10   continue
      beta(legtot+1) = 0
      eta(legtot+1)  = 0

      do 15 i=0,nphx
         iz(i) = 0
 15   continue

      do 20 i=1, nex
         col1(i) = 0
         col2(i) = 0
         col3(i) = 0
         col4(i) = 0
         col5(i) = 0
         col6(i) = 0
         col7(i) = 0
 20   continue

      return
      end

      subroutine reafms ( mfms, rfms2, idwopt, tk, thetad, sig2g,
     1            lmaxph, nat, iphat, rat,
     2            ipol, ispin, le2, angks, ptz,
     3            minv, rdirec, toler1, toler2,
     4            elnes,ipmin,ipmax,ipstep)   !KJ added this line 1-06     

      use json_module
      implicit double precision (a-h, o-z)
      logical :: found
      type(json_file) :: json   !the JSON structure read from the file:
      double precision toss
      integer,dimension(:),allocatable :: intgs

      include '../HEADERS/const.h'
      include '../HEADERS/dim.h'
      
      integer elnes,ipmin,ipmax,ipstep  !KJ added these variables 1-06

cc    geom.dat
        integer  nat, iatph(0:nphx), iphat(natx), ibounc(natx)
        double precision  rat(3,natx)
cc    global.dat 
c       configuration average
        integer nabs, iphabs
c       global polarization data
        integer  ipol, ispin, le2
        double precision evec(3), xivec(3), spvec(3), elpty,angks,rclabs
        complex*16 ptz(-1:1, -1:1)
cc    mod3.inp
        integer mfms, idwopt, minv
        integer lmaxph(0:nphx)
        real rfms2, rdirec, toler1, toler2
        double precision   tk, thetad, sig2g

c     Local stuff
c      character*512 slog
c      character*80 head(nheadx)
c      dimension lhead(nheadx)

c     standard formats for string, integers and real numbers
  10  format(a)
  20  format (20i4)
  30  format (6f13.5)

      call json_read_geom(nat, nph, iatph, rat, iphat, ibounc)

      call json_read_global(nabs, iphabs, rclabs, ipol, ispin, le2,
     1                      elpty, angks, evec, xivec, spvec, ptz)


c$$$c     Read  geom.dat file
c$$$      open (file='geom.dat', unit=3, status='old',iostat=ios)
c$$$c       read header from geom.dat
c$$$        nhead = nheadx
c$$$        call rdhead (3, nhead, head, lhead)
c$$$        nat = 0
c$$$        nph = 0
c$$$        do 40 iph = 0, nphx
c$$$  40    iatph(iph) = 0
c$$$  50    continue
c$$$           nat = nat+1
c$$$           if (nat .gt. natx)  then
c$$$              write(slog,55) ' nat, natx ', nat, natx
c$$$              call wlog(slog)
c$$$  55          format(a, 2i10)
c$$$              stop 'Bad input'
c$$$           endif
c$$$           read(3,*,end=60)  idum, (rat(j,nat),j=1,3), iphat(nat), i1b
c$$$           if (iphat(nat).gt.nph) nph = iphat(nat)
c$$$           if ( iatph(iphat(nat)).eq.0) iatph(iphat(nat)) = nat
c$$$        goto 50
c$$$  60    continue
c$$$        nat = nat-1
c$$$      close(3)
c$$$
c$$$cc    global.inp
c$$$      open (file='global.dat', unit=3, status='unknown',iostat=ios)
c$$$c       configuration average data
c$$$        read  (3, 10) slog
c$$$        read  (3, 65) nabs, iphabs, rclabs
c$$$  65    format ( 2i8, f13.5)
c$$$c       global polarization data
c$$$        read  (3,10)   slog
c$$$        read  (3, 70)  ipol, ispin, le2, elpty, angks
c$$$  70    format ( 3i5, 2f12.4)
c$$$        read  (3, 10) slog
c$$$        do 80 i = 1,3
c$$$          read  (3,30) evec(i), xivec(i), spvec(i)
c$$$  80    continue
c$$$        read  (3, 10) slog
c$$$        do 90 i = -1, 1
c$$$          read (3,30) a1, b1, a2, b2, a3, b3
c$$$          ptz(-1,i)= cmplx(a1,b1)
c$$$          ptz(0,i) = cmplx(a2,b2)
c$$$          ptz(1,i) = cmplx(a3,b3)
c$$$  90    continue
c$$$      close(3)
c$$$c     read mod3.inp
c$$$      open (file='mod3.inp', unit=3, status='old',iostat=ios)
c$$$        read (3,10)  slog
c$$$        read (3,20)  mfms, idwopt, minv
c$$$        read (3,10)  slog
c$$$        read (3,30)  rfms2, rdirec, toler1, toler2
c$$$        read (3,10)  slog
c$$$        read (3,30)  tk, thetad, sig2g
c$$$        read (3,10)  slog
c$$$        read (3,20)  (lmaxph(iph),iph=0,nph)
c$$$      close(3)

      call json%load_file('fms.json')
      if (json_failed()) then   !if there was an error reading the file
         print *, "failed to read fms.json"
         stop
      else
         call json%get('mfms',   mfms, found)
                   if (.not. found) call bailout('mfms',   'fms.json')
         call json%get('idwopt', idwopt, found)
                   if (.not. found) call bailout('idwopt', 'fms.json')
         call json%get('minv',   minv, found)
                   if (.not. found) call bailout('minv',   'fms.json')

         call json%get('rfms2',  toss, found)
                   if (.not. found) call bailout('rfms2',  'fms.json')
         rfms2  = real(toss)
         call json%get('rdirec', toss, found)
                   if (.not. found) call bailout('rdirec', 'fms.json')
         rdirec = real(toss)
         call json%get('toler1', toss, found)
                   if (.not. found) call bailout('toler1', 'fms.json')
         toler1 = real(toss)
         call json%get('toler2', toss, found)
                   if (.not. found) call bailout('toler2', 'fms.json')
         toler2 = real(toss)

         call json%get('tk',     tk, found)
                   if (.not. found) call bailout('tk',     'fms.json')
         call json%get('thetad', thetad, found)
                   if (.not. found) call bailout('thetad', 'fms.json')
         call json%get('sig2g',  sig2g, found)
                   if (.not. found) call bailout('sig2g',  'fms.json')

         call json%get('lmaxph', intgs, found)
                   if (.not. found) call bailout('lmaxph', 'fms.json')
         do 1000 iph = 0, nphx
            lmaxph(iph) = intgs(iph+1)            
 1000    continue

         call json%destroy()
      end if


      
c$$$c  !KJ Next section added to read ELNES variables 1-06     
c$$$c     read eels.inp
c$$$      elnes=0
c$$$      open(file='eels.inp',unit=3,status='old',err=900)
c$$$        read(3,*,err=900,end=900) 
c$$$        read(3,20,err=900,end=900) elnes
c$$$        read(3,*,err=900,end=900)
c$$$        read(3,*,err=900,end=900)
c$$$        read(3,*,err=900,end=900)
c$$$        read(3,20,err=900,end=900) ipmin,ipstep,ipmax
c$$$      close(3)
c$$$      goto 901
c$$$900   continue
c$$$      elnes=0
c$$$901   continue
c$$$      if(elnes.eq.0) then
c$$$        ipstep=1
c$$$        ipmax=1
c$$$        ipmin=1
c$$$      endif
c$$$               
c$$$c  !KJ end my changes

c     transform to code units (bohrs and hartrees - atomic units)
      rfms2 = rfms2 / real(bohr)
      rdirec = rdirec / real(bohr)
      do 210 iat = 1, nat
      do 210 i = 1,3
        rat(i,iat) = rat (i, iat) / bohr
 210  continue

      return
      end

      subroutine messer
c  prints error message on the output device
      implicit double precision (a-h,o-z)
      common/messag/dlabpr,numerr
      character*8 dlabpr
      character*512 slog
 
      ilig=numerr/1000
      ier=numerr-1000*ilig
      write(slog,'(a,i6,a,i6,a,a8)')  'error number ',ier,
     1 ' detected on a line ',ilig,'in the program',dlabpr
      call wlog(slog)
      return
      end

      subroutine bkmrdf (i,j,k)
c     angular coefficients for the breit term. i and j are the numbers
c     of orbitals and  k is the value of k in uk(1,2)
c        this programm uses cwig3j
c     coefficients for magnetic interaction  are in cmag
c     and those for retarded term are in cret
c     the order correspond to -1 0 and +1
 
      implicit double precision (a-h,o-z)
      common/ratom1/xnel(30),en(30),scc(30),scw(30),sce(30),
     1nq(30),kap(30),nmax(30)
      common/tabre/cmag(3),cret(3)
c#mn
       external cwig3j
 
      do 12 l=1,3
        cmag(l)=0.0d 00
 12     cret(l)=0.0d 00
      ji=2* abs(kap(i))-1
      jj=2* abs(kap(j))-1
      kam=kap(j)-kap(i)
      l=k-1
      do 51 m=1,3
         if (l.lt.0) go to 51
         a=cwig3j(ji,jj,l+l,-1,1,2)**2
         if (a.eq.0.0d 00) go to 51
         c=l+l+1
         if (m-2) 14,16,17
 14      cm=(kam+k)**2
         cz=kam*kam-k*k
         cp=(k-kam)**2
         n=k
 15      l1=l+1
         am=(kam-l)*(kam+l1)/c
         az=(kam*kam+l*l1)/c
         ap=(l+kam)*(kam-l1)/c
         d=n*(k+k+1)
         go to 31

 16      d=k*(k+1)
         cm=(kap(i)+kap(j))**2
         cz=cm
         cp=cm
         go to 41

 17      cm=(kam-l)**2
         cz=kam*kam-l*l
         cp=(kam+l)**2
         n=l
         c=-c
         go to 15

 31      c= abs(c)*d
         if (c.ne.0.0d 00) c=n/c
         cret(1)=cret(1)+a*(am-c*cm)
         cret(2)=cret(2)+(a+a)*(az-c*cz)
         cret(3)=cret(3)+a*(ap-c*cp)
 41      if (d.eq.0.0d 00) go to 51
         a=a/d
         cmag(1)=cmag(1)+cm*a
         cmag(2)=cmag(2)+cz*(a+a)
         cmag(3)=cmag(3)+cp*a
 51      l=l+1
      return
      end

#!/bin/sh

files='/usr/local/share/larch/dlls/linux32/_feffpathwrapper.so
/usr/local/share/larch/plugins/xafs/scatteringpath.py
/usr/local/share/larch/modules/feffpathwrapper.py
/usr/local/bin/ff2x
/usr/local/bin/genfmt
/usr/local/bin/pathfinder
/usr/local/bin/pot
/usr/local/bin/rdinp
/usr/local/bin/xsph
/usr/local/lib/libfeffpath.so
/usr/local/lib/libonepath.so
/usr/local/lib/json_module.mod
/usr/local/lib/libjsonfortran.a
'

for f in $files; do
    rm -fv $f
done

## source prep.sh

alias ls='ls -F --color=always'
alias scons='python /c/Python27/Scripts/scons.py'
alias rm='rm -i'

## need to put the location of gcc 4.9 at the front of the path
## (Demeter, for instance, comes with 4.7, which won't work for json-fortran)
export PATH=/C/Program\ Files/mingw-w64/x86_64-4.9.2-win32-seh-rt_v3-rev1/mingw64/bin:$PATH

## want the installation location of swig at the end of the path
export PATH=$PATH:/c/Program\ Files/swigwin-3.0.5
export PATH=$PATH:/c/Program\ Files/larch/bin
export PATH=$PATH:/c/Program\ Files/larch/dlls/win32

export VS90COMNTOOLS="/C/Users/bravel/AppData/Local/Programs/Common/Microsoft/Visual C++ for Python"

## these need to be in the path as well
# /c/Python27
# /c/Program Files/Larch/bin
# /c/Program Files/swigwin-3.0.5

# Feff8L installation

Building and Installing  Feff8L, aka feff85exafs:


## Requirements

* gfortran v 4.9 or higher (someone please verify) and an accompanying gcc compiler.

* Python, version 2.7 or 3.5 or higher.  Some scripts may still be
  incompatible with Python3 -- please let us know if you run into a problem
  with this.

## Download source code

Download the tarball (or zip ball) for this project, and unpack onto your
computer,  or use `git clone` on the master branch of this repository to
pull onto your computer. You may be able to use one of the following
commands (you do not need all of them!):

usig wget:

```
    wget  https://github.com/xraypy/feff85exafs/archive/0.2.tar.gz
    tar xvf 0.2.tar.gz
    cd feff85exafs-0.2
```

using curl:

```
    curl -L https://github.com/xraypy/feff85exafs/archive/0.2.tar.gz
    tar xvf 0.2.tar.gz
    cd feff85exafs-0.2
```

using git:

```
     git clone https://github.com/xraypy/feff85exafs.git
     cd feff85exafs
```

## Build and install

It should be possible to build feff8l with

```
    make install
```

By default, this will place the executables in the `local_install` folder
in the `feff85exafs` folder.  You should be able to install these elsewhere
simply by copying them to your favorite location of binaries, perhaps with

```
    sudo cp -pr local_install/bin/* /usr/local/bin/.
    sudo cp -pr local_install/lib/* /usr/local/lib/.
    sudo cp -pr local_install/include/* /usr/local/include/.
```

You can also change the install location by editing the first few lines of the
Makefile (in this directory).  By default this reads

```
    export PREFIX  = /usr/local
    export PREFIX =  ${CURDIR}/local_install
```

But you can change this to just read

```
    export PREFIX  = /usr/local
```

or anywhere else you would like to install to.  The executables will go in
the `bin/` folder below this main install location.

For further details on compiling Feff8l and using
[json-fortran](https://github.com/jacobwilliams/json-fortran),
see [`src/README.md`](src/README.md).


## Testing

Testing requires
[python's nose tool](https://nose.readthedocs.org/en/latest/) and [Larch](https://github.com/xraypy/xraylarch).

To compile and  test, do the following in the top directory

```
	  feff8l> make
	  feff8l> LD_LIBRARY_PATH='wrappers/python:src/GENFMT' && nosetests --verbosity=3
	  feff8l> sudo make install
```


For more example programs using the fortran entry point to the stand-alone
F_eff calculations or programs using the C wrapper see the `wrappers/`
directory.  There you will also find language bindings to the C wrapper,
including python and perl.

# Running Feff8L


With feff8l so that it is in your path, you can create a folder and place a
`feff.inp` folder in that folder, and then run the `feff8l` python script
on that directory:

```
      mkdir FeffTest
      cp SomeFeff8.inp FeffTest/.
      feff8l  FeffTest/.
```

feff8l is a Python 2 script that runs all (or selected) modules of Feff85L in order:
     feff8l_rdinp
     feff8l_pot
     feff8l_xsph
     feff8l_pathfinder
     feff8l_genfmt
     feff8l_ff2x

After running the feff8l script, the directory FeffTest should contain the
Feff8L output files. Since they have generic names, it is recommended that
you copy them into a sensibly named subdirectory in your EXAFS Project
Directoy.

To understand the feff.inp file, have a look at feff6l_doc.txt or feff8.tex in the directory feff85exafs/doc/ .
